/* -*- coding: cp866 -*- */
/* $Id: necklace_cher.c 285 2005-04-18 17:49:36Z jury $ */

#include <stdio.h>
#include <stdlib.h>

#define MAX_N 50
int a[MAX_N];
int b[MAX_N];
int N;

void do_move(int st_ind, int len)
{
  int j, i, k, t;

  if (len == N) return;

  j = (st_ind + N - 1) % N;
  if (a[j] + 1 == a[st_ind]) {
    do_move(j, len + 1);
    return;
  }

  for (k = 0, i = st_ind; k < len; k++) {
    printf("%d %d\n", a[j] + 1, a[i] + 1);
    t = a[i];
    a[i] = a[j];
    a[j] = t;
    j = i;
    i = (i + 1) % N;
  }
  j = (st_ind + N - 1) % N;
  do_move(j, len);
}

int main(void)
{
  FILE *fin;
  int i, x;

  fin = fopen("necklace.in", "r");
  freopen("necklace.out", "w", stdout);

  fscanf(fin, "%d", &N);
  if (N < 2 || N > 50) abort();
  for (i = 0; i < N; i++) {
    fscanf(fin, "%d", &x);
    if (x < 1 || x > N) abort();
    a[i] = x - 1;
    if (b[a[i]]) abort();
    b[a[i]] = 1;
  }

  for (i = 0; i < N; i++)
    if (a[i] == N - 1) break;
  if (i == N) abort();

  do_move(i, 1);
  printf("0\n");

  fclose(fin);

  /*
  for (i = 0; i < N; i++)
    fprintf(stderr, " %d", a[i] + 1);
  fprintf(stderr, "\n");
  */

  return 0;
}

/*
 * Local variables:
 *  compile-command: "gcc -Wall -O2 -s necklace_cher.c -o necklace_cher"
 * End:
 */
