#include <stdio.h>

class Functions
{
public:
	static int ReadInt()
	{
		int value = 0;
		scanf("%d", &value);
		return value;
	}

	static int Abs(int x)
	{
		return (x < 0) ? -x: x;
	}
};

class Data
{
private:
	int n;
	int *perm;

	void Init()
	{
		n = 0;
		perm = 0;
	}

	void Dispose()
	{
		if (perm)
			delete perm;
		Init();
	}

public:
	int Size()
	{
		return n;
	}

	int NormalizeIndex(int index)
	{
		return (index%n+n)%n;
	}

	int& operator[](int index)
	{
		return perm[NormalizeIndex(index)];
	}

	bool Swap(int i, int j)
	{
		Data &data = *this;

		if (Functions::Abs(data[i]-data[j]) < 2)
			return false;

		int t = data[i];
		data[i] = data[j];
		data[j] = t;

		return true;
	}

	void Read()
	{
		Dispose();
		
		n = Functions::ReadInt();
		perm = new int[n];

		for (int i = 0; i < n; i++)
			perm[i] = Functions::ReadInt();
	}

	Data()
	{
		Init();
	}

	~Data()
	{
		Dispose();
	}
};

class Solver
{
public:

	static void Solve(Data &data)
	{
		while (true)
		{
			bool end = true;

			for (int i = 0; i < data.Size(); i++)
			{
				if (data[i] > data[i+1])
					continue;

				if (data.Swap(i, i+1))
				{
					printf("%d %d\n", data[i+1], data[i]);
					end = false;
				}
			}
			if (end)
				break;
		}

		printf("0\n");
	};
};

int main()
{
	freopen("necklace.in", "r", stdin);
	freopen("necklace.out", "w", stdout);

	Data data;
	data.Read();

	Solver::Solve(data);

	return 0;
}