{Correct solution O(N^2)}
{$D-,L-,I-,Q-,R-,S-}
Program stalker;
const
  inpfile='stalker.in';
  outfile='stalker.out';
  nm=2005;
type
  PNode = ^Node;
  Node = record
    x : LongInt;
    next : PNode;
  end;

  Vertex = record
    x,d : LongInt;
  end; 
var
  a : array [1..nm,1..nm] of PNode;
  u : array [1..nm] of Boolean;
  v : array [1..nm] of LongInt;

  b : array [1..nm*nm+nm] of PNode;
  q : array [1..nm*nm+nm] of Vertex;
  uq : array [1..nm*nm+nm] of Boolean;
  comp,cnt : LongInt;
  n,k : LongInt;
{}
Procedure Inp;
var
  i,j,m : LongInt;
  x,y : LongInt;
  p : PNode;
begin
  assign(input,inpfile);
  reset(input);
  read(n,k);
  for i:=1 to k do begin
    read(m);
    for j:=1 to m do begin
      read(x,y);
      new(p);
      p^.x:=y;
      p^.next:=a[i,x];
      a[i,x]:=p;

      new(p);
      p^.x:=x;
      p^.next:=a[i,y];
      a[i,y]:=p;
    end;
  end;
end;
{}
Procedure Out(res : LongInt);
begin
  assign(output,outfile);
  rewrite(output);
  if res=-1 then writeln(-1)
            else writeln(res div 2); 
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
  fillchar(uq,sizeof(uq),0);
end;
{}
Procedure Dfs(col, x : LongInt);
var
  p : PNode;
begin
  if u[x] then exit;
  u[x]:=true; inc(cnt);
  v[cnt]:=x;

  p:=a[col,x];
  while p<>nil do begin
    Dfs(col,p^.x);
    p:=p^.next;
  end;
end;
{}
Procedure Solve;
var
  i,j,h : LongInt;
  s,t : LongInt;
  p : PNode;
begin
  if n=1 then Out(0);

  comp:=n;
  for i:=1 to k do begin
    fillchar(u,sizeof(u),0);
    for j:=1 to n do
      if not u[j] then begin
        cnt:=0;
        Dfs(i,j);
        if cnt>1 then begin
          inc(comp);
          for h:=1 to cnt do begin
            new(p);
            p^.x:=v[h];
            p^.next:=b[comp];
            b[comp]:=p;

            new(p);
            p^.x:=comp;
            p^.next:=b[v[h]];
            b[v[h]]:=p;
          end;
        end;
      end;
  end;

  s:=1; t:=2;
  q[1].x:=1; q[1].d:=0;
  uq[1]:=true;

  while s<t do begin
    p:=b[q[s].x];
    while p<>nil do begin
      if not uq[p^.x] then begin
        q[t].x:=p^.x;
        q[t].d:=q[s].d+1;
        uq[p^.x]:=true;
        if q[t].x=n then Out(q[t].d);
        inc(t);
      end;
      p:=p^.next;
    end;
    inc(s);
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out(-1);
End.
