{$APPTYPE CONSOLE}
{$R+,Q+,O-}

type
  int = longint;

var
  dist: array[-500..500, 0..999] of int;
  mark: array[-500..500, 0..999] of boolean;
  l1, l2, link: array[-500..500, 0..999] of int;
  poss: array[-500..500, 0..999] of int;
  h1, h2: array[1..1001000] of int;
  hlen: int;

function wrong(cur: int): boolean;
begin
  wrong := (dist[h1[cur], h2[cur]] < dist[h1[cur div 2], h2[cur div 2]]);
end;

procedure swap(cur: int);
var
  t: int;
begin
  t := h1[cur];
  h1[cur] := h1[cur div 2];
  h1[cur div 2] := t;
  t := h2[cur];
  h2[cur] := h2[cur div 2];
  h2[cur div 2] := t;
  poss[h1[cur div 2], h2[cur div 2]] := cur div 2;
  poss[h1[cur], h2[cur]] := cur;
end;

procedure siftup(cur: int);
begin
  while (cur > 1) and wrong(cur) do
  begin
    swap(cur);
    cur := cur div 2;
  end;
end;

procedure siftdown(cur: int);
begin
  repeat
    if (2 * cur + 1 <= hlen) and
       (dist[h1[cur], h2[cur]] > dist[h1[2 * cur + 1], h2[2 * cur + 1]]) and
       (dist[h1[2 * cur], h2[2 * cur]] > dist[h1[2 * cur + 1], h2[2 * cur + 1]]) then
    begin
      cur := 2 * cur + 1;
      swap(cur);
    end
    else if (2 * cur <= hlen) and wrong(2 * cur) then
    begin
      cur := 2 * cur;
      swap(cur);
    end
    else
      exit;
  until false;    
end;

procedure add(x, y: int);
begin
  inc(hlen);
  h1[hlen] := x;
  h2[hlen] := y;
  poss[x, y] := hlen;
  siftup(hlen);
end;

procedure takebest(var x, y: int);
begin
  x := h1[1];
  y := h2[1];
  poss[h1[1], h2[1]] := 0;
  h1[1] := h1[hlen];
  h2[1] := h2[hlen];
  dec(hlen);
  poss[h1[1], h2[1]] := 1;
  siftdown(1);
end;

function empty: boolean;
begin
  empty := (hlen = 0);
end;

procedure solve(a, b, time: int);
var
  i, j: int;
  x, y: int;
  za, zb: int;
  ca, cb: char;

procedure edge(xa, xb, li: int);
var
  ti, xn: int;
begin
  if (xa = 0) and (xb = 0) then
    exit;
  if (xa = 0) then
  begin
    ti := xb;
    xn := 0;
    li := li xor 4;
  end
  else if (xb = 0) then
  begin
    ti := xa;
    xn := 0;
  end
  else if (xa <= xb) then
  begin
    ti := xa;
    xn := xb - xa;
  end
  else
  begin
    ti := xb;
    xn := xb - xa;
    li := li xor 4;
  end;
  if (xn > b div 2) then
  begin
    xn := b - xn;
    li := li xor 8;
  end;
  if (xn < -(a div 2)) then
  begin
    xn := -xn - a;
    li := li xor 16;
  end;
  inc(ti, dist[x, y]);
  if (dist[xn, ti mod a] > ti) then
  begin
    l1[xn, ti mod a] := x;
    l2[xn, ti mod a] := y;
    link[xn, ti mod a] := li;
    dist[xn, ti mod a] := ti;
    siftup(poss[xn, ti mod a]);
  end
  else if (dist[xn, ti mod a] < 0) then
  begin
    l1[xn, ti mod a] := x;
    l2[xn, ti mod a] := y;
    link[xn, ti mod a] := li;
    dist[xn, ti mod a] := ti;
    add(xn, ti mod a);
  end;
end;

procedure output(x, y: int);
var
  wa, wb: boolean;
begin
  if (x = 0) and (y = 0) then
    exit;
  output(l1[x, y], l2[x, y]);
  write('flip ');
  wa := (link[x, y] and 2 > 0) xor (link[l1[x, y], l2[x, y]] and 16 > 0);
  wb := (link[x, y] and 1 > 0) xor (link[l1[x, y], l2[x, y]] and 8 > 0);
  if wa and wb then
    writeln('A and B')
  else if wa then
    writeln(ca)
  else if wb then
    writeln(cb)
  else
  begin
    {}{}{}
  end;
  if (link[x, y] and 4 > 0) then
    write('When ', cb, ' stops: ')
  else
    write('When ', ca, ' stops: ')
end;

begin
  if (a > b) then
  begin
    i := a;
    a := b;
    b := i;
    ca := 'B';
    cb := 'A';
  end
  else
  begin
    ca := 'A';
    cb := 'B';
  end;
  for i := -(a div 2) to b div 2 do for j := 0 to a - 1 do
  begin
    dist[i, j] := -1;
    mark[i, j] := false;
  end;
  hlen := 0;
  dist[0, 0] := 0;
  add(0, 0);
  repeat
    if empty then
      break;
    takebest(x, y);
    if (dist[x, y] mod a = time mod a) then
      break;
    if (dist[x, y] > time) then
      break;
    mark[x, y] := true;
    za := 0;
    zb := 0;
    if (x >= 0) then
      zb := x
    else
      za := -x;
    edge(za, zb, 0);
    edge(za, b - zb, 1);
    edge(a - za, zb, 2);
    edge(a - za, b - zb, 3);
  until false;
  if (dist[x, y] mod a <> time mod a) or (dist[x, y] > time) then
  begin
    writeln('Impossible');
    exit;
  end;
  write('Initially: ');
  while (dist[x, y] < time) do
  begin
    writeln('flip ', ca);
    write('When ', ca, ' stops: ');
    dec(time, a);
  end;
  output(x, y);
  writeln('ready');
end;

var
  a, b, time: int;

begin
  assign(input, 'clocks.in');
  assign(output, 'clocks.out');
  reset(input);
  rewrite(output);
  read(a, b, time);
  solve(a, b, time);
end.
