{$o-,q+,r+}
uses
  math, sysutils;

const
  maxa = 500;
  maxt = 1000000;
  inf = maxt + 1;

var
  d, ph, pi, ptt, pd, pe: array[-maxa..maxa, 0..maxa-1] of integer;
  hi, htt: array[1..(2 * maxa + 1) * maxa] of integer;
  hN: integer;

procedure hSwap(i, j: integer);
var
  t: integer;
begin
  t := hi[i];
  hi[i] := hi[j];
  hi[j] := t;
  t := htt[i];
  htt[i] := htt[j];
  htt[j] := t;
  ph[hi[i], htt[i]] := i;
  ph[hi[j], htt[j]] := j;
end;

procedure hSiftDown(i: integer);
var
  ii, iii: integer;
begin
  if i shl 1 > hN then exit;
  ii := i shl 1;
  if d[hi[i], htt[i]] < d[hi[ii], htt[ii]] then ii := i;
  iii := i shl 1 + 1;
  if (iii <= hN) and (d[hi[iii], htt[iii]] < d[hi[ii], htt[ii]]) then ii := iii;
  if ii = i then exit;
  hSwap(i, ii);
  hSiftDown(ii);
end;

procedure hSiftUp(i: integer);
var
  ii: integer;
begin
  if i = 1 then exit;
  ii := i shr 1;
  if d[hi[i], htt[i]] < d[hi[ii], htt[ii]] then begin
    hSwap(i, ii);
    hSiftUp(ii);
  end;
end;

procedure hExtractMin(var i, tt: integer);
begin
  assert(hN > 0);
  i := hi[1];
  tt := htt[1];
  hSwap(1, hN);
  dec(hN);
  hSiftDown(1);
end;


procedure hAdd(i, tt: integer);
begin
  inc(hN);
  hi[hN] := i;
  htt[hN] := tt;
  ph[i, tt] := hN;
  hSiftUp(hN);
end;


procedure relaxMoment(ka, kb, tt, dd, ppi, pptt, ppd, ppe: integer);
var
  i: integer;
begin
  assert((ka = 0) or (kb = 0));
  i := kb-ka;
  if d[i, tt] > dd then begin
    d[i, tt] := dd;
    pi[i, tt] := ppi;
    ptt[i, tt] := pptt;
    pd[i, tt] := ppd;
    pe[i, tt] := ppe;
    hSiftUp(ph[i, tt]);
  end;
end;

var
  a, b: integer;

procedure relaxEvent(ka, kb, tt, dd, ppi, pptt, ppd: integer);
begin
//  if (ka = 0) or (kb = 0) then relaxMoment(ka, kb, tt, dd, kb - ka, tt);
  if (ka > 0) and ((kb = 0) or (ka < kb)) then
    relaxMoment(0, max(kb - ka, 0), (tt + ka) mod a, dd + ka, ppi, pptt, ppd, 1);
  if (kb > 0) and ((ka = 0) or (kb < ka)) then
    relaxMoment(max(ka - kb, 0), 0, (tt + kb) mod a, dd + kb, ppi, pptt, ppd, 2);
end;

procedure go(i, tt: integer);
var
  ii, ttt: integer;
begin
  if d[i, tt] = 0 then exit;
  ii := pi[i, tt];
  ttt := ptt[i, tt];
  go(ii, ttt);
  if (pd[i, tt] = 0) then exit;
  if (pd[i, tt] = 1) then begin
    writeln('flip A');
  end else if (pd[i, tt] = 2) then begin
    writeln('flip B');
  end else if (pd[i, tt] = 3) then begin
    writeln('flip A and B');
  end;
  if (pe[i, tt] = 1) then begin
    write('When A stops: ');
  end else if (pe[i, tt] = 2) then begin
    write('When B stops: ');
  end;
end;

var
  t, i, tt, kb, ka: integer;

begin
  reset(input, 'clocks.in');
  rewrite(output, 'clocks.out');

  read(a, b, t);
  assert((a <= maxa) and (b <= maxa));

  for i := -a to b do
    for tt := 0 to a-1 do
      d[i, tt] := inf;
  d[0, 0] := 0;
  hN := 0;
  for i := -a to b do
    for tt := 0 to a-1 do
      hAdd(i, tt);

  while hN > 0 do begin
    hExtractMin(i, tt);
    if (tt = t mod a) then begin
      if (d[i, tt] > t) then break;
      write('Initially: ');
      while (t > d[i, tt]) do begin
        writeln('flip A');
        write('When A stops: ');
        t := t - a;
      end;
      go(i, tt);
      writeln('ready');
      halt;
    end;
    if (i > 0) then begin
      ka := 0;
      kb := i;
    end else begin
      ka := -i;
      kb := 0;
    end;
    relaxEvent(ka, kb, tt, d[i, tt], i, tt, 0);
    relaxEvent(a - ka, kb, tt, d[i, tt], i, tt, 1);
    relaxEvent(ka, b - kb, tt, d[i, tt], i, tt, 2);
    relaxEvent(a - ka, b - kb, tt, d[i, tt], i, tt, 3);
  end;
  writeln('Impossible');
end.