{$R+,Q+,O-}
{$APPTYPE CONSOLE}
Uses
  SysUtils;
  
type
  int = longint;

const
  filename = 'clocks';
  MAXN = 510;

var
  a, b, t, hsize: int;
  h: array [1..2 * MAXN * MAXN + MAXN] of int;
  d, p, w: array [0..2 * MAXN * MAXN + MAXN] of int;
  pfa, pfb: array [0..2 * MAXN * MAXN + MAXN] of boolean;
  mark: array [0..2 * MAXN * MAXN + MAXN] of boolean;

procedure sift_down(u: int);
var
  uu, tmp, min: int;

begin
  while true do
  begin
    uu:=u shl 1;
    if (uu + 1 <= hsize) and (d[h[uu + 1]] < d[h[u]]) then
      min:=uu + 1
    else
      min:=u;

    if (uu <= hsize) and (d[h[uu]] < d[h[min]]) then
      min:=uu;

    if (min = u) then break;
    tmp:=h[u];
    h[u]:=h[min];
    h[min]:=tmp;
    w[h[u]]:=u;
    w[h[min]]:=min;

    u:=min;
  end;
end;

procedure sift_up(u: int);
var
  uu, tmp: int;

begin
  while (u > 1) do
  begin
    uu:=u shr 1;
    if (d[h[uu]] > d[h[u]]) then
    begin
      tmp:=h[uu];
      h[uu]:=h[u];
      h[u]:=tmp;

      w[h[u]]:=u;
      w[h[uu]]:=uu;
      u:=uu;
      continue;
    end;
    break;
  end;
end;

function emin: int;
begin
  w[h[1]]:=0;
  result:=h[1];
  h[1]:=h[hsize];
  dec(hsize);

  w[h[1]]:=1;
  sift_down(1);
end;

procedure add(r: int; value: int);
begin
  d[r]:=value;
  
  inc(hsize);
  h[hsize]:=r;
  w[h[hsize]]:=hsize;
  sift_up(hsize);
end;

procedure relax(r: int; fa, fb: boolean; dd, rr: int);
var
  newr, u, v, dt: int;

begin
  if (dd <= a) then
  begin
    u:=dd;
    v:=0;
  end
  else
  begin
    u:=0;
    v:=dd - a;
  end;

  if (fa) then u:=a - u;
  if (fb) then v:=b - v;
  if (u < v) then
  begin
    v:=v - u;
    dt:=u;
    u:=0;
  end
  else
  begin
    u:=u - v;
    dt:=v;
    v:=0;
  end;

  if (dt = 0) then
    exit;

  if (v = 0) then
    newr:=u * b + ((dt + rr) mod b)
  else
    newr:=(v + a) * b + ((dt + rr) mod b);

  if (mark[newr]) then exit;

  if (w[newr] = 0) then
  begin
    p[newr]:=r;
    pfa[newr]:=fa;
    pfb[newr]:=fb;

    add(newr, d[r] + dt);
    exit;
  end;

  if (d[r] + dt < d[newr]) then
  begin
    p[newr]:=r;
    pfa[newr]:=fa;
    pfb[newr]:=fb;
    d[newr]:=d[r] + dt;
    assert(h[w[newr]] = newr);
    sift_up(w[newr]);
    exit;
  end;
end;

procedure print(r: int);
var
  u, v: int;

begin
  if (r = 0) then exit;
  print(p[r]);

  assert(pfa[r] or pfb[r]);
  if (pfa[r] and pfb[r]) then
    writeln('flip A and B')
  else if (pfa[r]) then
    writeln('flip A')
  else
    writeln('flip B');

  if (p[r] <= a * b) then
  begin
    u:=p[r] div b;
    v:=0;
  end
  else
  begin
    u:=0;
    v:=(p[r] - a * b) div b;
  end;

  if (pfa[r]) then u:=a - u;
  if (pfb[r]) then v:=b - v;

  if (u < v) then
    write('When A stops: ')
  else
    write('When B stops: ');
end;

procedure solve;
var
  r, u, v: int;
  min, mini, i: int;

begin
  d[0]:=0;
  hsize:=1;
  h[1]:=0;
  w[h[1]]:=1;
  while hsize > 0 do
  begin
    r:=emin;
    mark[r]:=true;
    u:=r div b;
    v:=r mod b;
    relax(r, true, false, u, v);
    relax(r, false, true, u, v);
    relax(r, true, true, u, v);

{    relax(r, true, false, u, v);
    relax(r, false, true, u, v);
    relax(r, true, true, u, v);}
  end;

  min:=1000000000;
  mini:=0;
  for i:=0 to a + b do
    if (mark[b * i + (t mod b)]) and (d[b * i + (t mod b)] < min) then
    begin
      min:=d[b * i + (t mod b)];
      mini:=b * i + (t mod b);
    end;

  if (min > t) then
  begin
    writeln('Impossible');
    exit;
  end;

  assert(min mod b = t mod b);
  write('Initially: ');
  for i:=1 to (t - min) div b do
  begin
    writeln('flip B');
    write('When B stops: ');
  end;

  print(mini);
  writeln('ready');
  exit;
end;

begin
  assign(input, filename + '.in');
  assign(output, filename + '.out');
  reset(input);
  rewrite(output);

  read(a, b, t);
  assert((1 <= a) and (a <= 500));
  assert((1 <= b) and (b <= 500));
  assert((1 <= t) and (a <= 100000));
  solve;
end.

