{$R+,Q+,O-}
{$APPTYPE CONSOLE}
type
  int = longint;

const
  filename = 'clocks';
  MAXN = 1100;

var
  a, b, t: int;
  d, p: array [0..2 * MAXN * MAXN + MAXN] of int;
  pfa, pfb: array [0..2 * MAXN * MAXN + MAXN] of boolean;
  mark: array [0..2 * MAXN * MAXN + MAXN] of boolean;

procedure add(r: int; value: int);
begin
  d[r]:=value;
end;

procedure relax(r: int; fa, fb: boolean; dd, rr: int);
var
  newr, u, v, dt: int;

begin
  if (dd <= a) then
  begin
    u:=dd;
    v:=0;
  end
  else
  begin
    u:=0;
    v:=dd - a;
  end;

  if (fa) then u:=a - u;
  if (fb) then v:=b - v;
  if (u < v) then
  begin
    v:=v - u;
    dt:=u;
    u:=0;
  end
  else
  begin
    u:=u - v;
    dt:=v;
    v:=0;
  end;

  if (dt = 0) then
    exit;

  if (v = 0) then
    newr:=u * b + ((dt + rr) mod b)
  else
    newr:=(v + a) * b + ((dt + rr) mod b);

  if (mark[newr]) then
    exit;

  if (d[newr] = -1) or (d[r] + dt < d[newr]) then
  begin
    p[newr]:=r;
    pfa[newr]:=fa;
    pfb[newr]:=fb;
    d[newr]:=d[r] + dt;
    exit;
  end;
end;

procedure print(r: int);
var
  u, v: int;

begin
  if (r = 0) then exit;
  print(p[r]);

  assert(pfa[r] or pfb[r]);
  if (pfa[r] and pfb[r]) then
    writeln('flip A and B')
  else if (pfa[r]) then
    writeln('flip A')
  else
    writeln('flip B');

  if (p[r] <= a * b) then
  begin
    u:=p[r] div b;
    v:=0;
  end
  else
  begin
    u:=0;
    v:=(p[r] - a * b) div b;
  end;

  if (pfa[r]) then u:=a - u;
  if (pfb[r]) then v:=b - v;

  if (u < v) then
    write('When A stops: ')
  else
    write('When B stops: ');
end;

procedure solve;
var
  r, u, v: int;
  min, mini, i: int;

begin
  fillchar(d, sizeof(d), $ff);
  d[0]:=0;
  while true do
  begin
    mini:=-1;
    min:=1000000;
    for i:=0 to (a + b) * b do
      if (d[i] <> -1) and (not mark[i]) and (d[i] < min) then
      begin
        min:=d[i];
        mini:=i;
      end;

    if (mini = -1) then
      break;

    r:=mini;
    mark[r]:=true;
    u:=r div b;
    v:=r mod b;
    relax(r, true, false, u, v);
    relax(r, false, true, u, v);
    relax(r, true, true, u, v);

    relax(r, true, false, u, v);
    relax(r, false, true, u, v);
    relax(r, true, true, u, v);
  end;

  min:=1000000000;
  mini:=0;
  for i:=0 to a + b do
    if (mark[b * i + (t mod b)]) and (d[b * i + (t mod b)] < min) then
    begin
      min:=d[b * i + (t mod b)];
      mini:=b * i + (t mod b);
    end;

  if (min > t) then
  begin
    writeln('Impossible');
    exit;
  end;

  assert(min mod b = t mod b);
  write('Initially: ');
  for i:=1 to (t - min) div b do
  begin
    writeln('flip B');
    write('When B stops: ');
  end;

  print(mini);
  writeln('ready');

{  for t:=0 to b - 1 do
  begin
    write(t: 4, ' : ');
    min:=1000000000;
    mini:=0;
    for i:=0 to a + b do
      if (mark[b * i + (t mod b)]) and (d[b * i + (t mod b)] < min) then
      begin
        min:=d[b * i + (t mod b)];
        mini:=b * i + (t mod b);
      end;

    if (min = 1000000000) then
    begin
      writeln('Impossible');
      continue;
    end;

    assert(min mod b = t mod b);
    writeln(t, ' + ', (min - t) div b, ' * ', b, ' (', min, ')');
  end;}
end;

begin
  assign(input, filename + '.in');
  assign(output, filename + '.out');
  reset(input);
  rewrite(output);

  read(a, b, t);
  assert((1 <= a) and (a <= 1000));
  assert((1 <= b) and (b <= 1000));
  assert((1 <= t) and (a <= 100000));
  solve;
end.

