{$MINSTACKSIZE $00400000}
{$o-,q+,r+}
const
    max_n = 100000;

type
    tState = (_NONE_ = 0, _OK_, _BAR_, _FORK_, _FAIL_);

var
    i, n, q: longint;
    v, c, next: array [1..2 * max_n] of longint;
    b: array [1..2 * max_n] of boolean;
    r: array [1..max_n] of longint;
    ea, eb, ec: longint;
    col: array [1..max_n] of longint;
    fail: boolean;
    state: array [1..max_n] of tState;
    killed: array [1..max_n] of boolean;
    cg: longint;
    idx: array [1..max_n] of longint;

procedure calcState(i: longint);
var
    j: longint;
begin
    if state[i] = _NONE_ then begin
        inc(q);
        idx[i] := q;
        state[i] := _OK_;
        j := r[i];
        while j <> 0 do begin
            if col[c[j]] <> 0 then begin
                b[j] := true;
                b[col[c[j]]] := true;
                if state[i] = _OK_ then begin
                    if (state[v[j]] <> _NONE_) or (state[v[col[c[j]]]] <> _NONE_) then begin
                        state[i] := _BAR_;
                    end else begin
                        state[i] := _FORK_;
                    end;
                end else begin
                    fail := true;
                    state[i] := _FAIL_;
                end;
            end else begin
                col[c[j]] := j;
            end;
            j := next[j];
        end;
        j := r[i];
        while j <> 0 do begin
            col[c[j]] := 0;
            j := next[j];
        end;
    end;
end;

function kill(i: longint): boolean;
var
    j: longint;
begin
    if killed[i] then begin
        kill := false;
        exit;
    end;
    calcState(i);
    killed[i] := true;
    result := state[i] = _FORK_;

    j := r[i];
    while j <> 0 do begin
        if (idx[v[j]] = 0) or (idx[v[j]] > idx[i]) then begin
            if kill(v[j]) then result := true;
        end;
        j := next[j];
    end;
end;

function dfs(i: longint): boolean;
var
    j: longint;
    fork: boolean;
begin
    calcState(i);

    fork := false;
    if state[i] = _OK_ then begin
        j := r[i];
        while j <> 0 do begin
            if (state[v[j]] = _NONE_) then begin
                if dfs(v[j]) then fork := true;
            end;
            j := next[j];
        end;
    end else begin
        j := r[i];
        while j <> 0 do begin
            if (state[v[j]] = _NONE_) then begin
                if not b[j] then begin
                    if kill(v[j]) then fork := true;
                end else begin
                    if dfs(v[j]) then fork := true;
                end;
            end;
            j := next[j];
        end;
    end;
    if fork then kill(i);
    result := (state[i] = _FORK_) or fork;
end;

procedure add(ea, eb, ec: longint);
begin
    inc(q);
    v[q] := eb;
    c[q] := ec;
    next[q] := r[ea];
    r[ea] := q;
end;

begin
    assign(input, 'robot.in'); reset(input);
    assign(output, 'robot.out'); rewrite(output);

    fillchar(r, sizeof(r), 0);
    fillchar(state, sizeof(state), 0);
    fillchar(col, sizeof(col), 0);

    read(n);
    for i := 1 to n - 1 do begin
        read(ea, eb, ec);
        add(ea, eb, ec);
        add(eb, ea, ec);
    end;

    q := 0;
    dfs(1);

    if not fail then begin
        cg := 0;
        for i := 1 to n do begin
            if (state[i] = _OK_) and not (killed[i]) then inc(cg)
        end;
        writeln(cg);
        for i := 1 to n do begin
            if (state[i] = _OK_) and not (killed[i]) then write(i, ' ');
        end;
    end else begin
        writeln('0');
    end;

    close(input);
    close(output);
end.