{$MINSTACKSIZE $00400000}
{$o+,q-,r-}
const
    max_n = 100000;

type
    tState = (_OK_, _BAD_, _FAIL_);

var
    i, n, q: longint;
    v, c, next: array [1..2 * max_n] of longint;
    b: array [1..2 * max_n] of boolean;
    r: array [1..max_n] of longint;
    u, z: array [1..max_n] of boolean;
    ea, eb, ec: longint;
    fail: boolean;
    state: array [1..max_n] of tState;
    cg: longint;

procedure calcState(i: longint);
var
    j, k: longint;
begin
    state[i] := _OK_;
    j := r[i];
    while j <> 0 do begin
        k := next[j];
        while k <> 0 do begin
            if c[j] = c[k] then begin
                b[j] := true;
                b[k] := true;
                if state[i] = _OK_ then begin
                    state[i] := _BAD_;
                end else begin
                    fail := true;
                    state[i] := _FAIL_;
                end;
            end;
            k := next[k];
        end;
        j := next[j];
    end;
end;

function dfs(i: longint): boolean;
var
    j: longint;
begin
    u[i] := true;

    if state[i] = _BAD_ then begin
        j := r[i];
        while j <> 0 do begin
            if u[v[j]] and not b[j] then begin
                dfs := false;
                exit;
            end;
            j := next[j];
        end;
    end;

    j := r[i];
    while j <> 0 do begin
        if not u[v[j]] then begin
            if not dfs(v[j]) then begin
                dfs := false;
                exit;
            end;
        end;
        j := next[j];
    end;
    dfs := true;
end;

procedure add(ea, eb, ec: longint);
begin
    inc(q);
    v[q] := eb;
    c[q] := ec;
    next[q] := r[ea];
    r[ea] := q;
end;

begin
    assign(input, 'robot.in'); reset(input);
    assign(output, 'robot.out'); rewrite(output);

    fillchar(r, sizeof(r), 0);
    fillchar(state, sizeof(state), 0);

    read(n);
    for i := 1 to n - 1 do begin
        read(ea, eb, ec);
        add(ea, eb, ec);
        add(eb, ea, ec);
    end;

    for i := 1 to n do begin
        calcState(i);
    end;

    if not fail then begin
        cg := 0;
        for i := 1 to n do begin
            fillchar(u, sizeof(u), 0);
            z[i] := (state[i] = _OK_) and dfs(i);
            if z[i] then begin
                inc(cg);
            end;
        end;
        writeln(cg);
        for i := 1 to n do begin
            if z[i] then write(i, ' ');
        end;
    end else begin
        writeln('0');
    end;

    close(input);
    close(output);
end.