// Solution for 'Robot' problem by Igor Sinev
// Code lenght without comments is approximately 2K

{$o-,q+,r+}
{ $o+,q-,r-}
{$MINSTACKSIZE $00400000}
{$APPTYPE console}

uses
  math, sysutils;

const
  maxn = 2 * 100000;
  maxd = 100000;

type
  int = longint;
  ta = array[1 .. maxn] of int;

var
  e, // destination vertex
  v, // mark of the arc
  p, // pair to this
  a, // next arc from current vertex
  b, // dupilcate for initial array  a
  h, // head for arcs lists from this vertex
  g  // dupilcate for initial array  h
  : ta;
  u  // marks for vertices
  : array[1 .. maxn] of boolean;
  w  // array for counting arcs with same marks
  : array[1 .. maxd] of int;

procedure dfs(x: int); forward;

// looks for all arcs outgoing from vertex  x
// and calls search from every one for which
// value in array  v  is not equal to  r
// and removes it from the arcs list for  x
procedure make(x: int; const v: ta; r: int);
var
  i, l: int;
begin
  i := h[x];
  l := 0;
  while true do begin
    if (i > 0) and (v[i] <> r) then
      dfs(i)
    else begin
      if (l = 0) then
        h[x] := i
      else
        a[l] := i;
      l := i;
    end;
    if (i > 0) then
      i := a[i]
    else
      break;
  end;
end;

// search procedure
procedure dfs(x: int);
var
  z: int;
begin
  z := e[x];
  u[z] := false;

  // process all arcs except the pair to
  // one we've used to get here
  make(z, p, x);
end;

var
  n: int;
  m: int;
  i, j, k, l, lk: int;

begin
  reset(input, 'robot.in');
  rewrite(output, 'robot.out');

  // read input data, build arcs lists
  read(n);
  for i := 1 to n do
    h[i] := 0;
  m := 0;
  for i := 1 to n - 1 do begin
    read(j, k);
    inc(m);
    e[m] := k;
    read(v[m]);
    p[m] := m + 1;
    a[m] := h[j];
    b[m] := a[m];
    h[j] := m;
    inc(m);
    e[m] := j;
    v[m] := v[m - 1];
    p[m] := m - 1;
    a[m] := h[k];
    b[m] := a[m];
    h[k] := m;
  end;

  // search initialization
  for i := 1 to n do begin
    u[i] := true;
    g[i] := h[i];
  end;
  for i := 1 to maxd do
    w[i] := 0;

  // search itself
  for i := 1 to n do begin
    // look for arcs with duplicate marks
    j := g[i];
    l := 0;
    while (j > 0) do begin
      k := v[j];
      inc(w[k]);
      if (w[k] > 1) then begin
        inc(l);
        // lk will be equal to mark of duplicate
        // arcs if there are any
        lk := k;
      end;
      j := b[j];
    end;

    // check if there is no possibility to hang this vertex
    if (l > 1) then begin
      for j := 1 to n do
        u[j] := false;
      break;
    end;

    // return array  w  to the initial state
    j := g[i];
    while (j > 0) do begin
      w[v[j]] := 0;
      j := b[j];
    end;

    // check if this vertex can be hang anyhow
    if (l = 0) then
      continue;

    // process a vertex and arcs outgoing from it
    // skipping two duplicate arcs
    u[i] := false;
    make(i, v, lk);
  end;

  // output results
  j := 0;
  for i := 1 to n do
    if (u[i]) then
      inc(j);
{  writeln(j);}

  for i := 1 to n do
    if (u[i]) then
      write(i, ' ');
end.
