/*
          

    :        
    :       
    :     
*/
#include <math.h>
#include <stdio.h>

#define for(what) if (0) ; else for(what)

#define EPS 1E-7
#define PI 3.1415926535897932384626433832795

struct Point
{
  double x;
  double y;

  Point()
  {
    x = 0;
    y = 0;
  }
  Point(double x, double y)
  {
    this->x = x;
    this->y = y;
  }
  Point operator+(const Point& a) const
  {
    return Point(x+a.x,y+a.y);
  }
  Point operator-(const Point& a) const
  {
    return Point(x-a.x,y-a.y);
  }
  Point turn(double cos, double sin) const
  {
    return Point(x*cos+y*sin,-x*sin+y*cos);
  }
  double length() const
  {
    return sqrt(x*x+y*y);
  }
  Point operator*(double a) const
  {
    return Point(a*x,a*y);
  }
  double atan2() const
  {
    return ::atan2(y,x);
  }
};

Point c[2];
double r[2];
int pcount;
Point p[4];
double m[4][4];
int circ[4][4];
int prev[4][4];
int renum[2];

void addpoints()
{
  double l = (c[1]-c[0]).length();
  if ((l-EPS>r[1]-r[0])&&(l+EPS<r[0]+r[1]))
  {
    double x = (r[0]*r[0]-r[1]*r[1]+l*l)/2/l;
    double h = sqrt(r[0]*r[0]-x*x);
    p[pcount++] = (c[1]-c[0]).turn(x/r[0],h/r[0])*(r[0]/l)+c[0];
    p[pcount++] = (c[1]-c[0]).turn(x/r[0],-h/r[0])*(r[0]/l)+c[0];
    return;
  }
  if (fabs(l-(r[1]-r[0]))<EPS||(fabs(l-(r[0]+r[1]))<EPS))
    p[pcount++] = (c[0]-c[1])*(r[1]/l)+c[1];
}

double min(double x, double y)
{
  return (x<y)?x:y;
}

void writepath(int a, int b)
{
  if (prev[a][b]==-1)
  {
    printf("%.16lf %.16lf %d\n",p[b].x,p[b].y,circ[a][b]);
    return;
  }
  writepath(a,prev[a][b]);
  writepath(prev[a][b],b);
}

int main()
{
  freopen("bike.in","rt",stdin);
  freopen("bike.out","wt",stdout);

  for (int i=0;i<2;i++)
    scanf("%lf%lf%lf",&(c[i].x),&(c[i].y),&(r[i]));
  if (r[1]<r[0])
  {
    Point tp = c[0];
    c[0] = c[1];
    c[1] = tp;
    double tr = r[0];
    r[0] = r[1];
    r[1] = tr;
    renum[0] = 1;
    renum[1] = 0;
  }
  else
  {
    renum[0] = 0;
    renum[1] = 1;
  }
  for (int i=0;i<2;i++)
    scanf("%lf%lf",&(p[i].x),&(p[i].y));
  pcount = 2;
  addpoints();

  for (int i=0;i<pcount;i++)
    for (int j=0;j<pcount;j++)
      m[i][j] = (i==j)-1;

  for (int i=0;i<2;i++)
    for (int j=0;j<pcount;j++)
      if (fabs((p[j]-c[i]).length()-r[i])<EPS)
        for (int k=0;k<pcount;k++)
          if (fabs((p[k]-c[i]).length()-r[i])<EPS)
          {
            double alpha = (p[j]-c[i]).atan2();
            double beta = (p[k]-c[i]).atan2();
            if (alpha>beta)
            {
              double t = alpha;
              alpha = beta;
              beta = t;
            }
            double w = min(beta-alpha,alpha+2*PI-beta)*r[i];
            if ((m[j][k]<-0.5)||(m[j][k]>w))
            {
              m[j][k] = w;
              circ[j][k] = renum[i]+1;
            }
          }

  for (int i=0;i<pcount;i++)
    for (int j=0;j<pcount;j++)
      prev[i][j] = -1;

  for (int j=0;j<pcount;j++)
    for (int i=0;i<pcount;i++)
      for (int k=0;k<pcount;k++)
        if ((m[i][j]>-0.5)&&(m[j][k]>-0.5)&&((m[i][k]<-0.5)||(m[i][k]>m[i][j]+m[j][k])))
        {
          m[i][k] = m[i][j]+m[j][k];
          prev[i][k] = j;
        }

  if (m[0][1]<-0.5)
    printf("-1\n");
  else
  {
    printf("%.16lf\n",m[0][1]);
#ifdef WRITEPATH
    printf("%.16lf %.16lf\n",p[0].x,p[0].y);
    writepath(0,1);
#endif    
  }

  return 0;
}