{
          

    :      
    :       
    :     
}

{$apptype CONSOLE}
{$q+,r+,o-,c+}

uses Sysutils, Math;

const
	IN_FILE = 'campaign.in';
	OUT_FILE = 'campaign.out';
	
	MAX_N = 2000;
	MAX_M = 50000;
	MAX_R = 10000;
	MAX_C = 10000;
	
	INFINITY = maxint div 2;

type
	TEdge = record
		id : integer;
		a, b : integer;
		p : integer;
		c : integer;
		nexte : integer;
		used : boolean;
	end;		

var
	n : integer;
	r : array[1..MAX_N] of integer;
	
	m : integer;
	e : array[1..MAX_M * 2] of TEdge;
	firste : array[1..MAX_N] of integer;
	
	d : array[1..MAX_N] of integer;
	f : array[1..MAX_N] of boolean;
	by : array[1..MAX_N] of integer;
	
	cost : integer;
	
procedure Solve;
var
	i, j, k : integer;
	relaxed : integer;

begin
	cost := 0;
	for i := 1 to m do
		if odd(i) and (e[i].p = 1) then
			dec(cost, e[i].c);

	for i := 1 to n do begin
		d[i] := INFINITY;
		f[i] := false;
	end;

	d[1] := 0;

	while not f[n] do begin
		j := 0;
		for i := 1 to n do
			if not f[i] and ((j = 0) or (d[i] < d[j])) then
				j := i;

		if j = 0 then
			break;

		f[j] := true;
		k := firste[j];
		while k <> 0 do begin
            if not f[e[k].b] then begin
                relaxed := d[j] + e[k].c + r[e[k].b];
                if d[e[k].b] > relaxed then begin
                    d[e[k].b] := relaxed;
                    by[e[k].b] := k;
                end;
            end;
            k := e[k].nexte;
        end;
	end;

	if f[n] then begin
		inc(cost, d[n]);
	end;
end;

procedure ReadInput;
var
	i, k : integer;
	a, b, c, p : integer;
	
	procedure AddEdge(id, a, b, p, c : integer);
	begin
		inc(m);
		e[m].a := a;
		e[m].b := b;
		e[m].p := p;
		e[m].c := c;
		e[m].id := id;
		e[m].used := false;
		e[m].nexte := firste[a];
		firste[a] := m;
	end;
	
begin
	reset(input, IN_FILE);
	read(n);
	assert((n >= 2) and (n <= MAX_N));
	assert(not eoln);
	read(k);
	assert((k >= 1) and (k <= MAX_M));
	assert(eoln);
	readln;

	for i := 1 to n do begin
		read(r[i]);
		assert((r[i] >= 0) and (r[i] <= MAX_R));
		assert(eoln);
		readln;
	end;

	assert(r[1] = 0);
	assert(r[n] = 0);

	m := 0;
	fillchar(firste, sizeof(firste), 0);

	for i := 1 to k do begin
		read(a);
		assert((a >= 1) and (a <= n));
		assert(not eoln);

		read(b);
		assert((b >= 1) and (b <= n));
		assert(not eoln);

		read(p);
		assert((p >= 1) and (p <= n));
		assert(not eoln);

		read(c);
		assert((c >= 1) and (c <= MAX_C));
		assert(eoln);
		readln;

		AddEdge(i, a, b, p, c);
		AddEdge(i, b, a, p, c);
	end;

	assert(eof);
		
	close(input);
end;

procedure WriteOutput;
var
	i : integer;
	count : integer;
	
	path : array[1..MAX_N] of integer;
	pathlen : integer;
	
begin
	rewrite(output, OUT_FILE);
	
	if f[n] and (cost <= 0) then begin
		i := n;
		pathlen := 1;
		path[1] := n;
		while i <> 1 do begin
			e[by[i]].used := true;
			i := e[by[i]].a;
			inc(pathlen);
			path[pathlen] := i;
		end;

		count := 0;
		for i := 1 to m do
			if odd(i) and (e[i].p = 1) then
				inc(count);
		write(count);
		for i := 1 to m do
			if odd(i) and (e[i].p = 1) then
				write(' ', e[i].id);
		writeln;

		count := 0;
		for i := 1 to m do
			if odd(i) and (e[i].used or e[i+1].used) then
				inc(count);
		write(count);
		for i := 1 to m do
			if odd(i) and (e[i].used or e[i+1].used) then
				write(' ', e[i].id);
		writeln;

		for i := pathlen downto 1 do
			write(path[i], ' ');
		writeln;
	end else begin
		writeln(-1);
	end;
	
	close(output);	
end;
		
begin
	ReadInput;
	Solve;
	WriteOutput;
end.
	