/*
          

    :      
    :       
    :     
*/
#include <assert.h>
#include <stdio.h>
#include <string.h>

#define for(what) if (0) ; else for(what)

bool sell[50000], buy[50000];

struct City;

struct Edge
{
  City* from;
  City* to;
  int w;
  Edge* next;
  bool our;
  bool mark;
  int no;
};            

struct City
{
  int no;
  Edge* e;
  int data;
  int r;
  Edge* prev;
  bool mark;

  City(int no, int r)
  {
    this->no = no;
    this->r = r;
    mark = false;
    data = -1;
    e = 0;
    prev = 0;
  }

  void add_edge(City* to, int w, bool our, int no)
  {
    Edge* f = new Edge;
    f->from = this;
    f->to = to;
    f->w = w+r;
    f->our = our;
    f->next = e;
    f->no = no;
    f->mark = false;
    e = f;
  }

  void relax(Edge* f)
  {
    int t = f->w+f->from->data;
    if ((data==-1)||(data>t))
    {
      assert(!mark);
      data = t;
      prev = f;
    }
  }

  void backward()
  {
    if (prev)
    {
      prev->mark = true;
      prev->from->backward();
    }
  }
  
  void writepath()
  {
    if (prev)
      prev->from->writepath();
    printf("%d ",no);
  }
};

int n, m, sum;
City* c[2000];

int main()
{
  freopen("campaign.in","rt",stdin);
  freopen("campaign.out","wt",stdout);

  scanf("%d%d",&n,&m);
  for (int i=0;i<n;i++)
  {
    int r;
    scanf("%d",&r);
    c[i] = new City(i+1,r);
  }
  sum = 0;
  for (int i=0;i<m;i++)
  {
    int a, b, p, cc;
    scanf("%d%d%d%d",&a,&b,&p,&cc);
    c[a-1]->add_edge(c[b-1],cc,p==1,i);
    c[b-1]->add_edge(c[a-1],cc,p==1,i);
    if (p==1)
      sum += cc;
  }

  City* cur = c[0];
  cur->data = 0;
  while (cur)
  {
    cur->mark = true;
    for (Edge* e = cur->e;e;e=e->next)
      e->to->relax(e);
    cur = 0;
    for (int i=0;i<n;i++)
      if ((c[i]->data!=-1)&&(!c[i]->mark)&&(!cur||(cur->data>c[i]->data)))
        cur = c[i];
  }

  if ((c[n-1]->data==-1)||(c[n-1]->data>sum))
    printf("-1\n");
  else
  {
    for (int i=0;i<m;i++)
    {
      sell[i] = true;
      buy[i] = false;
    }
    c[n-1]->backward();
    for (int i=0;i<n;i++)
      for (Edge* e=c[i]->e;e;e=e->next)
      {
        sell[e->no] &= (e->our)&&!(e->mark);
        buy[e->no] |= (e->mark)&&!(e->our);
      }
    int count = 0;
    for (int i=0;i<m;i++)
      count += sell[i];
    printf("%d",count);
    for (int i=0;i<m;i++)
      if (sell[i])
        printf(" %d",i+1);
    printf("\n");
    count = 0;
    for (int i=0;i<m;i++)
      count += buy[i];
    printf("%d",count);
    for (int i=0;i<m;i++)
      if (buy[i])
        printf(" %d",i+1);
    printf("\n");
    c[n-1]->writepath();
    printf("\n");
  }

  return 0;
}