{
          

    :     
    :       
    :     
}

{$apptype CONSOLE}
{$q+,r+,o-,c+}

uses Sysutils;

const
	IN_FILE = 'censored.in';
	OUT_FILE = 'censored.out';

	ALLOWED_CHARS = [#32..#255];
	DELIMITERS = [' ', '.', '!', '?', ':', '-', ',', ';', '(', ')'];
	MAX_PHRASE_LEN = 250;
	MAX_PHRASES = 1000;
	
var
	i, j : integer;
	n : integer;
	phrase, token : string;	
	nTokens, nSuspiciousTokens : integer;
	
function IsSuspicious(text : string) : boolean;
var
	used : array[char] of boolean;
	i : integer;
	nDistinct : integer;
	
begin
	fillchar(used, sizeof(used), false);
	nDistinct := 0;
	for i := 1 to length(text) do
		if not used[text[i]] then begin
			used[text[i]] := true;
			inc(nDistinct);
		end;

	result := nDistinct <= 3;				
end;

		
begin
	reset(input, IN_FILE);
	rewrite(output, OUT_FILE);
	
	n := 0;
	while not EOF do begin
		inc(n);
		readln(phrase);
		
		assert(length(phrase) <= MAX_PHRASE_LEN);
		for i := 1 to length(phrase) do
			assert(phrase[i] in ALLOWED_CHARS);
			
		i := 1;
		nTokens := 0;
		nSuspiciousTokens := 0;
		while i <= length(phrase) do begin
			while (i <= length(phrase)) and (phrase[i] in DELIMITERS) do
				inc(i);
			if i > length(phrase) then
				break;

			j := i;
			while (j < length(phrase)) and not (phrase[j+1] in DELIMITERS) do
				inc(j);
				
			inc(nTokens);
			token := copy(phrase, i, j - i + 1);
			if IsSuspicious(token) then
				inc(nSuspiciousTokens);
				
			i := j + 1;	
		end;
		
		assert(nTokens > 0);
		
		if nSuspiciousTokens * 2 < nTokens then
			writeln(phrase);
	end;
	
	assert(n <= MAX_PHRASES);
	
	close(input);
	close(output);
end.
	