uses
    sysutils;

const
    max_n = 300;
    max_q = 1000000000;

const
    dx: array [1..8] of longint = (1, 1,  1, 0,  0, -1, -1, -1);
    dy: array [1..8] of longint = (1, 0, -1, 1, -1,  1,  0, -1);
var
    i, j, k, n, m, c: longint;
    x, y, v: array [1..max_n * max_n] of longint;
    f: array [1..max_n, 1..max_n] of longint;
    f1, f2: boolean;

procedure qsort(l, r: longint);
var
    i, j, z, t: longint;
begin
    i := l;
    j := r;
    z := v[(i * 13 + j * 17) div 30];
    while i <= j do begin
        while v[i] < z do inc(i);
        while z < v[j] do dec(j);
        if i <= j then begin
            t := v[i]; v[i] := v[j]; v[j] := t;
            t := x[i]; x[i] := x[j]; x[j] := t;
            t := y[i]; y[i] := y[j]; y[j] := t;
            inc(i);
            dec(j);
        end;
    end;
    if l < j then qsort(l, j);
    if i < r then qsort(i, r);
end;


begin
    assign(input, 'chess.in'); reset(input);
    assign(output, 'chess.out'); rewrite(output);

    read(m, n, k);     
    assert((0 < n) and (n <= max_n), 'N out of bounds');
    assert((0 < m) and (m <= max_n), 'M out of bounds');
    assert((0 <= k) and (k < m * n), 'K out of bounds');

    c := 0;
    for i := 1 to m do begin
        for j := 1 to n do begin
            read(f[i][j]);
            assert((0 <= f[i][j]) and (f[i][j] <= max_q), format('f[%d][%d]', [i, j]));
            if f[i][j] > 0 then begin
                inc(c);
                x[c] := j;
                y[c] := i;
                v[c] := f[i][j];
            end;
        end;
    end;

    qsort(1, c);

    f1 := c = k + 1;
    for i := 1 to c - 1 do begin
        f2 := false;
        for j := 1 to 8 do begin
            f2 := f2 or ((x[i] - x[i + 1]) * dy[j] = (y[i] - y[i + 1]) * dx[j]);
        end;
        f1 := f1 and f2 and (v[i] < v[i + 1]);
    end;

    if f1 then begin
        for i := 1 to c do begin
            f[y[i]][x[i]] := i;
        end;
        for i := 1 to m do begin
            for j := 1 to n do begin
                write(f[i][j], ' ');
            end;
            writeln;
        end;
    end else begin
        writeln('Wrong Board');
    end;


    close(input);
    close(output);
end.