{
          

    :        
    :       
    :     
}

{$APPTYPE CONSOLE}
{$O-,Q+,R+}
Uses Math, SysUtils;

const
  problem_id = 'chess';
  maxr = 300;
  maxc = 300;

procedure NoSolution;
begin
  writeln('Wrong Board');
  halt;
end;

var r, c : integer;
    a, b : array [1..maxr, 1..maxc] of integer;
    n : integer;
    rr, cc : array [1..maxr * maxc] of integer;
    p : array [1..maxr * maxc] of integer;

function value(index : integer) : integer;
begin
  index := p[index];
  value := a[rr[index]][cc[index]];
end;

procedure Sort(l, r : integer);
var i, j, m, y : integer;
begin
  m := value(l + random(r - l + 1));
  i := l;
  j := r;
  while i <= j do
  begin
    while value(i) < m do inc(i);
    while value(j) > m do dec(j);
    if i <= j then
    begin
      y := p[i];
      p[i] := p[j];
      p[j] := y;
      inc(i);
      dec(j);
    end;
  end;
  if i < r then Sort(i, r);
  if l < j then Sort(l, j);
end;

function qt(x1, y1, x2, y2 : integer) : boolean;
begin
  qt := (x1 = x2) or (y1 = y2) or (abs(x1 - x2) = abs(y1 - y2));
end;

var nt, i, j : integer;

begin
  randseed := 138531;
  reset(input, problem_id + '.in');
  rewrite(output, problem_id + '.out');
  read(r); // rows in the board
  assert(not seekeoln);
  read(c); // columns in the board
  assert(not seekeoln);
  read(nt); // number of queen's turns
  assert((1 <= r) and (r <= maxr));
  assert((1 <= c) and (c <= maxc));
  assert((0 <= nt) and (nt < r * c));

  n := 0;
  for i := 1 to r do
  begin
    assert(seekeoln);
    readln;
    for j := 1 to c do
    begin
      assert(not seekeoln);
      read(a[i][j]);
      assert((a[i][j] >= 0) and (a[i][j] <= 1000 * 1000 * 1000));
      if a[i][j] > 0 then
      begin
        inc(n);
        rr[n] := i;
        cc[n] := j;
      end;
    end;
  end;
  assert(seekeof);

  if nt+1 <> n then NoSolution;

  for i := 1 to n do p[i] := i;
  Sort(1, n);
  for i := 1 to n-1 do if value(i) = value(i+1) then NoSolution;
  for i := 1 to n-1 do if not qt(rr[p[i]], cc[p[i]], rr[p[i+1]], cc[p[i+1]]) then
    NoSolution;
  fillchar(b, sizeof(b), 0);
  for i := 1 to n do
    b[rr[p[i]]][cc[p[i]]] := i;
  for i := 1 to r do
  begin
    for j := 1 to c do write(b[i][j],' ');
    writeln;
  end;
end.
