(*
  "Two Knights". Jury's solution.
  Antony Popovich, 21.10.2004.
  Used an algorythm, based on simple tracing
*)

{$APPTYPE CONSOLE}
{$Q+,R+,O+}

uses
  math, sysutils;

const
  fn = 'buses';

type
  tman = record
    overtime, ready, curtrip, curplace : longint;
    over : boolean;
    c : array[0..105] of longint;
  end;

var
  a : array[0..105, 0..105] of longint;
  i, j,
  n, k : longint;
  curtime, numover : longint;

  p : array[0..105] of tman;
  pnum : longint;

  sused : array[0..105] of boolean; {station is used by at least one bus}

begin
  assign(input, fn + '.in'); reset(input);
  assign(output, fn + '.out'); rewrite(output);

  read(n, k); assert(n > 0);
  for i := 1 to k do begin
    read(a[i, 0]);
    for j := 1 to a[i, 0] do begin
      read(a[i, j]);
      sused[a[i, j]] := true;
    end;
  end;

  numover := 0;

  read(pnum);
  for i := 1 to pnum do begin
    read(p[i].curplace, p[i].c[0]);
    p[i].ready := 1; p[i].curtrip := 0; p[i].over := false;
    for j := 1 to p[i].c[0] do
      read(p[i].c[j]);
    if not sused[p[i].curplace] then begin
      p[i].over := true; p[i].overtime := 0; p[i].curplace := 0; inc(numover);
    end;
  end;

  curtime := 0;
  while numover < pnum do begin
    {putting people into buses}
    for i := 1 to pnum do if (not p[i].over) and (p[i].ready > 0) then begin
      for j := 1 to k do if a[j, (curtime mod a[j, 0]) + 1] = p[i].curplace then begin
        inc(p[i].curtrip);
        p[i].ready := -p[i].c[p[i].curtrip];
        p[i].curplace := a[j, ((curtime - p[i].ready) mod a[j, 0]) + 1];
        break;
      end;
    end;

    for i := 1 to pnum do if not p[i].over then begin
      inc(p[i].ready);
      if (p[i].ready > 0) and (p[i].curtrip >= p[i].c[0]) then begin
        p[i].over := true;
        p[i].overtime := curtime;
        inc(numover);
      end;
    end;

    inc(curtime);
  end;

  for i := 1 to pnum do begin
    writeln(p[i].overtime, ' ', p[i].curplace);
  end;
end.

