{$O-,Q+,R+}

program buses;

uses
    sysutils;

const
    maxn = 50;
    maxk = 50;
    maxp = 50;
    maxl = 50;
    maxm = 50;
    maxc = 50;

var
    n, k, p: longint;
    l: array [1..maxk] of longint;
    stop: array [1..maxk, 1..maxl] of longint;
    b, m: array [1..maxp] of longint;
    c: array [1..maxp, 1..maxc] of longint;
    pass: array [1..maxn] of boolean;


procedure readinput;
var
    i, j: longint;
begin
    assert(not eoln);
    read(n);
    assert((n >= 1) and (n <= maxn));

    assert(not eoln);
    read(k);
    assert((k >= 1) and (k <= maxk));

    assert(eoln);
    readln;
    for i := 1 to k do begin
        assert(not eoln);
        read(l[i]);
        assert((l[i] >= 1) and (l[i] <= maxl));
        for j := 1 to l[i] do begin
            assert(not eoln);
            read(stop[i][j]);
            pass[stop[i][j]] := true;

            assert((stop[i][j] >= 1) and (stop[i][j] <= n));
        end;
        assert(eoln);
        readln;
    end;

    assert(not eoln);
    read(p);
    assert((p >= 1) and (p <= maxp));

    assert(eoln);
    readln;
    for i := 1 to p do begin
        assert(not eoln);
        read(b[i]);
        assert((b[i] >= 1) and (b[i] <= n));

        assert(not eoln);
        read(m[i]);
        assert((m[i] >= 1) and (m[i] <= maxm));
        for j := 1 to m[i] do begin
            assert(not eoln);
            read(c[i][j]);
            assert((c[i][j] >= 1) and (c[i][j] <= maxc));
        end;
        assert(eoln);
        readln;
    end;

    assert(eof);
end;

var
    bus, left, where, part, time: array [1..maxp] of longint;
    fail: array [1..maxp] of boolean;
    cur: array [1..maxk] of longint;

procedure findbus(i: longint);
var
    j: longint;
begin
    for j := 1 to n do
        if stop[j][cur[j]] = where[i] then begin
            bus[i] := j;
            left[i] := c[i][part[i]];
            break;
        end;
end;

var
    i, t: longint;
    riding: boolean;

begin
    reset(input, 'buses.in');
    rewrite(output, 'buses.out');

    readinput;

    for i := 1 to n do
        cur[i] := 1;

    for i := 1 to p do begin
        where[i] := b[i];
        if not pass[b[i]] then
            fail[i] := true;
        part[i] := 1;
        findbus(i);
    end;

    riding := true;
    t := 0;
    while riding do begin
        riding := false;

        inc(t);
        for i := 1 to n do begin
            inc(cur[i]);
            if cur[i] > l[i] then 
                cur[i] := 1;
        end;

        for i := 1 to p do begin
            if not fail[i] and (part[i] <= m[i]) then begin
                riding := true;
                if bus[i] = 0 then begin
                    riding := true;
                    findbus(i);
                end else begin
                    dec(left[i]);
                    if left[i] = 0 then begin
                        where[i] := stop[bus[i]][cur[bus[i]]];
                        bus[i] := 0;
                        inc(part[i]);
                        if part[i] > m[i] then begin
                            time[i] := t;
                        end;
                    end;
                end;
            end;
        end;
    end;

    for i := 1 to p do
        if fail[i] then
            writeln(0, ' ', 0)
        else
            writeln(time[i], ' ', where[i]);
end.
