{$apptype CONSOLE}
{$O-,R+,Q+}

uses
	Math;
	
const
	IN_FILE = 'castle.in';
	OUT_FILE = 'castle.out';
	
	MAX_N = 180;
	MAX_R = 100;

type
	real = extended;
	TPointType = (_start, _end);
	
	TPoint = record
		x : integer;
		t : TPointType;
	end;	
		
var
	n : integer;
	r : integer;

	p : array[1..MAX_N * 2 + 2] of TPoint;	
	np : integer;
	
	answer : real;

procedure AppendPoint(x : integer; t : TPointType);
begin
	inc(np);
	p[np].x := x;
	p[np].t := t;
end;

procedure SortPoints;
var
	i, j : integer;
	tmp : TPoint;
	
begin
	for i := 1 to np do
		for j := i + 1 to np do
			if p[i].x > p[j].x then begin
				tmp := p[i];
				p[i] := p[j];
				p[j] := tmp;
			end;	
end;

procedure AppendCover(lo, hi : integer);
begin
//writeln('conver ', lo, ' ', hi);
	answer := answer + r * (hi - lo) * Pi / 180;
end;

procedure AppendEmpty(lo, hi : integer);
begin
//writeln('empty ', lo, ' ', hi);
	answer := answer + 2 * r * sin(abs(lo - hi) * Pi / 360);
end;

procedure ReadInput;
var
	lo, hi : integer;
	i : integer;

begin
	reset(input, IN_FILE);
	read(n);
	if (n < 1) or (n > MAX_N) then runerror(239);
	if eoln then runerror(239);
	read(r);
	if (r < 1) or (r > MAX_R) then runerror(239);
	if not eoln then runerror(239);
	readln;
	
	np := 0;
	for i := 1 to n do begin
		read(lo);
		if (lo < 0) or (lo > 360) then runerror(239);
		if eoln then runerror(239);
		read(hi);
		if (hi < 0) or (hi > 360) then runerror(239);
		if not eoln then runerror(239);
		readln;
		
		if lo <= hi then begin
			AppendPoint(lo, _start);
			AppendPoint(hi, _end);
		end else begin
			AppendPoint(lo, _start);
			AppendPoint(360, _end);
			AppendPoint(0, _start);
			AppendPoint(hi, _end);
		end;
	end;
	if not eof then runerror(239);
	close(input);
end;

procedure Solve;
var
	depth : integer;
	
	thisstart, thisend : integer;
	firststart, lastend : integer;
	i : integer;
	
begin
	SortPoints;	

	answer := 0;
	depth := 0;
	firststart := -1;
	lastend := -1;
	
	thisstart := -1;
	thisend := 0;
	for i := 1 to np do begin
		if p[i].t = _start then begin
			inc(depth);
			if depth > 1 then runerror(239);
			if depth = 1 then begin
				thisstart := p[i].x;
				if (firststart <> -1) and (thisstart > thisend) then
					AppendEmpty(thisend, thisstart);
				if firststart = -1 then
					firststart := thisstart;
			end;
		end else begin
			dec(depth);
			if depth = 0 then begin
				thisend := p[i].x;
				lastend := thisend;
				if thisstart < thisend then
					AppendCover(thisstart, thisend);
			end;
		end;
	end;
	
	if (lastend < 360) or (firststart > 0) then
		AppendEmpty(lastend, firststart);
end;

procedure WriteOutput;
begin
	rewrite(output, OUT_FILE);
	writeln(answer:0:3);
	close(output);
end;

begin
	ReadInput;
	Solve;
	WriteOutput;	
end.
