program chart;

uses
    sysutils;

const
    allowed: set of char = ['A'..'Z', 'a'..'z', '0'..'9', ' ', #13, #10, 
        '-', ',', '.', '!', '?', ':', ';', '(', ')'];
    maxcount = 10000;

var
    c, prev: char;
    ccount: longint;
    i: longint;
    count: array [char] of longint;
    max: longint;

begin
    reset(input, 'chart.in');
    rewrite(output, 'chart.out');

    ccount := 0;
    prev := #0;
    while not eof do begin
        read(c);
        inc(ccount);
        assert(c in allowed, format('Invalid character at %d: %c', [ccount, c]));
        assert(ccount <= maxcount);

        if prev = #13 then
            assert(c = #10)
        else
            assert(c <> #10);

        inc(count[c]);
        prev := c;
    end;

    max := 0;
    for c := succ(' ') to #255 do begin
        if count[c] > max then max := count[c];
    end;

    for i := max downto 1 do begin
        for c := succ(' ') to #255 do begin
            if count[c] > 0 then begin
                if count[c] >= i then
                    write('#')
                else
                    write(' ');
            end;
        end;
        writeln;
    end;
    for c := succ(' ') to #255 do begin
        if count[c] > 0 then begin
            write(c);
        end;
    end;
    writeln;
end.