(*
  "Minesweeper". Jury's solution.
  Antony Popovich, 21.10.2004.
*)

{$APPTYPE CONSOLE}
{$Q+,R+,O+}

uses
  math, sysutils;

const
  fn = 'mines';
  di : array[1..8] of longint = (-1,  0,  1, -1,  1, -1,  0,  1);
  dj : array[1..8] of longint = (-1, -1, -1,  0,  0,  1,  1,  1);

procedure impos;
begin
  writeln('No solution');
  halt;
end;

var
  a : array[0..101, 0..101] of longint;
  i, j, k, cnt,
  m, n : longint;

begin
  assign(input, fn + '.in'); reset(input);
  assign(output, fn + '.out'); rewrite(output);

  read(m, n);
  for i := 1 to m do
    for j := 1 to n do
      read(a[i, j]);

  for i := 0 to m + 1 do begin
    a[i, 0] := 1;
    a[i, n + 1] := 1;
  end;
  for i := 0 to n + 1 do begin
    a[0, i] := 1;
    a[m + 1, i] := 1;
  end;

  {placing mines}
  for i := 1 to m do begin
    for j := 1 to n do if a[i, j] <> 0 then begin
      {counting the number of non-zero elements in the adjacent cells}
      cnt := 0;
      for k := 1 to 8 do
        inc(cnt, ord(a[i + di[k], j + dj[k]] <> 0));

      if cnt = 8 then
        a[i, j] := -1; {put a mine there}
    end;
  end;

  for i := 0 to m + 1 do begin
    a[i, 0] := 0;
    a[i, n + 1] := 0;
  end;
  for i := 0 to n + 1 do begin
    a[0, i] := 0;
    a[m + 1, i] := 0;
  end;

  {placing digits and verifying}
  for i := 1 to m do begin
    for j := 1 to n do if a[i, j] > 0 then begin
      {counting the number of mines in the adjacent cells}
      cnt := 0;
      for k := 1 to 8 do
        inc(cnt, ord(a[i + di[k], j + dj[k]] = -1));

      if cnt = 0 then
        impos;

      a[i, j] := cnt; {draw number of mines}
    end;
  end;

  {all right. output the field}
  for i := 1 to m do begin
    for j := 1 to n do begin
      if a[i, j] = 0 then begin
        write('.');
      end else if a[i, j] < 0 then begin
        write('*');
      end else begin
        write(a[i, j]);
      end;
    end;
    writeln;
  end;
end.
