// SPb-JPC-Kirov-2004
// Problem: "Mines"
// Solution by Orshanskiy Sergey

{$APPTYPE CONSOLE}
Uses Math, SysUtils;
{$O-,Q+,R+}

const problem_id = 'mines';
      maxr = 100;
      maxc = 100;

dr : array [1..8] of integer = (0, 1, 1, 1, 0, -1, -1, -1);
dc : array [1..8] of integer = (1, 1, 0, -1, -1, -1, 0, 1);

var
  r, c, i, j, x, d : integer;
  free : array [0..maxr + 1, 0..maxc + 1] of boolean;
  mine : array [0..maxr + 1, 0..maxc + 1] of boolean;
  nn : array [1..maxr, 1..maxc] of integer;

procedure NoSolution;
begin
  writeln('No solution');
  halt;
end;

begin
  if ParamCount < 1 then
	  AssignFile(input, problem_id + '.in') else
    AssignFile(input, ParamStr(1));
	reset(input);
  if ParamCount < 2 then
    AssignFile(output, problem_id + '.out') else
    AssignFile(output, ParamStr(2));
	rewrite(output);

  assert(not seekeoln);
  read(r);
  assert(not seekeoln);
  read(c);
  assert(seekeoln);
  readln;
  assert((1 <= r) and (r <= maxr));
  assert((1 <= c) and (c <= maxc));

  fillchar(free, sizeof(free), 0);
  for i := 1 to r do
  begin
    for j := 1 to c do
    begin
      assert(not seekeoln);
      read(x);
      free[i][j] := (x = 0);
    end;
    assert(seekeoln);
    readln;
  end;
  assert(seekeof);

  fillchar(mine, sizeof(mine), false);
  for i := 1 to r do
    for j := 1 to c do
    begin
      mine[i][j] := not free[i][j];
      for d := 1 to 8 do
        mine[i][j] := mine[i][j] and
          (not free[i + dr[d]][j + dc[d]]);
    end;

  for i := 1 to r do
    for j := 1 to c do
    begin
      nn[i][j] := 0;
      for d := 1 to 8 do
        if mine[i + dr[d]][j + dc[d]] then
          inc(nn[i][j]);
      if free[i][j] <> ((not mine[i][j]) and (nn[i][j] = 0)) then
        NoSolution;
    end;

  for i := 1 to r do
  begin
    for j := 1 to c do
      if mine[i][j] then write('*') else
      if free[i][j] then write('.') else
      write(char(ord('0') + nn[i][j]));
    writeln;
  end;
end.

