// SPb-JPC-Kirov-2004
// Problem: "Number"
// Solution by Orshanskiy Sergey

{$APPTYPE CONSOLE}
Uses Math, SysUtils;
{$O-,Q+,R+}

const problem_id = 'number';
      max_n = 1000;    // max n in the input

      max_l = max_n div 5; // max answer's length. (supposed to be)

var
  n : integer;
  // r[i][j] - digit j in the i-th position gives
  // such additional remainder modulo n
  rem : array [0..max_l - 1, 0..9] of integer;

  // is it possible to construct an i-digit number
  // to be j modulo n and to have sum of digits equal to k?

  // it contains either 0 or the chosen digit + 1
  // leading zeroes are possible here
  z : array [0..max_l - 1, 0..max_n - 1, 0..max_n] of byte;

  i, j, r, sm, ll, dig : integer;

procedure print(ll, rm, sm : integer);
var y : integer;
begin
  if ll = 0 then exit;
  y := z[ll][rm][sm];
  assert(y <> 0);
  dec(y);
  write(char(ord('0') + y));
  rm := rm - rem[ll-1][y];
  if rm < 0 then rm := rm + n;
  sm := sm - y;
  assert((0 <= rm) and (rm < n));
  assert((0 <= sm) and (sm <= n));
  print(ll - 1, rm, sm);
end;

var y : integer;
begin
  if ParamCount < 1 then
	  AssignFile(input, problem_id + '.in') else
    AssignFile(input, ParamStr(1));
	reset(input);
  if ParamCount < 2 then
    AssignFile(output, problem_id + '.out') else
    AssignFile(output, ParamStr(2));
	rewrite(output);

  assert(not seekeoln);
  read(n);
  assert(seekeof);
  assert((1 <= n) and (n <= max_n));

  r := 1;
  for i := 0 to max_l - 1 do
  begin
    for j := 0 to 9 do
    begin
      rem[i][j] := (r * j) mod n;
    end;
    r := (r * 10) mod n;
  end;

  fillchar(z, sizeof(z), 0);
  z[0][0][0] := 255;

  for ll := 1 to max_l do // let the answer be of "ll" digits
  begin
    // first of all check
    for dig := 1 to min(9, n) do
    begin
      if z[ll - 1][(n - rem[ll - 1][dig]) mod n][n - dig] <> 0 then
      begin
        write(dig);
        print(ll - 1, (n - rem[ll - 1][dig]) mod n, n - dig);
		writeln;
		halt(0);
      end;
    end;

    for r := 0 to n - 1 do
      for sm := 0 to n do
        for dig := 0 to min(sm, 9) do
        begin
          y := r - rem[ll-1][dig];
          if y < 0 then y := y + n;
          if z[ll-1][y][sm - dig] <> 0 then
          begin
            z[ll][r][sm] := dig + 1;
            break;
          end;
        end;
  end;
  assert(false); // the answer is longer than max_l digits


end.