{$o-,q+,r+}
{$minstacksize $00400000}
{$apptype console}
uses
	math, sysutils;

const
	inf = $77777777;
	eps = 1e-10;
    maxn = 1000;
	finname = 'rect';
type
	int = longint;
    tbound = record
        x1, x2, y1, y2: int;
    end;
    bmatr = record
        m, n: int;
        a: array[0 .. maxn + 1, 0 .. maxn + 1] of boolean;
    end;
    cmatr = record
        m, n: int;
        a: array[0 .. maxn + 1, 0 .. maxn + 1] of char;
    end;
const
    nulb: tbound = (x1: maxn + 1; x2: 0; y1: maxn + 1; y2: 0);
procedure relax(var a: tbound; const x, y: int);
begin
    if (a.x1 > x) then
        a.x1 := x;
    if (a.y1 > y) then
        a.y1 := y;
    if (a.x2 < x) then
        a.x2 := x;
    if (a.y2 < y) then
        a.y2 := y;
end;
procedure rotbm(var v: bmatr);
var
    t: array[0 .. maxn + 1, 0 .. maxn + 1] of boolean;
    i, j: int;
begin
    with v do begin
        for i := 0 to m + 1 do
            for j := 0 to n + 1 do
                t[j, m - i + 1] := a[i, j];
        i := m;
        m := n;
        n := i;
        for i := 0 to m + 1 do
            for j := 0 to n + 1 do
                a[i, j] := t[i, j];
    end;
end;
procedure rotcm(var v: cmatr);
var
    t: array[0 .. maxn + 1, 0 .. maxn + 1] of char;
    i, j: int;
begin
    with v do begin
        for i := 0 to m + 1 do
            for j := 0 to n + 1 do
                t[j, m - i + 1] := a[i, j];
        i := m;
        m := n;
        n := i;
        for i := 0 to m + 1 do
            for j := 0 to n + 1 do
                a[i, j] := t[i, j];
    end;
end;
function check(const a: bmatr; const d: int; var r: cmatr): boolean;
var
    na, nb: int;
    ba, bb: tbound;
    i, j: int;
begin
    result := false;

    na := 0;
    nb := 0;
    ba := nulb;
    bb := nulb;

    for j := 1 to d do
        for i := 1 to a.m do
            if (a.a[i, j]) then begin
                relax(ba, i, j);
                inc(na);
            end;

    for j := d + 1 to a.n do
        for i := 1 to a.m do
            if (a.a[i, j]) then begin
                relax(bb, i, j);
                inc(nb);
            end;

	//writeln('a: ', ba.x1, ' ', ba.x2, '  ', ba.y1, ' ', ba.y2, '  ', na);
	//writeln('b: ', bb.x1, ' ', bb.x2, '  ', bb.y1, ' ', bb.y2, '  ', nb);

    if ( (ba.x2 - ba.x1 + 1) * (ba.y2 - ba.y1 + 1) <> na) then
        exit;

    if (nb = 0) then begin
        if ((ba.x1 = ba.x2) and (ba.y1 = ba.y2)) then
            exit;
        if (ba.x1 = ba.x2) then begin
            bb := ba;
            bb.y1 := ba.y2;
            dec(ba.y2);
            nb := ba.x2 - ba.x1 + 1;
        end
        else begin
            bb := ba;
            bb.x1 := ba.x2;
            dec(ba.x2);
            nb := ba.y2 - ba.y1 + 1;
        end;
    end;

    if ( (bb.x2 - bb.x1 + 1) * (bb.y2 - bb.y1 + 1) <> nb) then
        exit;

    result := true;
    r.m := a.m;
    r.n := a.n;
    for i := 1 to r.m do
        for j := 1 to r.n do
            r.a[i, j] := '.';
    for i := ba.x1 to ba.x2 do
        for j := ba.y1 to ba.y2 do
            r.a[i, j] := 'a';
    for i := bb.x1 to bb.x2 do
        for j := bb.y1 to bb.y2 do
            r.a[i, j] := 'b';
end;
var
	i, j: int;
    a: bmatr;
    ch: char;
    nr: int;
    l, lh1, lh2, r: int;
    an: cmatr;
begin
	reset(input, finname + '.in');
	rewrite(output, finname + '.out');

    read(a.m, a.n);
    for i := 0 to a.n + 1 do begin
        a.a[0, i] := false;
        a.a[a.m + 1, i] := false;
    end;
    for i := 0 to a.m + 1 do begin
        a.a[i, 0] := false;
        a.a[i, a.n + 1] := false;
    end;
    for i := 1 to a.m do begin
        //assert(eoln);
        readln;
        for j := 1 to a.n do begin
            read(ch);
            //assert((ch = '.') or (ch = '#'));
            a.a[i, j] := (ch = '#');
        end;
    end;
    //assert(eof);

    for nr := 1 to 4 do begin
        rotbm(a);
        {for i := 1 to a.m do begin
            for j := 1 to a.n do
                if (a.a[i, j]) then
                    write('#')
                else
                    write('.');
            writeln;
        end;

        writeln;
        writeln;}

        l := -1;
        for j := 1 to a.n do begin
            for i := 1 to a.m do
                if (a.a[i, j]) then begin
                    l := j;
                    lh1 := i;
                    break;
                end;
            if (l >= 0) then
                break;
        end;
        if (l = -1) then
            continue;
        lh2 := lh1;
        while (a.a[lh2 + 1, l]) do
            inc(lh2);
        r := l;
        while (
                     a.a[lh1, r + 1] and a.a[lh2, r + 1]
                and (not a.a[lh1 - 1, r + 1]) and (not a.a[lh2 + 1, r + 1])

               ) do
            inc(r);
        if (check(a, r, an)) then begin
            for i := 1 to 4 - nr do
                rotcm(an);
            writeln('YES');
            for i := 1 to an.m do begin
                for j := 1 to an.n do
                    write(an.a[i, j]);
                writeln;
            end;
            close(output);
            halt(0);
        end;
    end;

    write('NO');

	close(input);
	close(output);
end.