{$O-,R+,Q+}
{$apptype CONSOLE}

const
	MAX_N = 200;
	INFINITY = 10000;
	IN_FILE = 'rect.in';
	OUT_FILE = 'rect.out';
	
type
	TArray = array[1..MAX_N,1..MAX_N] of char;

var
	m, n : integer;
	a : TArray;
	
procedure Transpose;
var
	_a : TArray;
	i, j : integer;	
	tmp : integer;
		
begin
	for i := 1 to m do
		for j := 1 to n do
			_a[j,i] := a[i,j];
	a := _a;
	
	tmp := m;
	m := n;
	n := tmp;		
end;	

function Check : boolean;
var
	min, max : array[1..MAX_N] of integer;
	holes : array[1..MAX_N] of boolean;
	
	i, j, k : integer;
	count : integer;
	
	function IsGood(lo, hi : integer) : boolean;
	var
		i : integer;
		
	begin
		IsGood := false;
		while (lo < hi) and (min[lo] = INFINITY) do
			inc(lo);
		while (lo < hi) and (min[hi] = INFINITY) do
			dec(hi);
		if min[lo] = INFINITY then
			exit;
		for i := lo to hi do
			if (min[i] <> min[lo]) or (max[i] <> max[lo]) or holes[i] then
				exit;
		IsGood := true;
	end;
	
begin
	for i := 1 to m do begin
		min[i] := INFINITY;
		max[i] := -INFINITY;
		count := 0;
		for j := 1 to n do
			if a[i,j] = '#' then begin
				if min[i] = INFINITY then
					min[i] := j;
				max[i] := j;	
				inc(count);
			end;
		holes[i] := count <> max[i] - min[i] + 1;
	end;
	
	for k := 1 to m - 1 do
		if IsGood(1, k) and IsGood(k + 1, m) then begin
			for i := 1 to m do
				for j := 1 to n do
					if a[i,j] = '#' then begin
						if i <= k then
							a[i,j] := 'a'
						else
							a[i,j] := 'b';	
					end;
			Check := true;
			exit;		
		end;
		
	Check := false;
end;

procedure WriteYES;
var
	i, j : integer;
	
begin
	rewrite(output, OUT_FILE);
	writeln('YES');
	for i := 1 to m do begin
		for j := 1 to n do
			write(a[i,j]);
		writeln;
	end;		
	close(output);
end;
			
procedure WriteNO;
begin
	rewrite(output, OUT_FILE);
	writeln('NO');
	close(output);
end;

procedure ReadInput;
var
	i, j : integer;
	s : string;
	
begin
	reset(input, IN_FILE);
	read(m);
	if (m < 1) or (m > MAX_N) then runerror(239);
	if eoln then runerror(239);
	read(n);
	if (n < 1) or (n > MAX_N) then runerror(239);
	if not eoln then runerror(239);	
	readln;
	for i := 1 to m do begin
		if eof then runerror(239);
		readln(s);
		if length(s) <> n then runerror(239);
		for j := 1 to n do begin
			if not (s[j] in ['.', '#']) then runerror(239);
			a[i,j] := s[j];
		end;
	end;
	if not eof then runerror(239);
	close(input);
end;
			
begin
	ReadInput;
	if Check then begin
		WriteYES;
		halt;
	end;
	Transpose;
	if Check then begin
		Transpose;
		WriteYES;
		halt;
	end;		
	WriteNO;
end.
