// SPb-JPC-Kirov-2004
// Problem: "Rect"
// Solution by Orshanskiy Sergey

{$APPTYPE CONSOLE}
Uses Math, SysUtils;
{$O-,Q+,R+}

const problem_id = 'rect';
      maxr = 200;
      maxc = 200;
var
  r, c : integer;
  a : array [1..maxr, 1..maxc] of boolean;
  vert : array [1..maxc] of integer; // '#'s in every column
  horz : array [1..maxr] of integer; // '#'s in every row
  s : array [0..maxr, 0..maxc] of integer; // number of cells in left-upper sector

// number of '#'s in such a rectangle
function inrect(r1, c1, r2, c2 : integer) : integer;
begin
  inrect := s[r2][c2] - s[r1-1][c2] - s[r2][c1-1] + s[r1-1][c1-1];
end;

function rect(r1, c1, r2, c2 : integer) : boolean;
begin
  rect := inrect(r1, c1, r2, c2) = (r2 - r1 + 1) * (c2 - c1 + 1);
end;

// tells whether r1, c1, r2, c2 is the only rectangle in
// border rect. br1, bc1, br2, bc2
function onlyrect(br1, bc1, br2, bc2, r1, c1, r2, c2 : integer) : boolean;
begin
  onlyrect := rect(r1, c1, r2, c2) and
    (inrect(br1, bc1, br2, bc2) = inrect(r1, c1, r2, c2));
end;

function detectrectV(c1, c2 : integer) : boolean;
var i, j, k, l : integer;
begin
  result := false;
  i := c1;
  while (i <= c2) and (vert[i] = 0) do inc(i);
  if i > c2 then exit;
  j := c2;
  while vert[j] = 0 do dec(j);
  k := 1;
  while not a[k][i] do inc(k);
  l := r;
  while not a[l][i] do dec(l);
  detectrectV := onlyrect(1, c1, r, c2, k, i, l, j);
end;

function detectrectH(r1, r2 : integer) : boolean;
var i, j, k, l : integer;
begin
  result := false;
  i := r1;
  while (i <= r2) and (horz[i] = 0) do inc(i);
  if i > r2 then exit;
  j := r2;
  while horz[j] = 0 do dec(j);
  k := 1;
  while not a[i][k] do inc(k);
  l := c;
  while not a[i][l] do dec(l);
  detectrectH := onlyrect(r1, 1, r2, c, i, k, j, l);
end;
var
  rr, cc, i, j, v, h : integer;
  ch : char;

procedure printsolV(v : integer);
var i, j : integer;
begin
  writeln('YES');
  for i := 1 to r do
  begin
    for j := 1 to c do
      if not a[i][j] then write('.') else
      if j <= v then write('a') else
        write('b');
    writeln;
  end;
  halt;
end;
procedure printsolH(h : integer);
var i, j : integer;
begin
  writeln('YES');
  for i := 1 to r do
  begin
    for j := 1 to c do
      if not a[i][j] then write('.') else
      if i <= h then write('a') else
        write('b');
    writeln;
  end;
  halt;
end;

begin
  if ParamCount < 1 then
	  AssignFile(input, problem_id + '.in') else
    AssignFile(input, ParamStr(1));
	reset(input);
  if ParamCount < 2 then
    AssignFile(output, problem_id + '.out') else
    AssignFile(output, ParamStr(2));
	rewrite(output);

  assert(not seekeoln);
  read(r);
  assert(not seekeoln);
  read(c);
  assert(seekeoln);
  readln;
  assert((1 <= r) and (r <= maxr));
  assert((1 <= c) and (c <= maxc));

  fillchar(vert, sizeof(vert), 0);
  fillchar(horz, sizeof(horz), 0);

  for rr := 1 to r do
  begin
    for cc := 1 to c do
    begin
      assert(not seekeoln);
      read(ch);
      assert((ch = '.') or (ch = '#'));
      a[rr][cc] := (ch = '#');
      if a[rr][cc] then
      begin
        inc(vert[cc]);
        inc(horz[rr]);
      end;
    end;
    assert(seekeoln);
    readln;
  end;
  assert(seekeof);

  fillchar(s, sizeof(s), 0);
  for i := 1 to r do
    for j := 1 to c do
    s[i][j] :=
      s[i-1][j] + s[i][j-1] - s[i-1][j-1] + ord(a[i][j]);

  // dividing with a vertical line
  for v := 1 to c - 1 do //1..v, v+1..c
    if detectrectV(1, v) and detectrectV(v+1, c) then
      printsolV(v);
  for h := 1 to r - 1 do //1..h, h+1..r
    if detectrectH(1, h) and detectrectH(h+1, r) then
      printsolH(h);
  writeln('NO');
end.
