(*
  "Red Zeroes". Jury's solution.
  Antony Popovich, 20.10.2004.
*)

{$APPTYPE CONSOLE}
{$Q+,R+,O+}

uses
  math, sysutils;

const
  fn = 'zeroes';

var
  ulz, z : array[0..65535] of longint; {z[i] = number of zeroes in number i (ulz[i] = taking in account only unleading zeroes}
  rz, {rz[i, j] = number of red zeroes in number i with offset j}
  cum : array[0..65535, 0..29] of longint; {cum[i, j] = sum[0..i](cum[i, j])}
  ulrz, ulcum : array[0..65535] of longint; {-||-, taking in account only unleading zeroes}
  n, k : longint;

procedure precalc;
var
  i, j, cur, ones : longint;
begin
  {counting, how many zeroes are in each of the following numbers}
  for i := 0 to 65535 do begin
    ones := 0; cur := i; ulz[i] := 0;
    while cur <> 0 do begin
      inc(ones);
      if cur and (cur - 1) = 0 then begin
        while cur <> 0 do begin
          inc(ulz[i]);
          cur := cur shr 1;
        end;
        dec(ulz[i], ones);
        break;
      end;
      cur := cur and (cur - 1);
    end;
    z[i] := 16 - ones;
  end;

  {counting the number of red zeroes}
  for i := 0 to 65535 do begin
    for j := 0 to 29 do begin
      rz[i, j] := (z[i] - j + k - 1) div k;
    end;
    ulrz[i] := (ulz[i] + k - 1) div k;
  end;

  {counting cum array}
  for i := 0 to 65535 do begin
    for j := 0 to 29 do begin
      if i <> 0 then inc(cum[i, j], cum[i - 1, j]);
      inc(cum[i, j], rz[i, j]);
    end;
    if i <> 0 then inc(ulcum[i], ulcum[i - 1]);
    inc(ulcum[i], ulrz[i]);
  end;
end;

var
  ans : int64;
  i, offset : longint;

begin
  assign(input, fn + '.in'); reset(input);
  assign(output, fn + '.out'); rewrite(output);

  read(n, k);

  precalc;

  ans := 0;
  for i := 0 to (n shr 16) - 1 do begin
    if i = 0 then begin
      inc(ans, ulcum[65535]);
    end else begin
      offset := ((32 * k) - z[i]) mod k;
      inc(ans, 65536 * ulrz[i]);
      inc(ans, cum[65535, offset]);
    end;
  end;

  if (n shr 16) = 0 then begin
    inc(ans, ulcum[n]);
  end else begin
    offset := ((32 * k) - ulz[n shr 16]) mod k;
    inc(ans, (n - ((n shr 16) shl 16) + 1) * ulrz[n shr 16]);
    inc(ans, cum[n mod 65536, offset]);
  end;

  writeln(ans);
end.
