{$o-,q+,r+}
{$apptype console}
uses
    math, sysutils;
const
	finname = 'zeroes';
    maxk = 30;
    maxd = 31;
    maxs = 2 * maxd;
type
	int = longword;

var
    s, v: array[0 .. maxs] of int;
    ns: int;
    
/////////////////////////////////////////////////////////////
//   Finds the position of number a in sorted array s and   /
// adds it if necessary                                     /
/////////////////////////////////////////////////////////////
function getn(const a: int): int;
var
    l, h, x: int;
begin
    l := 1;
    h := ns + 1;
    while (l + 1 < h) do begin
        x := (l + h) div 2;
        if (a < s[x]) then
            h := x
        else
            l := x;
    end;

    if (l >= h) or (s[l] <> a) then begin
        l := ns;
        inc(ns);
        while (s[l] > a) do begin
            s[l + 1] := s[l];
            v[l + 1] := v[l];
            dec(l);
        end;
        inc(l);
        s[l] := a;
        v[l] := ns;
    end;
    result := v[l];
end;

var
    k: int;
    a: array[0 .. maxd, 0 .. maxk - 1, 1 .. maxs] of int64;

/////////////////////////////////////////////////////////////
//   Counts the amount of zeroes if first m  o-digit numbers/
// skipping first d zeroes in each number                   /
/////////////////////////////////////////////////////////////
function gen(const o, d, m: int): int64;
var
    x, dd, mm, mn: int;
begin
    mn := getn(m);
    if (a[o, d, mn] >= 0) then begin
        result := a[o, d, mn];
        exit;
    end;

    result := 0;

    x := 1 shl (o - 1) - 1;
    if (m > x) then begin
        inc(result, gen(o - 1, d, m - x - 1));
        mm := x
    end
    else
        mm := m;

    if (d = 0) then begin
        inc(result, mm + 1);
        dd := k - 1;
    end
    else
        dd := d - 1;
    inc(result, gen(o - 1, dd, mm));

    a[o, d, mn] := result;
end;

var
	n, i, j, l, p2i: int;
    res: int64;
begin
	reset(input, finname + '.in');
	rewrite(output, finname + '.out');

    read(n, k);

    for i := 0 to min( maxd, ceil(ln(n) / ln(2)) ) do
        for j := 0 to k - 1 do
            for l := 1 to maxs do
                a[i, j, l] := -1;
    for i := 0 to maxk - 1 do
        a[0, i, 1] := 0;

    ns := 1;
    s[1] := 0;
    v[1] := 1;

    res := 0;
    i := 1;
    p2i := 1;
    while (p2i <= n) do begin
        inc(res, gen( i - 1, 0, min(n - p2i, p2i - 1)) );
        inc(i);
        p2i := p2i shl 1;
    end;

    write(res);

	close(input);
	close(output);
end.