{$D-,L-,I-,Q-,R-,S-}
Program popular_alx;
const
  inpfile='popular.in';
  outfile='popular.out';
  nm=5025;
  eps=1e-6;
type
  Coord = record
    x,y : Extended;
  end;

  Rope = record
    o : Coord;
    r : Extended;
  end;

  Arc = record
    p1,p2 : Coord;
    num : LongInt;
  end;
var
  a : array [1..nm] of Rope;
  b : array [1..nm] of Arc;
  p : array [1..3] of Coord;
  q : array [1..3] of LongInt;
  n, m, state : LongInt;
  res : Coord;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  assert((1<=n) and (n<=5000));
  for i:=1 to n do begin
    read(a[i].o.x,a[i].r);
    assert((-eps<a[i].o.x) and (a[i].o.x<100000.0+eps));
    a[i].o.y:=0;
  end;
end;
{}
Procedure Out(ok : Boolean);
begin
  assign(output,outfile);
  rewrite(output);
  if ok then writeln(res.x:0:4,' ',res.y:0:4)
        else writeln('-1 -1');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(b,sizeof(b),0);
end;
{}
Function Vc(var p1,p2,p3,p4 : Coord) : Extended;
begin
  Vc:=(p2.x-p1.x)*(p4.y-p3.y)-(p2.y-p1.y)*(p4.x-p3.x);
end;
{}
Function Len(var q,w : Coord) : Extended;
begin
  Len:=sqrt(sqr(q.x-w.x)+sqr(q.y-w.y));
end;
{}
Procedure Cross(i,j : LongInt);
var
  pp,o : Coord;
  d,cs : Extended;
  ra,rb : Extended;
begin
  o:=a[b[j].num].o;
  rb:=a[b[j].num].r;
  ra:=a[i].r;
  d:=abs(a[i].o.x-o.x);

  if (d>ra+rb+eps) or (d<abs(ra-rb)+eps) then exit;

  cs:=(sqr(ra)+sqr(d)-sqr(rb))/(2*ra*d);
  if a[i].o.x>o.x then cs:=-cs;
  pp.x:=a[i].o.x+ra*cs;
  pp.y:=-ra*sqrt(1-sqr(cs));

  if (Vc(o,b[j].p1,o,pp)*Vc(o,b[j].p2,o,pp)<eps) then begin
    inc(state);
    p[state]:=pp;
    q[state]:=j;
  end;
end;
{}
Procedure Solve;
var
  i,j : LongInt;
  pp,o : Coord;
begin
  m:=1;
  b[1].num:=1;
  b[1].p1.x:=a[1].o.x-a[1].r;
  b[1].p1.y:=0;
  b[1].p2.x:=a[1].o.x+a[1].r;
  b[1].p2.y:=0;

  for i:=2 to n do begin
    state:=0;
    fillchar(q,sizeof(q),0);
    fillchar(p,sizeof(p),0);
    if (b[1].p1.x<a[i].o.x-a[i].r+eps) and (a[i].o.x+a[i].r<b[m].p2.x+eps) then begin
        m:=1;
        b[1].p1.x:=a[i].o.x-a[i].r;
        b[1].p1.y:=0;
        b[1].p2.x:=a[i].o.x+a[i].r;
        b[1].p2.y:=0;
        b[1].num:=i;
    end else
    if (a[i].o.x-a[i].r<b[1].p1.x+eps) and (b[m].p2.x<a[i].o.x+a[i].r+eps) then begin
      for j:=1 to m do begin
        Cross(i,j);
        if state=2 then break;
      end;  

      if state=2 then begin
        b[q[1]].p2:=p[1];
        b[q[2]].p1:=p[2];

        if q[1]+1=q[2] then begin
          for j:=m+1 downto q[2]+1 do b[j]:=b[j-1];
          inc(m);
          b[q[2]].p1:=p[1];
          b[q[2]].p2:=p[2];
          b[q[2]].num:=i;
        end else begin
          dec(m,q[2]-q[1]-2);
          for j:=q[1]+2 to m do b[j]:=b[j+q[2]-q[1]-2];
          b[q[1]+1].p1:=p[1];
          b[q[1]+1].p2:=p[2];
          b[q[1]+1].num:=i;
        end;
      end;
    end else
    if (b[1].p1.x<a[i].o.x+a[i].r+eps) and (a[i].o.x+a[i].r<b[m].p2.x+eps) then begin
      for j:=1 to m do begin
        Cross(i,j);
        if state=1 then break;
      end;

      b[q[1]].p2:=p[1];
      m:=q[1]+1;
      b[m].p1:=p[1];
      b[m].p2.x:=a[i].o.x+a[i].r;
      b[m].p2.y:=0;
      b[m].num:=i;
    end else
    if (b[1].p1.x<a[i].o.x-a[i].r+eps) and (a[i].o.x-a[i].r<b[m].p2.x+eps) then begin
      for j:=1 to m do begin
        Cross(i,j);
        if state=1 then break;
      end;

      if q[1]=1 then begin
        for j:=m+1 downto 2 do b[j]:=b[j-1];
        inc(m);

        b[1].p1.x:=a[i].o.x-a[i].r;
        b[1].p1.y:=0;
        b[1].p2:=p[1];
        b[1].num:=i;
        b[2].p1:=p[1];
      end else begin
        for j:=2 to m-q[1]+2 do b[j]:=b[j+q[1]-2];
        dec(m,q[1]-2);

        b[1].p1.x:=a[i].o.x-a[i].r;
        b[1].p1.y:=0;
        b[1].p2:=p[1];
        b[1].num:=i;
        b[2].p1:=p[1];
      end;
    end else Out(false);
  end;

  res:=b[1].p1;
  for i:=1 to m do begin
    pp.x:=a[b[i].num].o.x;
    pp.y:=-a[b[i].num].r;
    o:=a[b[i].num].o;
    if pp.y<res.y then begin
      if (Vc(o,b[i].p1,o,pp)*Vc(o,b[i].p2,o,pp)<eps) then res:=pp;
    end;

    if b[i].p1.y<res.y then res:=b[i].p1;
    if b[i].p2.y<res.y then res:=b[i].p2;
  end;

  for i:=1 to n do begin
    assert(Len(a[i].o,res)<a[i].r+eps)
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out(true);
End.
