{$D-,L-,I-,Q-,R-,S-}
Program popular_alx_slow;
const
  inpfile='popular.in';
  outfile='popular.out';
  nm=5005;
  eps=1e-10;
type
  Coord = record
    x,y : Extended;
  end;

  Rope = record
    o : Coord;
    r : Extended;
  end;  
var
  a : array [1..nm] of Rope;
  b : array [1..nm] of Coord;
  n : LongInt;
  res : Coord;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n);
  for i:=1 to n do begin
    read(a[i].o.x,a[i].r);
    a[i].o.y:=0;
  end;
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  if res.y<0.5 then writeln(res.x:0:4,' ',res.y:0:4)
               else writeln('-1 -1');
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
end;
{}
Function Len(var q,w : Coord) : Extended;
begin
  Len:=sqrt(sqr(q.x-w.x)+sqr(q.y-w.y));
end;
{}
Procedure Update(var p : Coord);
var
  i : LongInt;
begin
  if p.y>res.y then exit;

  for i:=1 to n do
    if Len(a[i].o,p)>a[i].r+eps then exit;

  res:=p;
end;
{}
Procedure Cross(i,j : LongInt; var p : Coord);
var
  d,cs : Extended;
begin
  d:=abs(a[i].o.x-a[j].o.x);

  if (d>a[i].r+a[j].r+eps) or (d<abs(a[i].r-a[j].r)+eps) then exit;
  
  cs:=(sqr(a[i].r)+sqr(d)-sqr(a[j].r))/(2*a[i].r*d);
  if a[i].o.x>a[j].o.x then cs:=-cs;
  p.x:=a[i].o.x+cs*a[i].r;
  p.y:=-a[i].r*sqrt(1-sqr(cs));
end;
{}
Procedure Solve;
var
  i,j : LongInt;
  p : Coord;
begin
  res.y:=1;

  for i:=1 to n do begin
    p.x:=a[i].o.x;
    p.y:=-a[i].r;
    Update(p);
  end;

  for i:=1 to n-1 do
    for j:=i+1 to n do begin
      p.y:=1;
      Cross(i,j,p);
      if p.y<0.5 then Update(p);
    end;
end; 
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
