#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cassert>
#include <cstdio>
#include <cmath>
#include <iomanip>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); i++)

#define INFILE "popular.in"
#define OUTFILE "popular.out"

#define EPS (1E-9)
#define INF (1E20)

typedef long double real;

int n;
int ans;

vector < pair<real, real> > rope;

real cross(real x, int idx)
{
    if (x + EPS < rope[idx].first - rope[idx].second + EPS || x > EPS + rope[idx].first + rope[idx].second)
        return INF;
    else
    {
        return -sqrt(rope[idx].second * rope[idx].second - (x - rope[idx].first) * (x - rope[idx].first));
    }
}

real height(real x)
{
    real retval = -INF;
    forn(i, n)
    {
        retval = max(retval, cross(x, i));
    }
    return retval;
}

int main()
{
    freopen(INFILE, "rt", stdin);
    freopen(OUTFILE, "wt", stdout);
    assert(cin >> n);
    assert(1 <= n && n <= 5000);
    rope.reserve(n);
    forn(i, n)
    {
        real x, l;
        assert(cin >> x >> l);
        assert(0 <= x && x <= 1E5);
        assert(0 <= l && l <= 1E5);
        rope.push_back(make_pair(x, l));
    }

    real lf = -INF;
    real rg = +INF;

    forn(i, n)
    {
        lf = max(lf, rope[i].first - rope[i].second);
        rg = min(rg, rope[i].first + rope[i].second);
    }

    real ans = INF;

    if (lf <= rg + EPS)
    {
        forn(it, 300)
        {
            real midl = (2 * lf + rg) / 3.0;
            real midr = (lf + 2 * rg) / 3.0;
            if (height(midl) > height(midr))
                lf = midl;
            else
                rg = midr;
        }

        ans = height(lf);
    }

    if (ans > INF / 2)
        ans = -1, lf = -1;
    cout << setprecision(4);
    cout << fixed;

    cout << lf << " " << ans << endl;

    return 0;
}