{$A8,B-,C+,D+,E-,F-,G+,J-,K-,L+,M-,N+,P+,T-,U-,V+,W-,X+,Y+,Z1}
{$Q+,R+,S+,O-,H+,I+}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE console}

const
  cinfile = 'pursuit.in';
  coutfile = 'pursuit.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 500;
  mmax = 20000;
  kmax = 10;

type
  int = longint;
  real = extended;

  rebro = record
            v : int;
            nx : int;
          end;

  vertex = record
             u, v, d : int;
           end;

var
  ans : int;
  n, m, k : int;
  ex : int;

  s : array [0..nmax, 0..nmax, 0..kmax] of int;

  es : array [0..nmax, 0..kmax] of boolean;
  g : array [0..nmax, 0..kmax] of int;
  kst : int;
  st : array [0..mmax] of rebro;

  h, t : int;
  q : array [0..nmax*nmax*kmax] of vertex;
  wn : array [0..nmax, 0..nmax, 0..kmax] of shortint;
  rs : array [0..nmax, 0..nmax, 0..kmax] of integer;

  nx : array [0..nmax, 0..nmax, 0..kmax] of vertex;

  sm, sb : int;

procedure outdata;
var
  i, j : int;
begin
  if wn[sm, sb, 0] = -1 then writeln('Endless') else
    if wn[sm, sb, 0] = 0 then
    begin
      writeln('Escaped');
      writeln(rs[sm, sb, 0] shr 1);
    end else
    begin
      writeln('Caught');
      writeln((rs[sm, sb, 0] + 1) shr 1);
    end;
end;

procedure calc(cn, c : vertex);
begin
  if wn[cn.u, cn.v, cn.d] <> -1 then exit;
  if wn[c.u, c.v, c.d] = 0 then
  begin
    inc(t);
    q[t]:= cn;
    wn[cn.u, cn.v, cn.d]:= 1;
    rs[cn.u, cn.v, cn.d]:= rs[c.u, c.v, c.d] + 1;
    nx[cn.u, cn.v, cn.d]:= c;
  end else
  begin
    dec(s[cn.u, cn.v, cn.d]);
    if s[cn.u, cn.v, cn.d] = 0 then
    begin
      inc(t);
      q[t]:= cn;
      wn[cn.u, cn.v, cn.d]:= 0;
      rs[cn.u, cn.v, cn.d]:= rs[c.u, c.v, c.d] + 1;
      nx[cn.u, cn.v, cn.d]:= c;
    end;
  end;
end;

procedure solve;
var
  i, j : int;
  x : int;
  c, cn : vertex;
begin
  h:= 1;
  t:= 0;
  fillchar(wn, sizeof(wn), 255);
  fillchar(q, sizeof(q), 0);
  for i:= 1 to n do
    for j:= 1 to k do
    begin
      inc(t);
      q[t].u:= i;
      q[t].v:= i;
      q[t].d:= j;
      wn[q[t].u, q[t].v, q[t].d]:= 0;
      rs[q[t].u, q[t].v, q[t].d]:= 0;
    end;
  for i:= 1 to n do
  begin
    inc(t);
    q[t].u:= i;
    q[t].v:= i;
    q[t].d:= 0;
    wn[q[t].u, q[t].v, q[t].d]:= 1;
    rs[q[t].u, q[t].v, q[t].d]:= 0;
  end;
  for i:= 2 to n do
  begin
    inc(t);
    q[t].u:= i;
    q[t].v:= 1;
    q[t].d:= 0;
    wn[q[t].u, q[t].v, q[t].d]:= 0;
    rs[q[t].u, q[t].v, q[t].d]:= 0;
  end;
  while h <= t do
  begin
    c:= q[h];
    if (c.u = sm) and (c.v = sb) and (c.d = 0) then break;
    inc(h);
    if c.d = 0 then
    begin
      for i:= 1 to k do
      begin
        x:= g[c.v, i];
        while x <> 0 do
        begin
          cn.u:= c.u;
          cn.v:= st[x].v;
          cn.d:= i;
          calc(cn, c);
          x:= st[x].nx;
        end;
        cn:= c;
        cn.d:= i;
        calc(cn, c);
      end;
    end else
    begin
      x:= g[c.u, c.d];
      while x <> 0 do
      begin
        cn.u:= st[x].v;
        cn.v:= c.v;
        cn.d:= 0;
        calc(cn, c);
        x:= st[x].nx;
      end;
    end;
  end;
end;

procedure pusht(a1, b1, c1, a2, b2, c2 : int);
begin
  inc(s[a1, b1, c1]);
end;

procedure push(u, v, d : int);
begin
  inc(kst);
  st[kst].v:= v;
  st[kst].nx:= g[u, d];
  g[u, d]:= kst;
  es[u, d]:= true;
end;

procedure pushAll(u, v, d : int);
var
  i, j : int;
begin
  for i:= 1 to n do
    pusht(i, u, d, i, v, 0);
  for i:= 1 to n do
    pusht(u, i, 0, v, i, d);
  push(u, v, d);
end;

procedure init;
begin
  fillchar(s, sizeof(s), 0);
  kst:= 0;
  fillchar(g, sizeof(g), 0);
  fillchar(st, sizeof(st), 0);
  ex:= 1;
  fillchar(es, sizeof(es), 0);
end;

procedure readdata;
var
  i, j, e : int;
  u, v, d : int;
begin
  init;
  read(n, m, k);
  assert((n >= 4) and (n <= nmax));
  assert((m >= 1) and (m <= mmax));
  assert((k >= 1) and (k <= kmax));
  for i:= 1 to m do
  begin
    read(u, v, d);
    assert((u >= 1) and (u <= n));
    assert((v >= 1) and (v <= n));
    assert((d >= 1) and (d <= k));
    assert(u <> v);
    pushAll(u, v, d);
    pushAll(v, u, d);
  end;
  for i:= 1 to n do
    for j:= 1 to n do
      for e:= 1 to k do
        if i <> j then inc(s[i, j, e]);
  read(sm, sb);
  assert((sm >= 1) and (sm <= n));
  assert((sb >= 1) and (sb <= n));
  assert(sm <> sb);
end;

begin
  reset(input, cinfile);
  rewrite(output, coutfile);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.

