{$O-,Q+,R+}
uses SysUtils;

const MaxN=200;
      MaxK=200;
      MaxC=1000;
      inf=1e1000;
      eps=1e-10;

type point=record x, y:extended end;
     line=record r, d:point end;

procedure intersect (const l1, l2:line; var t1, t2:extended);
var det, d2, curt:extended;
begin
  det:=l1.d.x*l2.d.y-l1.d.y*l2.d.x;
  d2:=(l2.r.x-l1.r.x)*l2.d.y-(l2.r.y-l1.r.y)*l2.d.x;
  if abs (det)<eps then begin
    if d2<-eps then begin t1:=inf; t2:=-inf end
  end else begin
    curt:=d2/det;
    if det>0 then begin
      if curt<t2 then t2:=curt
    end else begin
      if curt>t1 then t1:=curt
    end;
  end;
end;

var f:array [1..MaxN] of point;
    k:integer;
    max, maxx, maxy:extended;

procedure test (x, y:extended);
var min:extended;
    i:integer;
begin
//  writeln (x:0:20, ' ', y:0:20);
  min:=inf;
  for i:=1 to k do 
    if sqr (x-f[i].x)+sqr (y-f[i].y) < min then
      min := sqr (x-f[i].x)+sqr (y-f[i].y);
  if min>max then begin
    max:=min; maxx:=x; maxy:=y
  end;
end;

var i, j, p, q, n:integer;
    t:array [0..MaxN+1] of point;
    l:array [1..MaxN+MaxK] of line;
    z:point;
    t1, t2, s:extended;

begin
  assert (not seekeoln); read (n); assert ((n>=3) and (n<=MaxN));
  assert (seekeoln); readln;
  for i:=1 to n do with t[i] do begin
    assert (not seekeoln); read (x); assert (abs (x)<=MaxC);
    assert (not seekeoln); read (y); assert (abs (y)<=MaxC);
    assert (seekeoln); readln;
  end;
  t[0]:=t[n]; t[n+1]:=t[1];
  s:=0;
  for i:=1 to n do s:=s+t[i-1].x*t[i].y-t[i].x*t[i-1].y;
  assert (s<>0);
  if s<0 then
    for i:=0 to n shr 1 do begin
      z:=t[i]; t[i]:=t[n+1-i]; t[n+1-i]:=z;
    end;
  for i:=1 to n do
    assert ((t[i].x-t[i-1].x)*(t[i+1].y-t[i].y)-(t[i+1].x-t[i].x)*(t[i].y-t[i-1].y)>0);
  assert (not seekeoln); read (k); assert ((k>=1) and (k<=MaxK));
  assert (seekeoln); readln;
  for i:=1 to k do with f[i] do begin
    assert (not seekeoln); read (x); assert (abs (x)<=MaxC);
    assert (not seekeoln); read (y); assert (abs (y)<=MaxC);
    assert (seekeoln); readln;
  end;
  for i:=1 to n do
    for j:=1 to k do begin
      if ((t[i-1].y-t[i].y)*(f[j].x-t[i].x)+(t[i].x-t[i-1].x)*(f[j].y-t[i].y)<0) then
        writeln ('point ', j, ' does not belong to the forest');
      assert ((t[i-1].y-t[i].y)*(f[j].x-t[i].x)+(t[i].x-t[i-1].x)*(f[j].y-t[i].y)>=0);
    end;
  assert (seekeof);
  for i:=1 to n do with l[i] do begin 
    r:=t[i-1]; d.x:=t[i].x-t[i-1].x; d.y:=t[i].y-t[i-1].y;
  end;
  for i:=1 to k do begin
    for j:=1 to k do
      with l[n+j] do begin
        r.x:=(f[i].x+f[j].x)*0.5;
        r.y:=(f[i].y+f[j].y)*0.5;
        d.x:=f[i].y-f[j].y;
        d.y:=f[j].x-f[i].x;
      end;
    for p:=1 to n+k do begin
      t1:=-inf; t2:=inf;
      for q:=1 to n+k do begin
        intersect (l[p], l[q], t1, t2);
      end;
      if t1<=t2-eps then with l[p] do begin
        test (r.x+d.x*t1, r.y+d.y*t1);
        test (r.x+d.x*t2, r.y+d.y*t2);
      end;
    end;
  end;
  //test (0, 0);
  //writeln (max:0:20);
  writeln (maxx:0:20, ' ' ,maxy:0:20);
end.