{$A8,B-,C+,D+,E-,F-,G+,J-,K-,L+,M-,N+,P+,T-,U-,V+,W-,X+,Y+,Z1}
{$Q+,R+,S+,O-,H+,I+}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE console}

uses Math, SysUtils;

const
  cinfile = 'fire.in';
  coutfile = 'fire.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 200;

type
  int = longint;
  real = extended;

  point = record
    x, y : real;
  end;

  line = record
    a, b, c : real;
  end;

  polygon = array [0..nmax+1] of point;

var
  ans : real;
  ansp : point;
  n, k : int;

  p, s : polygon;
  kc : int;
  c : polygon;

procedure outdata;
begin
  writeln(ansp.x : 0 : 10, ' ', ansp.y : 0 : 10);
end;

function comb(const p1, p2 : point; const k1, k2 : real) : point;
begin
  Result.x:= p1.x * k1 + p2.x * k2;
  Result.y:= p1.y * k1 + p2.y * k2;
end;

function side(const l : line; const p : point) : int;
begin
  side:= sign(l.a * p.x + l.b * p.y + l.c);
end;

function mline(const p1, p2 : point) : line;
begin
  Result.a:= p1.y - p2.y;
  Result.b:= p2.x - p1.x;
  Result.c:= - (Result.a * p1.x + Result.b * p1.y);
end;

function dist(const p1, p2 : point) : real;
begin
  dist:= sqr(p1.x - p2.x) + sqr(p1.y - p2.y); 
end;

function cross(const l1 : line; const p3, p4 : point; var cr : point) : boolean;
var
  l2 : line;
  d : real;
begin
  cross:= false;
  l2:= mline(p3, p4);
  if side(l1, p3) * side(l1, p4) >= 0 then exit;
  d:= l1.a * l2.b - l1.b * l2.a;
  if sign(d) = 0 then exit;
  cross:= true;
  cr.x:= (l1.b * l2.c - l1.c * l2.b) / d;
  cr.y:= (l1.c * l2.a - l1.a * l2.c) / d;
end;

procedure divide(var c : polygon; var n : int; const p1, p2 : point);
var
  md : point;
  l : line;
  i : integer;
  c2 : polygon;
  kc2 : int;
begin
  fillchar(c2, sizeof(c2), 0);
  md:= comb(p1, p2, 0.5, 0.5);
  l.a:= p1.x - p2.x;
  l.b:= p1.y - p2.y;
  l.c:= - (md.x * l.a + md.y * l.b);
  kc2:= 0;
  for i:= 1 to n do
  begin
    if side(l, c[i]) * side(l, p1) >= 0 then
    begin
      inc(kc2);
      c2[kc2]:= c[i];
    end;
    if cross(l, c[i], c[i + 1], md) then
    begin
      inc(kc2);
      c2[kc2]:= md;
    end;
  end;
  kc:= kc2;
  c:= c2;
  c[kc + 1]:= c[1];
end;

procedure solve;
var
  i, j : int;
  td : real;
begin
  ans:= 0;
  for i:= 1 to k do
  begin
    c:= p;
    kc:= n;
    for j:= 1 to k do
      if i <> j then
        divide(c, kc, s[i], s[j]);
    for j:= 1 to kc do
    begin
      td:= dist(c[j], s[i]);
      if td > ans then
      begin
        ans:= td;
        ansp:= c[j];
      end;
    end;
  end;
end;

procedure readdata;
var
  i : int;
begin
  fillchar(p, sizeof(p), 0);
  read(n);
  assert((n >= 1) and (n <= nmax));
  for i:= 1 to n do
  begin
    read(p[i].x, p[i].y);
    assert(abs(p[i].x) <= 1000);
    assert(abs(p[i].y) <= 1000);
  end;
  p[n + 1]:= p[1];
  read(k);
  assert((k >= 1) and (k <= nmax));
  for i:= 1 to k do
  begin
    read(s[i].x, s[i].y);
    assert(abs(s[i].x) <= 1000);
    assert(abs(s[i].y) <= 1000);
  end;
end;

begin
  reset(input, cinfile);
  rewrite(output, coutfile);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
