#include <stdio.h>

#define FILE_IN "rects.in"
#define FILE_OUT "rects.out"
#define MAXN 100000

struct RECT {
  int x1,y1,x2,y2,prev,num,prevc;
  long long bc,cost;
};

struct POINT {
  int y,x,type,num;
};

int n;
RECT a[MAXN];
POINT b[2*MAXN];
int c[MAXN];

void swapP(POINT *a,POINT *b){
  POINT c;
  c=*a;
  *a=*b;
  *b=c;
}

void Sort(POINT * a,int l,int r){
  int i=l,j=r,y=a[(l+r)/2].y,x=a[(l+r)/2].x;
  do {
    while ((a[i].y<y)||((a[i].y==y) && (a[i].x>x))) i++;
    while ((y<a[j].y)||((a[j].y==y) && (a[j].x<x))) j--;
    if (i<=j) {
      swapP(&a[i],&a[j]);
      i++;
      j--;
    }
  } while (i<=j);
  if (i<r) Sort(a,i,r);
  if (l<j) Sort(a,l,j);
}

void swap(int *a,int *b){
  int c=*a;
  *a=*b;
  *b=c;
}

int main(){
  freopen(FILE_IN,"r",stdin);
  freopen(FILE_OUT,"w",stdout);

  int i;
  scanf("%d",&n);
  for (i=0;i<n;i++){
    scanf("%d %d %d %d %d",&a[i].x1,&a[i].y1,&a[i].x2,&a[i].y2,&a[i].cost);
    swap(&a[i].y1,&a[i].y2);
  }

  for (i=0;i<n;i++){
    b[2*i].y=2*a[i].y1+1;
    b[2*i].num=i;
    b[2*i].type=1;
    b[2*i].x=a[i].x1;
    b[2*i+1].y=2*a[i].y2;
    b[2*i+1].num=i;
    b[2*i+1].type=2;
    b[2*i+1].x=a[i].x2;
  }

  Sort(b,0,2*n-1);

  int cur=-1,cnum=0;
  for(i=0;i<2*n;i++) {
    if (b[i].type==1) {
      cur=b[i].num;
      a[b[i].num].num=cnum++;
    } else {
      a[b[i].num].prev=cur;
    }
  }

  for (i=0;i<n;i++){
    b[2*i].y=2*a[i].x1;
    b[2*i].num=i;
    b[2*i].type=1;
    b[2*i].x=a[i].y1;
    b[2*i+1].y=2*a[i].x2+1;
    b[2*i+1].num=i;
    b[2*i+1].type=2;
    b[2*i].x=a[i].y2;


    a[i].prevc=-1;
    a[i].bc=0;
  }

  Sort(b,0,2*n-1);

  for (i=0;i<n;i++) c[i]=0;


  int j;

  for (i=2*n-1;i>=0;i--){
    if (b[i].type==1){
      c[a[b[i].num].num]=b[i].num+1;
    } else {
      if (a[b[i].num].prev!=-1)
      for (j=0;j<=a[a[b[i].num].prev].num;j++){
          if (c[j])
          if (a[b[i].num].bc<a[c[j]-1].bc+a[c[j]-1].cost) {
            a[b[i].num].bc=a[c[j]-1].bc+a[c[j]-1].cost;
            a[b[i].num].prevc=c[j]-1;
          }
        }
    }
  }

  j=0;
  for (i=0;i<n;i++) {
    if (a[j].bc+a[j].cost<a[i].bc+a[i].cost) j=i;
  }

  printf("%lld\n",a[j].bc+a[j].cost);
  while (j!=-1){
    printf("%d ",j+1);
    j=a[j].prevc;
  }


  fclose(stdout);
  fclose(stdin);
}
