#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cassert>
#include <cstdio>
#include <cmath>
#include <iomanip>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); i++)

#define INFILE "rects.in"
#define OUTFILE "rects.out"

typedef long double real;
typedef long long __int64;

#define x first
#define y second

#define NMAX (100000)
#define CMAX (1000000000)

typedef pair<int, int> point;

typedef struct rect
{
    point c[2];
    int v;
    int idx;
} rect;

int n;
rect r[NMAX];

int main()
{
    freopen(INFILE, "rt", stdin);
    freopen(OUTFILE, "wt", stdout);

    assert(cin >> n);
    assert(1 <= n && n <= NMAX);
    forn(i, n)
    {
        point c[2];
        assert(cin >> c[0].x >> c[0].y >> c[1].x >> c[1].y);
        assert(abs(c[0].x) <= CMAX);
        assert(abs(c[0].y) <= CMAX);
        assert(abs(c[1].x) <= CMAX);
        assert(abs(c[1].y) <= CMAX);
        r[i].c[0].x = min(c[0].x, c[1].x);
        r[i].c[0].y = min(c[0].y, c[1].y);
        r[i].c[1].x = max(c[0].x, c[1].x);
        r[i].c[1].y = max(c[0].y, c[1].y);
        assert(cin >> r[i].v);
        assert(1 <= r[i].v && r[i].v <= CMAX);
        r[i].idx = i;
    }

    vector < pair<int, int> > left;
    forn(i, n)
        left.push_back(make_pair(r[i].c[0].x, i));
    sort(left.begin(), left.end());

    int before[NMAX];
    __int64 value[NMAX];

    forn(i, n)
    {
        int idx = left[i].second;
        value[idx] = r[idx].v;
        before[idx] = idx;
        forn(j, i)
        {
            int prev = left[j].second;
            if (value[idx] < value[prev] + r[idx].v)
            {
                if (r[prev].c[1].x < r[idx].c[0].x && r[prev].c[0].y > r[idx].c[1].y)
                {
                    value[idx] = value[prev] + r[idx].v;
                    before[idx] = prev;
                }
            }
        }
    }

    int bestIdx = -1;
    __int64 bestValue = 0;

    forn(i, n)
        if (bestValue < value[i])
            bestValue = value[i], bestIdx = i;

    vector <int> answer(1, bestIdx);

    while (before[bestIdx] != bestIdx)
    {
        bestIdx = before[bestIdx];
        answer.push_back(bestIdx);
    }

    reverse(answer.begin(), answer.end());

    cout << bestValue << endl;
    forn(i, answer.size())
        cout << answer[i] + 1 << " ";

    return 0;
}