{$A8,B-,C+,D+,E-,F-,G+,J-,K-,L+,M-,N+,P+,T-,U-,V+,W-,X+,Y+,Z1}
{$Q+,R+,S+,O-,H+,I+}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE console}

uses Math, SysUtils;

const
  cinfile = 'rects.in';
  coutfile = 'rects.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 100000;

  list = 1 shl 17;

type
  int = longint;
  real = extended;

  rectangle = record
    x1, y1, x2, y2 : int;
    c : int;
    no : int;
  end;

  tarint = array [1..2 * nmax] of int;

  event = record
            y, no : int;
            u : boolean;
          end;

  tarevent = array [1.. 2 * nmax] of event;

var
  ans, av : int;
  n : int;

  p : array [1..nmax] of rectangle;
  res : array [0..nmax] of int;

  pr : array [1..nmax] of int;

  kx, ky : int;
  x, y : tarint;

  ks : int;
  ms : tarevent;

  tree, lm, rm : array [1..list shl 1] of int;

procedure outit(v : int);
begin
  if v = 0 then exit;
  outit(pr[v]);
  write(v,' ');
end;

procedure outdata;
begin
  writeln(ans);
  outit(av);
end;

procedure sort(var a : tarint; var n : int); overload;
var
  l,  r : int;
  x : int;

  procedure sift;
  var
    i, j : int;
  begin
    x:= a[l];
    i:= l;
    j:= i shl 1;
    if (j < r) and (a[j + 1] > a[j]) then inc(j);
    while (j <= r) and (a[j] > x) do
    begin
      a[i]:= a[j];
      i:= j;
      j:= i shl 1;
      if (j < r) and (a[j + 1] > a[j]) then inc(j);
    end;
    a[i]:= x;
  end;

begin
  r:= n;
  for l:= n shr 1 downto 1 do sift;
  l:= 1;
  for r:= n - 1 downto 1 do
  begin
    x:= a[1];
    a[1]:= a[r + 1];
    a[r + 1]:= x;
    sift;
  end;
end;

function less(const a1, a2 : event) : boolean;
begin
  less:= (a1.y > a2.y) or ((a1.y = a2.y) and a1.u);
end;

procedure sort(var a : tarevent; var n : int); overload;
var
  l,  r : int;
  x : event;

  procedure sift;
  var
    i, j : int;
  begin
    x:= a[l];
    i:= l;
    j:= i shl 1;
    if (j < r) and less(a[j], a[j + 1]) then inc(j);
    while (j <= r) and less(x, a[j]) do
    begin
      a[i]:= a[j];
      i:= j;
      j:= i shl 1;
    if (j < r) and less(a[j], a[j + 1]) then inc(j);
    end;
    a[i]:= x;
  end;

begin
  r:= n;
  for l:= n shr 1 downto 1 do sift;
  l:= 1;
  for r:= n - 1 downto 1 do
  begin
    x:= a[r + 1];
    a[r + 1]:= a[1];
    a[1]:= x;
    sift;
  end;
end;

procedure delDouble(var a : tarint; var n : int);
var
  i, n2 : int;
begin
  if n <= 1 then exit;
  n2:= 1;
  for i:= 2 to n do
    if a[i] <> a[i - 1] then
    begin
      inc(n2);
      a[n2]:= a[i];
    end;
  n:= n2;
end;

function bfind(const a : tarint; const n : int; const x : int) : int;
var
  l, r, mid : int;
begin
  l:= 1;
  r:= n;
  while l < r do
  begin
    mid:= (l + r) shr 1;
    if a[mid] < x then l:= mid + 1 else r:= mid;
  end;
  bfind:= l;
end;

function maxlr(v, l, r : int) : int;
var
  c : int;
begin
  if (r < lm[v]) or (l > rm[v]) then maxlr:= 0 else
    if (lm[v] >= l) and (rm[v] <= r) then maxlr:= tree[v] else
    begin
      Result:= maxlr(v shl 1, l, r);
      c:= maxlr(v shl 1 + 1, l, r);
      if res[Result] < res[c] then Result:= c;
    end;
end;

procedure update(v : int; b : int);
begin
  v:= v + list - 1;
  if res[tree[v]] < res[b] then tree[v]:= b;
  while v > 1 do
  begin
    v:= v shr 1;
    tree[v]:= tree[v shl 1 + 1];
    if res[tree[v]] < res[tree[v shl 1]] then tree[v]:= tree[v shl 1];
  end;
end;

procedure inittree;
var
  i : int;
begin
  fillchar(res, sizeof(res), 0);
  fillchar(tree, sizeof(tree), 0);
  for i:= list to list shl 1 do
  begin
    lm[i]:= i - list + 1;
    rm[i]:= i - list + 1;
  end;
  for i:= list - 1 downto 1 do
  begin
    lm[i]:= lm[i shl 1];
    rm[i]:= rm[i shl 1 + 1];
  end;
end;

procedure solve;
var
  i, e : int;
begin
  fillchar(pr, sizeof(pr), 0);
  inittree;
  kx:= 0;
  for i:= 1 to n do
  begin
    inc(kx);
    x[kx]:= p[i].x1;
    inc(kx);
    x[kx]:= p[i].x2;
  end;
  ky:= 0;
  for i:= 1 to n do
  begin
    inc(ky);
    y[ky]:= p[i].y1;
    inc(ky);
    y[ky]:= p[i].y2;
  end;
  sort(x, kx);
  delDouble(x, kx);
  sort(y, ky);
  delDouble(y, ky);

  for i:= 1 to n do
  begin
    p[i].x1:= bfind(x, kx, p[i].x1);
    p[i].x2:= bfind(x, kx, p[i].x2);
    p[i].y1:= bfind(y, ky, p[i].y1);
    p[i].y2:= bfind(y, ky, p[i].y2);
  end;

  ks:= 0;
  for i:= 1 to n do
  begin
    inc(ks);
    ms[ks].y:= p[i].y2;
    ms[ks].no:= i;
    ms[ks].u:= true;
    inc(ks);
    ms[ks].y:= p[i].y1;
    ms[ks].no:= i;
    ms[ks].u:= false;
  end;
  sort(ms, ks);

  for i:= 1 to ks do
  begin
    if ms[i].u then
    begin
      if ms[i].no = 10 then
      begin
        inc(e);
      end;
      pr[ms[i].no]:= maxlr(1, 1, p[ms[i].no].x1 - 1);
      res[ms[i].no]:= res[pr[ms[i].no]] + p[ms[i].no].c;
    end else update(p[ms[i].no].x2, ms[i].no);
  end;
  ans:= res[1];
  av:= 1;
  for i:= 2 to n do
    if ans < res[i] then
    begin
      ans:= res[i];
      av:= i;
    end;
end;

procedure readdata;
var
  i : int;
begin
  read(n);
  assert((n >= 1) and (n <= nmax));
  for i:= 1 to n do
  begin
    read(p[i].x1, p[i].y1, p[i].x2, p[i].y2, p[i].c);
    p[i].no:= i;
    assert(abs(p[i].x1) <= 1000000000);
    assert(abs(p[i].y1) <= 1000000000);
    assert(abs(p[i].x2) <= 1000000000);
    assert(abs(p[i].y2) <= 1000000000);
    assert(p[i].x1 < p[i].x2);
    assert(p[i].y1 < p[i].y2);
    assert((p[i].c >= 1) and (p[i].c <= 1000000000));
  end;
end;

begin
  reset(input, cinfile);
  rewrite(output, coutfile);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
