#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cassert>
#include <cstdio>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); i++)

#define INFILE "eq.in"
#define OUTFILE "eq.out"

#define NMAX (500)
#define INF (1000000)

int n;
int ans;

struct
{
  int len;
  int prev_row;
  int prev_col;
  int way;
    
} diff[NMAX][NMAX];

struct
{
  int next[2];
  int terminal;
} aut[NMAX];

int main()
{
    freopen(INFILE, "rt", stdin);
    freopen(OUTFILE, "wt", stdout);

    memset(aut, sizeof(aut), 0);

    assert(cin >> n);
    assert(1 <= n && n <= 500);
    int t;
    assert(cin >> t);
    assert(0 <= t && t <= n);
    set <int> A;
    forn(i, t)
    {
        int cur;
        assert(cin >> cur);
        assert(1 <= cur && cur <= n);
        A.insert(cur);
        aut[--cur].terminal = 1;
    }
    assert(A.size() == t);

    forn(i, n)
    {
        int cur;
        assert(cin >> cur);
        assert(1 <= cur && cur <= n);
        aut[i].next[0] = --cur;
        assert(cin >> cur);
        assert(1 <= cur && cur <= n);
        aut[i].next[1] = --cur;
    }

    forn(i, n) 
        forn(j, n)
            if (aut[i].terminal != aut[j].terminal)
                diff[i][j].len = 0, diff[i][j].prev_row = i, diff[i][j].prev_col = j;

            else
                diff[i][j].len = INF;

    bool was_update = true;

    while (was_update)
    {
        was_update = false;
        forn(i, n)
            forn(j, n)
                // if (diff[i][j].len == INF)
                {
                    forn(k, 2)
                    {
                        if (diff[aut[i].next[k]][aut[j].next[k]].len + 1 < diff[i][j].len)
                        {
                            was_update = true;
                            diff[i][j].len = diff[aut[i].next[k]][aut[j].next[k]].len + 1;
                            diff[i][j].prev_row = aut[i].next[k];
                            diff[i][j].prev_col = aut[j].next[k];
                            diff[i][j].way = k;
                        }
                   }
                }
    }

    int k;
    assert(cin >> k);
    assert(1 <= k && k <= 1000);

    forn(i, k)
    {
        int a, b;
        assert(cin >> a >> b);
        assert(1 <= a && a <= n);
        assert(1 <= b && b <= n);
        --a;
        --b;
        if (diff[a][b].len == INF)
            printf("equivalent\n");
        else
        {
            string path;
            while (diff[a][b].prev_row != a || diff[a][b].prev_col != b)
            {
                path += '0' + diff[a][b].way;
                int na = diff[a][b].prev_row;
                int nb = diff[a][b].prev_col;
                a = na;
                b = nb;
            }
            printf("%s\n", path.c_str());
        }
    }

    return 0;
}
