#include <stdio.h>
#include "guess.h"

#define assert(x) {if (!(x)) return 222;}

#define MAXN 200000
#define MAXK 1000
#define MAXQ 200000

struct NODE {
  int p,rank,w;
};

NODE a[MAXN];
int n,k,q;
int l,r,s;
int ans[MAXN],anss[MAXN+1];

int Get(int x,int *w){
  if (a[x].p!=x) {
    a[x].p=Get(a[x].p,w);
    *w=(*w+a[x].w)%k;
    a[x].w=*w;
  } else *w=0;
  return a[x].p;
}

int t1,t2;

void Union(int x,int y,int w){
  x=Get(x,&t1);
  y=Get(y,&t2);
  w=(t1+w-t2+k)%k;
  if (a[x].rank==a[y].rank) a[x].rank++;
  if (a[x].rank>a[y].rank) {
    a[y].p=x;
    a[y].w=w;
  } else {
    a[x].p=y;
    a[x].w=k-w;
  }
}

void Solve(){
  int x,i,w;
  for (i=0;i<=n;i++) anss[i]=-1;
  anss[0]=0;
  if (a[0].p!=0) {
    x=Get(0,&w);
    anss[x]=k-w;
  }
  for (i=1;i<=n;i++){
    x=Get(i,&w);
    if (anss[x]==-1) {
      anss[x]=0;
    }
    anss[i]=(anss[x]+w)%k;
  }
  for (i=0;i<n;i++) ans[i]=(anss[i+1]-anss[i]+k)%k;
}

int main(){

  Initialize(&n,&k,&q);
  assert(n<=MAXN);
  assert(1<=n);
  assert(k<=MAXK);
  assert(1<=k);
  assert(q<=MAXQ);
  assert(1<=q);

  int i,w1,w2,x,y;
  for (i=0;i<=n;i++) {
    a[i].p=i;
    a[i].rank=0;
    a[i].w=0;
  }

  for (i=0;i<q;i++){
    NextQuery(&l,&r,&s);
    assert(1<=l);
    assert(l<=r);
    assert(r<=n);

    x=Get(r,&w1);
    y=Get(l-1,&w2);
    if (x!=y) Union(r,l-1,k-s);
    else {
      if (((w1-w2+k)%k)!=s) {
        Solve();
        Error(n,ans);
      }
    }
  }
  
  Solve();
  Consistent(n,ans);

  return 0;
}