{$R+,Q+,S+}
{$ASSERTIONS ON}
Uses Guess;
Const
  MaxN=200000;
  MaxK=1000;
  MaxQueries=200000;

Type
  Integer=LongInt;
  TGetResult=Record
    Root:Integer;
    By:Integer;
  End;

Var
  N,K,Queries:Integer;
  I,A,B,C:Integer;
  RA,RB:TGetResult;
  Arr,Parent,Delta:Array[1..MaxN+1]Of Integer;
  Res:Integer;

Function Get(A:Integer):TGetResult;
Var
  Res:TGetResult;
Begin
  If Parent[A]=0 Then Begin
    Res.Root:=A;
    Res.By:=0;
  End Else Begin
    Res:=Get(Parent[A]);
    Res.By:=(Res.By+Delta[A]) Mod K;
    Parent[A]:=Res.Root;
    Delta[A]:=Res.By;
  End;
  Get:=Res;
End;

Procedure Union(G1,G2:TGetResult; AddDelta:Integer; Inv:Boolean);
Begin
  If Inv Then Union(G2,G1,(K-AddDelta) Mod K,Not Inv) Else Begin
    Parent[G2.Root]:=G1.Root;
    Delta[G2.Root]:=(AddDelta+G1.By+K-G2.By) Mod K;
  End;
End;

Procedure GetArr;
Var
  RA,RB:TGetResult;
Begin
  RB:=Get(1);
  For I:=1 To N Do Begin
    RA:=RB;
    RB:=Get(I+1);
    Arr[I]:=(RB.By+K-RA.By) Mod K;
  End;
End;

Begin
  RandSeed:=432171193;
  Initialize(N,K,Queries);
  FillChar(Parent,SizeOf(Parent),0);
  FillChar(Delta,SizeOf(Delta),0);
  Assert((N>=1) And (N<=MaxN) And (K>=1) And (K<=MaxK) And (Queries>=0) And (Queries<=MaxQueries));
  Res:=-1;
  For I:=1 To Queries Do Begin
    NextQuery(A,B,C);
    Assert((A>=1) And (A<=B) And (B<=N) And (C>=0) And (C<K));
    RA:=Get(A);
    RB:=Get(B+1);
    If (RA.Root=RB.Root) Then Begin
      If ((RA.By+C) Mod K<>RB.By) Then Begin
        Res:=I;
        Break;
      End;
    End Else Union(RA,RB,C,Boolean(Random(2)));
  End;
  GetArr;
  If Res>0 Then Begin
    Error(N,Arr);
  End Else Begin
    Consistent(N,Arr);
  End;
End.
