Unit Guess_Server_Pm;

Interface

Procedure Initialize(Var _N,_K,_Q:LongInt);
Procedure NextQuery(Var _L,_R,_S:LongInt);
Procedure Error(Var A:Array Of LongInt);
Procedure Consistent(Var A:Array Of LongInt);

Implementation

Const
  MaxN=200000;
  MaxQ=200000;

Var
  N,K,Q:LongInt;
  QID:LongInt;
  Sum:Array[0..MaxN]Of LongInt;
  L,R,S:Array[1..MaxQ]Of LongInt;

Procedure Initialize(Var _N,_K,_Q:LongInt);
Begin
  _N:=N;
  _K:=K;
  _Q:=Q;
End;

Procedure NextQuery(Var _L,_R,_S:LongInt);
Var
  T:LongInt;
Begin
  Inc(QID);
  _L:=Random(N)+1;
  _R:=Random(N)+1;
  If _L>_R Then Begin
    T:=_L;
    _L:=_R;
    _R:=T;
  End;
  _S:=(Sum[_R]+K-Sum[_L-1]) Mod K;
  L[QID]:=_L;
  R[QID]:=_R;
  S[QID]:=_S;
End;

Procedure Error(Var A:Array Of LongInt);
Begin
  WriteLn('HAHA!');
  Halt;
End;

Procedure Consistent(Var A:Array Of LongInt);
Var
  I:LongInt;
Begin
  If QID<Q Then Begin
    WriteLn('TOO EARLY!!!');
    Halt;
  End Else Begin 
    If High(A)<N-1 Then Begin
      WriteLn('TOO SMALL!!!');
      Halt;
    End;
    Sum[0]:=0;
    For I:=0 To N-1 Do
      Sum[I+1]:=Sum[I]+A[I];
    For I:=1 To Q Do
      If (Sum[R[I]]+K-Sum[L[I]-1]) Mod K<>S[I] Then Begin
        WriteLn('FAULT!!!');
        Halt;
      End;
    WriteLn('OK');
    Halt;
  End;
End;

Procedure CreateRandom;
Var
  I:LongInt;
Begin
  For I:=0 To N Do Sum[I]:=Random(K)+1;
  QID:=0;
End;

Begin
  N:=200000;
  K:=57;
  Q:=200000;
  RandSeed:=441357131;
  LoadData;
End.