{$R+,Q+,S+}
{$ASSERTIONS ON}
Program AParticularlyStrangePunctuationManager;

Type
  Integer=LongInt;
  TChange=Record
    AtLen:Integer;
    By:Integer;
  End;

Const
  TaskID='commas';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxLen=1000;

Var
  N:Integer;
  Seq:Array[1..MaxLen]Of Integer;
  NextNonzero:Array[1..MaxLen]Of Integer;
  Change:Array[1..MaxLen,1..MaxLen]Of TChange;
  CommaBefore:Array[1..MaxLen+1]Of Boolean;
  MaxCan:Array[1..MaxLen]Of Integer;

Procedure Load;
Var
  Ch:Char;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  While Not EOF Do Begin
    Read(Ch);
    If Ch<=' ' Then Continue;
    Inc(N);
    Assert(N<=MaxLen);
    Seq[N]:=Ord(Ch)-Ord('0');
  End;
  Assert(N>0);
  Close(Input);
End;

Function AllZeros:Boolean;
Var
  I:Integer;
Begin
  AllZeros:=False;
  For I:=1 To N Do If Seq[I]>0 Then Exit;
  AllZeros:=True;
End;

Procedure Initialize;
Var
  Diff,I,J:Integer;
Begin
  J:=N+1;
  For I:=N Downto 1 Do Begin
    If Seq[I]>0 Then J:=I;
    NextNonzero[I]:=J;
  End;
  For Diff:=1 To N-1 Do
    For J:=N DownTo Diff+1 Do Begin
      I:=J-Diff;
      With Change[I,J] Do Begin
        If Seq[I]>Seq[J] Then Begin
          AtLen:=1;
          By:=1;
        End Else If Seq[I]<Seq[J] Then Begin
          AtLen:=1;
          By:=-1;
        End Else If J=N Then Begin
          AtLen:=2;
          By:=1;
        End Else Begin
          AtLen:=Change[I+1,J+1].AtLen+1;
          By:=Change[I+1,J+1].By;
        End;
        Change[J,I].AtLen:=AtLen;
        Change[J,I].By:=-By;
      End;
    End;
End;

Function IsLess(A,LA,B,LB:Integer):Boolean;
Begin
  If LA<LB Then IsLess:=True Else If LA>LB Then IsLess:=False Else With Change[A,B] Do Begin
    If (By<0) And (AtLen<=LA) Then IsLess:=True Else IsLess:=False;
  End;
End;

Function Check(AllowLast:Integer):Boolean;
Var
  I,J,K,L:Integer;
Begin
  While (AllowLast<N) And (Seq[N-AllowLast]=0) Do Inc(AllowLast);
  For I:=N DownTo 1 Do Begin
    MaxCan[I]:=0;
    If N-I+1<=AllowLast Then MaxCan[I]:=N-I+1 Else Begin
      L:=NextNonzero[I];
      If L>N Then Continue;
      For J:=1 To N-I Do Begin
        K:=NextNonzero[I+J];
        If K>N Then Continue;
        If L>=K Then Begin
          If MaxCan[K]>0 Then MaxCan[I]:=J;
          Continue;
        End;
        If IsLess(L,I+J-L,K,MaxCan[K]) Then
          MaxCan[I]:=J;
      End;
    End;
  End;
  Check:=(MaxCan[1]>0);
End;

Procedure BuildResult;
Var
  I:Integer;
Begin
  I:=1;
  While I<N Do Begin
    CommaBefore[I+MaxCan[I]]:=True;
    I:=I+MaxCan[I];
  End;
End;

Procedure Solve;
Var
  Left,Right,Middle:Integer;
Begin
  FillChar(CommaBefore,SizeOf(CommaBefore),False);
  If AllZeros Then Exit;
  Initialize;
  Right:=N;
  Left:=0;
  While Right-Left>1 Do Begin
    Middle:=(Left+Right) Div 2;
    If Check(Middle) Then Right:=Middle Else Left:=Middle;
  End;
  Check(Right);
  BuildResult;
End;

Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  For I:=1 To N Do Begin
    If CommaBefore[I] Then Write(',');
    Write(Seq[I]);
  End;
  WriteLn;
  Close(Output);
End;

Begin
  Load;
  Solve;
  Save;
End.