#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <algorithm>
#include <cassert>
#include <cstdio>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); i++)

#define INFILE "expr.in"
#define OUTFILE "expr.out"

#define NMAX (80)

int n;
int ans;
string data;
int * state[NMAX][NMAX];
int ready[NMAX][NMAX];
int value[NMAX][NMAX][NMAX * 9 * 2];
int dig;

void calc(int l, int r);

void processSign(char sign, int l1, int r1, int l2, int r2, int l, int r)
{
            calc(l1, r1);
            calc(l2, r2);

            forn(j1, ready[l1][r1])
            {
                int p1 = value[l1][r1][j1];
                if (state[l1][r1][p1])
                    forn(j2, ready[l2][r2])
                    {
                        int p2 = value[l2][r2][j2];
                        if (state[l2][r2][p2])
                        {
                            int result = p1 + p2;
                            if (sign == '-')
                                result = p1 - p2;
                            assert(- 9 * dig <= result && result <= 9 * dig);
                            if (state[l][r][result] == 0)
                            {
                                state[l][r][result] = 1;
                                value[l][r][ready[l][r]++] = result;
                            }
                        }
                    }
            }
}

void calc(int l, int r)
{
    if (ready[l][r] >= 0)
        return;

    ready[l][r] = 0;
    if (r - l <= 1 && data[l] >= '0' && data[l] <= '9')
    {
        ready[l][r] = 1;
        value[l][r][0] = data[l] - '0';
        state[l][r][data[l] - '0'] = 1;
    }

    if (r - l <= 2)
        return;

    // prefix
    if (data[l] == '-' || data[l] == '+')
    {
        for (int len = 1; len < r - l - 1; len++)
        {
            int l1 = l + 1;
            int r1 = l1 + len;
            int l2 = r1;
            int r2 = r;
            processSign(data[l], l1, r1, l2, r2, l, r);
        }
    }

    // infix
    for (int mid = l + 1; mid < r - 1; mid++)
        if (data[mid] == '-' || data[mid] == '+')
        {
            int l1 = l;
            int r1 = mid;
            int l2 = r1 + 1;
            int r2 = r;
            processSign(data[mid], l1, r1, l2, r2, l, r);
        }

    // suffix
    if (data[r - 1] == '+' || data[r - 1] == '-')
    {
        for (int len = 1; len < r - l - 1; len++)
        {
            int l1 = l;
            int r1 = l1 + len;
            int l2 = r1;
            int r2 = r - 1;
            processSign(data[r - 1], l1, r1, l2, r2, l, r);
        }
    }
}

int main()
{
    freopen(INFILE, "rt", stdin);
    freopen(OUTFILE, "wt", stdout);

    string symb = "0123456789+-";

    assert(cin >> data);
    n = data.length();

    assert(1 <= data.length() && data.length() <= NMAX);
    forn(i, data.length())
        assert(symb.find(data[i]) != string::npos);

    dig = 0;
    forn(i, n)
        if (data[i] >= '0' && data[i] <= '9')
            dig++;

    forn(i, n + 1)
        forn(j, n + 1)
        {
            state[i][j] = new int[dig * 9 * 2 + 1];
            memset(state[i][j], 0, sizeof(int) * (dig * 9 * 2 + 1));
            state[i][j] = state[i][j] + (dig * 9);
        }

    memset(ready, 255, sizeof(ready));
    calc(0, n);

    int ans = 0;
    for (int i = - 9 * dig; i <= 9 * dig; i++)
        ans += state[0][n][i];

    printf("%d\n", ans);

    forn(i, n + 1)
        forn(j, n + 1)
        {
            state[i][j] = state[i][j] - (dig * 9);
            delete[] state[i][j];
        }

    fclose(stdin);
    fclose(stdout);

    return 0;
}
