{$R-,Q-,S-}
{$ASSERTIONS ON}
Program YetAnotherGrammarLikeGame;

Type
  Integer=LongInt;

Const
  TaskID='game';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=150;
  MaxRule=150;
  MaxLen=150;
  MaxLetter=26;

Var
  N:Integer;
  Seq:Array[1..MaxN]Of Integer;
  NRule:Integer;
  RuleStart:Array[1..MaxRule]Of Integer;
  RuleLen:Array[1..MaxRule]Of Integer;
  RuleLeft:Array[1..MaxRule]Of Integer;
  Rule:Array[1..MaxLen]Of Integer;
  Closure:Array[1..MaxLetter,1..MaxLetter]Of Boolean;
  CanGet:Array[1..MaxLetter,1..MaxN,1..MaxN]Of Boolean;
  CanGetRule:Array[1..MaxRule,1..MaxN,1..MaxN]Of Boolean;

Procedure Load;
Var
  St:String;
  I,J,K:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  ReadLn(St);
  N:=Length(St);
  Assert((N>=1) And (N<=MaxN));
  For I:=1 To N Do Begin
    Assert((St[I]>='A') And (St[I]<='Z'));
    Seq[I]:=Ord(St[I])-Ord('A')+1;
  End;
  ReadLn(NRule);
  Assert((NRule>=1) And (NRule<=MaxRule));
  J:=1;
  For I:=1 To NRule Do Begin
    ReadLn(St);
    Assert((Length(St)>=3) And (St[Length(St)-1]=' '));
    Assert((St[Length(St)]>='A') And (St[Length(St)]<='Z'));
    RuleLeft[I]:=Ord(St[Length(St)])-Ord('A')+1;
    Delete(St,Length(St)-1,2);
    RuleStart[I]:=J;
    RuleLen[I]:=Length(St);
    J:=J+RuleLen[I];
    Assert((RuleLen[I]>0) And (J<=MaxLen+1));
    For K:=1 To RuleLen[I] Do
      Rule[RuleStart[I]+K-1]:=Ord(St[K])-Ord('A')+1;    
  End;
  Assert(EOF);
  Close(Input);
End;

Procedure BuildClosure;
Var
  K,I,J:Integer;
Begin
  FillChar(Closure,SizeOf(Closure),False);
  For I:=1 To NRule Do
    If RuleLen[I]=1 Then
      Closure[RuleLeft[I],Rule[RuleStart[I]]]:=True;
  For K:=1 To MaxLetter Do
    For I:=1 To MaxLetter Do
      For J:=1 To MaxLetter Do
        If Closure[I,K] And Closure[K,J] Then
          Closure[I,J]:=True;
End;

Procedure Solve;
Var
  I,J,K,L,R,M,Len:Integer;
Begin
  BuildClosure;
  FillChar(CanGet,SizeOf(CanGet),False);
  FillChar(CanGetRule,SizeOf(CanGetRule),False);
  For Len:=1 To N Do
    For L:=1 To N+1-Len Do Begin
      R:=L+Len-1;
      If Len=1 Then Begin
        CanGet[Seq[L],L,R]:=True;
      End Else Begin
        For I:=1 To NRule Do
          For J:=2 To RuleLen[I] Do Begin
            K:=RuleStart[I]+J-1;
            For M:=L+1 To R Do
              If CanGet[Rule[K],M,R] And CanGetRule[K-1,L,M-1] Then
                CanGetRule[K,L,R]:=True;
          End;
        For I:=1 To NRule Do If CanGetRule[RuleStart[I]+RuleLen[I]-1,L,R] Then
          CanGet[RuleLeft[I],L,R]:=True;
      End;
      For I:=1 To MaxLetter Do If CanGet[I,L,R] Then
        For J:=1 To MaxLetter Do
          If Closure[J,I] Then CanGet[J,L,R]:=True;
      For I:=1 To NRule Do
        CanGetRule[RuleStart[I],L,R]:=CanGet[Rule[RuleStart[I]],L,R];
    End;
End;

Procedure Save;
Var
  I:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  For I:=1 To MaxLetter Do If CanGet[I,1,N] Then Write(Chr(Ord('A')+I-1));
  WriteLn;
  Close(Output);
End;

Begin
  Load;
  Solve;
  Save;
End.
