{$D+,L+,I+,Q+,R+,S+}
{$APPTYPE CONSOLE}
Program necklace2_alx;
Uses SysUtils;
const
  inpfile='necklace2.in';
  outfile='necklace2.out';
  nm=100005;
  km=10005;
  inf = nm*Int64(MaxLongInt);
  eps=1e-12;
type
  Stone = record
    ang : Extended;
    w : Int64;
  end;

  Node = record
    x,y : Int64;
  end;

  Move = record
    ang : Extended;
    num,p : LongInt;
  end;

var
  a : array [1..nm] of Stone;
  d : array [1..nm] of Move;
  b : array [1..4*km] of Node;
  n,k,shift : LongInt;
  dang,ang : Extended;
  res : Int64;
{}
Procedure Inp;
var
  i : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,k);
  assert((1<=n) and (n<=100000));
  assert((1<=k) and (k<=10000));
  for i:=1 to n do begin
    read(a[i].ang,a[i].w);
    assert((1<=a[i].w) and (a[i].w<=1000000000));
    assert((a[i].ang>-eps) and (a[i].ang<2*pi+eps));
  end;
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(res);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(d,sizeof(d),0);
  fillchar(b,sizeof(b),0);
end;
{}
Procedure SwapD(var q,w : Move);
var
  bak : Move;
begin
  bak:=q;
  q:=w;
  w:=bak;
end;
{}
Procedure SortD(l,r : LongInt);
var
  i,j : LongInt;
  x : Extended;
begin
  i:=l; j:=r; x:=d[(l+r) div 2].ang;
  repeat
    while d[i].ang<x do inc(i);
    while x<d[j].ang do dec(j);
    if i<=j then begin
      SwapD(d[i],d[j]);
      inc(i); dec(j);
    end;
  until i>j;

  if l<j then SortD(l,j);
  if i<r then SortD(i,r);
end;
{}
Function min(q,w : Int64) : Int64;
begin
  if q<w then min:=q else min:=w;
end;
{}
Function max(q,w : Int64) : Int64;
begin
  if q>w then max:=q else max:=w;
end;
{}
Procedure Update(i : LongInt);
begin
  inc(i,shift);
  while i>1 do begin
    i:=i div 2;
    b[i].x:=min(b[2*i].x,b[2*i+1].x);
    b[i].y:=max(b[2*i].y,b[2*i+1].y);
  end;
end;
{}
Procedure Solve;
var
  i,j : LongInt;
begin
  dang:=2*pi/k;

  shift:=1;
  while shift<k do shift:=2*shift;
  dec(shift);

  for i:=2*shift+1 downto shift+k+1 do begin
    b[i].x:=inf;
    b[i].y:=-inf;
  end;

  for i:=1 to n do begin
    ang:=a[i].ang;
    j:=trunc(ang/dang)+1;
    d[i].ang:=dang*j-a[i].ang;
    d[i].num:=i;
    d[i].p:=j;
    inc(b[j+shift].x,a[i].w);
    inc(b[j+shift].y,a[i].w);
  end;
  SortD(1,n);

  for i:=2 to n do
    assert(abs(d[i].ang-d[i-1].ang)>eps,'Bad composition');

  for i:=shift downto 1 do begin
    b[i].x:=min(b[2*i].x,b[2*i+1].x);
    b[i].y:=max(b[2*i].y,b[2*i+1].y);
  end;

  res:=b[1].y-b[1].x;
  for i:=1 to n do begin
    dec(b[shift+d[i].p].x,a[d[i].num].w);
    dec(b[shift+d[i].p].y,a[d[i].num].w);

    Update(d[i].p);

    inc(b[shift+d[i].p mod k + 1].x,a[d[i].num].w);
    inc(b[shift+d[i].p mod k + 1].y,a[d[i].num].w);

    Update(d[i].p mod k + 1);

    if b[1].y-b[1].x<res then res:=b[1].y-b[1].x;
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
