#include <stdio.h>
#include <math.h>

#define MAXN 100000
#define MAXK 10000
#define pi 3.141592653589
#define eps 1e-10

#define FILE_IN "necklace2.in"
#define FILE_OUT "necklace2.out"

#define assert(x) {if(!(x)) {printf("Error");fclose(stdout);return 222;}}

struct DIAMOND{
  long long cost;
  double angle;
};

struct DE {
  double de;
  int num,part;
};

struct NODE {
   int left,right;
   long long key;
};

int n,k;
long long ans;

DIAMOND a[MAXN];
DE de[MAXN];
NODE arr1[4*MAXK];
NODE arr2[4*MAXK];
long long sum[MAXK];

void swap(DIAMOND *a,DIAMOND *b){
  DIAMOND c;
  c=*a;
  *a=*b;
  *b=c;
}

void Sort(DIAMOND *a,int l,int r){
  int i=l,j=r;
  double x=a[(l+r)/2].angle;
  do {
    while (a[i].angle<x) i++;
    while (x<a[j].angle) j--;
    if (i<=j) swap(&a[i++],&a[j--]);
  } while (i<=j);
  if (i<r) Sort(a,i,r);
  if (l<j) Sort(a,l,j);
}

void swapDe(DE *a,DE *b){
  DE c;
  c=*a;
  *a=*b;
  *b=c;
}

void SortDe(DE *a,int l,int r){
  int i=l,j=r;
  double x=a[(l+r)/2].de;
  do {
    while (a[i].de<x) i++;
    while (x<a[j].de) j--;
    if (i<=j) swapDe(&a[i++],&a[j--]);
  } while (i<=j);
  if (i<r) SortDe(a,i,r);
  if (l<j) SortDe(a,l,j);
}

long long min(long long a,long long b){
  if (a<b) return a;
  else return b;
}

long long max(long long a,long long b){
  if (a>b) return a;
  else return b;
}

void buildMIN(int r,int left,int right){
  if (left==right) {
    arr1[r].key=sum[left];
    arr1[r].left=left;
    arr1[r].right=right;
  } else {
    buildMIN(2*r+1,left,(left+right)/2);
    buildMIN(2*r+2,(left+right)/2+1,right);
    arr1[r].left=left;
    arr1[r].right=right;
    arr1[r].key=min(arr1[2*r+1].key,arr1[2*r+2].key);
  }
}

void putMIN(int r,int num,long long key){
  if (arr1[r].left==arr1[r].right) {
    arr1[r].key=key;
  } else {
    if (num<=(arr1[r].left+arr1[r].right)/2) putMIN(2*r+1,num,key);
    else putMIN(2*r+2,num,key);
    arr1[r].key=min(arr1[2*r+1].key,arr1[2*r+2].key);
  }
}

long long getMIN(int r,int a,int b){
  if (arr1[r].left==a && arr1[r].right==b) return arr1[r].key;
  else {
    if (b<=(arr1[r].left+arr1[r].right)/2) return getMIN(2*r+1,a,b);
    else if (a>=(arr1[r].left+arr1[r].right)/2+1) return getMIN(2*r+2,a,b);
    else return min(getMIN(2*r+1,a,(arr1[r].left+arr1[r].right)/2),
                    getMIN(2*r+2,(arr1[r].left+arr1[r].right)/2+1,b));
  }
}

void buildMAX(int r,int left,int right){
  if (left==right) {
    arr2[r].key=sum[left];
    arr2[r].left=left;
    arr2[r].right=right;
  } else {
    buildMAX(2*r+1,left,(left+right)/2);
    buildMAX(2*r+2,(left+right)/2+1,right);
    arr2[r].left=left;
    arr2[r].right=right;
    arr2[r].key=max(arr2[2*r+1].key,arr2[2*r+2].key);
  }
}

void putMAX(int r,int num,long long key){
  if (arr2[r].left==arr2[r].right) {
    arr2[r].key=key;
  } else {
    if (num<=(arr2[r].left+arr2[r].right)/2) putMAX(2*r+1,num,key);
    else putMAX(2*r+2,num,key);
    arr2[r].key=max(arr2[2*r+1].key,arr2[2*r+2].key);
  }
}

long long getMAX(int r,int a,int b){
  if (arr2[r].left==a && arr2[r].right==b) return arr2[r].key;
  else {
    if (b<=(arr2[r].left+arr2[r].right)/2) return getMAX(2*r+1,a,b);
    else if (a>=(arr2[r].left+arr2[r].right)/2+1) return getMAX(2*r+2,a,b);
    else return max(getMAX(2*r+1,a,(arr2[r].left+arr2[r].right)/2),
                    getMAX(2*r+2,(arr2[r].left+arr2[r].right)/2+1,b));
  }
}


int main(){
  freopen(FILE_IN,"r",stdin);

  scanf("%d %d",&n,&k);
  int i;
  for (i=0;i<n;i++){
    scanf("%lf %lld",&a[i].angle,&a[i].cost);
  }

  Sort(a,0,n-1);

  for (i=1;i<n;i++){
    a[i].angle-=a[0].angle;
  }
  a[0].angle=0;

  double kan=2*pi/(double)k;
  double san=0;

  de[0].de=0;
  de[0].num=0;
  int j=0;
  sum[j]=a[j].cost;
  for (i=1;i<n;i++){
    while (a[i].angle-san>kan) {
      san+=kan;
      sum[++j]=0;
    }
    sum[j]+=a[i].cost;
    de[i].de=a[i].angle-san;
    de[i].num=i;
    de[i].part=j;
  }

  SortDe(de,1,n-1);

  buildMIN(0,0,k-1);
  buildMAX(0,0,k-1);

  ans=getMAX(0,0,k-1)-getMIN(0,0,k-1);

  long long t;
  for (i=0;i<n;i++) {
    if (i>0) 
      assert(fabs(de[i].de-de[i-1].de)>eps);
    
    t=getMIN(0,de[i].part,de[i].part);
    t-=a[de[i].num].cost;
    putMIN(0,de[i].part,t);

    t=getMAX(0,de[i].part,de[i].part);
    t-=a[de[i].num].cost;
    putMAX(0,de[i].part,t);

    de[i].part--;

    if (de[i].part<0) de[i].part=k-1;
    t=getMIN(0,de[i].part,de[i].part);
    t+=a[de[i].num].cost;
    putMIN(0,de[i].part,t);

    t=getMAX(0,de[i].part,de[i].part);
    t+=a[de[i].num].cost;
    putMAX(0,de[i].part,t);

    t=getMAX(0,0,k-1)-getMIN(0,0,k-1);
    if (t<ans) ans =t;
  }
  
  freopen(FILE_OUT,"w",stdout);

  printf("%lld",ans);

  fclose(stdin);    
  fclose(stdout);
  return 0;
}

