{$O-,Q+,R+}
program roads_as_dumb;

uses
    SysUtils;

const
    maxn = 100000;
    maxm = 100000;

var
    a: array [1..maxn] of record
        v, cnt: longint;
    end;
    pos: array [0..maxn] of longint;
    ind, ri: array [1..maxn] of longint;

    list: array [1..2 * maxm] of record
        next: longint;
        v: longint;
    end;
    head: array [1..maxn] of longint;
    free: longint;

    s, t: array [1..maxn] of longint;
    orr: array [1..maxn] of boolean;
    n: longint;

procedure incr(l, r, d: longint);
var
    i: longint;
begin
    for i := l to r do begin
        a[i].v := a[i].v + d;
    end;
end;

function cursum: longint;
var
    i, r: longint;
begin
    r := 0;
    for i := 1 to n do begin
        if a[i].v = 0 then
            r := r + a[i].cnt;
    end;
    cursum := r;
end;

procedure init;
var
    i: longint;
begin
    for i := 1 to n do begin
        a[i].cnt := pos[i] - pos[i - 1];
    end;
end;

procedure sort(l, r: longint);
var
    i, j, x, t: longint;
begin
    i := l;
    j := r;
    x := pos[l + random(r - l + 1)];
    while i <= j do begin
        while pos[i] < x do inc(i);
        while pos[j] > x do dec(j);
        if i <= j then begin
            t := pos[i]; pos[i] := pos[j]; pos[j] := t;
            t := ind[i]; ind[i] := ind[j]; ind[j] := t;
            inc(i);
            dec(j);
        end;
    end;

    if l < j then sort(l, j);
    if i < r then sort(i, r);
end;

procedure add(i, v: longint);
begin
    list[free].v := v;
    list[free].next := head[i];
    head[i] := free;
    inc(free);
end;

var
    i, j, k: longint;
    m, l: longint;
    best, z: longint;

begin
    reset(input, 'roads.in');
    rewrite(output, 'roads.out');

    read(n, m, l);
    for i := 1 to n do begin
        read(pos[i]);
        ind[i] := i;
    end;

    sort(1, n);
    pos[0] := pos[n] - l;

    for i := 1 to n do begin
        assert((0 <= pos[i]) and (pos[i] < l) and (pos[i] <> pos[i - 1])); 
    end;

    for i := 1 to n do begin
        ri[ind[i]] := i;
    end;

    init;

    for i := 1 to m do begin
        read(s[i], t[i]);
        s[i] := ri[s[i]];
        t[i] := ri[t[i]];

        if s[i] > t[i] then begin
            j := s[i]; s[i] := t[i]; t[i] := j;
        end;
    end;

    free := 1;
    for i := 1 to m do begin
        add(s[i], i);
        add(t[i], i);
    end;

    for i := 1 to m do begin
        orr[i] := true;
        incr(s[i] + 1, t[i], 1);
    end;

    best := 0;
    for i := 1 to n do begin
        z := cursum;
        if z > best then begin
            best := z;
        end;

        j := head[i];
        while j <> 0 do begin
            k := list[j].v;
            if orr[k] then begin
                orr[k] := false;
                incr(s[k] + 1, t[k], -1);
                incr(t[k] + 1, n, 1);
                incr(1, s[k], 1);
            end else begin
                orr[k] := true;
                incr(t[k] + 1, n, -1);
                incr(1, s[k], -1);
                incr(s[k] + 1, t[k], 1);
            end;

            j := list[j].next;
        end;
    end;

    writeln(l - best);

    close(output);
end.