{$O-,Q+,R+}
program rrr;

uses
    SysUtils;

const
    maxn = 100000;
    maxm = 100000;

var
    a: array [1..4 * maxn] of record
        min: longint;
        cnt: longint;
        dlt: longint;
    end;
    pos: array [0..maxn] of longint;
    ind, ri: array [1..maxn] of longint;

    list: array [1..2 * maxm] of record
        next: longint;
        v: longint;
    end;
    head: array [1..maxn] of longint;
    free: longint;

    s, t: array [1..maxn] of longint;
    orr: array [1..maxn] of boolean;

procedure incr(tl, tr, ti, l, r, d: longint);
var
    tm, minl, minr: longint;
begin
    if (l <= tl) and (tr <= r) then begin
        a[ti].dlt := a[ti].dlt + d;
        exit;
    end;
    if (r < tl) or (tr < l) then exit;

    a[2 * ti].dlt := a[2 * ti].dlt + a[ti].dlt;
    a[2 * ti + 1].dlt := a[2 * ti + 1].dlt + a[ti].dlt;
    a[ti].dlt := 0;

    tm := (tl + tr) div 2;
    incr(tl, tm, 2 * ti, l, r, d);
    incr(tm + 1, tr, 2 * ti + 1, l, r, d);

    minl := a[2 * ti].min + a[2 * ti].dlt;
    minr := a[2 * ti + 1].min + a[2 * ti + 1].dlt;
    if (minl < minr) then begin
        a[ti].min := minl;
        a[ti].cnt := a[2 * ti].cnt;
    end else if (minr < minl) then begin
        a[ti].min := minr;
        a[ti].cnt := a[2 * ti + 1].cnt;
    end else begin
        a[ti].min := minl;
        a[ti].cnt := a[2 * ti].cnt + a[2 * ti + 1].cnt;
    end;
end;

function cursum: longint;
begin
    if a[1].min + a[1].dlt = 0 then
        cursum := a[1].cnt
    else
        cursum := 0;
end;

procedure init(tl, tr, ti: longint);
var
    tm: longint;
begin
    a[ti].min := 0;
    a[ti].dlt := 0;

    if tl = tr then begin
        a[ti].cnt := pos[tl] - pos[tl - 1];
        exit;
    end;

    tm := (tl + tr) div 2;
    init(tl, tm, 2 * ti);
    init(tm + 1, tr, 2 * ti + 1);
    a[ti].cnt := a[2 * ti].cnt + a[2 * ti + 1].cnt;
end;

procedure sort(l, r: longint);
var
    i, j, x, t: longint;
begin
    i := l;
    j := r;
    x := pos[l + random(r - l + 1)];
    while i <= j do begin
        while pos[i] < x do inc(i);
        while pos[j] > x do dec(j);
        if i <= j then begin
            t := pos[i]; pos[i] := pos[j]; pos[j] := t;
            t := ind[i]; ind[i] := ind[j]; ind[j] := t;
            inc(i);
            dec(j);
        end;
    end;

    if l < j then sort(l, j);
    if i < r then sort(i, r);
end;

procedure add(i, v: longint);
begin
    list[free].v := v;
    list[free].next := head[i];
    head[i] := free;
    inc(free);
end;

var
    i, j, k: longint;
    n, m, l: longint;
    best, z: longint;

begin
    reset(input, 'roads.in');
    rewrite(output, 'roads.out');

    read(n, m, l);
    for i := 1 to n do begin
        read(pos[i]);
        ind[i] := i;
    end;

    sort(1, n);
    pos[0] := pos[n] - l;

    for i := 1 to n do begin
        assert((0 <= pos[i]) and (pos[i] < l) and (pos[i] <> pos[i - 1])); 
    end;

    for i := 1 to n do begin
        ri[ind[i]] := i;
    end;

    init(1, n, 1);

    for i := 1 to m do begin
        read(s[i], t[i]);
        s[i] := ri[s[i]];
        t[i] := ri[t[i]];

        if s[i] > t[i] then begin
            j := s[i]; s[i] := t[i]; t[i] := j;
        end;
    end;

    free := 1;
    for i := 1 to m do begin
        add(s[i], i);
        add(t[i], i);
    end;

    for i := 1 to m do begin
        orr[i] := true;
        incr(1, n, 1, s[i] + 1, t[i], 1);
    end;

    best := 0;
    for i := 1 to n do begin
        z := cursum;
        if z > best then begin
            best := z;
        end;

        j := head[i];
        while j <> 0 do begin
            k := list[j].v;
            if orr[k] then begin
                orr[k] := false;
                incr(1, n, 1, s[k] + 1, t[k], -1);
                incr(1, n, 1, t[k] + 1, n, 1);
                incr(1, n, 1, 1, s[k], 1);
            end else begin
                orr[k] := true;
                incr(1, n, 1, t[k] + 1, n, -1);
                incr(1, n, 1, 1, s[k], -1);
                incr(1, n, 1, s[k] + 1, t[k], 1);
            end;

            j := list[j].next;
        end;
    end;

    writeln(l - best);

    close(output);
end.