#include <stdio.h>

#define FILE_IN "roads.in"
#define FILE_OUT "roads.out"

#define MAXN 100000
#define MAXM 100000
#define MAXL 1000000000

#define TL 70000000

#define assert(x) {if (!(x)) {printf("%s","Assert failed!!!");return 220;}}

struct TOWN {
  int pos,num;
};

struct WAY {
  int a,b;
};

int n,m,l,ans;
TOWN town[2*MAXN],a[MAXN];
WAY way[2*MAXM];
int num[2*MAXN];
int ver[2*MAXN];


void TSwap(TOWN * town,int i,int j){
  num[town[i].num]=j;
  num[town[j].num]=i;

  TOWN c=town[i];
  town[i]=town[j];
  town[j]=c;
}

void Sort(TOWN *a,int l,int r){
  int i=l,j=r,x=a[(l+r)/2].pos;
  do{
    while (a[i].pos<x) i++;
    while (x<a[j].pos) j--;
    if (i<=j) TSwap(a,i++,j--);
  } while (i<=j);
  if (i<r) Sort(a,i,r);
  if (l<j) Sort(a,l,j);
}

void WSwap(int i,int j){
  WAY c;
  c=way[i];
  way[i]=way[j];
  way[j]=c;
}

void SortW(int l,int r){
  int i=l,j=r,x=way[(l+r)/2].a;
  do{
    while (way[i].a<x) i++;
    while (x<way[j].a) j--;
    if (i<=j) WSwap(i++,j--);
  } while (i<=j);
  if (i<r) SortW(i,r);
  if (l<j) SortW(l,j);
}

int abs(int i1,int i2,int cen){
  if (cen<i1) {
    if (cen<i2) return town[i2].pos-town[i1].pos;
    else return l-town[i1].pos+town[i2].pos;
  } else{
    return town[i2].pos-town[i1].pos;
  }
}

int GetAns(int i){
  int s=town[i+1].pos-town[i].pos;
  if (s<0) s+=l;
  int j,k;

  int cf=i+1;
  for (k=0;k<2*m;k++) {
    j=ver[i+1]+k;
    if (j>=2*m) j-=2*m;
    if (i<n-1){
      if ((way[j].b>way[j].a && (way[j].a >i || way[j].b<=i))||(way[j].a>i && way[j].b<=i)) {
        if ((way[j].a>cf && ((cf>i) ||(way[j].a<i)))|| (way[j].a<cf && way[j].a<i && cf>i)) {
          s+=abs(cf,way[j].a,i);
          cf=way[j].b;
        } else {
          if ((cf<way[j].b && (!(way[j].b>i && cf<=i)))|| (way[j].b<cf && way[j].b<=i && cf>i)) {
            cf=way[j].b;
            if (cf==i) return l-s;
          }
        }
      }
    } else {
        if (way[j].b>way[j].a) {
        if (way[j].a>cf) {
          s+=abs(cf,way[j].a,i);
          cf=way[j].b;
        } else {
          if (cf<way[j].b) {
            cf=way[j].b;
            if (cf==i) return l-s;
          }
        }
      }
    }
  }
  return l-s;
}

int min(int a,int b){
  if (a<b) return a;
  else return b;
}

int main(){
  freopen(FILE_IN,"r",stdin);
  freopen(FILE_OUT,"w",stdout);

  assert(scanf("%d %d %d",&n,&m,&l)==3);
  assert(n<=MAXN);
  assert(m<=MAXM);
  assert(n<=MAXL);
  assert(2<=n);
  assert(1<=m);
  assert(2<=l);

  int i;

  for (i=0;i<n;i++) {
    assert(scanf("%d",&town[i].pos)==1);
    assert(town[i].pos<=l-1);
    assert(0<=town[i].pos);
    town[i].num=i;
    num[i]=i;
  }

  for (i=0;i<m;i++) {
    assert(scanf("%d %d",&way[i].a,&way[i].b));
    assert(way[i].a<=n);
    assert(way[i].b<=n);
    assert(1<=way[i].a);
    assert(1<=way[i].b);
    way[m+i].a=--way[i].b;
    way[m+i].b=--way[i].a;
  }

  Sort(town,0,n-1);

  for (i=0;i<2*m;i++) {
    way[i].a=num[way[i].a];
    way[i].b=num[way[i].b];
  }

  for (i=1;i<n;i++) town[i].pos-=town[0].pos;
  town[0].pos=0;

  for (i=0;i<n;i++) town[n+i]=town[i];

  int t;

  ans=town[n-1].pos;
  for (i=1;i<n;i++) {
    if (ans>l-(town[i].pos-town[i-1].pos)) ans=l-(town[i].pos-town[i-1].pos);
  }

  SortW(0,2*m-1);

  for (i=0;i<n;i++) ver[i];
  int j=-1;
  for (i=0;i<2*m;i++) {
    if (j!=way[i].a) {
      while (j!=way[i].a) ver[++j]=i;
    }
  }
  while (j<n) ver[j++]=i-1;

  for (i=0;i<n;i++) {
    ver[i+n]=ver[i];
    num[i+n]=num[i];
  }

  for (i=0;i<n;i++) {
    a[i].pos=town[i+1].pos-town[i].pos;
    if (a[i].pos<0) a[i].pos+=l;
    a[i].num=i;
  }

  Sort(a,0,n-1);

  int work=min(n,TL/m);

  for (i=n-1;i>=n-work;i--) {
    t=GetAns(a[i].num);
    if (ans>t) ans=t;
  }

  printf("%d",ans);

  fclose(stdin);
  fclose(stdout);
  return 0;
}