Program JustAGreedySolutionForTheProblemThatInvolvesAKindOfVeryStrangeDataStructureInventedByAndrewAndMisha;

Type
  Integer=LongInt;

Const
  TaskID='roads';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=100000;
  MaxM=100000;

Type
  TSegment=Record
    A,B:Integer;
  End;
  TEvent=Record
    P:Integer;
    Start:Boolean;
  End;

Var
  N,M,L:Integer;
  At,SAt:Array[1..MaxN]Of Integer;
  Any:Array[1..MaxN]Of Boolean;
  S:Array[1..MaxM]Of TSegment;
  NP:Integer;
  UnPerm,Perm:Array[1..MaxN]Of Integer;
  CoverZero:Integer;
  NEvent:Integer;
  Event:Array[1..2*MaxM]Of TEvent;
  Res:Integer;

Procedure Load;
Var
  I:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,M,L);
  FillChar(Any,SizeOf(Any),False);
  For I:=1 To N Do
    Read(At[I]);
  For I:=1 To M Do With S[I] Do Begin
    Read(A,B);
    Any[A]:=True;
    Any[B]:=True;
  End;
  Close(Input);
End;

Procedure QSort(L,R:Integer);
Var
  I,J,X,Y:Integer;
Begin
  I:=L;
  J:=R;
  X:=At[Perm[L+Random(R-L+1)]];
  While I<=J Do Begin
    While At[Perm[I]]<X Do Inc(I);
    While X<At[Perm[J]] Do Dec(J);
    If I<=J Then Begin
      Y:=Perm[I];
      Perm[I]:=Perm[J];
      Perm[J]:=Y;
      Inc(I);
      Dec(J);
    End;
  End;
  If I<R Then QSort(I,R);
  If L<J Then QSort(L,J);
End;

Procedure QSort2(L,R:Integer);
Var
  I,J:Integer;
  X,Y:TEvent;
Begin
  I:=L;
  J:=R;
  X:=Event[L+Random(R-L+1)];
  While I<=J Do Begin
    While Event[I].P<X.P Do Inc(I);
    While X.P<Event[J].P Do Dec(J);
    If I<=J Then Begin
      Y:=Event[I];
      Event[I]:=Event[J];
      Event[J]:=Y;
      Inc(I);
      Dec(J);
    End;
  End;
  If I<R Then QSort2(I,R);
  If L<J Then QSort2(L,J);
End;

Procedure SortThem;
Var
  I:Integer;
Begin
  NP:=0;
  For I:=1 To N Do If Any[I] Then Begin
    Inc(NP);
    Perm[NP]:=I;
  End;
  QSort(1,NP);
  SAt:=At;
  For I:=1 To NP Do UnPerm[Perm[I]]:=I;
  N:=NP;
  For I:=1 To N Do At[I]:=SAt[Perm[I]];
  For I:=1 To M Do With S[I] Do Begin
    A:=UnPerm[A];
    B:=UnPerm[B];
  End;
End;

Function Distance(X,Y:Integer):Integer;
Begin
  If X<=Y Then Distance:=Y-X Else Distance:=(L+Y-X);
End;

Function GetAnswer:Integer;
Var
  I:Integer;
  Res,Cov:Integer;
Begin
  CoverZero:=0;
  NEvent:=0;
  For I:=1 To M Do With S[I] Do Begin
    If A>B Then Inc(CoverZero);
    Inc(NEvent);
    Event[NEvent].P:=At[A];
    Event[NEvent].Start:=True;
    Inc(NEvent);
    Event[NEvent].P:=At[B];
    Event[NEvent].Start:=False;
  End;
  QSort2(1,NEvent);
  Res:=0;
  If CoverZero>0 Then 
    Res:=Res+Distance(At[N],At[1]);
  Cov:=CoverZero;
  For I:=1 To NEvent-1 Do Begin
    If Event[I].Start Then Inc(Cov) Else Dec(Cov);
    If Cov>0 Then Res:=Res+Distance(Event[I].P,Event[I+1].P);
  End;
  GetAnswer:=Res;
End;

Procedure Solve;
Var
  I,T:Integer;
  Mx,MxAt:Integer;
Begin 
  SortThem;
  For I:=1 To M Do With S[I] Do
    If Distance(At[A],At[B])>Distance(At[B],At[A]) Then Begin
      T:=A;
      A:=B;
      B:=T;
    End;
  Res:=GetAnswer;
  Mx:=0;
  MxAt:=1;
  For I:=1 To N Do If Distance(At[I],At[I Mod N+1])>Mx Then Begin
    Mx:=Distance(At[I],At[I Mod N+1]);
    MxAt:=I;
  End;
  If L-Mx<Res Then Begin
    For I:=1 To M Do With S[I] Do
      If Distance(At[A],At[MxAt])+Distance(At[MxAt],At[MxAt Mod N+1])+Distance(At[MxAt Mod N+1],At[B])=Distance(At[A],At[B]) Then Begin
        T:=A;
        A:=B;
        B:=T;
      End;
  End;
  Res:=GetAnswer;
End;

Procedure Save;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Res);
  Close(Output);
End;

Begin
  RandSeed:=431688111;
  Load;
  Solve;
  Save;
End.
