{$A8,B-,C+,D+,E-,F-,G+,J-,K-,L+,M-,N+,P+,T-,U-,V+,W-,X+,Y+,Z1}
{$Q+,R+,S+,O-,H+,I+}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE console}

uses SysUtils;

const
  cinfile = 'network.in';
  coutfile = 'network.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 110;
  kmax = 110;

type
  int = longint;
  real = extended;

var
  ans, ar, ah : int;
  n, m, k, l : int;
  kl : int;

  a, no, d : array [-1..nmax] of int;

  pr, c : array [-1..nmax, -1..kmax] of int;

  u  : array [-nmax..nmax] of boolean;
  pred  : array [-nmax..nmax] of int;
  g : array [-nmax..nmax, 0..kmax] of int;

procedure pre(i : int);
var
  j, t : int;
begin
  t:= 1;
  for j:= i + 1 to n do
  begin
    a[t]:= d[j] - d[i + 1];
    no[t]:=  j;
    inc(t);
  end;
  for j:= 0 to i do
  begin
    a[t]:= d[j] + l - d[i + 1];
    no[t]:=  j;
    inc(t);
  end;
  kl:= t - 2;
  move(a[1], a[0], sizeof(a[1]) * (kl + 1));
  move(no[1], no[0], sizeof(no[1]) * (kl + 1));
  dec(kl);
end;

procedure findHab(t, i : int; var res, h : int);
var
  s : int;
  j : int;
begin
  h:= i;
  s:= 0;
  for j:= t to i do inc(s, a[i] - a[j]);
  res:= s;

  for j:= i - 1 downto t do
  begin
    s:= s + (a[j + 1] - a[j]) * (i - j) - (a[j + 1] - a[j]) * (j + 1 - t);
    if res > s then
    begin
      res:= s;
      h:= j;
    end;
  end;
end;

procedure dyn(r : int);
var
  i, j, t, h : int;
  lf, rp : int;
  res, s : int;
  n : int;
begin
  n:= kl;
  fillchar(c, sizeof(c), 1);
  fillchar(pr, sizeof(pr), 0);
  c[0, 0]:= 0;
  for i:= 1 to n do
    for t:= 1 to i do
    begin
      if i - t + 1 > k - 1 then continue;

      findHab(t, i, res, h);
      for j:= 1 to m do
        if c[i, j] > c[t - 1, j - 1] + res then
        begin
          c[i, j]:= c[t - 1, j - 1] + res;
          pr[i, j]:= t - 1;
        end;
    end;

  for j:= 0 to m do
    if ans > c[n, j] + l - d[r + 1] + d[r] then
    begin
      ans:= c[n, j] + l - d[r + 1] + d[r];
      ar:= r;
      ah:= j;
    end;
end;

procedure deep(v : int);
var
  i : int;
begin
  u[v]:= true;
  for i:= 1 to g[v, 0] do
    if not u[g[v, i]] then
    begin
      pred[g[v, i]]:= v;
      deep(g[v, i]);
    end;
end;

procedure push(a, b : int);
begin
  inc(g[a, 0]);
  g[a, g[a, 0]]:= b;
  inc(g[b, 0]);
  g[b, g[b, 0]]:= a;
end;

procedure outdata;
var
  i, j : int;
  x, y : int;

  buf : int;

  kh : int;
  ph : array [1..nmax] of int;

  kr : int;
  r : array [1..nmax] of int;
begin
  if ar = -1 then writeln(-1) else
  begin
//    writeln('---------debug-------', ans);
    fillchar(g, sizeof(g), 0);
    pre(ar);
    dyn(ar);
    x:= kl;
    y:= ah;
    kh:= 0;
    kr:= ah + 2;
    dec(kr);
    r[kr]:= x;
    while (x <> 0) do
    begin
      x:= pr[x, y];
      dec(y);
      dec(kr);
      r[kr]:= x;
    end;
    kr:= ah + 1;
    kh:= 0;
    for i:= 1 to kr - 1 do
    begin
      inc(kh);
      findHab(r[i] + 1, r[i + 1], buf, ph[kh]);
      ph[kh]:= no[ph[kh]]
    end;
    for i:= 1 to kh do
    begin
      for j:= r[i] + 1 to r[i + 1] do
      begin
        push(-i, no[j]);
      end;
      if i > 1 then
      begin
        push(-i, - (i - 1));
      end else
      begin
        push(-i, no[0]);
      end;
      if i = ah then
        push(-i, no[kl + 1]);
    end;
    deep(0);
    writeln(ah);
    for i:= 1 to ah do
    begin
      write(d[ph[i]], ' ', pred[-i]);
      for j:= 1 to g[-i, 0] do
        if g[-i, j] <> pred[-i] then write(' ', g[-i, j]);
      writeln;
    end;
  end;
end;

procedure solve;
var
  i, j : int;
begin
  fillchar(ans, sizeof(ans), 1);
  ar:= -1;
  for i:= 0 to n do
  begin
    pre(i);
    dyn(i);
  end;
end;

procedure readdata;
var
  i, j : int;
begin
  read(n, l, k, m);
  assert((n >= 1) and (n <= 100));
  assert((l >= 1) and (n <= 1000000));
  assert((k >= 1) and (k <= 100));
  assert((m >= 1) and (m <= 100));
  d[0]:= 0;
  for i:= 1 to n do
  begin
    read(d[i]);
    assert(d[i] > d[i - 1]);
  end;
  d[n + 1]:= l;
  assert(d[n + 1] > d[n]);
end;

begin
  reset(input, cinfile);
  rewrite(output, coutfile);
  readdata;
  solve;
  outdata;
  close(input);
  close(output);
end.
