{$D+,L+,I+,Q+,R+,S+}
Program tractor_alx;
Uses SysUtils;
const
  inpfile='tractor.in';
  outfile='tractor.out';
  inf=1e20;
  nm=105;
  eps=1e-10;
type
  Coord = record
    x,y : Extended;
    num : LongInt;
  end;  
var
  a : array [1..nm*nm] of Coord;
  r : array [0..nm*nm] of Extended;
  b : array [1..nm*nm] of Boolean;
  p : array [1..2] of Coord;
  n,m : LongInt;
  v,u : Extended;
{}
Procedure Inp;
var
  i,x,y : LongInt;
begin
  assign(input,inpfile);
  reset(input);
  read(n,u,v);
  assert((1<=n) and (n<=80));
  assert((0.1-eps<u) and (u+eps<v) and (v-eps<100.0));
  m:=n+1;
  for i:=1 to n+1 do begin
    read(x,y);
    a[i].x:=x; a[i].y:=y;
    assert((abs(a[i].x)-eps<1000) and (abs(a[i].y)-eps<1000));
    if i=1 then a[i].num:=i
    else begin
      a[i].num:=i-1;
      if i<n+1 then begin
        inc(m);
        a[m]:=a[i];
        a[m].num:=i;
      end;
    end;
  end;
end;
{}
Procedure Out;
begin
  assign(output,outfile);
  rewrite(output);
  writeln(r[n+1]:0:10);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  fillchar(a,sizeof(a),0);
  fillchar(r,sizeof(r),0);
  fillchar(b,sizeof(b),0);
end;
{}
Function Vc(var p1,p2,p3,p4 : Coord) : Extended;
begin
  Vc:=(p2.x-p1.x)*(p4.y-p3.y)-(p2.y-p1.y)*(p4.x-p3.x);
end;
{}
Function Sc(var p1,p2,p3,p4 : Coord) : Extended;
begin
  Sc:=(p2.x-p1.x)*(p4.x-p3.x)+(p2.y-p1.y)*(p4.y-p3.y);
end;
{}
Function Len(var q,w : Coord) : Extended;
begin
  Len:=sqrt(sqr(q.x-w.x)+sqr(q.y-w.y));
end;
{}
Function FindPoint(var q,p1,p2 : Coord) : LongInt;
var
  d,sq,p1p2,sn,tg : Extended;
  dx,dy : Extended;
  h : Coord;
  r : LongInt;
begin
  r:=1;
  FindPoint:=0;
  sq:=Vc(p1,p2,p1,q);
  if abs(sq)<eps then exit;

  p1p2:=Len(p1,p2);
  d:=sq/p1p2;

  dx:=(p2.x-p1.x)/p1p2;
  dy:=(p2.y-p1.y)/p1p2;

  h.x:=q.x+d*dy;
  h.y:=q.y-d*dx;

  if abs(Vc(p1,p2,p1,h))>eps then begin
    h.x:=q.x-d*dy;
    h.y:=q.y+d*dx;
    assert(abs(Vc(p1,p2,p1,h))<eps,'Buga');
  end;

  sn:=u/v;
  tg:=sn/sqrt(1-sqr(sn));
  d:=d*tg;

  p[r].x:=h.x+d*dx;
  p[r].y:=h.y+d*dy;
  if Sc(p[r],p1,p[r],p2)<-eps then inc(r);

  p[r].x:=h.x-d*dx;
  p[r].y:=h.y-d*dy;
  if Sc(p[r],p1,p[r],p2)<-eps then inc(r);

  FindPoint:=r-1;
end;
{}
Function Eq(var q,w : Coord) : Boolean;
begin
  if (abs(q.x-w.x)<eps) and (abs(q.y-w.y)<eps) then Eq:=true
                                               else Eq:=false;
end;
{}
Function Cross(var p1,p2,p3,p4 : Coord) : Boolean;
begin
  Cross:=false;
  if (Vc(p1,p2,p1,p3)*Vc(p1,p2,p1,p4)<-eps)
  and (Vc(p3,p4,p3,p1)*Vc(p3,p4,p3,p2)<-eps) then Cross:=true;

  if Eq(p1,p3) or Eq(p1,p4) or Eq(p2,p3) or Eq(p2,p4) then Cross:=true;

end;
{}
Procedure Solve;
var
  i,j,k,mini : LongInt;
  d : Extended;
begin
  for i:=1 to n+1 do
    for j:=1 to n do
      assert((Sc(a[i],a[j],a[i],a[j+1])>-eps) or (abs(Vc(a[j],a[j+1],a[j],a[i]))>eps));

  for i:=1 to n-2 do
    for j:=i+2 to n do
      assert(not Cross(a[i],a[i+1],a[j],a[j+1]),'Selfcrossing way');

  for i:=1 to n+1 do
    for j:=1 to n do
      for k:=1 to FindPoint(a[i],a[j],a[j+1]) do begin
        inc(m);
        a[m]:=p[k];
        a[m].num:=j;
      end;

  for i:=0 to m do r[i]:=inf;
  r[1]:=0;
  while not b[n+1] do begin
    mini:=0;
    for i:=1 to m do
      if not b[i] and (r[i]<r[mini]) then mini:=i;

    assert(mini<>0,'Buga');
    b[mini]:=true;

    for i:=1 to m do
      if not b[i] then begin
        d:=Len(a[i],a[mini]);
        if a[i].num=a[mini].num then d:=d/v
                                else d:=d/u;
        if r[mini]+d<r[i] then r[i]:=r[mini]+d;                         
      end;
  end;     
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out;
End.
