{$A+,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S+,T-,V-,X+}
{$M 64000,10000,655360}

program p0604_4;

const
  maxx                  = 45;
  maxy                  = 41;
  maxl                  = maxx*maxy+10;
  maxtime               = 4*18;

type

  Area                  = record
    c                   : byte;
    n                   : integer;
    fp                  : integer;
    nl                  : integer;
    fl                  : integer;
  end;
  Point                 = record
    x,y                 : byte;
  end;
  Queue                 = array[1..maxl] of integer;
  PQueue                = ^Queue;

var
  tbl                   : array[-1..maxx+1,-1..maxy+1] of byte;
  atbl                  : array[1..maxx, 1..maxy] of integer;
  na                    : integer;
  ar                    : array[1..maxx*maxy] of Area;
  m                     : array[1..maxx,1..maxy] of boolean;
  from                  : array[1..maxl] of integer;
  p                     : array[1..maxx*maxy] of Point;
  mydist                : array[1..maxl] of integer;
  hisdist               : array[1..maxl] of integer;
  myfirst               : array[1..maxl] of integer;
  np                    : integer;
  mymove                : integer;
  lnk                   : array[1..maxl] of integer;
  nl                    : integer;
  myc,hisc              : integer;
  q1,q2                 : PQueue;
  q                     : PQueue absolute q1;
  lq1,lq2               : integer;
  first                 : integer;
  time                  : longint absolute $0000:$046c;
  starttime             : longint;

procedure SwapQueues;
var
  t                     : PQueue;
begin
  t := q1;
  q1 := q2;
  q2 := t;
  lq1 := lq2;
end;

function FindRoute( s,e : integer ) : integer;
var
  a,b,i,j,step          : integer;

procedure Append( i,j : integer );
begin
  if from[j] <> -1 then exit;
  from[j] := i;
  inc( lq2 );
  q2^[lq2] := j;
end;

begin
  lq1 := 1;
  q1^[1] := s;
  step := 1;
  fillchar( from, sizeof(from), $ff );
  repeat
    lq2 := 0;
    for i:=1 to lq1 do begin
      a := q1^[i];
      for j:=ar[a].fl to ar[a].nl + ar[a].fl - 1 do begin
        b := lnk[j];
        Append( a, b );
        if b = e then begin
          i := b;
          while from[i] <> s do i := from[i];
          first := i;
          FindRoute := step;
          exit;
        end;
      end;
    end;
    SwapQueues;
    inc( step );
  until lq1 = 0;
  FindRoute := maxint;
end;

function Trace( x,y,a : integer ) : integer;
var
  c                     : integer;
begin
  if (x<1) or (x>maxx) or (y<1) or (y>maxy) or
     m[x,y] then begin
   Trace := 0;
   exit;
  end;
  m[x,y] := true;
  atbl[x,y]:=a;
  c := 0;
  p[np].x := x;
  p[np].y := y;
  inc( np );
  if tbl[x-1,y] = tbl[x,y] then inc( c, Trace( x-1, y, a ) );
  if tbl[x+1,y] = tbl[x,y] then inc( c, Trace( x+1, y, a ) );
  if tbl[x,y-1] = tbl[x,y] then inc( c, Trace( x, y-1, a ) );
  if tbl[x,y+1] = tbl[x,y] then inc( c, Trace( x, y+1, a ) );
  Trace := c+1;
end;

procedure AddLink( q,x1,y1,x2,y2 : integer );
var
  i,sr,tg               : integer;
begin
  if (x2<1) or (x2>maxx) or (y2<1) or (y2>maxy) then exit;
  sr := atbl[x1,y1];
  tg := atbl[x2,y2];
  for i:=ar[q].fl to nl-1 do if lnk[i] = tg then exit;
  lnk[nl] := tg;
  inc( ar[q].nl );
  inc( nl );
end;

procedure TraceAll;
var
  i,j,k,x,y             : integer;
begin
  fillchar( m, sizeof(m), 0 );
  na := 0;
  np := 1;
  nl := 1;
  for x:=1 to maxx do for y:=1 to maxy do
    if not m[x,y] then begin
      inc( na );
      ar[na].c := tbl[x,y];
      ar[na].fp := np;
      ar[na].n := Trace( x, y, na );
    end;

  for i:=1 to na do begin
    ar[i].fl := nl;
    ar[i].nl := 0;
    k := ar[i].fp;
    for j:=1 to ar[i].n do begin
      x := p[j].x;
      y := p[j].y;
      if tbl[x,y] <> tbl[x-1,y] then AddLink( i,x,y,x-1,y );
      if tbl[x,y] <> tbl[x+1,y] then AddLink( i,x,y,x+1,y );
      if tbl[x,y] <> tbl[x,y-1] then AddLink( i,x,y,x,y-1 );
      if tbl[x,y] <> tbl[x,y+1] then AddLink( i,x,y,x,y+1 );
    end;

  end;

end;

procedure AnyMove;
var
  i,mx,k                : integer;
begin

  i := atbl[1,1];
  mx := -1;
  mymove := 0;
  for k:=ar[i].fl to ar[i].fl + ar[i].nl - 1 do
    if not (ar[lnk[k]].c in [myc,hisc]) then begin
      if ar[lnk[k]].n > mx then begin
        mx := ar[lnk[k]].n;
        mymove := ar[lnk[k]].c;
      end;
    end;
  if mymove = 0 then for i:=1 to 6 do
    if not (i in [myc,hisc]) then mymove := i;

end;

procedure WriteData;forward;

procedure Solve;
var
  i,j,k,mx              : integer;
  mya,hisa              : integer;
begin
  starttime := time;
  myc := tbl[1,1];
  hisc := tbl[maxx,maxy];
  TraceAll;
  new( q1 );
  new( q2 );

  mya := atbl[1,1];
  hisa := atbl[maxx,maxy];
  for i:=1 to na do if (i <> mya) and (i <> hisa) then begin
    if time - starttime >= maxtime then begin
      AnyMove;
      WriteData;
      halt;
    end;
    mydist[i] := FindRoute( mya, i );
    myfirst[i] := first;
    hisdist[i] := FindRoute( hisa, i );
  end;

  mx := -1;
  mymove := 0;
  for i:=1 to na do
    if (i<>mya) and (i<>hisa) and not( ar[myfirst[i]].c in [myc,hisc]) then begin
      if hisdist[i] >= mydist[i] then begin
        if ar[i].n > mx then begin
          mx := ar[i].n;
          mymove := ar[myfirst[i]].c;
        end;
      end;
    end;
  if mymove = 0 then AnyMove;
end;

procedure ReadData;
var
  s                     : string;
  i,j                   : integer;
begin
  fillchar( tbl, sizeof(tbl), 255 );
  for i:=1 to maxy do begin
    readln( s );
    for j:=1 to maxx do tbl[j,i] := ord( s[j] ) - 48;
  end;
end;

procedure WriteData;
begin
  writeln( mymove );
end;

procedure Reassign;
begin
  assign( input, 'filya.in' );
  reset( input );
  assign( output, 'filya.out' );
  rewrite( output );
end;

begin
  Reassign;
  ReadData;
  Solve;
  WriteData;
  close(output);
end.