{$A+,B-,D+,E-,F-,G+,I-,L+,N-,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
{$M 65520,0,655360}
program macro;

const
  MaxDepth = 5;
  S0       = 16384;
type
  TMap   = array [0..46, 0..42] of byte;
  RestEl = record X, Y, V : byte end;
var
  Map, Mark   : TMap;
  Stack       : array [0..S0-1] of RestEl;
  SP          : integer;
  Queue       : array [1..2000, 1..2] of byte;
  QR, QW      : integer;
  Timer       : longint absolute $40:$6c;
  sttime      : longint;

procedure readmap;
var i, j, k  : integer;
    S        : string;
begin
  assign (input, 'filya.in');
  reset (input);
{$IFDEF PLAYER2}
  for j := 41 downto 1 do
    begin
      readln (S);
      if S[0] <> #45 then runerror (239);
      for i := 1 to 45 do
        begin
          k := ord (S[46-i]) - 48;
          if (k < 1) or (k > 6) then runerror (239) else Map[i,j] := k
        end
    end;
{$ELSE}
  for j := 1 to 41 do
    begin
      readln (S);
      if S[0] <> #45 then runerror (239);
      for i := 1 to 45 do
        begin
          k := ord (S[i]) - 48;
          if (k < 1) or (k > 6) then runerror (239) else Map[i,j] := k
        end
    end;
{$ENDIF}
  if Map[1, 1] = Map [45, 41] then runerror (239)
end;

procedure initQ;
begin
  QR := 0;
  QW := 0
end;

procedure pushQ (X, Y : integer);
begin
  inc (QW);
  Queue [QW, 1] := X;
  Queue [QW, 2] := Y
end;

function popQ (var X, Y : integer) : boolean;
begin
  if QR = QW then begin popQ := false; exit end;
  popQ := true;
  inc (QR);
  X := Queue [QR, 1];
  Y := Queue [QR, 2]
end;

procedure mark0;
var X, Y, c : integer;
begin
  initQ;
  pushQ (1, 1);
  c := Map [1, 1];
  Map [1, 1] := c or $10;
  while popQ (X, Y) do
    begin
      if Map [X-1, Y] = c then begin pushQ (X-1, Y); Map[X-1,Y] := Map[X-1,Y] or $10 end;
      if Map [X+1, Y] = c then begin pushQ (X+1, Y); Map[X+1,Y] := Map[X+1,Y] or $10 end;
      if Map [X, Y+1] = c then begin pushQ (X, Y+1); Map[X,Y+1] := Map[X,Y+1] or $10 end;
      if Map [X, Y-1] = c then begin pushQ (X, Y-1); Map[X,Y-1] := Map[X,Y-1] or $10 end;
    end;
  initQ;
  pushQ (45, 41);
  c := Map [45, 41];
  Map [45, 41] := c or $20;
  while popQ (X, Y) do
    begin
      if Map [X-1, Y] = c then begin pushQ (X-1, Y); Map[X-1,Y] := Map[X-1,Y] or $20 end;
      if Map [X+1, Y] = c then begin pushQ (X+1, Y); Map[X+1,Y] := Map[X+1,Y] or $20 end;
      if Map [X, Y+1] = c then begin pushQ (X, Y+1); Map[X,Y+1] := Map[X,Y+1] or $20 end;
      if Map [X, Y-1] = c then begin pushQ (X, Y-1); Map[X,Y-1] := Map[X,Y-1] or $20 end;
    end;
end;

procedure Let (Xs, Ys, Vs : integer);
begin
  if Map[Xs, Ys] <> Vs then
    begin
      if SP = S0 then runerror (239);
      with Stack[SP] do
        begin
          X := Xs;
          Y := Ys;
          V := Map [Xs, Ys]
        end;
      inc (SP);
      Map [Xs, Ys] := Vs
    end
end;

procedure Restore (KeepSP : integer);
begin
  while SP > KeepSP do
    begin
      dec (SP);
      with Stack[SP] do
        Map [X, Y] := V
    end
end;

procedure pushQ_Let (X, Y, V : integer);
begin
  {pushQ (X, Y);}
  inc (QW);
  Queue [QW, 1] := X;
  Queue [QW, 2] := Y;
  {Let (X, Y, V)}
  Map [X, Y] := V;
end;

function trymove (P, c : integer) : integer;
var
  X, Y, count, f, newc  : integer;
begin
  f := 8 shl P;
  newc := c or f;
  {initQ;} QR:=0; QW:=0;
  count := 0;
  for X := 1 to 45 do
    for Y := 1 to 41 do
      if ((Map [X, Y] and f) > 0) then {pushQ_Let (X, Y, newc);}
         begin inc(QW); queue[QW,1]:=X; queue[QW,2]:=Y; Map[X,Y]:=newc; end;
  while {popQ (X, Y)} QR < QW do
    begin
       inc (QR);
       X := Queue[QR, 1];
       Y := Queue[QR, 2];
      if Map [X-1, Y] = c then
        begin inc(count); {pushQ_Let (X-1, Y, newc)} inc(QW); queue[QW,1]:=X-1; queue[QW,2]:=Y; Map[X-1,Y]:=newc; end;
      if Map [X+1, Y] = c then
        begin inc(count); {pushQ_Let (X+1, Y, newc)} inc(QW); queue[QW,1]:=X+1; queue[QW,2]:=Y; Map[X+1,Y]:=newc; end;
      if Map [X, Y-1] = c then
        begin inc(count); {pushQ_Let (X, Y-1, newc)} inc(QW); queue[QW,1]:=X; queue[QW,2]:=Y-1; Map[X,Y-1]:=newc; end;
      if Map [X, Y+1] = c then
        begin inc(count); {pushQ_Let (X, Y+1, newc)} inc(QW); queue[QW,1]:=X; queue[QW,2]:=Y+1; Map[X,Y+1]:=newc; end;
    end;
  if P = 1 then trymove := count shl 1 else trymove := count
end;

const move : integer = 1;

function getmove (P : integer; {best : integer;} depth : integer) : integer;
var
{  KeepSP  : integer;}
  i, mv   : integer;
  bst, th : integer;
  KeepMap : TMap;
begin
  if depth = 0 then begin getmove := 0; exit end;
  {KeepSP := SP;}
  KeepMap := Map;
  bst := -10000;
  mv := 0;
  for i := 1 to 6 do
    if (i <> (Map[1,1] and $0f)) and (i <> (Map[45,41] and $0f)) then
      begin
        th := trymove (P, i) - getmove (P xor 3, {-20000,} depth-1);
        {Restore (KeepSP);}
        Map := KeepMap;
        if th > bst then begin mv := i; bst := th end
      end;
  move := mv;
  getmove := bst
end;

begin
  sttime := timer;
  readmap;
  mark0;
  getmove (1, {-20000,} MaxDepth);
  if (move < 0) or (move > 6) then move := 1;
  while (move = (Map[1,1] and $f)) or (move = (Map[45,41] and $f)) do
    inc (move);
  assign (output, 'filya.out');
  rewrite (output);
  writeln (move);
  close (output);
{  assign (output,'time'); append (output); writeln (timer - sttime); if timer-sttime > 90 then writeln ('***');}
end.