{$A8,B-,C+,D+,E-,F-,G+,J-,K-,L+,M-,N+,P+,T-,U-,V+,W-,X+,Y+,Z1}
{$Q+,R+,S+,O-,H+,I+}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}
{$IMAGEBASE $00400000}
{$APPTYPE console}

uses SysUtils;

const
  cinfile = 'filya.in';
  coutfile = 'filya.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  n = 41;
  m = 45;

  nmax = m + 1;

  base = 1 shl 12 - 1;

  vx : array [1..4] of integer = (-1, 0, 1,  0);
  vy : array [1..4] of integer = ( 0, 1, 0, -1);

  gc = 9;

  KoefMegaShamanstvo = 3;

type
  int = longint;
  real = extended;

  Tdist = array [0..nmax, 0..nmax] of int;
  point = record
    x, y : int;
  end;
  TPred = array [0..nmax, 0..nmax] of point;

var
  ans, ac, ansc : int;
  k : int;

  d : array [0..nmax, 0..nmax] of byte;

  y, p : Tdist;
  yp, pp : TPred;

  h, t, nm : int;
  q : array [0..base] of point;

  ai, aj : int;

  res : int;
  u : array [0..nmax, 0..nmax] of boolean;

procedure outdata;
var
  i, j : int;
begin

end;

procedure deep(x, y : int);
var
  i : int;
begin
  if u[x, y] then exit;
  u[x, y]:= true;
  inc(res);
  for i:= 1 to 4 do
    if d[x, y] = d[x + vx[i], y + vy[i]] then deep(x + vx[i], y + vy[i]); 
end;

procedure go(x, y : int; var a : Tdist; var pr : TPred; zc : byte);
var
  c : point;
  i : int;
begin
  fillchar(a, sizeof(a), 1);
  a[x, y]:= 0;
  h:= 1;
  t:= 1;
  q[1].x:= x;
  q[1].y:= y;
  nm:= 1;
  while nm > 0 do
  begin
    dec(nm);
    c:= q[h];
    h:= (h + 1) and base;
    for i:= 1 to 4 do
      if (d[c.x + vx[i], c.y + vy[i]] <> zc) and (d[c.x + vx[i], c.y + vy[i]] <> gc)
        and (a[c.x + vx[i], c.y + vy[i]] > a[c.x, c.y]
          + ord(d[c.x, c.y] <> d[c.x + vx[i], c.y + vy[i]])) then
            if d[c.x, c.y] <> d[c.x + vx[i], c.y + vy[i]] then
            begin
              t:= (t + 1) and base;
              inc(nm);
              q[t].x:= c.x + vx[i];
              q[t].y:= c.y + vy[i];
              a[c.x + vx[i], c.y + vy[i]]:= a[c.x, c.y] + 1;
              pr[c.x + vx[i], c.y + vy[i]]:= c;
            end else
            begin
              h:= (h + base) and base;
              inc(nm);
              q[h].x:= c.x + vx[i];
              q[h].y:= c.y + vy[i];
              a[c.x + vx[i], c.y + vy[i]]:= a[c.x, c.y];
              pr[c.x + vx[i], c.y + vy[i]]:= c;
            end;
  end;
end;

procedure greedy;
var
  c : array [0..10] of int;
  ii, i, j : int;
begin
  fillchar(u, sizeof(u), 0);
  fillchar(c, sizeof(c), 0);
  deep(1, 1);
  for i:= 1 to n do
    for j:= 1 to m do
      if u[i, j] and (d[i, j] = d[1, 1]) then
      begin
         for ii:= 1 to 4 do
           if (d[i + vx[ii], j + vy[ii]] <> gc) and
             (d[i + vx[ii], j + vy[ii]] <> d[1, 1]) and
             (d[i + vx[ii], j + vy[ii]] <> d[n, m]) then
           begin
             res:= 0;
             deep(i + vx[ii], j + vy[ii]);
             inc(c[d[i + vx[ii], j + vy[ii]]], res);
           end;
      end;
  ac:= -1;
  ans:= -1;
  for i:= 1 to 6 do
    if (ans < c[i]) and (i <> d[1, 1]) and (i <> d[n, m]) then
    begin
      ac:= i;
      ans:= c[i];
    end;
  ansc:= ac;
end;

procedure solve;
var
  i, j : int;
begin
  go(n, m, p, pp, gc);
  go(1, 1, y, yp, d[n, m]);
  ans:= inf;
  ai:= 0;
  aj:= 0;
  res:= 0;
  deep(1, 1);
  if (res < n * m div 25) or (res > n * m div 2) then
  begin
    greedy;
    exit;
  end;
  if res < n * m div 15 then
  begin
    for i:= n div 2 - 10 to n div 2 + 10 do
      for j:= m div 2 - 10 to m div 2 + 10 do
        if (y[i, j] < 100) and (ans < y[i, j]) then
        begin
          ans:= y[i, j];
          ai:= i;
          aj:= j;
          break;
        end;
  end;
  if ai = 0 then
    for i:= 1 to n do
      for j:= 1 to m do
        if (p[i, j] > y[i, j] + KoefMegaShamanstvo) and (ans > p[i, j]) and (y[i, j] <> 0) then
        begin
          ans:= p[i, j];
          ai:= i;
          aj:= j;
        end;
  if ai = 0 then
  begin
    i:= n;
    ans:= 0;
    for j:= m div 2 - 5 to m div 2 + 15 do
      if (y[i, j] < 100) and (ans < y[i, j]) then
      begin
        ans:= y[i, j];
        ai:= i;
        aj:= j;
        break;
      end;

    j:= m;
    for i:= n div 2 - 5 to n div 2 + 15 do
      if (y[i, j] < 100) and (ans < y[i, j]) then
      begin
        ans:= y[i, j];
        ai:= i;
        aj:= j;
        break;
      end;
    if ans > 10 then
    begin
      ai:= 0;
      aj:= 0;
    end;
  end;
  
  if ai = 0 then
  begin
    greedy;
    exit;
  end;
  i:= ai;
  j:= aj;
  while y[i, j] <> 0 do
  begin
    ai:= yp[i, j].x;
    aj:= yp[i, j].y;
    if y[ai, aj] = 0 then
    begin
      ansc:= d[i, j];
      exit;
    end;
    i:= ai;
    j:= aj;
  end;
end;

procedure readdata;
var
  i, j : int;
  ch : char;
begin
  fillchar(d, sizeof(d), gc);
  for i:= 1 to n do
  begin
    for j:= 1 to m do
    begin
      read(ch);
      d[i, j]:= ord(ch) - ord('0');
    end;
    readln;
  end;
end;

begin
  reset(input, cinfile);
  rewrite(output, coutfile);
  readdata;
  solve;
  writeln(ansc);
  outdata;
  close(input);
  close(output);
end.
