{$R+,Q+,S+}
{$APPTYPE CONSOLE}
{$MINSTACKSIZE 30000000}
Uses Math;
Type
  Integer=LongInt;

Const
  TaskID='divide';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxLen=60000;
  Base=10000;
  MaxDigits=60000;
  Pow10:Array[0..3]Of Integer=(1,10,100,1000);

Type
  TLong=Record
    Len:Integer;
    Data:Array[0..MaxLen]Of Integer;
  End;
  TFraction=Record
    Num,Den:TLong;
  End;

Var
  SA,SB:String;
  A,B:TFraction;
  R:TFraction;
  Tmp3,Tmp2,Tmp:TLong;
  Digits:Array[1..MaxDigits]Of Integer;

Procedure LZero(Var L:TLong);
Begin
  FillChar(L,SizeOf(L),0);
End;

Procedure LOne(Var L:TLong);
Begin
  LZero(L);
  L.Len:=1;
  L.Data[0]:=1;
End;

Procedure LIncS(Var A:TLong; B:Integer);
Var
  I,P:Integer;
Begin
  P:=B;
  I:=0;
  While P>0 Do Begin
    If A.Len<=I Then A.Len:=I+1;
    Inc(P,A.Data[I]);
    A.Data[I]:=P Mod Base;
    P:=P Div Base;
  End;
End;

Function LCmp(Var A:TLong; Var B:TLong; Shift:Integer):Integer;
Var
  I:Integer;
Begin
  If A.Len>B.Len+Shift Then LCmp:=1 Else If A.Len<B.Len+Shift Then LCmp:=-1 Else Begin
    For I:=B.Len-1 DownTo 0 Do
      If A.Data[I+Shift]>B.Data[I] Then Begin
        LCmp:=1;
        Exit;
      End Else If A.Data[I+Shift]<B.Data[I] Then Begin
        LCmp:=-1;
        Exit;
      End;
    LCmp:=0;
  End;
End;

Procedure LMulS(Var A:TLong; B:Integer);
Var
  I,P:Integer;
Begin
  P:=0;
  For I:=0 To A.Len-1 Do Begin
    Inc(P,A.Data[I]*B);
    A.Data[I]:=P Mod Base;
    P:=P Div Base;
  End;
  While P>0 Do Begin
    A.Data[A.Len]:=P Mod Base;
    Inc(A.Len);
    P:=P Div Base;
  End;
End;

Procedure LDivS(Var A:TLong; B:Integer);
Var
  I,P:Integer;
Begin
  P:=0;
  For I:=A.Len-1 DownTo 0 Do Begin
    Inc(P,A.Data[I]);
    A.Data[I]:=P Div B;
    P:=(P Mod B)*Base;
  End;
  While (A.Len>0) And (A.Data[A.Len-1]=0) Do Dec(A.Len);
End;

Procedure LInc(Var A:TLong; Var B:TLong);
Var
  I,P:Integer;
Begin
  P:=0;
  If A.Len<B.Len Then A.Len:=B.Len;
  For I:=0 To A.Len-1 Do Begin
    Inc(P,A.Data[I]+B.Data[I]);
    If P>=Base Then Begin
      A.Data[I]:=P-Base;
      P:=1;
    End Else Begin
      A.Data[I]:=P;
      P:=0;
    End;
  End;
  If P>0 Then Begin
    A.Data[A.Len]:=P;
    Inc(A.Len);
  End;
End;

Procedure LDec(Var A:TLong; Var B:TLong; Shift:Integer);
Var
  I,P:Integer;
Begin
  P:=0;
  For I:=Shift To A.Len-1 Do Begin
    Inc(P,A.Data[I]-B.Data[I-Shift]);
    If P<0 Then Begin
      A.Data[I]:=P+Base;
      P:=-1;
    End Else Begin
      A.Data[I]:=P;
      P:=0;
    End;
  End;
  While (A.Len>0) And (A.Data[A.Len-1]=0) Do Dec(A.Len);
End;

Procedure LMul(Var A,B:TLong; Var C:TLong);
Var
  I,J,K,P:Integer;
Begin
  LZero(C);
  C.Len:=A.Len+B.Len+3;
  For I:=0 To A.Len-1 Do Begin
    P:=0;
    K:=I;
    For J:=0 To B.Len-1 Do Begin
      Inc(P,A.Data[I]*B.Data[J]+C.Data[K]);
      C.Data[K]:=P Mod Base;
      P:=P Div Base;
      Inc(K);
    End;
    While P>0 Do Begin
      Inc(P,C.Data[K]);
      C.Data[K]:=P Mod Base;
      P:=P Div Base;
      Inc(K);
    End;
  End;
  While (C.Len>0) And (C.Data[C.Len-1]=0) Do Dec(C.Len);
End;

Procedure LMod(Var A:TLong; Var B:TLong; Var Q:TLong);
Var
  P2,Shift:Integer;
Begin
  LZero(Q);
  Q.Len:=A.Len-B.Len+1;
  If Q.Len<0 Then Q.Len:=0;
  For Shift:=A.Len-B.Len DownTo 0 Do Begin
    P2:=1;
    While P2*2<=Base Do Begin
      P2:=P2*2;
      LMulS(B,2);
    End;
    While True Do Begin
      If LCmp(A,B,Shift)>=0 Then Begin
        LDec(A,B,Shift);
        Inc(Q.Data[Shift],P2);
      End;
      If P2=1 Then Break Else Begin
        P2:=P2 Div 2;
        LDivS(B,2);
      End;
    End;
  End;
  While (Q.Len>0) And (Q.Data[Q.Len-1]=0) Do Dec(Q.Len);
End;

Procedure LGCD(A,B:TLong; Var C:TLong);
Var
  I,P2:Integer;
Begin
  P2:=0;
  While (A.Len>0) And Not Odd(A.Data[0]) And (B.Len>0) And Not Odd(B.Data[0]) Do Begin
    Inc(P2);
    LDivS(A,2);
    LDivS(B,2);
  End;
  While (A.Len>0) And (B.Len>0) Do Begin
    If Not Odd(A.Data[0]) Then Begin
      LDivS(A,2);
    End Else If Not Odd(B.Data[0]) Then Begin
      LDivS(B,2);
    End Else Begin
      If LCmp(A,B,0)>=0 Then LDec(A,B,0) Else LDec(B,A,0);
    End;
  End;
  If A.Len=0 Then C:=B Else C:=A;
  For I:=1 To P2 Do LMulS(C,2);
End;

Procedure LWrite(Var A:TLong);
Var
  I:Integer;
Begin
  If A.Len=0 Then Write(0) Else Begin
    Write(A.Data[A.Len-1]);
    For I:=A.Len-2 DownTo 0 Do Begin
      If A.Data[I]<1000 Then Write('0');
      If A.Data[I]<100 Then Write('0');
      If A.Data[I]<10 Then Write('0');
      Write(A.Data[I]);
    End;
  End;
End;

Function LGetLen(Var A:TLong):Integer;
Var
  Len,I:Integer;
Begin
  If A.Len=0 Then Len:=0 Else Begin
    Len:=4*(A.Len-1)+1;
    If A.Data[A.Len-1]>=1000 Then Inc(Len);
    If A.Data[A.Len-1]>=100 Then Inc(Len);
    If A.Data[A.Len-1]>=10 Then Inc(Len);
  End;
  LGetLen:=Len;
End;

Procedure ParseFraction(S:String; Var X:TFraction);
Var
  FracShift:Integer;
  PrePeriod,Period:String;
  I:Integer;
Begin
  If Pos('.',S)=0 Then S:=S+'.';
  If Pos('(',S)=0 Then S:=S+'(0)';
  FracShift:=Pos('(',S)-Pos('.',S)-1;
  Delete(S,Pos('.',S),1);
  Period:=Copy(S,Pos('(',S)+1,Pos(')',S)-Pos('(',S)-1);
  PrePeriod:=Copy(S,1,Pos('(',S)-1);
  LZero(Tmp);
  For I:=1 To Length(PrePeriod) Do Begin
    LMulS(Tmp,10);
    LIncS(Tmp,Ord(PrePeriod[I])-Ord('0'));
  End;
  X.Num:=Tmp;
  For I:=1 To Length(Period) Do LMulS(X.Num,10);
  LDec(X.Num,Tmp,0);
  LZero(Tmp);
  For I:=1 To Length(Period) Do Begin
    LMulS(Tmp,10);
    LIncS(Tmp,Ord(Period[I])-Ord('0'));
  End;
  LInc(X.Num,Tmp);
  LZero(X.Den);
  For I:=1 To Length(Period) Do Begin
    LMulS(X.Den,10);
    LIncS(X.Den,9);
  End;
  For I:=1 To FracShift Do LMulS(X.Den,10);
End;

Procedure WriteDecimal(Var A:TFraction);
Var
  IntLen,PerLen,TotLen,I,P2,P5,P10,N9:Integer;
Begin
  P2:=0;
  While Not Odd(A.Den.Data[0]) Do Begin
    Inc(P2);
    LDivS(A.Den,2);
  End;
  P5:=0;
  While (A.Den.Data[0] Mod 5=0) Do Begin
    Inc(P5);
    LDivS(A.Den,5);
  End;
  P10:=Max(P2,P5);
  For I:=P2+1 To P10 Do LMulS(A.Num,2);
  For I:=P5+1 To P10 Do LMulS(A.Num,5);
  LZero(Tmp);
  N9:=0;
  Repeat
    Inc(N9);
    LMulS(Tmp,10);
    LIncS(Tmp,9);
    While LCmp(Tmp,A.Den,0)>=0 Do
      LDec(Tmp,A.Den,0);
  Until Tmp.Len=0;
  LZero(Tmp);
  Tmp.Len:=(N9+3) Div 4;
  For I:=0 To Tmp.Len-2 Do Tmp.Data[I]:=9999;
  Case N9 Mod 4 Of
    0:Tmp.Data[Tmp.Len-1]:=9999;
    1:Tmp.Data[Tmp.Len-1]:=9;
    2:Tmp.Data[Tmp.Len-1]:=99;
    3:Tmp.Data[Tmp.Len-1]:=999;
  End;
  LMod(A.Num,A.Den,Tmp2);
  LMod(Tmp,A.Den,Tmp3);
  LMul(Tmp3,A.Num,Tmp);
  IntLen:=LGetLen(Tmp2)-P10;
  If IntLen<1 Then IntLen:=1;
  PerLen:=N9;
  TotLen:=P10+IntLen+PerLen;
  For I:=1 To TotLen-PerLen Do
    Digits[I]:=Tmp2.Data[(TotLen-PerLen-I) Div 4] Div Pow10[(TotLen-PerLen-I) Mod 4] Mod 10;
  For I:=TotLen-PerLen+1 To TotLen Do
    Digits[I]:=Tmp.Data[(TotLen-I) Div 4] Div Pow10[(TotLen-I) Mod 4] Mod 10;
  If (PerLen=1) And (Digits[TotLen]=0) Then Begin
    Dec(PerLen);
    Dec(TotLen);
  End;
  If PerLen>0 Then Begin
    While (IntLen+PerLen<TotLen) And (Digits[TotLen]=Digits[TotLen-PerLen]) Do Begin
      Dec(TotLen);
    End;
  End Else While (IntLen<TotLen) And (Digits[TotLen]=0) Do Dec(TotLen);
  For I:=1 To IntLen Do Write(Digits[I]);
  If IntLen<TotLen Then Write('.');
  For I:=IntLen+1 To TotLen-PerLen Do Write(Digits[I]);
  If PerLen>0 Then Begin
    Write('(');
    For I:=TotLen-PerLen+1 To TotLen Do Write(Digits[I]);
    Write(')');
  End;
  WriteLn;
End;

Begin
  Assign(Input,InFile);
  ReSet(Input);
  Assign(Output,OutFile);
  ReWrite(Output);
  ReadLn(SA);
  ReadLn(SB);
  ParseFraction(SA,A);
  ParseFraction(SB,B);
  LMul(A.Num,B.Den,R.Num);
  LMul(A.Den,B.Num,R.Den);
  LGCD(R.Num,R.Den,Tmp);
  LMod(R.Num,Tmp,Tmp2);
  R.Num:=Tmp2;
  LMod(R.Den,Tmp,Tmp2);
  R.Den:=Tmp2;
  WriteDecimal(R);
  Close(Input);
  Close(Output);
End.
