{$D+,L+,I+,Q+,R+,S+}
{$APPTYPE CONSOLE}
Program glass_alx;
Uses SysUtils;
const
  inpfile='glass.in';
  outfile='glass.out'; 
  eps=1e-10;
  eps2=1e-5;
  nm=205;
type
  Coord = record
    x,y : Extended;
  end;
var
  a : array [1..nm] of Coord;
  n : LongInt;
  r,dx,dy : Extended;
  o,q : Coord;
{}
Function Len(var q,w : Coord) : Extended;
begin
  Len:=sqrt(sqr(q.x-w.x)+sqr(q.y-w.y));
end;
{}
Procedure Inp;
var
  i : LongInt;
  l : extended;
begin
  assign(input,inpfile);
  reset(input);
  read(r,n);
  assert((1.0-eps2<r) and (r-eps2<100.0));
  assert((2<=n) and (n<=200));
  for i:=1 to n do begin
    read(a[i].x,a[i].y);
    if (i>1) and (i<n) then
      assert(Len(o,a[i])+eps2<r);
  end;
  assert((abs(Len(a[1],o)-r)<eps2) and (abs(Len(a[n],o)-r)<eps2));  
end;
{}
Procedure Out(ok : Boolean);
begin
  assign(output,outfile);
  rewrite(output);
  if ok then writeln(q.x:0:10,' ',q.y:0:10,' ',dx:0:10,' ',dy:0:10)
        else writeln(-1);
  close(output);
  halt;
end;
{}
Procedure Init;
begin
  o.x:=0; o.y:=0;
  fillchar(a,sizeof(a),0);
end;
{}
Function Vc(var p1,p2,p3,p4 : Coord) : Extended;
begin
  Vc:=(p2.x-p1.x)*(p4.y-p3.y)-(p2.y-p1.y)*(p4.x-p3.x);
end;
{}
Function Sc(var p1,p2,p3,p4 : Coord) : Extended;
begin
  Sc:=(p2.x-p1.x)*(p4.x-p3.x)+(p2.y-p1.y)*(p4.y-p3.y);
end;
{}
Function InAngle(q,o,p1,p2 : Coord) : Boolean;
begin
  InAngle:=false;
  if Vc(o,p1,o,q)*Vc(o,p2,o,q)>eps then exit;
  if Vc(o,p1,o,p2)*Vc(o,q,o,p2)<-eps then exit;
  if Vc(o,p2,o,p1)*Vc(o,q,o,p1)<-eps then exit;
  InAngle:=true;
end;
{}
Function Eq(var q,w : Coord) : Boolean;
begin
  if (abs(q.x-w.x)<eps2) and (abs(q.y-w.y)<eps2) then Eq:=true
                                                 else Eq:=false;
end;
{}
Function Cross(var p1,p2,p3,p4 : Coord) : Boolean;
begin
  Cross:=false;
  if (Vc(p1,p2,p1,p3)*Vc(p1,p2,p1,p4)<-eps2)
  and (Vc(p3,p4,p3,p1)*Vc(p3,p4,p3,p2)<-eps2) then Cross:=true;

  if Eq(p1,p3) or Eq(p1,p4) or Eq(p2,p3) or Eq(p2,p4) then Cross:=true;
end;
{}
Procedure Solve;
var
  i,j : LongInt;
  d : Extended;
  p : Coord;
  ok : Boolean;
begin
  for i:=1 to n do
    for j:=1 to n-1 do
      assert((Sc(a[i],a[j],a[i],a[j+1])>-eps2) or (abs(Vc(a[j],a[j+1],a[j],a[i]))>eps2));

  for i:=1 to n-3 do
    for j:=i+2 to n-1 do
      assert(not Cross(a[i],a[i+1],a[j],a[j+1]),'Selfcrossing way');


  q.x:=(a[1].x+a[n].x)/2;
  q.y:=(a[1].y+a[n].y)/2;
  if abs(Vc(a[1],q,a[1],a[n]))<eps then begin
    q.x:=a[n].y-a[1].y;
    q.y:=a[1].x-a[n].x;
  end;

  d:=Len(o,q)+eps2;
  q.x:=q.x*r/d;
  q.y:=q.y*r/d;

  for i:=1 to n-1 do begin
    dx:=a[i+1].x-a[i].x;
    dy:=a[i+1].y-a[i].y;
    p.x:=o.x+dx;
    p.y:=o.y+dy;
    if not (InAngle(p,o,q,a[1]) or InAngle(p,o,a[n],q)) then begin
      dx:=-dx;
      dy:=-dy;
    end;

    ok:=true;
    for j:=1 to n-2 do begin
      if Vc(a[j],a[j+1],a[j+1],a[j+2])>-eps then begin
        p.x:=a[j+1].x-dx;
        p.y:=a[j+1].y-dy;
      end else begin
        p.x:=a[j+1].x+dx;
        p.y:=a[j+1].y+dy;
      end;

      if not InAngle(p,a[j+1],a[j],a[j+2]) then begin
        ok:=false;
        break;
      end;  
    end;

    if ok then Out(true);
  end;
end;
{}
Begin
  Init;
  Inp;
  Solve;
  Out(false);
End.
