import java.util.*;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.PrintWriter;

public class chat_as {
    int n;

    public class Person implements Comparable<Person> {
        int[] sees;
        int ind;
        int sum;

        public Person(int ind, int n, String s) {
            this.ind = ind;
            sees = new int[n];
            StringTokenizer st = new StringTokenizer(s);
            for (int i = 0; i < n; i++) {
                sees[i] = Integer.parseInt(st.nextToken());
            }
        }

        public void initSum(int my) {
            sees[ind] = my;
            for (int i = 0; i < sees.length; i++) {
                sum += sees[i];
            }
        }

        public int compareTo(Person o) {
            if (sum != o.sum) {
                return sum - o.sum;
            } else {
                return ind - o.ind;
            }
        }
    }

    public int[] leaveOrder(String[] numSeen) {
        n = numSeen.length;
        Person[] p = new Person[n];
        for (int i = 0; i < n; i++) {
            p[i] = new Person(i, n, numSeen[i]);
        }

        for (int i = 0; i < n; i++) {
            int max = 0;
            for (int j = 0; j < n; j++) {
                if (p[j].sees[i] > max) {
                    max = p[j].sees[i];
                }
            }
            p[i].initSum(max);
        }

        Arrays.sort(p);

        int[] sub = new int[n];
        for (int i = 0; i < n; i ++) {
            int k = p[i].ind;
            for (int j = i + 1; j < n; j ++) {
                if (p[j].sees[k] != p[i].sees[k]) {
                    return new int[]{};
                }
            }
            for (int j = 0; j < n; j++) {
                if (p[i].sees[j] < sub[j]) {
                    return new int[]{};
                }
                sub[j] = p[i].sees[j];
            }
        }

        int[] a = new int[n];
        for (int i = 0; i < n; i++) {
            a[i] = p[i].ind;
        }
        return a;
    }


    public static void main(String[] args) throws FileNotFoundException {
        chat_as chat = new chat_as();
        Scanner sc = new Scanner(new FileInputStream("chat.in"));
        PrintWriter pw = new PrintWriter("chat.out");
    	while (sc.hasNext()) {
            int n = sc.nextInt();
            if (n == 0) {
                break;
            }
            sc.skip("\\s*");
            String[] s = new String[n];
            for (int i = 0; i < n; i++) {
                s[i] = sc.nextLine();
            }
            int[] ans = chat.leaveOrder(s);
            if (ans.length == 0) {
                pw.println(-1);
            } else {
                for (int i = 0; i < n; i++) {
                    pw.print((ans[i] + 1) + (i == n - 1 ? "\n" : " "));
                }
            }
        }
        pw.close();
        sc.close();
    }
}
