{$O-,R+,S+,Q+}
Program Poet;

Type
  Integer=LongInt;

Const
  TaskID='rhyme';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=50;
  MaxK=50;
  MaxM=1000;
  MaxV=MaxN+2*MaxN*MaxK;
  MaxEdge=2*(MaxM+2*MaxN*MaxK);

Type
  TEdge=Record
    Dest:Integer;
    Cap,Flow:Integer;
    Rev:Integer;
    Next:Integer;
  End;

Var
  S,T,N,K:Integer;
  NEdge:Integer;
  Edge:Array[1..MaxEdge]Of TEdge;
  First:Array[1..MaxV]Of Integer;
  Mark:Array[1..MaxV]Of Boolean;
  Res:Integer;

Procedure AddEdge(X,Y:Integer);
Begin
  Inc(NEdge);
  With Edge[NEdge] Do Begin
    Dest:=Y;
    Cap:=1;
    Flow:=0;
    Rev:=NEdge+1;
    Next:=First[X];
    First[X]:=NEdge;
  End;
  Inc(NEdge);
  With Edge[NEdge] Do Begin
    Dest:=X;
    Cap:=0;
    Flow:=0;
    Rev:=NEdge-1;
    Next:=First[Y];
    First[Y]:=NEdge;
  End;
End;

Procedure Load;
Var
  I,J,A,B,C,M:Integer;
Begin
  Assign(Input,InFile);
  ReSet(Input);
  Read(N,K,S,T);
  Assert((N>=1) And (N<=MaxN) And (K>=1) And (K<=MaxK) And (S>=1) And (S<=N) And (T>=1) And (T<=N) And (S<>T));
  NEdge:=0;
  For I:=1 To N Do 
    For J:=1 To K Do Begin
      AddEdge(N+(I-1)*K+J,I);
      AddEdge(I,N+N*K+(I-1)*K+J);
    End;
  Read(M);
  Assert((M>=1) And (M<=MaxM));
  For I:=1 To M Do Begin
    Read(A,B,C);
    Assert((A>=1) And (A<=N) And (B>=1) And (B<=N) And (A<>B) And (C>=1) And (C<=K));
    AddEdge(N+N*K+(A-1)*K+C,N+(B-1)*K+C);
  End;
  Close(Input);
End;

Procedure Solve;
Function DFS(At:Integer):Boolean;
Var
  I:Integer;
Begin
  If Mark[At] Then Begin
    DFS:=False;
    Exit;
  End;
  Mark[At]:=True;
  If At=T Then Begin
    DFS:=True;
    Exit;
  End;
  I:=First[At];
  While I>0 Do With Edge[I] Do Begin
    If (Flow<Cap) And DFS(Dest) Then Begin
      Inc(Flow);
      //Dec(Edge[Rev].Flow);
      DFS:=True;
      Exit;
    End;
    I:=Next;
  End;
  DFS:=False;
End;
Begin
  Res:=0;
  While True Do Begin
    FillChar(Mark,SizeOf(Mark),False);
    If DFS(S) Then Inc(Res) Else Break;
  End;
End;

Procedure WriteSomePath(At:Integer);
Var
  I:Integer;
Begin
  If At=T Then Begin
    Write(T);
    Exit;
  End;
  If At<=N Then Write(At,' ') Else If At<=N+N*K Then Write((At-N-1) Mod K+1,' ');
  I:=First[At];
  While True Do With Edge[I] Do Begin
    If Flow>0 Then Begin
      Dec(Flow);
      WriteSomePath(Dest);
      Break;
    End;
    I:=Next;    
  End;
End;

Procedure Save;
Var
  Step:Integer;
Begin
  Assign(Output,OutFile);
  ReWrite(Output);
  WriteLn(Res);
  For Step:=1 To Res Do Begin
    WriteSomePath(S);
    WriteLn;
  End;
  Close(Output);
End;

Begin
  Load;
  Solve;
  Save;
End.
