{$O-,R+,Q+}
program antiufo;

const
    maxn = 50000;
    eps = 1e-8;

var
    i, j, k: longint;
    x, y, ind: array [0..maxn] of longint;
    n: longint;
    dc, ds: array [0..maxn] of extended;
    c, s: extended;
    pl, l: extended;
    py: longint;
    ar: extended;
    ps, ns: extended;
    qa, qb, qc: extended;
    cuty: extended;

procedure sort(l, r: longint);
var
    i, j: longint;
    v, t: longint;
begin
    i := l;
    j := r;
    v := y[ind[l + random(r - l + 1)]];
    while i < j do begin
        while y[ind[i]] < v do inc(i);
        while v < y[ind[j]] do dec(j);
        if i <= j then begin
            t := ind[i]; ind[i] := ind[j]; ind[j] := t;
            inc(i);
            dec(j);
        end;
    end;
    if l < j then sort(l, j);
    if i < r then sort(i, r);
end;

begin
    reset(input, 'antiufo.in');
    rewrite(output, 'antiufo.out');

    read(n, k);
    for i := n downto 1 do begin
        read(x[i], y[i]);
        ind[i] := i;
    end;
    x[0] := x[n];
    y[0] := y[n];

    ar := 0;
    for i := 1 to n do
        ar := ar + (x[i] + x[i - 1]) * (y[i] - y[i - 1]);
    ar := ar / (2 * (k + 1));

    for i := 1 to n do begin
        if y[i] <> y[i - 1] then begin
            c := (x[i] - x[i - 1]) / (y[i] - y[i - 1]);
            dc[i - 1] := dc[i - 1] + c;
            dc[i] := dc[i] - c;
        end else begin
            ds[i] := x[i] - x[i - 1];
        end;
    end;

    dc[n] := dc[n] + dc[0];
    ds[n] := ds[n] + ds[0];

    sort(1, n);

    py := y[ind[1]];
    pl := 0;
    ps := 0;
    c := 0;
    s := 0;
    ns := ar;

    for i := 1 to n do begin
        j := ind[i];
        l := pl + (y[j] - py) * c;

        s := s + (l + pl) * (y[j] - py) / 2;

        while (s > ns) and (k > 0) do begin
            if (abs(c) < eps) then begin
                cuty := py + (ns - ps) / pl;
            end else begin
                qa := c / 2;
                qb := pl;
                qc := ps - ns;
                cuty := py + (-pl + sqrt(qb * qb - 4 * qa * qc)) / (2 * qa);
                if (cuty < py - eps) or (cuty > y[j] + eps) then begin
                    cuty := py + (-pl - sqrt(qb * qb - 4 * qa * qc)) / (2 * qa);
                end;
            end;
            writeln(cuty :0 :4);

            ns := ns + ar;
            dec(k);
        end;

        c := c + dc[j];
        l := l + ds[j];

        //writeln(x[j], ' ', y[j], ' ', s :0 :2);

        pl := l;
        py := y[j];
        ps := s;
    end;

    close(input);
    close(output);
end.