#include <iostream>
#include <vector>
#include <map>
#include <set>
#include <cmath>
#include <algorithm>
#include <cassert>
#include <cstdio>
#include <iomanip>

using namespace std;

#define forn(i, n) for (int i = 0; i < (n); i++)

#define INFILE "king.in"
#define OUTFILE "king.out"

#define NMAX (2005)
#define INF (4294967196)

int n;

typedef struct point
{
    int x, y;
    point(int x = 0, int y = 0) : x(x), y(y) {};
} point;

point A[NMAX];
point s, t;

point V[NMAX];
unsigned int D[NMAX][NMAX];
int used[NMAX];
long long d[NMAX];

int sign(int a)
{
    if (a == 0)
        return 0;
    if (a < 0)
        return -1;
    else
        return +1;
}

bool lay(point mid, point a, point b)
{
    if (mid.x < min(a.x, b.x))
        return false;
    if (mid.y < min(a.y, b.y))
        return false;
    if (mid.x > max(a.x, b.x))
        return false;
    if (mid.y > max(a.y, b.y))
        return false;

    long long dx = a.x - b.x;
    long long dy = a.y - b.y;

    long long rx = mid.x - b.x;
    long long ry = mid.y - b.y;

    return (dx * ry - dy * rx == 0);
}

bool free(point a, point b)
{
    forn(i, n)
        if (lay(A[i], a, b))
            return false;
    return true;
}

int solve()
{
    int k = 0;
    V[k++] = s;
    forn(i, n)
    {
        V[k++] = point(A[i].x + 1, A[i].y);
        V[k++] = point(A[i].x, A[i].y + 1);
        V[k++] = point(A[i].x - 1, A[i].y);
        V[k++] = point(A[i].x, A[i].y - 1);
    }
    V[k++] = t;

    forn(i, k)
        forn(j, k)
            D[i][j] = INF;

    forn(i, k)
        forn(j, k)
            if (i == j || (V[i].x == V[j].x && V[i].y == V[j].y))
                D[i][j] = 0;
            else
            {
                if (V[i].x == V[j].x || V[i].y == V[j].y)
                {
                    if (free(V[i], V[j]))
                        D[i][j] = max(abs(V[i].x - V[j].x), abs(V[i].y - V[j].y));
                }
                else
                {
                    int d = min(abs(V[i].x - V[j].x), abs(V[i].y - V[j].y));
                    assert(d > 0);
                    point mid(V[i].x - sign(V[i].x - V[j].x) * d,
                         V[i].y - sign(V[i].y - V[j].y) * d);
                    if (free(V[i], mid) && free(mid, V[j]))
                        D[i][j] = max(abs(V[i].x - mid.x), abs(V[i].y - mid.y)) +
                            max(abs(mid.x - V[j].x), abs(mid.y - V[j].y));
                }
            }

    const int MAX = 2147483641;

    memset(used, 0, sizeof(used));
    forn(i, k)
        d[i] = MAX;
    d[0] = 0;

    for(;;)
    {
        int pmin = -1;
        long long vmin = INF;
        forn(i, k)
            if (!used[i] && d[i] < vmin)
                vmin = d[i], pmin = i;
        if (pmin < 0 || vmin > INF / 2)
            break;
        used[pmin] = true;
        forn(i, k)
            if (d[i] > d[pmin] + D[pmin][i])
                d[i] = d[pmin] + D[pmin][i];
    }

    return d[k - 1] < MAX ? d[k - 1] : -1;
}

int main()
{
    freopen(INFILE, "rt", stdin);
    freopen(OUTFILE, "wt", stdout);

    cin >> s.x >> s.y;
    cin >> t.x >> t.y;
    cin >> n;
    forn(i, n)
        cin >> A[i].x >> A[i].y;

    int ans = solve();

    cout << ans << endl;

    fclose(stdin);
    fclose(stdout);
    return 0;
}
