{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='tractor';
  fin =problem+'.in';
  fout=problem+'.out';

type
  point=record
    x,y:extended;
  end;
  line=record
    a,b,c:extended;
  end;

var
  i,j,k,l,n,m:longint;
  u,v:extended;
  z:array[0..60]of point;
  a:array[0..60,0..60]of extended;

procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n);
    read(u,v);
    inc(n);
    for i:=1 to n do
      read(z[i].x,z[i].y);

  close(input);
end;

function dist(a,b:point):extended;
begin
  dist:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y));
end;

procedure makeline(a,b:point;var l:line);
begin
  l.a:=b.y-a.y;
  l.b:=a.x-b.x;
  l.c:=-l.a*a.x-l.b*a.y;
end;

procedure intersect(l1,l2:line;var p:point);
var
  d:extended;
begin
  d:=l2.a*l1.b-l1.a*l2.b;
  if abs(d)<1e-8 then begin
    p.x:=0;
    p.y:=0;
    exit;
  end;
  p.y:=(l1.a*l2.c-l1.c*l2.a)/d;
  p.x:=(l2.b*l1.c-l2.c*l1.b)/d;
end;

function makeh(l:line;p:point;var a:line;var b:point):extended;
begin
  a.a:=-l.b;
  a.b:=l.a;
  a.c:=-a.a*p.x-a.b*p.y;
  intersect(l,a,b);
  makeh:=dist(b,p);
end;

function pointv(l:line;p:point):extended;
begin
  pointv:=l.a*p.x+l.b*p.y+l.c;
end;

procedure solve;
var
  l1,l2,l3,l4:line;
  p,p1,p2,p3:point;
  x,c,h:extended;
begin
  for i:=1 to n do
    for j:=1 to n do
      a[i,j]:=1e100;
  for i:=1 to n do
    a[i,i+1]:=dist(z[i],z[i+1])/v;
  c:=(u/v)/sqrt(1-sqr(u/v));
  for l:=2 to n do
    for i:=1 to n-l+1 do begin
      for j:=i+1 to i+l-1 do
        if a[i,i+l]>a[i,j]+a[j,i+l] then
          a[i,i+l]:=a[i,j]+a[j,i+l];
      if a[i,i+l]>dist(z[i],z[i+l])/u then
        a[i,i+l]:=dist(z[i],z[i+l])/u;

      repeat

        makeline(z[i],z[i+1],l1);
        h:=makeh(l1,z[i+l],l2,p);
        if (dist(p,z[i])>dist(p,z[i+1]))or
          (pointv(l2,z[i])*pointv(l2,z[i+1])<1e-8) then
          if dist(z[i],p)>h*c then begin
            if (pointv(l2,z[i])*pointv(l2,z[i+1])>1e-8)and(dist(z[i+1],p)>h*c) then
              break;
            if a[i,i+l]>(dist(z[i],p)-h*c)/v + sqrt(sqr(h)+sqr(h*c))/u then
              a[i,i+l]:=(dist(z[i],p)-h*c)/v + sqrt(sqr(h)+sqr(h*c))/u{}
          end;

      until true;

      repeat

        makeline(z[i+l-1],z[i+l],l1);
        h:=makeh(l1,z[i],l2,p);
        if (dist(p,z[i+l])>dist(p,z[i+l-1]))or
          (pointv(l2,z[i+l])*pointv(l2,z[i+l-1])<1e-8) then
          if dist(z[i+l],p)>h*c then begin
            if (pointv(l2,z[i+l])*pointv(l2,z[i+l-1])>1e-8)and(dist(z[i+l-1],p)>h*c) then
              break;
            if a[i,i+l]>(dist(z[i+l],p)-h*c)/v + sqrt(sqr(h)+sqr(h*c))/u then
              a[i,i+l]:=(dist(z[i+l],p)-h*c)/v + sqrt(sqr(h)+sqr(h*c))/u;
          end;

      until true;
    end;
end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    write(a[1,n]:0:8);

  close(output);
end;

begin
  init;
  solve;
  done;
end.
