{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
const
  problem='fire';
  fin =problem+'.in';
  fout=problem+'.out';

type
  point=record
    x,y:extended;
  end;
  line=record
    a,b,c:extended;
  end;

var
  i,j,k,l,n,m:longint;
  a,b:array[0..500]of point;
  ans:extended;
  pans:point;


procedure init;
begin
  assign(input,fin);
  reset(input);

    read(n);
    for i:=1 to n do
      read(a[i].x,a[i].y);
    a[n+1]:=a[1];
    a[n+2]:=a[2];
    read(k);
    for i:=1 to k do
      read(b[i].x,b[i].y);

  close(input);
end;

function dist(a,b:point):extended;
begin
  dist:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y));
end;

function sgn(x:extended):longint;
begin
  if x<-1e-10 then
    sgn:=-1
  else if x>1e-10 then
    sgn:=1
  else
    sgn:=0;
end;

function vectorx(a,b,c:point):extended;
begin
  vectorx:=
  (b.x-a.x)*(c.y-a.y)-(c.x-a.x)*(b.y-a.y);
end;

function checkpoint(p:point;checkin:boolean):boolean;
var
  i:longint;
  min:extended;
begin
  min:=1e1000;
  checkpoint:=false;
  if checkin then
    for i:=1 to n do
      if sgn(vectorx(a[i],p,a[i+1]))<>sgn(vectorx(a[i+1],p,a[i+2])) then
        exit;
  for i:=1 to k do
    if dist(p,b[i])<min then
      min:=dist(p,b[i]);
  if min>ans then begin
    checkpoint:=true;
    ans:=min;
    pans:=p;
  end;
end;

procedure buildcenter(a,b,c:point;var p:point);
var
  la,lb:line;
  d:extended;
begin
  la.a:=b.x-c.x;
  la.b:=b.y-c.y;
  la.c:=-la.a*((b.x+c.x)/2)-la.b*((b.y+c.y)/2);
  lb.a:=a.x-c.x;
  lb.b:=a.y-c.y;
  lb.c:=-lb.a*((a.x+c.x)/2)-lb.b*((a.y+c.y)/2);
  d:=lb.a*la.b-la.a*lb.b;
  if abs(d)<1e-8 then begin
    p.x:=0;
    p.y:=0;
    exit;
  end;
  p.y:=(la.a*lb.c-la.c*lb.a)/d;
  p.x:=(lb.b*la.c-lb.c*la.b)/d;
end;

function getangle(a,b,c:point):extended;
begin
  if (dist(a,b)<>0) and (dist(b,c)<>0) then
    getangle:=
      ((b.x-a.x)*(b.x-c.x)+(b.y-a.y)*(b.y-c.y))/(dist(a,b)*dist(b,c))
  else
    getangle:=1e101;
end;

procedure solve;
var
  ang:extended;
  l1,l2:line;
  p,q:point;
  d:extended;
begin
  ans:=-1e100;
  for i:=1 to n do
    checkpoint(a[i],false);
  for i:=1 to k do
    for j:=i+1 to k do begin
      l1.a:=b[i].x-b[j].x;
      l1.b:=b[i].y-b[j].y;
      l1.c:=-l1.a*((b[i].x+b[j].x)/2)-l1.b*((b[i].y+b[j].y)/2);
      for l:=1 to n do
        if sgn(l1.a*a[l].x+l1.b*a[l].y+l1.c)<>sgn(l1.a*a[l+1].x+l1.b*a[l+1].y+l1.c) then begin
          l2.b:=a[l].x-a[l+1].x;
          l2.a:=a[l+1].y-a[l].y;
          l2.c:=-l2.a*(a[l].x)-l2.b*(a[l].y);
          d:=l2.a*l1.b-l1.a*l2.b;
          if abs(d)<1e-8 then
            continue;
          p.y:=(l1.a*l2.c-l1.c*l2.a)/d;
          p.x:=(l2.b*l1.c-l2.c*l1.b)/d;
          checkpoint(p,false);
        end;
      ang:=1e100;
      for l:=1 to k do
        if ang>getangle(b[i],b[l],b[j]) then begin
          q:=b[l];
          ang:=getangle(b[i],b[l],b[j]);
        end;
      buildcenter(b[i],b[j],q,p);
      if checkpoint(p,true) then
        for l:=1 to k do begin
          buildcenter(b[i],b[j],b[l],p);
          checkpoint(p,true);
        end;
  end;

end;

procedure done;
begin
  assign(output,fout);
  rewrite(output);

    write(pans.x:0:6,' ',pans.y:0:6);

  close(output);
end;

begin
  init;
  solve;
  done;
end.
