{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='antiufo.in';
        File_Out='antiufo.out';
        MaxN=50000;
        Eps=1E-10;
  Type Int=LongInt;
//       Real=Extended;
       TPoint=Record X,Y : Real; End;
       TM=Array [1..MaxN+1] Of TPoint;
  Var N,N2,K : Int;
      M,M2 : TM;
      Ans : Array [1..MaxN] Of Real;
      MaxY,MinY : Real;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N,K);
  For I :=1 To N Do
    Read(M[I].X,M[I].Y);
  M[N+1] :=M[1];
End;

Function Less(Const A,B : Real) : Boolean;
Begin
  Less :=A-B<-Eps;
End;

Function More(Const A,B : Real) : Boolean;
Begin
  More :=A-B>Eps;
End;

Function Eq(Const A,B : Real) : Boolean;
Begin
  Eq :=Abs(A-B)<Eps;
End;

Function Vect(Const X1,Y1,X2,Y2 : Real) : Real;
Begin
  Vect :=X1*Y2-Y1*X2;
End;

Function GetS(Const P : TPoint; Const M : TM; Const N : Int) : Real;
  Var I : Int;
      S : real;
Begin
  S :=0;
  For I :=1 To N Do
    S :=S+Vect(M[I].X-P.X,M[I].Y-P.Y,M[I+1].X-P.X,M[I+1].Y-P.Y);
  GetS :=Abs(S);
End;

Function GetNewS(Const Y : Real) : Real;
  Var I : Int;
Begin
  N2 :=0;
  For I :=2 To N+1 Do
    If Not Less(M[I].Y,Y) Then
      Begin
        If Less(M[I-1].Y,Y) Then
          Begin
            Inc(N2);
            M2[N2].Y :=Y;
            M2[N2].X :=M[I-1].X+(M[I].X-M[I-1].X)*(Y-M[I-1].Y)/(M[I].Y-M[I-1].Y);
          End;
        Inc(N2);
        M2[N2] :=M[I];
      End
    Else If More(M[I-1].Y,Y) Then
      Begin
        Inc(N2);
        M2[N2].Y :=Y;
        M2[N2].X :=M[I].X+(M[I-1].X-M[I].X)*(Y-M[I].Y)/(M[I-1].Y-M[I].Y);
      End;
  M2[N2+1] :=M2[1];
  GetNewS :=GetS(M2[1],M2,N2);
End;

Procedure FindY(Const FindS : Real; Var Y : Real);
  Var HelpS,L,R : Real;
Begin
  L :=MinY;
  R :=MaxY;
  While Not (Abs(L-R)<1E-5) Do
    Begin
      HelpS :=GetNewS((L+R)/2);
      If More(HelpS,FindS) Then L :=(L+R)/2
      Else R :=(L+R)/2;
    End;
  Y :=(L+R)/2;
End;

Procedure Solve;
  Var I : Int;
      S0 : Real;
Begin
  MinY :=M[1].Y;
  MaxY :=M[1].Y;
  For I :=2 To N Do
    If MinY>M[I].Y Then MinY :=M[I].Y
    Else If MaxY<M[I].Y Then MaxY :=M[I].Y;
  S0 :=GetS(M[1],M,N);
  For I :=1 To K Do
    Begin
      FindY(S0*I/(K+1),Ans[I]);
      MaxY :=Ans[I];
    End;
  For I :=K DownTo 1 Do
    WriteLn(Ans[I]:0:6);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
