{$A+,B-,D-,E+,F-,G-,I+,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='popular.in';
        File_Out='popular.out';
        MaxN=5001;
        Eps=1E-10;
  Type Int=LongInt;
       Real=Extended;
       TPoint=Record X,Y : Real; End;
  Var N : Int;
      X,L : Array [1..MaxN] Of Real;
      Answer : TPoint;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  For I :=1 To N Do
    Read(X[I],L[I]);
End;

Function Eq(Const A,B : Real) : Boolean;
Begin
  Eq :=Abs(A-B)<Eps;
End;

Function More(Const A,B : Real) : Boolean;
Begin
  More :=A-B>Eps;
End;

Function Less(Const A,B : Real) : Boolean;
Begin
  Less :=A-B<-Eps;
End;

Function LessEq(Const A,B : Real) : Boolean;
Begin
  LessEq :=Less(A,B) Or Eq(A,B);
End;

Function MoreEq(Const A,B : Real) : Boolean;
Begin
  MoreEq :=More(A,B) Or Eq(A,B);
End;

Function Dist(Const X1,Y1,X2,Y2 : Real) : Real;
Begin
  Dist :=Sqrt(Sqr(X1-X2)+Sqr(Y1-Y2));
End;

Function Include(Const I,J : Int) : Boolean;
Begin
  Include :=MoreEq(L[I],Abs(X[J]-X[I])+L[J]);
End;

Procedure Solve;
  Var Ans,I,J,K : Int;
      Cos,Sin : Real;
      Help : TPoint;
      Ok,Find,InOne : Boolean;
Begin
  Find :=False;
  InOne :=True;
  Ans :=1;
  For I :=1 To N Do
    For J :=I+1 To N Do
      Begin
        If Include(I,J) Or Include(J,I) Then
          Begin
            If Less(L[J],L[Ans]) Then Ans :=J;
            Continue;
          End;
        InOne :=False;
        If More(Dist(X[I],0,X[J],0),L[I]+L[J]) Then
          Begin
            WriteLn('-1 -1');
            Exit;
          End;
        Cos :=(Sqr(L[I])+Sqr(L[J])-Sqr(X[I]-X[J]))/(2*L[I]*L[J]);
        Sin :=Sqrt(1-Sqr(Cos));
        Help.Y :=-L[I]*L[J]*Sin/Abs(X[I]-X[J]);
        If Less(X[I],X[J]) Then
          If Less(Sqr(X[I]-X[J])+Sqr(L[I]),Sqr(L[J])) Then
            Help.X :=X[I]-Sqrt(Sqr(L[I])-Sqr(Help.Y))
          Else Help.X :=X[I]+Sqrt(Sqr(L[I])-Sqr(Help.Y))
        Else
          If Less(Sqr(X[J]-X[I])+Sqr(L[J]),Sqr(L[I])) Then
            Help.X :=X[J]-Sqrt(Sqr(L[J])-Sqr(Help.Y))
          Else Help.X :=X[J]+Sqrt(Sqr(L[J])-Sqr(Help.Y));
        Ok :=True;
        For K :=1 To N Do
          If More(Dist(X[K],0,Help.X,Help.Y),L[K]) Then Ok :=False;
        If Ok Then Answer :=Help;
        Find :=Find Or Ok;
      End;
  If Answer.Y=-0 Then Answer.Y :=0;
  If Not Find Then
    If InOne Then WriteLn(X[Ans]:0:4,' ',-L[Ans]:0:4)
    Else WriteLn('-1 -1')
  Else WriteLn(Answer.X:0:4,' ',Answer.Y:0:4);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
