{$A+,B-,D-,E+,F-,G-,I-,L-,N-,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='fire.in';
        File_Out='fire.out';
        Eps=1E-5;
        MaxNK=201;
  Type Int=LongInt;
       TPoint=Record X,Y : Real; End;
       TVect=Record X,Y : Real; End;
       TLine=Record A,B,C : Real End;
  Var N,K : Int;
      M,Fire : Array [1..MaxNK+1] Of TPoint;
      C,L,R,S : Real;
      Answer : TPoint;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  For I :=1 To N Do Read(M[I].X,M[I].Y);
  Read(K);
  For I :=1 To K Do Read(Fire[I].X,Fire[I].Y);
End;

Procedure Swap(Var A,B : Real);
  Var C : Real;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Function Eq(Const A,B : Real) : Boolean;
Begin
  Eq :=Abs(A-B)<Eps;
End;

Function More(Const A,B : Real) : Boolean;
Begin
  More :=A-B>Eps;
End;

Function Less(Const A,B : Real) : Boolean;
Begin
  Less :=A-B<-Eps;
End;

Function Dist(Const A,B : TPoint) : Real;
Begin
  Dist :=Sqrt(Sqr(A.X-B.X)+Sqr(A.Y-B.Y));
End;

Function Dist2(Const A,B : TPoint) : Real;
Begin
  Dist2 :=Sqr(A.X-B.X)+Sqr(A.Y-B.Y);
End;

Procedure GetLine(Const A,B : TPoint; Var L : TLine);
Begin
  L.A :=B.Y-A.Y;
  L.B :=A.X-B.X;
  L.C :=-(A.X*L.A+A.Y*L.B);
End;

Function DistToLine(Const A : TPoint; Const L : TLine) : Real;
Begin
  DistToLine :=Abs(A.X*L.A+A.Y*L.B+L.C)/Sqrt(Sqr(L.A)+Sqr(L.B));
End;

Function Skal(Const X1,Y1,X2,Y2 : Real) : Real;
Begin
  Skal :=X1*X2+Y1*Y2;
End;

Function Vect(Const X1,Y1,X2,Y2 : Real) : Real;
Begin
  Vect :=X1*Y2-Y1*X2;
End;

Function Max(Const A,B : Real) : Real;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Function Min(Const A,B : Real) : real;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

Function SquareT(Const A,B,C : TPoint) : Real;
Begin
  SquareT :=1/2*Abs(Vect(A.X-C.X,A.Y-C.Y,B.X-C.X,B.Y-C.Y));
End;

Function DistToSegm(Const A,B,C : TPoint) : real;
Begin
  If (Skal(A.X-C.X,A.Y-C.Y,B.X-C.X,B.Y-C.Y)>=0) And
     (Skal(A.X-B.X,A.Y-B.Y,C.X-B.X,C.Y-B.Y)>=0) Then
       DistToSegm :=2*SquareT(A,B,C)/Dist(B,C)
  Else
    DistToSegm :=Min(Dist(A,B),Dist(A,C));
End;

Function PointOnSegm(Const A,B,C : TPoint) : Boolean;
Begin
  PointOnSegm :=Eq(Dist(B,C),Dist(A,B)+Dist(A,C));
End;

Procedure GetSquare;
  Var I : Int;
Begin
  S :=0;
  For I :=3 To N Do
    S :=S+SquareT(M[1],M[I],M[I-1]);
End;

Function PointInM(Const P : TPoint) : Boolean;
  Var I : Int;
      HelpS : Real;
Begin
  M[N+1] :=M[1];
  HelpS :=0;
  For I :=1 To N Do
    HelpS :=HelpS+SquareT(P,M[I],M[I+1]);
  PointInM :=Eq(S,HelpS);
End;

Procedure RotateMinus90(Var V : TVect);
Begin
  Swap(V.X,V.Y);
  V.X :=-V.X;
End;

Procedure Rotate90(Var V : TVect);
Begin
  Swap(V.X,V.Y);
  V.Y :=-V.Y;
End;

Function Check(Const P : TPoint; Const R2 : Real) : Boolean;
  Var I : Int;
      Ok : Boolean;
Begin
  For I :=1 To K Do
    If Less(Dist2(P,Fire[I]),R2) Then
      Begin
        Check :=False;
        Exit;
      End;
  Check :=PointInM(P);
End;

Function EqPoints(Const A,B : TPoint) : Boolean;
Begin
  EqPoints :=Eq(A.X,B.X) And Eq(A.Y,B.Y);
End;

Procedure MakeVect(Const A,B : TPoint; Var V : TVect);
Begin
  V.X :=B.X-A.X;
  V.y :=B.Y-A.Y;
End;

Function Ok(Const R : Real) : Boolean;
  Var I,J : Int;
      L,L2,L3,H,R2 : Real;
      Cos,Sin : Real;
      HelpP : TPoint;
      HelpV,V : TVect;
Begin
  R2 :=R*R;
  For I :=1 To K Do
    For J :=I+1 To K Do
      If Not EqPoints(Fire[I],Fire[J]) Then
        If Not More{Less}(Dist2(Fire[I],Fire[J]),4*R2) Then
          Begin
            L :=Dist(Fire[I],Fire[J]);
            Cos :=(2*R2-Dist2(Fire[I],Fire[J]))/(2*R2);
            Sin :=Sqrt(1-Sqr(Cos));
            H :=R2*Sin/L;
            MakeVect(Fire[J],Fire[I],V);
            Rotate90(V);
            V.X :=H/L*V.X;
            V.Y :=H/L*V.Y;
            HelpP.X :=(Fire[I].X+Fire[J].X)/2+V.X;
            HelpP.Y :=(Fire[I].Y+Fire[J].Y)/2+V.Y;
            If Check(HelpP,R2) Then
              Begin
                Answer :=HelpP;
                Ok :=True;
                Exit;
              End;
            HelpP.X :=(Fire[I].X+Fire[J].X)/2-V.X;
            HelpP.Y :=(Fire[I].Y+Fire[J].Y)/2-V.Y;
            If Check(HelpP,R2) Then
              Begin
                Answer :=HelpP;
                Ok :=True;
                Exit;
              End;
          End
        Else
          Begin
            HelpP.X :=(Fire[I].X+Fire[J].X)/2;
            HelpP.Y :=(Fire[I].Y+Fire[J].Y)/2;
            If Check(HelpP,R2) Then
              Begin
                Answer :=HelpP;
                Ok :=True;
                Exit;
              End;
          End;
  For I :=1 To N Do
    For J :=1 To K Do
      If Not More(DistToSegm(Fire[J],M[I],M[I+1]),R) Then
        Begin
          L :=Dist(M[I],M[I+1]);
          L2 :=2*SquareT(Fire[J],M[I],M[I+1])/Dist(M[I],M[I+1]);
          MakeVect(M[I],M[I+1],V);
          HelpV :=V;
          Rotate90(V);
          V.X :=L2/L*V.X;
          V.Y :=L2/L*V.Y;
          L3 :=Sqrt(R2-Sqr(L2));
          HelpV.X :=L3/L*HelpV.X;
          HelpV.Y :=L3/L*HelpV.Y;
          HelpP.X :=Fire[J].X+V.X+HelpV.X;
          HelpP.Y :=Fire[J].Y+V.Y+HelpV.Y;
          If PointOnSegm(HelpP,M[I],M[I+1]) And Check(HelpP,R2) Then
            Begin
              Answer :=HelpP;
              Ok :=True;
              Exit;
            End;
          HelpP.X :=Fire[J].X+V.X-HelpV.X;
          HelpP.Y :=Fire[J].Y+V.Y-HelpV.Y;
          If PointOnSegm(HelpP,M[I],M[I+1]) And Check(HelpP,R2) Then
            Begin
              Answer :=HelpP;
              Ok :=True;
              Exit;
            End;
          HelpP.X :=Fire[J].X-V.X-HelpV.X;
          HelpP.Y :=Fire[J].Y-V.Y-HelpV.Y;
          If PointOnSegm(HelpP,M[I],M[I+1]) And Check(HelpP,R2) Then
            Begin
              Answer :=HelpP;
              Ok :=True;
              Exit;
            End;
          HelpP.X :=Fire[J].X-V.X+HelpV.X;
          HelpP.Y :=Fire[J].Y-V.Y+HelpV.Y;
          If PointOnSegm(HelpP,M[I],M[I+1]) And Check(HelpP,R2) Then
            Begin
              Answer :=HelpP;
              Ok :=True;
              Exit;
            End;
        End;
  Ok :=False;
End;

Procedure Solve;
  Var I,J : Int;
Begin
  GetSquare;
  R :=0;
  L :=0;
  For I :=1 To N Do
    For J :=1 To K Do
      R :=Max(R,Dist(M[I],Fire[J]));
  While Not Eq(R,L) Do
    Begin
      C :=(R+L)/2;
      If Ok(C) Then
        L :=C
      Else R :=C;
    End;
  If Eq(Answer.X,-0) Then Answer.X :=0;
  If Eq(Answer.Y,-0) Then Answer.Y :=0;
  WriteLn(Answer.X:0:4,' ',Answer.Y:0:4);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
