{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
  Const File_In='necklace.in';
        File_Out='necklace.out';
        MaxN=100001;
        Eps=1E-10;
  Type Int=LongInt;
       Real=Extended;
  Var K,K2,N : Int;
      Angle,Ost : Array [1..MaxN] Of Real;
      A : Array [1..MaxN] Of Int64;
      TreeMax,TreeMin : Array [1..1 Shl 18] Of Int64;
      PiK : Real;
      Answer : Int64;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I,Help : Int;
Begin
  Read(N,K);
  PiK :=2*Pi/K;
  For I :=1 To N Do
    Begin
      Read(Angle[I],Help);
      A[I] :=Help;
      Ost[I] :=(Angle[I]/PiK-Trunc(Angle[I]/PiK))*PiK;
    End;
End;

Function More(Const A,B : Real) : Boolean;
Begin
  More :=A-B>Eps;
End;

Function Less(Const A,B : Real) : Boolean;
Begin
  Less :=A-B<-Eps;
End;

Function Eq(Const A,B : Real) : Boolean;
Begin
  Eq :=Abs(A-B)<Eps;
End;

Procedure Swap(Var A,B : Int64);
  Var C : Int64;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure SwapReal(Var A,B : Real);
  Var C : Real;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure Sort(L,R : Int);
  Var X : Real;
      I,J : Int;
Begin
  X :=Ost[L+Random(R-L+1)];
  I :=L;
  J :=R;
  Repeat
    While Less(Ost[I],X) Do Inc(I);
    While More(Ost[J],X) Do Dec(J);
    If I<=J Then
      Begin
        Swap(A[I],A[J]);
        SwapReal(Angle[I],Angle[J]);
        SwapReal(Ost[I],Ost[J]);
        Inc(I);
        Dec(J);
      End;
  Until I>J;
  If I<R Then Sort(I,R);
  If J>L Then Sort(L,J);
End;

Function GetNum(Const Angle,Add : Real) : int;
  Var HelpAngle : Real;
Begin
  HelpAngle :=Angle-Add;
  If Less(HelpAngle,0) Then HelpAngle :=HelpAngle+2*Pi;
  GetNum :=Trunc(HelpAngle/PiK)+1
End;

Function Min(Const A,B : Int64) : Int64;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

Function Max(Const A,B : Int64) : Int64;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Procedure AddValue(Const I : Int; Const Add : Int64);
  Var J : Int;
Begin
  J :=I+K2-1;
  Inc(TreeMin[J],Add);
  TreeMax[J] :=TreeMin[J];
  J :=J Div 2;
  While J>=1 Do
    Begin
      TreeMax[J] :=Max(TreeMax[J*2],TreeMax[J*2+1]);
      TreeMin[J] :=Min(TreeMin[J*2],TreeMin[J*2+1]);
      J :=J Div 2;
    End;
End;

Procedure Change(Const I : Int; Const Add : Int64);
Begin
  AddValue(I,Add);
  AddValue(I Mod K+1,-Add);
End;

Function GetMin(I,J : Int) : Int64;
  Var L,R : Int;
      MinNow : Int64;
Begin
  MinNow :=MaxLongInt;
  L :=K2+I-1;
  R :=K2+J-1;
  While L<=R Do
    Begin
      MinNow :=Min(MinNow,TreeMin[L]);
      L :=(L+1) Div 2;
      MinNow :=Min(MinNow,TreeMin[R]);
      R :=(R-1) Div 2;
    End;
  GetMin :=MinNow;
End;

Function GetMax(I,J : Int) : Int64;
  Var L,R : Int;
      MaxNow : Int64;
Begin
  MaxNow :=0;
  L :=K2+I-1;
  R :=K2+J-1;
  While L<=R Do
    Begin
      MaxNow :=Max(MaxNow,TreeMax[L]);
      L :=(L+1) Div 2;
      MaxNow :=Max(MaxNow,TreeMax[R]);
      R :=(R-1) Div 2;
    End;
  GetMax :=MaxNow;
End;

Procedure Solve;
  Var I,J : Int;
Begin
  FillChar(TreeMax,SizeOf(TreeMax),0);
  FillChar(TreeMin,SizeOf(TreeMin),0);
  Randomize;
  Sort(1,N);
  K2 :=1;
  While K2<K Do K2 :=K2 Shl 1;
  For I :=1 To N Do
    Begin
      J :=GetNum(Angle[I],0);
      Inc(TreeMax[J+K2-1],A[I]);
      TreeMin[J+K2-1] :=TreeMax[J+K2-1];
    End;
  For I :=K2-1 DownTo 1 Do
    Begin
      TreeMax[I] :=Max(TreeMax[I*2],TreeMax[I*2+1]);
      TreeMin[I] :=Min(TreeMin[I*2],TreeMin[I*2+1]);
    End;
{  If Not Eq(Ost[1],0) Then
    Begin
      J :=GetNum(Angle[1],Ost[1]);
      Change(J,A[1]);
    End;}
  Answer :=GetMax(1,K)-GetMin(1,K);
  For I :=2 To N Do
    Begin
      J :=GetNum(Angle[I-1],Ost[I]);
      Change(J,A[I-1]);
      Answer :=Min(Answer,GetMax(1,K)-GetMin(1,K));
    End;
  WriteLn(Answer);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
