CONST
 Eps=0.000001;

TYPE
 tPoint=Record
   X,Y:Double;
 End;

 tLine=Record
   A,B,C:Double;
 End;

function  Crossing(A,B,C:tPoint;Var P:tPoint):Boolean;
 Var L1,L2:tLine;
 Begin
   L1.A:=A.X-B.X;
   L1.B:=A.Y-B.Y;
   L1.C:=-(A.X+B.X)*L1.A/2-(A.Y+B.Y)*L1.B/2;
   L2.A:=C.X-B.X;
   L2.B:=C.Y-B.Y;
   L2.C:=-(C.X+B.X)*L2.A/2-(C.Y+B.Y)*L2.B/2;
   If Abs(L1.A*L2.B-L1.B*L2.A)<Eps Then Begin
     Crossing:=False;
     Exit;
   End;
   P.X:=(L1.B*L2.C-L1.C*L2.B)/(L1.A*L2.B-L1.B*L2.A);
   P.Y:=(L1.C*L2.A-L1.A*L2.C)/(L1.A*L2.B-L1.B*L2.A);
   Crossing:=True;
 End;

VAR
 N,K,I,J,I1,I2,I3:LongInt;
 Poly:Array[0..200]Of Record
   X,Y:LongInt;
 End;
 Sign:Boolean;
 Fire:Array[0..200]Of Record
   X,Y:LongInt;
 End;
 MinL,MaxL,MaxX,MaxY,Temp:Double;
 A,B,C,P:tPoint;

Function Test(P:tPoint;R:Double):Boolean;
 Var
  I:LongInt;
  S:Double;
 Begin
   For I:=0 to N-1 Do Begin
     S:=Poly[I].X*Poly[(I+1)Mod N].Y-Poly[I].Y*Poly[(I+1)Mod N].X+
        Poly[(I+1)Mod N].X*P.Y-Poly[(I+1)Mod N].Y*P.X+
        P.X*Poly[I].Y-P.X*Poly[I].Y;
     If ((Sign)Xor(S<0))And(Abs(S)>Eps)Then Begin
       Test:=False;
       Exit;
     End;
   End;
   For I:=0 To K-1 Do
     If (R-Sqr(Fire[I].X-P.X)-Sqr(Fire[I].Y-P.Y))>Eps Then Begin
       Test:=False;
       Exit;
     End;
   Test:=True;
 End;

Procedure MakeFF255(P:tPoint);
 Var
  I:LongInt;
 Begin 
   MinL:=1000000000;
   For I:=0 To K-1 Do Begin
     Temp:=Sqr(P.X-Fire[I].X)+Sqr(P.Y-Fire[I].Y);
     If Temp<MinL Then MinL:=Temp;
   End;
   If MinL>MaxL Then Begin
     MaxL:=MinL;
     MaxX:=P.X;
     MaxY:=P.Y;
   End;
 End;

{ }

Procedure Make255FF(A,B:tPoint);
 Var
  L1,L2:tLine;
  I:LongInt;
  P:tPoint;
 Begin
   L1.A:=A.X-B.X;
   L1.B:=A.Y-B.Y;
   L1.C:=-(A.X+B.X)*L1.A/2-(A.Y+B.Y)*L1.B/2;
   For I:=0 To N-1 Do Begin
     L2.A:=Poly[(I+1)Mod N].Y-Poly[I].Y;
     L2.B:=Poly[I].X-Poly[(I+1)Mod N].X;
     L2.C:=-Poly[I].X*L2.A-Poly[I].Y*L2.B;
     If Abs(L1.A*L2.B-L1.B*L2.A)>Eps Then Begin
       P.X:=(L1.B*L2.C-L1.C*L2.B)/(L1.A*L2.B-L1.B*L2.A);
       P.Y:=(L1.C*L2.A-L1.A*L2.C)/(L1.A*L2.B-L1.B*L2.A);
       If ((P.X-Poly[I].X)>Eps)And((Poly[(I+1)Mod N].X-P.X)>Eps)Or((P.X-Poly[(I+1)Mod N].X)>Eps)And((Poly[I].X-P.X)>Eps)Or
          ((P.Y-Poly[I].Y)>Eps)And((Poly[(I+1)Mod N].Y-P.Y)>Eps)Or((P.Y-Poly[(I+1)Mod N].Y)>Eps)And((Poly[I].Y-P.Y)>Eps)Then Begin
          MakeFF255(P);
       End;
     End;
   End;
 End;

BEGIN
  Assign(Input,'fire.in');
  Assign(Output,'fire.out');
  Reset(Input);
  ReWrite(Output);
  ReadLn(N);
  For I:=0 To N-1 Do ReadLn(Poly[I].X,Poly[I].Y);
  ReadLn(K);
  For I:=0 To N-1 Do ReadLn(Fire[I].X,Fire[I].Y);
  MaxL:=0;
  For I:=0 To N-1 do Begin
    MaxL:=MaxL+Poly[I].X*Poly[(I+1)Mod N].Y-Poly[I].Y*Poly[(I+1)Mod N].X;
  End;
  Sign:=(MaxL<0);
  MaxL:=-1;
  For I:=0 To N-1 Do Begin
    MinL:=1000000000;
    For J:=0 To K-1 Do Begin
      Temp:=Sqr(Poly[I].X-Fire[J].X)+Sqr(Poly[I].Y-Fire[J].Y);
      If Temp<MinL Then MinL:=Temp;
    End;
    If MinL>MaxL Then Begin
      MaxL:=MinL;
      MaxX:=Poly[I].X;
      MaxY:=Poly[I].Y;
    End;
  End;
  For I1:=0 To K-1 Do
  For I2:=I1+1 To K-1 Do
  For I3:=I2+1 To K-1 Do Begin
    A.X:=Fire[I1].X;
    A.Y:=Fire[I1].Y;
    B.X:=Fire[I2].X;
    B.Y:=Fire[I2].Y;
    C.X:=Fire[I3].X;
    C.Y:=Fire[I3].Y;
    If Crossing(A,B,C,P) Then Begin;
      If Test(P,Sqr(A.X-P.X)+Sqr(A.Y-P.Y)) And(Sqr(A.X-P.X)+Sqr(A.Y-P.Y)>MaxL)Then Begin
        MaxL:=Sqr(A.X-P.X)+Sqr(A.Y-P.Y);
        MaxX:=P.X;
        MaxY:=P.Y;
      End;
    End;
  End;
  For I1:=0 To K-1 Do
  For I2:=I1+1 To K-1 Do Begin
    A.X:=Fire[I1].X;
    A.Y:=Fire[I1].Y;
    B.X:=Fire[I2].X;
    B.Y:=Fire[I2].Y;
    Make255FF(A,B);
  End;
  If Abs(MaxX)<Eps Then MaxX:=0.0000001;
  If Abs(MaxY)<Eps Then MaxY:=0.0000001;
  Writeln(1.0*MaxX:0:4,' ',1.0*MaxY:0:4);

  Close(Input);
  Close(Output);
END.
