const e2=1e-4;
const eps=1e-8;
const kx:array[1..4]of double=(0,0,1,-1);
const ky:array[1..4]of double=(1,-1,0,0);
var r:double;
    n:longint;
    pnt:array[1..110,1..2]of double;

procedure Load;
var i:longint;
begin
    read(r,n);
    for i:=1 to n do begin
        read(pnt[i,1],pnt[i,2]);
    end;
end;

procedure GWRT(a:double);
begin
    if abs(a)<eps then write('0.00000')
    else write(a:0:5);
end;

procedure Solve;
var i,j,f:longint;
    d1,d2,a,b,c,x,y,x0,y0,dx,dy,na,nb,nc:double;
begin
    for i:=1 to 4 do begin
        x:=(r-e2)*kx[i];
        y:=(r-e2)*ky[i];
        f:=0;
        for j:=1 to n-1 do begin
            a:=pnt[j+1,2]-pnt[j,2];
            b:=pnt[j+1,1]-pnt[j,1];
            c:=-pnt[j,1]*a-pnt[j,2]*b;
            if abs(x*a+y*b+c)<eps then begin
                f:=1;
                break;
            end;
        end;
        a:=pnt[1,2]-pnt[n,2];
        b:=pnt[1,1]-pnt[n,1];
        c:=-pnt[n,1]*a-pnt[n,2]*b;
        if abs(x*a+y*b+c)<eps then f:=1;
        if f=0 then begin
            x0:=x;
            y0:=y;
            break;
        end;
    end;
    a:=pnt[n,2]-pnt[1,2];
    b:=pnt[1,1]-pnt[n,1];
    c:=-a*pnt[1,1]-b*pnt[1,2];
    na:=a/sqrt(a*a+b*b);
    nb:=b/sqrt(a*a+b*b);
    nc:=c/sqrt(a*a+b*b);
    a:=na;
    b:=nb;
    c:=nc;
    dx:=a/100;
    dy:=-b/100;
    d1:=x0*a+y0*b+c;
    d2:=(x0+dx)*a+(y0+dy)*b+c;
    if abs(d2)<abs(d1) then begin
        dx:=-dx;
        dy:=-dy;
    end;
    GWRT(x0);
    write(' ');
    GWRT(y0);
    write(' ');
    GWRT(dx);
    write(' ');
    GWRT(dy);
end;

begin
    assign(input,'glass.in');
    assign(output,'glass.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.
