const eps=1e-9;
const SRCDX=4096;
const SRCDY=4096;
var src:array[1..201,1..2]of extended;
    pnt:array[1..201,1..2]of extended;
    cxs,cys:array[1..211]of extended;
    n,k:longint;
    sq:extended;

function TriSqr(x1,y1,x2,y2,x3,y3:extended):extended;
var v1x,v1y,v2x,v2y:extended;
begin
    v1x:=x2-x1;
    v1y:=y2-y1;
    v2x:=x3-x1;
    v2y:=y3-y1;
    TriSqr:=abs(v1x*v2y-v2x*v1y)/2;
end;


procedure Load;
var i:longint;
begin
    read(n);
    for i:=1 to n do begin
        read(pnt[i,1],pnt[i,2]);
    end;
    read(k);
    for i:=1 to k do begin
        read(src[i,1],src[i,2]);
    end;
    sq:=0;
    for i:=2 to n-1 do begin
        sq:=sq+TriSqr(pnt[1,1],pnt[1,2],pnt[i,1],pnt[i,2],pnt[i+1,1],pnt[i+1,2]);
    end;
end;

function F(x,y:extended):extended;
var i:longint;
    cur,min:extended;
begin
    min:=2000000000;
    for i:=1 to k do begin
        cur:=sqr(src[i,1]-x)+sqr(src[i,2]-y);
        if cur<min then min:=cur;
    end;
    F:=min;
end;

function Inside(x,y:extended):boolean;
var cs:extended;
    i:longint;
begin
    cs:=0;
    for i:=1 to n-1 do begin
        cs:=cs+TriSqr(x,y,pnt[i,1],pnt[i,2],pnt[i+1,1],pnt[i+1,2]);
    end;
    cs:=cs+TriSqr(x,y,pnt[n,1],pnt[n,2],pnt[1,1],pnt[1,2]);
    if(abs(cs-sq)<eps)then Inside:=true
    else Inside:=false;
end;

procedure Solve;
var mf,mx,my,cx,cy,dx,dy,nx,ny,cf,nf:extended;
    mvs,i,j,ii,ff,ncx:longint;
begin
    cx:=0;
    cy:=0;
    for i:=1 to n do begin
        cx:=cx+pnt[i,1];
        cy:=cy+pnt[i,2];
    end;
    ncx:=0;
    i:=1;
    while i<n do begin
        inc(ncx);
        cxs[ncx]:=pnt[i,1];
        cys[ncx]:=pnt[i,2];
        if n>100 then inc(i,3)
        else inc(i);
    end;
    inc(ncx);
    cxs[ncx]:=cx/n;
    cys[ncx]:=cy/n;
    mf:=-2000000000;
    mx:=0;
    my:=0;
    for i:=1 to ncx do begin
        cx:=cxs[i];
        cy:=cys[i];
        cf:=F(cx,cy);
        dx:=SRCDX;
        dy:=SRCDY;
        mvs:=0;
        while(abs(dx)>eps)and(abs(dy)>eps) do begin
            inc(mvs);
            if(mvs>10000)then break;
            nx:=cx+dx;
            ny:=cy;
            if Inside(nx,ny) then begin
                nf:=F(nx,ny);
                if nf-cf<eps then begin
                    dx:=-dx/2;
                end
                else begin
                    cx:=nx;
                    cy:=ny;
                end;
            end
            else dx:=dx/2;
            nx:=cx;
            ny:=cy+dy;
            if Inside(nx,ny) then begin
                nf:=F(nx,ny);
                if nf-cf<eps then begin
                    dy:=-dy/2;
                end
                else begin
                    cx:=nx;
                    cy:=ny;
                end;
            end
            else dy:=dy/2;
        end;
        cf:=f(cx,cy);
        if mf<cf then begin
            mx:=cx;
            my:=cy;
            mf:=cf;
        end;
    end;
    for i:=1 to k do begin
        for j:=i+1 to k do begin
            cx:=(pnt[i,1]+pnt[j,1])/2;
            cy:=(pnt[i,2]+pnt[j,2])/2;
            cf:=F(cx,cy);
            if cf-mf>eps then begin
                cf:=sqr(cx-pnt[i,1])+sqr(cy-pnt[i,2]);
                ff:=1;
                for ii:=1 to k do begin
                    nf:=sqr(cx-pnt[ii,1])+sqr(cy-pnt[ii,2]);
                    if not(cf-nf>-eps) then begin
                        ff:=0;
                        break;
                    end;
                end;
                if ff=1 then begin
                    mf:=F(cx,cy);
                    mx:=cx;
                    my:=cy;
                end;
            end;
        end;
    end;
    write(mx:0:4,' ',my:0:4);
end;


begin
  assign(input,'fire.in');
  assign(output,'fire.out');
  reset(input);
  rewrite(output);
  Load;
  Solve;
  close(input);
  close(output);
end.

