{$P+}
const pieces=80;
      moves=3200;
      fMove=1e-2;
      lMove=1e-8;
      inf=1000000000000000000.0;
var i,j,n:integer;
    px,py:array[0..52] of double;
    u,v:double;
    best:array[0..52] of double;

function min2(aa,bb:double):double;
begin
    if aa<bb then
        min2:=aa
    else
        min2:=bb;
end;

function Power(aa,bb:double):double;
begin
    Power:=exp(bb*ln(aa));
end;

procedure Norm(var aa,bb:double;rr:double);
var cc:double;
begin
    cc:=sqrt(sqr(aa)+sqr(bb));
    if cc<1e-10 then
    begin
        aa:=0;
        bb:=0;
    end
    else
    begin
        aa:=aa/cc*rr;
        bb:=bb/cc*rr;
    end;
end;

function findBestPath(aa,bb:integer):double;
var ap,bp,cp,dp,ep,fp,gp,hp,p0:double;
    x11,x21,x1d,x2d:double;
    y11,y21,y1d,y2d:double;
    qsq:double;
    w,r:integer; min,minx:double;
    moveA,moveB,bsta,bstb,newA,newB:double;

function getFunction(aa,bb:double):double;
var cc:double;
begin
    cc:=cp+dp*aa+ep*bb+fp*aa*aa+gp*bb*bb+hp*aa*bb;
    if cc<0 then cc:=0;
    getFunction:=p0+ap*aa+bp*bb+sqrt(cc);
end;

function getDiffA(aa,bb:double):double;
var cc:double;
begin
    cc:=cp+dp*aa+ep*bb+fp*aa*aa+gp*bb*bb+hp*aa*bb;
    if cc<0 then cc:=0;
    cc:=sqrt(cc);
    if cc>1e-6 then
        getDiffA:=ap+(dp+2*fp*aa+hp*bb)/2/cc
    else
        getDiffA:=ap*cc+(dp+2*fp*aa+hp*bb)/2;
end;

function getDiffB(aa,bb:double):double;
var cc:double;
begin
    cc:=cp+dp*aa+ep*bb+fp*aa*aa+gp*bb*bb+hp*aa*bb;
    if cc<0 then cc:=0;
    cc:=sqrt(cc);
    if cc>1e-6 then
        getDiffB:=bp+(ep+2*gp*bb+hp*aa)/2/cc
    else
        getDiffB:=bp*cc+(ep+2*gp*bb+hp*aa)/2;
end;

begin
    x11:=px[aa]; x21:=px[bb-1]; x1d:=px[aa+1]-px[aa]; x2d:=px[bb]-px[bb-1];
    y11:=py[aa]; y21:=py[bb-1]; y1d:=py[aa+1]-py[aa]; y2d:=py[bb]-py[bb-1];
    ap:=sqrt(sqr(x1d)+sqr(y1d))/v;
    bp:=-sqrt(sqr(x2d)+sqr(y2d))/v;
    p0:=-bp;
    cp:=(sqr(px[aa]-px[bb-1])+sqr(py[aa]-py[bb-1]))/u/u;
    dp:=2*((x11-x21)*x1d+(y11-y21)*y1d)/u/u;
    ep:=2*((x21-x11)*x2d+(y21-y11)*y2d)/u/u;
    fp:=(sqr(x1d)+sqr(y1d))/u/u;
    gp:=(sqr(x2d)+sqr(y2d))/u/u;
    hp:=-2*(x1d*x2d+y1d*y2d)/u/u;
    min:=inf;
    for w:=0 to pieces do
        for r:=0 to pieces do
        begin
            qsq:=getFunction(w/pieces,r/pieces);
            if qsq<min then
            begin
                min:=qsq;
                bsta:=w/pieces;
                bstb:=r/pieces;
            end;
        end;
    for w:=1 to moves do
    begin
        moveA:=-getDiffA(bsta,bstb);
        moveB:=-getDiffB(bsta,bstb);
        Norm(moveA,moveB,fMove*Power(lMove/fMove,(w-1)/(moves-1)));
        newA:=bstA+moveA;
        newB:=bstB+moveB;
        if ((newA<0) or (newB<0) or (newA>1) or (newB>1)) then
            break;
        bstA:=newA;
        bstB:=newB;
    end;
    minx:=getFunction(bstA,bstB);
    findBestPath:=minx;
end;

begin
    assign(input,'tractor.in');
    assign(output,'tractor.out');
    reset(input);
    rewrite(output);
    read(n,u,v);
    for i:=0 to n do
        read(px[i],py[i]);
    best[0]:=0;
    best[1]:=sqrt(sqr(px[1]-px[0])+sqr(py[1]-py[0]))/v;
    for i:=2 to n do
        best[i]:=inf;
    for i:=2 to n do
        for j:=0 to i-2 do
            best[i]:=min2(best[i],findBestPath(j,i)+best[j]);
    writeln(best[n]:0:6);
    close(output);
    close(input);
end.
