const Parts=1500000;
      deltaCoof=1-1e-5;
      deltaA=1e-1;
var i,j,n,lef:longint;
    r:double;
    px,py:array[1..200] of double;
    fpx,fpy,vx,vy:double;
    used:array[0..Parts-1] of boolean;
    cnt:longint;

function getAngle(xx,yy:double):double;
begin
    if abs(xx)<1e-6 then
    begin
        if yy<0 then
            getAngle:=-pi/2
        else
            getAngle:=pi/2;
    end
    else
    begin
        if xx<0 then
            getAngle:=arctan(yy/xx)+pi
        else
            getAngle:=arctan(yy/xx);
    end;
end;

procedure getFirstPartCoords(x1,y1,x2,y2:double;var xc,yc:double);
var kk,aa,bb,cc:double;
begin
    if abs(x1-x2)<1e-5 then
    begin
        fpx:=r;
        fpy:=0;
        exit;
    end;
    kk:=(y1-y2)/(x2-x1);
    fpy:=sqrt(r/(1+kk*kk));
    fpx:=kk*fpy;
end;

procedure Cross(x1,y1,x2,y2:double);
var ang:double;
    nvx,nvy:double;
    ll,rr:longint;
    u:longint;
begin
    nvx:=(y1-y2); nvy:=(x2-x1);
    ang:=getAngle(-nvx,-nvy);
    if ang<pi/2 then ang:=ang+2*pi;
    ll:=-trunc(-(ang-pi/2)/(2*pi)*Parts);
    rr:=trunc((ang+pi/2)/(2*pi)*Parts);
    if rr>=Parts then rr:=rr-Parts;
    u:=ll;
    repeat
        used[u]:=false;
        inc(u);
        if u>=Parts then u:=u-Parts;
    until u=rr;
end;

begin
    assign(input,'glass.in');
    assign(output,'glass.out');
    reset(input);
    rewrite(output);
    read(r,n);
    for i:=1 to n do
        read(px[i],py[i]);
    getFirstPartCoords(px[1],py[1],px[n],py[n],fpx,fpy);
    for i:=0 to Parts-1 do
        used[i]:=true;
    for i:=1 to n-1 do
        Cross(px[i],py[i],px[i+1],py[i+1]);
    cnt:=0; lef:=0;
    for i:=0 to Parts-1 do
    begin
        if cnt=0 then lef:=i;
        if used[i] then
            inc(cnt);
        if ((cnt>0) and (not used[i])) then
            break;
    end;
    if cnt=0 then
    begin
        writeln(-1);
        close(input);
        close(output);
        exit;
    end;
    j:=lef+cnt div 2;
    vx:=cos((j+0.5)*2*pi*Parts);
    vy:=sin((j+0.5)*2*pi*Parts);
    fpx:=px[1]*cos(deltaA)+py[1]*sin(deltaA);
    fpy:=-px[1]*sin(deltaA)+py[1]*cos(deltaA);
    fpx:=fpx*deltaCoof;fpy:=fpy*deltaCoof;
    writeln(fpx:0:6,' ',fpy:0:6,' ',vx:0:6,' ',vy:0:6);
    close(input);
    close(output);
end.