type
  integer = longint;
  extended = real;
  TPoint = record
    x, y: extended;
  end;

const
  eps=1E-4;

var
  u, v, old, globmin: extended;
  x, y: array [1..100] of integer;
  points: array [1..200] of extended;
  n, i, count: integer;

function getcoords(i: extended): TPoint;
var
  p: TPoint;
begin
  p.x:=x[trunc(i)+1]+(x[trunc(i)+2]-x[trunc(i)+1])*frac(i);
  p.y:=y[trunc(i)+1]+(y[trunc(i)+2]-y[trunc(i)+1])*frac(i);
  getcoords:=p;
end;

function calc(i, j: integer): extended;
var
  p1, p2: TPoint;
  k: integer;
  t: extended;
begin
  t:=0;
  for k:=i to j-1 do
  begin
    p1:=getcoords(points[k]);
    p2:=getcoords(points[k+1]);
    if (trunc(points[k])=trunc(points[k+1])) or ((trunc(points[k])=n-1) and (trunc(points[k+1])=n)) then
      t:=t+sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y))/v
    else
      t:=t+sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y))/u;
  end;
  calc:=t;
end;

procedure optimize(x: integer);
var
  delta, t, i, old, min: extended;
begin
  delta:=n;
  while delta>1E-5 do
  begin
    i:=0;
    old:=points[x];
    min:=calc(x-1, x+1);
    points[x]:=old-delta;
    if (points[x]>=0) and (min>calc(x-1, x+1)) then
      i:=-1;
    points[x]:=old+delta;
    if (points[x]<=n) and (min>calc(x-1, x+1)) then
      i:=1;
    if i=0 then
    begin
      points[x]:=old+delta*(random/640-1/1280);
      if points[x]>n then
        points[x]:=n;
      if points[x]<0 then
        points[x]:=0;
      delta:=delta/2;
      continue;
    end;
    points[x]:=old+delta*i{+delta*(random/320-1/640)};
//    delta:=4*delta/6;
//   if points[x]<0 then
  end;
//  WriteLn('Point #', x, ' optimized!');
end;

begin
  Assign(input, 'tractor.in');
  Assign(output, 'tractor.out');
  Reset(input);
  Rewrite(output);
  ReadLn(n, u, v);
  for i:=1 to n+1 do
    ReadLn(x[i], y[i]);
  x[n+2]:=x[n+1];
  y[n+2]:=y[n+1];
  randomize;
  {for i:=0 to 2*n-1 do
    points[i+1]:=n*i/(2*n-1)+(random*2-1);}
  for i:=1 to n do
    points[i]:=0;
  for i:=n+1 to 2*n do
    points[i]:=n;
  points[1]:=0;
  points[2*n]:=n;
  old:=0;
  globmin:=100000;
  while true do
  begin
    for i:=2 to 2*n-1 do
      optimize(i);
    for i:=2*n-1 downto 2 do
      optimize(i);
    inc(count);
    if globmin>calc(1, 2*n) then
    begin
      globmin:=calc(1, 2*n);
      count:=0;
    end;
    if count=5 then
      break;
    old:=calc(1, 2*n);
//    WriteLn(old:6:6);
  end;
  WriteLn(globmin:6:6);
  Close(input);
  Close(output);
end.
