type
  integer = longint;
  TGraph = record
    a, i, h, p, cc: array [1..1200] of integer;
    b, next, c: array [1..3000000] of integer;
    wc, hsize: integer;
  end;

var
  i, j, k, n, l, r: integer;
  a, b: array [1..1200, 1..1200] of integer;
  res, col: array [1..1200] of integer;
  g: TGraph;
  f: boolean;

procedure swap(i, j: integer);
begin
  if i=j then exit;
  g.p[g.h[i]]:=j;
  g.p[g.h[j]]:=i;
  g.h[i]:=g.h[i] xor g.h[j];
  g.h[j]:=g.h[i] xor g.h[j];
  g.h[i]:=g.h[i] xor g.h[j];
end;

procedure heapify(i: integer);
var
  min: integer;
begin
  min:=i;
  if (i*2+1<=g.hsize) and
    ((g.i[g.h[min]]>g.i[g.h[i*2+1]]) or
    ((g.i[g.h[min]]=g.i[g.h[i*2+1]]) and (g.cc[g.h[min]]>g.cc[g.h[i*2+1]])) or
    ((g.i[g.h[min]]=g.i[g.h[i*2+1]]) and (g.cc[g.h[min]]=g.cc[g.h[i*2+1]]) and (g.h[min]>g.h[i*2+1]))) then
    min:=i*2+1;
  if (i*2<=g.hsize) and
    ((g.i[g.h[min]]>g.i[g.h[i*2]]) or
    ((g.i[g.h[min]]=g.i[g.h[i*2]]) and (g.cc[g.h[min]]>g.cc[g.h[i*2]])) or
    ((g.i[g.h[min]]=g.i[g.h[i*2]]) and (g.cc[g.h[min]]=g.cc[g.h[i*2]]) and (g.h[min]>g.h[i*2]))) then
    min:=i*2;
  if min=i then exit;
  swap(i, min);
  heapify(i);
end;

procedure push(i: integer);
begin
  if i=1 then exit;
  if ((g.i[g.h[i div 2]]>g.i[g.h[i]]) or
      ((g.i[g.h[i div 2]]=g.i[g.h[i]]) and (g.cc[g.h[i div 2]]>g.cc[g.h[i]])) or
      ((g.i[g.h[i div 2]]=g.i[g.h[i]]) and (g.cc[g.h[i div 2]]=g.cc[g.h[i]]) and (g.h[i div 2]>g.h[i]))) then
  begin
    swap(i, i div 2);
    push(i div 2);
  end;
end;

procedure refresh(i: integer);
begin
  heapify(g.p[i]);
  push(g.p[i]);
end;

procedure HeapSort(k: integer);
var
  hsize, i: integer;

procedure swap(i, j: integer);
begin
  if i=j then exit;
  b[i, k]:=b[i, k] xor b[j, k];
  b[j, k]:=b[i, k] xor b[j, k];
  b[i, k]:=b[i, k] xor b[j, k];
end;

procedure Heapify(i: integer);
var
  max: integer;
begin
  max:=i;
  if (i*2+1<=hsize) and (a[b[i*2+1, k], k]>a[b[max, k], k]) then
    max:=i*2+1;
  if (i*2<=hsize) and (a[b[i*2, k], k]>a[b[max, k], k]) then
    max:=i*2;
  if max=i then exit;
  swap(i, max);
  heapify(max);
end;

begin
  hsize:=n;
  for i:=n div 2 downto 1 do
    heapify(i);
  for i:=1 to n do
  begin
    swap(1, hsize);
    dec(hsize);
    heapify(1);
  end;
end;

begin
  Assign(input, 'chat.in');
  Assign(output, 'chat.out');
  Reset(input);
  Rewrite(output);
  while true do
  begin
    ReadLn(n);
    if n=0 then
    begin
      Close(input);
      Close(output);
      exit;
    end;
    for i:=1 to n do
      for j:=1 to n do
      begin
        Read(a[i, j]);
        b[i, j]:=i;
      end;
    for j:=1 to n do
      HeapSort(j);
    for i:=1 to n do
    begin
      g.a[i]:=0;
      g.i[i]:=0;
    end;
    g.wc:=0;
    g.hsize:=n;
    for i:=1 to n do
    begin
      g.h[i]:=i;
      g.p[i]:=i;
      g.cc[i]:=0;
    end;
    for i:=n div 2 downto 1 do
      heapify(i);
    for j:=1 to n do
    begin
      k:=1;
      l:=1;
      for i:=1 to n do
      begin
        if (i=k) then
        begin
          while (k<=n) and (a[b[k, j], j]=a[b[i, j], j]) do
            inc(k);
          l:=k;
          while (l<=n) and (a[b[k, j], j]=a[b[l, j], j]) do
            inc(l);
        end;
        if b[i, j]=j then continue;
        if k>n then continue;
        for r:=k to l-1 do
        begin
          inc(g.i[b[r, j]]);
          refresh(b[r, j]);
          inc(g.wc);
          g.b[g.wc]:=b[r, j];
          g.c[g.wc]:=j;
          inc(g.cc[j]);
          refresh(j);
          g.next[g.wc]:=g.a[b[i, j]];
          g.a[b[i, j]]:=g.wc;
        end;
        {if b[k, j]=10 then
          WriteLn(b[i, j]);}
      end;
    end;
    f:=false;
    for i:=1 to n do
      col[i]:=0;
    for i:=1 to n do
    begin
      if g.i[g.h[1]]>0 then
      begin
        f:=true;
        WriteLn(-1);
        break;
      end;
      res[i]:=g.h[1];
      j:=g.a[g.h[1]];
      col[g.h[1]]:=1;
      swap(1, g.hsize);
      dec(g.hsize);
      heapify(1);
      while j<>0 do
      begin
        if col[g.c[j]]=1 then
        begin
          f:=true;
          WriteLn(-1);
          break;
        end;
        dec(g.cc[g.c[j]]);
        refresh(g.c[j]);
        dec(g.i[g.b[j]]);
        refresh(g.b[j]);
        j:=g.next[j];
      end;
      if f then break;
    end;
    if f then continue;
    for i:=1 to n do
      Write(res[i], ' ');
    WriteLn;
  end;
end.
