type
  integer = longint;
  TPoint = record
    x, y: extended;
  end;
  TEvent = record
    t, d, delta: extended;
    n: integer;
  end;

const eps=1e-10;

var
  i, n, k, hsize, cure, ec: integer;
  delta, d, curs, needs, l, r, x, oldt: extended;
  e: array [0..100000] of TEvent;
  s, p, p0: TPoint;

procedure swap(i, j: integer);
var
  t: TEvent;
begin
  t:=e[i];
  e[i]:=e[j];
  e[j]:=t;
end;

procedure heapify(i: integeR);
var
  min: integer;
begin
  min:=i;
  if (i*2+1<=hsize) and (e[min].t<e[i*2+1].t) then
    min:=i*2+1;
  if (i*2<=hsize) and (e[min].t<e[i*2].t) then
    min:=i*2;
  if i=min then exit;
  swap(i, min);
  heapify(min);
end;

procedure heapsort;
var
  i: integer;
begin
  for i:=hsize div 2 downto 1 do
    heapify(i);
  for i:=1 to ec do
  begin
    swap(1, hsize);
    dec(hsize);
    heapify(1);
  end;
end;

begin
  Assign(input, 'antiufo.in');
  Assign(output, 'antiufo.out');
  Reset(input);
  Rewrite(output);
  ReadLn(n, k);
  ReadLn(s.x, s.y);
  p:=s;
  needs:=0;
  for i:=1 to n*2 do
    e[i].n:=i;
  ec:=0;
  for i:=2 to n do
  begin
    p0:=p;
    ReadLn(p.x, p.y);
    if p.y=p0.y then
      continue;
    inc(ec);
    e[ec].t:=p0.y;
    if p0.y<p.y then
      e[ec].delta:=p0.x
    else
      e[ec].delta:=p0.x;
//    e[ec].delta:=p0.x;
    e[ec].d:=(p.x-p0.x)/(p.y-p0.y);
    inc(ec);
    e[ec].t:=p.y;
    if p0.y>p.y then
      e[ec].delta:=-p.x
    else
      e[ec].delta:=-p.x;
//    e[ec].delta:=p.x;
    e[ec].d:=-(p.x-p0.x)/(p.y-p0.y);
    needs:=needs+(p.y-p0.y)*(p0.x+p.x)/2;
  end;
  p0:=p;
  p:=s;
  if p.y<>p0.y then
  begin
    inc(ec);
    e[ec].t:=p0.y;
    if p0.y<p.y then
      e[ec].delta:=p0.x
    else
      e[ec].delta:=p0.x;
//    e[ec].delta:=p0.x;
    e[ec].d:=(p.x-p0.x)/(p.y-p0.y);
    inc(ec);
    e[ec].t:=p.y;
    if p0.y>p.y then
      e[ec].delta:=-p.x
    else
      e[ec].delta:=-p.x;
//    e[ec].delta:=p.x;
    e[ec].d:=-(p.x-p0.x)/(p.y-p0.y);
    needs:=needs+(p.y-p0.y)*(p0.x+p.x)/2;
  end;
  needs:=needs/(k+1);
  if needs<0 then
  begin
    needs:=-needs;
    for i:=1 to ec do
    begin
      e[i].delta:=-e[i].delta;
      e[i].d:=-e[i].d;
    end;
  end;
  hsize:=ec;
  heapsort;
  curs:=0;
  delta:=0;
  d:=0;
  e[0].t:=0;
  e[0].delta:=0;
  e[0].d:=0;
  for cure:=1 to ec do
  begin
    oldt:=e[cure-1].t;
    while curs+(2*delta+d*(e[cure].t-oldt))*(e[cure].t-oldt)/2-needs>-eps do
    begin
      l:=oldt;
      r:=e[cure].t;
      while abs(l-r)>=eps do
      begin
        x:=(l+r)/2;
        if curs+(2*delta+d*(x-oldt))*(x-oldt)/2>needs then
          r:=x
        else
          l:=x;
      end;
      WriteLn((l+r)/2:6:6);
      dec(k);
      if k=0 then
      begin
        Close(input);
        Close(output);
        exit;
      end;
      curs:=0;
      delta:=delta+d*((l+r)/2-oldt);
      oldt:=(l+r)/2;
    end;
    curs:=curs+(2*delta+d*(e[cure].t-oldt))*(e[cure].t-oldt)/2;
    delta:=delta+e[cure].delta+d*(e[cure].t-oldt);
    d:=d+e[cure].d;
  end;
  Close(input);
  Close(output);
end.

