  {$I-,Q-,R-,S-}
const
    maxn=300;
    inf=1000000000;
    _eps=1E-7;

type
    extended=double;
    tpoint=record x,y:longint; end;
    trpoint=record x,y:extended; end;
    tline=record a,b,c:extended; end;

var n,k:longint;
    a,b:array[1..maxn] of tpoint;
    res,resx,resy:extended;

Procedure init;
var i:longint;
begin
    assign(input,'fire.in');
    reset(input);
    assign(output,'fire.out');
    rewrite(output);
    read(n);
    for i:=1 to n do read(b[i].x,b[i].y);
    read(k);
    for i:=1 to k do read(a[i].x,a[i].y);
end;

Function min(const a,b:extended):extended;
begin
    if a<b then min:=a else min:=B;
end;

Function dist(const x1,y1,x2,y2:extended):extended;
begin
    dist:=sqrt(sqr(x1-x2)+sqr(y1-y2));
end;

Procedure p2l(const x1,y1,x2,y2:extended; var l:tline);
begin
    l.a:=y2-y1;
    l.b:=x1-x2;
    l.c:=-(l.a*x1+l.b*y1);
end;

Function less(const a,b:extended):boolean;
begin
    less:=(b-a)>_eps;
end;

Function eq(const a,b:extended):boolean;
begin
    eq:=abs(a-b)<_eps;
end;

Function intersect(const l1,l2:tline; var x,y:extended):boolean;
begin
    intersect:=false;
    if eq(l1.a*l2.b-l2.a*l1.b,0) then exit;
    y:=(l1.c*l2.a-l1.a*l2.c)/(l1.a*l2.b-l2.a*l1.b);
    x:=(l1.c*l2.b-l2.c*l1.b)/(l2.a*l1.b-l1.a*l2.b);
    intersect:=true;
end;

Function sp(const a,b:trpoint):extended;
begin
    sp:=a.x*b.x+a.y*b.y;
end;

Function inside(const x1,y1:extended; const p1,p2:tpoint):boolean;
var v1,v2:trpoint;
begin
    v1.x:=p1.x-x1;
    v1.y:=p1.y-y1;
    v2.x:=p2.x-x1;
    v2.y:=p2.y-y1;
    inside:=less(sp(v1,v2),0)or eq(sp(v1,v2),0);
end;

Procedure do3(const q,w:longint);
var x1,y1,x2,y2,vx,vy,cur:extended;
    i,j:longint;
    l,l2:tline;
begin
    x1:=(a[q].x+a[w].x)/2;
    y1:=(a[q].y+a[w].y)/2;
    vx:=-(a[w].y-a[q].y);
    vy:=a[w].x-a[q].x;
    P2L(x1,y1,x1+vx,y1+vy,l);
    for i:=1 to n do
    begin
        p2l(b[i].x,b[i].y,b[i mod n + 1].x,b[i mod n + 1].y,l2);
        if not intersect(l,l2,x2,y2) then continue;
        if inside(x2,y2,b[i],b[i mod n + 1]) then
        begin
            cur:=inf;
            for j:=1 to k do cur:=min(cur,dist(x2,y2,a[j].x,a[j].y));
            if cur>res then
            begin
                res:=cur;
                resx:=x2;
                resy:=y2;
            end;
        end;
    end;
end;

Procedure do1;
var i,j,h:longint;
    x,y,cur:extended;
begin
    for i:=1 to k do
    for j:=i+1 to k do
    begin
        x:=(a[i].x+a[j].x)/2;
        y:=(a[i].y+a[j].y)/2;
        cur:=inf;
        for h:=1 to k do
        begin
            cur:=min(cur,dist(x,y,a[h].x,a[h].y));
        end;
        if cur>res then
        begin
            res:=cur;
            resx:=x;
            resy:=y;
        end;
        do3(i,j);
    end;
end;

Procedure do2;
var i,j:longint;
    cur:extended;
begin
    for i:=1 to n do
    begin
        cur:=inf;
        for j:=1 to k do
        begin
            cur:=min(cur,dist(a[j].x,a[j].y,b[i].x,b[i].y));
        end;
        if cur>res then
        begin
            res:=cur;
            resx:=b[i].x;
            resy:=b[i].y;
        end;
    end;
end;

Procedure solve;
begin
    do1;
    do2;
end;

Procedure print;
begin
    writeln(resx:0:4,' ',resy:0:4);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.