  {$I-,Q-,R-,S-}
  {$M 40000000}
const
    maxn=200100;
    inf=1000000001;
    maxstep=18;

type
    TPoint=record x,y:longint; end;
    TP=record p:TPoint; ind,link:longint; black:boolean; end;
    tmax=record link:longint; max:int64; end;
    MaxTree=array[0..1 shl maxstep] of tmax;

var n,allnum,maxx,maxy:longint;
    a,tb,tw,Tall:array[0..maxn] of TP;
    tc,link:array[0..maxn] of longint;
    res:array[0..maxn] of int64;
    T:MaxTree;

Procedure init;
var i,x1,y1,x2,y2,cost:longint;
begin
    assign(input,'rects.in');
    reset(input);
    assign(output,'rects.out');
    rewrite(output);
    read(n);
    allnum:=0;
    for i:=1 to n do
    begin
        read(x1,y1,x2,y2,cost);
        tb[i].p.x:=x1;
        tb[i].p.y:=y2;
        tb[i].ind:=i;
        tb[i].black:=true;
        tw[i].p.x:=x2;
        tw[i].p.y:=y1;
        tw[i].ind:=i;
        tw[i].black:=false;
        tc[i]:=cost;
        inc(allnum);
        tall[allnum]:=tb[i];
        inc(allnum);
        tall[allnum]:=tw[i];
    end;
    tb[0].p.x:=-inf;
    tb[0].p.y:=inf;
    tb[0].ind:=0;
    tb[0].black:=true;
    tw[0].p.x:=-inf;
    tw[0].p.y:=inf;
    tw[0].ind:=0;
    tw[0].black:=false;
    tc[0]:=0;
    inc(allnum);
    tall[allnum]:=tb[0];
    inc(allnum);
    tall[allnum]:=tw[0];
end;

Procedure qsorty(const l,r:longint);
var i,j,x:longint;
    y:TP;
begin
    i:=l;
    j:=r;
    x:=tall[(l+r) div 2].p.y;
    repeat
        while x<tall[i].p.y do inc(i);
        while x>tall[j].p.y do dec(j);
        if i<=j then
        begin
            y:=tall[i];
            tall[i]:=tall[j];
            tall[j]:=y;
            inc(i);
            dec(j);
        end;
    until i>j;
    if i<r then qsorty(i,r);
    if j>l then qsorty(l,j);
end;

Procedure qsortx(const l,r:longint);
var i,j,x:longint;
    y:TP;
begin
    i:=l;
    j:=r;
    x:=tall[(l+r) div 2].p.x;
    repeat
        while x>tall[i].p.x do inc(i);
        while x<tall[j].p.x do dec(j);
        if i<=j then
        begin
            y:=tall[i];
            tall[i]:=tall[j];
            tall[j]:=y;
            inc(i);
            dec(j);
        end;
    until i>j;
    if i<r then qsortx(i,r);
    if j>l then qsortx(l,j);
end;

Function more(const a,b:TP):boolean;
begin
    if a.p.y<b.p.y then more:=true else
    if a.p.y>b.p.y then more:=false else
    if a.black and not b.black then more:=true else more:=false;
end;

Procedure qsort(const l,r:longint);
var i,j:longint;
    x,y:TP;
begin
    i:=l;
    j:=r;
    x:=a[(l+r) div 2];
    repeat
        while more(a[i],x) do inc(i);
        while more(x,a[j]) do dec(j);
        if i<=j then
        begin
            y:=a[i];
            a[i]:=a[j];
            a[j]:=y;
            inc(i);
            dec(j);
        end;
    until i>j;
    if i<r then qsort(i,r);
    if j>l then qsort(l,j);
end;

Procedure repoint;
var i:longint;
begin
    maxx:=0;
    maxy:=0;
    qsorty(1,allnum);
    for i:=1 to allnum do
    begin
        if tall[i].p.y<>tall[i-1].p.y then inc(maxy);
        a[i].p.x:=0;
        a[i].p.y:=maxy;
        a[i].ind:=tall[i].ind;
        a[i].black:=tall[i].black;
        a[i].link:=0;
        tall[i].link:=i;
    end;

    qsortx(1,allnum);

    for i:=1 to allnum do
    begin
        if tall[i].p.x=tall[i-1].p.x then
        begin
            a[tall[i].link].p.x:=maxx;
        end else
        begin
            inc(maxx);
            a[tall[i].link].p.x:=maxx;
        end;
    end;
    qsort(1,allnum);
end;

Function fmax(const a,b:longint):longint;
begin
    if a>b then fmax:=a else fmax:=b;
end;

Function get(const q:longint):tmax;
var i:longint;
    rr:int64;
begin
    get.max:=0;
    get.link:=0;
    rr:=-1;
    i:=q;
    while i<>0 do
    begin
        if t[i].max>rr then
        begin
            rr:=t[i].max;
            get:=t[i];
        end;
        i:=i-((i xor (i-1)) div 2 + 1);
    end;
end;

Procedure update(const q:longint);
var p:tmax;
begin
    p:=get(a[q].p.x-1);
    res[a[q].ind]:=p.max+int64(tc[a[q].ind]);
    link[a[q].ind]:=p.link;
end;

Procedure add(const q:longint);
var i:longint;
    rr:int64;
begin
    i:=a[q].p.x;
    rr:=res[a[q].ind];
    while i<=maxn do
    begin
        if t[i].max<rr then
        begin
            t[i].max:=rr;
            t[i].link:=a[q].ind;
        end;
        i:=i+((i xor (i-1)) div 2 + 1);
    end;
end;

Procedure solve;
var i:longint;
begin
    repoint;
    for i:=1 to allnum do if a[i].black then update(i) else add(i);
end;

Procedure recprint(const q:longint);
begin
    if q=0 then exit;
    recprint(link[q]);
    write(q,' ');
end;

Procedure print;
var i,cur:longint;
    rr:int64;
begin
    rr:=-1;
    cur:=0;
    for i:=1 to n do if res[i]>rr then
    begin
        rr:=res[i];
        cur:=i;
    end;
    writeln(rr);
    recprint(cur);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.