#include <stdio.h>
#include <string.h>

#define SIZE 103
#define MAXH 10313
#define MAXW 1013

int H1, W1, H2, W2;
char Key[SIZE][SIZE];
int DC[SIZE], St[SIZE], En[SIZE];
char Map[MAXH][MAXW];
char Is[MAXH][MAXW];

void dfsD( int y, int x );
void dfsL( int y, int x );
void dfsR( int y, int x );

void dfsD( int y, int x )
{
  int i;

  if (Is[y + 1][x])
    return;
  for (i = 0; i < W1; i++)
    if (Map[y + DC[i] + 1][x + i] == '#')
      return;
  Is[y + 1][x] = 1;
  dfsD(y + 1, x);
  dfsL(y + 1, x);
  dfsR(y + 1, x);
}

void dfsL( int y, int x )
{
  int i;

  if (Is[y][x - 1])
    return;
  for (i = 0; i < H1; i++)
    if (Map[y + i][x + St[i] - 1] == '#')
      return;
  Is[y][x - 1] = 1;
  dfsD(y, x - 1);
  dfsL(y, x - 1);
}

void dfsR( int y, int x )
{
  int i;

  if (Is[y][x + 1])
    return;
  for (i = 0; i < H1; i++)
    if (Map[y + i][x + En[i] + 1] == '#')
      return;
  Is[y][x + 1] = 1;
  dfsD(y, x + 1);
  dfsR(y, x + 1);
}

int main( void )
{
  int i, j, k, l;

  freopen("key.in", "rt", stdin);
  freopen("key.out", "wt", stdout);
  scanf("%d%d", &H1, &W1);
  for (i = 0; i < H1; i++)
    scanf("%s", Key[i]);
  scanf("%d%d", &H2, &W2);
  for (i = 0; i < H1; i++)
    for (j = 1; j <= W2; j++)
      Map[H1 + H2 + i][j] = Map[i][j] = '.';
  for (i = 0; i < H2; i++)
    scanf("%s", Map[i + H1] + 1);
  H2 += H1 * 2;
  for (i = 0; i < H2; i++)
    Map[i][0] = Map[i][W2 + 1] = '#';
  memset(Map[H2], '#', sizeof(Map[H2]));
  for (i = 0; i < H1; i++)
    for (j = 0; j < W1; j++)
      if (Key[i][j] == '#')
        En[i] = j;
  for (i = 0; i < H1; i++)
    for (j = W1 - 1; j >= 0; j--)
      if (Key[i][j] == '#')
        St[i] = j;
  for (j = 0; j < W1; j++)
    for (i = 0; i < H1; i++)
      if (Key[i][j] == '#')
        DC[j] = i;
  memset(Is, 0, sizeof(Is));
  for (i = 1; i <= W2; i++)
    dfsD(0, i);
  for (i = H2; i > 0; i--)
  {
    for (j = 1; j <= W2; j++)
      if (Is[i][j])
        break;
    if (j <= W2)
      break;
  }
  if (i >= H2 - H1 - 1)
    printf("-1");
  else
    printf("%d", i);
  return 0;
}
