#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define SQR(X) ((X) * (X))
#define MINI(A, B) ((A) < (B) ? (A) : (B))
#define MAXI(A, B) ((A) > (B) ? (A) : (B))

#define MAX 43
#define MAX2 (MAX * MAX)

#define NO    0
#define CROSS 1
#define ZERO  2

char S[MAX][MAX], S2[MAX][MAX];
int H, W, X1, Y1, X2, Y2, Cx, Cy, N;
int PX[MAX2][2], PY[MAX2][2];
int D[MAX][MAX][3];

void QSort1( int L, int R )
{
  int i = L, j = R, x, tmp;

  if (L >= R)
    return;
  x = PX[L + (rand() % (R - L + 1))][0];
  while (i <= j)
  {
    while (PX[i][0] < x)
      i++;
    while (PX[j][0] > x)
      j--;
    if (i <= j)
    {
      SWAP(PX[i][0], PX[j][0], tmp);
      SWAP(PX[i][1], PX[j][1], tmp);
      i++, j--;
    }
  }
  QSort1(L, j);
  QSort1(i, R);
}

void QSort2( int L, int R )
{
  int i = L, j = R, y, tmp;

  if (L >= R)
    return;
  y = PY[L + (rand() % (R - L + 1))][1];
  while (i <= j)
  {
    while (PY[i][1] < y)
      i++;
    while (PY[j][1] > y)
      j--;
    if (i <= j)
    {
      SWAP(PY[i][0], PY[j][0], tmp);
      SWAP(PY[i][1], PY[j][1], tmp);
      i++, j--;
    }
  }
  QSort2(L, j);
  QSort2(i, R);
}

void CalcD( int j, int i )
{
  int k, d;
  
  for (D[i][j][2] = (int)1e9, k = 0; k < N; k++)
  {
    d = SQR(PX[k][1] - i) + SQR(PX[k][0] - j);
    if (d < D[i][j][2])
      D[i][j][2] = d, D[i][j][0] = j, D[i][j][1] = i;
  }
}

int Test1( void )
{
  int m = MINI(X2 - X1, Y2 - Y1);
  
  if (m < 4)
    return NO;
  if (D[Cy][Cx][2] > (SQR(m) / 30))
    return ZERO;
  return CROSS;
}

int Test2( void )
{
  static int Is[MAX];
  int i, f1 = 0, f2 = 0, f3 = 0, y;
  int m = MINI(X2 - X1, Y2 - Y1);
  
  if (m < 3)
    return NO;
  memset(Is, 0, sizeof(Is));
  for (i = 0; !f1 || !f2; i++)
  {
    Is[y = PX[i][1]] = 1;
    if (y >= (Y2 * 4 + Y1) / 5)
      f1 = 1;
    if (y <= (Y1 * 4 + Y2) / 5)
      f2 = 1;
    if (Y1 * 3 + Y2 * 2 <= y * 5 && y * 5 <= Y1 * 2 + Y2 * 3)
      f3 = 1;
  }
  while (i < N && PX[i - 1][0] == PX[i][0])
  {
    y = PX[i][1];
    if (Y1 * 3 + Y2 * 2 < y * 5 && y * 5 < Y1 * 2 + Y2 * 3)
      f3 = 1;
    i++;
  }
  if (f3)
    return ZERO;
  return CROSS;
}

int Test3( void )
{
  int i, f1 = 0, f2 = 0, f3 = 0, y;
  int m = MINI(X2 - X1, Y2 - Y1);
  
  if (m < 3)
    return NO;
  for (i = N - 1; !f1 || !f2; i--)
  {
    y = PX[i][1];
    if (y >= (Y2 * 4 + Y1) / 5)
      f1 = 1;
    if (y <= (Y1 * 4 + Y2) / 5)
      f2 = 1;
    if (Y1 * 3 + Y2 * 2 < y * 5 && y * 5 < Y1 * 2 + Y2 * 3)
      f3 = 1;
  }
  while (i >= 0 && PX[i][0] == PX[i + 1][0])
  {
    y = PX[i][1];
    if (Y1 * 3 + Y2 * 2 < y * 5 && y * 5 < Y1 * 2 + Y2 * 3)
      f3 = 1;
    i--;
  }
  if (f3)
    return ZERO;
  return CROSS;
}

int Test4( void )
{
  int i, j, k, l, f1 = 0, f2 = 0, f3 = 0;
  int m = MINI(X2 - X1, Y2 - Y1);
  
  memset(S2, '.', sizeof(S2));
  for (i = 0; i < H; i++)
    for (j = 0; j < W; j++)
      if (S[i][j] == '*')
        for (k = -1; k <= 1; k++)
          for (l = -1; l <= 1; l++)
            if (k + j >= 0 && l + i >= 0)
              S2[l + i][k + j] = '*';
  for (i = 0; i <= H + 1; i++)
  {
    for (j = 0; S2[i][j] != '*' && j <= W + 1; j++)
      ;
    for (; S2[i][j] == '*' && j <= W + 1; j++)
      ;
    for (; S2[i][j] != '*' && j <= W + 1; j++)
      ;
    if (j == W + 2 && f1)
      f2 = 1;
    else if (j != W + 2 && !f1)
      f1 = 1;
    else if (j != W + 2 && f2)
      f3 = 1;
  }
  if (f3)
    return CROSS;
  if (f1)
    return ZERO;
  return NO;
}

int main( void )
{
  int i, j, k, x1, x2, a, sc, sz;

  srand(3017);
  freopen("x0.in", "rt", stdin);
  freopen("x0.out", "wt", stdout);
  while (1)
  {
    scanf("%s", S[H = 0]);
    while (S[H][0] != '-' && S[H][0] != '#')
      scanf("%s", S[++H]);
    W = strlen(S[0]);
    X1 = W, X2 = 0, Y1 = H, Y2 = 0;
    Cx = 0, Cy = 0, N = 0;
    for (i = 0; i < H; i++)
      for (j = 0; j < W; j++)
        if (S[i][j] == '*')
        {
          PX[N][0] = PY[N][0] = j;
          PX[N][1] = PY[N][1] = i;
          Cx += j, Cy += i, N++;
          if (i < Y1)
            Y1 = i;
          if (i > Y2)
            Y2 = i;
          if (j < X1)
            X1 = j;
          if (j > X2)
            X2 = j;
        }
    Cx /= N, Cy /= N;
    QSort1(0, N - 1);
    QSort2(0, N - 1);
    CalcD(Cx, Cy);
    sc = sz = 0;
    a = Test1();
    if (a == CROSS) sc++;
    else if (a == ZERO) sz++;
    a = Test2();
    if (a == CROSS) sc++;
    else if (a == ZERO) sz++;
    a = Test3();
    if (a == CROSS) sc++;
    else if (a == ZERO) sz++;
    a = Test4();
    if (a == CROSS) sc++;
    else if (a == ZERO) sz++;
//    printf("c=%d z=%d\n", sc, sz);
    if (sc > sz)
      printf("X\n");
    else if (sc < sz)
      printf("0\n");
    else
    {
      for (j = 0; j < W; j++)
        CalcD(j, Cy);
      for (x1 = Cx; x1 >= 0; x1--)
        if (D[Cy][x1][2] <= 1)
          break;
      for (x2 = Cx; x2 < W; x2++)
        if (D[Cy][x2][2] <= 1)
          break;
      if ((x2 - x1) * 5 >= (X2 - X1) * 2)
        printf("O\n");
      else
        printf("X\n");
    }
    if (S[H][0] == '#')
      return 0;
  }
}
