#include <stdio.h>
#include <math.h>

#define MINI(A, B) ((A) < (B) ? (A) : (B))
#define MAXI(A, B) ((A) > (B) ? (A) : (B))

#define EPS 1e-9
#define SUB 1e-6

#define MAX 50011
#define SHIFT 10001

int N, K;
double X[MAX], Y[MAX];

double Size( double y )
{
  int i;
  double s = 0, ymin, ymax;
 
  for (i = 0; i < N; i++)
    if ((ymin = MINI(Y[i], Y[i + 1])) + EPS >= y)
      s += (Y[i + 1] + Y[i] - y * 2) * (X[i + 1] - X[i]);
    else if ((ymax = MAXI(Y[i], Y[i + 1])) - EPS > y)
      s += (ymax - y) * (ymax - y) * (X[i + 1]  - X[i]) / (ymax - ymin);
  return fabs(s * 0.5);
}

int main( void )
{
  int i;
  double S, S1, S2, min, ave, max;

  freopen("antiufo.in", "rt", stdin);
  freopen("antiufo.out", "wt", stdout);
  scanf("%d%d", &N, &K);
  for (i = 0; i < N; i++)
    scanf("%lf%lf", &X[i], &Y[i]), X[i] += SHIFT, Y[i] += SHIFT;
  X[N] = X[0], Y[N] = Y[0];
  S = Size(0);
  for (i = 0; i < K; i++)
  {
    S1 = S * (K - i) / (K + 1);
    min = 0, max = SHIFT * 2;
    while (min + SUB < max)
    {
      ave = (min + max) * 0.5;
      if ((S2 = Size(ave)) > S1)
        min = ave;
      else
        max = ave;
    }
    printf("%.4lf\n", min - SHIFT);
  }
  return 0;
}
