#include <stdio.h>
#include <stdlib.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define MAX 2013

typedef unsigned int dword;

int Sx, Sy, Ex, Ey, N, X[MAX], Y[MAX];
int VN = 0, VX[MAX], VY[MAX];
dword MinD[MAX], Mark[MAX], U[MAX], D[MAX][MAX];
char Is[MAX][MAX];

void Add( int x, int y ) 
{
  int i;

  for (i = 0; i < VN; i++)
    if (VX[i] == x && VY[i] == y)
      return;
  VX[VN] = x, VY[VN++] = y;
}

int CheckH( int x1, int x2, int y1 )
{
  int i;

  if (x1 == x2)
    return 1;
  for (i = 0; i < N; i++)
    if (Y[i] == y1 && x1 <= X[i] && X[i] <= x2)
      return 0;
  return 1;
}
     
int CheckV( int y1, int y2, int x1 )
{
  int i;

  if (y1 == y2)
    return 1;
  for (i = 0; i < N; i++)
    if (X[i] == x1 && y1 <= Y[i] && Y[i] <= y2)
      return 0;
  return 1;
}          
     
int CheckD1( int x1, int y1, int x2, int y2 )
{
  int i;

  if (x1 == x2 && y1 == y2)
    return 1;
  for (i = 0; i < N; i++)
    if (X[i] + Y[i] == x1 + y1 && x1 <= X[i] && X[i] <= x2)
      return 0;
  return 1;
}
     
int CheckD2( int x1, int y1, int x2, int y2 )
{
  int i;

  if (x1 == x2 && y1 == y2)
    return 1;
  for (i = 0; i < N; i++)
    if (X[i] - Y[i] == x1 - y1 && x1 <= X[i] && X[i] <= x2)
      return 0;
  return 1;
}
     
int Dist( int x1, int y1, int x2, int y2 )
{
  int tmp, d = 0, dx, dy;

  if (x1 > x2)
    SWAP(x1, x2, tmp), SWAP(y1, y2, tmp);
  dx = x2 - x1, dy = abs(y1 - y2);
  if (dx > dy)
  {
    if (!CheckH(x1, x1 + (dx - dy), y1))
      return -1;
    d += dx - dy, x1 += dx - dy;
  }
  if (dy > dx)
    if (y1 > y2)
    {
      if (!CheckV(y1 - (dy - dx), y1, x1))
        return -1;
      d += dy - dx, y1 -= dy - dx;
    }
    else
    {
      if (!CheckV(y1, y1 + (dy - dx), x1))
        return -1;
      d += dy - dx, y1 += dy - dx;
    }
  if (y1 > y2)
  {
    if (!CheckD1(x1, y1, x2, y2))
      return -1;
  }
  else
  {
    if (!CheckD2(x1, y1, x2, y2))
      return -1;
  }
  d += x2 - x1;
  return d;
}

int main( void )
{
  int i, j, a, mini;

  freopen("king.in", "rt", stdin);
  freopen("king.out", "wt", stdout);
  scanf("%d%d%d%d%d", &Sx, &Sy, &Ex, &Ey, &N);
  for (i = 0; i < N; i++)
    scanf("%d%d", &X[i], &Y[i]);
  if (Sx == Ex && Sy == Ey)
  {
    printf("-- 0");
    return 0;
  }
  Add(Sx, Sy);
  Add(Ex, Ey);
  for (i = 0; i < N; i++)
  {
    Add(X[i] + 1, Y[i]);
    Add(X[i] - 1, Y[i]);
    Add(X[i], Y[i] + 1);
    Add(X[i], Y[i] - 1);
  }
  memset(Is, 0, sizeof(Is));
  for (i = 0; i < VN; i++)
    for (j = i + 1; j < VN; j++)
    {
      a = Dist(VX[i], VY[i], VX[j], VY[j]);
      if (a >= 0)
      {
        Is[i][j] = Is[j][i] = 1, D[i][j] = D[j][i] = a;
        if (i == 0 && j == 1)
        {
          printf("++ %u", D[i][j]);
          return 0;
        }
      }
    }
  memset(U, 0, sizeof(U));
  memset(Mark, 0, sizeof(Mark));
  memset(MinD, 0, sizeof(MinD));
  MinD[mini = 0] = 0;
  U[mini] = 1;
  while (mini != -1)
  {
    Mark[mini] = 1;
    for (i = 0; i < VN; i++)
      if (!Mark[i] && Is[mini][i] && 
         (!U[i] || MinD[i] > MinD[mini] + D[mini][i]))
        U[i] = 1, MinD[i] = MinD[mini] + D[mini][i];
    mini = -1;
    for (i = 0; i < VN; i++)
      if (!Mark[i] && U[i] && (mini == -1 || MinD[i] < MinD[mini]))
        mini = i;
  }
  for (i = 0; i < VN; i++)
    if (VX[i] == Ex && VY[i] == Ey)
      break;
  if (U[i])
    printf("%u", MinD[i]);
  else
    printf("-1");
  return 0;
}
