#include <stdio.h>
#include <math.h>

#define INF 1e7
#define EPS 2e-14

#define MAX 5011

typedef long double t;

int N;
t X[MAX], R[MAX], CX, CY;

t MySqrtL( t x )
{
  t min = 0, max = INF, ave;

  while (min + EPS < max)
  {
    ave = (min + max) * 0.5;
    if (ave * ave > x)
      max = ave;
    else
      min = ave;
  }
  return min;
}

int F( double Y )
{
  t min = -INF, max = INF, a, x;
  int i;

  for (i = 0; i < N; i++)
  {
    if (R[i] + EPS < Y)
      return 0;
    a = MySqrtL(x = fabsl(R[i] * R[i] - Y * Y));
    if (X[i] - a > min)
      min = X[i] - a;
    if (X[i] + a < max)
      max = X[i] + a;
  }
  if (min > max + EPS)
    return 0;
  CX = min, CY = Y;
  return 1;
}

int main( void )
{
  t min = 0, max = INF, ave;
  int i;

  freopen("popular.in", "rt", stdin);
  freopen("popular.out", "wt", stdout);
  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%Lf%Lf", &X[i], &R[i]);
  while (min + EPS < max)
  {
    ave = (min + max) * 0.5;
    if (F(ave))
      min = ave;
    else
      max = ave;
  } 
  if (!F(min))
    printf("-1 -1");
  else
    printf("%.4Lf %.4Lf", CX, -CY);
  return 0;
}
