#include <stdio.h>
#include <string.h>

#define MAXK 11
#define MAXV 311
#define MAXE 20013

#define CAUGHT  1 
#define ESCAPED 2 
#define ENDLESS 3 
#define DONOW 4 

int VN, EN, K, E[MAXK], GodV, BadV;
int He[MAXK][MAXV], Ne[MAXK][MAXE], Y[MAXK][MAXE];
int Res[MAXV][MAXV], T[MAXV][MAXV];

int f( int godv, int badv )
{
  int *He1, *Ne1, *Y1;
  int k, e1, e2, v1, v2, r, ti, fca, fes, fen, a, minca, mines;

  if (Res[godv][badv])
    return Res[godv][badv];
  Res[godv][badv] = r = DONOW, ti = 0;
  for (k = 0; k < K; k++)
  {
    He1 = He[k], Ne1 = Ne[k], Y1 = Y[k];
    for (e1 = He1[godv]; e1 != -1; e1 = Ne1[e1])
    {
      v1 = Y1[e1];
      if (v1 == badv)
      {
        r = CAUGHT;
        ti = 1;
        continue;
      }
      fca = fes = fen = 0;
      if (f(v1, badv) == ESCAPED)
        fes = 1, mines = T[v1][badv] + 1;
      else if (f(v1, badv) != CAUGHT)
        fen = 1;
      else
        fca = 1, minca = T[v1][badv] + 1;
      for (e2 = He1[badv]; e2 != -1; e2 = Ne1[e2])
      {
        v2 = Y1[e2];
        if (v1 == v2)
        {
          if (!fca)
            minca = 1;
          fca = 1;
          continue;
        }
        if (v2 == 0)
        {
          fes = 1;
          mines = 1;
        }
        a = f(v1, v2);
        if (a == ESCAPED)
        {
          if (!fes || mines > T[v1][v2] + 1)
            mines = T[v1][v2] + 1;
          fes = 1;
        }
        else if (a == ENDLESS || a == DONOW)
          fen = 1;
        else if (a == CAUGHT)
        {
          if (!fca || minca < T[v1][v2] + 1)
            minca = T[v1][v2] + 1;
          fca = 1;
        }
      }
      if (fes)
      {
        if (r == DONOW)
          r = ESCAPED, ti = mines;
        else if (r == ESCAPED)
          if (ti < mines)
            ti = mines;
      }
      else if (fca && !fen)
      {
        if (r != CAUGHT || minca < ti)
          ti = minca;
        r = CAUGHT;
      } 
      else
      {
        if (r != CAUGHT)
          r = ENDLESS;
      }
    }
  }
  T[godv][badv] = ti;
  return Res[godv][badv] = r;
}

int main( void )
{
  int i, a, b, k;

  freopen("pursuit.in", "rt", stdin);
  freopen("pursuit.out", "wt", stdout);
  scanf("%d%d%d", &VN, &EN, &K);
  memset(E, 0, sizeof(E));
  memset(He, -1, sizeof(He));
  for (i = 0; i < EN; i++)
  {
    scanf("%d%d%d", &a, &b, &k), a--, b--, k--;
    Ne[k][E[k]] = He[k][a], Y[k][E[k]] = b, He[k][a] = E[k]++;
    Ne[k][E[k]] = He[k][b], Y[k][E[k]] = a, He[k][b] = E[k]++;
  }
  scanf("%d%d", &GodV, &BadV), GodV--, BadV--;
  if (GodV == BadV)
  {
    printf("Caught\n0");
    return 0;
  }
  memset(Res, 0, sizeof(Res));
  memset(T, 0, sizeof(T));
  k = f(GodV, BadV);
  if (k == ESCAPED)
    printf("Escaped\n%d", T[GodV][BadV]);
  else if (k == CAUGHT)
    printf("Caught\n%d", T[GodV][BadV]);
  else
    printf("Endless");
  return 0;
}
