#include <stdio.h>
#include <string.h>

#include "guess.h"

#define MAX 200113

int N, K, Q, A[MAX], B[MAX], Pr[MAX], Si[MAX];

int Get( int v )
{ 
  if (v == Pr[v])
    return v;
  return Get(Pr[v]);
}

void Join( int v1, int v2 )
{
  if (Si[v1] > Si[v2])
    Si[v1] += Si[v2], Pr[v2] = v1, A[v2] = (A[v2] - A[v1] + K) % K;
  else
    Si[v2] += Si[v1], Pr[v1] = v2, A[v1] = (A[v1] - A[v2] + K) % K;
}

int Val( int v )
{
  if (v == Pr[v])
    return A[v];
  return A[v] + Val(Pr[v]);
}

int Sub( int x, int y )
{
  return ((x % K) - (y % K) + K) % K;
}

void Do( void )
{
  int i;

  for (i = 0; i < N; i++)
    B[i] = Sub(Val(i + 1), Val(i));
}

int main( void )
{
  int i, L, R, S, Lv, Rv, tmp;

  Initialize(&N, &K, &Q);
  for (i = 0; i <= N; i++)
    A[i] = 0, Pr[i] = i, Si[i] = 1;
  for (i = 0; i < Q; i++)
  {
    NextQuery(&L, &R, &S);
    if (L > R)
      tmp = L, L = R, R = tmp;
    L--;
    Lv = Get(L), Rv = Get(R);
    if (Lv != Rv)
    {
      A[Rv] = (A[Rv] + Sub(Val(L) + S, Val(R)) + K) % K;
      Join(Lv, Rv);
    }
    else if (Sub(Val(R), Val(L)) != S)
      Do(), Error(N, B);
  }
  Do(), Consistent(N, B);
  return 0;
}
