#include <stdio.h>
#include <stdlib.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define PI 3.14159265358979323846

#define EPS 1e-9
#define INF (int)1e9
                 
#define MAX 300013
#define MAXN 100013
#define MAXK 10013

int N, K, W[MAX], Pos[MAXK];
long long S[MAX];
double A[MAX], St[MAXN];

void QSort( int L, int R )
{
  int i = L, j = R;
  double t, a;

  if (L >= R)
    return;
  a = A[L + (rand() % (R - L + 1))];
  while (i <= j)
  {
    while (A[i] < a)
      i++;
    while (A[j] > a)
      j--;
    if (i <= j)
    {
      SWAP(A[i], A[j], t);
      SWAP(W[i], W[j], t);
      i++, j--;
    }
  }
  QSort(L, j);
  QSort(i, R);
}

void QSort2( int L, int R )
{
  int i = L, j = R;
  double t, a;

  if (L >= R)
    return;
  a = St[L + (rand() % (R - L + 1))];
  while (i <= j)
  {
    while (St[i] < a)
      i++;
    while (St[j] > a)
      j--;
    if (i <= j)
      SWAP(St[i], St[j], t), i++, j--;
  }
  QSort2(L, j);
  QSort2(i, R);
}

int main( void )
{
  double dist;
  int i, j;
  long long d, mind, maxd, dif = INF;

  srand(3017);
  freopen("necklace.in", "rt", stdin);
  freopen("necklace.out", "wt", stdout);
  scanf("%d%d", &N, &K);
  if (K == 1)
  {
    printf("0"); 
    return 0;
  }
  for (i = 0; i < N; i++)
    scanf("%lf%d", &A[i], &W[i]);

  dist = 2 * PI / K;
  QSort(0, N - 1);
  for (i = 0; i < 2 * N; i++)
    A[N + i] = A[i] + 2 * PI, W[N + i] = W[i];
  for (S[0] = 0, i = 0; i < 3 * N; i++)
    S[i + 1] = S[i] + W[i];
  for (i = 0; i < N; i++)
    St[i] = A[i] - (int)((A[i] - A[0]) / dist + EPS) * dist;
  St[N] = St[0] + dist;
  QSort2(0, N - 1);

  Pos[0] = 0;
  for (i = 0; i <= K; i++)
  {
    while (A[Pos[i]] + EPS < St[0] + dist * (i + 1))
      Pos[i]++;
    Pos[i + 1] = Pos[i];
  }
  for (j = 0; j < N; j++)
  {
    mind = INF, maxd = 0;
    for (i = 0; i < K; i++)
    {
      d = S[Pos[i + 1]] - S[Pos[i]];
      if (d < mind)
        mind = d;
      if (d > maxd)
        maxd = d;
    }
    for (i = 0; i <= K; i++)
      while (A[Pos[i]] + EPS < St[j + 1] + dist * (i + 1))
        Pos[i]++;
    if (maxd - mind < dif)
      dif = maxd - mind;
  }
  printf("%Ld", dif);
  return 0;
}
