program pb;
 uses sysutils;
 type point=record
  x,y:longint;
 end;
 type ppoint=record
  x,y,r,t:longint;
 end;
 type rect=record
  p1,p2:point;
  k1,k2,l1,l2:longint;
 end;
 var n:longint;
     rec:array[1..100000] of rect;
     a,b:array[1..100000] of ppoint;
     val:array[1..100000] of int64;
     fr:array[1..100000] of longint;
     cost:array[1..100000] of longint;
     tim,tno:extended;
     gr:longint;

 procedure load;
  var i:longint;
 begin
  assign(input,'rects.in');
  reset(input);
   read(n);
   for i:=1 to n do
    read(rec[i].p1.x,rec[i].p2.y,rec[i].p2.x,rec[i].p1.y,cost[i]);
  close(input);
 end;

 procedure print(x:longint);
 begin
  if fr[x]<>0 then print(fr[x]);
  write(x,' ');
 end;

 procedure save;
  var i,mn:longint;
      mx:int64;
 begin
  assign(output,'rects.out');
  rewrite(output);
   mx:=0;
   for i:=1 to n do
    if mx<val[i] then begin
     mx:=val[i];
     mn:=i;
    end;
   writeln(mx);
   print(mn);
  close(output);
 end;

 procedure qsort1;

  procedure sort(l,r: longint);
    var
       i,j: longint;
       x,y:ppoint;
    begin
       i:=l;
       j:=r;
       x:=a[(l+r) div 2];
       repeat
         while (a[i].x<x.x) do
          inc(i);
         while (x.x<a[j].x) do
          dec(j);
         if not(i>j) then
           begin
              y:=a[i];
              a[i]:=a[j];
              a[j]:=y;
              inc(i);
              j:=j-1;
           end;
       until i>j;
       if l<j then
         sort(l,j);
       if i<r then
         sort(i,r);
    end;

 begin
    sort(1,2*n);
 end;

 procedure qsort2;

  procedure sort(l,r: longint);
    var
       i,j: longint;
       x,y:ppoint;
    begin
       i:=l;
       j:=r;
       x:=b[(l+r) div 2];
       repeat
         while (b[i].y<x.y) do
          inc(i);
         while (x.y<b[j].y) do
          dec(j);
         if not(i>j) then
           begin
              y:=b[i];
              b[i]:=b[j];
              b[j]:=y;
              inc(i);
              j:=j-1;
           end;
       until i>j;
       if l<j then
         sort(l,j);
       if i<r then
         sort(i,r);
    end;

 begin
    sort(1,2*n);
 end;

 function max(x,y:int64):int64;
 begin
  if x>y then max:=x else max:=y;
 end;

 function find(x:longint):int64;
  var i,mf:longint;
      mx,tm:int64;
 begin
  if val[x]<>0 then begin
   find:=val[x];
   exit;
  end;
  if gr>10000000 then begin
   tno:=time;
   if (tno-tim)*12*60*60>0.9 then begin
    save;
    halt(0);
   end;
  end;
  mx:=0;
  mf:=0;
  inc(gr,2*n-(rec[x].k2+1));
  for i:=rec[x].k2+1 to 2*n do
   if (a[i].t=2)and(rec[a[i].r].p2.y>rec[x].p1.y)
      and(rec[a[i].r].p2.x>rec[x].p1.x) then begin
    tm:=find(a[i].r);
    if tm>mx then begin
     mx:=tm;
     mf:=a[i].r;
    end;
   end;
  val[x]:=mx;
  inc(val[x],cost[x]);
  fr[x]:=mf;
  find:=val[x];
 end;

 procedure solve;
  var i,j:longint;
 begin
  gr:=0;
  tim:=time;
  for i:=1 to n do begin
   rec[i].p1.x:=-rec[i].p1.x;
   rec[i].p2.x:=-rec[i].p2.x;
  end;

  for i:=1 to n do begin
   rec[i].k1:=2*i-1;
   rec[i].k2:=2*i;
   rec[i].l1:=2*i-1;
   rec[i].l2:=2*i;
   a[2*i-1].x:=rec[i].p1.x;
   a[2*i-1].y:=rec[i].p1.y;
   a[2*i-1].r:=i;
   a[2*i-1].t:=1;
   a[2*i].x:=rec[i].p2.x;
   a[2*i].y:=rec[i].p2.y;
   a[2*i].r:=i;
   a[2*i].t:=2;
   b[2*i-1].x:=rec[i].p1.x;
   b[2*i-1].y:=rec[i].p1.y;
   b[2*i-1].r:=i;
   b[2*i-1].t:=1;
   b[2*i].x:=rec[i].p2.x;
   b[2*i].y:=rec[i].p2.y;
   b[2*i].r:=i;
   b[2*i].t:=2;
  end;
  qsort1;
  for i:=1 to 2*n do
   if a[i].t=1 then rec[a[i].r].k1:=i
    else rec[a[i].r].k2:=i;
{  qsort2;
  for i:=1 to 2*n do
   if b[i].t=1 then rec[b[i].r].l1:=i
    else rec[b[i].r].l2:=i;}
  fillchar(fr,sizeof(fr),0);
  fillchar(val,sizeof(val),0);
  for i:=2*n downto 1 do if a[i].t=1 then
   if val[a[i].r]=0 then find(a[i].r);
 end;

begin
 load;
 solve;
 save;
end.
