const
        MaxN = 200;
type
        TPoint =
        record
          x, y : Real;
        end;
        TVector =
        record
          x, y : Real;
        end;
        TTD =
        record
          t : Real;
          dx, dy : Real;
          d : LongInt;
        end;

var
        n, r, c, cc : LongInt;
        can : Array[1 .. MaxN] of
        record
          l, r : Real;
        end;
        a : Array[1 .. MaxN] of TPoint;
        time : Array[1 .. MaxN] of TTD;
        p0, p : TPoint;
        max : Real;
        v0, v : TVector;

Procedure Init;
var
        i : LongInt;
begin
  c := 0;
  ReadLn(r, n);
  for i := 1 to n do
    Read(a[i].x, a[i].y);
end;

Procedure MakeVector(const n, k : TPoint; var v : TVector);
begin
  v.x := k.x - n.x;
  v.y := k.y - n.y;
end;

Function PA(const v : TVector) : Real;
var
        rez : Real;
begin
  if v.x = 0 then
  begin
    if v.y < 0 then
      PA := Pi * 2 / 3
    else
      PA := Pi / 2;
  end
  else
  begin
    rez := ArcTan(v.y / v.x);
    if v.x < 0 then
      rez := rez + Pi
    else
      if v.y < 0 then
        rez := rez + Pi * 2;
    PA := rez;
  end;
end;

Procedure Addd(const t : Real; const d : LongInt; const x, y : Real);
var
        v : TVector;
begin
  Inc(cc);
  time[cc].t := t;
  time[cc].d := d;
  time[cc].dx := x;
  v.x := x;
  v.y := y;
  time[cc].dy := y;
  if cc mod 2 = 1 then
    can[(cc - 1) div 2 + 1].l := PA(v)
  else
    can[cc div 2 + 1].r := PA(v);
end;

Procedure Swap(var a, b : TTD);
var
        c : TTD;
begin
  c := a;
  a := b;
  b := c;
end;

Procedure Solve;
var
        v1, v2 : TVector;
        i, j, r, min : LongInt;
        p : TPoint;
begin
  for i := 1 to n - 2 do
  begin
    MakeVector(a[i], a[i + 1], v1);
    MakeVector(a[i + 1], a[i + 2], v2);
    MakeVector(a[i + 1], a[i], v1);
    Addd(PA(v2), 1, v2.x, v2.y);
    Addd(PA(v1), -1, v1.x, v1.y);
  end;
  r := 0;
  for i := 1 to n - 2 do
    if can[i].l > can[i].r then
      Inc(r);
  for i := 1 to cc do
  begin
    min := i;
    for j := i + 1 to cc do
      if time[j].t < time[min].t then
        min := j;
    Swap(time[min], time[i]);
  end;
  for i := 1 to cc do
  begin
    if r = n - 2 then
      Break;
    Inc(r, time[i].d);
  end;
  if r = n - 2 then
  begin
    WriteLn(p.x : 0 : 6, p.y : 0 : 6, ' ', time[i].dx : 0 : 6, ' ', time[i].dy : 0 : 6);
  end
  else
    WriteLn(-1);
end;

Procedure Print;
begin
end;

Procedure MulVector(var v : TVector; const r : real);
begin
  v.x := v.x * r;
  v.y := v.y * r;
end;

Procedure Primvector(const v : TVector; const p : TPoint; var rez : TPoint);
begin
  rez.x := p.x + v.x;
  rez.y := p.y + v.y;
end;

Procedure NormVector(var v : TVector);
var
        l : Real;
begin
  l :=Sqrt(Sqr(v.x) + Sqr(v.y));
  v.x := v.x / l;
  v.y := v.y / l;
end;

begin
  Assign(input, 'glass.in');
  Reset(input);
  Assign(output, 'glass.out');
  Rewrite(output);
  Init;
{  Solve;
  Print;}
  if n = 2 then
  begin
    MakeVector(a[1], a[2], v);
    MulVector(v, 0.5);
    PrimVector(v, a[1], p);
    v0.x := v.y;
    v0.y := -v.x;
    NormVector(v0);
    max := r;
    While True do
    begin
      MulVector(v0, max);
      PrimVector(v0, p, p0);
      if Sqr(p0.x) + Sqr(p0.y) < r * r then
        Break;
      max := max / 2;
      v0.x := v.y;
      v0.y := -v.x;
      NormVector(v0);
    end;
    WriteLn(p0.x : 0 : 6, ' ', p0.y : 0 : 6, ' ', v0.x : 0 : 6, ' ', v0.y : 0 : 6);
  end
  else
    WriteLn(-1);
  Close(input);
  Close(output);
end.