const
        MaxN = 55;
        MaxK = MaxN;
type
        TP = ^TT;
        TT =
        record
          data : LongInt;
          next : TP;
        end;
var
        n, k, a, b, m : LongInt;
        sm, sm2 : Array[0 .. MaxN * MaxK * 2 + 1] of TP;
        pred : Array[0 .. MaxN * MaxK * 2 + 1] of LongInt;
        s : Array[0 .. MaxN * MaxK * 2 + 1, 0 .. MaxN * MaxK * 2 + 1] of Word;

Procedure Add(const a, b : LongInt; const c : Boolean);
var
        t : TP;
begin
  t := sm[a];
  New(sm[a]);
  sm[a]^.data := b;
  sm[a]^.next := t;
  if c then
  begin
    t := sm2[a];
    New(sm2[a]);
    sm2[a]^.data := b;
    sm2[a]^.next := t;
  end;
end;

Procedure Init;
var
        i, j, x, y, c : LongInt;
begin
  ReadLn(n, k, a, b, m);
  for i := 1 to m do
  begin
    Read(x, y, c);
    for j := 1 to k do
      if j <> c then
        Add((x - 1) * 2 * k + k + j, (y - 1) * 2 * k + c, True);
  end;
  for i := 1 to k do
    Add(0, (a - 1) * 2 * k + i, True);
  for i := 1 to k do
    Add((b - 1) * 2 * k + k + i, k * (2 * n - 1) + 1, True);
  a := 0;
  b := k * (2 * n - 1) + 1;
  for i := 1 to n - 1 do
    for j := 1 to k do
      Add((i - 1) * 2 * k + j, (i - 1) * 2 * k + k + j, True);
end;

Procedure Delete(const a, b : LongInt);
var
        t, g : TP;
begin
  t := sm[a];
  if t^.next = nil then
    if t^.data = b then
    begin
      Dispose(t);
      sm[a] := nil;
      Exit;
    end;
  While t^.next^.next <> nil do
  begin
    if t^.next^.data = b then
    begin
      g := t^.next;
      t^.next := g^.next;
      Dispose(g);
      Exit;
    end;
    t := t^.next;
  end;
  if t^.next^.data = b then
  begin
    g := t^.next;
    Dispose(g);
    t^.next := nil;
  end;
end;

Procedure RefreshWay;
var
        r : LongInt;
begin
  r := b;
  While r <> a do
  begin
    Delete(pred[r], r);
    Add(r, pred[r], False);
    r := pred[r];
  end;
end;

Procedure RefreshWay2;
var
        r : LongInt;
begin
  r := b;
  While r <> a do
  begin
    Add(r, pred[r], False);
    r := pred[r];
  end;
end;

Procedure PredSolve;
var
        bfs, bfs2, t, g : TP;
        bo : Boolean;
        i : LongInt;
begin
  bo := True;
  While bo do
  begin
    bo := False;
    New(bfs);
    bfs^.data := 0;
    bfs^.next := nil;
    bfs2 := nil;
    pred[0] := 0;
    for i := 1 to k * (2 * n - 1) + 1 do
      pred[i] := -1;
    While bfs <> nil do
    begin
      While bfs <> nil do
      begin
        if bfs^.data = b then
        begin
          RefreshWay;
          bo := True;
          While bfs <> nil do
          begin
            t := bfs;
            bfs := bfs^.next;
            Dispose(t);
          end;
          While bfs2 <> nil do
          begin
            t := bfs2;
            bfs2 := bfs2^.next;
            Dispose(t);
          end;
          Break;
        end
        else
        begin
          t := sm[bfs^.data];
          While t <> nil do
          begin
            if pred[t^.data] = -1 then
            begin
              g := bfs2;
              New(bfs2);
              bfs2^.data := t^.data;
              bfs2^.next := g;
              pred[t^.data] := bfs^.data;
            end;
            t := t^.next;
          end;
        end;
        t := bfs;
        bfs := bfs^.next;
        Dispose(t);
      end;
      bfs := bfs2;
      bfs2 := nil;
    end;
  end;
end;

Procedure Solve;
var
        i, j : LongInt;
        t : TP;
begin
  for i := 0 to (n - 1) * k * 2 + 1 do
  begin
    While sm2[i] <> nil do
    begin
      s[i][sm2[i]^.data] := 1;
      t := sm2[i];
      sm2[i] := sm2[i]^.next;
      Dispose(t);
    end;
  end;
  for i := 0 to (n - 1) * k * 2 + 1 do
  begin
    While sm[i] <> nil do
    begin
      if s[i][sm[i]^.data] = 1 then
        s[i][sm[i]^.data] := 2;
      t := sm[i];
      sm[i] := sm[i]^.next;
      Dispose(t);
    end;
  end;
  for i := 0 to (n - 1) * k * 2 + 1 do
    for j := 0 to (n - 1) * k * 2 + 1 do
      if s[i][j] = 1 then
      begin
        t := sm[i];
        New(sm[i]);
        sm[i]^.data := j;
        sm[i]^.next := t;
      end;
end;

Procedure Print;
var
        rez, r, i : LongInt;
        t, bfs, bfs2, g : TP;
        bo : Boolean;
begin
  rez := 0;
  t := sm[0];
  While t <> nil do
  begin
    Inc(rez);
    t := t^.next;
  end;
  WriteLn(rez);
  bo := True;
  for r := 1 to rez do
  begin
    bo := True;
    While bo do
    begin
      bo := False;
      New(bfs);
      bfs^.data := 0;
      bfs^.next := nil;
      bfs2 := nil;
      pred[0] := 0;
      for i := 1 to k * (2 * n - 1) + 1 do
        pred[i] := -1;
      While bfs <> nil do
      begin
        While bfs <> nil do
        begin
          if bfs^.data = b then
          begin
            RefreshWay2;
            bo := True;
            While bfs <> nil do
            begin
              t := bfs;
              bfs := bfs^.next;
              Dispose(t);
            end;
            While bfs2 <> nil do
            begin
              t := bfs2;
              bfs2 := bfs2^.next;
              Dispose(t);
            end;
            Break;
          end
          else
          begin
            t := sm[bfs^.data];
            While t <> nil do
            begin
              if pred[t^.data] = -1 then
              begin
                g := bfs2;
                New(bfs2);
                bfs2^.data := t^.data;
                bfs2^.next := g;
                pred[t^.data] := bfs^.data;
              end;
              t := t^.next;
            end;
          end;
          t := bfs;
          bfs := bfs^.next;
          Dispose(t);
        end;
        if bo then
          Break;
        bfs := bfs2;
        bfs2 := nil;
      end;
    end;
  end;
end;

begin
  n := n;
  n := n;
  n := n;
  Assign(input, 'rhyme.in');
  Reset(input);
  Assign(output, 'rhyme.out');
  Rewrite(output);
  Init;
  PredSolve;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
