const
        MaxN = 5010;
        _eps = 1e-5;
type
        Real = Extended;
        TOkr =
        record
          x, r : Real;
        end;
        TPoint =
        record
          x, y : Real;
        end;
        TP =
        record
          p : Real;
          d, okr : LongInt;
        end;
var
        o : Array[1 .. MaxN] of TOkr;
        point : Array[1 .. MaxN * 2] of TP;
        n : LongInt;

Function Dist(const x1, y1, x2, y2 : Real) : Real;
begin
  Dist := Sqr(x1 - x2) + Sqr(y1 - y2);
end;

Procedure Print(const p : TPoint);
begin
  Assign(output, 'popular.out');
  Rewrite(output);
  WriteLn(p.x : 0 : 4, ' ', p.y : 0 : 4);
  Close(output);
  Halt;
end;

Procedure Swap(var a, b : TP);
var
        c : TP;
begin
  c := a;
  a := b;
  b := c;
end;

Function RealMore(const a, b : Real) : Boolean;
begin
  RealMore := a - _eps > b;
end;

Function RealEq(const a, b : Real) : Boolean;
begin
  RealEq := Abs(a - b) < _eps;
end;

Function More(const a, b : TP) : Boolean;
begin
  More := (RealMore(a.p, b.p)) or ((RealEq(a.p, b.p)) and (a.d < b.d));
end;

Procedure QSort(const l, r : Word);
var
        i, j : Word;
        x : TP;
begin
  i := l;
  j := r;
  x := point[(l + r) div 2];
  repeat
    While More(x, point[i]) do
      Inc(i);
    While More(point[j], x) do
      Dec(j);
    if i <= j then
    begin
      Swap(point[i], point[j]);
      Inc(i);
      Dec(j);
    end;
  until i > j;
  if l < j then
    QSort(l, j);
  if i < r then
    QSort(i, r);
end;

Function Min(const a, b : Real) : Real;
begin
  if a < b then
    Min := a
  else
    Min := b;
end;

Function Max(const a, b : Real) : Real;
begin
  if a > b then
    Max := a
  else
    Max := b;
end;

Procedure Init;
var
        i, j : LongInt;
        o1, o2 : LongInt;
        pokr : LongInt;
        p, s, h : Real;
        po : TPoint;
begin
  Assign(input, 'popular.in');
  Reset(input);
  ReadLn(n);
  for i := 1 to n do
  begin
    ReadLn(o[i].x, o[i].r);
    point[i * 2 - 1].p := o[i].x - o[i].r;
    point[i * 2 - 1].d := 1;
    point[i * 2 - 1].okr := i;
    point[i * 2].p := o[i].x + o[i].r;
    point[i * 2].d := -1;
    point[i * 2].okr := i;
  end;
  Close(input);
  QSort(1, i * 2);
  pokr := 0;
  for i := 1 to n * 2 do
  begin
    Inc(pokr, point[i].d);
    if pokr = n then
    begin
      o1 := point[i].okr;
      o2 := point[i + 1].okr;
      p := (o[o1].r + o[o2].r + Abs(o[o1].x - o[o2].x)) / 2;
      s := Sqrt(p * (p - o[o1].r) * (p - o[o2].r) * (p - Abs(o[o1].x - o[o2].x)));
      h := s * 2 / Abs(o[o1].x - o[o2].x);
      po.y := -Abs(h);
      po.x := Sqrt(Sqr(o[o1].r) - Sqr(po.y)) + o[o1].x;
      if (po.x < Min(o[o1].x, o[o2].x)) or (po.x > Max(o[o1].x, o[o2].x)) then
        po.x := -Sqrt(Sqr(o[o1].r) - Sqr(po.y)) + o[o1].x;
      Print(po);
    end;
  end;
    Assign(output, 'popular.out');
    Rewrite(output);
    WriteLn('-1 -1');
    Close(output);
{  for i := 1 to n do
    if i <> okr then
      if (Abs(o[i].x - o[okr].x) + o[i].r >= o[okr].r) and (Abs(o[i].x - o[okr].x) + o[okr].r >= o[i].r) then
      begin
        can := True;
        for j := 1 to n do
          if Sqr(po.y) + Sqr(o[j].x - po.x)- _eps > Sqr(o[j].r) then
            can := False;
        if can then
          Print(po);
        po.x := -Sqrt(Sqr(o[i].r) - Sqr(po.y)) + o[i].x;
        can := True;
        for j := 1 to n do
          if Sqr(po.y) + Sqr(o[j].x - po.x)- _eps > Sqr(o[j].r) then
            can := False;
        if can then
          Print(po);
      end;}
end;

begin
  Init;
end.
