{$Q-,R-,S-,I-}

type float=extended;
     TVector = record x, y: float; end;

const maxn = 200;
      eps = 1e-10;
      v0: TVector = (x: 0; y: 0);

var n, i: longint;
    r: float;
    p: array [1..maxn] of TVector;
    v, vcur: TVector;
    minangle, maxangle: float;
    minv, maxv: TVector;
    angle: float;
    ansp, ansv, bv: TVector;
    max: float;
    vv: TVector;
    k:float;

function vect (const a, b: TVector): float;
begin
  vect := a.x * b.y - a.y * b.x;
end;

function scalar (const a, b: TVector): float;
begin
  scalar := a.x * b.x + a.y * b.y;
end;

procedure minus (const a, b: TVector; var c: TVector);
begin
  c.x := a.x - b.x;
  c.y := a.y - b.y;
end;

function equal (const a, b: float): boolean;
begin
  if abs (a-b) < eps then equal := true else equal := false;
end;

procedure sum (const a, b: TVector; var c: TVector);
begin
  c.x := a.x + b.x;
  c.y := a.y + b.y;
end;

function dist2 (const a, b: TVector): float;
begin
  dist2 := sqr (a.x - b.x) + sqr (a.y - b.y);
end;

begin
  assign (input, 'glass.in');
  reset (input);
  assign (output, 'glass.out');
  rewrite (output);
  read (r, n);
  for i := 1 to n do
    read (p [i].x, p [i].y);
  minus (p [n], p [1], v);
  minv := v;
  minus (v0, v, maxv);
  for i := 1 to n-1 do
  begin
    minus (p [i+1], p [i], vcur);
    if equal (vect (vcur, v), 0) then continue;
    if vect (vcur, v) > 0 then
    begin
      minus (v0, vcur, vcur);
      if vect (vcur, maxv) > 0 then maxv := vcur;
    end else
      if vect (minv, vcur) > 0 then minv := vcur;
  end;
  bv.x := (p [n].x + p [1].x) / 2;
  bv.y := (p [n].y + p [1].y) / 2;
  max := dist2 (bv, v0);
  if equal (max, 0) then
  begin
    bv.x := -v.y/3;
    bv.y := v.x/3;
    max := dist2 (bv, v0);
  end;
  if vect (minv, maxv) < 0 then writeln (-1) else
  begin
    sum (minv, maxv, ansv);
    for i := 2 to n-1 do
    begin
      minus (p [i], p [1], vcur);
      if (vect (v, vcur) > 0) and (dist2 (p [i], v0) > max) then
      begin
        max := dist2 (p [i], v0);
        bv := p [i];
      end;
    end;
    k := sqrt (((r*r + dist2 (bv, v0))/2) / dist2 (bv, v0));
    ansp.x := bv.x * k;
    ansp.y := bv.y * k;
    writeln (ansp.x:0:5, ' ', ansp.y:0:5, ' ', ansv.x:0:5, ' ', ansv.y:0:5);
  end;
  close (input);
  close (output);
end.