{$Q-,R-,S-,I-}
const maxn = 210;
      eps = 1e-7;

type
     real = double;
     TPoint = record x, y: real; end;
     TPointList = array [1..maxn] of TPoint;

var n, k, i, j, l, q: longint;
    g, f: TPointList;
    c, m1, v1, v2: TPoint;
    bp: TPoint;
    br: real;
    maxangle1, maxangle2, angle: real;
    maxnum1, maxnum2: longint;
    coss, r: real;
    maxr: real;

function vect (const p1, p2, p3: TPoint):real;
begin
  vect := p1.x * p2.y - p1.y * p2.x +
          p2.x * p3.y - p2.y * p3.x +
          p3.x * p1.y - p3.y * p1.x;
end;

function online (const p1, p2, p3: TPoint): boolean;
begin
  if abs (vect (p1, p2, p3)) < eps then online := true else online := false;
end;

function scalar (const p1, p2, p3: TPoint): real;
begin
  scalar := (p3.x - p1.x) * (p2.x - p1.x) + (p3.y - p1.y) * (p2.y - p1.y);
end;

function between (const p1, p2, p3: TPoint): boolean;
begin
  if abs (vect (p1, p2, p3)) > eps then between := false else
    if scalar (p1, p2, p3) < 0 then between := true else
    between := false;
end;

procedure cross (const m1, v1, m2, v2: TPoint; var c: TPoint);
var d, dt1, dt2, t1, t2: real;
begin
  d := - v1.x * v2.y + v2.x * v1.y;
  dt1 :=  - (m2.x - m1.x) * v2.y + (m2.y - m1.y) * v2.x;
  t1 := dt1 / d;
  c.x := m1.x + t1 * v1.x;
  c.y := m1.y + t1 * v1.y;
end;

procedure center (const p1, p2, p3: TPoint; var c: TPoint);
var m1, m2, v1, v2: TPoint;
    d, dt1, dt2, t1, t2: real;
begin
  m1.x := (p1.x + p2.x) / 2;
  m1.y := (p1.y + p2.y) / 2;
  m2.x := (p3.x + p2.x) / 2;
  m2.y := (p3.y + p2.y) / 2;
  v1.x := p2.y - p1.y;
  v1.y := p1.x - p2.x;
  v2.x := p2.y - p3.y;
  v2.y := p3.x - p2.x;
  cross (m1, v1, m2, v2, c);
end;

function dist2 (const a, b: TPoint): real;
begin
  dist2 := sqr (b.x - a.x) + sqr (b.y - a.y);
end;

function dist (const a, b: TPoint): real;
begin
  dist := sqrt (dist2 (a, b));
end;

function inside_angle (const a, o, b, x: TPoint):boolean;
begin
  if (vect (a, o, x) * vect (a, o, b) > -eps) and
     (vect (b, o, x) * vect (b, o, a) > -eps) then
     inside_angle := true else inside_angle := false;
end;

function inside_pol (const a: TPoint):boolean;
var i: longint;
begin
  for i := 1 to n do
    if not inside_angle (g [i], g [i+1], g [i+2], a) then
    begin
      inside_pol := false;
      exit;
    end;
  inside_pol := true;
end;

begin
  assign (input, 'fire.in');
  reset (input);
  assign (output, 'fire.out');
  rewrite (output);
  read (n);
  for i := 1 to n do
    read (g [i].x, g [i].y);
  g [n+1] := g [1];
  g [n+2] := g [2];
  read (k);
  for i := 1 to k do
    read (f [i].x, f [i].y);
  for i := 1 to k-1 do
    for j := i+1 to k do
    begin
      maxnum1 := 0;
      maxangle1 := 0;
      for l := 1 to k do
      begin
        if l = i then continue;
        if l = j then continue;
        if vect (f [l], f [i], f [j]) > 0 then
        begin
          coss := scalar (f [l], f [i], f [j]);
          if abs (coss) < eps then angle := pi/2 else
          angle := arctan (abs (vect (f [l], f [i], f [j])) / coss);
          if angle < 0 then angle := angle + pi;
          if angle - maxangle1 > eps then
          begin
            maxangle1 := angle;
            maxnum1 := l;
          end;
        end;
      end;
      maxnum2 := 0;
      maxangle2 := 0;
      for l := 1 to k do
      begin
        if l = i then continue;
        if l = j then continue;
        if vect (f [l], f [i], f [j]) < 0 then
        begin
          coss := scalar (f [l], f [i], f [j]);
          if abs (coss) < eps then angle := pi/2 else
          angle := arctan (abs (vect (f [l], f [i], f [j])) / coss);
          if angle < 0 then angle := angle + pi;
          if angle - maxangle2 > eps then
          begin
            maxangle2 := angle;
            maxnum2 := l;
          end;
        end;
      end;
      if (maxnum1 = 0) and (maxnum2 = 0) then continue;
      if maxnum1 = 0 then
      begin
        center (f [maxnum2], f [i], f [j], c);
        if inside_pol (c) then
        begin
          maxr := 10000000;
          for l := 1 to k do
          begin
            r :=  dist (f [l], c);
            if r - maxr < 0 then
              maxr := r;
          end;
          if maxr - br > 0 then
          begin
            br := r;
            bp := c;
          end;
        end;
        continue;
      end;
      if maxnum2 = 0 then
      begin
        center (f [maxnum1], f [i], f [j], c);
        if inside_pol (c) then
        begin
          maxr := 10000000;
          for l := 1 to k do
          begin
            r :=  dist (f [l], c);
            if r - maxr < 0 then
              maxr := r;
          end;
          if maxr - br > 0 then
          begin
            br := r;
            bp := c;
          end;
        end;
        continue;
      end;
      if maxangle1 + maxangle2 - pi > 0 then continue;
      center (f [maxnum1], f [i], f [j], c);
      if inside_pol (c) then
      begin
        maxr := 10000000;
        for l := 1 to k do
        begin
          r :=  dist (f [l], c);
          if r - maxr < 0 then
            maxr := r;
        end;
        if maxr - br > 0 then
        begin
          br := r;
          bp := c;
        end;
      end;
      center (f [maxnum2], f [i], f [j], c);
      if inside_pol (c) then
      begin
        maxr := 10000000;
        for l := 1 to k do
        begin
          r :=  dist (f [l], c);
          if r - maxr < 0 then
            maxr := r;
        end;
        if maxr - br > 0 then
        begin
          br := r;
          bp := c;
        end;
      end;
    end;
  for i := 1 to n do
  begin
    maxr := 10000000;
    for j := 1 to k do
    begin
      r := dist (g [i], f [j]);
      if r - maxr < 0 then
        maxr := r;
    end;
    if maxr - br > 0 then
    begin
      br := maxr;
      bp := g [i];
    end;
  end;
  writeln (bp.x:0:4, ' ', bp.y:0:4);
  close (input);
  close (output);
end.
 v.x := (g [i+1].x - g [i].x) / (_const + 1);
    v.y := (g [i+1].y - g [i].y) / (_const + 1);
    for j := 1 to _const do
    begin
      c.x := g [i].x + v.x * j;
      c.y := g [i].y + v.y * j;
      maxr := 10000000;
      for l := 1 to k do
      begin
        r := dist (c, f [l]);
        if r - maxr < 0 then
          maxr := r;
      end;
      if maxr - br > 0 then
      begin
        br := maxr;
        bp := c;
      end;
    end;
  end;
  writeln (bp.x:0:4, ' ', bp.y:0:4);
  close (input);
  close (output);
end.
