{$Q-,R-,S-,I-}

const
      _maxx = 7;
      maxx = 1 shl _maxx;

label 1;

type
     TVertex = record
                 sum: longint;
                 x1, x2, y1, y2, z1, z2, m: byte;
               end;
     TTree = array [1..(1 shl (3*(_maxx+1)) - 1) div 7 + 100] of TVertex;

//     int64=longint;

var x, y, z, x1, y1, z1, k, i, j, l, m: longint;
    a, pl: array [1..maxx, 1..maxx, 1..maxx] of longint;
    cur: longint;
    solved: boolean;
    op: int64;
    t: TTree;
    h: longint;

procedure inc_mod (var a: longint; const d: longint);
begin
  a := a + d;
  if a > k then a := a - (k+1);
end;

procedure dec_mod (var a: longint; const d: longint);
begin
  a := a - d;
  if a < 0 then a := a + k+1;
end;

function getvalue (const a, b, c: longint): longint;
var n, kol, p: longint;
    v: longint;
begin
  kol := (1 shl (3*(h+1)) - 1) div 7 - 1 shl (3*h);
  n := pl [a, b, c];
  v := t [n].sum;
  while n > 1 do
  begin
    p := (n+6) shr 3;
    inc_mod (v, t [p].sum);
    n := p;
  end;
  getvalue := v;
end;

procedure raise (const mx, my, mz, x, y, z, d: longint);
var i, p, n, kol: longint;
    pr: boolean;
begin
  kol := (1 shl (3*(h+1)) - 1) div 7 - 1 shl (3*h);
  n := pl [x, y, z];
  while n > 1 do
  begin
    p := (n+6) shr 3;
    for i := 8*p-6 to 8*p+1 do
    begin
      if t [i].m = 1 then continue;
      pr := false;
      case mx of
      0:if t [i].x1 < t [n].x1 then pr := true;
      1:if t [i].x1 > t [n].x1 then pr := true;
      end;
      case my of
      0:if t [i].y1 < t [n].y1 then pr := true;
      1:if t [i].y1 > t [n].y1 then pr := true;
      end;
      case mz of
      0:if t [i].z1 < t [n].z1 then pr := true;
      1:if t [i].z1 > t [n].z1 then pr := true;
      end;
      if pr then
      begin
        dec_mod (t [i].sum, d);
        t [i].m := 1;
      end;
    end;
    n := p;
  end;
end;

procedure raise_clear (const a, b, c, x, y, z, q: longint);
var kol, n, p, i: longint;
begin
  kol := (1 shl (3*(h+1)) - 1) div 7 - 1 shl (3*h);
  n := pl [x, y, z];
  while n > 1 do
  begin
    p := (n+6) shr 3;
    for i := 8*p-6 to 8*p+1 do
      t [i].m := 0;
    n := p;
  end;
end;

procedure increase (const a, b, c, d: longint);
begin
  raise (0, 0, 0, a, b, c, d);
  raise (0, 0, 1, a, b, c+z1-1, d);
  raise (0, 1, 0, a, b+y1-1, c, d);
  raise (0, 1, 1, a, b+y1-1, c+z1-1, d);
  raise (1, 0, 0, a+x1-1, b, c, d);
  raise (1, 0, 1, a+x1-1, b, c+z1-1, d);
  raise (1, 1, 0, a+x1-1, b+y1-1, c, d);
  raise (1, 1, 1, a+x1-1, b+y1-1, c+z1-1, d);
  raise_clear (0, 0, 0, a, b, c, d);
  raise_clear (0, 0, 1, a, b, c+z1-1, d);
  raise_clear (0, 1, 0, a, b+y1-1, c, d);
  raise_clear (0, 1, 1, a, b+y1-1, c+z1-1, d);
  raise_clear (1, 0, 0, a+x1-1, b, c, d);
  raise_clear (1, 0, 1, a+x1-1, b, c+z1-1, d);
  raise_clear (1, 1, 0, a+x1-1, b+y1-1, c, d);
  raise_clear (1, 1, 1, a+x1-1, b+y1-1, c+z1-1, d);
  inc_mod (t [1].sum, d);
end;

function max (const a, b: longint): longint;
begin
  if a > b then max := a else max := b;
end;

function maximum (const a, b, c: longint): longint;
begin
  maximum := max (max (a, b), c);
end;

procedure init_tree (const h: longint);
var i, kol, j, l, n: longint;
begin
  fillchar (t, sizeof (t), 0);
  kol := (1 shl (3*(h+1)) - 1) div 7 - 1 shl (3*h);
  t [1].x1 := 1;
  t [1].x2 := 1 shl h;
  t [1].y1 := 1;
  t [1].y2 := 1 shl h;
  t [1].z1 := 1;
  t [1].z2 := 1 shl h;
  for i := 1 to kol do
    with t [i] do
    begin
      t [8*i-6].x1 := x1;
      t [8*i-6].x2 := (x1+x2) shr 1;
      t [8*i-6].y1 := y1;
      t [8*i-6].y2 := (y1+y2) shr 1;
      t [8*i-6].z1 := z1;
      t [8*i-6].z2 := (z1+z2) shr 1;

      t [8*i-5].x1 := (x1+x2) shr 1+1;
      t [8*i-5].x2 := x2;
      t [8*i-5].y1 := y1;
      t [8*i-5].y2 := (y1+y2) shr 1;
      t [8*i-5].z1 := z1;
      t [8*i-5].z2 := (z1+z2) shr 1;

      t [8*i-4].x1 := x1;
      t [8*i-4].x2 := (x1+x2) shr 1;
      t [8*i-4].y1 := (y1+y2) shr 1+1;
      t [8*i-4].y2 := y2;
      t [8*i-4].z1 := z1;
      t [8*i-4].z2 := (z1+z2) shr 1;

      t [8*i-3].x1 := (x1+x2) shr 1+1;
      t [8*i-3].x2 := x2;
      t [8*i-3].y1 := (y1+y2) shr 1+1;
      t [8*i-3].y2 := y2;
      t [8*i-3].z1 := z1;
      t [8*i-3].z2 := (z1+z2) shr 1;

      t [8*i-2].x1 := x1;
      t [8*i-2].x2 := (x1+x2) shr 1;
      t [8*i-2].y1 := y1;
      t [8*i-2].y2 := (y1+y2) shr 1;
      t [8*i-2].z1 := (z1+z2) shr 1+1;
      t [8*i-2].z2 := z2;

      t [8*i-1].x1 := (x1+x2) shr 1+1;
      t [8*i-1].x2 := x2;
      t [8*i-1].y1 := y1;
      t [8*i-1].y2 := (y1+y2) shr 1;
      t [8*i-1].z1 := (z1+z2) shr 1+1;
      t [8*i-1].z2 := z2;

      t [8*i].x1 := x1;
      t [8*i].x2 := (x1+x2) shr 1;
      t [8*i].y1 := (y1+y2) shr 1+1;
      t [8*i].y2 := y2;
      t [8*i].z1 := (z1+z2) shr 1+1;
      t [8*i].z2 := z2;

      t [8*i+1].x1 := (x1+x2) shr 1+1;
      t [8*i+1].x2 := x2;
      t [8*i+1].y1 := (y1+y2) shr 1+1;
      t [8*i+1].y2 := y2;
      t [8*i+1].z1 := (z1+z2) shr 1+1;
      t [8*i+1].z2 := z2;

      if t [8*i+1].x1 = t [8*i+1].x2 then
        for j := 8*i-6 to 8*i+1 do
          pl [t [j].x1, t [j].y1, t [j].z1] := j;
    end;
  for l := 1 to z do
    for j := 1 to y do
      for i := 1 to x do
      begin
        n := pl [i, j, l];
        t [n].sum := a [i, j, l];
      end;
end;

begin
  assign (input, 'virtual.in');
  reset (input);
  assign (output, 'virtual.out');
  rewrite (output);
  read (x, y, z, x1, y1, z1, k);
  m := maximum (x, y, z);
  h := 0;
  while m > (1 shl h) do inc (h);
  solved := true;
  for l := 1 to z do
    for j := 1 to y do
      for i := 1 to x do
        read (a [i, j, l]);
  init_tree (h);
  for l := 1 to z - z1 + 1 do
    for j := 1 to y - y1 + 1 do
      for i := 1 to x - x1 + 1 do
      begin
        cur := getvalue (i, j, l);
        if cur = 0 then continue;
        op := op + k+1 - cur;
        increase (i, j, l, k+1 - cur);
      end;
  for i := 1 to x do
    for j := 1 to y do
      for l := 1 to z do
        if getvalue (i, j, l) <> 0 then
        begin
          solved := false;
          goto 1;
        end;
1:
  if solved then writeln (op) else writeln (-1);
  close (input);
  close (output);
end.
