{$ TRACTOR G-2005} {$R-,I-,S-,Q-,N+}
const
  eps = 0.0000001;
var
  n,i :integer;
  x,y :array [0..50] of extended;
  d :array [0..50,0..50] of extended;
  u,v :extended;

  function dd (x1,y1,x2,y2 :extended) :extended;
  begin
    dd:=sqrt(sqr(x1-x2)+sqr(y1-y2));
  end;

  procedure fp   (x0,y0,x1,y1,x2,y2 :extended; var x,y :extended);
  begin
    while dd(x1,y1,x2,y2)>eps do
      begin
        x:=(x1+x2)/2; y:=(y1+y2)/2;
        if dd(x1,y1,x0,y0)>dd(x2,y2,x0,y0)
          then begin x1:=x; y1:=y; end
          else begin x2:=x; y2:=y; end;
      end;
        x:=(x1+x2)/2; y:=(y1+y2)/2;
  end;

  procedure find (x0,y0,x1,y1,x2,y2 :extended; var x,y :extended);
  var a0,a :extended;
  begin
    if (x2-x0)*(x2-x1)+(y2-y0)*(y2-y1) < -eps then
      begin x:=x2; y:=y2; exit; end;
    if (x1-x0)*(x1-x2)+(y1-y0)*(y1-y2) < -eps then
      fp (x0,y0,x1,y1,x2,y2,x1,y1);
    a0:=sqr(u/v);
    while dd(x1,y1,x2,y2)>eps do
      begin
        x:=(x1+x2)/2; y:=(y1+y2)/2;
        a:=abs((x-x0)*(y-y2)-(x-x2)*(y-y0))/dd(x,y,x0,y0)/dd(x,y,x2,y2);
        if a>a0
          then begin x1:=x; y1:=y; end
          else begin x2:=x; y2:=y; end;
      end;
        x:=(x1+x2)/2; y:=(y1+y2)/2;

//{$} writeln ('x =',x :15:15,' y =',y :15:15);
  end;

  function cr (a,b :integer) :extended;
  var
    i :longint; th,m,al,xx,yy :extended;
  begin
    cr:=dd(x[a],y[a],x[b],y[b]);
    if b-a=1 then exit;
//{$} writeln ('PATH ',a,'->',b);
    find (x[a],y[a],x[b-1],y[b-1],x[b],y[b],xx,yy);
    cr:=dd(x[a],y[a],xx,yy)/u+dd(x[b],y[b],xx,yy)/v;
//{$} writeln ('PATH ',a,'->',b,': ',m:18:18,' minutes');
  end;

  procedure dun;
  var i,j,k :longint; th,m :extended;
  begin
    for i := 1 to n do
      for j := i-1 downto 0 do
        begin
          m:=cr(j,i);
//{$} writeln ('ITERATION ',i,':',j);
          for k := j+1 to i-1 do
            if m>d[j,k]+d[k,i]+eps then m:=d[j,k]+d[k,i]+eps;
          d[j,i]:=m;
        end;
  end;

var
  f1,f2 :text;

begin
  assign(f1,'tractor.in');
  assign(f2,'tractor.out');
  reset(f1); rewrite(f2);
  read(f1,n,u,v);
  for i := 0 to n do
    read (f1,x[i],y[i]);
  dun;
  writeln (f2,d[0,n]:15:15);
  close(f1); close(f2);
end.
