#include <cstdio>
#include <algorithm>
#include <vector>
#include <string>

using namespace std;

vector<char> string_buf(255);


class number {
  private:
    vector<long> data;
    static const long group;
  protected:
    void update(void) {
      while (!data.empty()) { if (data.back()) break; data.pop_back(); }
    }
  public:
    number& operator=(const string&str) {
      int pos;
      for (pos=str.length()-1; pos>=0; --pos)
        if ((str[pos]>='0')&&(str[pos]<='9')) break;
      data.clear();
      for (; pos>=0; --pos) {
        if (!((str[pos]>='0')&&(str[pos]<='9'))) break;
        data.push_back(static_cast<long>(str[pos]-'0'));
      }
      update();
      return(*this);
    }
    operator string(void) const {
      string str;
      if (!data.empty()) {
        vector<long>::const_reverse_iterator p_data;
        for (p_data=data.rbegin(); p_data!=data.rend(); ++p_data)
          str+=static_cast<char>(*p_data)+'0';
      } else str="0";
      return(str);
    }
    number& operator+=(const number&arg) {
      size_t pos;
      if (data.size()<arg.data.size()) data.resize(arg.data.size());
      long reg=0;
      for (pos=0; pos<arg.data.size(); ++pos) {
        (data[pos]+=arg.data[pos])+=reg;
        for (reg=0; data[pos]>=group; ++reg) data[pos]-=group;
      }
      for (; pos<data.size()&&reg; ++pos) {
        data[pos]+=reg;
        for (reg=0; data[pos]>=group; ++reg) data[pos]-=group;
      }
      for (; reg; ++pos) {
        data.push_back(reg);
        for (reg=0; data[pos]>=group; ++reg) data[pos]-=group;
      }
      update();
      return(*this);
    };
    number& operator*=(const number&arg) {
      size_t pos,arg_pos,buf_pos;
      vector<long> buf(data.size()+arg.data.size());
      for (pos=0; pos<data.size(); ++pos) {
        long reg=0;
        for (buf_pos=pos,arg_pos=0; arg_pos<arg.data.size();
             ++buf_pos,++arg_pos) {
          (buf[buf_pos]+=data[pos]*arg.data[arg_pos])+=reg;
          reg=buf[buf_pos]/group; buf[buf_pos]%=group;
        }
        for (; buf_pos<buf.size()&&reg; ++buf_pos) {
          buf[buf_pos]+=reg;
          reg=buf[buf_pos]/group; buf[buf_pos]%=group;
        }
        for (; reg; ++buf_pos) {
          buf.push_back(reg);
          reg=buf[buf_pos]/group; buf[buf_pos]%=group;
        }
      }
      data.swap(buf);
      update();
      return(*this);
    };
    number& divide(number&res,const number&arg) {
      res.data.clear();
      if (data.size()<arg.data.size()) return(*this);
      ptrdiff_t shift; size_t pos,arg_pos;
      long swp=0,dig;
      for (shift=data.size()-arg.data.size(); shift>=0; --shift) {
        data.back()+=swp*group;
        for (++(dig=data.back()/(arg.data.back()+1));; ++dig) {
          long reg=0,tmp;
          for (pos=shift,arg_pos=0; arg_pos<arg.data.size(); ++pos,++arg_pos) {
            tmp=data[pos]-arg.data[arg_pos]*dig+reg;
            reg=tmp/group; tmp%=group;
            for (; tmp<0; --reg) tmp+=group;
          }
          if (reg<0) break;
        } --dig;
          long reg=0;
          for (pos=shift,arg_pos=0; arg_pos<arg.data.size(); ++pos,++arg_pos) {
            (data[pos]-=arg.data[arg_pos]*dig)+=reg;
            reg=data[pos]/group; data[pos]%=group;
            for (; data[pos]<0; --reg) data[pos]+=group;
          }
        res.data.push_back(dig);
        swp=data.back(),data.pop_back();
      } data.push_back(swp);
      reverse(res.data.begin(),res.data.end());
      update(); res.update();
      return(*this);
    }
    number& operator<<=(int shift) {
      for (; shift>0; --shift) data.insert(data.begin(),0);
      update();
      return(*this);
    }
    number& shrink(number&arg) {
      vector<long>::iterator p_data,p_arg;
      for (p_data=data.begin(),p_arg=arg.data.begin();
           p_data!=data.end()&&p_arg!=arg.data.end();
           ++p_data,++p_arg)
        if (*p_data||*p_arg) break;
      data.erase(data.begin(),p_data);
      arg.data.erase(arg.data.begin(),p_arg);
      return(*this);
    }
    bool operator==(const number&arg) const { return(data==arg.data); }
    operator bool(void) const { return(!data.empty()); }
};
const long number::group=10L;

class fraction {
  private:
    number p,q;
    int sign;
    vector<number> stk;
  public:
    fraction& operator=(const string&str) {
      string str_part_int,str_part_frac,str_part_peri,
             str_span_frac,str_span_peri;
      number num_part_int,num_part_frac,num_part_peri,
             num_span_frac,num_span_peri;
      size_t pos;
      sign=0;
      if (str[0]=='-') { sign=1; str_part_int.assign(str,1,string::npos); }
      else if (str[0]=='+') str_part_int.assign(str,1,string::npos);
      else str_part_int=str;
      pos=str_part_int.find('.');
      if (pos<string::npos) {
        str_part_frac.assign(str_part_int,pos+1,string::npos);
        str_part_int.erase(pos);
      } else str_part_frac="";
      pos=str_part_frac.find('(');
      if (pos<string::npos) {
        str_part_peri.assign(str_part_frac,pos+1,string::npos);
        str_part_frac.erase(pos);
      } else str_part_peri="";
      pos=str_part_peri.find(')');
      if (pos<string::npos) str_part_peri.erase(pos);
      str_span_frac="1"+string(str_part_frac.length(),'0');
      str_span_peri=string(str_part_peri.length(),'9');
      if (str_span_peri.empty()) str_span_peri="1";
      num_part_int=str_part_int;
      num_part_frac=str_part_frac; num_part_peri=str_part_peri;
      num_span_frac=str_span_frac; num_span_peri=str_span_peri;
      ((((p=num_part_int)*=num_span_frac)+=num_part_frac)*=num_span_peri)+=
        num_part_peri;
      (q=num_span_frac)*=num_span_peri;
      #ifdef DEBUG
      printf("%s\n\"%s\" \"%s\" \"%s\" \"%s\" \"%s\"\n",str.c_str(),
        str_part_int.c_str(),str_part_frac.c_str(),str_part_peri.c_str(),
        str_span_frac.c_str(),str_span_peri.c_str());
      printf("%s %s %s %s %s\n",((string)num_part_int).c_str(),
        ((string)num_part_frac).c_str(),((string)num_part_peri).c_str(),
        ((string)num_span_frac).c_str(),((string)num_span_peri).c_str());
      printf("%d %s %s\n\n",sign,((string)p).c_str(),((string)q).c_str());
      #endif
      return(*this);
    }
    fraction& operator/=(const fraction&arg) {
      (p*=arg.q).shrink(q*=arg.p);
      sign^=arg.sign;
      #ifdef DEBUG
      printf("%d %s %s\n\n",sign,((string)p).c_str(),((string)q).c_str());
      #endif
      return(*this);
    }
    operator string(void) {
      string str;
      if (sign) str+='-';
      number a,b; int i_stk;
      (a=p).divide(b,q);
      str+=(string)b;
      if (!a) return(str);
      str+='.';
      while (a) {
        stk.push_back(a);
        a<<=1;
        a.divide(b,q);
        for (i_stk=stk.size()-1; i_stk>=0; --i_stk)
          if (a==stk[i_stk]) break;
        str+=(string)b;
        if (i_stk>=0) {
          str.insert(str.length()-stk.size()+i_stk,"(");
          str+=')';
          break;
        }
      }
      stk.clear();
      return(str);
    };
};


fraction a,b,d;

int main(void) {
  #ifndef OFFLINE
  freopen("divide.in","rt",stdin);
  freopen("divide.out","wt",stdout);
  #endif
  scanf("%s",&string_buf.front()); a=string(&string_buf.front());
  scanf("%s",&string_buf.front()); b=string(&string_buf.front());
  (d=a)/=b;
  #ifdef DEBUG
  printf("%s\n",((string)a).c_str());
  printf("%s\n",((string)b).c_str());
  #endif
  printf("%s\n",((string)d).c_str());
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


