#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;


class graph {
    struct t_edge {
      int from,to,color,id;
      char cap,flow;
      t_edge*adj,*next;
    };
  private:
    int n_verts,n_colors,n_cells,i_cell_in,i_cell_out,n_edges,
        source,target,flow_total;
    vector<t_edge> edges_cont_0,edges_cont_1; vector<t_edge*> edges;
    vector<int> ids_in_cont,ids_out_cont; vector<int*> ids_in,ids_out;
    vector<char> marks; vector<t_edge*> byps;
    vector<int> que_in,que_out; vector<int> path;
    void que(void) {
      while (!que_in.empty())
      que_out.push_back(que_in.back()),que_in.pop_back();
    }
  protected:
    int f_search;
    int search(void) {
      int cur,to; t_edge*edge; int f_found;
      fill(marks.begin(),marks.end(),0);
      fill(byps.begin(),byps.end(),static_cast<t_edge*>(0));
      que_in.clear(); que_out.clear();
      que_in.push_back(source); marks[source]=1;
      f_found=(source==target)?1:0;
      for (que(); !que_out.empty()&&!f_found; que()) while (!que_out.empty()) {
        cur=que_out.back(),que_out.pop_back();
        for (edge=edges[cur]; edge; edge=edge->next)
         if (( !f_search && (edge->flow<edge->cap) )
           ||( f_search && (edge->flow>0) )
           ) {
          if (marks[to=edge->to]) continue;
          que_in.push_back(to); marks[to]=1; byps[to]=edge;
          if (to==target) { f_found=1; break; }
        } if (edge) break;
      }
      return(f_found);
    }
    void supplyflow(void) {
      t_edge*edge;
      for (edge=byps[target]; edge; edge=byps[edge->from]) {
        ++edge->flow; --edge->adj->flow;
      } ++flow_total;
    }
    void retainpath(void) {
      t_edge*edge;
      path.clear(); path.push_back(target);
      for (edge=byps[target]; edge; edge=byps[edge->from]) {
        //if (edge->to<n_verts) path.push_back(edge->to);
        //if (edge->color>=0) path.push_back(edge->color);
        //if (edge->from<n_verts) path.push_back(edge->from);
        if (edge->from<n_verts) {
          path.push_back(edge->color);
          path.push_back(edge->from);
        }
        --edge->flow; ++edge->adj->flow;
      } --flow_total;
    }
    void printpath(void) {
      vector<int>::reverse_iterator p_path;
      for (p_path=path.rbegin(); p_path!=path.rend(); ++p_path) {
        if (p_path!=path.rbegin()) printf(" ");
        printf("%d",(*p_path)+1);
      } printf("\n");
    }
    void addedge(int from,int to,int color,int i_edge) {
        edges_cont_0[i_edge].from=from;
        edges_cont_0[i_edge].to=to;
        edges_cont_0[i_edge].color=color;
        edges_cont_0[i_edge].id=i_edge;
        edges_cont_0[i_edge].cap=1;
        edges_cont_0[i_edge].flow=0;
        edges_cont_0[i_edge].adj=&edges_cont_1[i_edge];
        edges_cont_0[i_edge].next=edges[from];
        edges[from]=&edges_cont_0[i_edge];
        edges_cont_1[i_edge].from=to;
        edges_cont_1[i_edge].to=from;
        edges_cont_1[i_edge].color=color;
        edges_cont_1[i_edge].id=i_edge;
        edges_cont_1[i_edge].cap=0;
        edges_cont_1[i_edge].flow=0;
        edges_cont_1[i_edge].adj=&edges_cont_0[i_edge];
        edges_cont_1[i_edge].next=edges[to];
        edges[to]=&edges_cont_1[i_edge];
    }
  public:
    void findflow(void) {
      f_search=0;
      while (search()) supplyflow();
    }
    void printpaths(void) {
      f_search=1;
      printf("%d\n",flow_total);
      while (search()) { retainpath(); printpath(); }
    }
    void scan(void) {
      int from,to,color,i_cell_from,i_cell_to,i_edge;
      scanf("%d%d%d%d%d",&n_verts,&n_colors,&source,&target,&n_edges);
      --source; --target;
      n_cells=n_verts*((n_colors<<1)+1);
      i_cell_in=n_verts; i_cell_out=n_verts*(n_colors+1);
      edges_cont_0.resize(n_edges+n_cells);
      edges_cont_1.resize(n_edges+n_cells);
      edges.clear(); edges.resize(n_cells);
      ids_in_cont.clear(); ids_out_cont.clear();
      ids_in_cont.resize(n_cells,-1); ids_out_cont.resize(n_cells,-1);
      ids_in.resize(n_verts); ids_out.resize(n_verts);
      for (from=0,color=0; from<n_verts; ++from,color+=n_colors) {
        ids_in[from]=&ids_in_cont[color];
        ids_out[from]=&ids_out_cont[color];
      }
      for (i_edge=0; i_edge<n_edges; ++i_edge) {
        scanf("%d%d%d",&from,&to,&color); --from; --to; --color;
        if ((i_cell_from=ids_out[from][color])<0) {
          ids_out[from][color]=i_cell_from=from+n_verts*color+i_cell_out;
          addedge(from,i_cell_from,color,i_cell_from);
        }
        if ((i_cell_to=ids_in[to][color])<0) {
          ids_in[to][color]=i_cell_to=to+n_verts*color+i_cell_in;
          addedge(i_cell_to,to,color,i_cell_to);
        }
        addedge(i_cell_from,i_cell_to,-1,n_cells+i_edge);
      } flow_total=0;
      marks.resize(n_cells); byps.resize(n_cells);
      que_in.reserve(n_cells); que_out.reserve(n_cells);
      path.reserve(n_verts<<1);
    }
};


graph gr;

int main(void) {
  #ifndef OFFLINE
  freopen("rhyme.in","rt",stdin);
  freopen("rhyme.out","wt",stdout);
  #endif
  gr.scan();
  gr.findflow();
  gr.printpaths();
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


