#include <cstdio>
#include <limits>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;


const long inf=numeric_limits<long>::max()>>1;
const long long linf=numeric_limits<long long>::max()>>1;


struct point {
  long x,y;
};
struct pos {
  int x,y;
  pos& operator+=(const pos&arg) { x+=arg.x; y+=arg.y; return(*this); }
};


enum { N_DIRS=8 };
const int n_dirs=N_DIRS;
const pos dirs[N_DIRS]={
  {+1,0},{+1,+1},{0,+1},{-1,+1},{-1,0},{-1,-1},{0,-1},{+1,-1}
};


struct t_cell {
  char blocked;
  char mark;
  long long dist;
};

int n_blocks,n_x,n_y,n_cells;
point source_p,target_p; vector<point> blocks_p;
pos source,target; vector<pos> blocks;
map<long,int> map_x,map_y;
vector<long> resolv_x,resolv_y;
vector<t_cell> mtrx_cont; vector<t_cell*> mtrx;
vector<pos> que_in,que_out;
inline void que(void) {
  while (!que_in.empty()) que_out.push_back(que_in.back()),que_in.pop_back();
}
inline long long distan(const pos&v,const pos&w) {
  long dx=resolv_x[v.x]-resolv_x[w.x],dy=resolv_y[v.y]-resolv_y[w.y];
  if (dx<0) dx=-dx; if (dy<0) dy=-dy;
  return(static_cast<long long>(dy<dx?dx:dy));
}

int main(void) {
  #ifndef OFFLINE
  freopen("king.in","rt",stdin);
  freopen("king.out","wt",stdout);
  #endif
  int i_bl;
  map_x[-inf]=-1; map_x[+inf]=-1;
  map_y[-inf]=-1; map_y[+inf]=-1;
  scanf("%ld%ld%ld%ld%d",&source_p.x,&source_p.y,&target_p.x,&target_p.y,
    &n_blocks);
  map_x[source_p.x]=-1; map_x[source_p.x+1]=-1; map_x[source_p.x-1]=-1;
  map_y[source_p.y]=-1; map_y[source_p.y+1]=-1; map_y[source_p.y-1]=-1;
  map_x[target_p.x]=-1; map_x[target_p.x+1]=-1; map_x[target_p.x-1]=-1;
  map_y[target_p.y]=-1; map_y[target_p.y+1]=-1; map_y[target_p.y-1]=-1;
  blocks_p.resize(n_blocks); blocks.resize(n_blocks);
  for (i_bl=0; i_bl<n_blocks; ++i_bl) {
    scanf("%ld%ld",&blocks_p[i_bl].x,&blocks_p[i_bl].y);
    map_x[blocks_p[i_bl].x]=-1;
    map_x[blocks_p[i_bl].x+1]=-1;
    map_x[blocks_p[i_bl].x-1]=-1;
    map_y[blocks_p[i_bl].y]=-1;
    map_y[blocks_p[i_bl].y+1]=-1;
    map_y[blocks_p[i_bl].y-1]=-1;
  }
  map<long,int>::iterator p_map;
  n_x=0; n_y=0;
  for (p_map=map_x.begin(); p_map!=map_x.end(); ++p_map) p_map->second=n_x++;
  for (p_map=map_y.begin(); p_map!=map_y.end(); ++p_map) p_map->second=n_y++;
  resolv_x.resize(n_x); resolv_y.resize(n_y);
  for (p_map=map_x.begin(); p_map!=map_x.end(); ++p_map)
    resolv_x[p_map->second]=p_map->first;
  for (p_map=map_y.begin(); p_map!=map_y.end(); ++p_map)
    resolv_y[p_map->second]=p_map->first;
  source.x=map_x[source_p.x]; source.y=map_y[source_p.y];
  target.x=map_x[target_p.x]; target.y=map_y[target_p.y];
  for (i_bl=0; i_bl<n_blocks; ++i_bl) {
    blocks[i_bl].x=map_x[blocks_p[i_bl].x];
    blocks[i_bl].y=map_y[blocks_p[i_bl].y];
  }
  int x,y;
  n_cells=n_x*n_y;
  mtrx_cont.clear();
  mtrx_cont.resize(n_cells,(t_cell){0,0,linf});
  mtrx.resize(n_x);
  for (x=0,y=0; x<n_x; ++x,y+=n_y) mtrx[x]=&mtrx_cont[y];
  for (x=0; x<n_x; ++x) { mtrx[x][0].blocked=1; mtrx[x][n_y-1].blocked=1; }
  for (y=0; y<n_y; ++y) { mtrx[0][y].blocked=1; mtrx[n_x-1][y].blocked=1; }
  for (i_bl=0; i_bl<n_blocks; ++i_bl)
    mtrx[blocks[i_bl].x][blocks[i_bl].y].blocked=1;
  que_in.reserve(n_cells); que_out.reserve(n_cells);
  pos cur,to; int i_dir; long long dist;
  que_in.clear(); que_out.clear();
  mtrx[source.x][source.y].dist=0;
  mtrx[source.x][source.y].mark=1;
  que_in.push_back(source);
  for (que(); !que_out.empty(); que()) while (!que_out.empty()) {
    cur=que_out.back(),que_out.pop_back();
    mtrx[cur.x][cur.y].mark=0;
    for (i_dir=0; i_dir<n_dirs; ++i_dir) {
      (to=cur)+=dirs[i_dir];
      if (mtrx[to.x][to.y].blocked) continue;
      dist=mtrx[cur.x][cur.y].dist+distan(cur,to);
      if (mtrx[to.x][to.y].dist<=dist) continue;
      mtrx[to.x][to.y].dist=dist;
      if (mtrx[to.x][to.y].mark) continue;
      mtrx[to.x][to.y].mark=1;
      que_in.push_back(to);
    }
  }
  if (mtrx[target.x][target.y].dist<linf)
    printf("%lld\n",mtrx[target.x][target.y].dist);
  else printf("-1\n");
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


