#include <cstdio>
#include <cmath>
#include <limits>
#include <utility>
#include <vector>

using namespace std;


typedef pair<long double,long double> point;
const point point_inf(-numeric_limits<long double>::max(),
  numeric_limits<long double>::max());

struct circle {
  long double x,r,s;
  bool in(const circle&arg) const { return(abs(arg.x-x)<=arg.r-r); }
  bool out(const circle&arg) const { return(abs(arg.x-x)>arg.r+r); }
  point operator&(const circle&arg) const {
    long double d=arg.x-x;
    point res;
    res.second=(d-(arg.s-s)/d)/2.L;
    res.first=-sqrt(s-res.second*res.second);
    res.second+=x;
    return(res);
  }
};


int n_circs;
vector<circle> circs;
int f_ok;
point best;

int main(void) {
  #ifndef OFFLINE
  freopen("popular.in","rt",stdin);
  freopen("popular.out","wt",stdout);
  #endif
  vector<circle>::iterator p_circ,p_circ_to,q_circ;
  scanf("%d",&n_circs);
  circs.resize(n_circs);
  for (q_circ=circs.end(),p_circ=circs.begin(); p_circ!=q_circ; ++p_circ) {
    scanf("%Lf%Lf",&p_circ->x,&p_circ->r);
    p_circ->s=p_circ->r*p_circ->r;
  }
  point cur;
  f_ok=1; best=point_inf;
  for (q_circ=circs.end(),p_circ=circs.begin(); p_circ!=q_circ; ++p_circ) {
      cur.second=p_circ->x; cur.first=-p_circ->r;
      if (best<cur) best=cur;
    for (++(p_circ_to=p_circ); p_circ_to!=q_circ; ++p_circ_to) {
      if (p_circ->in(*p_circ_to)||p_circ_to->in(*p_circ)) continue;
      if (p_circ->out(*p_circ_to)) { f_ok=0; break; }
      cur=(*p_circ)&(*p_circ_to);
      if (best<cur) best=cur;
    } if (!f_ok) break;
  }
  if (f_ok) printf("%.4Lf %.4Lf\n",best.second,best.first);
  else printf("-1 -1\n");
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


