#include <cstdio>
#include <utility>
#include <algorithm>
#include <vector>

using namespace std;


class graph {
    typedef pair< int,pair<int,int> > t_state;
    struct t_edge {
      int to,ring;
      t_edge*next;
    };
    typedef pair<char,int> t_info;
    typedef pair<t_info,int> t_outcome;
  private:
    int n_verts,n_edges,n_rings,n_pairs,n_ringverts,n_states;
    vector<t_edge> edges_cont_0,edges_cont_1;
    vector<t_edge*> edges;
    vector<int> degs_cont;
    vector<int*> degs;
    vector<t_outcome> outcs_cont_0;
    vector<t_outcome*> outcs_cont_1;
    vector<t_outcome**> outcs;
    t_state source;
    vector<t_state> que_in,que_out;
  protected:
    void que(void) {
      while (!que_in.empty()) {
        que_out.push_back(que_in.back());
        que_in.pop_back();
      }
    }
    void initoutcs(void) {
      t_state state;
      fill(outcs_cont_0.begin(),outcs_cont_0.end(),t_outcome(t_info(0,0),0));
      que_in.clear(); que_out.clear();
      for (state.first=0; state.first<=n_rings; ++state.first)
       for (state.second.first=0; state.second.first<n_verts;
            ++state.second.first) {
        outcs[state.first][state.second.first][0].first=t_info(2,0);
        if (state.second.first) que_in.push_back(state);
        outcs[state.first][state.second.first][state.second.first].first=
          t_info(1,0);
        que_in.push_back(state);
      }
    }
    void procoutcs(void) {
      t_state cur,to; t_edge*edge;
      for (que(); !que_out.empty(); que()) while (!que_out.empty()) {
        to=cur=que_out.back(); que_out.pop_back();
        t_outcome&outc_cur=
          outcs[cur.first][cur.second.first][cur.second.second];
        if (cur.first<n_rings) {
          for (edge=edges[cur.second.first]; edge; edge=edge->next) {
            if (cur.first!=edge->ring) continue;
            to.second.first=edge->to;
            t_outcome&outc_to=
              outcs[to.first][to.second.first][to.second.second];
            if (outc_cur.first.first<=1) {
              if (!outc_to.first.first) {
                que_in.push_back(to);
                outc_to.first.first=1;
                outc_to.first.second=outc_cur.first.second+1;
              } else {
                if (outc_to.first.second>outc_cur.first.second+1)
                outc_to.first.second=outc_cur.first.second+1;
              }
            } else {
              if (++outc_to.second>=degs[to.first][to.second.first])
               if (!outc_to.first.first) {
              if (outc_to.first.second<outc_cur.first.second+1)
                outc_to.first.second=outc_cur.first.second+1;
                que_in.push_back(to);
                outc_to.first.first=2;
              }
            }
          }
        } else {
          for (edge=edges[cur.second.second]; edge; edge=edge->next) {
            to.first=edge->ring;
            to.second.second=edge->to;
            t_outcome&outc_to=
              outcs[to.first][to.second.first][to.second.second];
            if (outc_cur.first.first>1) {
              if (!outc_to.first.first) {
                que_in.push_back(to);
                outc_to.first.first=2;
                outc_to.first.second=outc_cur.first.second;
              } else {
                if (outc_to.first.second>outc_cur.first.second)
                outc_to.first.second=outc_cur.first.second;
              }
            } else {
              if (++outc_to.second>=degs[n_rings][to.second.second])
               if (!outc_to.first.first) {
              if (outc_to.first.second<outc_cur.first.second)
                outc_to.first.second=outc_cur.first.second;
                que_in.push_back(to);
                outc_to.first.first=1;
              }
            }
          }
        }
      }
    }
  public:
    void scan(void) {
      int from,to,i_edge,ring; int x,y;
      scanf("%d%d%d",&n_verts,&n_edges,&n_rings);
      n_states=(n_pairs=n_verts*n_verts)*(n_rings+1);
      n_ringverts=n_verts*(n_rings+1);
      edges_cont_0.resize(n_edges); edges_cont_1.resize(n_edges);
      edges.clear(); edges.resize(n_verts);
      degs_cont.clear(); degs_cont.resize(n_ringverts);
      degs.resize(n_rings+1);
      for (x=0,y=0; x<=n_rings; ++x,y+=n_verts) degs[x]=&degs_cont[y];
      for (i_edge=0; i_edge<n_edges; i_edge++) {
        scanf("%d%d%d",&from,&to,&ring); --from; --to; --ring;
        edges_cont_0[i_edge].to=to;
        edges_cont_0[i_edge].ring=ring;
        edges_cont_0[i_edge].next=edges[from];
        edges[from]=&edges_cont_0[i_edge];
        ++degs[ring][to]; ++degs[n_rings][to];
        edges_cont_1[i_edge].to=from;
        edges_cont_1[i_edge].ring=ring;
        edges_cont_1[i_edge].next=edges[to];
        edges[to]=&edges_cont_1[i_edge];
        ++degs[ring][from]; ++degs[n_rings][from];
      }
      source.first=n_rings;
      scanf("%d%d",&source.second.first,&source.second.second);
      --source.second.first; --source.second.second;
      outcs_cont_0.resize(n_states); outcs_cont_1.resize(n_ringverts);
      outcs.resize(n_rings+1);
      for (x=0,y=0; x<n_ringverts; ++x,y+=n_verts)
        outcs_cont_1[x]=&outcs_cont_0[y];
      for (x=0,y=0; x<=n_rings; ++x,y+=n_verts) outcs[x]=&outcs_cont_1[y];
      que_in.reserve(n_states); que_out.reserve(n_states);
    }
    void printoutcome(void) {
      t_outcome&outc_source=
        outcs[source.first][source.second.first][source.second.second];
      if (outc_source.first.first) printf("%s\n%d\n",
        outc_source.first.first>1?"Escaped":"Caught",
        outc_source.first.second);
      else printf("%s\n","Endless");
    }
    void findoutcomes(void) {
      initoutcs();
      procoutcs();
    }
};


graph gr;

int main(void) {
  #ifndef OFFLINE
  freopen("pursuit.in","rt",stdin);
  freopen("pursuit.out","wt",stdout);
  #endif
  gr.scan();
  gr.findoutcomes();
  gr.printoutcome();
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


