#include <cstdio>
#include <limits>
#include <utility>
#include <algorithm>
#include <vector>

using namespace std;


typedef pair<long,int> t_elem;


const long inf=numeric_limits<long>::max()>>1;


int n_elems,n_parts;
vector<t_elem> elems;
int i_elem_shift_best,n_elems_scnd_best,i_elem_shift,n_elems_scnd;
long diff_best,sum_bnd,diff;
vector<t_elem> sums_cont; vector<t_elem*> sums;

void checkvariant(void) {
  int i_elem,i_elem_to,i_part; long sum_cur,sum;
  fill(sums_cont.begin(),sums_cont.end(),t_elem(-inf,-1));
  sums[0][0]=t_elem(inf,-1);
  for (i_part=0; i_part<n_parts; ++i_part)
   for (i_elem=0; i_elem<n_elems_scnd; ++i_elem) {
    sum=0;
    for (i_elem_to=i_elem; i_elem_to<n_elems_scnd; ) {
      if ((sum+=elems[i_elem_to++].first)>sum_bnd) break;
      sum_cur=sum<sums[i_part][i_elem].first?sum:sums[i_part][i_elem].first;
      if (!(sums[i_part+1][i_elem_to].first<sum_cur)) continue;
      sums[i_part+1][i_elem_to]=t_elem(sum_cur,i_elem);
    }
  }
  if (sums[n_parts][n_elems_scnd].first<0) return;
  diff=sum_bnd-sums[n_parts][n_elems_scnd].first;
  if (diff_best>diff) {
    i_elem_shift_best=i_elem_shift; n_elems_scnd_best=n_elems_scnd;
    diff_best=diff;
  }
}

int main(void) {
  #ifndef OFFLINE
  freopen("necklace.in","rt",stdin);
  freopen("necklace.out","wt",stdout);
  #endif
  int i_elem,i_elem_to,i_part; int x,y;
  scanf("%d%d",&n_elems,&n_parts); --n_parts;
  elems.resize(n_elems);
  diff_best=0;
  for (i_elem=0; i_elem<n_elems; ++i_elem) {
    scanf("%ld",&elems[i_elem].first);
    elems[i_elem].second=i_elem;
    diff_best+=elems[i_elem].first;
  }
  sums_cont.resize((n_elems+1)*(n_parts+1)); sums.resize(n_parts+1);
  for (x=0,y=0; x<=n_parts; ++x,y+=n_elems+1) sums[x]=&sums_cont[y];
  i_elem_shift_best=0; n_elems_scnd_best=n_elems;
  if (n_parts>0) for (i_elem_shift=0; i_elem_shift<n_elems; ++i_elem_shift) {
    sum_bnd=0;
    for (--(n_elems_scnd=n_elems); n_elems_scnd>0; --n_elems_scnd) {
      sum_bnd+=elems[n_elems_scnd].first;
      checkvariant();
    }
    rotate(elems.begin(),elems.begin()+1,elems.end());
  }
  if (n_elems_scnd_best<n_elems) {
    rotate(elems.begin(),elems.begin()+i_elem_shift_best,elems.end());
    sum_bnd=0;
    for (--(n_elems_scnd=n_elems); n_elems_scnd>=n_elems_scnd_best;
         --n_elems_scnd) sum_bnd+=elems[n_elems_scnd].first;
    ++n_elems_scnd;
    checkvariant();
  }
  printf("%ld\n",diff_best);
    for (i_elem=n_elems; i_elem>n_elems_scnd; ) {
      if (i_elem<n_elems) printf(" ");
      printf("%d",elems[--i_elem].second+1);
    } printf("\n");
  for (i_part=n_parts; i_part>0; --i_part) {
    i_elem_to=sums[i_part][i_elem].second;
    for (; i_elem>i_elem_to; ) {
      printf("%d",elems[--i_elem].second+1);
      if (i_elem>i_elem_to) printf(" ");
    } printf("\n");
  }
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


