#include <cstdio>
#include <limits>
#include <utility>
#include <algorithm>
#include <vector>
#include <map>

using namespace std;


typedef pair<long,long> point;
typedef pair<point,int> t_event;
typedef pair<long long,int> t_info;
struct t_rect {
  point v,w;
  long val;
  t_info info;
};


const long inf=numeric_limits<long>::max()>>1;


int n_rects,n_events;
vector<t_rect> rects;
vector<t_event> events;
map<long,t_info> data;
vector<int> seq;

int main(void) {
  #ifndef OFFLINE
  freopen("rects.in","rt",stdin);
  freopen("rects.out","wt",stdout);
  #endif
  int i_rect,i_event;
  scanf("%d",&n_rects);
  n_events=n_rects<<1;
  rects.resize(n_rects); events.resize(n_events); seq.reserve(n_rects);
  for (i_event=0,i_rect=0; i_rect<n_rects; ++i_rect) {
    scanf("%ld%ld%ld%ld%ld",&rects[i_rect].v.first,&rects[i_rect].w.second,
      &rects[i_rect].w.first,&rects[i_rect].v.second,&rects[i_rect].val);
    rects[i_rect].v.second=-rects[i_rect].v.second;
    rects[i_rect].w.second=-rects[i_rect].w.second;
    ++rects[i_rect].w.first; ++rects[i_rect].w.second;
    rects[i_rect].info=t_info(0,-1);
    events[i_event++]=t_event(rects[i_rect].v,i_rect);
    events[i_event++]=t_event(rects[i_rect].w,~i_rect);
  }
  sort(events.begin(),events.end());
  vector<t_event>::iterator p_event,q_event;
  map<long,t_info>::iterator p_data;
  t_info info;
  data[-inf]=t_info(0,-1);
  for (q_event=events.end(),p_event=events.begin(); p_event!=q_event;
       ++p_event) if ((i_rect=p_event->second)>=0) {
    info=(--(p_data=data.lower_bound(p_event->first.second)))->second;
    if (rects[i_rect].info.first<info.first) rects[i_rect].info=info;
    rects[i_rect].info.first+=rects[i_rect].val;
  } else {
    i_rect=~i_rect;
    info=t_info(rects[i_rect].info.first,i_rect);
    --(p_data=data.lower_bound(p_event->first.second));
    if (!(p_data->second.first<info.first)) continue;
    if (++p_data!=data.end()) if (!(info.first<p_data->second.first))
      data.erase(p_data,data.end());
    data[p_event->first.second-1]=info;
    #ifdef DEBUG
    for (p_data=data.begin(); p_data!=data.end(); ++p_data)
      printf("%ld  %lld %d\n",p_data->first,
      p_data->second.first,p_data->second.second);
    #endif
  }
  info=(--data.end())->second;
  for (i_rect=info.second; i_rect>=0; i_rect=rects[i_rect].info.second)
    seq.push_back(i_rect);
  int f_printed=0;
  printf("%lld\n",info.first);
  while (!seq.empty()) {
    if (f_printed) printf(" "); else f_printed=1;
    printf("%d",seq.back()+1);
    seq.pop_back();
  } printf("\n");
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


