#include <cstdio>
#include <utility>
#include <algorithm>
#include <vector>

using namespace std;


class graph {
    struct t_edge {
      int from;
      t_edge*next;
    };
    typedef pair<int,int> t_state;
    static const char*syms[];
  private:
    int n_verts,n_states,n_syms,n_edges;
    vector<t_edge> edges_cont_0;
    vector<t_edge*> edges_cont_1;
    vector<t_edge**> edges;
    vector<char> types;
    vector<char> marks_cont; vector<char*> marks;
    vector<t_state> tops_cont; vector<t_state*> tops;
    vector<int> byps_cont; vector<int*> byps;
    vector<t_state> que_in,que_out;
    void que(void) {
      while (!que_in.empty())
      que_out.push_back(que_in.back()),que_in.pop_back();
    }
  public:
    void calcinfo(void) {
      t_state cur,to; int i_sym; pair<t_edge*,t_edge*> edge;
      fill(marks_cont.begin(),marks_cont.end(),0);
      fill(tops_cont.begin(),tops_cont.end(),t_state(-1,-1));
      fill(byps_cont.begin(),byps_cont.end(),-1);
      que_in.clear(); que_out.clear();
        for (to.first=0; to.first<n_verts; ++to.first)
         for (to.second=0; to.second<n_verts; ++to.second)
         if (types[to.first]!=types[to.second]) {
          marks[to.first][to.second]=1;
          que_in.push_back(to);
        }
      for (que(); !que_out.empty(); que()) while (!que_out.empty()) {
        cur=que_out.back(),que_out.pop_back();
        for (i_sym=0; i_sym<n_syms; ++i_sym)
         for (edge.first=edges[cur.first][i_sym]; edge.first;
              edge.first=edge.first->next)
         for (edge.second=edges[cur.second][i_sym]; edge.second;
              edge.second=edge.second->next)
         if (!marks[to.first=edge.first->from][to.second=edge.second->from]) {
          tops[to.first][to.second]=cur;
          byps[to.first][to.second]=i_sym;
          marks[to.first][to.second]=1;
          que_in.push_back(to);
        }
      }
    }
    int getinfo(int v,int w) { return(!!marks[v][w]); }
    void printseq(int v,int w) {
      t_state cur; int i_sym;
      for (cur=t_state(v,w); (i_sym=byps[cur.first][cur.second])>=0;
           cur=tops[cur.first][cur.second])
        printf("%s",syms[i_sym]);
    }
    void scan(void) {
      int vert,to,i_sym,i_edge;
      n_syms=2,scanf("%d",&n_verts);
      n_states=n_verts*n_verts; n_edges=n_verts*n_syms;
      types.clear(); types.resize(n_verts);
      scanf("%d",&vert);
      for (; vert>0; --vert) {
        scanf("%d",&to); --to;
        ++types[to];
      }
      edges_cont_0.resize(n_edges);
      edges_cont_1.clear(); edges_cont_1.resize(n_edges);
      edges.resize(n_verts);
      for (vert=0,i_edge=0; vert<n_verts; ++vert,i_edge+=n_syms)
        edges[vert]=&edges_cont_1[i_edge];
      for (i_edge=0,vert=0; vert<n_verts; ++vert)
       for (i_sym=0; i_sym<n_syms; ++i_edge,++i_sym) {
        scanf("%d",&to); --to;
        edges_cont_0[i_edge].from=vert;
        edges_cont_0[i_edge].next=edges[to][i_sym];
        edges[to][i_sym]=&edges_cont_0[i_edge];
      }
      marks_cont.resize(n_states); marks.resize(n_verts);
      tops_cont.resize(n_states); tops.resize(n_verts);
      byps_cont.resize(n_states); byps.resize(n_verts);
      for (vert=0,to=0; vert<n_verts; ++vert,to+=n_verts) {
        marks[vert]=&marks_cont[to];
        tops[vert]=&tops_cont[to];
        byps[vert]=&byps_cont[to];
      }
      que_in.reserve(n_states); que_out.reserve(n_states);
    }
};
const char*graph::syms[]={"0","1"};


graph gr;

int main(void) {
  #ifndef OFFLINE
  freopen("eq.in","rt",stdin);
  freopen("eq.out","wt",stdout);
  #endif
  int n_querys,i_query;
  gr.scan();
  gr.calcinfo();
  scanf("%d",&n_querys);
  for (i_query=0; i_query<n_querys; ++i_query) {
    int v,w;
    scanf("%d%d",&v,&w); --v; --w;
    if (gr.getinfo(v,w)) {
      gr.printseq(v,w);
      printf("\n");
    } else printf("equivalent\n");
  }
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


