#include <cstdio>
#include <cmath>
#include <algorithm>
#include <vector>
#include <set>

using namespace std;

struct t_item {
  long double a;
  int part;
  long val;
  bool operator<(const t_item&arg) const { return(a<arg.a); }
};

int n_items,n_parts;
long double width,base;
vector<t_item> items;
vector<long long> sums;
multiset<long long> sums_srch;
long long diff_best,diff;

int main(void) {
  #ifndef OFFLINE
  freopen("necklace.in","rt",stdin);
  freopen("necklace.out","wt",stdout);
  #endif
  int i_item,i_part;
  vector<t_item>::iterator p_item;
  multiset<long long>::iterator p_sum_srch;
  scanf("%d%d",&n_items,&n_parts);
  width=M_PI*2.L/static_cast<long double>(n_parts);
  items.resize(n_items); sums.resize(n_parts);
  for (i_item=0; i_item<n_items; ++i_item)
    scanf("%Lf%ld",&items[i_item].a,&items[i_item].val);
  base=min_element(items.begin(),items.end())->a;
  for (p_item=items.begin(); p_item!=items.end(); ++p_item) {
    p_item->part=static_cast<int>((p_item->a-=base)/width)-1;
    if (p_item->part<0) p_item->part=0;
    p_item->a-=width*static_cast<long double>(p_item->part);
    for (; p_item->a>=width; ++p_item->part) p_item->a-=width;
    sums[p_item->part]+=p_item->val;
  }
  sort(items.begin(),items.end());
  for (i_part=0; i_part<n_parts; ++i_part) sums_srch.insert(sums[i_part]);
  diff_best=diff=(*--sums_srch.end())-(*sums_srch.begin());
    #ifdef DEBUG
    #if DEBUG>=2
    printf("%d ",n_parts);
    for (i_part=0; i_part<n_parts; ++i_part) printf(" %lld",sums[i_part]);
    printf("  ");
    #endif
    printf("%lld-%lld=%lld %lld\n",
      *--sums_srch.end(),*sums_srch.begin(),diff,diff_best);
    #endif
  for (p_item=items.begin(); p_item!=items.end(); ++p_item) {
    i_part=p_item->part;
    if ((p_sum_srch=sums_srch.find(sums[i_part]))!=sums_srch.end())
      sums_srch.erase(p_sum_srch);
    sums_srch.insert(sums[i_part]-=p_item->val);
    (i_part+=n_parts-1)%=n_parts;
    if ((p_sum_srch=sums_srch.find(sums[i_part]))!=sums_srch.end())
      sums_srch.erase(p_sum_srch);
    sums_srch.insert(sums[i_part]+=p_item->val);
    diff=(*--sums_srch.end())-(*sums_srch.begin());
    if (diff_best>diff) diff_best=diff;
    #ifdef DEBUG
    #if DEBUG>=2
    printf("%d ",n_parts);
    for (i_part=0; i_part<n_parts; ++i_part) printf(" %lld",sums[i_part]);
    printf("  ");
    #endif
    printf("%lld-%lld=%lld %lld  %Lf+%d*%Lf+%Lf=%Lf\n",
      *--sums_srch.end(),*sums_srch.begin(),diff,diff_best,
      p_item->a,p_item->part,width,base,
      p_item->a+static_cast<long double>(p_item->part)*width+base);
    #endif
  }
  printf("%lld\n",diff_best);
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


