#include <cstdio>
#include <string>
#include <vector>

using namespace std;

vector<char> string_buf(511);


const int n_syms=26;
const char sym_base='A';

inline int char2sym(char ch) {
  int sym;
  sym=static_cast<int>(ch-sym_base);
  ((sym%=n_syms)+=n_syms)%=n_syms;
  return(sym);
}
inline char sym2char(int sym) { return(static_cast<char>(sym)+sym_base); }


struct t_rule {
  int n_pts,i_pt_st,i_pt_en;
  int res;
};

int n_pts,n_pairs,n_pts_rules,n_rules,n_cells_t,n_cells_r,n_cells_s;
vector<int> pts,pts_rules;
vector<int> is_rules;
vector<t_rule> rules;
vector<char> trans_cont; vector<char*> trans;
vector<char> marks_r_cont_0,marks_s_cont_0;
vector<char*> marks_r_cont_1,marks_s_cont_1;
vector<char**> marks_r,marks_s;

int main(void) {
  #ifndef OFFLINE
  freopen("game.in","rt",stdin);
  freopen("game.out","wt",stdout);
  #endif
  int i_pt,i_pt_to,i_pt_by,c_pts_width,i_pt_rules,i_rule,
    i_sym,i_sym_to,i_sym_by;
  string str;
  scanf("%s",&string_buf.front());
  pts.resize(n_pts=(str=&string_buf.front()).length());
  for (i_pt=0; i_pt<n_pts; ++i_pt) pts[i_pt]=char2sym(str[i_pt]);
  scanf("%d",&n_rules);
  rules.resize(n_rules);
  n_pts_rules=0;
  for (i_rule=0; i_rule<n_rules; ++i_rule) {
    scanf("%s",&string_buf.front());
    rules[i_rule].n_pts=(str=&string_buf.front()).length();
    rules[i_rule].i_pt_st=n_pts_rules;
    for (i_pt=0; i_pt<rules[i_rule].n_pts; ++i_pt) {
      pts_rules.push_back(char2sym(str[i_pt]));
      is_rules.push_back(i_rule);
      ++n_pts_rules;
    }
    rules[i_rule].i_pt_en=n_pts_rules-1;
    scanf("%s",&string_buf.front());
    rules[i_rule].res=char2sym((str=&string_buf.front())[0]);
  } //is_rules.push_back(n_rules);
  #ifdef DEBUG
  for (i_pt=0; i_pt<n_pts; ++i_pt) printf("%c",sym2char(pts[i_pt]));
  printf("\n");
  for (i_pt_rules=0; i_pt_rules<n_pts_rules; ++i_pt_rules)
    printf("%c",sym2char(pts_rules[i_pt_rules]));
  printf("\n");
  printf("%d\n",n_rules);
  for (i_rule=0; i_rule<n_rules; ++i_rule)
    printf("%d %d %c\n",rules[i_rule].i_pt_st,rules[i_rule].i_pt_en,
    sym2char(rules[i_rule].res));
  #endif
  n_cells_t=n_syms*n_syms;
  trans_cont.resize(n_cells_t); trans.resize(n_syms);
  for (i_sym=0,i_sym_to=0; i_sym<n_syms; ++i_sym,i_sym_to+=n_syms)
    trans[i_sym]=&trans_cont[i_sym_to];
  for (i_sym=0; i_sym<n_syms; ++i_sym) trans[i_sym][i_sym]=1;
  for (i_rule=0; i_rule<n_rules; ++i_rule)
   if (rules[i_rule].i_pt_st>=rules[i_rule].i_pt_en) {
    trans[pts_rules[rules[i_rule].i_pt_st]][rules[i_rule].res]=1;
    rules[i_rule].res=n_syms;
  }
  for (i_sym_by=0; i_sym_by<n_syms; ++i_sym_by)
   for (i_sym=0; i_sym<n_syms; ++i_sym)
   for (i_sym_to=0; i_sym_to<n_syms; ++i_sym_to)
   if (trans[i_sym][i_sym_by]&&trans[i_sym_by][i_sym_to])
    trans[i_sym][i_sym_to]=1;
  #ifdef DEBUG
  for (i_sym=0; i_sym<n_syms; ++i_sym) {
    printf("%c ",sym2char(i_sym));
    for (i_sym_to=0; i_sym_to<n_syms; ++i_sym_to) if (trans[i_sym][i_sym_to])
      printf("%c",sym2char(i_sym_to));
    printf("\n");
  }
  #endif
  n_pairs=(n_pts+1)*(n_pts+1);
  n_cells_r=n_pairs*n_pts_rules; n_cells_s=n_pairs*(n_syms+1);
  marks_r_cont_0.resize(n_cells_r); marks_s_cont_0.resize(n_cells_s);
  marks_r_cont_1.resize(n_pairs); marks_s_cont_1.resize(n_pairs);
  marks_r.resize(n_pts+1); marks_s.resize(n_pts+1);
  for (i_pt_to=0,i_pt_rules=0; i_pt_to<n_pairs;
       ++i_pt_to,i_pt_rules+=n_pts_rules)
    marks_r_cont_1[i_pt_to]=&marks_r_cont_0[i_pt_rules];
  for (i_pt_to=0,i_sym=0; i_pt_to<n_pairs; ++i_pt_to,i_sym+=n_syms+1)
    marks_s_cont_1[i_pt_to]=&marks_s_cont_0[i_sym];
  for (i_pt=0,i_pt_to=0; i_pt<=n_pts; ++i_pt,i_pt_to+=n_pts+1) {
    marks_r[i_pt]=&marks_r_cont_1[i_pt_to];
    marks_s[i_pt]=&marks_s_cont_1[i_pt_to];
  }
  for (i_pt=0; i_pt<n_pts; ++i_pt) {
    for (i_sym_to=0; i_sym_to<n_syms; ++i_sym_to)
     if (trans[pts[i_pt]][i_sym_to])
      marks_s[i_pt][i_pt+1][i_sym_to]=1;
    #ifdef DEBUG
    printf("%d %d ",i_pt,i_pt+1);
    for (i_sym=0; i_sym<n_syms; ++i_sym) if (marks_s[i_pt][i_pt+1][i_sym])
      printf("%c",sym2char(i_sym));
    printf("\n");
    #endif
  }
  for (i_pt=0; i_pt<n_pts; ++i_pt) {
    for (i_rule=0; i_rule<n_rules; ++i_rule)
     if (marks_s[i_pt][i_pt+1][pts_rules[rules[i_rule].i_pt_st]])
      marks_r[i_pt][i_pt+1][rules[i_rule].i_pt_st]=1;
    #ifdef DEBUG
    printf("%d %d ",i_pt,i_pt+1);
    for (i_pt_rules=0; i_pt_rules<n_pts; ++i_pt_rules)
      if (marks_r[i_pt][i_pt+1][i_pt_rules]) printf(" %d",i_pt_rules);
    printf("\n");
    #endif
  }
  for (c_pts_width=2; c_pts_width<=n_pts; ++c_pts_width)
   for (i_pt=0,i_pt_to=c_pts_width; i_pt_to<=n_pts; ++i_pt,++i_pt_to) {
    for (i_pt_rules=0; i_pt_rules<n_pts_rules; ++i_pt_rules)
     if (rules[i_rule=is_rules[i_pt_rules]].i_pt_st<i_pt_rules)
     for (++(i_pt_by=i_pt); i_pt_by<i_pt_to; ++i_pt_by)
     if (marks_r[i_pt][i_pt_by][i_pt_rules-1]
       &&marks_s[i_pt_by][i_pt_to][pts_rules[i_pt_rules]]) {
      marks_r[i_pt][i_pt_to][i_pt_rules]=1;
      break;
    }
    for (i_rule=0; i_rule<n_rules; ++i_rule) if (rules[i_rule].res<n_syms)
     if (marks_r[i_pt][i_pt_to][i_pt_rules=rules[i_rule].i_pt_en])
     for (i_sym_to=0; i_sym_to<n_syms; ++i_sym_to)
     if (trans[rules[i_rule].res][i_sym_to])
      marks_s[i_pt][i_pt_to][i_sym_to]=1;
    for (i_rule=0; i_rule<n_rules; ++i_rule)
     if (marks_s[i_pt][i_pt_to][pts_rules[rules[i_rule].i_pt_st]])
      marks_r[i_pt][i_pt_to][rules[i_rule].i_pt_st]=1;
    #ifdef DEBUG
    printf("%d %d ",i_pt,i_pt_to);
    for (i_sym=0; i_sym<n_syms; ++i_sym) if (marks_s[i_pt][i_pt_to][i_sym])
      printf("%c",sym2char(i_sym));
    for (i_pt_rules=0; i_pt_rules<n_pts; ++i_pt_rules)
      if (marks_r[i_pt][i_pt_to][i_pt_rules]) printf(" %d",i_pt_rules);
    printf("\n");
    #endif
  }
  for (i_sym=0; i_sym<n_syms; ++i_sym) if (marks_s[0][n_pts][i_sym])
    printf("%c",sym2char(i_sym));
  printf("\n");
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


