#include <cstdio>
#include <ctime>
#include <vector>
#include <list>

using namespace std;


const long double time_bnd=static_cast<long double>(CLOCKS_PER_SEC)*1.5L;
long double time_start,time_cur;


struct t_offer {
  int from,to;
  long width;
  long long sum;
  long lock;
};

int n_gaps,n_offers;
long cap;
long long sum_all,sum_best,sum_max,sum_cur;
long n_masks,mask_best,mask_cur;
vector<t_offer> offers;
vector<long> left;
list<int> unlocked;
vector< vector<int> > locked;

void check(int i_offer=0) {
  time_cur=static_cast<long double>(clock());
  #ifdef DEBUG
  printf("%d %08lX  %Lf %Lf\n",i_offer,mask_cur,time_cur-time_start,time_bnd);
  #endif
  #ifndef NOTIMING
  if (time_cur-time_start>=time_bnd) return;
  #endif
  t_offer&offer=offers[i_offer];
  if (offer.lock) { if (i_offer+1<n_offers) check(i_offer+1); return; }
  int i_gap; list<int>::iterator p_unlocked;
  sum_max+=offer.sum; sum_cur+=offer.sum;
  for (i_gap=offer.from; i_gap<offer.to; ++i_gap) {
    left[i_gap]-=offer.width;
    for (p_unlocked=unlocked.begin(); p_unlocked!=unlocked.end(); ) {
      t_offer&tst=offers[*p_unlocked];
      if ((i_gap<tst.from)||(i_gap>=tst.to)) { ++p_unlocked; continue; }
      if (left[i_gap]<tst.width) {
        tst.lock|=1L<<i_gap;
        sum_max-=tst.sum;
        locked[i_offer].push_back(*p_unlocked);
        p_unlocked=unlocked.erase(p_unlocked);
      } else ++p_unlocked;
    }
  }
  mask_cur^=1L<<i_offer;
  if (sum_best<sum_cur) { sum_best=sum_cur; mask_best=mask_cur; }
  if (sum_best<sum_max) if (i_offer+1<n_offers) check(i_offer+1); 
  if (time_cur-time_start>=time_bnd) return;
  mask_cur^=1L<<i_offer;
  for (; !locked[i_offer].empty(); locked[i_offer].pop_back()) {
    int i_tst=locked[i_offer].back();
    t_offer&tst=offers[i_tst];
    tst.lock=0;
    sum_max+=tst.sum;
    unlocked.push_back(i_tst);
  }
  for (i_gap=offer.from; i_gap<offer.to; ++i_gap)
    left[i_gap]+=offer.width;
  sum_max-=offer.sum; sum_cur-=offer.sum;
  if (sum_best<sum_max) if (i_offer+1<n_offers) check(i_offer+1); 
}

int main(void) {
  #ifndef OFFLINE
  freopen("trains.in","rt",stdin);
  freopen("trains.out","wt",stdout);
  #endif
  time_start=static_cast<long double>(clock());
  int i_offer,i_gap;
  scanf("%ld%d%d",&cap,&n_gaps,&n_offers);
  left.resize(n_gaps,cap);
  offers.resize(n_offers);
  locked.resize(n_offers);
  sum_all=0;
  for (i_offer=0; i_offer<n_offers; ++i_offer) {
    scanf("%d%d%ld",&offers[i_offer].from,&offers[i_offer].to,
      &offers[i_offer].width);
    offers[i_offer].sum=static_cast<long long>(offers[i_offer].width)*
      static_cast<long long>(offers[i_offer].to-offers[i_offer].from);
    offers[i_offer].lock=0;
    for (i_gap=offers[i_offer].from; i_gap<offers[i_offer].to; ++i_gap)
      if (left[i_gap]<offers[i_offer].width) offers[i_offer].lock|=1L<<i_gap;
    if (!offers[i_offer].lock) {
      unlocked.push_back(i_offer);
      sum_all+=offers[i_offer].sum;
    }
    locked[i_offer].reserve(n_offers);
  }
  n_masks=1L<<n_offers;
  sum_best=0; mask_best=0;
  sum_max=sum_all;
  sum_cur=0; mask_cur=0;
  if (n_offers>0) check();
  int f_printed=0;
  printf("%lld\n",sum_best);
  for (i_offer=0; i_offer<n_offers; ++i_offer) if ((mask_best>>i_offer)&1) {
    if (f_printed) printf(" "); else f_printed=1;
    printf("%d",i_offer+1);
  } printf("\n");
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


