#include <cstdio>
#include <algorithm>
#include <vector>

using namespace std;


class tree {
    struct t_edge {
      int to;
      int id;
      t_edge*next;
    };
    struct t_node {
      int deg,left,size,sub_wanted;
      t_edge*edges,*parent;
      int*cs_edges_out;
    };
    struct t_info {
      int c_edges_out;
      int prev,sub;
      t_edge*edge;
    };
  private:
    int n_verts,n_pairs,n_verts_wanted,n_edges,c_edges_out_best,vert_best;
    vector<t_edge> edges_cont;
    vector<int> cs_edges_out_cont,cs_edges_out_buf;
    vector<t_node> nodes;
    vector<t_info> info_cont; vector<t_info*> info;
    vector<int> que_in,que_out;
    void que(void) {
      while (!que_in.empty())
      que_out.push_back(que_in.back()),que_in.pop_back();
    }
    vector<int> edges_out;
  protected:
    void relax(int*cs_edges_out_to,int sub,int c_edges_sub) {
      int cur,to; int c_edges_to;
      for (cur=0,to=sub; to<n_verts; ++cur,++to)
       if ((c_edges_to=cs_edges_out_buf[cur])<n_verts)
       if (cs_edges_out_to[to]>(c_edges_to+=c_edges_sub))
        cs_edges_out_to[to]=c_edges_to;
    }
    void relax(t_info*info_to,t_info*info_prev,int sub,int c_edges_sub,
               int prev,t_edge*edge) {
      int cur,to; int c_edges_to;
      for (cur=0,to=sub; to<n_verts; ++cur,++to)
       if ((c_edges_to=info_prev[cur].c_edges_out)<n_verts)
       if (info_to[to].c_edges_out>(c_edges_to+=c_edges_sub)) {
        info_to[to].c_edges_out=c_edges_to;
        info_to[to].prev=prev;
        info_to[to].sub=sub;
        info_to[to].edge=edge;
      }
    }
  public:
    int calcout(void) {
      int cur,to,prev,by,c_edges_out_cur; t_edge*edge;
      fill(cs_edges_out_cont.begin(),cs_edges_out_cont.end(),n_verts);
      que_in.clear(); que_out.clear();
      for (to=0; to<n_verts; ++to) {
        if ((nodes[to].left=nodes[to].deg)<=1) que_in.push_back(to);
        nodes[to].size=1;
      }
      for (que(); !que_out.empty(); que()) while (!que_out.empty()) {
        cur=que_out.back(),que_out.pop_back();
        nodes[cur].parent=0;
        nodes[cur].cs_edges_out[0]=0;
        for (edge=nodes[cur].edges; edge; edge=edge->next)
         if (!nodes[to=edge->to].cs_edges_out[0]) {
          copy(&nodes[cur].cs_edges_out[0],&nodes[cur].cs_edges_out[n_verts],
            cs_edges_out_buf.begin());
          for (by=1; by<nodes[to].size; ++by)
           if (nodes[to].cs_edges_out[by]<n_verts)
            relax(nodes[cur].cs_edges_out,by,nodes[to].cs_edges_out[by]);
          relax(nodes[cur].cs_edges_out,by,1);
        } else nodes[cur].parent=edge;
        if (nodes[cur].parent) {
          to=nodes[cur].parent->to;
          if (--nodes[to].left==1) que_in.push_back(to);
          nodes[to].size+=nodes[cur].size;
        }
        #ifdef DEBUG
        printf("%d %d %d ",cur+1,nodes[cur].parent->to+1,nodes[cur].size);
        for (by=0; by<n_verts; ++by) {
          if (by==nodes[cur].size) printf(" ");
          printf(" %d",nodes[cur].cs_edges_out[by]);
        }
        printf("\n");
        #endif
      }
      c_edges_out_best=n_verts; vert_best=-1;
      for (cur=0; cur<n_verts; ++cur) {
        if ((by=nodes[cur].sub_wanted=nodes[cur].size-n_verts_wanted)<0)
          continue;
        c_edges_out_cur=nodes[cur].cs_edges_out[by]+nodes[cur].left;
        if (c_edges_out_best>c_edges_out_cur) {
          c_edges_out_best=c_edges_out_cur;
          vert_best=cur;
        }
      }
      if (vert_best<0) return(0);
      edges_out.clear();
      que_in.clear(); que_out.clear();
      que_in.push_back(vert_best);
      if ((edge=nodes[vert_best].parent)) edges_out.push_back(edge->id);
      for (que(); !que_out.empty(); que()) while (!que_out.empty()) {
        cur=que_out.back(),que_out.pop_back();
        #ifdef DEBUG
        printf("%d %d\n",cur+1,nodes[cur].sub_wanted);
        #endif
        fill(info_cont.begin(),info_cont.end(),(t_info){n_verts,n_verts,0,0});
        info[prev=n_verts][0].c_edges_out=0;
        for (edge=nodes[cur].edges; edge; edge=edge->next) {
          to=edge->to;
          if (nodes[cur].parent) if (to==nodes[cur].parent->to) continue;
          copy(&info[prev][0],&info[prev][n_verts],&info[to][0]);
          for (by=1; by<nodes[to].size; ++by)
           if (nodes[to].cs_edges_out[by]<n_verts)
            relax(info[to],info[prev],by,nodes[to].cs_edges_out[by],prev,edge);
          relax(info[to],info[prev],by,1,prev,edge);
          prev=to;
        }
        for (by=nodes[cur].sub_wanted; by>0; ) {
          edge=info[prev][by].edge;
          if (info[prev][by].sub<nodes[to=edge->to].size) {
            que_in.push_back(to);
            nodes[to].sub_wanted=info[prev][by].sub;
            #ifdef DEBUG
            //printf("  %d %d\n",to+1,nodes[to].sub_wanted);
            #endif
          } else edges_out.push_back(edge->id);
          to=info[prev][by].prev;
          by-=info[prev][by].sub;
          prev=to;
        }
      }
      sort(edges_out.begin(),edges_out.end());
      return(1);
    }
    void scan(void) {
      int from,to,i_edge;
      scanf("%d%d",&n_verts,&n_verts_wanted);
      n_pairs=n_verts*n_verts;
      n_edges=(n_verts-1)<<1; if (n_edges<0) n_edges=0;
      edges_cont.resize(n_edges);
      cs_edges_out_cont.resize(n_pairs); cs_edges_out_buf.resize(n_verts);
      nodes.resize(n_verts);
      info_cont.resize(n_pairs+n_verts); info.resize(n_verts+1);
      for (i_edge=0; i_edge<n_edges; ) {
        scanf("%d%d",&from,&to); --from; --to;
        edges_cont[i_edge].to=to;
        edges_cont[i_edge].id=i_edge;
        edges_cont[i_edge].next=nodes[from].edges;
        nodes[from].edges=&edges_cont[i_edge++];
        ++nodes[from].deg;
        edges_cont[i_edge].to=from;
        edges_cont[i_edge].id=i_edge;
        edges_cont[i_edge].next=nodes[to].edges;
        nodes[to].edges=&edges_cont[i_edge++];
        ++nodes[to].deg;
      }
      for (from=0,to=0; from<n_verts; ++from,to+=n_verts) {
        nodes[from].cs_edges_out=&cs_edges_out_cont[to];
        info[from]=&info_cont[to];
      } info[from]=&info_cont[to];
      que_in.reserve(n_verts); que_out.reserve(n_verts);
      edges_out.reserve(n_verts);
    }
    void printout(void) {
      vector<int>::iterator p_edge;
      printf("%d\n",c_edges_out_best);
      for (p_edge=edges_out.begin(); p_edge!=edges_out.end(); ++p_edge) {
        if (p_edge!=edges_out.begin()) printf(" ");
        printf("%d",((*p_edge)>>1)+1);
      } printf("\n");
    }
};


tree tr;

int main(void) {
  #ifndef OFFLINE
  freopen("tree.in","rt",stdin);
  freopen("tree.out","wt",stdout);
  #endif
  tr.scan();
  tr.calcout();
  tr.printout();
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


