program afasf;
uses math;

const eps= 1e-9;

var x,y:array[1..300] of double;
    ban:array[1..500,1..2] of double;
    r:double;
    n,m:longint;
    ev,f:array[1..1000] of double;

procedure load;
var i:longint;
begin
    read(r,n);
    for i:= 1 to n do begin
        read(x[i],y[i]);
    end;
end;

procedure qsort(l,r:longint);
var t,x1,x2:double;
    i,j:longint;
begin
    j:=random(r-l+1)+l;
    x1:=ev[j];x2:=f[j];
    i:=l;
    j:=r;
    while i<j do begin
        while (ev[i]<x1-eps)or((abs(ev[i]-x1)<eps)and(f[i]>x2)) do inc(i);
        while (ev[j]>x1+eps)or((abs(ev[j]-x1)<eps)and(f[j]<x2)) do dec(j);
        if i<=j then begin
            t:=ev[i];ev[i]:=ev[j];ev[j]:=t;
            t:=f[i];f[i]:=f[j];f[j]:=t;
            inc(i);dec(j);
        end;
    end;
    if i<r then qsort(i,r);
    if l<j then qsort(l,j);
end;

procedure solve;
var ra,fa,rx,ry,fx,fy,prev:double;
    xx,yy,a,b,c,t,x1,dx,y1,dy:double;
    i,j:longint;
begin
    m:=0;
    for i:= 1 to n-1 do begin
        rx:=x[i]-x[i+1];
        ry:=y[i]-y[i+1];
        fx:=-rx;
        fy:=-ry;
        ra:=arccos(rx/sqrt(rx*rx+ry*ry));
        if ry<0 then ra:=2*pi-ra;
        fa:=arccos(fx/sqrt(fx*fx+fy*fy));
        if fy<0 then fa:=2*pi-fa;
        if fa<ra then begin
            inc(m);
            ban[m,1]:=fa+2*eps;
            ban[m,2]:=ra-2*eps;
        end
        else begin
            inc(m);
            ban[m,1]:=0;
            ban[m,2]:=ra-2*eps;
            inc(m);
            ban[m,1]:=fa+2*eps;
            ban[m,2]:=2*pi;
        end;
    end;
    for j:= 1 to m do begin
        ev[2*j-1]:=ban[j,1];
        ev[2*j]:=ban[j,2];
        f[2*j-1]:=1;
        f[2*j]:=-1;
    end;
    qsort(1,2*m);
    j:=0;
    prev:=0;
    c:=0;
    for i:= 1 to 2*m do begin
        if (j=0)and(i>1) then begin
            prev:=(prev+ev[i])/2;
            c:=2;
            break;
        end;
        if f[i]>eps then inc(j);
        if f[i]<eps then dec(j);
        prev:=ev[i];
    end;
    if c<1 then begin
        prev:=prev-2*pi;
        if prev+eps<ev[1] then begin
            prev:=(prev+ev[1])/2;
            c:=2;
        end;
    end;
    if c<1 then begin
        write(-1);
        exit;
    end;
    fx:=1*cos(prev);
    fy:=1*sin(prev);
    xx:=0;
    yy:=0;
    a:=fy;
    b:=-fx;
    c:=0;
    for i:= 1 to n-1 do begin
        x1:=x[i];
        y1:=y[i];
        dx:=x[i+1]-x[i];
        dy:=y[i+1]-y[i];
        t:=a*dx+b*dy;
        if abs(t)<eps then continue;
        t:=(-a*x1-b*y1)/(t);
        rx:=t*dx+x1;
        ry:=dy*t+y1;
        if rx*rx+ry*ry<eps then begin
            xx:=xx+fx/100;
            yy:=yy+fy/100;
            break;
        end;
        if (t<1+eps)and(t>-eps)and(rx*fx+ry*fy>eps) then
            c:=1;
    end;
    if c>0 then begin
        fx:=-fx;
        fy:=-fy;
    end;
    write(xx:0:5,' ',yy:0:5,' ',fx:0:5,' ',fy:0:5);
end;

procedure save;
begin

end;


begin
    assign(input,'glass.in');
    assign(output,'glass.out');
    reset(input);
    rewrite(output);
    load;
    solve;
    save;
    close(input);
    close(output);
end.