#include <stdio.h>
#include <stdlib.h>

#define m 100010

typedef struct _tree tree;
struct _tree
{
  int x, y, fr;
  tree *l, *r;
};
typedef struct
{
  int x1, x2, y1, y2, a, r, fr;
} rect;

int n, p1[m], p2[m], t[m], nt;
rect r[m];
tree _t[m];

tree *newt( int x, int y, int fr )
{
  _t[nt].x = x, _t[nt].y = y, _t[nt].fr = fr;
  return &_t[nt++];
}

void update( tree *t )
{
  if (!t)
    return;
  if (t->l && (t->fr == -1 || (t->l->fr != -1 && r[t->l->fr].r > r[t->fr].r)))
    t->fr = t->l->fr;
  if (t->r && (t->fr == -1 || (t->r->fr != -1 && r[t->r->fr].r > r[t->fr].r)))
    t->fr = t->r->fr;
}

void split( tree *t, tree **l, tree **r, int x )
{
  if (!t)
    *l = *r = 0;
  else if (x < t->x || (x == t->x && (rand() & 1)))
    split(t->l, l, &t->l, x), *r = t;
  else
    split(t->r, &t->r, r, x), *l = t;
  update(t);
}

void add( tree **t, int x, int y, int fr )
{
  if (!*t)
    *t = newt(x, y, fr);
  else if (y <= (*t)->y)
  {
    tree *tt;

    tt = newt(x, y, fr);
    split(*t, &tt->l, &tt->r, x);
    *t = tt;
  }
  else if (x < (*t)->x || (x == (*t)->x && (rand() & 1)))
    add(&(*t)->l, x, y, fr);
  else
    add(&(*t)->r, x, y, fr);
  update(*t);
}

int find( tree *t, int x )
{
  int ar;

  if (!t)
    return -1;
  if (t->x >= x)
    return find(t->l, x);
  ar = find(t->r, x);
  if (ar == -1 || (t->fr != -1 && r[ar].r < r[t->fr].r))
    ar = t->fr;
  if (t->l)
    if (ar == -1 || (t->l->fr != -1 && r[ar].r < r[t->l->fr].r))
      return t->l->fr;
  return ar;
}

void sort1( int l, int ri )
{
  int i, j, k, e;

  if (l >= ri)
    return;
  e = (l + ri) / 2;
  sort1(l, e), sort1(e + 1, ri);
  i = l, j = e + 1, k = l;
  while (i <= e || j <= ri)
    if (j > ri || (i <= e && r[p1[i]].x2 > r[p1[j]].x2))
      t[k++] = p1[i++];
    else
      t[k++] = p1[j++];
  for (k = l; k <= ri; k++)
    p1[k] = t[k];
}

void sort2( int l, int ri )
{
  int i, j, k, e;

  if (l >= ri)
    return;
  e = (l + ri) / 2;
  sort2(l, e), sort2(e + 1, ri);
  i = l, j = e + 1, k = l;
  while (i <= e || j <= ri)
    if (j > ri || (i <= e && r[p2[i]].x1 > r[p2[j]].x1))
      t[k++] = p2[i++];
    else
      t[k++] = p2[j++];
  for (k = l; k <= ri; k++)
    p2[k] = t[k];
}

int geth( tree *t )
{
  int l, r;

  if (!t)
    return 0;
  l = geth(t->l) + 1;
  r = geth(t->r) + 1;
  if (l < r)
    return r;
  return l;
}

int main( void )
{
  int i, j, tt;
  tree *ro;

  srand(301703);
  freopen("rects.in", "rt", stdin);
  freopen("rects.out", "wt", stdout);
  scanf("%d", &n);
  nt = 0;
  for (i = 0; i < n; i++)
  {
    scanf("%d%d%d%d%d", &r[i].x1, &r[i].y1, &r[i].x2, &r[i].y2, &r[i].a);
    p1[i] = p2[i] = i;
    r[i].fr = -1, r[i].r = r[i].a;
  }
  sort1(0, n - 1);
  sort2(0, n - 1);
  ro = 0;
  for (i = j = 0; i < n;)
    if (j >= n || r[p1[i]].x2 >= r[p2[j]].x1)
    {
      tt = find(ro, r[p1[i]].y1);
      if (tt != -1 && r[p1[i]].r < r[tt].r + r[p1[i]].a)
        r[p1[i]].r = r[tt].r + r[p1[i]].a, r[p1[i]].fr = tt;
      i++;
    }
    else
      add(&ro, r[p2[j]].y2, rand() % 301703, p2[j]), j++;
  for (i = j = 0; i < n; i++)
    if (r[j].r < r[i].r)
      j = i;
  printf("%d\n", r[j].r);
  for (; j != -1; j = r[j].fr)
    printf("%d ", j + 1);
  return 0;
}
