#include <stdio.h>
#include <string.h>

#include "guess.h"

#define m (1 << 18)

int l[2 * m], r[2 * m], v[2 * m], is[2 * m], res[m], n, k, q;

void init( int i, int ll, int rr )
{
  l[i] = ll, r[i] = rr, v[i] = -1, is[i] = 0;
  if (i < m)
  {
    init(i * 2, ll, (ll + rr) / 2);
    init(i * 2 + 1, (ll + rr) / 2 + 1, rr);
  }
}

int get( int i, int ll, int rr )
{
  int vl, vr;

  if (ll == l[i] && rr == r[i])
    return v[i];
  if (rr <= r[i * 2])
    return get(i * 2, ll, rr);
  if (ll >= l[i * 2 + 1])
    return get(i * 2 + 1, ll, rr);
  vl = get(i * 2, ll, r[i * 2]);
  vr = get(i * 2 + 1, l[i * 2 + 1], rr);
  if (vl == -1 || vr == -1)
    return -1;
  return vl + vr;
}

void draw( int i )
{
  if (i >= m)
    res[i - m] = v[i];
  else
  {
    if (v[i * 2] == -1 && v[i * 2 + 1] == -1)
      v[i * 2] = v[i], v[i * 2 + 1] = 0;
    else if (v[i * 2] == -1 && v[i * 2 + 1] != -1)
      v[i * 2] = (((v[i] - v[i * 2 + 1]) % k) + k) % k;
    else if (v[i * 2] != -1 && v[i * 2 + 1] == -1)
      v[i * 2 + 1] = (((v[i] - v[i * 2]) % k) + k) % k;
    draw(i * 2), draw(i * 2 + 1);
  }
}

int ifree( int i, int ll, int rr )
{
  if (ll == l[i] && rr == r[i])
    return !is[i];
  if (rr <= r[i * 2])
    return ifree(i * 2, ll, rr);
  if (ll >= l[i * 2 + 1])
    return ifree(i * 2 + 1, ll, rr);
  return ifree(i * 2, ll, r[i * 2]) && ifree(i * 2 + 1, l[i * 2 + 1], rr);
}

void set( int i, int ll, int rr, int s )
{
  if (ll == l[i] && rr == r[i])
    v[i] = s;
  else
  {
    if (rr <= r[i * 2])
      set(i * 2, ll, rr, s);
    else if (ll >= l[i * 2 + 1])
      set(i * 2 + 1, ll, rr, s);
    else
      set(i * 2, ll, r[i * 2], s), set(i * 2 + 1, l[i * 2 + 1], rr, 0);
    if (i < m)
    {
      if (v[i * 2] != -1 && v[i * 2 + 1] != -1)
        v[i] = v[i * 2] + v[i * 2 + 1];
      else
        v[i] = -1;
    }
  }
  is[i] = 1;
}

int findl( int i, int ll, int rr )
{
  int t;

  if (l[i] == ll && r[i] == rr)
  {
    if (!is[i])
      return l[i];
    if (v[i] == -1)
      return l[i];
    t = findl(i * 2, ll, r[i * 2]);
    if (t == -1)
      return findl(i * 2 + 1, l[i * 2 + 1], rr);
    return t;
  }
  if (rr <= r[i * 2])
    return findl(i * 2, ll, rr);
  if (ll >= l[i * 2 + 1])
    return findl(i * 2 + 1, ll, rr);
  t = findl(i * 2, ll, r[i * 2]);
  if (t == -1)
    return findl(i * 2 + 1, l[i * 2 + 1], rr);
  return t;
}

int findr( int i, int ll, int rr )
{
  int t;

  if (l[i] == ll && r[i] == rr)
  {
    if (!is[i])
      return r[i];
    if (v[i] == -1)
      return r[i];
    t = findr(i * 2 + 1, l[i * 2 + 1], rr);
    if (t == -1)
      return findr(i * 2, ll, r[i * 2]);
    return t;
  }
  if (rr <= r[i * 2])
    return findr(i * 2, ll, rr);
  if (ll >= l[i * 2 + 1])
    return findr(i * 2 + 1, ll, rr);
  t = findr(i * 2 + 1, l[i * 2 + 1], rr);
  if (t == -1)
    return findr(i * 2, ll, r[i * 2]);
  return t;
}

int main( void )
{
  int l, r, ll, rr, s, t;

  Initialize(&n, &k, &q);
  init(1, 1, m);
  while (q--)
  {
    NextQuery(&l, &r, &s);
    t = get(1, l, r);
    if (t == -1)
    {
      if (ifree(1, l, r))
        set(1, l, r, s);
      else
      {
        ll = findl(1, l, r);
        rr = findr(1, l, r);
        if (ll == -1 || rr == -1)
          continue;
        if (ifree(1, ll, rr))
          set(1, ll, rr, s - get(1, l, ll - 1) - get(1, rr + 1, r));
      }
    }
    else if (t != s)
      draw(1), Error(n, res);
  }
  draw(1);
  Consistent(n, res);
  return 0;
}
