const MaxN = 200;
      Q = 10e-2;

type TPoint = record
      x,y : extended;
     end;

     TVector = TPoint;

var a : array [1..MaxN] of TPoint;
    i,n : longint;
    r : extended;

function Dist(x,y : extended) : extended;
begin
    Dist := Sqrt(Sqr(x)+Sqr(y));
end;

procedure ChangeSize(var v : TVector; u : extended);
var d : extended;
begin
    d := Dist(v.x,v.y);
    v.x := v.x/d; v.y := v.y/d;
    v.x := v.x*u; v.y := v.y*u;
end;

procedure Done(v : TVector);
var x : longint;
    ot : TVector;
begin
    x := n div 2+1;
    ot := v;
    ChangeSize(v,Q);
    writeln(a[x].x+v.x : 0 : 5,' ',a[x].y+v.y : 0 : 5,' ',ot.x : 0 : 5,' ',ot.y : 0 : 5);
    close(input);
    close(output);
    halt;
end;

function VecMul(v,v1 : TVector) : extended;
begin
    VecMul := v.x*v1.y - v1.x*v.y;
end;

function NotCross(x1,y1,x2,y2,x3,y3,x4,y4 : extended) : boolean;
var ab,ac,ad,dc,db,da : TVector;
begin
    ab.x := x2 - x1; ab.y := y2 - y1;
    ac.x := x3 - x1; ac.y := y3 - y1;
    ad.x := x4 - x1; ad.y := y4 - y1;
    da.x := -ad.x; da.y := -ad.y;
    dc.x := x3 - x4; dc.y := y3 - y4;
    db.x := x2 - x4; db.y := y2 - y4;
    NotCross := not ((VecMul(ab,ac)*VecMul(ab,ad) < 0)
    and (VecMul(dc,da)*VecMul(dc,db) < 0));
end;

function Check(v : TVector; i,j : longint) : boolean;
begin
    Check := NotCross(a[i].x,a[i].y,a[i].x+v.x,a[i].y+v.y,a[j].x,a[j].y,a[j+1].x,a[j+1].y)
    and NotCross(a[i+1].x,a[i+1].y,a[i+1].x+v.x,a[i+1].y+v.y,a[j].x,a[j].y,a[j+1].x,a[j+1].y);
end;

procedure Solve;
var i,j,k : longint;
    v,v1 : TVector;
    f : boolean;
    s : extended;
begin
    if n = 2 then begin
     v.x := a[1].x-a[2].x; v.y := a[1].y-a[2].y;
     v1.x := v.y; v1.y := -v.x;
     inc(n);
     a[2].x := (a[1].x+a[2].x)/2;
     a[2].y := (a[1].y+a[2].y)/2;
     Done(v1);
     close(input);
     close(output);
     halt;
    end;
    for i := 2 to n-1 do begin
     v.x := a[i-1].x - a[i].x; v.y := a[i-1].y - a[i].y;
     v1.x := a[i+1].x - a[i].x; v1.y := a[i+1].y - a[i].y;
     v.x := v.x + v1.x; v.y := v.y + v1.y;
     s := Dist(v.x,v.y);
     v.x := v.x*r/s*2; v.y := v.y*r/s*2;
     for j := 1 to n-1 do begin
      f := true;
      for k := 1 to n-1 do
       if j <> k then
        if not Check(v,j,k) then begin
         f := false;
         break;
        end;
      if not f then break;
     end;
     if f then Done(v);
    end;
    writeln(-1);
end;

begin
    assign(input,'glass.in');
    assign(output,'glass.out');
    reset(input);
    rewrite(output);
    read(r,n);
    for i := 1 to n do
     read(a[i].x,a[i].y);
    Solve;
    close(input);
    close(output);
end.
