{$N+,E-}
type
  real=extended;
  integer=longint;
procedure halt;
begin
  close(input);
  close(output);
  system.halt;
end;
function sqr(x:real):real;
begin
  sqr:=x*x;
end;


var
  xk,yk:array[0..505]of integer;
  xn,yn:array[0..505]of integer;
  n,k:integer;

function triangle(i,j,s:integer; var x,y:real):boolean;
var
  x1,x2,x3,y1,y2,y3,a,b,c,d,e,f:integer;

begin
  if (xn[i]-xn[j])*(yn[i]-yn[s])=(yn[i]-yn[j])*(xn[i]-xn[s]) then begin
    triangle:=false;
    exit;
  end;
  triangle:=true;
  x1:=xn[i]; y1:=yn[i];
  x2:=xn[j]; y2:=yn[j];
  x3:=xn[s]; y3:=yn[s];
  a:=2*(x2-x1); b:=2*(y2-y1);
  c:=x2*x2-x1*x1+y2*y2-y1*y1;
  d:=2*(x3-x1); e:=2*(y3-y1);
  f:=x3*x3-x1*x1+y3*y3-y1*y1;
  if (a*e-b*d)=0 then begin
    triangle:=false;
    exit;
  end;
  x:=(c*e-b*f)/(a*e-b*d);
  y:=(a*f-c*d)/(a*e-b*d);
end;


function segment(i,j,s:integer; var x,y:real):boolean;
var
  x1,x2,xa,xb,y1,y2,ya,yb,a,b,c,d,e:integer;
  r1,r2,t1,t2,f,t:real;
begin
  x1:=xk[i]; y1:=yk[i];
  x2:=xk[j]; y2:=yk[j];
  xa:=xn[s]; ya:=yn[s];
  xb:=xn[s+1]; yb:=yn[s+1];
  a:=ya-yb; b:=xb-xa;
  c:=ya*xb-xa*yb;
  d:=x2-x1; e:=y2-y1;
  f:=(y2*y2-y1*y1+x2*x2-x1*x1)/2;
  if (a*e-b*d)=0 then begin
    segment:=false;
    exit;
  end;
  x:=(c*e-b*f)/(a*e-b*d);
  y:=(a*f-c*d)/(a*e-b*d);
  t1:=xa; t2:=xb; r1:=ya; r2:=yb;
  if t1>t2 then begin
    t:=t1;
    t1:=t2;
    t2:=t;
  end;
  if r1>r2 then begin
    t:=r1;
    r1:=r2;
    r2:=t;
  end;
  segment:=(t1<=x)and(x<=t2)and(r1<=y)and(y<=r2);
end;


function dist(x,y:real):real;
var
  z,r:real;
  i:integer;
begin
  r:=sqrt(sqr(x-xk[1])+sqr(y-yk[1]));
  for i:=2 to k do begin
    z:=sqrt(sqr(x-xk[i])+sqr(y-yk[i]));
    if z<r then r:=z;
  end;
  dist:=r;
end;

var
  x,y,res:real;

procedure try(xt,yt:real);
var z:real;
begin
  z:=dist(xt,yt);
  if z>res then begin
    res:=z;
    x:=xt;
    y:=yt;
  end;
end;

var
  i,j,s:integer;
  xt,yt:real;
begin
  assign(input,'fire.in');
  reset(input);
  assign(output,'fire.out');
  rewrite(output);
  readln(n);
  for i:=1 to n do readln(xn[i],yn[i]);
  xn[n+1]:=xn[1];
  yn[n+1]:=yn[1];
  readln(k);
  for i:=1 to k do readln(xk[i],yk[i]);
  x:=xn[1];
  y:=yn[1];
  res:=dist(xn[1],yn[1]);
  for i:=2 to n do begin
    try(xn[i],yn[i]);
  end;
  for i:=1 to k do begin
    for j:=i+1 to k do begin
      for s:=1 to n do begin
        if segment(i,j,s,xt,yt) then
          try(xt,yt);
      end;
    end;
  end;
  for i:=1 to k do begin
    for j:=i+1 to k do begin
      for s:=j+1 to k do begin
        if triangle(i,j,s,xt,yt) then
          try(xt,yt);
      end;
    end;
  end;
  writeln(x:0:4,' ',y:0:4);
  close(input);
  close(output);
end.
