{$I-,Q-,R-,S-}

program Tractor;
const infile = 'tractor.in';
      outfile = 'tractor.out';
      MAXN = 50;
      EPS = 1e-7;
type real = double;
var N : integer;
    u, v, sina, cosa, tga : real;
    dist : array[0..MAXN, 0..MAXN] of real;
    x, y : array[0..MAXN] of real;

procedure ReadData;
var i : integer;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  read(N, u, v);

  for i:=0 to N do begin
    read(x[i], y[i]);
  end;
end;

function Sign(a : real) : integer;
begin
  Sign:=ord(a>0)-ord(a<0);
end;

procedure TryUpdate(i, p, j : integer);
var a, b, c, ro, min, max, res : real;
    an, bn, cn : real;
    s1, s2 : integer;
begin
  a:=y[p]-y[i]; b:=x[i]-x[p]; c:=-(a*x[i]+b*y[i]);
  if abs(a*x[j]+b*y[j]+c)<=EPS then exit;

  ro:=abs(a*x[j]+b*y[j]+c)/sqrt(sqr(a)+sqr(b));

  an:=-b; bn:=a; cn:=-(an*x[j]+bn*y[j]);

  max:=(an*x[i]+bn*y[i]+cn)/sqrt(sqr(an)+sqr(bn)); s1:=Sign(max); max:=abs(max);
  min:=(an*x[p]+bn*y[p]+cn)/sqrt(sqr(an)+sqr(bn)); s2:=Sign(min); min:=abs(min);

  if max/sqrt(sqr(ro)+sqr(max))<sina then exit;

  if (s1=s2) then begin
    if (max<min) then exit;
    if ro*tga<min then exit;
    res:=(max-ro*tga)/v+ro/cosa/u;
  end else begin
    res:=(max-ro*tga)/v+ro/cosa/u;
  end;

  if res<dist[i, j] then dist[i, j]:=res;
end;

procedure Solve;
var k, i, j : integer;
begin
  sina:=u/v; cosa:=sqrt(1-sqr(sina)); tga:=sina/cosa;

  for i:=0 to N do
    for j:=0 to N do
      dist[i, j]:=1e10;

  for i:=0 to N-1 do
    dist[i, i+1]:=sqrt(sqr(x[i+1]-x[i])+sqr(y[i+1]-y[i]))/v;

  for i:=0 to N do
    for j:=0 to N do
      if dist[i, j]>sqrt(sqr(x[i]-x[j])+sqr(y[i]-y[j]))/u then
        dist[i, j]:=sqrt(sqr(x[i]-x[j])+sqr(y[i]-y[j]))/u;

  for i:=0 to N do
    for j:=0 to N do begin
      if i<>0 then TryUpdate(i, i-1, j);
      if i<>N then TryUpdate(i, i+1, j);
    end;

  for k:=0 to N do
    for i:=0 to N do
      for j:=0 to N do
        if dist[i, j]>dist[i, k]+dist[k, j] then
          dist[i, j]:=dist[i, k]+dist[k, j];

  writeln(dist[0, N]:0:6);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
