program X0;
const infile = 'x0.in';
      outfile = 'x0.out';
      MAXL = 40;
type tPair = record
  n1, n2 : integer;
end;
var R, C : integer;
    rows, cols : array[1..MAXL] of string[MAXL];
    rowsdiff, colsdiff : array[0..MAXL] of tPair;

procedure ReadData;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
end;

function GetDiff(s : string) : tPair;
var i, min, max : integer;
    res : tPair;
begin
  min:=1000; max:=0;
  for i:=1 to length(s) do
    if s[i]='*' then begin
      if min>i then min:=i;
      if max<i then max:=i;
    end;
  res.n1:=max-min+1;

  for i:=1 to length(s) do
    if (i=length(s)) or ((s[i]='*') and (s[i+1]='.')) then begin
      min:=i; break;
    end;

  for i:=length(s) downto 1 do
    if (i=1) or ((s[i]='*') and (s[i-1]='.')) then begin
      max:=i; break;
    end;

  if min>=max then res.n2:=0 else res.n2:=max-min-1;

  GetDiff:=res;
end;

function ReadInput : boolean;
var cur : string;
    i, j, tr, tc : integer;
    tempr : array[1..MAXL] of string[MAXL];
    need : array[1..MAXL] of boolean;
begin
  fillchar(need, sizeof(need), false);
  if eof(input) then begin ReadInput:=false; exit; end;

  R:=0; C:=0; tr:=0; tc:=0;
  while true do begin
    readln(cur); if (cur='-') or (cur='#') then break;

    if pos('*', cur)=0 then continue;
    inc(tr); tempr[tr]:=cur;
  end;

  tc:=length(tempr[1]);
  for i:=1 to tc do begin
    cur:='';
    for j:=1 to tr do
      cur:=cur+tempr[j, i];

    if pos('*', cur)=0 then continue;
    inc(C); cols[C]:=cur;
  end;

  for i:=1 to tr do begin
    cur:='';
    for j:=1 to C do
      cur:=cur+cols[j, i];

    inc(R); rows[R]:=cur;
  end;

  ReadInput:=true;
end;

function BuildAnswer(var a : array of tPair; n : integer) : integer;
var p2, p1 : tPair;
    to0, toX : integer;
    i : integer;
begin
  if n=1 then begin BuildAnswer:=0; exit; end;
  to0:=0; toX:=0;
  p2:=a[1]; p1:=a[2];

  if (p2.n1<p1.n1) then inc(to0);
  if (p2.n1>p1.n1) then inc(toX);

  if (p2.n2<p1.n2) then inc(to0);
  if (p2.n2>p1.n2) then inc(toX);

  for i:=3 to n do begin
    if (p1.n1<=p2.n1) and (a[i].n1>p1.n1) then inc(toX);
    if (p1.n1>=p2.n1) and (a[i].n1<p1.n1) then inc(to0);

    if (p1.n2<=p2.n2) and (a[i].n2>p1.n2) then inc(toX);
    if (p1.n2>=p2.n2) and (a[i].n2<p1.n2) then inc(to0);

    p2:=p1; p1:=a[i];
  end;

  BuildAnswer:=to0-toX;
end;

procedure Solve;
var i : integer;
    c1, c2 : longint;
begin
  while ReadInput do begin
    for i:=1 to R do
      rowsdiff[i]:=GetDiff(rows[i]);
    for i:=1 to C do
      colsdiff[i]:=GetDiff(cols[i]);

    c1:=BuildAnswer(rowsdiff, R)*C; c2:=BuildAnswer(colsdiff, C)*R;

    if c1+c2>0 then
      writeln('0')
    else
      writeln('X');
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
