program Glass;
const infile = 'glass.in';
      outfile = 'glass.out';
      MAXN = 200;
      EPS = 1e-7;
      DELTA = 1e-3;
type real = double;
var R : real;
    N : integer;
    x, y : array[1..MAXN] of real;

procedure ReadData;
var i : integer;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  read(R, N);

  for i:=1 to n do begin
    read(x[i], y[i]);
  end;
end;

function Sign(a : real) : integer;
begin
  if abs(a)<=EPS then Sign:=0 else Sign:=ord(a>0)-ord(a<0);
end;

function Rot(x11, y11, x12, y12, x21, y21, x22, y22 : real) : integer;
var vx1, vy1, vx2, vy2 : real;
begin
  vx1:=x12-x11; vy1:=y12-y11;
  vx2:=x22-x21; vy2:=y22-y21;

  Rot:=Sign(vx1*vy2-vx2*vy1);
end;

procedure Solve;
var nx, ny, dx, dy : real;
    i, j : integer;
    flag : boolean;

begin
  for i:=1 to N-1 do begin
    dx:=x[i+1]-x[i]; dy:=y[i+1]-y[i];

    flag:=true;
    for j:=1 to i-1 do
      if Rot(x[j], y[j], x[j+1], y[j+1], x[i], y[i], x[i+1], y[i+1])<0 then begin
        flag:=false; break;
      end;

    for j:=i+1 to N-1 do
      if Rot(x[i], y[i], x[i+1], y[i+1], x[j], y[j], x[j+1], y[j+1])>0 then begin
        flag:=false; break;
      end;

    if flag then begin
      nx:=-dy; ny:=dx;
      if Sign(nx*dy-dx*ny)>0 then begin nx:=-nx; ny:=-ny; end;
      writeln((x[i]+x[i+1])/2+nx*DELTA:0:8, ' ', (y[i]+y[i+1])/2+ny*DELTA:0:8, ' ', dx:0:8, ' ', dy:0:8); exit;

    end;
  end;

  writeln(-1);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
