program Temp;
const infile = 'rhyme.in';
      outfile = 'rhyme.out';
      MAXN = 50;
      MAXK = 50;
      MAXM = 1000;
type
tEdge = record
  v : integer;
  pair, next : longint;
  c, f : integer;
end;
tVertex = record
  s, k : integer;
end;
var a, b : integer;
    N, M, K, curv : integer;
    cure : longint;
    rhymein, rhymeout : array[1..MAXN, 1..MAXK] of integer;
    rhymes : array[1..MAXN+2*MAXN*MAXK] of tVertex;
    GA : array[1..MAXN+2*MAXN*MAXK] of longint;
    mark : array[1..MAXN+2*MAXN*MAXK] of boolean;
    GB : array[1..12*MAXM] of tEdge;

procedure ReadData;
var i, u, v, k : integer;

procedure addsimple(u, v, c : integer);
begin
  inc(cure);
  GB[cure].v:=v; GB[cure].c:=c; GB[cure].f:=0;
  GB[cure].next:=GA[u];
  if cure mod 2=0 then GB[cure].pair:=cure-1 else GB[cure].pair:=cure+1;
  GA[u]:=cure;
end;

procedure add(u, v, k : integer);
var uout, vin : integer;
begin
  if rhymeout[u, k]=0 then begin
    inc(curv); rhymes[curv].s:=u; rhymes[curv].k:=k; rhymeout[u, k]:=curv;

    addsimple(u, curv, 1); addsimple(curv, u, 0);
  end;

  if rhymein[v, k]=0 then begin
    inc(curv); rhymes[curv].s:=v; rhymes[curv].k:=k; rhymein[v, k]:=curv;

    addsimple(curv, v, 1); addsimple(v, curv, 0);
  end;

  uout:=rhymeout[u, k]; vin:=rhymein[v, k];

  addsimple(uout, vin, 1);
  addsimple(vin, uout, 0);
end;

begin
  fillchar(rhymein, sizeof(rhymein), 0);
  fillchar(rhymeout, sizeof(rhymeout), 0);

  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  read(N, K, a, b, M); curv:=N; cure:=0;
  for i:=1 to M do begin
    read(u, v, k);
    add(u, v, k);
  end;
end;

function DFSFlow(u : integer) : boolean;
var e : longint;
    v : integer;
begin
  mark[u]:=true;

  if u=b then begin DFSFlow:=true; exit; end;
  e:=GA[u];

  while e<>0 do begin
    v:=GB[e].v;

    if (not mark[v]) and (GB[e].c>GB[e].f) and (DFSFlow(v)) then begin
      inc(GB[e].f); dec(GB[GB[e].pair].f);

      DFSFlow:=true; exit;
    end;

    e:=GB[e].next;
  end;

  DFSFlow:=false;
end;

procedure DFSOut(u : integer);
var e, e2 : longint;
    v, w : integer;
begin
  if u=b then exit;

  e:=GA[u];
  while e<>0 do begin
    if GB[e].f>0 then begin
      v:=GB[e].v;
      dec(GB[e].f);

      write(rhymes[v].s, ' ', rhymes[v].k, ' ');

      e2:=GA[v];
      while e2<>0 do begin
        if GB[e2].f>0 then begin
          dec(GB[e2].f); w:=GB[e2].v; break;
        end;

        e2:=GB[e2].next;
      end;

      e2:=GA[w];
      while e2<>0 do begin
        if GB[e2].f>0 then begin
          dec(GB[e2].f); break;
        end;

        e2:=GB[e2].next;
      end;

      DFSOut(rhymes[w].s);

      break;
    end;

    e:=GB[e].next;
  end;
end;

procedure Solve;
var e : longint;
    i, res : integer;
begin
  while true do begin
    fillchar(mark, sizeof(mark), false);
    if not DFSFlow(a) then break;
  end;

  res:=0; e:=GA[a];
  while e<>0 do begin
   if GB[e].f>0 then inc(res);

   e:=GB[e].next;
  end;

  writeln(res);

  for i:=1 to res do begin
    DFSOut(a);
    writeln(b);
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
