program Popular;
const infile = 'popular.in';
      outfile = 'popular.out';
      MAXN = 5000;
      EPS = 1e-10;
      inf = 1000000000;
type real = extended;
var x, l : array[1..MAXN] of real;
    N : integer;

procedure ReadData;
var i : integer;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  read(N);
  for i:=1 to N do
    read(x[i], l[i]);
end;

function TryOneRope : boolean;
var i, j : integer;
    b : boolean;
begin
  for i:=1 to N do begin
    b:=true;
    for j:=1 to N do
      if (i<>j) and (sqrt(sqr(x[j]-x[i])+sqr(l[i]))>l[j]+EPS) then begin
        b:=false; break;
      end;
    if b then begin
      writeln(x[i]:0:4, ' ', -l[i]:0:4);
      TryOneRope:=true; exit;
    end;
  end;
  TryOneRope:=false;
end;

function TryTwoRopes : boolean;
var i, j : integer;
    b : boolean;
    minh, minc, th, tc, d : real;
begin
  b:=true;
  for i:=1 to N do begin
    for j:=i+1 to N do
      if (i<>j) and (abs(x[i]-x[j])-EPS>l[i]+l[j]) then begin
        b:=false; break;
      end;

    if not b then break;
  end;
  if not b then begin
    TryTwoRopes:=false;
    exit;
  end;

  minh:=inf;
  for i:=1 to N do begin
    for j:=i+1 to N do
    if (i<>j) and (abs(x[i]-x[j])>EPS) then begin
      d:=abs(x[i]-x[j]);
      tc:=(sqr(l[i])+sqr(d)-sqr(l[j]))/(2*d);
      if (tc<-EPS) or (d-tc<-EPS) then continue;
      if l[i]<tc then tc:=l[i];
      th:=sqrt(sqr(l[i])-sqr(tc));

      if th<minh then begin
        minh:=th;
        if x[j]>x[i] then minc:=x[i]+tc else minc:=x[i]-tc;
      end;
    end;

    if minh>inf-EPS then continue; b:=true;
    for j:=1 to N do
      if (i<>j) and (sqrt(sqr(x[j]-minc)+sqr(minh))>l[j]+EPS) then begin
        b:=false; break;
      end;

    if b then begin
      writeln(minc:0:4, ' ', -minh:0:4);
      TryTwoRopes:=true; exit;
    end;
  end;

  TryTwoRopes:=false;
end;

procedure Solve;
begin
  if TryOneRope then exit;
  if TryTwoRopes then exit;
  writeln('-1 -1');
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
