{$M 20000000,30000000}

program Pursuit;
const infile = 'pursuit.in';
      outfile = 'pursuit.out';
      MAXN = 300;
      MAXM = 10000;
type
tOutcome = (_Caught, _Endless, _Escaped, _Undef);
tEdge = record
  v, k : integer;
  next : integer;
end;
var outs : array[1..MAXN, 1..MAXN] of tOutcome;
    pmo, cmo : array[1..MAXN, 1..MAXN] of longint;
    udef : array[1..MAXN, 1..MAXN] of boolean;
    n, m, k0, cur : integer;
    GA : array[1..MAXN] of integer;
    GB : array[1..2*MAXM] of tEdge;

procedure add(u, v, k : integer);
begin
  inc(cur); GB[cur].v:=v; GB[cur].k:=k; GB[cur].next:=GA[u]; GA[u]:=cur;
end;

procedure ReadData;
var i, u, v, k : integer;
begin
  for u:=1 to MAXN do
    for v:=1 to MAXN do
      outs[u, v]:=_Undef;
  fillchar(pmo, sizeof(pmo), 0);
  fillchar(cmo, sizeof(cmo), 0);
  fillchar(GA, sizeof(GA), 0);
  cur:=0;
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  read(n, m, k0);

  for i:=1 to m do begin
    read(u, v, k);
    add(u, v, k);
    add(v, u, k);

    outs[u, v]:=_Caught; pmo[u, v]:=1;
    outs[v, u]:=_Caught; pmo[v, u]:=1;
  end;
end;

function DFS(u, v : integer) : tOutcome;
var i, j, k, nu, nv : integer;
    transu, transv, mv : array[1..MAXN] of integer;
    bout, polout : tOutcome;
    bmove, polmove : longint;

procedure GetBest(u, v : integer);
var j : integer;
begin
  bout:=_Caught; bmove:=-1;
  for j:=1 to nv do begin
    v:=transv[j];
    DFS(u, v);

    if outs[u, v]=bout then begin
      if (bout=_Caught) and (pmo[u, v]>bmove) then bmove:=pmo[u, v];
      if (bout=_Escaped) and (cmo[u, v]+mv[j]<bmove) then bmove:=cmo[u, v]+mv[j];
    end;

    if outs[u, v]>bout then begin
      bout:=outs[u, v]; bmove:=cmo[u, v]+mv[j];
    end;
  end;
end;

begin
  if outs[u, v]<>_Undef then begin DFS:=outs[u, v]; exit; end;

  outs[u, v]:=_Endless;
  for k:=1 to k0 do begin
    nu:=0; nv:=1; mv[1]:=0; transv[1]:=v;

    j:=GA[u];
    while j<>0 do begin
      if GB[j].k=k then begin inc(nu); transu[nu]:=GB[j].v; end;
      j:=GB[j].next;
    end;

    j:=GA[v];
    while j<>0 do begin
      if GB[j].k=k then begin inc(nv); transv[nv]:=GB[j].v; mv[nv]:=1; end;
      j:=GB[j].next;
    end;

    polout:=_Escaped; polmove:=-1;
    for i:=1 to nu do begin
      GetBest(transu[i], v);

      if (bout=polout) then begin
        if (bout=_Escaped) and (bmove>polmove) then polmove:=bmove;
        if (bout=_Caught) and (bmove+1<polmove) then polmove:=bmove+1;
      end;

      if (bout<polout) then begin
        polout:=bout; polmove:=bmove+1;
      end;
    end;

    if (udef[u, v]) and (polmove<>-1) then begin
      udef[u, v]:=false; outs[u, v]:=polout;
      if polout=_Escaped then cmo[u, v]:=polmove else pmo[u, v]:=polmove;
    end;

    if (outs[u, v]=polout) then begin
      if (polout=_Escaped) and (cmo[u, v]<polmove) then cmo[u, v]:=polmove;
      if (polout=_Caught) and (pmo[u, v]>polmove) then pmo[u, v]:=polmove;
    end;

    if (outs[u, v]>polout) then begin
      outs[u, v]:=polout; pmo[u, v]:=polmove;
    end;
  end;
end;

procedure Solve;
var u0, v0, i : integer;
begin
  fillchar(udef, sizeof(udef), true);
  for i:=1 to N do begin
    outs[i, i]:=_Caught; pmo[i, i]:=0;
  end;

  for i:=1 to N do begin
    outs[i, 1]:=_Escaped; cmo[i, 1]:=0;
  end;

  read(u0, v0);
  DFS(u0, v0);

  if outs[u0, v0]=_Endless then begin writeln('Endless'); exit; end;
  if outs[u0, v0]=_Escaped then begin
    writeln('Escaped');
    writeln(cmo[u0, v0]);
  end else begin
    writeln('Caught');
    writeln(pmo[u0, v0]);
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
