program Necklace;
const infile = 'necklace.in';
      outfile = 'necklace.out';
      inf = 1000000000;
      MAXN = 50;
type real = double;
var resdiff : longint;
    n, k, shift, shmax : integer;
    chain : array[1..MAXN] of longint;
    bestcuts, curcuts : array[1..MAXN] of boolean;
    cums : array[0..MAXN] of longint;

function GetSum(l, r : integer) : longint;
begin
  GetSum:=cums[r]-cums[l-1];
end;

procedure GetHeuristic;
var i, j, p, jmax : integer;
    sum : longint;
    max, min : longint;
    res : real;
begin
  fillchar(curcuts, sizeof(curcuts), false);
  sum:=0;
  for i:=1 to N do
    sum:=sum+chain[i];
  res:=sum / k;

  p:=1; max:=-inf; min:=inf;
  for i:=1 to k-1 do begin
    jmax:=p;
    for j:=p to n-k+i do
      if abs(GetSum(p, j)-res)<abs(GetSum(p, jmax)-res) then jmax:=j;

    if min>GetSum(p, jmax) then min:=GetSum(p, jmax);
    if max<GetSum(p, jmax) then max:=GetSum(p, jmax);

    curcuts[jmax]:=true; p:=jmax+1;
  end;

  if min>GetSum(p, n) then min:=GetSum(p, n);
  if max<GetSum(p, n) then max:=GetSum(p, n);

  curcuts[n]:=true;

  if (max-min)<resdiff then begin
    shmax:=shift; bestcuts:=curcuts; resdiff:=max-min;
  end;
end;

procedure Run(start, left : integer; min, max : longint);
var tmin, tmax : longint;
    rmin, rmax : longint;
    i : integer;
begin
  if left=1 then begin
    curcuts[n]:=true;
    if min>GetSum(start, n) then tmin:=GetSum(start, n) else tmin:=min;
    if max<GetSum(start, n) then tmax:=GetSum(start, n) else tmax:=max;

    if (tmax-tmin)<resdiff then begin
      shmax:=shift; bestcuts:=curcuts; resdiff:=tmax-tmin;
    end;
    curcuts[n]:=false; exit;
  end;

  for i:=start to n-left+1 do begin
    if min>GetSum(start, i) then tmin:=GetSum(start, i) else tmin:=min;
    if max<GetSum(start, i) then tmax:=GetSum(start, i) else tmax:=max;

    if (tmax-tmin)<resdiff then begin
      if tmin*(left-1)>GetSum(i+1, n) then rmin:=GetSum(i+1, n) else rmin:=tmin*(left-1);
      if tmax*(left-1)<GetSum(i+1, n) then rmax:=GetSum(i+1, n) else rmax:=tmax*(left-1);
      if (rmax-rmin>=resdiff*(left-1)) then continue;

      curcuts[i]:=true;
      Run(i+1, left-1, tmin, tmax);
      curcuts[i]:=false;
    end;
  end;
end;

procedure ReadData;
var i : integer;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  read(n, k);
  for i:=1 to n do
    read(chain[i]);
end;

procedure MakeShift;
var temp : longint;
    i : integer;
begin
  temp:=chain[1];
  for i:=1 to n-1 do
    chain[i]:=chain[i+1];
  chain[n]:=temp;
end;

procedure Solve;
var i, j, p, q : integer;
begin
  fillchar(bestcuts, sizeof(bestcuts), 0);
  resdiff:=inf;
  for shift:=1 to n do begin
    cums[0]:=0;
    for j:=1 to n do
      cums[j]:=cums[j-1]+chain[j];
    GetHeuristic;
    MakeShift;
  end;

  for shift:=1 to 1 do begin
    cums[0]:=0;
    for j:=1 to n do
      cums[j]:=cums[j-1]+chain[j];
    fillchar(curcuts, sizeof(curcuts), false);

    Run(1, k, inf, -inf);
    MakeShift;
  end;

  for i:=shmax to n do
    chain[i-shmax+1]:=i;
  for i:=1 to shmax-1 do
    chain[n-shmax+i+1]:=i;

  writeln(resdiff);
  p:=1;
  for i:=1 to k do begin
    q:=p;
    while not bestcuts[p] do inc(p);
    for j:=q to p do
      write(chain[j], ' ');
    inc(p);

    writeln;
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
