program VirtualReality;
const infile = 'virtual.in';
      outfile = 'virtual.out';
      MAXN = 100;
var field, res, rsq : array[1..MAXN, 1..MAXN, 1..MAXN] of longword;
    hp : array[1..MAXN] of integer;
    k : longword;
    x0, y0, z0, x1, y1, z1 : integer;
    answer : int64;

procedure ReadData;
var zt, yt, xt : integer;
begin
  fillchar(rsq, sizeof(rsq), 0);
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  read(x0, y0, z0, x1, y1, z1, k); k:=k+1;

  for zt:=1 to z0 do
    for yt:=1 to y0 do
      for xt:=1 to x0 do
        read(field[zt, yt, xt]);
end;

function max(a, b : integer) : integer;
begin
  if a>b then max:=a else max:=b;
end;

function h(n : integer) : integer;
begin
  h:=(n xor (n-1)+1) shr 1;
end;

function RSQQuery(z, y, x : integer) : longword;
var res : longword;
    xt, yt, zt : integer;
begin
  res:=0; zt:=z;
  while zt>0 do begin
    yt:=y;
    while yt>0 do begin
      xt:=x;
      while xt>0 do begin
        res:=(res+rsq[zt, yt, xt]) mod k;
        dec(xt, hp[xt]);
      end;
      dec(yt, hp[yt]);
    end;
    dec(zt, hp[zt]);
  end;
  RSQQuery:=res;
end;

function Get(z1, y1, x1, z2, y2, x2 : integer) : longword;
var res : longword;
begin
  res:=RSQQuery(z2, y2, x2);

  res:=(res+k-RSQQuery(z1-1, y2, x2)) mod k;
  res:=(res+k-RSQQuery(z2, y1-1, x2)) mod k;
  res:=(res+k-RSQQuery(z2, y2, x1-1)) mod k;

  res:=(res+RSQQuery(z1-1, y1-1, x2)) mod k;
  res:=(res+RSQQuery(z1-1, y2, x1-1)) mod k;
  res:=(res+RSQQuery(z2, y1-1, x1-1)) mod k;

  res:=(res+k-RSQQuery(z1-1, y1-1, x1-1)) mod k;
  Get:=res;
end;

procedure RSQChange(z, y, x : integer; delta : longword);
var xt, yt, zt : integer;
begin
  zt:=z;
  while zt<=z0 do begin
    yt:=y;
    while yt<=y0 do begin
      xt:=x;
      while xt<=x0 do begin
        rsq[zt, yt, xt]:=(rsq[zt, yt, xt]+delta) mod k;
        inc(xt, hp[xt]);
      end;
      inc(yt, hp[yt]);
    end;
    inc(zt, hp[zt]);
  end;
end;

procedure Solve;
var xt, yt, zt : integer;
    infl, delta : longword;
begin
  for xt:=1 to MAXN do
    hp[xt]:=h(xt);

  answer:=0;
  for zt:=1 to z0 do
    for yt:=1 to y0 do
      for xt:=1 to x0 do begin
        infl:=Get(max(zt-z1+1, 1), max(yt-y1+1, 1), max(xt-x1+1, 1), zt, yt, xt);

        res[zt, yt, xt]:=(field[zt, yt, xt]+infl) mod k;

        if (zt<=z0-z1+1) and (yt<=y0-y1+1) and (xt<=x0-x1+1) then begin
          delta:=(k-res[zt, yt, xt]) mod k;
          RSQChange(zt, yt, xt, delta);
          res[zt, yt, xt]:=0; answer:=answer+delta;
        end;
      end;

  for zt:=1 to z0 do
    for yt:=1 to y0 do
      for xt:=1 to x0 do
        if res[xt, yt, zt]<>0 then begin
          writeln(-1); exit;
        end;

  writeln(answer);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
