program GuessLie;
uses guess;
const MAXN = 200000;

var n, k, q : longint;
    p, diff : array[0..MAXN] of longint;
    sums : array[-1..MAXN] of longint;
    a : array[1..MAXN] of longint;

procedure DSUMakeSet(u : longint);
begin
  p[u]:=u; diff[u]:=0;
end;

function DSUFindSet(u : longint) : longint;
var tp : longint;
begin
  if p[u]<>u then begin
    tp:=p[u];
    p[u]:=DSUFindSet(p[u]);

    diff[u]:=(diff[u]+diff[tp]) mod k;
  end;

  DSUFindSet:=p[u];
end;

procedure DSUUnion(u, v, s : longint);
begin
  p[v]:=u; diff[v]:=s;
end;

function DSUCheck(l, r, d : longint) : boolean;
begin
  DSUCheck:=(diff[l]+d+k-diff[r]) mod k=0;
end;

procedure ProduceAnswer;
var i : longint;
begin
  for i:=0 to n do
    DSUFindSet(i);

  fillchar(sums, sizeof(sums), 0);

  for i:=1 to n do begin
    sums[i]:=(sums[p[i]-1]+diff[i]) mod k;
    a[i]:=(sums[i]+k-sums[i-1]) mod k;
  end;
end;

procedure Solve;
var l, r, s, i : longint;
    p1, p2 : longint;
begin
  Initialize(n, k, q);

  for l:=0 to n do
    DSUMakeSet(l);

  for i:=1 to q do begin
    NextQuery(l, r, s);

    p1:=DSUFindSet(l-1); p2:=DSUFindSet(r);

    if p1<>p2 then begin

      if (p1>p2) then
        DSUUnion(p2, p1, (diff[r]+2*k-diff[l-1]-s) mod k);

      if (p1<p2) and (p2<=l-1) then
        DSUUnion(p1, p2, (diff[l-1]+s+k-diff[r]) mod k);

      if (p2>l-1) then
        DSUUnion(p1, p2, (diff[l-1]+s+k-diff[r]) mod k);

    end else begin

      if not DSUCheck(l-1, r, s) then begin
        ProduceAnswer; Error(n, a);
      end;

    end;
  end;

  ProduceAnswer; Consistent(n, a);
end;

begin
  Solve;
end.
