program EqualStates;
const infile = 'eq.in';
      outfile = 'eq.out';
      MAXN = 350;
      inf = 10000;
type tPrev = record
  u, v, p : integer;
end;
var t, n, m : integer;
    isterm : array[1..MAXN] of boolean;
    terms : array[1..MAXN] of integer;
    f : array[1..MAXN, 0..1] of integer;
    dist : array[1..MAXN, 1..MAXN] of integer;
    prev : array[1..MAXN, 1..MAXN] of tPrev;
    Q : array[1..MAXN*MAXN, 1..2] of integer;

procedure ReadData;
var i : integer;
begin
  fillchar(isterm, sizeof(isterm), false);
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  read(n, t);

  for i:=1 to t do begin
    read(terms[i]); isterm[terms[i]]:=true;
  end;

  for i:=1 to n do begin
    read(f[i, 0], f[i, 1]);
  end;
end;

procedure BFS(u0, v0 : integer);
var l, r, p, uc, vc : integer;

procedure Relax(un, vn, uo, vo, p : integer);
begin
  if (dist[un, vn]>dist[uo, vo]+1) then begin
    dist[un, vn]:=dist[uo, vo]+1;
    prev[un, vn].u:=uo; prev[un, vn].v:=vo; prev[un, vn].p:=p;
    inc(r); Q[r, 1]:=un; Q[r, 2]:=vn;
  end;
end;

begin
  for l:=1 to N do
    for r:=1 to N do
      dist[l, r]:=inf;
  l:=1; r:=1; Q[1, 1]:=u0; Q[1, 2]:=v0; dist[u0, v0]:=0;
  prev[u0, v0].u:=0; prev[u0, v0].v:=0; prev[u0, v0].p:=0;

  while l<=r do begin
    uc:=Q[l, 1]; vc:=Q[l, 2]; inc(l);

    for p:=0 to 1 do
      Relax(f[uc, p], f[vc, p], uc, vc, p);
  end;
end;

procedure GetPath(u, v : integer);
begin
  if dist[u, v]=0 then exit;
  GetPath(prev[u, v].u, prev[u, v].v);
  write(prev[u, v].p);
end;

procedure Solve;
var count, i, j, u0, v0 : integer;
    min, minu, minv : integer;
begin
  read(m);
  for count:=1 to m do begin
    read(u0, v0); BFS(u0, v0);

    min:=inf;
    for i:=1 to n do
      for j:=1 to t do begin
        if isterm[i] then continue;

        if dist[terms[j], i]<min then begin
          min:=dist[terms[j], i]; minu:=terms[j]; minv:=i;
        end;

        if dist[i, terms[j]]<min then begin
          min:=dist[i, terms[j]]; minu:=i; minv:=terms[j];
        end;
      end;

    if min=inf then write('equivalent') else GetPath(minu, minv);
    writeln;
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
