program Experssion;
const infile = 'expr.in';
      outfile = 'expr.out';
      MAXN = 80;
      MAXV = 360;
var evaluable : array[1..MAXN, 1..MAXN] of boolean;
    res : array[1..MAXN, 1..MAXN, -MAXV..MAXV] of boolean;
    nvals : array[1..MAXN, 1..MAXN] of integer;
    vals : array[1..MAXN, 1..MAXN, 1..MAXV*2+1] of integer;
    seq : array[1..MAXN] of char;
    SeqLen : integer;

function isDigit(ch : char) : boolean;
begin
  if ('0'<=ch) and (ch<='9') then isDigit:=true else isDigit:=false;
end;

procedure ReadData;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  SeqLen:=0;
  while not eoln(input) do begin
    inc(SeqLen); read(seq[SeqLen]);
  end;
end;

procedure Evaluate(i, j : integer);
var k : integer;
begin
  if (i=j) and (isDigit(seq[i])) then begin
    evaluable[i, j]:=true; exit;
  end else
    evaluable[i, j]:=false;

  if (seq[i]='+') or (seq[i]='-') then begin
    for k:=i+1 to j do
      if evaluable[i+1, k] and evaluable[k+1, j] then begin
        evaluable[i, j]:=true; break;
      end;
    exit;
  end;

  if (seq[j]='+') or (seq[j]='-') then begin
    for k:=i to j-2 do
      if evaluable[i, k] and evaluable[k+1, j-1] then begin
        evaluable[i, j]:=true; break;
      end;
    exit;
  end;

  for k:=i+1 to j-1 do
    if ((seq[k]='+') or (seq[k]='-')) and evaluable[i, k-1] and evaluable[k+1, j] then begin
      evaluable[i, j]:=true; break;
    end;
end;

procedure Calculate(i, j : integer);
var k : integer;

function Apply(n1, n2 : integer; ch : char) : integer;
begin
  if ch='+' then Apply:=n1+n2 else Apply:=n1-n2;
end;

procedure Update(l1, r1, l2, r2 : integer; ch : char);
var n1, n2, p : integer;
begin
  for n1:=1 to nvals[l1, r1] do
    for n2:=1 to nvals[l2, r2] do begin
      p:=Apply(vals[l1, r1, n1], vals[l2, r2, n2], ch);

      if (p>=-MAXV) and (p<=MAXV) and (not res[i, j, p]) then begin
        res[i, j, p]:=true; inc(nvals[i, j]);
        vals[i, j, nvals[i, j]]:=p;
      end;
    end;
end;

begin
  if (i=j) and (isDigit(seq[i])) then begin
    res[i, j, ord(seq[i])-48]:=true;
    nvals[i, j]:=1; vals[i, j, 1]:=ord(seq[i])-48;
    exit;
  end;
  if not evaluable[i, j] then exit;

  if (seq[i]='+') or (seq[i]='-') then begin
    for k:=i+1 to j do
      if evaluable[i+1, k] and evaluable[k+1, j] then
        Update(i+1, k, k+1, j, seq[i]);

    exit;
  end;

  if (seq[j]='+') or (seq[j]='-') then begin
    for k:=i to j-2 do
      if evaluable[i, k] and evaluable[k+1, j-1] then
        Update(i, k, k+1, j-1, seq[j]);

    exit;
  end;

  for k:=i+1 to j-1 do
    if ((seq[k]='+') or (seq[k]='-')) and evaluable[i, k-1] and evaluable[k+1, j] then
      Update(i, k-1, k+1, j, seq[k]);
end;

procedure Solve;
var i, j : integer;
begin
  fillchar(evaluable, sizeof(evaluable), false);
  fillchar(res, sizeof(res), false);
  fillchar(nvals, sizeof(nvals), 0);
  for i:=1 to SeqLen do
    for j:=1 to i-1 do
      evaluable[i, j]:=false;

  for i:=1 to SeqLen do
    for j:=1 to SeqLen-i+1 do
      Evaluate(j, j+i-1);

  for i:=1 to SeqLen do
    for j:=1 to SeqLen-i+1 do
      Calculate(j, j+i-1);

  writeln(nvals[1, SeqLen]);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
