program Necklace;
const infile = 'necklace.in';
      outfile = 'necklace.out';
      MAXN = 100001;
      MAXK = 10000;
      DT = 1e-10;
type
real = double;
tGem = record
  a : real;
  w : longint;
end;
var gems : array[1..MAXN] of tGem;
    sums : array[0..MAXN] of int64;
    res : array[1..MAXK] of int64;
    delta, eps : real;
    N, K : longint;
    inf, answer, min, max : int64;

procedure HeapSort;
var i : longint;

procedure Swap(i, j : longint);
var t : tGem;
begin
  t:=gems[i]; gems[i]:=gems[j]; gems[j]:=t;
end;

procedure Heapify(i, hs : longint);
var l, r, largest : longint;
begin
  while true do begin
    l:=i shl 1; r:=l+1; largest:=i;

    if (l<=hs) and (gems[l].a>gems[largest].a) then largest:=l;
    if (r<=hs) and (gems[r].a>gems[largest].a) then largest:=r;

    if largest=i then break;
    Swap(i, largest); i:=largest;
  end;
end;

begin
  for i:=(N div 2) downto 1 do
    Heapify(i, N);

  for i:=N downto 2 do begin
    Swap(i, 1);
    Heapify(1, i-1);
  end;
end;

procedure ReadData;
var i : longint;
begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);

  read(N, K);
  for i:=1 to N do
    read(gems[i].a, gems[i].w);
end;

function GetSum(l, r : longint) : int64;
begin
  GetSum:=sums[r]-sums[l-1];
end;

function GemSearch(a : real) : longint;
var l, r, m : longint;
begin
  l:=1; r:=N+1;
  while l<r do begin
    m:=(l+r) shr 1;

    if a>gems[m].a+DT then l:=m+1 else r:=m;
  end;
  GemSearch:=l;
end;

procedure Solve;
var i, l, r, p : longint;
    a : real;
    s0 : int64;
begin
  delta:=2*pi/k; sums[0]:=0; a:=0; eps:=2*pi/500000;
  HeapSort; gems[N+1].a:=1000; inf:=1000000000; inf:=inf*inf;
  answer:=inf;

  for i:=1 to N do
    sums[i]:=sums[i-1]+gems[i].w;

  while a<=delta do begin
    s0:=0; min:=inf; max:=-inf;

    p:=GemSearch(a);

    for i:=1 to k do begin
      l:=GemSearch(a+(i-1)*delta); r:=GemSearch(a+i*delta);
      res[i]:=GetSum(l, r-1); s0:=s0+res[i];
    end;

    if p>1 then res[k]:=res[k]+sums[p-1];

    for i:=1 to k do begin
      if res[i]>max then max:=res[i];
      if res[i]<min then min:=res[i];
    end;

    if abs(max-min)<answer then answer:=abs(max-min);

    a:=a+eps;
  end;

  writeln(answer);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
