program TreeReduction;
const infile = 'tree.in';
      outfile = 'tree.out';
      MAXN = 250;
      inf = 255;
type
byte=integer;
tEdge = record
  v, next, order : integer;
end;
var temp, fromtemp, fromtempedge : array[1..MAXN, 1..MAXN, 0..MAXN] of byte;
    fromres, res : array[1..MAXN, 1..MAXN] of byte;
    GA, pow, nch, pe : array[1..MAXN] of integer;
    mustdie : array[1..MAXN] of boolean;
    GB : array[1..MAXN-1] of tEdge;
    N, p : integer;

procedure ReadData;
var G : array[1..MAXN, 1..MAXN] of integer;
    mark : array[1..MAXN] of boolean;
    i, a, b, cur : integer;

procedure AddEdge(u, v, order : integer);
begin
  inc(cur); GB[cur].v:=v; GB[cur].order:=order; GB[cur].next:=GA[u]; GA[u]:=cur;
end;

procedure DFS(u : integer);
var v : integer;
begin
  mark[u]:=true; pow[u]:=1;
  for v:=1 to N do begin
    if (G[u, v]=0) or (mark[v]) then continue;

    DFS(v);
    inc(nch[u]); inc(pow[u], pow[v]); AddEdge(u, v, G[u, v]); pe[v]:=G[u, v];
  end;
end;

begin
  fillchar(mark, sizeof(mark), false);
  fillchar(pow, sizeof(pow), 0);
  fillchar(nch, sizeof(nch), 0);
  fillchar(G, sizeof(G), 0); cur:=0;

  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  read(N, p);

  for i:=1 to N-1 do begin
    read(a, b);
    G[a, b]:=i; G[b, a]:=i;
  end;

  DFS(1);

  for i:=1 to N do
    for a:=1 to N do
      for b:=0 to N do
        temp[i, a, b]:=inf;

  for i:=1 to N do
    for a:=1 to N do
      res[i, a]:=inf;
end;

procedure run(u : integer);
var i, j, k, e, v, q : integer;
begin
  temp[u, 1, 0]:=0;

  e:=GA[u]; q:=0;
  while e<>0 do begin
    v:=GB[e].v; inc(q);

    run(v);
    for k:=q downto 1 do
      for i:=1 to pow[u] do
        if temp[u, i, k-1]<inf then
          for j:=1 to pow[v] do
            if (res[v, j]<inf) and (temp[u, i+j, k]>temp[u, i, k-1]+res[v, j]) then begin
              temp[u, i+j, k]:=temp[u, i, k-1]+res[v, j];

              fromtemp[u, i+j, k]:=i;
              fromtempedge[u, i+j, k]:=e;
            end;

    e:=GB[e].next;
  end;

  for i:=1 to pow[u] do
    for j:=0 to nch[u] do
      if (temp[u, i, j]+nch[u]-j<res[u, i]) then begin
        res[u, i]:=temp[u, i, j]+nch[u]-j;

        fromres[u, i]:=j;
      end;
end;

procedure BackTrace(u, q : integer);
var p, qt, pt, e : integer;
    tempdie : array[1..MAXN] of boolean;
begin
  fillchar(tempdie, sizeof(tempdie), true);
  p:=fromres[u, q]; qt:=q; pt:=p;

  while (pt<>0) do begin
    e:=fromtempedge[u, qt, pt];
    BackTrace(GB[e].v, qt-fromtemp[u, qt, pt]);
    tempdie[GB[e].order]:=false;

    qt:=fromtemp[u, qt, pt]; pt:=pt-1;
  end;

  e:=GA[u];
  while e<>0 do begin
    if tempdie[GB[e].order] then mustdie[GB[e].order]:=true;
    e:=GB[e].next;
  end;
end;

procedure Solve;
var i, min, temp, mini : integer;
begin
  fillchar(mustdie, sizeof(mustdie), false);
  fillchar(fromtemp, sizeof(fromtemp), 0);

  run(1); min:=inf;
  for i:=1 to n do begin
    temp:=res[i, p]; if i<>1 then inc(temp);
    if temp<min then begin min:=temp; mini:=i; end;
  end;

  writeln(min);

  if mini<>1 then mustdie[pe[mini]]:=true;

  BackTrace(mini, p);
  for i:=1 to N-1 do
    if mustdie[i] then write(i, ' ');
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
