{$o-,q+,r+}
uses sysutils;

type TLenTable=array of integer;
     PNode=^TNode;
     TNode=record
       u, l, r:PNode;
       value:integer;
     end;


function buildtree (T:TLenTable):PNode;
var max, i, j, k, l:integer;
    cur:PNode;
label lasttest;
begin
  new (Result); Result.u:=nil;
  max:=0; for i:=low (T) to high (T) do if T[i]>max then max:=T[i];
  cur:=Result; for i:=1 to max do begin
    cur.value:=-2; new (cur.l); cur.l.u:=cur; cur:=cur.l;
  end;
  for j:=max downto 1 do begin
    for i:=low (T) to high (T) do if T[i]=j then begin
      T[i]:=0;
      cur.value:=i; cur.l:=nil; cur.r:=nil;
      l:=0; repeat 
        cur:=cur.u; if cur=nil then goto lasttest;
        inc (l);
      until cur.value=-2;
      cur.value:=-1; new (cur.r); cur.r.u:=cur; cur:=cur.r;
      for k:=2 to l do begin
        cur.value:=-2; new (cur.l); cur.l.u:=cur; cur:=cur.l
      end;
    end;
    cur:=cur.u; dispose (cur.l); assert (cur.value=-2);
  end;
  lasttest:
  for i:=low (T) to high (T) do assert (T[i]=0);
end;
       

const MaxL=16777216;
      MaxLen=239017;

var s:array [0..MaxL-1] of byte;
    out:array [0..MaxLen-1] of byte;
    size, outsize:integer;


procedure readtet;
var c:char;
    z, t:integer;
begin
  read (c); assert (c in ['0'..'9', 'A'..'F']);
  if c>'9' then z:=ord (c)-55 else z:=ord (c)-48;
  for t:=size+3 downto size do begin s[t]:=z and 1; z:=z shr 1 end;
  inc (size, 4);
  assert (size<=MaxL);
end;

var ptr:integer;


function streamvalue (b:integer):integer;
var i:integer;
begin
  Result:=0;
  for i:=1 to b do begin Result:=Result shl 1 + s[ptr]; inc (ptr) end;
  assert (ptr<=size);
end;


function streamtree (T:PNode):integer;
begin
  while T.L<>nil do begin
    if s[ptr]=0 then T:=T.L else T:=T.R;
    inc (ptr);
  end;
  assert (ptr<=size);
  Result:=T.value;
end;

const bs:array [0..31] of integer=
(1, 2, 3, 4, 6, 8, 12, 16, 24, 32, 48, 64, 96, 128, 192, 256, 384, 512,
 768, 1024, 1536, 2048, 3072, 4096, 6144, 8192, 12288, 16384, 24576,
 32768, 49152, 65536);
const sz:array [0..31] of integer=
(0, 0, 0, 1, 1, 2, 2, 3, 3, 4, 4, 5, 5, 6, 6, 7, 7, 8, 8, 9, 9, 10, 10,
 11, 11, 12, 12, 13, 13, 14, 14, 15);


var x, l, code, i, len:integer;
    T1, T2, T3:TLenTable;
    TR1, TR2, TR3:PNode;


begin
  size:=0;
  repeat
    readtet; readtet;
  until seekeof;
  ptr:=0;
  assert (streamvalue (32) = $4b417204);
  len:=streamvalue (8)+streamvalue(8) shl 8+streamvalue (8) shl 16+streamvalue (8) shl 24;
  assert ((len>=1) and (len<=MaxLen));
  setlength (T1, 24); setlength (T2, 256+32); setlength (T3, 32);
  for i:=0 to 23 do T1[i]:=streamvalue (4);
  TR1:=buildtree (T1);
  for i:=0 to 255+32 do T2[i]:=streamtree (TR1);
  TR2:=buildtree (T2);
  for i:=0 to 31 do T3[i]:=streamtree (TR1);
  TR3:=buildtree (T3);
  outsize:=0;
  repeat
    code:=streamtree (TR2);
    if code<256 then begin out[outsize]:=code; inc (outsize) end else begin
      x:=bs[code-256]+streamvalue (sz[code-256]);
      l:=streamtree (TR3);
      l:=bs[l]+streamvalue (sz[l]);
      assert ((x>0) and (x<=outsize) and (l<=MaxLen));
      while l>0 do begin out[outsize]:=out[outsize-x]; inc (outsize); dec (l) end;
    end;
  until outsize>=len;
  assert (outsize=len);
  assert ((ptr+7) and (-8) = size);
  assert (streamvalue (size-ptr)=0);
  for i:=0 to outsize-1 do write (format ('%.2X', [out[i]]));
end.