Uses Crt;
Const
  MaxSize=40;
  MaxN=8;
Type
  TPos=Record
    Row,Col:Integer;
  End;
  TMove=(_Still,_Down,_Up,_Right,_Left);
Const
  MoveDR:Array[TMove]Of Integer=(0,1,-1,0,0);
  MoveDC:Array[TMove]Of Integer=(0,0,0,1,-1);
  MoveCode:Array[TMove]Of Char='WDURL';
Var
  Field:Array[1..MaxSize,1..MaxSize]Of Boolean;
  N:Integer;
  Mon:Array[1..MaxN]Of TPos;
  Cur,Start,Finish:TPos;
  I,Height,Width,Row,Col:Integer;
  Ch:Char;
  Res:Text;
  Queue:Array[1..MaxSize*MaxSize]Of TPos;
  QuTail,QuHead:Integer;
  Dist:Array[1..MaxSize,1..MaxSize]Of Integer;
Procedure DrawMove(Var Who:TPos; How:TMove; Color:Integer; Ch:Char);
Begin
  GotoXY(Who.Col,Who.Row);
  If (Who.Row=Finish.Row) And (Who.Col=Finish.Col) Then Begin
    TextColor(11);
    Write('&');
  End Else Begin
    TextColor(7);
    Write('.');
  End;
  Inc(Who.Row,MoveDR[How]);
  Inc(Who.Col,MoveDC[How]);
  GotoXY(Who.Col,Who.Row);
  TextColor(Color);
  Write(Ch);
End;
Procedure Die;
Begin
  TextColor(7);
  ClrScr;
  WriteLn('Suxxx');
  Close(Res);
  Halt;
End;
Procedure MoveMonsters;
Var
  I:Integer;
  At,Nxt:TPos;
  M:TMove;
Begin
  QuHead:=2;
  QuTail:=1;
  Queue[1]:=Cur;
  FillChar(Dist,SizeOf(Dist),255);
  Dist[Cur.Row,Cur.Col]:=0;
  While QuTail<QuHead Do Begin
    At:=Queue[QuTail];
    Inc(QuTail);
    For M:=Low(TMove) To High(TMove) Do Begin
      Nxt.Row:=At.Row+MoveDR[M];
      Nxt.Col:=At.Col+MoveDC[M];
      If Field[Nxt.Row,Nxt.Col] And (Dist[Nxt.Row,Nxt.Col]=-1) Then Begin
        Dist[Nxt.Row,Nxt.Col]:=Dist[At.Row,At.Col]+1;
        Queue[QuHead]:=Nxt;
        Inc(QuHead);
      End;
    End;
  End;
  For I:=1 To N Do Begin
    If Dist[Mon[I].Row,Mon[I].Col]<0 Then Continue;
    If Dist[Mon[I].Row,Mon[I].Col]<2 Then Die;
    For M:=Low(TMove) To High(TMove) Do
      If Dist[Mon[I].Row+MoveDR[M],Mon[I].Col+MoveDC[M]]=Dist[Mon[I].Row,Mon[I].Col]-1 Then Break;
    DrawMove(Mon[I],M,12,'');
  End;
End;
Procedure TryMove(How:TMove);
Begin
  If Field[Cur.Row+MoveDR[How],Cur.Col+MoveDC[How]] Then Begin
    DrawMove(Cur,How,10,'@');
    Write(Res,MoveCode[How]);
    MoveMonsters;
  End;
End;
Begin
  ClrScr;
  FillChar(Field,SizeOf(Field),True);
  Assign(Input,'');
  ReSet(Input);
  Assign(Res,'res.txt');
  ReWrite(Res);
  Read(Input,Height,Width);
  N:=0;
  For Row:=1 To Height Do
    For Col:=1 To Width Do Begin
      Repeat
        Read(Input,Ch);
      Until Ch>' ';
      Case UpCase(Ch) Of
        '.':;
        '#':Field[Row,Col]:=False;
        'S':Begin
          Start.Row:=Row;
          Start.Col:=Col;
        End;
        'E':Begin
          Finish.Row:=Row;
          Finish.Col:=Col;
        End;
        'W':Begin
          Inc(N);
          Mon[N].Row:=Row;
          Mon[N].Col:=Col;
        End;
      End;
    End;
  GotoXY(1,1);
  For Row:=1 To Height Do Begin
    For Col:=1 To Width Do Begin
      If Field[Row,Col] Then Begin
        TextColor(7);
        Write('.');
      End Else Begin
        TextColor(15);
        Write('#');
      End;
    End;
    WriteLn;
  End;
  For I:=1 To N Do DrawMove(Mon[I],_Still,12,'');
  DrawMove(Start,_Still,10,'@');
  DrawMove(Finish,_Still,11,'&');
  Cur:=Start;
  While True Do Begin
    Ch:=ReadKey;
    If Ch=#0 Then Ch:=ReadKey;
    Case Ch Of
      #72:TryMove(_Up);
      #75:TryMove(_Left);
      #77:TryMove(_Right);
      #80:TryMove(_Down);
      #32:TryMove(_Still);
      #27:Begin
        Close(Res);
        Halt;
      End;
    End;
    If (Cur.Row=Finish.Row) And (Cur.Col=Finish.Col) Then Break;
  End;
  Close(Res);
End.
