Type
  Integer=LongInt;
Const
  MaxN=10000;
  MaxNum=1000000000;
  MaxPrime=32768;
  Base=10000;
  MaxLong=30000;
Var
  N:Integer;
  A:Array[0..MaxN]Of Integer;
  I,J:Integer;
  P:Array[1..MaxPrime]Of Boolean;
  Len:Integer;
  Digit:Array[0..MaxLong]Of Integer;
Procedure LMul(By:Integer);
Var
  R:Int64;
  J:Integer;
Begin
  R:=0;
  For J:=0 To Len-1 Do Begin
    Inc(R,Int64(Digit[J])*By);
    Digit[J]:=R Mod Base;
    R:=R Div Base;
  End;
  While R>0 Do Begin
    Digit[Len]:=R Mod Base;
    R:=R Div Base;
    Inc(Len);
  End;
End;
Procedure Process(I:Integer);
Var
  J,K,MaxK:Integer;
Begin
  MaxK:=0;
  For J:=1 To N Do Begin
    K:=0;
    While A[J] Mod I=0 Do Begin
      A[J]:=A[J] Div I;
      Inc(K);
    End;
    If K>MaxK Then MaxK:=K;
  End;
  For K:=1 To MaxK Do LMul(I);
End;
Procedure QSort(L,R:Integer);
Var
  I,J,X,Y:Integer;
Begin
  I:=L;
  J:=R;
  X:=A[L+Random(R-L+1)];
  While I<=J Do Begin
    While A[I]<X Do Inc(I);
    While X<A[J] Do Dec(J);
    If I<=J Then Begin
      Y:=A[I];
      A[I]:=A[J];
      A[J]:=Y;
      Inc(I);
      Dec(J);
    End;
  End;
  If L<J Then QSort(L,J);
  If I<R Then QSort(I,R);
End;
Begin
  RandSeed:=542817211;
  Read(N); assert ((n>=1) and (n<=2000));
  For I:=1 To N Do begin Read(A[I]); assert ((a[i]>=1) and (a[i]<=1000000000)); end;
  FillChar(P,SizeOf(P),True);
  FillChar(Digit,SizeOf(Digit),0);
  Len:=1;
  Digit[0]:=1;
  For I:=2 To MaxPrime Do If P[I] Then Begin
    For J:=2 To MaxPrime Div I Do P[I*J]:=False;
    Process(I);
  End;
  QSort(1,N);
  A[0]:=1;
  For I:=1 To N Do If A[I]>A[I-1] Then
    Process(A[I]);
  Write(Digit[Len-1]);
  For I:=Len-2 DownTo 0 Do Begin
    If Digit[I]<1000 Then Write('0');
    If Digit[I]<100 Then Write('0');
    If Digit[I]<10 Then Write('0');
    Write(Digit[I]);
  End;
  WriteLn;
End.
