{$D+,L+,I+,Q+,R+,S+,O-}
Program pr_c;
const
  inpfile='quirks.in';
  outfile='quirks.out';
  nm=50005;
type
  PNode = ^Node;
  Node = record
    x : LongInt;
    next : PNode;
  end;
var
  a : array [1..nm] of PNode;
  d,f : array [0..nm] of LongInt;
  col : array [1..nm] of LongInt;
  tnum,n,m : LongInt;
  time : LongInt;
  solved : Boolean;
{}
Procedure Inp;
begin
  assign(output,outfile);
  rewrite(output);
  assign(input,inpfile);
  reset(input);
  read(tnum);
end;
{}
Procedure Out;
begin
  close(output);
  halt;
end;
{}
Procedure WritAns(ok : Boolean);
begin
  if ok then writeln('YES')
        else writeln('NO');
  solved:=true;      
end;
{}
Procedure Dfs1(x : LongInt);
var
  p : PNode;
begin
  col[x]:=1;

  p:=a[x];
  while p<>nil do begin
    if col[p^.x]=0 then Dfs1(p^.x);
    p:=p^.next;
  end;

  inc(time); f[x]:=time;
end;
{}
Procedure Update(d : LongInt; var f,f2 : LongInt);
begin
  if d<f then begin
    f2:=f; f:=d;
  end else
  if d<f2 then f2:=d;
end;
{}
Procedure Dfs2(x : LongInt);
var
  f2 : LongInt;
  p : PNode;
begin
  col[x]:=1;
  inc(time); d[x]:=time;

  p:=a[x]; f2:=n+1;
  while p<>nil do begin
    if col[p^.x]=2 then begin
      WritAns(false);
      exit;
    end;
    if col[p^.x]=1 then begin
      Update(d[p^.x],f[x],f2);
      if f2<d[x] then begin
        WritAns(false);
        exit;
      end;
    end else begin
      Dfs2(p^.x);
      if solved then exit;
      Update(f[p^.x],f[x],f2);
      if f2<d[x] then begin
        WritAns(false);
        exit;
      end;
    end;
    p:=p^.next;
  end;

  col[x]:=2;
end;
{}
Procedure Solve;
var
  i,t : LongInt;
  x,y : LongInt;
  num : LongInt;
  p : PNode;
begin
  for t:=1 to tnum do begin
    solved:=false;
    fillchar(a,sizeof(a),0);

    read(n,m);
    for i:=1 to m do begin
      read(x,y);
      new(p);
      p^.x:=y;
      p^.next:=a[x];
      a[x]:=p;
    end;


    time:=0;
    fillchar(f,sizeof(f),0);
    fillchar(col,sizeof(col),0);
    for i:=1 to n do
      if col[i]=0 then Dfs1(i);

    num:=0;
    for i:=1 to n do
      if f[i]>f[num] then num:=i;

    time:=0;
    fillchar(d,sizeof(d),0);
    fillchar(col,sizeof(col),0);
    for i:=1 to n do f[i]:=n+1;
    Dfs2(num);

    if not solved then begin
      for i:=1 to n do
        if col[i]=0 then begin
          WritAns(false);
          break;
        end;

      if not solved then WritAns(true);  
    end;
  end;
end;
{}
Begin
  Inp;
  Solve;
  Out;
End.
