{$APPTYPE CONSOLE}
{$O+,R-,Q-,I-}

program zzz;

uses math,sysutils;

const
  eps = 1e-8;

type
  point = record
    x,y: Double;
  end;

var
  pp,sc1,sc2,res,leftg,rightg,cmax,sc,buf,i,j,k,n,m: Longint;
  pol: array[0..300] of Point;
  vis: array[1..300] of Boolean;
  a: array[1..300,0..300] of Longint;
  best: array[1..300,1..300] of Longint;
  q1,q2,b: array[1..300] of Longint;
  fl1: Boolean;

function vectorp(a,b,c: Point): Double;
begin
  vectorp := (a.x - b.x) * (b.y - c.y) - (a.y - b.y) * (b.x - c.x);
end;

procedure sort1(num: Longint; st,fin: Longint);
var i,j: Longint;
    k: Point;
begin
  k := pol[a[num][(st+fin) div 2]];
  i := st;
  j := fin;
  while i <= j do begin
    while (arctan2(pol[num].x-pol[a[num,i]].x,pol[num].y-pol[a[num,i]].y) -
    arctan2(pol[num].x-k.x,pol[num].y-k.y) < -eps) do inc(i);
    while arctan2(pol[num].x-pol[a[num,j]].x,pol[num].y-pol[a[num,j]].y) -
    arctan2(pol[num].x-k.x,pol[num].y-k.y) > eps do dec(j);
    if i <= j then begin
      buf := a[num,i];
      a[num,i] := a[num,j];
      a[num,j] := buf;
      inc(i); dec(j);
    end;
  end;
  if j > st then sort1(num,st,j);
  if i < fin then sort1(num,i,fin);
end;

procedure sort2(num,st,fin: Longint);
var i,j,k: Longint;
begin
  i := st;
  j := fin;
  k := b[(i+j) div 2];
  while i <= j do begin
    while vectorp(pol[num],pol[k],pol[b[i]]) > 0 do inc(i);
    while vectorp(pol[num],pol[k],pol[b[j]]) < 0 do dec(j);
    if i <= j then begin
      buf := b[i];
      b[i] := b[j];
      b[j] := buf;
      inc(i); dec(j);
    end;
  end;
  if j > st then sort2(num,st,j);
  if i < fin then sort2(num,i,fin);
end;

begin
  res := 3;
  assign(input,'polygon.in'); reset(input);
  assign(output,'polygon.out'); rewrite(output);
  read(n);
  for i := 1 to n do read(pol[i].x,pol[i].y);
  for i := 1 to n do begin
    sc := 0;
    for j := 1 to n do begin
      if i <> j then begin
        inc(sc);
        a[i,sc] := j;
      end;
    end;
  end;

  for i := 1 to n do begin
    sort1(i,1,n-1);
  end;

  for i := 1 to n do begin
    sc := 0;
    fillchar(vis,sizeof(vis),false);
    for j := 1 to n do begin
      if i = j then continue;
      if pol[i].x <= pol[j].x then begin
        inc(sc);
        b[sc] := j;
        vis[j] := true;
      end;
    end;
    if sc = 0 then continue;
    sort2(i,1,sc);
    fillchar(best,sizeof(best),0);
    for j := 2 to sc do begin
      best[b[1],b[j]] := 3;
    end;
    for j := 2 to sc do begin
      fl1 := false;
      rightg := n-1;
      leftg := 1;
      sc1 := 0;
      sc2 := 0;
      for k := 1 to n-1 do begin
        if not fl1 then begin
          if vectorp(pol[i],pol[b[j]],pol[a[b[j],k]]) < 0 then begin
            fl1 := true;
            leftg := k;
          end;
        end else begin
          if vectorp(pol[i],pol[b[j]],pol[a[b[j],k]]) > 0 then begin
            rightg := k-1;
            break;
          end;
        end;
      end;
      for k := leftg to rightg do begin
        if vis[a[b[j],k]] then begin
          inc(sc2);
          q2[sc2] := a[b[j],k];
        end;
      end;
      for k := rightg+1 to n-1 do begin
        if vis[a[b[j],k]] then begin
          inc(sc1);
          q1[sc1] := a[b[j],k];
        end;
      end;
      for k := 1 to leftg-1 do begin
        if vis[a[b[j],k]] then begin
          inc(sc1);
          q1[sc1] := a[b[j],k];
        end;
      end;

      pp := 1;

      cmax := 2;
      for k := 1 to sc2 do begin
        while true do begin
          if pp > sc1 then break;
          if vectorp(pol[b[j]],pol[q2[k]],pol[q1[pp]]) < 0 then begin
            if cmax < best[q1[pp],b[j]] then cmax := best[q1[pp],b[j]];
            inc(pp);
          end else break;
        end;
        if best[b[j],q2[k]] < cmax+1 then best[b[j],q2[k]] := cmax+1;
      end;

    end;

    for j := 1 to sc do begin
      for k := j+1 to sc do begin
        if res < best[b[j],b[k]] then res := best[b[j],b[k]];
      end;
    end;
  end;

  writeln(res);
  close(input);
  close(output);
end.