{
  ⭨ ᡮ  ଠ⨪ '2000
  :  ⠭
  襭: ᨬ  
}

{.$define DEBUG}
{$M 16384,0,0}

program Solution;

{$ifndef DEBUG}
{$A-,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V-,X+,Y+}
const
  inFile                        = 'game.in';
  {$ifndef BUILD_ANSWER}
  outFile                       = 'game.out';
  {$else}
  outFile                       = 'answer.txt';
  {$endif}
{$else}
{$A-,B-,D+,E-,F-,G+,I+,L+,N+,O-,P-,Q+,R+,S+,T-,V-,X+,Y+}
const
  inFile                        = 'input.txt';
  outFile                       = 'con';
  dbgFile                       = 'con';
var
  dbg                           : Text;
{$endif}

const
  maxN                          = 1001;
  msgYes                        = 'YES';
  msgNo                         = 'NO';

type
  TPerm                         = array[1..maxN] of integer;

  TCycle                        = record
    len                         : integer;
    x                           : array[0..maxN-1] of integer;
  end;

  TEntry                        = record
    start                       : integer;
    len                         : integer;
  end;

var
  n                             : integer;
  perm                          : TPerm;
  ansF                          : boolean;
  ansPerm                       : TPerm;
  f                             : array[1..maxN] of boolean;

  c                             : TCycle;
  c0,c1                         : TCycle;

  nCycles                       : integer;
  cycles                        : array[1..maxN] of TEntry;

procedure WriteData; forward;
procedure Finalize; forward;

procedure BuildCycle( i : integer; var c : TCycle );
var
  j                             : integer;

begin
  c.len := 0;
  j := i;
  repeat
    f[j] := true;
    c.x[c.len] := j;
    inc( c.len );
    j := perm[j];
  until f[j];
end;

procedure SortCycles;
var
  i,j                           : integer;
  c                             : TEntry;

begin
  for i := 1 to nCycles do
    for j := i + 1 to nCycles do
      if cycles[i].len > cycles[j].len then begin
        c := cycles[i];
        cycles[i] := cycles[j];
        cycles[j] := c;
      end;
end;

procedure Solve;
var
  i,j,k                         : integer;
  len                           : integer;

begin
  nCycles := 0;
  fillchar( f, sizeof(f), false );
  for i := 1 to n do
    if not f[i] then begin
      inc( nCycles );
      BuildCycle( i, c );
      cycles[nCycles].len := c.len;
      cycles[nCycles].start := i;
    end;

  SortCycles;

  cycles[nCycles+1].len := -1;

  i := 1;
  fillchar( f, sizeof(f), false );

  while i <= nCycles do
    if odd( cycles[i].len ) then begin
      BuildCycle( cycles[i].start, c );
      for j := 0 to c.len - 1 do
        ansPerm[c.x[j]] := c.x[(j + (c.len + 1) div 2) mod c.len];
      inc( i );
    end else begin
      for j := i to nCycles + 1 do
        if cycles[j].len <> cycles[i].len then break;
      dec( j );

      if not odd( j - i ) then begin
        ansF := false;
        exit;
      end;

      while i <= j do begin
        BuildCycle( cycles[i].start, c0 );
        BuildCycle( cycles[i+1].start, c1 );
        len := cycles[i].len;
        for k := 0 to len - 1 do begin
          ansPerm[c0.x[k]] := c1.x[k];
          ansPerm[c1.x[k]] := c0.x[(k + 1) mod len];
        end;
        inc( i, 2 );
      end;
    end;

  ansF := true;
end;

procedure ReadData;
var
  i                             : integer;

begin
  read( n );
  for i := 1 to n do read( perm[i] );
end;

procedure WriteData;
var
  i                             : integer;

begin
  if ansF then begin
    writeln( msgYes );
    {$ifndef BUILD_ANSWER}
    for i := 1 to n do write( ansPerm[i], ' ' );
    writeln;
    {$endif}
  end else
    writeln( msgNo );
end;

procedure Initialize;
begin

  assign( input, inFile );
  reset( input );

  assign( output, outFile );
  rewrite( output );

  {$ifdef DEBUG}
  assign( dbg, dbgFile );
  rewrite( dbg );
  writeln( '----Initialized----' );
  {$endif}

end;

procedure Finalize;
begin

  {$ifdef DEBUG}
  writeln( '----Finalized----' );
  close( dbg );
  {$endif}

  close( input );
  close( output );

  halt( 0 );

end;

begin
  Initialize;
  ReadData;
  Solve;
  WriteData;
  Finalize;
end.