{$Q-,R-,I-,S-,D-,L-}
Program ProblemA;
Type
  Int=Longint;
  Real=Extended;
  TEvent=Record
    l,r:Int;
    add:Boolean;
    pos:Int;
    delete:Boolean;
    End;
  PTree=^TTree;
  TTree=Record
    max,min,am:Int;
    l,r:PTree;
    End;
Const
  FileIn='kitten.in';
  FileOut='kitten.out';
  MaxN=300000;
  MaxCoord=2000000;
  Inf=1000000000;
Var
  Used:Array[-MaxCoord..MaxCoord] Of Boolean;
  N,AmAsks,AmDevil:Int;
  Asks:Array[0..MaxN] Of TEvent;
  Answers:Array[0..MaxN] Of Int;
  A:Array[0..MaxN] Of Int;
  Mdt:PTree;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Init;
  Var k:Int;
  Begin
    N:=0;AmAsks:=0;AmDevil:=0;
    While Not SeekEof Do
      Begin
        Inc(N);
        Read(k);
        If SeekEoln Then
          Begin
            Asks[N].add:=True;
            Asks[N].pos:=k;
            If Not Used[k] Then
              Begin
                Inc(AmDevil);
                A[AmDevil]:=k;
              End;
            If Used[k] Then Asks[N].delete:=False Else Asks[N].delete:=True;
            Used[k]:=True;
          End Else
          Begin
            Inc(AmAsks);
            Asks[N].add:=False;
            Asks[N].l:=k;Read(Asks[N].r);
          End;
      End;
  End;

Procedure Swap(Var x,y:Int);
  Var t:Int;
  Begin
    t:=x;x:=y;y:=t;
  End;

Procedure Randy;
  Var i,k,l:Int;
  Begin
    Randomize;
    For i:=1 To AmDevil Shl 1 Do
      Begin
        k:=Random(AmDevil)+1;l:=Random(AmDevil)+1;
        Swap(A[l],A[k]);
      End;
  End;

Procedure QSort(l,r:Int);
  Var i,j,t:Int;
  Begin
    i:=l;j:=r;t:=A[(l+r) Shr 1];
    Repeat
      While A[i]<t Do Inc(i);
      While A[j]>t Do Dec(j);
      If i<=j Then
        Begin
          Swap(A[i],A[j]);Inc(i);Dec(j);
        End;
      Until i>j;
    If i<r Then QSort(i,r);
    If l<j Then QSort(l,j);
  End;

Function Min(x,y:Int):Int;
  Begin
    If x<y Then Min:=x Else Min:=y;
  End;

Function Max(x,y:Int):Int;
  Begin
    If x>y Then Max:=x Else Max:=y;
  End;

Function Build(l,r:Int):PTree;
  Var p:PTree;
  Begin
    New(p);
    p^.am:=r-l+1;
    p^.min:=A[l];p^.max:=A[r];
    If l=r Then
      Begin
        p^.l:=Nil;p^.r:=Nil;
        Build:=p;
        Exit;
      End;
    p^.l:=Build(l,(l+r) Shr 1);
    p^.r:=Build((l+r) Shr 1+1,r);
    Build:=p;
  End;

Function Search(x:Int;p:PTree):Int;
  Begin
    If x>=p^.max Then Begin Search:=p^.am;Exit;End;
    If x<p^.min Then Begin Search:=0;Exit;End;
    If p^.l^.max>x Then Search:=Search(x,p^.l) Else
      Search:=p^.l^.am+Search(x,p^.r);
  End;

Procedure Delete(x:Int;Var p:PTree);
  Begin
    Dec(p^.am);
    If (x=p^.min)And(x=p^.max) Then
      Begin
        p^.min:=Inf;p^.max:=-Inf;Exit;
      End;
    If p^.l^.max>=x Then Delete(x,p^.l) Else Delete(x,p^.r);
    p^.max:=Max(p^.l^.max,p^.r^.max);
    p^.min:=Min(p^.l^.min,p^.r^.min);
  End;

Procedure Solve;
  Var i,cnt:Int;
  Begin
    If AmDevil=0 Then
      Begin
        For i:=1 To AmAsks Do Writeln(0);Exit;
      End;
    Randy;
    QSort(1,AmDevil);
    Mdt:=Build(1,AmDevil);
    cnt:=AmAsks;
    For i:=N Downto 1 Do
      Begin
        If Not Asks[i].add Then
          Begin
            If Asks[i].l>Asks[i].r Then Swap(Asks[i].l,Asks[i].r);
            Answers[cnt]:=Search(Asks[i].r,mdt)-Search(Asks[i].l-1,mdt);
            Dec(cnt);
          End Else
            If Asks[i].delete Then Delete(Asks[i].pos,Mdt);
      End;
    For i:=1 To AmAsks Do Writeln(Answers[i]);
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
