{$B-,Q-,R-,I-,S-,D-,L-,N+}
Program ProblemB;
Type
  Int=Longint;
  Real=Extended;
  PList=^TList;
  TList=Record
    x:Int;
    cost:Int;
    next:PList;
    End;
  TT=Record
    inf:Int64;
    pos_in_heap:Int;
    End;
  THeapNode=Record
    inf:Int64;
    x:Int;
    End;
  TArr=Array[0..3] Of Int64;
Const
  FileIn='customs.in';
  FileOut='customs.out';
  MaxN=20000;
Var
  N,M,HeapSize,Start,Fin:Int;
  Ans:Int64;
  Inf:Int64;
  G:Array[0..MaxN] Of PList;
  A:Array[0..MaxN] Of TT;
  B:Array[0..MaxN] Of TArr;
  Heap:Array[0..MaxN] Of THeapNode;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Init;
  Var l,k,t,i:Int;
      p:PList;
  Begin
    Read(N,M);
    For i:=1 To N DO G[i]:=Nil;
    For i:=1 To M Do
      Begin
        Read(l,k,t);
        New(p);
        p^.x:=k;p^.next:=G[l];p^.cost:=t;G[l]:=p;
        New(p);
        p^.x:=l;p^.next:=G[k];p^.cost:=t;G[k]:=p;
      End;
    Read(Start,Fin);
  End;

Procedure Swap(Var x,y:Int);
  Var t:Int;
  Begin
    t:=x;x:=y;y:=t;
  End;

Procedure Swap_THeapNode(Var x,y:THeapNode);
  Var t:THeapNode;
  Begin
    t:=x;x:=y;y:=t;
    Swap(A[x.x].pos_in_heap,A[y.x].pos_in_heap);
  End;

Procedure Heapify(x:Int);
  Var min:Int;
  Begin
    min:=x;
    If (x Shl 1<=HeapSize)And(Heap[x Shl 1].inf<Heap[min].inf) Then min:=x Shl 1;
    If (x Shl 1+1<=HeapSize)And(Heap[x Shl 1+1].inf<Heap[min].inf) Then min:=x Shl 1+1;
    If min<>x Then
      Begin
        Swap_THeapNode(Heap[min],Heap[x]);
        Heapify(min);
      End;
  End;

Procedure BuildHeap;
  Var i:Int;
  Begin
    For i:=HeapSize Shr 1 Downto 1 Do
      Heapify(i);
  End;

Procedure Decrease_Key(x:Int);
  Begin
    While (x>1)And(Heap[x].inf<Heap[x Shr 1].inf) Do
      Begin
        Swap_THeapNode(Heap[x],Heap[x Shr 1]);x:=x Shr 1;
      End;
  End;

Procedure Swap64(Var x,y:Int64);
  Var t:Int64;
  Begin
    t:=x;x:=y;y:=t;
  End;

Procedure Update(Const x:TArr;y:Int;Var rs:TArr);
  Begin
    rs:=x;
    If y<=x[1] Then Exit;
    rs[1]:=y;
    If rs[1]>rs[2] Then Swap64(rs[1],rs[2]);
    If rs[2]>rs[3] Then Swap64(rs[2],rs[3]);
    rs[0]:=rs[1]+rs[2]+rs[3];
  End;

Procedure Solve;
  Var i:Int;
      curx:Int;
      p:PList;
      nw:TArr;
  Begin
    Inf:=1;For i:=1 To 12 Do Inf:=Inf*10;
    HeapSize:=N;
    For i:=0 To N Do
      Begin
        A[i].inf:=Inf;A[i].pos_in_heap:=i;
      End;
    B[Start][1]:=0;B[Start][2]:=0;B[Start][3]:=0;B[Start][0]:=0;
    A[Start].inf:=0;
    For i:=1 To N Do
      Begin
        Heap[i].inf:=A[i].inf;Heap[i].x:=i;
      End;
    BuildHeap;
    While True Do
      Begin
        curx:=Heap[1].x;
        If curx=0 Then Break;
        Swap_THeapNode(Heap[1],Heap[HeapSize]);Dec(HeapSize);Heapify(1);
        p:=G[curx];
        While p<>Nil Do
          Begin
            Update(B[curx],p^.cost,nw);
            If nw[0]<A[p^.x].inf Then
              Begin
                A[p^.x].inf:=nw[0];
                B[p^.x]:=nw;
                Heap[A[p^.x].pos_in_heap].inf:=A[p^.x].inf;
                Decrease_Key(A[p^.x].pos_in_heap);
              End;
            p:=p^.Next;
          End;
      End;
    Ans:=A[Fin].inf;
    Writeln(Ans);
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
