{$Q-,R-,I-,S-,D-,L-,N+}
Program Quirks;
Type
  Int=Longint;
  Real=Extended;
  PList=^TList;
  TList=Record
    inf:Int;
    next:PList;
    End;
Const
  FileIn='quirks.in';
  FileOut='quirks.out';
  MaxN=60000;
Var
  N,M,Tests,StupidCnt,AmComps:Int;
  G,G1,G2:Array[0..MaxN] Of PList;
  Comp,Income:Array[0..MaxN] Of Int;
  Used:Array[0..MaxN] Of Boolean;
  Away:Array[0..MaxN] Of Int;
  Head:Int;
  Ans:Boolean;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Procedure Init;
  Var i,k,l:Int;
      p:PList;
  Begin
    Read(N,M);
    Fillchar(Income,Sizeof(Income),0);
    For i:=1 To N Do
      Begin
        G[i]:=Nil;
        G1[i]:=Nil;G2[i]:=Nil;
      End;
    For i:=1 To M Do
      Begin
        Read(k,l);
        New(p);p^.inf:=l;p^.next:=G[k];G[k]:=p;
        New(p);p^.inf:=k;p^.next:=G1[l];G1[l]:=p;
      End;
  End;

Procedure DFS(x:Int);
  Var p:PList;
  Begin
    p:=G[x];Used[x]:=True;
    While p<>Nil Do
      Begin
        If Not Used[p^.inf] Then DFS(p^.inf);
        p:=p^.next;
      End;
    Away[Head]:=x;Inc(Head);
  End;

Procedure DFS1(x:Int);
  Var p:PList;
  Begin
    Comp[x]:=AmComps;Used[x]:=True;
    p:=G1[x];
    While p<>Nil Do
      Begin
        If Not Used[p^.inf] Then DFS1(p^.inf);
        p:=p^.next;
      End;
  End;

Procedure DFS2(x:Int);  {Checking strongly connected}
  Var p,q:PList;        {components and building G2}
      am:Int;
  Begin
    Used[x]:=True;
    p:=G[x];am:=0;
    While p<>Nil Do
      Begin
        If Comp[p^.inf]<>Comp[x] Then
          Begin
            Inc(Income[Comp[p^.inf]]);
            New(q);
            q^.inf:=Comp[p^.inf];q^.next:=G2[Comp[x]];G2[Comp[x]]:=q;
            End Else Inc(Am);
        If Not Used[p^.inf] Then DFS2(p^.inf);
        p:=p^.next;
      End;
    If Am>1 Then Ans:=False;
  End;

Procedure DFS3(x:Int);  {Finally checking the acyclic graph}
  Var p:PList;
  Begin
    Used[x]:=True;
    p:=G2[x];
    While p<>Nil Do
      Begin
        If Used[p^.inf] Then Ans:=False Else DFS3(p^.inf);
        p:=p^.next;
      End;
  End;

Procedure Solve;
  Var i:Int;
  Begin
    Fillchar(Used,Sizeof(Used),False);
    Head:=1;
    For i:=1 To N Do
      If Not Used[i] Then DFS(i);
    AmComps:=0;
    Fillchar(Used,Sizeof(Used),False);
    For i:=N DownTo 1 Do
      If Not Used[Away[i]] Then
        Begin
          Inc(AmComps);
          DFS1(Away[i]);
        End;
    Fillchar(Used,Sizeof(Used),False);
    Ans:=True;
    For i:=1 To N Do
      If Not Used[i] Then
        DFS2(i);
    Fillchar(Used,Sizeof(Used),False);
    For i:=1 To AmComps Do
      If Income[i]=0 Then
        Begin
          DFS3(i);
          Break;
        End;
    For i:=1 To AmComps Do
      Ans:=Ans And Used[i];
    If Ans Then Writeln('YES') Else Writeln('NO');
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Begin
  OpenFiles;
  Read(Tests);
  For StupidCnt:=1 To Tests Do
    Begin
      Init;
      Solve;
    End;
  CloseFiles;
End.
