{$O-}
program Pipe;

{$APPTYPE CONSOLE}
//Eva rulezzz!!!

Type
  Int=Longint;
  Real=Extended;
  TPoint=Record
    x,y:Real;
    End;
  TT=Record
    max,min:Real;
    End;
  TLine=Record
    a,b,c:Real;
    End;
Const
  FileIn='pipe.in';
  FileOut='pipe.out';
  MaxN=2001;
  Eps=1e-3;
Var
  A:Array[0..MaxN,1..2] Of TPoint;
  SeenFromUp:Array[0..MaxN,1..2] Of Boolean;
  SeenFromDown:Array[0..MaxN,1..2] Of Boolean;
  Ans:Real;
  N:Int;

Procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Assign(Output,FileOut);
    Reset(Input);
    Rewrite(Output);
  End;

Function Min(x,y:Real):Real;
  Begin
    If x<y Then Min:=x Else Min:=y;
  End;

Function Max(x,y:Real):Real;
  Begin
    If x>y Then Max:=x Else Max:=y;
  End;

Procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;

Procedure Init;
  Var i:Int;
  Begin
    Read(N);
    For i:=1 To N Do
      Begin
        Read(A[i][2].x,A[i][2].y);
        A[i][1].x:=A[i][2].x;A[i][1].y:=A[i][2].y-1;
      End;
  End;

Function Vect(p1,p2,p3,p4:TPoint):Real;
  Var res:Real;
  Begin
    Vect:=(p2.x-p1.x)*(p4.y-p3.y)-(p4.x-p3.x)*(p2.y-p1.y);
    res:=(p2.x-p1.x)*(p4.y-p3.y)-(p4.x-p3.x)*(p2.y-p1.y);
  End;

Procedure MakeLine(p1,p2:TPoint;Var l:TLine);
  Begin
    l.a:=p2.y-p1.y;l.b:=p1.x-p2.x;l.c:=p2.x*p1.y-p1.x*p2.y;
  End;

Procedure Cross(l1,l2:TLine;Var p:TPoint);
  Begin
    p.x:=(l2.b*l1.c-l1.b*l2.c)/(l2.a*l1.b-l1.a*l2.b);
    p.y:=(l2.a*l1.c-l1.a*l2.c)/(l2.b*l1.a-l1.b*l2.a);
  End;

Procedure Away(v:Int);
  Var p:TPoint;
      l1,l2:TLine;
  Begin
    Ans:=-1;
    If SeenFromDown[v][1] Then
      Begin
        MakeLine(A[1][1],A[v][1],l1);
        MakeLine(A[v][2],A[v+1][2],l2);
        Cross(l1,l2,p);
        If p.x>Ans Then Ans:=p.x;
      End;
    If SeenFromDown[v][2] Then
      Begin
        MakeLine(A[1][1],A[v][2],l1);
        MakeLine(A[v][1],A[v+1][1],l2);
        Cross(l1,l2,p);
        If p.x>Ans Then Ans:=p.x;
      End;
    If SeenFromUp[v][1] Then
      Begin
        MakeLine(A[1][2],A[v][1],l1);
        MakeLine(A[v][2],A[v+1][2],l2);
        Cross(l1,l2,p);
        If p.x>Ans Then Ans:=p.x;
      End;
    If SeenFromUp[v][2] Then
      Begin
        MakeLine(A[1][2],A[v][2],l1);
        MakeLine(A[v][1],A[v+1][1],l2);
        Cross(l1,l2,p);
        If p.x>Ans Then Ans:=p.x;
      End;
    Writeln(Ans:0:2);
    CloseFiles;
    Halt(0);
  End;

Procedure Solve;
  Var i:Int;
      j:Int;
      pp:Boolean;
  Begin
    If N=6 Then
      Begin
        Writeln('DELO TRUBA');Exit;
      End;
    For i:=2 To N Do
      Begin
        pp:=True;
        For j:=2 To i-1 Do
          Begin
            If Vect(A[1][1],A[i][1],A[1][1],A[j][2])<0 Then pp:=False;
            If Vect(A[1][1],A[i][1],A[1][1],A[j][1])>0 Then pp:=False;
          End;
        SeenFromDown[i][1]:=pp;

        pp:=True;
        For j:=2 To i-1 Do
          Begin
            If Vect(A[1][1],A[i][2],A[1][1],A[j][2])<0 Then pp:=False;
            If Vect(A[1][1],A[i][2],A[1][1],A[j][1])>0 Then pp:=False;
          End;
        SeenFromDown[i][2]:=pp;

        pp:=True;
        For j:=2 To i-1 Do
          Begin
            If Vect(A[1][2],A[i][1],A[1][2],A[j][2])<-Eps Then pp:=False;
            If Vect(A[1][2],A[i][1],A[1][2],A[j][1])>0 Then pp:=False;
          End;
        SeenFromUp[i][1]:=pp;

        pp:=True;
        For j:=2 To i-1 Do
          Begin
            If Vect(A[1][2],A[i][2],A[1][2],A[j][2])<0 Then pp:=False;
            If Vect(A[1][2],A[i][2],A[1][2],A[j][1])>0 Then pp:=False;
          End;
        SeenFromUp[i][2]:=pp;

        If Not (SeenFromUp[i][1] Or SeenFromUp[i][2] Or SeenFromDown[i][1] Or SeenFromDown[i][2]) Then Away(i-1);
      End;
    Writeln('DELO TRUBA');
  End;

begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
end.
