//****//***** THE FIRST DEADLY SIN *****//****//

#include <fstream>
#include <cmath>

using namespace std;

int n;
int b[1000];

struct opt_razb{
	double value;
	int a_last;
};

typedef struct index{
	unsigned long n:16;
	unsigned long m:16;
};

const double MININF=-100000;

int Fc[101][101];

opt_razb F[101][101];

struct index stack[20000];
struct index *sp;

ifstream I("sin.in");
ofstream O("sin.out");

void in(){
	I>>n;
	for(int i=0;i<n;i++) I>>b[i];

	struct index query;
	query.n=n;
	sp=stack;
	for(query.m=2;query.m<=n;query.m++) *(sp++)=query;
	memset(Fc,0,sizeof(Fc));
}

void sol(){
	while(sp!=stack){
		struct index cur=sp[-1];
		if(cur.m>cur.n){
			F[cur.n][cur.m].value=MININF;
			Fc[cur.n][cur.m]=1;
			sp--;
		}
		else if(cur.m==1){
			F[cur.n][cur.m].value=0;
			F[cur.n][cur.m].a_last=cur.n;
			Fc[cur.n][cur.m]=1;
			sp--;
		}
		else if(Fc[cur.n][cur.m]) sp--;
		else{
			int ok=1;
			for(int i=1;i<=cur.n-1;i++)
				if(!Fc[cur.n-i][cur.m-1]){
					ok=0;
					sp->n=cur.n-i;
					sp->m=cur.m-1;
					sp++;
				}
			if(ok){
				double maxf=MININF;
				int maxi;
				for(int i=1;i<=cur.n-1;i++) if(F[cur.n-i][cur.m-1].value!=MININF){
					double newv=(F[cur.n-i][cur.m-1].value*(cur.m-1)+sin((double)cur.m*b[cur.m-2]*F[cur.n-i][cur.m-1].a_last*i))/cur.m;
					if(newv>=maxf){
						maxf=newv;
						maxi=i;
					}
				}
				Fc[cur.n][cur.m]=1;
				F[cur.n][cur.m].value=maxf;
				F[cur.n][cur.m].a_last=maxi;
				sp--;
			}
		}
	}
}

void out(){
	int i;
	O<<fixed;
	O.precision(7);
	double maxf=MININF;
	int maxi;
	for(i=2;i<=n;i++) if(F[n][i].value>maxf) maxf=F[n][i].value,maxi=i;
	O<<maxf<<endl;
	int history[1000];
	struct index his;
	his.n=n;
	his.m=maxi;
	for(i=0;i<maxi;i++){
		history[i]=F[his.n][his.m].a_last;
		his.n-=F[his.n][his.m].a_last;
		his.m--;
	}
	for(i=maxi-1;i>=0;i--) O<<history[i]<<" ";
}

int main(){
	in();
	sol();
	out();
	return 0;
}
