#include <stdio.h>
#include <string.h>
#include <stdlib.h>

struct Group{
	int root;
	int size;
	int value;
	unsigned short cells[100];
};
struct Tree{
	int root;
	int size;
	int value;
	unsigned short cells[32768];
};

FILE *I,*O;

short AX;
short M[32768+1];

unsigned short T[32768+1];//intree
unsigned short G[32768+1];//ingroup
int trees=0;
Group Gr[32768];
Tree Tr[400];

//unsigned short stack[32768+1];

#define NORMAL 0
#define DIVBYZERO 1
#define RTE 2

#define ERR 65535

void shutdown(int code){
	if(code==NORMAL) fprintf(O,"SUCCESSFUL TERMINATION\n");
	else if(code==DIVBYZERO) fprintf(O,"DIVISION BY ZERO\n");
	else if(code==RTE) fprintf(O,"RUN-TIME ERROR\n");
	fprintf(O,"%i\n",(int)AX);
	for(int i=1;i<=32768;i++)
		fprintf(O,"%i\n",(int)M[i]);
	exit(0);
}

//void BuildCache(int offset){
//	unsigned short *se=stack+1;
//	*stack=offset;
//	while(se!=stack){
//		offset=se[-1];
//		if(M[offset]>=0) C[offset]=M[offset],CV[offset]=1,se--;
//		else if(CV[-M[offset]]) C[offset]=C[-M[offset]],CV[offset]=1,se--;
//		else *(se++)=-M[offset];
//	}
//}

int main(){
	char line[128];
	int i;
	I=fopen("indirect.in","r");
	O=fopen("indirect.out","w");
	AX=0;
	memset(M,0,sizeof(M));
	memset(T,0,sizeof(T));
	memset(G,0,sizeof(G));
	for(i=0;i<32768;i++){
		Gr[i].size=1;
		Gr[i].value=0;
		Gr[i].root=Gr[i].cells[0]=i+1;
	}
	for(i=1;i<=32768;i++) G[i]=i-1,T[i]=ERR;
	while(fgets(line,128,I)){
		int oper=atoi(line+2);
		if(line[1]=='*'){
			//if(*line=='W'){
			//	M[oper]=AX,CV[oper]=0;
			//}
			//else{
			//	if(!CV[oper]) BuildCache(oper);
			//	oper=C[oper];
			//}
			if(*line=='W'){
				if((T[oper]!=ERR && Tr[T[oper]].value==ERR) || (T[oper]==ERR && Gr[G[oper]].value==ERR))
					shutdown(RTE);
				if(AX<0){
					AX=-AX;
					if(T[AX]!=ERR){
						if(T[AX]==T[oper]){
							Tr[T[AX]].value=ERR;
							M[Tr[T[oper]].root]=-AX;
						}
						else{
							unsigned short *victcells;
							int victsize;
							if(T[oper!=ERR]){
								//connect of 2 trees
								victcells=Tr[T[oper]].cells;
								victsize=Tr[T[oper]].size;
								M[Tr[T[oper]].root]=-AX;
							}
							else{
								//connect of tree and group
								victcells=Gr[G[oper]].cells;
								victsize=Gr[G[oper]].size;
								M[Gr[G[oper]].root]=-AX;
							}
							for(;victsize;victsize--,victcells++,Tr[T[AX]].size++)
								T[Tr[T[AX]].cells[Tr[T[AX]].size]=*victcells]=T[AX];
						}
					}
					else if(T[oper]!=ERR){
						//connect of tree and group
						Tr[T[oper]].value=Gr[G[AX]].value;
						unsigned short *victcells=Gr[G[AX]].cells;
						int victsize=Gr[G[AX]].size;
						M[Tr[T[oper]].root]=-AX;
						for(;victsize;victsize--,victcells++,Tr[T[oper]].size++)
							T[Tr[T[oper]].cells[Tr[T[oper]].size]=*victcells]=T[oper];
					}
					else{
						//connect of 2 groups
						if(G[AX]==G[oper]){
							Gr[G[AX]].value=Gr[G[oper]].value=ERR;
							M[Gr[G[oper]].root]=-AX;
						}
						else if(Gr[G[AX]].size+Gr[G[oper]].size<=100){
							//to 1 group
							unsigned short *victcells=Gr[G[oper]].cells;
							int victsize=Gr[G[oper]].size;
							M[Gr[G[oper]].root]=-AX;
							for(;victsize;victsize--,victcells++,Gr[G[AX]].size++)
								G[Gr[G[AX]].cells[Gr[G[AX]].size]=*victcells]=G[AX];
						}
						else{
							//to tree !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
							Tr[trees].value=Gr[G[AX]].value;
							Tr[trees].size=0;
							M[Gr[G[oper]].root]=-AX;
							unsigned short *victcells=Gr[G[oper]].cells;
							int victsize=Gr[G[oper]].size;
							for(;victsize;victsize--,victcells++,Tr[trees].size++)
								T[Tr[trees].cells[Tr[trees].size]=*victcells]=trees;
							victcells=Gr[G[AX]].cells;
							victsize=Gr[G[AX]].size;
							for(;victsize;victsize--,victcells++,Tr[trees].size++)
								T[Tr[trees].cells[Tr[trees].size]=*victcells]=trees;
						}
					}
					AX=-AX;
				}
				else if(T[oper]!=ERR) M[Tr[T[oper]].root]=Tr[T[oper]].value=AX;
				else M[Gr[G[oper]].root]=Gr[G[oper]].value=AX;
			}
			else{
				if(T[oper]!=ERR) oper=Tr[T[oper]].value;
				else oper=Gr[G[oper]].value;
				if(oper==ERR) shutdown(RTE);
			}
		}
		switch(*line){
		case 'A':
			AX+=oper;
			break;
		case 'S':
			AX-=oper;
			break;
		case 'M':
			AX*=oper;
			break;
		case 'D':
			if(!oper) shutdown(DIVBYZERO);
			AX/=oper;
			break;
		case 'O':
			if(!oper) shutdown(DIVBYZERO);
			AX%=oper;
			break;
		case 'R':
			AX=oper;
			break;
		}
	}
	shutdown(NORMAL);
	return 0;
}