#include <fstream>
#include <string>
#include <stdio.h>

using namespace std;

//*************************************************************

#define LOAD 0
#define STORE 1
#define ADD 2
#define SUB 3
#define MULT 4
#define DIV 5
#define READ 6
#define WRITE 7
#define JUMP 8
#define JGTZ 9
#define JZERO 10
#define HALT 11

//*************************************************************

ifstream I("ram.in");
FILE *O;

struct cmd{
	unsigned long f:4;
	unsigned long oper_type:2;
	unsigned long oper:16;
};

cmd prog[1000],*eip=prog;
short D[1000],*RD=D;
short R[1000];

int m,n;

void in(){
	string cmdname;
	char oper[16];
	int i;

	O=fopen("ram.out","w");
	I>>m>>n;
	for(i=0;i<m;i++){
		I>>cmdname;
		if(cmdname=="LOAD") prog[i].f=LOAD;
		else if(cmdname=="STORE") prog[i].f=STORE;
		else if(cmdname=="ADD") prog[i].f=ADD;
		else if(cmdname=="SUB") prog[i].f=SUB;
		else if(cmdname=="MULT") prog[i].f=MULT;
		else if(cmdname=="DIV") prog[i].f=DIV;
		else if(cmdname=="READ") prog[i].f=READ;
		else if(cmdname=="WRITE") prog[i].f=WRITE;
		else if(cmdname=="JUMP") prog[i].f=JUMP;
		else if(cmdname=="JGTZ") prog[i].f=JGTZ;
		else if(cmdname=="JZERO") prog[i].f=JZERO;
		else if(cmdname=="HALT") prog[i].f=HALT;
		if(prog[i].f!=HALT){
			I>>oper;
			char *opr=oper;
			if(*opr=='=')
				prog[i].oper_type=0,opr++;
			else if(*opr=='*')
				prog[i].oper_type=2,opr++;
			else prog[i].oper_type=1;
			prog[i].oper=atoi(opr);
		}
	}
	for(i=0;i<n;i++) I>>D[i];
}

void emul(){
	while(eip->f!=HALT){
		short *v1;
		short v2=eip->oper;
		if(eip->f<=7) for(int i=0;i<eip->oper_type;i++) v1=R+v2,v2=R[v2];
		switch(eip->f){
		case LOAD:
			*R=v2;
			break;
		case STORE:
			*v1=*R;
			break;
		case ADD:
			*R+=v2;
			break;
		case SUB:
			*R-=v2;
			break;
		case MULT:
			*R*=v2;
			break;
		case DIV:
			*R/=v2;
			break;
		case READ:
			*v1=*(RD++);
			break;
		case WRITE:
			fprintf(O,"%hi\n",v2);
			break;
		case JUMP:
			eip=prog+v2-1;
			break;
		case JGTZ:
			if(*R>0) eip=prog+eip->oper-1;
			break;
		case JZERO:
			if(*R==0) eip=prog+eip->oper-1;
			break;
		}
		eip++;
	}
}

int main(){
	in();
	emul();
	return 0;
}