#include <fstream>
#include <math.h>

using namespace std;

ifstream I("polygon.in");
ofstream O("polygon.out");

struct Vector{
	long x,y;
};

struct Line{
	int a,b;
};

int N;
Vector P[300];

//unsigned char X[300][300][300];

double vectpr(Vector a,Vector b){
	return a.x*b.y-b.x*a.y;
}
double scalpr(Vector a,Vector b){
	return a.x*b.x+a.y*b.y;
}

double angle[300][300];

void in(){
	int i;
	I>>N;
	double x,y;
	for(i=0;i<N;i++) I>>x>>y,P[i].x=long(x*1000),P[i].y=long(y*1000);
	for(i=0;i<N;i++)
		for(int j=0;j<N;j++){
			Vector line=P[j];
			line.x-=P[i].x;
			line.y-=P[i].y;
			Vector xxx;
			xxx.x=1;
			xxx.y=0;
			double sinan=vectpr(xxx,line);
			double cosan=scalpr(xxx,line);
			angle[i][j]=atan2(sinan,cosan);
			/*if(sinan>=0 && cosan>=0) angle[i][j]=fabs(angle[i][j]);
			else if(sinan>=0 && cosan<=0) angle[i][j]=fabs(angle[i][j]);
			else if(sinan<=0 && cosan>=0) angle[i][j]=-fabs(angle[i][j]);
			else if(sinan<=0 && cosan<=0) angle[i][j]=-fabs(angle[i][j]);*/
		}
}

int processed[300];//[300];
Line stack[300*300];
Line *sp;
int root;
int _glub=0;
int maxpol=3;
double curoutangle=0;

bool xpxp(double a){
	if(a<0) a+=3.1415926*2;
	if(a>=3.1415926*2) a-=3.1415926*2;
	return (a>=3.1415926);
}

bool connected(Line a,int i){
	if(a.a==a.b) return true;
	double ang=angle[a.b][i]-angle[a.a][a.b];
	return xpxp(ang);
}

double norman(double angle){
	while(angle<0) angle+=3.1415926;
	while(angle>3.1415926) angle-=3.1415926;
	return angle;
}

void glub(){
	if(connected(sp[-1],root) && maxpol<_glub+1){
		double fullangle=curoutangle+norman(angle[sp[-1].a][sp[-1].b]-angle[sp[-1].b][root]);
		fullangle+=norman(angle[sp[-1].b][root]-angle[root][stack[1].b]);
		if(fabs(fullangle-3.1415926*2)<0.0000001)
			maxpol=_glub+1;
	}
	for(int i=root+1;i<N;i++){
		if(!processed[i] && connected(sp[-1],i)){
			_glub++;
			processed[i]=1;
			if(_glub>1)
				curoutangle+=norman(angle[sp[-1].a][sp[-1].b]-angle[sp[-1].b][i]);
			sp->a=sp[-1].b;
			sp->b=i;
			sp++;
			glub();
			processed[i]=0;
			sp--;
			if(_glub>1)
				curoutangle-=norman(angle[sp[-1].a][sp[-1].b]-angle[sp[-1].b][i]);
			_glub--;
		}
	}
}

void sol(){
	Line rt;
	for(root=0;root<N;root++){
		memset(processed,0,sizeof(processed));
		rt.a=rt.b=root;
		*stack=rt;
		sp=stack+1;
		glub();
	}
}

void out(){
	O<<maxpol;
}

int main(){
	in();
	sol();
	out();
	return 0;
}