{$A+,B-,D+,E+,F-,G-,I+,L+,N-,O-,P-,Q-,R-,S-,T-,V+,X+}
Const InputFile='customs.in';
      OutputFile='customs.out';

Const MaxN=10100;
      MaxM=2*100100;
      INF=2000000000;

Type Real=Double;
     Int=int64;

var a:Array[1..MaxM,1..3] of int;
    b:Array[1..MaxN+1] of Longint;
    N,M:Longint;
    First,Last:Longint;
    i,j:Longint;

Procedure FRead;
var t:Longint;
begin
FillChar(a,SizeOf(a),0);
Assign(Input,InputFile);
Reset(Input);
Read(N,M);
for j:=1 to M do
for i:=1 to 3 do
begin
  Read(t);
  a[j,i]:=t;
end;
Read(First,Last);
Close(Input);
end;

Function CmpA(i,j:Longint):Shortint;
var k:Byte;
begin
CmpA:=0;
for k:=1 to 3 do
  if a[i,k]>a[j,k] then
  begin
    CmpA:=1;
    Break;
  end
  else if a[i,k]<a[j,k] then
  begin
    CmpA:=-1;
    Break;
  end;
end;

Procedure QSort(L,R:Longint);
var i,j:Longint;
begin
i:=L;
j:=R;
a[M+1]:=a[(i+j) div 2];
Repeat
  While CmpA(i,M+1)=-1 Do Inc(i);
  While CmpA(j,M+1)= 1 Do Dec(j);
  if i<=j then
  begin
    a[M+2]:=a[i];
    a[i]:=a[j];
    a[j]:=a[M+2];
    Inc(i);
    Dec(j);
  end;
Until i>j;
if i<R then QSort(i,R);
if L<j then QSort(L,j);
end;

Procedure PrepareGraph;
begin
for j:=1 to M do
begin
  a[M+j,1]:=a[j,2];
  a[M+j,2]:=a[j,1];
  a[M+j,3]:=a[j,3];
end;
M:=M*2;
QSort(1,M);
a[M+1,1]:=0;
b[1]:=1;
j:=1;
for i:=1 to N do
begin
  b[i+1]:=b[i];
  While a[j,1]=i Do
  begin
    Inc(j);
    Inc(b[i+1]);
  end;
end;
end;

var Size:Longint;
    d:Array[1..MaxN,0..3] of int;
    Max:Array[1..MaxN,0..3,1..3] of int;
    Nums,ANums:Array[1..MaxN] of Longint;
    k:Byte;

Procedure FWrite(Answer:int);
begin
Assign(Output,OutputFile);
Rewrite(Output);
Writeln(Answer);
Close(Output);
Halt;
end;


Procedure Swap(i,j:Longint);
var t:Longint;
begin
d[N+1]:=d[i]; d[i]:=d[j]; d[j]:=d[N+1];
t:=Nums[i]; Nums[i]:=Nums[j]; Nums[j]:=t;
ANums[Nums[i]]:=i; ANums[Nums[j]]:=j;
Max[N+1]:=Max[i]; Max[i]:=Max[j]; Max[j]:=Max[N+1];
end;

Procedure Heapify(i:Longint);
var L,R,m:Longint;
begin
L:=i shl 1;
R:=L+1;
m:=i;
if (L<=Size) AND (d[L,k]<d[m,k]) then m:=L;
if (R<=Size) AND (d[R,k]<d[m,k]) then m:=R;
if m<>i then
begin
  Swap(m,i);
  Heapify(m);
end;
end;

Procedure ExtractMin;
begin
Swap(1,Size);
Dec(Size);
Heapify(1);
end;

Procedure DecKey(i:Longint;v:int);
begin
d[i,k]:=v;
While (i>1) AND (d[i shr 1,k]>d[i,k]) Do
begin
  Swap(i,i shr 1);
  i:=i shr 1;
end;
end;

Procedure BuildHeap;
var i,g:Longint;
begin
Size:=N;
g:=Size div 2;
for i:=g downto 1 do
  Heapify(i);
end;

Procedure SetMax(i:Longint);
var j:Longint;
    t:int;
begin
if Max[i,k,1]>Max[i,k,2] then
begin
  t:=Max[i,k,1]; Max[i,k,1]:=Max[i,k,2]; Max[i,k,2]:=t;
end;
if Max[i,k,2]>Max[i,k,3] then
begin
  t:=Max[i,k,2]; Max[i,k,2]:=Max[i,k,3]; Max[i,k,3]:=t;
end;
if Max[i,k,1]>Max[i,k,2] then
begin
  t:=Max[i,k,1]; Max[i,k,1]:=Max[i,k,2]; Max[i,k,2]:=t;
end;

t:=0;
for j:=3 downto 4-k do
  t:=t+Max[i,k,j];
DecKey(i,t);
end;

Procedure Solve;
var g,h:Longint;
    u,v:Longint;
    t:int;
begin
PrepareGraph;
FillChar(Max,SizeOf(Max),0);
FillChar(d,SizeOf(d),125);
for i:=1 to N do
begin
  Nums[i]:=i;
  ANums[i]:=i;
end;
d[First,0]:=0;
for k:=1 to 3 do
begin
  d[ANums[First],k]:=0;
  BuildHeap;
  for i:=1 to N do
  begin
    ExtractMin;
    g:=Nums[Size+1];
    for j:=b[g] to b[g+1]-1 do
    begin
      u:=ANums[a[j,1]];
      v:=ANums[a[j,2]];
      if (d[v,k]>d[u,k]) AND (d[v,k]>d[u,k]-Max[u,k,1]+a[j,3]) then
      begin
        Max[v,k]:=Max[u,k];
        if Max[v,k,1]<a[j,3] then
          Max[v,k,1]:=a[j,3];
        SetMax(v);
      end;
      v:=ANums[a[j,2]];
      t:=0;
      for h:=3 downto 4-k do
        t:=t+Max[u,k-1,h];
      if (d[v,k]>d[u,k-1]+a[j,3]) AND (d[v,k]>t) then
      begin
        Max[v,k]:=Max[u,k-1];
        if Max[v,k,1]<a[j,3] then
          Max[v,k,1]:=a[j,3];
        SetMax(v);
      end;
    end;
  end;
end;

FWrite(d[ANums[Last],3]);
end;

begin
FRead;
Solve;
end.