{$A+,B-,D+,E+,F-,G-,I+,L+,N+,O-,P-,Q-,R-,S-,T-,V+,X+}
Const InputFile='best.in';
      OutputFile='best.out';

Const MaxN=100100;
      EPS=1E-9;

Type Real=Extended;
     Point=record
     x,y:Longint;
     end;

var p:Array[1..MaxN] of Point;
    A,B,C:Real;
    Ans:Real;
    Sx,Sy,S2x,S2y,Sxy:Real;
    N:Longint;

    i,j:Longint;

Procedure FRead;
begin
Assign(Input,InputFile);
Reset(Input);
Read(N);
for i:=1 to N do
  Read(p[i].x,p[i].y);
Close(Input);
end;

Procedure FWrite(Answer:Longint);
begin
Assign(Output,OutputFile);
Rewrite(Output);
Writeln(Ans:0:7);
Writeln(A:0:7,' ',B:0:7,' ',C:0:7);
Close(Output);
Halt;
end;

Function REqual(a,b:Real):Boolean;
begin
REqual:=Abs(a-b)<EPS;
end;

Function RMore(a,b:Real):Boolean;
begin
RMore:=(a-b)>EPS;
end;

Function RLess(a,b:Real):Boolean;
begin
RLess:=(a-b)<-EPS;
end;

Function Dist2(var p:Point):Real;
begin
Dist2:=Sqr(C-A*p.x-B*p.y)/(A*A+B*B);
end;

Function f(t:Real):Real;
begin
f:=2*(Sx*Cos(t)+Sy*Sin(t))*(Sx*Sin(t)-Sy*Cos(t))/N+(S2y-S2x)*Sin(2*t)+2*Sxy*Cos(2*t);
end;

var t1:Real;
Procedure Solve;
var g,h:Longint;
    L,R,Phi:Real;
    t2:Real;
begin
Sx:=0; Sy:=0; S2x:=0; S2y:=0; Sxy:=0;
for i:=1 to N do
begin
  Sx:=Sx+p[i].x;
  Sy:=Sy+p[i].y;
  S2x:=S2x+Sqr(p[i].x);
  S2y:=S2y+Sqr(p[i].y);
  Sxy:=Sxy+p[i].x*p[i].y;
end;

L:=0;
R:=Pi;
Repeat
  Phi:=(L+R)/2;
  t2:=f(Phi);
  if RMore(t2,0) then
    R:=Phi
  else if RLess(t2,0) then
    L:=Phi
  else
    Break;
Until (R-L)<1E-20;

A:=Cos(Phi);
B:=Sin(Phi);
C:=(Sx*A+Sy*B)/N;
if C<0 then
begin
  A:=-A;
  B:=-B;
  C:=-C;
end;
t1:=0;
for i:=1 to N do
  t1:=t1+Dist2(p[i]);
Ans:=t1;
FWrite(1543);
end;

begin
FRead;
Solve;
end.