{$A+,B-,D-,E+,F-,G-,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V-,X-}
Const InputFile='pipe.in';
      OutputFile='pipe.out';

Const MaxN=2100;
      EPS=1E-8;

Type Real=Extended;
     Point=record
     x,y:Real;
     end;

var p:Array[1..MaxN,1..2] of Point;

    N:Longint;

    i,j:Longint;

Procedure FRead;
begin
Assign(Input,InputFile);
Reset(Input);
Read(N);
for i:=1 to N do
begin
  Read(p[i,1].x,p[i,1].y);
  p[i,2].x:=p[i,1].x;
  p[i,2].y:=p[i,1].y-1;
end;

Close(Input);
end;

Procedure FWrite(Answer:Real);
begin
Assign(Output,OutputFile);
Rewrite(Output);
if Answer=p[N,1].x then
  Writeln('DELO TRUBA')
else
  Writeln(Answer:0:2);

Close(Output);
Halt;
end;

Function REqual(a,b:Real):Boolean;
begin
REqual:=Abs(a-b)<EPS;
end;

Function RMore(a,b:Real):Boolean;
begin
RMore:=(a-b)>EPS;
end;

Function RLess(a,b:Real):Boolean;
begin
RLess:=(a-b)<-EPS;
end;

Function Sgn(a:Real):Shortint;
begin
if a<-EPS then
  Sgn:=-1
else if a>EPS then
  Sgn:=1
else
  Sgn:=0;

end;


Procedure Solve;
var g,h,l:Longint;
    d1y,d2y:Byte;
    p1,p2:Point;
    Ans:Real;
    A1,B1,C1,A2,B2,C2:Real;
    t1,t2:Longint;
    d,x0,y0:Real;
begin
Ans:=0;
for i:=1 to N do
for j:=i+1 to N do
for d1y:=1 to 2 do
for d2y:=1 to 2 do
begin
  p1:=p[i,d1y];
  p2:=p[j,d2y];

  A1:=p1.y-p2.y;
  B1:=p2.x-p1.x;
  C1:=-A1*p1.x-B1*p1.y;
  if Sgn(A1*p[1,1].x+B1*p[1,1].y+C1)*Sgn(A1*p[1,2].x+B1*p[1,2].y+C1)<=0 then
  begin
    h:=1;
    for g:=1 to N-1 do
    begin
      for l:=1 to 2 do
      begin
        t1:=Sgn(A1*p[g,l].x+B1*p[g,l].y+C1);
        t2:=Sgn(A1*p[g+1,l].x+B1*p[g+1,l].y+C1);
        if t1*t2<0 then
        begin
          h:=0;
          A2:=p[g+1,l].y-p[g,l].y;
          B2:=p[g,l].x-p[g+1,l].x;
          C2:=-A2*p[g,l].x-B2*p[g,l].y;
          d:=A1*B2-B1*A2;
          d:=1/d;
          x0:=-(C1*B2-B1*C2)*d;
          y0:=-(A1*C2-C1*A2)*d;
          if x0>Ans then Ans:=x0;
          Break;
        end
        else if t1=0 then
        begin
          if t2*(3-2*l)<0 then
          begin
            h:=0;
            if p[g,1].x>Ans then Ans:=p[g,1].x;
          end;
        end;
      end;
      if h=0 then Break;
    end;
    if h=1 then
      FWrite(p[N,1].x);
  end;
end;

FWrite(Ans);
end;

begin
FRead;
Solve;
end.