{$define nDEBUG}

{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Kitten;
const MAXN = 2000001;
      DELTA = 1000001;
      infile = 'kitten.in';
      outfile = 'kitten.out';
var cat : array[1..MAXN] of boolean;
    rsq : array[1..MAXN] of longint;

procedure ReadData;
begin
  fillchar(cat, sizeof(cat), false);

  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
end;

function h(n : longint) : longint;
begin
  h:=(n xor (n-1) + 1) shr 1;
end;

procedure RSQInit;
begin
  fillchar(rsq, sizeof(rsq), 0);
end;

function RSQGet(i : longint) : longint;
var res : longint;
begin
  res:=0;
  while i>0 do begin
    inc(res, rsq[i]);
    dec(i, h(i));
  end;

  RSQGet:=res;
end;

procedure RSQUpdate(i, delta : longint);
begin
  while i<=MAXN do begin
    inc(rsq[i], delta);
    inc(i, h(i));
  end;
end;

function RSQQueue(a, b : longint) : longint;
begin
  if a>b then RSQQueue:=0 else RSQQueue:=RSQGet(b)-RSQGet(a-1);
end;

procedure Solve;
var a, b : longint;

begin
  RSQInit;

  while not seekeof(input) do begin
    read(a);

    if seekeoln(input) then begin
      if not cat[a+DELTA] then begin
        cat[a+DELTA]:=true;
        RSQUpdate(a+DELTA, 1);
      end;
    end else begin
      read(b);
      writeln(RSQQueue(a+DELTA, b+DELTA));
    end;

    readln;
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
