{$define DEBUG}

{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Customs;
const infile = 'customs.in';
      outfile = 'customs.out';
      MAXN = 10000;
      MAXM = 100000;
type
tEdge = record
  A, B : longint;
  Z : longword;
end;
var N, M, A, B : longint;
    GA : array[1..MAXN] of longint;
    GB : array[1..2*MAXM] of tEdge;
    dist : array[1..MAXN] of longword;
    max : array[1..MAXN, 1..3] of longword;
    ps : array[1..MAXN] of longint;
    heap : array[1..MAXN] of longint;
    min, inf : longword;

procedure ReadData;
var l : array[1..MAXN] of longint;
    cur, i, u, v, Z : longint;

procedure add(u, v, Z : longint);
begin
  inc(cur); GB[cur].A:=v; GB[cur].B:=0; GB[cur].Z:=Z;
  if l[u]=0 then GA[u]:=cur else GB[l[u]].B:=cur;
  l[u]:=cur;
end;

begin
  inf:=310000000; inf:=inf*10;
  fillchar(l, sizeof(l), 0);
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(N, M); cur:=0; min:=inf;

  for i:=1 to N do
    dist[i]:=inf;

  for i:=1 to M do begin
    read(u, v, Z);
    add(u, v, Z);
    add(v, u, Z);
  end;

  read(A, B);
end;

procedure Dijkstra;
var i, j, hs : longint;
    cur : longint;
    mxt : array[1..4] of longword;

procedure SortMax(cur : longint; e : longword);
var i, j : integer;
    t : longword;
begin
  mxt[1]:=max[cur, 1];
  mxt[2]:=max[cur, 2];
  mxt[3]:=max[cur, 3];
  mxt[4]:=e;

  for i:=1 to 4 do
    for j:=i to 4 do
      if mxt[i]<mxt[j] then begin t:=mxt[i]; mxt[i]:=mxt[j]; mxt[j]:=t; end;
end;

procedure swap(i, j : longint);
var t1, t2 : longint;
begin
  t2:=ps[heap[i]]; ps[heap[i]]:=ps[heap[j]]; ps[heap[j]]:=t2;
  t1:=heap[i]; heap[i]:=heap[j]; heap[j]:=t1;
end;

procedure Heapify(i : longint);
var l, r, largest : longint;
begin
  while true do begin
    l:=2*i; r:=2*i+1; largest:=i;
    if (l<=hs)and(dist[heap[l]]<dist[heap[largest]]) then largest:=l;
    if (r<=hs)and(dist[heap[r]]<dist[heap[largest]]) then largest:=r;

    if largest=i then break;
    swap(i, largest);
    i:=largest;
  end;
end;

function ExtractMin : longint;
begin
  ExtractMin:=heap[1];
  swap(1, hs);
  dec(hs);
  Heapify(1);
end;

procedure DecreaseKey(i : longint);
var j : longint;
begin
  j:=i div 2;
  while (j>0)and(dist[heap[j]]>dist[heap[i]]) do begin
    swap(i, j);
    i:=j;
    j:=j div 2;
  end;
end;

procedure BuildHeap;
var i : longint;
begin
  hs:=N;
  for i:=1 to N do begin
    heap[i]:=i;
    ps[i]:=i;
  end;

  for i:=(hs div 2) downto 1 do
    Heapify(i);
end;

begin
  fillchar(max, sizeof(max), 0);
  dist[A]:=0;
  BuildHeap;

  for i:=1 to N do begin
    cur:=ExtractMin;
    j:=GA[cur];

    while j<>0 do begin
      SortMax(cur, GB[j].Z);

      if (dist[GB[j].A]>mxt[1]+mxt[2]+mxt[3]) then begin
        dist[GB[j].A]:=mxt[1]+mxt[2]+mxt[3];
        max[GB[j].A, 1]:=mxt[1];
        max[GB[j].A, 2]:=mxt[2];
        max[GB[j].A, 3]:=mxt[3];

        DecreaseKey(ps[GB[j].A]);
      end;

      j:=GB[j].B;
    end;
  end;
end;

procedure Solve;
begin
  Dijkstra;
  if min>dist[B] then
    min:=dist[B];

  writeln(min);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
