{$define DEBUG}

{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Quirks;
const infile = 'quirks.in';
      outfile = 'quirks.out';
      MAXN = 50000;
      MAXM = 50000;
type tEdge = record
  A, B : longint;
end;
var N, M, cur : longint;
    order, GA, l, mark : array[1..MAXN] of longint;
    GB : array[1..MAXM] of tEdge;
    i, T : integer;
    f : boolean;

procedure add(u, v : longint);
begin
  inc(cur); GB[cur].A:=v; GB[cur].B:=0;
  if l[u]=0 then GA[u]:=cur else GB[l[u]].B:=cur;
  l[u]:=cur;
end;

procedure TopSort(u : longint);
var j : longint;
begin
  mark[u]:=1; j:=GA[u];

  while j<>0 do begin
    if mark[GB[j].A]=0 then TopSort(GB[j].A);

    j:=GB[j].B;
  end;

  mark[u]:=2; dec(cur); order[cur]:=u;
end;

procedure DFS(u : longint);
var j : longint;
begin
  mark[u]:=1; j:=GA[u];

  while j<>0 do begin
    if mark[GB[j].A]=0 then DFS(GB[j].A) else
    if mark[GB[j].A]=2 then f:=false;

    j:=GB[j].B;
  end;

  mark[u]:=2;
end;

procedure ReadData;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(T);
end;

procedure Solve;
var i, u, v : longint;
begin
  fillchar(l, sizeof(l), 0);
  fillchar(GA, sizeof(GA), 0);
  fillchar(GB, sizeof(GB), 0);
  fillchar(mark, sizeof(mark), 0);
  fillchar(order, sizeof(order), 0);
  read(N, M); cur:=0;
  for i:=1 to M do begin
    read(u, v);
    add(u, v);
  end;

  cur:=N+1;
  for i:=1 to N do
    if mark[i]=0 then TopSort(i);

  fillchar(mark, sizeof(mark), 0);

  f:=true;
  DFS(order[1]);
  if not f then begin writeln('NO'); exit; end;

  for i:=1 to N do
    if mark[i]=0 then begin writeln('NO'); exit; end;

  writeln('YES');
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  for i:=1 to T do Solve;
  WriteData;
end.
