{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Indirect;
const MAXN = 32768;
const infile = 'indirect.in';
      outfile = 'indirect.out';
var memory : array[1..MAXN] of integer;
    link : array[1..MAXN] of longint;
    acc : integer;

procedure WriteDump;
var i : longint;
begin
  writeln(acc);
  for i:=1 to MAXN do
    writeln(memory[i]);
end;

procedure ProduceRE;
begin
  writeln('RUN-TIME ERROR');
  WriteDump;
  close(input);
  close(output);
  halt(0);
end;

procedure ProduceDiv0;
begin
  writeln('DIVISION BY ZERO');
  WriteDump;
  close(input);
  close(output);
  halt(0);
end;

function GetAddress(i, h : longint) : longint;
var p : longint;
begin
  if h>MAXN then ProduceRE;
  p:=memory[i];
  if p>=0 then begin GetAddress:=i; exit; end;
  if link[i]=0 then link[i]:=-p;
  link[i]:=GetAddress(link[i], h+1);

  GetAddress:=link[i];
end;

procedure Solve;
var cmd : string[2];
    adr, adrn : longint;
begin
  cmd:='  ';
  while not eof(input) do begin
    read(cmd[1], cmd[2]);
    readln(adr);
    if cmd[2]='*' then adrn:=GetAddress(adr, 1);

    if cmd = 'A*' then acc:=acc+memory[adrn];
    if cmd = 'S*' then acc:=acc-memory[adrn];
    if cmd = 'M*' then acc:=acc*memory[adrn];
    if cmd = 'D*' then begin if memory[adrn]=0 then ProduceDiv0; acc:=acc div memory[adrn]; end;
    if cmd = 'O*' then begin if memory[adrn]=0 then ProduceDiv0; acc:=acc mod memory[adrn]; end;
    if cmd = 'R*' then acc:=memory[adrn];
    if cmd = 'W*' then memory[adrn]:=acc;

    if cmd = 'A=' then acc:=acc+adr;
    if cmd = 'S=' then acc:=acc-adr;
    if cmd = 'M=' then acc:=acc*adr;
    if cmd = 'D=' then begin if adr=0 then ProduceDiv0; acc:=acc div adr; end;
    if cmd = 'O=' then begin if adr=0 then ProduceDiv0; acc:=acc mod adr; end;
    if cmd = 'R=' then acc:=adr;
  end;
end;

procedure ReadData;
begin
  fillchar(link, sizeof(link), 0);
  fillchar(memory, sizeof(memory), 0);
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
end;

procedure WriteData;
begin
  writeln('SUCCESSFUL TERMINATION');
  WriteDump;
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
