{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Instr2;
const infile = '2instr.in';
      outfile = '2instr.out';
      inf = 1000000000;
type tWord = record
  hi, lo : byte;
end;
var memory : array[0..65536] of byte;
    heap : array[1..65536] of tWord;
    ps : array[0..255, 0..255] of longint;
    dist : array[0..255, 0..255] of longint;
    from : array[0..255, 0..255] of tWord;
    cmd : array[1..100000] of integer;
    st, en : tWord;
    NCmd : longint;

function DecodeByte(st : string[2]) : byte;
var n1, n2 : byte;
begin
  if (st[1]>='0')and(st[1]<='9') then n1:=ord(st[1])-ord('0') else n1:=ord(st[1])-ord('A')+10;
  if (st[2]>='0')and(st[2]<='9') then n2:=ord(st[2])-ord('0') else n2:=ord(st[2])-ord('A')+10;
  DecodeByte:=n1*16+n2;
end;

procedure ReadData;
var tmp : string[2];
    ch : char;
    cur : longint;
    i, j : integer;
begin
  for i:=0 to 255 do
    for j:=0 to 255 do
      dist[i, j]:=inf;

  fillchar(memory, sizeof(memory), 0);
  tmp:='  '; cur:=-1;
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);

  read(tmp[1], tmp[2]); st.hi:=DecodeByte(tmp);
  read(tmp[1], tmp[2]); st.lo:=DecodeByte(tmp);
  read(ch);
  read(tmp[1], tmp[2]); en.hi:=DecodeByte(tmp);
  read(tmp[1], tmp[2]); en.lo:=DecodeByte(tmp);
  readln;

  for i:=1 to 4096 do begin
    for j:=1 to 8 do begin
      inc(cur);
      read(tmp[1], tmp[2]); memory[cur]:=DecodeByte(tmp);
      read(ch);
    end;
    read(ch);
    for j:=1 to 8 do begin
      inc(cur);
      read(tmp[1], tmp[2]); memory[cur]:=DecodeByte(tmp);
      if j<8 then read(ch);
    end;
    readln;
  end;
  memory[65536]:=memory[0];
end;

procedure Solve;
var hs, adr, i : longint;
    cur, tmp : tWord;

procedure swap(i, j : longint);
var t1 : longint;
    t2 : tWord;
begin
  t1:=ps[heap[i].hi, heap[i].lo];
  ps[heap[i].hi, heap[i].lo]:=ps[heap[j].hi, heap[j].lo];
  ps[heap[j].hi, heap[j].lo]:=t1;

  t2:=heap[i]; heap[i]:=heap[j]; heap[j]:=t2;
end;

procedure Heapify(i : longint);
var l, r, largest : longint;
begin
  while true do begin
    l:=2*i; r:=2*i+1; largest:=i;
    if (l<=hs)and(dist[heap[l].hi, heap[l].lo]<dist[heap[largest].hi, heap[largest].lo]) then largest:=l;
    if (r<=hs)and(dist[heap[r].hi, heap[r].lo]<dist[heap[largest].hi, heap[largest].lo]) then largest:=r;

    if largest=i then break;
    swap(i, largest);
    i:=largest;
  end;
end;

function ExtractMin : tWord;
begin
  ExtractMin:=heap[1];
  swap(1, hs);
  dec(hs);
  Heapify(1);
end;

procedure DecreaseKey(i : longint);
var j : longint;
begin
  j:=i div 2;
  while (j>0)and(dist[heap[j].hi, heap[j].lo]>dist[heap[i].hi, heap[i].lo]) do begin
    swap(i, j);
    i:=j;
    j:=j div 2;
  end;
end;

procedure BuildHeap;
var i, j : byte;
    count : longint;
begin
  hs:=0;
  for i:=0 to 255 do
    for j:=0 to 255 do begin
      inc(hs);
      heap[hs].hi:=i;
      heap[hs].lo:=j;
      ps[i, j]:=hs;
    end;
  for count:=(hs div 2) downto 1 do
    Heapify(count);
end;

begin
  dist[st.hi, st.lo]:=0;
  BuildHeap;

  while true do begin
    cur:=ExtractMin; if dist[cur.hi, cur.lo]=inf then break;

    if dist[cur.lo, cur.hi] > dist[cur.hi, cur.lo]+2 then begin
      dist[cur.lo, cur.hi] := dist[cur.hi, cur.lo]+2;
      DecreaseKey(ps[cur.lo, cur.hi]);
      from[cur.lo, cur.hi]:=cur;
    end;

    adr:=longint(cur.hi)*256+cur.lo;
    tmp.lo:=memory[adr]; tmp.hi:=memory[adr+1];

    if dist[tmp.hi, tmp.lo] > dist[cur.hi, cur.lo]+1 then begin
      dist[tmp.hi, tmp.lo] := dist[cur.hi, cur.lo]+1;
      DecreaseKey(ps[tmp.hi, tmp.lo]);
      from[tmp.hi, tmp.lo]:=cur;
    end;
  end;

  if dist[en.hi, en.lo]=inf then begin writeln('IMPOSSIBLE'); exit; end;

  writeln(dist[en.hi, en.lo]);
  cur:=en; tmp:=from[cur.hi, cur.lo]; NCmd:=0;

  while (cur.hi<>st.hi)or(cur.lo<>st.lo) do begin
    inc(NCmd);
    cmd[NCmd]:=dist[cur.hi, cur.lo]-dist[tmp.hi, tmp.lo];
    cur:=tmp; tmp:=from[cur.hi, cur.lo];
  end;

  for i:=NCmd downto 1 do begin
    if cmd[i]=1 then write('5C ') else write('0F CC ');
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
