{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program RAM;
const infile = 'ram.in';
      outfile = 'ram.out';
type
tCommandList = (_Load, _Store, _Add, _Sub, _Mult, _Div, _Read, _Write, _Jump, _Jgtz, _Jzero, _Halt);
tCommand = record
  name : tCommandList;
  tp : char;
  nmb : integer;
end;
var m, n, cur, cmdn : integer;
    reg : array[0..999] of integer;
    cmd : array[0..999] of tCommand;
    vars : array[1..1000] of integer;

function Decode(temp : string) : tCommandList;
begin
  if temp='LOAD' then Decode:=_Load;
  if temp='STORE' then Decode:=_Store;
  if temp='ADD' then Decode:=_Add;
  if temp='SUB' then Decode:=_Sub;
  if temp='MULT' then Decode:=_Mult;
  if temp='DIV' then Decode:=_Div;
  if temp='READ' then Decode:=_Read;
  if temp='WRITE' then Decode:=_Write;
  if temp='JUMP' then Decode:=_Jump;
  if temp='JGTZ' then Decode:=_Jgtz;
  if temp='JZERO' then Decode:=_Jzero;
  if temp='HALT' then Decode:=_Halt;
end;

procedure ReadData;
var i, k : integer;
    temp : string;
    ch : char;
begin
  cur:=0;
  fillchar(reg, sizeof(reg), 0);
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  readln(m, n);

  for i:=0 to m-1 do begin
    temp:=''; read(ch);
    while (ch<>' ') do begin
      temp:=temp+ch;
      if eoln(input) then break;
      read(ch);
    end;
    cmd[i].name:=Decode(temp);
    if seekeoln(input) then begin readln; continue; end;
    readln(temp);
    if (temp[1] in ['=', '*']) then begin
      cmd[i].tp:=temp[1];
      delete(temp, 1, 1);
    end else cmd[i].tp:='!';
    val(temp, cmd[i].nmb, k);
  end;

  for i:=1 to n do
    read(vars[i]);
end;

procedure Solve;
var v : integer;
begin
  cmdn:=0;
  while true do begin
    if cmd[cmdn].name=_Halt then break;
    if cmd[cmdn].name=_Jump then begin cmdn:=cmd[cmdn].nmb; continue; end;
    if (cmd[cmdn].name=_Jgtz)and(reg[0]>0) then begin cmdn:=cmd[cmdn].nmb; continue; end;
    if (cmd[cmdn].name=_Jzero)and(reg[0]=0) then begin cmdn:=cmd[cmdn].nmb; continue; end;

    if (cmd[cmdn].name=_Store)and(cmd[cmdn].tp='!') then reg[cmd[cmdn].nmb]:=reg[0];
    if (cmd[cmdn].name=_Store)and(cmd[cmdn].tp='*') then reg[reg[cmd[cmdn].nmb]]:=reg[0];

    if (cmd[cmdn].name=_Read)and(cmd[cmdn].tp='!') then begin inc(cur); reg[cmd[cmdn].nmb]:=vars[cur]; end;
    if (cmd[cmdn].name=_Read)and(cmd[cmdn].tp='*') then begin inc(cur); reg[reg[cmd[cmdn].nmb]]:=vars[cur]; end;

    if (cmd[cmdn].name=_Read)or(cmd[cmdn].name=_Store)or(cmd[cmdn].name=_Jgtz)or(cmd[cmdn].name=_Jzero) then begin inc(cmdn); continue; end;

    if cmd[cmdn].tp='=' then v:=cmd[cmdn].nmb;
    if cmd[cmdn].tp='!' then v:=reg[cmd[cmdn].nmb];
    if cmd[cmdn].tp='*' then v:=reg[reg[cmd[cmdn].nmb]];

    if cmd[cmdn].name=_Load then reg[0]:=v;
    if cmd[cmdn].name=_Add then inc(reg[0], v);
    if cmd[cmdn].name=_Sub then dec(reg[0], v);
    if cmd[cmdn].name=_Mult then reg[0]:=reg[0]*v;
    if cmd[cmdn].name=_Div then reg[0]:=reg[0] div v;
    if cmd[cmdn].name=_Write then writeln(v);

    inc(cmdn);
  end;
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
