{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Best;
const infile = 'best.in';
      outfile = 'best.out';
      MAXN = 100000;
      inf = 1e10;
      EPS = 1e-6;
type real = extended;
var x, y : array[1..MAXN] of real;
    dist : array[1..MAXN] of real;
    alpha : array[1..MAXN] of real;
    x0, y0, sdist : real;
    n : longint;

procedure ReadData;
var i : longint;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(n);
  for i:=1 to n do
    read(x[i], y[i]);
end;

function PolarAngle(x, y : real) : real;
var p : real;
begin
  if abs(x)<=EPS then
    p:=pi/2+pi*ord(y<0)
  else begin
    p:=ArcTan(y/x)+pi;
    if x>0 then
      if y>=0 then p:=p-pi else p:=p+pi;
  end;
  PolarAngle:=p;
end;

procedure Init;
var i : longint;
begin
  x0:=0; y0:=0;
  for i:=1 to n do begin
    x0:=x0+x[i];
    y0:=y0+y[i];
  end;
  x0:=x0/n; y0:=y0/n;

  sdist:=0;
  for i:=1 to n do begin
    dist[i]:=sqr(x[i]-x0)+sqr(y[i]-y0);
    sdist:=sdist+dist[i];
  end;

  for i:=1 to n do
    alpha[i]:=PolarAngle(x[i]-x0, y[i]-y0);
end;

function Calc(a : real) : real;
var tmp : real;
    i : longint;
begin
  tmp:=0;
  for i:=1 to n do
    tmp:=tmp + dist[i]*sqr(cos(alpha[i]-a));
  Calc:=sdist-tmp;
end;

function Findmin1(al, ar : real) : real;
var m : real;
begin
  while (ar-al)>EPS do begin
    m:=(ar+al)/2;
    if Calc(al)>Calc(m) then al:=m else ar:=m;
  end;
  Findmin1:=(al+ar)/2;
end;

function Findmin2(al, ar : real) : real;
var m : real;
begin
  while (ar-al)>EPS do begin
    m:=(ar+al)/2;
    if Calc(ar)>Calc(m) then ar:=m else al:=m;
  end;
  Findmin2:=(al+ar)/2;
end;

procedure Solve;
var a, b, c : real;
    m1, m2, m3, m4, r1, r2, r3, r4, r, m : real;
begin
  Init;
  m1:=0; m2:=0; m3:=0; m4:=0; m1:=0; r1:=inf; r2:=inf; r3:=inf; r4:=inf;
  if n<=40000 then begin m1:=Findmin1(0, pi/2); m2:=Findmin1(pi/2, pi); end;
  m3:=Findmin2(0, pi/2); m4:=Findmin2(pi/2, pi);
  r1:=Calc(m1); r2:=calc(m2); r3:=Calc(m3); r4:=calc(m4);

  r:=r1; m:=m1;
  if r2<r then begin r:=r2; m:=m2; end;
  if r3<r then begin r:=r3; m:=m3; end;
  if r4<r then begin r:=r4; m:=m4; end;

  writeln(r:0:6);

  a:=sin(m); b:=-cos(m); c:=a*x0+b*y0;
  if c<0 then begin a:=-a; b:=-b; c:=-c; end;

  writeln(a:0:6, ' ', b:0:6, ' ', c:0:6);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
