{$define nDEBUG}

{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program RLECoding;
type
tRect = record
  i1, j1, i2, j2 : longint;
end;
tConn = record
  A, B : integer;
end;
const MAXRECTS = 50000;
      MAXRECTSCONN = 500000;
      infile = 'rle.in';
      outfile = 'rle.out';
var M, N, NRects, cure, ans : longint;
    B, k : integer;
    rects : array[1..MAXRECTS] of tRect;
    l, GA : array[1..MAXRECTS] of longint;
    GB : array[1..MAXRECTSCONN] of tConn;
    mark : array[1..MAXRECTS] of boolean;
    tab : array[0..1001, 0..1001] of byte;
    mark2 : array[1..1000, 1..1000] of boolean;

procedure AddRect(i1, j1, i2, j2 : longint);
begin
  inc(NRects);

  rects[NRects].i1:=i1;
  rects[NRects].j1:=j1;
  rects[NRects].i2:=i2;
  rects[NRects].j2:=j2;
end;

function CutCross(j1, j2, p1, p2 : longint) : boolean;
begin
  if (j2+1=p1) or (p2+1=j1) then begin CutCross:=true; exit; end;
  if (j2>=p1) and (j2<=p2) then begin CutCross:=true; exit; end;
  if (p2>=j1) and (p2<=j2) then begin CutCross:=true; exit; end;

  CutCross:=false;
end;

function Cross(r1, r2 : tRect) : boolean;
begin
  if (r1.i1<>r1.i2) and (r2.i1-1=r1.i2) then begin Cross:=true; exit; end;
  if (r1.i1<>r1.i2) and (r2.i2+1=r1.i1) then begin Cross:=true; exit; end;

  if (r2.i1<>r2.i2) and (r1.i1-1=r2.i2) then begin Cross:=true; exit; end;
  if (r2.i1<>r2.i2) and (r1.i2+1=r2.i1) then begin Cross:=true; exit; end;

  if (abs(r1.i1- r2.i1)=1) and CutCross(r1.j1, r1.j2, r2.j1, r2.j2) then begin Cross:=true; exit; end;

  Cross:=false;
end;

procedure AddEdge(u, v : integer);
begin
  inc(cure); GB[cure].A:=v; GB[cure].B:=0;
  if l[u]=0 then GA[u]:=cure else GB[l[u]].B:=cure;
  l[u]:=cure;
end;

procedure DFS(u : integer);
var j : longint;
begin
  mark[u]:=true;

  j:=GA[u];
  while j<>0 do begin
    if not mark[GB[j].A] then
      DFS(GB[j].A);

    j:=GB[j].B;
  end;
end;

procedure DFSMain;
var i : integer;
begin
  fillchar(mark, sizeof(mark), false);

  for i:=1 to NRects do
    if not mark[i] then begin
      inc(ans);
      DFS(i);
    end;
end;

procedure ReadData;
begin
  fillchar(l, sizeof(l), 0);

  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(M, N, B, k);
end;

procedure Solve;
var i, j : integer;
    curi, curj : longint;
    l, lt, l1, l2, l3 : longint;
begin
  curi:=1; curj:=1; NRects:=0; ans:=0; cure:=0;

  for i:=1 to k do begin
    read(l); lt:=l;

    if B=1 then begin
      if (curj+l-1<=M) then begin
        AddRect(curi, curj, curi, curj+l-1);

      end else begin
        l1:=M-curj+1; l:=l-l1;
        l2:=(l div M)*M;
        l3:=l-l2;

        if l1<>0 then AddRect(curi, curj, curi, M);
        if l2<>0 then AddRect(curi+1, 1, curi+(l2 div M), M);
        if l3<>0 then AddRect(curi+(l2 div M)+1, 1, curi+(l2 div M)+1, l3);

      end;

    end;

    curj:=curj+lt-1;
    curi:=curi+(curj div M);
    curj:=(curj mod M)+1;

    B:=1-B;
  end;

  for i:=1 to NRects do
    for j:=i+1 to NRects do
      if Cross(rects[i], rects[j]) then begin
        AddEdge(i, j);
        AddEdge(j, i);
      end;

  DFSMain;

  writeln(ans);
end;

procedure SolveH;
var i : integer;
    curi, curj : integer;
    j, l : longint;

procedure DFS2(i, j : integer);
begin
  mark2[i, j]:=true;

  if (tab[i-1, j]=1)and(not mark2[i-1, j]) then DFS2(i-1, j);
  if (tab[i+1, j]=1)and(not mark2[i+1, j]) then DFS2(i+1, j);
  if (tab[i, j+1]=1)and(not mark2[i, j+1]) then DFS2(i, j+1);
  if (tab[i, j-1]=1)and(not mark2[i, j-1]) then DFS2(i, j-1);
  if (tab[i-1, j-1]=1)and(not mark2[i-1, j-1]) then DFS2(i-1, j-1);
  if (tab[i-1, j+1]=1)and(not mark2[i-1, j+1]) then DFS2(i-1, j+1);
  if (tab[i+1, j-1]=1)and(not mark2[i+1, j-1]) then DFS2(i+1, j-1);
  if (tab[i+1, j+1]=1)and(not mark2[i+1, j+1]) then DFS2(i+1, j+1);
end;

begin
  fillchar(tab, sizeof(tab), 0);
  fillchar(mark2, sizeof(mark2), false);
  curi:=1; curj:=1; ans:=0;

  for i:=1 to k do begin
    read(l);
    for j:=1 to l do begin
      tab[curi, curj]:=B;

      inc(curj); if curj>M then begin inc(curi); curj:=1; end;
    end;

    B:=1-B;
  end;

  for i:=1 to N do
    for j:=1 to M do
      if (tab[i, j]=1)and(not mark2[i, j]) then begin
        inc(ans);
        DFS2(i, j);
      end;
  writeln(ans);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  if (M>1000)or(N>1000) then Solve else SolveH;
  WriteData;
end.
