{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Pipe;
const infile = 'pipe.in';
      outfile = 'pipe.out';
      MAXN = 2000;
      EPS = 1e-8;
      inf = 1e5;
type real = double;
var x, y : array[1..MAXN+1] of real;
    maxx : real;
    n : integer;

procedure ReadData;
var i : integer;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(n);
  for i:=1 to n do
    read(x[i], y[i]);
  x[n+1]:=x[n]+1;
  y[n+1]:=1e5;
end;

function CheckLine(x1, y1, x2, y2 : real; j : integer) : real;
var i2 : integer;
    dx, dy, t, a, b, c, xc, yc : real;
    bo : boolean;
begin
  bo:=false;
  a:=(y1-y2)/(x1-x2); b:=(x2*y1-x1*y2)/(x2-x1);
  for i2:=1 to j do begin
    t:=a*x[i2]+b;
    if (t>=(y[i2]+EPS))or(t<=(y[i2]-1-EPS)) then begin CheckLine:=-inf; exit; end;
  end;

  for i2:=j+1 to n do begin
    t:=a*x[i2]+b;
    if (t>=(y[i2]+EPS))or(t<=(y[i2]-1-EPS)) then begin bo:=true; break; end;
  end;
  if not bo then begin CheckLine:=inf; exit; end;
  dx:=x2-x1; dy:=y2-y1;

  t:=a*x[i2]+b;
  if (t>=(y[i2]+EPS)) then begin
    dec(i2);
    a:=y[i2+1]-y[i2]; b:=x[i2]-x[i2+1]; c:=-(a*x[i2]+b*y[i2]);
  end else begin
    dec(i2);
    a:=y[i2+1]-y[i2]; b:=x[i2]-x[i2+1]; c:=-(a*x[i2]+b*(y[i2]-1));
  end;

  t:=-(c+a*x1+b*y1)/(a*dx+b*dy);
  xc:=x1+dx*t; yc:=y1+dy*t;

  CheckLine:=xc;
end;

procedure Solve;
var i, j : integer;
    tmp : real;
begin
  maxx:=-inf;

  for i:=1 to n do
    for j:=i+1 to n do begin
      tmp:=CheckLine(x[i], y[i], x[j], y[j], j);
      if tmp>maxx then maxx:=tmp;

      tmp:=CheckLine(x[i], y[i], x[j], y[j]-1, j);
      if tmp>maxx then maxx:=tmp;

      tmp:=CheckLine(x[i], y[i]-1, x[j], y[j], j);
      if tmp>maxx then maxx:=tmp;

      tmp:=CheckLine(x[i], y[i], x[j], y[j]-1, j);
      if tmp>maxx then maxx:=tmp;
    end;

  if maxx>=x[n]-EPS then
    writeln('DELO TRUBA')
  else
    writeln(maxx:0:2);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
