{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Polygon;
uses SysUtils;
const infile = 'polygon.in';
      outfile = 'polygon.out';
      MAXN = 300;
type real = double;
var x, y : array[1..MAXN] of real;
    x2, y2 : array[1..MAXN] of real;
    res : array[1..MAXN, 1..MAXN] of integer;
    n, n2, max : integer;
    told : TDateTime;

procedure ReadData;
var i : integer;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(n);
  for i:=1 to n do
    read(x[i], y[i]);
end;

procedure swap(var a, b : real);
var t : real;
begin
  t:=a; a:=b; b:=t;
end;

procedure SortPoints;
var i, j : integer;
begin
  for i:=1 to n do
    for j:=i+1 to n do
      if y[i]>y[j] then begin
        swap(x[i], x[j]);
        swap(y[i], y[j]);
      end;
end;

procedure PreparePoints(lowest : integer);
var i, j : integer;
begin
  n2:=1; x2[1]:=x[lowest]; y2[1]:=y[lowest];
  for i:=1 to n do
    if (i<>lowest)and(y[i]>=y[lowest]) then begin
      inc(n2);
      x2[n2]:=x[i];
      y2[n2]:=y[i];
    end;
  for i:=1 to n2 do begin
    x2[i]:=x2[i]-x[lowest];
    y2[i]:=y2[i]-y[lowest];
  end;
  for i:=2 to n2 do
    for j:=i+1 to n2 do
      if (x2[i]*y2[j]-x2[j]*y2[i])<0 then begin
        swap(x2[i], x2[j]);
        swap(y2[i], y2[j]);
      end;

  fillchar(res, sizeof(res), 255);
  for i:=2 to n2 do
    res[1, i]:=2;
end;

function CanAttach(p1, p2, p3 : integer) : boolean;
begin
  if ((x2[p2]-x2[p1])*(y2[p3]-y2[p2])-(x2[p3]-x2[p2])*(y2[p2]-y2[p1]))<0 then begin
    CanAttach:=false; exit;
  end;
  if (x2[p2]*(y2[p3]-y2[p2])-y2[p2]*(x2[p3]-x2[p2]))<0 then begin
    CanAttach:=false; exit;
  end;

  CanAttach:=true;
end;

procedure Solve;
var lowest, p1, p2, p3 : integer;
begin
  SortPoints; max:=-1;
  for lowest:=1 to n do begin
    PreparePoints(lowest);

    for p1:=1 to n2-2 do
      for p2:=p1+1 to n2-1 do begin
        if res[p1, p2]=-1 then continue;

        for p3:=p2+1 to n2 do
          if (CanAttach(p1, p2, p3))and(res[p2, p3]<res[p1, p2]+1) then
            res[p2, p3]:=res[p1, p2]+1;
      end;

    for p1:=1 to n2-1 do
      for p2:=p1+1 to n2 do
        if res[p1, p2]>max then
          max:=res[p1, p2];

    if (now-told)*24*3600>=3.5 then break;
  end;

  writeln(max);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  told:=now;
  ReadData;
  Solve;
  WriteData;
end.
