{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Young;
const infile = 'young.in';
      outfile = 'young.out';
      MAXN = 50;
var d1, d2, d3 : array[0..MAXN] of integer;
    mt, b : array[0..MAXN, 0..MAXN] of integer;
    left : array[1..MAXN] of integer;
    nr1, nr2, nr3 : integer;
    res : longint;

function max(a, b : integer) : integer;
begin
  if a>b then max:=a else max:=b;
end;

procedure ReadData;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
end;

procedure WriteData;
begin
  close(input);
  close(output);
  halt(0);
end;

procedure Load;
var a : integer;
begin
  fillchar(d1, sizeof(d1), 0);
  fillchar(d2, sizeof(d2), 0);
  fillchar(d3, sizeof(d3), 0);
  fillchar(mt, sizeof(mt), 0);
  fillchar(b, sizeof(b), 0);
  nr1:=0; nr2:=0; nr3:=0;
  read(a); if a=-1 then WriteData;
  while a<>0 do begin
    inc(nr1); d1[nr1]:=a; read(a);
  end;
  while true do begin
    read(a); if a=0 then break;
    inc(nr2); d2[nr2]:=a;
  end;
  while true do begin
    read(a); if a=0 then break;
    inc(nr3); d3[nr3]:=a;
  end;
end;

procedure Rec(i, j : integer);
var it, jt, k, l : integer;
begin
  it:=i; jt:=d1[i]+j;
  while (it<=nr3)and(jt>d3[it]) do begin inc(it); jt:=d1[it]+1; end;
  if it>nr3 then begin inc(res); exit; end;

  for k:=max(mt[it, jt-1], mt[it-1, jt]+1) to nr2 do begin
    if left[k]=0 then continue;
    if (k>1)and(b[k, it]+1>b[k-1, it-1]) then continue;

    for l:=it to nr3 do inc(b[k, l]);
    dec(left[k]); mt[it, jt]:=k;

    Rec(it, jt-d1[it]+1);

    for l:=it to nr3 do dec(b[k, l]);
    inc(left[k]); mt[it, jt]:=0;
  end;
end;

procedure Solve;
var ds1, ds2, ds3, i : integer;
begin
{Checking}
  ds1:=0; ds2:=0; ds3:=0;
  for i:=1 to nr1 do ds1:=ds1+d1[i];
  for i:=1 to nr2 do ds2:=ds2+d2[i];
  for i:=1 to nr3 do ds3:=ds3+d3[i];
  if (ds3-ds1)<>ds2 then begin writeln(0); exit; end;
  if ds1>ds3 then begin writeln(0); exit; end;
  for i:=1 to nr3 do
    if d1[i]>d3[i] then begin writeln(0); exit; end;
  if (ds3-ds1=0)and(ds2=0) then begin writeln(1); exit; end;
{Backtracking}
  for i:=1 to nr2 do
    left[i]:=d2[i];
  res:=0;
  Rec(1, 1);
  writeln(res);
end;

begin
  ReadData;
  while true do begin
    Load;
    Solve;
  end;
end.
