{$define nDEBUG}

{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Elevator;
const infile = 'elevator.in';
      outfile = 'elevator.out';
      MAXN = 1000;
var N : integer;
    C, K, nlift, cur : longint;
    etmin, etmax : longint;
    et : array[1..MAXN] of longint;
    b : array[1..MAXN, 1..MAXN] of longint;
    lift : array[1..MAXN] of longint;
    res : longint;

function min(a, b : longint) : longint;
begin
  if a<b then min:=a else min:=b;
end;

procedure UpdateEtMax;
begin
  while (etmax>=1)and(et[etmax]=0) do
    dec(etmax);
end;

procedure UpdateEtMin;
begin
  while (etmin<=N)and(et[etmin]=0) do
    inc(etmin);
end;

procedure ReadData;
var i, u, v : longint;
begin
  fillchar(b, sizeof(b), 0);
  fillchar(nlift, sizeof(nlift), 0);
  fillchar(et, sizeof(et), 0);
  fillchar(lift, sizeof(lift), 0);

  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);

  read(N, C, K);
  for i:=1 to K do begin
    read(u, v);
    inc(b[u, v]);
    inc(et[u]);
  end;
end;

procedure LiftAll;
var i : integer;
    delta : longint;
begin
  for i:=cur+1 to etmax do begin
    if lift[cur]>0 then begin
      dec(K, lift[cur]);
      UpdateEtMin;
      UpdateEtMax;
      lift[cur]:=0;
    end;

    for i:=1 to N do begin
      inc(b[cur, i], lift[i]);
      inc(et[cur], lift[i]);
      lift[i]:=0;
    end;

    nlift:=0;

    for i:=N downto cur+1 do
      if (nlift<C)and(b[cur, i]>0) then begin
        delta:=min(C-nlift, b[cur, i]);
        inc(nlift, delta);
        inc(lift[i], delta);
        dec(b[cur, i], delta);
        dec(et[cur], delta);
      end;

    inc(cur); inc(res);
  end;
end;

procedure Solve;
var i, v1, v2, delta : longint;

begin
  for etmin:=1 to N do
    if et[etmin]>0 then break;
  for etmax:=N downto 1 do
    if et[etmax]>0 then break;

  res:=0; cur:=1;

  LiftAll;

  while K>0 do begin
    if lift[cur]>0 then begin
      dec(K, lift[cur]);
      UpdateEtMin;
      UpdateEtMax;
      lift[cur]:=0;
    end;

    for i:=1 to N do begin
      inc(b[cur, i], lift[i]);
      inc(et[cur], lift[i]);
      lift[i]:=0;
    end;

    v1:=0; v2:=0;
    if cur<N then begin
      for i:=N downto cur+1 do
        if (v1<C)and(b[cur, i]>0) then
          v1:=v1 + min(C-v1, b[cur, i]);

    end;

    if cur>1 then begin
      for i:=1 to cur-1 do
        if (v2<C)and(b[cur, i]>0) then
          v2:=v2 + min(C-v2, b[cur, i]);

    end;

    nlift:=0;

    if (v1=0)and(v2=0) then begin
      if K=0 then break;
      if (cur>etmax) then dec(cur) else
      if (cur<etmin) then inc(cur) else
        inc(cur);
    end else

    if v1>=v2 then begin
      for i:=N downto cur+1 do
        if (nlift<C)and(b[cur, i]>0) then begin
          delta:=min(C-nlift, b[cur, i]);
          inc(nlift, delta);
          inc(lift[i], delta);
          dec(b[cur, i], delta);
          dec(et[cur], delta);
        end;

      inc(cur);
    end else

    if v2>v1 then begin
      for i:=1 to cur-1 do
        if (nlift<C)and(b[cur, i]>0) then begin
          delta:=min(C-nlift, b[cur, i]);
          inc(nlift, delta);
          inc(lift[i], delta);
          dec(b[cur, i], delta);
          dec(et[cur], delta);
        end;

      dec(cur);
    end;

    inc(res);
  end;

  inc(res, cur-1);
  writeln(int64(res)*5);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
