{$define DEBUG}

{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Lcm;
const infile = 'lcm.in';
      outfile = 'lcm.out';
      MAXN = 2000;
      MAXP = 60000;
      MN = 200003;
      MNt = 200002;
      MAXL = 3000;
      OSN = 1000000000;
type tCell = record
  whatprime : longint;
  index : longint;
end;
tLong = record
  l : longint;
  v : array[0..MAXL] of longint;
end;
var numbers : array[1..MAXN] of longint;
    nprimes : array[1..MAXP] of longint;
    primes : array[1..MAXP] of longint;
    hash : array[0..MN] of tCell;
    ColRazlog : array[1..30] of integer;
    Razlog : array[1..30] of longint;
    allprimes : longint;
    N, NRazl : integer;
    ans : tLong;

procedure ReadData;
var i : integer;
begin
  fillchar(hash, sizeof(hash), 0);
  fillchar(nprimes, sizeof(nprimes), 0);
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(N); allprimes:=0;
  for i:=1 to N do
    read(numbers[i]);
end;

procedure PRazl(n : longint);
var i, r : longint;
    b : boolean;

begin
  fillchar(Razlog, sizeof(Razlog), 0);
  fillchar(ColRazlog, sizeof(ColRazlog), 0);
  NRazl:=0;
  while n<>1 do begin
    r:=trunc(sqrt(n));
    b:=false;

    for i:=2 to r do begin
      if n mod i=0 then begin
        inc(NRazl);
        Razlog[NRazl]:=i;
        while n mod i=0 do begin
          inc(ColRazlog[NRazl]);
          n:=n div i;
        end;
        b:=true;
      end;

      if b then break;
    end;
    if b then continue;
    inc(NRazl);
    Razlog[NRazl]:=n;
    inc(ColRazlog[NRazl]);
    n:=1;
  end;
end;

function h1(k : longint) : longint;
begin
  h1:=k mod MN;
end;

function h2(k : longint) : longint;
begin
  h2:=1+(k mod MNt);
end;

function h(k, i : longint) : longint;
begin
  h:=(h1(k) + int64(i)*h2(k)) mod MN;
end;

function HashInsert(k : longint) : longint;
var i, j : longint;
begin
  i:=0;
  repeat
    j:=h(k, i);
    if hash[j].whatprime=0 then begin
      hash[j].whatprime:=k;
      HashInsert:=j;
      exit;
    end;
    inc(i);
  until (i=MN);
end;

function HashSearch(k : longint) : longint;
var i, j : longint;
begin
  i:=0;
  repeat
    j:=h(k, i);
    if hash[j].whatprime=k then begin
      HashSearch:=j;
      exit;
    end;
    inc(i);
  until (hash[j].whatprime=0)or(i=MN);
  HashSearch:=-1;
end;

procedure WriteLong(A : tLong);
var i : longint;
    S : string[9];
begin
  write(A.v[A.l]);
  for i:=A.l-1 downto 1 do begin
    str(A.v[i], S);
    while length(s)<9 do S:='0'+S;
    write(S);
  end;
end;

procedure LongMulShort(A : tLong; var B : tLong; x : int64);
var i : longint;
    p, r : int64;
begin
  B.l:=A.l; p:=0;
  for i:=1 to A.l do begin
    r:=p+A.v[i]*x;
    p:=r div OSN; r:=r mod OSN;
    B.v[i]:=r;
  end;
  while p<>0 do begin
    inc(B.l);
    B.v[B.l]:=p mod OSN;
    p:=p div OSN;
  end;
end;

procedure Solve;
var i, j : integer;
    k : longint;
begin
  for i:=1 to N do begin
    if numbers[i]=1 then continue;
    PRazl(numbers[i]);

    for j:=1 to NRazl do begin
      k:=HashSearch(Razlog[j]);
      if k=-1 then begin
        k:=HashInsert(Razlog[j]);
        inc(allprimes);
        primes[allprimes]:=Razlog[j];
        hash[k].index:=allprimes;
        nprimes[allprimes]:=ColRazlog[j];
      end else begin
        k:=hash[k].index;
        if nprimes[k]<ColRazlog[j] then
          nprimes[k]:=ColRazlog[j];
      end;
    end;
  end;
  ans.l:=1; ans.v[1]:=1;

  for i:=1 to allprimes do
    for j:=1 to nprimes[i] do
      LongMulShort(ans, ans, primes[i]);

  WriteLong(ans);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
