{$define DEBUG}

{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Professor;
const infile = 'prof.in';
      outfile = 'prof.out';
      MAXL = 3000;
type
pList = ^tList;
pNode = ^tNode;
tList = record
  link : pNode;
  letter : char;
  next : pList;
end;
tNode = record
  nwords : integer;
  children : pList;
end;
var root : pNode;
    S : array[1..MAXL] of char;
    ln : integer;
    res : longint;

function CreateTrie : pNode;
var temp : pNode;
begin
  new(temp);
  temp^.children:=nil; temp^.nwords:=0; 
  CreateTrie:=temp;
end;

procedure DeleteList(var temp : pList);
begin
  if temp = nil then exit;
  DeleteList(temp^.next);

  dispose(temp);
  temp:=nil;
end;

procedure DeleteTrie(var temp : pNode);
var cur : pList;
begin
  if temp = nil then exit;
  cur:=temp^.children;

  while cur<>nil do begin
    DeleteTrie(cur^.link);
    cur:=cur^.next;
  end;

  DeleteList(temp^.children);

  dispose(temp);
  temp:=nil;
end;

procedure InsertTrie(var temp : pNode; ps : integer);
var cur : pList;
    tmp : pNode;
begin
  if temp<>root then inc(temp^.nwords);
  if ps>ln then exit;

  cur:=temp^.children;
  while cur<>nil do begin
    if cur^.letter = S[ps] then begin
      InsertTrie(cur^.link, ps+1);
      exit;
    end;

    cur:=cur^.next;
  end;

  tmp:=CreateTrie;
  new(cur);
  cur^.link:=tmp; cur^.letter:=S[ps]; cur^.next:=temp^.children;
  temp^.children:=cur;

  InsertTrie(tmp, ps+1);
end;

procedure WalkTrie(temp : pNode);
var cur : pList;
begin
  if temp = nil then exit;
  if temp^.nwords>1 then inc(res);
  cur:=temp^.children;

  while cur<>nil do begin
    WalkTrie(cur^.link);
    cur:=cur^.next;
  end;
end;

procedure ReadData;
begin
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  ln:=0; res:=0;
  while not eoln(input) do begin
    inc(ln);
    read(S[ln]);
  end;
end;

procedure Solve;
var i : integer;
begin
  root:=CreateTrie;

  for i:=1 to ln do
    InsertTrie(root, i);

  WalkTrie(root);
  DeleteTrie(root);
end;

procedure WriteData;
begin
  writeln(res);
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
