{$define DEBUG}

{$ifdef DEBUG}
  {$I+,Q+,R+,S-}
{$else}
  {$I-,Q-,R-,S-}
{$endif}

program Chrom;
const infile = 'chrom.in';
      outfile = 'chrom.out';
      MAXN = 12;
var n, m : integer;
    G : array[1..MAXN, 1..MAXN] of boolean;
    mark : array[1..MAXN] of boolean;
    numb : array[1..MAXN] of integer;
    poly, poly2 : array[0..MAXN] of longint;

procedure ReadData;
var i, u, v : integer;

begin
  fillchar(G, sizeof(G), 0);
  assign(input, infile); reset(input);
  assign(output, outfile); rewrite(output);
  read(n, m);
  for i:=1 to m do begin
    read(u, v);
    G[u, v]:=true;
    G[v, u]:=true;
  end;
end;

function SearchClique(u : integer) : integer;
var NN, v, i, j, size, p, temp : integer;
    incl, nei : array[1..MAXN] of integer;

function CheckClique : boolean;
var i, j : integer;
begin
  for i:=1 to NN do
    for j:=1 to NN do begin
      if i=j then continue;
      if (incl[i]=1)and(incl[j]=1)and(not G[nei[i], nei[j]]) then begin
        CheckClique:=false;
        exit;
      end;
    end;

  CheckClique:=true;
end;

begin
  size:=0; NN:=0;
  for v:=1 to N do
    if (G[u, v])and(mark[v]) then begin
      inc(NN); nei[NN]:=v;
    end;

  temp:=(1 shl NN)-1;
  for v:=0 to temp do begin
    i:=v; p:=0;
    for j:=NN downto 1 do begin
      incl[j]:=i mod 2;
      inc(p, incl[j]);
      i:=i shr 1;
    end;

    if p<=size then continue;
    if CheckClique then begin

      size:=p;
    end;
  end;

  SearchClique:=size;
end;

procedure DFS(u : integer);
var v : integer;
begin
  numb[u]:=SearchClique(u); mark[u]:=true;
  for v:=1 to N do
    if (G[u, v])and(not mark[v]) then
      DFS(v);
end;

procedure Solve;
var i, j : integer;
begin
  fillchar(numb, sizeof(numb), 0);
  fillchar(mark, sizeof(mark), false);
  fillchar(poly, sizeof(poly), 0);

  poly[0]:=1;
  for i:=1 to N do
    if not mark[i] then DFS(i);

  for i:=1 to N do begin
    fillchar(poly2, sizeof(poly2), 0);
    for j:=0 to i-1 do begin
      inc(poly2[j+1], poly[j]);
      dec(poly2[j], poly[j]*numb[i]);
    end;
    poly:=poly2;
  end;

  write(N);
  for i:=0 to N do
    write(' ', poly[i]);
end;

procedure WriteData;
begin
  close(input);
  close(output);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
