#include <stdio.h>
#include <math.h>

#define e 1e-8
#define m 2003
#define inf 1e9

typedef struct
{
  double x, y;
}
pnt;

pnt p[m], p2[m];
double best = -inf;
int n;

int inter( double a1, double b1, double c1, pnt p1, pnt p2, double *x )
{
  double a2 = p1.y - p2.y, b2 = p2.x - p1.x, c2, d;

  c2 = a2 * p1.x + b2 * p1.y;
  if (fabs(d = (a1 * b2 - a2 * b1)) < e)
    return 0;
  *x = (c1 * b2 - c2 * b1) / d;
  if ((*x <= (p1.x + e)) || (*x >= (p2.x - e)))
    return 0;
  return 1;
}

void check( pnt p1, pnt pp2 )
{
  int i;
  double a1 = p1.y - pp2.y, b1 = pp2.x - p1.x, c1,
         a2 = 1, b2 = 0, c2, d, x;
  pnt pp;

  c1 = p1.x * a1 + p1.y * b1;
  for (i = 1; i <= n; i++)
  {
    c2 = p[i].x;
    d = a1 * b2 - a2 * b1;
    pp.x = (c1 * b2 - c2 * b1) / d;
    pp.y = (a1 * c2 - a2 * c1) / d;
    if ((pp.y < p2[i].y - e) || (pp.y > p[i].y + e))
      break;
  }
  if (i > n)
  {
    best = inf;
    return;
  }
  if (i == 1)
    return;
  if (inter(a1, b1, c1, p[i - 1], p[i], &x))
  {
    if (best < x)
      best = x;
  }
  else if (inter(a1, b1, c1, p2[i - 1], p2[i], &x))
  {
    if (best < x)
      best = x;
  }
  if (best < p[i - 1].x)
    best = p[i - 1].x;
}

int main( void )
{
  int i, j;

  freopen("pipe.in", "r", stdin);
  freopen("pipe.out", "w", stdout);
  scanf("%d", &n);
  for (i = 1; i <= n; i++)
  {
    scanf("%lf%lf", &p[i].x, &p[i].y);
    p2[i] = p[i];
    p2[i].y--;
  }
  for (i = 2; i <= n; i++)
  {
    int b1 = 1, b2 = 1;

    for (j = 1; j < i; j++)
    {
      if ((p[b1].x - p[i].x) * (p[j].y - p[i].y)
           - (p[b1].y - p[i].y) * (p[j].x - p[i].x) > e)
        b1 = j;
    }
    for (j = 1; j < i; j++)
    {
      if ((p2[b2].x - p[i].x) * (p2[j].y - p[i].y)
           - (p2[b2].y - p[i].y) * (p2[j].x - p[i].x) < -e)
        b2 = j;
    }
    check(p[b1], p[i]);
    check(p2[b2], p[i]);
    b1 = b2 = 1;
    for (j = 1; j < i; j++)
    {
      if ((p[b1].x - p2[i].x) * (p[j].y - p2[i].y)
           - (p[b1].y - p2[i].y) * (p[j].x - p2[i].x) > e)
        b1 = j;
    }
    for (j = 1; j < i; j++)
    {
      if ((p2[b2].x - p2[i].x) * (p2[j].y - p2[i].y)
           - (p2[b2].y - p2[i].y) * (p2[j].x - p2[i].x) < -e)
        b2 = j;
    }
    check(p[b1], p2[i]);
    check(p2[b2], p2[i]);
  }
  if (fabs(best - inf) < e)
    printf("DELO TRUBA\n");
  else
    printf("%.2lf\n", best);
  return 0;
}
