#include <stdio.h>
#include <math.h>

#define m 303
#define e 1e-8
#define sq(x) ((x) * (x))

typedef struct
{
  double x, y;
  int n;
}
pnt;

pnt p[m], pp[m], s;
int c[m][m], bad[m];

void swp( int i, int j )
{
  pnt t = pp[i];

  pp[i] = pp[j];
  pp[j] = t;
}

int cmp( int i, int j )
{
  double ss;

  if (pp[i].n == s.n)
    return 0;
  if (pp[j].n == s.n)
    return 1;
  ss = (pp[i].x - s.x) * (pp[j].y - s.y)
          - (pp[i].y - s.y) * (pp[j].x - s.x);
  if (fabs(ss) < e)
    return ((sq(pp[i].x - s.x) + sq(pp[i].y - s.y)) <
           (sq(pp[j].x - s.x) + sq(pp[j].y - s.y)));
  return ss > e;
}

void down( int v, int s )
{
  while ((v * 2 <= s && cmp(v * 2, v))
         || ((v * 2 + 1 <= s && cmp(v * 2 + 1, v))))
    if (v * 2 + 1 <= s && cmp(v * 2 + 1, v * 2))
    {
      swp(v * 2 + 1, v);
      v = v * 2 + 1;
    }
    else
    {
      swp(v * 2, v);
      v *= 2;
    }
}

int main( void )
{
  int i, j, k, t, n, b = 3, ii;
  pnt p1, p2, p3;

  freopen("polygon.in", "r", stdin);
  freopen("polygon.out", "w", stdout);
  scanf("%d", &n);
  for (i = 1; i <= n; i++)
    scanf("%lf%lf", &p[i].x, &p[i].y);
  for (i = 1; i <= n; i++)
    for (j = i + 1; j <= n; j++)
      if (fabs(p[i].x - p[j].x) < e && fabs(p[i].y - p[j].y) < e)
        bad[j] = 1;
  for (k = 0, i = 1; i <= n; i++)
    if (!bad[i])
      pp[++k] = p[i];
  for (i = 1, n = k; i <= n; i++)
  {
    p[i] = pp[i];
    p[i].n = i;
  }
  for (i = 1; i <= n; i++)
    for (j = 1; j < n; j++)
      if (p[j].y > p[j + 1].y + e)
      {
        pnt t = p[j];

        p[j] = p[j + 1];
        p[j + 1] = t;
      }
  if (n == 3)
  {
    printf("3\n");
    return 0;
  }
  for (t = 1; t <= n; t++)
  {
    for (k = 0, i = 1; i <= n; i++)
      if ((p[i].y > p[t].y + e)
          || ((fabs(p[i].y - p[t].y) < e && p[i].x > p[t].x - e)))
        pp[++k] = p[i];
    if (k <= b)
      continue;
    s = p[t];
    for (i = k; i > 0; i--)
      down(i, k);
    for (i = k; i > 1; i--)
    {
      swp(1, i);
      down(1, i - 1);
    }
    for (i = 1; i <= k; i++)
      for (j = 1; j < i; j++)
      {
        p1 = pp[i], p2 = pp[j];
        c[i][j] = 1;
        for (ii = 1; ii < j; ii++)
        {
          p3 = pp[ii];
          if ((((p1.x - p2.x) * (p2.y - p3.y)
              - (p1.y - p2.y) * (p2.x - p3.x)) > e)
              && (c[i][j] < c[j][ii] + 1))
            c[i][j] = c[j][ii] + 1;
        }
        if (c[i][j] + 1 > b)
          b = c[i][j] + 1;
      }
  }
  printf("%d\n", b);
  return 0;
}
