{$q-,r-,n-}

const cinfile = 'indirect.in';
      coutfile = 'indirect.out';

const reg = 32767;
      inf = maxlongint shr 1;
      successful_termination = 'SUCCESSFUL TERMINATION';
      division_by_zero       = 'DIVISION BY ZERO';
      runtime_error          = 'RUN-TIME ERROR';

type int = smallint;

var r    : array[0..reg] of int;
    link : array[0..reg] of longint;
    use  : array[0..reg] of longint;
    a, v  : int;
    count : longint;
    o, s  : char;

procedure pre_init;
var i : int;
begin
   fillchar(use, sizeof(use), 0);
   fillchar(r, sizeof(r), 0);
   for i:=0 to reg do link[i]:=i;
   a:=0;
   count:=0;
end;

function init : boolean;
begin
   if eof then begin
      init:=false;
      exit;
   end;
   read(o, s);
   readln(v);
   init:=true;
end;

procedure out_regs(msg : string);
var i : int;
begin
   writeln(msg);
   writeln(a);
   for i:=0 to reg do writeln(r[i]);
   close(input); close(output);
   halt(0);
end;

function get_value(x : int) : int;
begin
   if use[x] = count then exit;
   if (r[x] < 0) and (link[x] = x) then link[x]:=-r[x]-1;
   use[x]:=count;
   if link[x] <> x then
      link[x]:=get_value(link[x]);
   if r[link[x]] < 0 then out_regs(runtime_error);
   get_value:=link[x];
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   pre_init;
   while init do begin
      inc(count);
      if s = '*' then begin
         dec(v);
         case o of
            'A' : begin
                     inc(a, r[get_value(v)]);
                  end;
            'S' : begin
                     dec(a, r[get_value(v)]);
                  end;
            'M' : begin
                     a:=a * r[get_value(v)];
                  end;
            'D' : begin
                     if r[get_value(v)] = 0 then out_regs(division_by_zero);
                     a:=a div r[get_value(v)];
                  end;
            'O' : begin
                     if r[get_value(v)] = 0 then out_regs(division_by_zero);
                     a:=a mod r[get_value(v)];
                  end;
            'R' : begin
                     a:=r[get_value(v)];
                  end;
            'W' : begin
                     v:=get_value(v);
                     r[v]:=a;
                  end;
         end;
      end else begin
         case o of
            'A' : begin
                     inc(a, v);
                  end;
            'S' : begin
                     dec(a, v);
                  end;
            'M' : begin
                     a:=a * v;
                  end;
            'D' : begin
                     if v = 0 then out_regs(division_by_zero);
                     a:=a div v;
                  end;
            'O' : begin
                     if v = 0 then out_regs(division_by_zero);
                     a:=a mod v;
                  end;
            'R' : begin
                     a:=v;
                  end;
         end;
      end;
   end;
   out_regs(successful_termination);
end.
