{$q+,r+,n-}

const cinfile = '2instr.in';
      coutfile = '2instr.out';

const n = 65535;
      inf = maxlongint shr 1;

type int = longint;

var r       : array[0..n] of int;
    a, p    : array[0..n] of int;
    q       : array[0..n+1] of int;
    use     : array[0..n] of byte;
    way     : array[0..n, 1..2] of int;
    s, f : int;

procedure init;
var i : int;
   procedure read_word(var x : int);
   var c    : char;
       j, v : int;
   begin
      repeat
         read(c);
      until c in ['0'..'9', 'A'..'F'];
      x:=0;
      for j:=1 to 4 do begin
         if c in ['0'..'9'] then v:=ord(c) - ord('0')
                            else v:=ord(c) - ord('A') + 10;
         x:=x shl 4 + v;
         read(c);
      end;
   end;
   procedure read_byte(var x : int);
   var c    : char;
       j, v : int;
   begin
      repeat
         read(c);
      until c in ['0'..'9', 'A'..'F'];
      x:=0;
      for j:=1 to 2 do begin
         if c in ['0'..'9'] then v:=ord(c) - ord('0')
                            else v:=ord(c) - ord('A') + 10;
         x:=x shl 4 + v;
         read(c);
      end;
   end;
begin
   fillchar(r, sizeof(r), 0);
   read_word(s);
   read_word(f);
   for i:=0 to n do read_byte(r[i]);
end;

procedure swap(x, y : int);
var t : int;
begin
   p[q[x]]:=y;
   p[q[y]]:=x;
   t:=q[x]; q[x]:=q[y]; q[y]:=t;
end;

procedure sift_up(x : int);
begin
   while x > 1 do begin
      if a[q[x]] >= a[q[x div 2]] then exit;
      swap(x, x div 2);
      x:=x div 2;
   end;
end;

procedure sift_down(x : int);
var l : int;
begin
   l:=x;
   while true do begin
      if 2*x <= q[0] then
         if a[q[l]] > a[q[2*x]] then l:=2*x;
      if 2*x < q[0] then
         if a[q[l]] > a[q[2*x+1]] then l:=2*x+1;
      if x = l then exit;
      swap(x, l);
      x:=l;
   end;
end;

procedure solve;
var i, j, v1, v2 : int;
   procedure relax(x, y : int);
   begin
      if a[x] <= y then exit;
      a[x]:=y;
      way[x, 1]:=i;
      way[x, 2]:=y - a[i];
      if p[x] = 0 then begin
         inc(q[0]);
         p[x]:=q[0];
         q[q[0]]:=x;
      end;
      sift_up(p[x]);
   end;
begin
   fillchar(way, sizeof(way), 0);
   fillchar(use, sizeof(use), 0);
   fillchar(p, sizeof(p), 0);
   for i:=0 to n do a[i]:=inf;
   a[s]:=0;
   q[0]:=1;
   q[1]:=s;
   p[s]:=1;

   while q[0] > 0 do begin
      i:=q[1];
      swap(1, q[0]);
      dec(q[0]);
      sift_down(1);
      use[i]:=1;
      if i = f then exit;

      v1:=r[i];
      v2:=r[(i+1) mod (n+1)];
      relax(v2 shl 8 + v1, a[i] + 1);
      relax(v1 shl 8 + v2, a[i] + 3);
   end;
end;

procedure writeanswer;
var c : int;
   procedure out(s : string);
   begin
      if c > 0 then begin
         if c mod 16 = 0 then writeln else
            if c mod 8 = 0 then write('  ') else write(' ');
      end;
      write(s);
      inc(c);
   end;
   procedure go(x : int);
   begin
      if x = s then exit;
      go(way[x, 1]);
      out('5C');
      if way[x, 2] = 3 then begin
         out('0F');
         out('CC');
      end;
   end;
begin
   if a[f] = inf then begin
      write('IMPOSSIBLE');
      exit;
   end;
   writeln(a[f]);
   c:=0;
   go(f);
//   if c = a[f] then writeln('ok') else writeln('wa');
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   solve;
   writeanswer;
   close(input); close(output);
end.