{$q+,r+,n-}

const cinfile = 'lcm.in';
      coutfile = 'lcm.out';

const base = 100000;

type int = longint;
     tlong = array[0..10000] of int64;

var p, add : array[0..10000] of int;
    a      : array[1..10000] of int;
    ans, b : tlong;
    d, i, j : int;

procedure fill(var x : tlong; y : int);
begin
   fillchar(x, sizeof(x), 0);
   while y > 0 do begin
      inc(x[0]);
      x[x[0]]:=y mod base;
      y:=y div base;
   end;
end;

procedure mul_int(var x : tlong; y : int64);
var i : int;
    t : int64;
begin
   t:=0;
   for i:=1 to x[0] do begin
      x[i]:=x[i]*y + t;
      t:=x[i] div base;
      dec(x[i], base*t);
   end;
   while t > 0 do begin
      inc(x[0]);
      x[x[0]]:=t mod base;
      t:=t div base;
   end;
end;

procedure writelong(var x : tlong);
var i, j : int;
begin
   write(x[x[0]]);
   for i:=x[0]-1 downto 1 do begin
      j:=base div 10;
      while x[i] < j do begin
         write('0');
         j:=j div 10;
      end;
      if x[i] > 0 then write(x[i]);
   end;
end;

procedure primes;
var d, j : int;
begin
   p[0]:=1;
   p[1]:=2;
   d:=3;
   while sqr(d) <= 1000000000 do begin
      j:=1;
      while (j <= p[0]) and (sqr(p[j]) <= d) do
         if d mod p[j] = 0 then break else inc(j);
      if (j > p[0]) or (sqr(p[j]) > d) then begin
         inc(p[0]);
         p[p[0]]:=d;
      end;
      inc(d, 2);
   end;
end;

procedure init;
var i, j, x, t : int;
begin
   fillchar(a, sizeof(a), 0);
   add[0]:=0;
   read(i);
   while i > 0 do begin
      read(x);
      for j:=1 to p[0] do begin
         t:=0;
         while x mod p[j] = 0 do begin
            x:=x div p[j];
            inc(t);
         end;
         if a[j] < t then a[j]:=t;
         if x = 1 then break;
      end;
      if x > 1 then begin
         inc(add[0]);
         add[add[0]]:=x;
      end;
      dec(i);
   end;
end;

procedure solve;
var i : int;
    t : int64;
   procedure swap(x, y : int);
   var t : int;
   begin
      t:=add[x]; add[x]:=add[y]; add[y]:=t;
   end;
   procedure heapify(x, len : int);
   var l : int;
   begin
      l:=x;
      while true do begin
         if 2*x <= len then
            if add[l] < add[2*x] then l:=2*x;
         if 2*x < len then
            if add[l] < add[2*x+1] then l:=2*x+1;
         if x = l then exit;
         swap(x, l);
         x:=l;
      end;
   end;
begin
   fill(ans, 1);
   t:=1;
   for i:=1 to p[0] do begin
      while a[i] > 0 do begin
         if t * p[i] > base then begin
            mul_int(ans, t);
            t:=p[i];
         end else t:=t * p[i];
         dec(a[i]);
      end;
   end;
   if t > 1 then mul_int(ans, t);

   if add[0] = 0 then exit;
   for i:=add[0] div 2 downto 1 do heapify(i, add[0]);
   for i:=add[0] downto 2 do begin
      swap(1, i);
      heapify(1, i-1);
   end;

   mul_int(ans, add[1]);
   for i:=2 to add[0] do
      if add[i] <> add[i-1] then mul_int(ans, add[i]);
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   primes;
   init;
   solve;
   writelong(ans);
   close(input); close(output);
end.