program Customs_with_heap;

{$D-,Q-,R-}

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'customs.in';
  OutFile = 'customs.out';
  MaxN = 10000;
  MaxM = 100000;

type
  Int = longint;
  Real = extended;
  PEdge = ^TEdge;
  TEdge = record
    link, cost : Int;
    next : PEdge;
  end;
  TMem = record
    max1, max2, max3, sum : Int;
  end;
  TPQVert = record
    p, num : Int;
  end;

var
  vert : array [1..MaxN] of PEdge;
  d : array [1..MaxN] of TMem;
  state : array [1..MaxN] of byte;
  a, b, n, m : Int;
  heap : array [1..MaxN * 2] of TPQVert;
  heapc : Int;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

{ PRIORITY QUEUE REALIZATION }

procedure PQInit;
begin
  heapc := 0;
end;

procedure PushUp( num : Int );
var
  i : Int;
  temp : TPQVert;
begin
  i := num;
  while ( i > 1 ) and ( heap[ i ].p < heap[ i div 2 ].p ) do begin
    temp := heap[ i ];
    heap[ i ] := heap[ i div 2 ];
    heap[ i div 2 ] := temp;
    i := i div 2;
  end;
end;

procedure PushDown( num : Int );
var
  i, j : Int;
  temp : TPQVert;
begin
  i := num;
  while ( i <= heapc div 2 ) do begin
    if heap[ 2 * i ].p < heap[ 2 * i + 1 ].p then
      j := 2 * i
    else
      j := 2 * i + 1;
    if heap[ i ].p > heap[ j ].p then begin
      temp := heap[ i ];
      heap[ i ] := heap[ j ];
      heap[ j ] := temp;
      i := j;
    end else
      exit;
  end;
end;

procedure PQInsert( v : Int );
var
  nv : TPQVert;
begin
  nv.num := v;
  nv.p := d[ v ].sum;
  inc( heapc );
  heap[ heapc ] := nv;
  PushUp( heapc );
end;

function PQGetMin : Int;
begin
  PQGetMin := heap[ 1 ].num;
  heap[ 1 ] := heap[ heapc ];
  dec( heapc );
  PushDown( 1 );
end;

procedure PQUpdate( num : Int );
var
  i : Int;
begin
  for i := 1 to heapc do
    if heap[ i ].num = num then begin
      heap[ i ].p := d[ num ].sum;
      PushUp( i );
      break;
    end;
end;

procedure AddEdge( v1, v2, cost : Int );
var
  pe : PEdge;
begin
  new( pe );
  pe^.link := v2;
  pe^.cost := cost;
  pe^.next := vert[ v1 ];
  vert[ v1 ] := pe;
end;

procedure InitData;
var
  i, x, y, z : Int;
begin
  fillchar( vert, sizeof( vert ), 0 );
  read( n, m );
  for i := 1 to m do begin
    read( x, y, z );
    AddEdge( x, y, z );
    AddEdge( y, x, z );
  end;
  read( a, b );
end;

procedure PushMax( old : TMem; pmax : Int; var res : TMem );
begin
  res := old;
  if pmax > res.max3 then begin
     res.max1 := res.max2;
     res.max2 := res.max3;
     res.max3 := pmax;
  end else if pmax > res.max2 then begin
     res.max1 := res.max2;
     res.max2 := pmax;
  end else if pmax > res.max1 then begin
     res.max1 := pmax;
  end;
  res.sum := res.max1 + res.max2 + res.max3;
end;

procedure dejkstra;
var
  i, mini : Int;
  changed : boolean;
  pe : PEdge;
  nm : TMem;
begin
  fillchar( state, sizeof( state ), 0 );
  fillchar( d, sizeof( d ), 0 );
  PQInit;
  state[ a ] := 1;
  changed := true;
  PQInsert( a );
  while ( changed ) do begin
    changed := false;
    mini := PQGetMin;
    state[ mini ] := 2;
    pe := vert[ mini ];
    { RELAX =) }
    while ( pe <> nil ) do begin
      if state[ pe^.link ] <> 2 then begin
        PushMax( d[ mini ], pe^.cost, nm );
        if ( state[ pe^.link ] = 0 ) then begin
          d[ pe^.link ] := nm;
          state[ pe^.link ] := 1;
          changed := true;
          PQInsert( pe^.link );
        end else if d[ pe^.link ].sum > nm.sum then begin
          d[ pe^.link ] := nm;
          changed := true;
          PQUpdate( pe^.link );
        end;
      end;
      pe := pe^.next;
    end;
  end;
end;

procedure Solve;
begin
  dejkstra;
  writeln( d[ b ].sum );
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
 