program InDirect;

{$D-}

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'indirect.in';
  OutFile = 'indirect.out';

  DIV_BY_ZERO = 'DIVISION BY ZERO';
  RUNTIME = 'RUN-TIME ERROR';
  SUCCESS = 'SUCCESSFUL TERMINATION';
  MemSize = 32768;

type
  Int = longint;
  Real = extended;
  TCell = record
    num : Int;
  end;

var
  Memory : array [1..MemSize] of TCell;
  been : array [1..MemSize] of boolean;
  accum, cc : Int;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure InitData;
begin
  FillChar( memory, sizeof( memory ), 0 );
  accum := 0;
  cc := 0;
end;

function StrToInt( s : string ) : Int;
var
  res, k : Integer;
begin
  val( s, res, k );
  StrToInt := res;
end;

procedure GenerateError( err : string );
var
  i : Int;
begin
  writeln( err );
  writeln( accum );
  for i := 1 to MemSize do
    writeln( memory[ i ].num );
  CloseFiles;
  Halt;
end;

function ReadFromMemory( mem : Int ) : Int;
begin
  been[ mem ] := true;
  if memory[ mem ].num >= 0 then
    ReadFromMemory := memory[ mem ].num
  else
    if been[ abs( memory[ mem ].num ) ] then
      GenerateError( RUNTIME )
    else
      ReadFromMemory := ReadFromMemory( abs( memory[ mem ].num ) );
end;

procedure WriteToMemory( mem : Int );
begin
  been[ mem ] := true;
  if memory[ mem ].num >= 0 then begin
    memory[ mem ].num := accum;
  end else
    if been[ abs( memory[ mem ].num ) ] then
      GenerateError( RUNTIME )
    else
      WriteToMemory( abs( memory[ mem ].num ) );
end;

procedure Solve;
var
  s : String;
  op : Int;
begin
  while not( eof ) do begin
    readln( s );
    case s[ 2 ] of
      '=' : begin
              op := StrToInt( copy( s, pos( '=', s ) + 1, length( s ) - pos( '=', s ) ) );
              case s[ 1 ] of
                'A' : accum := integer( accum + op );
                'S' : accum := integer( accum - op );
                'M' : accum := integer( accum * op );
                'D' : if ( op = 0 ) then
                        GenerateError( DIV_BY_ZERO )
                      else
                        accum := integer( accum div op );
                'O' : if ( op = 0 ) then
                        GenerateError( DIV_BY_ZERO )
                      else
                        accum := integer( accum mod op );
                'R' : accum := op;
              end;
            end;
      '*' : begin
              op := StrToInt( copy( s, pos( '*', s ) + 1, length( s ) - pos( '*', s ) ) );
              fillchar( been, sizeof( been ), false );
              case s[ 1 ] of
                'A' : accum := integer( accum + ReadFromMemory( op ) );
                'S' : accum := integer( accum - ReadFromMemory( op ) );
                'M' : accum := integer( accum * ReadFromMemory( op ) );
                'D' : if ReadFromMemory( op ) = 0 then
                        GenerateError( DIV_BY_ZERO )
                      else
                        accum := integer( accum div ReadFromMemory( op ) );
                'O' : if ReadFromMemory( op ) = 0 then
                        GenerateError( DIV_BY_ZERO )
                      else
                        accum := integer( accum mod ReadFromMemory( op ) );
                'R' : accum := ReadFromMemory( op );
                'W' : WriteToMemory( op );
              end;
            end;
    end;
  end;
  GenerateError( SUCCESS );
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
 