program Instr2;

{$D-}

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = '2instr.in';
  OutFile = '2instr.out';

type
  Int = longint;
  Real = extended;
  TVert = record
    state : Int;
    turn : char;
    prev : Int;
  end;
  TPQVert = record
    p, num : Int;
  end;

var
  memory : array [ 0..65535 + 3 ] of byte;
  vert : array [ word ] of TVert;
  d : array [ word ] of Int;
  sstart, send : Int;
  heap : array[ 1..65536 * 2 ] of TPQVert;
  heapc : Int;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

{ PRIORITY QUEUE REALIZATION }

procedure PQInit;
begin
  heapc := 0;
end;

procedure PushUp( num : Int );
var
  i : Int;
  temp : TPQVert;
begin
  i := num;
  while ( i > 1 ) and ( heap[ i ].p < heap[ i div 2 ].p ) do begin
    temp := heap[ i ];
    heap[ i ] := heap[ i div 2 ];
    heap[ i div 2 ] := temp;
    i := i div 2;
  end;
end;

procedure PushDown( num : Int );
var
  i, j : Int;
  temp : TPQVert;
begin
  i := num;
  while ( i <= heapc div 2 ) do begin
    if heap[ 2 * i ].p < heap[ 2 * i + 1 ].p then
      j := 2 * i
    else
      j := 2 * i + 1;
    if heap[ i ].p > heap[ j ].p then begin
      temp := heap[ i ];
      heap[ i ] := heap[ j ];
      heap[ j ] := temp;
      i := j;
    end else
      exit;
  end;
end;

procedure PQInsert( v : Int );
var
  nv : TPQVert;
begin
  nv.num := v;
  nv.p := d[ v ];
  inc( heapc );
  heap[ heapc ] := nv;
  PushUp( heapc );
end;

function PQGetMin : Int;
begin
  if heapc = 0 then begin
    PQGetMin := -1;
    exit;
  end;
  PQGetMin := heap[ 1 ].num;
  heap[ 1 ] := heap[ heapc ];
  dec( heapc );
  PushDown( 1 );
end;

procedure PQUpdate( num : Int );
var
  i : Int;
begin
  for i := 1 to heapc do
    if heap[ i ].num = num then begin
      heap[ i ].p := d[ num ];
      PushUp( i );
      break;
    end;
end;

function GetHexNum( c : char ) : Int;
begin
  if c in ['0'..'9'] then
    GetHexNum := ord( c ) - ord( '0' )
  else
    GetHexNum := ord( c ) - ord( 'A' ) + 10;
end;

function FromHex( const s : string ) : Int;
begin
  FromHex := GetHexNum( s[ 1 ] ) * 16 + GetHexNum( s[ 2 ] );
end;

procedure InitData;
var
  p1, p2 : string[ 3 ];
  c : char;
  i, j : Int;
begin
  read( c ); p1 := '' + c; read( c ); p1 := p1 + c;
  read( c ); p2 := '' + c; read( c ); p2 := p2 + c;
  sstart := 256 * FromHex( p1 ) + FromHex( p2 );
  read( c );
  read( c ); p1 := '' + c; read( c ); p1 := p1 + c;
  read( c ); p2 := '' + c; read( c ); p2 := p2 + c;
  send := 256 * FromHex( p1 ) + FromHex( p2 );

  readln;

  for i := 1 to 4096 do begin
    for j := 1 to 8 do begin
      read( c ); p1 := '' + c; read( c ); p1 := p1 + c;
      read( c );
      memory[ ( i - 1 ) * 16 + j - 1 ] := FromHex( p1 );
    end;
    read( c );
    for j := 1 to 8 do begin
      read( c ); p1 := '' + c; read( c ); p1 := p1 + c;
      read( c );
      memory[ ( i - 1 ) * 16 + j + 7 ] := FromHex( p1 );
    end;
    readln;
  end;
  memory[ 65536 ] := memory[ 0 ];
  memory[ 65537 ] := memory[ 1 ];
  memory[ 65538 ] := memory[ 2 ];
end;

function SwapBytes( num : Int ) : Int;
var
  n1, n2 : Int;
begin
  n1 := num div 256;
  n2 := num mod 256;
  SwapBytes := n2 * 256 + n1;
end;

function PopBytes( num : Int ) : Int;
begin
  PopBytes := memory[ num ] + memory[ num + 1 ] * 256;
end;

procedure Solve;
var
  found : boolean;
  i, j, imin, ns, p, src : Int;
  stack : array [ 1..2*65536] of string[ 3 ];
begin
  PQInit;
  fillchar( vert, sizeof( vert ), 0 );
  for i := 0 to 65535 do
    d[ i ] := MaxLongInt;

  vert[ sstart ].state := 1;
  vert[ sstart ].prev := -1;
  d[ sstart ] := 0;
  PQInsert( sstart );
  i := 0;
  found := false;
  imin := -1;
  while not( found ) and ( i <= 65535 ) do begin
    inc( i );
    imin := PQGetMin;
    if imin = -1 then
      break;
    vert[ imin ].state := 2;
    if imin = send then begin
      found := true;
      break;
    end;
    { SWAPPING BYTES }
    ns := SwapBytes( imin );
    if vert[ ns ].state = 0 then begin
      vert[ ns ].state := 1;
      vert[ ns ].turn := 's';
      vert[ ns ].prev := imin;
      d[ ns ] := d[ imin ] + 2;
      PQInsert( ns );
    end else
    if ( vert[ ns ].state = 1 ) and ( d[ ns ] > d[ imin ] + 2 ) then begin
      vert[ ns ].turn := 's';
      vert[ ns ].prev := imin;
      d[ ns ] := d[ imin ] + 2;
      PQUpdate( ns );
    end;
    { POPPING BYTES }
    ns := PopBytes( imin );
    if vert[ ns ].state = 0 then begin
      vert[ ns ].state := 1;
      vert[ ns ].turn := 'p';
      vert[ ns ].prev := imin;
      d[ ns ] := d[ imin ] + 1;
      PQInsert( ns );
    end else
    if ( vert[ ns ].state = 1 ) and ( d[ ns ] > d[ imin ] + 1 ) then begin
      vert[ ns ].turn := 'p';
      vert[ ns ].prev := imin;
      d[ ns ] := d[ imin ] + 1;
      PQUpdate( ns );
    end;
  end;
  if not( found ) then
    writeln( 'IMPOSSIBLE' )
  else begin
    p := imin;
    src := 0;
    while ( p <> -1 ) do begin
      inc( src );
      case vert[ p ].turn of
        'p' : stack[ src ] := '5C';
        's' : begin
                stack[ src ] := 'CC';
                inc( src );
                stack[ src ] := '0F';
              end;
      end;
      p := vert[ p ].prev;
    end;
    j := 1;
    writeln( src - 1 );
    for i := src - 1 downto 1 do begin
      if j = 17 then begin
        j := 1;
        writeln;
      end else
      if j = 9 then
        write( ' ' );
      write( stack[ i ] );
      if ( i <> 1 ) and ( j <> 16 ) then
        write( ' ' );
      inc( j );
    end;
    writeln;
  end;
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
 