program chrom;

{

  EVA RULEZZZ!!!!!!!

  Fight with the best? Die like the rest!

  Copyright by [ hr0nix@darkwired ]

}

const
  InFile = 'chrom.in';
  OutFile = 'chrom.out';
  MaxN = 12;

type
  Int = longint;
  Real = extended;

var
  g : array [1..MaxN,1..MaxN] of boolean;
  n, m, cc : Int;
  col : array [1..MaxN] of Int;
  color : array [1..MaxN] of Int;
  been : array [1..MaxN] of boolean;
  poly : array [0..MaxN] of Int;

procedure OpenFiles;
begin
  assign( input, InFile );
  reset( input );
  assign( output, OutFile );
  rewrite( output );
end;

procedure CloseFiles;
begin
  close( input );
  close( output );
end;

procedure InitData;
var
  i, v1, v2 : Int;
begin
  fillchar( g, sizeof( g ), false );
  read( n, m );
  for i := 1 to m do begin
    read( v1, v2 );
    g[ v1, v2 ] := true;
    g[ v2, v1 ] := true;
  end;
  fillchar( been, sizeof( been ), 0 );
  fillchar( color, sizeof( color ), false );
  fillchar( col, sizeof( col ), 0 );
end;

function power( x, degree : Int ) : Int;
var
  i, ans : Int;
begin
  ans := 1;
  for i := 1 to degree do
    ans := ans * x;
  power := ans;
end;

procedure dfs( v, maxc : Int );
var
  i, j : Int;
  found : boolean;
begin
  been[ v ] := true;
  for i := 1 to maxc do begin
    found := false;
    for j := 1 to n do
      if g[ v, j ] and been[ j ] and ( color[ j ] = i ) then begin
        found := true;
        break;
      end;
    if found then
      continue;
    inc( cc );
    if ( cc = n ) then
      inc( col[ maxc ] );
    color[ v ] := i;
    for j := 1 to n do
      if g[ v, j ] and not( been[ j ] ) then
        dfs( j, maxc );
    dec( cc );
  end;
  been[ v ] := false;
  color[ v ] := 0;
end;

function check( maxdegree : Int ) : boolean;
var
  i, j, ans : Int;
begin
  check := false;
  for i := 1 to MaxN do begin
    ans := 0;
    for j := 0 to MaxDegree do
      ans := ans + poly[ j ] * power( i, j );
    if ans <> col[ i ] then
      exit;
  end;
  check := true;
end;

procedure Build( num, limit : Int );
var
  i : Int;
begin
  if ( num = limit + 1 ) then begin
    if check( limit ) then begin
      write( limit, ' ' );
      for i := 0 to limit do
        write( poly[ i ], ' ' );
      writeln;
      CloseFiles;
      Halt;
    end;
    exit;
  end;
  for i := -MaxN to MaxN do begin
    if ( num = limit ) and ( i = 0 ) then continue;
    poly[ num ] := i;
    Build( num + 1, limit );
  end;
end;

procedure Solve;
var
  degree, i : Int;
begin
  for i := 1 to MaxN do
    dfs( 1, i );
  degree := 0;
  while true do begin
    Build( 0, degree );
    inc( degree );
  end;
end;

begin
  OpenFiles;
  InitData;
  Solve;
  CloseFiles;
end.
 