{$N+}
{$M 30000000,2097152}
var n,m:longint;
    edg1,edg2:array[1..51000,1..2]of longint;
    bedg1,bedg2:array[1..51000]of longint;

procedure QsortEdg1(be,en:longint);
var l,r,x,t:longint;
begin
    l:=be;
    r:=en;
    x:=edg1[l+random(r-l+1),1];
    while l<r do begin
        while x>edg1[l,1] do inc(l);
        while x<edg1[r,1] do dec(r);
        if l<=r then begin
            t:=edg1[l,1];
            edg1[l,1]:=edg1[r,1];
            edg1[r,1]:=t;
            t:=edg1[l,2];
            edg1[l,2]:=edg1[r,2];
            edg1[r,2]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then QsortEdg1(be,r);
    if l<en then QsortEdg1(l,en);
end;

procedure FillBedg1;
var i:longint;
begin
    bedg1[edg1[1,1]]:=1;
    for i:=2 to m do begin
        if edg1[i,1]<>edg1[i-1,1] then begin
            bedg1[edg1[i,1]]:=i;
        end;
    end;
    bedg1[n+1]:=m+1;
    for i:=n downto 1 do begin
        if bedg1[i]=0 then bedg1[i]:=bedg1[i+1];
    end;
end;

procedure QsortEdg2(be,en:longint);
var l,r,x,t:longint;
begin
    l:=be;
    r:=en;
    x:=edg2[l+random(r-l+1),1];
    while l<r do begin
        while x>edg2[l,1] do inc(l);
        while x<edg2[r,1] do dec(r);
        if l<=r then begin
            t:=edg2[l,1];
            edg2[l,1]:=edg2[r,1];
            edg2[r,1]:=t;
            t:=edg2[l,2];
            edg2[l,2]:=edg2[r,2];
            edg2[r,2]:=t;
            inc(l);
            dec(r);
        end;
    end;
    if be<r then QsortEdg2(be,r);
    if l<en then QsortEdg2(l,en);
end;

procedure FillBedg2;
var i:longint;
begin
    bedg2[edg2[1,1]]:=1;
    for i:=2 to m do begin
        if edg2[i,1]<>edg2[i-1,1] then begin
            bedg2[edg2[i,1]]:=i;
        end;
    end;
    bedg2[n+1]:=m+1;
    for i:=n downto 1 do begin
        if bedg2[i]=0 then bedg2[i]:=bedg2[i+1];
    end;
end;


procedure Load;
var i:longint;
begin
    fillchar(bedg1,sizeof(bedg1),0);
    fillchar(bedg2,sizeof(bedg2),0);
    randseed:=32113;
    readln(n,m);
    for i:=1 to m do begin
        readln(edg1[i,1],edg1[i,2]);
    end;
    QsortEdg1(1,m);
    FillBedg1;
end;

var top,was:array[1..51000]of longint;
    comp:array[1..51000]of longint;
    ctop,cc:longint;

procedure DfsTop(ver:longint);
var i:longint;
begin
    was[ver]:=1;
    for i:=bedg1[ver] to bedg1[ver+1]-1 do begin
        if was[edg1[i,2]]=0 then DfsTop(edg1[i,2]);
    end;
    inc(ctop);
    top[ctop]:=ver;
end;

procedure DfsComp(ver:longint);
var i:longint;
begin
    was[ver]:=1;
    for i:=bedg2[ver] to bedg2[ver+1]-1 do begin
        if was[edg2[i,2]]=0 then begin
            DfsComp(edg2[i,2]);
        end;
    end;
    comp[ver]:=cc;
end;

procedure DfsConn(ver:longint);
var i:longint;
begin
    was[ver]:=1;
    for i:=bedg1[ver] to bedg1[ver+1]-1 do begin
        if was[edg1[i,2]]=0 then DfsConn(edg1[i,2]);
    end;
    for i:=bedg2[ver] to bedg2[ver+1]-1 do begin
        if was[edg2[i,2]]=0 then DfsConn(edg2[i,2]);
    end;
end;

function DfsPath(ver:longint):boolean;
var i:longint;
    tr:boolean;
begin
    was[ver]:=1;
    for i:=bedg1[ver] to bedg1[ver+1]-1 do begin
        if was[edg1[i,2]]=0 then begin
            tr:=DfsPath(edg1[i,2]);
            if not tr then begin
                DfsPath:=false;
                exit;
            end;
        end
        else if was[edg1[i,2]]=2 then begin
            DfsPath:=false;
            exit;
        end;
    end;
    was[ver]:=2;
    DfsPath:=true;
end;

var rt:array[1..51000]of longint;
    cmedg1,cmedg2:longint;

procedure Solve;
var f2:boolean;
    root,i:longint;
begin
    f2:=true;
    {trying first condition}
    {topo-sort}
    fillchar(was,sizeof(was),0);
    ctop:=0;
    for i:=1 to n do begin
        if was[i]=0 then DfsTop(i);
    end;
    {retrain edges}
    for i:=1 to m do begin
        edg2[i,1]:=edg1[i,2];
        edg2[i,2]:=edg1[i,1];
    end;
    QsortEdg2(1,m);
    FillBedg2;
    {checking for a graph connectivity}
    fillchar(was,sizeof(was),0);
    DfsConn(1);
    for i:=1 to n do begin
        if was[i]=0 then begin
            write('NO');
            exit;
        end;
    end;
    {finding components}
    fillchar(was,sizeof(was),0);
    cc:=0;
    for i:=n downto 1 do begin
        if was[top[i]]=0 then begin
            inc(cc);
            DfsComp(top[i]);
        end;
    end;
    {build compo-graph and checking for a rootable tree}
    fillchar(rt,sizeof(rt),0);
    for i:=1 to m do begin
        if comp[edg1[i,1]]<>comp[edg1[i,2]] then begin
            cmedg1:=comp[edg1[i,1]];
            cmedg2:=comp[edg1[i,2]];
            if rt[cmedg2]=0 then begin
                rt[cmedg2]:=cmedg1;
            end
            else if rt[cmedg2]<>cmedg1 then begin
                write('NO');
                exit;
            end;
        end;
    end;
    {find root}
    root:=1;
    for i:=1 to cc do begin
        if rt[root]=0 then break;
        root:=rt[root];
    end;
    for i:=1 to n do begin
        if comp[i]=root then begin
            root:=i;
            break;
        end;
    end;
    {trying second condition}
    fillchar(was,sizeof(was),0);
    f2:=DfsPath(root);
    if not f2 then begin
        write('NO');
        exit;
    end;
    write('YES');
end;

var t,it:longint;

begin
    assign(input,'quirks.in');
    assign(output,'quirks.out');
    reset(input);
    rewrite(output);
    read(t);
    for it:=1 to t do begin
        Load;
        Solve;
        if it<t then writeln;
    end;
    close(input);
    close(output);
end.
