{$N+}
const eps=1e-9;
type point=record
    x,y:extended;
end;
var pnt1,pnt2:array[1..2100]of point;
    n:longint;
    notr:extended;
procedure Load;
var i:longint;
begin
    read(n);
    for i:=1 to n do begin
        read(pnt1[i].x,pnt1[i].y);
        pnt2[i]:=pnt1[i];
        pnt2[i].y:=pnt2[i].y-1;
    end;
end;

function Equal(a,b:point):boolean;
var f1,f2:boolean;
begin
    f1:=false;
    f2:=false;
    if abs(a.x-b.x)<eps then f1:=true;
    if abs(a.y-b.y)<eps then f2:=true;
    Equal:=f1 and f2;
end;

function Vector(p1,p2,p3,p4:point):extended;
var v1x,v1y,v2x,v2y:extended;
begin
    v1x:=p2.x-p1.x;
    v1y:=p2.y-p1.y;
    v2x:=p4.x-p3.x;
    v2y:=p4.y-p3.y;
    Vector:=v1x*v2y-v1y*v2x;
end;

function VectorSign(p1,p2,p3,p4:point):longint;
var s1:longint;
    v1:extended;
begin
    v1:=vector(p1,p2,p3,p4);
    if abs(v1)<eps then s1:=0
    else if v1>0 then s1:=1
    else s1:=-1;
    VectorSign:=s1;
end;

function GetLineIntPoint(p1,p2,p3,p4:point):point;
var a1,a2,b1,b2,c1,c2:extended;
    y,x:extended;
    p:point;
begin
    a1:=p2.y-p1.y;
    b1:=p1.x-p2.x;
    c1:=-(a1*p1.x+b1*p1.y);
    a2:=p4.y-p3.y;
    b2:=p3.x-p4.x;
    c2:=-(a2*p3.x+b2*p3.y);
    if (abs(b1*a2-a1*b2)<eps)or(abs(a1*b2-b1*a2)<eps) then begin
        y:=2000000000;
        x:=2000000000;
    end
    else begin
        y:=(c2*a1-c1*a2)/(b1*a2-a1*b2);
        x:=(c2*b1-c1*b2)/(a1*b2-b1*a2);
    end;
    p.x:=x;
    p.y:=y;
    GetLineIntPoint:=p;
end;

function GetIntPoint(p1,p2,p3,p4:point):point;
var s1,s2:longint;
    res:point;
begin
    res.x:=2000000000;
    res.y:=2000000000;
    s1:=VectorSign(p1,p2,p1,p3);
    s2:=VectorSign(p1,p2,p1,p4);
    if (s1=0)and(s2=0) then begin
        if p3.x<p4.x then GetIntPoint:=p3
        else GetIntPoint:=p4;
        exit;
    end
    else if s1*s2<=0 then begin
        res:=GetLineIntPoint(p1,p2,p3,p4);
    end;
    GetIntPoint:=res;
end;

function SmartCheck1(begp,ip,enp:point;j:longint):boolean;
var s1,s2,s3:longint;
    v1,v2:extended;
begin
    if Equal(ip,pnt1[j]) then begin
        s1:=VectorSign(begp,enp,begp,pnt1[j-1]);
        s2:=VectorSign(begp,enp,begp,pnt1[j+1]);
        s3:=VectorSign(begp,enp,pnt1[j],pnt1[j+1]);
        if (s1*s2>0)or(s3>=0) then begin
           SmartCheck1:=false;
           exit;
        end;
    end
    else if Equal(ip,pnt1[j+1]) then begin
        if j+1<>n then begin
            s1:=VectorSign(begp,enp,begp,pnt1[j]);
            s2:=VectorSign(begp,enp,begp,pnt1[j+2]);
            s3:=VectorSign(begp,enp,pnt1[j+1],pnt1[j+2]);
            if (s1*s2>0)or(s3>=0) then begin
                SmartCheck1:=false;
                exit;
            end;
        end;
    end;
    SmartCheck1:=true;
end;

function SmartCheck2(begp,ip,enp:point;j:longint):boolean;
var s1,s2,s3:longint;
    v1,v2:extended;
begin
    if Equal(ip,pnt2[j]) then begin
        s1:=VectorSign(begp,enp,begp,pnt2[j-1]);
        s2:=VectorSign(begp,enp,begp,pnt2[j+1]);
        s3:=VectorSign(begp,enp,pnt2[j],pnt2[j+1]);
        if (s1*s2>0)or(s3<=0) then begin
           SmartCheck2:=false;
           exit;
        end;
    end
    else if Equal(ip,pnt2[j+1]) then begin
        if j+1<>n then begin
            s1:=VectorSign(begp,enp,begp,pnt2[j]);
            s2:=VectorSign(begp,enp,begp,pnt2[j+2]);
            s3:=VectorSign(begp,enp,pnt2[j+1],pnt2[j+2]);
            if (s1*s2>0)or(s3<=0) then begin
                SmartCheck2:=false;
                exit;
            end;
        end;
    end;
    SmartCheck2:=true;
end;

function GetGoodCx(p1,p2:point):extended;
var cx:extended;
    np1,np2,ipnt:point;
    i:longint;
begin
    cx:=2000000000;
    for i:=2 to n-1 do begin
        {upper otr}
        ipnt:=GetIntPoint(p1,p2,pnt1[i],pnt1[i+1]);
        if SmartCheck1(p1,ipnt,p2,i) then if cx>ipnt.x then cx:=ipnt.x;
        {downer otr}
        ipnt:=GetIntPoint(p1,p2,pnt2[i],pnt2[i+1]);
        if SmartCheck2(p1,ipnt,p2,i) then if cx>ipnt.x then cx:=ipnt.x;
    end;
    if not Equal(p1,pnt2[1]) then begin
        ipnt:=GetIntPoint(p1,p2,pnt2[1],pnt2[2]);
        if SmartCheck2(p1,ipnt,p2,1) then if cx>ipnt.x then cx:=ipnt.x;
    end;
    if not Equal(p1,pnt1[1]) then begin
        ipnt:=GetIntPoint(p1,p2,pnt1[1],pnt1[2]);
        if SmartCheck2(p1,ipnt,p2,1) then if cx>ipnt.x then cx:=ipnt.x;
    end;
    GetGoodCx:=cx;
end;

procedure Solve;
var i,f1,f2:longint;
    mx,cx:extended;
    cp1:point;
begin
    mx:=-2000000000;
    cp1:=pnt1[1];
    notr:=1/(100000/(n*n));
    if(notr>1) then notr:=1;
    if notr<0.0005 then notr:=0.0005;
    while cp1.y>pnt2[1].y do begin
        for i:=2 to n do begin
            f1:=0;
            f2:=0;
            if Equal(cp1,pnt1[1]) then begin
                if VectorSign(cp1,pnt1[i],pnt1[1],pnt1[2])<0 then f1:=1;
                if VectorSign(cp1,pnt2[i],pnt1[1],pnt1[2])<0 then f2:=1;
            end;
            if Equal(cp1,pnt2[1]) then begin
                if VectorSign(cp1,pnt1[i],pnt2[1],pnt2[2])>0 then f1:=1;
                if VectorSign(cp1,pnt2[i],pnt2[1],pnt2[2])>0 then f2:=1;
            end;
            if f1=0 then begin
                cx:=GetGoodCx(cp1,pnt1[i]);
                if mx<cx then mx:=cx;
            end;
            if f2=0 then begin
                cx:=GetGoodCx(cp1,pnt2[i]);
                if mx<cx then mx:=cx;
            end;
        end;
        if abs(cp1.y-pnt2[1].y)<eps then break;
        cp1.y:=cp1.y-notr;
        if(cp1.y<pnt2[1].y)then begin
            cp1.y:=pnt2[1].y;
        end;
    end;
    if (abs(mx-2000000000)<eps)or(abs(mx-pnt1[n].x)<eps) then write('DELO TRUBA')
    else write(mx:0:2);
end;

begin
    assign(input,'pipe.in');
    assign(output,'pipe.out');
    reset(input);
    rewrite(output);
    Load;
    Solve;
    close(input);
    close(output);
end.







