{Thank Peter Mitrichev for the parts of code below!!!!}
const
     FileIn='kitten.in';
     FileOut='kitten.out';
type
    PTree=^TTree;
    TTree=record
                X, Y: LongInt;
                L, R: PTree;
          end;

procedure Split (T: PTree; X: LongInt; var L, R: PTree);
begin
     if not Assigned (T)
        then begin
             L:=nil;
             R:=nil;
             Exit;
        end
        else if X>T^.X
                then begin
                     Split (T^.R, X, T^.R, R);
                     L:=T;
                end
                else begin
                     Split (T^.L, X, L, T^.L);
                     R:=T;
                end;
end;

function Merge (L, R: PTree): PTree;
begin
     if not Assigned (L)
        then Merge:=R
        else if not Assigned (R)
                then Merge:=L
                else if L^.Y>R^.Y
                        then begin
                             L^.R:=Merge (L^.R, R);
                             Merge:=L;
                        end
                        else begin
                             R^.L:=Merge (L, R^.L);
                             Merge:=R;
                        end;
end;

procedure Insert (var T: PTree; X, Y: LongInt);
var
   T1: PTree;
begin
     if (not Assigned (T)) or (Y>T^.Y)
        then begin
             New (T1);
             Split (T, X, T1^.L, T1^.R);
             T1^.X:=X;
             T1^.Y:=Y;
             T:=T1;
        end
        else if X<T^.X
                then Insert (T^.L, X, Y)
                else if X>T^.X
                        then Insert (T^.R, X, Y); // There must be no duplicates!!!
end;

var
   Root: PTree;

function GetAnswer (Start, Finish: LongInt): LongInt;
var
   Answer: LongInt;

procedure Walk (aNode: PTree);
begin
     if Assigned (aNode)
        then if Finish<aNode^.X
                then Walk (aNode^.L)
                else if Start>aNode^.X
                        then Walk (aNode^.R)
                        else begin
                             if (Start<=aNode^.X) and (aNode^.X<=Finish)
                                then Inc (Answer);
                             Walk (aNode^.L);
                             Walk (aNode^.R);
                        end;
end;

begin
     Answer:=0;
     Walk (Root);
     GetAnswer:=Answer;
end;

procedure Solve;
var
   FIn, FOut: Text;
   X, Start, Finish: LongInt;
begin
     Assign (FIn, FileIn);
     Reset (FIn);
     Assign (FOut, FileOut);
     Rewrite (FOut);

     Root:=nil;

     RandSeed:=117;

     while not SeekEOF (FIn)
           do begin
              Read (FIn, X);
              if EOLn (FIn)
                 then Insert (Root, X, Random (MaxLongInt))
                 else begin
                      Start:=X;
                      Read (FIn, Finish);
                      Writeln (FOut, GetAnswer (Start, Finish));
                 end;
              Readln (FIn);
           end;

     Close (FIn);
     Close (FOut);
end;

begin
     Solve;
end.
