function Max (aA, aB: LongInt): LongInt;
begin
     if aA>aB
        then Max:=aA
        else Max:=aB;
end;

const
     Base=100000000;
     BaseLength=8;
     MaxIndexsCount=1007;
type
    TLong=record
                MaxIndex: LongInt;
                Digits: array [1..MaxIndexsCount] of LongInt;
          end;

procedure CreateLong (var aLong: TLong; aValue: LongInt);
begin
     with aLong
          do begin
             MaxIndex:=0;
             while aValue>0
                   do begin
                      Inc (MaxIndex);
                      Digits [MaxIndex]:=aValue mod Base;
                      aValue:=aValue div Base;
                   end;
          end;
end;

procedure AddLong (var aWhere: TLong; const aFrom: TLong);
var
   Index: LongInt;
begin
     for Index:=1 to aFrom.MaxIndex
         do Inc (aWhere.Digits [Index], aFrom.Digits [Index]);
     for Index:=1 to aWhere.MaxIndex+1
         do if aWhere.Digits [Index]>=Base
               then begin
                    Dec (aWhere.Digits [Index], Base);
                    Inc (aWhere.Digits [Index+1]);
               end;
     aWhere.MaxIndex:=Max (aWhere.MaxIndex, aFrom.MaxIndex);
     if aWhere.Digits [aWhere.MaxIndex+1]<>0
        then Inc (aWhere.MaxIndex);
end;

const
     FileIn='programs.in';
     FileOut='programs.out';
     MaxN=600;
     MaxL=600;
var
   N: LongInt;
   Words: array [1..MaxN] of string;
   L: LongInt;
   Dynamic: array [0..MaxL] of TLong;

procedure ReadData;
var
   F: Text;
   NWord: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NWord:=1 to N
         do Readln (F, Words [NWord]);
     Readln (F, L);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   Index: LongInt;
   S: string;
begin
     Assign (F, FileOut);
     Rewrite (F);
     with Dynamic [L]
          do begin
             MaxIndex:=Max (MaxIndex, 1);
             for Index:=MaxIndex downto 1
                 do begin
                    Str (Digits [Index], S);
                    if Index<>MaxIndex
                       then while Length (S)<BaseLength
                                  do S:='0'+S;
                    Write (F, S);
                 end;
          end;
     Close (F);
end;

function Strip (const aString: string): string;
var
   Res: string;
   NChar: LongInt;
begin
     Res:='';
     for NChar:=1 to Length (aString)
         do if aString [NChar]<>#32
               then Res:=Res+aString [NChar];
     Strip:=Res;
end;

procedure Solve;
var
   CurrentLength, NewLength: LongInt;
   NWord: LongInt;
begin
     for NWord:=1 to N
         do Words [NWord]:=Strip (Words [NWord]);
     FillChar (Dynamic, SizeOf (Dynamic), 0);
     CreateLong (Dynamic [0], 1);
     for CurrentLength:=1 to L
         do CreateLong (Dynamic [CurrentLength], 0);
     for CurrentLength:=0 to L-1
         do if Dynamic [CurrentLength].MaxIndex>0
               then for NWord:=1 to N
                        do begin
                           NewLength:=CurrentLength+Length (Words [NWord]);
                           if NewLength<=L
                              then AddLong (Dynamic [NewLength], Dynamic [CurrentLength]);
                        end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
