{$Q-, $R-}
const
     FileIn='indirect.in';
     FileOut='indirect.out';
     MaxInstructionsCount=262144;
     tSuccess=0;
     tDivisionByZero=1;
     tRunError=2;
type
    TInstruction=record
                       Ch: Char;
                       Sign: Char;
                       Argument: LongInt;
                 end;
var
   InstructionsCount: LongInt;
   Instructions: array [1..MaxInstructionsCount] of TInstruction;
   Memory: array [0..32768] of Integer;
   Answer: LongInt;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     InstructionsCount:=0;
     while not EOF (F)
           do begin
              Inc (InstructionsCount);
              with Instructions [InstructionsCount]
                   do Readln (F, Ch, Sign, Argument);
           end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   Address: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     case Answer of
          tSuccess: Writeln (F, 'SUCCESSFUL TERMINATION');
          tDivisionByZero: Writeln (F, 'DIVISION BY ZERO');
          tRunError: Writeln (F, 'RUN-TIME ERROR');
     end;
     for Address:=Low (Memory) to High (Memory)
         do Writeln (F, Memory [Address]);
     Close (F);
end;

var
   Notes: array [1..32768] of Int64;

procedure Solve;
var
   NInstruction: LongInt;
   Address: LongInt;
   NoteMark: Int64;

function Locate: Boolean;
begin
     Inc (NoteMark);
     Address:=Instructions [NInstruction].Argument;
     while Memory [Address]<0
           do begin
              Notes [Address]:=NoteMark;
              Address:=-Memory [Address];
              if Notes [Address]=NoteMark
                 then begin
                      Locate:=false;
                      Exit;
                 end;
           end;
     Locate:=true;
end;

begin
     FillChar (Memory, SizeOf (Memory), 0);
     FillChar (Notes, SizeOf (Notes), 0);
     NoteMark:=0;
     NInstruction:=1;
     Answer:=tSuccess;
     repeat
           with Instructions [NInstruction]
                do case Sign of
                        '*': if Locate
                                then case Ch of
                                          'A': Memory [0]:=Memory [0]+Memory [Address];
                                          'S': Memory [0]:=Memory [0]-Memory [Address];
                                          'M': Memory [0]:=Memory [0]*Memory [Address];
                                          'D': if Memory [Address]=0
                                                  then Answer:=tDivisionByZero
                                                  else Memory [0]:=Memory [0] div Memory [Address];
                                          'O': if Memory [Address]=0
                                                  then Answer:=tDIvisionByZero
                                                  else Memory [0]:=Memory [0] mod Memory [Address];
                                          'R': Memory [0]:=Memory [Address];
                                          'W': Memory [Address]:=Memory [0];
                                      end
                                else Answer:=tRunError;
                        '=': case Ch of
                                  'A': Memory [0]:=Memory [0]+Argument;
                                  'S': Memory [0]:=Memory [0]-Argument;
                                  'M': Memory [0]:=Memory [0]*Argument;
                                  'D': if Argument=0
                                          then Answer:=tDivisionByZero
                                          else Memory [0]:=Memory [0] div Argument;
                                  'O': if Argument=0
                                          then Answer:=tDIvisionByZero
                                          else Memory [0]:=Memory [0] mod Argument;
                                  'R': Memory [0]:=Argument;
                             end;
                   end;
           Inc (NInstruction);
     until (NInstruction>InstructionsCount) or (Answer<>tSuccess);
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
