uses SysUtils;
const
     FileIn='ram.in';
     FileOut='ram.out';
     MaxM=1000;
     MaxN=1000;
     cLoad=1;
     cStore=2;
     cAdd=3;
     cSub=4;
     cMult=5;
     cDiv=6;
     cRead=7;
     cWrite=8;
     cJump=9;
     cJgtz=10;
     cJzero=11;
     cHalt=12;
     vtConst=0;
     vtIndex=1;
     vtIndexOfIndex=2;
type
    TInstruction=record
                       Command: LongInt;
                       VType: LongInt;
                       Argument: LongInt;
                 end;
var
   M, N: longInt;
   Registers: array [0..999] of Integer;
   Instructions: array [0..MaxM-1] of TInstruction;
   Tape: array [1..MaxN] of Integer;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
   Instruction, Command: string;
   FirstSpace, LastSpace, NChar: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, M, N);
     for NItem:=0 to M-1
         do begin
            Readln (F, Instruction);
            for FirstSpace:=1 to Length (Instruction)
                do if Instruction [FirstSpace]=#32
                      then Break;
            for LastSpace:=Length (Instruction) downto 1
                do if Instruction [LastSpace]=#32
                      then Break;
            if Instruction [FirstSpace]<>#32
               then FirstSpace:=Length (Instruction)+1;
            Command:=Copy (Instruction, 1, FirstSpace-1);
            if Command='LOAD'
               then Instructions [NItem].Command:=cLoad
               else
            if Command='STORE'
               then Instructions [NItem].Command:=cStore
               else
            if Command='ADD'
               then Instructions [NItem].Command:=cAdd
               else
            if Command='SUB'
               then Instructions [NItem].Command:=cSub
               else
            if Command='MULT'
               then Instructions [NItem].Command:=cMult
               else
            if Command='DIV'
               then Instructions [NItem].Command:=cDiv
               else
            if Command='READ'
               then Instructions [NItem].Command:=cRead
               else
            if Command='WRITE'
               then Instructions [NItem].Command:=cWrite
               else
            if Command='JUMP'
               then Instructions [NItem].Command:=cJump
               else
            if Command='JGTZ'
               then Instructions [NItem].Command:=cJgtz
               else
            if Command='JZERO'
               then Instructions [NItem].Command:=cJZero
               else
            if Command='HALT'
               then Instructions [NItem].Command:=cHalt;

            NChar:=LastSpace;
            Inc (NChar);
            case Instruction [NChar] of
                 '=': begin
                           Instructions [NItem].VType:=vtConst; // Constant
                           Inc (NChar);
                      end;
                 '*': begin
                           Instructions [NItem].VType:=vtIndexOfIndex; // c(c(i))
                           Inc (NCHar);
                      end;
                 else Instructions [NItem].VType:=vtIndex; // c(i)
            end;
            Val (Copy (Instruction, NChar, Length (Instruction)), Instructions [NItem].Argument);
         end;
     for NItem:=1 to N
         do Read (F, Tape [NItem]);
     Close (F);
end;

procedure Solve;
var
   FOut: Text;
   InstructionIndex, TapeIndex: LongInt;
   Value: LongInt;

procedure LocateValue;
var
   NIteration: LongInt;
begin
     Value:=Instructions [InstructionIndex].Argument;
     for NIteration:=1 to Instructions [InstructionIndex].VType
         do Value:=Registers [Value];
end;

begin
     Assign (FOut, FileOut);
     Rewrite (FOut);
     InstructionIndex:=0;
     TapeIndex:=1;
     repeat
           with Instructions [InstructionIndex]
                do case Command of
                        cLoad: begin
                                    LocateValue;
                                    Registers [0]:=Value;
                                    Inc (InstructionIndex);
                               end;
                        cStore: begin
                                     case VType of
                                          vtIndex: Registers [Argument]:=Registers [0];
                                          vtIndexOfIndex: Registers [Registers [Argument]]:=Registers [0];
                                     end;
                                     Inc (InstructionIndex);
                                end;
                        cAdd: begin
                                   LocateValue;
                                   Registers [0]:=Registers [0]+Value;
                                   Inc (InstructionIndex);
                              end;
                        cSub: begin
                                   LocateValue;
                                   Registers [0]:=Registers [0]-Value;
                                   Inc (InstructionIndex);
                              end;
                        cMult: begin
                                    LocateValue;
                                    Registers [0]:=Registers [0]*Value;
                                    Inc (InstructionIndex);
                               end;
                        cDiv: begin
                                   LocateValue;
                                   Registers [0]:=Registers [0] div Value;
                                   Inc (InstructionIndex);
                              end;
                        cRead: begin
                                    case VType of
                                         vtIndex: Registers [Argument]:=Tape [TapeIndex];
                                         vtIndexOfIndex: Registers [Registers [Argument]]:=Tape [TapeIndex];
                                    end;
                                    Inc (TapeIndex);
                                    Inc (InstructionIndex);
                               end;
                        cWrite: begin
                                     LocateValue;
                                     Writeln (FOut, Value);
                                     Inc (InstructionIndex);
                                end;
                        cJump: InstructionIndex:=Argument;
                        cJgtz: if Registers [0]>0
                                  then InstructionIndex:=Argument
                                  else Inc (InstructionIndex);
                        cJzero: if Registers [0]=0
                                   then InstructionIndex:=Argument
                                   else Inc (InstructionIndex);
                        cHalt: Break;
                end;
     until InstructionIndex>=M;
     Close (FOut);
end;

begin
     ReadData;
     Solve;
end.
