const
     FileIn='rle.in';
     FileOut='rle.out';
     MaxK=30000;
type
    PRange=^TRange;
    TRange=record
                 Start, Finish: LongInt;
                 Id: LongInt;
                 Next: PRange;
           end;
var
   Parents: array [1..MaxK] of LongInt;
   LastId: LongInt;

procedure Link (A, B: LongInt);
begin
     Parents [A]:=B;
end;

function GetParent (A: LongInt): LongInt;
begin
     if Parents [A]<>A
        then Parents [A]:=GetParent (Parents [A]);
     GetParent:=Parents [A];
end;

procedure Unite (A, B: LongInt);
begin
     Link (GetParent (A), GetParent (B));
end;

procedure InitParents;
var
   Id: LongInt;
begin
     for Id:=Low (Parents) to High (Parents)
         do Parents [Id]:=Id;
     LastId:=Low (Parents)-1;
end;

function Min (aA, aB: LongInt): LongInt;
begin
     if aA<aB
        then Min:=aA
        else Min:=aB;
end;

procedure Solve;
var
   FIn, FOut: Text;
   M, N: LongInt;
   B: Byte;
   K: LongInt;
   UpperRanges, CurrentRanges, Last: PRange; // We may be sure to waste memory

procedure AddRange (aStart, aFinish: LongInt);
begin
     Inc (LastId);
     if Assigned (Last)
        then begin
             New (Last^.Next);
             Last:=Last^.Next;
        end
        else begin
             New (Last);
             CurrentRanges:=Last;
        end;
     Last^.Start:=aStart;
     Last^.Finish:=aFinish;
     Last^.Id:=LastId;
     Last^.Next:=nil;
end;

procedure Check;
var
   UpperRange, CurrentRange: PRange;
begin
     UpperRange:=UpperRanges;
     CurrentRange:=CurrentRanges;
     while Assigned (UpperRange) and Assigned (CurrentRange)
           do begin
              if (UpperRange^.Start<=CurrentRange^.Finish) and (UpperRange^.Finish+1>=CurrentRange^.Start) // 室  current
                 then Unite (UpperRange^.Id, CurrentRange^.Id)
                 else if (UpperRange^.Start-1<=CurrentRange^.Finish) and (UpperRange^.Finish>=CurrentRange^.Start) // ࠢ current
                          then Unite (UpperRange^.Id, CurrentRange^.Id);
              if UpperRange^.Finish<CurrentRange^.Finish
                 then UpperRange:=UpperRange^.Next
                 else CurrentRange:=CurrentRange^.Next;
           end;
end;

var
   LastX, Len, Delta: LongInt;
   Answer: LongInt;
begin
     Assign (FIn, FileIn);
     Reset (FIn);

     Read (FIn, M, N);
     Read (FIn, B, K);

     B:=B xor 1;

     LastX:=0;
     Len:=0;

     UpperRanges:=nil;
     CurrentRanges:=nil;
     Last:=nil;

     InitParents;

     repeat
           if LastX=M
              then begin
                   Check;
                   UpperRanges:=CurrentRanges;
                   CurrentRanges:=nil;
                   Last:=nil;
                   LastX:=0;
              end;
           if Len=0
              then begin
                   Dec (K);
                   if K<0
                      then Break;
                   Read (FIn, Len);
                   B:=B xor 1;
              end;
           Delta:=Min (Len, M-LastX);
           if Boolean (B)
              then AddRange (LastX+1, LastX+Delta);
           Inc (LastX, Delta);
           Dec (Len, Delta);
     until (Len=0) and (K=0);
     Check;

     Close (FIn);

     Answer:=0;
     for LastId:=LastId downto 1
         do if GetParent (LastId)=LastId
               then Inc (Answer);

     Assign (FOut, FileOut);
     Rewrite (FOut);
     Writeln (FOut, Answer);
     Close (FOut);
end;

begin
     Solve;
end.
