const
     FileIn='pipe.in';
     FileOut='pipe.out';
     MaxN=200;
     Eps=1e-7;
type
    TPoint=record
                 X, Y: Extended;
           end;
var
   N: LongInt;
   Points: array [1..MaxN*2] of TPoint;
   Ks, Bs: array [1..MaxN*2] of Extended;
   DeloTruba: Boolean;
   AnswerX: Extended;

procedure ReadData;
var
   F: Text;
   NPoint: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, N);
     for NPoint:=1 to N
         do Readln (F, Points [NPoint].X, Points [NPoint].Y);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     if DeloTruba
        then Writeln (F, 'DELO TRUBA')
        else Writeln (F, AnswerX:0:2);
     Close (F);
end;

function VectorMultiplication (aX1, aY1, aX2, aY2, aX3, aY3: Extended): Extended;
var
   AX, AY, BX, BY: Extended;
begin
     AX:=aX2-aX1;
     AY:=aY2-aY1;
     BX:=aX3-aX2;
     BY:=aY3-aY2;
     VectorMultiplication:=AX*BY-AY*BX;
end;

procedure Solve;
var
   NPoint, NPoint1, NPoint2: LongInt;
   K, B: Extended;
   MinX, X: Extended;
   Intersects: Boolean;
begin
     AnswerX:=Points [1].X;
     for NPoint:=1 to N
         do begin
            Points [NPoint+N].X:=Points [NPoint].X;
            Points [NPoint+N].Y:=Points [NPoint].Y-1.0;
         end;
     for NPoint:=1 to N*2-1
         do begin
            Ks [NPoint]:=(Points [NPoint+1].Y-Points [NPoint].Y)/(Points [NPoint+1].X-Points [NPoint].X);
            Bs [NPoint]:=Points [NPoint].Y-Ks [NPoint]*Points [NPoint].X;
         end;
     for NPoint1:=1 to N*2
         do for NPoint2:=1 to N*2
                do if Points [NPoint2].X>Points [NPoint1].X+Eps
                      then begin
                           K:=(Points [NPoint2].Y-Points [NPoint1].Y)/(Points [NPoint2].X-Points [NPoint1].X);
                           B:=Points [NPoint1].Y-K*Points [NPoint1].X;

                           {  ࠢ 室  砫 ? }
                           if (K*Points [1].X+B>Points [1].Y+Eps) or (K*Points [N+1].X+B+Eps<Points [N+1].Y)
                              then Continue;

                           Intersects:=false;
                           MinX:=Points [N].X;

                           {  ᥪ  ࠭? }
                           for NPoint:=1 to N-1
                               do if VectorMultiplication (Points [NPoint1].X, Points [NPoint1].Y, Points [NPoint2].X,
                                     Points [NPoint2].Y, Points [NPoint+1].X, Points [NPoint+1].Y)<-Eps
                                     then begin
                                          X:=(B-Bs [NPoint])/(Ks [NPoint]-K);
                                          if (not Intersects) or (X+Eps<MinX)
                                             then begin
                                                  MinX:=X;
                                                  Intersects:=true;
                                                  Break;
                                             end;
                                     end;
                           {  ᥪ  ࠭? }
                           for NPoint:=N+1 to 2*N-1
                               do if VectorMultiplication (Points [NPoint1].X, Points [NPoint1].Y, Points [NPoint2].X,
                                     Points [NPoint2].Y, Points [NPoint+1].X, Points [NPoint+1].Y)>Eps
                                     then begin
                                          X:=(B-Bs [NPoint])/(Ks [NPoint]-K);
                                          if (not Intersects) or (X+Eps<MinX)
                                             then begin
                                                  MinX:=X;
                                                  Intersects:=true;
                                                  Break;
                                             end;
                                     end;
                           if not Intersects
                              then begin
                                   DeloTruba:=true;
                                   Exit;
                              end;
                           if MinX>AnswerX
                              then AnswerX:=MinX;
                        end;
     DeloTruba:=false;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
