const
     FileIn='rescue.in';
     FileOut='rescue.out';
     MaxN=50000;
     MaxM=50000;
     MinX=-999;
     MaxX=999;
     MinY=-999;
     MaxY=999;
type
    TPoint=record
                 X, Y: Integer;
           end;
var
   N, M: LongInt;
   Bases: array [1..MaxN] of TPoint;
   Screams: array [1..MaxM] of TPoint;

procedure ReadData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Read (F, N, M);
     for NItem:=1 to N
         do Read (F, Bases [NItem].X, Bases [NItem].Y);
     for NItem:=1 to M
         do Read (F, Screams [NItem].X, Screams [NItem].Y);
     Close (F);
end;

var
   CurrentMinX, CurrentMaxX, CurrentMinY, CurrentMaxY: LongInt;
   Cells: array [MinX..MaxX, MinY..MaxY] of LongInt;

procedure WriteData;
var
   F: Text;
   NItem: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     for NItem:=1 to M
         do with Screams [NItem]
                 do Writeln (F, Bases [Cells [X, Y]].X, #32, Bases [Cells [X, Y]].Y);
     Close (F);
end;

var
   Queue: array [1..(MaxX-MinX+1)*(MaxY-MinY)+1] of TPoint;
   QueueIndex, QueueTail: LongInt;

procedure Push (aX, aY: LongInt);
begin
     if QueueTail=High (Queue)
        then QueueTail:=1
        else Inc (QueueTail);
     Queue [QueueTail].X:=aX;
     Queue [QueueTail].Y:=aY;
end;

procedure Debug;
var
   Y, X: LongInt;
begin
     Writeln ('---------- Debug -----------');
     for Y:=CurrentMinY to CurrentMaxY
         do begin
            for X:=CurrentMinX to CurrentMaxX
                do Write (Cells [X, Y]);
            Writeln;
         end;
     Readln;
end;

procedure BFS;
var
   X, Y: Integer;
   Distance, NewDistance: LongInt;
   Base, NewBase: LongInt;

procedure DoTry;
begin
     if (X>=CurrentMinX) and (X<=CurrentMaxX) and (Y>=CurrentMinY) and (Y<=CurrentMaxY)
        then if Cells [X, Y]=0
                then begin
                     Cells [X, Y]:=NewBase;
                     Push (X, Y);
                end
                else begin
                     Base:=Cells [X, Y];
                     Distance:=Sqr (LongInt (Bases [Base].X-X))+Sqr (LongInt (Bases [Base].Y-Y));
                     NewDistance:=Sqr (LongInt (Bases [NewBase].X-X))+Sqr (LongInt (Bases [NewBase].Y-Y));
                     if NewDistance<Distance
                        then begin
                             Cells [X, Y]:=NewBase;
                             Push (X, Y);
                        end;
                end;
end;

begin
     while true
           do begin
              NewBase:=Cells [Queue [QueueIndex].X, Queue [QueueIndex].Y];
{              for X:=Queue [QueueIndex].X-1 to Queue [QueueIndex].X+1
                  do for Y:=Queue [QueueIndex].Y-1 to Queue [QueueIndex].Y+1
                         do if (X<>Queue [QueueIndex].X) or (Y<>Queue [QueueIndex].Y)
                               then DoTry; }
              X:=Queue [QueueIndex].X-1;
              Y:=Queue [QueueIndex].Y;
              DoTry;
              X:=Queue [QueueIndex].X+1;
              Y:=Queue [QueueIndex].Y;
              DoTry;
              X:=Queue [QueueIndex].X;
              Y:=Queue [QueueIndex].Y-1;
              DoTry;
              X:=Queue [QueueIndex].X;
              Y:=Queue [QueueIndex].Y+1;
              DoTry;
//              Debug;
              if QueueIndex=QueueTail
                 then Break;
              if QueueIndex=High (Queue)
                 then QueueIndex:=1
                 else Inc (QueueIndex);
           end;
end;

procedure Solve;
var
   NBase, NScream: LongInt;
   X, Y: LongInt;
begin
     CurrentMinX:=Bases [1].X;
     CurrentMinY:=Bases [1].Y;
     CurrentMaxX:=Bases [1].X;
     CurrentMaxY:=Bases [1].Y;
     for NBase:=2 to N
         do with Bases [NBase]
                 do begin
                    if X<CurrentMinX
                       then CurrentMinX:=X;
                    if Y<CurrentMinY
                       then CurrentMinY:=Y;
                    if X>CurrentMaxX
                       then CurrentMaxX:=X;
                    if Y>CurrentMaxY
                       then CurrentMaxY:=Y;
                 end;
     for NScream:=1 to M
         do with Screams [NScream]
                 do begin
                    if X<CurrentMinX
                       then CurrentMinX:=X;
                    if Y<CurrentMinY
                       then CurrentMinY:=Y;
                    if X>CurrentMaxX
                       then CurrentMaxX:=X;
                    if Y>CurrentMaxY
                       then CurrentMaxY:=Y;
                 end;
     FillChar (Cells, SizeOf (Cells), 0);

     QueueTail:=0;
     QueueIndex:=1;
     for NBase:=1 to N
         do with Bases [NBase]
                 do begin
                    Cells [X, Y]:=NBase;
                    Push (X, Y);
                 end;
     BFS;
end;

procedure NaiveSolve;
var
   NScream, NBase: LongInt;
   Distance, NewDistance: LongInt;
begin
     for NScream:=1 to M
         do begin
            Distance:=Sqr (LongInt (Bases [1].X-Screams [NScream].X))+Sqr (LongInt (Bases [1].Y-Screams [NScream].Y));
            Cells [Screams [NScream].X, Screams [NScream].Y]:=1;
            for NBase:=2 to N
                do begin
                   NewDistance:=Sqr (LongInt (Bases [NBase].X-Screams [NScream].X))+Sqr (LongInt (Bases [NBase].Y-Screams [NScream].Y));
                   if NewDistance<Distance
                      then begin
                           Cells [Screams [NScream].X, Screams [NScream].Y]:=NBase;
                           Distance:=NewDistance;
                      end;
                end;
         end;
end;

begin
     ReadData;
     if (N*M<=10000000) and (ParamCount=0)
        then NaiveSolve
        else Solve;
     WriteData;
end.
