const
     FileIn='young.in';
     FileOut='young.out';
     MaxRows=50;
     MaxColumns=50;
     MaxK=50;
var
   FIn, FOut: Text;
   Lambda, Mu, Nu: array [1..MaxRows] of LongInt;
   Finished: Boolean;
   Answer: LongInt;

procedure ReadData;
var
   Index: LongInt;
begin
     FillChar (Lambda, SizeOf (Lambda), 0);
     FillChar (Mu, SizeOf (Mu), 0);
     FillChar (Nu, SizeOf (Nu), 0);
     Read (FIn, Lambda [1]);
     Finished:=Lambda [1]<0;
     if not Finished
        then begin
             Index:=1;
             repeat
                   Inc (Index);
                   Read (FIn, Lambda [Index]);
             until Lambda [Index]=0;
             Index:=0;
             repeat
                   Inc (Index);
                   Read (FIn, Mu [Index]);
             until Mu [Index]=0;
             Index:=0;
             repeat
                   Inc (Index);
                   Read (FIn, Nu [Index]);
             until Nu [Index]=0;
        end;
end;

procedure WriteData;
begin
     Writeln (FOut, Answer);
end;

var
   Image: array [1..MaxRows, 1..MaxRows] of LongInt;
   CurrentMaxK, CurrentMaxRow: LongInt;

function Min (aA, aB: LongInt): LongInt;
begin
     if aA<aB
        then Min:=aA
        else Min:=aB;
end;

procedure Debug;
var
   X, Y: LongInt;
begin
     for Y:=1 to CurrentMaxRow
         do begin
            for X:=1 to Lambda [Y]
                do Write (#32);
            for X:=Lambda [Y]+1 to Nu [Y]
                do if Image [X, Y]=MaxLongInt
                      then Write ('.')
                      else Write (Image [X, Y]);
            Writeln;
         end;
//     Readln;
end;

procedure FillRow (aRow: LongInt); forward;

procedure FillColumn (aRow, aColumn: LongInt);
var
   K: LongInt;
begin
     for K:=Min (Min (Image [aColumn+1, aRow], Image [aColumn, aRow+1]-1), CurrentMaxK) downto 1
         do if Mu [K]<>0 //    ⠢
               then begin
                    Dec (Mu [K]);
                    Image [aColumn, aRow]:=K;
//                    Debug;
                    if aColumn>Lambda [aRow]+1
                       then FillColumn (aRow, aColumn-1)
                       else FillRow (aRow-1);
                    Inc (Mu [K]);
//                    Image [aColumn, aRow]:=MaxLongInt; // !!!!!!!!!!
               end;
end;

var
   B: array [1..MaxK, 0..MaxRows] of Byte;

procedure FillRow (aRow: LongInt);
var
   X, Y, K: LongInt;
begin
//     Debug;
     if aRow=0
        then begin
             FillChar (B, SizeOf (B), 0);
             for Y:=1 to CurrentMaxRow
                 do begin
                    for K:=1 to CurrentMaxK
                        do B [K, Y]:=B [K, Y-1];
                    for X:=Lambda [Y]+1 to Nu [Y]
                        do Inc (B [Image [X, Y], Y]);
//                    for K:=1 to CurrentMaxK
//                        do Writeln (K, ' 砥   ', Y, ' ப ', B [K, Y], ' ࠧ');
                 end;
             for K:=1 to CurrentMaxK
                 do for Y:=0 to CurrentMaxRow-1
                        do if B [K, Y]<B [K+1, Y+1]
                              then Exit;
             Inc (Answer);
        end
        else FillColumn (aRow, Nu [aRow]);
end;

procedure Solve;
var
   Index: LongInt;
   X, Y: LongInt;
   CellsInMu, CellsInNuLambda: LongInt;
begin
     // Lambda 뢠  Nu?
     for Index:=1 to MaxRows
         do if Lambda [Index]>Nu [Index]
               then begin
                    Answer:=0;
                    Exit;
               end;
     // 0 ⮪ ⠫?
     CellsInNuLambda:=0;
     for Index:=1 to MaxRows
         do Inc (CellsInNuLambda, Nu [Index]-Lambda [Index]);
     if CellsInNuLambda=0
        then begin
             Answer:=1;
             Exit;
        end;
     // ᫮ ⮪  Mu ᮮ⢥  ⠢ ⮪  Nu-Lambda?
     CellsInMu:=0;
     for Index:=1 to MaxRows
         do Inc (CellsInMu, Mu [Index]);
     if CellsInMu<>CellsInNuLambda
        then begin
             Answer:=0;
             Exit;
        end;
     //  .   㬠.

     //  ⠬ ᠬ 讥 ᫮, ஥   ⠢?
     CurrentMaxK:=MaxRows;
     while Mu [CurrentMaxK]=0
           do Dec (CurrentMaxK);

     // ᫥  窠  ࠧ
     Answer:=0;
     for Index:=MaxRows downto 1
         do if Lambda [Index]<Nu [Index]
               then Break;
     CurrentMaxRow:=Index;
     //   !
     for X:=1 to MaxRows
         do for Y:=1 to MaxRows
                do Image [X, Y]:=High (Image [X, Y]);
     FillRow (CurrentMaxRow);
end;

begin
     Assign (FIn, FileIn);
     Reset (FIn);
     Assign (FOut, FileOut);
     Rewrite (FOut);
     repeat
           ReadData;
           if not Finished
              then begin
                   Solve;
                   WriteData;
              end;
     until Finished;
     Close (FIn);
     Close (FOut);
end.
