{$H+}
uses SysUtils;

function Max (aA, aB: LongInt): LongInt;
begin
     if aA>aB
        then Max:=aA
        else Max:=aB;
end;

function ResizeNumber (const aA: string; aLength: LongInt): string;
var
   B: string;
   Delta, NChar: LongInt;
begin
     SetLength (B, aLength);
     Delta:=aLength-Length (aA);
     for NChar:=1 to Delta
         do B [NChar]:='0';
     for NChar:=1 to Length (aA)
         do B [NChar+Delta]:=aA [NChar];
     ResizeNumber:=B;
end;

function NormalizeNumber (aA: string): string;
var
   NChar: LongInt;
begin
     for NChar:=1 to Length (aA)
         do if aA [NChar]<>'0'
               then Break;
     NormalizeNumber:=Copy (aA, NChar, Length (aA));
end;

function LongSum (const aA, aB: string): string;
var
   A, B: string;
   NewLength: LongInt;
   NChar: LongInt;
begin
     if aB='0'
        then begin
             LongSum:=aA;
             Exit;
        end;
     NewLength:=Max (Length (aA), Length (aB))+1;
     A:=ResizeNumber (aA, NewLength);
     B:=ResizeNumber (aB, NewLength);
     for NChar:=NewLength downto 1
         do begin
            A [NChar]:=Chr (Ord (A [NChar])+Ord (B [NChar])-Ord ('0'));
            if A [NChar]>'9'
               then begin
                    Inc (A [NChar-1]);
                    Dec (A [NChar], 10);
               end;
         end;
     LongSum:=NormalizeNumber (A);
end;

function LongMulOnCh (const aA: string; aCh: Char): string;
var
   Digit: LongInt;
   A: string;
   NChar: LongInt;
begin
     if aCh='0'
        then begin
             LongMulOnCh:='0';
             Exit;
        end;
     Digit:=Ord (aCh)-Ord ('0');
     A:=ResizeNumber (aA, Length (aA)+1);
     for NChar:=Length (A) downto 1
         do A [NChar]:=Chr ((Ord (A [NChar])-Ord ('0'))*Digit+Ord ('0'));
     for NChar:=Length (A) downto 1
         do begin
            Digit:=Ord (A [NChar])-Ord ('0');
            if Digit>=10
               then begin
                    Inc (A [NChar-1], Digit div 10);
                    A [NChar]:=Chr ((Digit mod 10)+Ord ('0'));
               end;
         end;
     LongMulOnCh:=A;
end;

function LongMul (const aA, aB: string): string;
var
   NChar: LongInt;
   Shift: string;
   C: string;
begin
     Shift:='';
     C:='';
     for NChar:=Length (aB) downto 1
         do begin
            C:=LongSum (C, LongMulOnCh (aA, aB [NChar])+Shift);
            Shift:=Shift+'0';
         end;
     LongMul:=NormalizeNumber (C);
end;



const
     FileIn='lcm.in';
     FileOut='lcm.out';
     MaxN=2000;
var
   N: LongInt;
   Numbers: array [1..MaxN] of LongInt;
   Answer: string;

procedure ReadData;
var
   F: Text;
   NNumber: LongInt;
begin
     Assign (F, FileIn);
     Reset (F);
     Read (F, N);
     for NNumber:=1 to N
         do Read (F, Numbers [NNumber]);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

var
   PrimesCount: LongInt;
   Primes: array [1..10000] of LongInt;

procedure InitPrimes;
var
   Number, LastPrime: LongInt;
   Index: LongInt;
   IsPrime: Boolean;
begin
     PrimesCount:=1;
     Primes [PrimesCount]:=2;
     Number:=Primes [PrimesCount]+1;

     while PrimesCount<High (Primes)
           do begin
              IsPrime:=true;
              LastPrime:=Trunc (Sqrt (Number));
              for Index:=1 to PrimesCount
                  do if Primes [Index]>LastPrime
                        then Break
                        else if Number mod Primes [Index]=0
                                then begin
                                     IsPrime:=false;
                                     Break;
                                end;
              if IsPrime
                 then begin
                      Inc (PrimesCount);
                      Primes [PrimesCount]:=Number;
                 end;
              Inc (Number, 2);
           end;
end;


type
    TDivider=packed record
                   Value: LongInt;
                   Count: LongInt;
             end;
    PDividers=^TDividers;
    TDividers=array [1..5000] of TDivider;
var
   Total, Current, Merged: PDividers;
   TotalCount, CurrentCount, MergedCount: LongInt;

procedure Merge;
var
   TotalIndex, CurrentIndex: LongInt;
begin
     TotalIndex:=1;
     CurrentIndex:=1;
     MergedCount:=0;
     while (TotalIndex<=TotalCount) and (CurrentIndex<=CurrentCount)
           do begin
              if Total^ [TotalIndex].Value=Current^ [CurrentIndex].Value
                 then begin
                      Inc (MergedCount);
                      Merged^ [MergedCount].Value:=Current^ [CurrentIndex].Value;
                      Merged^ [MergedCount].Count:=Max (Total^ [TotalIndex].Count, Current^ [CurrentIndex].Count);
                      Inc (TotalIndex);
                      Inc (CurrentIndex);
                 end
                 else if Total^ [TotalIndex].Value<Current^ [CurrentIndex].Value
                         then begin
                              Inc (MergedCount);
                              Merged^ [MergedCount].Value:=Total^ [TotalIndex].Value;
                              Merged^ [MergedCount].Count:=Total^ [TotalIndex].Count;
                              Inc (TotalIndex);
                         end
                         else if Total^ [TotalIndex].Value>Current^ [CurrentIndex].Value
                                 then begin
                                      Inc (MergedCount);
                                      Merged^ [MergedCount].Value:=Current^ [CurrentIndex].Value;
                                      Merged^ [MergedCount].Count:=Current^ [CurrentIndex].Count;
                                      Inc (CurrentIndex);
                                 end;
           end;
     while TotalIndex<=TotalCount
           do begin
              Inc (MergedCount);
              Merged^ [MergedCount].Value:=Total^ [TotalIndex].Value;
              Merged^ [MergedCount].Count:=Total^ [TotalIndex].Count;
              Inc (TotalIndex);
           end;
     while CurrentIndex<=CurrentCount
           do begin
              Inc (MergedCount);
              Merged^ [MergedCount].Value:=Current^ [CurrentIndex].Value;
              Merged^ [MergedCount].Count:=Current^ [CurrentIndex].Count;
              Inc (CurrentIndex);
           end;
end;

procedure Swap (var aA, aB: Pointer);
var
   T: Pointer;
begin
     T:=aA;
     aA:=aB;
     aB:=T;
end;

procedure Swap (var aA, aB: LongInt);
var
   T: LongInt;
begin
     T:=aA;
     aA:=aB;
     aB:=T;
end;

function QuickPower (aValue, aPower: LongInt): LongInt;
begin
     if aPower=0
        then QuickPower:=1
        else if Odd (aPower)
                then QuickPower:=QuickPower (aValue, aPower-1)*aValue
                else QuickPower:=Sqr (QuickPower (aValue, aPower shr 1));
end;

procedure Solve;
var
   NNumber, Number, NPrime: LongInt;
   Divider: LongInt;

procedure Probe;
begin
     Inc (CurrentCount);
     Current^ [CurrentCount].Count:=0;
     while Number mod Divider=0
           do begin
              Number:=Number div Divider;
              Inc (Current^ [CurrentCount].Count);
           end;
     if Current^ [CurrentCount].Count>0
        then Current^ [CurrentCount].Value:=Divider
        else Dec (CurrentCount);
     if Odd (Divider)
        then Inc (Divider, 2)
        else Inc (Divider);
end;

begin
     InitPrimes;

     New (Total);
     New (Current);
     New (Merged);
     TotalCount:=0;
     CurrentCount:=0;

     for NNumber:=1 to N
         do begin
            Divider:=2;

            Number:=Numbers [NNumber];
            CurrentCount:=0;

            for NPrime:=1 to High (Primes)
                do if Number<=1
                      then Break
                      else begin
                           Divider:=Primes [NPrime];
                           Probe;
                      end;
            if Number>1 // Let it be prime
               then begin
                    Divider:=Number;
                    Probe;
               end;
            Merge;
            Swap (Total, Merged);
            Swap (TotalCount, MergedCount);
         end;
     Dispose (Current);
     Dispose (Merged);

     Answer:='1';
     for NNumber:=1 to TotalCount
         do Answer:=LongMul (Answer, IntToStr (QuickPower (Total^ [NNumber].Value, Total^ [NNumber].Count)));
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
