{$H+}
uses Objects;
const
     FileIn='prof.in';
     FileOut='prof.out';
var
   Lection: string;
   Answer: LongInt;

procedure ReadData;
var
   F: Text;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, Lection);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

type
    PTrie=^TTrie;
    TTrie=packed object (TObject)
                Letter: Char;
                Depth: Integer;
                First, Right: PTrie; // First - first child; Right - child of owner
                Used: Integer;
                Position: Integer; // Position of last char, which this substring occupies

                constructor Init (aLetter: Char; aDepth: LongInt; aRight: PTrie);
                procedure Insert (aLetter: Char);
                procedure Use (aPosition: LongInt);
          end;

constructor TTrie.Init (aLetter: Char; aDepth: Longint; aRight: PTrie);
begin
     inherited Init;

     Letter:=aLetter;
     Depth:=aDepth;
     First:=nil;
     Right:=aRight;
     Used:=0;
end;

procedure TTrie.Insert (aLetter: Char);
begin
     First:=New (PTrie, Init (aLetter, Depth+1, First))
end;

procedure TTrie.Use (aPosition: LongInt);
begin
     if Used=0
        then begin
             Used:=1;
             Position:=aPosition;
        end
        else if Position<aPosition-Depth+1 // Last char is to the left of first char of new occurence
                then begin
                     Inc (Used);
                     Position:=aPosition;
                end;
end;

var
   Root: PTrie;

procedure AddToTrie (aStart: LongInt);
var
   NChar, NodeNChar: LongInt;
   Node, Child: PTrie;
begin
     Node:=Root;

     NChar:=aStart;
     while NChar<=Length (Lection)
           do begin
              if Node^.Letter=Lection [NChar]
                 then begin
                      Node^.Use (NChar);
                      Inc (NChar);
                 end;
              if NChar>Length (Lection)
                 then Break;
              Child:=Node^.First;
              while Assigned (Child)
                    do begin
                       if Child^.Letter=Lection [NChar]
                          then Break;
                       Child:=Child^.Right;
                    end;
              if not Assigned (Child)
                 then begin
                      Node^.Insert (Lection [NChar]);
                      Child:=Node^.First;
                 end;
              Node:=Child;
           end;
end;

procedure Walk (aNode: PTrie);
begin
     if Assigned (aNode)
        then begin
             if aNode^.Used>=2
                then Inc (Answer);
             Walk (aNode^.First);
             Walk (aNode^.Right);
        end;
end;

procedure Solve;
var
   Start, Finish: LongInt;
begin
     Root:=New (PTrie, Init (#$20, 0, nil));
     for Start:=1 to Length (Lection)
         do AddToTrie (Start);
     Answer:=0;
     Walk (Root);
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
