const
     FileIn='chrom.in';
     FileOut='chrom.out';
     MaxN=12;
     MaxD=MaxN*2+10;
type
    TPolynom=record
                   D: LongInt;
                   A: array [0..MaxD] of LongInt;
             end;
var
   N, M: LongInt;
   Matrix: array [1..MaxN, 1..MaxN] of LongInt;
   Answer: TPolynom;

procedure ReadData;
var
   F: Text;
   NEdge: LongInt;
   Node1, Node2: LongInt;
begin
     FillChar (Matrix, SizeOf (Matrix), 0);

     Assign (F, FileIn);
     Reset (F);
     Readln (F, N, M);
     for NEdge:=1 to M
         do begin
            Read (F, Node1, Node2);
            Matrix [Node1, Node2]:=1;
            Matrix [Node2, Node1]:=1;
         end;
     Close (F);
end;

procedure WriteData;
var
   F: Text;
   Index: LongInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Write (F, Answer.D);
     for Index:=0 to Answer.D
         do Write (F, #32, Answer.A [Index]);
     Close (F);
end;

procedure Multiply (const aA, aB: TPolynom; var aC: TPolynom);
var
   i, j: LongInt;
begin
     FillChar (aC, SizeOf (aC), 0);
     for i:=0 to aA.D
         do for j:=0 to aB.D
                do Inc (aC.A [i+j], aA.A [i]*aB.A [j]);
     for i:=High (aC.A) downto 0
         do if aC.A [i]<>0
               then Break;
     aC.D:=i;
end;

var
   Current, Temporary: TPolynom;
   States: array [1..MaxN] of LongInt;

procedure DFS (aNode: LongInt);
var
   Next: LongInt;
begin
     Current.A [0]:=0;
     for Next:=1 to N
         do if (Matrix [aNode, Next]<>0) and (States [Next]=1) // It depends on Next
               then Dec (Current.A [0]);
     Multiply (Current, Answer, Temporary);
     Answer:=Temporary;

     States [aNode]:=1;
     for Next:=1 to N
         do if (Matrix [aNode, Next]<>0) and (States [Next]=0)
               then DFS (Next);
     States [aNode]:=2;
end;

function HasPetli: Boolean;
var
   Node: LongInt;
begin
     for Node:=1 to N
         do if Matrix [Node, Node]<>0
               then begin
                    HasPetli:=true;
                    Exit;
               end;
     HasPetli:=false;
end;

procedure Solve;
var
   Node: LongInt;
begin
     FillChar (Answer, SizeOf (Answer), 0);
     Answer.D:=0;
     if HasPetli
        then Answer.A [0]:=0
        else begin
             Answer.A [0]:=1;

             FillChar (Current, SizeOf (Current), 0);
             Current.D:=1;
             Current.A [1]:=1;

             FillChar (States, SizeOf (States), 0);
             for Node:=1 to N
                 do if States [Node]=0
                       then DFS (Node);
        end;
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
