{$D-,I-,L-,Q-,R-,S-,N+}
program _Customs; {Heap_Dijkstra}
const
 f_in='customs.in';
 f_out='customs.out';
 maxN=16384; {10000}
 maxM=100000;
 Inf=1e+15;

type
 int=longint;
 Real=Extended;
 PEdge = ^TEdge;
 TEdge = record
  v : int;
  len : Real;
  next : PEdge;
  end;
 TMax3 = array[1..3] of Real;

var
 N, M, A, B : int;
 First : array[1..maxN] of PEdge;
 D : array[0..maxN] of TMax3; {0 - barier dlja kuchi}
 Heap, Back : array[1..maxN*2] of Int;
 HeapSize : int;
 Used : array[1..maxN] of boolean; {for better performance}

procedure OpenFiles;
begin
 assign(input, f_in);
 reset(input);
 assign(output, f_out);
 rewrite(output);
end;

procedure CloseFIles;
begin
 close(input);
 close(output);
end;

procedure WriteMax3(X : TMax3);
var
 i : int;
 Sum : Real;
begin
 Sum:=0;
 for i:=1 to 3 do
  Sum:=Sum+X[i];
 Writeln(Sum:0:0);
end;

procedure Add(v1, v2 : int; Len : Real);
var
 p : PEdge;
begin
 new(p);
 p^.v:=v2;
 p^.len:=Len;
 p^.next:=First[v1];
 First[v1]:=p;
end;

function MoreEQ(const A, B : TMax3) : boolean;
var
 i : int;
 SumA, SumB : Real;
begin
 sumA:=0; sumB:=0;
 for i:=1 to 3 do
  sumA:=SumA+A[i];
 for i:=1 to 3 do
  sumB:=SumB+B[i];
 MoreEQ:=sumA>=sumB;
end;

function More(const A, B : TMax3) : boolean;
var
 i : int;
 SumA, SumB : Real;
begin
 sumA:=0; sumB:=0;
 for i:=1 to 3 do
  sumA:=SumA+A[i];
 for i:=1 to 3 do
  sumB:=SumB+B[i];
 More:=sumA>sumB;
end;

procedure Sum(A : TMax3; X : Real; Var Ans : TMax3);
var
 i, j : int;
begin
 for i:=1 to 3 do
  if X>A[i] then
   begin
   for j:=3 downto i+1 do
    A[j]:=A[j-1];
   A[i]:=X;
   Ans:=A;
   Exit;
   end;
end;

function min(const a, b : Real) : Real;
begin
 if a<b then min:=a else min:=b;
end;

{menajet elementi kuchi s nomerami h1 i h2}
procedure Swap(h1, h2 : int);
var
 help : int;
begin
 help:=Heap[h1]; Heap[h1]:=Heap[h2]; Heap[h2]:=help;
 Back[ Heap[h1] ]:=h1;
 Back[ Heap[h2] ]:=h2;
end;

procedure Push(v : int);
var
 t : int;
begin
 t:=Back[v];
 while (t>1) and not MoreEQ(D[ Heap[t] ], D[ Heap[t div 2] ]) do
  begin
  Swap( t, t div 2 );
  t:=t div 2;
  end;
end;

procedure Pull(v : int);
var
 t, s : int;
begin
 t:=Back[v];
 s:=0;
 while (s<>t) do
  begin
  s:=t;
  if not MoreEQ(D[ Heap[ t*2+0 ] ],D[ Heap[s] ]) then
   s:=t*2+0;
  if not MoreEQ(D[ Heap[ t*2+1 ] ],D[ Heap[s] ]) then
   s:=t*2+1;
  if s<>t then
   Swap(s, t);
  end;
end;

procedure CreateHeap;
var
 i : int;
begin
 D[0][1] :=Inf;
 D[0][2] :=Inf;
 D[0][3] :=Inf;
 fillchar( Heap, sizeof(Heap), 0);
 HeapSize:=N;
 for i:=1 to N do
  Heap[i]:=i;
 for i:=1 to N do
  Back[i]:=i;
 Push(A);
 Pull(A);
end;

function ExtractMin : int;
begin
 ExtractMin:=Heap[1];
 Swap( 1, HeapSize );
 Heap[ HeapSize ]:=0;
 dec( HeapSize );
 Pull( Heap[1] );
end;

procedure Change(v : int; value : TMax3);
begin
 D[ v ]:=Value;
 Push( v );
 Pull( v );
end;

procedure Init;
var
 i, X, Y, Z : int;
begin
 Read(N, M);
 for i:=1 to N do
  First[i]:=nil;
 for i:=1 to M do
  begin
  Read(X, Y, Z);
  Add(X, Y, Z);
  end;
 Read(A, B);
 for i:=1 to N do
  begin
  D[i][1]:=Inf;
  D[i][2]:=Inf;
  D[i][3]:=Inf;
  end;
 D[A][1]:=0; D[A][2]:=0; D[A][3]:=0;
 CreateHeap;
 fillchar(Used, sizeof(Used), false);
end;

procedure Solve;
var
 i, j, jmin : int;
 p : PEdge;
 S : TMax3;
begin
 for i:=1 to N-1 do
  begin
  jmin:=ExtractMin;
  Used[jmin]:=True;
  p:=First[jmin];
  while p<>nil do
   begin
   if not Used[ p^.v ] then begin {podgonka}
   Sum( D[jmin], p^.len, S);
   if More( D[ p^.v ] , S ) then
    Change( p^.v, S );
   end;
   p:=p^.next;
   end;
  end;
 WriteMax3( D[B] );
end;

begin
 OpenFiles;
 Init;
 Solve;
 CloseFiles;
end.
