{$D-,I-,L-,Q-,R-,S-,N+}
program _A;
const
 f_in='indirect.in';
 f_out='indirect.out';
 MemorySize=32768;
 fhl16=65536;
 fhl15=32768;
 sOK='SUCCESSFUL TERMINATION';
 sDIV0='DIVISION BY ZERO';
 sRUNTIME='RUN-TIME ERROR';

type
 int=longint;
 TCommand = string[2] ;

var
 A : int;
 Memory, Help : array[1..MemorySize] of int;
 State : int;

procedure OpenFiles;
begin
 assign(input, f_in);
 reset(input);
 assign(output, f_out);
 rewrite(output);
end;

procedure CloseFIles;
begin
 close(input);
 close(output);
end;

procedure Init;
begin
 A:=0;
 fillchar(Memory, sizeof(Memory), 0);
 fillchar(Help, sizeof(Help), 0);
end;

procedure MakeRef( Source, Dest : Int);
var
 t, save : int;
begin
 t:=Source;
 while t<>Dest do
  begin
  save:=Abs( Memory[t] );
  if Help[t]=0 then
   Help[t]:=Memory[t];
  Memory[t]:=-Dest;
  t:=save;
  end;
end;

function ReadMemory(Adr : int;var error : boolean) : int;
var
 t : int;

begin
 error:=false;
 t:=Adr;
 if Memory[t]>=0 then
  begin
  ReadMemory:=Memory[t];
  exit;
  end;
 t:=Abs( Memory[t] );
 while t<>Adr do
  begin
  if Memory[t]>=0 then
   begin
   ReadMemory:=Memory[t];
   MakeRef(Adr, t);
   exit;
   end
  else
   t:=Abs( Memory[t] );
  end;
 {RUNTIME ERROR!}
 error:=true;
end;

procedure WriteMemory(Adr, Value : int; var error : boolean);
var
 t : int;
begin
 error:=false;
 t:=Adr;
 if Memory[t]>=0 then
  begin
  Memory[t]:=Value;
  exit;
  end;
 t:=Abs( MEmory[t] );
 while t<>Adr do
  begin
  if Memory[t]>=0 then
   begin
   Memory[t]:=Value;
   MakeRef(Adr, t);
   exit;
   end
  else
   t:=Abs( Memory[t] );
  end;
 {RUNTIME ERROR!}
 error:=true;
end;

function RangeControl(X : int) : int;
begin
 RangeControl:= (X+fhl15) mod fhl16 - fhl15;
end;

procedure Solve;
var
 C : TCommand;
 c1, c2 : char;
 P, X : int;
 Error : boolean;

begin
 State:=0;
 Error:=False;
 while not SeekEOF do
  begin
  Read(C);
  c1:=C[1]; c2:=C[2];
  Readln(P);
  if c2='=' then
   X:=P
  else if c1<>'W' then
   X:=ReadMemory(P, Error);
  if Error then
   begin
   State:=2;
   Exit;
   end;
  case c1 of
  'A':
   begin
   A:=RangeControl( A+X );
   end;
  'S':
   begin
   A:=RangeControl( A-X );
   end;
  'M':
   begin
   A:=RangeControl( A*X );
   end;
  'D':
   begin
   if X=0 then
    begin
    State:=1;
    Exit;
    end;
   A:=RangeControl( A div X );
   end;
  'O':
   begin
   if X=0 then
    begin
    State:=1;
    Exit;
    end;
   A:=RangeControl( A mod X );
   end;
  'R':
   begin
   A:=X;
   end;
  'W':
   begin
   WriteMemory( P, A, Error );
   if Error then
    begin
    State:=2;
    Exit;
    end;
   end;
  end;

  end;
end;

procedure WriteData;
var
 i : int;
begin
 case State of
 0:
  begin
  Writeln(sOK);
  end;
 1:
  begin
  Writeln(sDiv0);
  end;
 2 :
  begin
  Writeln(sRunTIme);
  end;
 end;
 Writeln(A);
 for i:=1 to MemorySize do
  if Help[i]=0 then
   Writeln( Memory[i])
  else
   Writeln( Help[i]);
end;

begin
 OpenFiles;
 Init;
 Solve;
 WriteData;
 CloseFiles;
end.
{
R=2
A=2
W*1
R=0
S*1
W*1
R*1
S=2
W*1
R=1
W*1
}
{
R=0
S=2
W*1
S=1
W*2
S=1
W*3
R=10
W*4
R*1
}
