{$D-,I-,L-,Q-,R-,S-,N+}
program _RAM;
const
 f_in='ram.in';
 f_out='ram.out';
 maxN=1000;
 maxM=1000;
 memSize=1000;
 fhl16=65536;
 fhl15=32768;

{
load      0
store     1
add       2
sub       3
mult      4
div       5
read      6
write     7
jump      8
jgtz      9
jzero     10
halt      11
}

type
 int=longint;
 DataType=( constant, ref, ref2 );
 TCommand = record
  cType : int;
  dType : DataType;
  data  : int;
  end;

var
 N, M, NowData, NowLine : int;
 Command : array[0..maxN] of TCommand;
 MData : array[1..maxM] of int;
 Mem : array[0..memSize-1] of int;
 ch : Char;

procedure OpenFiles;
begin
 assign(input, f_in);
 reset(input);
 assign(output, f_out);
 rewrite(output);
end;

procedure CloseFIles;
begin
 close(input);
 close(output);
end;

function RangeControl(X : int) : int;
begin
 RangeControl:= (X+fhl15) mod fhl16 - fhl15;
end;

function ReadCommand : int;
var
 tS : String;
begin
 while not (ch in ['A'..'Z']) do
  Read(ch);
 tS:='';
 while (ch<>' ') and (tS<>'HALT') do
  begin
  tS:=tS+ch;
  Read(ch);
  end;
 if tS='LOAD' then
  ReadCommand:=0
 else if tS='STORE' then
  ReadCommand:=1
 else if tS='ADD' then
  ReadCommand:=2
 else if tS='SUB' then
  ReadCommand:=3
 else if tS='MULT' then
  ReadCommand:=4
 else if tS='DIV' then
  ReadCommand:=5
 else if tS='READ' then
  ReadCommand:=6
 else if tS='WRITE' then
  ReadCommand:=7
 else if tS='JUMP' then
  ReadCommand:=8
 else if tS='JGTZ' then
  ReadCommand:=9
 else if tS='JZERO' then
  ReadCommand:=10
 else if tS='HALT' then
  ReadCommand:=11;
end;

procedure ReadParametr(var Value: int; var D : DataType);
var
 tS : String;
 code : integer;

begin
 Read(ch);
 while ch=' ' do
  Read(ch);
 if ch='=' then
  begin
  D:=Constant;
  Read(ch);
  end
 else if ch='*' then
  begin
  D:=Ref2;
  Read(ch);
  end
 else
  D:=Ref;
 tS:=ch;
 Read(ch);
 while ch in ['0'..'9'] do
  begin
  tS:=tS+ch;
  Read(ch);
  end;
 Val( tS, Value, Code );
end;

procedure Init;
var
 i, j : int;
begin
 fillchar(Command, sizeof(Command), 0);
 fillchar(Mem, sizeof(Mem), 0);
 Readln(N, M);
 Read(ch);
 for i:=0 to N-1 do
 with Command[i] do
  begin
  cType:=ReadCommand;
  if cType<>11 then
   ReadParametr( Data, dType );
  end;
 for i:=1 to M do
  Read(MData[i]);
 NowData:=1;
 NowLine:=0;
end;

function GetVal(const X : Int; const dType : DataTYpe) : int;
begin
 case dType of
 constant:
  GetVal:=X;
 ref:
  GetVal:=Mem[X];
 ref2:
  GetVal:=Mem[Mem[X]];
 end;
end;

procedure Solve;
begin
 while NowLine<=N-1 do
 with Command[NowLine] do
  begin

  case cType of
  0:
   begin
   Mem[0]:=GetVal( data, dType );
   end;
  1 :
   begin
   if dType=ref then
    Mem[data]:=Mem[0]
   else
    Mem[Mem[data]]:=Mem[0];
   end;
  2 :
   begin
   Mem[0]:=RangeControl( Mem[0] + GetVal(data, dType) );
   end;
  3 :
   begin
   Mem[0]:=RangeControl( Mem[0] - GetVal(data, dType) );
   end;
  4 :
   begin
   Mem[0]:=RangeControl( Mem[0] * GetVal(data, dType) );
   end;
  5 :
   begin
   Mem[0]:=RangeControl( Mem[0] div GetVal(data, dType) );
   end;
  6 :
   begin
   if dType=ref then
    Mem[data]:=MData[NowData]
   else
    Mem[Mem[data]]:=MData[NowData];
   inc(NowData);
   end;
  7 :
   begin
   Writeln( GetVal(data, dType) );
   end;
  8 :
   begin
   NowLine:=data; continue;
   end;
  9 :
   begin
   if Mem[0]>0 then
    begin
    NowLine:=data;
    continue;
    end;
   end;
  10 :
   begin
   if Mem[0]=0 then
    begin
    NowLine:=data;
    continue;
    end;
   end;
  11 :
   begin
   Exit;
   end;

  end;
  NowLine:=NowLine+1;

  end;
end;

begin
 OpenFiles;
 Init;
 Solve;
 CloseFiles;
end.
