{$D-,I-,L-,Q-,R-,S-,N+}
program _Blocks;
uses
 SysUtils;
type
 int=longint;
 TPoint = array[1..3] of int;
 {Type 1 - one cube}
 {Type 2 - two cubes}
 {1x, 2y, 3z}
 TBlock = record
  Par, Size : int;
  Cube : array[1..4] of TPoint;
  end;
 Plist = ^TList;
 TList = record
  num : int;
  Next : PList;
  end;

const
 f_in='block.in';
 f_out='block.out';
 TimeLimit=4.5/(24*60*60);
 maxV=50;
 maxXYZ=7;
 maxB=1000;
 maxA=50;
 BlockKol : array[1..12] of int =
   (1,2,3,3,4,4,4,4,4,4,4,4);
 Blocks2 : array[2..2,1..2] of TPoint =
                           (( (1,1,1), (1,2,1) ));
 Blocks3 : array[3..4,1..3] of TPoint =
                 (( (1,1,1), (1,2,1), (1,3,1) ),
                 (  (1,1,1), (1,2,1), (1,1,2) ));
 Blocks4 : array[5..12,1..4] of TPoint =
          (( (1,1,1), (1,2,1), (1,3,1), (1,4,1) ),
           ( (1,1,1), (1,2,1), (1,1,2), (1,2,2) ),
           ( (1,1,1), (1,2,1), (1,1,2), (1,1,3) ),
           ( (1,1,1), (1,2,1), (1,3,1), (1,2,2) ),
           ( (1,2,1), (1,3,1), (1,1,2), (1,2,2) ),
           ( (2,1,1), (1,2,1), (2,2,1), (2,1,2) ),
           ( (1,1,1), (1,2,1), (2,2,1), (1,1,2) ),
           ( (2,2,1), (2,1,2), (1,2,2), (2,2,2) ));

var
 V, K : int;
 Figure : array[1..maxV] of TPoint;
 Start : array[1..maxV] of PList;
 Matr : array[-3..maxXYZ+4, -3..maxXYZ+4, -3..maxXYZ+4] of byte;
 Blocks : array[1..maxB] of TBlock;
 Ans, BestAns : array[1..maxA] of int;
 KolAns, BestKolAns  :int;
 StartTime : Double;
 Optimal : int;

procedure OpenFiles;
begin
 assign(input, f_in);
 reset(input);
 assign(output, f_out);
 rewrite(output);
end;

procedure CloseFIles;
begin
 close(input);
 close(output);
end;

procedure RotateXY(var B : TBlock);
var
 i, x, y, z : int;
begin
 for i:=1 to B.Size do
  with B do
   begin
   x:=Cube[i][1];
   y:=Cube[i][2];
   z:=Cube[i][3];
   Cube[i][1]:=-y;
   Cube[i][2]:= x;
   Cube[i][3]:= z;
   end;
end;

procedure RotateYZ(var B : TBlock);
var
 i, x, y, z : int;
begin
 for i:=1 to B.Size do
  with B do
   begin
   x:=Cube[i][1];
   y:=Cube[i][2];
   z:=Cube[i][3];
   Cube[i][1]:= x;
   Cube[i][2]:=-z;
   Cube[i][3]:= y;
   end;
end;

procedure RotateZX(var B : TBlock);
var
 i, x, y, z : int;
begin
 for i:=1 to B.Size do
  with B do
   begin
   x:=Cube[i][1];
   y:=Cube[i][2];
   z:=Cube[i][3];
   Cube[i][1]:= z;
   Cube[i][2]:= y;
   Cube[i][3]:=-x;
   end;
end;

function PointsEQ(const A, B : TPoint) : boolean;
var
 i : int;
begin
 for i:=1 to 3 do
  if A[i]<>B[i] then
   begin
   PointsEQ:=False;
   Exit;
   end;
 PointsEQ:=True;
end;

function BlocksEQ(const A, B : TBLock) : boolean;
var
 i, j : int;
{ Used : array[1..4] of boolean;}
 find : boolean;

begin
 if A.Size<>B.Size then
  begin
  BlocksEQ:=False;
  Exit;
  end;
{ fillchar(Used, sizeof(Used), false);}
 for i:=1 to A.Size do
  begin
  find:=false;
  for j:=1 to B.Size do
{   if not Used[j] then}
    if PointsEQ( A.Cube[i], B.Cube[j] ) then
     begin
     find:=True;
{     Used[j]:=True;}
     end;
  if not find then
   begin
   BlocksEQ:=False;
   Exit;
   end;
  end;
 BlocksEQ:=True;
end;

procedure AddBlock(var B : TBlock);
var
 i : int;
 find : boolean;

begin
 find:=false;
 for i:=K downto 1 do
  if BlocksEQ(B, Blocks[i]) then
   begin
   find:=True;
   Break;
   end;
 if not find then
  begin
  inc(K);
  Blocks[K]:=B;
  end;
end;

procedure SimpleRotate(var B : TBlock);
begin
  AddBlock(B);
 RotateXY(B);
  AddBlock(B);
 RotateXY(B);
  AddBlock(B);
 RotateXY(B);
  AddBlock(B);
 RotateXY(B);
 RotateYZ(B);
  AddBlock(B);
 RotateYZ(B);
 RotateYZ(B);
  AddBlock(B);
 RotateYZ(B);
end;

procedure Rotate2(var B : TBlock);
var
 i : int;
begin
  for i:=1 to 4 do
   begin
   AddBlock(B);
   RotateZX(B);
   end;
 RotateXY(B);
  for i:=1 to 4 do
   begin
   AddBlock(B);
   RotateYZ(B);
   end;
 RotateXY(B);
  for i:=1 to 4 do
   begin
   AddBlock(B);
   RotateZX(B);
   end;
 RotateXY(B);
  for i:=1 to 4 do
   begin
   AddBlock(B);
   RotateYZ(B);
   end;
 RotateXY(B);
 RotateYZ(B);
  for i:=1 to 4 do
   begin
   AddBlock(B);
   RotateXY(B);
   end;
 RotateYZ(B);
 RotateYZ(B);
  for i:=1 to 4 do
   begin
   AddBlock(B);
   RotateXY(B);
   end;
 RotateYZ(B);
end;

procedure Init;
var
 tB : TBlock;
 i, j, f, c : int;
 First : TPoint;
 p : PList;
 May : boolean;

begin
 StartTime:=Time;

 {Reading data}
 Read(V);
 for i:=1 to V do
  Read( Figure[i][1], Figure[i][2], Figure[i][3]  );
 {}
 K:=1;
 Blocks[1].Par:=1;
 Blocks[1].Size:=1;
 Blocks[1].Cube[1][1]:=0;
 Blocks[1].Cube[1][2]:=0;
 Blocks[1].Cube[1][3]:=0;
 for i:=2 to 12 do
  begin
  tB.Par:=i;
  tB.Size:=BlockKol[i];
  case tB.Size of
  2:
   begin
   for j:=1 to 2 do
    tB.Cube[j]:=Blocks2[i][j];
   end;
  3:
   begin
   for j:=1 to 3 do
    tB.Cube[j]:=Blocks3[i][j];
   end;
  4:
   begin
   for j:=1 to 4 do
    tB.Cube[j]:=Blocks4[i][j];
   end;
  end;
  for f:=1 to tB.Size do
   begin
   First:=tB.Cube[f];
   for j:=1 to tB.Size do
    for c:=1 to 3 do
     tB.Cube[j][c]:=tB.Cube[j][c]-First[c];
   Rotate2(tB);
   end;

  end;
 {}
 fillchar(Matr, sizeof(Matr), 0);
 for i:=1 to V do
  Matr[ Figure[i][1], Figure[i][2], Figure[i][3] ]:=1;
 {}
 for i:=1 to V do {nomer kubika}
  begin
  Start[i]:=nil;
  for j:=1 to K do {nomer povernutogo bloka}
   begin
   May:=True;
   for c:=1 to Blocks[j].Size do {nomer kubika v bloke}
    if MAtr[ Figure[i][1]+Blocks[j].Cube[c][1],
             Figure[i][2]+Blocks[j].Cube[c][2],
             Figure[i][3]+Blocks[j].Cube[c][3] ]=0 then
       begin
       May:=False;
       Break;
       end;
   if May then
    begin {dobavlaem element v spisok}
    new(p);
    p^.num:=j;
    p^.next:=Start[i];
    Start[i]:=p;
    end;
   end;

  end;

end;

procedure WriteAnswer;
var
 i : int;
begin
 Writeln(BestKolAns);
 for i:=1 to BestKolAns do
  Write(BestAns[i],' ');
 Writeln;
{Writeln( ((Time-StartTime)*(26*60*60)) :0:6 );
}
end;

procedure TryBlock(i : int);
var
 p : Plist;
 c, num : int;
 May : boolean;
begin
 if KolAns>BestKolAns then Exit;
 if i=V+1 then
  begin
  if KolAns<BestKolAns then
   begin
   BestKolAns:=KolAns;
   BestAns:=Ans;
   if BestKolAns=Optimal then
    begin
    WriteAnswer;
    CloseFIles;
    Halt(0);
    end;
   end;
  Exit;
  end;
 if Matr[ Figure[i][1], Figure[i][2], Figure[i][3] ]=0 then
  begin
  TryBlock(i+1);
  Exit;
  end;
 if Time-StartTime>TimeLimit then
  begin
  WriteAnswer;
  CloseFIles;
  Halt(0);
  end;
 p:=Start[i];
 while p<>nil do
  begin
  num:=p^.num;
  May:=True;
  for c:=1 to Blocks[num].Size do
   if MAtr[ Figure[i][1]+Blocks[num].Cube[c][1],
            Figure[i][2]+Blocks[num].Cube[c][2],
            Figure[i][3]+Blocks[num].Cube[c][3] ]=0 then
      begin
      May:=False;
      Break;
      end;
  if May then
   begin
   for c:=1 to Blocks[num].Size do
    MAtr[ Figure[i][1]+Blocks[num].Cube[c][1],
          Figure[i][2]+Blocks[num].Cube[c][2],
          Figure[i][3]+Blocks[num].Cube[c][3] ]:=0;
   inc(KolAns);
   Ans[KolAns]:=Blocks[num].par;
   TryBlock(i+1);
   dec(KolAns);
   for c:=1 to Blocks[num].Size do
    MAtr[ Figure[i][1]+Blocks[num].Cube[c][1],
          Figure[i][2]+Blocks[num].Cube[c][2],
          Figure[i][3]+Blocks[num].Cube[c][3] ]:=1;
   end;
  p:=p^.next;
  end;
end;

procedure Solve;
begin
 Optimal:=V div 4;
 if V mod 4 <> 0 then
  Optimal:=Optimal+1;
 {}
 BestKolAns:=maxlongint;
 KolAns:=0;
 TryBlock(1);
 WriteAnswer;
end;

begin
 OpenFiles;
 Init;
 Solve;
 CloseFiles;
end.
