{$D-,I-,L-,Q-,R-,S-,N+}
program _POLYNOM;
const
 f_in='chrom.in';
 f_out='chrom.out';
 maxN=12;
 maxM=100;

type
 int=longint;
 Real = Extended;
 PEdge= ^TEdge;
 TEdge = record
  v : int;
  next : PEdge;
  end;
 TMatrix = array[0..maxN,0..maxN] of Real;
 TVector = array[0..maxN] of Real;

var
 N, M : int;
 First : array[1..maxN] of PEdge;
 B, Ans : TVector;
 Color, Comp : array[1..maxN] of int;
 A, A1 : TMatrix;

procedure OpenFiles;
begin
 assign(input, f_in);
 reset(input);
 assign(output, f_out);
 rewrite(output);
end;

procedure CloseFIles;
begin
 close(input);
 close(output);
end;

function IsEdge(v1, v2 : int) : boolean;
var
 p : PEdge;
begin
 p:=First[v1];
 while p<>nil do
  begin
  if (p^.v=v2) then
   begin
   IsEdge:=True;
   exit;
   end;
  p:=p^.next;
  end;
 IsEdge:=False;
end;

procedure Add(v1, v2 : int);
var
 p : PEdge;
begin
 new(p);
 p^.v:=v2;
 p^.next:=First[v1];
 First[v1]:=p;
end;

procedure Add2(v1, v2 : int);
begin
 if not IsEdge(v1, v2) then Add(v1, v2);
 if not IsEdge(v2, v1) then Add(v2, v1);
end;

procedure Init;
var
 i, j, v1, v2 : Int;
begin
 Read(N, M);
 for i:=1 to N do
  First[i]:=nil;
 for i:=1 to M do
  begin
  Read(v1, v2);
  Add2(v1, v2);
  end;
 fillchar(B, sizeof(B), 0);
end;

procedure Solve;
var
 k, i, cc, tc : int;
 p : Real;
 detA : Real;

procedure Count(i : int);
var
 cl : int;
 q : PEdge;
 Kol : set of 1..maxN;
begin
 if i=N+1 then
  begin
  p:=p+1;
  Exit;
  end;
 if Comp[i]<>tC then
  begin
  Count(i+1);
  Exit;
  end;
 {}
 Kol:=[];
 q:=First[i];
 while q<>nil do
  begin
  if (Color[q^.v]<>0) then
   Kol:=Kol+[ Color[q^.v] ];
  q:=q^.next;
  end;
 {}
 for cl:=1 to k do
  if not (cl in Kol) then
   begin
   Color[i]:=cl;
   Count(i+1);
   end;
 Color[i]:=0;
end;

procedure Dfs(v : int);
var
 p : PEdge;
begin
 if Comp[v]<>0 then exit;
 Comp[v]:=cc;
 p:=First[v];
 while p<>nil do
  begin
  Dfs(p^.v);
  p:=p^.next;
  end;
end;

procedure SwapLines(i,j : int; var A : TMatrix);
var
 tmp : Real;
 x : int;
begin
 for x:=0 to N do
  begin
  tmp:=A[i,x];
  A[i,x]:=A[j,x];
  A[j,x]:=tmp;
  end;
end;

function RealEQ(const a, b : Real) : boolean;
const
 eps=1e-10;
begin
 RealEQ:=abs(a-b)<eps;
end;

procedure LineMinus(i, j : int; k : Extended; var A : TMatrix);
var
 tmp : Real;
 x : int;
begin
 for x:=0 to N do
  begin
  A[i,x]:=A[i,x]-A[j,x]*k;
  end;
end;

function Det(A : TMatrix) : Real;
var
 i, j, mn, find, s : int;
 Ans : Real;
begin
 mn:=1;
 for s:=0 to N-1 do {zanulaem stolbec s}
  begin
  if RealEQ(A[s, s], 0) then
   begin
   mn:=-mn;
   for i:=s+1 to N do
    if not RealEQ(A[i, s],0) then
     begin
     find:=i;
     break;
     end;
   SwapLines(s, find, A);
   end;
  for i:=s+1 to N do
   LineMinus( i, s, A[i,s]/A[s,s], A );
  end;
 Ans:=1;
 for i:=0 to N do
  Ans:=Ans*A[i,i];
 Det:=Ans*mn;
end;

procedure SetColumn(var A : TMatrix; col : int; B : TVector);
var
 x : int;
begin
 for x:=0 to N do
  A[x, col]:=B[x];
end;

function ComputePolynom(const P : TVector; X : Real) : Real;
var
 S, V  : Real;
 i : int;

begin
 V:=1; S:=0;
 for i:=0 to N do
  begin
  S:=S+V*P[i];
  V:=V*X;
  end;
 ComputePolynom:=S;
end;

begin
 fillchar(Comp, sizeof(Comp), 0);
 cc:=0;
 for i:=1 to N do
  if Comp[i]=0 then
   begin
   inc(cc);
   Dfs(i);
   end;

 for k:=1 to N do
  begin
  fillchar(Color, sizeof(Color), 0);

  B[k]:=1;

  for tC:=1 to cc do
   begin
   p:=0;
   Count(1);
   B[k]:=B[k]*p;
   end;

  end;

 for k:=0 to N do
  begin
  A[k, 0]:=1;
  for i:=1 to N do
   A[k, i]:=A[k, i-1]*k;
  end;

 detA:=Det(A);
 {najdem kooficienti}
 for i:=0 to N do
  begin
  A1:=A;
  SetColumn( A1, i, B );
  Ans[i]:=Det(A1)/DetA;
  end;

 Write(N,' ');
 for i:=0 to N do Write( Round(Ans[i]),' ' );
 {
 writeln;
 for i:=0 to N+1 do Write(B[i]:0:0,' ');
 writeln;
 for i:=0 to N+1 do Write((ComputePolynom(Ans, i) ):0:0,' ');
 }
end;

begin
 OpenFiles;
 Init;
 Solve;
 CloseFiles;
end.
