  {$I-,Q-,R-,S-}
const
    maxn=11000;
    maxm=101000;
    inf=1000000000;

type
    list=^Tlist;
    Tlist=record next:list; val,c,num,m1,m2,m3:longint; end;

var n,m,p1,p2,cc:longint;
    a:array[1..maxn] of list;
    link:array[1..maxm*2] of list;
    heap:array[0..maxm*2] of record sum:int64; link:longint; end;
    lnh:array[1..maxm*2] of longint;
    res:array[1..maxn] of int64;

Procedure add(const u,v,c:longint);
var p:list;
begin
    new(p);
    p^.next:=a[u];
    p^.val:=v;
    p^.c:=c;
    p^.m1:=0;
    p^.m2:=0;
    p^.m3:=0;
    inc(cc);
    p^.num:=cc;
    link[cc]:=p;
    a[u]:=p;
end;

Procedure init;
var i,x,y,z:longint;
begin
    assign(input,'customs.in');
    reset(input);
    assign(output,'customs.out');
    rewrite(output);
    read(n,m);
    for i:=1 to m do
    begin
        read(x,y,z);
        add(x,y,z);
        add(y,x,z);
    end;
    read(p1,p2);
end;

Function min(const a,b:int64):int64;
begin
    if a<b then min:=a else min:=b;
end;

Function max(const a,b:int64):int64;
begin
    if a>b then max:=a else max:=b;
end;

Procedure swap(var a,b:longint);
var t:longint;
begin
    t:=a;
    a:=b;
    b:=t;
end;

Procedure swap(var a,b:int64);
var t:int64;
begin
    t:=a;
    a:=b;
    b:=t;
end;

Procedure sift_up(const q:longint);
begin
    if q=1 then exit;
    if heap[q div 2].sum>heap[q].sum then
    begin
        swap(lnh[heap[q div 2].link],lnh[heap[q].link]);
        swap(heap[q div 2].link,heap[q].link);
        swap(heap[q div 2].sum,heap[q].sum);
        sift_up(q div 2);
    end;
end;

Procedure h_insert(const q:longint; const key:int64);
var t:longint;
begin
    inc(heap[0].sum);
    t:=heap[0].sum;
    heap[t].sum:=key;
    heap[t].link:=q;
    lnh[q]:=t;
    sift_up(t);
end;

Procedure relax(const q,c,val:longint; m1,m2,m3:longint);
var t:longint;
begin
    t:=min(min(m1,m2),m3);
    if t=m1 then m1:=max(m1,c) else
    if t=m2 then m2:=max(m2,c) else
    if t=m3 then m3:=max(m3,c);
    if lnh[q]=0 then
    begin
        res[val]:=min(res[val],int64(m1)+int64(m2)+int64(m3));
        h_insert(q,int64(m1)+int64(m2)+int64(m3));
        link[q]^.m1:=m1;
        link[q]^.m2:=m2;
        link[q]^.m3:=m3;
    end else
    begin
        if lnh[q]=inf then exit;
        t:=heap[lnh[q]].sum;
        if t>m1+m2+m3 then
        begin
            res[val]:=min(res[val],int64(m1)+int64(m2)+int64(m3));
            heap[lnh[q]].sum:=int64(m1)+int64(m2)+int64(m3);
            link[q]^.m1:=m1;
            link[q]^.m2:=m2;
            link[q]^.m3:=m3;
            sift_up(lnh[q]);
        end;
    end;
end;

Procedure sift_down(const q:longint);
var lnk:longint;
    t:int64;
begin
    t:=heap[q].sum;
    lnk:=q;
    if q*2<=heap[0].sum then
    if heap[q*2].sum<t then
    begin
        t:=heap[q*2].sum;
        lnk:=q*2;
    end;
    if q*2+1<=heap[0].sum then
    if heap[q*2+1].sum<t then
    begin
        t:=heap[q*2+1].sum;
        lnk:=q*2+1;
    end;
    if lnk<>q then
    begin
        swap(lnh[heap[q].link],lnh[heap[lnk].link]);
        swap(heap[q].sum,heap[lnk].sum);
        swap(heap[q].link,heap[lnk].link);
        sift_down(lnk);
    end;
end;

Procedure h_extract(var buf:list);
begin
    if heap[0].sum=0 then
    begin
        buf:=nil;
        exit;
    end;
    buf:=link[heap[1].link];
    lnh[buf^.num]:=inf;
    heap[1]:=heap[heap[0].sum];
    dec(heap[0].sum);
    sift_down(1);
end;

Procedure solve;
var t,m1,m2,m3,i:longint;
    buf:list;
begin
    for i:=1 to n do res[i]:=int64(inf)*int64(inf);
    res[p1]:=0;
    buf:=a[p1];
    m1:=0; m2:=0; m3:=0;
    while buf<>nil do
    begin
        relax(buf^.num,buf^.c,buf^.val,m1,m2,m3);
        buf:=buf^.next;
    end;
    while true do
    begin
        h_extract(buf);
        if buf=nil then break;
        m1:=buf^.m1;
        m2:=buf^.m2;
        m3:=buf^.m3;
        buf:=a[buf^.val];
        while buf<>nil do
        begin
            relax(buf^.num,buf^.c,buf^.val,m1,m2,m3);
            buf:=buf^.next;
        end;
    end;
end;

Procedure print;
begin
    writeln(res[p2]);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.