  {$I-,Q-,R-,S-}
const
    cmds=['a'..'z','A'..'Z'];
    maxn=34000;

type
    TCmdList=(_amem,_acon,_smem,_scon,_mmem,_mcon,_dmem,_dcon,_omem,_ocon,_rmem,_rcon,_wmem);

var cmd:TCmdList;
    arg,acc:integer;
    mem:array[0..maxn] of integer;
    vis:array[0..maxn] of boolean;

Procedure init;
begin
    assign(input,'indirect.in');
    reset(input);
    assign(output,'indirect.out');
    rewrite(output);
end;

Procedure print(const s:string);
var i:longint;
begin
    writeln(s);
    writeln(acc);
    for i:=1 to 32768 do writeln(mem[i]);
    close(input);
    close(output);
    halt;
end;

Procedure readcmd;
var ch:char;
begin
    read(ch);
    if ch=#26 then print('SUCCESSFUL TERMINATION');
    while not (ch in cmds) do
    begin
        read(ch);
        if ch=#26 then print('SUCCESSFUL TERMINATION');
    end;
    ch:=upcase(ch);
    case ch of
      'A':
        begin
            read(ch);
            if ch='*' then cmd:=_amem else cmd:=_acon;
            read(arg);
        end;
      'S':
        begin
            read(ch);
            if ch='*' then cmd:=_smem else cmd:=_scon;
            read(arg);
        end;
      'M':
        begin
            read(ch);
            if ch='*' then cmd:=_mmem else cmd:=_mcon;
            read(arg);
        end;
      'D':
        begin
            read(ch);
            if ch='*' then cmd:=_dmem else cmd:=_dcon;
            read(arg);
        end;
      'O':
        begin
            read(ch);
            if ch='*' then cmd:=_omem else cmd:=_ocon;
            read(arg);
        end;
      'R':
        begin
            read(ch);
            if ch='*' then cmd:=_rmem else cmd:=_rcon;
            read(arg);
        end;
      'W':
        begin
            read(ch);
            cmd:=_wmem;
            read(arg);
        end;
    end;
end;

Procedure FAmem;
begin
    fillchar(vis,sizeof(vis),0);
    while mem[arg]<0 do
    begin
        vis[arg]:=true;
        arg:=abs(mem[arg]);
        if vis[arg] then print('RUN-TIME ERROR');
    end;
    acc:=mem[arg]+acc;
end;

Procedure FSmem;
begin
    fillchar(vis,sizeof(vis),0);
    while mem[arg]<0 do
    begin
        vis[arg]:=true;
        arg:=abs(mem[arg]);
        if vis[arg] then print('RUN-TIME ERROR');
    end;
    acc:=acc-mem[arg];
end;

Procedure FMmem;
begin
    fillchar(vis,sizeof(vis),0);
    while mem[arg]<0 do
    begin
        vis[arg]:=true;
        arg:=abs(mem[arg]);
        if vis[arg] then print('RUN-TIME ERROR');
    end;
    acc:=acc*mem[arg];
end;

Procedure FDmem;
begin
    fillchar(vis,sizeof(vis),0);
    while mem[arg]<0 do
    begin
        vis[arg]:=true;
        arg:=abs(mem[arg]);
        if vis[arg] then print('RUN-TIME ERROR');
    end;
    if mem[arg]=0 then print('DIVISION BY ZERO');
    acc:=acc div mem[arg];
end;

Procedure FOmem;
begin
    fillchar(vis,sizeof(vis),0);
    while mem[arg]<0 do
    begin
        vis[arg]:=true;
        arg:=abs(mem[arg]);
        if vis[arg] then print('RUN-TIME ERROR');
    end;
    if mem[arg]=0 then print('DIVISION BY ZERO');
    acc:=acc mod mem[arg];
end;

Procedure FRmem;
begin
    fillchar(vis,sizeof(vis),0);
    while mem[arg]<0 do
    begin
        vis[arg]:=true;
        arg:=abs(mem[arg]);
        if vis[arg] then print('RUN-TIME ERROR');
    end;
    acc:=mem[arg];
end;

Procedure FWmem;
begin
    fillchar(vis,sizeof(vis),0);
    while mem[arg]<0 do
    begin
        vis[arg]:=true;
        arg:=abs(mem[arg]);
        if vis[arg] then print('RUN-TIME ERROR');
    end;
    mem[arg]:=acc;
end;

Procedure FAcon;
begin
    acc:=acc+arg;
end;

Procedure FScon;
begin
    acc:=acc-arg;
end;

Procedure FMcon;
begin
    acc:=acc*arg;
end;

Procedure FDcon;
begin
    if arg=0 then print('DIVISION BY ZERO');
    acc:=acc div arg;
end;

Procedure FOcon;
begin
    if arg=0 then print('DIVISION BY ZERO');
    acc:=acc mod arg;
end;

Procedure FRcon;
begin
    acc:=arg;
end;

Procedure docmd;
begin
    case cmd of
      _amem:FAmem;
      _smem:FSmem;
      _mmem:FMmem;
      _dmem:FDmem;
      _omem:FOmem;
      _rmem:FRmem;
      _wmem:FWmem;
      _acon:FAcon;
      _scon:FScon;
      _mcon:FMcon;
      _dcon:FDcon;
      _ocon:FOcon;
      _rcon:FRcon;
    end;
end;

Procedure solve;
begin
    while true do
    begin
        readcmd;
        docmd;
    end;
end;

begin
    init;
    solve;
end.