  {$I-,Q-,R-,S-}
  {$M 60000000}
const
    mn16=['0'..'9','A'..'F','a'..'f'];

var u,v:longint;
    a,res,dep:array[0..1 shl 17] of longint;
    que:array[0..3,0..1 shl 17] of longint;
    used,p,sym,a1,a2:array[0..1 shl 17] of longint;

Procedure read16(var t:longint);
var ch:char;
begin
    read(ch);
    while not (ch in mn16) do read(ch);
    ch:=upcase(ch);
    case ch of
      '0':t:=0;  '1':t:=1;  '2':t:=2;  '3':t:=3;
      '4':t:=4;  '5':t:=5;  '6':t:=6;  '7':t:=7;
      '8':t:=8;  '9':t:=9;  'A':t:=10; 'B':t:=11;
      'C':t:=12; 'D':t:=13; 'E':t:=14; 'F':t:=15;
    end;
    t:=t shl 4;
    read(ch);
    ch:=upcase(ch);
    case ch of
      '0':t:=t+0;  '1':t:=t+1;  '2':t:=t+2;  '3':t:=t+3;
      '4':t:=t+4;  '5':t:=t+5;  '6':t:=t+6;  '7':t:=t+7;
      '8':t:=t+8;  '9':t:=t+9;  'A':t:=t+10; 'B':t:=t+11;
      'C':t:=t+12; 'D':t:=t+13; 'E':t:=t+14; 'F':t:=t+15;
    end;
end;

Procedure init;
var b1,b2,i:longint;
begin
    assign(input,'2instr.in');
    reset(input);
    assign(output,'2instr.out');
    rewrite(output);
    read16(b1);
    read16(b2);
    u:=b1 shl 8 + b2;
    read16(b1);
    read16(b2);
    v:=b1 shl 8 + b2;
    for i:=0 to 65535 do read16(a[i]);
end;

Function bswap(const q:longint):longint;
begin
    bswap:=(q and ((1 shl 8) - 1) shl 8)+(q shr 8);
end;

Function pop(const t:longint):longint;
begin
    pop:=a[(t+1)and((1 shl 16)-1)] shl 8 + a[t];
end;

Function less(q,l,w:longint):boolean;
begin
    a1[0]:=1;
    a1[1]:=l;
    a2[0]:=0;
    while q<>u do
    begin
        inc(a1[0]);
        a1[a1[0]]:=sym[q];
        q:=p[q];
    end;
    while w<>u do
    begin
        inc(a2[0]);
        a2[a2[0]]:=sym[w];
        w:=p[w];
    end;
    while (a1[a1[0]]=a2[a2[0]]) do
    begin
        dec(a1[0]);
        dec(a2[0]);
    end;
    if a1[a1[0]]<a2[a2[0]] then less:=true else less:=false;
end;

Procedure solve;
var i,j,t,tt,cd:longint;
begin
    que[0,0]:=1;
    que[0,1]:=u;
    dep[u]:=1;
    i:=0;
    cd:=1;
    while true do
    begin
        for j:=1 to que[i,0] do
        begin
            t:=que[i,j];
            tt:=pop(t);
            if dep[tt]=0 then
            begin
                dep[tt]:=cd+1;
                inc(que[(i+1) and 3,0]);
                que[(i+1) and 3,que[(i+1) and 3,0]]:=tt;
                p[tt]:=t;
                sym[tt]:=1;
            end else
            if cd+1=dep[tt] then
            begin
                if less(t,1,tt) then
                begin
                    p[tt]:=t;
                    sym[tt]:=1;
                end;
            end;
        end;
        for j:=1 to que[i,0] do
        begin
            t:=que[i,j];
            tt:=bswap(t);
            if dep[tt]=0 then
            begin
                dep[tt]:=cd+2;
                inc(que[(i+2) and 3,0]);
                que[(i+2) and 3,que[(i+2) and 3,0]]:=tt;
                p[tt]:=t;
                sym[tt]:=0;
            end else
            if cd+2=dep[tt] then
            begin
                if less(t,0,tt) then
                begin
                    p[tt]:=t;
                    sym[tt]:=0;
                end;
            end;
        end;
        que[i,0]:=0;
        i:=(i+1) and 3;
        if (que[1,0]=0)and(que[2,0]=0)and(que[3,0]=0)and(que[0,0]=0) then exit;
        inc(cd);
    end;
end;

Procedure print;
var i,num:longint;
begin
    if u=v then
    begin
        writeln(0);
        exit;
    end;
    if dep[v]=0 then
    begin
        writeln('IMPOSSIBLE');
        exit;
    end;
    writeln(dep[v]-1);
    while v<>u do
    begin
        inc(res[0]);
        res[res[0]]:=sym[v];
        v:=p[v];
    end;
    num:=0;
    for i:=res[0] downto 1 do
    begin
        if res[i]=0 then
        begin
            if num=8 then write('  ') else
            if num=16 then
            begin
                writeln;
                num:=0;
            end else if num<>0 then write(' ');
            write('0F');
            inc(num);
            if num=8 then write('  ') else
            if num=16 then
            begin
                writeln;
                num:=0;
            end else if num<>0 then write(' ');
            write('CC');
            inc(num);
        end else
        begin
            if num=8 then write('  ') else
            if num=16 then
            begin
                writeln;
                num:=0;
            end else if num<>0 then write(' ');
            write('5C');
            inc(num);
        end;
    end;
    writeln;
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.
