  {$I-,Q-,R-,S-}
const
    maxm=1100;
    maxn=1100;
    cmds=['A'..'Z','a'..'z'];
    as=['0'..'9','*','='];
    num=['0'..'9'];

type
    TCmdList=(_load,_store,_add,_sub,_mult,_div,_read,_write,_jump,_jgtz,_jzero,_halt);
    TCmd=record
        c:TCmdList;
        t,link:longint;
    end;

var m,n:longint;
    cmd:array[0..maxm] of TCmd;
    reads:array[0..maxn] of longint;
    c:array[0..maxn] of longint;

Function strtoint(const s:string):longint;
var err:integer;
    v:longint;
begin
    val(s,v,err);
    strtoint:=v;
end;

Procedure adda(const c:TCmdList; const q:longint);
var ch:char;
    cc:longint;
    s:string;
begin
    read(ch);
    while not (ch in as) do read(ch);
    if ch='=' then cc:=0 else
    if ch='*' then cc:=2 else cc:=1;
    s:='';
    while not (ch in num) do read(ch);
    while ch in num do
    begin
        s:=s+ch;
        read(ch);
    end;
    cmd[q].c:=c;
    cmd[q].t:=cc;
    cmd[q].link:=strtoint(s);
end;

Procedure readcmd(const q:longint);
var ch:char;
    s:string;
begin
    read(ch);
    while not (ch in cmds) do read(ch);
    s:='';
    while ch in cmds do
    begin
        s:=s+upcase(ch);
        read(ch);
    end;
    if s='LOAD'  then adda(_Load,q)  else
    if s='ADD'   then adda(_Add,q)   else
    if s='SUB'   then adda(_Sub,q)   else
    if s='MULT'  then adda(_Mult,q)  else
    if s='DIV'   then adda(_Div,q)   else
    if s='WRITE' then adda(_Write,q) else
    if s='STORE' then adda(_Store,q) else
    if s='READ'  then adda(_Read,q)  else
    if s='JUMP'  then adda(_Jump,q)  else
    if s='JGTZ'  then adda(_Jgtz,q)  else
    if s='JZERO' then adda(_Jzero,q) else
    if s='HALT'  then Cmd[q].c:=_Halt;
end;

Procedure init;
var i:longint;
begin
    assign(input,'ram.in');
    reset(input);
    assign(output,'ram.out');
    rewrite(output);
    reads[0]:=0;
    readln(m,n);
    for i:=0 to m-1 do readcmd(i);
    for i:=1 to n do read(reads[i]);
end;

Procedure FLoad(var cur:longint);
begin
    case cmd[cur].t of
      0:c[0]:=cmd[cur].link;
      1:c[0]:=c[cmd[cur].link];
      2:c[0]:=c[c[cmd[cur].link]];
    end;
    inc(cur);
end;

Procedure FStore(var cur:longint);
begin
    case cmd[cur].t of
      1:c[cmd[cur].link]:=c[0];
      2:c[c[cmd[cur].link]]:=c[0];
    end;
    inc(cur);
end;

Procedure FAdd(var cur:longint);
begin
    case cmd[cur].t of
      0:c[0]:=c[0]+cmd[cur].link;
      1:c[0]:=c[0]+c[cmd[cur].link];
      2:c[0]:=c[0]+c[c[cmd[cur].link]];
    end;
    inc(cur);
end;

Procedure FSub(var cur:longint);
begin
    case cmd[cur].t of
      0:c[0]:=c[0]-cmd[cur].link;
      1:c[0]:=c[0]-c[cmd[cur].link];
      2:c[0]:=c[0]-c[c[cmd[cur].link]];
    end;
    inc(cur);
end;

Procedure FMult(var cur:longint);
begin
    case cmd[cur].t of
      0:c[0]:=c[0]*cmd[cur].link;
      1:c[0]:=c[0]*c[cmd[cur].link];
      2:c[0]:=c[0]*c[c[cmd[cur].link]];
    end;
    inc(cur);
end;

Procedure FDiv(var cur:longint);
begin
    case cmd[cur].t of
      0:c[0]:=c[0] div cmd[cur].link;
      1:c[0]:=c[0] div c[cmd[cur].link];
      2:c[0]:=c[0] div c[c[cmd[cur].link]];
    end;
    inc(cur);
end;

Procedure FRead(var cur:longint);
begin
    inc(reads[0]);
    case cmd[cur].t of
      1:c[cmd[cur].link]:=reads[reads[0]];
      2:c[c[cmd[cur].link]]:=reads[reads[0]];
    end;
    inc(cur);
end;

Procedure FWrite(var cur:longint);
begin
    case cmd[cur].t of
      0:writeln(cmd[cur].link);
      1:writeln(c[cmd[cur].link]);
      2:writeln(c[c[cmd[cur].link]]);
    end;
    inc(cur);
end;

Procedure FJump(var cur:longint);
begin
    cur:=cmd[cur].link;
end;

Procedure FJgtz(var cur:longint);
begin
    if c[0]>0 then cur:=cmd[cur].link else inc(cur);
end;

Procedure FJzero(var cur:longint);
begin
    if c[0]=0 then cur:=cmd[cur].link else inc(cur);
end;

Procedure solve;
var i,cur:longint;
begin
    cur:=0;
    while true do
    begin
        case cmd[cur].c of
          _Load  :FLoad(cur);
          _Store :FStore(cur);
          _Add   :FAdd(cur);
          _Sub   :FSub(cur);
          _Mult  :FMult(cur);
          _Div   :FDiv(cur);
          _Read  :FRead(cur);
          _Write :FWrite(cur);
          _Jump  :FJump(cur);
          _Jgtz  :FJgtz(cur);
          _Jzero :FJzero(cur);
          _Halt  :exit;
        end;
    end;
end;

begin
    init;
    solve;
    close(input);
    close(output);
end.