  {$I-,Q-,R-,S-}
const
    maxn=3000;
    _eps=1E-7;

type
    TPoint=record x,y:extended; end;
    TLine=record a,b,c:extended; end;
    TSector=record a,b:TPoint; end;

const
    P0:tpoint=(x:0; y:0);

var a,b:array[1..maxn] of TPoint;
    res:extended;
    n:longint;

Procedure init;
var i:longint;
begin
    assign(input,'pipe.in');
    reset(input);
    assign(output,'pipe.out');
    rewrite(output);
    read(n);
    for i:=1 to n do
    begin
        read(a[i].x,a[i].y);
        b[i]:=a[i];
        b[i].y:=b[i].y-1;
    end;
end;

Function getvec(const a,b:TPoint):TPoint;
begin
    GetVec.x:=b.x-a.x;
    GetVec.y:=b.y-a.y;
end;

Function vp(const a,b:TPoint):extended;
begin
    vp:=a.x*b.y-a.y*b.x;
end;

Function less(const a,b:extended):boolean;
begin
    less:=b-a>_eps;
end;

Procedure P2L(const a,b:TPoint; var l:tline);
begin
    l.a:=a.y-b.y;
    l.b:=b.x-a.x;
    l.c:=-(l.a*a.x+l.b*a.y);
end;

Function intersect(const l1,l2:TLine):TPoint;
begin
    intersect.x:=(l1.b*l2.c-l1.c*l2.b)/(l1.a*l2.b-l2.a*l1.b);
    intersect.y:=(l2.c*l1.a-l1.c*l2.a)/(l1.b*l2.a-l2.b*l1.a);
end;

Function eq(const a,b:extended):boolean;
begin
    eq:=abs(a-b)<_eps;
end;

Function eqPoint(const a,b:TPoint):boolean;
begin
    eqPoint:=eq(a.x,b.x) and eq(a.y,b.y);
end;

Function sp(const a,b:TPoint):extended;
begin
    sp:=a.x*b.x+a.y*b.y;
end;

Function inside(const p,a,b:TPoint):boolean;
var v1,v2:TPoint;
begin
    v1:=GetVec(p,a);
    v2:=GetVec(p,b);
    if less(sp(v1,v2),0) then inside:=true else inside:=false;
end;

Function koll(const v1,v2:TPoint):boolean;
begin
    if eq(vp(v1,v2),0) then koll:=true else koll:=false;
end;

Procedure getres(const ss:TSector);
var l1,l2:TLine;
    P,v,v2,vv1,vv2,vv3:TPoint;
    i:longint;
    t:extended;
begin
    P2L(ss.a,ss.b,l1);
    P2L(a[1],b[1],l2);
    P:=Intersect(l1,l2);
    V:=GetVec(p,ss.a);
    if eqpoint(v,P0) then v:=GetVec(p,ss.b);
    if eqPoint(p,a[1]) then
    begin
        v2:=GetVec(a[1],a[2]);
        if (less(vp(v,v2),0))or(eq(vp(v,v2),0)) then exit;
    end;
    if eqpoint(p,b[1]) then
    begin
        v2:=GetVec(b[1],b[2]);
        if less(vp(v2,v),0)or(eq(vp(v,v2),0)) then exit;
    end;
    for i:=1 to n-1 do
    begin
        P2L(a[i],a[i+1],l2);
        if koll(GetVec(a[i],a[i+1]),GetVec(ss.a,ss.b)) then continue;
        p:=intersect(l1,l2);
        if inside(p,a[i],a[i+1]) then
        begin
            if p.x>res then res:=p.x;
            exit;
        end;

        if (eqpoint(p,a[i+1]))and(i<>n-1) then
        begin
            vv1:=GetVec(ss.a,ss.b);
            vv2:=GetVec(a[i+1],a[i]);
            vv3:=GetVec(a[i+1],a[i+2]);
            t:=vp(vv1,vv2)*vp(vv1,vv3);
            if less(t,0) then
            begin
                if p.x>res then res:=p.x;
                exit;
            end;
        end;

        P2L(b[i],b[i+1],l2);
        p:=intersect(l1,l2);
        if inside(p,b[i],b[i+1]) then
        begin
            if p.x>res then res:=p.x;
            exit;
        end;

        if (eqpoint(p,b[i+1]))and(i<>n-1) then
        begin
            vv1:=GetVec(ss.a,ss.b);
            vv2:=GetVec(b[i+1],b[i]);
            vv3:=GetVec(b[i+1],b[i+2]);
            t:=vp(vv1,vv2)*vp(vv1,vv3);
            if less(t,0) then
            begin
                if p.x>res then res:=p.x;
                exit;
            end;
        end;
    end;
    writeln('DELO TRUBA');
    close(input);
    close(output);
    halt;
end;

Procedure look(const s:TSector);
var v1,v2,v,p:TPoint;
    t:extended;
begin
    v1:=GetVec(s.a,a[1]);
    v2:=GetVec(s.a,b[1]);
    v:=GetVec(s.a,s.b);
    t:=vp(v1,v)*vp(v,v2);
    if less(t,0) then exit;
    getres(s);
end;

Procedure solve;
var i,j:longint;
    S:TSector;
begin
    res:=0;
    for i:=1 to n do
    for j:=i+1 to n do
    begin
        s.a:=a[i];
        s.b:=a[j];
        look(s);
        s.a.y:=s.a.y-1;
        look(s);
        s.b.y:=s.b.y-1;
        look(s);
        s.a.y:=s.a.y+1;
        look(s);
    end;
end;

Procedure print;
begin
    writeln(res:0:2);
end;

begin
    init;
    solve;
    print;
    close(input);
    close(output);
end.