  {$I-,Q-,R-,S-}
  {$M 60000000}

uses SysUtils;

const
    maxblock=1100;
    inf=1000000000;
    kk:array[1..12] of longint=(1,2,3,3,4,4,4,4,4,4,4,4);

type
    TPoint=record x,y,z:longint; end;
    TBlock=array[1..5] of TPoint;

const
    qq:array[1..12] of TBlock=(((x:1; y:1; z:1),(),(),(),())
                              ,((x:1; y:1; z:1),(x:1; y:2; z:1),(),(),())
                              ,((x:1; y:1; z:1),(x:1; y:2; z:1),(x:1; y:3; z:1),(),())
                              ,((x:1; y:1; z:1),(x:1; y:2; z:1),(x:1; y:1; z:2),(),())
                              ,((x:1; y:1; z:1),(x:1; y:2; z:1),(x:1; y:3; z:1),(x:1; y:4; z:1),())
                              ,((x:1; y:1; z:1),(x:1; y:2; z:1),(x:1; y:1; z:2),(x:1; y:2; z:2),())
                              ,((x:1; y:1; z:1),(x:1; y:2; z:1),(x:1; y:1; z:2),(x:1; y:1; z:3),())
                              ,((x:1; y:1; z:1),(x:1; y:2; z:1),(x:1; y:3; z:1),(x:1; y:2; z:2),())
                              ,((x:1; y:2; z:1),(x:1; y:3; z:1),(x:1; y:1; z:2),(x:1; y:2; z:2),())
                              ,((x:2; y:1; z:1),(x:1; y:2; z:1),(x:2; y:2; z:1),(x:2; y:1; z:2),())
                              ,((x:1; y:1; z:1),(x:1; y:2; z:1),(x:2; y:2; z:1),(x:1; y:1; z:2),())
                              ,((x:2; y:2; z:1),(x:2; y:1; z:2),(x:1; y:2; z:2),(x:2; y:2; z:2),()));

var nblock,n,ans:longint;
    blocks:array[1..maxblock] of record bl:tblock; k,t:longint; end;
    a:array[-4..10,-4..10,-4..10] of longint;
    res,cur:array[0..50] of longint;
    start,time:extended;

Procedure fix(var block:TBlock; const q,k:longint);
var i,dx,dy,dz:longint;
begin
    dx:=block[q].x;
    dy:=block[q].y;
    dz:=block[q].z;
    for i:=1 to k do
    begin
        dec(block[i].x,dx);
        dec(block[i].y,dy);
        dec(block[i].z,dz);
    end;
end;

Procedure rotate(const k:longint; var block:TBlock; const xyz:longint);
var i,tx,ty,tz:longint;
begin
    case xyz of
      1:
        for i:=1 to k do
        begin
            tx:=block[i].x;
            ty:=-block[i].z;
            tz:=block[i].y;
            block[i].x:=tx;
            block[i].y:=ty;
            block[i].z:=tz;
        end;
      2:
        for i:=1 to k do
        begin
            tx:=-block[i].z;
            ty:=block[i].y;
            tz:=block[i].x;
            block[i].x:=tx;
            block[i].y:=ty;
            block[i].z:=tz;
        end;
      3:
        for i:=1 to k do
        begin
            tx:=-block[i].y;
            ty:=block[i].x;
            tz:=block[i].z;
            block[i].x:=tx;
            block[i].y:=ty;
            block[i].z:=tz;
        end;
    end;
end;

Function eqblocks(const b1,b2:TBlock; const t1,t2,k1,k2:longint):boolean;
var i:longint;
begin
    eqblocks:=false;
    if t1<>t2 then exit;
    if k1<>k2 then exit;
    for i:=1 to k1 do if (b1[i].x<>b2[i].x)or
                         (b1[i].y<>b2[i].y)or
                         (b1[i].z<>b2[i].z) then exit;
    eqblocks:=true;
end;

Procedure addblock(const t,k:longint; const Block:TBlock);
var i:longint;
begin
    for i:=1 to nblock do
    begin
        if eqblocks(blocks[i].bl,block,blocks[i].t,t,blocks[i].k,k) then exit;
    end;
    inc(nblock);
    blocks[nblock].bl:=block;
    blocks[nblock].t:=t;
    blocks[nblock].k:=k;
end;

Procedure add(const t,k:longint; const cur:TBlock);
var i,j,h,t1,t2,qh,qj,qt:longint;
    BL,block:TBlock;
begin
    for i:=1 to k do
    begin
        bl:=cur;
        fix(bl,i,k);
        for j:=1 to 3 do
        for h:=1 to 3 do if (j<>h) then
        begin
            block:=bl;
            for t1:=1 to 4 do
            begin
                rotate(k,block,j);
                for t2:=1 to 4 do
                begin
                    rotate(k,block,h);
                    AddBlock(t,k,block);
                end;
            end;
        end;
    end;
end;

procedure readtypes;
var i,j,t,k:longint;
    cur:TBlock;
begin
    for i:=1 to 12 do
    begin
        t:=i;
        k:=kk[i];
        cur:=qq[i];
        add(t,k,cur);
    end;
end;

Procedure readinput;
var i,x,y,z:longint;
begin
    assign(input,'block.in');
    reset(input);
    assign(output,'block.out');
    rewrite(output);
    read(n);
    for i:=1 to n do
    begin
        read(x,y,z);
        a[x,y,z]:=1;
    end;
end;

Procedure init;
begin
    readtypes;
    readinput;
end;

Function compare(const q,w,e:longint; const bl:TBlock; const k:longint):boolean;
var i:longint;
begin
    compare:=false;
    for i:=1 to k do if a[q+bl[i].x,w+bl[i].y,e+bl[i].z]=0 then exit;
    compare:=true;
end;

Procedure print;
var i:longint;
begin
    writeln(ans);
    for i:=1 to ans do write(res[i],' ');
    close(input);
    close(output);
    halt;
end;

Procedure rec(const dep:longint);
var i,j,h,k,x,y,z,t:longint;
begin
    time:=(now-start)*24*60*60;
    if time>4.5 then print;
    if dep>=ans then exit;
    for i:=1 to 7 do
    for j:=1 to 7 do
    for h:=1 to 7 do if a[i,j,h]=1 then
    begin
        for k:=nblock downto 1 do
        begin
            if compare(i,j,h,blocks[k].bl,blocks[k].k) then
            begin
                for t:=1 to blocks[k].k do a[i+blocks[k].bl[t].x,j+blocks[k].bl[t].y,h+blocks[k].bl[t].z]:=0;
                inc(cur[0]);
                cur[cur[0]]:=blocks[k].t;
                rec(dep+1);
                dec(cur[0]);
                for t:=1 to blocks[k].k do a[i+blocks[k].bl[t].x,j+blocks[k].bl[t].y,h+blocks[k].bl[t].z]:=1;
            end;
        end;
        exit;
    end;
    ans:=dep;
    res:=cur;
end;

Procedure solve;
begin
    ans:=inf;
    rec(0);
end;

begin
    start:=now;
    init;
    solve;
    print;
    close(input);
    close(output);
end.