#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STR_SIZE 256

char* scanline(char*,int);

template <class TElem> class TFen {
  private:
    TElem*data;
    int size;
  public:
    void init(TElem*,int);
    void set(void);
    void add(int,TElem);
    TElem queryone(int);
    TElem querysum(int);
    TElem queryrange(int,int);
};

const int i_bnd=2097152;

int*data; TFen<int>fen;

char*str;
int a,b;

int main(void) {
  #ifndef OFFLINE
  freopen("kitten.in","rt",stdin);
  freopen("kitten.out","wt",stdout);
  #endif
  data=new int[i_bnd];
  fen.init(data,i_bnd);
  memset(data,0,sizeof(int)*i_bnd);
  fen.set();
  str=new char[STR_SIZE];
  while (scanline(str,STR_SIZE)) switch (sscanf(str,"%d%d",&a,&b)) {
    case 1:
      a+=i_bnd>>1;
      if (!fen.queryone(a)) fen.add(a,1);
      break;
    case 2:
      a+=i_bnd>>1; b+=i_bnd>>1;
      if (a>b) { int z=a; a=b; b=z; }
      printf("%d\n",fen.queryrange(a,b));
      break;
  }
  delete[]str;
  delete[]data;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


template <class TElem>
void TFen<TElem>::set(void) {
  int lev,i;
  for (lev=1; lev<size; lev<<=1) for (i=(lev<<1)-1; i<size; i+=lev<<1)
  data[i]+=data[i-lev];
}
template <class TElem>
void TFen<TElem>::add(int i,TElem arg) {
  int lev;
  data[i]+=arg;
  for (lev=1; lev<size; lev<<=1) if (!(i&lev)) data[i|=lev]+=arg;
}
template <class TElem>
TElem TFen<TElem>::queryone(int i) {
  TElem res=data[i];
  int lev;
  for (lev=1; lev<size; lev<<=1) {
    if (!(i&lev)) break;
    res-=data[i^lev];
  }
  return(res);
}
template <class TElem>
TElem TFen<TElem>::querysum(int i) {
  TElem res=data[i];
  int lev;
  for (lev=1; lev<size; lev<<=1) if (i&lev) res+=data[i^lev]; else i|=lev;
  return(res);
}
template <class TElem>
TElem TFen<TElem>::queryrange(int i_from,int i_to) {
  TElem res=querysum(i_to);
  if (--i_from>=0) res-=querysum(i_from);
  return(res);
}

template <class TElem>
void TFen<TElem>::init(TElem*data_,int size_) {
  data=data_; size=size_;
}


char* scanline(char*str,int size) {
  char*p_str; int pos;
  do {
    if (!fgets(str,size,stdin)) return(0);
    for (pos=strlen(str)-1; pos>=0; pos--) {
      if ((str[pos]<0)||(str[pos]>32)) break;
      str[pos]=0;
    }
    for (p_str=str; (*p_str>=0)&&(*p_str<=32); p_str++);
  } while (!*p_str);
  return(p_str);
}


