#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STR_SIZE 32767

#define NUM_SIZE 511
#define NUM_DIG 10000L
#define NUM_FMT_FIRST "%ld"
#define NUM_FMT_NEXT "%04ld"
#define NUM_FMT_LAST "0"

char* scanline(char*,int);

class TNum {
  private:
    long*data;
    int len,size;
  protected:
    void clear(void);
    void update(int);
  public:
    void setup(long*,int);
    void print(void) const;
    TNum& operator=(long);
    TNum& peek(const TNum&,long);
};

int n_strs,*cs_strs_len;
int*lens,bnd;
long*cnts_cont,*p_cnts_cont;
TNum*cnts;

int main(void) {
  #ifndef OFFLINE
  freopen("programs.in","rt",stdin);
  freopen("programs.out","wt",stdout);
  #endif
  int i_str; char*str,*p_str; int len,step;
  scanf("%d",&n_strs);
  lens=new int[n_strs];
  memset(lens,0,sizeof(int)*n_strs);
  str=new char[STR_SIZE];
  for (i_str=0; i_str<n_strs; i_str++) {
    p_str=scanline(str,STR_SIZE);
    for (; *p_str; p_str++) if ((*p_str>32)&&(*p_str<127)) lens[i_str]++;
  }
  delete[]str;
  scanf("%d",&bnd);
  cs_strs_len=new int[bnd+1];
  memset(cs_strs_len,0,sizeof(int)*(bnd+1));
  for (i_str=0; i_str<n_strs; i_str++) if (lens[i_str]<=bnd)
    cs_strs_len[lens[i_str]]++;
  p_cnts_cont=cnts_cont=new long[(bnd+1)*NUM_SIZE]; cnts=new TNum[bnd+1];
  for (len=0; len<=bnd; len++) {
    cnts[len].setup(p_cnts_cont,NUM_SIZE);
    p_cnts_cont+=NUM_SIZE;
  }
  *cnts=1; for (len=1; len<=bnd; len++) cnts[bnd]=0;
  for (len=0; len<bnd; len++) {
    for (step=0; len+step<=bnd; step++) if (cs_strs_len[step]>0)
      cnts[len+step].peek(cnts[len],cs_strs_len[step]);
  }
  cnts[bnd].print(); printf("\n");
  delete[]cnts_cont; delete[]cnts;
  delete[]cs_strs_len;
  delete[]lens;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


TNum& TNum::operator=(long arg) {
  clear();
  if (arg) { *data=arg; len++; }
  return(*this);
}
TNum& TNum::peek(const TNum&arg,long mult) {
  int pos;
  long reg=0;
  for (pos=0; ((pos<len)||(pos<arg.len)||reg)&&(pos<size); pos++) {
    data[pos]+=arg.data[pos]*mult+reg;
    reg=data[pos]/NUM_DIG;
    data[pos]-=reg*NUM_DIG;
  }
  update(pos);
  return(*this);
}

void TNum::clear(void) {
  memset(data,0,sizeof(long)*size); len=0;
}
void TNum::update(int pos) {
  for (len=pos; len>0; len--) if (data[len-1]>0) break;
}

void TNum::print(void) const {
  if (len>0) {
    int pos;
    printf(NUM_FMT_FIRST,data[len-1]);
    for (pos=len-2; pos>=0; pos--) printf(NUM_FMT_NEXT,data[pos]);
  } else printf(NUM_FMT_LAST);
}

void TNum::setup(long*data_,int size_) {
  data=data_; size=size_;
}


char* scanline(char*buf,int size) {
  char*p_buf; int pos;
  do {
    if (!fgets(buf,size,stdin)) return(0);
    for (pos=strlen(buf)-1; pos>=0; pos--) {
      if ((buf[pos]<0)||(buf[pos]>32)) break;
      buf[pos]=0;
    }
    for (p_buf=buf; (*p_buf>0)&&(*p_buf<=32); p_buf++);
  } while (!*p_buf);
  return(p_buf);
}


