#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MEM_SIZE 0x8000

#define CMD_SIZE 255

short reg,*mem;
int*links; char*marks;
int status;

int main(void) {
  #ifndef OFFLINE
  freopen("indirect.in","rt",stdin);
  freopen("indirect.out","wt",stdout);
  #endif
  int addr,to,next; short arg; char*cmd;
  mem=new short[MEM_SIZE]; links=new int[MEM_SIZE]; marks=new char[MEM_SIZE];
  reg=0; memset(mem,0,sizeof(short)*MEM_SIZE);
  memset(links,-1,sizeof(int)*MEM_SIZE);
  memset(marks,0,sizeof(char)*MEM_SIZE);
  status=0;
  cmd=new char[CMD_SIZE];
  while (scanf("%s",cmd)>=1) {
    #ifdef OFFLINE
    if (*cmd==127) break;
    #endif
    if (cmd[1]=='*') {
      sscanf(&cmd[2],"%d",&addr); addr--;
      for (to=addr; links[to]>=0; to=links[to]) {
        if (marks[to]) { status=2; break; }
        marks[to]=1;
      } if (status) break;
      for (; links[addr]>=0; addr=next) {
        next=links[addr];
        links[addr]=to;
        marks[addr]=0;
      }
      arg=mem[addr];
    } else sscanf(&cmd[2],"%hd",&arg);
    switch (*cmd) {
      case 'a': case 'A': reg+=arg; break;
      case 's': case 'S': reg-=arg; break;
      case 'm': case 'M': reg*=arg; break;
      case 'd': case 'D': if (!arg) status=1; else reg/=arg; break;
      case 'o': case 'O': if (!arg) status=1; else reg%=arg; break;
      case 'r': case 'R': reg=arg; break;
      case 'w': case 'W':
        mem[addr]=reg;
        if (reg<0) links[addr]=~(int)reg;
        break;
    } if (status) break;
  }
  switch (status) {
    case 1: printf("DIVISION BY ZERO\n"); break;
    case 2: printf("RUN-TIME ERROR\n"); break;
    default: printf("SUCCESSFUL TERMINATION\n");
  }
  printf("%hd\n",reg);
  for (addr=0; addr<MEM_SIZE; addr++) printf("%hd\n",mem[addr]);
  delete[]cmd;
  delete[]mem; delete[]links; delete[]marks;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


