#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define DATA_SIZE 0x10000

void printdump(unsigned char data) {
  static unsigned int phase=0;
  if (!(phase&0x7U)) {
    if (phase) printf("  ");
    else printf("\n");
  } else printf(" ");
  (++phase)&=0xFU;
  printf("%02hX",data);
}

struct TNode {
  unsigned short from;
  TNode*next;
};

unsigned short source,target;
unsigned short*data,*moves;
TNode*lists_cont,*p_lists_cont,**lists;
char*marks; int*dists; unsigned short*fromps; int*byps;
int*que; unsigned short que_len,que_pos;
int*seq; int seq_len,seq_pos,seq_weight;

int main(void) {
  #ifndef OFFLINE
  freopen("2instr.in","rt",stdin);
  freopen("2instr.out","wt",stdout);
  #endif
  int idx; unsigned short cur,to; int dist; TNode*node;
  scanf("%hX%hX",&source,&target);
  data=new unsigned short[DATA_SIZE];
  for (idx=0; idx<DATA_SIZE; idx++) scanf("%hX",&data[idx]);
  moves=new unsigned short[DATA_SIZE];
  for (cur=0,to=1,idx=0; idx<DATA_SIZE; cur++,to++,idx++)
    moves[idx]=data[cur]|(data[to]<<8);
  p_lists_cont=lists_cont=new TNode[DATA_SIZE]; lists=new TNode*[DATA_SIZE];
  memset(lists,0,sizeof(TNode*)*DATA_SIZE);
  for (cur=0,idx=0; idx<DATA_SIZE; cur++,idx++) {
    to=moves[idx];
    p_lists_cont->from=cur;
    p_lists_cont->next=lists[to];
    lists[to]=p_lists_cont++;
  }
  #ifdef DEBUG
  for (to=1,idx=1; idx<DATA_SIZE; to++,idx++) if (lists[to]) {
    printf("%04hX ",to);
    for (node=lists[to]; node; node=node->next) printf(" %04hX",node->from);
    printf("\n");
  }
  #endif
  marks=new char[DATA_SIZE]; dists=new int[DATA_SIZE];
  fromps=new unsigned short[DATA_SIZE]; byps=new int[DATA_SIZE];
  que=new int[DATA_SIZE];
  memset(marks,0,sizeof(char)*DATA_SIZE);
  for (cur=0,idx=0; idx<DATA_SIZE; cur++,idx++) dists[cur]=(DATA_SIZE<<1)+1;
  memset(byps,-1,sizeof(int)*DATA_SIZE);
  que_len=1; marks[*que=target]=1;
  dists[target]=0; fromps[target]=target; byps[target]=0;
  for (que_pos=0; que_pos!=que_len; que_pos++) {
    marks[cur=que[que_pos]]=0;
      to=(cur>>8)|(cur<<8);
      dist=dists[cur]+4; dist&=~1;
      if (dists[to]>dist) {
        dists[to]=dist; fromps[to]=cur; byps[to]=2;
        if (!marks[to]) marks[que[que_len++]=to]=1;
      }
    for (node=lists[cur]; node; node=node->next) {
      to=node->from;
      dist=dists[cur]+2; dist|=1;
      if (dists[to]>dist) {
        dists[to]=dist; fromps[to]=cur; byps[to]=1;
        if (!marks[to]) marks[que[que_len++]=to]=1;
      }
    }
  }
  delete[]que;
  seq=new int[DATA_SIZE];
  if (byps[source]>=0) {
    seq_len=0; seq_weight=0;
    for (cur=source; byps[cur]>0; cur=fromps[cur])
      seq_weight+=seq[seq_len++]=byps[cur];
  } else seq_weight=-1;
  if (seq_weight>=0) {
    printf("%d",seq_weight);
    for (seq_pos=0; seq_pos<seq_len; seq_pos++) switch (seq[seq_pos]) {
      case 1: printdump(0x5CU); break;
      case 2: printdump(0x0FU); printdump(0xCCU); break;
    } printf("\n");
  } else printf("IMPOSSIBLE\n");
  delete[]seq;
  delete[]marks; delete[]dists; delete[]fromps; delete[]byps;
  delete[]lists_cont; delete[]lists;
  delete[]data; delete[]moves;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


