#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STR_SIZE 15
#define CMD_SIZE 15
#define N_VALUES 0x10000

typedef void cmdfunc(short);
typedef const cmdfunc*cmdgroup[3];

struct TOutput {
  char str[STR_SIZE];
  int len;
};

const int n_regs=1000;

int n_cmds,n_nums,i_cmd;
const cmdfunc**cmds;
short*args,*regs,*nums,*p_nums;
TOutput*outs;

void cmd_load_0(short arg) { *regs=arg; }
void cmd_load_1(short arg) { *regs=regs[arg]; }
void cmd_load_2(short arg) { *regs=regs[regs[arg]]; }
const cmdgroup cmd_load={cmd_load_0,cmd_load_1,cmd_load_2};
void cmd_store_1(short arg) { regs[arg]=*regs; }
void cmd_store_2(short arg) { regs[regs[arg]]=*regs; }
const cmdgroup cmd_store={0,cmd_store_1,cmd_store_2};
void cmd_add_0(short arg) { *regs+=arg; }
void cmd_add_1(short arg) { *regs+=regs[arg]; }
void cmd_add_2(short arg) { *regs+=regs[regs[arg]]; }
const cmdgroup cmd_add={cmd_add_0,cmd_add_1,cmd_add_2};
void cmd_sub_0(short arg) { *regs-=arg; }
void cmd_sub_1(short arg) { *regs-=regs[arg]; }
void cmd_sub_2(short arg) { *regs-=regs[regs[arg]]; }
const cmdgroup cmd_sub={cmd_sub_0,cmd_sub_1,cmd_sub_2};
void cmd_mul_0(short arg) { *regs*=arg; }
void cmd_mul_1(short arg) { *regs*=regs[arg]; }
void cmd_mul_2(short arg) { *regs*=regs[regs[arg]]; }
const cmdgroup cmd_mul={cmd_mul_0,cmd_mul_1,cmd_mul_2};
void cmd_div_0(short arg) { *regs/=arg; }
void cmd_div_1(short arg) { *regs/=regs[arg]; }
void cmd_div_2(short arg) { *regs/=regs[regs[arg]]; }
const cmdgroup cmd_div={cmd_div_0,cmd_div_1,cmd_div_2};
void cmd_read_1(short arg) { regs[arg]=*(p_nums++); }
void cmd_read_2(short arg) { regs[regs[arg]]=*(p_nums++); }
const cmdgroup cmd_read={0,cmd_read_1,cmd_read_2};
void cmd_write_0(short arg) {
  TOutput&out=outs[(unsigned int)(unsigned short)arg];
  fwrite(out.str,out.len,1,stdout);
}
void cmd_write_1(short arg) {
  TOutput&out=outs[(unsigned int)(unsigned short)regs[arg]];
  fwrite(out.str,out.len,1,stdout);
}
void cmd_write_2(short arg) {
  TOutput&out=outs[(unsigned int)(unsigned short)regs[regs[arg]]];
  fwrite(out.str,out.len,1,stdout);
}
const cmdgroup cmd_write={cmd_write_0,cmd_write_1,cmd_write_2};
void cmd_jump(short arg) { (i_cmd=(int)arg)--; }
void cmd_jgtz(short arg) { if (*regs>0) (i_cmd=(int)arg)--; }
void cmd_jzero(short arg) { if (!*regs) (i_cmd=(int)arg)--; }

int main(void) {
  #ifndef OFFLINE
  freopen("ram.in","rt",stdin);
  freopen("ram.out","wt",stdout);
  #endif
  int i_num; short arg; char*cmd,*prm;
  scanf("%d%d",&n_cmds,&n_nums);
  cmds=new const cmdfunc*[n_cmds]; args=new short[n_cmds];
  memset(cmds,0,sizeof(cmdfunc*)*n_cmds);
  cmd=new char[CMD_SIZE]; prm=new char[CMD_SIZE];
  for (i_cmd=0; i_cmd<n_cmds; i_cmd++) {
    scanf("%s",cmd);
    if (!strcasecmp(cmd,"HALT")) continue;
    int lev;
    scanf("%s",prm);
    if (*prm=='=') lev=0; else if (*prm=='*') lev=2; else lev=1;
    sscanf((lev!=1)?(&prm[1]):prm,"%hd",&args[i_cmd]);
    if (!strcasecmp(cmd,"LOAD")) cmds[i_cmd]=cmd_load[lev];
    if (!strcasecmp(cmd,"STORE")) cmds[i_cmd]=cmd_store[lev];
    if (!strcasecmp(cmd,"ADD")) cmds[i_cmd]=cmd_add[lev];
    if (!strcasecmp(cmd,"SUB")) cmds[i_cmd]=cmd_sub[lev];
    if (!strcasecmp(cmd,"MULT")) cmds[i_cmd]=cmd_mul[lev];
    if (!strcasecmp(cmd,"DIV")) cmds[i_cmd]=cmd_div[lev];
    if (!strcasecmp(cmd,"READ")) cmds[i_cmd]=cmd_read[lev];
    if (!strcasecmp(cmd,"WRITE")) cmds[i_cmd]=cmd_write[lev];
    if (!strcasecmp(cmd,"JUMP")) cmds[i_cmd]=cmd_jump;
    if (!strcasecmp(cmd,"JGTZ")) cmds[i_cmd]=cmd_jgtz;
    if (!strcasecmp(cmd,"JZERO")) cmds[i_cmd]=cmd_jzero;
  }
  delete[]cmd; delete[]prm;
  regs=new short[n_regs]; nums=new short[n_nums];
  for (i_num=0; i_num<n_nums; i_num++) scanf("%hd",&nums[i_num]);
  outs=new TOutput[N_VALUES];
  for (arg=0,i_num=0; i_num<N_VALUES; arg++,i_num++) {
    TOutput&out=outs[(unsigned int)(unsigned short)arg];
    sprintf(out.str,"%hd\n",arg);
    out.len=strlen(out.str);
  }
  memset(regs,0,sizeof(short)*n_regs); p_nums=nums;
  for (i_cmd=0; *cmds[i_cmd]; i_cmd++) (*cmds[i_cmd])(args[i_cmd]);
  delete[]outs;
  delete[]regs; delete[]nums;
  delete[]cmds; delete[]args;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


