#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define sqrtl sqrt

struct TPoint {
  long double x,y;
};
struct TLine {
  long double a,b,c;
  long double operator*(const TPoint&) const;
};

int n_pnts;
TPoint*pnts;

long double calcdist(const TLine&line) {
  int i_pnt;
  long double dist=0;
  for (i_pnt=0; i_pnt<n_pnts; i_pnt++) dist+=line*pnts[i_pnt];
  return(dist);
}

long double sum_x_sq,sum_y_sq,sum_xy,sum_x,sum_y,sum_i;
long double coeff_x,coeff_y,coeff_z,base,var_0,var_1;
TLine line_best; long double dist_best;

void checkline(long double a,long double b) {
  TLine line; long double dist;
  line.a=a; line.b=b; line.c=-(sum_x*a+sum_y*b)/sum_i;
  dist=calcdist(line);
  if (dist_best>dist) { line_best=line; dist_best=dist; }
  #ifdef DEBUG
  printf("%Lf %Lf %Lf  %Lf\n",line.a,line.b,line.c,dist);
  #endif
}

int main(void) {
  #ifndef OFFLINE
  freopen("best.in","rt",stdin);
  freopen("best.out","wt",stdout);
  #endif
  int i_pnt;
  scanf("%d",&n_pnts);
  pnts=new TPoint[n_pnts];
  for (i_pnt=0; i_pnt<n_pnts; i_pnt++)
    scanf("%Lf%Lf",&pnts[i_pnt].x,&pnts[i_pnt].y);
  line_best.a=1; line_best.b=0; line_best.c=0;
  dist_best=calcdist(line_best);
  sum_x_sq=0; sum_y_sq=0; sum_xy=0; sum_x=0; sum_y=0;
  for (i_pnt=0; i_pnt<n_pnts; i_pnt++) {
    sum_x_sq+=pnts[i_pnt].x*pnts[i_pnt].x;
    sum_y_sq+=pnts[i_pnt].y*pnts[i_pnt].y;
    sum_xy+=pnts[i_pnt].x*pnts[i_pnt].y;
    sum_x+=pnts[i_pnt].x;
    sum_y+=pnts[i_pnt].y;
  } sum_i=(long double)n_pnts;
  coeff_x=(sum_xy*sum_i-sum_x*sum_y)*2.L;
  coeff_y=(sum_x_sq-sum_y_sq)*sum_i-(sum_x*sum_x-sum_y*sum_y);
  coeff_z=coeff_x*coeff_x+coeff_y*coeff_y;
  if (coeff_z>0) {
    base=coeff_y/sqrtl(coeff_z)/2.L;
    var_0=0.5L+base;
    if (var_0<=0.L) var_0=0.L;
    else if (var_0>=1.L) var_0=1.L;
    else var_0=sqrtl(var_0);
    var_1=0.5L-base;
    if (var_1<=0.L) var_1=0.L;
    else if (var_1>=1.L) var_1=1.L;
    else var_1=sqrtl(var_1);
    checkline(var_0,var_1); checkline(var_1,var_0);
    checkline(-var_0,var_1); checkline(var_1,-var_0);
    checkline(var_0,-var_1); checkline(-var_1,var_0);
    checkline(-var_0,-var_1); checkline(-var_1,-var_0);
  } else checkline(1,0);
  line_best.c=-line_best.c;
  #ifdef DEBUG
  printf("%.6Lf\n%.6Lf %.6Lf %.6Lf\n",dist_best,
    line_best.a,line_best.b,line_best.c);
  #endif
  if (!(line_best.c>=0)) {
    line_best.a=-line_best.a;
    line_best.b=-line_best.b;
    line_best.c=-line_best.c;
  }
  if (!(line_best.c>=0)) line_best.c=0;
  printf("%.6Lf\n%.6Lf %.6Lf %.6Lf\n",dist_best,
    line_best.a,line_best.b,line_best.c);
  delete[]pnts;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


long double TLine::operator*(const TPoint&arg) const {
  long double d=a*arg.x+b*arg.y+c;
  return(d*d);
}


