#include <stdio.h>
#include <stdlib.h>
#include <string.h>

struct TDsuNode {
  int id,rank;
  TDsuNode*parent;
};
class TDsu {
  private:
    TDsuNode*nodes;
    int n_nodes;
  protected:
    TDsuNode* top(TDsuNode*);
  public:
    TDsu(void);
    ~TDsu();
    void Create(void);
    void Delete(void);
    void init(int);
    void reset(void);
    int gettop(int i) { return(top(&nodes[i])->id); }
    int unite(int,int);
};

struct TLine {
  int id;
  long long pos,len;
};

long long n_x,n_y;
int n_segs,n_ids,c_syms,n_lns_cur,n_lns_prev;
int ch_st;
TDsu ids;
TLine*lns_cur,*lns_prev;

int main(void) {
  #ifndef OFFLINE
  freopen("rle.in","rt",stdin);
  freopen("rle.out","wt",stdout);
  #endif
  int i_seg,id,i_ln; int ch; long long y,seg;
  scanf("%lld%lld%d%d",&n_y,&n_x,&ch_st,&n_segs);
  lns_cur=new TLine[n_segs]; lns_prev=new TLine[n_segs];
  ids.init(n_segs);
  n_ids=0; c_syms=0; n_lns_prev=0; n_lns_cur=0; y=0; i_ln=0;
  for (i_seg=0,ch=ch_st; i_seg<n_segs; i_seg++,ch^=1) {
    scanf("%lld",&seg);
    if ((y>0)&&(seg>=n_y-y)) {
      if (ch) {
        id=-1;
        if (i_ln<n_lns_prev) {
          if (lns_prev[i_ln].pos+lns_prev[i_ln].len>=y)
            id=ids.gettop(lns_prev[i_ln].id);
          i_ln++;
        } if (id<0) if (i_ln<n_lns_prev)
          id=ids.gettop(lns_prev[i_ln++].id);
        for (; i_ln<n_lns_prev; i_ln++)
          c_syms-=ids.unite(id,lns_prev[i_ln].id);
        if (id<0) { id=n_ids++; c_syms++; }
        lns_cur[n_lns_cur].id=id;
        lns_cur[n_lns_cur].pos=y;
        lns_cur[n_lns_cur].len=n_y-y;
        n_lns_cur++;
      }
      seg-=n_y-y; y=0;
      { TLine*lns_z=lns_prev; lns_prev=lns_cur; lns_cur=lns_z; }
      n_lns_prev=n_lns_cur; i_ln=0; n_lns_cur=0;
    }
    if (seg>=n_y) {
      if (ch) {
        id=-1;
        if (i_ln<n_lns_prev) id=ids.gettop(lns_prev[i_ln++].id);
        for (; i_ln<n_lns_prev; i_ln++)
          c_syms-=ids.unite(id,lns_prev[i_ln].id);
      }
      seg%=n_y;
      { TLine*lns_z=lns_prev; lns_prev=lns_cur; lns_cur=lns_z; }
      n_lns_prev=n_lns_cur; i_ln=0; n_lns_cur=0;
      if (ch) {
        if (id<0) { id=n_ids++; c_syms++; }
        lns_cur[n_lns_cur].id=id;
        lns_cur[n_lns_cur].pos=0;
        lns_cur[n_lns_cur].len=n_y;
        n_lns_cur++;
      }
    }
    if (seg>0) {
      if (ch) {
        for (id=-1; (i_ln<n_lns_prev)&&(id<0); i_ln++) {
          if (lns_prev[i_ln].pos>y+seg) break;
          if (lns_prev[i_ln].pos+lns_prev[i_ln].len>=y)
            id=ids.gettop(lns_prev[i_ln].id);
        }
        for (; i_ln<n_lns_prev; i_ln++) {
          if (lns_prev[i_ln].pos>y+seg) break;
          c_syms-=ids.unite(id,lns_prev[i_ln].id);
        }
        if (id<0) { id=n_ids++; c_syms++; }
        lns_cur[n_lns_cur].id=id;
        lns_cur[n_lns_cur].pos=y;
        lns_cur[n_lns_cur].len=seg;
        n_lns_cur++;
      }
      y+=seg;
    }
  }
  delete[]lns_cur; delete[]lns_prev;
  printf("%d\n",c_syms);
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


TDsuNode* TDsu::top(TDsuNode*node) {
  TDsuNode*parent,*cur,*next;
  for (parent=node; parent!=parent->parent; parent=parent->parent);
  for (cur=node; cur->parent!=parent; cur=next) {
    next=cur->parent;
    cur->parent=parent;
  }
  return(parent);
}
int TDsu::unite(int i_v,int i_w) {
  TDsuNode*v=top(&nodes[i_v]),*w=top(&nodes[i_w]),*u;
  if (v==w) return(0);
  if (v->rank>=w->rank) u=w->parent=v;
  else u=v->parent=w;
  if (v->rank==w->rank) u->rank++;
  return(1);
}

void TDsu::reset(void) {
  int i_node;
  for (i_node=0; i_node<n_nodes; i_node++) {
    nodes[i_node].id=i_node;
    nodes[i_node].rank=0;
    nodes[i_node].parent=&nodes[i_node];
  }
}

void TDsu::init(int n_nodes_) {
  Delete();
  n_nodes=n_nodes_;
  Create();
  reset();
}

TDsu::TDsu(void) {
  n_nodes=0;
  Create();
}
TDsu::~TDsu() {
  Delete();
}
void TDsu::Create(void) {
  nodes=new TDsuNode[n_nodes];
}
void TDsu::Delete(void) {
  delete[]nodes;
}


