#include <stdio.h>
#include <stdlib.h>
#include <string.h>

int n_ins,n_outs;
long n_masks;
long*devs_cont,**devs;
int f_zero,f_one,f_not,f_logic,f_bail;
long mask_carbon,mask_a,mask_a_n,mask_b,mask_b_n;

void check_unary(void) {
  int i_out; long bit_0,bit_1;
  for (i_out=0; i_out<n_outs; i_out++) {
    bit_0=devs[i_out][mask_carbon|mask_a_n];
    bit_1=devs[i_out][mask_carbon|mask_a];
    if ((bit_0)&&(!bit_1)) if (!f_not) { f_not=1; f_bail=1; }
    if (f_not) {
      if (bit_0==bit_1)
       if ((!f_zero)||(!f_one)) { f_zero=1; f_one=1; f_bail=1; }
    } else {
      if ((!bit_0)&&(!bit_1)) if (!f_zero) { f_zero=1; f_bail=1; }
      if ((bit_0)&&(bit_1)) if (!f_one) { f_one=1; f_bail=1; }
    }
  }
}
void check_binary(void) {
  int i_out; long bit_00,bit_01,bit_10,bit_11; int c_0,c_1;
  for (i_out=0; i_out<n_outs; i_out++) {
    bit_00=devs[i_out][mask_carbon|mask_a_n|mask_b_n];
    bit_01=devs[i_out][mask_carbon|mask_a|mask_b_n];
    bit_10=devs[i_out][mask_carbon|mask_a_n|mask_b];
    bit_11=devs[i_out][mask_carbon|mask_a|mask_b];
    c_0=0; c_1=0;
    if (bit_00) c_1++; else c_0++;
    if (bit_01) c_1++; else c_0++;
    if (bit_10) c_1++; else c_0++;
    if (bit_11) c_1++; else c_0++;
    if ((c_0==1)||(c_1==1)) if (!f_logic) { f_logic=1; f_bail=1; }
  }
}

void rec_unary(int i_in=0,long mask=1L) {
  if (i_in>=n_ins) { check_unary(); return; }
    mask_a^=mask;
    rec_unary(i_in+1,mask<<1);
    mask_a^=mask;
    if (f_bail) return;
  if (f_zero) {
    rec_unary(i_in+1,mask<<1);
    if (f_bail) return;
  }
  if (f_one) {
    mask_carbon^=mask;
    rec_unary(i_in+1,mask<<1);
    mask_carbon^=mask;
    if (f_bail) return;
  }
  if (f_not) {
    mask_a_n^=mask;
    rec_unary(i_in+1,mask<<1);
    mask_a_n^=mask;
    if (f_bail) return;
  }
}
void rec_binary(int i_in=0,long mask=1L) {
  if (i_in>=n_ins) { check_binary(); return; }
    mask_a^=mask;
    rec_binary(i_in+1,mask<<1);
    mask_a^=mask;
    if (f_bail) return;
    mask_b^=mask;
    rec_binary(i_in+1,mask<<1);
    mask_b^=mask;
    if (f_bail) return;
  if (f_zero) {
    rec_binary(i_in+1,mask<<1);
    if (f_bail) return;
  }
  if (f_one) {
    mask_carbon^=mask;
    rec_binary(i_in+1,mask<<1);
    mask_carbon^=mask;
    if (f_bail) return;
  }
  if (f_not) {
    mask_a_n^=mask;
    rec_binary(i_in+1,mask<<1);
    mask_a_n^=mask;
    if (f_bail) return;
    mask_b_n^=mask;
    rec_binary(i_in+1,mask<<1);
    mask_b_n^=mask;
    if (f_bail) return;
  }
}

int main(void) {
  #ifndef OFFLINE
  freopen("unit.in","rt",stdin);
  freopen("unit.out","wt",stdout);
  #endif
  int n_tests,i_test;
  scanf("%d",&n_tests);
  for (i_test=0; i_test<n_tests; i_test++) {
    int i_in,i_out; long i_mask,mask,bit;
    scanf("%d%d",&n_ins,&n_outs);
    n_masks=1L<<n_ins;
    devs_cont=new long[n_outs*n_masks]; devs=new long*[n_outs];
    for (i_out=0,i_mask=0; i_out<n_outs; i_out++,i_mask+=n_masks)
      devs[i_out]=&devs_cont[i_mask];
    memset(devs_cont,0,sizeof(long)*(n_outs*n_masks));
    for (i_mask=0; i_mask<n_masks; i_mask++) {
      mask=0;
      for (i_in=0; i_in<n_ins; i_in++) {
        scanf("%ld",&bit);
        mask|=bit<<i_in;
      }
      for (i_out=0; i_out<n_outs; i_out++) scanf("%ld",&devs[i_out][mask]);
    }
    f_zero=0; f_one=0; f_not=0; f_logic=0;
    mask_carbon=0; mask_a=0; mask_a_n=0; mask_b=0; mask_b_n=0;
    do { f_bail=0; rec_unary(); } while (f_bail);
    do { f_bail=0; rec_binary(); } while (f_bail);
    #ifdef DEBUG
    printf("%d %d %d %d ",f_zero,f_one,f_not,f_logic);
    #endif
    printf("%s\n",(f_not&&f_logic)?"YES":"NO");
    delete[]devs_cont; delete[]devs;
  }
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


