#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define NUM_SIZE 20480
#define NUM_DIG 100000000LL

#define N_PRIMES_BND 32768

class TNum {
  private:
    long long*data;
    int len,size;
  protected:
    void reset(void);
    void update(int);
  public:
    TNum(int);
    ~TNum();
    void print(void) const;
    TNum& operator=(long long);
    TNum& operator*=(long long);
};

int n_primes,n_primes_pure,n_nums;
long*primes,*nums,*rems,*pows;
TNum mult(NUM_SIZE);

#define divide(i_prime,i_num) { \
      for (pow=0; ; pow++) { \
        buf=rems[i_num]/primes[i_prime]; \
        if (rems[i_num]!=buf*primes[i_prime]) break; \
        rems[i_num]=buf; \
      } \
      if (pows[i_prime]<pow) pows[i_prime]=pow; \
}
//      pow++; break;

int main(void) {
  #ifndef OFFLINE
  freopen("lcm.in","rt",stdin);
  freopen("lcm.out","wt",stdout);
  #endif
  int i_prime,i_num,i_num_to; long num,rem_max,pow,buf;
  primes=new long[N_PRIMES_BND];
  n_primes=2; primes[0]=2; primes[1]=3;
  scanf("%d",&n_nums);
  nums=new long[n_nums];
  for (i_num=0; i_num<n_nums; i_num++) scanf("%ld",&nums[i_num]);
  rems=new long[n_nums]; pows=new long[N_PRIMES_BND];
  memset(pows,0,sizeof(long)*N_PRIMES_BND);
  rem_max=1;
  for (i_num=0; i_num<n_nums; i_num++) {
    rems[i_num]=nums[i_num];
    for (i_prime=0; i_prime<n_primes; i_prime++)
      divide(i_prime,i_num);
    if (rem_max<rems[i_num]) rem_max=rems[i_num];
  }
  for (num=primes[n_primes-1]+2; num*num<=rem_max; num+=2) {
    for (i_prime=1; i_prime<n_primes; i_prime++)
      if (!(num%primes[i_prime])) break;
    if (i_prime<n_primes) continue;
    primes[n_primes++]=num;
    rem_max=1;
    for (i_num_to=0; i_num_to<n_nums; i_num_to++) {
      divide(i_prime,i_num_to);
      if (rem_max<rems[i_num_to]) rem_max=rems[i_num_to];
    }
  }
  n_primes_pure=n_primes;
  for (i_num=0; i_num<n_nums; i_num++) {
    if (rems[i_num]>1) {
      primes[i_prime=n_primes++]=rems[i_num];
      for (i_num_to=i_num; i_num_to<n_nums; i_num_to++)
        divide(i_prime,i_num_to);
    }
  }
  #ifdef DEBUG
  printf("%d\n",n_primes);
  for (i_prime=0; i_prime<n_primes; i_prime++) {
    if (i_prime) printf(" ");
    printf("%ld",primes[i_prime]);
  } printf("\n");
  for (i_prime=0; i_prime<n_primes; i_prime++) {
    if (i_prime) printf(" ");
    printf("%ld",pows[i_prime]);
  } printf("\n");
  #endif
  mult=1;
  for (i_prime=0; i_prime<n_primes; i_prime++)
   for (num=0; num<pows[i_prime]; num++)
    mult*=primes[i_prime];
  mult.print(); printf("\n");
  delete[]pows;
  delete[]rems;
  delete[]nums;
  delete[]primes;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


TNum& TNum::operator*=(long long arg) {
  int pos;
  long long reg=0;
  for (pos=0; ((pos<len)||reg)&&(pos<size); pos++) {
    data[pos]=arg*data[pos]+reg;
    reg=data[pos]/NUM_DIG;
    data[pos]-=reg*NUM_DIG;
  }
  //update(pos);
  for (len=pos; len>0; len--) if (data[len-1]) break;
  return(*this);
}

TNum& TNum::operator=(long long arg) {
  reset();
  if (arg) { *data=arg; len++; }
  return(*this);
}

void TNum::reset(void) {
  memset(data,0,sizeof(long long)*size); len=0;
}
void TNum::update(int pos) {
  for (len=pos; len>0; len--) if (data[len-1]) break;
}

void TNum::print(void) const {
  if (len>0) {
    int pos;
    printf("%lld",data[len-1]);
    for (pos=len-2; pos>=0; pos--) printf("%08lld",data[pos]);
  } else printf("0");
}

TNum::TNum(int size_) {
  size=size_;
  data=new long long[size];
}
TNum::~TNum() {
  delete[]data;
}


