#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STR_SIZE 4096

void compprefix(int*prefix,const char*str,int len) {
  int pos,match;
  match=*prefix=0;
  for (pos=1; pos<len; pos++) {
    prefix[pos]=match;
    while (match>0) {
      if (str[pos]==str[match]) break;
      match=prefix[match];
    } if (str[pos]==str[match]) match++;
  } prefix[pos]=match;
}
int countsubs(int*cs_subs,const char*str,const int*prefix,const int*cs_subs_prev,int len) {
  int c_subs_this=0,c_subs_prev;
  int pos,match;
  match=0;
  for (pos=1; pos<len; pos++) {
    while (pos-match<match) match=prefix[match];
    c_subs_prev=cs_subs_prev[pos-match];
    if (c_subs_prev>match) c_subs_prev=match;
    if (*cs_subs<c_subs_prev) *cs_subs=c_subs_prev;
    if (c_subs_this<match) c_subs_this=match;
    if (cs_subs[pos-match]<match) cs_subs[pos-match]=match;
    while (match>0) {
      if (str[pos]==str[match]) break;
      match=prefix[match];
    } if (str[pos]==str[match]) match++;
  } while (pos-match<match) match=prefix[match];
    c_subs_prev=cs_subs_prev[pos-match];
    if (c_subs_prev>match) c_subs_prev=match;
    if (*cs_subs<c_subs_prev) *cs_subs=c_subs_prev;
    if (c_subs_this<match) c_subs_this=match;
    if (cs_subs[pos-match]<match) cs_subs[pos-match]=match;
  #ifdef DEBUG
  printf("%d\n  ",c_subs_this);
  for (pos=0; pos<len; pos++) printf(" %c",str[pos]);
  printf("\n");
  for (pos=0; pos<=len; pos++) printf("%2d",prefix[pos]);
  printf("\n  ");
  for (pos=0; pos<=len; pos++) printf("%2d",cs_subs_prev[pos]);
  printf("\n  ");
  for (pos=0; pos<=len; pos++) printf("%2d",cs_subs[pos]);
  printf("\n");
  #endif
  c_subs_this-=*cs_subs; *cs_subs+=c_subs_this;
  if (c_subs_this<0) return(0);
  return(c_subs_this);
}

char*str;
int len,pos,*prefix;
int c_subs_total,*cs_subs_cur,*cs_subs_prev;

int main(void) {
  #ifndef OFFLINE
  freopen("prof.in","rt",stdin);
  freopen("prof.out","wt",stdout);
  #endif
  str=new char[STR_SIZE];
  scanf("%s",str);
  len=strlen(str);
  prefix=new int[len+1];
  cs_subs_cur=new int[len+1]; cs_subs_prev=new int[len+1];
  memset(cs_subs_cur,0,sizeof(int)*(len+1)); c_subs_total=0;
  for (pos=0; pos<len; pos++) {
    compprefix(&prefix[pos],&str[pos],len-pos);
    memcpy(cs_subs_prev,cs_subs_cur,sizeof(int)*(len+1));
    c_subs_total+=countsubs(&cs_subs_cur[pos],
    &str[pos],&prefix[pos],&cs_subs_prev[pos],len-pos);
  }
  printf("%d\n",c_subs_total);
  delete[]cs_subs_cur; delete[]cs_subs_prev;
  delete[]prefix;
  delete[]str;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


