{$I-,Q-,R-,S-}
const taskid='customs';
      inf=taskid+'.in';
      ouf=taskid+'.out';
      infinity:int64=1000000001;
var v,e,a,b,hlen:longint;
    first,heap,hpos:array [1..10000] of longint;
    w1,w2,w3:array [1..10000] of int64;
    vertex,next,weight:array [1..200000] of longint;
procedure addedge(n,s,f,w:longint);
begin
  vertex[n]:=f;
  next[n]:=first[s];
  weight[n]:=w;
  first[s]:=n;
end;
procedure init;
var i,x,y,z:longint;
begin
  assign(input,inf);
  reset(input);
  read(v,e);
  fillchar(first,sizeof(first),0);
  for i:=1 to e do
  begin
    read(x,y,z);
    addedge(2*i-1,x,y,z);
    addedge(2*i,y,x,z);
  end;
  read(a,b);
  close(input);
end;
procedure swap(x,y:longint);
var t:longint;
begin
  t:=heap[x];
  heap[x]:=heap[y];
  heap[y]:=t;
  hpos[heap[x]]:=x;
  hpos[heap[y]]:=y;
end;
function count(x:longint):int64;
begin
  count:=w1[x]+w2[x]+w3[x];
end;
procedure heapify(x:longint);
var l,r,min:longint;
begin
  l:=x shl 1;
  r:=l or 1;
  min:=x;
  if (l<=hlen) and (count(heap[l])<count(heap[min])) then
    min:=l;
  if (r<=hlen) and (count(heap[r])<count(heap[min])) then
    min:=r;
  if min<>x then
  begin
    swap(min,x);
    heapify(min);
  end;
end;
procedure extract(var x:longint);
begin
  x:=heap[1];
  swap(1,hlen);
  dec(hlen);
  heapify(1);
end;
procedure flow(x:longint);
begin
  while (x>1) and (count(heap[x shr 1])>count(heap[x])) do
  begin
    swap(x,x shr 1);
    x:=x shr 1;
  end;
end;
procedure relax(s,f,w:longint);
var a:array [1..4] of int64;
    i,j,t:longint;
begin
  a[1]:=w1[s];
  a[2]:=w2[s];
  a[3]:=w3[s];
  a[4]:=w;
  for i:=1 to 3 do
    for j:=i+1 to 4 do
      if a[i]>a[j] then
      begin
        t:=a[i];
        a[i]:=a[j];
        a[j]:=t;
      end;
  if a[2]+a[3]+a[4]<count(f) then
  begin
    w1[f]:=a[2];
    w2[f]:=a[3];
    w3[f]:=a[4];
    flow(hpos[f]);
  end;
end;
procedure run;
var i,k,cur:longint;
begin
  for i:=1 to v do
  begin
    w1[i]:=infinity;
    w2[i]:=infinity;
    w3[i]:=infinity;
  end;
  w1[a]:=0;
  w2[a]:=0;
  w3[a]:=0;
  hlen:=v;
  for i:=1 to v do
  begin
    heap[i]:=i;
    hpos[i]:=i;
  end;
  for i:=1 to v do
  begin
    extract(k);
    cur:=first[k];
    while cur<>0 do
    begin
      relax(k,vertex[cur],weight[cur]);
      cur:=next[cur];
    end;
  end;
end;
procedure done;
begin
  assign(output,ouf);
  rewrite(output);
  writeln(w1[b]+w2[b]+w3[b]);
  close(output);
end;
begin
  init;
  run;
  done;
end.
