type
  TCmdKind=(cLoad,cStore,cAdd,cSub,cMult,cDiv,cRead,cWrite,cJump,cJgtz,cJzero,
            cHalt);
  TCmd=record
    Kind: TCmdKind;
    a: Byte;
    x: Integer;
    end;
var
  f: Text;
  Coms: array[0..1000] of TCmd;
  InputA, OutputA: array[1..1000] of Integer;
  M,InputN,OutputN,InputS: Word;
  CP: Word;
  c: array[0..1000] of Integer;

procedure ReadCmd(st: string; const n: Word);
var
  b: Word;
begin
  case st[1] of
    'L':Coms[n].Kind := cLoad;
    'S':case st[2] of
          'T':Coms[n].Kind := cStore;
          'U':Coms[n].Kind := cSub;
        end;
    'A':Coms[n].Kind := cAdd;
    'M':Coms[n].Kind := cMult;
    'D':Coms[n].Kind := cDiv;
    'R':Coms[n].Kind := cRead;
    'W':Coms[n].Kind := cWrite;
    'H':Coms[n].Kind := cHalt;
    'J':case st[2] of
          'U':Coms[n].Kind := cJump;
          'G':Coms[n].Kind := cJgtz;
          'Z':Coms[n].Kind := cJzero;
        end;
  end;

  if Coms[n].Kind<>cHalt then
  begin
    Delete(st,1,pos(' ',st));
    while st[1]=' ' do
      Delete(st,1,1);
    case st[1] of
    '=':begin
          Coms[n].a := 0;
          Delete(st,1,1);
        end;
    '*':begin
          Coms[n].a := 2;
          Delete(st,1,1);
        end
        else
          Coms[n].a := 1;
    end;
    Val(st,Coms[n].x,b);
  end
  else
  begin
    Coms[n].a:=0;
    Coms[n].x:=0;
  end;
end;
procedure ReadData;
var
  i: Word;
  st: string;
begin
  InputS:=1;
  Assign(f,'ram.in');
  Reset(f);
  Readln(f,M,InputN);
  for i:=0 to M-1 do
  begin
    Readln(f,st);
    ReadCmd(st,i);
  end;
  for i:=1 to InputN do
    Read(f,InputA[i]);
  Close(f);
end;

function GetInput: Integer;
var
  i: Word;
  res: Integer;
begin
  i:=Coms[CP].a;
  res:=Coms[CP].x;
  if (Coms[CP].Kind=cRead) or (Coms[CP].Kind=cStore) then
    i:=i-1;
  while i>0 do
  begin
    res:=c[res];
    Dec(i);
  end;
  GetInput:=res;
end;
procedure Solve;
var
  i: LongInt;
  Hlt: Boolean;
begin
  for i:=0 to 1000 do
    c[i]:=0;
  Hlt:=False;
  CP:=0;
  OutputN:=0;
  while not(Hlt) do
    case Coms[CP].Kind of
      cJump: CP:=Coms[CP].x;
      cJgtz: if c[0]>0 then CP:=Coms[CP].x
             else Inc(CP);
      cJzero:if c[0]=0 then CP:=Coms[CP].x
             else Inc(CP);
      cHalt: Hlt:=True
      else
      begin
        i:=GetInput;
        case Coms[CP].Kind of
          cLoad: c[0]:=i;
          cStore:c[i]:=c[0];
          cAdd:  c[0]:=c[0]+i;
          cSub:  c[0]:=c[0]-i;
          cMult: c[0]:=c[0]*i;
          cDiv:  c[0]:=c[0] div i;
          cRead: begin
                   c[i]:=InputA[InputS];
                   Inc(InputS);
                 end;
          cWrite:begin
                   Inc(OutputN);
                   OutputA[OutputN]:=i;
                 end;
        end;
        Inc(CP);
      end;
    end;
end;

procedure WriteData;
var
  i: Word;
begin
  Assign(f,'ram.out');
  Rewrite(f);
  for i:=1 to OutputN do
    Writeln(f,OutputA[i]);
  Close(f);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.