type
  TPoint=record
    X,Y: Extended;
    end;
  TVector=TPoint;
  TSegm=record
    A,B: TPoint;
    end;
  TLine=record
    A,B,C: Extended;
    end;
var
  f: Text;
  N: Word;
  P: array[1..10000] of TPoint;
  Finish: Boolean;
  IntersectPnt: Extended;

procedure ReadData;
var
  i: Word;
begin
  Assign(f,'pipe.in');
  Reset(f);
  Readln(f,N);
  for i:=1 to N do
    Readln(f,P[i].X,P[i].Y);
  Close(f);
end;

function GetVector(const P1,P2: TPoint): TVector;
begin
  GetVector.X:=P2.X-P1.X;
  GetVector.Y:=P2.Y-P1.Y;
end;
function Max(const A,B: Extended): Extended;
begin
  if A>B then Max:=A
  else Max:=B;
end;
function ScalProd(const V1,V2: TVector): Extended;
begin
  ScalProd := V1.X*V2.X+V1.Y*V2.Y;
end;
function VectProd(const V1,V2: TVector): Extended;
begin
  VectProd := V1.X*V2.Y-V1.Y*V2.X;
end;
function TanV(const V1,V2: TVector): Extended;
begin
  TanV := VectProd(V1,V2)/ScalProd(V1,V2);
end;
function Calc(const i: Word): Extended;
var
  V1,V2: TVector;
  A,X,Y: Extended;
begin
  V1:=GetVector(P[i+1],P[i]);
  V2:=GetVector(P[i+1],P[i+2]);
  if Abs(V1.Y)<Abs(V2.Y) then
  begin
    A:=V1.X;
    V1.X:=-V2.X;
    V2.X:=-A;
    A:=V1.Y;
    V1.Y:=V2.Y;
    V2.Y:=A;
  end;

  if VectProd(V2,V1)>=0 then
  begin
    X:=V1.X;
    Y:=V1.Y;
  end
  else
  begin
    X:=V2.X;
    Y:=V2.Y;
  end;
  A := Abs(((-V1.Y+V2.Y)*X)/(-V1.X+V2.X));
  Calc := Abs(Y)-A;
end;
function SegmToLine(const S: TSegm): TLine;
begin
  SegmToLine.A := S.B.Y-S.A.Y;
  SegmToLine.B := S.B.X-S.A.X;
  SegmToLine.C := S.A.Y*(S.B.X-S.A.X) - S.A.X*(S.B.Y-S.A.Y);
end;
function Line2ToPointX(const L1,L2: TLine): Extended;
begin
  Line2ToPointX := (L2.C*L1.B - L1.C*L2.B) / (L1.A*L2.B - L2.A*L1.B);
end;
function IntersectX(const S1,S2: TSegm): Extended;
var
  L1,L2: TLine;
begin
  L1:=SegmToLine(S1);
  L2:=SegmToLine(S2);
  IntersectX:=Line2ToPointX(L1,L2);
end;
procedure GetIntersectPnt(const i: Word; var X: Extended);
var
  V1,V2: TVector;
  A,X1,X2: Extended;
  W,L: TSegm; { W - १ ⥭; L - १  }
begin
  V1:=GetVector(P[i+1],P[i]);
  V2:=GetVector(P[i+1],P[i+2]);
  A:=VectProd(V2,V1);
  if A>=0 then
  begin
    W.A:=P[i];
    W.B:=P[i+1];
    L.A.X:=P[i].X;
    L.A.Y:=P[i].Y-1;
    L.B.X:=P[i+2].X;
    L.B.Y:=P[i+2].Y-1;
  end
  else
  begin
    W.A.X:=P[i].X;
    W.A.Y:=P[i].Y-1;
    W.B.X:=P[i+1].X;
    W.B.Y:=P[i+1].Y-1;
    L.A:=P[i];
    L.B:=P[i+2];
  end;
  X1:=IntersectX(L,W);
  if (X1<=W.A.X) or (X>=W.B.X) then
    X1:=0;
  if A>=0 then
  begin
    W.A.X:=P[i+1].X;
    W.A.Y:=P[i+1].Y-1;
    W.B.X:=P[i+2].X;
    W.B.Y:=P[i+2].Y-1;
    L.A.X:=P[i].X;
    L.A.Y:=P[i].Y-1;
    L.B.X:=P[i+1].X;
    L.B.Y:=P[i+1].Y;
  end
  else
  begin
    W.A:=P[i+1];
    W.B:=P[i+2];
    L.A.X:=P[i].X;
    L.A.Y:=P[i].Y;
    L.B.X:=P[i+1].X;
    L.B.Y:=P[i+1].Y-1;
  end;
  X2:=IntersectX(W,L);
  if (X2<=W.A.X) or (X2>=W.B.X) then
    X2:=0;
  X:=Max(X1,X2);
end;
procedure Solve;
var
  A: Extended;
  i: Word;
begin
  Finish:=False;
  i:=1;
  while (Calc(i)<=1) and (i<(N-2)) do
    Inc(i);
  if Calc(i)<=1 then Finish:=True
  else GetIntersectPnt(i,IntersectPnt);
end;

procedure WriteData;
begin
  Assign(f,'pipe.out');
  Rewrite(f);
  if Finish then Write(f,'DELO TRUBA')
  else Write(f,IntersectPnt:0:2);
  Close(f);
end;

begin
  ReadData;
  Solve;
  WriteData;
end.
