#include <stdio.h>
#include <string.h>
#include <time.h>

#define DBG 2

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define INF (long long)(1e12)

#define MAX_E 200003
#define MAX_V 10003

int tmp, K;
int VN, Fi[MAX_V], Start, End;
int EN, Ne[MAX_E], X[MAX_E], Y[MAX_E];
long long Z[MAX_E];
long long D[4][MAX_V];
int Mark[MAX_V];
int H[MAX_V], HV[MAX_V], HN;

long long max( long long a, long long b )
{
  if (a > b)
    return a;
  return b;
}

void Down( int I )
{
  int min = I, L = I << 1, R = L + 1, tmp;

# if DBG == 1
  printf("DOWN: HV=%d Dk=%Ld\n", I, D[K][H[I]]);
# endif
  if (L < HN && D[K][H[L]] < D[K][H[min]])
    min = L; 
  if (R < HN && D[K][H[R]] < D[K][H[min]])
    min = R; 
  if (min != I)
  {
    SWAP(H[I], H[min], tmp);
    HV[H[I]] = I;
    HV[H[min]] = min;
    Down(min);
  }
}

int GetMin( void )
{
  int res = H[0];

  if (HN == 0)
    return -1;
  H[0] = H[--HN];
  HV[H[0]] = 0;
  Down(0);
  return res;
}

void Up( int I )
{
  int i = 0, tmp;

# if DBG == 1
  printf("UP: %d HV=%d Dk=%Ld\n", I, HV[I], D[K][I]);
# endif
  I = HV[I];
  while (I > 0 && D[K][H[I >> 1]] > D[K][H[I]])
  {
    SWAP(H[I >> 1], H[I], tmp);
    HV[H[I >> 1]] = I >> 1;
    HV[H[I]] = I;
    I >>= 1;
  }
}

void Dijkstra( int k )
{
  int i, minv, e;
  long long min, d, *Dk = D[k], *Dk1 = D[k - 1];

  K = k;
  memset(Mark, 0, sizeof(Mark));
  HN = VN;
  for (i = 0; i < VN; i++)
    Dk[i] = INF, H[i] = i, HV[i] = i;
  Dk[Start] = 0;
  for (i = VN - 1; i >= 0; i--)
    Down(i);
  minv = GetMin(), min = Dk[minv];
# if DBG == 1
  printf("\n(%d)----> minv=%d\n", k, minv);
  for (i = 0; i < VN; i++)
    printf("D[%d]=%Ld ", i, Dk[i]);
  printf("\n");
  for (i = 0; i < HN; i++)
    printf("H[%d]=%d ", i, H[i]);
  printf("\n");
# endif    
  while (minv != -1)
  {
    Mark[minv] = 1;
    for (e = Fi[minv]; e != -1; e = Ne[e])
      if (Dk[Y[e]] > (d = max(Z[e] + Dk1[minv], Dk[minv])))
      { 
#       if DBG == 1
        printf("IF> ");
#       endif    
        Dk[Y[e]] = d;
        Up(Y[e]);
      }
#   if DBG == 1
    printf("\n");
    for (i = 0; i < HN; i++)
      printf("H[%d]=%d ", i, H[i]);
    printf("\n");
#   endif    
    minv = GetMin(), min = Dk[minv];
#   if DBG == 1
    printf("(%d)----> minv=%d\n", k, minv);
    for (i = 0; i < VN; i++)
      printf("D[%d]=%Ld ", i, Dk[i]);
    printf("\n");
    for (i = 0; i < HN; i++)
      printf("H[%d]=%d ", i, H[i]);
    printf("\n");
#   endif    
  }
}

int main( void )
{
  FILE *InF, *OutF;
  int i;
# if DBG == 2
  int t = clock();
# endif

  InF = fopen("customs.in", "rt");
  OutF = fopen("customs.out", "wt");
  fscanf(InF, "%d%d", &VN, &EN);
  EN <<= 1;
  for (i = 0; i < EN; i += 2)
  {
    fscanf(InF, "%d%d%Ld", &X[i], &Y[i], &Z[i]);
    X[i]--, Y[i]--;
    X[i + 1] = Y[i], Y[i + 1] = X[i], Z[i + 1] = Z[i];
  }
  fscanf(InF, "%d%d", &Start, &End), Start--, End--;
  for (i = 0; i < VN; i++)
    Fi[i] = -1;
  for (i = 0; i < EN; i++)
    Ne[i] = Fi[X[i]], Fi[X[i]] = i;
  memset(D, 0, sizeof(D));
# if DBG == 1
  printf("\nV=%d E=%d\n", VN, EN);
  for (i = 0; i < VN; i++)
  {
    printf("%d: ", i);
    for (tmp = Fi[i]; tmp != -1; tmp = Ne[tmp])
      printf("(%d,%d) ", Y[tmp], Z[tmp]);
    printf("\n");
  }
# endif
  for (i = 1; i <= 3; i++)
    Dijkstra(i);
  fprintf(OutF, "%Ld", D[3][End]);
# if DBG == 2
  printf("Time=%d\n", clock() - t);
# endif
  return 0;
}
