#include <stdio.h>
#include <string.h>

#define DBG 0

#define MAX_V 50013
#define MAX_E 50013

#define WHITE 0
#define BLACK 1
#define GRAY  2
#define RED   3

int VN, Fi[MAX_V];
int EN, Ne[MAX_E], X[MAX_E], Y[MAX_E];
int U[MAX_V], Pos[MAX_V], Count;
int Q[MAX_V], QN = 0;

void dfs1( int v )
{
  int e;

  U[v] = 1, Count++;
  for (e = Fi[v]; e != -1; e = Ne[e])
    if (!U[Y[e]])
      dfs1(Y[e]);
}

int dfs2( int v )
{
  int e, n = 0;

  U[v] = GRAY;
  for (e = Fi[v]; e != -1; e = Ne[e])
    if (U[Y[e]] == BLACK)
      return 0;
    else if (U[Y[e]] == GRAY)
    {
      U[Y[e]] = RED;
      n++;
      Pos[Y[e]] = QN;
      Q[QN++] = Y[e];
    }
    else if (U[Y[e]] == RED) 
      if (QN - Pos[Y[e]] > n)
        return 0;
  for (e = Fi[v]; e != -1; e = Ne[e])
    if (U[Y[e]] == WHITE)
      if (!dfs2(Y[e]))
        return 0;
  while (n--)
    U[Q[--QN]] = GRAY;
  U[v] = BLACK;
  Count++;
  return 1;
}

int Solve( void )
{
  int i, v0;

  memset(U, 0, sizeof(U));
  Count = 0;
# if DBG
  printf("--> 0\n");
# endif  
  for (i = 0; i < VN && Count < VN; i++)
    if (!U[i])
      dfs1(i);
# if DBG
  printf("--> 1\n");
# endif  
  if (Count < VN)
    return 0;
  v0 = i - 1;
  memset(U, 0, sizeof(U));
  Count = 0;
# if DBG
  printf("--> 2\n");
# endif  
  if (!dfs2(v0))
    return 0;
# if DBG
  printf("--> 3\n");
# endif  
  if (Count < VN)
    return 0;
  return 1;
}

int main( void )
{
  FILE *InF, *OutF;
  int T, i, j, k;

  InF = fopen("quirks.in", "rt");
  OutF = fopen("quirks.out", "wt");
  fscanf(InF, "%d", &T);
  for (k = 0; k < T; k++)
  {
    fscanf(InF, "%d%d", &VN, &EN);
    for (i = 0; i < EN; i++)
      fscanf(InF, "%d%d", &X[i], &Y[i]), X[i]--, Y[i]--;
    for (i = 0; i < VN; i++)
      Fi[i] = -1;
    for (i = 0; i < EN; i++)
      Ne[i] = Fi[X[i]], Fi[X[i]] = i;
#   if DBG
    printf("\nVN=%d EN=%d\n", VN, EN);
    for (i = 0; i < VN; i++)
    {
      printf("%d: ", i);
      for (j = Fi[i]; j != -1; j = Ne[j])
        printf("%d ", Y[j]);
      printf("\n");
    }
    printf(".End.\n");   
#   endif  
    if (Solve())
      fprintf(OutF, "YES\n");
    else
      fprintf(OutF, "NO\n");
  }
  return 0;
}
