#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define DBG 0

#define MAX 1001
#define LEN 20

char *Name[] = 
{
  "LOAD", "STORE", "ADD", "SUB", "MULT", "DIV", 
  "READ", "WRITE", "JUMP", "JGTZ", "JZERO", "HALT"
};
int ComN = 12;
int Reg[MAX];
int Q[MAX], Pos = 0;
int K, N, IP = 0, Count = 0;
char Com[MAX][LEN], Tmp[LEN];
int Type[MAX], Flag[MAX], Num[MAX];
FILE *InF, *OutF;
int t;

int V( int f, int n )
{
  if (f == 0)
    return Reg[n];
  else if (f == 1)
    return n;
  else 
    return Reg[Reg[n]];
}

void Load( int f, int n )
{
  Reg[0] = V(f, n), IP++;
}

void Store( int f, int n )
{
  if (f == 0)
    Reg[n] = Reg[0];
  else
    Reg[Reg[n]] = Reg[0];
  IP++;
}

void Add( int f, int n )
{
  Reg[0] += V(f, n), IP++;
}

void Sub( int f, int n )
{
  Reg[0] -= V(f, n), IP++;
}

void Mul( int f, int n )
{
  Reg[0] *= V(f, n), IP++;
}

void Div( int f, int n )
{
  Reg[0] /= V(f, n), IP++;
}

void Read( int f, int n )
{
  if (f == 0)
    Reg[n] = Q[Pos++];
  else
    Reg[Reg[n]] = Q[Pos++];
  IP++;
}

void Write( int f, int n )
{
  fprintf(OutF, "%d\n", V(f, n)), IP++;
}

void Jump( int f, int n )
{
  IP = n;
}

void Jgtz( int f, int n )
{
  if (Reg[0] > 0)
    IP = n;
  else
    IP++;
}

void Jzero( int f, int n )
{
  if (Reg[0] == 0)
    IP = n;
  else
    IP++;
}

void Halt( int f, int n )
{
# if DBG == 2
  printf("\nCount=%d\nTime=%d\n", Count, clock() - t);
# endif
  exit(0);
}

typedef void (*func)( int f, int n );
func Func[12] = 
{
  Load, Store, Add, Sub, Mul, Div,
  Read, Write, Jump, Jgtz, Jzero, Halt
};

int main( void )
{
  int i, j, m;

  t = clock();
  memset(Reg, 0, sizeof(Reg));
  InF = fopen("ram.in", "rt");
  OutF = fopen("ram.out", "wt");
  fscanf(InF, "%d%d", &K, &N);
  fgets(Com[0], LEN, InF);
  for (i = 0; i < K; i++)
    fgets(Com[i], LEN, InF);
  for (i = 0; i < N; i++)
    fscanf(InF, "%d", &Q[i]);
  for (i = 0; i < K; i++)
  {
    sscanf(Com[i], "%s", Tmp);
    for (j = 0; j < ComN; j++)
      if (strcmp(Tmp, Name[j]) == 0)
        break;
    Type[i] = j;
    j = 0;
    while (Com[i][j] != '=' && Com[i][j] != '*' && Com[i][j] != '-' && 
           !('0' <= Com[i][j] && Com[i][j] <= '9') && Com[i][j] != '\n')
      j++;
    if (Com[i][j] == '=')
      Flag[i] = 1, j++;
    else if (Com[i][j] == '*')
      Flag[i] = 2, j++;
    else
      Flag[i] = 0;
    if (Com[i][j] == '-')
      m = 1, j++;
    else
      m = 0;
    Num[i] = 0;
    while ('0' <= Com[i][j] && Com[i][j] <= '9')
      Num[i] = Num[i] * 10 + (Com[i][j] - '0'), j++;
    if (m)
      Num[i] = -Num[i];
  }
  while (1)
    Func[Type[IP]](Flag[IP], Num[IP]), Count++;
}
