#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define SQR(X) ((X) * (X))

#define MYPI 3.14159265358979323846

#define MAX 80000

int N, SX = 0, SY = 0, SX2 = 0, SY2 = 0, SXY = 0;
double St[MAX], En[MAX], Step, St2[MAX], D2[MAX];
int Num = 0, Num2;

double GetMin( double a, double b )
{
  return a * a * SX2 + 2 * a * b * SXY + b * b * SY2 - SQR(a * SX + b * SY) / N;
}

double GetC( double *a, double *b )
{
  double n, c;

  c = (*a * SX + *b * SY) / N;
  if (c <= 0)
    *a = -(*a), *b = -(*b), c = -c;
  return c;
}

void QSort( int L, int R )
{
  int i = L, j = R;
  double x, tmp;

  if (L >= R)
    return;
  x = D2[L + (rand() % (R - L + 1))];
  while (i < j)
  {
    while (D2[i] < x)
      i++;
    while (D2[j] > x)
      j--;
    if (i <= j)
    {
      SWAP(St2[i], St2[j], tmp);
      SWAP(D2[i], D2[j], tmp);
      i++, j--;
    }
  }
  QSort(L, j);
  QSort(i, R);
}

int main( void )
{
  FILE *InF, *OutF;
  int i, j, k, x, y;
  double Phi, a, b, c, d;

  srand(3017);
  InF = fopen("best.in", "rt");
  OutF = fopen("best.out", "wt");
  fscanf(InF, "%d", &N);
  for (i = 0; i < N; i++)
  {
    fscanf(InF, "%d%d", &x, &y);
    SX += x, SY += y, SX2 += SQR(x), SY2 += SQR(y), SXY += x * y;
  }
  Num = 1, St[0] = 0, En[0] = 2 * MYPI, Step = 1e-4;
  for (k = 0; k < 5; k++)
  {
    Num2 = 0;
    for (j = 0; j < Num; j++)
      for (Phi = St[j]; Phi < En[j]; Phi += Step)
      { 
        a = -sin(Phi);
        b = cos(Phi);
        D2[Num2] = GetMin(a, b);
        St2[Num2++] = Phi;
      }
    QSort(0, Num2 - 1);
    Num = Num2 / 10;
    for (i = 0; i < Num; i++)
      St[i] = St2[i], En[i] = St[i] + Step;
    Step /= 10.0;
  }
  a = -sin(St[0]);
  b = cos(St[0]);
  d = GetMin(a, b);
  c = GetC(&a, &b);
  fprintf(OutF, "%.8lf\n%.8lf %.8lf %.8lf\n", d, a, b, c);
  return 0;
}
