#include <stdio.h>
#include <string.h>
#include <time.h>

#define DBG 0

#define MAX_PRIME 32000
#define MAX_N 3005
#define MAX_LEN 4000
#define BASE 10000000000
#define LEN 10

int PN = 0, P[MAX_PRIME], Is[MAX_PRIME];
int Num[MAX_PRIME];
int N, A;
long long Res[MAX_LEN + 1], RLen = 1;

void Mult( int k )
{
  int i;

  for (i = 0; i < RLen; i++)
    Res[i] *= k;
  for (i = 0; i < RLen + 2; i++)
    if (Res[i] >= BASE)
    {
      Res[i + 1] += Res[i] / BASE, Res[i] %= BASE; 
      if (i + 2 > RLen)
        RLen = i + 2;
    }
}

int main( void )
{
  FILE *In, *Out;
  int i, j, x;
# if DBG
  int t = clock();
# endif

  memset(Is, 0, sizeof(Is));
  memset(Num, 0, sizeof(Num));
  memset(Res, 0, sizeof(Res));
  Res[0] = 1;
  for (i = 2; i < MAX_PRIME; i++)
    if (!Is[i])
      for (j = i << 1; j < MAX_PRIME; j += i)
        Is[j] = 1;
  for (i = 2; i < MAX_PRIME; i++)
    if (!Is[i])
      P[PN++] = i;
# if DBG
  printf("\nPN = %d\n", PN);
  for (i = 0; i < 25; i++)
    printf("%d ", P[i]);
  printf(" ...\n");
# endif
  In = fopen("lcm.in", "rt");
  Out = fopen("lcm.out", "wt");
  fscanf(In, "%d", &N);
  for (i = 0; i < N; i++)
  {
    fscanf(In, "%d", &A);
    for (j = 0; j < PN; j++)
    {
      x = 0;
      while ((A % P[j]) == 0)
        x++, A /= P[j];
      if (x > Num[j])
        Num[j] = x;
    }
    if (A > 1) 
      Mult(A);
  }
# if DBG
  for (i = 0; i < 50; i++)
    printf("%d ", Num[i]);
  printf(" ...\n");
# endif
  for (i = 0; i < PN; i++)
    for (j = 0; j < Num[i]; j++)
      Mult(P[i]);
  for (i = MAX_LEN; Res[i] == 0; i--)
    ;
# if DBG
  printf("\nN=%d I=%d\n", N, i);
//  for (j = i; j >= 0; j--)
//    printf("%Ld ", Res[j]);
//  printf("\n");
# endif
  fprintf(Out, "%Ld", Res[i]); 
  for (--i; i >= 0; i--)
    fprintf(Out, "%0*Ld", LEN, Res[i]); 
# if DBG
  printf("Time=%d\n", clock() - t);
# endif
  return 0;
}
