#include <stdio.h>
#include <string.h>

#define DBG 0

#define MAX_LEN 3003
#define MAX_NUM 300003 
#define MAX 50000000

char S[MAX_LEN];
int P[MAX_LEN], X[MAX_LEN];
int Max[MAX_LEN];
int WN = 0, PW = 0;
char W[MAX];
int St[MAX_NUM], Len[MAX_NUM];

void Kmp( int Pos )
{
  int i, j, k, x, flag = 1;

  P[Pos] = 0;
  for (i = 1; S[Pos + i] != 0; i++)
  {
    k = i;
    flag = 1;
    while (flag)
    {
      k = P[Pos + k - 1];
      x = k;
      if (S[Pos + i] == S[Pos + k])
        x++;
      flag = (k > 0 && Pos + x > Pos + i - x + 1);
    }
    while (k > 0 && S[Pos + i] != S[Pos + k])
      k = P[Pos + k - 1];
    if (S[Pos + i] == S[Pos + k])
      k++;
    P[Pos + i] = k;
    if (Max[Pos] < k)
      Max[Pos] = k;
  }
}

int Check( char *S1, int L )
{
  int i, j;
  char *S2, *S3;

  for (i = 0; i < WN; i++)
    if (Len[i] == L)
    {
      S3 = S1;
      S2 = W + St[i];
      for (j = 0; j < L; j++)
        if (*S2++ != *S3++)
          break;
      if (j == L)
        break;
    }
  if (i < WN)
    return 0;
  St[WN] = PW; 
  for (i = 0; i < L; i++)
    W[St[WN] + i] = S1[i], PW++;
  Len[WN++] = L;
  return 1;
}

int main( void )
{
  FILE *InF, *OutF;
  int i, j;

  memset(Max, 0, sizeof(Max));
  InF = fopen("prof.in", "rt");
  OutF = fopen("prof.out", "wt");
  fscanf(InF, "%s", S);
  for (i = 0; S[i] != 0; i++)
    Kmp(i);
  for (i = 0; S[i] != 0; i++)
    for (j = 1; j <= Max[i]; j++)
      Check(S + i, j);
  fprintf(OutF, "%d\n", WN);
# if DBG
  printf("%d %d\n", WN, PW);
# endif
  return 0;
}
