program prB;

{$D-,R-,I-,L-,Q-,S-}
uses
  SysUtils;

Const FileIn='pipe.in';
      FileOut='pipe.out';
      MaxN=2000;
      Step=0.001;
      Eps=1e-8;
      Kol=10;

Type Integer=LongInt;
     TPoint=Record X,Y:Extended; End;
     TLine=Record A,B,C:Extended; End;
Var Data:Array[0..MaxN] Of TPoint;
    V:TPoint;
    Pol:TPoint;
    N:Integer;
    Ans:Extended;
procedure Init;
  Var I:Integer;
  Begin
    Read(N);
    For I:=0 To N - 1 Do
      Read(Data[I].X,Data[I].Y);
    Pol.X:=Data[1].X;
    Pol.Y:=Data[1].Y;
    V.X:=Data[1].X - Data[0].X;
    V.Y:=Data[1].Y - Data[0].Y;
    V.Y:=V.Y / V.X;
    V.X:=1;
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Function Vect(P11,P12:TPoint;P21,P22:TPoint):Extended;
  Begin
    Vect:=(P12.X - P11.X)*(P22.Y - P21.Y) -
          (P12.Y - P11.Y)*(P22.X - P21.X);
  End;
Function Scal(P11,P12:TPoint;P21,P22:TPoint):Extended;
  Begin
    Scal:=(P12.X - P11.X)*(P22.X - P21.X) +
          (P12.Y - P11.Y)*(P22.Y - P21.Y);
  End;
Function Dist(P1,P2:TPoint):Extended;
  Begin
    Dist:=Sqrt(Sqr(P1.X - P2.X) + Sqr(P1.Y - P2.Y));
  End;
Function PointPeres(P1,P2:TPoint;PP1,PP2:TPoint):TPoint;
  Var L1,L2:TLine;
      P:TPoint;
      Z:Extended;
  Function GetKoef(P1,P2:TPoint):TLine;
    Var A,B,C:Extended;
        Z:Extended;
    Begin
      A:=P2.Y - P1.Y;
      B:=P1.X - P2.X;
      Z:=Sqrt(Sqr(A) + Sqr(B));
      A:=A / Z; B:=B / Z;
      C:=-(A*P1.X + B*P1.Y);
      GetKoef.A:=A; GetKoef.B:=B; GetKoef.C:=C;
    End;
  Begin
    PointPeres.X:=MaxInt;
    If Vect(PP1,P2,PP1,PP2) * Vect(PP1,P1,PP1,PP2)>Eps Then Exit;
    If Vect(P1,PP1,P1,P2) * Vect(P1,PP2,P1,P2)>Eps Then Exit;
    L1:=GetKoef(P1,P2);
    L2:=GetKoef(PP1,PP2);
    Z:=L1.A * L2.B - L2.A * L1.B;
    If Abs(Z)<Eps Then
      Exit;
    P.X:=(L2.C * L1.B - L1.C * L2.B) / Z;
    P.Y:=(L1.C * L2.A - L2.C * L1.A) / Z;
    PointPeres:=P;
  End;
Function Peres(P1,P2:TPoint):Extended;
  Var P:TPoint;
      PP1,PP2:TPoint;
      I:Integer;
  Begin
    Peres:=MaxInt;
    For I:=0 To N - 2 Do
      Begin
        PP1:=Data[I];
        PP2:=Data[I + 1];
        P:=PointPeres(P1,P2,PP1,PP2);
        If Not (P.X>15000) Then
          Begin
            If Dist(P,PP2)>Eps Then
              If Dist(P,PP1)<Eps Then
                Begin
                  if Vect(P,P2,P,PP2)<-Eps Then
                    Begin
                      Peres:=P.X;
                      Exit;
                    End;
                End
                Else
                Begin
                  Peres:=P.X;
                  Exit;
                End;
          End;
        PP1.Y:=PP1.Y - 1;
        PP2.Y:=PP2.Y - 1;
        P:=PointPeres(P1,P2,PP1,PP2);
        If Not (P.X>15000) Then
          Begin
            If Dist(P,PP2)>Eps Then
              If Dist(P,PP1)<Eps Then
                Begin
                  if Vect(P,P2,P,PP2)>Eps Then
                    Begin
                      Peres:=P.X;
                      Exit;
                    End;
                End
                Else
                Begin
                  Peres:=P.X;
                  Exit;
                End;
          End;
      End;
  End;
Function Max(A,B:Extended):Extended;
  Begin
    If A>B Then Max:=A Else Max:=B;
  End;
Procedure Solve;
  Var P1,P2:TPoint;
      Z:Extended;
      I,J:Integer;
  Begin
    Ans:=Pol.X; P2.X:=Data[N - 1].X;
    Z:=Data[N - 1].X - Data[0].X; P1.X:=Data[0].X;
    For I:=N - 1 DownTo 1 Do
      Begin
        P1.Y:=Data[0].Y;
        For J:=1 To Kol + 1 Do
          Begin
            P2.Y:=P1.Y + (Data[I].Y - Data[0].Y) / (Data[I].X - Data[0].X) * Z;
            Ans:=Max(Ans,Peres(P1,P2));
            If Ans>Data[N - 1].X Then
              Begin
                Write('DELO TRUBA');
                Exit;
              End;
            P1.Y:=P1.Y - 1/Kol;
          End;
        P1.Y:=Data[0].Y;
        For J:=1 To Kol + 1 Do
          Begin
            P2.Y:=P1.Y + (Data[I].Y - Data[0].Y - 1) / (Data[I].X - Data[0].X) * Z;
            Ans:=Max(Ans,Peres(P1,P2));
            If Ans>Data[N - 1].X Then
              Begin
                Write('DELO TRUBA');
                Exit;
              End;
            P1.Y:=P1.Y - 1/Kol;
          End;
      End;
    Write(Ans:0:2);
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles
end.
