program PrA;

{$D-,R-,I-,L-,Q-,S-}
uses
  SysUtils;

Const FileIn='polygon.in';
      FileOut='polygon.out';
      MaxN=300;
      Eps=1e-7;
Type Integer=LongInt;
     TPoint=Record X,Y:Integer; End;
     TPol=Record Last:TPoint; Alpha:Extended; End;
     TMan=Record Chel, Kol : Integer; End;
Var A:Array[1..MaxN,0..MaxN] Of TPol;
    Used:Array[1..MaxN,0..MaxN] Of Boolean;
    B:Array[1..MaxN*MaxN] Of TMan;
    Data:Array[1..MaxN] Of TPoint;
    N:Integer;
procedure Init;
  Var I:Integer;
  Begin
    Read(N);
    For I:=1 To N Do
      Read(Data[I].X,Data[I].Y);
  End;
procedure CloseFiles;
  Begin
    Close(Input);
    Close(Output);
  End;
Function Vect(P11,P12,P21,P22:TPoint):Extended;
  Begin
    Vect:=(P12.X - P11.X)*(P22.Y - P21.Y) - (P12.Y - P11.Y)*(P22.X - P21.X);
  End;
Function Scal(P11,P12,P21,P22:TPoint):Extended;
  Begin
    Scal:=(P12.X - P11.X)*(P22.X - P21.X) + (P12.Y - P11.Y)*(P22.Y - P21.Y);
  End;
Function GetAngle(P1,P2,P3:TPoint):Extended;
  Var F:Extended;
      V,S:Extended;
  Begin
    V:=Vect(P2,P3,P2,P1);
    S:=Scal(P2,P3,P2,P1);
    If (P2.X=6)And(P2.Y=6) Then
      Begin
        V:=V + 1 - 1;
      End;
    If Abs(S)<Eps Then
      Begin
        F:=pi/2;
        If V<-Eps Then F:=-F;
        GetAngle:=F;
        Exit;
      End;
    F:=Arctan(V/S);
    If (S<0)And(V>-Eps) Then
      Begin
        F:=pi - Abs(F);
        GetAngle:=F;
        Exit;
      End;
    If (S<0)And(V<+Eps)Then
      Begin
        F:=F - pi;
        GetAngle:=F;
        Exit;
      End;
    GetAngle:=F;
  End;
procedure OpenFiles;
  Begin
    Assign(Input,FileIn);
    Reset(Input);
    Assign(Output,FileOut);
    Rewrite(Output);
  End;
Function Max(A,B:Integer):Integer;
  Begin
    If A>B Then Max:=A Else Max:=B;
  End;
Procedure Solve;
  Var I,J,K:Integer;
      Lo,Hi:Integer;
      Num,Kol:Integer;
      F:Extended;
      P:TPoint;
      Ans:Integer;
  Begin
    Ans:=0;
    For I:=1 To N Do
      Begin
        For J:=1 To N Do
          For K:=0 To N Do
            A[J,K].Alpha:=MaxInt;
        Lo:=1;Hi:=1;B[1].Chel:=I; B[1].Kol:=0;
        Fillchar(Used,Sizeof(Used),False);
        Used[I,0]:=True;
        Used[I,1]:=True;
        A[I,0].Alpha:=0;
        For J:=1 To N Do
          If Not Used[J,1] Then
            Begin
              Inc(Hi);
              A[J,1].Alpha:=0;
              A[J,1].Last:=Data[I];
              B[Hi].Chel:=J;
              B[Hi].Kol:=1;
              Used[J,1]:=True;
            End;
        While Lo<>Hi Do
          Begin
            Inc(Lo);
            Num:=B[Lo].Chel;
            Kol:=B[Lo].Kol;
            P.X:=2*Data[Num].X - A[Num,Kol].Last.X;
            P.Y:=2*Data[Num].Y - A[Num,Kol].Last.Y;
            For J:=1 To N Do
              If Num<>J Then
                Begin
                  F:=GetAngle(Data[J],Data[Num],P);
                  If F<-Eps Then Continue;
                  If Used[J,Kol + 1] Then
                    Begin
                      If A[J,Kol + 1].Alpha>(A[Num,Kol].Alpha + F) Then
                        Begin
                          A[J,Kol + 1].Alpha:=A[Num,Kol].Alpha + F;
                          A[J,Kol + 1].Last:=Data[Num];
                        End;
                    End
                    Else
                    Begin
                      Used[J,Kol + 1]:=True;
                      A[J,Kol + 1].Alpha:=A[Num,Kol].Alpha + F;
                      A[J,Kol + 1].Last:=Data[Num];
                      Inc(Hi);
                      B[Hi].Chel:=J;
                      B[Hi].Kol:=Kol + 1;
                    End;
                End;
          End;
        For J:=1 To N Do
          If A[I,J].Alpha<2*pi - Eps Then
             Ans:=Max(Ans,J);
      End;
    Write(Ans);
  End;
begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles
end.
