{$I-,Q-,R-,S-}
const probname = 'indirect';
      maxm = 32768;
var mem: array [1..maxm] of longint;
    ak, i: longint;
    s: string;

procedure terminate (const msg: string);
var i: longint;
begin
  writeln (msg);
  writeln (ak);
  for i := 1 to maxm do
    writeln (mem [i]);
  close (output);
  halt (0);
end;

procedure docommand (const comstr: string);
var v: longint;
    c1, c2: char;
    err: integer;
    ec: longint;
begin
  c1 := comstr [1];
  c2 := comstr [2];
  val (copy (comstr, 3, ord (comstr [0]) - 2), v, err);
  if c2 = '=' then
  begin
    case c1 of
    'A':ak := ak + v;
    'S':ak := ak - v;
    'M':ak := ak * v;
    'D':if v = 0 then terminate ('DIVISION BY ZERO') else ak := ak div v;
    'O':if v = 0 then terminate ('DIVISION BY ZERO') else ak := ak mod v;
    'R':ak := v;
    end;
    if ak > 32767 then
    begin
      ak := (ak + 32768) mod 65536 - 32768;
    end else
    if ak < -32768 then
    begin
      ak := -((abs (ak) + 32767) mod 65536 - 32767);
    end;
  end else
  begin
    ec := 0;
    while mem [v] < 0 do
    begin
      inc (ec);
      if ec > maxm then terminate ('RUN-TIME ERROR');
      v := abs (mem [v]);
    end;
    case c1 of
    'A':ak := ak + mem [v];
    'S':ak := ak - mem [v];
    'M':ak := ak * mem [v];
    'D':if mem [v] = 0 then terminate ('DIVISION BY ZERO') else ak := ak div mem [v];
    'O':if mem [v] = 0 then terminate ('DIVISION BY ZERO') else ak := ak mod mem [v];
    'R':ak := mem [v];
    'W':mem [v] := ak;
    end;
    if ak > 32767 then
    begin
      ak := (ak + 32768) mod 65536 - 32768;
    end else
    if ak < -32768 then
    begin
      ak := -((abs (ak) + 32767) mod 65536 - 32767);
    end;
  end;
end;

begin
  assign (input, probname+'.in');
  reset (input);
  assign (output, probname+'.out');
  rewrite (output);
  while not eof (input) do
  begin
    readln (s);
    docommand (s);
  end;
  terminate ('SUCCESSFUL TERMINATION');
  close (input);
  close (output);
end.
