{$I-,Q-,R-,S-}
const probname = '2instr';
      maxn = 65536;
      big = 1000000;

type TVertex = record v, d, k: longint; end;
     TByte = string[2];

var s, s1, s2: string;
    b, e, i, hs, sw, pop: longint;
    r, f, ind: array [0..maxn] of longint;
    h: array [1..maxn] of TVertex;
    p: array [0..maxn, 1..2] of longint;
    prog: array [1..maxn*2] of TByte;
    ans, l, x: longint;

procedure swap (var a, b: longint);
var c: longint;
begin
  c := a;
  a := b;
  b := c;
end;

function bswap_sp (const sp: longint): longint;
var a, b: longint;
begin
  a := sp div 256;
  b := sp mod 256;
  swap (a, b);
  bswap_sp := a * 256 + b;
end;

function pop_sp (const sp: longint): longint;
begin
  pop_sp := r [sp];
end;

function hex_dig (const c: char): longint;
begin
  if c in ['0'..'9'] then hex_dig := ord (c) - 48 else
  hex_dig := ord (c) - ord ('A') + 10;
end;

function hex_dec (const s: string): longint;
var i, d, x: longint;

begin
  d := 1;
  x := 0;
  for i := ord (s [0]) downto 1 do
  begin
    inc (x, hex_dig (s [i]) * d);
    d := d shl 4;
  end;
  hex_dec := x;
end;

procedure swapV (var a, b: TVertex);
var c: TVertex;
begin
  c := a;
  a := b;
  b := c;
end;

procedure siftup (const v: longint);
begin
  if v=1 then exit;
  if h [v].d < h [v shr 1].d then
  begin
    swap (ind [h [v].v], ind [h [v shr 1].v]);
    swapV (h [v], h [v shr 1]);
    siftup (v shr 1);
  end;
end;

procedure siftdown (const v: longint);
var min, w: longint;
begin
  w := v;
  if (v*2 <= hs) and (h [v*2].d < h [w].d) then w := 2*v;
  if (v*2+1 <= hs) and (h [v*2+1].d < h [w].d) then w := 2*v+1;
  if w <> v then
  begin
    swap (ind [h [w].v], ind [h [v].v]);
    swapV (h [w], h [v]);
    siftdown (w);
  end;
end;

procedure extractroot;
begin
  swapV (h [1], h [hs]);
  swap (ind [h [1].v], ind [h [hs].v]);
  dec (hs);
  siftdown (1);
end;

procedure print;
var f, r, i: longint;
begin
  writeln (ans);
  f := ans div 16;
  r := ans mod 16;
  for i := 0 to f-1 do
    writeln (prog [i*16+1], ' ',prog [i*16+2], ' ',
             prog [i*16+3], ' ',prog [i*16+4], ' ',
             prog [i*16+5], ' ',prog [i*16+6], ' ',
             prog [i*16+7], ' ',prog [i*16+8], '  ',
             prog [i*16+9], ' ',prog [i*16+10], ' ',
             prog [i*16+11], ' ',prog [i*16+12], ' ',
             prog [i*16+13], ' ',prog [i*16+14], ' ',
             prog [i*16+15], ' ',prog [i*16+16]);
  if r = 0 then exit;
  write (prog [ans-r+1]);
  if r > 1 then write (' ', prog [ans-r+2]);
  if r > 2 then write (' ', prog [ans-r+3]);
  if r > 3 then write (' ', prog [ans-r+4]);
  if r > 4 then write (' ', prog [ans-r+5]);
  if r > 5 then write (' ', prog [ans-r+6]);
  if r > 6 then write (' ', prog [ans-r+7]);
  if r > 7 then write (' ', prog [ans-r+8]);
  if r > 8 then write ('  ', prog [ans-r+9]);
  if r > 9 then write (' ', prog [ans-r+10]);
  if r > 10 then write (' ', prog [ans-r+11]);
  if r > 11 then write (' ', prog [ans-r+12]);
  if r > 12 then write (' ', prog [ans-r+13]);
  if r > 13 then write (' ', prog [ans-r+14]);
  if r > 14 then write (' ', prog [ans-r+15]);
  writeln;
end;

begin
  assign (input, probname+'.in');
  reset (input);
  assign (output, probname+'.out');
  rewrite (output);
  readln (s);
  s1 := copy (s, 1, 4);
  b := hex_dec (s1);
  s2 := copy (s, 6, 4);
  e := hex_dec (s2);
  for i := 0 to maxn div 16-1 do
  begin
    readln (s);
    r [i * 16] := hex_dec (s [1]+s [2]);
    r [i * 16+1] := hex_dec (s [4]+s [5]);
    r [i * 16+2] := hex_dec (s [7]+s [8]);
    r [i * 16+3] := hex_dec (s [10]+s [11]);
    r [i * 16+4] := hex_dec (s [13]+s [14]);
    r [i * 16+5] := hex_dec (s [16]+s [17]);
    r [i * 16+6] := hex_dec (s [19]+s [20]);
    r [i * 16+7] := hex_dec (s [22]+s [23]);

    r [i * 16+8] := hex_dec (s [26]+s [27]);
    r [i * 16+9] := hex_dec (s [29]+s [30]);
    r [i * 16+10] := hex_dec (s [32]+s [33]);
    r [i * 16+11] := hex_dec (s [35]+s [36]);
    r [i * 16+12] := hex_dec (s [38]+s [39]);
    r [i * 16+13] := hex_dec (s [41]+s [42]);
    r [i * 16+14] := hex_dec (s [44]+s [45]);
    r [i * 16+15] := hex_dec (s [47]+s [48]);
  end;
  r [maxn] := r [0];
  for i := 0 to maxn-1 do
    r [i] := r [i+1] * 256 + r [i];
  for i := 0 to maxn-1 do
  begin
    h [i+1].v := i;
    ind [i] := i+1;
    h [i+1].d := big;
  end;
  hs := 65536;
  h [ind [b]].d := 0;
  siftup (ind [b]);
  fillchar (f, sizeof (f), 0);
  for i := 1 to maxn-1 do
  begin
    f [h [1].v] := 1;
    if f [e] = 1 then break;
    sw := bswap_sp (h [1].v);
    pop := pop_sp (h [1].v);
    if (f [sw] = 0) and (h [ind [sw]].d > h [1].d + 2) then
    begin
      h [ind [sw]].d := h [1].d + 2;
      h [ind [sw]].k := h [1].k + 1;
      p [sw, 1] := h [1].v;
      p [sw, 2] := 2;
      siftup (ind [sw]);
    end;
    if ((f [pop] = 0) and (h [ind [pop]].d > h [1].d + 1)) or
       ((h [ind [pop]].d = h [1].d + 1) and (h [1].k < h [ind [pop]].k)) then
    begin
      h [ind [pop]].d := h [1].d + 1;
      h [ind [pop]].k := h [1].k + 1;
      p [pop, 1] := h [1].v;
      p [pop, 2] := 1;
      siftup (ind [pop]);
    end;
    extractroot;
  end;
  if h [ind [e]].d = big then writeln ('IMPOSSIBLE') else
  begin
    ans := h [ind [e]].d;
    l := ans;
    x := e;
    while x <> b do
    begin
      if p [x, 2] = 1 then
      begin
        prog [l] := '5C';
        dec (l);
      end else
      begin
        prog [l] := 'CC';
        dec (l);
        prog [l] := '0F';
        dec (l);
      end;
      x := p [x, 1];
    end;
    print;
  end;
  close (input);
  close (output);
end.