{$I-,Q-,R-,S-}

const
  MAXN = 1000005;

  Alph = ['-', '0'..'9'];

type
  Integer = Longint;

var
  Exists: array[0..MAXN * 2] of Boolean;
  Fenvik: array[0..MAXN * 2] of Integer;

function ExtInt(var Tmp: String; var k: Integer): Boolean;
var
  s, Count, i, o: Integer;
begin
  if Length(Tmp) = 0 then
  begin
    ExtInt := False;
    Exit;
  end;

  k := 0;
  i := 1;
  while not (Tmp[i] in Alph) and (i <= Length(Tmp)) do Inc(i);

  if i > Length(Tmp) then
  begin
    ExtInt := False;
    Exit;
  end;

  s := i;

  Count := 0;
  while (Tmp[i] in Alph) and (i <= Length(Tmp)) do
  begin
    Inc(i);
    Inc(Count);
  end;

  Val(Copy(Tmp, s, Count), k, o);

  Delete(Tmp, 1, i - 1);

  ExtInt := True;
end;

procedure ReadNums(var Count, k1, k2: Integer);
var
  Str: String;
begin
  k1 := 0;
  k2 := 0;
  Readln(Str);
  Count := 0;
  if ExtInt(Str, k1) then Inc(Count);
  if ExtInt(Str, k2) then Inc(Count);
end;

procedure SwapInt(var a, b: Integer);
var
  t: Integer;
begin
  t := a;
  a := b;
  b := t;
end;

procedure Add(k: Integer);
var
  h: Integer;
begin
  while (k <= 2 * MAXN) do
  begin
    Inc(Fenvik[k]);
    h := (k xor (k - 1)) div 2 + 1;
    k := k + h;
  end;
end;

function Get(k: Integer): Integer;
var
  h, Tmp: Integer;
begin
  Tmp := 0;
  while (k > 0) do
  begin
    Inc(Tmp, Fenvik[k]);
    h := (k xor (k - 1)) div 2 + 1;
    k := k - h;
  end;
  Get := Tmp;
end;

procedure Init();
var
  k1, k2, Count: Integer;
begin
  Assign(Input, 'kitten.in');
  Reset(Input);
  Assign(Output, 'kitten.out');
  Rewrite(Output);

  while not Eof do
  begin
    ReadNums(Count, k1, k2);
    if Count = 2 then
    begin
      Inc(k1, MAXN);
      Inc(k2, MAXN);
      if (k1 > k2) then SwapInt(k1, k2);
      Writeln(Get(k2) - Get(k1 - 1));
    end else
    begin
      Inc(k1, MAXN);

      if not Exists[k1] then
      begin
        Add(k1);
        Exists[k1] := True;
      end;
    end;
  end;
end;

procedure Done();
begin
  Close(Input);
  Close(Output);
end;

begin
  Init();
  Done();
end.
