{$I-,Q-,R-,S-}
{$D-}

const
  MAXN = 10015;

type
  Integer = Longint;

  PList = ^TList;
  TList = record
    k: Integer;
    c: Integer;
    Next: PList;
  end;

  TCost = array[1..3] of Longword;

  THeapNode = record
    c: TCost;
    v: Integer;
  end;

const
  INFINITE: TCost = (1000000015, 1000000015, 1000000015);

var
  n, m, a, b: Integer;
  Links: array[1..MAXN] of PList;
  Heap: array[0..MAXN * 2] of THeapNode;
  Back: array[1..MAXN] of Integer;
  Costs: array[1..MAXN] of TCost;
  NNew: array[1..MAXN] of Boolean;
  Count: Integer;

procedure AddLink(const k1, k2: Integer; const c: Integer);
var
  Tmp: PList;
begin
  New(Tmp);
  Tmp^.k := k2;
  Tmp^.c := c;
  Tmp^.Next := Links[k1];
  Links[k1] := Tmp;
end;

procedure Init();
var
  x, y, z, i: Integer;
begin
  Assign(Input, 'customs.in');
  Reset(Input);
  Assign(Output, 'customs.out');
  Rewrite(Output);

  Read(n, m);
  for i := 1 to m do
  begin
    Read(x, y, z);
    AddLink(x, y, z);
    AddLink(y, x, z);
  end;
  Read(a, b);
end;

function More(const n1, n2: TCost): Boolean;
begin
  More := (n1[1] + n1[2] + n1[3] > n2[1] + n2[2] + n2[3]);
end;

procedure SwapInt(var a, b: Integer);
var
  t: Integer;
begin
  t := a;
  a := b;
  b := t;
end;

procedure SwapHeap(const k1, k2: Integer);
var
  Tmp: THeapNode;
begin
  Back[Heap[k1].v] := k2;
  Back[Heap[k2].v] := k1;

  Tmp := Heap[k1];
  Heap[k1] := Heap[k2];
  Heap[k2] := Tmp;
end;

procedure HeapUp(k: Integer);
begin
  while k > 1 do
  begin
    if More(Heap[k div 2].c, Heap[k].c) then
    begin
      SwapHeap(k div 2, k);
      k := k div 2;
    end else Break;
  end;
end;

procedure HeapDown(const k: Integer);
var
  Min: Integer;
begin
  Min := k;
  if (k * 2  <= Count) then
    if More(Heap[Min].c, Heap[k * 2].c) then Min := k * 2;
  if (k * 2 + 1  <= Count) then
    if More(Heap[Min].c, Heap[k * 2 + 1].c) then Min := k * 2 + 1;

  if k <> Min then
  begin
    SwapHeap(k, Min);
    HeapDown(Min);
  end;
end;

procedure SwapLong(var a, b: Longword);
var
  t: Longword;
begin
  t := a;
  a := b;
  b := t;
end;

procedure AddHeap(const Node: THeapNode);
begin
  Inc(Count);
  Heap[Count] := Node;
  Back[Node.v] := Count;
  HeapUp(Count);
  HeapDown(Back[Node.v]);
end;

procedure SortCost(var Cost: TCost);
begin
  if Cost[2] > Cost[3] then SwapLong(Cost[2], Cost[3]);
  if Cost[1] > Cost[2] then SwapLong(Cost[1], Cost[2]);
  if Cost[2] > Cost[3] then SwapLong(Cost[2], Cost[3]);
end;

procedure ExtractMin();
begin
  SwapHeap(1, Count);
  Dec(Count);
  HeapDown(1);
end;

procedure Solve();
var
  Cur: PList;
  Tmp, MinNode: THeapNode;
  Cost: TCost;
  i: Integer;
begin
  NNew[a] := True;
  Cur := Links[a];
  while (Cur <> nil) do
  begin
    Fillchar(Tmp, Sizeof(Tmp), 0);
    Tmp.c[3] := Cur^.c;
    Tmp.v := Cur^.k;
    AddHeap(Tmp);

    Cur := Cur^.Next;
  end;

  for i := 1 to n do
    if (Back[i] = 0) and (i <> a) then
    begin
      Tmp.c := INFINITE;
      Tmp.v := i;
      AddHeap(Tmp);
    end;

  while not NNew[b] do
  begin
    MinNode := Heap[1];
    ExtractMin();
    Costs[MinNode.v] := MinNode.c;
    NNew[MinNode.v] := True;

    Cur := Links[MinNode.v];
    while (Cur <> nil) do
    begin
      if not NNew[Cur^.k] then
      begin
        Cost := MinNode.c;
        if Cur^.c > Cost[1] then
        begin
          Cost[1] := Cur^.c;
          SortCost(Cost);
        end;

        if More(Heap[Back[Cur^.k]].c, Cost) then
        begin
          Heap[Back[Cur^.k]].c := Cost;
          HeapUp(Back[Cur^.k]);
        end;
      end;

      Cur := Cur^.Next;
    end;
  end;
end;

procedure Done();
begin
  Writeln(Costs[b][1] + Costs[b][2] + Costs[b][3]);

  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
