{$D-}
{$I-,Q-,R-,S-}

const
  MAXM = 10000;

  MAX_LONG = 12000;

type
  Integer = Longint;

  TMul = record
    k, s: Integer;
  end;
  TMuls = array[0..MAXM] of TMul;

  TLong = array[0..MAX_LONG] of Integer;

var
  Nok: TMuls;
  n: Integer;

procedure Init();
begin
  Assign(Input, 'lcm.in');
  Reset(Input);
  Assign(Output, 'lcm.out');
  Rewrite(Output);

  Read(n);
end;

procedure OnMuls(k: Integer; var Res: TMuls);
var
  m: Integer;
  Next: Boolean;
begin
  m := 2;
  Res[0].k := 0;
  Next := True;
  while (m <= Round(Sqrt(k))) and (k > 1) do
  begin
    if k mod m = 0 then
    begin
      if Next then
      begin
        Inc(Res[0].k);
        Res[Res[0].k].k := m;
        Res[Res[0].k].s := 1;
        Next := False;
      end else
        Inc(Res[Res[0].k].s);

      k := k div m;
    end else
    begin
      Next := True;
      Inc(m);
    end;
  end;

  if k > 1 then
    if Res[Res[0].k].k = k then Inc(Res[Res[0].k].s) else
    begin
      Inc(Res[0].k);
      Res[Res[0].k].k := k;
      Res[Res[0].k].s := 1;
    end;
end;

function Max(const a, b: Integer): Integer;
begin
  if a > b then Max := a else Max := b;
end;

procedure Union(var Res: TMuls; const Tmp: TMuls);
var
  i, j: Integer;
  Find: Boolean;
begin
  for i := 1 to Tmp[0].k do
  begin
    Find := False;
    for j := 1 to Res[0].k do
      if Tmp[i].k = Res[j].k then
      begin
        Find := True;
        Res[j].s := Max(Res[j].s, Tmp[i].s);
      end;

    if not Find then
    begin
      Inc(Res[0].k);
      Res[Res[0].k].k := Tmp[i].k;
      Res[Res[0].k].s := Tmp[i].s;
    end;
  end;
end;

procedure Solve();
var
  i, k: Integer;
  Tmp: TMuls;
begin
  for i := 1 to n do
  begin
    Read(k);
    OnMuls(k, Tmp);
    Union(Nok, Tmp);
  end;
end;

procedure LongMulShort(var Res: TLong; const k: Integer);
var
  pv: Longword;
  i: Integer;
  c: TLong;
begin
  pv := 0;
  c[0] := Res[0];
  for i := 1 to Res[0] do
  begin
    pv := LongWord(Res[i]) * k + pv;
    c[i] := pv mod 10;
    pv := pv div 10;
  end;

  while pv > 0 do
  begin
    Inc(c[0]);
    c[c[0]] := pv mod 10;
    pv := pv div 10;
  end;

  Res := c;
end;

procedure Done();
var
  Res: TLong;
  i, j: Integer;
begin
  Res[0] := 1;
  Res[1] := 1;

  for i := 1 to Nok[0].k do
    for j := 1 to Nok[i].s do
      LongMulShort(Res, Nok[i].k);

  for i := Res[0] downto 1 do Write(Res[i]);

  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
