{$I-,Q-,R-,S-}

const
  MAXN = 50;
  MAXK = 50;

type
  TMng = array[0..MAXK] of Integer;

var
  a: array[1..MAXN, 1..MAXN] of Boolean;
  g, s, ln: array[1..MAXN] of Integer;
  Mn: array[1..MAXN] of TMng;
  n, m: Integer;

procedure Init();
var
  i, v1, v2: Integer;
begin
  Assign(Input, 'chrom.in');
  Reset(Input);
  Assign(Output, 'chrom.out');
  Rewrite(Output);

  Read(n, m);
  for i := 1 to m do
  begin
    Read(v1, v2);
    a[v1, v2] := True;
    a[v2, v1] := True;
    Inc(s[v1]);
    Inc(s[v2]);
  end;
end;

procedure Mul(a: TMng; const b: TMng; var c: TMng);
var
  i, j: Integer;
  Tmp: Integer;
begin
  Fillchar(c, Sizeof(c), 0);
  for i := 1 to a[0] do
    for j := 1 to b[0] do
    begin
      Tmp := a[i] * b[j];
      Inc(c[(i - 1) + (j - 1) + 1], Tmp);
    end;

  c[0] := MAXK;
  while c[c[0]] = 0 do Dec(c[0]);
end;

procedure Sort(l, r: Integer);
var
  i, j, x, y: integer;
begin
  i := l; j := r; x := s[(l+r) DIV 2];
  repeat
    while s[i] < x do i := i + 1;
    while x < s[j] do j := j - 1;
    if i <= j then
    begin
      y := s[i]; s[i] := s[j]; s[j] := y;
      y := ln[i]; ln[i] := ln[j]; ln[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

procedure Solve();
var
  i, j: Integer;
  Tmp: TMng;
begin
  for i := 1 to n do
    ln[i] := i;

  Sort(1, n);

  for i := 1 to n do
    g[ln[i]] := n - i;

  for i := 1 to n do
    for j := i + 1 to n do
      if not a[i, j] then
      begin
        if g[i] < g[j] then Dec(g[j]) else Dec(g[i]);
      end;

  for i := 1 to n do
  begin
    Mn[i][0] := 2;
    Mn[i][1] := -g[i];
    Mn[i][2] := 1;
  end;

  Tmp := Mn[1];

  for i := 2 to n do
    Mul(Tmp, Mn[i], Tmp);

  Write(Tmp[0] - 1, ' ');
  for i := 1 to Tmp[0] do Write(Tmp[i], ' ');
end;

procedure Done();
begin
  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.

