Program Tinstr;

type
  integer=longint;
  PNode=^TNode;
  TNode=record
    key:integer;
    left,right:PNode;
  end;

function cmp(a,b:integer):integer;forward;

var
  root:PNode;
  value:integer;

  procedure Insert(var root:PNode);
  begin
    if root=nil then
      begin
        new(root);
        root^.left:=nil;
        root^.right:=nil;
        root^.key:=value;
      end
    else
      if cmp(root^.key,value)>0 then
        Insert(root^.left)
      else
      if cmp(root^.key,value)<0 then
        Insert(root^.right);
  end;

  function DeleteLeft(var root:PNode):integer;
  var p:PNode;
  begin
    if root^.left=nil then
      begin
        p:=root^.right;
        DeleteLeft:=root^.key;
        dispose(root);
        root:=p;
      end
    else
      DeleteLeft:=DeleteLeft(root^.left);
  end;


  procedure Delete(var root:PNode);
  var p:PNode;
  begin
    if root=nil then exit;
    if cmp(root^.key,value)=0 then begin
      if root^.left=nil then begin
        p:=root^.right;
        dispose(root);
        root:=p;
      end else
      if root^.right=nil then begin
        p:=root^.left;
        dispose(root);
        root:=p;
      end else
        root^.key:=DeleteLeft(root);
    end else
    if cmp(root^.key,value)>0 then Delete(root^.left)
    else Delete(root^.right);
  end;
//--------------------------------------------
var coloumn:integer;
procedure DumpHex(x:byte);
begin
  if x<10 then
    write(x)
  else
    write(chr(x-10+ord('A')));
end;
procedure DumpByte(x:byte);
begin
  case coloumn of
    0:writeln;
    1..7,9..15:write(' ');
    8:write('  ');
  end;
  DumpHex(x shr 4);
  DumpHex(x and $f);
  coloumn:=(coloumn+1) mod 16;
end;
procedure Dump(x:byte);
begin
  case x of
    0:DumpByte($5c);
    1:begin
      DumpByte($0f);
      DumpByte($cc);
    end;
  end;
end;
function loadByte:integer;
var ch:char;
b:integer;
begin
  repeat read(ch) until ch>' ';
  case ch of
    '0'..'9':b:=ord(ch)-ord('0');
    'a'..'z':b:=ord(ch)-ord('a')+10;
    'A'..'Z':b:=ord(ch)-ord('A')+10;
  end;
  b:=b*16;
  repeat read(ch) until ch>' ';
  case ch of
    '0'..'9':b:=b+ord(ch)-ord('0');
    'a'..'z':b:=b+ord(ch)-ord('a')+10;
    'A'..'Z':b:=b+ord(ch)-ord('A')+10;
  end;
  loadByte:=b;
end;
function bswap(x:word):word;
begin
  bswap:=((x and $ff) shl 8) + (x shr 8);
end;

var
  start,finish:word;
  mem:array[0..65535]of byte;
  was:array[0..65535]of boolean;

function pop(x:word):word;
begin
  pop:=(mem[(x+1)and $ffff] shl 8) + mem[x];
end;

//--------------------------------------------
procedure Load;
var i:word;
begin
  start  :=loadByte*256+loadByte;
  finish :=loadByte*256+loadByte;
  for i:=0 to 65535 do mem[i]:=loadByte;
end;

type
  TStat=object
    len:integer;
    num,count:integer;
    a:array[0..250]of longword;
    procedure Add(x:byte;p:integer);
    procedure Init;
    function cmp(var s:TStat):integer;
  end;

var
  stat:array[0..65535]of TStat;
  st:TStat;
  x,y:integer;

function TStat.cmp(var s:TStat):integer;
var
  n2,n1,x1,x2:longword;
  c1,c2:integer;
begin
  if len>s.len then cmp:=1 else
  if len<s.len then cmp:=-1 else
  begin
    c1:=count;
    c2:=s.count;
    n1:=num;
    n2:=s.num;
    while (c1>=0)and(c2>=0) do begin
      x1:=(a[c1]and (1 shl n1))shr (1 shl n1-1);
      x2:=(s.a[c2]and (1 shl n2))shr (1 shl n2-1);
      if x1>x2 then begin
        cmp:=-1;
        exit;
      end else
      if x1<x2 then begin
        cmp:=1;
        exit;
      end;
      if n1=0 then begin
        dec(c1);
        n1:=31;
      end else dec(n1);
      if n2=0 then begin
        dec(c2);
        n2:=31;
      end else dec(n2);
    end;
    cmp:=0;
  end;
end;

procedure TStat.Init;
var i:integer;
begin
  len:=-1;
  FillChar(a,sizeof(a),0);
end;

procedure TStat.Add(x:byte;p:integer);
begin
  Self:=stat[p];
  inc(num);
  if num>=32 then begin
    num:=0;
    inc(count);
  end;
  len:=len+1+x;
  a[count]:=a[count]shl 1+x;
end;


function cmp(a,b:integer):integer;
begin
  cmp:=stat[a].cmp(stat[b]);
end;

procedure Print;
var d,s,i,j:integer;
begin
  write(stat[finish].len);
  for j:=0 to stat[finish].count-1 do begin
    d:=0;
    s:=stat[finish].a[j];
    for i:=0 to 31 do begin
      d:=d*2+s mod 2;
      s:=s div 2;
    end;
    for i:=0 to 31 do begin
      Dump(d mod 2);
      d:=d div 2;
    end;
  end;
  if stat[finish].count>=0 then begin
    d:=0;
    s:=stat[finish].a[stat[finish].count];
    for i:=0 to stat[finish].num do begin
      d:=d*2+s mod 2;
      s:=s div 2;
    end;
    for i:=0 to stat[finish].num do begin
      Dump(d mod 2);
      d:=d div 2;
    end;
  end;
  writeln;
end;

procedure GoOn;
var i:word;
begin
  root:=nil;
  value:=start;
  Insert(root);
  for i:=0 to 65535 do begin
    was[i]:=false;
    stat[i].init;
    stat[i].len:=-1;
  end;
  stat[start].len:=0;
  stat[start].num:=31;
  stat[start].count:=-1;
  while not(was[finish] or (root=nil)) do begin
    x:=DeleteLeft(root);
    was[x]:=true;
    y:=pop(x);
    if not was[y] then begin
      st.add(0,x);
      value:=y;
      Delete(root);
      if (stat[y].len<0) or (stat[y].cmp(st)>0) then
        stat[y]:=st;
      Insert(root);
    end;
    y:=bswap(x);
    if not was[y] then begin
      st.add(1,x);
      value:=y;
      Delete(root);
      if (stat[y].len<0) or (stat[y].cmp(st)>0) then
        stat[y]:=st;
      Insert(root);
    end;
  end;{while}
  if was[finish] then
    Print
  else
    writeln('IMPOSSIBLE');
end;
{var s:string;
i:integer;}
begin
  coloumn:=0;
  assign(input,'2instr.in');
  reset(input);
  assign(output,'2instr.out');
  rewrite(output);
  Load;
  GoOn;
  close(input);
  close(output);
{  readln(s);
  for i:=1 to length(s) do
    Dump(ord(s[i])-ord('0'));
  readln;}


end.
