{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='indirect.in';
         File_Out='indirect.out';
         Osn=1 Shl 15;
         MaxN=Osn;
   Type Int=LongInt;
   Var Memory : Array [1..MaxN] Of Int;
       Use : Array [1..MaxN] Of Boolean;
       Akk : Int;
       Answer : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Procedure WriteAnswer;
  Var I : Int;
Begin
  If Answer=0 Then
    WriteLn('SUCCESSFUL TERMINATION');
  If Answer=1 Then
    WriteLn('DIVISION BY ZERO');
  If Answer=-1 Then
    WriteLn('RUN-TIME ERROR');
  WriteLn(Akk);
  For I :=1 To MaxN Do
    WriteLn(Memory[I]);
  CloseFiles;
  Halt(0);
End;

Function GetMem(Const A : Int) : Int;
  Var Help : Int;
Begin
  Help :=A;
  While (Memory[Help]<0) And Not (Use[Help]) Do
    Begin
      Use[Help] :=True;
      Help :=Abs(Memory[Help]);
    End;
  If Not Use[Help] Then
    Begin
      GetMem :=Help;
      Help :=A;
      While (Memory[Help]<0) Do
        Begin
          Use[Help] :=False;
          Help :=Abs(Memory[Help]);
        End;
    End
  Else
    Begin
      GetMem :=-1;
      Answer :=-1;
      WriteAnswer;
    End;
End;

Procedure Check(Var A : Int);
Begin
  If A>=Osn Then A :=A Mod Osn;
  If A<-Osn Then
    If A Mod Osn=0 Then A :=-Osn
    Else A :=A Mod Osn;
End;

Procedure InitSolve;
  Var Command1,Command2 : Char;
      Help,Num : Int;
Begin
  FillChar(Memory,SizeOf(Memory),0);
  FillChar(Use,SizeOf(Use),False);
  Akk :=0;
  Answer :=0;
  While Not EoF Do
    Begin
      Read(Command1,Command2);
      ReadLn(Num);
      Case Command2 Of
        '*' : Begin
                Case Command1 Of
                  'A' : Begin
                          Help :=GetMem(Num);
                          Akk :=Akk+Memory[Help];
                          Check(Akk);
                        End;
                  'S' : Begin
                          Help :=GetMem(Num);
                          Akk :=Akk-Memory[Help];
                          Check(Akk);
                        End;
                  'M' : Begin
                          Help :=GetMem(Num);
                          Akk :=Akk-Memory[Help];
                          Check(Akk);
                        End;
                  'D' : Begin
                          Help :=GetMem(Num);
                          If Memory[Help]=0 Then
                            Begin
                              Answer :=1;
                              Break;
                            End;
                          Akk :=Akk Div Memory[Help];
                          Check(Akk);
                        End;
                  'O' : Begin
                          Help :=GetMem(Num);
                          If Memory[Help]=0 Then
                            Begin
                              Answer :=1;
                              Break;
                            End;
                          Akk :=Akk Mod Memory[Help];
                          Check(Akk);
                        End;
                  'R' : Begin
                          Help :=GetMem(Num);
                          Akk :=Memory[Help];
                          Check(Akk);
                        End;
                  'W' : Begin
                          Help :=GetMem(Num);
                          Memory[Help] :=Akk;
                        End;
                End;
              End;
        '=' : Begin
                Case Command1 Of
                  'A' : Begin
                          Akk :=Akk+Num;
                          Check(Akk);
                        End;
                  'S' : Begin
                          Akk :=Akk-Num;
                          Check(Akk);
                        End;
                  'M' : Begin
                          Akk :=Akk*Num;
                          Check(Akk);
                        End;
                  'D' : Begin
                          If Num=0 Then
                            Begin
                              Answer :=1;
                              Break;
                            End;
                          Akk :=Akk Div Num;
                          Check(Akk);
                        End;
                  'O' : Begin
                          If Num=0 Then
                            Begin
                              Answer :=1;
                              Break;
                            End;
                          Akk :=Akk Mod Num;
                          Check(Akk);
                        End;
                  'R' : Begin
                          Akk :=Num;
                        End;
                End;
              End;
      End;
    End;
  WriteAnswer;
End;

Begin
  OpenFiles;
  InitSolve;
End.
