{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='2instr.in';
         File_Out='2instr.out';
         MaxN=1 Shl 16;
         Infinity=MaxLongInt Div 2;
   Type Int=LongInt;
   Var First,Last : Int;
       Dump,From,Num : Array [0..MaxN-1] Of Int;
       D : Array [0..MaxN] Of Record D,Num : Int; End;
       Answer,AnswerHelp : Array [0..MaxN*3] Of Int;
       SizeHeap : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function Read16 : Int;
  Var Sym : Char;
Begin
  Read(Sym);
  While Not (Sym In ['0'..'9','A'..'F']) Do
    Read(Sym);
  If Sym In ['0'..'9'] Then
    Read16 :=Ord(Sym)-Ord('0')
  Else Read16 :=Ord(Sym)-Ord('A')+10;
End;

Procedure Init;
  Var I,Help : Int;
Begin
  First :=0;
  For I :=1 To 4 Do
    Begin
      Help :=Read16;
      First :=First*16+Help;
    End;
  Last :=0;
  For I :=1 To 4 Do
    Begin
      Help :=Read16;
      Last :=Last*16+Help;
    End;
  For I :=0 To MaxN-1 DO
    Begin
      Dump[I] :=Read16;
      Dump[I] :=Dump[I]*16+Read16;
    End;
End;

Procedure ChangeKey(Const I,Key : Int);
  Var Now : Int;
Begin
  Now :=I;
  D[Now].D :=Key;
  While (Now>1) And (D[Now].D<D[Now Div 2].D) Do
    Begin
      D[0] :=D[Now];
      D[Now] :=D[Now Div 2];
      D[Now Div 2] :=D[0];
      Num[D[Now].Num] :=Now;
      Num[D[Now Div 2].Num] :=Now Div 2;
      Now :=Now Div 2;
    End;
End;

Function ExtractMin : Int;
  Var Now : Int;
Begin
  ExtractMin :=D[1].Num;
  If D[1].D=Infinity Then
    Begin
      ExtractMin :=-1;
      Exit;
    End;
  Num[D[1].Num] :=SizeHeap;
  Num[D[SizeHeap].Num] :=1;
  D[0] :=D[SizeHeap];
  D[SizeHeap] :=D[1];
  D[1] :=D[0];
  Dec(SizeHeap);
  Now :=1;
  While Now<=SizeHeap Do
    Begin
      If (Now*2+1<=SizeHeap) Then
        If (D[Now*2+1].D<D[Now*2].D) And (D[Now*2+1].D<D[Now].D) Then
          Begin
            D[0] :=D[Now*2+1];
            D[Now*2+1] :=D[Now];
            D[Now] :=D[0];
            Num[D[Now].Num] :=Now;
            Num[D[Now*2+1].Num] :=Now*2+1;
            Now :=Now*2+1;
          End
        Else
          If (D[Now*2].D<D[Now].D) Then
            Begin
              D[0] :=D[Now*2];
              D[Now*2] :=D[Now];
              D[Now] :=D[0];
              Num[D[Now].Num] :=Now;
              Num[D[Now*2].Num] :=Now*2;
              Now :=Now*2;
            End
          Else Break
      Else If (Now*2<=SizeHeap) And (D[Now*2].D<D[Now].D) Then
             Begin
               D[0] :=D[Now*2];
               D[Now*2] :=D[Now];
               D[Now] :=D[0];
               Num[D[Now].Num] :=Now;
               Num[D[Now*2].Num] :=Now*2;
               Now :=Now*2;
             End
           Else Break;
    End;
End;

Function Swap(Const A : Int) : Int;
Begin
  Swap :=(A Mod 256)*256+A Div 256;
End;

Function Get(Const A : Int) : Int;
Begin
  Get :=Dump[(A+1) Mod MaxN]*256+Dump[A];
End;

Function Less(Const I,J : Int) : Boolean;
  Var Help,HelpLen,K : Int;
Begin
  Help :=I;
  HelpLen :=D[Num[I]].D;
  While Help<>-1 Do
    Begin
      If D[Num[Help]].D-D[Num[From[Help]]].D=2 Then
        Begin
          Answer[HelpLen] :=3;
          Dec(HelpLen);
          Answer[HelpLen] :=1;
          Dec(HelpLen);
        End
      Else
        Begin
          Answer[helpLen] :=2;
          Dec(HelpLen);
        End;
      Help :=From[Help];
    End;
  Help :=J;
  HelpLen :=D[Num[J]].D;
  While Help<>-1 Do
    Begin
      If D[Num[Help]].D-D[Num[From[Help]]].D=2 Then
        Begin
          AnswerHelp[HelpLen] :=3;
          Dec(HelpLen);
          AnswerHelp[HelpLen] :=1;
          Dec(HelpLen);
        End
      Else
        Begin
          AnswerHelp[HelpLen] :=2;
          Dec(HelpLen);
        End;
      Help :=From[Help];
    End;
  For K :=1 To D[Num[J]].D Do
    If Answer[K]<AnswerHelp[K] Then
      Begin
        Less :=True;
        Exit;
      End
    Else
      If Answer[K]>AnswerHelp[K] Then
        Begin
          Less :=False;
          Exit;
        End;
  Less :=False;
End;

Procedure WriteAnswer(Const I : Int);
  Var Help,HelpLen,J : Int;
Begin
  Help :=I;
  HelpLen :=D[Num[I]].D;
  While Help<>-1 Do
    Begin
      If D[Num[Help]].D-D[Num[From[Help]]].D=2 Then
        Begin
          Answer[HelpLen] :=3;
          Dec(HelpLen);
          Answer[HelpLen] :=1;
          Dec(HelpLen);
        End
      Else
        Begin
          Answer[helpLen] :=2;
          Dec(HelpLen);
        End;
      Help :=From[Help];
    End;
  Help :=0;
  For J :=1 To D[Num[I]].D Do
    Begin
      Inc(Help);
      Case Answer[J] Of
        1 : Write('0F');
        3 : Write('CC');
        2 : Write('5C');
      End;
      If (Help Mod 16=0) Or (J=D[Num[I]].D) Then WriteLn
      Else If Help Mod 8=0 Then Write('  ')
      Else Write(' ');
    End;
End;

Procedure Solve;
  Var I,Min : Int;
      Help : Int;
Begin
  For I :=1 To MaxN Do
    Begin
      D[I].D :=Infinity;
      D[I].Num :=I-1;
      From[I-1] :=-1;
      Num[I-1] :=I;
    End;
  D[1].D :=0;
  D[1].Num :=First;
  D[First+1].Num :=0;
  Num[First] :=1;   {2 new lines}
  Num[0] :=First+1;
  SizeHeap :=MaxN;
  For I :=1 To MaxN Do
    Begin
      Min :=ExtractMin;
      If Min=-1 then Break;
      Help :=Swap(Min);
      If (D[Num[Help]].D>D[Num[Min]].D+2) Then
        Begin
          ChangeKey(Num[Help],D[Num[Min]].D+2);
          From[Help] :=Min;
        End;
      Help :=Get(Min);
      If (D[Num[Help]].D>D[Num[Min]].D+1) Or
         ((D[Num[Help]].D=D[Num[Min]].D+1) And Less(Min,Help)) Then
        Begin
          ChangeKey(Num[Help],D[Num[Min]].D+1);
          From[Help] :=Min;
        End;
    End;
  If D[Num[Last]].D<>Infinity Then
    Begin
      WriteLn(D[Num[Last]].D);
      WriteAnswer(Last);
    End
  Else WriteLn('IMPOSSIBLE')
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
