{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='rle.in';
         File_Out='rle.out';
         MaxK=30001;
         Eps=1E-14;
   Type Int=LongInt;
        Real=Double;
        TPoint=Record
                 X,Y : Real;
               End;
        TSegment=Record
                   P1,P2 : TPoint;
                   P3 : TPoint;
                 End;
   Var N,M : Real;
       Answer,CountR,CountSegm,K : Int;
       Segm : Array [1..MaxK] Of TSegment;
       R,RHelp : Array [1..MaxK*2] Of Record
                                        A,B : Int;
                                      End;
       Count : Array [1..MaxK+1] Of Int;
       Use : Array [1..MaxK] Of Boolean;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function Eq(Const A,B : Real) : Boolean;
Begin
  Eq :=Abs(A-B)<=Eps*Abs(A);
End;

Function Less(Const A,B : Real) : Boolean;
Begin
  Less :=A-B<-Eps*Abs(B);
End;

Function More(Const A,B : Real) : Boolean;
Begin
  More :=A-B>Eps*Abs(A);
End;

Function DivReal(Const A,B : Real) : Real;
Begin
  DivReal :=Trunc(A/B);
End;

Function ModReal(Const A,B : Real) : Real;
Begin
  ModReal :=(A/B-DivReal(A,B))*B;
End;

Procedure GetXY(Var NowX,NowY : Real; Const Len : Real);
Begin
  NowY :=NowY+DivReal(NowX+Len,M);
  NowX :=ModReal(NowX+Len,M);
End;

Procedure Add(Const X,Y,Len : Real);
Begin
  Inc(CountSegm);
  Segm[CountSegm].P1.X :=X;
  Segm[CountSegm].P1.Y :=Y;
  Segm[CountSegm].P2.X :=X;
  Segm[CountSegm].P2.Y :=Y;
  Segm[CountSegm].P3.X :=X+Len;
  Segm[CountSegm].P3.Y :=Y;
  If Eq(X+Len,M) Then
    Begin
      Segm[CountSegm].P2.X :=M;
      Segm[CountSegm].P2.Y :=Y;
    End
  Else GetXY(Segm[CountSegm].P2.X,Segm[CountSegm].P2.Y,Len)
End;

Function DistX(Const A,B : TPoint) : real;
Begin
  DistX :=Sqr(A.X-B.X);
End;

Function CheckCross(Const A,B : TSegment) : Boolean;
Begin
  CheckCross :=False;
  If (A.P2.Y=B.P1.Y) And (A.P2.X<B.P1.X) Then
    Begin
      If A.P1.Y=A.P2.Y Then
        CheckCross :=False
      Else
        CheckCross :=(Less(A.P1.X,B.P3.X) Or Eq(A.P1.X,B.P3.X)) Or
                     (Less(A.P1.Y+1,A.P2.Y))
    End
  Else
    If A.P2.Y+1=B.P1.Y Then
    If Eq(DistX(A.P1,A.P2),DistX(A.P1,B.P1)+DistX(A.P2,B.P1)) Or
       Eq(DistX(A.P1,A.P2),DistX(A.P1,B.P2)+DistX(A.P2,B.P2)) Or
       Eq(DistX(B.P1,B.P2),DistX(B.P1,A.P1)+DistX(B.P2,A.P1)) Or
       Eq(DistX(B.P1,B.P2),DistX(B.P1,A.P2)+DistX(B.P2,A.P2)) Then
         CheckCross :=True;
End;

Function Cross(Const A,B : TSegment) : Boolean;
Begin
  Cross :=CheckCross(A,B) Or CheckCross(B,A);
End;

Procedure Init;
  Var I : Int;
      Color : Int;
      NowX,NowY : Real;
      Len : Int;
Begin
  Read(M,N,Color,K);
  CountSegm :=0;
  CountR :=0;
  NowX :=0;
  NowY :=0;
  For I :=1 To K Do
    Begin
      Read(Len);
      If Color=1 Then
        If More(NowX+Len,M) Then
          Begin
            Add(NowX,NowY,M-NowX);
            Add(0,NowY+1,Len-M+NowX);
          End
        Else
          Add(NowX,NowY,Len);
      GetXY(NowX,NowY,Len);
      Color :=Color Xor 1;
    End;
End;

Procedure Dfs(A : Int);
  Var I : Int;
Begin
  Use[A] :=True;
  For I :=Count[A] To Count[A+1]-1 Do
    If Not Use[R[I].B] Then
      Dfs(R[I].B);
End;

Procedure Solve;
  Var I,J : Int;
Begin
  FillChar(Count,SizeOf(Count),0);
  For I :=1 To CountSegm Do
    For J :=I+1 To CountSegm Do
      Begin
        If Less(Segm[I].P2.Y+1,Segm[J].P1.Y) Or Eq(Segm[I].P2.Y,Segm[CountSegm].P1.Y)  Then Break;
        If Cross(Segm[I],Segm[J]) Then
          Begin
            Inc(CountR);
            R[CountR].A :=I;
            R[CountR].B :=J;
            Inc(CountR);
            R[CountR].B :=I;
            R[CountR].A :=J;
          End;
      End;
  For I :=1 To CountR Do
    Inc(Count[R[I].A]);
  Inc(Count[1]);
  For I :=2 To CountSegm+1 Do
    Inc(Count[I],Count[I-1]);
  RHelp :=R;
  For I :=1 To CountR Do
    Begin
      Dec(Count[RHelp[I].A]);
      R[Count[RHelp[I].A]] :=RHelp[I];
    End;
  Answer :=0;
  FIllChar(Use,SizeOf(Use),False);
  For I :=1 To CountSegm Do
    If Not Use[I] Then
      Begin
        Inc(Answer);
        Dfs(I);
      End;
  WriteLn(Answer)
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
