{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='pipe.in';
         File_Out='pipe.out';
         Eps=1E-12;
         MaxN=2000;
   Type Int=LongInt;
        Real=Double;
        TPoint=Record
                 X,Y : Real;
               End;
        TLine=Record
                A,B,C : Real;
                P1,P2 : TPoint;
              End;
   Var P,PD : Array [1..MaxN] Of TPoint;
       N : Int;
       Answer : Real;
       CanAnswer : Boolean;
       D,U : Real;
       Line,Line2,Line3 : TLine;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  For I :=1 To N Do
    Begin
      Read(P[I].X,P[I].Y);
      PD[I].X :=P[I].X;
      PD[I].Y :=P[I].Y-1;
    End;
End;

Function Eq(Const A,B : Real) : Boolean;
Begin
  Eq :=Abs(A-B)<Eps
End;

Function Less(Const A,B : Real) : Boolean;
Begin
  Less :=A-B<-Eps*Abs(A)
End;

Function More(Const A,B : Real) : Boolean;
Begin
  More :=A-B>Eps*Abs(A);
End;

Procedure MakeLine(Const P1,P2 : TPoint; Var L : TLine);
  Var Help : Real;
Begin
  L.A :=P1.Y-P2.Y;
  L.B :=P2.X-P1.X;
  L.C :=-(L.A*P1.X+L.B*P1.Y);
  Help :=Sqrt(Sqr(L.A)+Sqr(L.B));
  L.A :=L.A/Help;
  L.B :=L.B/Help;
  L.C :=L.C/Help;
  L.P1 :=P1;
  L.P2 :=P2;
End;

Function Vect(Const A,B,C : TPoint) :Real;
Begin
  Vect :=(A.X-C.X)*(B.Y-C.Y)-(A.Y-C.Y)*(B.X-C.X);
End;

Function Check(Const A,B : TPoint; Const L :TLine) : Boolean;
  Var V1,V2 : real;
Begin
  V1 :=Vect(A,L.P1,L.P2);
  V2 :=Vect(B,L.P1,L.P2);
  If Less(V1*V2,0) Then Check :=True
  Else Check :=False;
End;

Procedure Cross(Const L1,L2 : TLine; Var P : TPoint);
  Var D : Real;
Begin
  D :=1/(L2.B*L1.A-L2.A*L1.B);
  P.Y :=(L1.A*L2.C-L1.B*L2.A)*D;
  P.X :=-(L1.C*L2.B-L1.B*L2.C)*D;
End;

Function Dist(COnst A : TPoint; Const L : Tline) : Real;
Begin
  Dist :=Abs(A.X*L.A+A.Y*L.B+L.C);
End;

Procedure Solve;
  Var I,J : Int;
      Help : TPoint;
Begin
  For I :=2 To N Do
    Begin
      MakeLine(P[1],P[I],Line);
      MakeLine(PD[1],PD[I],Line2);
      CanAnswer :=False;
      U :=1;
      D :=0;
      For J :=2 To N Do
        Begin
          If Check(P[J-1],P[J],Line2) Then
            Begin
              CanAnswer :=True;
              MakeLine(P[J-1],P[J],Line3);
              Cross(Line2,Line3,Help);
              If Help.X>Answer Then Answer :=Help.X;
              Break;
            End;
          If Check(PD[J-1],PD[J],Line) Then
            Begin
              CanAnswer :=True;
              MakeLine(PD[J-1],PD[J],Line3);
              Cross(Line,Line3,Help);
              If Help.X>Answer Then Answer :=Help.X;
              Break;
            End;
          If Eq(Dist(P[I],Line)+Dist(P[I],Line2),Abs(Line2.C-Line.C)) Then
            Line2.C :=-(P[I].X*Line2.A+P[I].Y*Line2.B);
          If Eq(Dist(PD[I],Line)+Dist(PD[I],Line2),Abs(Line2.C-Line.C)) Then
            Line.C :=-(PD[I].X*Line.A+PD[I].Y*Line.B);
        End;
      If Not CanAnswer Then Break;
    End;
  If Not CanAnswer Then
    WriteLn('DELO TRUBA')
  Else WRiteLn(Answer:0:2);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
