{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='polygon.in';
         File_Out='polygon.out';
         MaxN=300;
         Eps=1E-12;
   Type Int=Integer;
{        Real=Double;}
        TPoint=Record
                 X,Y : Real;
               End;
   Var Ans : Array [1..MaxN,1..MaxN] Of Int;
       OK : Array [1..MaxN,1..MaxN,1..MaxN] Of Boolean;
       Answer,N : Int;
       P,PLast : Array [1..MaxN] Of TPoint;
       Num : Array [1..MaxN] Of Int;
       Left : TPoint;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function Eq(Const A,B : Real) : Boolean;
Begin
  Eq :=Abs(A-B)<Eps;
End;

Function Less(Const A,B : Real) : Boolean;
Begin
  Less :=A-B<-Eps;
End;

Function More(Const A,B : Real) : Boolean;
Begin
  More :=A-B>Eps;
End;

Procedure Init;
  var I : Int;
Begin
  Read(N);
  For I :=1 To N Do
    Read(P[I].X,P[I].Y);
End;

Procedure Swap(Var A,B : TPoint);
  Var C : TPoint;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure SwapInt(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Function Vect(Const P1,P2,P3 : TPoint) : Real;
Begin
  Vect :=(P1.X-P3.X)*(P2.Y-P3.Y)-(P1.Y-P3.Y)*(P2.X-P3.X);
End;

Procedure Sort(L,R : Int);
  Var B,E : Int;
      X : TPoint;
Begin
  B :=L;
  E :=R;
  X :=P[(L+R) Div 2];
  Repeat
    While Less(Vect(P[B],X,Left),0) Do Inc(B);
    While More(Vect(P[E],X,Left),0) Do Dec(E);
    If B<=E Then
      Begin
        Swap(P[B],P[E]);
        SwapInt(Num[B],Num[E]);
        Inc(B);
        Dec(E);
      End;
  Until B>E;
  If B<R Then Sort(B,R);
  If E>L Then Sort(L,E);
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Procedure Solve;
  Var I,J,K,L : Int;
      CountP : Int;
Begin
  PLast :=P;
  Answer :=3;
  For K :=1 To N Do
    For I :=1 To N Do
      Begin
        Ok[I,I,K] :=False; 
        For J :=I+1 To N Do
          Begin
            Ok[I,J,K] :=(P[I].X-P[K].X)*(P[J].Y-P[K].Y)-(P[I].Y-P[K].Y)*(P[J].X-P[K].X)>Eps{More(Vect(P[I],P[J],P[K]),0)};
            Ok[J,I,K] :=Not Ok[I,J,K];
          End;
      End; 
  For I :=1 To N Do
    Begin
      FillChar(Ans,SizeOf(Ans),0);
      CountP :=0;
      Swap(PLast[I],PLast[1]);
      For J :=1 To N Do
        If PLast[1].X<=PLast[J].X Then
          Begin
            Inc(CountP);
            P[CountP] :=PLast[J];
            Num[CountP] :=J;
            If J=I Then
              Num[CountP] :=1;
          End;
      Num[1] :=I;
      Swap(PLast[I],PLast[1]);
      If CountP<=Answer Then Continue;
      Left :=PLast[I];
      Sort(2,CountP);
      For J :=2 To CountP Do
         Ans[1,J] :=2;
      For K :=3 To CountP Do
        For J :=2 To K-1 Do
          For L :=1 To J-1 Do
            If Ok[Num[K],Num[J],Num[L]] Then
              If Ans[L,J]+1>Ans[J,K] Then
                Ans[J,K] :=Ans[L,J]+1;
      For J :=2 To CountP Do
        For K :=J+1 To CountP Do
          If Ok[Num[1],Num[K],Num[J]] Then
            Answer :=Max(Answer,Ans[J,K]);
{      If (N>170) And (I>50) Then Break;}
    End;
  WriteLn(Answer);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
