{$A+,B-,D-,E-,F-,G+,I-,L-,N-,O+,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='prof.in';
         File_Out='prof.out';
         MaxLen=3000;
   Type Int=LongInt;
        TTrie=^TTTrie;
        TCHildren=^TTChildren;
        TTChildren=Record
                     Now : TTrie;
                     Next : TChildren;
                     R : Char;
                   End;
        TTTrie=Record
                 Children : TChildren;
                 Ok,Use : Boolean;
                 Len,From : Int;
               End;
   Var S : Array [1..MaxLen] Of Char;
       LenS : Int;
       Trie : TTrie;
       Answer : Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
Begin
  LenS :=0;
  While Not SeekEoF DO
    Begin
      Inc(LenS);
      Read(S[LenS]);
    End;
End;

Function TryT(Var T : TTrie; Const R : Char; Const From : Int) : Boolean;
  Var Help : TChildren;
Begin
  Help :=T^.Children;
  While Help<>Nil Do
    Begin
      If Help^.R=R Then
        Begin
          T :=Help^.Now;
          TryT :=True;
          If From>=Help^.Now^.From+Help^.Now^.Len Then
            Help^.Now^.Ok :=True;
          Exit;
        End;
      Help :=Help^.Next;
    End;
  TryT :=False;
End;

Procedure Add(Var T : TTrie; Const R : CHar; Const From : Int);
  Var Help : TChildren;
Begin
  If T^.CHildren=Nil Then
    Begin
      New(T^.Children);
      T^.Children^.Next :=Nil;
      T^.Children^.R :=R;
      New(T^.Children^.Now);
      T^.Children^.Now^.Ok :=False;
      T^.Children^.Now^.Use :=False;
      T^.Children^.Now^.Len :=T^.Len+1;
      T^.Children^.Now^.From :=From;
      T^.Children^.Now^.Children :=Nil;
      T :=T^.Children^.Now;
      Exit;
    End;
  Help :=T^.Children;
  While Help^.Next<>Nil Do
    Help :=Help^.Next;
  New(Help^.Next);
  Help :=Help^.Next;
  Help^.Next :=Nil;
  Help^.R :=R;
  New(Help^.Now);
  Help^.Now^.Ok :=False;
  Help^.Now^.Use :=False;
  Help^.Now^.Len :=T^.Len+1;
  Help^.Now^.From :=From;
  Help^.Now^.Children :=Nil;
  T :=Help^.Now;
End;

Procedure CountAnswer(T : TTrie);
  Var R : TChildren;
Begin
  If T^.Len=1000 Then
    Begin
      R :=Nil;
    End;
  If T^.Ok Then Inc(Answer);
  T^.Use :=True;
  R :=T^.Children;
  While R<>NIl Do
    Begin
      CountAnswer(R^.Now);
      R :=R^.Next;
    End;
End;

Procedure Solve;
  Var I,J : Int;
      Now : TTrie;
Begin
  New(Trie);
  Trie^.Children :=Nil;
  Trie^.Ok :=False;
  Trie^.Use :=False;
  Trie^.Len :=0;
  Trie^.From :=0;
  For I :=1 To LenS Do
    Begin
      Now :=Trie;
      For J :=I To LenS Do
        If Not TryT(Now,S[J],I) Then
          Add(Now,S[J],I);
    End;
  Answer :=0;
  CountAnswer(Trie);
  WriteLn(Answer);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
