program ZA;

{$APPTYPE CONSOLE}

type
  PHash = ^THash;
  
  THash = record
    next: PHash;
    i: word;
  end;

var
  memory: array [1..32768] of smallint;
  acc: {longword}smallint;
  i, v: longint;
  c, op: char;
  indirect: boolean;
  col: array [1..32768] of boolean;
  p: array [1..32768] of word;
  h: array [1..32768] of PHash;


procedure OutMem;
var
  i: longint;
begin
  WriteLn(acc);
  for i:=1 to 32768 do
    WriteLn(memory[i]);
  Close(input);
  Close(output);
end;

procedure DelP(i: integer);
var
  t, j: PHash;
begin
  p[i]:=0;
  if h[i]=nil then
    exit;
  j:=h[i];
  h[i]:=nil;
  while j<>nil do
  begin
    p[j^.i]:=0;
    DelP(j^.i);
    t:=j;
    j:=j^.next;
    dispose(t);
  end;
end;

function GetMem(i: longint): longint;
var
  j: longint;
  t: PHash;
begin
  if p[i]<>0 then
  begin
    GetMem:=p[i];
    exit;
  end;
  j:=i;
  while (memory[j]<0) and not(col[j]) do
  begin
    col[j]:=true;
    j:=-memory[j];
    new(t);
    t^.next:=h[j];
    t^.i:=i;
    h[j]:=t;
    if p[j]<>0 then
    begin
      j:=p[j];
      break;
    end;
  end;
  if col[j] then
  begin
    WriteLn('RUN-TIME ERROR');
    OutMem;
    halt(0);
  end;
  GetMem:=j;
  p[i]:=j;
  j:=i;
  while (memory[j]<0) and col[j] do
  begin
    col[j]:=false;
    j:=-memory[j];
    if p[j]<>0 then
      break;
  end;
end;

procedure Operate;
var
  i: smallint;
begin
  if indirect then
    i:=memory[GetMem(v)]
  else
    i:=v;
  if ((op='D') or (op='O')) and (i=0) then
  begin
    WriteLn('DIVISION BY ZERO');
    OutMem;
    Halt(0);
  end;
  case op of
    'A': acc:=acc+i;
    'S': acc:=acc-i;
    'M': acc:=acc*i;
    'D': acc:=acc div i;
    'O': acc:=acc mod i;
    'R': acc:=i;
    'W':
    begin
      memory[GetMem(v)]:=acc;
      DelP(GetMem(v));
    end;
  end;
end;

begin
  fillchar(c, 32768, 0);
  fillchar(p, 65536, 0);
  for i:=1 to 32768 do
    h[i]:=nil;
  Assign(input, 'indirect.in');
  Assign(output, 'indirect.out');
  Reset(input);
  Rewrite(output);
  for i:=1 to 32768 do
    memory[i]:=0;
  acc:=0;
  while not(seekeof) do
  begin
    Read(c);
    op:=c;
    Read(c);
    if c='*' then
      indirect:=true
    else
      indirect:=false;
    ReadLn(i);
    {if i=32768 then
    begin
      WriteLn('Ura!');
      exit;
    end;}
    v:=i;
    operate;
  end;
  WriteLn('SUCCESSFUL TERMINATION');
  OutMem;
end.
