program ZB;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  pop=#92;
  bswap=#15#204;

var
  i, j, x, y, hsize: longword;
  k: word;
  d, p: array [0..65537] of word;
  nom: array [1..65537] of word;
  h: array [1..65537] of longword;
  ind: array [0..65537] of longword;
  w: array [0..65537, 1..2] of word;
  c: char;

procedure Swap(i, j: longword);
begin
  if i=j then exit;
  ind[nom[i]]:=j;
  ind[nom[j]]:=i;
  nom[i]:=nom[i] xor nom[j];
  nom[j]:=nom[i] xor nom[j];
  nom[i]:=nom[i] xor nom[j];
  h[i]:=h[i] xor h[j];
  h[j]:=h[i] xor h[j];
  h[i]:=h[i] xor h[j];
end;

procedure Heapify(i: longword);
var
  min: longword;
begin
  min:=i;
  if (i*2<=hsize) and (h[i*2]<h[min]) then
    min:=i*2;
  if (i*2+1<=hsize) and (h[i*2+1]<h[min]) then
    min:=i*2+1;
  if min<>i then
  begin
    Swap(min, i);
    Heapify(min);
  end;
end;

procedure ExtractMin;
begin
  swap(1, hsize);
  dec(hsize);
  heapify(1);
end;

procedure DecKey(i: longword; key: longword);
var
  j: longword;
begin
  j:=ind[i];
  if key>=h[j] then
    exit;
  h[j]:=key;
  while (j>1) and (h[j]<h[j div 2]) do
  begin
    swap(j, j div 2);
    j:=j div 2;
  end;
end;

function GetPath(i: word): string;
begin
  GetPath:='';
  if i=x then
    exit;
  if p[i]=word(i shl 8)+(i shr 8) then
    GetPath:=GetPath(p[i])+bswap
  else
    GetPath:=GetPath(p[i])+pop;
end;

procedure OutHex(s: string);
var
  i: integer;
  t: string;
begin
  WriteLn(length(s));
  for i:=1 to Length(s) do
  begin
    t:=Format('%X', [Ord(s[i])]);
    if length(t)=2 then
      Write(t, ' ')
    else
      Write('0', t, ' ');
  end;
  WriteLn;
end;

begin
  Assign(input, '2instr.in');
  Assign(output, '2instr.out');
  Reset(input);
  Rewrite(output);
  i:=1;
  x:=0;
  while i<=4 do
  begin
    Read(c);
    if c in ['1','2','3','4','5','6','7','8','9','0'] then
    begin
      x:=x shl 4;
      x:=x+ord(c)-ord('0');
      inc(i);
    end;
    if c in ['A','B','C','D','E','F'] then
    begin
      x:=x shl 4;
      x:=x+ord(c)-ord('A')+10;
      inc(i);
    end;
  end;
  i:=1;
  y:=0;
  while i<=4 do
  begin
    Read(c);
    if c in ['1','2','3','4','5','6','7','8','9','0'] then
    begin
      y:=y shl 4;
      y:=y+ord(c)-ord('0');
      inc(i);
    end;
    if c in ['A','B','C','D','E','F'] then
    begin
      y:=y shl 4;
      y:=y+ord(c)-ord('A')+10;
      inc(i);
    end;
  end;
  for k:=0 to 65535 do
  begin
    w[k, 2]:=word(k shl 8)+(k shr 8);
  end;
  i:=1;
  d[0]:=0;
  while i<=2 do
  begin
    Read(c);
    if c in ['1','2','3','4','5','6','7','8','9','0'] then
    begin
      d[0]:=d[0] shl 4;
      d[0]:=d[0]+ord(c)-ord('0');
      inc(i);
    end;
    if c in ['A','B','C','D','E','F'] then
    begin
      d[0]:=d[0] shl 4;
      d[0]:=d[0]+ord(c)-ord('A')+10;
      inc(i);
    end;
  end;
  for i:=1 to 65535 do
  begin
    j:=1;
    d[i]:=0;
    while j<=2 do
    begin
      Read(c);
      if c in ['1','2','3','4','5','6','7','8','9','0'] then
      begin
        d[i]:=d[i] shl 4;
        d[i]:=d[i]+ord(c)-ord('0');
        inc(j);
      end;
      if c in ['A','B','C','D','E','F'] then
      begin
        d[i]:=d[i] shl 4;
        d[i]:=d[i]+ord(c)-ord('A')+10;
        inc(j);
      end;
    end;
    w[i-1, 1]:=word(d[i] shl 8)+d[i-1];
  end;
  w[65535, 1]:=word(d[0] shl 8)+d[65535];
  for i:=0 to 65535 do
  begin
    h[i+1]:=429496729;
    ind[i]:=i+1;
    nom[i+1]:=i;
  end;
  hsize:=65536;
  DecKey(x, 0);
  while hsize>0 do
  begin
    if h[1]=429496729 then
      break;
    if nom[1]=y then
      break;
    for i:=1 to 2 do
    begin
      if (i=1) and (h[ind[w[nom[1], i]]]=h[1]+i) and (GetPath(nom[1])+pop<GetPath(w[nom[1], i])) then
      begin
        p[w[nom[1], i]]:=nom[1];
        DecKey(w[nom[1], i], h[1]+i);
      end;
      if (i=2) and (h[ind[w[nom[1], i]]]=h[1]+i) and (GetPath(nom[1])+bswap<GetPath(w[nom[1], i])) then
      begin
        p[w[nom[1], i]]:=nom[1];
        DecKey(w[nom[1], i], h[1]+i);
      end;
      if h[ind[w[nom[1], i]]]>h[1]+i then
      begin
        p[w[nom[1], i]]:=nom[1];
        DecKey(w[nom[1], i], h[1]+i);
      end;
    end;
    ExtractMin;
  end;
  if h[1]=429496729 then
    WriteLn('IMPOSSIBLE')
  else
    OutHex(GetPath(nom[1]));
  Close(input);
  Close(output);
end.

