#include <stdio.h>
#include <string.h>

#define opLoad   0
#define opStore  1
#define opAdd    2
#define opSub    3
#define opMult   4
#define opDiv    5
#define opRead   6
#define opWrite  7
#define opJump   8
#define opJgtz   9
#define opJzero 10
#define opHALT  11

#define vtConst   0
#define vtReg     1
#define vtPointer 2

typedef struct{
    short int op, v, vt;
} TOperation;    

int i, j, m, n;
short int reg[1000], inp[1000];
char* s;
TOperation prog[1000];

FILE *fin = fopen("ram.in", "r");
FILE *fout = fopen("ram.out", "w");

void opLOAD(int v, int vt){
    if (vt==vtConst) reg[0]=v;
    if (vt==vtReg)  reg[0]=reg[v];
    if (vt==vtPointer)  reg[0]=reg[reg[v]];
}

void opSTORE(int v, int vt){
    if (vt==vtReg)  reg[v]=reg[0];
    if (vt==vtPointer)  reg[reg[v]]=reg[0];
}

void opADD(int v, int vt){
    if (vt==vtConst) reg[0]+=v;
    if (vt==vtReg)  reg[0]+=reg[v];
    if (vt==vtPointer)  reg[0]+=reg[reg[v]];
}

void opSUB(int v, int vt){
    if (vt==vtConst) reg[0]-=v;
    if (vt==vtReg)  reg[0]-=reg[v];
    if (vt==vtPointer)  reg[0]-=reg[reg[v]];
}

void opMULT(int v, int vt){
    if (vt==vtConst) reg[0]*=v;
    if (vt==vtReg)  reg[0]*=reg[v];
    if (vt==vtPointer)  reg[0]*=reg[reg[v]];
}

void opDIV(int v, int vt){
    if (vt==vtConst) reg[0]/=v;
    if (vt==vtReg)  reg[0]/=reg[v];
    if (vt==vtPointer)  reg[0]/=reg[reg[v]];
}

void opREAD(int v, int vt){
    if (vt==vtReg)  reg[v]=inp[j++];
    if (vt==vtPointer)  reg[reg[v]]=inp[j++];
}

void opWRITE(int v, int vt){
    if (vt==vtConst) fprintf(fout, "%i\n", v);
    if (vt==vtReg)  fprintf(fout, "%i\n", reg[v]);
    if (vt==vtPointer)  fprintf(fout, "%i\n", reg[reg[v]]);
}

void opJUMP(int v, int vt){
    i=v-1;
}

void opJGTZ(int v, int vt){
    if (reg[0]>0) i=v-1;
}

void opJZERO(int v, int vt){
    if (reg[0]==0) i=v-1;
}

int main(){
    s=new char[0];
    fscanf(fin, "%i%i", &m, &n);
    for (i=0; i<m; i++){
        fscanf(fin, "%s ", s);
        if (strcmp(s, "LOAD")==0)  prog[i].op =  opLoad;
        if (strcmp(s, "STORE")==0) prog[i].op = opStore;
        if (strcmp(s, "ADD")==0)   prog[i].op =   opAdd;
        if (strcmp(s, "SUB")==0)   prog[i].op =   opSub;
        if (strcmp(s, "MULT")==0)  prog[i].op =  opMult;
        if (strcmp(s, "DIV")==0)   prog[i].op =   opDiv;
        if (strcmp(s, "READ")==0)  prog[i].op =  opRead;
        if (strcmp(s, "WRITE")==0) prog[i].op = opWrite;
        if (strcmp(s, "JUMP")==0)  prog[i].op =  opJump;
        if (strcmp(s, "JGTZ")==0)  prog[i].op =  opJgtz;
        if (strcmp(s, "JZERO")==0) prog[i].op = opJzero;
        if (strcmp(s, "HALT")==0)  prog[i].op =  opHALT;
        if (prog[i].op==opHALT) continue;
        fscanf(fin, " %s", s);
        prog[i].vt = vtReg;
        if (s[0]=='=') prog[i].vt=vtConst; 
        if (s[0]=='*') prog[i].vt=vtPointer; 
        if (prog[i].vt==vtReg)
            sscanf(s, "%hi", &prog[i].v); 
        else
            sscanf(s, "%c%hi", &prog[i].v, &prog[i].v);      
    }
    for (i=0; i<n; i++) fscanf(fin, "%hi", &inp[i]);
    j=0;
    i=0;
    while(1){
        switch (prog[i].op){
            case opLoad:
                opLOAD(prog[i].v, prog[i].vt);
                break;
            case opStore:
                opSTORE(prog[i].v, prog[i].vt);
                break;
            case opAdd:
                opADD(prog[i].v, prog[i].vt);
                break;
            case opSub:
                opSUB(prog[i].v, prog[i].vt);
                break;
            case opMult:
                opMULT(prog[i].v, prog[i].vt);
                break;
            case opDiv:
                opDIV(prog[i].v, prog[i].vt);
                break;
            case opRead:
                opREAD(prog[i].v, prog[i].vt);
                break;
            case opWrite:
                opWRITE(prog[i].v, prog[i].vt);
                break;
            case opJump:
                opJUMP(prog[i].v, prog[i].vt);
                break;
            case opJgtz:
                opJGTZ(prog[i].v, prog[i].vt);
                break;
            case opJzero:
                opJZERO(prog[i].v, prog[i].vt);
                break;
            case opHALT:
                fclose(fin);
                fclose(fout);
                return 0;
        }
        i++;
    }    
    return 0;   
}    
