program ZB;

{$APPTYPE CONSOLE}

uses
  Windows;

const
  base=1000000000;

type
  TLongInt = record
    a: array [1..10000] of longint;
    l: integer;
  end;

function ShortMul(var x: TLongInt; const y: longint): TLongInt;
var
  i: integer;
  res: TLongInt;
begin
  //time:=GetTickCount;
  res.l:=x.l;
  res.a[1]:=0;
  for i:=1 to x.l do
  begin
    res.a[i]:=res.a[i]+x.a[i]*y;
    if ((i<>x.l) and (res.a[i]>=base)) then
    begin
      res.a[i+1]:=res.a[i] div base;
      res.a[i]:=res.a[i] mod base;
    end else
      res.a[i+1]:=0;
  end;
  while (res.a[res.l]>=base) do
  begin
    res.a[res.l+1]:=res.a[res.l] div base;
    res.a[res.l]:=res.a[res.l] mod base;
    inc(res.l);
  end;
  while ((res.l>0) and (res.a[res.l]=0)) do
    dec(res.l);
  ShortMul:=res;
  //WriteLn('ShortMul: ', (GetTickCount-time)/1000:2:2);
end;

function Less(x, y: TLongInt): boolean;
var
  i: integer;

begin
  //time:=GetTickCount;
  Less:=false;
  if x.l>y.l then
    exit;
  if x.l<y.l then
  begin
    Less:=true;
    exit;
  end;
  for i:=x.l downto 1 do
  begin
    if x.a[i]>y.a[i] then
      exit;
    if x.a[i]<y.a[i] then
    begin
      Less:=true;
      exit;
    end;
  end;
  //WriteLn('Less: ', (GetTickCount-time)/1000:2:2);
end;

procedure LongDec(var x: TLongInt; const y: TLongInt);
var
  i: integer;
begin
  //time:=GetTickCount;
  for i:=1 to y.l do
  begin
    dec(x.a[i], y.a[i]);
    while x.a[i]<0 do
    begin
      inc(x.a[i], base);
      dec(x.a[i+1]);
    end;
  end;
  i:=y.l+1;
  while i<=x.l do
  begin
    while x.a[i]<0 do
    begin
      inc(x.a[i], base);
      dec(x.a[i+1]);
    end;
    inc(i);
  end;
  while ((x.l>0) and (x.a[x.l]=0)) do
    dec(x.l);
  //WriteLn('LongDec: ', (GetTickCount-time)/1000:2:2);
end;

procedure LongInc(var x: TLongInt; const y: TLongInt);
var
  i: integer;
begin
  //time:=GetTickCount;
  if y.l>x.l then
  begin
    for i:=x.l+1 to y.l do
      x.a[i]:=0;
    x.l:=y.l;
  end;
  inc(x.l);
  x.a[x.l+1]:=0;
  for i:=1 to y.l do
  begin
    inc(x.a[i], y.a[i]);
    if x.a[i]>=base then
    begin
      inc(x.a[i+1], x.a[i] div base);
      x.a[i]:=x.a[i] mod base;
    end;
  end;
  i:=y.l+1;
  while i<=x.l do
  begin
    if x.a[i]>=base then
    begin
      inc(x.a[i+1], x.a[i] div base);
      x.a[i]:=x.a[i] mod base;
    end;
    inc(i);
  end;
  while ((x.l>0) and (x.a[x.l]=0)) do
    dec(x.l);
  //WriteLn('LongInc: ', (GetTickCount-time)/1000:2:2);
end;

function LongMod(a, b: TLongInt): TLongInt;
var
  x, y: TLongInt;
  shift, i: integer;
begin
  //time:=GetTickCount;
  shift:=0;
  x:=b;
  y:=a;
  while Less(x, y) do
  begin
    inc(shift);
    inc(x.l);
    for i:=1 to x.l-shift do
      x.a[i+shift]:=b.a[i];
    for i:=1 to shift do
      x.a[i]:=0;
  end;
  if shift>0 then
  begin
    dec(shift);
    dec(x.l);
    for i:=1 to x.l-shift do
      x.a[i+shift]:=b.a[i];
    for i:=1 to shift do
      x.a[i]:=0;
  end;
  while ((shift>0) or not(Less(y, x))) do
  begin
    if (Less(y, x)) then
    begin
      dec(shift);
      dec(x.l);
      for i:=1 to x.l-shift do
        x.a[i+shift]:=b.a[i];
      for i:=1 to shift do
        x.a[i]:=0;
    end else
      if (y.a[y.l] div (x.a[x.l])-1)>0 then
        LongDec(y, ShortMul(x, y.a[y.l] div (x.a[x.l])-1))
      else
        LongDec(y, x);
  end;
  LongMod:=y;
  //WriteLn('LongMod: ', (GetTickCount-time)/1000:2:2);
end;

function LongDiv(a, b: TLongInt): TLongInt;
var
  x, y, res: TLongInt;
  shift, i: integer;
begin
  //time:=GetTickCount;
  shift:=0;
  x:=b;
  y:=a;
  while Less(x, y) do
  begin
    inc(shift);
    inc(x.l);
    for i:=1 to x.l-shift do
      x.a[i+shift]:=b.a[i];
    for i:=1 to shift do
    x.a[i]:=0;
  end;
  if shift>0 then
  begin;
    dec(shift);
    dec(x.l);
    for i:=1 to x.l-shift do
      x.a[i+shift]:=b.a[i];
    for i:=1 to shift do
      x.a[i]:=0;
  end;
  res.l:=shift+1;
  for i:=1 to shift+1 do
    res.a[i]:=0;
  while ((shift>0) or not(Less(y, x))) do
  begin
    if (Less(y, x)) then
    begin
      dec(shift);
      dec(x.l);
      for i:=1 to x.l-shift do
        x.a[i+shift]:=b.a[i];
      for i:=1 to shift do
        x.a[i]:=0;
    end else
      if y.a[y.l] div (x.a[x.l])-1>0 then
      begin
        inc(res.a[shift+1], y.a[y.l] div (x.a[x.l])-1);
        LongDec(y, ShortMul(x, y.a[y.l] div (x.a[x.l])-1));
      end else
      begin
        LongDec(y, x);
        inc(res.a[shift+1], 1);
      end;
  end;
  LongDiv:=res;
  //WriteLn('LongDiv: ', (GetTickCount-time)/1000:2:2);
end;

function NOD(a, b: TLongInt): TLongInt;
var
  x, y, t: TLongInt;
  time: integer;
begin
  //time:=GetTickCount;
  if not(Less(a, b)) then
  begin
    x:=a;
    y:=b;
  end else
  begin
    x:=b;
    y:=a;
  end;
  while y.l>0 do
  begin
    x:=LongMod(x, y);
    t:=x;
    x:=y;
    y:=t;
  end;
  NOD:=x;
  //WriteLn('NOD: ', (GetTickCount-time)/1000:2:2);
end;

function LongMul(x, y: TLongInt): TLongInt;
var
  i, j: integer;
  t, res: TLongInt;
begin
  //time:=GetTickCount;
  res.l:=x.l+y.l;
  for i:=1 to res.l do
    res.a[i]:=0;
  res.l:=0;
  for i:=1 to y.l do
  begin
    t.l:=x.l+i-1;
    for j:=1 to x.l do
      t.a[i+j-1]:=x.a[j];
    for j:=1 to i-1 do
      t.a[j]:=0;
    LongInc(res, ShortMul(t, y.a[i]));
  end;
  while ((res.l>0) and (res.a[res.l]=0)) do
    dec(res.l);
  LongMul:=res;
  //WriteLn('LongMul: ', (GetTickCount-time)/1000:2:2);
end;

var
  i, a, N: longint;
  x, NOK: TLongInt;

begin
  Assign(input, 'lcm.in');
  Assign(output, 'lcm.out');
  Reset(input);
  Rewrite(output);
  ReadLn(n);
  NOK.l:=1;
  NOK.a[1]:=1;
  for i:=1 to N do
  begin
    Read(a);
    x.l:=1;
    x.a[1]:=1;
    x:=ShortMul(x, a);
    {if LongMod(NOK, x).l=0 then
      continue;}
    NOK:=LongDiv(LongMul(x, NOK), NOD(NOK, x));
  end;
  for i:=NOK.l downto 1 do
    Write(NOK.a[i]);
  WriteLn;
  Close(input);
  Close(output);
end.
 