#include <stdio.h>

#define maxn 10100
#define maxm 200100
#define inf (int)2e9

typedef struct
{
  int v, m0, m1, m2;
} hnode;
typedef struct
{
  int v0, v1, w, next;
} edge;

int n, m, hs;
edge e[maxm];
int vnum[maxn], head[maxn];
hnode heap[maxn];

void swap( int i, int j )
{
  hnode tt;

  tt = heap[i], heap[i] = heap[j], heap[j] = tt;
  vnum[heap[i].v] = i, vnum[heap[j].v] = j;
}

hnode norm( hnode a )
{
  if (a.m0 == -1)
    a.m0 = 0;
  if (a.m1 == -1)
    a.m1 = 0;
  if (a.m2 == -1)
    a.m2 = 0;
  return a;
}

int less( hnode a, hnode b )
{
  a = norm(a), b = norm(b);
  return (long long)a.m0 + a.m1 + a.m2 < (long long)b.m0 + b.m1 + b.m2;
}

hnode sum( hnode a, int m )
{
  int t;
  
  if (a.m0 == -1)
    a.m0 = m;
  else if (a.m1 == -1)
    a.m1 = m;
  else if (a.m2 == -1)
    a.m2 = m;
  else if (m > a.m0)
    a.m2 = a.m1, a.m1 = a.m0, a.m0 = m;
  else if (m > a.m1)
    a.m2 = a.m1, a.m1 = m;
  else if (m > a.m2)
    a.m2 = m;
  if (a.m1 > a.m0)
    t = a.m1, a.m1 = a.m0, a.m0 = t;
  if (a.m2 > a.m1)
    t = a.m2, a.m2 = a.m1, a.m1 = t;
  if (a.m1 > a.m0)
    t = a.m1, a.m1 = a.m0, a.m0 = t;
  return a;
}

void siftup( int i )
{
  if (i > 1 && less(heap[i], heap[i >> 1]))
    swap(i, i >> 1), siftup(i >> 1);
}

void siftdown( int i )
{
  int m;

  m = i;
  if ((i << 1) <= hs && less(heap[i << 1], heap[m]))
    m = (i << 1);
  if ((i << 1) + 1 <= hs && less(heap[(i << 1) + 1], heap[m]))
    m = (i << 1) + 1;
  if (i != m)
    swap(i, m), siftdown(m);
}

hnode extmin( void )
{
  swap(1, hs--);
  siftdown(1);
  return heap[hs + 1];
}

int main( void )
{
  int i, a, b;
  hnode mi;

  freopen("customs.in", "rt", stdin);
  freopen("customs.out", "wt", stdout);
  scanf("%d%d", &n, &m);
  for (i = 0; i < n; i++)
    head[i] = -1;
  for (i = 0; i < (m << 1); i += 2)
  {
    scanf("%d%d%d", &e[i].v0, &e[i].v1, &e[i].w);
    e[i].v0--, e[i].v1--;
    e[i + 1].v0 = e[i].v1, e[i + 1].v1 = e[i].v0, e[i + 1].w = e[i].w;
    e[i].next = head[e[i].v0], head[e[i].v0] = i;
    e[i + 1].next = head[e[i + 1].v0], head[e[i + 1].v0] = i + 1;
  }
  for (i = 0; i < n; i++)
    vnum[i] = i + 1;
  for (i = 1; i <= n; i++)
  {
    heap[i].v = i - 1;
    heap[i].m0 = heap[i].m1 = heap[i].m2 = inf;
  }
  hs = n;
  scanf("%d%d", &a, &b);
  a--, b--;
  heap[vnum[a]].m0 = heap[vnum[a]].m1 = heap[vnum[a]].m2 = -1;
  siftup(vnum[a]);
  while (hs > 0)
  {
    mi = extmin();
    for (i = head[mi.v]; i != -1; i = e[i].next)
      if (less(sum(mi, e[i].w), heap[vnum[e[i].v1]]))
      {
        heap[vnum[e[i].v1]] = sum(mi, e[i].w), heap[vnum[e[i].v1]].v = e[i].v1;
        siftup(vnum[e[i].v1]);
      }
  }
  mi = norm(heap[vnum[b]]);
  printf("%Ld", (long long)mi.m0 + mi.m1 + mi.m2);
  return 0;
}

