#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

//#define dbg

#define maxn 1100
#define maxm 1100
#define maxl 1023
#define maxr 1100
#define maxv 32769

#define load   0
#define store  1
#define add    2
#define sub    3
#define mult   4
#define div    5
#define read   6
#define write  7
#define jump   8
#define jgtz   9
#define jzero 10
#define halt  11

int cmd[maxm], oper[maxm], opty[maxm], n, m;
int inp[maxn];
char buf[maxl], buf1[maxl], buf2[maxl];
int reg[maxr];
char num[maxv][10];

int v( int i )
{
  if (opty[i] == 0)
    return oper[i];
  if (opty[i] == 1)
    return reg[oper[i]];
  if (opty[i] == 2)
    return reg[reg[oper[i]]];
  return -1;
}

void print( int a )
{
  if (a < 0)
    putc('-', stdout), a = -a;
  puts(num[a]);
}

void printprep( void )
{
  int i;

  for (i = 0; i < maxv; i++)
    itoa(i, num[i], 10);
}

int main( void )
{
  int i, sp, cn;
#ifdef dbg
  double st;
#endif

  freopen("ram.in", "rt", stdin);
  freopen("ram.out", "wt", stdout);
#ifdef dbg
  st = clock();
#endif
  printprep();
  scanf("%d%d\n", &m, &n);
  for (i = 0; i < m; i++)
  {
    gets(buf);
    sscanf(buf, "%s%s", buf1, buf2);
    if (!strcmp(buf1, "LOAD"))
      cmd[i] = load;
    else if (!strcmp(buf1, "STORE"))
      cmd[i] = store;
    else if (!strcmp(buf1, "ADD"))
      cmd[i] = add;
    else if (!strcmp(buf1, "SUB"))
      cmd[i] = sub;
    else if (!strcmp(buf1, "MULT"))
      cmd[i] = mult;
    else if (!strcmp(buf1, "DIV"))
      cmd[i] = div;
    else if (!strcmp(buf1, "READ"))
      cmd[i] = read;
    else if (!strcmp(buf1, "WRITE"))
      cmd[i] = write;
    else if (!strcmp(buf1, "JUMP"))
      cmd[i] = jump;
    else if (!strcmp(buf1, "JGTZ"))
      cmd[i] = jgtz;
    else if (!strcmp(buf1, "JZERO"))
      cmd[i] = jzero;
    else if (!strcmp(buf1, "HALT"))
      cmd[i] = halt;
    else
      cmd[i] = -1;
    if (cmd[i] != halt)
    {
      if (buf2[0] == '=')
        opty[i] = 0, sscanf(buf2 + 1, "%d", &oper[i]);
      else if (buf2[0] == '*')
        opty[i] = 2, sscanf(buf2 + 1, "%d", &oper[i]);
      else
        opty[i] = 1, sscanf(buf2, "%d", &oper[i]);
    }
  }
  for (i = 0; i < n; i++)
    scanf("%d", &inp[i]);
  sp = cn = 0;
  while (cmd[sp] != halt && sp < m)
  {
    if (cmd[sp] == load)
      reg[0] = v(sp);
    else if (cmd[sp] == store)
    {
      if (opty[sp] == 1)
        reg[oper[sp]] = reg[0];
      else
        reg[reg[oper[sp]]] = reg[0];
    }
    else if (cmd[sp] == add)
      reg[0] += v(sp);
    else if (cmd[sp] == sub)
      reg[0] -= v(sp);
    else if (cmd[sp] == mult)
      reg[0] *= v(sp);
    else if (cmd[sp] == div)
      reg[0] /= v(sp);
    else if (cmd[sp] == read)
    {
      if (opty[sp] == 1)
        reg[oper[sp]] = inp[cn++];
      else
        reg[reg[oper[sp]]] = inp[cn++];
    }
    else if (cmd[sp] == write)
      print(v(sp));
//      printf("%d\n", v(sp));
    else if (cmd[sp] == jump)
      sp = oper[sp] - 1;
    else if (cmd[sp] == jgtz)
    {
      if (reg[0] > 0)
        sp = oper[sp] - 1;
    }
    else if (cmd[sp] == jzero)
    {
      if (reg[0] == 0)
        sp = oper[sp] - 1;
    }
    sp++;
  }
#ifdef dbg
  st = (clock() - st) / CLOCKS_PER_SEC;
  fprintf(stderr, "time: %.3lf", st);
#endif
  return 0;
}
