#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <time.h>

#define dbg

#define maxt 18000000
#define maxn 310
#define pi 3.1415926536

typedef struct
{
  double x, y, phi;
} point;

int n;
point p[maxn], c;
int res[maxn][maxn];
int totm;
short lefta[maxn][maxn][maxn];

void sort( int l, int r )
{
  int i, j;
  double x;
  point t;

  if (l >= r)
    return;
  x = p[l + (rand() % (r - l + 1))].phi;
  i = l, j = r;
  while (i <= j)
  {
    while (p[i].phi < x)
      i++;
    while (p[j].phi > x)
      j--;
    if (i <= j)
    {
      t = p[i], p[i] = p[j], p[j] = t;
      i++, j--;
    }
  }
  sort(l, j);
  sort(i, r);
}

int left( int i0, int i1, int i2 )
{
  point p0, p1, p2;

  if (lefta[i0][i1][i2])
    return lefta[i0][i1][i2] - 1;
  p0 = p[i0], p1 = p[i1], p2 = p[i2];
  p1.x -= p0.x, p1.y -= p0.y, p2.x -= p0.x, p2.y -= p0.y;
  lefta[i0][i1][i2] = (p1.x * p2.y - p2.x * p1.y < 0) + 1;
  return lefta[i0][i1][i2] - 1;
}

int main( void )
{
  int i, j, k, l, o, tt;
#ifdef dbg
  int tim;
#endif

#ifdef dbg
  tim = clock();
#endif
  tt = 0;
  freopen("polygon.in", "rt", stdin);
  freopen("polygon.out", "wt", stdout);
  memset(lefta, 0, sizeof(lefta));
  scanf("%d", &n);
  c.x = c.y = 0;
  for (i = 0; i < n; i++)
    scanf("%lf%lf", &p[i].x, &p[i].y), c.x += p[i].x, c.y += p[i].y;
  c.x /= n, c.y /= n;
  for (i = 0; i < n; i++)
    p[i].phi = atan2(p[i].y - c.y, p[i].x - c.x);
  for (i = 0; i < n; i++)
    if (p[i].phi < 0)
      p[i].phi += 2 * pi;
  sort(0, n - 1);
  totm = 0;
  for (i = 0; i < n; i++)
    for (j = i + 1; j < n; j++)
    {
      if (totm == n)
        break;
      res[i][j] = 2;
      for (k = i + 1; k < n; k++)
        for (l = i + 2; l < n; l++)
          res[k][l] = -1;
      for (k = i; k < n; k++)
        for (l = k + 1; l < n; l++, tt++)
          if (res[k][l] != -1)
            for (o = l + 1; o < n; o++, tt++)
              if (left(k, o, l) && res[l][o] < res[k][l] + 1)
                res[l][o] = res[k][l] + 1;
      for (k = i; k < n; k++)
        for (l = k + 1; l < n; l++)
          if (left(k, i, l) && left(l, j, i) && res[k][l] > totm)
            totm = res[k][l];
      if (totm == n || tt >= maxt)
        break;
    }
  printf("%d", totm);
#ifdef dbg
  fprintf(stderr, "%.3lf\n", (double)(clock() - tim) / CLOCKS_PER_SEC);
#endif
  return 0;
}
