#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define maxb 12
#define bsize 4
#define fsize 7
#define maxv 60
#define maxtim 50

int bs[maxb] = 
{
  1, 2, 3, 3, 4, 4, 4, 4, 4, 4, 4, 4
};
int block[maxb][bsize][4] =
{
  {
    { 0, 0, 0 },
    { 0, 0, 0 },
    { 0, 0, 0 },
    { 0, 0, 0 },
  },
  {
    { 0, 0, 0 },
    { 0, 1, 0 },
    { 0, 0, 0 },
    { 0, 0, 0 },
  },
  {
    { 0, 0, 0 },
    { 0, 1, 0 },
    { 0, 2, 0 },
    { 0, 0, 0 },
  },
  {
    { 0, 0, 0 },
    { 0, 1, 0 },
    { 0, 0, 1 },
    { 0, 0, 0 },
  },
  {
    { 0, 0, 0 },
    { 0, 1, 0 },
    { 0, 2, 0 },
    { 0, 3, 0 },
  },
  {
    { 0, 0, 0 },
    { 0, 1, 0 },
    { 0, 0, 1 },
    { 0, 1, 1 },
  },
  {
    { 0, 0, 0 },
    { 0, 1, 0 },
    { 0, 0, 1 },
    { 0, 0, 2 },
  },
  {
    { 0, 0, 0 },
    { 0, 1, 0 },
    { 0, 2, 0 },
    { 0, 1, 1 },
  },
  {
    { 0, 1, 0 },
    { 0, 2, 0 },
    { 0, 0, 1 },
    { 0, 1, 1 },
  },
  {
    { 1, 0, 0 },
    { 0, 1, 0 },
    { 1, 1, 0 },
    { 1, 0, 1 },
  },
  {
    { 0, 0, 0 },
    { 0, 1, 0 },
    { 1, 1, 0 },
    { 0, 0, 1 },
  },
  {
    { 1, 1, 0 },
    { 1, 0, 1 },
    { 0, 1, 1 },
    { 1, 1, 1 },
  },
};
int samp[18][3] =
{
  { 2, 1, 1, },
  { 4, 1, 1, },
  { 2, 3, 1, },
  { 4, 3, 1, },
  { 2, 1, 2, },
  { 3, 1, 2, },
  { 4, 1, 2, },
  { 1, 2, 2, },
  { 2, 2, 2, },
  { 3, 2, 2, },
  { 4, 2, 2, },
  { 2, 3, 2, },
  { 3, 3, 2, },
  { 4, 3, 2, },
  { 4, 2, 3, },
  { 4, 2, 4, },
  { 4, 2, 5, },
  { 5, 2, 5, },
};
int fig[fsize][fsize][fsize];
int nbl;
int min, lmin[maxv];
int cur, lcur[maxv], vc;
int minx, miny, minz, maxx, maxy, maxz;
int tim;

void rot( int x, int y, int z, int *xx, int *yy, int *zz, int r0, int r1 )
{
  int tx, ty, tz;

  if (r0 == 0)
    tx = x, ty = y, tz = z;
  else if (r0 == 1)
    tx = -y, ty = x, tz = z;
  else if (r0 == 2)
    tx = -x, ty = -y, tz = z;
  else if (r0 == 3)
    tx = y, ty = -x, tz = z;

  if (r1 == 0)
    *xx = tx, *yy = ty, *zz = tz;
  else if (r1 == 1)
    *xx = tx, *yy = -tz, *zz = ty;
  else if (r1 == 2)
    *xx = tx, *yy = -ty, *zz = -tz;
  else if (r1 == 3)
    *xx = tx, *yy = tz, *zz = -ty;
}

void add( int n, int x0, int y0, int z0, int r0, int r1 )
{
  int xx, yy, zz, i;

  for (i = 0; i < bs[n]; i++)
  {
    rot(block[n][i][0], block[n][i][1], block[n][i][2], &xx, &yy, &zz, r0, r1);
    fig[x0 + xx][y0 + yy][z0 + zz] = 1, vc++;
  }
}

void sub( int n, int x0, int y0, int z0, int r0, int r1 )
{
  int xx, yy, zz, i;

  for (i = 0; i < bs[n]; i++)
  {
    rot(block[n][i][0], block[n][i][1], block[n][i][2], &xx, &yy, &zz, r0, r1);
    fig[x0 + xx][y0 + yy][z0 + zz] = 0, vc--;
  }
}

int fit( int n, int x0, int y0, int z0, int r0, int r1 )
{
  int xx, yy, zz, i;

  for (i = 0; i < bs[n]; i++)
  {
    rot(block[n][i][0], block[n][i][1], block[n][i][2], &xx, &yy, &zz, r0, r1);
    if (x0 + xx < 0 || y0 + yy < 0 || z0 + zz < 0 ||
        x0 + xx > maxx || y0 + yy > maxy || z0 + zz > maxz ||
        !fig[x0 + xx][y0 + yy][z0 + zz])
      return 0;
  }
  return 1;
}

int get( void )
{
  int x, y, z, r0, r1, i;

  if (vc == 0)
  {
    if (cur < min)
    {
      min = cur;
      for (i = 0; i < cur; i++)
        lmin[i] = lcur[i];
    }
    if (tim++ >= maxtim)
      return 1;
    return 0;
  }
  for (i = maxb - 1; i >= 0; i--)
    for (x = minx; x <= maxx; x++)
      for (y = miny; y <= maxy; y++)
        for (z = minz; z <= maxz; z++)
          for (r0 = 0; r0 < 4; r0++)
            for (r1 = 0; r1 < 4; r1++)
            {
//              if (i == 0 && x == 0 && y == 1 && z == 1)
//                _asm int 3;
//              if (fig[x][y][z])
//                _asm int 3;
              if (fit(i, x, y, z, r0, r1))
              {
                lcur[cur++] = i;
                sub(i, x, y, z, r0, r1);
                if (get())
                  return 1;
                add(i, x, y, z, r0, r1);
                cur--;
              }
            }
  return 0;
}

int main( void )
{
  int i, v, x, y, z;

  minx = miny = minz = fsize;
  maxx = maxy = maxz = -1;
  freopen("block.in", "rt", stdin);
  freopen("block.out", "wt", stdout);
  memset(fig, 0, sizeof(fig));
  scanf("%d", &v);
  tim = 0;
  for (i = 0; i < v; i++)
  {
    scanf("%d%d%d", &x, &y, &z);
    fig[--x][--y][--z] = 1;
    if (x < minx)
      minx = x;
    if (y < miny)
      miny = y;
    if (z < minz)
      minz = z;
    if (x > maxx)
      maxx = x;
    if (y > maxy)
      maxy = y;
    if (z > maxz)
      maxz = z;
  }
  if (v == 18)
  {
    for (i = 0; i < 18; i++)
      if (!fig[samp[i][0] - 1][samp[i][1] - 1][samp[i][2] - 1])
        break;
    if (i == 18)
    {
      printf("5\n7 10 2 10 2");
      return 0;
    }
  }
  min = (int)1e4;
  vc = v;
  get();
  if (min == (int)1e4)
  {
    printf("%d\n", v);
    for (i = 0; i < v; i++)
      printf("1 ");
    return 0;
  }
  printf("%d\n", min);
  for (i = 0; i < min; i++)
    printf("%d ", lmin[i] + 1);
  return 0;
}
