#include <stdio.h>
#include <string.h>

#define maxn 2100
#define maxpa 3500
#define maxp 30
#define maxl 2000
#define base 100000000

int n, a[maxn];
int np, pr[maxpa];
int pp[maxn][maxp], dp[maxn][maxp], npp[maxn];
long long res[maxl];

void genpr( void )
{
  int i, j;

  np = 0;
  pr[np++] = 2;
  for (i = 3; np < maxpa; i++)
  {
    for (j = 0; j < np; j++)
      if (!(i % pr[j]))
        break;
    if (j == np)
      pr[np++] = i;
  }
}

void topr( int a, int *ar, int *dp, int *num )
{
  int i;

  *num = 0;
  for (i = 0; i < maxpa && a > 1; i++)
    if (!(a % pr[i]))
    {
      ar[*num] = pr[i], dp[*num] = 0;
      while (a && !(a % pr[i]))
        dp[*num]++, a /= pr[i];
      (*num)++;
    }
  if (a > 1)
    ar[*num] = a, dp[(*num)++] = 1;
}

void mul( long long *a, int k )
{
  int i;

  for (i = 0; i < maxl; i++)
    a[i] *= k;
  for (i = 0; i < maxl - 1; i++)
    a[i + 1] += a[i] / base, a[i] %= base;
}

void print( long long *a )
{
  int i;

  for (i = maxl - 1; i >= 0 && !a[i]; i--)
    ;
  if (i < 0)
    printf("0");
  else
  {
    printf("%d", a[i]);
    for (i--; i >= 0; i--)
      printf("%08Ld", a[i]);
  }
}

#ifdef dbg
void printnum( int *pp, int *dp, int n )
{
  int i;

  for (i = 0; i < n; i++)
    printf("%d^%d * ", pp[i], dp[i]);
  printf("\n");
}
#endif

int main( void )
{
  int i, j, k, l;

  freopen("lcm.in", "rt", stdin);
  freopen("lcm.out", "wt", stdout);
  scanf("%d", &n);
  for (i = 0; i < n; i++)
    scanf("%d", &a[i]);
  if (n == 1)
  {
    printf("%d", a[0]);
    return 0;
  }
  genpr();
#ifdef dbg
  printf("%d\n", np);
  for (i = 0; i < np; i++)
    printf("%d ", pr[i]);
  printf("\n");
#endif
  for (i = 0; i < n; i++)
    topr(a[i], pp[i], dp[i], &npp[i]);
#ifdef dbg
  for (i = 0; i < n; i++)
  {
    printf("number #%d: ", i);
    printnum(pp[i], dp[i], npp[i]);
  }
#endif
/*
  for (i = 1; i < n; i++)
  {
    for (k = 0; k < ngp; k++)
    {
      for (j = 0; j < npp[i]; j++)
        if (pp[i][j] == gp[k])
          break;
      if (j == npp[i])
        dgp[k] = 0;
      else
      {
        if (dgp[k] > dp[i][j])
          dgp[k] = dp[i][j];
      }
    }
  }
  for (k = 0; k < ngp; k++)
    if (dgp[k] != 0 && gp[k] != 1)
    {
      for (j = 0; j < npp[0]; j++)
        if (pp[0][j] == gp[k])
          break;
      dp[0][j] -= dgp[k];
    }
*/
  for (i = 0; i < n; i++)
    for (j = i + 1; j < n; j++)
    {
      for (k = l = 0; k < npp[i] && l < npp[j];)
        if (pp[i][k] < pp[j][l])
          k++;
        else if (pp[i][k] > pp[j][l])
          l++;
        else
        {
          if (dp[i][k] > dp[j][l])
            dp[j][l] = 0;
          else
            dp[i][k] = 0;
          k++, l++;
        }
    }
  memset(res, 0, sizeof(res));
  res[0] = 1;
  for (i = 0; i < n; i++)
    for (j = 0; j < npp[i]; j++)
      for (k = 0; k < dp[i][j]; k++)
        mul(res, pp[i][j]);
  print(res);
  return 0;
}
