#include <stdio.h>
#include <string.h>

//#define dbg

#define maxn 15

int n, m;
int c[maxn][maxn], d[maxn], co[maxn][maxn];
int nc, u[maxn], u0[maxn];
int num, col[maxn], cur[maxn];
long long res[maxn], tot[maxn];
long long coef[maxn][maxn], x[maxn];

long long gcd( long long a, long long b )
{
  if (!b)
    return a;
  return gcd(b, a % b);
}

void dfs( int v, int co )
{
  int i;

  u[v] = 1, col[v] = co;
  for (i = 0; i < d[v]; i++)
    if (!u[c[v][i]])
      dfs(c[v][i], co);
}

void search( int v, int col )
{
  int i, j;

  if (v == n)
  {
    res[col]++;
    return;
  }
  u[v] = 1, num++;
  for (i = 0; i < nc; i++)
  {
    for (j = 0; j < d[v]; j++)
      if (u[c[v][j]] && cur[c[v][j]] == i)
        break;
    if (j == d[v])
      cur[v] = i, search(v + 1, col);
  }
  u[v] = 0;
}

int main( void )
{
  int i, j, k, a, b;

  freopen("chrom.in", "rt", stdin);
  freopen("chrom.out", "wt", stdout);
  memset(co, 0, sizeof(co));
  memset(d, 0, sizeof(d));
  memset(res, 0, sizeof(res));
  scanf("%d%d", &n, &m);
  for (i = 0; i < m; i++)
  {
    scanf("%d%d", &a, &b);
    a--, b--;
    if (!co[a][b])
      co[a][b] = 1, c[a][d[a]++] = b, c[b][d[b]++] = a;
  }
  memset(u, 0, sizeof(u));
  for (i = a = 0; i < n; i++)
    if (!u[i])
      dfs(i, a++);
  for (nc = 0; nc <= n; nc++)
  {
    memset(u, 0, sizeof(u));
    memset(u0, 0, sizeof(u0));
    memset(res, 0, sizeof(res));
    for (i = 0; i < n; i++)
      if (!u0[col[i]])
        u0[col[i]] = 1, search(i, col[i]);
    tot[nc] = 1;
    for (i = 0; i < a; i++)
      tot[nc] *= res[i];
    coef[nc][0] = 1;
    for (i = 1; i <= n; i++)
      coef[nc][i] = coef[nc][i - 1] * nc;
  }
#ifdef dbg
  for (i = 0; i <= n; i++)
  {
    for (j = 0; j <= n; j++)
      printf("%Ld * A%d + ", coef[i][j], j);
    printf(" == %Ld\n", tot[i]);
  }
#endif
  for (i = 0; i <= n; i++)
  {
    for (j = i + 1; j <= n; j++)
    {
      a = coef[i][i] / gcd(coef[i][i], coef[j][i]);
      b = coef[j][i] / gcd(coef[i][i], coef[j][i]);
      for (k = 0; k <= n; k++)
        coef[j][k] *= a, coef[i][k] *= b;
      for (k = 0; k <= n; k++)
        coef[j][k] -= coef[i][k];
      for (k = 0; k <= n; k++)
        coef[i][k] /= b;
    }
  }
  for (i = n; i >= 0; i--)
  {
    for (j = i + 1; j <= n; j++)
      tot[i] -= coef[i][j] * x[j];
    x[i] = tot[i] / coef[i][i];
  }
  for (; n >= 0 && !x[n]; n--)
    ;
  printf("%d", n);
  for (i = 0; i <= n; i++)
    printf(" %Ld", x[i]);
  return 0;
}

