#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STR_SIZE 24

template <class TElem> void sift(const TElem**,int,int);
template <class TElem> void sort(const TElem**,int);

struct TEntry {
  char lastname[STR_SIZE],firstname[STR_SIZE];
  int id;
  int operator<(const TEntry&) const;
};

int n_entrs;
TEntry*entrs,**p_entrs;

int main(void) {
  #ifndef OFFLINE
  freopen("sort.in","rt",stdin);
  freopen("sort.out","wt",stdout);
  #endif
  int i_entr;
  scanf("%d",&n_entrs);
  entrs=new TEntry[n_entrs]; p_entrs=new TEntry*[n_entrs];
  for (i_entr=0; i_entr<n_entrs; i_entr++) {
    scanf("%s%s",entrs[i_entr].lastname,entrs[i_entr].firstname);
    entrs[i_entr].id=i_entr;
    p_entrs[i_entr]=&entrs[i_entr];
  }
  sort((const TEntry**)p_entrs,n_entrs);
  printf("%d\n",n_entrs);
  for (i_entr=0; i_entr<n_entrs; i_entr++) printf("%s %s\n",
    p_entrs[i_entr]->lastname,p_entrs[i_entr]->firstname);
  delete[]entrs;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


int TEntry::operator<(const TEntry&arg) const {
  int res=strcmp(lastname,arg.lastname);
  if (res) return(res<0); else return(id<arg.id);
}


template <class TElem>
void sift(const TElem**a,int v,int w) {
  int i,j; const TElem*z;
  i=v; j=(v<<1)+1;
  z=a[i];
  while (j<=w) {
    if (j<w) if ((*a[j])<(*a[j+1])) j++;
    if (!((*z)<(*a[j]))) break;
    a[i]=a[j];
    i=j; j=(j<<1)+1;
  }
  a[i]=z;
}
template <class TElem>
void sort(const TElem**a,int n) {
  int i,j; const TElem*z;
  for (i=n>>1,j=n-1; i>0; i--) sift(a,i,j);
  for (; j>0; j--) { sift(a,i,j);
    z=a[i]; a[i]=a[j]; a[j]=z;
  }
}



