#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define INF 1e100L

int n_verts,n_cells;
long double*mtrx_cont,**mtrx,*bckp_cont,**bckp;

int main(void) {
  #ifndef OFFLINE
  freopen("floyd.in","rt",stdin);
  freopen("floyd.out","wt",stdout);
  #endif
  int v,w,u; long double dist;
  scanf("%d",&n_verts);
  mtrx_cont=new long double[n_cells=n_verts*n_verts];
  bckp_cont=new long double[n_cells=n_verts*n_verts];
  mtrx=new long double*[n_verts];
  bckp=new long double*[n_verts];
  for (v=0,w=0; v<n_verts; v++,w+=n_verts) {
    mtrx[v]=&mtrx_cont[w];
    bckp[v]=&bckp_cont[w];
  }
  for (v=0; v<n_verts; v++) for (w=0; w<n_verts; w++) {
    scanf("%Lf",&mtrx[v][w]);
    if (!mtrx[v][w]) mtrx[v][w]=INF;
  }
  for (u=0; u<n_verts; u++)
   for (v=0; v<n_verts; v++) for (w=0; w<n_verts; w++) {
    dist=mtrx[v][u]+mtrx[u][w];
    if (mtrx[v][w]>dist) mtrx[v][w]=dist;
  }
  memcpy(bckp_cont,mtrx_cont,sizeof(long double)*n_cells);
  for (u=0; u<n_verts; u++)
   for (v=0; v<n_verts; v++) for (w=0; w<n_verts; w++) {
    dist=bckp[v][u]+bckp[u][w];
    if (bckp[v][w]>dist) bckp[v][w]=dist;
  }
  #ifdef DEBUG
  for (v=0; v<n_verts; v++) {
    for (w=0; w<n_verts; w++) {
      if (w) printf(" ");
      if (mtrx[v][w]<INF) printf("%Lf",mtrx[v][w]);
      else printf("-");
    } printf("\n");
  } printf("\n");
  for (v=0; v<n_verts; v++) {
    for (w=0; w<n_verts; w++) {
      if (w) printf(" ");
      if (bckp[v][w]<INF) printf("%Lf",bckp[v][w]);
      else printf("-");
    } printf("\n");
  } printf("\n");
  #endif
  for (v=0; v<n_verts; v++) {
    for (w=0; w<n_verts; w++) {
      if (w) printf(" ");
      if (mtrx[v][w]<INF) {
        if (bckp[v][w]>=mtrx[v][w]) printf("1");
        else printf("2");
      } else printf("0");
    } printf("\n");
  }
  delete[]mtrx_cont; delete[]mtrx;
  delete[]bckp_cont; delete[]bckp;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


