{$I-,Q-,R-,S-}

const
  IN_FILE = 'floyd.in';
  OUT_FILE = 'floyd.out';

  MAXN = 120;

  INFINITE = 100000000;

type
  Integer = Longint;

var
  n: Integer;
  a, b, ans: array[1..MAXN, 1..MAXN] of Integer;

procedure Init();
var
  i, j: Integer;
begin
  Assign(Input, IN_FILE);
  Reset(Input);
  Assign(Output, OUT_FILE);
  Rewrite(Output);

  Read(n);
  for i := 1 to n do
    for j := 1 to n do
    begin
      Read(a[i, j]);
      if a[i, j] = 0 then
      begin
        {if i = j then b[i, j] := 0 else} b[i, j] := INFINITE;
      end else
        b[i, j] := a[i, j];
    end;
end;

procedure Solve();
var
  k, i, j: Integer;
begin
  for k := 1 to n do
    for i := 1 to n do
      for j := 1 to n do if (b[i, k] < INFINITE) and (b[k, j] < INFINITE) then
        if b[i, j] > b[i, k] + b[k, j] then
          b[i, j] := b[i, k] + b[k, j];

  ans := b;

  for i := 1 to n do
    for j := 1 to n do
      for k := 1 to n do
        if (b[i, k] < INFINITE) and (b[k, k] < 0) and (b[k, j] < INFINITE) then
          ans[i, j] := -INFINITE;

  for i := 1 to n do
  begin
    for j := 1 to n do
      case ans[i, j] of
        INFINITE: Write(0, ' ');
        -INFINITE: Write(2, ' ');
        else Write(1, ' ');
      end;
      Writeln;
    end;
end;

procedure Done();
begin
  Close(Input);
  Close(Output);
end;

begin
  Init();
  Solve();
  Done();
end.
