const
     FileIn='twohorse.in';
     FileOut='twohorse.out';
     MaxX=8;
     MaxY=8;
     MaxMovesCount=16;
type
    TMove=record
                DeltaX, DeltaY: LongInt;
          end;
var
   Nodes: array [1..MaxX, 1..MaxY, 1..MaxX, 1..MaxY] of LongInt;
   StartX1, StartY1, StartX2, StartY2: LongInt;
   Answer: LongInt;
   MovesCount: LongInt;
   Moves: array [1..MaxMovesCount] of TMove;

procedure ReadData;
var
   F: Text;
   Ch: Char;
begin
     Assign (F, FileIn);
     Reset (F);
     Read (F, Ch);
     StartX1:=Ord (Ch)-Ord ('a')+1;
     Read (F, StartY1);
     Read (F, Ch);
     while not (Ch in ['a'..'z'])
           do Read (F, Ch);
     StartX2:=Ord (Ch)-Ord ('a')+1;
     Read (F, StartY2);
     Close (F);
end;

procedure WriteData;
var
   F: Text;
begin
     Assign (F, FileOut);
     Rewrite (F);
     Writeln (F, Answer);
     Close (F);
end;

type
    TItem=record
                X1, Y1, X2, Y2: LongInt;
          end;
var
   FIFO: array [1..MaxX*MaxY*MaxX*MaxY] of TItem;
   FIFOLen, FIFOIndex: LongInt;

procedure BFS;
var
   X1, Y1, X2, Y2: LongInt;

procedure Push (aX1, aY1, aX2, aY2: LongInt);
begin
     if (aX1>=1) and (aX1<=MaxX) and (aY1>=1) and (aY1<=MaxY) and
        (aX2>=1) and (aX2<=MaxX) and (aY2>=1) and (aY2<=MaxY)
        then if Nodes [aX1, aY1, aX2, aY2]<0
                then begin
                     Nodes [aX1, aY1, aX2, aY2]:=Nodes [X1, Y1, X2, Y2]+1;
                     Inc (FIFOLen);
                     FIFO [FIFOLen].X1:=aX1;
                     FIFO [FIFOLen].Y1:=aY1;
                     FIFO [FIFOLen].X2:=aX2;
                     FIFO [FIFOLen].Y2:=aY2;
                end;
end;

var
   Move1, Move2: LongInt;
begin
     for X1:=1 to MaxX
         do for Y1:=1 to MaxY
                do for X2:=1 to MaxX
                       do for Y2:=1 to MaxY
                              do Nodes [X1, Y1, X2, Y2]:=-1;
     X1:=StartX1;
     Y1:=StartY1;
     X2:=StartX2;
     Y2:=StartY2;
     Push (X1, Y1, X2, Y2);
     FIFOIndex:=FIFOLen;
     while FIFOIndex<=FIFOLen
           do begin
              X1:=FIFO [FIFOIndex].X1;
              Y1:=FIFO [FIFOIndex].Y1;
              X2:=FIFO [FIFOIndex].X2;
              Y2:=FIFO [FIFOIndex].Y2;
              for Move1:=1 to MovesCount
                  do for Move2:=1 to MovesCount
                         do Push (X1+Moves [Move1].DeltaX, Y1+Moves [Move1].DeltaY, X2+Moves [Move2].DeltaX, Y2+Moves [Move2].DeltaY);
              Inc (FIFOIndex);
           end;
end;

procedure AddMove (aDeltaX, aDeltaY: LongInt);
begin
     Inc (MovesCount);
     Moves [MovesCount].DeltaX:=aDeltaX;
     Moves [MovesCount].DeltaY:=aDeltaY;
end;

procedure Solve;
var
   X, Y: LongInt;
begin
     MovesCount:=0;
     AddMove (-1, -2);
     AddMove (-1, 2);
     AddMove (1, -2);
     AddMove (1, 2);
     AddMove (-2, -1);
     AddMove (-2, 1);
     AddMove (2, -1);
     AddMove (2, 1);
     BFS;
     Answer:=-1;
     for X:=1 to MaxX
         do for Y:=1 to MaxY
                do if (Nodes [X, Y, X, Y]<Answer) or (Answer<0)
                      then Answer:=Nodes [X, Y, X, Y];
end;

begin
     ReadData;
     Solve;
     WriteData;
end.
