{$I-,Q-,R-,S-}

const
  IN_FILE = 'twohorse.in';
  OUT_FILE = 'twohorse.out';

  MAXP = 10000;

  di: array[1..8] of Integer = (-2, -1, 1, 2, 2, 1, -1, -2);
  dj: array[1..8] of Integer = (1, 2, 2, 1, -1, -2, -2, -1);

type
  Integer = Longint;

  TPoint = record
    i, j: Integer;
  end;

  TPos = record
    p1, p2: TPoint;
  end;

var
  p: TPos;
  Queue: array[1..MAXP] of TPos;
  NNew: array[1..8, 1..8, 1..8, 1..8] of Boolean;

function ReadPoint(): TPoint;
var
  p: TPoint;
  Ch: Char;
begin
  Read(Ch);
  while not (Ch in ['a'..'h']) do Read(Ch);
  p.i := Ord(Ch) - Ord('a') + 1;
  Read(Ch);
  p.j := Ord(Ch) - 48;

  ReadPoint := p;
end;

procedure Init();
begin
  Assign(Input, IN_FILE);
  Reset(Input);
  Assign(Output, OUT_FILE);
  Rewrite(Output);

  p.p1 := ReadPoint();
  p.p2 := ReadPoint();
end;

function Exists(const p: TPos): Boolean;
begin
  Exists := NNew[p.p1.i, p.p1.j, p.p2.i, p.p2.j];
end;

procedure Apply(const p: TPos);
begin
  NNew[p.p1.i, p.p1.j, p.p2.i, p.p2.j] := True;
end;

procedure Done();
begin
  Close(Input);
  Close(Output);
end;

function EqPoint(const p1, p2: TPoint): Boolean;
begin
  EqPoint := (p1.i = p2.i) and (p1.j = p2.j);
end;

function IsOk(const p: TPoint): Boolean;
begin
  IsOk := (p.i > 0) and (p.i <= 8) and (p.j > 0) and (p.j <= 8);
end;

procedure Solve();
var
  l, r, Link: Integer;
  tp, np: TPos;
  i, j, t1, t2, q: Integer;
begin
  Queue[1] := p;
  l := 1;
  q := 0;
  r := 1;
  Link := 1;
  while (l <= r) do
  begin
    for i := l to r do
    begin
      tp := Queue[i];

      if EqPoint(tp.p1, tp.p2) then
      begin
        Writeln(q);
        Done();
        Halt;
      end;

      for t1 := 1 to 8 do
        for t2 := 1 to 8 do
        begin
          np.p1.i := tp.p1.i + di[t1];
          np.p1.j := tp.p1.j + dj[t1];
          np.p2.i := tp.p2.i + di[t2];
          np.p2.j := tp.p2.j + dj[t2];
          if IsOk(np.p1) and IsOk(np.p2) then
          if not Exists(np) then
          begin
            Apply(np);
            Inc(Link);
            Queue[Link] := np;
          end;
        end;
    end;

    l := r + 1;
    r := Link;
    Inc(q);
  end;
end;

begin
  Init();
  Solve();
  Writeln(-1);
  Done();
end.
