#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define STR_SIZE 262143

void calcprefix(int*prefix,const char*str,int len) {
  int match,pos;
  *prefix=match=0;
  for (pos=1; pos<len; pos++) {
    prefix[pos]=match;
    while (str[pos]!=str[match]) {
      if (match<=0) break;
      match=prefix[match];
    } if (str[pos]==str[match]) match++;
  } prefix[pos]=match;
}
void printins(const char*str,const char*text,const int*prefix,int len) {
  int match,pos;
  match=0;
  for (pos=0; *text; text++,pos++) {
    if (match>=len) printf("%d\n",pos-match+1);
    while (*text!=str[match]) {
      if (match<=0) break;
      match=prefix[match];
    } if (*text==str[match]) match++;
  } if (match>=len) printf("%d\n",pos-match+1);
}

char*str,*text;
int str_len,text_len;
int*prefix;

int main(void) {
  #ifndef OFFLINE
  freopen("substr.in","rt",stdin);
  freopen("substr.out","wt",stdout);
  #endif
  text=str=new char[STR_SIZE]; str_len=0;
  while (fgets(text,sizeof(char)*(STR_SIZE-str_len),stdin)) {
    for (; *text; text++) if ((*text>32)&&(*text<127)) str[str_len++]=*text;
    text=&str[str_len];
  } str[str_len]=0;
  text=strchr(str,'*'); *(text++)=0;
  str_len=strlen(str); text_len=strlen(text);
  #ifdef DEBUG
  printf("%d %s\n",str_len,str);
  printf("%d %s\n",text_len,text);
  #endif
  prefix=new int[str_len+1];
  calcprefix(prefix,str,str_len);
  printins(str,text,prefix,str_len);
  delete[]prefix;
  delete[]str;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


