uses Math;
//{$H+}
const
     FileIn='formatting.in';
     FileOut='formatting.out';
     MaxRowsCount=110;
     MaxColumnsCount=100;
var
   F: Text;
   Align: string;
   RowsCount: LongInt;
   Rows: array [1..MaxRowsCount] of string;
   Widths: array [1..MaxColumnsCount] of LongInt;

procedure ReadData;
begin
     Assign (F, FileIn);
     Reset (F);
     Readln (F, Align);
     RowsCount:=0;
     while not SeekEOF (F)
           do begin
              Inc (RowsCount);
              Readln (F, Rows [RowsCount]);
           end;
     Close (F);
end;

procedure CalcWidths;
var
   NRow, NColumn: LongInt;
   Start, Finish, NChar: LongInt;
begin
     FillChar (Widths, SizeOf (Widths), 0);
     for NRow:=1 to RowsCount
         do begin
            Start:=1;
            for NColumn:=1 to Length (Align)
                do begin
                   for NChar:=Start to Length (Rows [NRow])
                       do if ROws [NRow] [NCHar]='&'
                             then Break;
                   if Rows [NRow] [NChar]='&'
                      then Finish:=NChar-1
                      else Finish:=NChar;
                   Widths [NColumn]:=Max (Widths [NColumn], Finish-Start+1);
                   Start:=Finish+2;
                end;
         end;
end;

function MakeMeStringOf (aCh: Char; aLength: LongInt): string;
var
   S: string;
   Index: LongInt;
begin
     SetLength (S, aLength);
     for Index:=1 to aLength
         do S [Index]:=aCh;
     MakeMeStringOf:=S;
end;

procedure PrintBreak;
var
   NColumn: LongInt;
   S: string;
begin
     for NColumn:=1 to Length (Align)
         do Write (F, '+', MakeMeStringOf ('-', WIdths [NColumn]+2));
     Writeln (F, '+');
end;

function MakeLeft (const aEntry: string; aWidth: LongInt): string;
begin
     MakeLeft:=aEntry+MakeMeStringOf (#32, aWidth-Length (aEntry));
end;

function MakeRight (const aEntry: string; aWidth: LongInt): string;
begin
     MakeRight:=MakeMeStringOf (#32, aWidth-Length (aEntry))+aEntry;
end;

function MakeCenter (const aEntry: string; aWidth: LongInt): string;
var
   S: string;
begin
     S:=MakeMeStringOf (#32, aWidth-Length (aEntry));
     Insert (aEntry, S, ((aWidth-Length (aEntry)) shr 1)+1);
     MakeCenter:=S;
end;

procedure PrintRow (aRow: LongInt);
var
   Start, Finish: LongInt;
   NColumn: LongInt;
   NCHar: LongInt;
   Entry: string;
begin
     Start:=1;
     for NColumn:=1 to Length (Align)
         do begin
            for NChar:=Start to Length (Rows [aRow])
                do if Rows [aRow] [NCHar]='&'
                      then Break;
            if Rows [aRow] [NChar]='&'
               then Finish:=NChar-1
               else Finish:=NChar;
            Entry:=Copy (Rows [aRow], Start, Finish-Start+1);
            Write (F, '| ');
            case Align [NColumn] of
                 'l': Write (F, MakeLeft (Entry, WIdths [NColumn]));
                 'r': Write (F, MakeRight (Entry, WIdths [NColumn]));
                 'c': Write (F, MakeCenter (Entry, WIdths [NColumn]));
            end;
            Write (F, ' ');
            Start:=Finish+2;
         end;
     Writeln (F, '|');
end;

procedure Solve;
var
   NRow: longInt;
begin
     Assign (F, FileOut);
     Rewrite (F);
     CalcWidths;
     PrintBreak;
     PrintRow (1);
     PrintBreak;
     for NRow:=2 to RowsCount
         do PrintRow (NRow);
     PrintBreak;
     Close (F);
end;

begin
     ReadData;
     Solve;
end.
