{$A+,B-,D-,E-,F-,G+,I-,L-,N+,O-,P-,Q-,R-,S-,T-,V+,X+,Y+}
   Const File_In='convex.in';
         File_Out='convex.out';
         Eps=1E-10;
         MaxN=20000;
   Type Int=LongInt;
        TPoint=Record
                 X,Y : Int;
               End;
   Var P : Array [1..MaxN] Of TPoint;
       Answer : Array [1..MaxN] Of TPoint;
       AnswerCount,N : Int;
       Left : TPoint;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N);
  For I :=1 To N Do
    Read(P[I].X,P[I].Y);
End;

Function Eq(Const A,B : Real) : Boolean;
Begin
  Eq :=Abs(A-B)<Eps;
End;

Function Less(Const A,B : Real) : Boolean;
Begin
  Less :=A-B<-Eps;
End;

Function More(Const A,B : Real) : Boolean;
Begin
  More :=A-B>Eps;
End;

Procedure Swap(Var A,B : TPoint);
  Var C : TPoint;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Procedure SwapInt(Var A,B : Int);
  Var C : Int;
Begin
  C :=A;
  A :=B;
  B :=C;
End;

Function Vect(Const P1,P2,P3 : TPoint) : Int;
Begin
  Vect :=(P1.X-P3.X)*(P2.Y-P3.Y)-(P1.Y-P3.Y)*(P2.X-P3.X);
End;

Procedure Sort(L,R : Int);
  Var B,E : Int;
      X : TPoint;
Begin
  B :=L;
  E :=R;
  X :=P[(L+R) Div 2];
  Repeat
    While Less(Vect(P[B],X,Left),0) Do Inc(B);
    While More(Vect(P[E],X,Left),0) Do Dec(E);
    If B<=E Then
      Begin
        Swap(P[B],P[E]);
        Inc(B);
        Dec(E);
      End;
  Until B>E;
  If B<R Then Sort(B,R);
  If E>L Then Sort(L,E);
End;

Function Dist2(Const P1,P2 : TPoint) : Int;
Begin
  Dist2 :=Sqr(P1.X-P2.X)+Sqr(P1.Y-P2.Y);
End;

Procedure Solve;
  Var I,LeftNum : Int;
Begin
  If N=1 Then
    Begin
      WriteLn('1');
      WriteLn(P[1].X,' ',P[1].Y);
      Exit;
    End;
  Left.X :=MaxLongInt Div 2;
  For I :=1 To N Do
    If Less(P[I].X,Left.X) Or (Eq(P[I].X,Left.X) And Less(P[I].Y,Left.Y)) Then
      Begin
        Left :=P[I];
        LeftNum :=I;
      End;
  Swap(P[LeftNum],P[1]);
  Sort(2,N);
  AnswerCount :=2;
  Answer[1] :=P[1];
  Answer[2] :=P[2];
  I :=2;
  While (I<=N) And (P[1].X=P[I].X) And (P[1].Y=P[I].Y) Do
    Inc(I);
  If I>N Then
    Begin
      WriteLn('1');
      WriteLn(P[1].X,' ',P[1].Y);
      Exit;
    End;
  I :=3;
  While I<=N Do
    Begin
      While Less(Vect(P[I],Answer[AnswerCount],Answer[AnswerCount-1]),0) Do
        Dec(AnswerCount);
      If Eq(Vect(P[I],Answer[AnswerCount],Answer[AnswerCount-1]),0) Then
        If Dist2(P[I],Answer[AnswerCount-1])>Dist2(Answer[AnswerCount],Answer[AnswerCount-1]) Then
          Answer[ANswerCount] :=P[I]
        Else
      Else
        Begin
          Inc(AnswerCount);
          Answer[AnswerCount] :=P[I];
        End;
      Inc(I);
    End;
  WriteLn(AnswerCount);
  If Odd(N) Then
    For I :=1 To AnswerCount Do
      WriteLn(Answer[I].X,' ',Answer[I].Y)
  Else For I :=AnswerCount DownTo 1 Do
         WriteLn(Answer[I].X,' ',Answer[I].Y);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.
