#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define INF 1e100L

struct TCell {
  long double dist;
  int status;
};

int n_verts,n_cells;
TCell*mtrx_cont,**mtrx;
long double*dists; int*fromps;
char*marks; int*cnts;
int*que; int que_len,que_pos,que_break;

int main(void) {
  #ifndef OFFLINE
  freopen("floyd.in","rt",stdin);
  freopen("floyd.out","wt",stdout);
  #endif
  int v,w,u; long double dist;
  scanf("%d",&n_verts);
  mtrx_cont=new TCell[n_cells=n_verts*n_verts]; mtrx=new TCell*[n_verts];
  for (v=0,w=0; v<n_verts; v++,w+=n_verts) mtrx[v]=&mtrx_cont[w];
  for (v=0; v<n_verts; v++) for (w=0; w<n_verts; w++) {
    scanf("%Lf",&mtrx[v][w].dist);
    if (!mtrx[v][w].dist) mtrx[v][w].dist=(v!=w?INF:0);
  }
  int source,cur,to;
  dists=new long double[n_verts]; fromps=new int[n_verts];
  marks=new char[n_verts]; cnts=new int[n_verts];
  que=new int[n_verts<<1];
  for (source=0; source<n_verts; source++) {
    for (cur=0; cur<n_verts; cur++) mtrx[source][cur].status=0;
    mtrx[source][source].status=1;
    for (cur=0; cur<n_verts; cur++) dists[cur]=INF; dists[source]=0;
    memset(fromps,-1,sizeof(int)*n_verts);
    memset(marks,0,sizeof(char)*n_verts);
    memset(cnts,0,sizeof(int)*n_verts);
    que_len=1; marks[*que=source]=1;
    for (que_pos=0; que_pos!=que_len; que_pos++) {
      if (que_pos>=(n_verts<<1)) que_pos-=n_verts<<1;
      marks[cur=que[que_pos]]=0;
      for (to=0; to<n_verts; to++) if (cnts[to]<=n_verts+n_verts+2)
       if (mtrx[cur][to].dist<INF) {
        dist=dists[cur]+mtrx[cur][to].dist;
        if (dists[to]>dist) {
          dists[to]=dist; fromps[to]=cur;
          if (!marks[to]) {
            if (que_len>=(n_verts<<1)) que_len-=n_verts<<1;
            marks[que[que_len++]=to]=1;
          }
          if (cnts[to]++>=n_verts+n_verts+2) mtrx[source][to].status=2;
          else mtrx[source][to].status=(cnts[cur]<n_verts+n_verts+2?1:2);
        }
      }
    }
  }
  for (v=0; v<n_verts; v++) {
    for (w=0; w<n_verts; w++) {
      if (w) printf(" ");
      printf("%d",mtrx[v][w].status);
    } printf("\n");
  }
  delete[]que;
  delete[]marks; delete[]cnts;
  delete[]dists; delete[]fromps;
  delete[]mtrx_cont; delete[]mtrx;
  #ifndef OFFLINE
  fclose(stdin);
  fclose(stdout);
  #endif
  return(0);
}


