#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define maxn 30000
#define eps 1e-8

int x[maxn], y[maxn], n;
double fi[maxn], d[maxn];
int s[maxn], sp;
int xx, yy;
int u[maxn];

void sort( int l, int r )
{
  int i, j;
  double xx, tt;
  int t;

  if (l >= r)
    return;
  i = l, j = r;
  xx = fi[l + (rand() % (r - l + 1))];
  while (i <= j)
  {
    while ((fi[i] < xx) || (fabs(fi[i] - xx) < eps && x[i] == xx && y[i] == yy))
      i++;
    while ((fi[j] > xx) || (fabs(fi[i] - xx) < eps && x[j] != xx && y[i] == yy))
      j--;
    if (i <= j)
    {
      t = x[i], x[i] = x[j], x[j] = t;
      t = y[i], y[i] = y[j], y[j] = t;
      tt = fi[i], fi[i] = fi[j], fi[j] = tt;
      i++, j--;
    }
  }
  sort(l, j);
  sort(i, r);
}

int left( int i0, int i1, int i2 )
{
  int xx, yy, x1, y1;

  xx = x[i1] - x[i0], yy = y[i1] - y[i0];
  x1 = x[i2] - x[i0], y1 = y[i2] - y[i0];
  return xx * y1 - x1 * yy <= 0;
}

int same( int i0, int i1, int i2 )
{
  int xx, yy, x1, y1;

  xx = x[i1] - x[i0], yy = y[i1] - y[i0];
  x1 = x[i2] - x[i0], y1 = y[i2] - y[i0];
  return xx * y1 - x1 * yy == 0;
}

int main( void )
{
  int i, lef, nn;

  srand(3017);
  freopen("convex.in", "rt", stdin);
  freopen("ccnvex.out", "wt", stdout);
  scanf("%d", &n);
  for (i = 0; i < n; i++)
    scanf("%d%d", &x[i], &y[i]);
  if (n == 1)
  {
    printf("1\n");
    printf("%d %d\n", x[0], y[0]);
    return 0;
  }
  if (n == 2)
  {
    if (x[0] == x[1] && y[0] == y[1])
    {
      printf("1\n");
      printf("%d %d\n", x[0], y[0]);
    }
    else
    {
      printf("2\n");
      printf("%d %d\n%d %d\n", x[0], y[0], x[1], y[1]);
    }
    return 0;
  }
  lef = 0;
  for (i = 1; i < n; i++)
    if (x[i] < x[lef] || (x[i] == x[lef] && y[i] < y[lef]))
      lef = i;
  xx = x[lef], yy = y[lef];
  fi[lef] = 0;
  for (i = 0; i < n; i++)
    if (i != lef)
      fi[i] = atan2(y[i] - y[lef], x[i] - x[lef]);
  sort(0, n - 1);
  s[0] = 0;
  s[1] = 1;
  sp = 2;
  for (i = 2; i < n; i++)
  {
    while (sp >= 2 && left(s[sp - 2], s[sp - 1], i))
      sp--;
    s[sp++] = i;
  }
  memset(u, 0, sizeof(u));
  nn = sp;
  for (i = 0; i < sp; i++)
    if (same(s[i], s[(i + 1) % sp], s[(i + 2) % sp]))
      u[(i + 1) % n] = 1, nn--;
  if (!(n & 1))
  {
    printf("%d\n", nn);
    for (i = 0; i < sp; i++)
      if (!u[i])
        printf("%d %d\n", x[s[i]], y[s[i]]);
  }
  else
  {
    printf("%d\n", nn);
    for (i = sp - 1; i >= 0; i--)
      if (!u[i])
        printf("%d %d\n", x[s[i]], y[s[i]]);
  }
  return 0;
}
