#include <stdio.h>
#include <stdlib.h>

#define SIGN(A) ((A) > 0 ? 1 : ((A) < 0 ? -1 : 0))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define SQR(X) ((X) * (X))

#define MAX_N 20003

int N0, N, X[MAX_N], Y[MAX_N], D[MAX_N];
int mini, minx, miny = (int)1e3;
int X2[MAX_N], Y2[MAX_N], N2 = 0;
int ResX[MAX_N], ResY[MAX_N], ResN = 0;

int CmpA( int i, int j )
{
  return (X2[i] - minx) * (Y2[j] - miny) - (Y2[i] - miny) * (X2[j] - minx);
}

int Cmp( int i )
{
  int s1 = (X[i] - minx) * (Y[N] - miny) - (Y[i] - miny) * (X[N] - minx);

  if (s1)
    return s1;
  if (D[i] < D[N])
    return -1;
  if (D[i] > D[N])
    return 1;
  return 0;
}

int CmpXY( int x1, int y1, int x2, int y2 )
{
  return x1 * y2 - x2 * y1;
}

void QSort( int L, int R )
{
  int i = L, j = R, tmp, x;

  if (L >= R)
    return;
  x = L + (rand() % (R - L + 1));
  X[N] = X[x], Y[N] = Y[x], D[N] = D[x];
  while (i < j)
  {
    while (Cmp(i) < 0)
      i++;
    while (Cmp(j) > 0)
      j--;
    if (i <= j)
    {
      SWAP(X[i], X[j], tmp);
      SWAP(Y[i], Y[j], tmp);
      SWAP(D[i], D[j], tmp);
      i++, j--;
    }
  }
  QSort(L, j);
  QSort(i, R);
}

int main( void )
{
  int i, a1, a2;

  srand(3017);
  freopen("convex.in", "rt", stdin);
  freopen("convex.out", "wt", stdout);
  scanf("%d", &N), N0 = N;
  for (i = 0; i < N; i++)
    scanf("%d%d", &X[i], &Y[i]);
  if (N < 3)
  {
    for (i = 0; i < N; i++)
      printf("%d %d\n", X[i], Y[i]);
    return 0;
  }
  for (i = 0; i < N; i++)
    if (Y[i] < miny || (Y[i] == miny && X[i] > minx))
      mini = i, miny = Y[i], minx = X[i];
  N--;
  for (i = mini; i < N; i++)
    X[i] = X[i + 1], Y[i] = Y[i + 1];
  for (i = 0; i < N; i++)
    D[i] = SQR(X[i] - minx) + SQR(Y[i] - miny);
  QSort(0, N - 1);
  for (i = 0; i < N; i++)
  {
    X2[N] = X[i], Y2[N] = Y[i];
    while (N2 >= 1 && !CmpA(N2 - 1, N))
      N2--;
    X2[N2] = X[i], Y2[N2++] = Y[i];
  }
  ResX[0] = minx, ResY[0] = miny, ResN = 1;
  for (i = 0; i < N2; i++)
  {
    a1 = CmpXY(
      X2[i] - ResX[ResN - 1], Y2[i] - ResY[ResN - 1],
      ResX[ResN - 1] - ResX[ResN - 2], ResY[ResN - 1] - ResY[ResN - 2]);
    while (ResN > 2 && SIGN(a1) < 0)
    {
      ResN--;
      a1 = CmpXY(
        X2[i] - ResX[ResN - 1], Y2[i] - ResY[ResN - 1],
        ResX[ResN - 1] - ResX[ResN - 2], ResY[ResN - 1] - ResY[ResN - 2]);
    }
    ResX[ResN] = X2[i], ResY[ResN++] = Y2[i];
  }
  if (!(N & 1))
  {
    printf("%d\n", ResN);
    for (i = 0; i < ResN; i++)
      printf("%d %d\n", ResX[i], ResY[i]);
    printf("\n");
  }
  else
  {
    printf("%d\n", ResN);
    for (i = ResN - 1; i >= 0; i--)
      printf("%d %d\n", ResX[i], ResY[i]);
    printf("\n");
  }
  return 0;
}
