#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

#define FILE_IN "cards.in"
#define FILE_OUT "cards.out"

const long long MAXLONGLONG = 100000000000000000LL;

const int magic = 10000;

const int MAXN = 1005;

int n;
int a[MAXN];
long long left,right;

void OpenFiles() {
	freopen(FILE_IN,"r",stdin);
	freopen(FILE_OUT,"w",stdout);
}

void CloseFiles() {
	fclose(stdout);
}

void Initialize(){
	
}

void ReadData() {	
	n = 0;
	unsigned char ch;
	while (scanf("%c",&ch)==1) {
		if (isdigit(ch)) {
			a[++n] = ch-'0';
		} else break;
	}
	int i,t;
	for (i=1;i<=n/2;i++) {
		t = a[i];
		a[i] = a[n-i+1];
		a[n-i+1] = t;
	}	
}

int di[20];
int possible(int num){
	if (num<=0) return 1;
	int i = n-1;
	int len=0;
	while (num>0) {
		di[len++] = num%10;
		num = num/10;
	}	
	int j = n;
	for (i=len-1;i>=0;i--) {
		a[0] = di[i];
		while (a[j]!=di[i]) j--;
		if (j==0) return 0;
		j--;
	}	
	return 1;
}

void Solve() {	
	left = 0;
	right = MAXLONGLONG+magic;

	int re = 1;
	int i;
	while (right-left>1){
		re = 1;
		for (i=0;i<magic;i++)
			re = re && possible((right+left)/2-i);

		if (re)
			left = (right+left)/2;
		else
			right = (right+left)/2;
	}	
}

void OutData() {
	printf("%LLd",left+1);
}

int main(int argc, char * arg[]) {
	OpenFiles();
    Initialize();
    ReadData();
    Solve();
    OutData();
    CloseFiles();
    return 0;	
}