{$R+,Q+,S+,H+}
Uses SysUtils;

Const
  TaskID='cards';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxLen=1000;
  Base=10;

Var
  S,Res:String;
  TotalGroups:Array[1..MaxLen]Of Integer;
  OthersMask:Array[1..MaxLen]Of Integer;
  
Procedure Load;
Var
  I:Integer;
Begin
  ReSet(Input,InFile);
  Read(S);
  Assert(EOLN And Not EOF);
  ReadLn;
  Assert(EOF);
  Assert(Length(S)>0);
  Assert(Length(S)<=MaxLen);
  For I:=1 To Length(S) Do Assert((S[I]>='0') And (S[I]<='9'));
  Assert(S[1]>'0');
  Close(Input);
End;

Procedure FillGroups;
Var
  I:Integer;
  NG,CMask:Integer;
Begin
  CMask:=0;
  NG:=0;
  For I:=Length(S) DownTo 1 Do Begin
    CMask:=CMask Or (1 Shl (Ord(S[I])-Ord('0')));
    If CMask=1 Shl Base-1 Then Begin
      Inc(NG);
      cMask:=0;
    End;
    TotalGroups[I]:=NG;
    OthersMask[I]:=CMask;
  End;
End;

Function AllCovered(X:String):Boolean;
Var
  At,St,I,Mask,Need:Integer;
Begin
  For St:=1 To Length(X) Do If X[St]>'0' Then Break;
  AllCovered:=False;
  If TotalGroups[1]<Length(X)-St Then Exit;
  At:=1;
  For I:=St To Length(X) Do Begin
    If (I>St) And (X[I]>'0') Or (X[I]>'1') Then Begin
      If TotalGroups[At]<Length(X)-I Then Exit;
      If TotalGroups[At]=Length(X)-I Then Begin
        Mask:=OthersMask[At];
        If I=St Then Mask:=Mask Or 1;
        Need:=1 Shl (Ord(X[I])-Ord('0'))-1;
        If (Mask And Need)<>Need Then Exit;
      End;
    End;
    While S[At]<>X[I] Do Begin
      If At=Length(S) Then Exit;
      Inc(At);
    End;
    Inc(At);
    If (At>Length(S)) And (I<Length(X)) Then Exit;
  End;
  AllCovered:=True;
End;

Procedure Middle(L,R:String; Var M:String);
Var
  I,P:Integer;
Begin
  P:=0;
  For I:=Length(L) DownTo 1 Do Begin
    Inc(P,Ord(L[I])+Ord(R[I])-Ord('0')-Ord('0'));
    If P>=10 Then Begin
      M[I]:=Chr(P-10+Ord('0'));
      P:=1;
    End Else Begin
      M[I]:=Chr(P+Ord('0'));
      P:=0;
    End;
  End;
  P:=0;
  For I:=1 To Length(L) Do Begin
    P:=P*10+Ord(M[I])-Ord('0');
    M[I]:=Chr(P Div 2+Ord('0'));
    P:=P Mod 2;
  End;
End;

Procedure Solve;
Var
  L,R,M:String;
  I:Integer;
Begin
  FillGroups;
  R:='01';
  For I:=1 To 5+Length(S) Div 10 Do R:=R+'0';
  L:='';
  While Length(L)<Length(R) Do L:=L+'0';
  M:=L;
  While True Do Begin
    Middle(L,R,M);
    If M=L Then Break;
    If AllCovered(M) Then L:=M Else R:=M;
  End;
  Res:=R;
  While (Res<>'') And (Res[1]='0') Do Delete(Res,1,1);
End;

Procedure Save;
Begin
  ReWrite(Output,OutFile);
  If Res='' Then WriteLn(0) Else WriteLn(Res);
  Close(Output);
End;

Begin
  Load;
  Solve;
  Save;
End.
