program Task1;

uses
  SysUtils;

var
  X, N: AnsiString;

procedure ReadInput;
var
  F: TextFile;
begin
  AssignFile(F, 'cards.in');
  Reset(F);
  Read(F, X);
  CloseFile(F);
end;

procedure WriteOutput;
var
  F: TextFile;
begin
  AssignFile(F, 'cards.out');
  Rewrite(F);
  while N[1] = '0' do
    Delete(N, 1, 1);
  Write(F, N);
  CloseFile(F);
end;

function StrIncByOne(S: Char): Char;
begin
  case S of
    '0': Result := '1';
    '1': Result := '2';
    '2': Result := '3';
    '3': Result := '4';
    '4': Result := '5';
    '5': Result := '6';
    '6': Result := '7';
    '7': Result := '8';
    '8': Result := '9';
  end;
end;

function StrInc(var Str: AnsiString): Integer;
var
  I: Integer;
  IncNext: Boolean;
begin
  Result := 0;
  IncNext := True;
  I := Length(Str);
  while IncNext do begin
    Inc(Result);
    if Str[I] <> '9' then begin
      Str[I] := StrIncByOne(Str[I]);
      IncNext := False;
    end else
      Str[I] := '0';
    Dec(I);
  end;
end;

function PosEx(Str: AnsiString; SubStr: AnsiChar; Offset: Integer): Integer;
var
  I: Integer;
begin
  Result := 0;
  for I := Offset to Length(Str) do
    if Str[I] = SubStr then begin
      Result := I;
      Exit;
    end;
end;

var
  I, J, Changed: Integer;
  CharPosition: array [1..1001] of Integer;
begin
  ReadInput;

  for I := 1 to 1001 do
    CharPosition[I] := 0;

  N := StringOfChar('0', Length(X));
  while True do begin
    Changed := StrInc(N);
    for J := Length(N) - Changed + 1 to Length(N) do begin
      CharPosition[J] := PosEx(X, N[J], CharPosition[J-1]+1);
      if CharPosition[J] = 0 then begin
        WriteOutput;
        Exit;
      end;
    end;
  end;
end.
