#include <cstdio>
#include <queue>
#include <stack>
#include <set>
#include <string>
#include <cstring>

using namespace std;

const int MAX = 1020;

string curMin = "";
int curMinLen = -1;

char line[MAX];
int nums[MAX][10];
int initNums[10];
string str;
set<string> setS;

inline bool lessStr(string &s1, string &s2)
{
	if ( s1.length() < s2.length() )
		return true;
	if ( s2.length() < s1.length() )
		return false;
	for ( int i = 0; i < s1.length(); ++i )
	{
		if ( s1[i] < s2[i] )
			return true;
		if ( s2[i] < s1[i] )
			return false;
	}
	return false;
}

void backtrack(int ind, int digit)
{
	str.push_back(digit + '0');
	int newInd;
	if ( ind == -1 )
	{
		newInd = initNums[digit];
		if ( newInd != -1 )
		{
			if ( curMinLen == -1 || str.size() + 1 <= curMinLen )
				for ( int i = 0; i <= 9; ++i )
					backtrack(newInd, i);
		}
		else 
		{
			if ( curMin == "" || lessStr(str, curMin) )
				curMin = str;
			if ( curMinLen == -1 || str.size() < curMinLen )
				curMinLen = str.size();
		}
	}
	else if ( nums[ind][digit] != -1 )
	{
		if ( curMinLen == -1 || str.size() + 1 <= curMinLen )
		{
			newInd = nums[ind][digit];
			for ( int i = 0; i <= 9; ++i )
				backtrack(newInd, i);
		}
	}
	else 
	{
		if ( curMin == "" || lessStr(str, curMin) )
			curMin = str;
		if ( curMinLen == -1 || str.size() < curMinLen )
			curMinLen = str.size();
	}
	str.erase(str.length() - 1);
}


int main()
{
	freopen("cards.in", "r", stdin);
	freopen("cards.out", "w", stdout);
	gets(line);
	int len = strlen(line);
	memset(nums[len-1], -1, 10 * sizeof(int));
	for ( int i = len - 2; i >= 0; --i )
	{
		memcpy(nums[i], nums[i+1], 10 * sizeof(int));
		nums[i][line[i+1] - '0'] = i + 1;
	}
	memcpy(initNums, nums[0], 10 * sizeof(int));
	initNums[line[0] - '0'] = 0;
	for ( int i = 1; i <= 9; ++i )
		backtrack(-1, i);
	printf("%s\n\n", curMin.c_str());
	return 0;
}