/**************************************/
/*   57, Moscow                       */
/**************************************/

#include <fstream>
using namespace std;

#define MEGA_INT 2006

struct cell_info
{
   int next [10];

   int mega_len;
   int mnum;
};

int card [1024];
cell_info ptrs [1024];
cell_info header;
int fdf [1024][1024];
int n;

void init_next ()
{
   for ( int i = 0; i < n; i++ )
      for ( int j = 0; j < 10; j++ )
         ptrs [i].next [j] = MEGA_INT;
   for ( int i = 0; i < 10; i++ )
      header.next [i] = MEGA_INT;
}
void fill_next ( int i )
{
   int val = card [i];
   for ( int j = 0; j < i; j++ )
   {
      if ( ptrs [j].next [val] > i )
         ptrs [j].next [val] = i;
   }
   if ( header.next [val] > i )
      header.next [val] = i;
}

int main ()
{
   ifstream fin ( "cards.in" );
   ofstream fout ( "cards.out" );

   // input ///////
   char mega_str [1024];
   fin >> mega_str;
   n = (int) strlen ( mega_str );
   for ( int i = 0; i < n; i++ )
      card [i] = mega_str [i] - '0';
   init_next ();
   ////////////////

   ptrs [0].mega_len = 1;
   ptrs [0].mnum = -1;
   fill_next ( 0 );

   for ( int i = 1; i < n; i++ )
   {
      fill_next ( i );
      if ( header.next [card [i]] == i && card [i] != 0 )
      {
         ptrs [i].mega_len = 1;
         ptrs [i].mnum = -1;
         for ( int j = 0; j < i; j++ )
         {
            if ( ptrs [j].mega_len == 1 )
            {
               fdf [i][j] = i;
               fdf [j][i] = j;
            }
         }
      }
      else
      {
         int min_mega = -1;
         for ( int j = 0; j < i; j++ )
         {
            if ( ptrs [j].next [card [i]] == i )
            {
               if ( min_mega < 0 )
                  min_mega = j;
               else
               {
                  if ( ptrs [j].mega_len < ptrs [min_mega].mega_len )
                     min_mega = j;
                  else if ( ptrs [j].mega_len == ptrs [min_mega].mega_len )
                     if ( card [fdf [j][min_mega]] < card [fdf [min_mega][j]] )
                        min_mega = j;
               }
            }
         } // end for
         ptrs [i].mega_len = ptrs [min_mega].mega_len + 1;
         ptrs [i].mnum = min_mega;
         for ( int j = 0; j < i; j++ )
         {
            if ( ptrs [i].mega_len == ptrs [j].mega_len )
            {
               if ( ptrs [i].mnum == ptrs [j].mnum )
               {
                  fdf [i][j] = i;
                  fdf [j][i] = j;
               }
               else
               {
                  fdf [i][j] = fdf [ptrs [i].mnum][ptrs [j].mnum];
                  fdf [j][i] = fdf [ptrs [j].mnum][ptrs [i].mnum];
               }
            }
         }
      }
   }

   // all set; spent O(n^2)
   for ( int i = 1; i < 10; i++ )
   {
      if ( header.next [i] >= MEGA_INT )
      {
         fout << (char) ( i + '0' );
         return 0;
      }
   }

   int min_badw = -1;
   int badw_suff;
   for ( int i = 0; i < n; i++ )
   {
      for ( int j = 0; j < 10; j++ )
      {
         if ( ptrs [i].next [j] >= MEGA_INT )
         {
            if ( min_badw < 0 )
            {
               min_badw = i;
               badw_suff = j;
            }
            else
            {
               if ( ptrs [i].mega_len < ptrs [min_badw].mega_len )
               {
                  min_badw = i;
                  badw_suff = j;
               }
               else if ( ptrs [i].mega_len == ptrs [min_badw].mega_len )
               {
                  if ( card [fdf [i][min_badw]] < card [fdf [min_badw][i]] )
                  {
                     min_badw = i;
                     badw_suff = j;
                  }
               }
            }
            break;
         }
      }
   }

   char badw [1024];
   int badwl = ptrs [min_badw].mega_len + 1;
   badw [badwl-1] = badw_suff + '0';
   badw [badwl] = 0;
   badwl -= 2;
   int last = min_badw;
   while ( last >= 0 )
   {
      badw [badwl--] = card [last] + '0';
      last = ptrs [last].mnum;
   }

   fout << badw;

   return 0;
}
