#include <cstdio>
#include <cstdlib>
#include <string>
#include <cmath>

#define inpfile "fur.in"
#define outfile "fur.out"

using namespace std;

const int NMAX = 1005;
const int LMAX = 2005;
const int KMAX = 15;
const int INF = 1000000000;

enum Type {
    UP, DOWN, ALT
};

char s[NMAX][LMAX];
int a[KMAX];
int n,k;

int c[NMAX][NMAX];
Type type[NMAX][NMAX];
int d[NMAX];
int prev[NMAX];
bool u[NMAX];
int res;

void Init()
{
    freopen(inpfile,"r",stdin);
    freopen(outfile,"w",stdout);
}

void Out()
{
    exit(0);
}

/*int abs(int x)
{
    if (x >= 0) return x; else return -x;
}

int min(int q, int w)
{
    if (q < w) return q; else return w;
} */

void Writ(int y)
{
    int i,x = prev[y];

    if (!x) return;
    Writ(x);

    if (type[x][y] == UP) {
        for (i = 1; i <= c[x][y]; i++) printf("up\n");
    } else
    if (type[x][y] == DOWN) {
        for (i = 1; i <= c[x][y]; i++) printf("down\n");
    } else {
        printf("Alt\n");
        for (i = 2; i <= c[x][y]; i++) printf("%c\n",s[y][i-1]);
    }
}

void Solve()
{
    int i,j,t;
    int mini;

    for (i = 1; i <= n; i++)
        for (j = 1; j <= n; j++) {
            c[i][j] = min(abs(i - j), n - abs(i - j));
            if (i < j) {
                if (c[i][j] == j - i) type[i][j] = DOWN;
                else type[i][j] = UP;
            } else {
                if (c[i][j] == i - j) type[i][j] = UP;
                else type[i][j] = DOWN;
            }
        }

    res = 0; a[0] = 1;
    for (t = 1; t <= k; t++) {
        memset(u,0,sizeof(u));
        memset(prev,0,sizeof(prev));

        for (i = 0; i <= n; i++) d[i] = INF;
        d[a[t - 1]] = 0;

        while (!u[a[t]]) {
            mini = 0;
            for (i = 1; i <= n; i++)
                if (!u[i] && (d[i] < d[mini])) mini = i;

            u[mini] = true;
            for (i = 1; i <= n; i++)
                if (d[i] > d[mini] + c[mini][i]) {
                    d[i] = d[mini] + c[mini][i];
                    prev[i] = mini;
                }
        }

        printf("%d\n",d[a[t]]);
        Writ(a[t]);
    }
}

void Inp()
{
    int i;

    scanf("%d\n",&n);
    for (i = 1; i <= n; i++) scanf("%s\n",s[i]);

    scanf("%d",&k);
    for (i = 1; i <= k; i++) scanf("%d",a + i);
}

int main()
{
    Init();
    Inp();
    Solve();
    Out();
    return 0;
}
