{$apptype console}
{$q+,r+,n-,o+}

{
   sort + dijkstra
   O(N*logN*lmax + N*N*k)
}

const cinfile = 'fur.in';
      coutfile = 'fur.out';

const nmax = 1011;
      lmax = 2011;
      inf = maxlongint shr 1;

type int = longint;

var s : array[1..nmax, 1..lmax] of char;
    len : array[1..nmax] of int;
    p : array[1..nmax] of int;
    common : array[1..nmax, 1..nmax] of int;

    ak : array[1..23] of int;
    d : array[1..nmax, 1..nmax] of int;
    r : array[1..nmax] of int;
    way : array[1..nmax] of int;
    use : array[1..nmax] of byte;
    n, k : int;

procedure init;
var i : int;
    c : char;
begin
   read(n);

   assert((n >= 1) and (n <= 1000));
   
   for i:=1 to n do begin
      repeat
         read(c);
      until c in ['a'..'z'];
      len[i]:=0;
      repeat
         inc(len[i]);
         s[i][len[i]]:=c;
         read(c);
      until not (c in ['a'..'z']);
      s[i][len[i] + 1]:=pred('a');

      assert(len[i] <= 1000);
   end;
   read(k);

   assert((k >= 1) and (k <= 10));
   
   inc(k);
   ak[1]:=1;
   for i:=2 to k do begin
      read(ak[i]);
      assert((ak[i] >= 1) and (ak[i] <= n));
   end;
end;

procedure sort;
var i, j, x, y : int;
    cadj : array[1..nmax] of int;
begin
   for i:=1 to n do p[i]:=i;
   for i:=1 to n do begin
      x:=p[i];
      y:=p[i mod n + 1];
      cadj[x]:=0;
      while (cadj[x] < len[x]) and (s[x][cadj[x] + 1] = s[y][cadj[x] + 1]) do
         inc(cadj[x]);

      assert((cadj[x] <= len[x]) and (cadj[x] <= len[y]));
   end;
   fillchar(common, sizeof(common), 0);
   for i:=2 to n do begin
      x:=p[i];
      y:=inf;
      j:=i;
      while true do begin
         dec(j);
         if j = 0 then break;
         if (y > cadj[p[j]]) then y:=cadj[p[j]];
         if y = 0 then break;
         common[p[j]][x]:=y;
         common[x][p[j]]:=y;
      end;
   end;
end;

procedure create_graph;
var i, j, t : int;
begin
   for i:=1 to n do begin
      t:=0;
      j:=i;
      repeat
         dec(j);
         if j = 0 then j:=n;
         if t < common[i][j] then t:=common[i][j];
         if t = len[i] then d[j][i]:=inf else d[j][i]:=t + 2;
      until j = i;
   end;
   for i:=1 to n do begin
      d[i][i mod n + 1]:=1;
      d[i][(i - 2 + n) mod n + 1]:=1;
   end;
end;

procedure solve;
var i, j, t : int;
   procedure go(x : int);
   var y, tmp : int;
   begin
      y:=way[x];
      if (y = 0) then exit;
      go(y);
      if (y mod n + 1 = x) then writeln('down') else
         if (y - 2 + n) mod n + 1 = x then writeln('up')
         else begin
            writeln('Alt');
            for tmp:=1 to d[y][x] - 1 do
               writeln(s[x][tmp]);
         end;
   end;
begin
   for t:=1 to k - 1 do begin
      fillchar(use, sizeof(use), 0);
      for i:=1 to n do r[i]:=inf;
      r[ak[t]]:=0;
      way[ak[t]]:=0;
      while (true) do begin
         j:=1;
         for i:=2 to n do if (use[i] = 0) then
            if (use[j] = 1) or
               ((use[j] = 0) and (r[j] > r[i]))
            then j:=i;
         if (use[j] = 1) or (r[j] >= inf) then break;
         use[j]:=1;
         for i:=1 to n do if (use[i] = 0) then
            if r[i] > r[j] + d[j, i] then begin
               r[i]:=r[j] + d[j, i];
               way[i]:=j;
            end;
      end;
      writeln(r[ak[t + 1]]);
      go(ak[t + 1]);
   end;
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   sort;
   create_graph;
   solve;   
   close(input); close(output);
end.
