#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define inpfile "fur.in"
#define outfile "fur.out"

const int NMAX = 1005;
const int LMAX = 2005;
const int KMAX = 15;
const int INF = 1000000000;
const int LETTERS_NUM = 26;
const int OSN = 1000000000;

enum Type {
    UP, DOWN, ALT
};

char s[NMAX][LMAX];
int a[KMAX];
int n,k;

int c[NMAX][NMAX];
int prefix[NMAX][NMAX];
int hash2[NMAX][LMAX];
int len[NMAX];
Type type[NMAX][NMAX];
int d[NMAX];
int prev[NMAX];
bool u[NMAX];
int res;

void Init()
{
    freopen(inpfile,"r",stdin);
    freopen(outfile,"w",stdout);
}

void Out()
{
    exit(0);
}

/*int abs(int x)
{
    if (x >= 0) return x; else return -x;
}*/

int min(int q, int w)
{
    if (q < w) return q; else return w;
}

int dec(int x)
{
    if (x == 1) return n;
    else return x - 1;
}

int Prefix(int x, int y)
{
    int l, r, m;
    int i;

    l = -1; r = min(len[x], len[y]) - 1;
    while (l != r) {
        m = (l + r + 1) / 2;
        if (hash2[x][m] == hash2[y][m]) l = m;
        else r = m - 1;
    }

    return l + 1;
}

void Writ(int y)
{
    int i,x = prev[y];

    if (!x) return;
    Writ(x);

    if (type[x][y] == UP) {
        for (i = 1; i <= c[x][y]; i++) printf("up\n");
    } else
    if (type[x][y] == DOWN) {
        for (i = 1; i <= c[x][y]; i++) printf("down\n");
    } else {
        printf("Alt\n");
        for (i = 2; i <= c[x][y]; i++) printf("%c\n",s[y][i-2]);
    }
}

void Solve()
{
    int i,j,t;
    int mini,x;

    for (i = 1; i <= n; i++)
        for (j = 1; j <= n; j++) {
            c[i][j] = min(abs(i - j), n - abs(i - j));
            if (i < j) {
                if (c[i][j] == j - i) type[i][j] = DOWN;
                else type[i][j] = UP;
            } else {
                if (c[i][j] == i - j) type[i][j] = UP;
                else type[i][j] = DOWN;
            }
        }

    int p;
    for (i = 1; i <= n; i++) {
        hash2[i][0] = s[i][0] - 'a'; p = 1;
        for (j = 1; s[i][j]; j++) {
            p = (p * LETTERS_NUM) % OSN;
            hash2[i][j] = (hash2[i][j-1] + (s[i][j] - 'a') * p) % OSN;
        }
    }

    for (i = 1; i <= n; i++) len[i] = strlen(s[i]);

    for (i = 1; i <= n - 1; i++)
        for (j = i + 1; j <= n; j++) {
            prefix[i][j] = Prefix(i,j);
            prefix[j][i] = prefix[i][j];
        }

    for (i = 1; i <= n; i++) {
        x = 1;
        for (j = dec(i); j != i; j = dec(j)) {
            if (prefix[i][j] + 2 > x) x = prefix[i][j] + 2;
            if (x - 1 > len[i]) x = INF;
            if (x < c[j][i]) {
                c[j][i] = x;
                type[j][i] = ALT;
            }
        }
    }

    res = 0; a[0] = 1;
    for (t = 1; t <= k; t++) {
        memset(u,0,sizeof(u));
        memset(prev,0,sizeof(prev));

        for (i = 0; i <= n; i++) d[i] = INF;
        d[a[t - 1]] = 0;

        while (!u[a[t]]) {
            mini = 0;
            for (i = 1; i <= n; i++)
                if (!u[i] && (d[i] < d[mini])) mini = i;

            u[mini] = true;
            for (i = 1; i <= n; i++)
                if (d[i] > d[mini] + c[mini][i]) {
                    d[i] = d[mini] + c[mini][i];
                    prev[i] = mini;
                }
        }

        printf("%d\n",d[a[t]]);
        Writ(a[t]);
    }
}

void Inp()
{
    int i;

    scanf("%d\n",&n);
    for (i = 1; i <= n; i++) scanf("%s\n",s[i]);

    scanf("%d",&k);
    for (i = 1; i <= k; i++) scanf("%d",a + i);
}

int main()
{
    Init();
    Inp();
    Solve();
    Out();
    return 0;
}
