#include <vector>
#include <string>
#include <iostream>
#include <fstream>

#define PROBLEM_NAME "fur"
#define MM 26
#define NN 1024

using namespace std;

struct TNode {
	TNode() {
		int i;
		n = 0; l = 0;
		for(i=0;i<MM;i++) {
			p[i]=NULL;
			ref[i]="";
		}
		prev = NULL;
	}
	
	int n,l;
	TNode *p[MM];
	TNode *prev;
	string ref[MM];
};

typedef string::iterator strptr;

ifstream fi(PROBLEM_NAME ".in");
ofstream fo(PROBLEM_NAME ".out");
int n,k;
string s;
TNode *head;
vector <TNode> swapp;
vector <TNode*> T;
string fnames[NN];
int iswap = 0;
int a[NN][NN];
TNode *v[NN][NN];
int cur;
TNode *b[2*NN][2*NN];
int r[NN];
int d[NN];
int used[NN];
string res;

TNode *getnew() {
	swapp[iswap].n=iswap;
	return &swapp[iswap++];
}

TNode *push(int x, int y, TNode *p) {
	TNode *t;
	int i,l;
	if(x==y) {
		return p;
	}
	if(p->p[s[x]-'a']==NULL) {
		t=getnew();
		p->p[s[x]-'a']=t;
		t->l=p->l+y-x;
		t->prev=p;
		p->ref[s[x]-'a']=string(s,x,y-x);
		return p->p[s[x]-'a'];
	}
	l=p->ref[s[x]-'a'].length();
	for(i=0;(i<l)&&(i<y-x);i++)
		if(s[x+i]!=p->ref[s[x]-'a'][i])
			break;
	if(i<l) {
		t=getnew();
		t->p[p->ref[s[x]-'a'][i]-'a']=p->p[s[x]-'a'];
		t->ref[p->ref[s[x]-'a'][i]-'a']=string(p->ref[s[x]-'a'],i,l-i);
		t->l=p->l+i;
		t->prev=p;
		p->p[s[x]-'a']->prev=t;
		p->p[s[x]-'a']=t;
		p->ref[s[x]-'a']=string(p->ref[s[x]-'a'],0,i);
		return push(x+i,y,p->p[s[x]-'a']);
	} else {
		return push(x+l,y,p->p[s[x]-'a']);
	}
}

TNode *pref(TNode *x, TNode *y) {
	if(b[x->n][y->n]!=NULL) return b[x->n][y->n];
	if(x==y) {
		b[x->n][y->n]=x;
		return x;
	}
	if(x->l<y->l) {
		b[x->n][y->n]=pref(y,x);
		return b[x->n][y->n];
	}
	b[x->n][y->n]=pref(x->prev,y);
	return b[x->n][y->n];
}

void Dijkstra(int st) {
	int i,mx,k;
	for(i=0;i<n;i++) {
		used[i]=0;
		r[i]=100000000;
		d[i]=-1;
	}
	r[st]=0;
	while(true) {
		k=-1;
		mx=100000000;
		for(i=0;i<n;i++) {
			if(!used[i]) {
				if(r[i]<mx) {
					mx=r[i]; k=i;
				}
			}
		}
		if(k<0) break;
		used[k]=1;
		for(i=0;i<n;i++) {
			if(r[i]>r[k]+a[k][i]) {
				r[i]=r[k]+a[k][i];
				d[i]=k;
			}
		}
	}
}

void wr_calc(int v) {
	if(d[v]<0) return;
	wr_calc(d[v]);
	if(d[v]==(v+n-1)%n) { res+="D"; return ; }
	if(d[v]==(v+1)%n) { res+="U"; return ; }
	res+="A";
	res+=string(fnames[v].begin(),fnames[v].begin()+a[d[v]][v]-1);
}

void wr() {
	int l = res.length();
	fo<<l<<endl;
	for(int i = 0 ; i < l ; i++) {
		switch(res[i]) {
			case 'D':
				fo<<"down\n";
				break;
			case 'U':
				fo<<"up\n";
				break;
			case 'A':
				fo<<"Alt\n";
				break;
			default:
				fo<<res[i]<<endl;
				break;
		}
	}
}

int main() {
	int i,j,q,x;
	TNode *w;
	fi>>n;
	swapp.resize(2*n);
//	T.push_back(&head);
	head=getnew();
	for(i=0;i<n;i++) {
		fi>>s;
		fnames[i]=s;
		T.push_back(push(0,s.length(),head));
	}
	for(i=0;i<iswap+1;i++) {
		for(j=0;j<iswap+1;j++) {
			b[i][j]=NULL;
		}
	}
	for(i=0;i<iswap+1;i++) {
		for(j=0;j<iswap+1;j++) {
			b[i][j]=pref(&swapp[i],&swapp[j]);
		}
	}
	for(i=0;i<n;i++) {
		a[i][i]=0;
		a[i][(i+1)%n]=1;
		a[i][(i+n-1)%n]=1;
	}
	for(j=0;j<n;j++) {
		x=b[T[j]->n][T[(j+n-1)%n]->n]->l;
		for(i=(j+n-2)%n;i!=(j+1)%n;i=(i+n-1)%n) {
			if(x<b[T[i]->n][T[j]->n]->l) {
				x=b[T[i]->n][T[j]->n]->l;
			}
			a[i][j]=x+2;
			if(x>=fnames[j].length())
				a[i][j]=100000000;
		}
	}
	fi>>k;
	cur = 0;
	for(i=0;i<k;i++) {
		fi>>x;
		Dijkstra(cur);
		res="";
		wr_calc(x-1);
		wr();
		cur=x-1;
	}
	return 0;
}
