{$D-,I-,L-,Q-,R-,Q-,S-,H+,O+}
  Const TaskID='fur';
        File_In=TaskID+'.in';
        File_Out=TaskID+'.out';
//        File_Out='fur2.out';
        MaxN=1000;
        Infinity=MaxLongInt Div 4;
        MaxK=10;
        Down=#96;
        Up=#122;
  Type Int=LongInt;
       TTrie=^THelpTrie;
       TEdge=^THelpEdge;
       THelpTrie=Record
                   Num,NumV : Int;
                   H : Int;
                   Parent : TTrie;
                   Edge : Array [Down..Up] Of TEdge;
                 End;
       THelpEdge=Record
                   Num,L,R : Int;
                   Child : TTrie;
                 End;
  Var K,N : Int;
      S : Array [1..MaxN] Of String;
      Trie : TTrie;
      Edges,LCA : Array [1..MaxN,1..MaxN] Of Int;
      P : Array [0..MaxN] Of TTrie;
      Use : Array [0..MaxN] Of Int;
      A : Array [0..MaxK] Of Int;
      D,From : Array [0..MaxN] Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I : Int;
Begin
  ReadLn(N);
  For I :=1 To N Do
    ReadLn(S[I]);
  Read(K);
End;

Procedure ClearEdges(var Trie: TTrie);
  Var Sym : Char;
Begin
  For Sym :=Down To Up Do
    Trie^.Edge[Sym] :=Nil;     
End;

Procedure AddTrie(Var Trie : TTrie; Const Num : Int);

Procedure Add(Var Trie : TTrie; I : Int);
  Var HelpTrie : TTrie;
      HelpEdge : TEdge;
      J : Int;
Begin
  If Trie^.Edge[S[Num][I]]<>Nil Then Begin
    J :=0;
    HelpEdge :=Trie^.Edge[S[Num][I]];
    While (I+J<=Length(S[Num])) And (HelpEdge^.L+J<=HelpEdge^.R) Do Begin
      If S[Num][I+J]=S[HelpEdge^.Num][HelpEdge^.L+J] Then Inc(J)
      Else Break;
    End;
    If (I+J<=HelpEdge^.R) And (I+J<=Length(S[Num])) Then Begin
      New(HelpTrie);
      New(HelpEdge);
      ClearEdges(HelpTrie);
      HelpTrie^.Edge[S[Trie^.Edge[S[Num][I]]^.Num][Trie^.Edge[S[Num][I]]^.L+J]] :=HelpEdge;
      HelpTrie^.NumV :=0;
      HelpTrie^.Num :=0;
      HelpTrie^.Parent :=Trie;
      HelpEdge^.Child :=Trie^.Edge[S[Num][I]]^.Child;
      HelpEdge^.Num :=Trie^.Edge[S[Num][I]]^.Num;
      HelpEdge^.R :=Trie^.Edge[S[Num][I]]^.R;
      HelpEdge^.L :=Trie^.Edge[S[Num][I]]^.L+J;
      Trie^.Edge[S[Num][I]]^.Child^.Parent :=HelpTrie;
      Trie^.Edge[S[Num][I]]^.Child :=HelpTrie;
      Trie^.Edge[S[Num][I]]^.R :=Trie^.Edge[S[Num][I]]^.L+J-1;
      Add(HelpTrie,I+J);
    End
    Else Begin
      Add(HelpEdge^.Child,I+J);
    End;
  End
  Else Begin
    New(HelpTrie);
    New(HelpEdge);
    Trie^.Edge[S[Num][I]] :=HelpEdge;
    HelpEdge^.Child :=HelpTrie;
    HelpEdge^.Num :=Num;
    HelpEdge^.L :=I;
    HelpEdge^.R :=Length(S[Num]);
    HelpTrie^.Num :=Num;
    HelpTrie^.NumV :=Num;
    HelpTrie^.Parent :=Trie;
    ClearEdges(HelpTrie);
  End;
End;

Begin
  Add(Trie,1);
End;

Procedure GetEdges(Trie : TTrie; H : Int);
  Var I : Char;
      J : Int;
Begin
  Trie^.H :=H;
  Use[Trie^.NumV] :=1;
  P[Trie^.NumV] :=Trie;
  For I :=Down To Up Do
    If Trie^.Edge[I]<>Nil Then
      GetEdges(Trie^.Edge[I]^.Child,H+Trie^.Edge[I]^.R-Trie^.Edge[I]^.L+1);
  If Trie^.NumV<>0 Then
    For J :=1 To N Do
      If Use[J]=2 Then Begin
        LCA[J,Trie^.NumV] :=P[J]^.H;
        LCA[Trie^.NumV,J] :=LCA[J,Trie^.NumV];
      End;
  For J :=1 To N Do
    If P[J]=Trie Then P[J] :=Trie^.Parent;
  Use[Trie^.NumV] :=2;
End;

Function Min(Const A,B : Int) : Int;
Begin
  If A<B Then Min :=A
  Else Min :=B;
End;

Function Max(Const A,B : Int) : Int;
Begin
  If A>B Then Max :=A
  Else Max :=B;
End;

Procedure WriteTrie(Trie : TTrie; Cnt : Int);
  Var I : Int;
      Sym :Char;
Begin
  For I :=1 To Cnt Do Write(' ');
  WriteLn('<');
  For Sym :=Down To Up Do
    If Trie^.Edge[Sym]<>Nil Then Begin
      For I :=1 To Cnt Do Write(' ');
      For I :=Trie^.Edge[Sym]^.L To Trie^.Edge[Sym]^.R Do
        Write(S[Trie^.Edge[Sym]^.Num,I]);
      WriteLn;
      WriteTrie(Trie^.Edge[Sym]^.Child,Cnt+1);
    End;
  WriteLn;
  For I :=1 To Cnt Do Write(' ');
  WriteLn('>');
End;

Procedure WriteAns(J : Int);
  Var JJ : Int;
Begin
  If J=A[0] Then Exit;
  WriteAns(From[J]);
  If J=From[J] Mod N+1 Then WriteLn('down')
  Else If J=(From[J]+N-2) Mod N+1 Then WriteLn('up')
  Else Begin
    WriteLn('Alt');
    For JJ :=1 To Edges[From[J],J]-1 Do
      WriteLn(S[J][JJ]);
  End;
End;

Procedure Solve;
  Var I,J,JJ,JJJ,Help : Int;
Begin
  New(Trie);
  Trie^.Num :=0;
  Trie^.NumV :=0;
  ClearEdges(Trie);
  For I :=1 To N Do Begin
    S[I] :=S[I]+Down;
    AddTrie(Trie,I);
{    WriteLn('----------',I);
    WriteTrie(Trie,0);}
  End;
//  WriteTrie(Trie,0);
  For I :=1 To N Do
    For J :=1 To N Do
      Edges[I,J] :=Infinity;
  For I :=1 To N Do Begin
    Edges[I,I Mod N+1] :=1;
    Edges[I,(I+N-2) Mod N+1] :=1;
    Edges[I,I] :=0;
  End;
  FillChar(Use,SizeOf(Use),0);
  FillChar(LCA,SizeOf(LCA),0);
  GetEdges(Trie,0);
  For I :=1 To N Do Begin
    Help :=LCA[I,(I+N-2) Mod N+1];
    If I=N Then
      For J :=I-2 DownTo 2 Do Begin
        Help :=Max(Help,LCA[I,J]);
        If Help+1<Length(S[I]) Then
          Edges[J,I] :=Help+2;
      End
    Else
      For J :=I-2 DownTo 1 Do Begin
        Help :=Max(Help,LCA[I,J]);
        If Help+1<Length(S[I]) Then
          Edges[J,I] :=Help+2;
      End;
    If I=1 Then
      For J :=N-1 DownTo I+2 Do Begin
        Help :=Max(Help,LCA[I,J]);
        If Help+1<Length(S[I]) Then
          Edges[J,I] :=Help+2;
      End
    Else
      For J :=N DownTo I+2 Do Begin
        Help :=Max(Help,LCA[I,J]);
        If Help+1<Length(S[I]) Then
          Edges[J,I] :=Help+2;
      End;
  End;
  A[0] :=1;
  For I :=1 To K Do Begin
    Read(A[I]);
    For J :=1 To N Do
      D[J] :=Infinity;
    FillChar(Use,SizeOf(Use),0);
    FillChar(From,SizeOf(From),0);
    From[A[0]] :=0;
    D[A[0]] :=0;
    For J :=1 To N Do Begin
      JJJ :=1;
      For JJ :=1 To N Do
        If (Use[JJ]=0) And ((Use[JJJ]=1) Or (D[JJ]<D[JJJ])) Then JJJ :=JJ;
      If (Use[JJJ]=1) Or (D[JJJ]=Infinity) Then Break;
      Use[JJJ] :=1;
      For JJ :=1 To N Do
        If D[JJ]>D[JJJ]+Edges[JJJ,JJ] Then Begin
          D[JJ] :=D[JJJ]+Edges[JJJ,JJ];
          From[JJ] :=JJJ;
        End;
    End;
    WriteLn(D[A[I]]);
    WriteAns(A[I]);
    A[0] :=A[I];
  End;
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.