#include <stdio.h>
#include <stdlib.h>
#include <memory.h>
#define up -1
#define down -2
#define infty 10000

typedef struct
{
	char name[3000];
	int num;
} file, *lpfile;

file array[1001];
int n;

int adjmat[1001][1001];

int find(int pos, char dummy)
{
	for (int i = pos + 1; i <= n; i++)
	{
		if (array[i].name[0] == dummy) return i;
	}

	for (int i = 1; i < pos; i++)
	{
		if (array[i].name[0] == dummy) return i;
	}

	return 0;
}

void make_adjmat()
{
	for (int i = 1; i <= n; i++)
	{
		if (i < n)
			adjmat[i][i+1] = down;
		else
			adjmat[i][1] = down;

		if (i > 1)
			adjmat[i][i-1] = up;
		else
			adjmat[1][n] = up;
	}

	for (int i = 1; i <= n; i++)
	{
		for (char dummy = 'a'; dummy <= 'z'; dummy++)
		{
			int k = find(i, dummy);
			if (k != 0)
			{
				if (adjmat[i][k] == 0)
				{
					adjmat[i][k] = (int)dummy + 1000;
				}
			}
		}
	}
}

int way(int x)
{
	if (x < 0) return 1;
	if (x == 0) return infty;
	if (x > 0) return 2;
	return 0;
}

int mark[1001];
int path[1001];
int dist[1001];

void dejikstra(int from, int to)
{
	for (int i = 1; i <= n; i++)	
	{
		mark[i] = 0;
		dist[i] = infty;
		path[i] = 0;
	}
	dist[from] = 0;

	while (1)
	{
		int v = -1;
		for (int i = 1; i <= n; i++)
			if (mark[i] == 0 && (v == -1 || dist[i] < dist[v]))
				v = i;

		if (dist[v] == infty || v == -1) break;
		mark[v] = 1;

		for (int i = 1; i <= n; i++)
		{
			if (i != v && dist[i] > dist[v] + way(adjmat[v][i]))
			{
				dist[i] = dist[v] + way(adjmat[v][i]);
				path[i] = v;
			}
		}
	}	
}

void out_edge(int i, int j)
{
	if (adjmat[i][j] == down)
	{
		printf("down\n");
		return;
	}

	if (adjmat[i][j] == up)
	{
		printf("up\n");
		return;
	}

	if (adjmat[i][j] > 0)
	{
		printf("Alt\n%c\n", (char)(adjmat[i][j] - 1000));
	}
}

int arr[1001];

void out(int from, int to)
{
	dejikstra(from, to);
	printf("%d\n", dist[to]);
	int n = to;
	int ln = 0;

	while (1)
	{		
		arr[++ln] = n;
		if (n == from) break;		
		n = path[n];
	}

	for (int i = ln; i > 1; i--)
	{
		out_edge(arr[i], arr[i-1]);
	}
}


int main()
{
	freopen("fur.in", "r", stdin);
	freopen("fur.out", "w", stdout);

	scanf("%d", &n);
	for (int i = 1; i <= n; i++)
	{
		scanf("%s", &array[i].name);
		array[i].num = i;
	}

    make_adjmat();

	int k, now;
	scanf("%d", &k);
	now = 1;
	for (int i = 1; i <= k; i++)
	{
		int a;
		scanf("%d", &a);		
        out(now, a);
		now = a;
	}

	return 0;
}