{$APPTYPE CONSOLE}
program fur;

const
 taskid = 'fur';
 infile = taskid + '.in';
 outfile = taskid + '.out';
 maxn = 1005;
 maxk = 15;
 maxs = 2005;
 inf = 1000000000;

type
 plist = ^tlist;
 pnode = ^tnode;

 tlist = record
  nd: pnode;
  next: plist;
 end;

 tnode = record
  sym: char;
  pr: pnode;
  t, dist: integer;
  c: plist;
 end;

 pedge = ^tedge;
 tedge = record
  v: integer;
  w: integer;
  key: byte;
  s: pnode;
  next: pedge;
 end;

var
 n,k: integer;
 names: array [1..maxn] of string;
 sq: array [1..maxk] of integer;

 e: array [1..maxn] of pedge;
 root: pnode;

procedure init;
 begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  new(root);
  root.sym := #0;
  root.pr := nil;
  root.c := nil;
  root.dist := 1;
 end;

procedure load;
 var i: integer;
 begin
  readln(n);
  for i := 1 to n do begin
   readln(names[i]);
   names[i] := names[i] + '#';
  end; 
  readln(k);
  for i := 1 to k do read(sq[i]);
 end;

var f: array [1..maxn] of boolean;
    d,p: array [1..maxn] of integer;
    pe: array [1..maxn] of pedge;
    dst: array [1..2*maxn] of integer;
    node: array [1..2*maxn] of pnode;

procedure addedge(u,v,w,key: integer; nd: pnode);
 var ne: pedge;
 begin
  new(ne);
  ne.v := v;
  ne.w := w;
  ne.key := key;
  ne.s := nd;
  ne.next := e[u];
  e[u] := ne;
 end;

procedure insert(var s: string; t: integer);
 var cur: plist;
     ok: boolean;
     x: pnode;
     i: integer;
     ne: pnode;
 begin
  x := root;
  for i := 1 to length(s) do begin
   ok := false;
   cur := x.c;
   while cur <> nil do begin
    if cur.nd.sym = s[i] then begin
     ok := true;
     x := cur.nd;
     break;
    end;
    cur := cur.next;
   end;
   if ok then begin
    if t < x.t then begin
     x.t := t;
     if x.dist < dst[t] then begin
      dst[t] := x.dist;
      node[t] := x;
     end;
    end;
    continue;
   end;
   new(ne);
   ne.sym := s[i];
   ne.pr := x;
   ne.dist := x.dist + 1;
   ne.t := t;
   if ne.dist < dst[t] then begin
    dst[t] := ne.dist;
    node[t] := ne;
   end;
   ne.c := nil;
   new(cur);
   cur.nd := ne;
   cur.next := x.c;
   x.c := cur;
   x := ne;
  end;
 end;

procedure delete(var s: string; i,l: integer; x: pnode);
 var cur: plist;
     min: integer;
 begin
  if i <= l then begin
   cur := x.c;
   while cur.nd.sym <> s[i] do cur := cur.next;
   delete(s, i+1, l, cur.nd);
  end;
  if x <> root then begin
   min := inf;
   cur := x.c;
   while cur <> nil do begin
    if cur.nd.t < min then begin
     min := cur.nd.t;
    end;
    cur := cur.next;
   end;
   x.t := min;
   if min = inf then exit;
   if x.dist < dst[min] then begin
    dst[min] := x.dist;
    node[min] := x;
   end;
  end;
 end;

procedure buildgraph;
 var i,j: integer;
 begin
  for i := 1 to n do begin
   addedge(i, i mod n + 1, 1, 0, nil);
   addedge(i, (i+n-2) mod n + 1, 1, 1, nil); 
  end;
  for i := 1 to 2*n do dst[i] := inf;
  for i := 1 to n do insert(names[i], i);
  for i := 1 to n do begin
   for j := 1 to n-1 do addedge(i, (i+j-1) mod n + 1, dst[i+j], 2, node[i+j]);
   delete(names[i], 1, length(names[i]), root);
   insert(names[i], i+n);
  end;
 end;

procedure dijkstra(v: integer);
 var i,j,min: integer;
     cur: pedge;
 begin
  for i := 1 to n do begin
   f[i] := false;
   d[i] := inf;
  end;
  f[v] := true;
  d[v] := 0;
  for i := 2 to n do begin
   cur := e[v];
   while cur <> nil do begin
    if d[v] + cur.w < d[cur.v] then begin
     d[cur.v] := d[v] + cur.w;
     p[cur.v] := v;
     pe[cur.v] := cur;
    end;
    cur := cur.next;
   end;
   min := inf;
   for j := 1 to n do
    if (not f[j]) and (d[j] < min) then begin
     min := d[j];
     v := j;
    end;
   f[v] := true;
  end;
 end;

var ans: array [1..maxs] of char;
    path: array [1..maxn] of pedge;

procedure solve;
 var i,v,u,q,j,pl,l: integer;
     cur: pnode;
 begin
  buildgraph;
  v := 1;
  for i := 1 to k do begin
   dijkstra(v);
   writeln(d[sq[i]]);
   u := sq[i];
   pl := 0;
   while u <> v do begin
    inc(pl);
    path[pl] := pe[u];
    u := p[u];
   end;
   for l := pl downto 1 do begin
    case path[l].key of
     0: writeln('down');
     1: writeln('up');
     2: begin
         writeln('Alt');
         q := 0;
         cur := path[l].s;
         while cur <> root do begin
          inc(q);
          ans[q] := cur.sym;
          cur := cur.pr;
         end;
         for j := q downto 1 do writeln(ans[j]);
        end;
    end;
   end;
   v := sq[i];
  end;
 end;

begin
 init;
 load;
 solve;
end.