#include <stdio.h>
#include <memory.h>
#include <string.h>
#include <math.h>

#define MAXN 1002
#define MAXLEN 2005

char a[MAXN][MAXLEN];
char path[MAXN][MAXLEN];
int n;
int res[MAXN];
int d[MAXN];

void init()
{
	freopen("fur.in", "r", stdin);
	freopen("fur.out", "w", stdout);
	memset(path, 0, sizeof(path));
	memset(a, 0, sizeof(a));
}

void readdata()
{
	int i;
	char name[MAXLEN];
	scanf("%d\n", &n);
	for(i=0;i<n;i++)
	{
		gets(name);
		strcpy(a[i], name);
	}
}

void print_path(int s, int t)
{
	if(s !=t)
	{
		print_path(s, d[t]);
		printf("%s", path[t]);
	}
}

void writedata(int s, int t)
{
	printf("%d\n", res[t-1]);
	print_path(s-1, t-1);
}

int min(int a, int b)
{
	if(a<=b) return a; else return b;
}

int check(char* str, char* t)
{
	int l1 = strlen(str);
	int l2 = strlen(t);
	int i;
	if(l1<l2) return 0;
	for(i=0;i<l2;i++)
		if(str[i]!=t[i]) return 0;
	return 1;
}

int find_first(char* name, int s, int t)
{
	int i = s;
	int k;
	k = check(a[i], name);
	i++;
	i = i % n;
	if(k) return s;
	while((!k)&&(i!=s))
	{
		i++;
		i = i %n;
		k = check(a[i], name);
	}
	if(k) return i;
	return -1;
}

void relax(int s, int t)
{
	int min = res[s], p;
	int l =1;
	int len = strlen(a[t]);
	char name[MAXLEN] = "";
	strncpy(name, a[t], l);
	p = find_first(name, s, t);
	while((p<t)&&(l<len))
	{
		l++;
		strcpy(name, "");
		strncpy(name, a[t], l);
		p = find_first(name, p, t);
		if(l+1+res[p]<min) min  = res[p]+1+l;
	}
	if(res[s]<min)
	{
		res[s] = min;
		strcpy(path[s], "Alt\n");
	}
	//printf("%s\n", name);
}

void make_path(int s, int t)
{
	int i;
}

void find_path(int s, int t)
{
	int i, k;
	memset(res, 0, sizeof(res));
	memset(d, 0, sizeof(d));
	res[s-1] = 0;
	d[s-1] = 0;
	for(i=s;i<n;i++)
	{
		res[i] = i-s+1;
		d[i] = i-1;
		strcpy(path[i],"down\n");
	}
	for(i=0;i<s-1;i++)
	{
		res[i] = res[n-1]+i+1;
		d[i] = i-1;
		if(d[i]<0) d[i]+=n;
		strcpy(path[i], "down\n");
	}
	for(i=s-2;i>=0;i--)
	{
		k = s-1-i;
		if(k<res[i])
		{
			res[i] = k;
			d[i] = i+1;
			strcpy(path[i], "up\n");
		}
	}
	for(i=n-1;i>=s;i--)
	{
		k = res[0]+n-i;
		if(k<res[i])
		{
			res[i] = k;
			d[i] = i+1;
			if(d[i]>=n) d[i] = d[i]-n;
			strcpy(path[i], "up\n");
		}
	}
}

void solve()
{
	int k, i, t, v;
	scanf("%d", &k);
	t = 1;
	for(i=0;i<k;i++)
	{
		scanf("%d", &v);
		find_path(t, v);
		writedata(t, v);
		t = v;
	}
}

int main()
{
	init();
	readdata();
	solve();
	return 0;
}