{$S 1050000}
{ $define debug}
{ $define input}
{ $define output}
  {$ifndef debug} {$define input} {$define output} {$endif}
  procedure Done (ch :longint); forward; const
  {$ifdef debug}
     maxname = 20;
     maxfiles = 20;
  {$else}
     maxname = 2001;
     maxfiles = 1000;
  {$endif}
const fname = 'fur';

type
  PFile = ^TFile;
  TFile = record
    name :array [0..maxname] of char;
    pred :array [0..maxname+1] of PFile;
    sd,d :longint;
    num :longint;
    flag :boolean;
  end;

var
  files :array [1..maxfiles] of TFile;
  graph :array [1..maxfiles, 1..maxfiles] of longint;
  n :longint;

procedure LiBuild (f :PFile; ind :longint);
var
  pf :array [char] of pfile;
  t :pfile;
begin
  if ind>maxname then exit;
  fillchar(pf, sizeof(pf), 0);
  t:=f;

  repeat
    if pf[t^.name[ind]] <> nil then
      pf[t^.name[ind]]^.pred[ind]:=t;
    pf[t^.name[ind]]:=t;

    t := t^.pred[ind-1];
  until t=f;

  repeat
    pf[t^.name[ind]]^.pred[ind]:=t;
    pf[t^.name[ind]]:=t;

    if t^.pred[ind+1]=nil then
      LiBuild(t, ind+1);

    t := t^.pred[ind-1];
  until t=f;
end;

procedure GraphBuild (f :pfile);
var
  j :longint;
  t,e :pfile;
begin
  {AltBuild}
  for j := maxname-1 downto 0 do
    if f^.pred[j+1]<>f then
      begin
        e := f^.pred[j+1];
        t := f^.pred[j];

        while t<>e do
          begin
            graph[t^.num, f^.num] := j+2;
            t := t^.pred[0];
          end;
      end;
end;

  function mina (a,b :longint) :longint;
  begin
    if ((a<b) and (a>=0)) or (b<0) then mina:=a else mina:=b;
  end;

  function min (a,b,c,d,e :longint) :longint;
  begin
    min:=mina(a,mina(b,mina(c,mina(d,e))));
  end;

procedure Deikstra (g :integer);
var
  i :longint;
begin
  for i := 1 to n do
    begin
      files[i].flag := false;
      files[i].d:=maxlongint;
    end;
  files[g].d:=0;
  files[g].sd:=0;
  repeat
    for i := 1 to n do
      if not files[i].flag then break;
    if files[i].flag then exit;
    g:=i;
    for i := i+1 to n do
      if (not files[i].flag) and (files[i].d<files[g].d) then
        g:=i;
    files[g].flag:=true;

    for i := 1 to n do
      if files[i].d>files[g].d+graph[g,i] then
        begin
          files[i].d:=files[g].d+graph[g,i];
          files[i].sd := files[g].sd+1;
        end;
  until false;
end;

procedure Run;
var
  i,j,k,g,t,gg :longint;
begin
  readln(n);
  for i := 1 to n do
    begin
      j:=0;
      while not eoln do
        begin
          inc(j);
          read(files[i].name[j]);
        end;
      readln;
      files[i].num:=i;
    end;

  for i := 1 to n do
    files[i].pred[0]:=@(files[1+(i+n-2) mod n]);
  LiBuild (@(files[1]), 1);

  fillchar(graph,sizeof(graph),127);
  for i := 1 to n do
    GraphBuild (@(files[i]));

  for i := 1 to n do
    for j := 1 to n do
      graph[i,j]:=min(graph[i,j], i-j, n+i-j, j-i, n+j-i);

  readln(k);
  g := 1;
  for i := 1 to k do
    begin
      Deikstra(g);
      read(g); gg:=g;
      {Write block}
      writeln(files[g].d);
      while files[g].sd>0 do
        begin
          for j := 1 to n do
            if (graph[j,g]>0)and(files[g].d=files[j].d+graph[g,j]) then
              break;
          {Jump write}
          if (graph[j,g]=(j-g))or(graph[j,g]=(j+n-g)) then
            for t := 1 to graph[j,g] do
              writeln('up') else
          if (graph[j,g]=(g-j))or(graph[j,g]=(g+n-j)) then
            for t := 1 to graph[j,g] do
              writeln('down') else
            begin
              writeln('Alt');
              for t := 1 to graph[j,g]-1 do
                writeln(files[g].name[t]);
            end;
          g:=j;
        end;
      g:=gg;
    end;
end;

procedure WriteData (ch :longint);
var
  i,j :longint;
begin
  {debug 1
    readln(i,j);
    writeln(graph[i,j]);
  {end of debug 1}//}
end;

procedure Done (ch :longint); begin WriteData(ch); close(input); close(output); halt(0); end;
begin
  {$ifdef input} assign(input,fname+'.in'); reset(input); {$endif}
  {$ifdef output} assign(output,fname+'.out'); rewrite(output); {$endif}
  Run; Done(0);
end.
