#include <stdio.h>
#include <string>
using namespace std;

#define Inf 1000000000

string Way[1001][1001];
int W[1001][1001];
string Name[1001];
char Temp[2001];
int n;

int CountDown(int a,int b)
{
	if (a == b)
		return 0;
	if (a < b)
		return b - a;
	return CountDown(1,b) + CountDown(a,n) + 1;
}

int CountUp(int a,int b)
{
	if (a == b)
		return 0;
	if (b < a)
		return a - b;
	return CountUp(a,1) + CountUp(n,b) + 1;
}

int next(int a)
{
	if (a == n)
		return 1;
	return a + 1;
}

int prev(int a)
{
	if (a == 1)
		return n;
	return a - 1;
}

void Dijkstra(int b,int e)
{
	int P[1001];
	int C[1001];
	int Who[1001];
	int color[1001];
	int Q[1001];
	int i;
	for(i = 1; i <= n; ++i)
	{
		P[i] = 0;
		C[i] = W[b][i];
		Who[i] = b;
		color[i] = 0;
		Q[i] = 0;
	}
	P[b] = -1;
	color[b] = 1;
	int cur = b;
	int MinV,MinI;
	while(cur != e)
	{
		MinV = Inf;
		MinI = -1;
		for(i = 1; i <= n; ++i)
		{
			if (color[i] == 0 && C[i] < MinV)
			{
				MinV = C[i];
				MinI = i;
			}
		}
		P[MinI] = Who[MinI];
		color[MinI] = 1;
		for(i = 1; i <= n; ++i)
		{
			if (color[i] == 0)
			{
				if (C[i] > C[MinI] + W[MinI][i])
				{
					C[i] = C[MinI] + W[MinI][i];
					Who[i] = MinI;
				}
			}
		}
		cur = MinI;
	}
	i = e;
	cur = 1;
	while(i != -1)
	{
		Q[cur++] = i;
		i = P[i];
	}
	printf("%d\n",C[e]);
	for(i = cur - 1; i > 1; --i)
		printf("%s",Way[Q[i]][Q[i-1]].c_str());
}

int Pref(string a, string b, int l)
{
	if (a.length() < l)
		return 0;
	int i;
	for(i = 0; i <= l; ++i)
		if (a[i] != b[i])
			return 0;
	return 1;
}

int Down,Up,Len,Alt,start,end,count,k;

int main ()
{
	freopen("fur.in","r",stdin);
	freopen("fur.out","w",stdout);

	int i,j,l,q;
	scanf("%d\n",&n);
	for(i = 1; i <= n; ++i)
	{
		scanf("%s",Temp);
		Name[i] = Temp;
	}
	for(i = 1; i <= n; ++i)
	{
		for(j = 1; j <= n; ++j)
		{
			if (i == j)
			{
				W[i][j] = 0;
				continue;
			}
			Down = CountDown(i,j);
			Up = CountUp(i,j);
			Len = Name[j].length();
			Alt = Inf;
			for(l = 0; l < Len; ++l)
			{
				q = i;
				count = 0;
				while(Pref(Name[q],Name[j],l) == 0)
				{
					q = next(q);
					++count;
					if (count > n)
					{
						Alt = Inf;
						break;
					}
				}
				if (q == j && l + 2 < Alt)
				{
					Alt = l + 2;
					break;
				}
			}
			if (Down <= Up && Down <= Alt)
			{
				W[i][j] = Down;
				for(l = 1; l <= Down; ++l)
					Way[i][j] = Way[i][j] + "down"+"\n";
				continue;
			}
			if (Up <= Down && Up <= Alt)
			{
				W[i][j] = Up;
				for(l = 1; l <= Up; ++l)
					Way[i][j] = Way[i][j] + "up"+"\n";
				continue;
			}
			if (Alt <= Up && Alt <= Down)
			{
				W[i][j] = Alt;
				Way[i][j] = "Alt";
				Way[i][j] = Way[i][j] + "\n";
				for(l = 0; l < Alt - 1; ++l)
					Way[i][j] = Way[i][j] + Name[j][l]+"\n";
				continue;
			}
		}
	}
	start = 1;
	scanf("%d",&k);
	for(i = 1; i <= k; ++i)
	{
		scanf("%d",&end);
		Dijkstra(start,end);
		start = end;
	}
	return 0;
}