program P_2;

{$APPTYPE CONSOLE}

const
  MaxN = 1010;
  MaxM = 510;
  Inf = MaxM * 2;
  MaxL = 5;
var
  n, c : LongInt;
  s : Array[1 .. MaxN] of String;
  bor : Array[1 .. MaxN * MaxM] of
  record
    pred : Word;
    sons : Array['a' .. 'z'] of Word;
  end;
  sm : Array[1 .. MaxN, 1 .. MaxN] of Word;
  d, p : Array[1 .. MaxN] of LongInt;
  u : Array[1 .. MaxN] of Boolean;

Procedure Init;
var
  i : LongInt;
begin
  Reset(input, 'fur.in');
  Rewrite(output, 'fur.out');
  ReadLn(n);
  for i := 1 to n do
  begin
    ReadLn(s[i]);
    if Length(s[i]) > MaxM then
      Delete(s[i], MaxM + 1, Length(s[i]) - MaxM);
  end;
end;

Function Min(const a, b : Word) : Word;
begin
  if a < b then
    Min := a
  else
    Min := b;
end;

Procedure Go(var tek : LongInt; const ch : Char);
begin
  if bor[tek].sons[ch] = 0 then
  begin
    Inc(c);
    bor[tek].sons[ch] := c;
  end;
  tek := bor[tek].sons[ch];
end;

Procedure AddToBor(const r : LongInt);
var
  i, j, tek, p : LongInt;
begin
  tek := 1;
  p := 0;
  for i := 1 to Length(s[r]) do
  begin
    Go(tek, s[r][i]);
    if bor[tek].pred <> 0 then
      if p <> bor[tek].pred then
      begin
        p := bor[tek].pred;
        if p < r then
        begin
          for j := p + 1 to r do
            sm[j][r] := Min(sm[j][r], i + 1);
        end
        else
        begin
          for j := r + 1 to n do
            sm[j][r] := Min(sm[j][r], i + 1);
          for j := 1 to p do
            sm[j][r] := Min(sm[j][r], i + 1);
        end;
      end;
    bor[tek].pred := r;
  end;
end;

Procedure Dejkstra(const a : LongInt);
var
  i, t, m : LongInt;
begin
  for i := 1 to n do
  begin
    d[i] := Inf;
    u[i] := False;
  end;
  d[a] := 0;
  for t := 1 to n do
  begin
    m := 1;
    for i := 1 to n do
      if (not u[i]) and ((u[m]) or (d[m] > d[i])) then
        m := i;
    u[m] := True;
    for i := 1 to n do
      if d[i] > d[m] + sm[m][i] then
      begin
        d[i] := d[m] + sm[m][i];
        p[i] := m;
      end;
  end;   
end;

Procedure WriteRoute(j : LongInt);
var
  i : LongInt;
begin
  if d[j] <> 0 then
  begin    
    WriteRoute(p[j]);
    if d[j] - d[p[j]] = Min((p[j] - j + n) mod n, (j - p[j] + n) mod n) then
    begin
      if (p[j] - j + n) mod n < (j - p[j] + n) mod n then
        for i := 1 to d[j] - d[p[j]] do
          WriteLn('up')
      else
        for i := 1 to d[j] - d[p[j]] do
          WriteLn('down');
    end
    else
    begin
      WriteLn('Alt');
      for i := 1 to d[j] - d[p[j]] - 1 do
        WriteLn(s[j][i]);
    end;
  end;
end;

Procedure Solve;
var
  i, j, k, tek : LongInt;
begin
  c := 1;
  FillChar(bor, SizeOf(bor), 0);
  for i := 1 to n do
    for j := 1 to n do
        sm[i][j] := Min((i - j + n) mod n, (j - i + n) mod n);
  for j := 1 to 2 do
    for i := 1 to n do
      AddToBor(i);
  ReadLn(k);
  tek := 1;
  for i := 1 to k do
  begin
    Read(j);
    Dejkstra(tek);
    WriteLn(d[j]);
    WriteRoute(j);
    tek := j; 
  end;
end;

Procedure Print;
begin
  Close(input);
  Close(output);
end;

begin
  Init;
  Solve;
  Print;
end.
 