program Task2;

uses
  SysUtils,
  Math;

var
  N, K, CurrentFile, AltCount, MinMoves: Integer;
  Map: AnsiString;
  FileList: array [1..1000] of AnsiString;
  UseFiles: array [1..10] of Integer;

procedure ReadInput;
var
  F: TextFile;
  I: Integer;
begin
  AssignFile(F, 'fur.in');
  Reset(F);
  ReadLn(F, N);
  for I := 1 to N do ReadLn(F, FileList[I]);
  ReadLn(F, K);
  for I := 1 to K do Read(F, UseFiles[I]);
  CloseFile(F);
end;

function AltGo(From: Integer; AltChar: string): Integer;
var
  I: Integer;
begin
  for I := From to N do begin
    if Copy(FileList[I], 1, Length(AltChar)) = AltChar then begin
      Result := I;
      Exit;
    end;
  end;
  for I := 1 to From - 1 do begin
    if Copy(FileList[I], 1, Length(AltChar)) = AltChar then begin
      Result := I;
      Exit;
    end;
  end;
end;

function GetViaDown(From: Integer): Integer;
begin
  if From < UseFiles[CurrentFile] then Result := UseFiles[CurrentFile] - From
  else Result := UseFiles[CurrentFile] - From + N;
end;

function GetViaTop(From: Integer): Integer;
begin
  if From < UseFiles[CurrentFile] then Result := From - UseFiles[CurrentFile] + N
  else Result := From - UseFiles[CurrentFile];
end;

procedure BuildMap(From: Integer);
var
  ViaTop, ViaDown: Integer;
  I: Integer;
begin
  Map := '';

  if AltCount > 0 then begin
    Map := 'Alt';
    for I := 1 to AltCount do
      Map := Map + #13#10 + FileList[UseFiles[CurrentFile]][I];
  end;

  ViaDown := GetViaDown(From);
  ViaTop := GetViaTop(From);
  if ViaDown <= ViaTop then begin
    MinMoves := ViaDown;
    for I := 1 to ViaDown do
      Map := Map + #13#10 + 'down';
  end else begin
    MinMoves := ViaTop;
    for I := 1 to ViaTop do
      Map := Map + #13#10 + 'up';
  end;

  if AltCount > 0 then
    MinMoves := MinMoves + 1 + AltCount;
end;

var
  CurrentPos: Integer;
  F: TextFile;
begin
  ReadInput;

  AssignFile(F, 'fur.out');
  Rewrite(F);
  CurrentPos := 1;
  for CurrentFile := 1 to K do begin
    AltCount := 0;
    BuildMap(CurrentPos);

    repeat
      Inc(AltCount);
      CurrentPos := AltGo(CurrentPos, Copy(FileList[UseFiles[CurrentFile]], 1, AltCount));

      if Min(GetViaDown(CurrentPos), GetViaTop(CurrentPos)) + 1 + AltCount < MinMoves then
        BuildMap(CurrentPos);
    until AltCount = Length(FileList[UseFiles[CurrentFile]]);
    CurrentPos := UseFiles[CurrentFile];

    WriteLn(F, MinMoves);
    if MinMoves > 0 then WriteLn(F, TrimLeft(Map));
  end;
  CloseFile(F);
end.
