{$O+,Q-,R-}
program Fur;

{$APPTYPE CONSOLE}

uses
  SysUtils, dialogs;

const
  MaxN = 1000;
  MaxK = 10;
  MaxL = 2000;
  MaxT = 100000;

type
  TTreeVertex = record
    children: array ['a'..'z'] of integer;
  end;

  TWayVertex = record
    wayLen: integer;
    parent: integer;
  end;

  TGraphVertex = record
    connection: integer;
    jumpMethod: integer;
  end;

var
  n, k, i, j, p, l, c, treePos: integer;
  s: string;
  files: array [1..MaxN] of string;
  use: array [0..MaxN] of integer;
  tree: array [0..MaxT] of TTreeVertex;
  graph: array [1..MaxN, 1..MaxN] of TGraphVertex;
  ways: array [1..MaxN] of TWayVertex;

procedure FindWay(par, ver, len: integer);
var
  i: integer;
begin
  ways[ver].wayLen := len;
  ways[ver].parent := par;
  for i := 1 to n do
    if (graph[ver, i].connection > 0) and
     (ways[i].wayLen > len + graph[ver, i].connection) then
      FindWay(ver, i, len + graph[ver, i].connection);
end;

function NextVertex(v: integer): integer;
begin
  Result := v + 1;
  if Result > n then Result := 1;
end;

function PrevVertex(v: integer): integer;
begin
  Result := v - 1;
  if Result < 1 then Result := n;
end;

begin
  AssignFile(Input, 'fur.in');
  AssignFile(Output, 'fur.out');
  Reset(Input);
  Rewrite(Output);

  Readln(n);
  for i := 1 to n do
  begin
    Readln(files[i]);
    files[i] := Trim(files[i]);
  end;
  use[0] := 1;
  Readln(k);
  for i := 1 to k do Read(use[i]);

  for i := 1 to n do
  begin
    FillChar(tree, SizeOf(tree), 0);
    treePos := 0;
    graph[i, i].connection := 0;
    graph[i, i].jumpMethod := 0;
    graph[i, NextVertex(i)].connection := 1;
    graph[i, NextVertex(i)].jumpMethod := 1;
    graph[i, PrevVertex(i)].connection := 1;
    graph[i, PrevVertex(i)].jumpMethod := 2;
    j := i;
    if j > n then j := j mod n;
    while (j <> PrevVertex(i)) do
    begin
      p := 0;
      l := 1;
      while tree[p].children[files[j][l]] > 0 do
      begin
        p := tree[p].children[files[j][l]];
        Inc(l);
        if l > Length(files[j]) then
        begin
          p := -1;
          Break;
        end;
      end;
      if p = -1 then
      begin
        if  (j <> i) and (j <> NextVertex(i)) then
        begin
          graph[i, j].connection := 0;
          graph[i, j].jumpMethod := 0;
        end;
      end
      else
      begin
        if  (j <> i) and (j <> NextVertex(i)) then
        begin
          graph[i, j].connection := l + 1;
          graph[i, j].jumpMethod := 3;
        end;
        for c := l to Length(files[i]) do
        begin
          Inc(treePos);
          tree[p].children[files[j][c]] := treePos;
          p := treePos;
        end;
      end;

      j := NextVertex(j)
    end;
  end;

  for i := 1 to k do
  begin
    for j := 1 to n do
    begin
      ways[j].wayLen := High(integer);
      ways[j].parent := 0;
    end;
    if use[i-1] = use[i] then
      Writeln('0')
    else
    begin
      FindWay(0, use[i-1], 0);
      p := use[i];
      Writeln(ways[p].wayLen);
      s := '';
      while p <> use[i-1] do
      begin
        case graph[ways[p].parent, p].jumpMethod of
          1: s := 'down'#13#10 + s;
          2: s := 'up'#13#10 + s;
          3:
          begin
            for c := 1 to graph[ways[p].parent, p].connection - 1 do
              s := files[p][c] + #13#10 + s;
            s := 'Alt'#13#10 + s;
          end;
        end;
        p := ways[p].parent;
      end;
      Write(s);
    end;
  end;

  CloseFile(Input);
  CloseFile(Output);
end.
