#include <iostream>
#include <string>
#include <set>
#include <algorithm>

#define inf 1000000

using namespace std;

set<string> q;
string s[1010];
int d[1010][1010], n, i, dist[1010], p[1010], path[1010], pathlen, k, x, y;
set<string>::iterator next, prev;

inline int fix(int x){
	return (n+(x%n))%n;
}

inline int common(string x, string y){
	int i;
	for (i=0; i<x.size()&&i<y.size()&&x[i]==y[i]; i++);
	return i;
}

void makegraph(){
	int i, j, lca, t;
	for (i=0; i<n; i++){
		q.clear();
		q.insert(s[i]);
		for (j=1; j<n-1; j++){
			lca=-1;
			next=prev=q.insert(s[fix(i+j)]).first;
			next++;
			prev--;
			if (prev!=q.end()){
				t=common(s[fix(i+j)], *prev);
				if (t>lca) lca=t;
			}
			if (next!=q.end()){
				t=common(s[fix(i+j)], *next);
				if (t>lca) lca=t;
			}
			if (lca==-1||lca==s[fix(i+j)].size()) d[i][fix(i+j)]=inf; else d[i][fix(i+j)]=lca+2;
		}
	}
	for (i=0; i<n; i++)
		d[i][fix(i-1)]=d[i][fix(i+1)]=1;
}

void dijkstra(int x){
	char col[1000];
	int i, j, min;
	for (i=0; i<n; i++){
		dist[i]=inf;
		col[i]=0;
	}
	dist[x]=0;
	p[x]=-1;
	for (j=0; j<n; j++){
		min=-1;
		for (i=0; i<n; i++) if (col[i]==0&&(min==-1||dist[i]<dist[min])) min=i;
		col[min]=1;
		for (i=0; i<n; i++)
			if (dist[i]>dist[min]+d[min][i]){
				dist[i]=dist[min]+d[min][i];
				p[i]=min;
			}
	}
}

void makepath(int x){
	pathlen=0;
	while (p[x]!=-1){
		path[pathlen++]=x;
		x=p[x];
	}
	path[pathlen++]=x;
	reverse(&path[0], &path[pathlen]);
}

void printedge(int x, int y){
	int i, n;
	if (fix(x+1)==y) printf("down\n");
	else if (fix(x-1)==y) printf("up\n");
	else {
		printf("Alt\n");
		n=common(s[x], s[y])+1;
		for (i=0; i<n; i++)
			printf("%c\n", s[y][i]);
	}
}

void printpath(){
	int i;
	for (i=0; i<pathlen-1; i++){
		printedge(path[i], path[i+1]);
	}
}

int main(){
	freopen("fur.in", "rt", stdin);
	freopen("fur.out", "wt", stdout);
	scanf("%d\n", &n);
	for (i=0; i<n; i++)
		getline(cin, s[i], '\n');
	makegraph();
	scanf("%d", &k);
	x=0;
	for (i=0; i<k; i++){
		scanf("%d", &y);
		y--;
		dijkstra(x);
		makepath(y);
		printf("%d\n", dist[y]);
		printpath();
		x=y;
	}
	return 0;
}