#include <iostream>
#include <cstring>
#include <set>
#include <algorithm>

#define inf 1000000

using namespace std;

char s[1010][2010];

struct Less{
	bool operator()(int x, int y){
		return strcmp(s[x], s[y])==-1;
	}
};

set<int, Less> q;
int d[1010][1010], n, i, dist[1010], p[1010], path[1010], pathlen, k, x, y;
set<int, Less>::iterator next, prev;

inline int fix(int x){
	return (n+(x%n))%n;
}

inline int common(int x, int y){
	int i;
	for (i=0; s[x][i]&&s[y][i]&&s[x][i]==s[y][i]; i++);
	return i;
}

void makegraph(){
	int i, j, lcp, t;
	for (i=0; i<n; i++){
		q.clear();
		q.insert(i);
		for (j=1; j<n-1; j++){
			lcp=-1;
			next=prev=q.insert(fix(i+j)).first;
			if (prev!=q.begin()){
				prev--;
				t=common(fix(i+j), *prev);
				if (t>lcp) lcp=t;
			}
			next++;
			if (next!=q.end()){
				t=common(fix(i+j), *next);
				if (t>lcp) lcp=t;
			}
			if (lcp==-1||s[fix(i+j)][lcp]==0) d[i][fix(i+j)]=inf; else d[i][fix(i+j)]=lcp+2;
		}
	}
	for (i=0; i<n; i++)
		d[i][fix(i-1)]=d[i][fix(i+1)]=1;
}

void dijkstra(int x){
	char col[1000];
	int i, j, min;
	for (i=0; i<n; i++){
		dist[i]=inf;
		col[i]=0;
	}
	dist[x]=0;
	p[x]=-1;
	for (j=0; j<n; j++){
		min=-1;
		for (i=0; i<n; i++) if (col[i]==0&&(min==-1||dist[i]<dist[min])) min=i;
		col[min]=1;
		for (i=0; i<n; i++)
			if (dist[i]>dist[min]+d[min][i]){
				dist[i]=dist[min]+d[min][i];
				p[i]=min;
			}
	}
}

void makepath(int x){
	pathlen=0;
	while (p[x]!=-1){
		path[pathlen++]=x;
		x=p[x];
	}
	path[pathlen++]=x;
	reverse(&path[0], &path[pathlen]);
}

void printedge(int x, int y){
	int i, n;
	if (fix(x+1)==y) printf("down\n");
	else if (fix(x-1)==y) printf("up\n");
	else {
		printf("Alt\n");
		n=common(x, y)+1;
		for (i=0; i<n; i++)
			printf("%c\n", s[y][i]);
	}
}

void printpath(){
	int i;
	for (i=0; i<pathlen-1; i++){
		printedge(path[i], path[i+1]);
	}
}

int main(){
	freopen("fur.in", "rt", stdin);
	freopen("fur.out", "wt", stdout);
	scanf("%d", &n);
	char tmp[2020];
	for (i=0; i<n; i++)
		scanf("%s", s[i]);
	makegraph();
	scanf("%d", &k);
	x=0;
	for (i=0; i<k; i++){
		scanf("%d", &y);
		y--;
		dijkstra(x);
		makepath(y);
		printf("%d\n", dist[y]);
		printpath();
		x=y;
	}
	return 0;
}