#include <stdio.h>
#include <string.h>

#define MAX_N 1006
#define MAX_L 2005
#define MAX_K 12

#define STATE(N, L) (N * MAX_N + (L + 1))
#define GET_L(S)    ((S % MAX_N) - 1)
#define GET_N(S)    (S / MAX_N)

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

short int To[2 * MAX_N * MAX_L];
int EH[MAX_N][MAX_L], Ne[2 * MAX_N * MAX_L], EP = 0;

int Q[MAX_N * MAX_L], D[MAX_N][MAX_L], P[MAX_N][MAX_L];

int ind[MAX_N];
char Words[MAX_N][MAX_L];

int N;

void QS( int l, int r )
{
  int i = l, j = r, x = ind[(l + r + 1) >> 1], tmp;
  
  if (l >= r)
    return;
  while (i < j)
  {
    while (strcmp(Words[ind[i]], Words[x]) < 0)
      i++;
    while (strcmp(Words[ind[j]], Words[x]) > 0)
      j--;
    if (i <= j)
    {
      if (i != j)
        SWAP(ind[i], ind[j], tmp);
      i++, j--;
    }
  }

  QS(l, j);
  QS(i, r);
}

void AddE( int n1, int l1, int n2, int l2 )
{
  To[EP] = STATE(n2, l2);
  Ne[EP] = EH[n1][l1];
  EH[n1][l1] = EP++;
}

int DistDown( int i1, int i2 )
{
  if (i1 <= i2)
    return i2 - i1;
  return N + i2 - i1;
}

void MakeEdge( int u, int d, int q )
{
  int i1, i2, i, j, m;

  for (i1 = u, i2 = u; i2 <= d; i2++)
    if (i2 == d || Words[ind[i2 + 1]][q] != Words[ind[i1]][q])
    {
      if (Words[ind[i1]][q] != 0)
      {
        for (i = u; i < i1; i++)
        {
          for (m = ind[i1], j = i1; j <= i2; j++)
            if (DistDown(ind[i], m) > DistDown(ind[i], ind[j]))
              m = ind[j];
          AddE(ind[i], q, m, q + 1);
        }
        for (i = i2 + 1; i <= d; i++)
        {
          for (m = ind[i1], j = i1; j <= i2; j++)
            if (DistDown(ind[i], m) > DistDown(ind[i], ind[j]))
              m = ind[j];
          AddE(ind[i], q, m, q + 1);
        }
        if (i1 < i2)
          MakeEdge(i1, i2, q + 1);
      }
      
      i1 = i2 + 1;
    }
}

void Bfs( int v )
{
  int st, en, n, l, i, t, tl;
  
  memset(D, -1, sizeof(D));
  memset(P, -1, sizeof(P));
  Q[0] = STATE(v, -1), D[v][0] = 0;

  for (st = en = 0; st <= en; st++)
  {
    n = GET_N(Q[st]), l = GET_L(Q[st]);
    if (l == -1)
    {
      t = (n + 1) % N;
      if (D[t][0] == -1)
      {
        D[t][0] = D[n][0] + 1;
        P[t][0] = Q[st];
        Q[++en] = STATE(t, -1);
      }
      t = (n - 1 + N) % N;
      if (D[t][0] == -1)
      {
        D[t][0] = D[n][0] + 1;
        P[t][0] = Q[st];
        Q[++en] = STATE(t, -1);
      }
      if (D[n][1] == -1)
      {
        D[n][1] = D[n][0] + 1;
        P[t][1] = Q[st];
        Q[++en] = STATE(t, 0);
      }
    }
    else
    {
      for (i = EH[n][l + 1]; i != -1; i = Ne[i])
      {
        t = GET_N(To[i]), tl = GET_L(To[i]);

        if (D[t][0] == -1)
        {
          D[t][0] = D[n][l + 1] + 1;
          P[t][1] = Q[st];
          Q[++en] = STATE(t, -1);
        }
        if (D[t][tl + 1] == -1)
        {
          D[t][tl + 1] = D[n][l + 1] + 1;
          P[t][1] = Q[st];
          Q[++en] = STATE(t, tl);
        }
      }
    }
  }
}

int main( void )
{
  int K, i, j, cur, t, n, nn, l, nl;

  freopen("fur.in", "rt", stdin);
  freopen("fur.out", "wt", stdout);

  scanf("%i", &N);
  for (i = 0; i < N; i++)
    scanf("%s", Words[i]), ind[i] = i;
  QS(0, N - 1);
 
  memset(EH, -1, sizeof(EH));
  MakeEdge(0, N - 1, 0);

  for (cur = 0, scanf("%i", &K); K; K--, cur = t)
  {
    scanf("%i", &t), t--;
    
    Bfs(t);
    printf("%i\n", D[cur][0]);

    n = cur, l = -1;
    while (P[n][l + 1] != -1)
    {
      nn = GET_N(P[n][l + 1]), nl = GET_L(P[n][l + 1]);
      //printf("%i %i\n", n, l);
      
      if (nl == -1 && ((n + 1) % N) == nn)
        printf("down\n");
      else if (nl == -1 && ((n - 1 + N) % N) == nn)
        printf("up\n");
      else if (nl == -1 && l == 0)
        printf("Alt\n");
      else
        printf("%c\n", Words[n][nl]);
      
      n = nn, l = nl;
    }
    //printf("%i %i\n\n", n, l);
  }


  memset(To, -1, sizeof(To));
  memset(Ne, -1, sizeof(Ne));
  memset(Q, -1, sizeof(Q));
  memset(D, -1, sizeof(D));
  memset(ind, -1, sizeof(ind));
  memset(Words, -1, sizeof(Words));
  memset(P, -1, sizeof(P));

  return 0;
}
