#include <stdio.h>

#define SWAP( a, b, c ) (c) = (a), (a) = (b), (b) = (c)

#define Next(i) (((i) + 1) % N)
#define Prev(i) (((i) + N -  1) % N)

char Names[1000][2001];
int Size[1000];
int N, K;

int DistD( int a, int b )
{
	if (b > a)
		return b - a;
	return N - b + a;
}
int DistU( int a, int b )
{
	if (b < a)
		return a - b;
	return N - b + a;
}


int GetF(char *S1, int N1, char *S2, int N2)
{
	int r = -1;
	while (r < N1 - 1 && r <  N2 - 1 && S1[r + 1] == S2[r + 1])
		r++;
	return r + 1;
}

int Pref[1000][1000];

typedef struct
{
	int st;/*0 - up, 1 - down, 2 - alt*/
	int d;
} EDGE;
typedef struct
{
	EDGE E[1000];
} VERT;

VERT V[1000];

int H[1000], HN, Where[1000], Wich[1000], St[1000], Prev[1000],
Dist[1000];

void SWP( int i, int j )
{
	int t;
	SWAP(H[i], H[j], t);
	SWAP(Wich[i], Wich[j], t);
	Where[Wich[i]] = i;
	Where[Wich[j]] = j;
}

void FixDown( int i )
{
	int l, r, min, t;

	min = i;
	l = (i << 1) + 1;
	r = l + 1;
	if (l < HN && H[l] < H[min])
		min = l;
	if (r < HN && H[r] < H[min])
		min = r;
	if (min != i)
	{
		SWP(min, i);
		FixDown(min);
	}

}

void FixUp( int i )
{
	int n;
	while (i > 0 && H[(n = ((i - 1) >> 1))] > H[i])
		SWP(n, i), i = n;
}

void Add( int v, int d )
{
	H[HN] = d;
	Where[v] = HN;
	Wich[HN] = v;
	FixUp(HN);
	HN++;
}

void DelUp( void )
{
	SWP(0, HN - 1);
	HN--;
	FixDown(0);
}

void Deicstra( int a, int b) 
{
	int i, j, k, mv, md, t;

	HN = 0;
	for (i = 0; i < N; i++)
		Wich[i] = 0, Where[i] = 0, St[i] = 0;
	Add(a, 0);
	while (HN > 0)
	{
		mv = Wich[0];
		md = H[0];
		DelUp();
		St[mv] = 2;
		Dist[mv] = md;
		if (mv == b)
			return;
		for (i = 0; i < N; i++)
			if (St[i] != 2)
			{
				if (St[i] == 0)
				{
					St[i] = 1;
					Prev[i] = mv;
					Add(i, md + V[mv].E[i].d);
				}
				else
				{
					t = md + V[mv].E[i].d;
					if (t < H[Where[i]])
						H[Where[i]] = t, FixUp(Where[i]),
						Prev[i] = mv;
				}
			}

	}
}

int W[2000];
int WN;

int main( void )
{
	int i, j, k, a = 1, b = 1, t, d, min, cp, cd, isu, mpref;
	char c;
	freopen("fur.in", "rt", stdin);
	freopen("fur.out", "wt", stdout);
	scanf("%i", &N);
	for (i = 0; i < N; i++)
	{
		while ((c = getc(stdin)) < 'a' || c > 'z')
			;
		Size[i] = 1;
		Names[i][0] = c;
		while ((c = getc(stdin)) >= 'a' && c <= 'z')
			Names[i][Size[i]++] = c;
	}
	for (i = 0; i < N; i++)
		for (j = i + 1; j < N; j++)
			Pref[i][j] = Pref[j][i] = GetF(Names[i], Size[i], Names[j], Size[j]);
	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
			if (i != j)
			{
				V[i].E[j].st = 0;
				V[i].E[j].d = DistU(i, j);
				if (DistD(i, j) < V[i].E[j].d)
					V[i].E[j].st = 1,
					V[i].E[j].d = DistD(i, j);
			}
	for (i = 0; i < N; i++)
	{
		mpref = 0;
		for (j = Prev(i); j != i; j = Prev(j))
		{
			if ((t = Pref[i][j]) > mpref)
				mpref = t;
			if (t != Size[i] && V[j].E[i].d > mpref + 2)
				V[j].E[i].d = mpref + 2,
				V[j].E[i].st = 2;
		
		}
	}

	
	scanf("%i", &K);
	for (j = 0; j  < K; j++)
	{
		a = b;
		scanf("%i", &b);
		if (a == b)
		{
			printf("0\n");
			continue;
		}
		Deicstra(a - 1, b - 1);
		WN = 0;
		printf("%i\n", Dist[b - 1]);
		t = b - 1;
		do
		{
			W[WN++] = t;
			t = Prev[t];
		} while (t != a - 1);
		W[WN++] = a - 1;
		for (i = WN - 1; i > 0; i--)
			switch(V[W[i]].E[W[i - 1]].st)
			{
			case 0:
				for (k = 0; k < V[W[i]].E[W[i - 1]].d; k++)
					printf("up\n");
				break;
			case 1:
				for (k = 0; k < V[W[i]].E[W[i - 1]].d; k++)
					printf("down\n");
				break;
			case 2:
				printf("Alt\n");
				for (k = 0; k  < V[W[i]].E[W[i - 1]].d - 1; k++)
					putc(Names[W[i - 1]][k], stdout),
					putc('\n', stdout);
				break;
			}
	}
	return 0;
}
