{$A8,B-,C+,D+,E-,F-,G+,H+,I-,J-,K-,L+,M-,N+,O-,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
{$MINSTACKSIZE $00004000}
{$MAXSTACKSIZE $00100000}

program fur_ea;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const namein='fur.in';
      nameout='fur.out';
      NMax=1100;
      NA=-1;
      Up=-2;
      Down=-3;
type
 TDat=array [1..NMax] of string;
 TLn=array [1..NMax] of integer;
 TBl=array [1..NMax] of boolean;
 TGraph=array [1..NMax,1..NMax] of integer;
var w:TDat;
    n,m:integer;
    c,s,d,p:TLn;
    f:TBl;
    g,x,y:TGraph;

procedure Init;
var i:integer;
begin
 assign(input,namein);
 reset(input);
 readln(n);
 for i:=1 to n do readln(w[i]);
 readln(m);
 for i:=1 to m do read(c[i]);
 randseed:=n;
 close(input)
end;

procedure SortS(l,r:integer);
var i,j,v:integer;
    q:string;
begin
 i:=l; j:=r; q:=w[s[l+random(r-l)]];
 repeat
  while w[s[i]]<q do inc(i);
  while w[s[j]]>q do dec(j);
  if i<=j then begin
    v:=s[i]; s[i]:=s[j]; s[j]:=v;
    inc(i); dec(j)
   end
 until i>j;
 if i<r then SortS(i,r);
 if l<j then SortS(l,j)
end;

function Eq(const a,b:string):boolean;
var i:integer;
begin
 i:=0;
 while (i<length(a))and(i<length(b))and(a[i+1]=b[i+1]) do inc(i);
 Result:=(i=length(b))
end;

function FindS(const a:string):integer;
var l,r,q:integer;
begin
 l:=1; r:=n+1;
 while l<r do begin
   q:=(l+r) div 2;
   if Eq(w[s[q]],a) then begin
     Result:=q;
     Exit
    end
   else
    if a<w[s[q]] then r:=q-1
    else l:=q+1
  end;
 if Eq(w[s[l]],a) then Result:=l
 else Result:=NA
end;

function FindN(a,b:integer; q:string):integer;
var i,t,l,tl:integer;
begin
 i:=b; t:=NA; tl:=maxint;
 while (i<=n) and Eq(w[s[i]],q) do begin
   if s[i]>=a then l:=s[i]-a else l:=n-a+s[i];
   if l<tl then begin
     t:=i;
     tl:=l
    end;
   inc(i)
  end;
 i:=b;
 while (i>0) and Eq(w[s[i]],q) do begin
   if s[i]>=a then l:=s[i]-a else l:=n-a+s[i];
   if l<tl then begin
     t:=i;
     tl:=l
    end;
   dec(i)
  end;
 Result:=s[t] 
end;

function Relax(a,b,c,d:integer):integer;
begin
 if (g[a,b]=NA)or(g[a,b]>c) then begin
   g[a,b]:=c+1;
   x[a,b]:=d;
  end
end;

procedure BuiltStr;
var i,j,k,v,a:integer;
    p:string;
    ok:boolean;
begin
 for i:=1 to n do s[i]:=i;
 SortS(1,n);
 fillchar(g,sizeof(g),NA);
 for i:=1 to n do begin
   if i<>n then a:=i+1 else a:=1;
   g[i,a]:=1; x[i,a]:=Down;
   if i<>1 then a:=i-1 else a:=n;
   g[i,a]:=1; x[i,a]:=Up;
   fillchar(f,sizeof(f),false);
   f[i]:=true;
   for j:=1 to n do
    if not f[j] then begin
      k:=1; ok:=false; p:='';
      while (k<=length(w[j])) and not ok do begin
        p:=p+w[j,k];
        v:=FindS(p);
        if v<>NA then begin
          v:=FindN(i,v,p);
          f[v]:=true;
          Relax(i,v,k,j);
          if v=j then ok:=true
         end;
        inc(k) 
       end
     end
  end
end;

procedure PrintWay(b,l:integer);
var i:integer;
begin
 if b<>l then begin
   PrintWay(p[b],l);
   if x[p[b],b]=Up then writeln('up')
   else
    if x[p[b],b]=Down then writeln('down')
    else begin
      writeln('Alt');
      for i:=1 to g[p[b],b]-1 do writeln(w[x[p[b],b],i])
     end
  end   
end;

procedure Dijkstra(a,b:integer);
var i,t:integer;
begin
 fillchar(d,sizeof(d),NA);
 fillchar(f,sizeof(f),false);
 d[a]:=0;
 repeat
  t:=NA;
  for i:=1 to n do
   if (not f[i])and(d[i]<>NA)and((t=NA)or(d[t]>d[i]))
   then t:=i;
  if t<>NA then begin
    f[t]:=true;
    for i:=1 to n do
     if (g[t,i]<>NA)and((d[i]=NA)or(d[i]>d[t]+g[t,i]))
     then begin
       d[i]:=d[t]+g[t,i];
       p[i]:=t
      end
   end
 until t=NA;
 writeln(d[b]);
 PrintWay(b,a)
end;

procedure Process;
var i,a,b:integer;
begin
 assign(output,nameout);
 rewrite(output);
 a:=1;
 for i:=1 to m do begin
   b:=c[i];
   Dijkstra(a,b);
   a:=c[i]
  end;
 close(output)
end;

begin
 Init;
 BuiltStr;
 Process
end.
 