#include <fstream>
#include <algorithm>
#include <windows.h>
#include <iostream>
#include <deque>
using namespace std;

template<class T>
T &minx(T &a,T &b){
	if(a<b) return a;
	else return b;
}

template<class T>
T maxx(T a,T b){
	if(a>b) return a;
	else return b;
}


template<class T,int S,int lgS>
struct min_looker{
	T M[lgS+1][S];
	void init(T *A){
		int i,j,l=2;
		for(i=0;i<S;i++) M[0][i]=A[i];
		for(j=1;l<=S;j++,l*=2) for(i=0;i<=S-l;i++)
			M[j][i]=minx(M[j-1][i],M[j-1][i+l/2]);
	}
	//[a;b)
	T look(int a,int b){
		if(a==b)
			return -1;/////////////////!!!!!!!
		int l=b-a,lgl=0,rl=1;
		while(l!=1) l/=2,lgl++,rl*=2;
		return minx(M[lgl][a],M[lgl][b-rl]);
	}
};

ofstream O("fur.out");

int N;
char *F[1000];
int Flen[1000];
int sortF[1000];
int Fvalue[2000]={};//sortF[Fvalue[x]]==x
int maxP[1000];
min_looker<int,2000,11> MinInF;
min_looker<int,1000,10> MaxPrefix;

bool sort_files(const int &a,const int &b){
	return strcmp(F[a],F[b])<0;
}

int K;
int A[100];

char file[4*1024*1024],*pfile=file;

int minkeypress[1000][1000]={};//[kyga][otkyga]

void in(){
	HANDLE H=CreateFile("fur.in",GENERIC_READ,FILE_SHARE_READ,NULL,OPEN_EXISTING,0,NULL);
	DWORD d;
	ReadFile(H,file,sizeof(file),&d,NULL);
	file[d]=0;
	CloseHandle(H);
	while(isspace(*pfile)) pfile++;
	N=atoi(pfile);
	while(!isspace(*pfile)) pfile++;
	for(int i=0;i<N;i++){
		while(isspace(*pfile)) pfile++;
		F[i]=pfile;
		while(!isspace(*pfile)) pfile++;
		*pfile++=0;
	}

	while(isspace(*pfile)) pfile++;
	K=atoi(pfile);
	while(!isspace(*pfile)) pfile++;
	for(int i=0;i<N;i++){
		while(isspace(*pfile)) pfile++;
		A[i]=atoi(pfile)-1;
		while(!isspace(*pfile) && *pfile) pfile++;
	}
}

int inheap[1000];
int D[1000];
struct HeapElem{
	static HeapElem *Hbegin,*Hend;
	int *val;
	HeapElem(){};
	HeapElem(int *v):val(v){};
	HeapElem &operator =(const HeapElem &a){
		val=a.val;
		if(this>=Hbegin && this<Hend) inheap[val-D]=this-Hbegin;
		return *this;
	}
	bool operator <(const HeapElem &a){
		return *val<*a.val;
	}
};
typedef HeapElem *phel;

HeapElem heap[2000];
HeapElem *endHeap=heap;
phel HeapElem::Hbegin=heap,HeapElem::Hend=heap+2000;
int P[1000];
int E[1000];
int cur;

void edge(int v,int w){
	if(w==0x7FFFFFFF) return;
	if(D[v]>D[cur]+w){
		D[v]=D[cur]+w;
		P[v]=cur;
		E[v]=w;
		if(inheap[v]==-1){
			inheap[v]=endHeap-heap;
			*endHeap++=HeapElem(D+v);
		}
		push_heap(heap,heap+inheap[v]);
	}
}


int wrote=0;
void dijkstra(int start,int end){
	endHeap=heap+1;
	*heap=HeapElem(D+start);
	for(int i=0;i<N;i++) inheap[i]=-1,D[i]=0x7FFFFFFF;
	D[start]=0;
	inheap[start]=0;
	while(heap!=endHeap){
		cur=heap->val-D;
		pop_heap(heap,endHeap);
		endHeap--;
		inheap[cur]=-1;
		edge((cur-1+N)%N,1);
		edge((cur+1)%N,1);
		for(int i=0;i<N;i++) if(i!=cur) edge(i,minkeypress[i][cur]+1);
	}
	deque<int> way;
	for(int i=end;i!=start;i=P[i])
		way.push_front(i);
	way.push_front(start);
	if(wrote) O<<endl;
	else wrote=1;
	O<<D[end];
	for(int i=0;i<way.size()-1;i++){
		int w1=way[i],w2=way[i+1];
		if(w2==(w1+1)%N)
			O<<endl<<"down";
		else if(w2==(w1-1+N)%N)
			O<<endl<<"up";
		else{
			O<<endl<<"Alt";
			for(int j=0;j<E[w2]-1;j++) O<<endl<<F[w2][j];
		}
	}
}

int main(){
	in();
	for(int i=0;i<N;i++) sortF[i]=i,Flen[i]=strlen(F[i]);
	sort(sortF,sortF+N,sort_files);
	for(int i=0;i<N;i++) Fvalue[sortF[i]]=Fvalue[sortF[i]+N]=i;
	MinInF.init(Fvalue);
	for(int i=0;i<N-1;i++)
		for(maxP[i]=0;F[sortF[i]][maxP[i]]==F[sortF[i+1]][maxP[i]];maxP[i]++);
	MaxPrefix.init(maxP);
	/*for(int i=0;i<N-1;i++)
		for(int j=0;j<i;j++)
			if(MaxPrefix.look(j,i)!=*min_element(maxP+j,maxP+i))
				cout<<"xyi";
			else cout<<MaxPrefix.look(j,i)<<endl;*/
	for(int i=0;i<N;i++){
		for(int j=i-1;j!=i && j+N!=i;j--){
			if(j<0) j+=N;
			int pos1=Fvalue[i];
			int pos2=Fvalue[j];
			if(pos2<pos1) swap(pos1,pos2);
			int maxpr=MaxPrefix.look(pos1,pos2);
			if(maxpr!=Flen[i]) minkeypress[i][j]=maxx(maxpr+1,minkeypress[i][(j+1)%N]);
			else minkeypress[i][j]=0x7FFFFFFE;
		}
	}
	dijkstra(0,A[0]);
	for(int i=0;i<K-1;i++)
		dijkstra(A[i],A[i+1]);
	return 0;
}