#include <stdio.h>
#include <string.h>

#define MaxB 2000010
#define MaxK 20
#define MaxL 2010
#define MaxN 1010

int N, K, Ta[MaxK], Tar, BorN;
int d[MaxN][MaxL], GoPos[MaxN][MaxL], GoBot[MaxN][MaxL], BorI[MaxB], BorP[MaxB][27], GoBor[MaxN][MaxL];
char Name[MaxN][MaxL];

void BorPut(int t, int i, int p)
{
  GoBor[i][p] = t;
  if (BorI[t] > i || BorI[t] == -1)
    BorI[t] = i;
  if (Name[i][p] == 0)
    return;
  if (BorP[t][Name[i][p] - 'a'] == -1)
    BorP[t][Name[i][p] - 'a'] = BorN++;
  BorPut(BorP[t][Name[i][p] - 'a'], i, p + 1);
}

int relax(int *a, int b)
{
  if (b < 0)
    return 0;
  if (*a < 0 || b < *a)
  {
    *a = b;
    return 1;
  }
  return 0;
}

int Find(int t, char c)
{
  c -= 'a';
  if (BorP[t][c] == -1)
    return -1;
  return BorI[BorP[t][c]];
}

int dfs(int Pos, int Bot)
{
  if (d[Pos][Bot + 1] + 1)
    return d[Pos][Bot + 1];
  d[Pos][Bot + 1] = -2;

  if (Tar == Pos)
  {
    d[Pos][Bot + 1] = 0;
    return 0;
  }

  if (Bot == -1)
  {
    int Tmp;
    Tmp = dfs((Pos + 1) % N, Bot) + 1;
    if (relax(&d[Pos][Bot + 1], Tmp))
      GoPos[Pos][Bot + 1] = (Pos + 1) % N, GoBot[Pos][Bot + 1] = Bot;
    Tmp = dfs((Pos + N - 1) % N, Bot) + 1;
    if (relax(&d[Pos][Bot + 1], Tmp))
      GoPos[Pos][Bot + 1] = (Pos + N - 1) % N, GoBot[Pos][Bot + 1] = Bot;
    Tmp = dfs(Pos, 0) + 1;
    if (relax(&d[Pos][Bot + 1], Tmp))
      GoPos[Pos][Bot + 1] = Pos, GoBot[Pos][Bot + 1] = 0;
  }
  else
  {
    int Tmp, k;
    Tmp = dfs(Pos, -1);
    if (relax(&d[Pos][Bot + 1], Tmp))
      GoPos[Pos][Bot + 1] = Pos, GoBot[Pos][Bot + 1] = -1;
    for (k = 'a'; k < 'z'; k++)
    {
      int Temp = Find(GoBor[Pos][Bot], k);
      if (Temp + 1)
      {
        Tmp = dfs(Temp, Bot + 1) + 1;
        if (relax(&d[Pos][Bot + 1], Tmp))
          GoPos[Pos][Bot + 1] = Temp, GoBot[Pos][Bot + 1] = Bot + 1;
      }
    }
  }
  return d[Pos][Bot + 1];
}

int main( void )
{
  int i, res, Pos, Bot, NewPos, NewBot;
  freopen("fur.in", "rt", stdin);
  freopen("fur.out", "wt", stdout);

  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%s", Name[i]);
  scanf("%d", &K);
  for (i = 0; i < K; i++)
    scanf("%d", &Ta[i]);

  BorN = 1;
  memset(BorP, -1, sizeof(BorP));
  memset(BorI, -1, sizeof(BorI));
  for (i = 0; i < N; i++)
    BorPut(0, i, 0);

/*
  fprintf(stderr, "BorN = %d\n", BorN);
  fprintf(stderr, "Alphabet      :  ");
  for (j = 0; j < 26; j++)
    fprintf(stderr, " %c ", j + 'a');
  fprintf(stderr, "\n");
  for (i = 0; i < BorN; i++)
  {
    int j;
    fprintf(stderr, "BorI[%02d] = %d :  ", i, BorI[i]);
    for (j = 0; j < 26; j++)
      fprintf(stderr, "%2d ", BorP[i][j]);
    fprintf(stderr, "\n");
  }
*/

  Pos = 0;
  for (i = 0; i < K; i++)
  {
    Tar = Ta[i] - 1;
    memset(d, -1, sizeof(d));
    res = dfs(Pos, -1);
    printf("%d\n", res);
    Bot = -1;
    while (Pos != Tar)
    {
      if (Bot == -1 && GoBot[Pos][Bot + 1] != -1)
        printf("Alt\n");
      else if (Bot == -1 && GoBot[Pos][Bot + 1] == -1)
        if ((Pos + 1) % N == GoPos[Pos][Bot + 1])
          printf("down\n");
        else
          printf("up\n");
      else if (GoBot[Pos][Bot + 1] != -1)
        printf("%c\n", Name[GoPos[Pos][Bot + 1]][Bot]);
      NewPos = GoPos[Pos][Bot + 1];
      NewBot = GoBot[Pos][Bot + 1];
      Pos = NewPos;
      Bot = NewBot;
    }
  }

  return 0;
}
