#include <stdio.h>
#include <string.h>

#define MaxB 300010
#define MaxC 700
#define MaxK 20
#define MaxL 700
#define MaxN 700

short Table[MaxN][MaxL][26];
int N, K, Ta[MaxK], Tar, BorN, PN[MaxC], PP[MaxC][MaxN], Cnt[26], Per[26];
int d[MaxN][MaxL], GoPos[MaxN][MaxL], GoBot[MaxN][MaxL], BorP[MaxB][26], GoBor[MaxN][MaxL], C[MaxN];
char Name[MaxN][MaxL];

void BorPut(int t, int i, int p)
{
  GoBor[i][p] = t;
  if (Name[i][p] == 0)
    return;
  if (BorP[t][Name[i][p] - 'a'] == -1)
    BorP[t][Name[i][p] - 'a'] = BorN++;
  BorPut(BorP[t][Name[i][p] - 'a'], i, p + 1);
}

int relax(int *a, int b)
{
  if (b < 0)
    return 0;
  if (*a < 0 || b < *a)
  {
    *a = b;
    return 1;
  }
  return 0;
}

void Make1( void )
{
  int i, CC = 1;
  memset(Table, -1, sizeof(Table));
  memset(C, 0, sizeof(C));
  for (i = 0; ; i++)
  {
    int j, OCC = CC, f = 0;
    for (j = 0; j < N; j++)
      if (C[j] + 1)
        f = 1;
    if (!f)
      break;
    memset(PN, 0, sizeof(PN));
    for (j = 0; j < N; j++)
      if (C[j] + 1)
        PP[C[j]][PN[C[j]]++] = j;
    for (j = 0; j < OCC; j++)
    {
      int k, mz = 26, f = 0, ch;
      memset(Cnt, 0, sizeof(Cnt));
      for (k = 0; k < PN[j]; k++)
      {
        if (Name[PP[j][k]][i])
        {
          Cnt[Name[PP[j][k]][i] - 'a']++;
          if (mz > Name[PP[j][k]][i] - 'a')
            mz = Name[PP[j][k]][i] - 'a';
        }
        else
          f = 1;
      }
      if (f)
        CC++;
      for (k = 0; k < 26; k++)
        if (Cnt[k])
          if (k != mz)
            Per[k] = CC++;
          else
            Per[k] = CC - 1;
      for (k = 0; k < 26; k++)
        if (Name[PP[j][k]][i])
          C[PP[j][k]] = Per[Name[PP[j][k]][i] - 'a'];
        else
          C[PP[j][k]] = -1;
      for (ch = 0; ch < 26; ch++)
        if (Cnt[ch])
        {
          int tmp = -1;
          for (k = 0; Table[PP[j][k]][i][ch] == -1; k = (k + PN[j] - 1) % PN[j])
          {
            if (Name[PP[j][k]][i] == ch + 'a')
              tmp = k;
            if (tmp + 1)
              Table[PP[j][k]][i][ch] = PP[j][tmp];
          }
        }
    }
  }
}

int Find(int Pos, int Bot, char c)
{
  return Table[Pos][Bot][c - 'a'];
}

int dfs(int Pos, int Bot)
{
  if (d[Pos][Bot + 1] + 1)
    return d[Pos][Bot + 1];
  d[Pos][Bot + 1] = -2;

  if (Tar == Pos)
  {
    d[Pos][Bot + 1] = 0;
    return 0;
  }

  if (Bot == -1)
  {
    int Tmp;
    Tmp = dfs((Pos + 1) % N, Bot) + 1;
    if (relax(&d[Pos][Bot + 1], Tmp))
      GoPos[Pos][Bot + 1] = (Pos + 1) % N, GoBot[Pos][Bot + 1] = Bot;
    Tmp = dfs((Pos + N - 1) % N, Bot) + 1;
    if (relax(&d[Pos][Bot + 1], Tmp))
      GoPos[Pos][Bot + 1] = (Pos + N - 1) % N, GoBot[Pos][Bot + 1] = Bot;
    Tmp = dfs(Pos, 0) + 1;
    if (relax(&d[Pos][Bot + 1], Tmp))
      GoPos[Pos][Bot + 1] = Pos, GoBot[Pos][Bot + 1] = 0;
  }
  else
  {
    int Tmp, k;
    Tmp = dfs(Pos, -1);
    if (relax(&d[Pos][Bot + 1], Tmp))
      GoPos[Pos][Bot + 1] = Pos, GoBot[Pos][Bot + 1] = -1;
    for (k = 'a'; k < 'z'; k++)
    {
      int Temp = Find(Pos, Bot, k);
      if (Temp + 1)
      {
        Tmp = dfs(Temp, Bot + 1) + 1;
        if (relax(&d[Pos][Bot + 1], Tmp))
          GoPos[Pos][Bot + 1] = Temp, GoBot[Pos][Bot + 1] = Bot + 1;
      }
    }
  }
  return d[Pos][Bot + 1];
}

int main( void )
{
  int i, res, Pos, Bot, NewPos, NewBot;
  freopen("fur.in", "rt", stdin);
  freopen("fur.out", "wt", stdout);

  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%s", Name[i]);
  scanf("%d", &K);
  for (i = 0; i < K; i++)
    scanf("%d", &Ta[i]);

  BorN = 1;
  memset(BorP, -1, sizeof(BorP));
  for (i = 0; i < N; i++)
    BorPut(0, i, 0);

/*
  fprintf(stderr, "BorN = %d\n", BorN);
  fprintf(stderr, "Alphabet      :  ");
  for (j = 0; j < 26; j++)
    fprintf(stderr, " %c ", j + 'a');
  fprintf(stderr, "\n");
  for (i = 0; i < BorN; i++)
  {
    int j;
    fprintf(stderr, "BorI[%02d] = %d :  ", i, BorI[i]);
    for (j = 0; j < 26; j++)
      fprintf(stderr, "%2d ", BorP[i][j]);
    fprintf(stderr, "\n");
  }
*/
  Make1();
  Pos = 0;
  for (i = 0; i < K; i++)
  {
    Tar = Ta[i] - 1;
    memset(d, -1, sizeof(d));
    res = dfs(Pos, -1);
    printf("%d\n", res);
    Bot = -1;
    while (Pos != Tar)
    {
      if (Bot == -1 && GoBot[Pos][Bot + 1] != -1)
        printf("Alt\n");
      else if (Bot == -1 && GoBot[Pos][Bot + 1] == -1)
        if ((Pos + 1) % N == GoPos[Pos][Bot + 1])
          printf("down\n");
        else
          printf("up\n");
      else if (GoBot[Pos][Bot + 1] != -1)
        printf("%c\n", Name[GoPos[Pos][Bot + 1]][Bot]);
      NewPos = GoPos[Pos][Bot + 1];
      NewBot = GoBot[Pos][Bot + 1];
      Pos = NewPos;
      Bot = NewBot;
    }
  }

  return 0;
}
