#include <stdio.h>
#include <memory.h>
#include <string.h>

#define NUM 1010
#define LEN 2010
#define TASKS 12

int n;
int clen[NUM];
char names[NUM][LEN];
int k;
int tasks[TASKS];

bool used[NUM];
int dist[NUM];
int father[NUM];
int matr[NUM][NUM];
int pnum;
char path[NUM];

inline int uabs(int a) {
	return (a<0 ? -a : a);
}
struct Edge {
	int word, let, len;
	int next;
};

struct TNode {
	int min;
	Edge earr['z'-'a'+1];
};

TNode tree[NUM+10];
int tn;

int readString(char *arr) {
	fgets(arr, LEN+NUM, stdin);
	int res = strlen(arr);
	while ((arr[res-1] < 'a') || (arr[res-1] > 'z'))
		res--;
	arr[res] = 0;
	return res;
}

int compare;
bool WordLess(int a, int b) {
	if (a < 0)
		return false;
	if (b < 0)
		return true;
	a -= compare;
	b -= compare;
	if (a<0) a += n;
	if (b<0) b += n;
	return (a<b);
}

int minlen[NUM];
int DFS(int u, int pl, int pll) {
	int i;
	int res = tree[u].min;
	for (i = 0; i<='z'-'a'; i++)
		if (tree[u].earr[i].word >= 0) {
			int tr = DFS(tree[u].earr[i].next, pl + tree[u].earr[i].len, pl);
			if (WordLess(tr, res))
				res = tr;
		}
	minlen[res] = pll+1;
	return res;
}

void GenerateMatrix() {
	int i, j;
	tn = 1;
	memset(tree, -1, sizeof(tree));
	for (i = 0; i<n; i++) {
		int done = 0;
		int curr = 0;
		while (done <= clen[i]) {
			int nc = names[i][done] - 'a';
			if (done == clen[i]) {
				tree[curr].min = i;
				done++;
				continue;
			}
			if (tree[curr].earr[nc].word < 0) {
				tree[curr].earr[nc].word = i;
				tree[curr].earr[nc].let = done;
				tree[curr].earr[nc].len = clen[i] - done;
				tree[curr].earr[nc].next = tn;
				curr = tn;
				done = clen[i];
				tn++;
			}
			else {
				int ost = tree[curr].earr[nc].len;
				int start = tree[curr].earr[nc].let;
				int ew = tree[curr].earr[nc].word;
				int mc = -1;
				for (j = 0; j<=ost; j++) {
					if (names[ew][start+j] != names[i][done+j]) {
						mc = j;
						break;
					}
				}
				if (mc < ost) {
					int lastnext = tree[curr].earr[nc].next;
					tree[curr].earr[nc].next = tn;
					tree[curr].earr[nc].len = mc;
					int nnc = names[ew][start+mc] - 'a';
					tree[tn].earr[nnc].word = ew;
					tree[tn].earr[nnc].let = start+mc;
					tree[tn].earr[nnc].len = ost-mc;
					tree[tn].earr[nnc].next = lastnext;
					tn++;
				}
				done += tree[curr].earr[nc].len;
				curr = tree[curr].earr[nc].next;
			}
		}
	}
	
	memset(matr, 63, sizeof(matr));
	for (i = 0; i<n; i++) {
		compare = i;
		memset(minlen, -1, sizeof(minlen));
		DFS(0, 0, -1);
		for (j = 0; j<n; j++) {
			if (i==j)
				matr[i][j] = 0;
			else {
				if (minlen[j] >= 0)
					matr[i][j] = minlen[j]+1;
			}
		}
	}
	for (i = 0; i<n-1; i++) {
		matr[i][i+1] = 1;
		matr[i+1][i] = 1;
	}
	matr[n-1][0] = 1;
	matr[0][n-1] = 1;
}

void MinPath(int stp, int enp) {
	memset(used, 0, sizeof(used));
	memset(dist, 63, sizeof(dist));
	memset(father, -1, sizeof(father));
	dist[stp] = 0;
	int i;
	while (1) {
		int best = -1;
		int min = 1000000000;
		for (i = 0; i<n; i++)
			if (!used[i])
				if (dist[i] < min) {
					min = dist[i];
					best = i;
				}
		if (best < 0)
			break;
		used[best] = true;
		for (i = 0; i<n; i++)
			if (!used[i])
				if (dist[i] > dist[best] + matr[best][i]) {
					dist[i] = dist[best] + matr[best][i];
					father[i] = best;
				}
	}
	printf("%d\n", dist[enp]);
	pnum = 0;
	int curr = enp;
	while (curr != stp) {
		int prev = father[curr];
		if (matr[prev][curr] == 1) {
			if ((prev < curr) ^ (uabs(prev-curr)>1))
				path[pnum] = 'D';
			else
				path[pnum] = 'U';
			pnum++;
		}
		else {
			for (i = matr[prev][curr]-2; i>=0; i--) {
				path[pnum] = names[curr][i];
				pnum++;
			}
			path[pnum] = 'A';
			pnum++;
		}
		curr = prev;
	}
	for (i = pnum-1; i>=0; i--) {
		if (path[i] == 'A') {
			printf("Alt\n");
			continue;
		}
		if (path[i] == 'D') {
			printf("down\n");
			continue;
		}
		if (path[i] == 'U') {
			printf("up\n");
			continue;
		}
		printf("%c\n", path[i]);
	}
}

int main(int argc, char **argv) {
	freopen("fur.in", "r", stdin);
	freopen("fur.out", "w", stdout);
	scanf("%d\n", &n);
	int i, j;
	for (i = 0; i<n; i++)
		clen[i] = readString(names[i]);
	scanf("%d", &k);
	for (i = 0; i<k; i++) {
		scanf("%d", tasks+i);
		tasks[i]--;
	}

	GenerateMatrix();

	int lastpoint = 0;
	for (i = 0; i<k; i++) {
		MinPath(lastpoint, tasks[i]);
		lastpoint = tasks[i];
	}


	return 0;
}