#include <iostream>
#include <list>
#include <queue>

#define W 1000
#define L 2000
#define BS long(588153931)
#define O 113
#define MAX 2000000000

using namespace std;

char wor[W+1][L+2];
long w_num;
long n_num;
long need[101];
long last[W +1];
long h[W + 1][L + 2];
long po[L + 2];
struct edge{long f; long l;};
list<edge> adj[W + 1];
edge pred[W + 1];
long way[W + 1];
long prv[W + 1];
//-------------------------------------------------------------------------------------------------------------
long next(long ar)
{
	if (ar < w_num) {return (ar + 1);} else {return 1;}
}
//-------------------------------------------------------------------------------------------------------------
long prev(long ar)
{
	if (ar > 1) {return (ar - 1);} else {return w_num;}
}
//-------------------------------------------------------------------------------------------------------------
void initialization()
{
	long y;
	cin >> w_num;
	memset(last, 0, sizeof(last));
	for(y = 1; y <= w_num; y++)
	{
		scanf("%s", &wor[y]);
	}
	cin >> n_num;
	for(y = 1; y <= n_num; y++)
	{
		cin >> need[y];
	}
	need[0] = 1;
}
//-------------------------------------------------------------------------------------------------------------
void make_real(long &a, long &b, long &pos)
{
	long y;
	for(y = 0; y <= pos; y++)
	{
		if (wor[a][y] != wor[b][y]) {return;}
	}
	for(pos++; ;pos++)
	{
		if (wor[a][pos] != wor[b][pos]) {return;}
	}
}
//-------------------------------------------------------------------------------------------------------------
void build_graph()
{
	long y, j, pos, jo;
	edge he;
	for(y = 1; y <= w_num; y++)
	{
		pos = 0;
		jo = y;
		jo = prev(jo);
		for(; jo != y;  jo = prev(jo))
		{
			if (h[y][pos] == h[jo][pos])
			{
				make_real(y, jo, pos);
			}
			if (pos >= strlen(wor[y])) {continue;}
			he.f = (-y);
			he.l = pos;
			adj[jo].push_back(he);
		}
	}
	for(y = 1; y <= w_num; y++)
	{
		he.f = 0;
		he.l = 1;
		adj[y].push_back(he);
		he.l = 2;
		adj[y].push_back(he);
	}
}
//-------------------------------------------------------------------------------------------------------------
void make_hash()
{
	__int64 jo;
	long  y, j;
	memset(h, 0, sizeof(h));
	po[0] = 0;
	po[1] = O;
	for(y = 2; y <= L; y++)
	{
		po[y] = ((po[y-1] * O) % BS);
	}
	for(y = 1; y <= w_num; y++)
	{
		jo = 0;
		for(j = 0; j <= (strlen(wor[y]) - 1); j++)
		{
			jo += ((__int64(po[j]) * __int64(wor[y][j] - 'a')) % BS);
			jo %= BS;
			h[y][j] = jo;
		}
	}
}
//-------------------------------------------------------------------------------------------------------------
void bfs(long be)
{
	queue<long> qu;
	list<edge>::iterator i;
	long jo, y, v, del;
	for(y = 1; y <= w_num; y++) 
	{
		way[y] = MAX;
	}
	way[be] = 0;
	for(; !qu.empty();) {qu.pop();}
	qu.push(be);
	for(; !qu.empty();)
	{
		jo = qu.front();
		qu.pop();
		for(i = adj[jo].begin(); i != adj[jo].end(); i++)
		{
			v = (-(i->f));
			if (v == 0)
			{
				del = 1;
				if (i->l == 1)
				{
					v = prev(jo);
				}
				else
				{
					v = next(jo);
				}
			}
			else
			{
				del = ((i->l) + 2);
			}
			if (way[v] > (way[jo] + del))
			{
				//relax
				way[v] = (way[jo] + del);
				pred[v] = *i;
				prv[v] = jo;
				qu.push(v);
			}
		}
	}
}
//-------------------------------------------------------------------------------------------------------------
void print_way(long be, long en)
{
	long sol_num = 0, c, y;
	edge sol[W + 1];
	long log[W + 1], v, j;
	c = en;
	for(; c != be;)
	{
		v = prv[c];
		sol_num++;
		sol[sol_num] = pred[c];
		c = v;
		log[sol_num] = v;
	}
	cout << way[en] << "\n";
	for(y = sol_num; y >= 1; y--)
	{
		if (sol[y].f < 0)
		{
			cout << "Alt\n";
			for(j = 0; j <= (sol[y].l); j++)
			{
				cout << wor[-sol[y].f][j] << "\n";
			}
			c = (-sol[y].f);
		}
		else
		{
			if (sol[y].l == 1)
			{
				cout << "up\n";
				c = prev(c);
			}
			else
			{
				cout << "down\n";
				c = next(c);
			}
		}
	}
}
//-------------------------------------------------------------------------------------------------------------
void print_list()
{
	long y;
	list<edge>::iterator i;
	cout << "Adjacent lists : \n";
	for(y = 1; y <= w_num; y++)
	{
		for(i = adj[y].begin(); i != adj[y].end(); i++)
		{
			cout << "(" << (i->f) << "," << (i->l) << ") ";
		}
		cout << "\n";
	}
	cout << "End of it\n";
}
//-------------------------------------------------------------------------------------------------------------
void logic()
{
	long y;
	initialization();
	make_hash();
	build_graph();
	//print_list();
	for(y = 0; y <= (n_num - 1); y++)
	{
		bfs(need[y]);
		print_way(need[y], need[y+1]);
	}
}
//-------------------------------------------------------------------------------------------------------------
int main()
{
	freopen("fur.in", "r", stdin);
	freopen("fur.out", "w", stdout);
	logic();
	return 0;
}