#include <stdio.h>
#include <stdlib.h>
#include <string.h>

inline int max(int i, int j) {
	return (i>j)?i:j;
}

inline int min(int i, int j) {
	return -max(-i,-j);
}                  

#define FILE_IN "advent.in"
#define FILE_OUT "advent.out"

const int REALMAXN  = 2006;
const int MAXN = 100;
const int MAXH = 100;

class CHELOVEC {
	public:
		int rost,ruky;
	int operator<(CHELOVEC & m2) {
		return rost+ruky<m2.rost+m2.ruky;
	}

	int operator>(CHELOVEC & m2) {
		return rost+ruky>m2.rost+m2.ruky;
	}
};
                   
int n,h,sh;
int ans;

int a[MAXN][MAXN][MAXH];

CHELOVEC man[REALMAXN];

void OpenFiles() {
	freopen(FILE_IN,"r",stdin);
	freopen(FILE_OUT,"w",stdout);
}

void CloseFiles() {
	fclose(stdout);
}

void Initialize(){
	memset(a, 0 ,sizeof(a));
}

int ReadData() {
	scanf("%d",&n);
	int i;
	sh = 0;
	for (i=0;i<n;i++) {
		scanf("%d %d",&man[i].rost,&man[i].ruky);
		sh+=man[i].rost;
	}

	scanf("%d",&h);

	return 0;
}

void QSort(int l,int r){
	int i = l, j = r;
	CHELOVEC x = man[(l+r)/2],y;
	do {
		while (man[i]<x) i++;
		while (x<man[j]) j--;
		if (i<=j) {
			y = man[i];
			man[i] = man[j];
			man[j] = y;
			i++;j--;
		}
	} while (i<=j);

	if (i<r) QSort(i,r);
	if (l<j) QSort(l,j);
}

void Solve() {
	if (n>MAXN || sh>MAXH) {
		ans = (2*n+h)/(3*n+2*h);
		return;
	}                                                

	int i,j,k;

	QSort(0,n-1);

	int r;

	for (i=0;i<n;i++) {
  	  	if (i>0)
	  	  	for (k=1;k<=h;k++) 
    			a[i][1][k] = a[i-1][1][k];

    	k = man[i].rost+man[i].ruky;
		a[i][1][k] = max(a[i][1][k],man[i].rost);
	}

	for (i=0;i<n-1;i++) {
    	for (j=1;j<=i+1;j++) {
			for (k=1;k<=h;k++) {			
				a[i+1][j][k] = a[i][j][k];
				if (a[i][j][k]) {
					r = min(k+man[i].rost,man[i].rost+man[i].ruky);
					a[i+1][j+1][r] = max(a[i+1][j+1][r],a[i][j][k]+man[i].rost);
				}
			}
		}
	}

	ans = 0;
	for (j=1;j<=n;j++) 
		for (k=1;k<=h;k++)
			if (a[n-1][j][k])
				if (h+a[n-1][j][k]<=sh+k) ans = j;
}

void OutData() {
	printf("%d",ans);
}

int main(int argc, char * arg[]) {
	OpenFiles();
   	Initialize();
   	ReadData();
   	Solve();
   	OutData();
    CloseFiles();
    return 0;	
}