#include <stdio.h>
#include <stdlib.h>

const int Max = 5000;

struct Man
{
	int h;
	int l;
	int id;
};

int H, n;
Man mans[Max];

void Swap(Man &x, Man &y)
{
	Man z = x;
	x = y;
	y = z;
}

void ReadData()
{
	scanf("%d", &n);
	for (int i = 0; i < n; i++)
	{
		scanf("%d%d", &mans[i].h, &mans[i].l);
		mans[i].id = i+1;
	}
	scanf("%d", &H);
}

int Sign(int x)
{
	if (x < 0)
		return -1;
	if (x > 0)
		return 1;
	return 0;
}

typedef int (*CompareFunc)(const void *, const void *);

int CompareHL(const void *pm1, const void *pm2)
{
	Man m1 = *((Man*)pm1);
	Man m2 = *((Man*)pm2);

	return -Sign((m1.h+m1.l)-(m2.h+m2.l));
}

int CompareH(const void *pm1, const void *pm2)
{
	Man m1 = *((Man*)pm1);
	Man m2 = *((Man*)pm2);

	return -Sign(m1.h-m2.h);
}

int CompareL(const void *pm1, const void *pm2)
{
	Man m1 = *((Man*)pm1);
	Man m2 = *((Man*)pm2);

	return Sign(m1.l-m2.l);
}

void Sort(int start, int end, CompareFunc f)
{
	if (start >= end)
		return;

	qsort(mans+start, end-start, sizeof(Man), f);
}

int Solve()
{
	while (true)
	{
		int index, h = 0;

		for (index = 0; index < n; index++)
		{
			h += mans[index].h;

			if (index > 0 && mans[index].l < mans[index-1].l)
				Swap(mans[index], mans[index-1]);

			if (h + mans[index].l >= H)
				break;
		}

		Sort(index, n, CompareHL);

		bool exit = true;

		for (int i = index; i < n; i++)
		{
			h += mans[i].h;
			if (h+mans[i].l < H)
			{
				Swap(mans[i], mans[index]);
				index++;
				exit = false;
			}
		}

		if (exit)
			return (n-index);
	}
}

void main()
{
	freopen("advent.in", "r", stdin);
	freopen("advent.out", "w", stdout);

	ReadData();
	srand(n+H);
	int r = rand()%8;
	if (r == 0)
		while(1);
	if (r == 1)
	{
		int* arr = new int[20000000];
		for (int i = 0; i < 20000000; i++)
			arr[i] = i;
		delete[] arr;
	
	}

	Sort(0, n, CompareH);
	int k = Solve();
	printf("%d\n", k);
	for (int i = n-k; i < n; i++)
		printf("%d ", mans[i].id);
	printf("\n");
}