program advent;

{$APPTYPE CONSOLE}

type TPupil = record
  h, l: Integer;
  id: Integer;
  escaped: Boolean;
end;

var
  h, i, j, n: Integer;
  sumh: Int64;
  Count: Integer;
  Pupils: array of TPupil;

procedure LoadData;
var Data: TextFile;
begin
  AssignFile(Data, 'advent.in');
  Reset(Data);
  ReadLn(Data, n);
  SetLength(Pupils, n + 1);
  for i := 1 to n do Read(Data, Pupils[i].h, Pupils[i].l);
  ReadLn(Data, h);
  sumh := 0;
  for i := 1 to n do begin
    Pupils[i].escaped := False;
    Pupils[i].id := i;
    sumh := sumh + Pupils[i].h;
  end;
  CloseFile(Data);
end;

procedure Exchange(var p1: TPupil; var p2: TPupil);
var p: TPupil;
begin
  p := p2;
  p2 := p1;
  p1 := p;
end;

procedure Sort;
var min: Integer;
begin
  for i := 1 to n - 1 do begin
    min := i;
    for j := i + 1 to n do
      if Pupils[j].h < Pupils[min].h then min := j;
    Exchange(Pupils[i], Pupils[min]);
  end;
end;

procedure Escape;
var x: Integer;
begin
  Count := 0;
  for i := 1 to n do begin
    if Pupils[i].l >= h - sumh then begin
      Pupils[i].escaped := True;
      Inc(Count);
      sumh := sumh - Pupils[i].h;
    end;
  end;
end;

procedure SaveData;
var Data: TextFile;
begin
  AssignFile(Data, 'advent.out');
  Rewrite(Data);
  WriteLn(Data, Count);
  for i := 1 to n do if Pupils[i].escaped then Write(Data, Pupils[i].id);
  CloseFile(Data);
end;

begin
  LoadData;
  Sort;
  Escape;
  SaveData;
end.
