#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define FILE_IN "buses.in"
#define FILE_OUT "buses.out"

const int MAXM = 10000;
const int MAXK = 10000;


// global variables

class sDepArr{
	public:
		int type;       // 1 - department, 0 - arrival
		int station;	
		int time;

		int x() {
			return 2*time+type;
		}

} timetable[2*MAXM];

int nt;
int k,m;
int ans;

int created[MAXK+1];
int current[MAXK+1];

void swap(sDepArr * a, sDepArr * b) {
	sDepArr tmp;
	tmp = *a;
    *a = *b;
    *b = tmp;
}

void QSort(sDepArr * a,int l,int r) {
	int i = l,j = r,x = a[(i+j)/2].x();
	do {
		while (a[i].x() < x) i++;
		while (x < a[j].x()) j--;
		if (i<=j) {
			swap(a+i,a+j);
			i++;j--;			
		}
	} while (i<=j);
	if (l<j) QSort(a,l,j);
	if (i<r) QSort(a,i,r);
}

void Init(){
    freopen(FILE_OUT,"w",stdout);
	freopen(FILE_IN,"r",stdin);	
	memset(created,0,sizeof(created));
	memset(current,0,sizeof(current));
	nt = 0;
}

void OutData(int ans){
	if (ans>=0)	
		printf("%d",ans);
	else 
		printf("impossible");
	fclose(stdout);
	exit(0);
}

void ReadData(){	
	scanf("%d %d",&k,&m);    
	int i;
	int s1,s2,t1,t2;
	for(i=0;i<m;i++) {
		scanf("%d %d %d %d",&s1,&s2,&t1,&t2);		
		if (t1<=t2) {			
			timetable[nt].type = 1;
			timetable[nt].station = s1;
			timetable[nt].time = t1;
			nt++;	
			
			timetable[nt].type = 0;
			timetable[nt].station = s2;
			timetable[nt].time = t2;
			nt++;
		} else {
			created[s1]++;
			
			timetable[nt].type = 0;
			timetable[nt].station = s2;
			timetable[nt].time = t2;
			nt++;
		}
	}	
}

void Solve(){
	QSort(timetable,0,nt-1);
	
	int i;
	for (i=0;i<nt;i++) {
		if (timetable[i].type) {
			if (current[timetable[i].station]>0) current[timetable[i].station]--; 
			else created[timetable[i].station]++;
		} else
			current[timetable[i].station]++;
	}

	ans = 0;
	for (i=1;i<=k;i++) {
		if (current[i]!=created[i]) OutData(-1);
		ans += created[i];
	}
}

int main() {
	Init();
	ReadData();
	Solve();
	OutData(ans);
	
	return 0;
}