import java.io.*;
import java.util.*;

public class buses_md implements Runnable {
	class Event implements Comparable<Event> {
		int time;
		int value;
		int city;
		
		public Event(int c, int t, int v) {
			time = t;
			value = v;
			city = c;
		}

		public int compareTo(Event that) {
			if (time == that.time) {
				return that.value - value;
			}
			return time - that.time;
		}
	}
	
	private Scanner in;
	private PrintWriter out;
	
	public void run() {
		try {
			solve();
		} catch (IOException e) {
			e.printStackTrace();
		}
	}

	private void solve() throws IOException {
		in = new Scanner(new File("buses.in"));
		out = new PrintWriter(new File("buses.out"));
		in.useDelimiter("[\\s:]+");
		ArrayList<Event> events = new ArrayList<Event>();
		HashMap<Integer, Integer> now = new HashMap<Integer, Integer>();
		HashMap<Integer, Integer> atNight = new HashMap<Integer, Integer>();
		int trains = 0;
		
		in.nextInt();
		int m = in.nextInt();
		for (int i = 0; i < m; i++) {
			int from = in.nextInt();
			int fromTime = getTime(in);
			int to = in.nextInt();
			int toTime = getTime(in);

			events.add(new Event(from, fromTime, -1));
			events.add(new Event(to, toTime, 1));
			if (fromTime > toTime) {
				events.add(new Event(-1, -1, -1));
				events.add(new Event(-1, Integer.MAX_VALUE / 2, 1));
			}
		}
		Collections.sort(events);
		for (Event event : events) {
			int c = event.city;
			int here = now.containsKey(c) ? now.get(c) : 0;
			here += event.value;
			if (here < 0) {
				trains++;
				here = 0;
				int v = atNight.containsKey(c) ? atNight.get(c) : 0;
				atNight.put(c, v + 1);
			}
			now.put(c, here);
		}
		for (int city : atNight.keySet()) {
			if (!atNight.get(city).equals(now.get(city))) {
				out.println("Infinity");
				in.close();
				out.close();
				return;
			}
		}
		out.println(trains);
		in.close();
		out.close();
	}

	private int getTime(Scanner in) {
		int hh = in.nextInt();
		int mm = in.nextInt();
		return 60 * hh + mm;
	}

	public static void main(String[] args) {
		new buses_md().run();
	}

}
