{$R+,Q+,S+,H+}
{$APPTYPE CONSOLE}
Uses SysUtils;

Const
  TaskID='buses';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxN=100002;
  MaxM=100002;
  TotalTime=24*60;

Type
  Integer=LongInt;
  TTrain=Record
    S,SAt,E,EAt:Integer;
  End;
  TEvent=Record
    Kind:(_E,_S);
    Where:Integer;
    At:Integer;
  End;

Var
  N:Integer;
  M:Integer;
  T:Array[1..MaxM]Of TTrain;
  NEv:Integer;
  Ev:Array[1..2*MaxM]Of TEvent;
  Start,Now:Array[1..MaxN]Of Integer;
  Num:Integer;
  Inf:Boolean;

Procedure ReadTime(Var T:Integer);
Var
  S:String;
  Ch:Char;
Begin
  S:='';
  Repeat
    Read(Ch);
  Until Ch>' ';
  Repeat
    S:=S+Ch;
    Read(Ch);
  Until Ch<=' ';
  T:=StrToInt(Copy(S,1,Pos(':',S)-1))*60+StrToInt(Copy(S,Pos(':',S)+1,Length(S)));
End;

Procedure Load;
Var
  I:Integer;
Begin
  ReSet(Input,InFile);
  Read(N,M);
  For I:=1 To M Do
    With T[I] Do Begin
      Read(S);
      ReadTime(SAt);
      Read(E);
      ReadTime(EAt);
    End;
  Close(Input);
End;

Function Less(A,B:TEvent):Boolean;
Begin
  If A.At<>B.At Then Less:=A.At<B.At 
  Else Less:=A.Kind<B.Kind;
End;

Procedure QSort(L,R:Integer);
Var
  I,J:Integer;
  X,Y:TEvent;
Begin
  X:=Ev[L+Random(R-L+1)];
  I:=L;
  J:=R;
  While I<=J Do Begin
    While Less(Ev[I],X) Do Inc(I);
    While Less(X,Ev[J]) Do Dec(J);
    If I<=J Then Begin
      Y:=Ev[I];
      Ev[I]:=Ev[J];
      Ev[J]:=Y;
      Inc(I);
      Dec(J);
    End;
  End;
  If I<R Then QSort(I,R);
  If L<J Then QSort(L,J);
End;

Procedure Solve;
Var
  I:Integer;
Begin
  NEv:=0;
  Num:=0;
  For I:=1 To M Do With T[I] Do Begin
    Inc(NEv);
    Ev[NEv].Kind:=_S;
    Ev[NEv].Where:=S;
    Ev[NEv].At:=SAt;
    Inc(NEv);
    Ev[NEv].Kind:=_E;
    Ev[NEv].Where:=E;
    Ev[NEv].At:=EAt;
    If SAt>EAt Then Inc(Num);
  End;
  QSort(1,NEv);
  FillChar(Start,SizeOf(Start),0);
  FillChar(Now,SizeOf(Now),0);
  For I:=1 To NEv Do With Ev[I] Do
    Case Kind Of
      _E:Inc(Now[Where]);
      _S:If Now[Where]>0 Then Dec(Now[Where]) Else Begin
        Inc(Num);
        Inc(Start[Where]);
      End;
    End;
  Inf:=False;
  For I:=1 To N Do If Start[I]<>Now[I] Then Inf:=True;
End;

Procedure Save;
Begin
  ReWrite(Output,OutFile);
  If Inf Then WriteLn(-1) Else WriteLn(Num);
  Close(Output);
End;

Begin
  RandSeed:=548391574;
  Load;
  Solve;
  Save;
End.