{$D+,I+,L+,Q+,R+,S+,H-,O-}
  Uses SysUtils;
  Const TaskID='buses';
        File_In=TaskId+'.in';
        File_Out=TaskID+'.out';
        MaxN=100000;
  Type Int=LongInt;
       TTime=Record H,M : Int; End;
  Var Ans,N,M : Int;
      A,B : Array [1..MaxN] Of Int;
      Ballance,Trains : Array [0..MaxN] Of Int;
      Num : Array [1..2*MaxN] Of Int;
      TimeA,TimeB : Array [1..MaxN] Of TTime;
      Time : Array [1..2*MaxN] Of TTime;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Function ReadNext : Char;
  Var Sym : Char;
Begin
  Read(Sym);
  While Not(Sym In ['0'..'9',':']) Do
    Read(Sym);
  ReadNext :=Sym;
End;

Procedure ReadTime(Var T : TTime);
  Var HelpS : String;
Begin
  HelpS :=ReadNext+ReadNext;
  T.H :=StrToInt(HelpS);
  ReadNext;
  HelpS :=ReadNext+ReadNext;
  T.M :=StrToInt(HelpS);
End;

Procedure Init;
  Var I : Int;
Begin
  Read(N,M);
  For I :=1 To M Do Begin
    Read(A[I]);
    ReadTime(TimeA[I]);
    Time[I*2-1] :=TimeA[I];
    Num[I*2-1] :=I*2-1;
    Read(B[I]);
    ReadTime(TimeB[I]);
    Time[I*2] :=TimeB[I];
    Num[I*2] :=I*2;
  End;
End;

Procedure Swap(Var A,B : Int);
  Var C : Int;
Begin
  C:=A;
  A:=B;
  B:=C;
End;

Function Less(Const A,B : TTime) : Boolean;
Begin
  Less :=(A.H<B.H) Or ((A.H=B.H) And (A.M<B.M));
End;

Function Eq(Const A,B : TTime) : Boolean;
Begin
  Eq :=(A.H=B.H) And (A.M=B.M);
End;

Procedure QSort(L,R : Int);
  Var I,J,NumX : Int;
      X : TTime;
Begin
  I :=L;
  J :=R;
  NumX :=Num[I+Random(J-I+1)];
  X :=Time[NumX];
  Repeat
    While Less(Time[Num[I]],X) Or (Eq(Time[Num[I]],X) And Not Odd(Num[I]) And Odd(NumX)) Do
      Inc(I);
    While Less(X,Time[Num[J]]) Or (Eq(Time[Num[J]],X) And Odd(Num[J]) And Not Odd(NumX)) Do
      Dec(J);
    If I<=J Then Begin
      Swap(Num[I],Num[J]);
      Inc(I);
      Dec(J);
    End;
  Until I>J;
  If I<R Then QSort(I,R);
  If J>L Then QSort(L,J);
End;

Procedure Solve;
  Var I : Int;
Begin
  Randomize;
  RandSeed :=456513679;
  QSort(1,2*M);
  FillChar(Ballance,SizeOf(Ballance),0);
  FillChar(Trains,SizeOf(Trains),0);
  Ans :=0;
  For I :=1 To 2*M Do
    If Not Less(TimeB[(Num[I]+1) Div 2],TimeA[(Num[I]+1) Div 2]) Then Begin
        If Odd(Num[I]) Then Begin
          Dec(Ballance[A[(Num[I]+1) Div 2]]);
          Dec(Ballance[0]);
          Dec(Trains[A[(Num[I]+1) Div 2]]);
            If Trains[A[(Num[I]+1) Div 2]]<0 Then Begin
              Inc(Trains[A[(Num[I]+1) Div 2]]);
              Inc(Ans);
            End
        End
        Else
          Begin
            Inc(Ballance[B[(Num[I]+1) Div 2]]);
            Inc(Trains[B[(Num[I]+1) Div 2]]);
            Inc(Ballance[0]);
          End
    End
    Else Begin
      If Not Odd(Num[I]) Then Begin
           Inc(Ballance[B[(Num[I]+1) Div 2]]);
           Inc(Trains[B[(Num[I]+1) Div 2]]);
           Inc(Ballance[0]);
           Inc(Ans);
         End
      Else Begin
        Dec(Ballance[A[(Num[I]+1) Div 2]]);
        Dec(Trains[A[(Num[I]+1) Div 2]]);
        Dec(Ballance[0]);
        If Trains[A[(Num[I]+1) Div 2]]<0 Then Begin
          Inc(Trains[A[(Num[I]+1) Div 2]]);
          Inc(Ballance[0]);
          Inc(Ans);
        End;
      End;
    End;
  For I :=1 To N Do
    If Ballance[I]<>0 Then
      Ans :=-1;
  WriteLn(Ans);
{  For I :=1 To 2*M Do
    WriteLn(Time[Num[I]].H:2,':',Time[Num[I]].M:2);}
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.