#include <iostream>
#include <fstream>
#include <vector>
#include <list>
#include <queue>
using namespace std;

ifstream fin;
ofstream fout;
const int INFI=1000000001;


struct Reb
{
	int out_time, in_time;
	int vert_st, vert_fn;
	Reb() { vert_st=in_time=out_time=vert_fn=-1; };
	Reb(int sv, int oi, int iv, int ii)
	{ out_time=oi; in_time=ii; vert_fn=iv; vert_st=sv; };
};

struct RIn
{
	int reb_id;
	int time;
	RIn() { reb_id=time=-1; }
	RIn(int ri, int tm)
	{ reb_id=ri, time=tm; };
	bool operator < (const RIn &rin) const
	{ return ( time < rin.time ); };
	bool operator > (const RIn &rin) const
	{ return ( time > rin.time ); };
};

vector< Reb > edge;
vector< int > deg;
vector< bool > is_bus;
vector< int > when_is;
priority_queue< RIn, vector< RIn >, greater<RIn> > pq;
vector< priority_queue< RIn, vector< RIn >, greater<RIn> > > vpq;
int n, m;

int to_int(char *ch)
{
	int ret=int(ch[0]-'0')*10 + int(ch[1]-'0');
	ret*=60;
	ret+=int(ch[3]-'0')*10 + int(ch[4]-'0');
	return ret;
}

int main()
{
	int i;
	fin.open("buses.in");
	fin>>n>>m;
	deg.resize(n+1);
	is_bus.resize(n+1); when_is.resize(n+1);
	edge.resize(m+1); vpq.resize(n+1);
	for (i=1; i<=n; i++) 
	{ 
		deg[i]=0; 
		when_is[i]=INFI;
		is_bus[i]=false;
	}
	for (i=1; i<=m; i++)
	{
		int p, v;
		char v1[8], v2[8];
		int vi1, vi2;
		fin>>p>>v1>>v>>v2;
		vi1=to_int(v1); vi2=to_int(v2);
		pq.push( RIn(i, vi1) );
		edge[i]=Reb( p, vi1, v, vi2 ); deg[v]++;
	}

	fin.close();

	int ans=0;
	bool is_ans=true;
	for (i=1; i<=n; i++) 
	{ 
		if (deg[i]==0) 
		{ ans=-1; is_ans=false; break; }
	}

	if (is_ans)
	{
		while (!pq.empty())
		{
			RIn temp=pq.top(); pq.pop();
			Reb test=edge[temp.reb_id];

			if ( !is_bus[ test.vert_st ] )
			{ ans++; }
			else
			{
				RIn in_min=vpq[test.vert_st].top();
				if ( in_min.time > test.out_time ) { ans++; }
				else
				{
					vpq[test.vert_st].pop();
					if ( vpq[test.vert_st].empty() ) 
					{ is_bus[test.vert_st]=false; }
				}
			}

			is_bus[test.vert_fn]=true;
			vpq[test.vert_fn].push( RIn(temp.reb_id, test.in_time) );   
		}

	}
	
	fout.open("buses.out");
	fout<<ans<<endl;
	fout.close();
	return 0;
}
