#include <stdio.h>
#include <stdlib.h>

int scan_time()
{
	int h, m;
	scanf("%d:%d", &h, &m);
	return h*60+m;
}

struct route
{
	int tst, tfn;
	int st, fn;
	void scan()
	{
		scanf("%d", &st);
		tst = scan_time();
		scanf("%d", &fn);
		tfn = scan_time();
		if (tfn < tst)
			tfn += 24*60;
	}
	route()
	{
		st = 0;		fn = 0;
		tst = 0;    tfn = 0;
	}
};

/*heap*/
route heap[100001];
int size;

int left(int index)
{
	return index * 2;
}

int right(int index)
{
	return index * 2;
}

int parent(int index)
{
	return index / 2;
}

route tmp;

void heapify(int index)
{
	int l = left(index), r = right(index), large = index;
	if (l <= size && heap[l].tfn < heap[large].tfn) large = l;
	if (r <= size && heap[r].tfn < heap[large].tfn) large = r;
	if (large != index)
	{
		tmp = heap[large];
		heap[large] = heap[index];
		heap[index] = tmp;
		heapify(large);
	}
}

void add_heap(route &r)
{
	size++;
	heap[size] = r;
	int k = size;
	while(parent(k) > 0 && heap[parent(k)].tfn > heap[k].tfn)
	{
		tmp = heap[k];
		heap[k] = heap[parent(k)];
		k = parent(k);
		heap[k] = tmp;
	}
}

void del()
{
	tmp = heap[1];
	heap[1] = heap[size];
	heap[size] = tmp;
	size--;
	if (size == 0) return;
    heapify(1);
}
/*end heap*/

int n, m;
route arr[100001];

int sf(const void *a, const void *b)
{
	route *x = (route*)a, *y  = (route*)b;
	if (x->tst < y->tst) return -1;
	if (x->tst > y->tst) return +1;
	if (x->tfn < y->tfn) return -1;
	if (x->tfn > y->tfn) return +1;
	return 0;
}

int status[100001];
int ans[100001];

int main()
{
	freopen("buses.in", "r", stdin);
	freopen("buses.out", "w", stdout);
	scanf("%d %d", &n, &m);
	int i;
	for (i = 1; i <= m; i++)
	{
		arr[i*2-1].scan();
		arr[i*2] = arr[i*2-1];
		arr[i*2].tfn += 24*60;
		arr[i*2].tst += 24*60;
	}

	m = m*2;

	qsort(&arr[1], m, sizeof(route), sf);

	for (i = 1; i <= m; i++)
	{
		if (size != 0 && heap[1].tfn <= arr[i].tst)
		{
			i--;
			status[ heap[1].fn ]++;
			del();
			continue;
		}
		else
		{
			status[arr[i].st]--;
			if (status[arr[i].st] < ans[arr[i].st]) ans[arr[i].st] = status[arr[i].st];
			add_heap(arr[i]);
		}
	}

	while (size > 0)
	{
		status[ heap[1].fn ]++;
		del();
		continue;
	}

	for (i = 1; i <= n; i++)
	{
		if (status[i] != 0)
		{
			printf("-1");
			return 0;
		}
	}

	int sum = 0;

	for (i = 1; i <= n; i++)
	{
		sum += -ans[i];
	}

	printf("%d", sum);

	return 0;
}