program _4;

{$APPTYPE CONSOLE}

const MaxN = 100000;

type SS = ^TPoint;

     TPoint = record
       u : longint;
       income, outcome : longint;
       next : SS;
     end;

     TEdge = record
       x, y : longint;
       income, outcome : longint;
     end;

var a, ban : array [1..MaxN] of SS;
    reb : array [1..MaxN] of TEdge;
    intime : array [1..MaxN] of boolean;
    bus : longint;
    n, m : longint;

procedure Add(reb : TEdge);
var w : SS;
begin
    New(w);
    w^.u := reb.y;
    w^.income := reb.income;
    w^.outcome := reb.outcome;
    w^.next := nil;
    if ban[reb.x] = nil then a[reb.x] := w
    else ban[reb.x]^.next := w;
    ban[reb.x] := w;
end;

procedure Swap(var a, b : TEdge);
var c : TEdge;
begin
    c := a;
    a := b;
    b := c;
end;

procedure Sort(l, r : longint);
var i, j : longint;
    x : TEdge;
begin
    i := l;
    j := r;
    x := reb[Random(j - i + 1) + i];
    repeat
      while (reb[i].x < x.x) or ((reb[i].x = x.x) and (reb[i].income < x.income)) do inc(i);
      while (reb[j].x > x.x) or ((reb[i].x = x.x) and (reb[j].income > x.income)) do dec(j);
      if i <= j then begin
        Swap(reb[i], reb[j]);
        inc(i);
        dec(j);
      end;
    until i > j;
    if i < r then Sort(i, r);
    if l < j then Sort(l, j);
end;

procedure Init();
var income, outcome, in_, ou_ : longint;
    i, q : longint;
    x, y : longint;
    h1, h2, m1, m2, c : char;
    s : string;
begin
    Reset(input, 'buses.in');
    Rewrite(output, 'buses.out');
    Readln(n, m);
    for i := 1 to m do begin
      Read(x);
      Read(c);
      Read(h1, h2);
      Read(c);
      Read(m1, m2);
      s := h1 + h2;
      Val(s, income, q);
      s := m1 + m2;
      Val(s, in_, q);
      income := income*60 + in_;
      Read(y);
      Read(c);
      Read(h1, h2);
      Read(c);
      Read(m1, m2);
      s := h1 + h2;
      Val(s, outcome, q);
      s := m1 + m2;
      Val(s, ou_, q);
      outcome := outcome*60 + ou_;
      reb[i].x := x;
      reb[i].y := y;
      reb[i].income := income;
      reb[i].outcome := outcome;
      Readln;
    end;
    Sort(1, m);
    for i := 1 to n do ban[i] := a[i];
    for i := 1 to m do Add(reb[i]);
    for i := 1 to n do ban[i] := a[i];
end;

function DFS(v : longint; outcome : longint) : boolean;
var w : SS;
begin
    DFS := false;
    while ban[v] <> a[v] do ban[v] := ban[v]^.next;
    while a[v] <> nil do begin
      DFS := true;
      if a[v]^.income < outcome then intime[v] := false;
      w := a[v];
      a[v] := a[v]^.next;      
      DFS(w^.u, w^.outcome);
      if a[v] <> nil then inc(bus);
    end;
end;

procedure Solve();
var i : longint;
begin
    Fillchar(intime, sizeof(intime), true);
    for i := 1 to n do
      if DFS(i, 0) then inc(bus);
end;

procedure Halting();
begin
    Writeln(-1);
    Close(input);
    Close(output);
    Halt;
end;

procedure Print();
var i : longint;
    s : longint;
begin
    for i := 1 to n do
      if ban[i] <> nil then Halting();
    s := 0;
    for i := 1 to n do s := s + Ord(not intime[i]);
    Writeln(s + bus);
    Close(input);
    Close(output);
end;

begin
    Init();
    Solve();
    Print();
end.
