program buses;

{$APPTYPE CONSOLE}

uses
  SysUtils;

function gettime(s:string):longint;
 var
  i:longint;
  h,m:longint;
 begin
  while s[1] = ' ' do delete(s,1,1);
  h:=strtoint(copy(s,1,2));
  m:=strtoint(copy(s,4,2));
  result:=h*60+m;
 end;

type

 ts = record
  v : longint;
  t : longint;
 end;

 plist = ^tlist;
 tlist = record
  time : longint;
  next : plist;
 end;

function lcreate(time : longint):plist;
 begin
  new(result);
  result.time:=time;
  result.next:=nil;
 end;

var
 a,b:array[1..100000] of ts;
 time:array[1..100000] of plist; //time by vertex
 time_last:array[1..100000] of plist;
 i:longint;
 ttime : string[6];
 n,m:longint;

procedure pushtime(num,t:longint);
 begin
   if time[num]=nil then
    begin
     time[num]:=lcreate(t);
     time_last[num]:=time[num];
    end
   else
    begin
     time_last[num].next:=lcreate(t);
     time_last[num]:=time_last[num].next;
    end;
 end;

procedure sort(l,r:longint);
 var
  x,i,j:longint;
  c:ts;
 begin
  x:=a[(l+r) div 2].t;
  i:=l; j:=r;
  repeat
   while a[i].t<x do inc(i);
   while a[j].t>x do dec(j);
   if i<=j then
    begin
     c:=a[i];a[i]:=a[j]; a[j]:=c;
     c:=b[i];b[i]:=b[j]; b[j]:=c;
     inc(i);
     dec(j);
    end;
  until i>j;
  if l<j then sort(l,j);
  if i<r then sort(i,r);
 end;

function find(num,need_time:longint):boolean;
 var
  t,l : plist;
 begin
  find := false;
  t:=time[num]; l:=t;
  if t = nil then exit;
  while t.time>need_time do
   begin
    if t.next = nil then exit;
    l:=t;
    t:=t.next;
    if t.time<=need_time then
     begin
      find := true;
      l.next:=t.next;
      exit;
     end;
   end;
  if t.time<=need_time then
   begin
    find := true;
    if t = time[num] then time[num]:=time[num].next;
    exit;
   end;
 end;

function make:longint;
 var
  ans,i:longint;
  tt:longint;
 begin
  ans:=0;
  for i:=1 to m do
   begin
    if not find(a[i].v,a[i].t) then inc(ans);
    tt:=b[i].t;
    if b[i].t<a[i].t then tt:=tt+1000000;
    pushtime(b[i].v,tt);
   end;
  make := ans;
 end;

procedure upd;
 var
  i:longint;
  t,l:plist;
 begin
  for i:=1 to m do
   begin
    t:=time[i]; l:=t;
    while t<>nil do
     begin
      if t.time>=1000000 then dec(t.time,1000000) else t.time:=0;
      l:=t;
      t:=t.next; 
     end;
   end;
 end;

var
 fl : boolean;
 ans,dt,ddt : longint;

begin
 assign(input,'buses.in'); reset(input);
 assign(output,'buses.out'); rewrite(output);
 read(n,m);
 for i:=1 to m do
  begin
   readln;
   read(a[i].v);
   read(ttime);
   a[i].t:=gettime(ttime);
   read(b[i].v);
   read(ttime);
   b[i].t:=gettime(ttime);
  end;

 sort(1,m);
 ans:=make;
 upd;
 dt:=make;
 if dt <> 0 then ans:=-1;
 write(ans);
 close(input);
 close(output);
end.
