program buses;

uses SysUtils;

type dtime = record
         hour   : Byte;
         minute : Byte;
         day    : Cardinal;
     end;

     plc = record
         t1,t2   : Cardinal;
         dt1,dt2 : dtime;
     end;
     List = ^mnode;
     mnode = Record
         inf  : Cardinal;
         next : List;
     end;

var table        : array[1..100000] of plc;
    mint         : array[1..100000] of List;
    avaible      : array[1..100000] of boolean;
    N,M,acnt,buse: Cardinal;

    // List functions <<<<<<<<<<<<<<<<<<<<<

    procedure AddIn(var lst: List; value : Cardinal);
    var nd : List;
    begin
         new(nd);
         nd^.inf := value;
         nd^.next:=lst;
         lst:=nd;
    end;

    function RetVal(lst : List; ind : Cardinal) : Cardinal;
    var i : Cardinal;
    begin
         for i:=1 to ind do
             lst:=lst^.next;
         result:=lst^.inf;
    end;

    procedure rem(var lst : List);
    var tmp : List;
    begin
         tmp:=lst;
         lst:=lst^.next;
         dispose(tmp);
    end;

    procedure deleteInd(var lst : List; ind : Cardinal);
    var i   : Cardinal;
    begin
         for i:=1 to ind do
             lst:=lst^.next;
         rem(lst);
    end;

    procedure freeList(var lst : List);
    var tmp : list;
    begin
         while lst<>nil do
         begin
              tmp:=lst;
              lst:=lst^.next;
              dispose(tmp);
         end;
    end;

    // end list functions ***************

    function deless(time1,time2: dtime) : boolean;
    begin
         result:=time1.day <= time2.day;
         if result and (time1.day = time2.day) then
              result:=time1.hour <= time2.hour else exit;
         if result and (time1.hour = time2.hour) then
            result:=time1.minute <= time2.minute;
    end;

    procedure Input;
    var f       : text;
        tmb,tme : dtime;
        s1,s2   : string[6];
        b,e,i   : Cardinal;

        procedure DecTime(var dtm : dTime; source : String);
        begin
             dtm.hour:=StrToInt(Copy(source,2,2));
             dtm.minute:=StrToInt(Copy(source,5,2));
        end;

        procedure InDate;
        begin
             tmb.day:=0;
             tme.day:=0;
             ReadLn(f,b,s1,e,s2);
             DecTime(tmb,s1);
             DecTime(tme,s2);
             if deless(tme,tmb) then tme.day:=1;
        end;

    begin
         fillChar(table,sizeof(table),0);
         buse:=0;
         Assign(f,'buses.in');
         Reset(f);

         ReadLn(f,N,M);

         for i:=1 to M do
         begin
              InDate;
              table[i].t1:=b;
              table[i].t2:=e;
              table[i].dt1:=tmb;
              table[i].dt2:=tme;
        end;
        Close(f);
    end;

    procedure InitGraf;
    var i,j : Cardinal;
    begin
         fillChar(mint,sizeof(mint),0);
         fillchar(avaible,sizeof(avaible),1);
         acnt:=M;
         for i:=1 to M do
             for j:=1 to M do
                 if (i<>j) and (table[i].t2=table[j].t1) and
                    (deless(table[j].dt1,table[i].dt2)) then
                    AddIn(mint[i],j);
    end;

    procedure Final;
    var i : Cardinal;
    begin
         for i:=1 to M do
             FreeList(mint[i]);
    end;

    function noret(ind : Cardinal) : boolean;
    var i : Cardinal;
    begin
         result:=false;
         for i:=1 to M do
             if (ind<>i) and (table[i].t2=table[ind].t1) then exit;
         result:=true;
    end;

    procedure Solve;
    var i,j,oav,b,e,o : Cardinal;
        ef            : boolean;
        f             : Text;
    begin
         o:=M;
         oav:=M;
         ef:=false;
         buse:=0;
         repeat
               o:=oav;
               b:=1;
               inc(buse);
               while (avaible[b]=false) and (b<=M) do inc(b);
               e:=b;
               while (mint[e]<>nil) and avaible[e] do
               begin
                    avaible[e]:=false;
                    e:=mint[e]^.inf;
                    dec(oav);
               end;
               {if b<>e then ef:=true;}
         until ef or (oav=o) or (oav=0);

         for i:=1 to M do
             if noret(i) then break;
         if i=M then ef:=true;

         Assign(f,'buses.out');
         Rewrite(f);
              if M=1 then WriteLn(f,-1) else
                 WriteLn(f,buse);
         Close(f);
    end;

// ********* Main begin *********************************************
begin
     Input;
     InitGraf;
     Solve;
     Final;
end.
