{$APPTYPE CONSOLE}
program buses;

const
 taskid = 'buses';
 infile = taskid + '.in';
 outfile = taskid + '.out';
 maxn = 100000 + 5;
 inf = 1000000000;
 dlen = 24*60;

type
 pedge = ^tedge;
 tedge = record
  v: integer;
  x,len: integer;
  next: pedge;
 end;

var n,m,ans: integer;
    e: array [1..maxn] of pedge;
    din, dout: array [1..maxn] of integer;

procedure init;
 begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
 end;

procedure readtime(var t: integer);
 var a,b,c,d,x: char;
 begin
  seekeof;
  read(a,b,x,c,d);
  t := ((ord(a) - $30) * 10 + (ord(b) - $30)) * 60 + ((ord(c) - $30) * 10 + (ord(d) - $30));
 end;

procedure add(u,v,x,len: integer);
 var ne: pedge;
 begin
  new(ne);
  ne.v := v;
  ne.x := x;
  ne.len := len;
  ne.next := e[u];
  e[u] := ne;
  inc(din[v]);
  inc(dout[u]);
 end;

procedure load;
 var i,u,v,x,y: integer;
 begin
  readln(n,m);
  for i := 1 to n do begin
   e[i] := nil;
   din[i] := 0;
   dout[i] := 0;
  end;
  for i := 1 to m do begin
   read(u);
   readtime(x);
   read(v);
   readtime(y);
   if y > x then add(u,v,x,y-x) else add(u,v,x,y-x+dlen);
  end;
 end;

procedure process(q: integer);
 var t,t0,v,min,dst,d: integer;
     cur,prev,minp,minc: pedge;
 begin
  t := e[q].x;
  t0 := t;
  v := q;
  d := 0;
  repeat
   prev := nil;
   minp := nil;
   minc := nil;
   min := inf;
   cur := e[v];
   while cur <> nil do begin
    if t <= cur.x then dst := cur.x - t else dst := cur.x + dlen - t;
    if dst < min then begin
     min := dst;
     minc := cur;
     minp := prev;
    end;
    prev := cur;
    cur := cur.next;
   end;
   if minp = nil then
    e[v] := e[v].next
   else
    minp.next := minc.next;
   inc(t, min + minc.len);
   while t >= dlen do begin
    inc(d);
    dec(t, dlen);
   end;
   v := minc.v;
  until v = q;
  if t > t0 then inc(d);  
  inc(ans, d);
 end;

procedure solve;
 var i: integer;
 begin
  load;
  for i := 1 to n do
   if din[i] <> dout[i] then begin
    write(-1);
    exit;
   end;
  ans := 0;
  for i := 1 to n do
   while e[i] <> nil do begin
    process(i);
   end;
  write(ans);
 end;

begin
 init;
 solve;
end.