#include <stdio.h>
#include <memory.h>

#define MAXN 100001
#define INFINITE 1000000

struct task
{
	int time, s, t, finish;
};

struct list
{
	int start, finish;
};

struct list a[MAXN];
int n, m, res;
char vert[MAXN];
struct task time[MAXN];
int buses[MAXN];
struct task r[MAXN];
struct task heap[MAXN];
int pr, t;
int heap_size = 0;


void init()
{
	freopen("buses.in", "r", stdin);
	freopen("buses.out", "w", stdout);
	memset(a, 0, sizeof(a));
	memset(vert, 1, sizeof(vert));
	n = 0;
	m = 0;
	res = 0;
	memset(time, 0, sizeof(time));
	memset(buses, 0, sizeof(buses));
	memset(r, 0, sizeof(r));
	pr = 0;
}


void readdata()
{
	int x, y, start, finish, i;
	int st, fin;
	scanf("%d%d", &n, &m);
	for(i=1;i<=m;i++)
	{
		scanf("%d %2d:%2d", &x, &st, &fin);
		start = st*60+fin;
		scanf("%d %2d:%2d", &y, &st, &fin);
		finish = st*60+fin;
		if(start>finish) finish+=24*60;
		a[x].start++;
		a[y].finish++;
		time[i].time = start;
		time[i].s = x;
		time[i].t = y;
		time[i].finish = finish;
	}
}


void swap(struct task* a, struct task* b)
{
	struct task t;
	t = *a; *a = *b; *b = t;
}

void qsort(int p, int q)
{
	int i = p-1, j;
	if(p<q)
	{
		for(j=p;j<q;j++)
			if(time[j].time<time[q].time)
				swap(&time[++i], &time[j]);
		swap(&time[++i], &time[q]);
		qsort(p, i-1);
		qsort(i+1, q);
	}
}

int strong_connect()
{
	return 1;
}

int heap_min_finish()
{
	return heap[1].finish;
}

void task_copy(struct task* d, struct task s)
{
	*d = s;
}

void min_heapify(int i)
{
	int l = i*2;
	int r = l+1;
	int smallest;
	if((l<=heap_size)&&(heap[l].finish<heap[i].finish)) smallest = l; else smallest = i;
	if((r<=heap_size)&&(heap[smallest].finish>heap[r].finish)) smallest = r;
	if(smallest!=i)
	{
		swap(&heap[i], &heap[smallest]);
		min_heapify(smallest);
	}
}

struct task heap_extract_min()
{
	struct task tmp;
	task_copy(&tmp, heap[1]);
	task_copy(&heap[1], heap[heap_size]);
	heap_size--;
	min_heapify(1);
	return tmp;
}

void heap_decrease_key(int i, int key)
{
	struct task tsk = heap[i];
	heap[i].finish = key;
	while((i>1)&&(heap[i/2].finish>heap[i].finish))
	{
		swap(&heap[i/2], &heap[i]);
		i = i /2;
	}
}

void heap_insert(struct task tsk)
{
	heap_size++;
	heap[heap_size] = tsk;
	heap[heap_size].finish = INFINITE;
	heap_decrease_key(heap_size, tsk.finish);
}

void check()
{
	struct task tsk;
	while((heap_size>0)&&(t>=heap_min_finish()))
	{
		tsk  = heap_extract_min();
		buses[tsk.t]++;
	}
}

void add_reis(int s, int t, int time, int finish)
{
	struct task tsk;
	tsk.s = s;
	tsk.t = t;
	tsk.time = time;
	tsk.finish = finish;
	heap_insert(tsk);
}

int check_res()
{
	int i;
	for(i=1;i<=n;i++)
		if(a[i].finish==0) return 0;
	return 1;
}

void solve()
{
	int i;
	int mm = 3*m;
	if(check_res())
	{
		qsort(1, n);
		for(i=m+1;i<=mm;i++)
		{
			time[i] = time[i-m];
			time[i].time+=24*60;
			time[i].finish+=24*60;
		}
		for(i=1;i<=mm;i++)
		{
			t = time[i].time;
			if(buses[time[i].s]==0)
			{
				check();
				if(buses[time[i].s]==0)
				{
					res++;
					buses[time[i].s] = 1;
				}
			}
			add_reis(time[i].s, time[i].t, time[i].time, time[i].finish);
			buses[time[i].s]--;
		}
	}
	else res = -1;
}

void writedata()
{
	printf("%d", res);
}


int main()
{
	init();
	readdata();
	solve();
	writedata();
	return 0;
}