#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define MAX 100010
#define MAXEV 200010

int N, E, X[MAX], Y[MAX], T1[MAX], T2[MAX];
int PIn[MAX], POut[MAX];
int EvN = 0, Ev[MAXEV], A[MAXEV], T[MAXEV];
int Ans = 0, Num[MAX];

void QSort( int L, int R )
{
  int i = L, j = R, n, ev, t, tmp;

  if (L >= R)
    return;
  n = L + (rand() % (R - L + 1));
  ev = Ev[n], t = T[n];
  while (i <= j)
  {
    while (T[i] < t || (T[i] == t && Ev[i] < ev)) i++;
    while (T[j] > t || (T[j] == t && Ev[j] > ev)) j--;
    if (i <= j)
    {
      SWAP(T[i], T[j], tmp);
      SWAP(Ev[i], Ev[j], tmp);
      SWAP(A[i], A[j], tmp);
      i++, j--;
    }
  }
  QSort(L, j), QSort(i, R);
}

int main( void )
{
  int i, h1, m1, h2, m2;

  srand(301703);
  freopen("buses.in", "rt", stdin);
  freopen("buses.out", "wt", stdout);
  scanf("%d%d", &N, &E);
  memset(PIn, 0, sizeof(PIn));
  memset(POut, 0, sizeof(POut));
  for (i = 0; i < E; i++)
  {
    scanf("%d%d%*c%d%d%d%*c%d", &X[i], &h1, &m1, &Y[i], &h2, &m2);
    X[i]--, Y[i]--;
    T1[i] = h1 * 60 + m1, T2[i] = h2 * 60 + m2;
    if (T2[i] < T1[i])
      T2[i] += 24 * 60;
    PIn[Y[i]]++, POut[X[i]]++;
  }
  for (i = 0; i < N; i++)
    if (PIn[i] != POut[i])
    {
      puts("-1");
      return 0;
    }
  for (i = 0; i < E; i++)
  {
    A[EvN] = X[i], T[EvN] = T1[i], Ev[EvN++] = 1; // OPEN
    A[EvN] = Y[i], T[EvN] = T2[i], Ev[EvN++] = 0; // CLOSE
  }
  QSort(0, EvN - 1);
  memset(Num, 0, sizeof(Num));
  for (i = 0; i < EvN; i++)
    if (Ev[i] == 0)
      Num[A[i]]++;
    else 
      if (Num[A[i]] == 0)
        Ans++;
      else
        Num[A[i]]--;
  printf("%d\n", Ans);
  return 0;
}
