#include <stdio.h>
#include <memory.h>

#define MAXM 100000
#define MAXN 100000
#define FALSE 0
#define TRUE 1

typedef struct
{
  long start, destination;
  long leave, arrival;
  int used;
} bus_t;

bus_t buses[MAXM];
long n, m;
int used[MAXN];
long way[MAXN];
long from[MAXN];
int buscount;
long visited;

void dfs (long v, long time, long depth, long f)
{
  long i, t, uk;
  from[v]=f;
  if (used[v])
    {
      uk=depth-1;
      t=from[v];
      visited++;
      while (t!=v)
        {
          visited++;
          buses[way[uk]].used=TRUE;
          uk--;
          t=from[t];
        }
      buses[way[uk]].used=TRUE;
      buscount++;
      return;
    }
  used[v]=TRUE;
  for (i=0; i<m; i++)
    {
      if (buses[i].leave>=time && buses[i].start==v && !buses[i].used)
        {
          way[depth]=i;
          dfs (buses[i].destination, buses[i].arrival, depth+1, v);
        }
    }
  used[v]=FALSE;
}

int check ()
{
  int pr;
  long i, j;
  for (i=0; i<m; i++)
    {
      pr=FALSE;
      if (buses[i].used) continue;
      for (j=0; j<m; j++)
        {
          if (buses[j].used) continue;
          if (buses[i].destination==buses[j].start &&
              buses[j].destination==buses[i].start) pr=TRUE;
        }
      if (!pr) return FALSE;
    }
  return TRUE;
}

int main ()
{
  long i, ah, am, lh, lm;
  freopen ("buses.in", "r", stdin);
  freopen ("buses.out", "w", stdout);
  scanf ("%ld %ld", &n, &m);
  memset (used, FALSE, sizeof (used));
  for (i=0; i<m; i++)
    {
      scanf ("%ld %ld:%ld %ld %ld:%ld",
        &buses[i].start,
        &lh, &lm,
        &buses[i].destination,
        &ah, &am
        );
      buses[i].leave=lh*60+lm;
      buses[i].arrival=ah*60+am;
      buses[i].start--; buses[i].destination--;
      buses[i].used=FALSE;
    }
  buscount=0;
  visited=0;
  for (i=0; i<n; i++)
    dfs (i, 0, 0, -1);
  if (!check ()) buscount=-1; else buscount+=n-visited;
  printf ("%ld", buscount);
  return 0;
}