program auto;

{$DEFINE DEBUG}
{$D+,L+}
{$R+,Q+}
{$S+,I+,C+}

uses
  SysUtils;

type
  TTime = record
    hour, minute: Byte;
  end;
  pList = ^TList;
  TList = record
    city: Integer;
    start, finish: TTime;
    next, prev: pList;
  end;
  TCity = record
    //input, lastin: pList;
    //output, lastout: pList;
    autocount: Integer;
  end;

  TRoad = record
    f, t: Integer;
    start, finish: Integer;
  end;

var
  n, m: Integer;
  city: array [1..100000] of TCity;
  road, roadfinish: array [1..100000] of TRoad;
  buscount: Integer;
  cityroad: array [1..100000, 1..2] of Boolean;

{procedure AddRoad(f: Integer; ft: TTime; t: Integer; tt: TTime);
var
  l: pList;
begin
  if city[f].output = nil then
  begin
    New(city[f].output);
    city[f].lastout := city[f].output;
    city[f].lastout.prev := nil;
  end
  else
  begin
    New(city[f].lastout.next);
    city[f].lastout.prev := city[f].lastout;
    city[f].lastout := city[f].lastout.next;
  end;

  l := city[f].lastout;
end;}

procedure ReadRoad(var f: Text);
var
  i: Integer;
  s: String[255];
  fr, t: Integer;
  ft, tt: TTime;
  c1, c2: Char;
begin
  for i := 1 to m do
  begin
    Readln(f, s);
    fr := StrToInt(Copy(s, 1, Pos(' ', s) - 1));
    Delete(s, 1, Pos(' ', s));
    c1 := s[1];
    c2 := s[2];
    ft.hour := (Ord(c1) - Ord('0')) * 10 + Ord(c2) - Ord('0');
    c1 := s[4];
    c2 := s[5];
    ft.minute := (Ord(c1) - Ord('0')) * 10 + Ord(c2) - Ord('0');
    Delete(s, 1, Pos(' ', s));

    t := StrToInt(Copy(s, 1, Pos(' ', s) - 1));
    Delete(s, 1, Pos(' ', s));
    c1 := s[1];
    c2 := s[2];
    tt.hour := (Ord(c1) - Ord('0')) * 10 + Ord(c2) - Ord('0');
    c1 := s[4];
    c2 := s[5];
    tt.minute := (Ord(c1) - Ord('0')) * 10 + Ord(c2) - Ord('0');

    //AddRoad(fr, ft, t, tt);
    road[i].f := fr;
    road[i].t := t;
    road[i].start := ft.hour * 60 + ft.minute;
    road[i].finish := tt.hour * 60 + ft.minute;
  end
end;

procedure ReadFromFile;
var
  f: Text;
  i: Integer;
begin
  Assign(f, 'buses.in');
  Reset(f);
  Readln(f, n, m);
  for i := 1 to n do
  begin
    city[i].autocount := 0;
    //city[i].input := nil;
    //city[i].output := nil
  end;
  ReadRoad(f);
  Close(f);
end;

procedure WriteToFile;
var
  f: Text;
begin
  Assign(f, 'buses.out');
  Rewrite(f);
  Writeln(f, buscount);
  Close(f);
end;

function Parition(p, r: Integer): Integer;
var
  i, j: Integer;
  x: Integer;
  buf: TRoad;
begin
  i := p - 1;
  j := r + 1;
  x := road[Random(r - p + 1) + p].start;
  while true do
  begin
    repeat
      Inc(i);
    until road[i].start >= x;
    repeat
      Dec(j);
    until road[j].start <= x;
    if i < j then
    begin
      buf := road[i];
      road[i] := road[j];
      road[j] := buf;
    end
    else
    begin
      Result := j;
      Exit
    end
  end
end;

procedure QSort(p, r: Integer);
var
  q: Integer;
begin
  while p < r do
  begin
    q := Parition(p, r);
    QSort(p, q);
    p := q + 1;
  end
end;

function ParitionFinish(p, r: Integer): Integer;
var
  i, j: Integer;
  x: Integer;
  buf: TRoad;
begin
  i := p - 1;
  j := r + 1;
  x := road[Random(r - p + 1) + p].finish;
  while true do
  begin
    repeat
      Inc(i);
    until road[i].finish >= x;
    repeat
      Dec(j);
    until road[j].finish <= x;
    if i < j then
    begin
      buf := road[i];
      road[i] := road[j];
      road[j] := buf;
    end
    else
    begin
      Result := j;
      Exit
    end
  end
end;

procedure QSortFinish(p, r: Integer);
var
  q: Integer;
begin
  while p < r do
  begin
    q := ParitionFinish(p, r);
    QSort(p, q);
    p := q + 1;
  end
end;

function Sorting: Boolean;
var
  i: Integer;
begin
  for i := 1 to m - 1 do
    if road[i].start > road[i + 1].start then
    begin
      Result := false;
      Exit;
    end;
  Result := true;
end;

function SortingFinish: Boolean;
var
  i: Integer;
begin
  for i := 1 to m - 1 do
    if road[i].finish > road[i + 1].finish then
    begin
      Result := false;
      Exit;
    end;
  Result := true;
end;

procedure TryZero;
var
  i: Integer;
begin
  for i := 1 to n do
  begin
    cityroad[i, 1] := false;
    cityroad[i, 2] := false;
  end;

  for i := 1 to m do
  begin
    cityroad[road[i].f, 1] := true;
    cityroad[road[i].t, 2] := true;
  end;

  for i := 1 to n do
  begin
    if not (cityroad[i, 1] and cityroad[i, 2]) then
    begin
      buscount := -1;
      WriteToFile;
    end
  end
end;

procedure MakeAutoCount;
var
  i: Integer;
begin
  TryZero;

  buscount := 1;
  for i := 1 to m do
  begin

  end
end;

begin
  ReadFromFile;
  QSort(1, m);
  roadfinish := road;
  QSortFinish(1, m);
{$IFDEF DEBUG}
  if (not Sorting) or (not SortingFinish) then
    raise Exception.Create('Not sorting');
{$ENDIF}
  MakeAutoCount;
  WriteToFile;
end.
