program auto;

{$DEFINE NODEBUG}
{$D-,L-}
{$R-,Q-}
{$S-,I-,C-}

uses
  Windows, SysUtils;

type
  TTime = record
    hour, minute: Byte;
  end;
  pList = ^TList;
  TList = record
    city: Integer;
    start, finish: TTime;
    next, prev: pList;
  end;
  TCity = record
    //input, lastin: pList;
    //output, lastout: pList;
    autocount: Integer;
  end;

  TRoad = record
    f, t: Integer;
    start, finish: Int64;
  end;

  TRoadAr = array [1..100000] of TRoad;

var
  n, m: Integer;
  city: array [1..100000] of TCity;
  road, roadfinish, buf: TRoadAr;
  buscount: Integer;
  cityroad: array [1..100000, 1..2] of Integer;
  timer: Integer;

{procedure AddRoad(f: Integer; ft: TTime; t: Integer; tt: TTime);
var
  l: pList;
begin
  if city[f].output = nil then
  begin
    New(city[f].output);
    city[f].lastout := city[f].output;
    city[f].lastout.prev := nil;
  end
  else
  begin
    New(city[f].lastout.next);
    city[f].lastout.prev := city[f].lastout;
    city[f].lastout := city[f].lastout.next;
  end;

  l := city[f].lastout;
end;}

procedure ReadRoad(var f: Text);
var
  i: Integer;
  s: String[255];
  fr, t: Integer;
  ft, tt: TTime;
  c1, c2: Char;
begin
  for i := 1 to m do
  begin
    Readln(f, s);
    fr := StrToInt(Copy(s, 1, Pos(' ', s) - 1));
    Delete(s, 1, Pos(' ', s));
    c1 := s[1];
    c2 := s[2];
    ft.hour := (Ord(c1) - Ord('0')) * 10 + Ord(c2) - Ord('0');
    c1 := s[4];
    c2 := s[5];
    ft.minute := (Ord(c1) - Ord('0')) * 10 + Ord(c2) - Ord('0');
    Delete(s, 1, Pos(' ', s));

    t := StrToInt(Copy(s, 1, Pos(' ', s) - 1));
    Delete(s, 1, Pos(' ', s));
    c1 := s[1];
    c2 := s[2];
    tt.hour := (Ord(c1) - Ord('0')) * 10 + Ord(c2) - Ord('0');
    c1 := s[4];
    c2 := s[5];
    tt.minute := (Ord(c1) - Ord('0')) * 10 + Ord(c2) - Ord('0');

    //AddRoad(fr, ft, t, tt);
    road[i].f := fr;
    road[i].t := t;
    road[i].start := ft.hour * 60 + ft.minute;
    road[i].finish := tt.hour * 60 + ft.minute;
  end
end;

procedure ReadFromFile;
var
  f: Text;
  i: Integer;
begin
  Assign(f, 'buses.in');
  Reset(f);
  Readln(f, n, m);
  for i := 1 to n do
  begin
    city[i].autocount := 0;
    //city[i].input := nil;
    //city[i].output := nil
  end;
  ReadRoad(f);
  Close(f);
end;

procedure WriteToFile;
var
  f: Text;
begin
  Assign(f, 'buses.out');
  Rewrite(f);
  if buscount > 1000000 then
    Writeln(f, '-1')
  else
    Writeln(f, buscount);
  Close(f);
end;

function Parition(p, r: Integer): Integer;
var
  i, j: Integer;
  x: Integer;
  buf: TRoad;
begin
  i := p - 1;
  j := r + 1;
  x := road[Random(r - p + 1) + p].start;
  while true do
  begin
    repeat
      Inc(i);
    until road[i].start >= x;
    repeat
      Dec(j);
    until road[j].start <= x;
    if i < j then
    begin
      buf := road[i];
      road[i] := road[j];
      road[j] := buf;
    end
    else
    begin
      Result := j;
      Exit
    end
  end
end;

procedure QSort(p, r: Integer);
var
  q: Integer;
begin
  while p < r do
  begin
    q := Parition(p, r);
    QSort(p, q);
    p := q + 1;
  end
end;

procedure Cons(var a: TRoadAr; p, c, r: Integer; f: Boolean);
var
  i, j, k: Integer;
begin
  i := p;
  j := c + 1;
  for k := p to r do
  begin
    if (i > c) then
    begin
      buf[k] := a[j];
      Inc(j);
    end
    else
    if (j > r) then
    begin
      buf[k] := a[i];
      Inc(i);
    end
    else
    if ((f) and (a[j].start < a[i].start)) or
       ((not f) and (a[j].finish < a[i].finish)) then
    begin
      buf[k] := a[j];
      Inc(j);
    end
    else
    begin
      buf[k] := a[i];
      Inc(i);
    end
  end;

  for k := p to r do
  begin
    a[k] := buf[k];
  end
end;

procedure Sort(var a: TRoadAr; p, r: Integer; f: Boolean);
var
  c: Integer;
begin
  if p < r then
  begin
    c := (p + r) div 2;
    Sort(a, p, c, f);
    Sort(a, c + 1, r, f);
  end;
  Cons(a, p, c, r, f);
end;

function ParitionFinish(p, r: Integer): Integer;
var
  i, j: Integer;
  x: Integer;
  buf: TRoad;
begin
  i := p - 1;
  j := r + 1;
  x := road[Random(r - p + 1) + p].finish;
  while true do
  begin
    repeat
      Inc(i);
    until road[i].finish >= x;
    repeat
      Dec(j);
    until road[j].finish <= x;
    if i < j then
    begin
      buf := road[i];
      road[i] := road[j];
      road[j] := buf;
    end
    else
    begin
      Result := j;
      Exit
    end
  end
end;

procedure QSortFinish(p, r: Integer);
var
  q: Integer;
begin
  while p < r do
  begin
    q := ParitionFinish(p, r);
    QSort(p, q);
    p := q + 1;
  end
end;

function Sorting: Boolean;
var
  i: Integer;
begin
  for i := 1 to m - 1 do
    if road[i].start > road[i + 1].start then
    begin
      Result := false;
      Exit;
    end;
  Result := true;
end;

function SortingFinish: Boolean;
var
  i: Integer;
begin
  for i := 1 to m - 1 do
    if roadfinish[i].finish > roadfinish[i + 1].finish then
    begin
      Result := false;
      Exit;
    end;
  Result := true;
end;

procedure TryZero;
var
  i: Integer;
begin
  for i := 1 to n do
  begin
    cityroad[i, 1] := 0;
    cityroad[i, 2] := 0;
  end;

  for i := 1 to m do
  begin
    Inc(cityroad[road[i].f, 1]);
    Inc(cityroad[road[i].t, 2]);
  end;

  for i := 1 to n do
  begin
    if cityroad[i, 1] <> cityroad[i, 2] then
    begin
      buscount := -1;
      WriteToFile;
      Halt(0);
    end
  end
end;

procedure MakeAutoCount;
var
  i, j, sj: Integer;
begin
  TryZero;

  buscount := 0;
  j := 1;
  while roadfinish[j].finish < road[1].start do
  begin
    Inc(j);
  end;
  sj := j;
  i := 1;
  while GetTickCount - timer < 1500 do
  begin
    while roadfinish[j].finish <= road[i].start do
    begin
      Inc(roadfinish[j].start, 24 * 60);
      Inc(roadfinish[j].finish, 24 * 60);
      Inc(city[roadfinish[j].t].autocount);
      Inc(j);
      if j = m + 1 then
        j := 1;
    end;
    if city[road[i].f].autocount = 0 then
      Inc(buscount)
    else
      Dec(city[road[i].f].autocount);

    Inc(road[i].start, 24 * 60);
    Inc(road[i].finish, 24 * 60);
    Inc(i);
    if i = m + 1 then
    begin
      {while roadfinish[j].finish >= road[1].start do
      begin
        Inc(city[roadfinish[j].t].autocount);
        Inc(j);
        if j = m + 1 then
          j := 1;
      end;}
      i := 1;
    end
  end
end;

begin
  timer := GetTickCount;
  Randomize;
  ReadFromFile;
  //QSort(1, m);
  Sort(road, 1, m, true);
  roadfinish := road;
  //QSortFinish(1, m);
  Sort(roadfinish, 1, m, false);
{$IFDEF DEBUG}
  if (not Sorting) or (not SortingFinish) then
    raise Exception.Create('Not sorting');
{$ENDIF}
  MakeAutoCount;
  WriteToFile;
end.
