#include <stdio.h>
#include <stdlib.h>

#define MaxLen 100010
#define Inf 1000000000
#define IN 1
#define OUT 0

class Time
{
public:
	int s,h,m;
	Time(){}
	Time(int S,int H,int M) {s = S; h = H; m = M;}
	bool operator < (Time a)
	{
		if ( s < a.s ) return true; if (s > a.s) return false;
		if ( h < a.h ) return true; if (h > a.h) return false;
		if ( m < a.m ) return true; if (m > a.m) return false;
		return false;
	}
	bool operator == (Time a)
	{
		return (s == a.s && h == a.h && m == a.m);
	}

	bool operator <= (Time a)
	{
		if (*this < a || *this == a)
			return true;
		return false;
	}
};

class Stack
{
public:
	int A[MaxLen];
	int size;
	Stack()	{size = 0;}
	void Push(int a) { A[size++] = a; }
	int Get() { return A[size - 1]; }
	int Pop() { return A[--size]; }
};

class Vertix
{
public:
	int v,t;
};

class HeapItem
{
public:
	Time a;
	int k,f;

	HeapItem(){}
	HeapItem(Time q,int w,int h){a = q; k = w; f = h;}

	bool operator < (HeapItem T)
	{
		if (a < T.a)
			return true;
		if (T.a < a)
			return false;
		if (f > T.f)
			return true;
		return false;
	}
};

class Heap
{
public:
	HeapItem A[MaxLen];
	int SizeHeap;

	Heap(){SizeHeap = 0;}

 	void Insert(HeapItem a)
	{
		HeapItem Tmp;
		++SizeHeap;
		int i = SizeHeap;
		while(i > 0 && a < A[i / 2])
		{
			A[i] = A[i / 2];
			i = i / 2;			
		}
		A[i] = a; 
	}

	void down(int a)
	{
		HeapItem Tmp;
		int min = 0;
		while(min != a)
		{
			min = a;
			if (2 * a <= SizeHeap && A[2 * a] < A[min])
				min = 2 * a;
			if (2 * a + 1<= SizeHeap && A[2 * a + 1] < A[min])
				min = 2 * a + 1;
			if (min != a)
			{
				Tmp = A[min]; A[min] = A[a]; A[a] = Tmp;
				a = min;
				min = 0;
			}
		}
	}

	void get()
	{
		A[1].a = Time(A[1].a.s + 1,A[1].a.h,A[1].a.m);
		this->down(1);
	}
} H;

int AmountBus[MaxLen];
Time TimeBus[MaxLen][2];
int A1[MaxLen], B1[MaxLen], Next1[MaxLen];
int A2[MaxLen], B2[MaxLen], Next2[MaxLen];
Vertix T[MaxLen];
int color[MaxLen],WereV[MaxLen];
int Edge[MaxLen][2];
int TIME;
Stack D;
int n,m,AmountEdge;
int Ans;

void DFS(int a)
{
	D = Stack(); D.Push(a);
	int i,u,f;
	while(D.size != 0)
	{
		u = D.Get(); color[u] = 1; 	f = 0;
		for(i = A1[u]; i; i = Next1[i])
			if (color[B1[i]] == 0)
			{
				D.Push(B1[i]);
				f = 1;
				break;
			}
		if (f == 0)
		{
			u = D.Pop();
			++TIME;
			T[TIME - 1].t = TIME;
			T[TIME - 1].v = u; 
		}
	}
}

void dfs(int a,int comp)
{
	D = Stack(); D.Push(a);
	int i,u,f;
	while(D.size != 0)
	{
		u = D.Get(); color[u] = 0; 	f = 0; WereV[u] = comp;
		for(i = A2[u]; i; i = Next2[i])
			if (color[B2[i]] == 1)
			{
				D.Push(B2[i]);
				f = 1;
				break;
			}
		if (f == 0)
		{
			u = D.Pop();
			++TIME;
			T[TIME - 1].t = TIME;
			T[TIME - 1].v = u; 
		}
	}
}

int SortFunc(const void *a1, const void *a2)
{
	Vertix a = *(Vertix *)a1;
	Vertix b = *(Vertix *)a2;
	if (a.t > b.t) return 1;
	if (a.t < b.t) return -1;
	return 0;
}

int main ()
{
	freopen("buses.in","r",stdin);
	freopen("buses.out","w",stdout);

	scanf("%d %d",&n,&m);
	int i,j,a,b,h1=0,m1=0,h2=0,m2=0;
	for(i = 1; i <= m; ++i)
	{
		scanf("%d %d:%d %d %d:%d",&a,&h1,&m1,&b,&h2,&m2);

		++AmountEdge;
		Next1[AmountEdge] = A1[a];
		A1[a] = AmountEdge;
		B1[AmountEdge] = b;

		Next2[AmountEdge] = A2[b];
		A2[b] = AmountEdge;
		B2[AmountEdge] = a;

		TimeBus[AmountEdge][0] = Time(0,h1,m1);
		TimeBus[AmountEdge][1] = Time(0,h2,m2);
		if (TimeBus[AmountEdge][1] < TimeBus[AmountEdge][0])
			TimeBus[AmountEdge][1] = Time(1,h2,m2);
		Edge[AmountEdge][0] = a;
		Edge[AmountEdge][1] = b;
	}
	for(i = 1; i <= n; ++i)
	{
		if (color[i] == 0)
			DFS(i);
	}
	qsort((void*)T,n,sizeof(T[0]),SortFunc);
	a = 0;
	for(i = 1; i <= n; ++i)
	{
		if (color[i] == 1)
			dfs(i,++a);
	}
	for(i = 1; i <= m; ++i)
	{
		H.Insert(HeapItem(TimeBus[i][0],Edge[i][0],OUT));
		H.Insert(HeapItem(TimeBus[i][1],Edge[i][1],IN));
		if (WereV[Edge[i][0]] != WereV[Edge[i][1]])
		{
			printf("-1");
			return 0;
		}
	}
	a = H.A[1].k;
	b = 1;
	while(1)
	{
		if (H.A[1].k == a && b == 0)
			break;
		if (H.A[1].k == a && b == 1)
			b = 0;
		if (H.A[1].f == OUT)
		{
			if (AmountBus[H.A[1].k] == 0)
			{
				b = 1;
				++Ans;
			}
			else
				--AmountBus[H.A[1].k];
			H.get();
			continue;
		}
		if (H.A[1].f == IN)
		{
			++AmountBus[H.A[1].k];
			H.get();
		}
	}
	printf("%d",Ans);
	return 0;
}