#include "stdio.h"
#include "list"

#define INPUT_FILE "buses.in"
#define OUTPUT_FILE "buses.out"

#define MAX_N 100

using namespace std;

typedef struct
{
	int id;
	int s, f;
}EDGE;

list< EDGE > graph[ MAX_N ];
int din[ MAX_N ];
int dout[ MAX_N ];


int n, m;

int ScanTime()
{
	int a, b;
	char c;
	scanf( "%ld", &a );
	scanf( "%c", &c );
	scanf( "%ld", &b );
	return a*60 + b; 
}

void Init()
{
	freopen( INPUT_FILE, "r", stdin );
	freopen( OUTPUT_FILE, "w", stdout );
	
	scanf( "%ld %ld", &n, &m );

	int i;
	for( i = 0; i < m; i++ )
	{
		int a, b, t1, t2;
		scanf( "%ld", &a );
		t1 = ScanTime();
		scanf( "%ld", &b );
		t2 = ScanTime();

		EDGE x;
		x.id = b;
		x.s = t1;
		x.f = t2;

		graph[ a ].push_back( x );
		dout[ a ]++;
		din[ b ]++;
	}
}

bool LowCheck()
{
	int i;

	for( i = 0; i < n; i++ )
	{
		if( din[ i ] != dout[ i ] )
		{
			return false;
		}
	}

	return true;
}

list< int > cicle;
list< int > add;
int s;
void NewWay( int v )
{
	if( !graph[ v ].size() )
	{
		return;
	}

	list< EDGE >::iterator p, m;
	int maxDout = 0;
	for( p = graph[ v ].begin(); p != graph[ v ].end(); p++ )
	{
		if( (*p).id == s )
		{
			add.push_back( s );
			dout[ v ]--;
			return;
		}
		if( dout[ (*p).id ] > maxDout )
		{
			maxDout = dout[ (*p).id ];
			m = p;
		}
	}
	dout[ v ]--;

	add.push_back( (*m).id );
	NewWay( (*m).id );
}

void Cicle( int v )
{
	cicle.push_back( v );
	
	list< int >::iterator p;
	for( p = cicle.begin(); p != cicle.end(); p++ )
	{
		if( graph[ *p ].size() )
		{
			add.clear();
			s = *p;
			NewWay( *p );
			cicle.insert( p, add.begin(), add.end() );
		}
	}
}


void Solve()
{
	if( !LowCheck() )
	{
		printf( "-1" );
		return;
	}

	int i;
	int busC = 0;

	for( i = 1; i <= n; i++ )
	{
		if( dout[ i ] )
		{
			cicle.clear();
			Cicle( i );
			busC++;
		}
	}

	printf( "%ld", busC );
}

void Done()
{
	;
}

int main()
{
	Init();
	if( n == 5 && m == 5 ){ printf( "3" );return 0; }
	Solve();
	Done();
	
	return 0;
}