program tru4;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  inf = 'buses.in';
  outf = 'buses.out';

function readtime: integer;
var
  c: char;
  h, m: integer;
begin
  h:=0;
  read(c);
  while not (c in ['0'..'9']) do read(c);
  while (c in ['0'..'9']) do
  begin
    h:=h*10+strtoint(c);
    read(c);
  end;
  while not (c in ['0'..'9']) do read(c);
  m:=0;
  m:=m*10+strtoint(c);
  read(c);
  m:=m*10+strtoint(c);
  result:=h*60+m;
end;

procedure Swap(var a, b: integer);
var
  t: integer;
begin
  t:=a; a:=b; b:=t;
end;


var
  v, e, i, src, dst, otpr, prib, x, j: integer;
  towns: array of record
    prib: array of integer;
    otpr: array of record
      t, dst, dstp: integer;
    end;
  end;

procedure QUIT_NOANS;
begin
  write('-1');
  close(output);
  halt(0);
end;

var
  cp: array [0..100000] of integer;
  pathes: array of array of record
    num, prib, otpr: integer;
  end;

procedure delprib(i, j: integer);
var
  x: integer;
begin
  x:=length(towns[i].prib)-1;
  towns[i].prib[j]:=towns[i].prib[x];
  setlength(towns[i].prib, x);
end;

procedure delotpr(i, j: integer);
var
  x: integer;
begin
  x:=length(towns[i].otpr)-1;
  towns[i].otpr[j]:=towns[i].otpr[x];
  setlength(towns[i].otpr, x);
end;

procedure makepath(cpi, st: integer; var cpii: integer);
var
  np, i: integer;
begin
  np:=cpi;
  if st > 1 then
  begin
    setlength(pathes, length(pathes)+1);
    np:=length(pathes)-1;
    setlength(pathes[np], cpii-st+1);
  end;
  for i:=st to cpii-1 do
  begin
    pathes[np][i-st+1]:=pathes[cpi][i];
    cp[pathes[cpi][i].num]:=0;
  end;
  pathes[np][1].prib:=pathes[cpi][cpii].prib;
  setlength(pathes[np], cpii-st+1);
  cpii:=st;
end;

function tdiff(a, b: integer): integer;
begin
  result:=b-a;
  if result < 0 then result:=result+1440;
end;

function findotpr(src: integer; t: integer = -1): integer;
var
  m, i: integer;
  nt: integer;
begin
  result:=-1;
  m:=length(towns[src].otpr)-1;
  if m < 0 then exit;
  result:=0;
  if t < 0 then exit;
  nt:=tdiff(t, towns[src].otpr[0].t);
  for i:=1 to m do
    if tdiff(t, towns[src].otpr[i].t) < nt then
    begin
      nt:=tdiff(t, towns[src].otpr[i].t);
      result:=i;
    end;
end;

procedure trypath(src: integer; cpi: integer = -1; tp: integer = -1);
var
  cpii: integer;
  dsti, dst: integer;
  pn, otpr, pt: integer;
begin
  if cpi = -1 then
  begin
    fillchar(cp, sizeof(cp),0);
    setlength(pathes, length(pathes)+1);
    cpi:=length(pathes)-1;
    setlength(pathes[cpi], 2);
    cpii:=1;
    pathes[cpi][cpii].prib:=-1;
  end else
  begin
    cpii:=length(pathes[cpi]);
    setlength(pathes[cpi], cpii+1);
    pathes[cpi][cpii].prib:=tp;
  end;
  pathes[cpi][cpii].num:=src;
  if cp[src] > 0 then
  begin
    makepath(cpi, cp[src], cpii);
    if cpii = 1 then exit else
      setlength(pathes[cpi], cpii+1);
  end;
  cp[src]:=cpii;
  dsti:=findotpr(src, pathes[cpi][cpii].prib);
  if dsti = -1 then QUIT_NOANS;
  dst:=towns[src].otpr[dsti].dst;
  pn:=towns[src].otpr[dsti].dstp;
  pt:=towns[dst].prib[pn];
  delprib(dst, pn);
  otpr:=towns[src].otpr[dsti].t;
  pathes[cpi][cpii].otpr:=otpr;
  delotpr(src, dsti);
  trypath(dst, cpi, pt);
end;

var
  res: integer;

function countpath(x: integer): integer;
var
  m, tall, i: integer;
begin
  m:=length(pathes[x])-1;
  pathes[x][0]:=pathes[x][m];
  setlength(pathes[x], m);
  tall:=0;
  for i:=0 to m-1 do
  begin
    tall:=tall+tdiff(pathes[x][i].prib, pathes[x][i].otpr)+tdiff(pathes[x][i].otpr, pathes[x][(i+1) mod m].prib);
  end;
  result:=tall div 1440;
  if tall mod 1440 > 0 then inc(result);
end;

begin
  assign(input, inf); assign(output, outf);
  reset(input); rewrite(output);
  res:=0;

  read(v, e);
  setlength(pathes, 0);

  setlength(towns, v);
  for i := 0 to v - 1 do
  begin
    setlength(towns[i].otpr, 0);
    setlength(towns[i].prib, 0);;
  end;

  for i:=1 to e do
  begin
    read(src);
    otpr:=readtime;
    read(dst);
    dec(src); dec(dst);
    prib:=readtime;
    setlength(towns[dst].prib, length(towns[dst].prib)+1);
    j:=length(towns[dst].prib)-1;
    towns[dst].prib[j]:=prib;
    SetLength(towns[src].otpr, length(towns[src].otpr)+1);
    x:=length(towns[src].otpr)-1;
    towns[src].otpr[x].t:=otpr;
    towns[src].otpr[x].dst:=dst;
    towns[src].otpr[x].dstp:=j;
  end;
  close(input);

  for i:=0 to v-1 do
    if length(towns[i].prib) <> length(towns[i].otpr) then QUIT_NOANS else
    while length(towns[i].otpr) > 0 do
      trypath(i);

  for i:=0 to length(pathes)-1 do
    res:=res+countpath(i);

  write(res);

  close(output);
end.
