program buses;

{$APPTYPE CONSOLE}

uses SysUtils;

type
  TRace = record
    fromt, tot: Integer;
    fromtime, totime: Integer;
    used: Boolean;
  end;
var
  Race: array[1..100000] of TRace;
  towns, races: Integer;
  buscount: Integer;
  aBuses: array[1..100000] of record
    Time: Integer;
    City: Integer;
    start: Integer;
  end;
  Cities: array[1..100000] of Boolean;
  connectedcities: Integer;

function LoadData: Boolean;
var Data: TextFile;
sf, st: string[6];
i: Integer;
begin
  Result := True;
  AssignFile(Data, 'buses.in');
  Reset(Data);
  ReadLn(Data, Towns, Races);
  ConnectedCities := 0;
  for i := 1 to races do begin
    ReadLn(Data, Race[i].fromt, sf, Race[i].tot, st);
    Race[i].fromtime := StrToInt(sf[2] + sf[3]) * 60 + StrToInt(sf[5] + sf[6]);
    Race[i].totime := StrToInt(st[2] + st[3]) * 60 + StrToInt(st[5] + st[6]);
    if Cities[i] = False then begin
      Cities[i] := True;
      Inc(ConnectedCities)
    end;
    Race[i].used := False;
  end;
  if ConnectedCities <> towns then Result := False;
  CloseFile(Data);
end;

procedure Exchange(var a: TRace; var b: TRace);
var c: TRace;
begin
  C := A;
  A := B;
  B := C;
end;

procedure Sort;
var X: TRace;
i, j: Integer;
min: Integer;
begin
  for i := 1 to Races do begin
    min := i;
    for j := i+1 to Races do
      if Race[j].fromtime < Race[min].fromtime then min := j;
    Exchange(Race[i], Race[min]);
  end;
end;

function FindTown(t: Integer; time: Integer): Integer;
var I: Integer;
begin
  Result := 0;
  for i := 1 to buscount do if (aBuses[i].City = t) and (aBuses[i].Time <= time) then begin
    Result := i;
    Exit;
  end;
end;

procedure Day;
var
  g: Integer;
  i: Integer;
begin
  BusCount := 1;
  aBuses[1].Time := Race[1].totime;
  aBuses[1].City := Race[1].tot;
  aBuses[1].start := Race[1].fromt;
  for i := 2 to Races do begin
    g := FindTown(Race[i].fromt, Race[i].fromtime);
    if g = 0 then begin
      Inc(busCount);
      aBuses[busCount].Time := Race[i].totime;
      aBuses[busCount].City := Race[i].tot;
      aBuses[busCount].start := Race[i].fromt;
    end else begin
      aBuses[g].Time := Race[i].totime;
      aBuses[g].City := Race[i].tot;
    end;
  end;
end;

var Data: TextFile;
begin
  AssignFile(Data, 'buses.out');
  Rewrite(Data);
  if LoadData then begin
    Sort;
    Day;
    Write(Data, busCount);
  end
  else Write(Data, -1);
  CloseFIle(data);
end.
