program P_4;

{$APPTYPE CONSOLE}

const
  Cif : Set of Char = ['0' .. '9'];
  MaxN = 330000;
type
  TEvent =
  record
    n, d, t : LongInt;
  end;
var
  n, m, c, rez : LongInt;
  e : Array[1 .. MaxN] of TEvent;
  now : Array[1 .. MaxN] of LongInt;

Procedure ReadTime(var t : LongInt);
var
  h, m : LongInt;
  c : Char;
begin
  Read(c);
  h := 0;
  While not (c in Cif) do
    Read(c);
  While c in Cif do
  begin
    h := h * 10 + Ord(c) - Ord('0');
    Read(c);
  end;
  m := 0;
  While not (c in Cif) do
    Read(c);
  While c in Cif do
  begin
    m := m * 10 + Ord(c) - Ord('0');
    Read(c);
  end;
  t := h * 60 + m;
end;

Procedure Swap(var a, b : TEvent);
var
  c : TEvent;
begin
  c := a;
  a := b;
  b := c;
end;

Function More(const a, b : TEvent) : Boolean;
begin
  More := (a.t > b.t) or ((a.t = b.t) and (a.d < b.d));
end;

Procedure QSort(const l, r : LongInt);
var
  i, j : LongInt;
  x : TEvent;
begin
  i := l;
  j := r;
  x := e[(l + r) div 2];
  repeat
    While More(x, e[i]) do
      Inc(i);
    While More(e[j], x) do
      Dec(j);
    if i <= j then
    begin
      Swap(e[i], e[j]);
      Inc(i);
      Dec(j);
    end;
  until i > j;
  if l < j then
    QSort(l, j);
  if i < r then
    QSort(i, r);
end;

Procedure Init;
var
  a, b, t1, t2, i : LongInt;
begin
  Reset(input, 'buses.in');
  Rewrite(output, 'buses.out');
  ReadLn(n, m);
  for i := 1 to n do
    now[i] := 0;
  for i := 1 to m do
  begin
    Read(a);
    ReadTime(t1);
    Read(b);
    ReadTime(t2);
    if t1 >= t2 then
    begin
      Inc(c);
      e[c].d := -1;
      e[c].n := a;
      e[c].t := t1 - 24 * 60;
    end;
    Inc(c);
    e[c].d := -1;
    e[c].n := a;
    e[c].t := t1;
    Dec(now[a]);
    Inc(c);
    e[c].d := 1;
    e[c].n := b;
    e[c].t := t2;
    Inc(now[b]);
  end;
  QSort(1, c);
end;

Procedure Solve;
var
  i : LongInt;
begin
  for i := 1 to n do
    if now[i] <> 0 then
    begin
      Write(-1);
      Exit;
    end;
  for i := 1 to c do
  begin
    Case e[i].d of
      -1 :
      begin
        if now[e[i].n] <> 0 then
          Dec(now[e[i].n])
        else
          Inc(rez);
      end;
      1 : Inc(now[e[i].n]);
    end;
  end;
  Write(rez);
end;

Procedure Print;
begin
  Close(input);
  Close(output);
end;

begin
  Init;
  Solve;
  Print;
end.
