{$O+,Q-,R-}
program Buses;

{$APPTYPE CONSOLE}

uses
  SysUtils, Windows;

const
  maxN = 100000;
  maxM = 100000;
  maxWorkTime = 1800;
  maxBuses = 100000000;
  busIn = 1;
  busOut = 2;

type
  TVertex = record
    edgeIn, edgeOut: integer;
    busesNow: integer;
    used: boolean;
  end;

  TEdge = record
    v1, v2: integer;
    t1, t2: integer;
  end;

  THalfEdge = record
    v, v0: integer;
    t: integer;
    io: integer;
  end;

var
  n, m, i, p, busesTotal: integer;
  workTime: cardinal;
  changed: boolean;
  s: string;
  v: array [1..maxN] of TVertex;
  e: array [1..maxM] of TEdge;
  q: array [1..maxM*2] of THalfEdge;

procedure Return(x: integer);
begin
  Writeln(x);
  CloseFile(Input);
  CloseFile(Output);
  Halt(0);
end;

procedure QSort(l, r: integer);
var
  i, j: integer;
  x, y: THalfEdge;
begin
  i := l;
  j := r;
  x := q[(l+r) div 2];
  repeat
    while (q[i].t < x.t) or
     ((q[i].t = x.t) and (q[i].io = busIn) and (x.io = busOut)) do i := i+1;
    while (x.t < q[j].t) or
     ((x.t = q[j].t) and (x.io = busIn) and (q[j].io = busOut)) do j := j-1;
    if i <= j then
    begin
      y := q[i];
      q[i] := q[j];
      q[j] := y;
      i := i+1;
      j := j-1;
    end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;

begin
  workTime := GetTickCount;

  AssignFile(Input, 'buses.in');
  AssignFile(Output, 'buses.out');
  Reset(Input);
  Rewrite(Output);

  Readln(n, m);
  for i := 1 to m do
  begin
    Readln(s);
    s := Trim(s);
    p := Pos(' ', s);
    e[i].v1 := StrToInt(Copy(s, 1, p-1));
    Delete(s, 1, p);
    s := TrimLeft(s);
    e[i].t1 := StrToInt(Copy(s, 1, 2)) * 60 + StrToInt(Copy(s, 4, 2));
    Delete(s, 1, 5);
    s := TrimLeft(s);
    p := Pos(' ', s);
    e[i].v2 := StrToInt(Copy(s, 1, p-1));
    Delete(s, 1, p);
    s := TrimLeft(s);
    e[i].t2 := StrToInt(Copy(s, 1, 2)) * 60 + StrToInt(Copy(s, 4, 2));
  end;
  QSort(1, m);

  FillChar(v, SizeOf(v), 0);
  for i := 1 to m do
  begin
    Inc(v[e[i].v1].edgeOut);
    Inc(v[e[i].v2].edgeIn);
  end;

  for i := 1 to n do
    if v[i].edgeIn <> v[i].edgeOut then Return(-1); 

  for i := 1 to m do
  begin
    q[i].v := e[i].v1;
    q[i].v0 := e[i].v2;
    q[i].t := e[i].t1;
    q[i].io := busOut;
    q[i+m].v := e[i].v2;
    q[i+m].v0 := e[i].v1;
    q[i+m].t := e[i].t2;
    q[i+m].io := busIn;
  end;
  QSort(1, 2*m);

  busesTotal := 0;
  changed := true;
  while changed do
  begin
    changed := false;
    for i := 1 to 2*m do
    begin
      if q[i].io = busIn then
      begin
        if not v[q[i].v0].used then Inc(busesTotal);
        Inc(v[q[i].v].busesNow);
      end
      else
      begin
        if v[q[i].v].busesNow = 0 then
        begin
          Inc(busesTotal);
          changed := true;
        end
        else
          Dec(v[q[i].v].busesNow);
      end;
      v[q[i].v].used := true;
      v[q[i].v0].used := true;
    end;
    if (GetTickCount - workTime > maxWorkTime) or
     (busesTotal > maxBuses) then Return(-1);
  end;

  Return(busesTotal);
end.

