{$APPTYPE CONSOLE}
TYPE Path = RECORD
                       X, Y : Integer;
              Start, Finish : Integer;
            END;

VAR N, M, Buses : Integer;
          Graph : Array [1..100000] of Path;
          Flags : Array [1..100000] of Integer;

PROCEDURE Opening;
  BEGIN
    Assign(Input, 'buses.in');    Reset(Input);
    Assign (Output, 'buses.out'); Rewrite(Output);
  END;

PROCEDURE Preparation;
  VAR i : Integer;

  FUNCTION Time : Integer;
    VAR Text : String [6];
        Temp, Code : Integer;
    BEGIN
      Read(Text);
      Val(Copy(Text, 2, 2), Temp, Code);
      Result:=Temp*60;
      Val(Copy(Text, 5, 2), Temp, Code);
      Result:=Result+Temp;
    END;

  BEGIN
    Read(N, M);
    FOR i:=1 to M DO BEGIN
                       Read(Graph [i].X);
                       Graph [i].Start:=Time;
                       Read(Graph [i].Y);
                       Graph [i].Finish:=Time;
                     END;
  END;

PROCEDURE Execution;
  VAR       i, j, x, y, k : Integer;
      Incoming, Outcoming : Array [0..100000] of Integer;

  PROCEDURE SortIncoming;
    VAR i, j, Min, Temp : Integer;
    BEGIN
      FOR i:=1 to Incoming [0] DO
        BEGIN
          Min:=i;
          FOR j:=i to Incoming [0] DO
            IF Graph [Incoming [j]].Finish < Graph [Incoming [Min]].Finish
              THEN Min:=j;
          Temp:=Incoming [i];
          Incoming [i]:=Incoming [Min];
          Incoming [Min]:=Temp;
        END;
    END;

  PROCEDURE SortOutcoming;
    VAR i, j, Min, Temp : Integer;
    BEGIN
      FOR i:=1 to Outcoming [0] DO
        BEGIN
          Min:=i;
          FOR j:=i to Outcoming [0] DO
            IF Graph [Outcoming [j]].Start < Graph [Outcoming [Min]].Start
              THEN Min:=j;
          Temp:=Outcoming [i];
          Outcoming [i]:=Outcoming [Min];
          Outcoming [Min]:=Temp;
        END;
    END;

  BEGIN
    FOR i:=1 to M DO BEGIN
                       Flags [Graph [i].X]:=Flags [Graph [i].X] + 1;
                       Flags [Graph [i].Y]:=Flags [Graph [i].Y] - 1;
                     END;
    i:=0;
    REPEAT
      Inc(i);
    UNTIL (i > N) or (Flags [i] <> 0);
    IF i <= N
      THEN Buses:=-1
      ELSE
        BEGIN
          Buses:=0;
          FOR i:=1 to N DO
            BEGIN
              Incoming [0]:=0;
              Outcoming [0]:=0;
              FOR j:=1 to M DO
                IF Graph [j].X = i
                  THEN BEGIN
                         Inc(Outcoming [0]);
                         Outcoming [Outcoming [0]]:=j;
                       END
                  ELSE IF Graph [j].Y = i
                         THEN BEGIN
                                Inc(Incoming [0]);
                                Incoming [Incoming [0]]:=j;
                                IF Graph [j].Finish < Graph [j].Start
                                  THEN Inc(Buses);
                              END;
              SortIncoming;
              SortOutcoming;
              x:=1;
              y:=1;
              WHILE (x <= Incoming [0]) and (y <=Outcoming [0]) DO
                BEGIN
                  IF Graph [Incoming [x]].Finish > Graph [Outcoming [y]].Start
                    THEN BEGIN
                           Inc(Buses);
                           Inc(y);
                         END
                    ELSE BEGIN
                           Inc(x);
                           Inc(y);
                         END;

                END;
            END;
        END;
  END;

PROCEDURE Termination;
  BEGIN
    Write(Buses);
  END;

PROCEDURE Closing;
  BEGIN
    Close(Input);
    Close(Output);
  END;

BEGIN
  Opening;
  Preparation;
  Execution;
  Termination;
  Closing;
END.
