program z4_ver2_READY;
{$APPTYPE CONSOLE}
uses
  SysUtils;
const MaxN = 100001;
type pnode = ^tnode;
     tnode = record
                 v, t1, t2, num: LongInt;
                 next: pnode;
             end;
var adj, adj2, adj3: array[0..MaxN] of pnode;
    deg, fin, start, d, p, compon, posit, vertex: array[0..MaxN] of LongInt;
    passed, can: array[0..MaxN] of Boolean;
    i, j, t1, t2, a, b, N, M, count, StartTime, StartVer: longInt;
    ch: char;

function GetTime: LongInt;
var tt: LongInt;
begin
   repeat
       Read(ch)
   until ch in ['0'..'9'];

   tt := ( pos(ch,'0123456789')-1 ) * 10;
   read(ch);
   tt := tt + ( pos(ch,'0123456789')-1 );
   read(ch);read(ch);
   tt := tt*60 + ( pos(ch,'0123456789')-1 ) * 10;
   read(ch);
   tt := tt + ( pos(ch,'0123456789')-1 );

   GetTime := tt;
end;

procedure Add(v1, time1, v2, time2, num: LongInt);
var tmp: pnode;
begin
    new(tmp);
    tmp^.v := v2;
    tmp^.t1 := time1;
    tmp^.t2 := time2;
    tmp^.num := num;
    tmp^.next := adj[v1];
    adj[v1] := tmp;

    fin[num] := time2;
    start[num] := time1;
    vertex[num] := v1;
    posit[num] := num;
end;

procedure Add2(v1, time1, v2, time2, num: LongInt);
var tmp: pnode;
begin
    new(tmp);
    tmp^.v := v2;
    tmp^.t1 := time1;
    tmp^.t2 := time2;
    tmp^.num := num;
    tmp^.next := adj2[v1];
    adj2[v1] := tmp;
end;

procedure init;
begin
    Assign(input, 'buses.in'); Reset(input);
    Assign(output, 'buses.out'); ReWrite(output);

    FillChar(deg, sizeof(deg), 0);

       Read(N, M);
       for i := 1 to M do begin
           Read(a);
           t1 := GetTime;
           Read(b);
           t2 := GetTime;
           if t1 > t2 then t2 := t2 + 1440;
           Add(a, t1, b, t2, i);
           Add2(b, t2, a, t1, i);

           inc(deg[b]); dec(deg[a]);
       end;

    Close(input);
end;

procedure save;
begin
    Close(output);
end;

procedure dfs(v: LongInt);
var w: pnode;
begin
    inc(count);
    passed[v] := true;

    w := adj[v];
    while w <> nil do begin
       if not passed[w^.v] then dfs(w^.v);
       w := w^.next;
    end;

    d[v] := count;
    inc(j);
    p[j] := v;
end;

procedure dfs2(v: LongInt);
var w: pnode;
begin
    passed[v] := true;
    compon[v] := i;

    w := adj2[v];
    while w <> nil do begin
       if not passed[w^.v] then dfs2(w^.v);
       w := w^.next;
    end;
end;

procedure dfs3(v: LongInt);
var w: pnode;
begin
    passed[v] := true;

    w := adj2[v];
    while w <> nil do begin
       if (not passed[w^.v]) then dfs3(w^.v);
       if compon[v] = compon[w^.v] then
             can[w^.num] := true;
       w := w^.next;
    end;
end;

procedure QSort(L, R: LongInt);
var i, j, tmp, e: LongInt;
begin
    i := L; j := R;
    e := d[(i+j) div 2];

    repeat
        while d[i] < e do inc(i);
        while e < d[j] do dec(j);
        if i <= j then begin
                          tmp := d[i]; d[i] := d[j]; d[j] := tmp;
                          tmp := posit[i]; posit[i] := posit[j]; posit[j] := tmp;
                          inc(i); dec(j);
                       end;
    until i > j;

   if i < R then QSort(i, R);
   if L < j then QSort(L, j);
end;

procedure find(v, CurTime: LongInt);
var w, next: pnode;
    left: Boolean;
begin
    w := adj[v];
    new(next);
    next^.v := 0;
    left := false;

    while w <> nil do begin
        if (not passed[w^.num]) and (CurTime <= start[w^.num]) and (start[next^.v] > start[w^.num]) then
           next := w;
        if (not passed[w^.num]) then left := true;
        w := w^.next;
    end;

    if not left then begin
                       if (StartVer = v) and (StartTime < CurTime-1440) then inc(count,2)
                                                                        else inc(count);
                       exit;
                     end;

    if next^.v = 0 then begin
                            StartTime := -1;
                            StartVer := -1;
                            inc(count);
                            find(v, 0);
                        end
                   else begin
                            if StartTime = -1 then StartTime := next^.t1;
                            if StartVer = -1 then StartVer := v;
                            passed[next^.num] := true;
                            find(next^.v, fin[next^.num]);
                        end;
end;

procedure work;
begin
    { count := 0;
     j := 0;
     Fillchar(passed, sizeof(passed), false);
     for i := 1 to N do
        if not passed[i] then dfs(i);

     Fillchar(passed, sizeof(passed), false);
     for i := N downto 1 do
        if not passed[p[i]] then dfs2(p[i]);

     Fillchar(passed, sizeof(passed), false);
     Fillchar(can, sizeof(can), false);
     for i := 1 to N do
       if not passed[i] then dfs3(i);

     for i := 1 to M do
        if not can[i] then begin
            writeln(-1);
            exit;
        end;
                 }
     for i := 1 to N do
        if deg[i] <> 0 then begin
            writeln(-1);
            exit;
        end;

    d := start;
    QSort(1, M);  //d and posit
    //posit - v kakom poradke prosmatrivat vershini

    Fillchar(passed, sizeof(passed), false);
    start[0] := 2000000000;
    count := 0;

    for i := 1 to M do begin
        j := vertex[posit[i]];
        StartTime := -1;
        StartVer := -1;
        if not passed[posit[i]] then
            find(j, 0);
    end;
    
    writeln(count);
end;

begin
    init;
    work;
    save;
end.
