#include <stdio.h>
#include <string.h>

#define MAX_T 1440
#define MAX_N 100002

typedef struct tagEDGE
{
  int a, b, st, en;
  int is;
} EDGE;

EDGE BySt[MAX_N], ByEn[MAX_N];
int Is[MAX_N], FA[MAX_N], A = 0, EN = 0;;

char * ReadNumber( char *s, int *n )
{
  *n = 0;
  while (*s != 0 && (*s < '0' || *s > '9'))
    s++;
  while (*s >= '0' && *s <= '9')
    *n = *n * 10 + (*s - '0'), s++;

  return s;
}

void QSSt( int l, int r )
{
  int i = l, j = r, x;
  static EDGE tmp;

  if (l >= r)
    return;

  x = BySt[(l + r + 1) >> 1].st;
  while (i < j)
  {
    while (BySt[i].st < x)
      i++;
    while (BySt[j].st > x)
      j--;

    if (i <= j)
    {
      if (i != j)
      {
        memcpy(&tmp, &BySt[i], sizeof(EDGE));
        memcpy(&BySt[i], &BySt[j], sizeof(EDGE));
        memcpy(&BySt[j], &tmp, sizeof(EDGE));
      }
      i++, j--;
    }
  }

  QSSt(l, j);
  QSSt(i, r);
}

void QSEn( int l, int r )
{
  int i = l, j = r, x;
  static EDGE tmp;

  if (l >= r)
    return;

  x = ByEn[(l + r + 1) >> 1].en;
  while (i < j)
  {
    while (ByEn[i].en < x)
      i++;
    while (ByEn[j].en > x)
      j--;

    if (i <= j)
    {
      if (i != j)
      {
        memcpy(&tmp, &ByEn[i], sizeof(EDGE));
        memcpy(&ByEn[i], &ByEn[j], sizeof(EDGE));
        memcpy(&ByEn[j], &tmp, sizeof(EDGE));
      }
      i++, j--;
    }
  }

  QSEn(l, j);
  QSEn(i, r);
}

int main( void )
{
  int i, j, t, h1, m1, h2, m2, N, M, a, b, pen, pst;
  char buf[1002], *s;

  freopen("buses.in", "rt", stdin);
  freopen("buses.out", "wt", stdout);

  memset(FA, 0, sizeof(FA));
  memset(Is, 0, sizeof(Is));

  gets(buf);
  sscanf(buf, "%i%i", &N, &M);

  for (i = 0; i < M; i++)
  {
    gets(buf);
    s = buf;
    s = ReadNumber(s, &a);
    s = ReadNumber(s, &h1);
    s = ReadNumber(s, &m1);
    s = ReadNumber(s, &b);
    s = ReadNumber(s, &h2);
    s = ReadNumber(s, &m2);

    BySt[EN].a = ByEn[EN].a = a - 1;
    BySt[EN].b = ByEn[EN].b = b - 1;
    BySt[EN].st = ByEn[EN].st = h1 * 60 + m1;
    BySt[EN].en = ByEn[EN].en = h2 * 60 + m2;
    BySt[EN].is = ByEn[EN].is = EN++;
  }

  QSSt(0, EN - 1);
  QSEn(0, EN - 1);

  for (pen = 0, pst = 0, t = 0; t < MAX_T; t++)
  {
    
    while (pen < EN && ByEn[pen].en < t)
      pen++;
    for (; pen < EN && ByEn[pen].en == t; pen++)
      if (Is[ByEn[pen].is])
        FA[ByEn[pen].b]++, Is[ByEn[pen].is] = 0;

    while (pst < EN && BySt[pst].st < t)
      pst++;
    for (; pst < EN && BySt[pst].st == t; pst++)
    {
      if (!FA[BySt[pst].a])
        FA[BySt[pst].a]++, A++;
      Is[BySt[pst].is] = 1, FA[BySt[pst].a]--;
    }
  }

  for (pen = 0, pst = 0, t = 0; t < MAX_T; t++)
  {
    
    while (pen < EN && ByEn[pen].en < t)
      pen++;
    for (; pen < EN && ByEn[pen].en == t; pen++)
      if (Is[ByEn[pen].is])
        FA[ByEn[pen].b]++, Is[ByEn[pen].is] = 0;

    while (pst < EN && BySt[pst].st < t)
      pst++;
    for (; pst < EN && BySt[pst].st == t; pst++)
    {
      if (!FA[BySt[pst].a])
      {
        printf("-1");
        return 0;
      }
 
      Is[BySt[pst].is] = 1, FA[BySt[pst].a]--;
    }
  }

  printf("%i", A);
  
  return 0;
}