{$APPTYPE CONSOLE}

uses
  SysUtils;

const nmax=100010;

type
  int=longint;
  bool=boolean;
  Ted=record
    st,tst,fn,tfn:int;
  end;
  pTcom=^tcom;
  Tcom=record
    v:int;
    prev,next:pTcom;
  end;
  pTg=^tg;
  Tg=record
    ed:int;
    prev,next:pTg;
  end;

var
  ccom,n,m,c:int;
  edl:array[1..nmax] of Ted;
  cg,first,ncom,st,p,rank,vin,vout:array[1..nmax] of int;
  com:array[1..nmax] of pTcom;
  gst,gin,gout:array[1..nmax] of pTg;
  used:array[1..nmax] of bool;

function findset(v:int):int;
var rt,yk,i:int;
begin
  yk:=1;
  st[1]:=v;
  while st[yk]<>p[st[yk]] do begin
    inc(yk);
    st[yk]:=p[st[yk-1]];
  end;
  rt:=st[yk];
  for i:=1 to yk do
    p[st[i]]:=rt;
  result:=rt;
end;

procedure link(x,y:int);
begin
  if rank[x]>rank[y] then
    p[y]:=x
  else begin
    p[x]:=y;
    if rank[x]=rank[y] then
      inc(rank[y]);
  end;
end;

procedure init;
var i:int;
  rt1,rt2,v1,v2:int;
  h1,h2,m1,m2:string[2];
  ch:char;
  t:pTcom;
begin
  assignfile(input,'buses.in');
  reset(input);
  readln(n,m);
  for i:=1 to n do begin
    vin[i]:=0;
    vout[i]:=0;
  end;
  for i:=1 to n do begin
    rank[i]:=0;
    p[i]:=i;
  end;
  for i:=1 to m do begin
    read(v1,ch,h1,ch,m1,ch,v2,ch,h2,ch,m2);
    rt1:=findset(v1);
    rt2:=findset(v2);
    if rt1<>rt2 then
      link(rt1,rt2);
    inc(vin[v2]);
    inc(vout[v1]);
    edl[i].st:=v1;
    edl[i].fn:=v2;
    edl[i].tst:=strtoint(h1)*60+strtoint(m1);
    edl[i].tfn:=strtoint(h2)*60+strtoint(m2);
  end;

  ccom:=0;
  for i:=1 to n do begin
    first[i]:=-1;
    rt1:=findset(i);
    if ncom[rt1]=0 then begin
      inc(ccom);
      ncom[rt1]:=ccom;
    end;
    ncom[i]:=ncom[rt1];
  end;
  for i:=1 to ccom do
    new(com[i]);
  for i:=1 to n do begin
    if first[ncom[i]]=-1 then
      first[ncom[i]]:=i;
    com[ncom[i]]^.v:=i;
    getmem(com[ncom[i]]^.next,sizeof(Tcom));
    com[ncom[i]]^.next^.prev:=com[ncom[i]];
    com[ncom[i]]:=com[ncom[i]].next;
  end;
  for i:=1 to ccom do
    while com[i]^.v<>first[i] do begin
      com[i]:=com[i].prev;
    end;

  for i:=1 to n do begin
    new(gin[i]);
    gst[i]:=gin[i];
    new(gout[i]);
    used[i]:=false;
    cg[i]:=0
  end;
  c:=0;
  closefile(input);
end;

procedure qsortst(l,r:int);
var i,j,x:int;
  te:Ted;
  ti:int;
begin
  i:=l;
  j:=r;
  x:=edl[(l+r) shr 1].tst;
  repeat
    while edl[i].tst<x do inc(i);
    while edl[j].tst>x do dec(j);
    if i<=j then begin
      te:=edl[i];
      edl[i]:=edl[j];
      edl[j]:=te;
      inc(i);
      dec(j);
    end;
  until i>j;
  if i<r then qsortst(i,r);
  if l<j then qsortst(l,j);
end;

procedure save;
begin
  assignfile(output,'buses.out');
  rewrite(output);
  if c<=m then
    write(c)
  else
    write(-1);
  closefile(output);
end;

function mint(v,tm:int):int;
var tm1:int;
  gnc:pTg;
begin
  gnc:=gin[v];
  tm1:=100000;
  repeat
    if (not used[gin[v]^.ed]) and (tm1<=edl[gin[v]^.ed].tst) then
      tm1:=edl[gin[v]^.ed].tst;
  until gnc=gin[v];
{  if not used[gin[v]^.ed] then
    result:=edl[gin[v]^.ed].tfn
  else
    result:=tm-10;}
  if tm1<>100000 then
    result:=tm1
  else
    result:=tm-10;
  gin[v]:=gnc;
end;

procedure serv(v:int);
var
  ed:Ted;
  tm,u,t:int;
  mi:bool;
begin
  dec(vin[v]);
  tm:=0;
  inc(c);
//  while mint(v,tm)>=tm do begin
    u:=v;
    repeat
      if ((edl[gin[u]^.ed].tst>tm) and (vin[edl[gin[u]^.ed].fn]=0) and (gin[u]<>gst[u]) and (not used[gin[u]^.ed])) then
        repeat
          gin[u]:=gin[u]^.next;
        until not((edl[gin[u]^.ed].tst>tm) and (vin[edl[gin[u]^.ed].fn]=0) and (gin[u]<>gst[u]) and (not used[gin[u]^.ed]));
      while (vin[edl[gin[u]^.ed].fn]=0) and not((vin[edl[gin[u]^.ed].fn]>=0) and (edl[gin[u]^.ed].fn=v) and (not used[gin[u]^.ed])) do
        gin[u]:=gin[u]^.next;
      if (tm>edl[gin[u]^.ed].tst){ and (edl[gin[u]^.ed].fn<>v) }then
        inc(c);
      tm:=edl[gin[u]^.ed].tfn;
      t:=edl[gin[u]^.ed].fn;
      used[gin[u]^.ed]:=true;
      if (u<>t) and (t<>v) then
        dec(vin[t]);
      u:=t;
    until u=v;
//  end;
end;

procedure work;
var i,j:int;
begin
  for i:=1 to n do
    if vin[i]<>vout[i] then begin
      c:=m+2;
      exit;
    end;
  qsortst(1,m);
  for i:=1 to m do begin
    gin[edl[i].st]^.ed:=i;
    getmem(gin[edl[i].st]^.next,sizeof(Tg));
    gin[edl[i].st]^.next^.prev:=gin[edl[i].st];
    gin[edl[i].st]:=gin[edl[i].st].next;
    gout[edl[i].fn]^.ed:=i;
    getmem(gout[edl[i].fn]^.next,sizeof(Tg));
    gout[edl[i].fn]^.next^.prev:=gout[edl[i].fn];
    gout[edl[i].fn]:=gout[edl[i].fn].next;
  end;
  for i:=1 to n do
    if vin[i]<>0 then begin
      gin[i]^.prev^.next:=gst[i];
      gst[i]^.prev:=gin[i]^.prev;
      gin[i]:=gst[i];
    end;
{
  for i:=1 to m do begin
    for j:=1 to vin[i] do
      gin[i]:=gin[i].prev;
    for j:=1 to vout[i] do
      gout[i]:=gout[i].prev;
  end;}
{  for i:=1 to ccom do
    repeat
      serv(com[i]^.v);
      com[i]:=com[i]^.next;
    until com[i]^.next=nil;}
  for i:=1 to m do
    if not used[i] then
      serv(edl[i].st);

end;

begin
  init;
  work;
  save;
end.
