#include <cstdio>
#include <vector>
#include <cstring>

using namespace std;

struct Route
{
	bool firstDay;
	int dest;
	int sTime;
	int fTime;

	Route(int d, int st, int ft) : dest(d), sTime(st), fTime(ft), firstDay(false)
	{}
};

enum Color
{
	WHITE = 0,
	GRAY = 1,
	BLACK = 2
};

int N, M;

const int MAX = 200000;
vector<Route> Graph[MAX];
bool visited[MAX];
Color color[MAX];
bool hasLoop;

char line[50];

int getRoute(int ind)
{
	for ( int i = 0; i < Graph[ind].size(); ++i )
		if ( !Graph[ind][i].firstDay )
			return i;
	return -1;
}

int curTime;

void DFS(int ver)
{
	if ( !hasLoop )
	{
		int route = getRoute(ver);
		color[ver] = GRAY;
		for ( int i = 0; i < Graph[ver].size(); ++i )
		{
			int adj = Graph[ver][i].dest;
			if ( color[adj] == GRAY )
			{
				if ( Graph[ver][i].sTime >= curTime )
					Graph[ver][route].firstDay = true;
				hasLoop = true;
				return;
			}
			else if ( color[adj] == WHITE )
			{
				if ( Graph[ver][i].sTime >= curTime )
					Graph[ver][route].firstDay = true;
				curTime = Graph[ver][i].fTime;
				DFS(adj);
			}
		}
		color[ver] = BLACK;
	}
}

int main()
{
	freopen("buses.in", "r", stdin);
	freopen("buses.out", "w", stdout);
	scanf("%d %d\n", &N, &M);
	for ( int i = 0; i < M; ++i ) 
	{
		int F = 0, G = 0;
		int Xh = 0, Xm = 0, Yh = 0, Ym = 0;
		gets(line);
		sscanf(line, "%d %d:%d %d %d:%d", &F, &Xh, &Xm, &G, &Yh, &Ym);
		Route r(G - 1, Xh * 60 + Xm, Yh * 60 + Ym);
		Graph[F - 1].push_back(r);
	}
	int cnt = 0;
	bool flag = true;
	while ( flag )
	{
		flag = false;
		for ( int i = 0; i < N; ++i )
		{
			int num = 0;
			if ( (num = getRoute(i)) != -1 )
			{
				++cnt;
				flag = true;
				memset(visited, 0, sizeof(visited));
				memset(color, 0, sizeof(color));
				curTime = 0;
				hasLoop = false;
				DFS(i);
				if ( !hasLoop )
				{
					puts("-1");
					return 0;
				}
			}
		}
	}
	printf("%d", cnt);
	/*for ( int i = 0; i < N; ++i )
	for ( int j = 0; j < Graph[i].size(); ++j )
	printf("Start - %d Finish - %d\n", Graph[i][j].sTime, Graph[i][j].fTime);*/
	return 0;
}