#include <fstream>
#include <deque>
#include <algorithm>
using namespace std;

ifstream I("buses.in");
ofstream O("buses.out");

struct bus_event{
	int type;//0-in 1-out
	int time;
	int city;
	bool operator <(const bus_event &a) const{
		if(city<a.city) return true;
		if(city>a.city) return false;
		if(time<a.time) return true;
		if(time>a.time) return false;
		if(type<a.type) return true;
		if(type>a.type) return false;
		return false;
	}
};

int N,M;
bus_event E[200000];
int sortE[200000];
int P[200000];
int predst[200000]={};
int C[200000];

struct Ecmp{
	bool operator ()(const int &a,const int &b){
		return E[a]<E[b];
	}
};

int get_predst(int a){
	if(P[a]==a) return a;
	int x=a;
	int i;
	for(i=0;P[x]!=x;i++,x=P[x]) C[i]=x;
	for(int j=0;j<i;j++) P[C[j]]=x;
	return x;
}

int main(){
	I>>N>>M;
	char buf[256];
	for(int i=0;i<M;i++) for(int j=1;j>=0;j--){
		P[i*2+j]=i*2+1;
		sortE[i*2+j]=i*2+j;
		E[i*2+j].type=j;
		I>>E[i*2+j].city;
		I>>buf;
		E[i*2+j].time=atoi(buf)*60+atoi(buf+3);
	}
	sort(sortE,sortE+M*2,Ecmp());
	for(int i=0;i<2*M;){
		int sum=0;
		int firstin=i;
		for(int j=i;j<2*M && E[sortE[j]].city==E[sortE[i]].city;j++){
			if(E[sortE[j]].type){
				sum--;
				if(sum>=0){
					while(E[sortE[firstin]].type) firstin++;
					if(get_predst(sortE[j])!=get_predst(sortE[firstin]))
						P[sortE[j]]=sortE[firstin];
					firstin++;
				}
			}
			else sum++;
		}
		i=j;
		if(sum!=0){
			O<<-1;
			return 0;
		}
	}
	for(int i=0;i<2*M;i++) predst[get_predst(i)]++;
	int ans=0;
	for(int i=0;i<2*M;i++) if(predst[i]) ans++;
	O<<ans;
}
