Program buses;
{$APPTYPE CONSOLE}
Const
{  InpPath='c:\work\buses_in.txt';
  OutPath='c:\work\buses_out.txt';}
  InpPath='buses.in';
  OutPath='buses.out';
Type
  A=Array[1..1000] Of Word;
Var
  Map                 :Array[1..1000, 1..1000] Of Boolean;
  N, M                :Integer;
  Come, Go            :Array[1..1000] Of A;
  LCome, LGo          :Array[1..1000] Of Integer;
  Used, Ok            :Array[1..1000] Of Boolean;

//         Word
Function Time(S:String):Word;
Var
  Code                :Integer;
  H, M                :Byte;
Begin
  If S[1]=' ' Then S:=Copy(S, 2, Length(S)-1);
  Val(Copy(S, 1, 2), H, Code);
  Val(Copy(S, 4, 2), M, Code);
  Time:=H*60+M;
End;

//   
Procedure ReadData;
Var
  InpFile             :Text;
  F, T, i, j          :Integer;
  Time1, Time2        :String[6];
  T1, T2              :Word;
  bOk                 :Boolean;
Begin
  FillChar(Map, SizeOf(Map), False);
  FillChar(LCome, SizeOf(LCome), 0);
  FillChar(LGo, SizeOf(LGo), 0);
  FillChar(Used, SizeOf(Used), False);
  FillChar(Ok, SizeOf(Ok), False);
  Assign(InpFile, InpPath);
  Reset(InpFile);
  ReadLn(InpFile, N, M);
  For i:=1 To M Do
  Begin
    ReadLn(InpFile, F, Time1, T, Time2);
    Map[F, T]:=True;
    Inc(LGo[F], 1);
    T1:=Time(Time1);
    T2:=Time(Time2);
    If T2<T1 Then
    Begin
      T2:=T2+1440;
      bOk:=True;
    End;
    Go[F, LGo[F]]:=T1;
    Inc(LCome[T], 1);
    Come[T, LCome[T]]:=T2;
  End;
  Close(InpFile);
End;

//  :)
Procedure Fill(Pos, Start:Integer);
Var
  i                   :Integer;
Begin
  If Map[Pos, Start] And (Pos<>Start) Then
  Begin
    Ok[Start]:=True;
    Exit;
  End;
  Used[Pos]:=True;
  For i:=1 To N Do
    If Map[Pos, i] And Not Used[i] And (Pos<>i) Then
    Begin
      Fill(i, Start);
      If Ok[Start] Then
      Begin
        Used[Pos]:=False;
        Exit;
      End;
    End;
  Used[Pos]:=False;
End;

Function Partition(Min, Max:Integer; Var Arr:A):Integer;
Var
 l, r              :Integer;
 X, reg            :Word;
Begin
  X:=Arr[Min];
  l:=Min-1;
  r:=Max+1;
  While True Do
  Begin
    Repeat
      l:=l+1;
    Until Arr[l]>=X;
    Repeat
      r:=r-1;
    Until Arr[r]<=X;
    If l<r Then
    Begin
      reg:=Arr[l];
      Arr[l]:=Arr[r];
      Arr[r]:=reg;
    End Else
    Begin
      Partition:=r;
      Exit;
    End;
  End;
End;

Procedure QuickSort(Min, Max:Integer; Var Arr:A);
Var
  q                 :Integer;
Begin
  If Min<Max Then
  Begin
    q:=Partition(Min, Max, Arr);
    QuickSort(Min, q, Arr);
    QuickSort(q+1, Max, Arr);
  End;
End;

Procedure WriteData(Out:Integer);
Var
  OutFile                     :Text;
Begin
  Assign(OutFile, OutPath);
  ReWrite(OutFile);
  WriteLn(OutFile, Out);
  Close(OutFile);
End;

Var
  i, x, y, z, sw              :Integer;
Begin
  ReadData;
  For i:=1 To N Do
  Begin
      Fill(i, i);//   ...
      If Not Ok[i] Then
      Begin
        WriteData(-1);
        Halt;
      End;
      QuickSort(1, LCome[i], Come[i]);
      QuickSort(1, LGo[i], Go[i]);
  End;
  sw:=0;
  For i:=1 To N Do
  Begin
    x:=1;
    y:=1;
    z:=0;
    If(Come[i, x]<=Go[i, y]) And (x<=LCome[i]) Then
    Begin
      x:=x+1;
      z:=z+1;
    End Else If(Come[i, x]>=Go[i, y]) And (y<=LGo[i]) Then
    Begin
      y:=y+1;
      z:=z-1;
      If z<0 Then
      Begin
        sw:=sw+1;
        z:=0;
      End;
    End;
  End;
  WriteData(sw);
End.
