#include <stdio.h>
#include <string.h>

#define MaxM 100010
#define MaxN 100010
#define MaxH 100010
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

int N, M, H, A[MaxM], B[MaxM], Ti[MaxM], To[MaxM], He[MaxN], Ans = 0, Co[MaxN], Ht[MaxH], Hl[MaxH], Hr[MaxH], Hc[MaxH];

void QSort(int l, int r)
{
  int i = l, j = r, x, t;
  if (l >= r)
    return;
  x = Ti[l + rand() % (r - l + 1)];
  while (i <= j)
  {
    while (Ti[i] < x) i++;
    while (Ti[j] > x) j--;
    if (i <= j)
      SWAP(Ti[i], Ti[j], t), SWAP(To[i], To[j], t), SWAP(A[i], A[j], t), SWAP(B[i], B[j], t), i++, j--;
  }
  QSort(l, j);
  QSort(i, r);
}

int HPut(int t, int T)
{
  if (t == -1)
  {
    Ht[H] = T;
    Hl[H] = -1;
    Hr[H] = -1;
    Hc[H] = 1;
    return H++;
  }
  Hc[t]++;
  if (Ht[t] >= T)
  {
    if (rand() & 1)
      Hl[t] = HPut(Hl[t], Ht[t]);
    else
      Hr[t] = HPut(Hr[t], Ht[t]);
    Ht[t] = T;
    return t;
  }
  if (rand() & 1)
    Hl[t] = HPut(Hl[t], T);
  else
    Hr[t] = HPut(Hr[t], T);
  return t;
}

int HDel(int t)
{
  if (t == -1 || (Hl[t] == -1 && Hr[t] == -1))
    return -1;
  if (Hl[t] == -1)
    return Hr[t];
  if (Hr[t] == -1)
    return Hl[t];
  Hc[t]--;
  if (Ht[Hl[t]] <= Ht[Hr[t]])
  {
    Ht[t] = Ht[Hl[t]];
    Hl[t] = HDel(Hl[t]);
  }
  else
  {
    Ht[t] = Ht[Hr[t]];
    Hr[t] = HDel(Hr[t]);
  }
  return t;
}

int main( void )
{
  int i;
  srand(30566239);
  freopen("buses.in", "rt", stdin);
  freopen("buses.out", "wt", stdout);

  scanf("%d%d", &N, &M);
  for (i = 0; i < M; i++)
  {
    int a1, b1, a2, b2;
    scanf("%d %d:%d %d %d:%d", &A[i], &a1, &b1, &B[i], &a2, &b2);
    A[i]--, B[i]--;
    Ti[i] = a1 * 60 + b1;
    To[i] = a2 * 60 + b2;
    if (To[i] < Ti[i])
      To[i] += 60 * 24;
  }
  QSort(0, M - 1);
  H = 0;
  memset(He, -1, sizeof(He));
  memset(Co, 0, sizeof(Co));
  for (i = 0; i < M; i++)
  {
    if (He[A[i]] == -1 || Ht[He[A[i]]] > Ti[i])
      Ans++;
    else
      He[A[i]] = HDel(He[A[i]]);
    Co[A[i]]--, Co[B[i]]++;
    He[B[i]] = HPut(He[B[i]], To[i]);
  }
  for (i = 0; i < N; i++)
    if (Co[i])
      Ans = -1;
  printf("%d\n", Ans);

  return 0;
}
