{$apptype console}
{$q-,r-,s-}
program p4dpr;

const maxn = 100001;

type trec = record
        a, b, t1, t2 : integer;
     end;
     tkey = record
        a, t : integer;
     end;
     pnode = ^tnode;
     tnode = record
        x : tkey;
        y : integer;
        l, r : pnode;
     end;

var r : array [1..maxn] of trec;
    i, n, m : integer;
    c       : char;
    tree    : pnode;
    bus, tb : tkey;
    nb      : integer;

procedure Sort(le, ri : integer);
var i, j : integer;
    x, y : trec;
begin
   i := le; j := ri; x := r[le+random(ri-le+1)];
   repeat
      while (r[i].t1 < x.t1) do inc(i);
      while (r[j].t1 > x.t1) do dec(j);
      if i <= j then begin
         y := r[i]; r[i] := r[j]; r[j] := y;
         inc(i); dec(j);
      end;
   until i > j;
   if i < ri then Sort(i, ri);
   if j > le then Sort(le, j);
end;

function less(x1, x2 : tkey) : boolean;
begin
   less := (x1.a < x2.a) or ((x1.a = x2.a) and (x1.t < x2.t));
end;

function find(x : tkey; a : pnode) : tkey;
begin
   if a = nil then begin
      result.a := -1; exit;
   end;
   if (a^.x.t <= x.t) and (x.a = a^.x.a) then
      find := a^.x
   else
      if less(x, a^.x) then find := find(x, a^.l)
         else find := find(x, a^.r);
end;

function merge(a, b : pnode) : pnode;
var tmp : pnode;
begin
   if a = nil then merge := b
    else if b = nil then merge := a
     else
        if a^.y > b^.y then begin
           tmp := a; tmp^.r := merge(a^.r, b); merge := tmp;
        end else begin
           tmp := b; tmp^.l := merge(a, b^.l); merge := tmp;
        end;
end;

procedure delete(x : tkey; var a : pnode);
var tmp : pnode;
begin
   if (x.a = a^.x.a) and (x.t = a^.x.t) then begin
      tmp := a;
      a   := merge(a^.l, a^.r);
      dispose(tmp);
   end else
      if less(x, a^.x) then delete(x, a^.l) else delete(x, a^.r);
end;

procedure split(a : pnode; x : tkey; var b, c : pnode);
begin
   if a = nil then begin
      b := nil; c := nil; exit;
   end;
   if less(x, a^.x) then begin
      split(a^.l, x, b, a^.l); c := a;
   end else begin
      split(a^.r, x, a^.r, c); b := a;
   end;
end;

procedure add(x : tkey; y : integer; var a : pnode);
var tmp : pnode;
begin
   if a = nil then begin
      new(a); a^.l := nil; a^.r := nil; a^.x := x; a^.y := y; exit;
   end;
   if a^.y < y then begin
      new(tmp); tmp^.x := x; tmp^.y := y;
      split(a, x, tmp^.l, tmp^.r);
      a := tmp;
   end else
      if less(x, a^.x) then Add(x, y, a^.l) else Add(x, y, a^.r);
end;

procedure print(a : pnode);
begin
   if a = nil then exit;
   write('('); print(a^.l); write(')');
   write('[', a^.x.a, ' ', a^.x.t div 60, ':', a^.x.t mod 60, ']');
   write('('); print(a^.r); write(')');
end;

function readt : integer;
var ans : integer;
begin
   read(c); ans := 0;
   read(c); ans := ord(c)-ord('0');
   read(c); ans := 10*ans+ord(c)-ord('0');
   read(c); ans := ans*60;
   read(c); ans := ans+10*(ord(c)-ord('0'));
   read(c); ans := ans+ord(c)-ord('0');
   readt := ans;
end;

begin
   randomize;

   reset(Input, 'buses.in');
   rewrite(Output, 'buses.out');

   readln(n, m);
   for i := 1 to m do begin
      read(r[i].a);
      r[i].t1 := readt;
      read(r[i].b);
      r[i].t2 := readt;
      if r[i].t2 < r[i].t1 then r[i].t2 := r[i].t2+24*60;
      readln;
   end;

   Sort(1, m);
   tree := nil; nb := 0;
   for i := 1 to m do begin
      tb.a := r[i].a; tb.t := r[i].t1;
      bus := find(tb, tree);
      if bus.a <> tb.a then begin
         inc(nb);
      end else delete(bus, tree);
      bus.a := r[i].b; bus.t := r[i].t2;
      add(bus, random(1000000), tree);
   end;
   for i := 1 to m do begin
      tb.a := r[i].a; tb.t := r[i].t1+24*60;
      bus := find(tb, tree);
      if bus.a <> tb.a then begin
         nb := -1; break;
      end else delete(bus, tree);
      bus.a := r[i].b; bus.t := r[i].t2+24*60;
      add(bus, random(1000000), tree);
   end;
   writeln(nb);
   
   close(Input);
   close(Output);
end.