program Avtobusy;

{$APPTYPE CONSOLE}


uses
  SysUtils;

const
 InFile  = 'buses.in';
 OutFile = 'buses.out';
 o0      = ord('0');
 MaxN    = 100000;
 MaxM    = 100000;

type
 TPole = record
          kud,vot,vpr: integer;
 end;

var
 n,m,otv,kot              : integer;
 st,skk,skl               : array [1..MaxN] of integer;
 por,vr,nom               : array [1..MaxM] of integer;
 spis                     : array [1..MaxN] of array of TPole;


procedure AA;
begin
 assign(input,InFile);
 reset(input);
 assign(output,outFile);
 rewrite(output);
end;

procedure CA;
var
 i      : integer;
begin
 close(input);
 close(output);
end;

procedure Vihodi;
begin
 write(-1);
 CA;
 Halt;
end;

function Norm(v1,v2,v3,v4: char): integer;
var
 cv1,cv2,cv3,cv4    : integer;
begin
 cv1 := ord(v1)-o0;
 cv2 := ord(v2)-o0;
 cv3 := ord(v3)-o0;
 cv4 := ord(v4)-o0;
 cv1 := cv1*10+cv2;
 cv3 := cv3*10+cv4;
 result := cv1*60+cv3;
end;

procedure QSort(lo,hi: integer);
var
 t        : TPole;
 x,i,j    : integer;

begin
 x := (spis[kot,(lo+hi)div 2].vot+spis[kot,lo].vot+spis[kot,hi].vot) div 3;
 i := lo; j := hi;
 repeat
  while spis[kot,i].vot<x do Inc(i);
  while x<spis[kot,j].vot do Dec(j);
  if i<=j then begin
   t := spis[kot,i];
   spis[kot,i] := spis[kot,j];
   spis[kot,j] := t;
   Inc(i); Dec(j);
  end;
 until i>j;
 if lo<j then QSort(lo,j);
 if j+1<hi then QSort(j+1,hi);
end;

procedure Swap(var a,b: integer);
var
 t        : integer;
begin
 t := a;
 a := b;
 b := t;
end;

procedure QSort2(lo,hi: integer);
var
 t        : integer;
 x,i,j    : integer;

begin
 x := (vr[(lo+hi)div 2]+vr[lo]+vr[hi]) div 3;
 i := lo; j := hi;
 repeat
  while vr[i]<x do Inc(i);
  while x<vr[j] do Dec(j);
  if i<=j then begin
   Swap(por[i],por[j]);
   Swap(vr[i],vr[j]);
   Swap(nom[i],nom[j]);
   Inc(i); Dec(j);
  end;
 until i>j;
 if lo<j then QSort2(lo,j);
 if j+1<hi then QSort2(j+1,hi);
end;

procedure ReadData;
var
 i,c1,c2,vo,vp            : integer;
 ch,v1,v2,v3,v4           : char;

begin
 read(n,m);
 for i:= 1 to n do begin
  st[i] := 0;
  SetLength(spis[i],1);
  skl[i] := 0;
  skk[i] := 1;
 end;

 for i:= 1 to m do begin
  read(c1);
  Inc(skl[c1]);
  SetLength(spis[c1],skl[c1]+1);

  read(ch); read(v1,v2);
  read(ch); read(v3,v4); read(ch);
  spis[c1,skl[c1]].vot := Norm(v1,v2,v3,v4);
  Inc(st[c1]);
  read(c2);
  spis[c1,skl[c1]].kud := c2;
  read(ch); read(v1,v2);
  read(ch); read(v3,v4);
  spis[c1,skl[c1]].vpr := Norm(v1,v2,v3,v4);
  Dec(st[c2]);
 end;

 for i:= 1 to n do
  if st[i]<>0 then
   Vihodi;
end;

procedure Init;
var
 i,j,sch          : integer;
begin
 for i:= 1 to n do begin
  kot := i;
  QSort(1,skl[kot]);
 end;
 sch := 0;
 for i := 1 to n do
  for j := 1 to skl[i] do begin
   Inc(sch);
   por[sch] := i;
   vr[sch] := spis[i,j].vot;
   nom[sch] := j;
  end;
 QSort2(1,m);
end;

function Idi(i : integer): integer;
var
 den,nach,kon,j,sk,l       : integer;
begin
 sk := skk[i];
 nach := spis[i,sk].vot;
 kon := spis[i,sk].vpr;
 j := spis[i,sk].kud;
 if nach>kon then
  den := 2
 else
  den := 1;
 Inc(skk[i]);
 repeat
  sk := skk[j];
  if kon>spis[j,sk].vot then begin
   Inc(den);
   kon := spis[j,sk].vot;
  end;
  if kon>spis[j,sk].vpr then
   Inc(den);
  kon := spis[j,sk].vpr;
  l := j;
  j := spis[j,sk].kud;
  Inc(skk[l]);
 until (skk[i]>skl[i]) and (j=i);
 if kon<=nach then Dec(den);
 result := den;
end;

procedure Solve;
var
 i            : integer;
begin
 otv := 0;
 for i := 1 to m do
  if (skk[por[i]]<=skl[por[i]]) and
     (skk[por[i]]<=nom[por[i]]) then
   otv := otv + Idi(por[i]);
end;

procedure WriteData;
begin
 write(otv);
end;

begin
 AA;
 ReadData;
 Init;
 Solve;
 WriteData;
 CA;
end.
