#include <stdio.h>
#include <algorithm>

#define TIMES 5
#define NUM 100000

struct Root {
	int from, to;
	int begin, end;
};

struct Event {
	int ind;
	int time;
	bool open;
};

int n, m;
Root arr[NUM];
Event evs[2*NUM*TIMES];
int adr[2*NUM*TIMES];

int init[NUM];
int ost[NUM];

bool inf;
int ans;

bool cmpEvents(int a, int b) {
	if (evs[a].time == evs[b].time) {
		if (evs[a].open == evs[b].open)
			return (evs[a].ind < evs[b].ind);
		return (evs[a].open < evs[b].open);
	}
	return (evs[a].time < evs[b].time);
}

int main(int argc, char **argv) {
	freopen("buses.in", "r", stdin);
//	freopen("buses.out", "w", stdout);
	int i, j;
	scanf("%d%d", &n, &m);
	for (i = 0; i<m; i++) {
		int b1, b2, e1, e2;
		scanf("%d %d:%d %d %d:%d", &arr[i].from, &b1, &b2
								 , &arr[i].to, &e1, &e2);
		arr[i].from--;
		arr[i].to--;
		arr[i].begin = b1*60 + b2;
		arr[i].end = e1*60 + e2;
		if (arr[i].end < arr[i].begin)
			arr[i].end += 24*60;

		for (j = 0; j<TIMES; j++) {
			evs[2*TIMES*i + 2*j].ind = i;
			evs[2*TIMES*i + 2*j].time = arr[i].begin + j*24*60;
			evs[2*TIMES*i + 2*j].open = true;
			evs[2*TIMES*i + 2*j+1].ind = i;
			evs[2*TIMES*i + 2*j+1].time = arr[i].end + j*24*60;
			evs[2*TIMES*i + 2*j+1].open = false;
		}
	}
	for (i = 0; i<2*TIMES*m; i++)
		adr[i] = i;
	std::sort(adr, adr+2*TIMES*m, cmpEvents);
	int dcnt = 0;
	int maxcnt = 0;
	bool change = false;
	for (j = 0; j<TIMES; j++) {
		change = false;
		for (i = j*2*m; i<(j+1)*2*m; i++) {
			if (evs[adr[i]].open) {
				int cfr = arr[evs[adr[i]].ind].from;
				if (ost[cfr] == 0) {
					ost[cfr]++;
					init[cfr]++;
					change = true;
				}
				ost[cfr]--;
			}
			else {
				int cto = arr[evs[adr[i]].ind].to;
				ost[cto]++;
			}
		}
		if (change) {
			dcnt++;
			maxcnt = dcnt;
		}
	}
	if (maxcnt>2)
		printf("-1");
	else {
		for (i = 0; i<n; i++)
			ans += init[i];
		printf("%d", ans);
	}
	return 0;
}