#include <iostream>
#include <set>
#include <cstdlib>
#include <algorithm>

#define E 90001
#define S 1440

using namespace std;


struct edge{long tbe; long ten; long vbe; long ven;} e[E + 1];
struct ps{long pas;};
bool operator <(const edge &a, const edge &b)
{
	return (a.tbe < b.tbe);
}
bool operator < (const ps &a, const ps &b)
{
	return (e[a.pas].tbe < e[b.pas].tbe);
}
set<ps> adj[E + 1];
long e_num;
long v_num;
long po[E + 1];
long ban[E + 1];

char sr[12];
long flag;
long ans = 0;
//------------------------------------------------------------------------------------------------------------------
long read_time()
{
	scanf("%s", &sr);
	return ((60*atol(&sr[0])) + (atol(&sr[3])));
}
//------------------------------------------------------------------------------------------------------------------
void initialization()
{
	long y;
	memset(po, 0, sizeof(po));
	memset(ban, 0, sizeof(ban));
	cin >> v_num >> e_num;
	for(y = 1; y <= e_num; y++)
	{
		cin >> e[y].vbe;
		e[y].tbe = read_time();
		cin >> e[y].ven;
		e[y].ten = read_time();
	}
	sort(&e[1], &e[e_num + 1]);
	for(y = 1; y <= e_num; y++)
	{
		po[e[y].vbe]++;
		po[e[y].ven]--;
	}
	flag = 1;
	for(y = 1; y <= v_num; y++)
	{
		if (po[y] != 0) {flag = 0; break;}
	}
	if (flag == 0) {cout << "-1\n";}
}
//------------------------------------------------------------------------------------------------------------------
void print_edges()
{
	long y;
	for(y = 1; y <= e_num; y++)
	{
		cout << e[y].vbe << " " << e[y].tbe << " " << e[y].ven << " " << e[y].ten << "\n";
	}
}
//------------------------------------------------------------------------------------------------------------------
void build_graph()
{
	ps jo;
	long y;
	for(y = 1; y <= e_num; y++)
	{
		jo.pas = y;
		adj[e[y].vbe].insert(jo);
	}
}
//------------------------------------------------------------------------------------------------------------------
long way_len(edge &arg)
{
	if (arg.ten > arg.tbe) {return (arg.ten - arg.tbe);} else {return (S - arg.tbe + arg.ten);}
}
//------------------------------------------------------------------------------------------------------------------
void update(long &arg)
{
	arg = (((arg / S) + 1) * S);
}
//------------------------------------------------------------------------------------------------------------------
long delta(long a, long b)
{
	long jo;
	jo = (b / S);
	if ((b % S) > a) {jo++;}
	return jo;
}
//------------------------------------------------------------------------------------------------------------------
void go_from(long be)
{
	long s_time, t, v;
	long s_vert;
	ps hu;
	s_vert = be;
	long p;
	set<ps>::iterator i;
	p = adj[be].begin()->pas;
	ban[p] = 1;
	adj[be].erase(adj[be].begin());
	be = e[p].ven;
	s_time = e[p].tbe;
	t = e[p].ten;
	for(;;)
	{
		if (adj[be].empty()) 
		{
			ans += delta(s_time, t);
			return;
		}
		else
		{
			e[E].tbe = (t % S);
			hu.pas = E;
			i = adj[be].lower_bound(hu);
			if (i == adj[be].end()) {i = adj[be].begin();}
			// i means earlest edge bow
			p = (i->pas);
			if (e[p].tbe < (t % S))
			{
				update(t);
				t += (e[p].tbe);
			}
			else
			{
				t += (e[p].tbe - (t % S));
			}
			t += way_len(e[p]);
			ban[p] = 1;
			v = (e[p].ven);
			adj[be].erase(i);
			be = v;
		}
	}
	
}
//------------------------------------------------------------------------------------------------------------------
void logic()
{
	long y;
	initialization();
	//print_edges();
	if (flag == 1)
	{
		build_graph();
		for(y = 1; y <= e_num; y++)
		{
			if (ban[y] == 0)
			{
				go_from(e[y].vbe);
			}
		}
		cout << ans;
	}
}
//------------------------------------------------------------------------------------------------------------------
int main()
{
	freopen("buses.in", "r", stdin);
	freopen("buses.out", "w", stdout);
	logic();
	return 0;
}