#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <vector>
using namespace std;

#define inpfile "poly.in"
#define outfile "poly.out"

const int NMAX = 305;

struct COORD {
	int x,y;

	COORD(int ix=0, int iy=0) {x=ix; y=iy;};
};

//Global variables
vector<COORD> a,c;
bool b[NMAX][NMAX];
int h1,w1,h2,w2;
int k;
int res;
//----------------

void Init()
{
	freopen(inpfile,"r",stdin);
	freopen(outfile,"w",stdout);
}

void Out()
{
	printf("%d\n",res);
	exit(0);
}

void Inp()
{
	int i,j;
	char ch;

	scanf("%d",&k);

	scanf("%d %d\n",&h1,&w1);
	for (i=1; i<=h1; i++) {
		for (j=1; j<=w1; j++) {
			scanf("%c",&ch);
			if (ch == 'X') 
				a.push_back(COORD(i,j));
		}
		scanf("\n");
	}

	scanf("%d %d\n",&h2,&w2);
	for (i=1; i<=h2; i++) {
		for (j=1; j<=w2; j++) {
			scanf("%c",&ch);
			if (ch == 'X') {
				b[i][j]=true;
				c.push_back(COORD(i,j));
			}
		}
		scanf("\n");
	}

	h2*=k; w2*=k;
}

bool Good(int x, int y)
{
	if (y<0) return false;
	return b[(x+k-1)/k][(y+k-1)/k];
}

void Solve()
{
	int i,j,x,y;
	int x0,y0;
	bool ok;

	for (i=1; i<a.size(); i++) {
		a[i].x-=a[0].x;
		a[i].y-=a[0].y;
	}

	h1-=a[0].x;
	w1-=a[0].y;

	res=0;
	for (i=0; i<c.size(); i++) {
		x0=(c[i].x - 1)*k;
		y0=(c[i].y - 1)*k;
		for (x=1; x<=k; x++) if (x0+x+h1<=h2)
			for (y=1; y<=k; y++) if (y0+y+w1<=w2) {
				ok=true;
				for (j=a.size()-1; j>0; j--)
					if (!Good(x0+x+a[j].x,y0+y+a[j].y)) {
						ok=false;
						break;
					}

				if (ok) res++;
			}
	}
}

int main()
{
	Init();
	Inp();
	Solve();
	Out();
	return 0;
}
