#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define inpfile "poly.in"
#define outfile "poly.out"

const int NMAX = 305;

struct COORD {
	int x,y;
};

COORD a[NMAX], b[NMAX], c[NMAX];
bool poly[NMAX][NMAX];
int u[NMAX][NMAX];
int h1,w1,h2,w2;
int m,n,k;
int cn;
int res = 0;

void Init()
{
	freopen(inpfile,"r",stdin);
	freopen(outfile,"w",stdout);
	memset(poly,0,sizeof(poly));
	memset(u,0,sizeof(u));
}

void Out()
{
	printf("%d\n",res);
	exit(0);
}

void Inp()
{
	int i,j;
	char ch;

	m = 0; n = 0;

	scanf("%d",&k);
	scanf("%d %d\n",&h1,&w1);
	for (i = 1; i <= h1; i++) {
		for (j = 1; j <= w1; j++) {
			scanf("%c",&ch);
			if (ch == 'X') {
				m++;
				a[m].x = i;
				a[m].y = j;
			}
		}
		scanf("\n");
	}

	scanf("%d %d\n",&h2,&w2);
	for (i = 1; i <= h2; i++) {
		for (j = 1; j <= w2; j++) {
			scanf("%c",&ch);
			if (ch == 'X') {
				poly[i][j] = true;
				n++;
				b[n].x = i;
				b[n].y = j;
			}
		}
		scanf("\n");
	}
}

void Solution1()
{
	int x0,y0;
	int x,y;
	int i,j;
	int col=0;
	bool ok;

	for (x0 = 1; x0 <= k; x0++)
		for (y0 = 1; y0 <= k; y0++) {
			cn = 0; col++;
			for (i = 1; i <= m; i++) {
				x = (x0 + a[i].x + k - 1) / k;
				y = (y0 + a[i].y + k - 1) / k;

				if (u[x][y] != col) {
					u[x][y] = col;
					cn++;
					c[cn].x = x;
					c[cn].y = y;
				}
			}

			for (i = 1; i <= n; i++) {
				ok = true;
				for (j = 1; j <= cn; j++) {
					x = b[i].x + c[j].x - c[1].x;
					y = b[i].y + c[j].y - c[1].y;

					if ((x <= 0) || (y <= 0) || (!poly[x][y])) {
						ok = false;
						break;
					}
				}

				if (ok) res++;
			}
		}
}

void Solve()
{
	Solution1();
}

int main()
{
	Init();
	Inp();
	Solve();
	Out();
	return 0;
}
