#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define inpfile "poly.in"
#define outfile "poly.out"

const int NMAX = 305;

struct COORD {
	int x,y;
};

COORD a[NMAX], b[NMAX], c[NMAX];
bool poly[NMAX][NMAX];
int u[NMAX][NMAX];
int h1,w1,h2,w2;
int m,n,k;
int cn;
__int64 res = 0;

void Init()
{
	freopen(inpfile,"r",stdin);
	freopen(outfile,"w",stdout);
	memset(poly,0,sizeof(poly[0][0])*NMAX*NMAX);
	memset(u,0,sizeof(u[0][0])*NMAX*NMAX);
}

void Out()
{
	printf("%I64d\n",res);
	exit(0);
}

void Inp()
{
	int i,j;
	char ch;

	m = 0; n = 0;

	scanf("%d",&k);
	scanf("%d %d\n",&h1,&w1);
	for (i = 1; i <= h1; i++) {
		for (j = 1; j <= w1; j++) {
			scanf("%c",&ch);
			if (ch == 'X') {
				m++;
				a[m].x = i;
				a[m].y = j;
			}
		}
		scanf("\n");
	}

	scanf("%d %d\n",&h2,&w2);
	for (i = 1; i <= h2; i++) {
		for (j = 1; j <= w2; j++) {
			scanf("%c",&ch);
			if (ch == 'X') {
				poly[i][j] = true;
				n++;
				b[n].x = i;
				b[n].y = j;
			}
		}
		scanf("\n");
	}
}

void Solution1()
{
	int x0,y0;
	int x,y;
	int i,j;
	int col=0;
	bool ok;

	for (x0 = 1; x0 <= k; x0++)
		for (y0 = 1; y0 <= k; y0++) {
			cn = 0; col++;
			for (i = 1; i <= m; i++) {
				x = (x0 + a[i].x + k - 1) / k;
				y = (y0 + a[i].y + k - 1) / k;

				if (u[x][y] != col) {
					u[x][y] = col;
					cn++;
					c[cn].x = x;
					c[cn].y = y;
				}
			}

			for (i = 1; i <= n; i++) {
				ok = true;
				for (j = 1; j <= cn; j++) {
					x = b[i].x + c[j].x - c[1].x;
					y = b[i].y + c[j].y - c[1].y;

					if ((x <= 0) || (y <= 0) || (!poly[x][y])) {
						ok = false;
						break;
					}
				}

				if (ok) res++;
			}
		}
}

const int COMB_MAX = 10;

int NumByComb(bool b1, bool b2, bool b3, bool b4)
{
	if (b1) {
		if (b2) {
			if (b3) {
				if (b4) return 8;
				else return 4;
			} else {
				if (b4) return 6;
				else return 2;
			}
		} else {
			if (b3) {
				if (b4) return 5;
				else return 3;
			} else return 1;
		}
	} else {
		if (b2 && b3 && b4) return 7;
	}
	return 0;
}

void Solution2()
{
	__int64 kol[COMB_MAX];
	int x0,y0;
	bool bol[3][3];
	int i;
	int x,y;

	memset(kol,0,sizeof(kol[0])*COMB_MAX);

	kol[1] = (k - h1 + 1) * (k - w1 + 1);
	kol[2] = (k - h1 + 1) * (w1 - 1);
	kol[3] = (h1 - 1) * (k - w1 + 1);
	for (x0 = k - h1 + 2; x0 <= k; x0++)
		for (y0 = k - w1 + 2; y0 <= k; y0++) {
			memset(bol,0,sizeof(bol[0][0])*3*3);
			for (i = 1; i <= m; i++) {
				x = (x0 + a[i].x - 1 + k - 1) / k;
				y = (y0 + a[i].y - 1 + k - 1) / k;
				bol[x][y] = true;
			}

			kol[NumByComb(bol[1][1], bol[1][2], bol[2][1], bol[2][2])]++;
		}

	kol[8] += kol[7] + kol[6] + kol[5] + kol[4] + kol[3] + kol[2] + kol[1];
	kol[6] += kol[2] + kol[1];
	kol[5] += kol[3] + kol[1];
	kol[4] += kol[3] + kol[2] + kol[1];
	kol[3] += kol[1];
	kol[2] += kol[1];
	kol[0] = 0;

	for (x0 = 1; x0 <= h2; x0++)
		for (y0 = 1; y0 <= w2; y0++)
			res+=kol[NumByComb(poly[x0][y0], poly[x0][y0 + 1], poly[x0 + 1][y0], poly[x0 + 1][y0 + 1])];
	res++;
}

void Solve()
{
	if ((w1 > k) || (h1 > k)) Solution1();
	else Solution2();
}

int main()
{
	Init();
	Inp();
	Solve();
	Out();
	return 0;
}
