#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <vector>
#include <map>

using namespace std;

#define FILE_IN "poly.in"
#define FILE_OUT "poly.out"
const int MAXN = 302;
const int MAXK = 10000;

int k;
int th,tw,eh,ew;
int t[MAXN][MAXN];
int ex[MAXN][MAXN];
int sum[MAXN][MAXN];
int ans;

struct Point {
	int x,y;
};

int operator<(const Point &p1,const Point &p2){
	if (p1.x<p2.x) return 1;
	if (p1.x==p2.x)	
		if (p1.y<p2.y) return 1;
	return 0;
}

map<vector<Point>,int> c;

            
void OpenFiles() {
	freopen(FILE_IN,"r",stdin);
	freopen(FILE_OUT,"w",stdout);
}

void CloseFiles() {
	fclose(stdout);
}

void Initialize(){
	memset(t, 0 ,sizeof(t));	
	memset(sum, 0 ,sizeof(sum));
}

void ReadChar(int & ci) {
	char ch;
	assert(scanf("%c",&ch)==1);
	if (ch=='X') ci = 1;
	else {
		assert(ch =='.');
		ci = 0;
	}
}

void ReadData() {
	assert(scanf("%d",&k)==1);
	assert(k>0);
	assert(k<=MAXK);
	assert(scanf("%d %d",&th,&tw)==2);
	int i,j;
	for (i=0;i<th;i++) {
		scanf("\n");
		for (j=0;j<tw;j++) ReadChar(t[i][j]);
	}
	
	assert(scanf("%d %d",&eh,&ew)==2);
	for (i=0;i<eh;i++) {
		scanf("\n");
		for (j=0;j<ew;j++) ReadChar(ex[i][j]);			
	}
}

void Solve() {
	// sum-table
	int i,j;
	for (i=th-1;i>=0;i--)
		for (j=tw-1;j>=0;j--)
			sum[i][j] = sum[i+1][j]+sum[i][j+1]-sum[i+1][j+1]+t[i][j];
	//

	Point po;
	int q,p;
	int t,x1,y1,x2,y2;
	vector<Point> v;
	for (i=0;i<k;i++) 
    	for (j=0;j<k;j++) {
    		v.clear();
    		for (q=0;q-i<th;q+=k)
    			for (p=0;p-j<tw;p+=k) {
    				x1 = q-i;
    				y1 = p-j;
    				x2 = x1+k;
    				y2 = y1+k;
    				if (x1<0) x1 = 0;
    				if (y1<0) y1 = 0;
    				//if (x2>=th) x2 = th;
    				//if (y2>=th) y2 = tw;
    				t = sum[x1][y1];//-sum[x1][y2]-sum[x2][y1]+sum[x2][y2];
					if (x2<th) t-=sum[x2][y1];
					if (y2<tw) t-=sum[x1][y2];
					if (x2<th && y2<tw) t+=sum[x2][y2];

    				if (t>0) {    					
    					po.x = q/k;
    					po.y = p/k;
    					v.push_back(po);
    				}
    			}
    		c[v]++;
    	}	

    vector<Point> pp;
    vector<Point> :: iterator jj;
	map<vector<Point>,int>:: iterator ii;
	ii = c.begin();
	int fl;
	int si = c.size();
	ans = 0;
	while (ii!=c.end()) {
		for (i=0;i<eh;i++)
			for (j=0;j<ew;j++) {
				fl = 1;
				pp = ii->first;
				jj = pp.begin();
				while (jj!=pp.end()) {
					if (i+jj->x<eh && j+jj->y<ew) {
						if (!ex[i+jj->x][j+jj->y]) {
                        	fl = 0;
                        	break;
						}
					} else {
						fl = 0;
						break;
					}
					jj++;
				}
				if (fl) {
					ans+=ii->second;
				}
			}
		ii++;
	}

}

void OutData() {
	printf("%d",ans);
}

int main(int argc, char * arg[]) {
	OpenFiles();
    Initialize();
    ReadData();
   	Solve();
   	OutData();
    CloseFiles();
    return 0;	
}