{$q-,r-}
uses
    math, sysutils;

const
    max_s = 300;

type
    tpoly = record
        w, h: longint;
        f: array [1..max_s, 1..max_s] of boolean;
        c: longint;
        x, y: array [1..max_s] of longint;
    end;

procedure readPoly(var p: tpoly);
var
    i, j: longint;
    ch: char;
begin
    for i := 1 to p.c do begin
        p.f[p.x[i]][p.y[i]] := false;
    end;
    p.c := 0;
    p.w := 0;
    p.h := 0;
    with p do begin
        read(h, w);
        for i := 1 to h do begin
            if seekeof then;
            for j := 1 to w do begin
                read(ch);
                if ch = 'X' then begin
                    f[i][j] := true;
                    inc(c);
                    x[c] := j;
                    y[c] := i;
                end;
            end;
        end;
    end;
end;

var
    k: longint;

procedure pattern(var p, t: tpoly; dx, dy: longint);
var
    i: longint;
    x, y: longint;
begin
    fillchar(t, sizeof(t), 0);
    for i := 1 to p.c do begin
        x := (p.x[i] + dx + k - 2) div k;
        y := (p.y[i] + dy + k - 2) div k;
        if not t.f[y][x] then begin
            t.f[y][x] := true;
            inc(t.c);
            t.x[t.c] := x;
            t.y[t.c] := y;
            t.w := max(t.w, x);
            t.h := max(t.h, y);
        end;
    end;
end;

function countMatches(var p, t: tpoly): int64;
var
    i, j: longint;
    x, y: longint;
    f: boolean;
    r: int64;
begin
    r := 0;
    for i := 1 to p.c do begin
        f := true;
        for j := 1 to t.c do begin
            x := p.x[i] + t.x[j] - t.x[1];
            y := p.y[i] + t.y[j] - t.y[1];
            f := f and (0 < x) and (x <= p.w) and (0 < y) and (y <= p.h) and p.f[y][x];
        end;
        if f then begin
            inc(r);
        end;
    end;
    countMatches := r;
end;

procedure o(var p: tpoly);
var
    i, j: longint;
begin
    with p do begin
        for i := 1 to h do begin
            for j := 1 to w do begin
                if p.f[i][j] then write('X') else write('.');
            end;
            writeln;
        end;
        writeln;
    end;
end;

function rect(w1, h1, w2, h2: longint): longint;
begin
    rect := (w1 - w2 + 1) * (h1 - h2 + 1);
end;

var
    p1, p2, t: tpoly;
    dx, dy: longint;
    c: array [1..15] of int64;
    q: longint;
    ans: int64;
begin
    assign(input, 'poly.in'); reset(input);
    assign(output, 'poly.out'); rewrite(output);

    read(k);
    readPoly(p1);
    readPoly(p2);

    ans := 0;
    if (p1.w <= k) and (p1.h <= k) then begin
        fillchar(c, sizeof(c), -1);
        pattern(p1, t, 1, 1);
        ans := ans + countMatches(p2, t) * rect(k, k, p1.w, p1.h);
        pattern(p1, t, k - p1.w + 2, 1);
        ans := ans + countMatches(p2, t) * (rect(k + p1.w - 1, k, p1.w, p1.h) - rect(k, k, p1.w, p1.h));
        pattern(p1, t, 1, k - p1.h + 2);
        ans := ans + countMatches(p2, t) * (rect(k, k + p1.h - 1, p1.w, p1.h) - rect(k, k, p1.w, p1.h));
        for dx := k - p1.w + 2 to k do begin
            for dy := k - p1.h + 2 to k do begin
                pattern(p1, t, dx, dy);
                q := 0;
                if t.f[1][1] then q := q + 8;
                if t.f[1][2] then q := q + 4;
                if t.f[2][1] then q := q + 2;
                if t.f[2][2] then q := q + 1;
                if c[q] = -1 then begin
                    c[q] := countMatches(p2, t);
                end;
                ans := ans + c[q];
             end;
        end;
    end else begin
        for dx := 1 to k do begin
            for dy := 1 to k do begin
                pattern(p1, t, dx, dy);
                ans := ans + countMatches(p2, t);
            end;
        end;
    end;

    writeln(ans);

    close(input);
    close(output);
end.
