#include <stdio.h>
#include <memory.h>

const int MAX = 300;

int Max(int x, int y)
{
	return (x > y) ? x: y;
}

int Min(int x, int y)
{
	return (x < y) ? x: y;
}

class Polymino
{
public:
	int xSize, ySize, k;
	bool cells[MAX][MAX];

	int GetArea()
	{
		int s = 0;

		for (int x = 0; x < xSize; x++)
			for (int y = 0; y < ySize; y++)
				if (cells[x][y])
					s++;

		return s*k;
	}

	bool GetCell(int x, int y)
	{
		x /= k;
		y /= k;

		if (x < 0 || x >= xSize || y < 0 || y >= ySize)
			return false;

		return cells[x][y];
	}

	static int GetIntersectionArea(Polymino p1, Polymino p2, int dx, int dy)
	{
		int s = 0;

		for (int x = 0; x < p1.xSize; x++)
			for (int y = 0; y < p1.ySize; y++)
			{
				bool c1 = p1.GetCell(x, y);
				bool c2 = p2.GetCell(x+dx, y+dy);
				if (c1 && c2)
					s++;
			}

		return s;
	}

	Polymino()
	{
		k = 0;
		xSize = 0;
		ySize = 0;
		memset(cells, 0, sizeof(cells));
	}
};

Polymino p1, p2;

bool ReadCell()
{
	char ch;

	do 
	{
		scanf("%c", &ch);
	}
	while (ch != '.' && ch != 'X');

	if (ch == '.')
		return false;
	else
		return true;
}

Polymino ReadPolymino()
{
	Polymino p;

	scanf("%d%d", &p.ySize, &p.xSize);
	for (int y = 0; y < p.ySize; y++)
		for (int x = 0; x < p.xSize; x++)
			p.cells[x][y] = ReadCell();

	return p;
}

void ReadData()
{
	int k;
	scanf("%d", &k);
	p1 = ReadPolymino();
	p1.k = 1;
	p2 = ReadPolymino();
	p2.k = k;
}

int Solve()
{
	int res = 0;
	for (int x = 0; x < p2.xSize*p2.k; x++)
		for (int y = 0; y < p2.ySize*p2.k; y++)
		{
			int s1 = p1.GetArea();
			int s = Polymino::GetIntersectionArea(p1, p2, x, y);

			if (s1 == s)
				res++;
		}
	return res;
}

void main()
{
	freopen("poly.in", "r", stdin);
	freopen("poly.out", "w", stdout);

	ReadData();
	printf("%d\n", Solve());
}