#include <iostream>
#include <utility>
#include <vector>
#include <algorithm>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define all(v) v.begin(), v.end()

typedef pair<int, int> point;
#define mp make_pair
#define pb push_back

#define x first
#define y second

#define INF (int)(1E+9)

typedef vector<point> polymino;

#define SMAX 333

long long k;

bool ex[SMAX][SMAX];

void genPattern(polymino &a, int dx, int dy, polymino &result)
{
	polymino res;
	res.reserve(a.size());
	point left = *min_element(all(a));
	forn (i, a.size())
	{
		int nx = a[i].x - left.x + dx; 
		int ny = a[i].y - left.y + dy; 
		if (ny < 0) 
			ny = -(-ny - 1) / k - 1;
		else
			ny /= k;
		nx /= k;
		res.pb(mp(nx, ny));
	}
	int minx = INF, miny = INF;
	forn (i, res.size())
	{
		minx = min(minx, res[i].x);
		miny = min(miny, res[i].y);
	}
	forn (i, res.size())
		ex[res[i].x - minx][res[i].y - miny] = true;
	result.clear();
	result.reserve(a.size());
	forn (i, res.size())
		if (ex[res[i].x - minx][res[i].y - miny])
		{
			result.pb(res[i]);
			ex[res[i].x - minx][res[i].y - miny] = false;
		}
	res.clear();
}

long long findPattern(polymino &a, polymino &b)
{
	int minx = INF, miny = INF;
	forn (i, a.size())
	{
		minx = min(minx, a[i].x);
		miny = min(miny, a[i].y);
	}
	forn (i, a.size())	
		ex[a[i].x - minx][a[i].y - miny] = true;
	long long res = 0;
	point left = *min_element(all(b));
	forn (i, a.size())
	{
		int x0 = a[i].x - minx;
		int y0 = a[i].y - miny;
		bool ok = true;
		forn (j, b.size())
		{
			int x = x0 + b[j].x - left.x;
			int y = y0 + b[j].y - left.y;
			if (x < 0 || x > SMAX - 1 || y < 0 || y > SMAX - 1)
			{
				ok = false;
				break;
			}
			if (!ex[x][y]) 
			{
				ok = false;
				break;
			}
		}
		res += (int)(ok);
	}
	forn (i, a.size())	
		ex[a[i].x - minx][a[i].y - miny] = false;
	return res;
}

void polyminoRead(polymino &r)
{
	int h, w;
	scanf("%d%d", &h, &w);
	forn (i, h)
		forn (j, w)
		{
			int c = getchar();
			while (c <= ' ') c = getchar();
			if (c == 'X') r.pb(mp(i, j));
		}
}

polymino large, small;

long long sol1()
{
	polymino pattern;
	long long ans = 0;
	forn (i, k)
		forn (j, k)
		{
			genPattern(small, i, j, pattern);
			ans += findPattern(large, pattern);
		}
	return ans;
}

void getPolymino(int ex1, int ex2, int ex3, int ex4, polymino &res)
{
	res.clear();
	if (ex1) res.pb(mp(0, 0));
	if (ex2) res.pb(mp(0, 1));
	if (ex3) res.pb(mp(1, 0));
	if (ex4) res.pb(mp(1, 1));
}

long long sol2()
{
	long long ans = 0;

	int minx = INF, miny = INF, maxx = -INF, maxy = -INF;
	forn (i, small.size())	
	{
		minx = min(minx, small[i].x);
		miny = min(miny, small[i].y);
		maxx = max(maxx, small[i].x);
		maxy = max(maxy, small[i].y);
	}
	int h = maxx - minx + 1;
	int w = maxy - miny + 1;
	long long kl[8];
	polymino pattern[8];

	pattern[0].pb(mp(0, 0));
	kl[0] = findPattern(large, pattern[0]) * (k - h + 1) * (k - w + 1);
	ans += kl[0];

	pattern[1].pb(mp(0, 0));
	pattern[1].pb(mp(0, 1));
	kl[1] = findPattern(large, pattern[1]) * (k - h + 1) * (w - 1);
	ans += kl[1];

	pattern[2].pb(mp(0, 0));
	pattern[2].pb(mp(1, 0));
	kl[2] = findPattern(large, pattern[2]) * (k - w + 1) * (h - 1);
	ans += kl[2];

	forn (i, h + 2)
		forn (j, w + 2)
		{
			int ex1, ex2, ex3, ex4;
			ex1 = ex2 = ex3 = ex4 = 0;
			forn (t, small.size())
			{
				int x = small[t].x - minx + 1;
				int y = small[t].y - miny + 1;
				if (x <= i && y <= j) ex1 = 1;
				if (x <= i && y > j) ex2 = 1;
				if (x > i && y <= j) ex3 = 1;
				if (x > i && y > j) ex4 = 1;
			}
			int kex = ex1 + ex2 + ex3 + ex4;
			if (kex < 3) continue;
			polymino cur;
			getPolymino(ex1, ex2, ex3, ex4, cur);
			ans += findPattern(large, cur);
		}
	return ans;
}

int main()
{
	freopen("poly.in", "rt", stdin);
	freopen("poly.out", "wt", stdout);
	memset(ex, false, sizeof(ex));
	cin >> k;
	polyminoRead(small);
	polyminoRead(large);
	long long ans;
	if (k < small.size()) 
		ans = sol1();
	else
		ans = sol2();
	cout << ans << endl;
	fcloseall();
	return 0;
}