#include <iostream>
#include <utility>
#include <vector>
#include <algorithm>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define all(v) v.begin(), v.end()

typedef pair<int, int> point;
#define mp make_pair
#define pb push_back

#define x first
#define y second

#define INF (int)(1E+9)

#define SMAX 10000

bool ex[SMAX][SMAX];

typedef vector<point> polymino;

long long findPattern(polymino &a, polymino &b)
{
	int minx = INF, miny = INF;
	forn (i, a.size())
	{
		minx = min(minx, a[i].x);
		miny = min(miny, a[i].y);
	}
	forn (i, a.size())	
		ex[a[i].x - minx][a[i].y - miny] = true;
	long long res = 0;
	point left = *min_element(all(b));
	forn (i, a.size())
	{
		int x0 = a[i].x - minx;
		int y0 = a[i].y - miny;
		bool ok = true;
		forn (j, b.size())
		{
			int x = x0 + b[j].x - left.x;
			int y = y0 + b[j].y - left.y;
			if (x < 0 || x > SMAX - 1 || y < 0 || y > SMAX - 1)
			{
				ok = false;
				break;
			}
			if (!ex[x][y]) 
			{
				ok = false;
				break;
			}
		}
		res += (int)(ok);
	}
	forn (i, a.size())	
		ex[a[i].x - minx][a[i].y - miny] = false;
	return res;
}

void polyminoRead(polymino &r)
{
	int h, w;
	scanf("%d%d", &h, &w);
	forn (i, h)
		forn (j, w)
		{
			int c = getchar();
			while (c <= ' ') c = getchar();
			if (c == 'X') r.pb(mp(i, j));
		}
}

void polyminoMagnify(polymino &cur, int k)
{
	polymino res;
	res.reserve(k * k * cur.size());
	forn (i, cur.size())	
		forn (x, k)
			forn (y, k)
				res.pb(mp(cur[i].x * k + x, cur[i].y * k + y));
	cur = res;
}

int main()
{
	freopen("poly.in", "rt", stdin);
	freopen("poly.out", "wt", stdout);
	int k;
	cin >> k;
	polymino small, large;
	polyminoRead(small);
	polyminoRead(large);
	polyminoMagnify(large, k);
	int ans = (int)findPattern(large, small);
	printf("%d\n", ans);
	return 0;
}