program P5;

uses
  SysUtils,Math;

type
    TSample=record
        NumPnts:Integer;
        Pnts:array[0..300,0..1] of Integer;
    end;
    TPolymino=record
        H,W:Integer;
        Cells:array[0..300,0..300] of Boolean;
    end;
var
    F:Text;
    K,N:Int64;
    XM,YM:Integer;
    OldP,NewP:TPolymino;
    Samples:array of array of TSample;

procedure ReadPoly(var Poly:TPolymino);
var
    X,Y:Integer;
    Ch:Char;
begin
    ReadLn(F,Poly.H,Poly.W);
    for Y:=0 to Poly.H-1 do
    begin
        for X:=0 to Poly.W-1 do
        begin
            Read(F,Ch);
            Poly.Cells[X,Y]:=Ch='X';
        end;
        ReadLn(F);
    end;
end;

function TestCell(XB,YB,XE,YE:Integer):Boolean;
var
    X,Y:Integer;
begin
    Result:=False;
    for Y:=YB to YE-1 do
        for X:=XB to XE-1 do
            if NewP.Cells[X,Y] then
            begin
                Result:=True;
                Exit;
            end;
end;

procedure CreateSamples;
var
    X,Y:Integer;
    XO,YO,XB,YB,XE,YE,XC,YC,XL,YL:Integer;
    UseCells:array[0..300] of array[0..300] of Boolean;
begin
    XM:=Min(K,NewP.W);
    YM:=Min(K,NewP.H);
    SetLength(Samples,XM,YM);
    for Y:=0 to YM-1 do
    begin
        if Y=0 then YO:=Y
        else YO:=Y-K;
        for X:=0 to XM-1 do
        begin
            if X=0 then XO:=X
            else XO:=X-K;
            XL:=(NewP.H div K)+1;
            YL:=(NewP.W div K)+1;
            Samples[X,Y].NumPnts:=0;
            for YC:=0 to YL do
            begin
                YB:=YC*K+YO;
                YE:=YB+K;
                if YB<0 then YB:=0;
                if YE>NewP.H then YE:=NewP.H;
                for XC:=0 to XL do
                begin
                    XB:=XC*K+XO;
                    XE:=XB+K;
                    if XB<0 then XB:=0;
                    if XE>NewP.W then XE:=NewP.W;
                    UseCells[XC,YC]:=TestCell(XB,YB,XE,YE);
                    if UseCells[XC,YC] then
                        with Samples[X,Y] do
                        begin
                            Pnts[NumPnts,0]:=XC;
                            Pnts[NumPnts,1]:=YC;
                            Inc(NumPnts);
                        end;
                end;
            end;
        end;
    end;
end;

function TestSample(XS,YS,X,Y:Integer):Boolean;
var
    I:Integer;
    XC,YC:Integer;
begin
    with Samples[XS,YS] do
        for I:=0 to NumPnts-1 do
        begin
            XC:=Pnts[I,0]+X;
            YC:=Pnts[I,1]+Y;
            if (X>=OldP.W) or (Y>=OldP.H) or
                (OldP.Cells[XC,YC]=False) then
            begin
                Result:=False;
                Exit;
            end;
        end;
    Result:=True;
end;

function FindSample(XS,YS:Integer):Integer;
var
    NS:Integer;
    X,Y:Integer;
begin
    NS:=0;
    for Y:=0 to OldP.H-1 do
        for X:=0 to OldP.W-1 do
            if TestSample(XS,YS,X,Y) then
                Inc(NS);
    Result:=NS;
end;

procedure FindMatches;
var
    X,Y,dN:Integer;
begin
    for Y:=0 to YM-1 do
        for X:=0 to XM-1 do
            Inc(N,FindSample(X,Y));
    if YM<K then
    begin
        dN:=K-YM;
        for X:=0 to XM-1 do
            Inc(N,FindSample(X,0)*dN);
    end;
    if XM<K then
    begin
        dN:=K-XM;
        for Y:=0 to YM-1 do
            Inc(N,FindSample(0,Y)*dN);
    end;
    if (YM<K) and (XM<K) then
        Inc(N,FindSample(0,0)*(K-YM)*(K-XM));
end;

begin
    AssignFile(F,'poly.in');
    Reset(F);
    ReadLn(F,K);
    ReadPoly(NewP);
    ReadPoly(OldP);
    CloseFile(F);
    CreateSamples;
    N:=0;
    FindMatches;
    AssignFile(F,'poly.out');
    Rewrite(F);
    WriteLn(F,N);
    CloseFile(F);
end.
