program poly;

{$D-,L-}
{$R-,Q-}
{$S-,I-,C-}

uses
  SysUtils;

var
  k: Integer;
  h1, w1, h2, w2: Integer;
  p1, p2: array [1..300, 1..300] of Char;
  newh, maxh, neww, maxw, obrmaxh, obrnewh: array [1..300] of Integer;
  res, full: int64;

procedure ReadFromFile;
var
  f: Text;
  i, j: Integer;
begin
  Assign(f, 'poly.in');
  Reset(f);
  Readln(f, k);
  Readln(f, h1, w1);
  
  for i := 1 to h1 do
  begin
    for j := 1 to w1 do
      Read(f, p1[i, j]);
    Readln(f);
  end;

  Readln(f, h2, w2);
  for i := 1 to h2 do
  begin
    for j := 1 to w2 do
      Read(f, p2[i, j]);
    Readln(f);
  end;

  Close(f)
end;

procedure WriteToFile;
var
  f: Text;
begin
  Assign(f, 'poly.out');
  Rewrite(f);
  Writeln(f, res);
  Close(f);
end;

function Max(a1, a2: Integer): Integer;
begin
  if a1 > a2 then
    Result := a1
  else
    Result := a2;
end;

procedure MakeH;
var
  i, j: Integer;
begin
  for j := 1 to w1 do
  begin
    i := h1;
    while p1[i, j] = '.' do
      Dec(i);
    newh[j] := i;
  end;

  for j := 1 to w1 do
  begin
    i := 1;
    while p1[i, j] = '.' do
      Inc(i);
    obrnewh[j] := i;
  end;

  maxh[1] := newh[1];
  for j := 2 to w1 do
  begin
    maxh[j] := max(maxh[j - 1], newh[j]);
  end;

  for i := 1 to h1 do
  begin
    j := w1;
    while p1[i, j] = '.' do
      Dec(j);
    neww[i] := j;
  end;

  maxw[1] := neww[1];
  for i := 2 to h1 do
  begin
    maxw[i] := max(maxw[i - 1], neww[i]);
  end;

  obrmaxh[w1] := obrnewh[w1];
  for j := w1 - 1 downto 1 do
  begin
    obrmaxh[j] := max(maxh[j + 1], obrnewh[j]);
  end;
end;

function RaspFull: Int64;
begin
  Result := (k - h1 + 1) * (k - w1 + 1);
  if result < 0 then
    result := 0;
end;

function Min(a, b: Integer): Integer;
begin
  if a < b then
    Result := a
  else
    Result := b;
end;

function RaspChast(y, x: Integer): Int64;
var
  i, j, m, m1, m2: Integer;
begin
  Result := 0;

  i := y;
  m := 0;
  while (i < h2) and (p2[i + 1, x] = 'X') do
  begin
    Inc(i);
    Inc(m, k);
    if m > 300 then
      break;
  end;

  i := maxh[w1] - 1;
  if i > m then
    i := m;

  if i * (k - w1 + 1) > 0 then
    result := result + i * (k - w1 + 1);

  j := x;
  m := 0;
  while (j < w2) and (p2[y, j + 1] = 'X') do
  begin
    Inc(j);
    Inc(m, k);
    if m > 300 then
      break;
  end;

  j := maxw[h1] - 1;
  if j > m then
    j := m;

  if j * (k - h1 + 1) > 0 then
    result := result + j * (k - h1 + 1);

  m1 := 0;
  i := y;
  while (i < h2) and (p2[i + 1, x] = 'X') do
  begin
    Inc(i);
    Inc(m1, k);
    if m1 > 300 then
      break;
  end;
  
  m2 := 0;
  j := x;
  while (j < w2) and (p2[y, j + 1] = 'X') do
  begin
    Inc(j);
    Inc(m2, k);
    if m2 > 300 then
      break;
  end;

  if (y + 1 <= h2) and (x + 1 <= w2) and (p2[y + 1, x + 1] = 'X') then
    if (p2[y + 1, x] = 'X') and (p2[y, x + 1] = 'X') then
    begin
      result := result + (w1 - 1) * (h1 - 1)
    end
    else
    if (p2[y + 1, x] = 'X') then
    begin
      for j := w1 - 1 downto 1 do
        result := result + (obrmaxh[j] - 1)
    end
    else
    if (p2[y, x + 1] = 'X') then
    begin
      for j := w1 - 1 downto 1 do
        result := result + (h1 - maxh[j]);
    end
end;

procedure MakeRes;
var
  i, j: Integer;
begin
  res := 0;
  full := RaspFull;
  for i := 1 to h2 do
    for j := 1 to w2 do
    begin
      if p2[i, j] = '.' then
        continue;

      res := res + full;
      res := res + RaspChast(i, j);
    end
end;

begin
  ReadFromFile;
  MakeH;
  MakeRes;
  WriteToFile
end.
 