
#include <iostream>
#include <fstream>
using namespace std;

bool SrcFig[300][300], BigFig[100000][100000];
int K, Hs, Ws, Hb, Wb;
char xc;

bool CanPut( int y, int x )
{
	for( int dy = 0; dy < Hs; ++dy )
		for( int dx = 0; dx < Ws; ++dx )
			if( SrcFig[dy][dx] && !BigFig[dy+y][dx+x] )
				return false;
	return true;
}

int GetNumVars()
{
	int count = 0, xmax = Wb*K-Ws, ymax = Hb*K-Ws;
	if( xmax < 0 || ymax < 0 ) return 0;
	for( int y = 0; y <= ymax; ++y )
		for( int x = 0; x <= xmax; ++x )
			if( CanPut( y, x ) )
				count++;
	return count;
}

int main()
{
	ifstream fi( "poly.in" );
	ofstream fo( "poly.out" );
	fi >> K >> Hs >> Ws;
	for( int y = 0; y < Hs; ++y )
		for( int x = 0; x < Ws; ++x )
			{ fi >> xc; SrcFig[y][x] = xc == 'X'; }
	fi >> Hb >> Wb;
	for( int y = 0; y < Hb; ++y )
		for( int x = 0; x < Wb; ++x )
		{
			fi >> xc;
			for( int yy = y * K; yy < (y+1)*K; ++yy )
				for( int xx = x * K; xx < (x+1)*K; ++xx )
					BigFig[yy][xx] = xc == 'X';
		}
	fo << GetNumVars();
	return 0;
}