program Task5;

uses
  SysUtils,
  Controls,
  Math;

var
  K, NewW, NewH, OldW, OldH: Integer;
  MethodsCol: Int64;
  NewPoly, OldPoly: array [1..301, 1..301] of Boolean;
  LeftTop, RightTop, RightBottom, LeftBottom: Integer;

  procedure ReadInput;
  var
    F: TextFile;
    I, J: Integer;
    HStr: AnsiString;
  begin
    AssignFile(F, 'poly.in');
    Reset(F);
    ReadLn(F, K);
    ReadLn(F, NewH, NewW);
    for I := 1 to NewH do begin
      ReadLn(F, HStr);
      for J := 1 to NewW do
        NewPoly[J, I] := (HStr[J] = 'X');
    end;
    ReadLn(F, OldH, OldW);
    for I := 1 to OldH do begin
      ReadLn(F, HStr);
      for J := 1 to OldW do
        OldPoly[J, I] := (HStr[J] = 'X');
    end;
    CloseFile(F);
  end;

  procedure WriteOutput;
  var
    F: TextFile;
  begin
    AssignFile(F, 'poly.out');
    Rewrite(F);
    Write(F, MethodsCol);
    CloseFile(F);
  end;

  procedure GenerateCorners;
  var
    I, J, WCorn, HCorn: Integer;
  begin
    LeftTop := 0;
    LeftBottom := 0;
    RightTop := 0;
    RightBottom := 0;

    //LeftTop
    for I := 1 to NewW do
      if NewPoly[I, 1] then begin
        WCorn := I - 1;
        Break;
      end;
    for I := 1 to NewH do
      if NewPoly[1, I] then begin
        HCorn := I - 1;
        Break;
      end;
    for I := 1 to WCorn do
      for J := 1 to HCorn do
        if not NewPoly[I, J] then
          Inc(LeftTop);

    //RightTop
    for I := NewW downto 1 do
      if NewPoly[I, 1] then begin
        WCorn := I + 1;
        Break;
      end;
    for I := 1 to NewH do
      if NewPoly[NewW, I] then begin
        HCorn := I - 1;
        Break;
      end;
    for I := WCorn to NewW do
      for J := 1 to HCorn do
        if not NewPoly[I, J] then
          Inc(RightTop);

    //LeftBottom
    for I := 1 to NewW do
      if NewPoly[I, NewH] then begin
        WCorn := I - 1;
        Break;
      end;
    for I := NewH downto 1 do
      if NewPoly[1, I] then begin
        HCorn := I + 1;
        Break;
      end;
    for I := 1 to WCorn do
      for J := HCorn to NewH do
        if not NewPoly[I, J] then
          Inc(LeftBottom);

    //RightBottom
    for I := NewW downto 1 do
      if NewPoly[I, 1] then begin
        WCorn := I + 1;
        Break;
      end;
    for I := NewH downto 1 do
      if NewPoly[1, I] then begin
        HCorn := I + 1;
        Break;
      end;
    for I := WCorn to NewW do
      for J := HCorn to NewH do
        if not NewPoly[I, J] then
          Inc(RightTop);
  end;

label
  NextCase;
var
  I, J, M, N: Integer;
  PerOne, PerWSide, PerHSide, PerTwoSides: Integer;
begin
  ReadInput;

  MethodsCol := 0;
  if (K <= NewH) or (K <= NewW) then begin
    for I := 0 to OldW * K - NewW do
      for J := 0 to OldH * K - NewH do begin
        for M := 1 to NewW do
          for N := 1 to NewH do
            if NewPoly[M, N] and not OldPoly[Ceil((M+I) / K), Ceil((N+J) / K)] then
              Goto NextCase;
        Inc(MethodsCol);
        NextCase:
      end;
  end else begin
    PerOne := (K - NewW + 1) * (K - NewH + 1);
    PerWSide := (NewW - 1) * (K - NewH + 1);
    PerHSide := (NewH - 1) * (K - NewW + 1);
    PerTwoSides := (NewW - 1) * (NewH - 1);
    GenerateCorners;

    for I := 1 to OldW do begin
      for J := 1 to OldH do begin
        if OldPoly[I, J] then begin
          Inc(MethodsCol, PerOne);
          if OldPoly[I + 1, J] then Inc(MethodsCol, PerWSide);
          if OldPoly[I, J + 1] then Inc(MethodsCol, PerHSide);
          if OldPoly[I + 1, J] and OldPoly[I, J + 1] and OldPoly[I + 1, J + 1] then Inc(MethodsCol, PerTwoSides);
          if OldPoly[I + 1, J + 1] and (not OldPoly[I + 1, J]) and OldPoly[I, J + 1] then Inc(MethodsCol, RightTop);
          if (not OldPoly[I + 1, J + 1]) and OldPoly[I + 1, J] and OldPoly[I, J + 1] then Inc(MethodsCol, RightBottom);
          if OldPoly[I + 1, J + 1] and OldPoly[I + 1, J] and (not OldPoly[I, J + 1]) then Inc(MethodsCol, LeftBottom);
        end else begin
          if OldPoly[I + 1, J + 1] and OldPoly[I + 1, J] and OldPoly[I, J + 1] then Inc(MethodsCol, LeftTop);
        end;
      end;
    end;
  end;

  WriteOutput;
end.
