#include <cstdio>
#include <set>
#include <map>
#include <utility>

using namespace std;

struct poly{
	int h, w;
	set<pair<int, int> > s;
	bool friend operator<(const poly& a, const poly& b){
		return a.s<b.s;
	}
	bool friend cont(poly& a, poly& b, int x, int y){
		set<pair<int, int> >::iterator it;
		for (it=a.s.begin(); it!=a.s.end(); it++)
			if (b.s.count(make_pair(it->first+x, it->second+y))==0) return false;
		return true;
	}
};

map<poly, int> pr;

poly p, q;
int k;

void makepr(){
	int i, j;
	set<pair<int, int> >::iterator it;
	poly tmp;
	tmp.h=(p.h-1)/k+((p.h-1)%k==0?0:1)+1;
	tmp.w=(p.w-1)/k+((p.w-1)%k==0?0:1)+1;
	if (p.h<=k){
		tmp.s.clear();
		for (i=0; i<tmp.w-1; i++) tmp.s.insert(make_pair(0, i));
		if ((p.w-1)%k!=0) pr[tmp]+=(k-(p.w-1)%k)*(k-p.h+1);
		tmp.s.insert(make_pair(0, tmp.w-1));
		if ((p.w-1)%k!=0)
			pr[tmp]+=((p.w-1)%k)*(k-p.h+1);
		else
			pr[tmp]+=k;
	}
	if (p.w<=k){
		tmp.s.clear();
		for (i=0; i<tmp.h-1; i++) tmp.s.insert(make_pair(i, 0));
		if ((p.h-1)%k!=0) pr[tmp]+=(k-(p.h-1)%k)*(k-p.w+1);
		tmp.s.insert(make_pair(tmp.h-1, 0));
		if ((p.h-1)%k!=0)
			pr[tmp]+=((p.h-1)%k)*(k-p.w+1);
		else
			pr[tmp]+=k;
	}
	if (p.h<=k&&p.w<=k){
		tmp.s.clear();
		tmp.s.insert(make_pair(0, 0));
		pr[tmp]-=(k-p.h+1)*(k-p.w+1);
	}
	for (i=p.h>k?0:k-p.h+1; i<k; i++)
		for (j=p.w>k?0:k-p.w+1; j<k; j++){
			tmp.s.clear();
			for (it=p.s.begin(); it!=p.s.end(); it++)
				tmp.s.insert(make_pair((it->first+i)/k, (it->second+j)/k));
			pr[tmp]++;
		}/**/
}

int main(){
	freopen("poly.in", "rt", stdin);
	freopen("poly.out", "wt", stdout);
	int i, j;
	__int64 ans=0;
	char t;
	scanf("%d%d%d\n", &k, &p.h, &p.w);
	for (i=0; i<p.h; i++){
		for (j=0; j<p.w; j++){
			scanf("%c", &t);
			if (t=='X') p.s.insert(make_pair(i, j));
		}
		scanf("\n");
	}
	scanf("%d%d\n", &q.h, &q.w);
	for (i=0; i<q.h; i++){
		for (j=0; j<q.w; j++){
			scanf("%c", &t);
			if (t=='X') q.s.insert(make_pair(i, j));
		}
		scanf("\n");
	}
	makepr();
	map<poly, int>::iterator it;
	set<pair<int, int> >::iterator jt;
	char tmp[300][300];
	for (it=pr.begin(); it!=pr.end(); it++){
		poly t=it->first;
		for (jt=q.s.begin(); jt!=q.s.end(); jt++)
			if (cont(t, q, jt->first, jt->second))
				ans+=it->second;
	}
	printf("%I64d", ans);/**/
	/*for (it=pr.begin(); it!=pr.end(); it++){
		for (i=0; i<it->first.h; i++)
			for (j=0; j<it->first.w; j++)
				tmp[i][j]='.';
		poly t=it->first;
		for (jt=t.s.begin(); jt!=t.s.end(); jt++)
			tmp[jt->first][jt->second]='X';
		for (i=0; i<it->first.h; i++){
			for (j=0; j<it->first.w; j++)
				printf("%c", tmp[i][j]);
			printf("\n");
		}
		printf("%d\n\n", it->second);
	}/**/
	return 0;
}