#include <stdio.h>
#include <string.h>
#include <stdlib.h>
#include <time.h>

#define MAX_S 304
#define MAX_TL 1.8

#define MAX(A, B) ((A) > (B) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

int F[MAX_S][MAX_S], FN[MAX_S][MAX_S], W, H, WN, HN;
int Q1[MAX_S][2], Q1N = 0, Q2[MAX_S][2], Q2N = 0;

int main( void )
{
  int K, i, j, k, l, f, a, b, c, d, x;
  __int64 sum;
  int t = clock();
  char buf[MAX_S];

  srand(30301);
  
  freopen("poly.in", "rt", stdin);
  freopen("poly.out", "wt", stdout);

  memset(F, 0, sizeof(F));
  memset(FN, 0, sizeof(FN));

  gets(buf), sscanf(buf, "%i", &K);
  gets(buf), sscanf(buf, "%i%i", &HN, &WN);
  for (i = 0; i < HN; i++)
    for (gets(buf), j = 0; j < WN; j++)
      if (buf[j] == 'X')
        FN[i][j] = 1;

  gets(buf), sscanf(buf, "%i%i", &H, &W);
  for (i = 0; i < H; i++)
    for (gets(buf), j = 0; j < W; j++)
      if (buf[j] == 'X')
        F[i][j] = 1;

  if (K * W < WN || K * H < HN)
  {
    printf("0");
    return 0;
  }

  for (Q1N = 0, i = 0; i < H; i++)
    for (j = 0; j < W; j++)
      if (F[i][j])
        Q1[Q1N][0] = j, Q1[Q1N++][1] = i;
  
  for (Q2N = 0, i = 0; i < HN; i++)
    for (j = 0; j < WN; j++)
      if (FN[i][j])
        Q2[Q2N][0] = j, Q2[Q2N++][1] = i;

  for (i = 0; i < Q1N * 0.6; i++)
  {
    a = rand() % Q1N, b = rand() % Q1N;
    SWAP(Q1[a][0], Q1[b][0], c);
    SWAP(Q1[a][1], Q1[b][1], c);
  }
  for (i = 0; i < Q2N * 0.6; i++)
  {
    a = rand() % Q2N, b = rand() % Q2N;
    SWAP(Q2[a][0], Q2[b][0], c);
    SWAP(Q2[a][1], Q2[b][1], c);
  }

  for (x = 0; x < WN; x++)
    if (FN[0][x])
      break;

  for (sum = 0, i = 0; i < Q1N; i++)
  {
    a = Q1[i][0], b = Q1[i][1];
    for (k = 0; k < K; k++)
      for (l = 0; l < K; l++)
      {
        if ((double)(clock() - t) / CLOCKS_PER_SEC >= MAX_TL)
        {
          printf("%I64i", sum);
          return 0;
        }

        for (f = 1, j = 0; j < Q2N; j++)
        {
          c = (Q2[j][0] + l - x + a * K) / K, d = (Q2[j][1] + k) / K + b;

          if (Q2[j][0] + l - x + K * a < 0 || !F[d][c])
          {
            f = 0;
            break;
          }
        }
        if (f)
          sum++;
      }
  }

  printf("%I64i", sum);

  return 0;
}
