#include <cstdio>

const int MAX = 302;

bool oldP[MAX][MAX];
bool newP[MAX][MAX];

int K;

int oldH, oldW;
int newH, newW;

inline bool getState(int i, int j)
{
	return oldP[i / K][j / K];
}

void readPoly(bool P[][MAX], int &H, int &W)
{
	scanf("%d %d\n", &H, &W);
	for ( int i = 0; i < H; ++i )
	{
		char line[MAX];
		gets(line);
		for ( int j = 0; j < W; ++j )
			P[i][j] = ( line[j] == 'X' ) ? true : false;
	}
}

int countPlaces()
{
	int sum = 0;
	for ( int i = 0; i <= oldH * K - newH; ++i )
		for ( int j = 0; j <= oldW * K - newW; ++j )
		{
			bool ok = true;
			for ( int k = i; k < i + newH; ++k )
				for ( int l = j; l < j + newW; ++l )
					if ( newP[k-i][l-j] && !getState(k, l) )
					{
						ok = false;
						break;
					}
			if ( ok )
				++sum;
		}
	return sum;
}

int main()
{
	freopen("poly.in", "r", stdin);
	freopen("poly.out", "w", stdout);
	scanf("%d", &K);
	readPoly(newP, newH, newW);
	readPoly(oldP, oldH, oldW);
	printf("%d", countPlaces());
	return 0;
}
