#include <stdio.h>
#include <vector>

#define SIZE 10010
#define SQ 610

typedef std::vector<int> iVect;
typedef iVect::iterator vIter;

bool matr[SQ][SQ];
bool image[SQ][SQ];
iVect imList[SQ];
long long answer;

int cnt, k;
int mw, mh;
int imw, imh;
int ans;

inline long long max2(long long a, long long b) {
	return (a>b ? a : b);
}

void ReadAll() {
	int i, j, u, v;
	scanf("%d", &k);
	scanf("%d%d\n", &imh, &imw);
	for (i = 0; i<imh; i++) {
		for (j = 0; j<imw; j++) {
			char ch;
			scanf("%c", &ch);
			image[i][j] = (ch=='X');
		}
		scanf("\n");
	}
	scanf("%d%d\n", &mh, &mw);
	for (i = 0; i<mh; i++) {
		for (j = 0; j<mw; j++) {
			char ch;
			scanf("%c", &ch);
			matr[i][j] = (ch=='X');
		}
		scanf("\n");
	}
}

void GenerateLists() {
	int i, j;
	for (i = 0; i<imh; i++)
		for (j = 0; j<imw; j++)
			if (image[i][j])
				imList[i].push_back(j);
}

void GetXY(int num, int &i, int &j) {
	if (num < ((imw-1)*k)) {
		i = num/(imw-1);
		j = k-1 - num%(imw-1);
		return;
	}
	num -= (imw-1)*k;
	i = k-1 - num/(k+1-imw);
	j = num%(k+1-imw);
}
 
int main(int argc, char **argv) {
	freopen("poly.in", "r", stdin);
	freopen("poly.out", "w", stdout);
	ReadAll();
	GenerateLists();
	int i, j, u, v;
	for (i = 0; i<mh; i++)
		for (j = 0; j<mw; j++) {
			if (!matr[i][j])
				continue;
			long long zh = k - imh + 1;
			long long zw = k - imw + 1;
			if ((zw>0) && (zh>0))
				answer += zw*zh;
			int mx;
			mx = (imw-1)*k + (imh-1)*k - (imh-1)*(imw-1);
			for (v = 0; v<mx; v++) {
				int ch, cw;
				GetXY(v, ch, cw);
				if ((ch<0) || (cw<0))
					continue;
				bool ok = true;
				for (u = 0; u<imh; u++) {
					for (vIter it = imList[u].begin(); it != imList[u].end(); it++) {
						int cmh = (i*k + ch+u)/k;
						int cmw = (j*k + cw+(*it))/k;
						if (!matr[cmh][cmw]) {
							ok = false;
							break;
						}
					}
					if (!ok)
						break;
				}
				answer += ok;
			}
		}
	printf("%I64d", answer);
	return 0;
}