#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <vector>

using namespace std;

#include "geom.h"

#define FILE_IN "reform.in"
#define FILE_OUT "reform.out"

const int MAXN = 20;

int n;        
Point point[MAXN];

vector<Line> ans;

PList * pol;

void fix(PList * &m) {
	if (m->size()<4) return;
	
	PList * q1 = m;
	PList * q2 = q1->next;
	PList * q3 = q2->next;

	do {               
		if (OnOneLine(*q1->val,*q2->val,*q3->val)) {			
			delete q2;
			if (q2==m) m = q3;
			q2 = q3;
			q1->next = q2;
			q3 = q3->next;
			if (q3==q1) break;
		} else {
			q1 = q1->next;
			q2 = q2->next;
			q3 = q3->next;
		}
	} while (q1!=m); 	
}

void OpenFiles() {
	freopen(FILE_IN,"r",stdin);
	freopen(FILE_OUT,"w",stdout);
}

void CloseFiles() {
	fclose(stdout);
}

void Initialize(){
	
}

void ReadData() {	
	int i;
	scanf("%d",&n);
	PList * q;
	for (i=0;i<n;i++) {
		scanf("%lf %lf",&point[i].x,&point[i].y);
        if (pol) {
        	q = new PList;
        	q->next = pol->next;
        	pol->next = q;
        	q->val = point+i;
        } else {
        	pol = new PList;
        	pol->next = pol;
        	pol->val = point+i;
        }
	}    	
}

void Print(PList * m) {
	fix(m);
	if (m->size()<4) return;
	PList *q2, *q1 = m;	
	int find = 0;
	do {
		q2 = q1->next->next;
		while(q2->next!=q1) {
			if (isInner(m,q1->val,q2->val)) {
				find = 1;
				q1->clon();
				q2->clon();

				m = q1->next;
				q1->next = q2->next;
				q2->next = m;

                ans.push_back(Line(*q1->val,*q2->val));
				Print(q1);
				Print(q2);
                break;
			}
			q2 = q2->next;
		}
		if (find) break;
		q1 = q1->next;
	} while (q1!=m);
}	

void Solve() {
	Print(pol);
}

void OutData() {
	vector<Line>::iterator p;
	p = ans.begin();
	printf("%d\n%d\n",n-2,ans.size());
	while (p!=ans.end()) {
		p->Print();
		printf("\n");
		p++;
	}	
}

int main(int argc, char * arg[]) {
	OpenFiles();
    Initialize();
    ReadData();
   	Solve();
   	OutData();
    CloseFiles();
    return 0;	
}