#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
//#include <queue>
//#include <set>
#include <map>
#include <algorithm>
#include <iostream>
//#include <cstdio>
//#include <sstream>
#include <cassert>
//#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "reform.in"
#define C_OUT_FILE "reform.out"
#define C_LOG_FILE "reform.aux"
FILE *LOG;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define prev(i) (int)((i - 1 + a.size()) % a.size())
#define next(i) (int)((i + 1) % a.size())

#include "geometry_vg.h"

int n, m, ans;

polygon a;

vectD operator + (const vectD &a, const vectD &b) {
    vectD res;
    forv(i, a) res.pb(a[i]);
    forv(i, b) res.pb(b[i]);
    return res;
}

inline bool operator < (const vectD &a, const vectD &b) {
    if (a.size() != b.size()) return a.size() < b.size();
    return a < b;
}

inline bool operator > (const vectD &a, const vectD &b) {
    return b < a;
}

map<polygon, vectD> memory;

polygon norm(const polygon &a) {
    vector<bool> bd(a.size(), false);
    forv(i, a) {
        point p1 = a[prev(i)], p2 = a[i], p3 = a[next(i)];
        bd[i] = ((p2 - p1) * (p3 - p1)) == 0;
    }
    polygon b, c;
    forv(i, a) {
        if (!bd[i]) b.pb(a[i]);
    }
    int t = 0;
    point mn = b[0];
    forv(i, b) {
        if (mn > b[i]) {
            mn = b[i];
            t = i;
        }
    }
    for(int i = t; i < (int)b.size(); ++i) c.pb(b[i]);
    for(int i = 0; i < t; ++i) c.pb(b[i]);
    if (c[1] > c[(int)c.size() - 1]) reverse(all(c));
    return c;
}

vectD calc(polygon &a) {
    if (a.size() <= 3) return vectD(0);
    a = norm(a);
    if (memory.count(a)) {
        return memory[a];
    }
    if (a.size() <= 3) return vectD(0);
    vector< PII > t[2], at, tmo;
    forv(i, a) {
        forn(j, i - 1) {
            if ((i + 1 - j) % a.size() == 0) continue;
            if (!inPolygon(segment(a[i], a[j]), a)) continue;
            if (inSegm(a[next(i)], segment(a[i], a[j])) ||
                inSegm(a[prev(i)], segment(a[i], a[j])) ||
                inSegm(a[next(j)], segment(a[i], a[j])) ||
                inSegm(a[prev(j)], segment(a[i], a[j]))) continue;
            int k = 0;
            line li1(a[prev(i)], a[i]), li2(a[i], a[next(i)]);
            line lj1(a[prev(j)], a[j]), lj2(a[j], a[next(j)]);
            line l(a[i], a[j]);
            if ((li1 || l) || (li2 || l)) ++k;
            if ((lj1 || l) || (lj2 || l)) ++k;
            if (k > 0) {
                t[k - 1].pb(mp(i, j));
                at.pb(mp(i, j));
            } else {
                tmo.pb(mp(i, j));
            }
        }
    }
    if (a.size() == n) {
        fprintf(LOG, "%d\n", at.size());
        forv(i, at) {
            fprintf(LOG, "%d %d %d %d\n", a[at[i].first].x / 8,  a[at[i].first].y / 8,
                a[at[i].second].x / 8,  a[at[i].second].y / 8);
        }
    }
    bool ok = true;
    forv(i, at) {
        if (!ok) break;
        forn(j, i) {
            if (cross(segment(a[at[i].first], a[at[i].second]), 
                segment(a[at[j].first], a[at[j].second]))) {
                    ok = false;
                    break;
            }
        }
    }
    if (ok) {
        forv(i, tmo) {
            if (!ok) break;
            forn(j, i) {
                if (cross(segment(a[tmo[i].first], a[tmo[i].second]), 
                    segment(a[tmo[j].first], a[tmo[j].second]))) {
                        if (line(a[tmo[i].first], a[tmo[i].second]) 
                            || line(a[tmo[j].first], a[tmo[j].second])) {
                            ok = false;
                            break;
                        }
                }
            }
        }
    }
    if (!ok) {
        vectD res(0), cres;
        forv(i, t[1]) {
            int fi = t[1][i].first, sj = t[1][i].second;
            polygon F, S;
            for(int t = fi; t != sj; t = next(t)) F.pb(a[t]);
            F.pb(a[sj]);
            for(int t = sj; t != fi; t = next(t)) S.pb(a[t]);
            S.pb(a[fi]);
            cres = vectD(1, segment(a[fi], a[sj])) + calc(F) + calc(S);
            if (res.size() == 0 || res > cres) res = cres;
        }
        forv(i, t[0]) {
            int fi = t[0][i].first, sj = t[0][i].second;
            polygon F, S;
            for(int t = fi; t != sj; t = next(t)) F.pb(a[t]);
            F.pb(a[sj]);
            for(int t = sj; t != fi; t = next(t)) S.pb(a[t]);
            S.pb(a[fi]);
            cres = vectD(1, segment(a[fi], a[sj])) + calc(F) + calc(S);
            if (res.size() == 0 || res > cres) res = cres;
        }
        assert(res.size() > 0);
        return memory[a] = res;
    } else {
        polygon F, S;
        int fi, sj;
        if (at.size() > 0) {
            fi = at[0].first;
            sj = at[0].second;
        } else {
            if (tmo.size() == 0) return vectD(0);
            fi = tmo[0].first;
            sj = tmo[0].second;
        }
        for(int t = fi; t != sj; t = next(t)) F.pb(a[t]);
        F.pb(a[sj]);
        for(int t = sj; t != fi; t = next(t)) S.pb(a[t]);
        S.pb(a[fi]);
        return memory[a] = vectD(1, segment(a[fi], a[sj])) + calc(F) + calc(S);
    }
}

vectD result;

void outdata() {
    printf("%d\n", result.size() + 1);
    printf("%d\n", result.size());
    forv(i, result) {
        printf("%d %d %d %d\n", result[i].p1.x / 8, result[i].p1.y / 8, result[i].p2.x / 8, result[i].p2.y / 8);
    }
}

void solve() {
    result = calc(a);
}

void readdata() {
    scanf("%d", &n);
    a.resize(n);
    forn(i, n) {
        scanf("%d%d", &a[i].x, &a[i].y);
        a[i].x *= 8;
        a[i].y *= 8;
    }
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
    LOG = fopen(C_LOG_FILE, "wt");
    readdata();
    solve();
    outdata();
    return 0;
}

