#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
//#include <queue>
//#include <set>
#include <map>
//#include <algorithm>
#include <iostream>
//#include <cstdio>
//#include <sstream>
#include <cassert>
//#include <utility>

using namespace std;

#define EPS 1E-8
const long long INF = (long long)1E+9;

#define C_IN_FILE "reform.in"
#define C_OUT_FILE "reform.out"
#define C_LOG_FILE "reform.aux"
FILE *LOG;

#define forn(i, n) for (long long i = 0; i < (long long)(n); ++i)
#define forv(i, v) for (long long i = 0; i < (long long)(v.size()); ++i)
#define fors(i, s) for (long long i = 0; i < (long long)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<long long, long long>
#define mp make_pair
#define VI vector<long long>
#define VS vector<string>

#define prev(i) (long long)((i - 1 + a.size()) % a.size())
#define next(i) (long long)((i + 1) % a.size())

#include "geometry_vg.h"

long long n, m, ans;

polygon a;
map<polygon, vectD> memory;

vectD operator + (const vectD &a, const vectD &b) {
    vectD res;
    forv(i, a) res.pb(a[i]);
    forv(i, b) res.pb(b[i]);
    return res;
}

inline bool operator < (const vectD &a, const vectD &b) {
    return a.size() < b.size();
}

inline bool operator > (const vectD &a, const vectD &b) {
    return a.size() > b.size();
}

polygon norm(const polygon &a) {
    vector<bool> bd(a.size(), false);
    forv(i, a) {
        point p1 = a[prev(i)], p2 = a[i], p3 = a[next(i)];
        bd[i] = ((p2 - p1) * (p3 - p1)) == 0;
    }
    polygon b;
    forv(i, a) {
        if (!bd[i]) b.pb(a[i]);
    }
    return b;
}

vectD calc(polygon &a) {
    a = norm(a);
    if (memory.count(a)) {
        return memory[a];
    }
    if (a.size() <= 3) return vectD(0);
    vector< PII > t[2], at, tmo;
    int k1 = 0, k2 = 0;
    forv(i, a) {
        forn(j, i - 1) {
            if ((i + 1 - j) % a.size() == 0) continue;
            if (!inPolygon(segment(a[i], a[j]), a)) continue;
            if (inSegm(a[next(i)], segment(a[i], a[j])) ||
                inSegm(a[prev(i)], segment(a[i], a[j])) ||
                inSegm(a[next(j)], segment(a[i], a[j])) ||
                inSegm(a[prev(j)], segment(a[i], a[j]))) continue;
            long long k = 0;
            line li1(a[prev(i)], a[i]), li2(a[i], a[next(i)]);
            line lj1(a[prev(j)], a[j]), lj2(a[j], a[next(j)]);
            line l(a[i], a[j]);
            if ((li1 || l) || (li2 || l)) ++k;
            if ((lj1 || l) || (lj2 || l)) ++k;
            if (k == 1) ++k1;
            if (k == 2) ++k2;
            if (k > 0) {
                t[k - 1].pb(mp(i, j));
                at.pb(mp(i, j));
            } else {
                at.pb(mp(i, j));
                tmo.pb(mp(i, j));
            }
        }
    }
    if (a.size() == n) {
        fprintf(LOG, "%d\n", at.size());
        fprintf(stderr, "%d %d\n", k1, k2);
        forv(i, at) {
            fprintf(LOG, "%I64d %I64d %I64d %I64d\n", a[at[i].first].x / 8,  a[at[i].first].y / 8,
                a[at[i].second].x / 8,  a[at[i].second].y / 8);
        }
    }
    vectD res(0), cres;
    t[1] = at;
    forv(i, t[1]) {
        long long fi = t[1][i].first, sj = t[1][i].second;
        polygon F, S;
        for(long long t = fi; t != sj; t = next(t)) F.pb(a[t]);
        F.pb(a[sj]);
        for(long long t = sj; t != fi; t = next(t)) S.pb(a[t]);
        S.pb(a[fi]);
        cres = vectD(1, segment(a[fi], a[sj])) + calc(F) + calc(S);
        if (res.size() == 0 || res > cres) res = cres;
    }
    return memory[a] = res;
}

vectD result;

void outdata() {
    printf("%d\n", result.size() + 1);
    printf("%d\n", result.size());
    forv(i, result) {
        cout << result[i].p1.x / 8 << " " << result[i].p1.y / 8 << " " << result[i].p2.x / 8 << " " << result[i].p2.y / 8 << endl;
    }
}

void solve() {
    result = calc(a);
}

void readdata() {
    scanf("%d", &n);
    a.resize(n);
    forn(i, n) {
        cin >> a[i].x >> a[i].y;
        a[i].x *= 8;
        a[i].y *= 8;
    }
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
    LOG = fopen(C_LOG_FILE, "wt");
    readdata();
    solve();
    outdata();
    return 0;
}
