program reform;

{$APPTYPE CONSOLE}
{$R+}
uses
  SysUtils;

const
 eps = 1e-9;

type
 tpoint = record
  x,y:longint;
 end;

 tpolygon = record
  p:array[0..21] of tpoint;
  n:longint;
 end;

procedure wr(p:tpoint);
 begin
  write(p.x,' ',p.y);
 end;

function getangle(p1,p2,p3:tpoint):longint;
 var
  x1,y1,x2,y2:longint;
 begin
  x1:=p2.x-p1.x;
  y1:=p2.y-p1.y;
  x2:=p3.x-p2.x;
  y2:=p3.y-p2.y;
  result:=x1*y2-x2*y1;
 end;

type
 tset = set of byte;

function diag(p:tpolygon;var s:tset):longint;
 var
  i,t:longint;
 begin
  s:=[];
  result:=p.n-3;
  for i:=1 to p.n do
   begin
    t:=getangle(p.p[i-1],p.p[i],p.p[i+1]);
    if t<0 then
     begin
      diag := -1;
      exit;
     end;
    if t=0 then dec(result) else s:=s+[i];
   end;
  if result<0 then result:=0; 
 end;

var
 ac:longint;
 a1,a2:array[1..20] of tpoint;

procedure awr;
 var
  i:longint;
 begin
  for i:=1 to ac do
   begin
    wr(a1[i]); write(' '); wr(a2[i]);
    writeln;
   end;
 end;

procedure putinans(p:tpolygon;s:tset; n:longint);
 var
  i,j,q:longint;
 begin
   i:=1; while not (i in s) do inc(i);
   j:=0;
   q:=i+1;
   while not (q in s) do inc(q);
   inc(q);
   while not (q in s) do inc(q);
   while j<n do
    begin
     if q in s then
      begin
       inc(ac);
       a1[ac]:=p.p[i];
       a2[ac]:=p.p[q];
       inc(j);
      end;
     inc(q);
    end;
 end;

function newpoly(p:tpolygon; s:tset):tpolygon;
 var
  i,j:longint;
  res:tpolygon;
 begin
  j:=0;
  for i:=1 to p.n do
   if i in s then
    begin
     inc(j);
     res.p[j]:=p.p[i];
    end;
  res.p[0]:=res.p[j];
  res.p[j+1]:=res.p[1];
  res.n:=j;  
  result := res;
 end;

var
 used : array[1..20] of boolean;
 anum:longint;
 k:longint;
 ans,ans_ns:tset; 
 p,ans_poly:tpolygon;

procedure sol(num:longint; s :tset);
 var
  i,t,count:longint;
  tans:longint;
  tpoly : tpolygon;
  ns :tset;
 begin
  if num = k+1 then
   begin
    count := 0;
    for i:=1 to k do
     if (i in s) then inc(count);
    if count<3 then exit;
    if k in s then s:=s+[0];
    if 1 in s then s:=s+[k+1];
    for i:=1 to k do
     if not(i in s) then
      if getangle(p.p[i-1],p.p[i],p.p[i+1])<0 then
       if (i-1 in s) {and}or (i+1 in s) then
        exit;
    tans:=k-count;
    tpoly := newpoly(p,s);
    t:=diag(tpoly,ns);
//    s:=s*ns;
    if t=-1 then exit;
    if anum>tans+t then
     begin
      anum:=tans;
      ans:=s;
      ans_poly:=tpoly;
     end;
   end
  else
   begin
    sol(num+1,s);
    used[num]:=true;
    s:=s-[num];
    sol(num+1,s);
    used[num]:=false;
   end;
 end;

var
 i,n,j,q:longint;
 s:tset;
begin
 assign(input,'reform.in'); reset(input);
 assign(output,'reform.out'); rewrite(output);
 read(p.n);
 for i:=1 to p.n do read(p.p[i].x,p.p[i].y);
 p.p[p.n+1]:=p.p[1]; p.p[0]:=p.p[p.n];

 n:=diag(p,s);
 if n>=0 then
  begin
   putinans(p,s,n);
   writeln(ac+1);
   writeln(ac);
   awr;
   halt;
  end;
 k:=p.n;
 s:=[1..k]; anum:=1000000;
 sol(1,s);
// awr;
 n:=diag(ans_poly,s);
 writeln(n+anum+1);
 writeln(n+anum);
 if n>0 then
  begin
   putinans(ans_poly,s,n);
   awr;
  end;
 for i:=1 to k do
  if i in ans then ans:=ans+[i+k];

 j:=0; i:=1;
 while not (i in ans) do inc(i);
 while j<anum do
  begin
   while i+1 in ans do inc(i);
   q:=i+1;
   while (j<anum) and not(q in ans) do
    begin
     wr(p.p[i]); write(' ');
     wr(p.p[q+1]); writeln;
     inc(q);
     inc(j);
    end;
   i:=q; 
  end;
 close(input);
 close(output);
end.
