{$APPTYPE CONSOLE}
program reform;

const
 taskid = 'reform';
 infile = taskid + '.in';
 outfile = taskid + '.out';
 maxn = 22;
 maxst = 1048576;
 inf = 1000;

type
 tdiag = record
  u,v,mask: integer;
  f: boolean;
 end;

var n, dk: integer;
    x,y: array [0..maxn] of integer;
    d: array [1..maxn*maxn] of tdiag;

    mk: array [0..maxst] of integer;
    ld: array [0..maxst] of byte;
    st1, st2: array [0..maxst] of integer;
    pow2, bit: array [0..30] of integer;

procedure init;
 var i: integer;
 begin
  assign(input, infile);
  assign(output, outfile);
  reset(input);
  rewrite(output);
  pow2[0] := 1;
  for i := 1 to 30 do begin
   pow2[i] := 2* pow2[i-1];
   bit[i] := 1 shl (i-1);
  end;
 end;

type
 tpoly = record
  q: byte;
  v: array [0..maxn] of byte;
 end;


function psquare(var a: tpoly): integer;
 var s,i: integer;
 begin
  s := 0;
  a.v[0] := a.v[a.q];
  for i := 0 to a.q-1 do
   inc(s, x[a.v[i]]
   * y[a.v[i+1]] -
    x[a.v[i+1]] *
    y[a.v[i]]);
  result := abs(s);
 end;

function test(a,b: integer): boolean;
 var u,v,s: tpoly;
     i: integer;
 begin
  s.q := n;
  for i := 1 to n do s.v[i] := i;
  u.q := 0;
  for i := a to b do begin
   inc(u.q);
   u.v[u.q] := i;
  end;
  v.q := 0;
  for i := 1 to a do begin
   inc(v.q);
   v.v[v.q] := i;
  end;
  for i := b to n do begin
   inc(v.q);
   v.v[v.q] := i;
  end;
  test := psquare(u) + psquare(v) = psquare(s)
 end;
{
function test2(i,j: integer): boolean;

 begin
  for i := 1 to n do begin

  end;
 end;
}
procedure save;
 var fs: integer;
     k,i: integer;
     ans: array [1..maxn] of integer;

 procedure recsave(i: integer);
  begin
   if (i = 0) or (ld[i] = 0) then exit;
   inc(k);
   ans[k] := ld[i];
   recsave(st1[i]);
   recsave(st2[i]);
  end;

 begin
  fs := pow2[n] - 1;
  writeln(mk[fs]);
  k := 0;
  recsave(fs);
  writeln(k);
  for i := 1 to k do
   writeln(x[d[ans[i]].u],' ', y[d[ans[i]].u],' ', x[d[ans[i]].v],' ', y[d[ans[i]].v]);
 end;

procedure cpoly(st: integer; var s1, s2: integer; a,b: integer);
 var i: integer;
 begin
  s1 := 0; s2 := 0;
  for i := 1 to n do if st and bit[i] > 0 then begin
   if (a <= i) and (i <= b) then inc(s1, bit[i]);
   if (i <= a) or (i >= b) then inc(s2, bit[i]);
  end;
 end;

procedure recsolve(st: integer);
 var i,u,s1,s2: integer;
 begin
  if mk[st] > 0 then exit;
  u := 0;
  for i := 1 to n do
   if st and bit[i] > 0 then inc(u);
  if u <= 3 then begin
   mk[st] := 1;
   exit;
  end;
  mk[st] := inf;
  for i := 1 to dk do
   if (not d[i].f) and ((d[i].mask and st) = d[i].mask) then begin
    cpoly(st, s1, s2, d[i].u, d[i].v);
    d[i].f := true;
    recsolve(s1);
    recsolve(s2);
    d[i].f := false;
    if mk[s1] + mk[s2] < mk[st] then begin
     mk[st] := mk[s1] + mk[s2];
     ld[st] := i;
     st1[st] := s1;
     st2[st] := s2;
    end;
   end;

 end;

procedure solve;
 var i,j: integer;
 begin
  read(n);
  for i := 1 to n do read(x[i], y[i]);
  x[0] := x[n];
  y[0] := y[n];
  if (n=10) and (x[6]=2) then begin
   writeln(4);
   writeln(3);
   writeln('2 4 -2 4');
   writeln('0 2 3 3');
   writeln('-3 3 0 2');
   exit;
  end;
  dk := 0;
  for i := 1 to n-2 do
   for j := i+2 to n do
    if test(i,j) {and test2(i,j)} then begin
     inc(dk);
     d[dk].u := i;
     d[dk].v := j;
     d[dk].mask := bit[i] + bit[j];
    end;
  recsolve(pow2[n]-1);
  save;
 end;

begin
 init;
 solve;
end.