type TPoint=record x,y:integer;end;
     TRealPoint=record x,y:extended;end;
     TPol=record
             c:byte;
             p:array[0..20]of TPoint;
          end;
     PPol=^TPol;
     TDiag=record p1,p2:TPoint;end;
     TDiags=record c:byte;d:array[1..18]of TDiag;end;
     PDiags=^TDiags;
     TLineEq=record a,b,c:longint;end;

var Land:TPol;
    Ans:TDiags;
    count:byte;

procedure init;
var f:text;i:byte;
begin
   assign(f,'reform.in');
   reset(f);
   readln(f,Land.c);
   for i:=0 to Land.c-1 do ReadLn(f,Land.p[i].x,Land.p[i].y);
   close(f);
end;

function Parallel(a1,a2,b1,b2:TPoint):boolean;
begin
   Parallel:=((a2.x-a1.x)*(b2.y-b1.y)=(a2.y-a1.y)*(b2.x-b1.x));
end;

procedure GetEq(p1,p2:TPoint;var e:TLineEq);
begin
   e.a:=p2.y-p1.y;
   e.b:=p1.x-p2.x;
   e.c:=p1.y*p2.x-p2.y*p1.x;
end;

procedure SolveEqs(e1,e2:TLineEq;var R:TRealPoint);
begin
   R.x:=(e1.c*e2.b-e2.c*e1.b)/(e2.a*e1.b-e1.a*e2.b);
   R.y:=(e1.c*e2.a-e2.c*e1.a)/(e2.b*e1.a-e1.b*e2.a);
end;

procedure GetCrossPoint(a1,a2,b1,b2:TPoint;var r:TRealPoint);
var e1,e2:TLineEq;
begin
   GetEq(a1,a2,e1);
   GetEq(b1,b2,e2);
   SolveEqs(e1,e2,r);
end;

function IsIn(p,a,b:TPoint):boolean;
begin
   IsIn:=(Parallel(a,p,p,b))and((p.x-a.x)*(p.x-b.x)<=0)and((p.y-a.y)*(p.y-b.y)<=0);
end;

function IsIn2(p:TRealPoint;a,b:TPoint):boolean;
begin
   IsIn2:=((p.x-a.x)*(p.x-b.x)<0)and((p.y-a.y)*(p.y-b.y)<0);
end;

function IsIn3(p:TRealPoint;a,b:TPoint):boolean;
begin
   IsIn3:=((p.x-a.x)*(p.x-b.x)<=0)and((p.y-a.y)*(p.y-b.y)<=0);
end;

function Cross(a1,a2,b1,b2:TPoint):boolean;
var P:TRealPoint;
begin
   if Parallel(a1,a2,b1,b2)then exit(false);
   GetCrossPoint(a1,a2,b1,b2,p);
   Cross:=(IsIn2(p,a1,a2))and(IsIn3(p,b1,b2));
end;

function DiagOK(D:TDiag):boolean;
var i:byte;e:TLineEq;x:Extended;isp,isn:boolean;
begin
   isp:=false;isn:=false;
   GetEq(d.p1,d.p2,e);
   for i:=0 to Land.c-1 do
   begin
      if Cross(D.p1,D.p2,Land.p[i],Land.p[(i+1)mod Land.c]) then Exit(false);
      x:=e.a*Land.p[i].x+e.b*Land.p[i].y+e.c;
      if x>0 then isp:=true else if x<0 then isn:=true;
   end;
   exit(isp and isn);
end;

procedure PackPol(p:PPol);
var i,j:byte;
begin
   for i:=p^.c-1 downto 0 do
      if IsIn(p^.p[i],p^.p[(i+1)mod p^.c],p^.p[(i+p^.c-1)mod p^.c]) then
      begin
         for j:=i to p^.c-2 do p^.p[j]:=p^.p[j+1];
         dec(p^.c);
      end;
end;

function bestcrack(Pol:PPol;Res:PDiags):byte;
var i,j,bc,cc:byte;p1:TPol;cd:TDiag;cds:TDiags;
begin
   packpol(Pol);
   if Pol^.c<=3 then begin Res^.c:=0;Exit(1);end;
   bc:=$FF;
   for i:=0 to pol^.c-1 do
   begin
      cd.p1:=pol^.p[i];
      cd.p2:=pol^.p[(i+2)mod pol^.c];
      if DiagOK(cd)then
      begin
         p1:=pol^;
         dec(p1.c);
         for j:=i+1 to p1.c-1 do p1.p[j]:=p1.p[j+1];
         cc:=bestcrack(@p1,@cds);
         if cc<bc then
         begin
            Res^:=cds;
            inc(Res^.c);
            Res^.d[Res^.c]:=cd;
            bc:=cc;
         end;
      end;
   end;
   bestcrack:=bc+1;
end;

procedure solve;
begin
   count:=bestcrack(@Land,@Ans);
end;

procedure out;
var f:text;i:byte;
begin
   assign(f,'reform.out');
   rewrite(f);
   WriteLn(f,count);
   WriteLn(f,Ans.c);
   for i:=1 to Ans.c do
      WriteLn(f,Ans.d[i].p1.x,' ',Ans.d[i].p1.y,' ',Ans.d[i].p2.x,' ',Ans.d[i].p2.y);
   close(f);
end;

begin
   init;
   solve;
   out;
end.
