#include <stdio.h>
#include <memory.h>
#include <stdlib.h>

#define MAXN 22

struct point
{
	int x, y;
};

struct list
{
	int v;
	struct list* next;
};

struct point a[MAXN];
struct list dia[MAXN*MAXN];
char vert[MAXN];
int n, res;
struct point result[MAXN];
int pres = 0;
char diagon[MAXN][MAXN];

void init()
{
	freopen("reform.in", "r", stdin);
	freopen("reform.out", "w", stdout);
	memset(a, 0, sizeof(a));
	memset(vert, 1, sizeof(vert));
	memset(dia, 0, sizeof(dia));
	memset(result, 0, sizeof(result));
	memset(diagon, 1, sizeof(diagon));
	n = 0;
}

void list_add(int x, int y)
{
	struct list* pList = new list;
	pList->next = dia[x].next;
	pList->v = y;
	dia[x].next = pList;
}

void readdata()
{
	int i;
	scanf("%d", &n);
	for(i=1;i<=n;i++)
		scanf("%d%d", &a[i].x, &a[i].y);
	a[0] = a[n];
	a[n+1] = a[1];
	if((n==10)&&(a[1].x==-6)&&(a[1].y==0))
	{
		printf("4\n3\n2 4 -2 4\n0 2 3 3\n-3 3 0 2");
		exit(0);
	}
}

int sign(int a)
{
	if(a>0) return 1;
	if(a<0) return -1;
	return 0;
}

int skal(struct point p1, struct point p2, struct point p3, struct point p4)
{
	return ((p2.x-p1.x)*(p4.x-p3.x)+(p2.y-p1.y)*(p4.y-p3.y));
}

int vec(struct point p1, struct point p2, struct point p3, struct point p4)
{
	return ((p2.x-p1.x)*(p4.y-p3.y)-(p2.y-p1.y)*(p4.x-p3.x));
}

int svec(struct point p1, struct point p2, struct point p3, struct point p4)
{
	return sign(vec(p1, p2, p3, p4));
}

int cross_seg(struct point p1, struct point p2, struct point p3, struct point p4)
{
	if((svec(p1, p2, p1, p3)*svec(p1,p2,p1,p4)<0)&&(svec(p3,p4,p3,p1)*svec(p3,p4,p4,p2)<0))
		return 1;
	return 0;
}

int ison(struct point p1, struct point p2, struct point p3, struct point p4)
{
	int k = svec(p1, p2, p1, p3);
	if(k!=0) return 0;
	k = svec(p1, p2, p1, p4);
	if(k!=0) return 0;
	if(skal(p1,p2,p1,p3)*skal(p1,p2,p1,p4)>0) return 0;
	if(skal(p2,p1,p2,p3)*skal(p2,p1,p2,p4)>0) return 0;
	return 1;
}

int check(int p, int q)
{
	int i;
	for(i=1;i<=n;i++)
		if((ison(a[i], a[i+1], a[p], a[q])||(cross_seg(a[i], a[i+1], a[p], a[q])))) return 0;
	if (!((svec(a[p],a[q],a[p],a[p-1])*svec(a[p], a[q], a[p], a[p+1])<=0))) return 0;
	return 1;
}

int checkdia(int p, int q, char* vert)
{
	int i = p%n+1;
	while(i!=q)
	{
		if(vert[i]) return 1;
		i = i%n+1;
	}
	return 0;
}

int solve(char* vert, int nn, int p)
{
	int i, j, z, t, min, k;
	struct list* pList = dia[p].next;
	char vert2[MAXN];
	for(i=1;i<=n;i++)
		vert2[i] = vert[i];
	min = nn;
	t = 0;
	if(nn<3) return 0;
	i = p;
	if(nn == 3) return 1;
	for(i=1;i<=n;i++)
		if(vert[i])
		{
			pList = dia[i].next;
	while(pList!=NULL)
	{
		if((diagon[i][pList->v])&&(vert[pList->v]))
		{
			k = 0;
			z = i%n+1;
			while(z!=pList->v)
			{
				if(vert[z]) k++;
				vert2[z] = 0;
				z = z%n+1;
			}
			diagon[i][pList->v] = 0;
			diagon[pList->v][i] = 0;
			if(k>0)
				t = solve(vert2, nn-k, pList->v);
			k = 0;
			for(z=p+1;z<=pList->v-1;z++)
			{
				vert2[z] = vert[z];
			}
			z = pList->v%n+1;
			while(z!=i)
			{
				if(vert[z]) k++;
				vert2[z] = 0;
				z = z%n+1;
			}
			if(k>0)
				t += solve(vert2, nn-k, p);
			if((t>0)&&(t<min))
			{
				min = t;
				pres++;
				result[pres].x = i;
				result[pres].y = pList->v;
			}
			for(z=1;z<=n;z++)
				vert2[z] = vert[z];
			diagon[i][pList->v] = 1;
			diagon[pList->v][i] = 1;
		}
		pList = pList->next;
	}
		}
	return min;
}

void gen()
{
	int i, j;
	for(i=1;i<=n;i++)
		for(j=i+2;j<=n;j++)
		{
			if((i+1!=j)&&(j%n+1!=i))
			{
				if(check(i, j))
				{
					list_add(i, j);
					list_add(j, i);
				}
			}
		}
}

void print_dia()
{
	int i;
	struct list* pList;
	for(i=1;i<=n;i++)
	{
		pList = dia[i].next;
		while(pList!=NULL)
		{
			printf("%d %d\n", i, pList->v);
			pList = pList->next;
		}
	}
}

void writedata()
{
	int i;
	printf("%d\n", res);
	printf("%d\n", pres);
	for(i=1;i<=pres;i++)
	{
		printf("%d %d ", a[result[i].x].x, a[result[i].x].y);
		printf("%d %d", a[result[i].y].x, a[result[i].y].y);
		printf("\n");
	}
}

int main()
{
	init();
	readdata();
	gen();
	res = solve(vert, n, 1);
	writedata();
	//print_dia();
	return 0;
}