{$R-,S-,I-,Q-}
{ $define debug}
{$define input}
{ $define output}
{$ifndef debug} {$define input} {$define output} {$endif}
procedure Done (ec :longint); forward;
const
  fname = 'reform'; finp = fname + '.in'; fout = fname + '.out';
{$ifdef debug}
{$else}
{$endif}
  polymax = 1024*1024*2-1;
  max = 2*polymax+4;

type
  TPoly = 0..polymax;

var
  k,ve1,ve2,l :array [TPoly] of longint;
  q :array [0..max-1] of TPoly;
  qs,qe :longint;

procedure PUSH (p :TPoly; v1,v2,ll :longint);
begin qe := (qe+1) mod max; q[qe]:=p; ve1[p]:=v1; ve2[p]:=v2; l[p]:=ll; end;
procedure PUSHTop (p :TPoly; v1,v2,ll :longint);
begin q[qs]:=p; qs := (qs+max-1) mod max; ve1[p]:=v1; ve2[p]:=v2; l[p]:=ll; end;
function POP :TPoly; begin qs := (qs+1) mod max; POP := q[qs]; end;

var
  vx,vy :array [0..20] of longint;
  alog2 :array [TPoly] of byte;

function vp (i,j,k :longint) :longint;
begin
  vp := (vx[i]-vx[j])*(vy[j]-vy[k]) - (vx[j]-vx[k])*(vy[i]-vy[j]);
end;

function sonap (i,j,k :longint) :boolean;
begin
  if vp(j,i,k)<>0 then exit(false);
  if (vx[i]-vx[j]) <> 0
    then exit ((vx[i]-vx[j])*(vx[i]-vx[k]) > 0)
    else exit ((vy[i]-vy[j])*(vy[i]-vy[k]) > 0);
end;

var
  vlist :array [0..20] of integer;
  n,vm,i,j,ip,v1,v2,v3 :longint;
  pp,a,b :TPoly;

procedure ProcessPoly (p :TPoly);
  function testvert (a,b,c :longint) :boolean;
  begin
    for j := 0 to vm-1 do
      begin
        v1 := vp(vlist[a],vlist[b],vlist[j]);
          if v1=0 then continue else v1 := v1 div abs(v1);
        v2 := vp(vlist[b],vlist[c],vlist[j]);
          if v2=0 then continue else v2 := v2 div abs(v2);
        v3 := vp(vlist[c],vlist[a],vlist[j]);
          if v3=0 then continue else v3 := v3 div abs(v3);

        if (v1*v2>0) and (v1*v3>0) then exit(false);
      end;
    exit(true);
  end;
begin
  if k[p]<0 then exit; {Processed now!} k[p]:=-k[p];

  if p=0 then Done(-k[p]);

  vm:=0;
  pp:=p;
  while pp<>0 do
    begin
      a := ((pp xor (pp-1)) + 1) shr 1; //First byte
      vlist[vm] := alog2[a];
      inc(vm);

      pp:=pp xor a;
    end;
  vlist[vm]:=vlist[0];

  for i := 0 to vm-1 do
    if (vp (vlist[(i+vm-1) mod vm],vlist[i],vlist[i+1])=0) or (vm<=3) then
      begin
        pp := p xor (longint(1) shl vlist[i]);
        if ((k[pp]>0) and (k[pp]>-k[p])) or (k[pp]=0) then
          begin
            k[pp]:=-k[p];
            PUSHTop(pp, -1, -1, p);
            exit;
          end;
      end;

  for i := 0 to vm-1 do
    begin
      ip := (i+vm-1) mod vm;
      if testvert (ip,i,i+1) then
        begin
          pp := p xor (longint(1) shl vlist[i]);
          if k[pp]=0 then
            begin
              k[pp]:=1-k[p];
              PUSH(pp, vlist[ip], vlist[i+1], p);
            end;
        end;
    end;
end;

procedure Run;
var
  i :longint;
begin
  for i := 0 to 20 do
    alog2[longint(1) shl i] := i;

  read(n);
  for i := 0 to n-1 do
    read(vx[i], vy[i]);

  PUSH(longint(1) shl n - 1, -1, -1, 0);

  while qs<>qe do
    begin
      pp := POP;
      ProcessPoly(pp);
    end;
end;

procedure WriteData (ec :longint);
var
  p :longint;
  v1,v2 :longint;
begin
  writeln(ec+1);
  writeln(ec);

  p:=0;
  while l[p]<>0 do
    begin
      if ve1[p]<>-1 then
        begin
          v1:=ve1[p]; v2:=ve2[p];
          while sonap (v1, (v1+1)   mod n, v2) do v1 := (v1+1)   mod n;
          while sonap (v1, (v1+n-1) mod n, v2) do v1 := (v1+n-1) mod n;
          while sonap (v2, (v2+1)   mod n, v1) do v2 := (v2+1)   mod n;
          while sonap (v2, (v2+n-1) mod n, v1) do v2 := (v2+n-1) mod n;

          writeln (vx[v1], ' ', vy[v1], ' ',
                   vx[v2], ' ', vy[v2]);
        end;
      p := l[p];
    end;
end;

procedure Done (ec :longint); begin WriteData(ec); close(input); close(output); halt(0); end;
begin
  {$ifdef input}  assign (input,  finp); reset  (input); {$endif}
  {$ifdef output} assign (output, fout); rewrite(output); {$endif}
  Run;
  Done(0);
end.
