
#include <iostream>
#include <fstream>
using namespace std;

int X[25], Y[25], N, Ans[24][4], NAns;
bool IsInVyp[25];

void MakeVyp()
{
	int lower_left = 0, next = -1, prev;
	for( int i = 0; i < N; ++i )
		if( X[i] < X[lower_left] ) 
			lower_left = i;
		else if( X[i] == X[lower_left] && Y[i] < Y[lower_left] )
			lower_left = i;
	prev = lower_left;
	while( next != lower_left )
	{
		next = ( prev + 1 ) % N;
		for( int i = 0; i < N; ++i )
		{			
			if( ( (X[next]-X[prev])*(Y[i]-Y[prev]) - (Y[next]-Y[prev])*(X[i]-X[prev]) ) > 0 )
				next = i;
		}
		IsInVyp[next] = true;
		prev = next;
	}
	for( int i = 0; i < N; ++i )
		if( IsInVyp[i] )
			cout << i << ' ';
	cout << endl;
}

bool CanBeDiag( int i1, int i2 )
{
	int m1, m2, m3, m4, dx = X[i2]-X[i1], dy = Y[i2]-Y[i1];
	for( int i = 0; i < N; ++i )
	{
		m1 = dx*(Y[ i ]-Y[i1]) - dy*(X[ i ]-X[i1]);
		m2 = dx*(Y[i+1]-Y[i1]) - dy*(X[i+1]-X[i1]);
		if( ( m1 < 0 && m2 > 0 ) || ( m1 > 0 && m2 < 0 ) )
		{
			m3 = (X[i+1]-X[i])*(Y[i1]-Y[i]) - (Y[i+1]-Y[i])*(X[i1]-X[i]),
			m4 = (X[i+1]-X[i])*(Y[i2]-Y[i]) - (Y[i+1]-Y[i])*(X[i2]-X[i]);
			if( ( m3 < 0 && m4 > 0 ) || ( m3 > 0 && m4 < 0 ) )
				return false;
		}
	}
	int i = 0;
	for( ; i == i1 || i == i2; ++i )
		;
	int s = (X[i2]-X[i1])*(Y[i]-Y[i1]) - (Y[i2]-Y[i1])*(X[i]-X[i1]);
	for( int i = 0; i < N; ++i )
	{
		if( i == i1 || i == i2 ) continue;
		m1 = (X[i2]-X[i1])*(Y[i]-Y[i1]) - (Y[i2]-Y[i1])*(X[i]-X[i1]);
		if( (m1>0 && s<0) || (m1<0 && s>0) )
			return true;
	}
	return false;
}

void FindUnavailable()
{
	for( int i = 0; i < N; ++i )
		for( int j = i+1; j < N; ++j )
		{
			if( !CanBeDiag( i, j ) )
				cout << i << ' ' << j << endl;
		}
}

void GenTriangles( int mask )
{
	int i1, i2, p1, p2;
	for( i1 = 0; i1 < N; ++i1 )
	{
		if( !(mask&(1<<i1)) ) continue;
		for( i2 = i1+1; !(mask&(1<<i2)) && i2 < N; ++i2 )
			;
		if( i2 == N ) break;
		for( p1 = 0; p1 < N; ++p1 )
		{
			if( p1 == i1 || p1 == i2 || !(mask&(1<<p1)) ) continue;
			p2 = p1;
			while( 1 )
			{
				for( p2++; !(mask&(1<<p2)) && p2 < N; ++p2 )
					;
				if( p2 == N ) break;
				if( p2 == i1 || p2 == i2 ) continue;
				else break;
			}
			if( p2 == N ) break;
			if( ( (X[i2]-X[i1])*(Y[p1]-Y[i1]) - (Y[i2]-Y[i1])*(X[p1]-X[i1]) == 0 ) &&
				( (X[i2]-X[i1])*(Y[p2]-Y[i1]) - (Y[i2]-Y[i1])*(X[p2]-X[i1]) == 0 ) )
			{
				Ans[NAns][0] = X[i2];
				Ans[NAns][1] = Y[i2];
				Ans[NAns][2] = X[p1];
				Ans[NAns][3] = Y[p1];
				NAns++;
				int mask1 = (1<<i1)|(1<<(p2)), mask2 = (1<<i2)|(1<<p1), l = i1-1;
				while( 1 )
				{
					if( l < 0 ) l = N-1;
					if( !(mask&(1<<l)) ) l--;
					else break;
				}
				int sign = (X[p2]-X[i1])*(Y[l]-Y[i1]) - (Y[p2]-Y[i1])*(X[l]-X[i1]);
				for( int i = 0; i < N; ++i )
				{
					if( i == i1 || i == i2 || i == p1 || i == p2 || !(mask&(1<<i)) ) continue;
					int m = (X[p2]-X[i1])*(Y[i]-Y[i1]) - (Y[p2]-Y[i1])*(X[i]-X[i1]);
					if( ( m>0 && sign>0 ) || ( m<0 && sign<0 ) ) mask1 |= (1<<i);
					else  mask2 |= (1<<i);
				}
				GenTriangles( mask1 );
				GenTriangles( mask2 );
				return;
			}
		}
	}

	for( i1 = 0; i1 < N; ++i1 )
	{
		if( !(mask&(1<<i1)) ) continue;
		for( i2 = i1+1; !(mask&(1<<i2)) && i2 < N; ++i2 )
			;
		if( i2 == N ) break;
		for( p1 = 0; p1 < N; ++p1 )
		{
			if( p1 == i1 || p1 == i2 || !(mask&(1<<p1)) ) continue;
			if( (X[i2]-X[i1])*(Y[p1]-Y[i1]) - (Y[i2]-Y[i1])*(X[p1]-X[i1]) == 0 )
			{
				Ans[NAns][0] = X[i2];
				Ans[NAns][1] = Y[i2];
				Ans[NAns][2] = X[p1];
				Ans[NAns][3] = Y[p1];
				NAns++;
				int mask1 = (1<<i1)|(1<<(p1)), mask2 = (1<<i2)|(1<<p1), l = i1-1;
				while( 1 )
				{
					if( l < 0 ) l = N-1;
					if( !(mask&(1<<l)) ) l--;
					else break;
				}
				int sign = (X[p1]-X[i1])*(Y[l]-Y[i1]) - (Y[p1]-Y[i1])*(X[l]-X[i1]);
				for( int i = 0; i < N; ++i )
				{
					if( i == i1 || i == i2 || i == p1 || !(mask&(1<<i)) ) continue;
					int m = (X[p1]-X[i1])*(Y[i]-Y[i1]) - (Y[p1]-Y[i1])*(X[i]-X[i1]);
					if( ( m>0 && sign>0 ) || ( m<0 && sign<0 ) ) mask1 |= (1<<i);
					else  mask2 |= (1<<i);
				}
				GenTriangles( mask1 );
				GenTriangles( mask2 );
				return;
			}
		}
	}

	int bits = 0;
	for( int i = 0; i < N; ++i )
		if( mask & (1<<i) ) ++bits;
	int need = bits - 3, g = 0, nnn;
	for( int i1 = 0; i1 < N && g < need; ++i1 )
	{
		if( !(mask&(1<<i1)) ) continue;
		int next = (i1+1)%N, prev = i1?i1-1:N-1;
		for( ; !(mask&(1<<next)); next = (next+1)%N );
		for( ; !(mask&(1<<prev)); prev ? --prev : prev=N-1 );
		for( int i2 = i1+1; i2 < N && g < need; ++i2 )
		{
			if( !(mask&(1<<i2)) ) continue;
			if( i2 == next || i2 == prev ) continue;
			if( CanBeDiag( i1, i2 ) )
			{
				Ans[NAns][0] = X[i1];
				Ans[NAns][1] = Y[i1];
				Ans[NAns][2] = X[i2];
				Ans[NAns][3] = Y[i2];
				NAns++;
				g++;
			}
		}
	}
}

int main()
{
	ifstream fi( "reform.in" );
	ofstream fo( "reform.out" );
	fi >> N;
	for( int i = 0; i < N; ++i )
		fi >> X[i] >> Y[i];
	X[N] = X[0]; Y[N] = Y[0];
	GenTriangles( (1<<N)-1 );
//	cout << NAns+1 << endl << NAns << endl;
	for( int i = 0; i < NAns; ++i )
		fo << Ans[i][0] << ' ' << Ans[i][1] << ' ' << Ans[i][2] << ' ' << Ans[i][3] << endl;
	return 0;
}