#include "stdio.h"
#include "list"
#include "queue"

#define INPUT_FILE "reform.in"
#define OUTPUT_FILE "reform.out"

#define MAX_N 20

using namespace std;

typedef struct
{
	int x, y;
	int t;
} POINT;


POINT points[ MAX_N ];
POINT pts[ MAX_N ];
list< int > source;
list< int > pol[ 7 ];
int polC;
int n;

int sd[ MAX_N ][ 2 ];
int sdC;


void Init()
{
	int i;


	freopen( INPUT_FILE, "r", stdin );
	freopen( OUTPUT_FILE, "w", stdout );

	scanf( "%ld", &n );
	for( i = 0; i < n; i++ )
	{
		scanf( "%ld %ld", &points[ i ].x, &points[ i ].y );
		pts[ i ] = points[ i ];
		source.push_back( i );
	}
}

POINT GetVec( POINT a, POINT b )
{
	POINT r;

	r.x = b.x - a.x;
	r.y = b.y - a.y;

	return r;
}

int VecMul( POINT a, POINT b )
{
	return (- b.x * a.y + b.y * a.x);
}

int InitPoint()
{
	int ans = 0;
	int i;
	for( i = 0; i < n; i++ )
	{
		POINT a, b;
		int p;

		p = ( i>0?i-1:n-1 );
		a = GetVec( points[ p ], points[ i ] );
		p = ( i<n-1?i+1:0 );
		b = GetVec( points[ i ], points[ p ] );
		if( VecMul( a, b ) > 0 )
		{
			points[ i ].t = 1;
		}
		else
		{
			points[ i ].t = -1;
			ans++;
		}
	}
	return ans;
}

void Parse( int s )
{
	queue< int > S;
	int i, j;
	int mc = 0;//  

	for( j = 0; j <= n; j++ )
	{
		i = (s + j) % n;
		if( points[ i ].t == 1 && mc == 1 && i == n - 1 )
		{
			pol[ polC ].push_back( i );
			polC++;
			sd[ sdC ][ 0 ] = S.back();
			sd[ sdC ][ 1 ] = i;
			sdC++;
			mc = 0;
			S.push( i );
		}
		if( points[ i ].t == 1 && mc == 0 )
		{
			S.push( i );
			continue;
		}
		if( points[ i ].t == -1 && mc == 0 )
		{
			mc = 1;
			S.push( i );
			pol[ polC ].push_back( i );
			continue;
		}
		if( points[ i ].t == 1 && mc == 1 )
		{
			pol[ polC ].push_back( i );
//			points[ i ] = points[ i - 1 ];
			continue;
		}
		if( points[ i ].t == -1 && mc == 1 )
		{
			pol[ polC ].push_back( i );
			polC++;
			sd[ sdC ][ 0 ] = S.back();
			sd[ sdC ][ 1 ] = i;
			sdC++;
			mc = 0;
			S.push( i );
			continue;
		}
	}

	while( !S.empty() )
	{
		pol[ polC ].push_back( S.front() );
		S.pop();
	}
	pol[ polC ].pop_back();

	list< int >::iterator p, p1, p2;
	for( p = pol[ polC ].begin(); p != pol[ polC ].end();  )
	{
		p1 = p;	p1++; if( p1 == pol[ polC ].end() ){ p1 = pol[ polC ].begin(); }
		p2 = p1; p2++; if( p2 == pol[ polC ].end() ){ p2 = pol[ polC ].begin(); }
		if( !VecMul( GetVec( points[ *p ], points[ *p1 ]  ), GetVec( points[ *p1 ], points[ *p2 ] ) ) )
		{
			pol[ polC ].erase( p1 );
		}
		else
		{
			p++;
		}
	}
/*	for( p = pol[ polC ].begin(); p != pol[ polC ].end(); p++ )
	{
		printf( "%ld", *p );
	}
*/	polC++;
}

int CalcAdmSub()
{
	int i;
	int ans = 0;

	for( i = 0; i < polC; i++ )
	{
		ans += pol[ i ].size() - 2;
	}

	return ans;
}

void PrintLP( int a, int b )
{
	printf( "%ld %ld %ld %ld\n", pts[ a ].x, pts[ a ].y, pts[ b ].x, pts[ b ].y );
}

void SDprint()
{
	int i;

	for( i = 0; i < sdC; i++ )
	{
		PrintLP( sd[ i ][ 0 ], sd[ i ][ 1 ] );
	}
}

void Triang( int x )
{
	int i;
	int s;
	list< int >::iterator p;

	p = pol[ x ].begin();
	s = *p;
	p++;

	for( i = 1; i < pol[ x ].size() - 2; i++ )
	{
		p++;
		PrintLP( s, *p );
	}
}

int FirstM()
{
	int i;

	for( i = 0; i < n; i++ )
	{
		if( points[ i ].t == -1 )return i;
	}
	return -1;
}

void Solve()
{
	int s = 0;
	int mC = InitPoint();
	if( mC == 1 )
	{
		s =( FirstM() + 2 ) % n;
		Parse( s );
	}
	else if( mC > 1 )
	{
		s = FirstM();
		Parse( s );
	}
	else
	{
		printf( "%ld\n", n - 2 );
		printf( "%ld\n", n - 3 );

		int i;
		for( i = 0; i < n; i++ )
		{
			pol[ 0 ].push_back( i );
		}
		Triang( 0 );
		return;
	}

	printf( "%ld\n", CalcAdmSub() );
	printf( "%ld\n", CalcAdmSub() - polC + sdC );

	SDprint();

	int i;

	for( i = 0; i < polC; i++ )
	{
		Triang( i );
	}
}

void Done()
{
	;
}

int main()
{
	Init();
	Solve();
	Done();
	
	return 0;
}