program tru6;

{$APPTYPE CONSOLE}

uses
  SysUtils;

const
  inf = 'reform.in';
  outf = 'reform.out';

type
  TPoint = record
    x, y: integer;
  end;

  TFig = array of TPoint;

function SQR2(x: TFig; n: integer): integer;
var
  i: integer;
begin
  result:=0;
  for i:=0 to n-1 do
    result:=result+x[i].x*x[(i+1) mod n].y-x[(i+1) mod n].x*x[i].y;
end;

function make4fig(x1, x2, x3, x4: TPoint): TFig;
begin
  setlength(result, 4);
  result[0]:=x1;
  result[1]:=x2;
  result[2]:=x3;
  result[3]:=x4;
end;

function make3fig(x1, x2, x3: TPoint): TFig;
begin
  setlength(result, 3);
  result[0]:=x1;
  result[1]:=x2;
  result[2]:=x3;
end;

var
  i, n, k, n2: integer;
  f, f2: TFig;
  answer: array of TPoint;

procedure addanswer(x: TPoint);
begin
  setlength(answer, length(answer)+1);
  answer[length(answer)-1]:=x;
end;

procedure delpoint(x: integer);
var
  i: integer;
begin
  x:=x mod n;
  dec(n);
  for i:=x to n-1 do
    f[i]:=f[i+1];
  setlength(f, n);
end;

procedure delpoint2(x: integer);
var
  i: integer;
begin
  x:=x mod n2;
  dec(n2);
  for i:=x to n-1 do
    f2[i]:=f2[i+1];
  setlength(f2, n2);
end;


function Candel(a: integer): boolean;
var
  t2: integer;
begin
  n2:=n;
  f2:=copy(f, 0, n);
  delpoint2(a+1);
  t2:=sqr2(f2, n2);
  result:=(sqr2(f, n) > t2) and (t2 > 0);
end;

function Candel2(a: integer): boolean;
var
  t: TFig;
  la: integer;
begin
  result:=candel(a);
  if not result then exit;
  la:=(a-1) mod n;
  while la < 0 do la:=la+n;
  t:=make4fig(f[la], f[a mod n], f[(a+2) mod n], f[(a+3) mod n]);
  result:=(sqr2(t, 4) = 0);
  setlength(t, 0);
end;

function delmany: boolean;
var
  i: integer;
begin
  result:=false;
  if n <= 5 then exit;
  i:=0;
  while i < n do
  begin
    if candel2(i) then
    begin
      addanswer(f[i]);
      addanswer(f[(i+2) mod n]);
      delpoint(i);
      delpoint(i);
      delpoint(i);
      result:=true;
    end else
      inc(i);
  end;
end;

procedure delfirst;
begin
  if n <= 3 then exit;
  i:=0;
  while i < n do
  begin
    if candel(i) then
    begin
      addanswer(f[i]);
      addanswer(f[(i+2) mod n]);
      delpoint(i+1);
      exit;
    end else
      inc(i);
  end;
end;

begin
  assign(input, inf); assign(output, outf);
  reset(input); rewrite(output);
  setlength(answer, 0);
  read(n);
  setlength(f, n);
  for i:=0 to n-1 do
    read(f[i].x, f[i].y);
    
  repeat until not delmany;

  while n > 3 do delfirst;

  k:=length(answer);
  k:=k div 2;

  writeln(k+1);
  write(k);

  for i:=0 to k-1 do
  begin
    writeln;
    write(answer[2*i].x, ' ', answer[2*i].y, ' ', answer[2*i+1].x, ' ', answer[2*i+1].y);
  end;

  close(input);
  close(output);
end.
