{$A8,B-,C+,D-,E-,F-,G+,H+,I-,J-,K-,L-,M-,N+,O+,P+,Q-,R-,S-,T-,U-,V+,W-,X+,Y+,Z1}
program P_6;

{$APPTYPE CONSOLE}

const
  MaxN = 21;
  Inf = 100;
type
  TPoint =
  record
    x, y : LongInt;
  end;
  TLine =
  record
    a, b, c : LongInt;
  end;
var                                                                                       
  n : LongInt;
  p : Array[1 .. MaxN] of TPoint;
  sm : Array[1 .. MaxN, 1 .. MaxN] of Boolean;
  rez : Array[1 .. 1 shl MaxN] of
  record
    a, b, r : Byte;
  end;
  col : LongInt;
  
Procedure Init;
var
  i : LongInt;
begin
  Reset(input, 'reform.in');
  Rewrite(output, 'reform.out');
  ReadLn(n);
  for i := 1 to n do
    ReadLn(p[i].x, p[i].y);
  n := 17;
  for i := 1 to n do
  begin
    p[i].x := i;
    p[i].y := 1 shl i;
  end;
end;

Procedure MakeLine(const a, b : TPoint; var l : TLine);
begin
  l.a := a.y - b.y;
  l.b := b.x - a.x;
  l.c := -(l.a * a.x + l.b * a.y);
end;

Function Podst(const a : TPoint; const l : TLine) : LongInt;
begin
  Podst := a.x * l.a + a.y * l.b + l.c;
end;

Function Dif(const a, b : TPoint; const l : TLine) : Boolean;
begin
  Dif := (Podst(a, l) = 0) or (Podst(b, l) = 0) or ((Podst(a, l) > 0) xor (Podst(b, l) > 0));
end;

Function Intersect(const a, b, c, d : TPoint) : Boolean;
var
  l1, l2 : TLine;
begin
  MakeLine(a, b, l1);
  MakeLine(c, d, l2);
  Intersect := (Dif(c, d, l1)) and (Dif(a, b, l2))
end;

Function Min(const a, b : LongInt) : LongInt;
begin
  if a < b then
    Min := a
  else
    Min := b;
end;

Function Max(const a, b : LongInt) : LongInt;
begin
  if a > b then
    Max := a
  else
    Max := b;
end;

Function Can(const a, b : LongInt) : Boolean;
var
  i : LongInt;
  l : TLine;
  bo1, bo2 : Boolean;
begin
  Can := False;
  MakeLine(p[a], p[b], l);
  for i := 1 to n do
    if (i <> a) and (i mod n + 1 <> a) and (i <> b) and (i mod n + 1 <> b) and (Intersect(p[i], p[i mod n + 1], p[a], p[b])) then
    begin
      p := p;
      p := p;
      Exit;
    end;
  bo1 := False;
  bo2 := False;
  for i := 1 to n do
    if Podst(p[i], l) <> 0 then
    begin
      if (i > Min(a, b)) and (i < Max(a, b)) then
        bo1 := Podst(p[i], l) > 0
      else
        bo2 := Podst(p[i], l) > 0;
    end;
  Can := bo1 xor bo2;
end;

Function IsInPoly(const i : Byte; const code : LongInt) : Boolean;
begin
  IsInPoly := Odd(code shr (i - 1));
end;

Procedure PrisvYes(const i : Byte; var code : LongInt);
begin
  if not IsInPoly(i, code) then
    Inc(code, 1 shl (i - 1));
end;

Procedure PrisvNo(const i : Byte; var code : LongInt);
begin
  if IsInPoly(i, code) then
    Dec(code, 1 shl (i - 1));
end;

Procedure MakeSm;
var
  i, j : LongInt;
begin
  for i := 1 to n do
    for j := 1 to n do
      sm[i][j] := Can(i, j);
end;

Procedure Divide(const code : LongInt; const a, b : Byte; var l, r : LongInt);
var
  i : Byte;
begin
  l := 0;
  r := 0;
  for i := 1 to n do
    if IsInPoly(i, code) then
    begin
      if (i >= a) and (i <= b) then
        PrisvYes(i, l);
      if (i <= a) or (i >= b) then
        PrisvYes(i, r);
    end;
end;

Function Sos(const r : LongInt; const a, b : Byte) : Boolean;
var
  i, p : Byte;
begin
  p := 0;
  for i := 1 to n do
    if IsInPoly(i, r) then
    begin
      if ((p = a) and (i = b)) or ((p = b) and (i = a)) then
      begin
        Sos := True;
        Exit;
      end;
      p := i;
    end;
  for i := 1 to n do
    if IsInPoly(i, r) then
    begin
      if ((p = a) and (i = b)) or ((p = b) and (i = a)) then
      begin
        Sos := True;
        Exit;
      end;
      p := i;
    end;
  Sos := False;
end;

Function Rec(const r : LongInt) : Byte;
var
  i, j, k : Byte;
  a, b : LongInt;
begin
  if rez[r].r = Inf then
  begin
    for i := 1 to n do
      if IsInPoly(i, r) then
        for j := i + 1 to n do
          if (IsInPoly(j, r)) and (sm[i][j]) and (not Sos(r, i, j)) then
          begin
            Divide(r, i, j, a, b);
            k := Rec(a) + Rec(b);
            if rez[r].r > k then
            begin
              rez[r].r := k;
              rez[r].a := i;
              rez[r].b := j;
            end;
          end;
  end;
  Rec := rez[r].r;
end;

Function IsIn3Ug(const code : LongInt) : Boolean;
var
  i, c, pred : Byte;
  l : Array[1 .. 3] of TLine;
begin
  c := 0;
  pred := 0;
  for i := 1 to n do
    if IsInPoly(i, code) then
    begin
      if pred = 0 then
      begin
        pred := i;
        Continue;
      end;
      if not (((c > 0) and (Podst(p[i], l[1]) = 0) and (Podst(p[pred], l[1]) = 0)) or ((c > 1) and (Podst(p[i], l[2]) = 0) and (Podst(p[pred], l[2]) = 0)) or ((c > 2) and (Podst(p[i], l[3]) = 0) and (Podst(p[pred], l[3]) = 0))) then
      begin
        Inc(c);
        if c > 3 then
          Break;
        MakeLine(p[pred], p[i], l[c]);
      end;
      pred := i;
    end;

    
  for i := 1 to n do
    if IsInPoly(i, code) then
    begin
      if pred = 0 then
      begin
        pred := i;
        Continue;
      end;
      if not (((c > 0) and (Podst(p[i], l[1]) = 0) and (Podst(p[pred], l[1]) = 0)) or ((c > 1) and (Podst(p[i], l[2]) = 0) and (Podst(p[pred], l[2]) = 0)) or ((c > 2) and (Podst(p[i], l[3]) = 0) and (Podst(p[pred], l[3]) = 0))) then
      begin
        Inc(c);
        if c > 3 then
          Break;
        MakeLine(p[pred], p[i], l[c]);
      end;
      pred := i;
    end;
        
  IsIn3Ug := c = 3;
end;

Procedure Pr(const now : LongInt; const wr : Boolean);
var
  x1, x2 : LongInt;
begin
  if rez[now].r = 1 then
    Exit;
  Divide(now, rez[now].a, rez[now].b, x1, x2);
  if wr then
    WriteLn(p[rez[now].a].x, ' ', p[rez[now].a].y, ' ', p[rez[now].b].x, ' ', p[rez[now].b].y);
  Pr(x1, wr);
  Pr(x2, wr);
  Inc(col);
end;

Procedure Solve;
var
  i, r : LongInt;
begin
  MakeSm;
  r := 0;
  for i := 1 to n do
    PrisvYes(i, r);
  for i := 0 to 1 shl n - 1 do
    if IsIn3Ug(i) then
      rez[i].r := 1
    else
      rez[i].r := Inf;
  WriteLn(Rec(r));
  col := 0;
  Pr(r, False);
  WriteLn(col);
  Pr(r, True);
end;

Procedure Print;
begin
  Close(input);
  Close(output);
end;

begin
  Init;
  Solve;
  Print;
end.
