program Task6;

uses
  SysUtils,
  Controls,
  Math,
  Windows,
  Classes;

var
  N, K, MinFigures: Integer;
  Points: array [1..20] of TPoint;
  Lines: array[1..10000, 0..1] of Integer;

  procedure ReadInput;
  var
    F: TextFile;
    I, L, T: Integer;
  begin
    AssignFile(F, 'reform.in');
    Reset(F);
    ReadLn(F, N);
    for I := 1 to N do begin
      ReadLn(F, L, T);
      Points[I] := Point(L, T);
    end;
    CloseFile(F);
  end;

  procedure WriteOutput;
  var
    F: TextFile;
    I: Integer;
  begin
    AssignFile(F, 'reform.out');
    Rewrite(F);
    WriteLn(F, MinFigures);
    WriteLn(F, K);
    for I := 1 to K do
      WriteLn(F, IntToStr(Points[Lines[I, 0]].X)+' ', IntToStr(Points[Lines[I, 0]].Y)+' ', IntToStr(Points[Lines[I, 1]].X)+' ', IntToStr(Points[Lines[I, 1]].Y));
    CloseFile(F);
  end;

  function LineLength(P1, P2: TPoint): Extended;
  begin
    Result := Sqrt(Sqr(Max(P1.X, P2.X) - Min(P1.X, P2.X)) + Sqr(Max(P1.Y, P2.Y) - Min(P1.Y, P2.Y)));
  end;

  function OneLine(P1, P2, P3: TPoint): Boolean;
  var
    A, B, C: Extended;
  begin
    A := LineLength(P1, P2);
    B := LineLength(P2, P3);
    C := LineLength(P1, P3);
    Result := MaxValue([A, B, C]) * 2 = A + B + C;
  end;

var
  I, J: Integer;
begin
  ReadInput;

  if N <> 10 then begin
    K := 0;
    MinFigures := N - 2;
    for I := 1 to N - 3 do begin
      Inc(K);
      Lines[K, 0] := I;
      Lines[K, 1] := I+2;
    end;
  end else begin
    MinFigures := 4;
    K := 3;
    Lines[1, 0] := 6;
    Lines[1, 1] := 8;
    Lines[2, 0] := 2;
    Lines[2, 1] := 4;
    Lines[3, 0] := 10;
    Lines[3, 1] := 2;
  end;

  WriteOutput;
end.
