#include <cstdio>
#include <vector>
#include <iterator>
#include <algorithm>

using namespace std;

typedef vector<pair<int, int> > poly;

poly p;
vector<pair<pair<int, int>, pair<int, int> > > ans;
int N;

bool lay(pair<int, int> x, pair<int, int> a, pair<int, int> b){
	return ((x.first-a.first)*(b.second-a.second)-(b.first-a.first)*(x.second-a.second)==0)&&
		((x.first-a.first)*(x.first-b.first)<=0)&&
		((x.second-a.second)*(x.second-b.second)<=0);
}

bool cross(pair<int, int> a1, pair<int, int> a2, pair<int, int> b1, pair<int, int> b2){
	int v1, v2;
	v1=(b1.first-a1.first)*(a2.second-a1.second)-(a2.first-a1.first)*(b1.second-a1.second);
	v2=(b2.first-a1.first)*(a2.second-a1.second)-(a2.first-a1.first)*(b2.second-a1.second);
	if ((v1>=0&&v2>=0)||(v1<=0&&v2<=0)) return false;
	v1=(a1.first-b1.first)*(b2.second-b1.second)-(b2.first-b1.first)*(a1.second-b1.second);
	v2=(a2.first-b1.first)*(b2.second-b1.second)-(b2.first-b1.first)*(a2.second-b1.second);
	if ((v1>=0&&v2>=0)||(v1<=0&&v2<=0)) return false;
	return true;
}


struct Less{
	bool operator()(pair<int, int> &a, pair<int, int> &b){
		return a.first>b.first;
	}
};

void rec(poly p){
	int i, j, k, t, q, n=p.size(), s1, s2;
	if (n<=2) return;
	pair<int, int> col[8000];
  for (i=0; i<n; i++)
		for (j=0; j<n; j++)
			for (k=0; k<n; k++){
				col[i*n*n+j*n+k].second=i*n*n+j*n+k;
				col[i*n*n+j*n+k].first=-1;
				if (i>=j||i>=k||j>=k) continue;
				col[i*n*n+j*n+k].first=0;
				for (t=0; t<n; t++)
					col[i*n*n+j*n+k].first+=(t!=i&&t!=j&&t!=k)&&(lay(p[t], p[i], p[j])||lay(p[t], p[j], p[k])||lay(p[t], p[k], p[i]));
				s1=s2=0;
				for (t=i; t!=j; t=(t+1)%n){
					if (cross(p[i], p[j], p[t], p[(t+1)%n])) 
						col[i*n*n+j*n+k].first=-1;
					s1+=(p[t].first-p[i].first)*(p[(t+1)%n].second-p[i].second)-(p[(t+1)%n].first-p[i].first)*(p[t].second-p[i].second);
				}
				for (t=j; t!=i; t=(t+1)%n){
					if (cross(p[i], p[j], p[t], p[(t+1)%n])) 
						col[i*n*n+j*n+k].first=-1;
					s2+=(p[t].first-p[i].first)*(p[(t+1)%n].second-p[i].second)-(p[(t+1)%n].first-p[i].first)*(p[t].second-p[i].second);
				}
				if ((s1<0&&s2>0)||(s1>0&&s2<0)) col[i*n*n+j*n+k].first=-1;
				s1=s2=0;
				for (t=j; t!=k; t=(t+1)%n){
					if (cross(p[j], p[k], p[t], p[(t+1)%n])) 
						col[i*n*n+j*n+k].first=-1;
					s1+=(p[t].first-p[j].first)*(p[(t+1)%n].second-p[j].second)-(p[(t+1)%n].first-p[j].first)*(p[t].second-p[j].second);
				}
				for (t=k; t!=j; t=(t+1)%n){
					if (cross(p[j], p[k], p[t], p[(t+1)%n])) 
						col[i*n*n+j*n+k].first=-1;
					s2+=(p[t].first-p[j].first)*(p[(t+1)%n].second-p[j].second)-(p[(t+1)%n].first-p[j].first)*(p[t].second-p[j].second);
				}
				if ((s1<0&&s2>0)||(s1>0&&s2<0)) col[i*n*n+j*n+k].first=-1;
				s1=s2=0;
				for (t=k; t!=i; t=(t+1)%n){
					if (cross(p[k], p[i], p[t], p[(t+1)%n])) 
						col[i*n*n+j*n+k].first=-1;
					s1+=(p[t].first-p[k].first)*(p[(t+1)%n].second-p[k].second)-(p[(t+1)%n].first-p[k].first)*(p[t].second-p[k].second);
				}
				for (t=i; t!=k; t=(t+1)%n){
					if (cross(p[k], p[i], p[t], p[(t+1)%n])) 
						col[i*n*n+j*n+k].first=-1;
					s2+=(p[t].first-p[k].first)*(p[(t+1)%n].second-p[k].second)-(p[(t+1)%n].first-p[k].first)*(p[t].second-p[k].second);
				}
				if ((s1<0&&s2>0)||(s1>0&&s2<0)) col[i*n*n+j*n+k].first=-1;
				s1=(p[i].first-p[k].first)*(p[j].second-p[k].second)-(p[j].first-p[k].first)*(p[i].second-p[k].second);
				if (s1==0) col[i*n*n+j*n+k].first=-1;
			}
	sort(&col[0], &col[n*n*n], Less());
	for (q=0; q<n*n*n; q++){
		if (col[q].first==-1) break;
		k=col[q].second%n;
		j=(col[q].second/n)%n;
		i=col[q].second/(n*n);
		poly tmp;
		//printf("%d %d %d %d\n", i, j, k, col[q].first);
		tmp.resize(0);
		char f=1, len=0;
		for (t=i; f||t!=i; t=(t+1)%n){
			f=0;
			tmp.push_back(p[t]);
			len++;
			if (lay(p[t], p[i], p[j])||lay(p[t], p[j], p[k])||lay(p[t], p[k], p[i])){
				if (tmp[0]!=p[t]&&len>1)
					ans.push_back(make_pair(tmp[0], p[t]));
				rec(tmp);
				tmp.resize(0);
				tmp.push_back(p[t]);
				len=0;
			}
		}
		return;
	}
}

int main(){
	freopen("reform.in", "rt", stdin);
	freopen("reform.out", "wt", stdout);
	int i, n;
	scanf("%d", &n);
	p.resize(n);
	N=n;
	for (i=0; i<n; i++)
		scanf("%d%d", &p[i].first, &p[i].second);
	rec(p);
	printf("%d\n%d\n", ans.size()+1, ans.size());
	for (i=0; i<ans.size(); i++)
		printf("%d %d %d %d\n", ans[i].first.first, ans[i].first.second, ans[i].second.first, ans[i].second.second);
	return 0;
}