#include <stdio.h>

#include <math.h>

#define GetBit(a, i) (((a) >> (i)) & 1)
#define AddBit(a, i) ((a) |= (1 << (i)))
#define DelBit(a, i) ((a) &= ~(1 << (i)))
#define eps 1e-9
typedef struct
{
	int x, y;
} VEC;

typedef struct
{
	int A, B, C;
} LINE;

typedef struct
{
	unsigned char a, b, cnt;
	int isok, newst, newcnt;
} DPST;

DPST DP[2000000];


LINE MakeLINE( VEC A, VEC B )
{
	LINE R;

	R.A = B.y - A.y;
	R.B = A.x - B.x;
	R.C = -(R.A * A.x + R.B * A.y);
	return R;
}

double GetL(VEC V, LINE L )
{
	return ((double)V.x) * L.A + ((double)V.y) * L.B + L.C;
}

int sign( double a )
{
	if (a < -eps)
		return -1;
	if (a > eps)
		return 1;
	return 0;
}

int IsInter( VEC A, VEC A1, VEC B, VEC B1 )
{
	LINE L1, L2;

	L1 = MakeLINE(A, A1);
	L2 = MakeLINE(B, B1);
	if (sign(GetL(A, L2)) * sign(GetL(A1, L2)) <= 0 &&
		sign(GetL(B, L1)) * sign(GetL(B1, L1)) <= 0)
		return 1;
	return 0;
}


int IsOnLINE( VEC A, VEC B, VEC C )
{
    LINE L;
	double a;
	L = MakeLINE(A, C);
	a = GetL(B, L);
	if (a >= -eps && a <= eps)
		return 1;
	return 0;

}


VEC P[20];
int N;
LINE Ln1[20][20];
int IsOk[20][20];
int Del[20];
int DN;
int dfs(int st, int cnt)
{
	int l, c, r, sl, i, min = 1000, minl, minr, oldst, t, tst, mc = 0;
	oldst = st;
	if (cnt <= 3)
{
		DP[st].cnt = 0;
		DP[st].isok = 1;
		return 0;
	}
	if (DP[st].isok == 1)
		return DP[st].cnt;
	l = 0;
	while (!GetBit(st, l))
		l++;
	c = l + 1;
	while (!GetBit(st, c))
		c++;
	r = c + 1;
	while (!GetBit(st, r))
		r++;
	sl = l;
	DN = 0;
	do
	{
		if (IsOnLINE(P[l], P[c], P[r]))
			Del[DN++] = c;
		l = c;
		c = r;
		r = (r + 1) % N;
		while (!GetBit(st, r))
			r = (r + 1) % N;
	} while (l != sl);
	for (i = 0; i < DN; i++)
		DelBit(st, Del[i]);
	cnt -= DN;
	if (cnt <= 3)
	{
		DP[oldst].cnt = 0;
		DP[oldst].isok = 1;
		return 0;
	}
	if (DP[st].isok == 1)
		return DP[st].cnt;
	
	

	l = 0;
	while (!GetBit(st, l))
		l++;
	c = l + 1;
	while (!GetBit(st, c))
		c++;
	r = c + 1;
	while (!GetBit(st, r))
		r++;
	sl = l;
	DN = 0;
	do
	{
		tst = st;
		DelBit(tst, c);
		if (IsOk[l][r] && GetL(P[c], Ln1[l][r]) > eps)
		{
			t = dfs(tst, cnt - 1) + 1;
			if (t < min)
				min = t, minl = l, minr = r, mc = c;
		}
		l = c;
		c = r;
		r = (r + 1) % N;
		while (!GetBit(st, r))
			r = (r + 1) % N;
	} while (l != sl);
	if (min == 1000)
		return 1000;
	DP[oldst].a = minl;
	DP[oldst].b = minr;
	DP[oldst].cnt = min;
	DP[oldst].newcnt = cnt - 1;
	DP[oldst].isok = 1;
	DelBit(st, mc);
	DP[oldst].newst = st;
	return min;
}

void dfs1( int st, int cnt )
{
	if (DP[st].cnt <= 0)
		return;
	printf("%i %i %i %i\n", P[DP[st].a].x, P[DP[st].a].y, P[DP[st].b].x, P[DP[st].b].y);
	dfs1(DP[st].newst, DP[st].newcnt);
}

double GetD( double a, double b, double c, double d )
{
	return sqrt((a - c) * (a - c) + (b - d) * (b - d));
}

int IsOn( VEC A, VEC B, VEC C )
{
	return fabs(GetD(A.x, A.y, B.x, B.y) - GetD(A.x, A.y, C.x, C.y) - 
		GetD(C.x, C.y, B.x, B.y)) < eps;
}

int main( void )
{
	int i, j, k, a, b, st, t;
	double d;

	freopen("reform.in", "rt", stdin);
	freopen("reform.out", "wt", stdout);
	scanf("%i", &N);
	for (i = 0; i < N; i++)
		scanf("%i%i", &P[i].x, &P[i].y);
	for (i = 0; i < N; i++)
		for (j = 0; j < N; j++)
			Ln1[i][j] = MakeLINE(P[i], P[j]);

	for (i = 0; i < N; i++)
		for (j = i + 2; j < N; j++)
		{
			IsOk[i][j] = 1;
			for (k = 0; k < N; k++)
			{
				a = k;
				b = (k + 1) % N;
				if (a != i && a != j && b != i && b != j)
					if (IsInter(P[i], P[j], P[a], P[b]))
						IsOk[i][j] = 0;
				if (a != i && a != j && IsOn(P[i], P[j], P[a]))
					IsOk[i][j] = 0;
			}
			
			IsOk[j][i] = IsOk[i][j];
		}

	st = 0;
	for (i = 0; i < N; i++)
		AddBit(st, i);

	printf("%i\n", t = (dfs(st, N) + 1));
	printf("%i\n", t - 1);
	dfs1(st, N);
	
	return 0;
}
