#include <cstdio>
#include <cstring>

const int MAX = 30;

struct Point
{
	int x, y;
	Point(int _x, int _y) : x(_x), y(_y)
	{}
	Point() : x(0), y(0)
	{}
};

struct Polygon
{
	Point ps[MAX];
	Polygon()
	{
		memset(ps, 0, sizeof(ps));
	}
};

int cnt;
Polygon p;

int vecProd(Point &p1, Point &p2)
{
	return p1.x * p2.y - p2.x * p1.y;
}

bool checkConvex()
{
	for ( int i = 0; i < cnt - 1; ++i )
	{
		Point p1(p.ps[i+1].x - p.ps[i].x, p.ps[i+1].y - p.ps[i].y), 
			p2(p.ps[i+2].x - p.ps[i+1].x, p.ps[i+2].y - p.ps[i+1].y);
		if ( vecProd(p1, p2) < 0 )
			return false;
	}
	return true;
}

int main()
{
	freopen("reform.in", "r", stdin);
	freopen("reform.out", "w", stdout);
	scanf("%d", &cnt);
	for ( int i = 0; i < cnt; ++i )
		scanf("%d %d", &p.ps[i].x, &p.ps[i].y);
	if ( checkConvex() )
	{
		printf("%d\n%d\n", cnt - 2, cnt - 3);
		for ( int i = 2; i < cnt - 1; ++i )
			printf("%d %d %d %d\n", p.ps[0].x, p.ps[0].y, p.ps[i].x, p.ps[i].y);
	}
	else
	{
		printf("%d\n%d\n", cnt / 4 + 2, cnt / 4 + 1);
		for ( int i = 1; i < cnt; i += 4 )
		{
			int j = (i + 2) % cnt;
			printf("%d %d %d %d\n", p.ps[i].x, p.ps[i].y, p.ps[j].x, p.ps[j].y);
		}
	}
	return 0;
}