program z6;
{$APPTYPE CONSOLE}
{$O-}
uses SysUtils, math;
type
 TVertex = record
  x,y :integer;//:real;
  prevLA :extended;
  fl :byte;
 end;

var
 polyL :integer;
 poly :array of TVertex;

 linesNum,trisNum :integer;
 linesStr :array of string;

const
 flExt = 1;
 flApx = 2;

function getV(i :integer) :integer;
begin
 if i >= 0 then
  result := i mod polyL else
  result := polyL-1 + ((i+1) mod polyL);
end;

procedure delV(i :integer);
var
 j :integer;
begin
// move(poly[i+1],poly[i],(polyL-i-1)*sizeof(poly[0]));
 for j := i+1 to polyL-1 do poly[j-1] := poly[j];
 dec(polyL);
 setLength(poly,polyL);
end;

procedure updatePoly;
var
 i,pv,nv :integer;
begin
 for i := 0 to polyL-1 do with poly[i] do
 with poly[i] do
 begin
  pv := getV(i-1);
  if (x-poly[pv].x) = 0 then
   prevLA := pi/2 else
  prevLA := arctan((y-poly[pv].y) / (x-poly[pv].x));
 end;

 for i := 0 to polyL-1 do with poly[i] do
 with poly[i] do
 begin
  fl := 0;
  pv := getV(i-1); nv := getV(i+1);
  if (x - poly[nv].x)*(poly[pv].y - poly[nv].y) < (y - poly[nv].y)*(poly[pv].x - poly[nv].x) then
   fl := fl or flExt;
 end;

 for i := 0 to polyL-1 do with poly[i] do
 with poly[i] do
 begin
  pv := getV(i-1); nv := getV(i+1);
  if (poly[pv].prevLA = poly[getV(i+2)].prevLA) and
     ((poly[pv].fl and flExt) = 0) and
     ((poly[nv].fl and flExt) = 0) and
     ((poly[ i].fl and flExt) = 1) then
   fl := fl or flApx;
 end;
end;

procedure print;
var
 i :integer;
begin
 writeln('Verts: ');
 for i := 0 to polyL-1 do
  writeln(poly[i].x,' ',poly[i].y,' ',poly[i].fl);
end;


procedure e;
begin readln; end;

procedure addResLine(const s :string);
begin
 setLength(linesStr,length(linesStr)+1);
 linesStr[high(linesStr)] := s;
end;

procedure cutAppendixes;
var
 i,pv,nv :integer;
begin
 i := 0;
 while i <= polyL-1 do
 if (poly[i].fl and flApx) <> 0 then
 begin
  pv := getV(i-1); nv := getV(i+1);

  inc(linesNum); inc(trisNum);
  addResLine(intToStr(poly[pv].x)+' '+intToStr(poly[pv].y)+' '+intToStr(poly[nv].x)+' '+intToStr(poly[nv].y));

  delV(i); delV(i);
  delV(getV(i-1));
  updatePoly;
  if polyL <= 3 then break;
 end else
  inc(i);
end;

procedure calcPoly;
var
 i,pv,nv :integer;
begin
 if polyL <= 3 then exit;
 cutAppendixes;

 // Cutting "internal" points
 i := 0;
 while i <= polyL-1 do
 if (poly[i].fl and flExt) = 0 then
 begin
  pv := getV(i-2);
  if (poly[getV(i-1)].fl and flExt) = 0 then
  begin inc(i); continue; end;

  inc(linesNum); inc(trisNum);
//  writeln(poly[pv].x,' ',poly[pv].y,' ',poly[i].x,' ',poly[i].y);
  addResLine(intToStr(poly[pv].x)+' '+intToStr(poly[pv].y)+' '+intToStr(poly[i].x)+' '+intToStr(poly[i].y));

  delV(getV(i-1));
  updatePoly;
  if polyL <= 3 then break;
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                               ;
  if polyL <= 3 then break;
  i := 0;
 end else
  inc(i);

 // Simple Triangulation
 while polyL > 3 do
 begin
  pv := getV(i-1); nv := getV(i+1);

  inc(linesNum); inc(trisNum);
//  writeln(poly[pv].x,' ',poly[pv].y,' ',poly[nv].x,' ',poly[nv].y);
  addResLine(intToStr(poly[pv].x)+' '+intToStr(poly[pv].y)+' '+intToStr(poly[nv].x)+' '+intToStr(poly[nv].y));

  delV(i);
 end;

end;

var
 f :textfile;
 i :integer;
begin
// exitProc := @e;
 assignfile(f,'reform.in');
 reset(f);
 readln(f,polyL);
 setLength(poly,polyL);
 fillChar(poly[0],polyL*sizeof(poly[0]),0);
 for i := 0 to polyL-1 do
  readln(f,poly[i].x,poly[i].y);
 closefile(f);

 linesNum := 0;
 trisNum := 0;
 
 updatePoly;
{
 print;
 writeln;
}
 calcPoly;
 inc(trisNum);

 assignfile(f,'reform.out');
 rewrite(f);
 writeln(f,trisNum);
 writeln(f,linesNum);
 for i := 0 to high(linesStr) do
  writeln(f,linesStr[i]);

 closefile(f);
end.
