{$N+}
type tpolygon=record
                size:longint;
                vs:array[0..20]of longint;
                where:array[0..20]of longint;
              end;
type tedges=record
              size:longint;
              vs:array[0..20]of record
                                  a,b:longint;
                                end;
            end;
const eps=1e-5;
      ang=pi/720;
var ds:tedges;
    o,nt,i,j,n:longint;
    first,x,y:array[1..20]of longint;
    polygon:tpolygon;
    next,ed:array[1..400]of longint;

function online(x,y,x1,y1,x2,y2:longint):boolean;
var d,d1,d2:extended;
begin
  online:=false;
  d:=sqrt(sqr(x2-x1)+sqr(y2-y1));
  d1:=sqrt(sqr(x-x1)+sqr(y-y1));
  d2:=sqrt(sqr(x-x2)+sqr(y-y2));
  if (abs(d-d1-d2)<eps)and(((x<>x1)or(y<>y1))and((x<>x2)or(y<>y2))) then
    online:=true;
end;

function cross(x1,y1,x2,y2,x3,y3,x4,y4:longint):boolean;
var a,b,c,d,e,f,t,s:extended;
begin
  cross:=true;
  if (x2-x1)*(y4-y3)-(x4-x3)*(y2-y1)=0 then
  begin
    if online(x1,y1,x3,y3,x4,y4) or online(x2,y2,x3,y3,x4,y4) or
       online(x3,y3,x1,y1,x2,y2) or online(x4,y4,x1,y1,x2,y2) then
       exit;
  end
  else
  begin
    a:=x2-x1;
    b:=x3-x4;
    c:=x3-x1;
    d:=y2-y1;
    e:=y3-y4;
    f:=y3-y1;
    t:=(c*e-b*f)/(a*e-b*d);
    s:=(a*f-c*d)/(a*e-b*d);
    if (t>eps)and(t<1-eps)and(s>eps)and(s<1-eps) then
      exit;
  end;
  cross:=false;
end;

function cross2(x1,y1,x2,y2,x3,y3,x4,y4:extended):boolean;
var a,b,c,d,e,f,t,s:extended;
begin
  cross2:=true;
  if (x2-x1)*(y4-y3)-(x4-x3)*(y2-y1)=0 then
  else
  begin
    a:=x2-x1;
    b:=x3-x4;
    c:=x3-x1;
    d:=y2-y1;
    e:=y3-y4;
    f:=y3-y1;
    t:=(c*e-b*f)/(a*e-b*d);
    s:=(a*f-c*d)/(a*e-b*d);
    if (t>eps)and(t<1-eps)and(s>eps)and(s<1+eps) then
      exit;
  end;
  cross2:=false;
end;

function inpolygon(xx,yy:extended):boolean;
var x1,y1,x2,y2:extended;
    i,cnt:longint;
begin
  x1:=xx;
  y1:=yy;
  x2:=xx+sin(ang)*20000;
  y2:=yy+cos(ang)*20000;
  cnt:=0;
  for i:=1 to n do
    if cross2(x1,y1,x2,y2,x[i],y[i],x[i+1],y[i+1]) then
      inc(cnt);
  inpolygon:=true;
  if cnt mod 2=0 then
    inpolygon:=false;
end;


function inner(x1,y1,x2,y2:longint):boolean;
var i:longint;
begin
  inner:=false;
  for i:=1 to n do 
    if cross(x1,y1,x2,y2,x[i],y[i],x[i+1],y[i+1]) then
      exit;
  inner:=true;
end;

procedure find(var polygon:tpolygon;var nt:longint;var ds:tedges);
var ll,lst,frst,aa,left,right,t,lnt,rnt,last,mint,ca,cb,i,j,a,b,l,size:longint;
    clds,lds,crds,rds:tedges;
    lpolygon:tpolygon;
begin
  if polygon.size=3 then
  begin
    nt:=1;
    ds.size:=0;
    exit;
  end;
  fillchar(polygon.where,sizeof(polygon.where),0);
  for i:=1 to polygon.size do
    polygon.where[polygon.vs[i]]:=i;
  mint:=maxlongint div 4;
  for i:=1 to polygon.size do
  begin
    j:=first[polygon.vs[i]];
    left:=i;
    ll:=left;
    a:=polygon.vs[i];
    aa:=a;
    while j<>0 do
    begin
      a:=aa;
      left:=ll;
      b:=ed[j];
      right:=polygon.where[b];
      if (right<>0)and(abs(left-right)>1)and(abs(left-right)<polygon.size-1) then
      begin
        fillchar(lpolygon,sizeof(lpolygon),0);
        l:=left;
        size:=0;
        while l<>right do
        begin
          inc(size);
          lpolygon.vs[size-1]:=polygon.vs[l];
          inc(l);
          if l=polygon.size+1 then
            l:=1;
        end;
        frst:=lpolygon.vs[1];
        last:=lpolygon.vs[size-1];
        lst:=size;
        lpolygon.vs[size]:=b;
        if not
        online(x[polygon.vs[right]],y[polygon.vs[right]],
               x[polygon.vs[left]],y[polygon.vs[left]],x[lpolygon.vs[frst]],y[lpolygon.vs[frst]])
        then
        begin
          inc(size);
          lpolygon.vs[size]:=a;
        end;
        if
        online(x[polygon.vs[left]],y[polygon.vs[left]],x[polygon.vs[right]],y[polygon.vs[right]],
               x[lpolygon.vs[last]],y[lpolygon.vs[last]])
        then
        begin
          lpolygon.vs[lst]:=lpolygon.vs[lst+1];
          dec(size);
        end;
        lpolygon.size:=size;
        find(lpolygon,lnt,lds);
        t:=left;
        left:=right;
        right:=t;
        t:=a;
        a:=b;
        b:=t;
        l:=left;
        size:=0;
        while l<>right do
        begin
          inc(size);
          lpolygon.vs[size-1]:=polygon.vs[l];
          inc(l);
          if l=polygon.size+1 then
            l:=1;
        end;
        frst:=lpolygon.vs[1];
        last:=lpolygon.vs[size-1];
        lst:=size;
        lpolygon.vs[size]:=b;
        if not online(x[polygon.vs[left]],y[polygon.vs[left]],x[polygon.vs[right]],y[polygon.vs[right]],
        x[frst],y[frst])
        then
        begin
          inc(size);
          lpolygon.vs[size]:=a;
        end;
        if
        online(x[polygon.vs[right]],y[polygon.vs[right]],x[polygon.vs[left]],y[polygon.vs[left]],
        x[last],y[last])
        then
        begin
          lpolygon.vs[lst]:=lpolygon.vs[lst+1];
          dec(size);
        end;
        lpolygon.size:=size;
        find(lpolygon,rnt,rds);
        if rnt+lnt<mint then
        begin
          mint:=rnt+lnt;
          clds:=lds;
          crds:=rds;
          ca:=a;
          cb:=b;
        end;
      end;
      j:=next[j];
    end;
  end;  
  if mint<>maxlongint then
  begin
    nt:=mint;
    ds.size:=clds.size+crds.size+1;
    for i:=1 to clds.size do
      ds.vs[i]:=clds.vs[i];
    for i:=1 to crds.size do
      ds.vs[clds.size+i]:=crds.vs[i];
    ds.vs[ds.size].a:=ca;
    ds.vs[ds.size].b:=cb;
  end;
end;

begin
  assign(input,'reform.in');
  reset(input);
  read(n);
  for i:=1 to n do
    read(x[i],y[i]);
  x[n+1]:=x[1];
  y[n+1]:=y[1];
  close(input);
  o:=0;
  for i:=1 to n-1 do
    for j:=i+2 to n do
      if (i<>1)or((i=1)and(j<>n)) then
        if (inner(x[i],y[i],x[j],y[j]))and(inpolygon((x[i]+x[j])/2,(y[i]+y[j])/2)) then
        begin
          inc(o);
          ed[o]:=j;
          if first[i]<>0 then
            next[o]:=first[i];
          first[i]:=o;
        end;
  for i:=1 to n do
    polygon.vs[i]:=i;
  polygon.size:=n;
  find(polygon,nt,ds);
  assign(output,'reform.out');
  rewrite(output);
  writeln(nt);
  writeln(ds.size);
  for i:=1 to ds.size do
    writeln(x[ds.vs[i].a],' ',y[ds.vs[i].a],' ',x[ds.vs[i].b],' ',y[ds.vs[i].b]);
  close(output);
end.