#include <fstream>
#include <utility>
#include <list>
using namespace std;

ifstream I("reform.in");
ofstream O("reform.out");

int N;
int _X[60],_Y[60],*X=_X+20,*Y=_Y+20;
int isdiag[20][20]={};

list<pair<int,int> > diags[20][20];
int minobl[20][20]={};

//edges (v1;v1+1),(v2;v2+1) are on the same line
bool oneline(int v1,int v2){
	int e1x=X[v1+1]-X[v1];
	int e1y=Y[v1+1]-Y[v1];
	int e2x=X[v2+1]-X[v2];
	int e2y=Y[v2+1]-Y[v2];
	int dx=X[v2]-X[v1];
	int dy=Y[v2]-Y[v1];
	if(e1x*e2y-e1y*e2x==0 && e1x*dy-e1y*dx==0) return true;
	else return false;
}

//vertices v1, v1+1, v2 are on the same line
bool oneline3(int v1,int v2){
	int e1x=X[v1+1]-X[v1];
	int e1y=Y[v1+1]-Y[v1];
	int dx=X[v2]-X[v1];
	int dy=Y[v2]-Y[v1];
	if(e1x*dy-e1y*dx==0) return true;
	else return false;
}

template<class T>
T minx(T a,T b){
	if(a<b) return a;
	else return b;
}

template<class T>
T maxx(T a,T b){
	if(a>b) return a;
	else return b;
}

int sign(int x){
	if(x>0) return 1;
	else if(x==0) return 0;
	else return -1;
}

int svect(int v1,int v2,int v3){
	int x1=X[v2]-X[v1];
	int y1=Y[v2]-Y[v1];
	int x2=X[v3]-X[v2];
	int y2=Y[v3]-Y[v2];
	return sign(x1*y2-x2*y1);
}

int svect(int v1,int v2,int v3,int v4){
	int x1=X[v2]-X[v1];
	int y1=Y[v2]-Y[v1];
	int x2=X[v4]-X[v3];
	int y2=Y[v4]-Y[v3];
	return sign(x1*y2-x2*y1);
}

bool intersect(int v1,int v2,int v3,int v4){
	if(minx(X[v1],X[v2])>maxx(X[v3],X[v4]) ||
		maxx(X[v1],X[v2])<minx(X[v3],X[v4]) || 
		minx(Y[v1],Y[v2])>maxx(Y[v3],Y[v4]) ||
		maxx(Y[v1],Y[v2])<minx(Y[v3],Y[v4])) return false;
	//bounding boxes do intersect
	if(svect(v1,v2,v3)*svect(v1,v2,v4)<=0 &&
		svect(v3,v4,v1)*svect(v3,v4,v2)<=0) return true;
	return false;
}

int main(){
	I>>N;
	for(int i=0;i<N;i++) I>>X[i]>>Y[i],X[i+N]=X[i-N]=X[i],Y[i+N]=Y[i-N]=Y[i];
	for(int i=0;i<N;i++) for(int j=i+2;j<(i==0?N-1:N);j++)
		if(
		/////////////////////////////diag is in
		(svect(i,i+1,i,i-1)>=0 && svect(i,i+1,i,j)>=0 && svect(i,j,i,i-1)>=0) ||
		( svect(i,i+1,i,i-1)<0 && !(svect(i,i-1,i,j)>=0 && svect(i,j,i,i+1)>=0) )
		///////////////////////////////////////
		){
		for(int k=0;k<N;k++) if(k!=i && k!=j && (k+1)%N!=i && (k+1)%N!=j &&
			intersect(i,j,k,k+1))
			break;
		if(k==N)
			isdiag[i][j]=isdiag[j][i]=1;
	}
	int xyi=1;
	for(int l=2;l<N;l++) for(int i=0;i<N;i++){
		int j=(i+l)%N;
		if(l==2 && isdiag[i][j]){
			minobl[i][j]=1;
			continue;
		}
		int mind=0x1FFFFFFF;
		if(oneline3(i,j) && minobl[i+1][j]<mind){
			diags[i][j]=diags[i+1][j];
			mind=minobl[i+1][j];
		}
		if(oneline3(j-1,i) && minobl[i][j-1]<mind){
			diags[i][j]=diags[i][j-1];
			mind=minobl[i][j-1];
		}
		for(int k=i+2;k<j;k++) if(oneline(i,k-1) && (isdiag[i+1][k-1] || i+1+1==k-1 || i+1==k-1+1)
		 && oneline(j-1,k) && (isdiag[j-1][k+1] || j-1+1==k-1 || j-1==k-1+1)
			&& mind>1+minobl[i+1][k-1]+minobl[k+1][j-1]){
				diags[i][j]=diags[i+1][k-1];
				diags[i][j].insert(diags[i][j].end(),diags[k+1][j-1].begin(),diags[k+1][j-1].end());
				diags[i][j].push_back(make_pair(i+1,k-1));
				diags[i][j].push_back(make_pair(k+1,j-1));
				mind=1+minobl[i+1][k-1]+minobl[k+1][j-1];
			}
		for(int k=i+2;k<j;k++) if(oneline3(i,k) && isdiag[i+1][k]
		 && oneline3(j-1,k) && isdiag[j-1][k]
			&& mind>1+minobl[i+1][k]+minobl[k][j-1]){
				diags[i][j]=diags[i+1][k-1];
				diags[i][j].insert(diags[i][j].end(),diags[k][j-1].begin(),diags[k][j-1].end());
				diags[i][j].push_back(make_pair(i+1,k));
				diags[i][j].push_back(make_pair(k,j-1));
				mind=1+minobl[i+1][k]+minobl[k][j-1];
			}
		for(int k=i+2;k<j;k++) if(isdiag[i][k]
		&& mind>minobl[i][k]+minobl[k][j]){
				diags[i][j]=diags[i][k];
				diags[i][j].insert(diags[i][j].end(),diags[k][j].begin(),diags[k][j].end());
				diags[i][j].push_back(make_pair(i,k));
				mind=minobl[i][k]+minobl[k][j];
		}
		minobl[i][j]=mind;
	}
	O<<minobl[0][N-1]<<endl;
	O<<diags[0][N-1].size()<<endl;
	for(list<pair<int,int> >::iterator it=diags[0][N-1].begin();it!=diags[0][N-1].end();it++)
		O<<"["<<it->first<<","<<it->second<<"]"<<X[it->first]<<" "<<Y[it->first]<<" "<<X[it->second]<<" "<<Y[it->second]<<endl;
}