#include <fstream>
#include <iostream>
using namespace std;

int n;

struct way
{
   bool comp;
   int from;
   int v; // by
   int num, m;
   way() {comp=false;}
};
way ways [1<<20];

int x [57];
int y [57];

inline bool hasv ( int poly, int v )
{
   return ( poly & ( 1 << v ) ) != 0;
}

int prevv ( int poly, int v )
{
   int p = v-1;
   if ( p < 0 )
      p = n-1;
   while ( !hasv ( poly, p ) )
   {
      p--;
      if ( p < 0 )
         p = n-1;
   }
   return p;
}
int nextv ( int poly, int v )
{
   int p = v+1;
   if ( p >= n )
      p = 0;
   while ( !hasv ( poly, p ) )
   {
      p++;
      if ( p >= n )
         p = 0;
   }
   return p;
}
int numv ( int poly )
{
   int n = 0;
   while ( poly > 0 )
   {
      n += ( poly & 1 );
      poly >>= 1;
   }
   return n;
}

inline int vecprod ( int a, int b, int c )
{
   return ( x [b] - x [a] ) * ( y [c] - y [b] ) -
          ( x [c] - x [b] ) * ( y [b] - y [a] );
}
inline int scprod ( int a, int b, int c )
{
   return ( x [b] - x [a] ) * ( x [c] - x [b] ) +
          ( y [b] - y [a] ) * ( y [c] - y [b] );
}
inline int delvert ( int poly, int v )
{
   return poly & ( ~ ( 1 << v ) );
}

int cutv ( int poly, int v )
{
   if ( !hasv ( poly, v ) )
      return -1;
   int p = prevv ( poly, v ), n = nextv ( poly, v );
   if ( vecprod ( p, v, n ) <= 0 )
      return -1;

   int m = nextv ( poly, n );
   int pm = n;
   int m1 = m;
   while ( m != p )
   {
      // if contains
      int vp1 = vecprod ( p, v, m );
      int vp2 = vecprod ( n, p, m );
      int vp3 = vecprod ( v, n, m );
      if ( vp1 >= 0 && vp2 >= 0 && vp3 >= 0 )
         return -1;
      pm = m;
      m = nextv ( poly, m );
   }
   int m2 = pm;

   // ok, can cut

   poly = delvert ( poly, v );
   if ( vecprod ( p, n, m1 ) == 0 )
      poly = delvert ( poly, n );
   if ( vecprod ( m2, p, n ) == 0 )
      poly = delvert ( poly, p );

   return poly;
}

int comp_poly ( int poly )
{
   if ( ways [poly].comp )
      return ways [poly].num;
   int num_v = numv ( poly );
   if ( num_v <= 3 )
   {
      ways [poly].comp = true;
      ways [poly].num = 1;
      ways [poly].from = -1;
      ways [poly].m = 0;
      return 1;
   }
   int best = 10000;
   for ( int v = 0; v < n; v++ )
   {
      if ( hasv ( poly, v ) )
      {
         int ct = cutv ( poly, v );
         if ( ct >= 0 )
         {
            int num = comp_poly ( ct ) + 1;
            if ( num < best )
            {
               ways [poly].num = num;
               ways [poly].v = v;
               ways [poly].from = ct;
               ways [poly].m = ways [ct].m + 1;
               best = num;
            }
         }
      }
   }
   ways [poly].comp = true;
   return best;
}

int main ()
{
   ifstream fin ( "reform.in" );
   ofstream fout ( "reform.out" );

   fin >> n;
   for ( int i = 0; i < n; i++ )
      fin >> x [i] >> y [i];

   int big_poly = (1<<n)-1;
   comp_poly ( big_poly );

   fout << ways [big_poly].num << endl;
   fout << ways [big_poly].m << endl;
   int cur = big_poly;
   while ( true )
   {
      if ( ways [cur].from >= 0 )
      {
         int v = ways [cur].v;
         int nv = nextv ( cur, v );
         int pv = prevv ( cur, v );
         fout << x [pv] << " " << y [pv] << " " << x [nv] << " " << y [nv] << endl;
         cur = ways [cur].from;
      }
      else
         break;
   }

   return 0;
}
