{$apptype console}

const
 maxn = 22;
 maxp = 1100255;
 eps = 1e-9;

var
 n, i, k: integer;
 x, y: array [0..maxn] of extended;
 s, f: array [0..maxn] of integer;
 d, mode, i1, i2: array [0..maxp] of shortint;
 pa1, pa2: array [0..maxp] of integer;

function los(x1, y1, x2, y2, x3, y3: extended): boolean;
 begin
   los := (abs((x2 - x1) * (y3 - y1) - (x3 - x1) * (y2 - y1)) <= eps) and 
          (((x1 <= x3 + eps) and (x2 >= x3 - eps)) or ((x1 >= x3 - eps) and (x2 <= x3 + eps))) and 
          (((y1 <= y3 + eps) and (y2 >= y3 - eps)) or ((y1 >= y3 - eps) and (y2 <= y3 + eps)));
 end;

function cross(xa1, ya1, xa2, ya2, xb1, yb1, xb2, yb2: extended): boolean;
 var
  a1, b1, c1, a2, b2, c2: extended;
 begin
   a1 := ya2 - ya1;
   b1 := xa1 - xa2;
   c1 := -(a1 * xa1 + b1 * ya1);
   a2 := yb2 - yb1;
   b2 := xb1 - xb2;
   c2 := -(a2 * xb1 + b2 * yb1);
   cross := ((a1 * xb1 + b1 * yb1 + c1) * (a1 * xb2 + b1 * yb2 + c1) <= eps) and 
            ((a2 * xa1 + b2 * ya1 + c2) * (a2 * xa2 + b2 * ya2 + c2) <= eps);
 end;

function test2(k: integer; p: array of integer; tx, ty: extended): boolean;
 var
  pa, pb, pc, na, nb, nc, ta, tb, tc, d, rx, ry: extended;
  i, res, a, b, f: integer;
 begin
   repeat
     repeat
       pa := random - 0.5;
       pb := random - 0.5;
     until sqr(pa) + sqr(pb) >= eps;
     na := -pb;
     nb := pa;
     pc := -(pa * tx + pb * ty);
     nc := -(na * tx + nb * ty);
     res := 0;
     f := 1;
     for i := 0 to k - 1 do begin
       a := p[i];
       b := p[(i + 1) mod k];
       ta := y[b] - y[a];
       tb := x[a] - x[b];
       tc := -(ta * x[a] + tb * y[a]);
       d := pa * tb - ta * pb;
       if abs(d) < eps then
         continue;
       rx := -(pc * tb - tc * pb) / d;
       ry := -(pa * tc - ta * pc) / d;
       if not los(x[a], y[a], x[b], y[b], rx, ry) then
         continue;
       if na * rx + nb * ry + nc >= eps then
         inc(res);
     end;
     if f = 0 then
       continue;
     break;
   until false;
   test2 := (res and 1) <> 0;
 end;

function dfs(pr: integer): integer;
 var
  i, j, k, a, b, c, f, pr1, pr2, res, r1, r2: integer;
  p: array [0..maxn] of integer;
 begin
   if d[pr] <> -1 then begin
     dfs := d[pr];
     exit;
   end;
   k := 0;
   for i := 0 to n - 1 do
     if pr and (1 shl i) <> 0 then begin
       p[k] := i;
       inc(k);
     end;
{
   for i := 0 to n - k - 1 do
     write(' ');
   write('DFS: ');
   for i := 0 to n - 1 do
     if pr and (1 shl i) <> 0 then
       write('1')
     else
       write('0');
   writeln('; k = ', k);
}
   if k <= 3 then begin
     d[pr] := 1;
     mode[pr] := 0;
     dfs := 1;
     exit;
   end;
   for i := 0 to k - 1 do begin
     a := i;
     b := (i + 1) mod k;
     c := (i + 2) mod k;
     if los(x[p[a]], y[p[a]], x[p[c]], y[p[c]], x[p[b]], y[p[b]]) then begin
       d[pr] := dfs(pr - (1 shl p[b]));
       mode[pr] := 1;
       pa1[pr] := pr - (1 shl p[b]);
       dfs := d[pr];
       exit;
     end;
   end;
   for i := 0 to k - 3 do
     for j := i + 2 to k - 1 do begin
       if (j + 1) mod k = i then
         continue;
       f := 1;
       for c := 0 to k - 1 do begin
         a := c;
         b := (c + 1) mod k;
         if (a = i) or (a = j) or (b = i) or (b = j) then
           continue;
         if cross(x[p[a]], y[p[a]], x[p[b]], y[p[b]], x[p[i]], y[p[i]], x[p[j]], y[p[j]]) then begin
           f := 0;
           break;
         end;
       end;
       if f = 0 then
         continue;
       if not test2(k, p, (x[p[i]] + x[p[j]]) / 2, (y[p[i]] + y[p[j]]) / 2) then
         continue;
       pr1 := 0;
       for c := i to j do
         pr1 := pr1 or (1 shl p[c]);
       pr2 := pr - pr1 + (1 shl p[i]) + (1 shl p[j]);
       r1 := dfs(pr1);
       if r1 = -1 then
         continue;
       r2 := dfs(pr2);
       if r2 = -1 then
         continue;
       res := r1 + r2;
       if (d[pr] = -1) or (d[pr] > res) then begin
         d[pr] := res;
         mode[pr] := 2;
         i1[pr] := p[i];
         i2[pr] := p[j];
//         writeln('RELAX! i = ', i, '; j = ', j);
         pa1[pr] := pr1;
         pa2[pr] := pr2;
       end;
     end;
{
   if d[pr] = -1 then begin
     writeln(erroutput, 'BONUS!');
     write(erroutput, 'pr = ');
     for i := 0 to n - 1 do
       if pr and (1 shl i) <> 0 then
         write(erroutput, '1')
       else
         write(erroutput, '0');
     writeln(erroutput);
   end;
}
   dfs := d[pr];
 end;

procedure makeout(pr: integer);
 begin
   if mode[pr] = 0 then
     exit;
   if mode[pr] = 1 then begin
     makeout(pa1[pr]);
     exit;
   end;
   if mode[pr] = 2 then begin
     s[k] := i1[pr];
     f[k] := i2[pr];
     inc(k);
     makeout(pa1[pr]);
     makeout(pa2[pr]);
     exit;
   end;
 end;

begin
  randseed := 20060425;
  reset(input, 'reform.in');
  rewrite(output, 'reform.out');

  read(n);
  for i := 0 to n - 1 do
    read(x[i], y[i]);

  fillchar(d, sizeof(d), -1);
  writeln(dfs(1 shl n - 1));
  k := 0;
  makeout(1 shl n - 1);
  writeln(k);
  for i := 0 to k - 1 do
    writeln(x[s[i]]:0:0, ' ', y[s[i]]:0:0, '  ', x[f[i]]:0:0, ' ', y[f[i]]:0:0);

  close(input);
  close(output);
end.
