{$A+,B-,D-,E-,I-,L-,N-,Q-,R-,S-,X+,Y-}
{O-,R+,S+,Q+}
const
  infile='reform.in';
 outfile='reform.out';
 mx=20+3;
 mx2=100+7;
 inf=maxlongint div 3;

type
 tpoint=record x,y:longint;end;
 trealpoint=record x,y:real;end;
 tpolyg=array[0..mx] of tpoint;
 tline=record a,b,c:real;end;

var
 n,k,res:longint;
 p:tpolyg;
 s,f:array[0..mx2] of longint;

procedure init;
var
 i:longint;
begin
 read(n);
 for i:=1 to n do
  read(p[i].x,p[i].y);
end;

function eqpoint(a,b:tpoint):boolean;
begin
 result:=(a.x=b.x) and (a.y=b.y);
end;

function stupidfind(q:tpoint):longint;
var
 i:longint;
begin
 for i:=1 to n do
  if eqpoint(p[i],q) then
   begin
    result:=i;
    exit;
   end;
 result:=0;
end;

function find(q:tpoint):longint;
begin
 result:=stupidfind(q);
end;

function prev(k,n:longint):longint;
begin
 if k>1 then
  result:=k-1 else
   result:=n;
end;

function succ(k,n:longint):longint;
begin
 if k<n then
  result:=k+1 else
   result:=1;
end;

function square(p1,p2,p3:tpoint):longint;
begin
 result:=p1.x*p2.y-p2.x*p1.y+p2.x*p3.y-p2.y*p3.x+p3.x*p1.y-p3.y*p1.x;
end;

function kmd(p:tpolyg;n:longint;flag:boolean;count:longint):longint;
 forward;

procedure correct(var pp:tpolyg;var m:longint);
var
 p:tpolyg;
 n:longint;
 i:longint;
begin
 n:=0;
 pp[0]:=pp[m];
 pp[m+1]:=pp[1];
 for i:=1 to m do
  begin
   if square(pp[i-1],pp[i],pp[i+1])<>0 then
    begin
     inc(n);
     p[n]:=pp[i];
    end;
  end;
 p[0]:=p[n];
 p[n+1]:=p[1]; 
 pp:=p;
 m:=n;   
end;

function dmd(pp:tpolyg;m:longint;s,f:longint;flag:boolean;count:longint):longint;
var
 p:tpolyg;
 n:longint;
 i:longint;
 fl:boolean;
begin
 pp[0]:=pp[m];
 pp[m+1]:=pp[1];
 n:=0;
 i:=prev(s,m);
 fl:=true;
 while (i<>f) or fl do
  begin
   fl:=false;
   i:=succ(i,m);
   inc(n);
   p[n]:=pp[i];
  end;
 correct(p,n);
 p[0]:=p[n];
 p[n+1]:=p[1];
 dmd:=kmd(p,n,flag,count);
end;

procedure swap(var a,b:longint);
var
 c:longint;
begin
 c:=a;
 a:=b;
 b:=c;
end;

function atsegm(p1:tpoint;p:trealpoint;p2:tpoint):boolean;
begin
 if p1.x>p2.x then
  swap(p1.x,p2.x);
 if p1.y>p2.y then
  swap(p1.y,p2.y);
 atsegm:=(p1.x<=p.x) and (p.x<=p2.x) and (p1.y<=p.y) and (p.y<=p2.y);
end;

procedure point2toline(p1,p2:tpoint;var l:tline);
begin
 l.a:=p1.y-p2.y;
 l.b:=p2.x-p1.x;
 l.c:=-(l.a*p1.x+l.b*p1.y);
end;

function line2topoint(l1,l2:tline;var p:trealpoint):boolean;
var
 st:real;
begin
 st:=l1.a*l2.b-l1.b*l2.a;
 if st=0 then
  result:=false else
   begin
    p.x:=(l1.b*l2.c-l1.c*l2.b)/st;
    p.y:=(l2.a*l1.c-l1.a*l2.c)/st;
    result:=true;
   end;
end;

function cross(p1,p2,p3,p4:tpoint):boolean;
var
 p:trealpoint;
 l1,l2:tline;
begin
 point2toline(p1,p2,l1);
 point2toline(p3,p4,l2);
 if line2topoint(l1,l2,p) then
  result:=atsegm(p1,p,p2) and atsegm(p3,p,p4) else
   result:=false;
end;

function includepoint(p:tpolyg;n:longint;q:trealpoint):boolean;
var
 i,t:longint;
 xx:real;
 l:tline;
begin
 t:=0;
 for i:=1 to n do
  begin
   if atsegm(p[i],q,p[i+1]) then
    begin
     result:=false;
     exit;
    end;
   point2toline(p[i],p[i+1],l);
   if (l.a*q.x+l.b*q.y+l.c<>0) and (l.a<>0) then
    begin
     xx:=(-l.b*q.y-l.c)/l.a;
     if xx>q.x then
      inc(t);
    end;
  end;
 result:=odd(t);
end;

function include(p:tpolyg;n:longint;s,f:longint):boolean;
var
 q:trealpoint;
 i:longint;
begin
 q.x:=(p[s].x+p[f].x)/2;
 q.y:=(p[s].y+p[f].y)/2;
 result:=false;
 if includepoint(p,n,q) then
  begin
   result:=true;
   for i:=1 to n do
    if (i<>prev(s,n)) and (i<>s) and (i<>prev(f,n)) and (i<>f) then
     if cross(p[i],p[i+1],p[s],p[f]) then
      begin
       result:=false;
       exit;
      end;
  end;
end;

function mark(k:longint):longint;
begin
 if k>0 then
  result:=1 else
   if k<0 then
    result:=-1 else
     result:=0;
end;

function hoho(p:tpolyg;n:longint):boolean;
var
 i,m:longint;
begin
 result:=true;
 m:=mark(square(p[0],p[1],p[2]));
 for i:=1 to n do
  if mark(square(p[i-1],p[i],p[i+1]))<>m then
   begin
    result:=false;
    exit;
   end;
end;

function yoo(p1,p2,p3:tpoint):boolean;{!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
begin
 result:=square(p1,p2,p3)<0;
end;

function min(a,b:longint):longint;
begin
 if a<b then
  min:=a else
   min:=b;
end;

function kmd(p:tpolyg;n:longint;flag:boolean;count:longint):longint;
var
 first,i,j,l,q,a,b:longint;
begin
 if n<=2 then
  begin
   result:=0;
   exit;
  end;
 if n=3 then
  begin
   result:=1;
   exit;   
  end;
 if n=4 then
  begin
   result:=2;
   if (flag) and (count=2) then
    begin
     inc(k);
     if include(p,n,1,3) then
      begin
       s[k]:=find(p[1]);
       f[k]:=find(p[3]);
      end else
       begin
        s[k]:=find(p[2]);
        f[k]:=find(p[4]);
       end;
    end;
   exit;
  end;
 p[0]:=p[n];
 p[n+1]:=p[1];
 if hoho(p,n) then
  begin
   result:=n-2;
   if (flag) and (count=n-2) then
    begin
     first:=find(p[1]);
     for i:=2 to n-1 do
      begin
       s[k+i-1]:=first;
       f[k+i-1]:=find(p[i]);
      end;
     inc(k,n-2);
    end;
   exit;
  end;
 result:=inf;
 for i:=1 to n do
  if yoo(p[i-1],p[i],p[i+1]) then
   begin
    {!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!}
    for j:=i+2 to i-2+n do
     begin
      l:=j mod n;
      if l=0 then
       l:=n;
      a:=dmd(p,n,i,l,false,count);
      b:=dmd(p,n,l,i,false,count);
      q:=a+b;
      result:=min(result,q);
      if (q=count) and flag then
       begin
        inc(k);
        s[k]:=find(p[i]);
        f[k]:=find(p[l]);
        dmd(p,n,i,l,true,a);
        dmd(p,n,l,i,true,b);
        exit;
       end;
     end;
   end;
end;

procedure run;
begin
 k:=0;
 res:=dmd(p,n,1,n,false,0);
 dmd(p,n,1,n,true,res);
end;

procedure done;
var
 i:longint;
begin
 writeln(res);
 writeln(k);
 for i:=1 to k do
  writeln(p[s[i]].x,' ',p[s[i]].y,' ',p[f[i]].x,' ',p[f[i]].y);
end;

begin
 assign(input,infile);
 reset(input);
 assign(output,outfile);
 rewrite(output);
 init;
 run;
 done;
 close(input);
 close(output);
end.