#include <cstdio>

#define maxn 1000

bool c[maxn][maxn];
bool u[maxn][maxn];

int dx[4] = {-1, 0, 1, 0};
int dy[4] = {0, -1, 0, 1};

int n, m;

void dfs(int x, int y) {
	if (u[x][y])
		return;
	u[x][y] = true;
	int xx, yy;
	for (int i = 0; i < 4; i++) {
		xx = x + dx[i];
		yy = y + dy[i];
		if (0 <= xx && xx < n && 0 <= yy && yy < m && (c[x][y] ^ c[xx][yy]))
			dfs(xx, yy);
	}
}

int main() {
	freopen("board.in", "r", stdin);
	freopen("board.out", "w", stdout);
	
	scanf("%d %d", &n, &m);
	int i, j;
	char ch;	
	
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {			
			do {
				ch = getchar();
			} while (ch != 'B' && ch != 'W');
			u[i][j] = false;
			c[i][j] = (ch == 'B');
		}		
	}

	int r = 0;
	for (i = 0; i < n; i++) {
		for (j = 0; j < m; j++) {			
			if (u[i][j])
				continue;
			r++;
			dfs(i, j);
		}		
	}
	printf("%d", r);

	return 0;
}