#include <stdio.h>
#include <stdlib.h>
#include <math.h>

short int *a, *dmin;

int gcd(int u, int v) {
    int tmp;
    while (v > 0) {
        tmp = u % v;
        u = v;
        v = tmp;
    }
    return u;
}

void init(int n) {
    int i, ii, j, jj, d;

    a = (short int *) malloc((n + 1) * sizeof(short int));
    dmin = (short int *) malloc((n + 1) * sizeof(short int));
    for (i = 0; i <= n; i++) {
        a[i] = -1;
        dmin[i] = 30000;
    }

    ii = 1;
    for (i = 1; ii <= n; i++) {
        jj = ii;
        for (j = i; ii + jj <= n; j++) {

            d = gcd(i, j);
            if (d < dmin[ii + jj]) {
                a[ii + jj] = i;
                dmin[ii + jj] = d;
            }

            jj = jj + (j << 1) + 1;
        }

        ii = ii + (i << 1) + 1;
    }
}

int check1(int n) {
    if (n <= 1) {
        printf("1\n");
        printf("%d\n", n);
        return 1;
    }

    return 0;
}

int check2(int n) {
    if (dmin[n] == 1) {
        printf("2\n");
        printf("%d %d\n", a[n], (int) round(sqrt(n - a[n] * a[n])));
        return 1;
    }
    return 0;
}

int check3(int n) {
    int i, u, ii = 1;

    for (i = 1; ii <= n; ii = ii + (i << 1) + 1, i++) {
        u = n - ii;
        if (a[u] == -1)
            continue;

        if (gcd(i, dmin[u]) != 1)
            continue;

        printf("3\n");
        printf("%d %d %d\n", i, a[u], (int) round(sqrt(u - a[u] * a[u])));
        return 1;
    }
    return 0;
}

int check4(int n) {
    int i, u;
    
    for (i = 1; i <= n; i++) {
        u = n - i;
        if (a[i] == -1 || a[u] == -1)
            continue;

        if (gcd(dmin[i], dmin[u]) != 1)
            continue;

        printf("4\n");
        printf("%d %d %d %d\n", a[i], (int) round(sqrt(i - a[i] * a[i])), a[u], (int) round(sqrt(u - a[u] * a[u])));
        return 1;
    }
    return 0;
}

int check5(int n) {
    int i, u;

    for (i = 1; i <= n - 1; i++) {
        u = n - 1 - i;
        if (a[i] == -1 || a[u] == -1)
            continue;

        printf("5\n");
        printf("1 %d %d %d %d\n", a[i], (int) round(sqrt(i - a[i] * a[i])), a[u], (int) round(sqrt(u - a[u] * a[u])));
        return 1;
    }
    return 0;
}

int check(int n) {
    if (check1(n)) {
        return 1;
    }

    if (check2(n)) {
        return 2;
    }

    if (check3(n)) {
        return 3;
    }

    if (check4(n)) {
        return 4;
    }

    if (check5(n)) {
        return 5;
    }
    return -1;
}

int main() {
    int n;

    freopen("hyper.in", "r", stdin);
    freopen("hyper.out", "w", stdout);

    scanf("%d", &n);
    init(n);

    if (check(n) < 0) {
        printf("Internal bug :(");
        return 239;
    }

    return 0;
}
