#include <stdio.h>
#include <stdlib.h>
#include <math.h>

typedef struct square_answer SQUARE_ANSWER;
struct square_answer {
    SQUARE_ANSWER *next;
    short int gcd;
    int amount;
};

short int *a, *dmin;
SQUARE_ANSWER **answers;

int gcd(int u, int v) {
    int tmp;
    while (v > 0) {
        tmp = u % v;
        u = v;
        v = tmp;
    }
    return u;
}

void init(int n) {
    int i, ii, j, jj, d, found;
    SQUARE_ANSWER *tmp;

    a = (short int *) malloc((n + 1) * sizeof(short int));
    dmin = (short int *) malloc((n + 1) * sizeof(short int));
    answers = (SQUARE_ANSWER **) malloc((n + 1) * sizeof(SQUARE_ANSWER *));
    for (i = 0; i <= n; i++) {
        a[i] = -1;
        dmin[i] = 30000;
        answers[i] = NULL;
    }

    ii = 1;
    for (i = 1; ii <= n; i++) {
        jj = ii;
        for (j = i; ii + jj <= n; j++) {
            d = gcd(i, j);
            if (d < dmin[ii + jj]) {
                a[ii + jj] = i;
                dmin[ii + jj] = d;
            }

            found = 0;
            for (tmp = answers[ii + jj]; tmp != NULL; tmp = tmp->next) {
                if (tmp->gcd == d) {
                    tmp->amount++;
                    if (ii != jj) {
                        tmp->amount++;
                    }
                    found = 1;
                    break;
                }
            }

            if (found == 0) {
                tmp = (SQUARE_ANSWER *) malloc(sizeof(SQUARE_ANSWER));
                tmp->gcd = d;
                tmp->amount = 1;
                if (ii != jj) {
                    tmp->amount++;
                }
                tmp->next = answers[ii + jj];
                answers[ii + jj] = tmp;
            }

            jj = jj + (j << 1) + 1;
        }

        ii = ii + (i << 1) + 1;
    }
}

int check1(int n) {
    if (n <= 1) {
        printf("1\n");
        printf("%d\n", n);
        printf("2\n");
        return 1;
    }

    return 0;
}

int check2(int n) {
    SQUARE_ANSWER *tmp;
    if (dmin[n] == 1) {
        printf("2\n");
        printf("%d %d\n", a[n], (int) round(sqrt(n - a[n] * a[n])));
        for (tmp = answers[n]; tmp != NULL; tmp = tmp->next) {
            if (tmp->gcd == 1) {
                printf("%d\n", 4 * tmp->amount);
                return 1;
            }
        }

        return 0;
    }
    return 0;
}

int check3(int n) {
    SQUARE_ANSWER *tmp;
    int i, u, ii = 1;
    int amount = 0;

    for (i = 1; ii <= n; ii = ii + (i << 1) + 1, i++) {
        u = n - ii;
        
        for (tmp = answers[u]; tmp != NULL; tmp = tmp->next) {
            if (gcd(i, tmp->gcd) != 1) {
                continue;
            }

            if (amount == 0) {
                printf("3\n");
                printf("%d %d %d\n", i, a[u], (int) round(sqrt(u - a[u] * a[u])));
            }
            amount += tmp->amount;
        }
    }

    if (amount == 0) {
        return 0;
    }
    printf("%d\n", 8 * amount);
    return 1;
}

int check4(int n) {
    SQUARE_ANSWER *tmp1;
    SQUARE_ANSWER *tmp2;
    int i, u, amount = 0;
    
    for (i = 1; i <= n; i++) {
        for (tmp1 = answers[i]; tmp1 != NULL; tmp1 = tmp1->next) {
            u = n - i;
            for (tmp2 = answers[u]; tmp2 != NULL; tmp2 = tmp2->next) {
                if (gcd(tmp1->gcd, tmp2->gcd) != 1) {
                    continue;
                }

                if (amount == 0) {
                    printf("4\n");
                    printf("%d %d %d %d\n", a[i], (int) round(sqrt(i - a[i] * a[i])), a[u], (int) round(sqrt(u - a[u] * a[u])));
                }

                amount += tmp1->amount * tmp2->amount;
            }
        }
    }

    if (amount == 0) {
        return 0;
    }
    printf("%d\n", 16 * amount);
    return 1;
}

int check5(int n) {
    int i, j, u, ii, d;
    int amount = 0;
    SQUARE_ANSWER *tmp1;
    SQUARE_ANSWER *tmp2;

    ii = 1;
    for (i = 1; ii <= n; ii = ii + (i << 1) + 1, i++) {
        if (i % 4 != 2) {
            continue;
        }
        for (j = 1; j + ii <= n; j++) {
            for (tmp1 = answers[j]; tmp1 != NULL; tmp1 = tmp1->next) {
                u = n - ii - j;
                d = gcd(i, tmp1->gcd);
                for (tmp2 = answers[u]; tmp2 != NULL; tmp2 = tmp2->next) {
                    if (gcd(d, tmp2->gcd) != 1) {
                        continue;
                    }
    
                    if (amount == 0) {
                        printf("5\n");
                        printf("%d %d %d %d %d\n", i, a[j], (int) round(sqrt(j - a[j] * a[j])), a[u], (int) round(sqrt(u - a[u] * a[u])));
                    }
    
                    amount += tmp1->amount * tmp2->amount;
                }
            }
        }
    }
    if (amount == 0) {
        return 0;
    }
    printf("%d\n", 32 * amount * 5);
    return 1;
}

int check(int n) {
    if (check1(n)) {
        return 1;
    }

    if (check2(n)) {
        return 2;
    }

    if (check3(n)) {
        return 3;
    }

    if (check4(n)) {
        return 4;
    }

    if (check5(n)) {
        return 5;
    }
    return -1;
}

int main() {
    int n;

    freopen("hyper.in", "r", stdin);
    freopen("hyper.out", "w", stdout);

    scanf("%d", &n);
    init(n);

    if (check(n) < 0) {
        printf("Internal bug :(");
        return 239;
    }
    return 0;
}
