import java.io.*;
import java.util.*;

public class mythes_rs implements Runnable {
    private StreamTokenizer in;
    private PrintWriter out;
    private Map<String,Integer> people;
    private int curSize;
    private int curPage = 0;
    private ArrayList<Integer> who = new ArrayList<Integer>();
    private ArrayList<Boolean> what = new ArrayList<Boolean>();
    private ArrayList<Integer> whom = new ArrayList<Integer>();
    private ArrayList<Integer> page = new ArrayList<Integer>();

    public static void main(String[] args) {
        new Thread(new mythes_rs()).start();
    }

    public void run() {
        try {
            solve();
        } catch (IOException e) {
            e.printStackTrace();
        }
    }
    
    private class Edge {
        int s, d;
        
        public Edge(int u, int v) {
            this.s = u;
            this.d = v;
        }
    }
    
    private class Graph {
        private int n;
        private ArrayList<Edge>[] edges;
        private boolean[] mark;
        private int sp = 0;
        public int[] stack;
        
        @SuppressWarnings("unchecked")
        public Graph(int n) {
            this.n = n;
            edges = new ArrayList[n];
            mark = new boolean[n];
            stack = new int[n];
            for (int i = 0; i < n; i++) {
                edges[i] = new ArrayList<Edge>();
            }
        }

        public void addEdge(int u, int v) {
            Edge e1 = new Edge(u, v);
            
            edges[u].add(e1);
        }

        public void topSort() {
            Arrays.fill(mark, false);
            sp = 0;
            for (int i = 0; i < n; i++) {
                if (!mark[i]) {
                    dfs(i);
                }
            }
        }

        private void dfs(int u) {
            mark[u] = true;
            for (Edge e: edges[u]) {
                if (!mark[e.d]) {
                    dfs(e.d);
                }
            }
            stack[sp++] = u;
        }
        
        public void printMe() {
            for (int i = 0; i < n; i++) {
                for (Edge e: edges[i]) {
                    System.out.println(i + " -> " + e.d);
                }
            }
        }
    }
    
    private void solve() throws IOException {
        in = new StreamTokenizer(new BufferedReader(new FileReader(new File("mythes.in"))));
        out = new PrintWriter("mythes.out");
        
        in.resetSyntax();
        in.wordChars('a', 'z');
        in.wordChars('A', 'Z');
        in.wordChars('0', '9');
        in.whitespaceChars(0, 32);
        
        int n = nextInt();
        people = new HashMap<String, Integer>();
        
        for (int i = 0; i < n; i++) {
            readPage();
        }
        
        int[] death = new int[curSize];
        int[] born = new int[curSize];
        Arrays.fill(death, -1);
        Arrays.fill(born, -1);
        /*     */
        for (int i = 0; i < who.size(); i++) {
            if (what.get(i)) {
                if (death[whom.get(i)] == -1) {
                    death[whom.get(i)] = page.get(i);
                } else {
                    out.println("No solution");
                    out.close();
                    return;
                }
            } else {
                if (born[whom.get(i)] == -1) {
                    born[whom.get(i)] = page.get(i);
                } else {
                    out.println("No solution");
                    out.close();
                    return;
                }
            }
        }
        
        Graph g = new Graph(n + 2);
        int globalDeath = n;
        int globalBorn = n + 1;
        for (int i = 0; i < curSize; i++) {
            if (death[i] == -1) {
                death[i] = globalDeath;
            }
            
            if (born[i] == -1) {
                born[i] = globalBorn;
            }
        }
        
        for (int i = 0; i < n; i++) {
            g.addEdge(globalBorn, i);
            g.addEdge(i, globalDeath);
        }
        
        for (int i = 0; i < who.size(); i++) {
            int pnum = page.get(i);
            int bornPage = born[who.get(i)];
            int deathPage = death[who.get(i)];
            
            if (bornPage != pnum) {
                g.addEdge(bornPage, pnum);
            }
            
            if (deathPage != pnum) {
                g.addEdge(pnum, deathPage);
            }
        }
        
        for (int i = 0; i < who.size(); i++) {
            int pnum = page.get(i);
            int bornPage = born[whom.get(i)];
            int deathPage = death[whom.get(i)];
            
            if (bornPage != pnum) {
                g.addEdge(bornPage, pnum);
            }
            
            if (deathPage != pnum) {
                g.addEdge(pnum, deathPage);
            }
        }
        
//        g.printMe();
        g.topSort();
        for (int i = n + 1; i >= 0; i--) {
            if ((g.stack[i] != globalBorn) && (g.stack[i] != globalDeath))
                out.println(g.stack[i] + 1);
        }
        out.close();
    }
    
    private void readPage() throws IOException {
        int m = nextInt();
        for (int i = 0; i < m; i++) {
            who.add(peopleLookup(nextToken()));
            String action = nextToken();
            
            if (action.equals("killed")) {
                what.add(true);
            } else if (action.equals("born")) {
                what.add(false);
            } else {
                throw new Error("Bad action: " + action);
            }
            
            whom.add(peopleLookup(nextToken()));
            page.add(curPage);
        }
        curPage++;
    }

    private String nextToken() throws IOException {
        in.nextToken();
        return in.sval;
    }
    
    private int nextInt() throws IOException {
        return Integer.parseInt(nextToken());
    }
    
    private int peopleLookup(String name) {
        name = name.toLowerCase();
        if (!people.keySet().contains(name)) {
            people.put(name, curSize);
            curSize++;
        }
            
        return people.get(name);
    }
}
