{$apptype console}
{$o-,r+,q+}
uses
  SysUtils, Math;

const
  inf = 1000000000;
  MAXN = 100000;

type
  int = longint;
  real = extended;

  tshelf = record
    id: int;
    c: int;
    w: int;
  end;

var
  s: array[1..MAXN] of tshelf;
  min_w: array[1..4 * MAXN] of int;
  n, nn: int;


procedure qsort(l, r: int);
var
  i, j: int;
  m, t: tshelf;
begin
  i := l;
  j := r;
  m := s[l + random(r - l + 1)];
  while i <= j do
  begin
    while s[i].c < m.c do inc(i);
    while s[j].c > m.c do dec(j);
    if i <= j then
    begin
      t := s[i];
      s[i] := s[j];
      s[j] := t;
      inc(i);
      dec(j);
    end;
  end;
  if l < j then
    qsort(l, j);
  if i < r then
    qsort(i, r);
end;

procedure put(p: int; w: int);
begin
  min_w[p] := w;
  p := p div 2;
  while p >= 1 do
  begin
    min_w[p] := min(min_w[2 * p], min_w[2 * p + 1]);
    p := p div 2;
  end;
end;

function find(p: int; w: int) : int;
begin
  result := -1;
  if min_w[p] > w then
    exit;
  if (p >= nn) then
  begin
    if min_w[p] <= w then
      result := p;
  end else begin
    result := find(2 * p + 1, w);
    if result < 0 then
      result := find(2 * p, w);
  end;
end;


var
  a: int;
  pos, free, res, tmp: int;
  i: int;
  ansCnt: int;
  ans: array[1..MAXN] of int;

begin
  reset(input, 'parcel.in');
  rewrite(output, 'parcel.out');
  readln(n);
  assert((1 <= n) and (n <= MAXN));
  for i := 1 to n do
  begin
    s[i].id := i;
    read(s[i].c);
    assert((0 < s[i].c) and (s[i].c < inf));
  end;
  for i := 1 to n - 1 do
  begin
    read(s[i].w);
    assert((0 < s[i].w) and (s[i].c < inf));
  end;
  readln(a);
  assert(( 0 < a) and (a < inf));
  s[n].w := inf;
  qsort(1, n);
  nn := 1;
  while nn < n do
    nn := 2 * nn;
  for i := 1 to n do
    min_w[nn + i - 1] := s[i].w;
  for i := n + 1 to nn do
    min_w[nn + i - 1] := inf;
  for i := nn - 1 downto 1 do
    min_w[i] := min(min_w[2 * i], min_w[2 * i + 1]);

  free := -1;
  for i := 1 to n do
  begin
    if s[i].w = inf then
    begin
      free := i;
      break;
    end;
  end;

  ansCnt := 0;
  while true do
  begin
    if s[free].c >= a then
    begin
      writeln(ansCnt + 1);
      for i := 1 to ansCnt do
        write(ans[i], ' ');
      halt(0);
    end;
    pos := free;
    while (pos <= n) and (s[pos].c = s[free].c) do 
      inc(pos);
//    writeln(free, ' ', pos);
//    flush(output);
    if pos > n then
    begin
      writeln('-1');
      halt(0);
    end;
    pos := pos + nn - 1;
    res := -1;
    while pos >= 1 do
    begin
      tmp := find(pos, s[free].c);
      if tmp > 0 then
        res := tmp;
      if pos and (pos + 1) = 0 then
        break;
      pos := (pos + 1) div 2;
    end;
    res := res - (nn - 1);
    if not ((1 <= res) and (res <= n)) then
    begin
      writeln('-1');
      exit;
    end;
    put(nn - 1 + free, s[res].w);
    put(nn - 1 + res, inf);
    s[free].w := s[res].w;
    s[res].w := inf;
    free := res;
    inc(ansCnt);             
    ans[ansCnt] := s[res].id;
  end;
end.

