import java.util.Scanner;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

public class brackets_dp {
    private static final int INF = 1000000000;
    private static final String INPUT_FILE = "brackets.in";
    private static final String OUTPUT_FILE = "brackets.out";

    private int n;
    private int[] d;

    public static void main(String[] args) throws IOException {
        brackets_dp sol = new brackets_dp();
        sol.read();
        sol.solve();
        sol.write();
    }

    private void read() throws IOException {
        Scanner in = new Scanner(new File(INPUT_FILE));
        String str = in.nextLine().trim();
        n = str.length();
        d = new int[n];
        for (int i = 0; i < d.length; i++) {
            switch (str.charAt(i)) {
                case '(':
                    d[i] = +1;
                    break;
                case ')':
                    d[i] = -1;
                    break;
                case '[':
                    d[i] = +INF;
                    break;
                case ']':
                    d[i] = -INF;
                    break;
                default:
                    System.out.println("Wrong string format");
                    System.exit(1);
            }
        }
    }
    
    private void solve() {
        int down = 0;
        int sum = 0;
        for (int i = 0; i < n; i++) {
            if (d[i] == -1 || d[i] == 1)
                sum += d[i];
            if (down > sum)
                down = sum;
        }
        boolean isFirst = true;
        for (int i = 0; i < n; i++) {
            if (d[i] == INF) {
                if (isFirst) {
                    isFirst = false;
                    d[i] = -down;
                } else {
                    d[i] = 0;
                }
            }
        }
        sum += -down;
        boolean isLast = true;
        for (int i = n - 1; i >= 0; i--) {
            if (d[i] == -INF) {
                if (isLast) {
                    isLast = false;
                    d[i] = -sum;
                } else {
                    d[i] = 0;
                }
            }
        }
    }
    
    private void write() throws IOException {
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        int down = 0;
        int sum = 0;
        for (int i = 0; i < n; i++) {
            sum += d[i];
            if (down > sum)
                down = sum;
        }
        if (sum != 0 || down < 0) {
            out.println("Impossible");
        } else {
            for (int i = 0; i < n; i++) {
                for (int j = d[i]; j < 0; j++)
                    out.print(')');
                for (int j = 0; j < d[i]; j++)
                    out.print('(');
            }
        }
        out.close();
    }
}
