{$R+,Q+,O-}
program candles;

uses
    sysutils;

const
	maxn = 10000;
	maxm = 1000;

var
	i, j, n, m, r, qn: longint;
	a, b, c: array [1..maxm] of longint;
	x, y: array [1..maxn] of longint;
	q: array [1..maxn] of longint;
	g: array [-maxn..maxn] of longint;
	found: boolean;

begin
	reset(input, 'candles.in');
	rewrite(output, 'candles.out');

	readln(n, m, r);
	assert((n >= 1) and (n <= 10000) and (m >= 0) and (m <= 1000) and (r >= 1) and (r <= 2000));
	for i := 1 to n do begin
		readln(x[i], y[i]);
		assert(x[i] * x[i] + y[i] * y[i] < r * r);
		for j := 1 to i - 1 do
			assert((x[i] <> x[j]) or (y[i] <> y[j]));

		q[i] := 1;
	end;
	qn := 1;

	for i := 1 to m do begin
		readln(a[i], b[i], c[i]);
		assert((abs(a[i]) <= 10000) and (abs(b[i]) <= 10000) and (abs(c[i]) <= 10000));
		assert((a[i] <> 0) or (b[i] <> 0));

		for j := 1 to i - 1 do begin
			if (a[j] * b[i] = a[i] * b[j]) then begin
				assert((a[j] * c[i] <> a[i] * c[j]) or (c[j] * b[i] <> c[i] * b[j]));
			end;
		end;

		for j := 1 to n do begin
			assert(a[i] * x[j] + b[i] * y[j] + c[i] <> 0);
			if a[i] * x[j] + b[i] * y[j] + c[i] < 0 then
				q[j] := -q[j];
		end;

		for j := -n to n do
			g[j] := 0;
		qn := 0;
		for j := 1 to n do begin
			if g[q[j]] = 0 then begin
				inc(qn);
				g[q[j]] := qn;
			end;
			q[j] := g[q[j]];
		end;
	end;
	assert(eof);

	found := false;
	for i := 1 to n do
		for j := i + 1 to n do
			if q[i] = q[j] then begin
				found := true;
			end;

	if found then
		writeln('YES')
	else
		writeln('NO');

	close(input);
	close(output);
end.