import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

public class candles_dp {
    private static final int INF = 1000000000;
    private static final String INPUT_FILE = "candles.in";
    private static final String OUTPUT_FILE = "candles.out";

    private int n;
    private int[] x;
    private int[] y;

    private int m;
    private int[] a;
    private int[] b;
    private int[] c;

    private boolean answer;
    private int[] cnt;

    private BufferedReader in;
    
    public static void main(String[] args) throws IOException {
        candles_dp sol = new candles_dp();
        sol.read();
        sol.solve();
        sol.write();
    }

    private int readInt() throws IOException {
        int ch = in.read();
        while (ch != '-' && (ch < '0' || ch > '9'))
            ch = in.read();
        int sign;
        if (ch == '-') {
            sign = -1;
            ch = in.read();
        } else {
            sign = +1;
        }
        int res = 0;
        while (ch >= '0' && ch <= '9') {
            res = res * 10 + ch - '0';
            ch = in.read();
        }
        return res * sign;
    }
    
    private void read() throws IOException {
        in = new BufferedReader(new FileReader(INPUT_FILE));
        n = readInt();
        m = readInt();
        readInt();
        x = new int[n];
        y = new int[n];
        for (int i = 0; i < n; i++) {
            x[i] = readInt();
            y[i] = readInt();
        }
        a = new int[m];
        b = new int[m];
        c = new int[m];
        for (int i = 0; i < m; i++) {
            a[i] = readInt();
            b[i] = readInt();
            c[i] = readInt();
        }
    }
    
    private void solve() {
        int partCnt = 1; 
        int[] part = new int[n];
        int[] newPart = new int[n];
        int[] dir = new int[n];
        boolean[] hasLeft = new boolean[n];
        boolean[] hasRight = new boolean[n];
        for (int l = 0; l < m; l++) {
            Arrays.fill(hasLeft, false);
            Arrays.fill(hasRight, false);
            for (int p = 0; p < n; p++) {
                int d = a[l] * x[p] + b[l] * y[p] + c[l];
                if (d > 0) {
                    dir[p] = 1;
                    hasLeft[part[p]] = true;
                } else if (d < 0) {
                    dir[p] = -1;
                    hasRight[part[p]] = true;
                } else {
                    throw new RuntimeException();
                }
            }
            for (int pt = 0; pt < partCnt; pt++) {
                if (hasLeft[pt] && hasRight[pt]) {
                    newPart[pt] = partCnt;
                    partCnt++;
                }
            }
            for (int p = 0; p < n; p++) {
                if (hasLeft[part[p]] && hasRight[part[p]] && dir[p] == 1) {
                    part[p] = newPart[part[p]];
                }
            }
        }
        cnt = new int[partCnt];
        for (int p = 0; p < n; p++) {
            cnt[part[p]]++;
        }
        answer = false;
        for (int pt = 0; pt < partCnt; pt++) {
            answer |= cnt[pt] > 1;
        }
    }
    
    private void write() throws IOException {
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        if (answer) {
            out.println("YES");
        } else {
            out.println("NO");
        }
        out.close();
    }
}
