{$apptype console}
{$o-,r+,q+}
{$maxstacksize 10000000}
uses
  sysutils, math;

const
  problem_name = 'candles';
  maxn = 10000;
  maxr = 1000;
  maxm = 1000;

type
  int = longint;

var
  x, y : array[1..maxn] of int64;
  a, b, c : array[1..maxm] of int64;
  n, i, m, r, j : int;
  tx, ty : array[1..maxn] of int64;

function check(l, r, beg : int) : boolean;
var
  p1, p2 : int;
  i : int;
begin
  if r < l then
  begin
    result := false;
    exit;
  end;
  if beg = m + 1 then
  begin
    if r > l then
    begin
      result := true;
    end else begin
      result := false;
    end;
    exit;
  end;
  for i := l to r do
  begin
    tx[i] := x[i];
    ty[i] := y[i];
    assert(a[beg] * x[i] + b[beg] * y[i] + c[beg] <> 0);
  end;
  p1 := l;
  p2 := r;
  for i := l to r do
  begin
    if a[beg] * tx[i] + b[beg] * ty[i] + c[beg] > 0 then
    begin
      x[p1] := tx[i];
      y[p1] := ty[i];
      inc(p1);
    end;
    if a[beg] * tx[i] + b[beg] * ty[i] + c[beg] < 0 then
    begin
      x[p2] := tx[i];
      y[p2] := ty[i];
      dec(p2);
    end;
  end;
  assert(p1 = p2 + 1);
  result := check(l, p1 - 1, beg + 1) or check(p2 + 1, r, beg + 1);
end;

begin
  reset(input, problem_name + '.in');
  rewrite(output, problem_name + '.out');
  read(n, m, r);
  for i := 1 to n do
  begin
    read(x[i], y[i]);
    assert(x[i] * x[i] + y[i] * y[i] <= r * r);
  end;
  for i := 1 to m do
  begin
    read(a[i], b[i], c[i]);
    assert(a[i] * a[i] + b[i] * b[i] > 0);
  end;
  for i := 1 to n do
  begin
    for j := 1 to m do
    begin
      assert(a[j] * x[i] + b[j] * y[i] + c[j] <> 0);
    end;
  end;
  if check(1, n, 1) then
  begin
    writeln('YES');
  end else begin
    writeln('NO');
  end;
end.