{$apptype console}
{$o+,r-,q-}
uses
  SysUtils, Math;

const
  inf = 1000000000;
  INPUT_FILE = 'perms.in';
  OUTPUT_FILE = 'perms.out';
  MAXN = 50;

type
  int = longint;
  titem = record
    val: byte;
    id: byte;
  end;
  tperm = array[1..MAXN] of titem;

var
  n: int;
  p: tperm;
  w: array[0..MAXN] of boolean;
  answer: int;
  ans: tperm;

procedure swap(var a, b: titem);
var
  t: titem;
begin
  t := a;
  a := b;
  b := t;
end;

procedure solve(cnt: int);
var
  i: int;
  l, r: int;
  tp : tperm;
begin
  tp := p;
  while p[1].val > 1 do
  begin
    inc(cnt);
    l := 1;
    r := p[1].val;
    while l < r do
    begin
      swap(p[l], p[r]);
      inc(l);
      dec(r);
    end;
  end;
  if p[1].val = 0 then
  begin
    for i := 1 to n do
    begin
      if w[i] then
        continue;
      w[i] := true;
      p[1].val := i;
      solve(cnt);
      p[1].val := 0;
      w[i] := false;
    end;
  end else if p[1].val = 1 then
  begin
    if answer < cnt then
    begin
      answer := cnt;
      ans := p;
    end;
  end;
  p := tp;
end;

var
  i, j, ii: int;

begin
  reset(input, INPUT_FILE);
  rewrite(output, OUTPUT_FILE);
  read(n);
  for i := 1 to n do
  begin
    ii := n - i + 1;
    read(p[ii].val);
    p[ii].id := i;
    w[p[ii].val] := true;
  end;
  answer := -1;
  solve(0);
  for i := 1 to n do
    for j := 1 to n - 1 do
    begin
      if ans[j].id > ans[j + 1].id then
        swap(ans[j], ans[j + 1]);
    end;
  fillchar(w, sizeof(w), false);
  for i := 1 to n do
    w[ans[i].val] := true;
  for i := 1 to n do
  begin
    if ans[i].val = 0 then
    begin
      for j := 1 to n do
        if not w[j] then
        begin
          w[j] := true;
          ans[i].val := j;
          break;
        end;
    end;
  end;
  writeln(answer);
  for i := 1 to n do
  begin
    write(ans[i].val);
    if i < n then
      write(' ');
  end;
end.
