import java.util.Scanner;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

public class perms_dp_slow {
    private static final int INF = 1000000000;
    private static final String INPUT_FILE = "perms.in";
    private static final String OUTPUT_FILE = "perms.out";

    private int n;

    private int[] pv;
    private int[] pp;
    private boolean[] w;

    private int answer;
    private int[] ansp;
    private int[] ansv;

    public static void main(String[] args) throws IOException {
        perms_dp_slow sol = new perms_dp_slow();
        sol.read();
        sol.solve();
        sol.write();
    }

    private void read() throws IOException {
        Scanner in = new Scanner(new File(INPUT_FILE));
        n = in.nextInt();
        pv = new int[n];
        pp = new int[n];
        w = new boolean[n + 1];
        for (int i = n - 1; i >= 0; i--) {
            pv[i] = in.nextInt();
            pp[i] = i;
            w[pv[i]] = true;
        }
    }
    
    private void solve() {
        answer = -1;
        ansv = new int[n];
        ansp = new int[n];
        sol(0);    
        for (int i = 0; i < n; i++) {
            for (int j = 1; j < n; j++) {
                if (ansp[j - 1] > ansp[j]) {
                    int tmp = ansv[j - 1];
                    ansv[j - 1] = ansv[j];
                    ansv[j] = tmp;
                    tmp = ansp[j - 1];
                    ansp[j - 1] = ansp[j];
                    ansp[j] = tmp;
                }
            }
        }
        Arrays.fill(w, false);
        for (int i = 0; i < n; i++) {
            w[ansv[i]] = true;
        }
        for (int i = 0; i < n; i++) {
            if (ansv[i] == 0) {
                for (int d = 1 ; d <= n; d++) {
                    if (!w[d]) {
                        w[d] = true;
                        ansv[i] = d;
                        break;
                    }
                }
            }
        }
    }

    private void sol(int cnt) {
        int[] tpv = new int[n];
        int[] tpp = new int[n];
        System.arraycopy(pv, 0, tpv, 0, n);
        System.arraycopy(pp, 0, tpp, 0, n);
        while (pv[0] > 1) {
            cnt++;
            int l = 0;
            int r = pv[0] - 1;
            while (l < r) {
                int tmp = pv[l];
                pv[l] = pv[r];
                pv[r] = tmp;
                tmp = pp[l];
                pp[l] = pp[r];
                pp[r] = tmp;
                l++;
                r--;
            }
        }
        if (pv[0] == 0) {
            for (int i = 1; i <= n; i++) {
                if (w[i]) 
                    continue;
                w[i] = true;
                pv[0] = i;
                sol(cnt);
                pv[0] = 0;
                w[i] = false;
            }
        } else if (pv[0] == 1) {
            if (answer < cnt) {
                answer = cnt;
                System.arraycopy(pv, 0, ansv, 0, n);
                System.arraycopy(pp, 0, ansp, 0, n);
            }
        }
        pp = tpp;
        pv = tpv;
    }
    
    private void write() throws IOException {
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        out.println(answer);
        for (int i = n - 1; i >= 0; i--)
            out.print(ansv[i] + " ");
        out.close();
    }
}
