{$apptype console}
{$o+,r-,q-}
{$maxstacksize 10000000}
uses
  sysutils, math;

const
  problem_name = 'perms';
  maxn = 1000;
  maxz = 13;

type
  int = longint;
  tperm = array[1..maxn] of int;

var
  zCnt : int;
  a, b : tperm;
  i, n : int;
  w : array[1..maxn] of boolean;
  quality : int;
  toPut : array[1..maxz] of int;
  used : array[1..maxz] of boolean;
  best : int;

procedure swap(var a, b : int);
var
  t : int;
begin
  t := a;
  a := b;
  b := t;
end;

procedure writeAns();
var
  i : int;
begin
  for i := 1 to n do
  begin
    write(b[i]);
    if i < n then
      write(' ');
  end;
  writeln;
end;

procedure reverse(var b : tperm; cnt : int);
var
  i : int;
  first : int;
  t : int;
begin
  first := n - cnt + 1;
  for i := 1 to cnt div 2 do
  begin
    t := b[first + i - 1];
    b[first + i - 1] := b[n - i + 1];
    b[n - i + 1] := t;
  end;
end;

procedure solve();
var
  i : int;
  tmp : int;
  curToPut : int;
  oldQ : int;
  t : int;
  first : int;

begin
  oldQ := quality;
  if b[n] > 1 then
  begin
    tmp := b[n];

    //reverse(b, tmp);
    first := n - tmp + 1;
    for i := 1 to tmp div 2 do
    begin
      t := b[first + i - 1];
      b[first + i - 1] := b[n - i + 1];
      b[n - i + 1] := t;
    end;

    inc(quality);

    solve();

//    reverse(b, tmp);
    first := n - tmp + 1;
    for i := 1 to tmp div 2 do
    begin
      t := b[first + i - 1];
      b[first + i - 1] := b[n - i + 1];
      b[n - i + 1] := t;
    end;

    exit;
  end;

  if b[n] = 1 then
  begin
    if best < quality then
    begin
      best := quality;
    end;
    exit;
  end;
  
  for i := 1 to zCnt do
  begin
    if not used[i] then
    begin
      curToPut := toPut[i];
      used[i] := true;
      b[n] := curToPut;
      quality := oldQ;
      solve();
      b[n] := 0;
      used[i] := false;
    end;
  end;
end;

function restoreAns(val : int) : boolean;
var
  i : int;
  tmp : int;
  curToPut : int;
  oldVal : int;
  first : int;
  t : int;

begin
  if b[n] > 1 then
  begin
    tmp := b[n];

//    reverse(b, tmp);
    first := n - tmp + 1;
    for i := 1 to tmp div 2 do
    begin
      t := b[first + i - 1];
      b[first + i - 1] := b[n - i + 1];
      b[n - i + 1] := t;
    end;

    dec(val);

    result := restoreAns(val);

//    reverse(b, tmp);
    first := n - tmp + 1;
    for i := 1 to tmp div 2 do
    begin
      t := b[first + i - 1];
      b[first + i - 1] := b[n - i + 1];
      b[n - i + 1] := t;
    end;

    exit;
  end;

  oldVal := val;

  if (b[n] = 1) then
  begin
    if val <= 0 then result := true
    else result := false;
    exit;
  end;
  
  for i := 1 to zCnt do
  begin
    if not used[i] then
    begin
      curToPut := toPut[i];
      used[i] := true;
      b[n] := curToPut;
      val := oldVal;
      if restoreAns(val) then
      begin
        result := true;
        exit;
      end;
      b[n] := 0;
      used[i] := false;
    end;
  end;
  result := false;
end;

begin
  reset(input, problem_name + '.in');
  rewrite(output, problem_name + '.out');
  readln(n);

  assert((1 <= n) and (n <= maxn));

  zCnt := 0;
  for i := 1 to n do
  begin
    read(a[i]);

    assert((0 <= a[i]) and (a[i] <= n));
    if a[i] > 0 then
    begin
      assert(not w[a[i]]);
      w[a[i]] := true;
    end;
  end;

  zCnt := 0;
  for i := n downto 1 do
  begin
    if not w[i] then
    begin
      inc(zCnt);
      toPut[zCnt] := i;
    end;
  end;

  assert((0 <= zCnt) and (zCnt <= maxz));

  b := a;
  quality := 0;

  best := 0;
  solve();

  writeln(best);

  b := a;
  restoreAns(best);
  for i := 1 to n do
  begin
    if b[i] = 0 then
    begin
      while (zCnt > 0) and (used[zCnt]) do dec(zCnt);
      b[i] := toPut[zCnt];
      dec(zCnt);
    end;
  end;
  writeAns();

end.
