{$apptype console}
{$o-,r+,q+}
uses
  sysutils, math;

const
  problem_name = 'perms';
  maxn = 1000;
  maxz = 13;

type
  int = longint;
  tperm = array[1..maxn] of int;
  tsperm = array[1..maxz] of int;

var
  zCnt : int;
  a, b : tperm;
  i, n : int;
  w : array[1..maxn] of boolean;
  quality : int;
  toPut : array[1..maxz] of int;
  used : array[1..maxz] of boolean;
  best : int;
  ans : tperm;
  curPerm : tsperm;
  zPos : array[1..maxz] of int;

procedure swap(var a, b : int);
var
  t : int;
begin
  t := a;
  a := b;
  b := t;
end;

procedure writeAns();
var
  i : int;
begin
  for i := 1 to n do
  begin
    write(ans[i]);
    if i < n then
      write(' ');
  end;
  writeln;
end;

procedure reverse(var b : tperm; cnt : int);
var
  i : int;
  first : int;
begin
  first := n - cnt + 1;
  for i := 1 to cnt div 2 do
  begin
    swap(b[first + i - 1], b[n - i + 1]);
  end;
end;

procedure gen(pos : int);
var
  i : int;
  cur : int;
begin
  if pos = zCnt then
  begin
    for i := 1 to zCnt do
    begin
      b[zPos[i]] := curPerm[i];
    end;
    cur := 0;
    while b[n] > 1 do
    begin
      reverse(b, b[n]);
      inc(cur);
    end;
    if cur > best then
    begin
      best := cur;
    end;
    exit;
  end;
  for i := 1 to zCnt do
  begin
    if not used[i] then
    begin
      used[i] := true;
      curPerm[pos + 1] := toPut[i];
      gen(pos + 1);
      used[i] := false;
    end;
  end;
end;

begin
  reset(input, problem_name + '.in');
  rewrite(output, problem_name + '.out');
  read(n);

  assert((1 <= n) and (n <= maxn));

  zCnt := 0;
  for i := 1 to n do
  begin
    read(a[i]);

    assert((0 <= a[i]) and (a[i] <= n));
    if a[i] > 0 then
    begin
      assert(not w[a[i]]);
      w[a[i]] := true;
    end;
    if a[i] = 0 then
    begin
      inc(zCnt);
      zPos[zCnt] := i;
    end;
  end;

  zCnt := 0;
  for i := 1 to n do
  begin
    if not w[i] then
    begin
      inc(zCnt);
      toPut[zCnt] := i;
    end;
  end;

  assert((0 <= zCnt) and (zCnt <= maxz));

  for i := 1 to zCnt do
    used[i] := false;
  gen(0);

  writeln(best);

end.

