import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;

public class problem_dp {
    private static final int INF = 1000000000;
    private static final String INPUT_FILE = "problem.in";
    private static final String OUTPUT_FILE = "problem.out";

    private int n;
    private int m;
    private int[][] a;
    private int answer;
    private int ar1;
    private int ar2;
    private int ac1;
    private int ac2;

    private BufferedReader in;
    
    public static void main(String[] args) throws IOException {
        problem_dp sol = new problem_dp();
        sol.read();
        sol.solve();
        sol.write();
    }

    private int readInt() throws IOException {
        int ch = in.read();
        while (ch != '-' && (ch < '0' || ch > '9'))
            ch = in.read();
        int sign;
        if (ch == '-') {
            sign = -1;
            ch = in.read();
        } else {
            sign = +1;
        }
        int res = 0;
        while (ch >= '0' && ch <= '9') {
            res = res * 10 + ch - '0';
            ch = in.read();
        }
        return res * sign;
    }
    
    private void read() throws IOException {
        in = new BufferedReader(new FileReader(INPUT_FILE));
        n = readInt();
        m = readInt();
        a = new int[n][m];
        for (int i = 0; i < n; i++)
            for (int j = 0; j < m; j++)
                a[i][j] = readInt();
        if (n < 2 || m < 2)
            System.exit(1);
    }
    
    private void solve() {
        java.util.Random r = new java.util.Random();
        int[] perm = new int[n];
        for (int i = 0; i < n; i++) {
            perm[i] = i;
            int j = r.nextInt(i + 1);
            int t = perm[i];
            perm[i] = perm[j];
            perm[j] = t;
        }

        int[] row = new int[n];
        for (int r1 = 0; r1 < n; r1++) {
            int max1 = -INF;
            int max2 = -INF;
            for (int c = 0; c < m; c++) {
                if (max1 < a[r1][c]) {
                    max2 = max1;
                    max1 = a[r1][c];
                } else if (max2 < a[r1][c]) {
                    max2 = a[r1][c];
                }
            }
            row[r1] = max1 + max2;
        }
        answer = -INF;
        for (int rr1 = 0; rr1 < n; rr1++)
            for (int rr2 = rr1 + 1; rr2 < n; rr2++) {
                int r1 = perm[rr1];
                int r2 = perm[rr2];
                int max1 = -INF;
                int max2 = -INF;
                int c1 = -1;
                int c2 = -1;
                for (int c = 0; c < m; c++) {
                    int sum = a[r1][c] + a[r2][c];
                    if (max1 < sum) {
                        max2 = max1;
                        max1 = sum;
                        c2 = c1;
                        c1 = c;
                    } else if (max2 < sum) {
                        max2 = sum;
                        c2 = c;
                    }
                }
                if (answer < max1 + max2) {
                    answer = max1 + max2;
                    ar1 = r1 + 1;
                    ar2 = r2 + 1;
                    ac1 = c1 + 1;
                    ac2 = c2 + 1;
                }
            }
    }
    
    private void write() throws IOException {
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        out.println(answer);
        out.println(Math.min(ar1, ar2) + " " + Math.min(ac1, ac2) + " " + Math.max(ar1, ar2) + " " + Math.max(ac1, ac2));
        out.close();
    }
}
