program puzzle;

uses
	sysutils;

const
	maxk = 10;
	maxn = 50;

var
	i, j, k, l, nn, a, b, t: longint;
	ok, found: boolean;
	d: array [1..maxk, 1..maxn, 1..maxn] of boolean;
	n, m: array [1..maxk] of longint;
	p, q: array [1..maxk, 1..maxn] of boolean;
	u: array [1..maxn] of boolean;

procedure dfs(i, j: longint);
var
	k: longint;
begin
	u[j] := true;

	for k := 1 to n[i] do
		if d[i][j][k] and not u[k] then
			dfs(i, k);
end;

begin
	reset(input, 'puzzle.in');
	rewrite(output, 'puzzle.out');

	readln(k);
	assert((1 <= k) and (k <= 10), 'number of graphs');
	nn := 0;
	for i := 1 to k do begin
		readln(n[i], m[i]);
		if (n[i] > nn) then
			nn := n[i];
		assert((2 <= n[i]) and (n[i] <= 50) and (1 <= m[i]) and (m[i] <= 1500), 'graph size ' + inttostr(i));
		for j := 1 to m[i] do begin
			readln(a, b);
			assert((a <> b), 'loop in graph ' + inttostr(i));
			assert((1 <= a) and (a <= n[i]) and (1 <= b) and (b <= n[i]), 'edge in graph ' + inttostr(i));
			d[i][a][b] := true;
			d[i][b][a] := true;
		end;

		fillchar(u, sizeof(u), 0);
		dfs(i, 1);
		for j := 1 to n[i] do
			assert(u[j], 'graph ' + inttostr(i) + ' is not connected');
	end;

	for i := 1 to k do
		p[i][1] := true;

	found := false;
	for t := 1 to 2 * nn do begin
		q := p;
		fillchar(p, sizeof(p), 0);
		for i := 1 to k do begin
			for j := 1 to n[i] do
				if q[i][j] then begin
					for l := 1 to n[i] do
						if d[i][j][l] then
							p[i][l] := true;
				end;
		end;

		ok := true;
		for i := 1 to k do
			if not p[i][n[i]] then
				ok := false;

		if ok then begin
			found := true;
			writeln(t);
			break;
		end;
	end;

	if not found then begin
		writeln('Impossible');
	end;

	close(input);
	close(output);
end.