import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Scanner;

public class puzzle_dp_bad {
    private static final int INF = 1000000000;

    private static final String INPUT_FILE = "puzzle.in";
    private static final String OUTPUT_FILE = "puzzle.out";

    private int k;
    private Graph[] gr;
    private int answer;
    
    private BufferedReader in;

    public static void main(String[] args) throws IOException {
        puzzle_dp_bad sol = new puzzle_dp_bad();
        sol.read();
        sol.solve();
        sol.write();
    }

    private int readInt() throws IOException {
        int ch = in.read();
        while (!(ch == '-' || (ch >= '0' && ch <= '9')))
            ch = in.read();
        int sign;
        if (ch == '-') {
            sign = -1;
            ch = in.read();
        } else {
            sign = +1;
        }
        int res = 0;
        while (ch >= '0' && ch <= '9') {
            res = res * 10 + ch - '0';
            ch = in.read();
        }
        return res * sign;
    }
    
    private void read() throws IOException {
        in = new BufferedReader(new FileReader(INPUT_FILE));
        k = readInt();
        gr = new Graph[k];
        for (int kk = 0; kk < k; kk++) {
            gr[kk] = new Graph();
        }
    }

    private void solve() {
        int maxOdd = 0;
        int maxEven = 0;
        for (int kk = 0; kk < k; kk++) {
            gr[kk].solve();
            if (maxOdd < gr[kk].distOdd)
                maxOdd = gr[kk].distOdd;
            if (maxEven < gr[kk].distEven)
                maxEven = gr[kk].distEven;
        }
        answer = Math.min(maxOdd, maxEven);
    }

    private void write() throws IOException {
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        if (answer == INF) {
            out.println("Impossible");
        } else {
            out.println(answer);
        }
        out.close();
    }
    
    private class Graph {
        private static final int EVEN = 0;
        private static final int ODD = 1;
        
        private int n;
        private int m;
        private boolean[][] e;
                        
        private int[][] dist;
        
        private int distOdd;
        private int distEven;
    
        private Graph() throws IOException {
            n = readInt();
            m = readInt();
            e = new boolean[n][n];
            for (int i = 0; i < m; i++) {
                int v1 = readInt() - 1;
                int v2 = readInt() - 1;
                e[v1][v2] = true;
                e[v2][v1] = true;
            }
        }
        
        private void solve() {
            dist = new int[2][n];
            for (int i = 0; i < 2; i++)
                for (int j = 0; j < n; j++) 
                    dist[i][j] = INF;
            dist[EVEN][n - 1] = 0;
            for (int t = 0; t < n - 4; t++)
                for (int v1 = 0; v1 < n; v1++)
                    for (int v2 = 0; v2 < n; v2++)
                        if (e[v1][v2]) {
                            if (dist[ODD][v1] > 1 + dist[EVEN][v2])
                                dist[ODD][v1] = 1 + dist[EVEN][v2];
                            if (dist[EVEN][v1] > 1 + dist[ODD][v2])
                                dist[EVEN][v1] = 1 + dist[ODD][v2];
                        }
            distOdd = dist[ODD][0];
            distEven = dist[EVEN][0];
        }
    }
}
