import java.io.BufferedReader;
import java.io.File;
import java.io.FileReader;
import java.io.IOException;
import java.io.PrintWriter;
import java.util.Arrays;

public class tester_dp {
    private static final int INF = 10000;
    private static final String INPUT_FILE = "tester.in";
    private static final String OUTPUT_FILE = "tester.out";
    private static final int MAXH = 50 + 1;
    private static final int MAXK = 10 + 1;

    private int h;
    private int k;

    private short[] ans;
    
    private BufferedReader in;
    
    public static void main(String[] args) throws IOException {
        tester_dp sol = new tester_dp();
        sol.read();
        sol.write();
    }

    private int readInt() throws IOException {
        int ch = in.read();
        while (ch != '-' && (ch < '0' || ch > '9'))
            ch = in.read();
        int sign;
        if (ch == '-') {
            sign = -1;
            ch = in.read();
        } else {
            sign = +1;
        }
        int res = 0;
        while (ch >= '0' && ch <= '9') {
            res = res * 10 + ch - '0';
            ch = in.read();
        }
        return res * sign;
    }
    
    private void read() throws IOException {
        in = new BufferedReader(new FileReader(INPUT_FILE));
        h = readInt();
        k = readInt();
        ans = new short[(MAXH + 1) * (MAXH + 1) * (MAXH + 1) * (MAXK + 1) * (MAXK + 1)];
        Arrays.fill(ans, (short) -1);
    }
    
    private int solve(int l, int r, int h, int k, int c) {
        if (l > r)
            return 0;
        if (k + c == 0 || k < 0) 
            return INF;

        if (l == r) {
            if (k > 0)
                return (h > l) ? 0: l - h;
            else
                return l - 1;
        }
        int ind = (((l * MAXH + r) * MAXH + h) * MAXK + k) * MAXK + c;
        if (ans[ind] != -1)
            return ans[ind];

        int result = INF;
        if (c > 0) {
            int res = l - 1 + solve(l, r, l, k + c, 0);
            if (result > res)
                result = res;
        }
        for (int i = l; i <= h; i++) {
            int res1 = solve(l, i - 1, i, k - 1, c);
            int res2 = solve(i + 1, r, i, k - 1, c + 1);
            if (res1 < res2)
                res1 = res2;
            if (result > res1) 
                result = res1;
        }
        for (int i = h + 1; i <= r; i++) {
            int res1 = solve(l, i - 1, i, k - 1, c);
            int res2 = solve(i + 1, r, i, k - 1, c + 1);
            if (res1 < res2)
                res1 = res2;
            res1 += i - h;
            if (result > res1) 
                result = res1;
        }
        ans[ind] = (short) result;
        return result;
    }
    
    private void write() throws IOException {
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        out.println(solve(2, h - 1, 1, k, 0));
        out.close();
    }
}
