{$apptype console}
{$o-,r+,q+}
{$maxstacksize 30000000}
uses
  sysutils, math;

type
  int = longint;

const
  maxfloor = 51;
  maxmarbles = 11;
  problem_name = 'tester';
  inf = 20000;
  THROW = 1;
  UP = 2;
  DOWN = 3;
  TOZERO = 4;

var
  a : array[0..maxfloor, 0..maxfloor, 1..maxfloor, 0..maxmarbles, 0..maxmarbles] of word;
  n, m : int;
  isIn : array[0..maxfloor, 0..maxfloor, 1..maxfloor, 0..maxmarbles, 0..maxmarbles] of boolean;

function solve(l, r : int; pos : int; have, zero : int) : int;
var
  t1, t2, t3, t4 : int;
begin
  if a[l][r][pos][have][zero] < inf then
  begin
    result := a[l][r][pos][have][zero];
    exit;
  end;
  if (l > r) then
  begin
    result := 0;
    exit;
  end;

  t1 := inf;
  t2 := inf;
  t3 := inf;
  t4 := inf;
  isIn[l][r][pos][have][zero] := true;
  result := inf;

  // Go up
  if (pos < r) and (not isIn[l][r][pos + 1][have][zero]) then
  begin
    t1 := 1 + solve(l, r, pos + 1, have, zero);
  end;

  // Go down
  if (pos > 1) and (not isIn[l][r][pos - 1][have][zero]) then
  begin
    t2 := solve(l, r, pos - 1, have, zero);
  end;

  // Take all
  if (pos = 1) and (zero <> 0) and (not isIn[l][r][pos][have + zero][0]) then
  begin
    t3 := solve(l, r, pos, have + zero, 0);
  end;

  // Drop the marble
  if (have > 0) and (l <= pos) and (pos <= r) then
  begin
    t4 := 0;
    // It breaks
    if (not isIn[l][pos - 1][pos][have - 1][zero]) then
      t4 := max(t4, solve(l, pos - 1, pos, have - 1, zero));
    // It doesn't break
    if (not isIn[pos + 1][r][pos][have - 1][zero + 1]) then
      t4 := max(t4, solve(pos + 1, r, pos, have - 1, zero + 1));
  end;

  result := min(result, t1);
  result := min(result, t2);
  result := min(result, t3);
  result := min(result, t4);

  isIn[l][r][pos][have][zero] := false;
//  a[l][r][pos][have][zero] := result;
end;

var
  i, j, k, l, p : int;

begin
  reset(input, problem_name + '.in');
  rewrite(output, problem_name + '.out');
  for i := 0 to maxfloor do
    for j := 0 to maxfloor do
      for k := 1 to maxfloor do
        for l := 0 to maxmarbles do
          for p := 0 to maxmarbles do
            a[i][j][k][l][p] := inf;
  while not seekeof do
  begin
    read(n, m);
    fillchar(isIn, sizeof(isIn), false);
    writeln(solve(2, n - 1, 1, m, 0));
  end;
end.