import java.util.Scanner;
import java.io.File;
import java.io.IOException;
import java.io.PrintWriter;

public class wall_dp {
    private static final int INF = 1000000000;
    private static final String INPUT_FILE = "wall.in";
    private static final String OUTPUT_FILE = "wall.out";

    private int n;
    private long[] h;
    private long[][] ans;

    private long height;
    private long answer;

    public static void main(String[] args) throws IOException {
        wall_dp sol = new wall_dp();
        sol.read();
        sol.solve();
        sol.write();
    }

    private void read() throws IOException {
        Scanner in = new Scanner(new File(INPUT_FILE));
        n = in.nextInt();
        h = new long[n];
        height = 0;
        for (int i = 0; i < n; i++) {
            height += h[i] = in.nextInt();
        }
        height /= n;
    }
    
    private void solve() {
        answer = 0;
        ans = new long[n][];
        for (int i = 0; i < n; i++) {
            ans[i] = new long[i + 2];
            for (int j = 0; j < ans[i].length; j++)
                ans[i][j] = -1;
        }
        long sum[] = new long[n];
        sum[0] = h[0];
        for (int i = 1; i < n; i++) {
            sum[i] = sum[i - 1] + h[i];
        }
        ans[0][0] = Math.abs(height - h[0]);
        ans[0][1] = Math.abs(height + 1 - h[0]);
        for (int x = 1; x < n; x++) {
            for (int cnt = 0; cnt <= x; cnt++) {
                for (int hh = 0; hh < 2; hh++) {
                    long diff = Math.abs(height * x + cnt + height + hh - sum[x]);
                    long tans = diff + ans[x - 1][cnt];
                    if (ans[x][cnt + hh] == -1 || ans[x][cnt + hh] > tans)
                        ans[x][cnt + hh] = tans;
                }
            }
        }
        int cnt = (int) (sum[n - 1] - n * height);
        answer = ans[n - 1][cnt];
    }
    
    private void write() throws IOException {
        PrintWriter out = new PrintWriter(new File(OUTPUT_FILE));
        out.println(answer);
        out.close();
    }
}
