#include <iostream>

#define forn(i, n) for (int i = 0; i < n; ++i)

using namespace std;

#define NMAX 3000

#define LIST (1 << 12)
#define INF int(1E+9)

int tree[2 * LIST];

void make_tree()
{
	forn (i, 2 * LIST) tree[i] = INF;
}

int find_lower(int val)
{
	int v = 1;
	while (v < LIST)		
	{
		v <<= 1;
		if (tree[v | 1] < val) v |= 1;
	}
	return v - LIST;
}

void update(int ps, int val)
{
	int v = LIST + ps;
	tree[v] = val;
	while (v > 1)
	{
		v >>= 1;
		tree[v] = min(tree[v << 1], tree[(v << 1) | 1]);
	}		
}

int main()
{
	freopen("rect.in", "rt", stdin);
	freopen("rect.out", "wt", stdout);
	int n, m;
	scanf("%d %d", &n, &m);
	long long ans = 0;
	int h[NMAX];
	memset(h, 0, sizeof(h));
	forn (i, n)
	{
		int T[NMAX];
		memset(T, 0, sizeof(T));	
		make_tree();
		forn (j, m)
		{
			int c = getchar();
			if (c <= ' ') c = getchar();
			if (c == 'W') h[j]++; else h[j] = 0;
			int pred = find_lower(h[j]);
			update(j, h[j]);
			if (h[pred] >= h[j])
				T[j] = (j + 1) * h[j];
			else
				T[j] = (j - pred) * h[j] + T[pred];
			ans += T[j];
		}						
	}

	cout << ans << endl;

	return 0;
}
