{$Q+,R+,I+,O-}
Const
  Max = 100000;

Type
  Integer = Longint;
  Point =
    Record
      x, y: Integer;
    End;

Var
  nk, n, h1, h2: Integer;
  p, p1, p2: Point;
  vx, vy, l: Array[0..Max] Of Integer;

Function GetH(Var nk: Integer; w, h1, h2: Integer): Integer;
Var
  k: Integer;
Begin
  k := 0;
  While (w > 0) Do
    Begin
      If (h1 <> h2) Then
        Inc(k);
      Dec(w, k);
      Dec(h1);
    End;
  GetH := h1+1;
  nk := k+w;
End;

Procedure SetPoint(p: Point);
Begin
  If (vx[p.y] <> 0) Then
    RunError(215);

  If (vy[p.x] <> 0) Then
    RunError(215);

  vx[p.y] := p.x;
  vy[p.x] := p.y;
End;

Procedure GetFreePoint(Var p: Point; x1, x2, hMax, hMin: Integer);
Var
  h: Integer;
Begin
  For h := hMax Downto hMin Do
    Begin
      If (vx[h] <> 0) Then
        Continue;
      If (l[h] > x2-x1+1) Then
        Continue;
      p.x := x1;
      p.y := h;
      Exit;
    End;
  RunError(215);
End;

Function GetFreeH(h: Integer): Integer;
Begin
  While (vx[h] <> 0) Do
    Inc(h);
  GetFreeH := h;
End;

Procedure Solve(i1, i2, hMin: Integer);
Var
  hMax: Integer;
  p: Point;
Begin
  hMax := n;
  While (i1 <= i2) Do
    Begin
      GetFreePoint(p, i1, i2, hMax, hMin);
      SetPoint(p);
      hMax := p.y;
      Inc(i1, l[p.y]);
    End;
End;

Procedure Fill(i1, i2: Integer);
Var
  i: Integer;
Begin
  p.x := 0;
  p.y := 0;
  For i := i2 Downto i1 Do
    If (vy[i] = 0) Then
      Begin
        p.x := i;
        p.y := GetFreeH(p.y);
        SetPoint(p);
      End;
End;

Procedure MakeL(w: Integer);
Var
  h: Integer;
Begin
  For h := h2 To n Do
    Begin
      If (vx[h] <> 0) Then
        Continue;
      l[h] := h-h2;
      If (nk > 0) Then
        Begin
          Inc(l[h]);
          Dec(nk);
        End;
      If (l[h] > w) Then
        l[h] := w;
      Dec(w, l[h]);
    End;
End;

Var
  w, i: Integer;
Begin
  Assign(input, 'skier.in');
  Reset(input);
  Read(n, p.x, p.y);

  h1 := GetH(nk, n, n, 0);
  If (p.y > h1) Then
    p.y := h1;

  p1 := p;
  While (p1.x > 1) And (p1.y < n) Do
    Begin
      Dec(p1.x);
      Inc(p1.y);
    End;

  p2 := p;
  While (p2.x < n) And (p2.y > h1) Do
    Begin
      Inc(p2.x);
      Dec(p2.y);
    End;
  
  vx[0]:=2*n;
  vy[0]:=2*n;
  w := n-(p2.x-p1.x+1);
  h2 := GetH(nk, w, n, p1.y);

  FillChar(vx, sizeof(vx), 0);
  FillChar(vy, sizeof(vy), 0);
  FillChar(l, sizeof(l), 0);
  vx[0]:=2*n;
  vy[0]:=2*n;

  SetPoint(p1);
  MakeL(w);

  Fill(p1.x, p2.x);
  Solve(1, p1.x-1, h2);
  Solve(p2.x+1, n, h2);
  Fill(1, n);

  Assign(output, 'skier.out');
  Rewrite(output);

  For i := 1 To n Do
    Write(vy[i], ' ');
  WriteLn;

  Close(output);
End.