#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>

#define inpfile "threecolors.in"
#define outfile "threecolors.out"

const int NMAX = 105;

int a[NMAX][NMAX];
int col[4];
int m,n;
int h,w;

void Init()
{
	freopen(inpfile,"r",stdin);
	freopen(outfile,"w",stdout);
}

void Out()
{
	exit(0);
}

void Paint(int x, int y)
{
	printf("%d %d\n",x,y);

	int num;
	memset(col,0,sizeof(col));
	col[a[x][y]]++;
	col[a[x + 1][y]]++;
	col[a[x][y + 1]]++;
	col[a[x + 1][y + 1]]++;

	num = 1;
	if (col[num] < col[2]) num = 2;
	if (col[num] < col[3]) num = 3;
	if ((col[1] == 2) && (col[2] == 2)) num = 3;
	if ((col[1] == 2) && (col[3] == 2)) num = 2;
	if ((col[2] == 2) && (col[3] == 2)) num = 1;

	a[x][y] = num;
	a[x + 1][y] = num;
	a[x][y + 1] = num;
	a[x + 1][y + 1] = num;
}

void IncHeight()
{
	int i,j;

	if (a[h + 1][1] == a[1][1]) j = 1;
	else {
		for (i = 2; (i <= w) && (a[h + 1][i] == a[h + 1][1]); i++);
		if (i <= w) j = i - 1;
		else {
			Paint(h,w - 1);
			Paint(h - 1,w - 2);
			Paint(h - 1,w - 1);
			j = w - 2;
		}
	}

	for (i = j; i >= 1; i--) Paint(h,i);
	for (i = j + 1; i <= w - 1; i++) Paint(h,i);
	h++;
}

void IncWidth()
{
	int i,j;

	if (a[1][w + 1] == a[1][1]) j = 1;
	else {
		for (i = 2; (i <= h) && (a[i][w + 1] == a[1][w + 1]); i++);
		if (i <= h) j = i - 1;
		else {
			Paint(h - 1,w);
			Paint(h - 2,w - 1);
			Paint(h - 1,w - 1);
			j = h - 2;
		}
	}

	for (i = j; i >= 1; i--) Paint(i,w);
	for (i = j + 1; i <= h - 1; i++) Paint(i,w);
	w++;
}

bool Triple()
{
	int i,j;
	for (i = 1; i <= 3; i++)
		for (j = 1; j <= 3; j++)
			if (a[i][j] != a[1][1]) return false;
	return true;
}

void Solve()
{
	int i,j;

	while (!Triple()) {
		i = rand()%2 + 1;
		j = rand()%2 + 1;
		Paint(i,j);
	}

	h = 3; w = 3;
	for (i = 3; i < m; i++) IncHeight();
	for (i = 3; i < n; i++) IncWidth();
}

void Inp()
{
	int i,j;
	char ch;

	scanf("%d %d\n",&m,&n);
	for (i = 1; i <= m; i++)
		for (j = 1; j <= n; j++) {
			scanf("%c",&ch);
			switch (ch) {
				case 'R': a[i][j] = 1; break;
				case 'G': a[i][j] = 2; break;
				case 'B': a[i][j] = 3;
			}
			scanf("\n");
		}
}

int main()
{
	srand(2835);
	Init();
	Inp();
	Solve();
	Out();
	return 0;
}
