#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#include <time.h>

#define inpfile "threecolors.in"
#define outfile "threecolors.out"

const int NMAX = 105;
const double TL = 1.9;

struct COORD {
	int x,y;
};

int a0[NMAX][NMAX];
int cnt0[4];

int a[NMAX][NMAX];
int cnt[4];
int col[4];
int m,n;
int h,w;
int start;

COORD way[10*NMAX*NMAX];
int wayn;

void Init()
{
	freopen(inpfile,"r",stdin);
	freopen(outfile,"w",stdout);
}

void Out()
{
	exit(0);
}

void Paint(int x, int y)
{
	wayn++;
	way[wayn].x = x;
    	way[wayn].y = y;

	int i,num;
	memset(col,0,sizeof(col));
	col[a[x][y]]++;
	col[a[x + 1][y]]++;
	col[a[x][y + 1]]++;
	col[a[x + 1][y + 1]]++;

	num = 1;
	if (col[num] < col[2]) num = 2;
	if (col[num] < col[3]) num = 3;
	if ((col[1] == 2) && (col[2] == 2)) num = 3;
	if ((col[1] == 2) && (col[3] == 2)) num = 2;
	if ((col[2] == 2) && (col[3] == 2)) num = 1;

	for (i = 1; i <= 3; i++) cnt[i] -= col[i];
	cnt[num] += 4;

	a[x][y] = num;
	a[x + 1][y] = num;
	a[x][y + 1] = num;
	a[x + 1][y + 1] = num;
}

bool Triple()
{
	int i;
	for (i = 1; i <= 3; i++)
		if (cnt[i] == n*m) return true;

	return false;
}

void Solve()
{
	int i,j;

	do {
		for (i = 1; i <= m; i++)
			for (j = 1; j <= n; j++) a[i][j] = a0[i][j];
		for (i = 1; i <= 3; i++) cnt[i] = cnt0[i];

		wayn = 0;
		while (!Triple() && (wayn <= 10*m*n)) {
			i = rand()%(m - 1) + 1;
			j = rand()%(n - 1) + 1;
			Paint(i,j);
		}
	} while ((wayn > 10*m*n) && (clock() - start < TL * CLOCKS_PER_SEC));

	for (i = 1; i <= wayn; i++)
		printf("%d %d\n",way[i].x,way[i].y);
}

void Inp()
{
	int i,j;
	char ch;

	memset(cnt0,0,sizeof(cnt0));
	scanf("%d %d\n",&m,&n);
	for (i = 1; i <= m; i++)
		for (j = 1; j <= n; j++) {
			scanf("%c",&ch);
			switch (ch) {
				case 'R': a0[i][j] = 1; cnt0[1]++; break;
				case 'G': a0[i][j] = 2; cnt0[2]++; break;
				case 'B': a0[i][j] = 3; cnt0[3]++;
			}
			scanf("\n");
		}
}

int main()
{
	start = clock();
	srand(2835);
	Init();
	Inp();
	Solve();
	Out();
	return 0;
}
