#include <stdio.h>
#include <assert.h>
#include <stdlib.h>
#include <string.h>
#include <iostream>

using namespace std;

#define FILE_IN "threecolors.in"
#define FILE_OUT "threecolors.out"

const int MAXN = 100;
const int MAXM = 100;

int a[MAXN][MAXM];
int n,m;

void OpenFiles() {
	freopen(FILE_IN,"r",stdin);
	freopen(FILE_OUT,"w",stdout);
}

void CloseFiles() {
	fclose(stdout);
}

void Initialize(){
	
}

void ReadData() {
	scanf("%d %d\n",&n,&m);
	assert(n>=3);
	assert(m>=3);
	char ch;
	for (int i=0;i<n;i++){
		for (int j=0;j<m;j++) {
			scanf("%c",&ch);
			switch(ch) {
			case 'R': a[i][j] = 0; break;
			case 'G': a[i][j] = 1; break;
			case 'B': a[i][j] = 2; break;
			}
		}
		scanf("\n");
	}
			
}

void OutData();

int Change(int i, int j) {
	int tmp[3]={0,0,0};
	int di,dj;
    for(di=0;di<2;di++)
    	for(dj=0;dj<2;dj++)
    		tmp[a[i+di][j+dj]]++;
    int t=0;
    if (tmp[1]>tmp[t]) t = 1;
    if (tmp[2]>tmp[t]) t = 2;

    if (tmp[t]==2) {
    	if (tmp[0]==0) t = 0;
    	else if (tmp[1]==0) t = 1;
    	else if (tmp[2]==0) t = 2;
    } 

	for(di=0;di<2;di++)
    	for(dj=0;dj<2;dj++)
    		a[i+di][j+dj] = t;
    
	cout << i+1 << " " << j+1 << endl;
	OutData();
	return t;
}

void Color33(int i,int j) {
	Change(i,j);
	Change(i+1,j+1);

	if (a[i][j]==a[i+1][j+1]) {
		Change(i+1,j);
		Change(i,j+1);
	} else {
		if (a[i+2][j]==a[i][j]) {
			Change(i+1,j);
			Change(i+1,j+1);
			Change(i,j);
			Change(i+1,j);
			Change(i,j+1);
		} else {
			Change(i+1,j);
			Change(i,j);
			Change(i+1,j);
			Change(i,j);
			Change(i+1,j+1);
			Change(i+1,j);
			Change(i,j+1);
		}
	}	
}

void AddDown(int i,int j) {
	Change(i,j+1);
	if (a[i][j]==a[i][j+2]) {
		Change(i+1,j+1);
	} else {
		Change(i,j);
		Change(i,j+1);
		Change(i+1,j);
		Change(i,j);
		Change(i+1,j+1);
	}
}                   

void AddRight(int i,int j) {
	Change(i+1,j);
	if (a[i][j]==a[i+2][j]) {
		Change(i+1,j+1);
	} else {
		Change(i,j);
		Change(i+1,j);
		Change(i,j+1);
		Change(i,j);
		Change(i+1,j+1);
	}
}

void Solve() {
	int i,j;
	for (i=0;i+2<n;i+=3) {
		if (i>0) {
			AddRight(i-2,0);
			AddRight(i-1,0);
			AddRight(i,0);		
		} else Color33(0,0);
		for (j=1;j<m-2;j++) {
			AddDown(i,j);
		}
	}
    
	if (n%3) {
		if (n%3==1) AddRight(n-3,0);
		if (n%3==2) {
			AddRight(n-4,0);
			AddRight(n-3,0);
		}
		for (j=1;j<m-2;j++) {
			AddDown(n-3,j);
		}	
	}
    
}

void OutData() {
/*		
	int i,j;
	printf("\n\n");
	for (i=0;i<n;i++)     {
		for (j=0;j<m;j++) printf("%d",a[i][j]);
		printf("\n");	
	}   
*/    

}

int main(int argc, char * arg[]) {
	OpenFiles();
    Initialize();
    ReadData();
   	Solve();
   	OutData();
    CloseFiles();
    return 0;	
}