{$R+,Q+,S+}
Uses SysUtils;
Const
  TaskID='threecolors';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
  MaxSize=100;
  BufSize=8 Shl 20;
  Colors='RGB';

Var
  Height,Width:Integer;
  GotRows,GotCols:Integer;
  Transposed:Boolean;
  Field,FieldTmp:Array[1..MaxSize,1..MaxSize]Of Integer;
  Buffer:Array[1..BufSize]Of Byte;

Procedure Load;
Var
  Row,Col:Integer;
  Ch:Char;
Begin
  ReSet(Input,InFile);
  SetTextBuf(Input,Buffer);
  Read(Height,Width);
  Assert(EOLN);
  Assert((Height>=3) And (Height<=MaxSize) And (Width>=3) And (Width<=MaxSize));
  ReadLn;
  For Row:=1 To Height Do Begin
    For Col:=1 To Width Do Begin
      Assert(Not EOLN);
      Read(Ch);
      Field[Row,Col]:=Pos(Ch,Colors)-1;
      Assert(Field[Row,Col]>=0);
    End;
    Assert(EOLN And Not EOF);
    ReadLn;
  End;
  Assert(EOF);
  Close(Input);
  Transposed:=False;
End;

Procedure Transpose;
Var
  I,J,T:Integer;
Begin
  For I:=1 To Height Do
    For J:=1 To Width Do 
      FieldTmp[J,I]:=Field[I,J];
  Field:=FieldTmp;
  T:=Height;
  Height:=Width;
  Width:=T;
  T:=GotRows;
  GotRows:=GotCols;
  GotCols:=T;
  Transposed:=Not Transposed;
End;

Procedure Toggle(Row,Col:Integer);
Var
  Num:Array[0..2]Of Integer;
  I,Color,DRow,DCol:Integer;
Begin
  If Transposed Then WriteLn(Col,' ',Row) Else WriteLn(Row,' ',Col);
  FillChar(Num,SizeOf(Num),0);
  For DRow:=0 To 1 Do
    For DCol:=0 To 1 Do
      Inc(Num[Field[Row+DRow,Col+DCol]]);
  Color:=-1;
  For I:=0 To 2 Do
    If Num[I]>=3 Then Color:=I;
  If Color=-1 Then
    For I:=0 To 2 Do
      If Num[I]=0 Then Color:=I;
  If Color=-1 Then
    For I:=0 To 2 Do
      If Num[I]=2 Then Color:=I;
  For DRow:=0 To 1 Do
    For DCol:=0 To 1 Do
      Field[Row+DRow,Col+DCol]:=Color;
End;

Procedure Solve;
Var
  I:Integer;
  We:Integer;
Begin
  ReWrite(Output,OutFile);
  Toggle(1,1);
  Toggle(1,2);
  If Field[1,1]=Field[1,2] Then Begin
    GotRows:=2;
    GotCols:=3;
  End Else Begin
    Toggle(1,1);
    While (Field[1,1]<>Field[3,1]) Do Begin
      Toggle(1,2);
      Toggle(1,1);
    End;
    Toggle(2,1);
    GotRows:=3;
    GotCols:=2;
  End;
  We:=Field[1,1];
  While (GotRows<Height) Or (GotCols<Width) Do Begin
    If (GotRows>=3) And (GotCols<Width) Then Begin
      If (Field[1,GotCols+1]=We) Or (Field[2,GotCols+1]=We) Or (Field[1,GotCols+1]<>Field[2,GotCols+1]) Then
        Toggle(1,GotCols)
      Else
        If Field[3,GotCols+1]<>Field[2,GotCols+1] Then Begin
          Toggle(2,GotCols);
          Toggle(1,GotCols);
        End Else Begin
          Toggle(1,GotCols);
          Toggle(2,GotCols-1);
          Toggle(1,GotCols-1);
          Toggle(2,GotCols);
          Toggle(1,GotCols);
        End; 
      For I:=2 To GotRows-1 Do Toggle(I,GotCols);
      Inc(GotCols);
    End Else Transpose;
  End;
  Close(Output);
End;

Begin
  Load;
  Solve;
End.
