#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
//#include <cmath>
//#include <queue>
#include <set>
//#include <map>
//#include <algorithm>
#include <iostream>
//#include <cstdio>
//#include <sstream>
#include <cassert>
#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "orient.in"
#define C_OUT_FILE "orient.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

const int NMAX =  11000;
const int MMAX = 110000;
const int VMAX = NMAX + MMAX;
const int list = 1 << 17;

struct edge {
	int u, v, c, p, w, rev;
};

typedef int tar[VMAX];

int n, m, ans, kans, kv;

vector<edge> g[VMAX];

int s, t;
tar pr, pv, d, p;
int tree[list * 2];

void outdata() {
	printf("%d %d\n", kans, ans);
}

int fmin() {
	int v = 1;
	while (v < list) {
		v <<= 1;
		if (tree[v | 1] < tree[v]) v |= 1;
	}
	return v - list;
}

void update(int v, int b) {
	v += list;
	tree[v] = b;
	while (v > 1) {
		tree[v >> 1] = min(tree[v], tree[v ^ 1]);
		v >>= 1;
	}
}

bool dijkstra() {
	forn(i, kv) d[i] = INF;
	forn(i, list * 2) tree[i] = INF;
	d[s] = 0;
	update(s, 0);
	while (tree[1] < INF) {
		int v = fmin();
		if (v == t) break;
		update(v, INF);
		forv(i, g[v]) {
			if (g[v][i].c > g[v][i].p) {
				int nv = d[v] + g[v][i].w + p[v] - p[g[v][i].v];
				if (d[g[v][i].v] > nv) {
					d[g[v][i].v] = nv;
					pv[g[v][i].v] = v;
					pr[g[v][i].v] = i;
					update(g[v][i].v, nv);
				}
			}
		}
	}
	if (d[t] >= INF) return false;
	forn(i, kv) p[i] += min(d[i], d[t]);
	int v = t;
	while (v != s) {
		int vp = pv[v];
		ans += g[vp][pr[v]].w;
		++g[vp][pr[v]].p;
		--g[v][g[vp][pr[v]].rev].p;
		v = vp;
	}
	return true;
}

void solve() {
	memset(p, 0, sizeof p);
	ans = kans = 0;
	while (dijkstra()) {
		++kans;
	}
}

void push(int u, int v, int c, int w) {
	edge r;
	r.u = u, r.v = v, r.c = c, r.w = w, r.p = 0, r.rev = (int)g[v].size();
	g[u].pb(r);
	r.u = v, r.v = u, r.c = 0, r.w = -w, r.p = 0, r.rev = (int)g[u].size() - 1;
	g[v].pb(r);
}

void readdata() {
	set< PII > edges;
	scanf("%d%d", &n, &m);
	assert(1 <= n && n <=  10000);
	assert(1 <= m && m <= 100000);
	forn(i, m) {
		int x, y, c1, c2;
		scanf("%d%d%d%d", &x, &y, &c1, &c2);
		--x, --y;
		assert(0 <= x && x < n);
		assert(0 <= y && y < n);
		assert(x != y);
		assert(edges.count(mp(x, y)) == 0);
		assert(edges.count(mp(y, x)) == 0);
		edges.insert(mp(x, y));
		push(x, n + i, 1, c2);
		push(y, n + i, 1, c1);
	}
	edges.clear();
	s = n + m;
	t = n + m + 1;
	forn(i, n) {
		push(s, i, 1, 0);
	}
	forn(i, m) {
		push(n + i, t, 1, 0);
	}
	kv = n + m + 2;
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}

