#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
//#include <cmath>
//#include <queue>
//#include <set>
//#include <map>
//#include <algorithm>
#include <iostream>
//#include <cstdio>
//#include <sstream>
#include <cassert>
//#include <utility>

using namespace std;

#define EPS 1E-8
const int INF = (int)1E+9;

#define C_IN_FILE "typing.in"
#define C_OUT_FILE "typing.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

int n, m, ans;

struct vertex {
	int p[26];
	int sfl, l;
	vertex() {
		memset(p, 255, sizeof p);
		l = sfl = -1;
	}
	vertex(const vertex & a) {
		memmove(p, a.p, sizeof p);
		l = a.l; sfl = a.sfl;
	}
};

typedef vector<vertex> tree;

VS a;
string s;
vector<tree> ats;

void outdata() {
	printf("%d\n", ans);
}

void makeAutomat(int no) {
	tree &b = ats[no];
	b.pb(vertex());
	int lst = 0;
	forv(i, a[no]) {
		int c = a[no][i] - 'a';
		assert(0 <= c && c < 26);
		int v = lst;
		lst = (int)b.size();
		b.pb(vertex());
		b[lst].l = i + 1;
		while (v > -1 && b[v].p[c] == -1) {
			b[v].p[c] = lst;
			v = b[v].sfl;
		}
		if (v == -1) {
			b[lst].sfl = 0;
			continue;
		}
		int q = b[v].p[c];
		if (b[q].l == b[v].l + 1) {
			b[lst].sfl = q;
		} else {
			int clone = (int)b.size();
			b.pb(vertex(b[q]));
			b[q].sfl = clone;
			b[clone].l = b[v].l + 1;
			b[lst].sfl = clone;
			while (v > -1 && b[v].p[c] == q) {
				b[v].p[c] = clone;
				v = b[v].sfl;
			}
		}
	}
}

void solve() {
	ats.resize(n);
	forv(i, a) makeAutomat(i);
	ans = (int)s.length();
	VI c(n, 0), nx(n, 0);
	fors(t, s) {
		int mx = 0;
		forv(i, a) {
			mx = max(mx, c[i]);
			int r, v = 0;
			for(r = c[i]; r < (int)s.length() && ats[i][v].p[s[r] - 'a'] != -1; ++r) v = ats[i][v].p[s[r] - 'a'];
			nx[i] = max(c[i] + 1, r);
		}
		bool ok = false;
		forv(i, a) {
			nx[i] = max(nx[i], mx);
			if (nx[i] == (int)s.length()) {
				ans = min(ans, t + 2);
				ok = true;
				break;
			}
		}
//		forn(i, n) cerr << nx[i] << " ";
//		cerr << endl;
		if (ok) break;
		c = nx; nx = VI(n, 0);
	}
}

void readdata() {
	scanf("%d", &n);
	a = VS(n);
	assert(0 < n && n <= 50);
	forn(i, n) cin >> a[i];
	forn(i, n) assert(0 < a[i].length() && a[i].length() <= 500);
	cin >> s;
	assert(0 < s.length() && s.length() <= 100000);
}

int main() {
    freopen(C_IN_FILE, "rt", stdin);
    freopen(C_OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}

