{$APPTYPE CONSOLE}
{$D-,L-,I-,Q-,R-,O+}
  Const MaxL=130000;
        Task_Id='holytape';
        File_In=Task_ID+'.in';
        File_Out=Task_ID+'.out';
  Type Int=LongInt;
       Tape=Record
              L:Int;
              Bits:Array[0..MaxL]Of Byte;
            End;
  Var T1,T2:Tape;
      D1,D2:Array[1..MaxL]Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure ReadTape(Var T:Tape);
  Var Sym:Char;
Begin
  T.L:=0;
  T.Bits[0]:=0;
  Read(Sym);
  While Not(Sym in ['0','1']) Do Read(Sym);
  While Sym in ['0','1'] Do Begin
    Inc(T.L);
    T.Bits[T.L]:=Ord(Sym)-Ord('0');
    Read(Sym);
  End;
End;

Procedure Init;
Begin
  ReadTape(T1);
  ReadTape(T2);
End;

Function Min(Const A,B:Int):Int;
Begin
  If A<B Then Min:=A
  Else Min:=B;
End;

Function Max(Const A,B:Int):Int;
Begin
  If A>B Then Max:=A
  Else Max:=B;
End;

Procedure Solve;
  Var Ans,I,J,NowAns:Int;
Begin
  Ans:=0;
  J:=T1.L+1;
  For I:=T1.L DownTo 1 Do
    If T1.Bits[I]=0 Then
      D1[I]:=J-I
    Else Begin
      J:=I;
      D1[I]:=1;
    End;
  J:=T2.L+1;
  For I:=T2.L DownTo 1 Do
    If T2.Bits[I]=0 Then
      D2[I]:=J-I
    Else Begin
      J:=I;
      D2[I]:=1;
    End;
  For J:=-T1.L+1 To T2.L-1 Do Begin
    NowAns:=0;
    I :=Max(1,1+J);
    While I<=Min(T2.L,T1.L+J) Do Begin
      If (T1.Bits[I-J] And T2.Bits[I]=1) And
         (T1.Bits[I-J-1] And T2.Bits[I-1]=0) Then Begin
        Inc(NowAns);
        Inc(I,2)
      End
      Else Inc(I,Max(D1[I-J],D2[I]));
    End;
    If NowAns>Ans Then
      Ans:=NowAns;
  End;
  WriteLn(Ans);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.