{$Q-,R-,I-,O+}
{$APPTYPE CONSOLE}
//{$MAXSTACKSIZE 1000000000}

uses SysUtils;



  
const 
  FileName = 'holytape';
  DEBUG = 0;
//  maxd = 300000;



const
  MaxN = 18;
  _2_MaxN = 1 shl MaxN;
  SShift = 1 shl (MaxN - 2);

type poly = array[0.._2_MaxN+6] of integer;


type
  float = extended;
  complex = record x, y : float end;
  carr = array [0.._2_MaxN-1] of complex;
  pcarr = ^carr;
var
  si  : array [0..3*SShift] of float;
  Rev : array [0.._2_MaxN-1] of integer;
  N, _2_N   : integer;

procedure inittabs;
var i, j, k : integer;
    alpha, s, c : float;
begin
  alpha := 2 * Pi / _2_MaxN;
  for i := 0 to 1 shl (MaxN - 3) do
    begin
      s := sin (alpha * i);
      c := cos (alpha * i);
      si[i] := s;
      si[SShift-i] := c;
      si[SShift+i] := c;
      si[2*SShift-i] := s;
      si[2*SShift+i] := -s;
      si[3*SShift-i] := -c
    end;
  j := 0;
  for i := 0 to _2_MaxN - 1 do
    begin
      Rev[i] := j;
      k := _2_MaxN;  repeat k := k shr 1 until (j and k) = 0;
      j := (j + 3*k) and (_2_MaxN - 1)
    end
end;

procedure setn (x : integer);
begin
  N := 0;  dec (x);
  while x > 0 do begin x := x shr 1; inc(N) end;
  if N > MaxN then runerror (239);
  _2_N := 1 shl N;
end;

function newcarr : pcarr;
var P : pcarr;
begin
  getmem (P, sizeof(complex) shl N);
  fillchar (P^, sizeof(complex) shl N, 0);
  newcarr := P
end;

procedure freecarr (X : pcarr);
begin
  freemem (X, sizeof(complex) shl N)
end;

function decomp (var Y : poly) : pcarr;
var X : pcarr;
    i : integer;
begin
  X := newcarr;
  for i := 0 to _2_N - 1 do X^[i].x := Y[i];
  Result := X
end;

procedure QFT (ZZ : pcarr);
var i, j, k, s, mark1, mark2, sh   : integer;
    z                              : complex;
begin
  for s := 0 to N - 1 do
    begin
      mark1 := 1 shl s;
      mark2 := mark1 - 1;
      sh := MaxN - s - 1;
      for i := 0 to _2_N - 1 do
        if (i and mark1) = 0 then begin
          j := i + mark1;
          k := (i and mark2) shl sh;
          with ZZ^[j] do begin
            z.x := si[SShift+k] * x - si[k] * y;
            z.y := si[SShift+k] * y + si[k] * x
          end;
          with ZZ^[i] do begin
            ZZ^[j].x := x - z.x;  ZZ^[j].y := y - z.y;
            x := x + z.x;  y := y + z.y
          end
        end
    end
end;

procedure revarr (ZZ : pcarr);
var i, j, sh : integer;
    t        : complex;
begin
  sh := MaxN - N;
  for i := 0 to _2_N - 1 do
    begin
      j := Rev[i shl sh];
      if j > i then begin
        t := ZZ^[i];  ZZ^[i] := ZZ^[j];  ZZ^[j] := t
      end
    end
end;

procedure mularrs (A, B : pcarr);
var i  : integer;
    z  : complex;
begin
  for i := 0 to _2_N - 1 do
    begin
      z.x := A[i].x * B[i].x - A[i].y * B[i].y;
      z.y := A[i].x * B[i].y + A[i].y * B[i].x;
      A[i] := z
    end
end;

var maxre : float;
function _round (x : float) : int64;
var y : int64;
begin y := round (x); Result := y;
      x := abs (x - y); if x > maxre then maxre := x
end;


procedure mull (var Y, Z, RES : poly);
var
  A, B : pcarr;
  nn,mm,i:integer;
  f:float;
begin
  i:=_2_MAXN-1;
  while (i>=0) and (y[i]=0) do dec(i);
  nn:=i;
  i:=_2_MAXN-1;
  while (i>=0) and (z[i]=0) do dec(i);
  mm:=i;
  setn (nn + mm+2);
  A := decomp (Y);
  B := decomp (Z);
  revarr (A);
  revarr (B);
  QFT (A);
  QFT (B);
  mularrs (A, B);
  freecarr (B);
  revarr (A);
  QFT (A);
  f:=1;
  for i:=1 to N do
    f:=f*0.5;
  RES[0] := round(A^[0].x*f);
  for i:=1 to _2_N-1 do begin
    res[i]:=round(A^[_2_N-i].x*f);
  end;
    
end;


var tn,tm,i,j,cc,best:integer;
    c:char;
    p1,p2,p,q1,q2,q:poly;
    s1,s2:array[0.._2_MAXN] of char;


begin
//  writeln('UU'); flush(output);
  reset(input,FileName+'.in');
  rewrite(output,FileName+'.out');
  inittabs;
  tn:=0; tm:=0;
  read (c);
  while c<>#13 do begin
    assert (c in ['0'..'1']);
    inc (tn);
    s1[tn]:=c;
    read(c);
  end;
  s1[0]:='0'; s1[tn+1]:='0';
  read (c);
  assert (c=#10);
  read (c);
  while c<>#13 do begin
    assert (c in ['0'..'1']);
    inc (tm);
    s2[tm]:=(c);
    read(c);
  end;
  s2[0]:='0'; s2[tm+1]:='0';
  inc(tm,2); inc(tn,2);
  read (c);
  assert (c=#10);
  for i:=0 to tn-2 do begin
    if(s1[i]='0') and (s1[i+1]='1') then begin
      p1[i]:=1;
    end;
  end;
  for i:=0 to tm-2 do begin
    if(s2[i]='1') and (s2[i+1]='0') then begin
      p2[tm-1-i]:=1;
    end;
  end;
  mull(p1,p2,p);
  for i:=0 to tn-2 do begin
    if(s1[i]='1') and ( s1[i+1]='0') then begin
      q1[i]:=1;
    end;
  end;
  for i:=0 to tm-2 do begin
    if(s2[i]='0') and (s2[i+1]='1') then begin
      q2[tm-1-i]:=1;
    end;
  end;
  mull(q1,q2,q);
  best:=0;
  cc:=0;
  for i:=-(tm-1) to tn-2 do begin
    if (cc>best) then
      best:=cc;
    inc(cc,p[i+(tm-1)]);
    dec(cc,q[i+(tm-1)+1]);

  end;
  writeln(best);
end.

