import java.io.*;
import java.util.*;
import java.math.*;



public class TwoStrings_vv_poly_zub{

  
  public static final String FileName = "holytape";

  int DEBUG = 0;
  int MAXD = 5000;

  public int max(int a,int b){
    if (a>b){ return a;}
    else return b;
  }

  public int min(int a,int b){
    if (a<b){ return a;}
    else return b;
  }

  public int max(int a, int b, int c){
    return max(max(a,b),c);
  }


  public int[] add(int[] x,int[] y) throws Exception{
    int n = x.length;
    int m = y.length;
    int[] res = new int[max(n,m)];
    for(int i=0;i<min(n,m);i++){
      res[i]=x[i]+y[i];
    }
    if (n<m){
      for(int i=n;i<m;i++){
        res[i]=y[i];
      }
    } else {
      for(int i=m;i<n;i++){
        res[i]=x[i];
      }
    }
    return res;
  }

  public int[] dec(int[] x,int[] y) throws Exception{
    int n = x.length;
    int m = y.length;
    int[] res = new int[max(n,m)];
    for(int i=0;i<min(n,m);i++){
      res[i]=x[i]-y[i];
    }
    if (n<m){
      for(int i=n;i<m;i++){
        res[i]=-y[i];
      }
    } else {
      for(int i=m;i<n;i++){
        res[i]=x[i];
      }
    }
    return res;
  }

  int tt=0;  

  public int[] easy_mult(int[] x,int[] y){
    int n = x.length-1;
    int m = y.length-1;
    int[] res = new int[n+m+1];
    for(int i=0; i<=n;i++)
      for(int j=0; j<=m; j++){
        res[i+j]+=x[i]*y[j];
      }
    return res;
  }

  public int[] mult(int[] x,int[] y) throws Exception{
    if (x.length*y.length<MAXD){
      return easy_mult(x,y);
    }
    if(DEBUG>0){
      tt++;
    }
    
    if (DEBUG>0){
      for(int i=0;i<tt;i++){
        System.out.print(" ");
      }
      System.out.println("MULT("+x.length+","+y.length+")");
    }
    
    if (x.length == 0 || y.length == 0){
      if (DEBUG>0) tt--;
      return new int[0];
    }
    if (x.length == 1){
      int[] z = new int[y.length];
      for(int i=0;i<z.length;i++){
        z[i]=y[i]*x[0];
      }
      if (DEBUG>0) tt--;
      return z;
    }
    if (y.length == 1){
      int[] z = new int[x.length];
      for(int i=0;i<z.length;i++){
        z[i]=x[i]*y[0];
      }
      if (DEBUG>0) tt--;
      return z;
    }
    int n = x.length;
    int m = y.length;
    int nn = min(n,m)/2;
    int[] a = new int[nn];
    for(int i=0; i<nn;i++){
      a[i]=x[i];
    }
    int[] b = new int[n-nn];
    for(int i=0; i<n-nn;i++){
      b[i]=x[i+nn];
    }
    int mm = nn;
    int[] c = new int[mm];
    for(int i=0; i<mm;i++){
      c[i]=y[i];
    }
    int[] d = new int[m-mm];
    for(int i=0; i<m-mm;i++){
      d[i]=y[i+mm];
    }
    int[] ac = mult(a,c);
    int[] bd = mult(b,d);
    int[] t1 = add(a,b);
    int[] t2 = add(c,d);
    t1 = mult(t1,t2);
    t1 = dec(t1,bd);
    t1 = dec(t1,ac);
    int u = max(ac.length,bd.length+2*nn,t1.length+nn);
    int[] res = new int[u];
    for(int i=0;i<ac.length;i++){
      res[i]+=ac[i];
    }
    for(int i=0;i<t1.length;i++){
      res[i+nn]+=t1[i];
    }
    for(int i=0;i<bd.length;i++){
      res[i+2*nn]+=bd[i];
    }
    if (DEBUG>1){
      System.out.println("MULT RESULT:");
      System.out.print("    "); draw(x);
      System.out.print("    "); draw(y);
      System.out.print("===="); draw(res);
    }
    if (DEBUG>0) tt--;
    return res;
  }

  public void draw(int[] x){
    for(int i=x.length-1;i>=0;i--){
      System.out.print(x[i]+" ");
    }
    System.out.println();
  }

  public void run() throws Exception{    
    Scanner in = new Scanner(new File(FileName+".in"));
    PrintWriter out = new PrintWriter(new File(FileName+".out"));
    String s1 = in.next(); s1 = '0'+s1+'0';
    String s2 = in.next(); s2 = '0'+s2+'0';
    int n = s1.length();
    int m = s2.length();
    int[] p1 = new int[n];
    for(int i=0;i<n-1;i++){
      if(s1.charAt(i)=='0' && s1.charAt(i+1)=='1'){
        p1[i]=1;
      }
    }
    int[] p2 = new int[m];
    for(int i=0;i<m-1;i++){
      if(s2.charAt(i)=='1' && s2.charAt(i+1)=='0'){
        p2[m-1-i]=1;
      }
    }
    int[] p = mult(p1,p2);
    int[] q1 = new int[n];
    for(int i=0;i<n-1;i++){
      if(s1.charAt(i)=='1' && s1.charAt(i+1)=='0'){
        q1[i]=1;
      }
    }
    int[] q2 = new int[m];
    for(int i=0;i<m-1;i++){
      if(s2.charAt(i)=='0' && s2.charAt(i+1)=='1'){
        q2[m-1-i]=1;
      }
    }
    int[] q = mult(q1,q2);
    if (DEBUG>0){
      draw(p1);
      draw(p2);
      draw(p);
      draw(q1);
      draw(q2);
      draw(q);
    }
    int best = 0;
    int cc = 0;
    for(int i=-(m-1);i<(n-1);i++){
      if (cc>best)
        best = cc;
      cc+=p[i+(m-1)];
      cc-=q[i+(m-1)+1];
      if (DEBUG>0)
        System.out.println(cc);
    }     
    out.println(best);
    out.close();
  }

  public static void main(String[] args) throws Exception{
    TwoStrings_vv_poly_zub t = new TwoStrings_vv_poly_zub();
    t.run();
  }
}