#include <iostream>

#define P 19
#define NMAX 5000

using namespace std;

int suf[NMAX + 1];
int pw[NMAX + 1];

int hash;

#define ok(p1, p2, p3, l1, l2, l3) (p3 + p2 * pw[l3] + p1 * pw[l2 + l3] == hash)

int main()
{
	freopen("stragain.in", "rt", stdin);	
	freopen("stragain.out", "wt", stdout);	

	string a, b;
	cin >> a >> b;

	int la = a.length(), lb = b.length();

	pw[0] = 1;
	for (int i = 1; i < la; ++i) pw[i] = P * pw[i - 1];

	int st = 1;
	suf[la] = 0;
	for (int i = la - 1; i >= 0; --i)
	{
		suf[i] = (a[i] - 'a') * st + suf[i + 1];
		st = st * P;
	}

	hash = 0;
	for (int i = 0; i < lb; ++i)
		hash = hash * P + b[i] - 'a';
	int p1 = 0;
	for (int i = 0; i < lb - 2; ++i)
	{
		p1 = p1 * P + a[i] - 'a';
		int p2 = 0;
		int l1 = i + 1;
		for (int j = i + 1; j < lb - 1; ++j)										
		{
			p2 = p2 * P + a[j] - 'a';
			int p3 = suf[j + 1];
			int l2 = j - i;
			int l3 = lb - j - 1;

			if (ok(p1, p2, p3, l1, l2, l3) || 
				ok(p1, p3, p2, l1, l3, l2) || 
				ok(p2, p1, p3, l2, l1, l3) || 
				ok(p2, p3, p1, l2, l3, l1) || 
				ok(p3, p1, p2, l3, l1, l2) || 
				ok(p3, p2, p1, l3, l2, l1))
			{
				printf("YES\n");
				printf("%s\n", a.substr(0, l1).c_str());
				printf("%s\n", a.substr(i + 1, l2).c_str());
				printf("%s\n", a.substr(j + 1, l3).c_str());
				return 0;
			}
		}
	}

	printf("NO\n");
 
	return 0;
}
