#include <cstdio>
#include <cmath>
#include <memory.h>
#include <assert.h>

#define MM 8
#define NN 100

#define NNN 100
#define MMM 8

int n,m,k,l;

double ver[NN][MM];
short int ans[NN][MM];


double Ans = 1;
double AnsLog = 0;

double dp2[2][1 << MMM][1 << MMM];
short int lst2[NNN + 1][1 << MMM][1 << MMM];

double dp1[NN + 1][1 << MM];
short int lst1[NN + 1][1 << MM];

double cur[NN + 1][1 << MM];
short int cgo[1 << MM][1 << MM];
bool valid[1 << MM];

double dp[MM];
int lst[MM];

int pm = 0;

void SolveLine();
void SolveDP2();
void SolveDP1();
void Count();


void Load()
{
	double tt;
	scanf( "%d %d %d %d", &m, &n, &k, &l);
	for ( int i = 0; i < n; i++) {
		tt = 0;
		for (int j = 0; j < m; j++){
			scanf( "%lf", &ver[i][j]);
			tt += ver[i][j];
		}
		assert(abs (tt - 1) < 1e-20);
	}
	pm = 1 << m;
	Count();
	if ( l == 1 ) SolveLine();
	if ( l == 2 ) SolveDP1();
	if ( l == 3 )  SolveDP2();
}



void SolveLine()
{

	double t;
	int i, j, jj;
	for (i = 0 ; i < n; i++) {
		t = 1;
		memset(dp,0,sizeof dp);
		for (j = 0; j < m; j++)	 dp[j] = ver[i][j];
		memset(lst,-1,sizeof lst);
		for (j = 0; j < m; j++) {
			for ( jj = j + k; jj < m; jj++)  {
				if (dp[jj] < dp[j] + ver[i][jj]) {
					dp[jj] = dp[j] + ver[i][jj];
					lst[jj] = j;
				}
			}
		}
		t = 0;
		for (j = 0; j < m; j++){
			if (dp[j] > t) {t = dp[j]; jj = j;}
		}
		if (t < 1e-9) {
			Ans = 0;
			AnsLog = 2;
			return;
		}


		for (; jj >= 0; jj = lst[jj]) ans[i][jj] = 1;
		Ans *= t;
		AnsLog += log(t);
	}
}



bool Valid( int mask)
{
	int i, j;
	for (i = 0; i < m; i++) {
		if ( ( mask & ( 1 << i ) ) == 0) continue;
		for (j = i + 1; j < m && (j - i) < k ; j++){
			if ( ( mask & ( 1 << j ) ) > 0) return false;
		}
	}
	return true;
}

void Count()
{
	int i,j,t;
	for ( i = 0; i < n; i++) {
		for (j = 0; j < (pm); j++){
			cur[i][j] = 0;
			for (t = 0; t < m; t++) {
				if ( (j & (1 << t)) > 0 ) cur[i][j] += ver[i][t];
			}
			if (cur[i][j] > 0) cur[i][j] = log(cur[i][j]);
			else cur[i][j] = 2;
		}
	}
	for (i = 0; i < (pm); i++) valid[i] = Valid(i);
	for (i = 0; i < (pm); i++){
		t = 0;
		for (j = 0; j < (pm); j++){
			if( (i & j) == 0 && valid[ j | i ]) {

				cgo[i][t] = j;
				t++;
			}
		}
		cgo[i][t] = pm;
	} 
}


void SolveDP1()
{
	int i, j, t, tt;
	memset( dp1, 0x7F, sizeof dp1);
 	memset( lst1, -1, sizeof lst1);
	dp1[0][0] = 0;
	Ans = 1;
	AnsLog = 0;
	for (int ii = 0; ii < n; ii++){
		//for( i = 0; i < (pm); i++){
		for (tt = 0,i = cgo[0][tt]; i != pm; i = cgo[0][++tt]){
			if (dp1[ii][i] > 1) continue;
			for (t = 0; cgo[i][t] != (pm); t++){
				j = cgo[i][t];
				if (cur[ii][j] > 1) continue;
				if (dp1[ii + 1][j] > 1 || dp1[ii + 1][j] < dp1[ii][i] + cur[ii][j]) {
					dp1[ii + 1][j] = dp1[ii][i] + cur[ii][j];
					lst1[ii + 1][j] = i;
				}
			}
		}
	}
	Ans = 1;
	AnsLog = 2;
	j = pm;
	//xx = n;
	for (i = 0; i < pm; i++){
		if (dp1[n][i] < 1 && (dp1[n][i] > AnsLog || AnsLog > 1) ) {
			AnsLog = dp1[n][i];
			j = i;
		}
	}
	if (AnsLog > 1) {
		Ans = 0;
		return;
	}
	for(i = n; j > 0; j = lst1[i][j],i--) {
		t = j;
		for (k = 0; k < m; k++) {
			if ( (t & (1 << k)) > 0 ) ans[i - 1][k] = 1; 
		}
	}
}


void SolveDP2()
{
	int i, j, t, tt, i1, i2;
	memset( dp2, 0x7F, sizeof dp2);
 	memset( lst2, -1, sizeof lst2);
	dp2[0][0][0] = 0;
	Ans = 1;
	AnsLog = 0;
	//for (int ii = 0; ii < n; ii++){
	for (int xx = 0,ii = 0; ii < n; xx = 1 - xx,ii++){
		for( i1 = 0; i1 < (pm); i1++){
			for( tt = 0,i2 = cgo[i1][tt]; i2 != pm; i2 = cgo[i1][++tt]){
				if (dp2[xx][i1][i2] > 1) continue;	
				i = i1 | i2;
				for (t = 0; cgo[i][t] != (pm); t++){
					j = cgo[i][t];
					if (cur[ii][j] > 1) continue;
					if (dp2[1 - xx][i2][j] > 1 || dp2[1 - xx][i2][j] < dp2[xx][i1][i2] + cur[ii][j]) {
						dp2[1 - xx][i2][j] = dp2[xx][i1][i2] + cur[ii][j];
						lst2[ii + 1][i2][j] = i1;
					}
				}
			}
		}
		memset( dp2[xx], 0x7F, sizeof dp2[xx]);
	}
	Ans = 1;
	AnsLog = 2;
	j = pm;
	int j1, j2;
	//xx = n;
	for (i1 = 0; i1 < pm; i1++){
		for( tt = 0,i2 = cgo[i1][tt]; i2 != pm; i2 = cgo[i1][++tt]){
			if (dp2[xx][i1][i2] < 1 && (dp2[xx][i1][i2] > AnsLog || AnsLog > 1) ) {
				AnsLog = dp2[xx][i1][i2];
				j1 = i1;
				j2 = i2;
			}
		}
	}
	if (AnsLog > 1) {
		Ans = 0;
		return;
	}
	for(i = n; j2 > 0; t = j1,j1 = lst2[i][j1][j2],j2 = t,i--) {
		t = j2;
		for (k = 0; k < m; k++) {
			if ( (t & (1 << k)) > 0 ) ans[i - 1][k] = 1; 
		}
	}
}



void Save()
{
	if (AnsLog > 1) { 
		printf( "IMPOSSIBLE\n");
		return;
	}
	int i,j;
	for (i = 0; i < n; i++){
		for (j = 0; j < m; j++){
			printf("%d ",ans[i][j]);
		}
		printf("\n");
	}
	
}



int main()
{
	freopen( "sprats.in", "rt", stdin);
	freopen( "sprats.out", "wt", stdout);
	Load();
	Save();
	return 0;
}