import java.io.*;
import java.util.*;
import java.math.*;

public class StrGame_vv{

  Exception EAssertionFailed;
  
  public static final String FileName = "strgame";

  final int DEBUG = 0;
  final int MAXN  = 10000;
  final int MAXR  = 50;
  final int MAXL  = 50;


  public void asert(boolean f) throws Exception{
    if (!f){ 
      EAssertionFailed = new Exception("ASSERTION FAILED");
      throw EAssertionFailed;
    }
  }


  public void run() throws Exception{    
    Scanner in = new Scanner(new File(FileName+".in"));
    PrintWriter out = new PrintWriter(new File(FileName+".out"));
    String to = in.next();
    short n = (short)to.length();
    int[] s = new int[n];
    assert(n<=MAXN);
    for(int i=0; i<n;i++){
      s[i]=to.charAt(i)-'a'+1;
      asert(s[i]>0);
      asert(s[i]<=8);
    }
    short l = (short)in.nextInt();
    asert(l>0); asert(l<=MAXL);
    short r = (short)in.nextInt();
    asert(r>0); asert(r<=MAXR);
    int f=0;
    int ll=-1;
    short[] pos = new short[n*9*9];
    byte[] ch1 = new byte[n*9*9];
    byte[] ch2 = new byte[n*9*9];
    int dist[][][] = new int[n][9][9];
    boolean gone[][][] = new boolean[n][9][9];
    byte res[][][] = new byte[n][9][9];
/*    int px[][][] = new int[n][9][9];
    int pc1[][][] = new int[n][9][9];*/

    for(short i=0; i<n;i++){
      for(byte c1=0; c1<9;c1++) if (c1!=s[i]) {
        for(byte c2=0; c2<9; c2++) if (c2!=s[i] && (c1!=c2 || c1 == 0)){
          int ok = 1;
          for(int j=-l; j<=r; j++) if (j!=0){
            short x = (short)((i+j)%n); 
            if (x<0) x+=n;
            if (s[x]!=c1 && s[x]!=c2 && s[x]!=s[i]){
              ok = 0; break;
            }
          }
          if (ok==1){
            ll++;
            pos[ll] = i;
            ch1[ll] = c1;
            ch2[ll] = c2;
            dist[i][c1][c2] = 0;
            gone[i][c1][c2] = true;
            res[i][c1][c2] = -1;
          }  
        }
      }
    }
    byte[][][] pp = new byte[n][9][9];
    for(int i=0;i<n;i++)
      for(int c1=0;c1<9;c1++)
        for(int c2=0;c2<9;c2++){
          pp[i][c1][c2]=(byte)(-l);
        }
    while (f<=ll){
      short p = pos[f]; byte c1 = ch1[f]; byte c2 = ch2[f]; f++;
      for(int i=-r;i<=l;i++) if (i!=0){
        short x = (short)((p+i)%n);
        if (x<0) x+=n;
        if (s[x]!=c1) continue;
        for(byte c3=0;c3<9;c3++) if (c3!=s[p] && c3!=c1 && (c3!=c2 || c2 == 0)){
          if (gone[x][c2][c3]) continue;
          if (res[p][c1][c2]==-1){
            gone[x][c2][c3]=true;
            dist[x][c2][c3]=dist[p][c1][c2]+1;
            res[x][c2][c3]=1;    
            ll++;
//            px[x][c2][c3]=p;
//            pc1[x][c2][c3]=c1;
            pos[ll]=x;
            ch1[ll]=c2;
            ch2[ll]=c3;
          } else {
            for(;pp[x][c2][c3]<=r;pp[x][c2][c3]++) if (pp[x][c2][c3]!=0){
              int t=(x+pp[x][c2][c3])%n; if (t<0) t+=n;
              if (s[t]==s[x] || s[t]==c2 || s[t]==c3) continue;
              if (res[t][c1][c2]<=0) break;
            }
            if (pp[x][c2][c3]>r){
              gone[x][c2][c3]=true;
              dist[x][c2][c3]=dist[p][c1][c2]+1;
              res[x][c2][c3]=-1;
              ll++;
              pos[ll]=x;
              ch1[ll]=c2;
              ch2[ll]=c3;
            }

          }
        }  
      }
    }
/*      for(int i=0;i<n;i++)
        for(int c1=0;c1<9;c1++)
          for(int c2=0;c2<9;c2++){
            System.out.println(i+" "+c1+" "+c2+" "+res[i][c1][c2]);
          }*/
    int k;
    if (DEBUG>0){
      k=in.nextInt();
    } else {
      k=1;
    }      
    for(int cc=0;cc<k;cc++){
      int p; int t1; int t2;
      if (DEBUG>0){
        p = in.nextInt();  
        t1 = in.nextInt();
        t2 = in.nextInt();
      } else {
        p = 0;
        t1 = 0;
        t2 = 0;
      }
        
      if (res[p][t1][t2]==1){
        out.println("WIN");
        out.println(dist[p][t1][t2]);
//        out.println(px[p][t1][t2]);
        for(int i=-l;i<=r;i++) if (i!=0){
          int x = (p+i)%n; if (x<0) x+=n;
          if (s[x]==s[p]|| s[x]==t1|| s[x]==t2) continue;
          if (res[x][s[p]][t1]==-1 && dist[x][s[p]][t1]==dist[p][t1][t2]-1){
            out.println(i); 
            if (DEBUG>0){
              out.println(x+" "+s[p]+" "+t1);
            }
            break;
          }
        }
      } else {
        if (res[p][t1][t2]==0){
          out.println("DRAW");
        } else {
          out.println("LOSE");
          out.println(dist[p][t1][t2]);
          if (DEBUG>0){
            for(int i=-l;i<=r;i++) if (i!=0){
              int x = (p+i)%n; if (x<0) x+=n;
              if (s[x]==s[p]|| s[x]==t1|| s[x]==t2) continue;
              if (res[x][s[p]][t1]==1 && dist[x][s[p]][t1]==dist[p][t1][t2]-1){
                out.println(i); 
                out.println(x+" "+s[p]+" "+t1);
                break;
              }
            }
          }
        }
      }
    }
    out.close();
  }

  public static void main(String[] args) throws Exception{
    StrGame_vv t = new StrGame_vv();
    t.run();
  }
}