#include <iostream>
#include <string>
#include <queue>

#define INFILE "strgame.in"
#define OUTFILE "strgame.out"

#define ALPH 8
#define NMAX 20000

using namespace std;

#define forn(i, n) for (int i = 0; i < n; ++i)

string s;

int field[NMAX];

struct state
{
	int pos;
	char prev;
	char last;

	state() {}
	state(int _pos, char _prev, char _last)
	{
		pos = _pos;
		prev = _prev;
		last = _last;
	}
};

#define RALPH (ALPH + 2)

int status[NMAX][RALPH][RALPH];
int deg[NMAX][RALPH][RALPH];
int dist[NMAX][RALPH][RALPH];

int n;
int l, r;
int f0;

void solve()
{
	memset(status, 0, sizeof(status));
	memset(deg, 0, sizeof(deg));

	queue <state> q;
	
	forn (pos, n)	
		forn (prev, RALPH) if (field[pos] != prev) 			
			forn (last, RALPH) if (field[pos] != last && prev != last)
			{
				for (int x = pos - l; x <= pos + r; ++x)
				{
					int ptr = (x % n + n) % n;
					if (field[ptr] != field[pos] && field[ptr] != prev && field[ptr] != last)
						++deg[pos][prev][last];
				}
				if (deg[pos][prev][last] != 0) continue;
				status[pos][prev][last] = -1;
				dist[pos][prev][last] = 0;
				q.push(state(pos, prev, last));
			}

	while (!q.empty())
	{
		state c = q.front();
		if (c.pos == 0 && c.prev == f0 && c.last == f0 + 1) return;
		q.pop();
		int cdist = dist[c.pos][c.prev][c.last];
		int cstatus = status[c.pos][c.prev][c.last];
		for (int x = c.pos - r; x <= c.pos + l; ++x)
		{
			int _pos = (x % n + n) % n;
			if (field[_pos] != c.prev) continue;
			if (field[_pos] == field[c.pos]) continue;
			int _prev = c.last;
			forn (_last, ALPH + 2) if (_last != field[c.pos] && _last != _prev)
				if (status[_pos][_prev][_last] == 0)
				{
					state nw(_pos, _prev, _last);
					if (cstatus == -1)
					{
						status[_pos][_prev][_last] = 1;
						dist[_pos][_prev][_last] = cdist + 1;						
					}
					else
					{
						--deg[_pos][_prev][_last];
						if (deg[_pos][_prev][_last] != 0) continue;
						status[_pos][_prev][_last] = -1;
						dist[_pos][_prev][_last] = cdist + 1;						
                    }
					q.push(nw);
                }
		}
	}

}

int main()
{
	freopen(INFILE, "rt", stdin);
	freopen(OUTFILE, "wt", stdout);

	cin >> s;
	cin >> l >> r;
	n = s.length();

	forn (i, n) field[i] = s[i] - 'a';
	f0 = ALPH;

	solve();

	if (status[0][f0][f0 + 1] == -1)
	{
		cout << "LOSE\n";
		cout << dist[0][f0][f0 + 1] << endl;
	}
	else
	if (status[0][f0][f0 + 1] == 0)		
		cout << "DRAW\n";
	else
	{
		cout << "WIN\n";
		int best = (int)1E+9;
		for (int dx = - l; dx <= r; ++dx)
		{
			int x = (dx % n + n) % n;
			if (status[x][field[0]][f0] == -1 && dist[x][field[0]][f0] == dist[0][f0][f0 + 1] - 1)
				best = min(best, dx);
		}
		cout << dist[0][f0][f0 + 1] << endl;
		cout << best << endl;
	}

	return 0;
}
