{$APPTYPE CONSOLE}
{$D-,I-,L-,Q-,R-,S-,O+}
  uses SysUtils;
  Const Task_Id='coins';
        File_In=Task_ID+'.in';
        File_Out=Task_ID+'.out';
        MaxN=100;
        MaxM=100;
        Infinity=MaxLongInt Div 4;
  Type Int=LongInt;
  Var Ans,N,M:Int;
      Coins:Array[1..MaxN,1..MaxM]Of Int;
      C,Edge,Flow,Inv:Array[1..MaxN*MaxM+2,0..MaxM+3]Of Int;

Procedure OpenFiles;
Begin
  Assign(Input,File_In);
  ReSet(Input);
  Assign(Output,File_Out);
  ReWrite(Output);
End;

Procedure Init;
  Var I,J:Int;
Begin
  Read(N,M);
  For I:=1 To N Do
   For J:=1 To M Do
     Read(Coins[I,J]);
End;

Procedure AddEdge(Const I,J,DIJ,DJI : Int);
Begin
  Inc(Edge[I,0]);
  Inc(Edge[J,0]);
  Edge[I,Edge[I,0]]:=J;
  Inv[I,Edge[I,0]]:=Edge[J,0];
  C[I,Edge[I,0]]:=DIJ;
  Edge[J,Edge[J,0]]:=I;
  Inv[J,Edge[J,0]]:=Edge[I,0];
  C[J,Edge[J,0]]:=DJI;
End;

Function Min(Const A,B:Int):Int;
Begin
  If A<B Then Min:=A
  Else Min:=B;
End;

Function FindWay: Boolean;
  Var Queue,From,FromE,CanFlow:Array[1..MaxN*MaxM+2]Of Int;
      Use:Array[0..MaxN*MaxM+2]Of Boolean;
      I,J,Now,Len:Int;
Begin
  FindWay:=False;
  Now:=1;
  Len:=1;
  Queue[1]:=1;
  From[1]:=0;
  Use[1]:=True;
  CanFlow[1]:=Infinity;
  For I:=0 To N*M+2 Do Use[I]:=False;
  While Now<=Len Do Begin
    For I:=1 To Edge[Queue[Now],0] Do
      If Not(Use[Edge[Queue[Now],I]]) And
         (C[Queue[Now],I]-Flow[Queue[Now],I]>0) Then Begin
        Inc(Len);
        Queue[Len]:=Edge[Queue[Now],I];
        From[Len]:=Now;
        FromE[Len]:=Inv[Queue[Now],I];
        CanFlow[Len]:=Min(CanFlow[Now],C[Queue[Now],I]-Flow[Queue[Now],I]);
        Use[Edge[Queue[Now],I]]:=True;
        If Edge[Queue[Now],I]=2 Then Begin
          Now:=Len;
          Use[0]:=True;
          Break;
        End;
      End;
    If Use[0] Then Break;
    Inc(Now);
  End;
  If (Now<=Len) And (Queue[Now]=2) Then Begin
    FindWay:=True;
    I:=CanFlow[Now];
    While (Now>1) Do Begin
      J:=Edge[Queue[Now],FromE[Now]];
      Inc(Flow[J,Inv[Queue[Now],FromE[Now]]],I);
      Flow[Queue[Now],FromE[Now]]:=-Flow[J,Inv[Queue[Now],FromE[Now]]];
      Now:=From[Now];
    End;
  End;
End;

Procedure WriteAns(I,K:Int);
  Var J:Int;
Begin
//  WriteLn(I);
  For J:=1 To Edge[I,0] Do
   If (Flow[I,J]>0) Then Begin
//     WriteLn(I,' ',Edge[I,J],' ',Flow[I,J],' -- ',C[I,J]);
     If (I>2) And (I<=M+2) And (Edge[I,J]>3) Then Begin
       WriteAns(Edge[I,J],I-2)
     End
     Else If (I>3) And (Edge[I,J]>2) And (Edge[I,J]<=M+2) Then Begin
       WriteLn((I-3)Div M+1,' ',(I-3)Mod M+1,' ',K);
       WriteAns(Edge[I,J],0);
     End
     Else WriteAns(Edge[I,J],K);
     Flow[I,J]:=0;
   End;
End;

Procedure Solve;
  Var I,J,K:Int;
Begin
  FIllChar(Flow,SizeOf(Flow),0);
  For I:=1 To M Do
    AddEdge(1,I+2,Coins[1,I],0);
  For I:=1 To M Do
    AddEdge(2,I+2,0,1);
  For I:=2 To N Do Begin
    For J:=1 To M Do Begin
      If Coins[I,J]=0 Then Begin
        AddEdge(J+2,(I-1)*M+2+J,1,0);
        For K:=J+1 To M Do
          If Coins[I,K]>0 Then
            AddEdge((I-1)*M+2+J,(I-1)*M+2+K,Infinity,0);
      End
      Else If Coins[I,J]=1 Then Begin
        AddEdge(J+2,(I-1)*M+2+J,0,0);
        For K:=J+1 To M Do
          If Coins[I,K]>0 Then
            AddEdge((I-1)*M+2+J,(I-1)*M+2+K,Infinity,0);              
      End
      Else Begin
        AddEdge(J+2,(I-1)*M+2+J,0,1);
        For K:=J+1 To M Do
          If Coins[I,K]>0 Then
            AddEdge((I-1)*M+2+J,(I-1)*M+2+K,Infinity,Infinity)
          Else AddEdge((I-1)*M+2+J,(I-1)*M+2+K,0,Infinity)
      End;
    End;
  End;
  Ans:=0;
  While FindWay Do Begin
    Inc(Ans);
  End;
  WriteLn(Ans);
  WriteAns(1,0);
End;

Procedure CloseFiles;
Begin
  Close(Input);
  Close(Output);
End;

Begin
  OpenFiles;
  Init;
  Solve;
  CloseFiles;
End.