#include <cstdio>
#include <memory.h>


#define DEB false
#define AFree 0
#define BFree 1
#define None 2


class heap {
private:
	void Up(int ver);
	void Down(int ver);
	bool Good(int  i, int j);
public:
	int Num;
	int val[1111][4];
	int wh[1111];
	int key[111];
	heap(){Num = 0; memset(wh,-1,sizeof(wh));};
	void Add(int p1, int p2, int p3,int p4, int Key);
	void Delete(int Key);
	void ExtractMin(int &p1, int &p2, int &p3);
};

bool heap::Good(int i, int j) 
{
	if (val[i][0] < val[j][0]) return true;
	if (val[i][0] > val[j][0]) return false;
	if (val[i][1] < val[j][1]) return true;
	if (val[i][1] > val[j][1]) return false;
	if (val[i][3] < val[j][3]) return true;
	if (val[i][3] > val[j][3]) return false;

	return false;
}

void heap::Up(int Key)
{
	int i,j;
	i = wh[Key];
	j = i / 2;
	int t;
	while (i > 1 && Good(i,j)) {
		t = val[i][0]; val[i][0] = val[j][0]; val[j][0] = t;
		t = val[i][1]; val[i][1] = val[j][1]; val[j][1] = t;
		t = val[i][2]; val[i][2] = val[j][2]; val[j][2] = t;
		t = val[i][3]; val[i][3] = val[j][3]; val[j][3] = t;
		t = key[i]; key[i] = key[j]; key[j] = t;
		wh[key[i]] = i; wh[key[j]] = j;
		i = j; j = i / 2;
	}
}

void heap::Down(int Key)
{
	int i,j;
	i = wh[Key];
	j = i * 2;
	if (j + 1 <= Num && Good(j + 1,j)) j++;
	int t;
	while (j <= Num && Good(j,i)) {
		t = val[i][0]; val[i][0] = val[j][0]; val[j][0] = t;
		t = val[i][1]; val[i][1] = val[j][1]; val[j][1] = t;
		t = val[i][2]; val[i][2] = val[j][2]; val[j][2] = t;
		t = val[i][3]; val[i][3] = val[j][3]; val[j][3] = t;
		t = key[i]; key[i] = key[j]; key[j] = t;
		wh[key[i]] = i; wh[key[j]] = j;
		i = j; j = i * 2;
		if (j + 1 <= Num && Good(j + 1,j)) j++;
	}
}

void heap::ExtractMin(int &p1, int &p2, int &p3)
{
	if (Num == 0) {
		p1 = 0; p2 = None; p3 = 0;
		return;
	}
	p1 = val[1][0];
	p2 = val[1][1];
	p3 = val[1][2];
	if (DEB) {printf("Extracting: time = %d  type = %d ind = %d prm = %d\n\n", p1, p2, p3, val[1][3]);}
	Delete(key[1]);
	
}

void heap::Add(int p1, int p2, int p3,int p4, int Key)
{
	Num++;
	if (DEB) {printf("Adding: time = %d  type = %d ind = %d (key = %d)\n\n", p1, p2, p3, Key);}
	val[Num][0] = p1;
	val[Num][1] = p2;
	val[Num][2] = p3;
	val[Num][3] = p4;
	key[Num] = Key;
	wh[Key] = Num;
	Up(Num);
}

void heap::Delete(int Key)
{
	if (DEB) {printf("Deleting: time = %d  type = %d ind = %d (key = %d)\n\n", val[wh[Key]][0], val[wh[Key]][1], val[wh[Key]][2], Key);}
	if (wh[Key] == Num) {
		Num--;
		return;
	}
	val[wh[Key]][0] = val[Num][0];
	val[wh[Key]][1] = val[Num][1];
	val[wh[Key]][2] = val[Num][2];
	val[wh[Key]][3] = val[Num][3];
	key[wh[Key]] = key[Num];
	wh[key[Num]] = wh[Key];
	int t = key[Num];
	wh[Key] = -1;
	Num--;
	Up(t);
	Down(t);
}

int n, na, nb;
int a[31], b[31], ause[31], buse[31];

void Load()
{
	scanf("%d", &n);
	scanf("%d", &na);
	for(int i = 0; i < na; i++) {
		scanf("%d", &a[i]);
	}
	int j;
	for(i = 0; i < na; i++) {
		for (j = 0; j < na - 1; j++) if (a[j] > a[j + 1]){
			int t = a[j]; a[j] = a[j + 1]; a[j + 1] = t;
		}
	}
	scanf("%d", &nb);
	for(i = 0; i < nb; i++) {
		scanf("%d", &b[i]);
	}
	for(i = 0; i < nb; i++) {
		for (j = 0; j < nb - 1; j++) if (b[j] < b[j + 1]){
			int t = b[j]; b[j] = b[j + 1]; b[j + 1] = t;
		}
	}
}



void Solve()
{
	int i;
	int CurTimeA = 0, CurTimeB = 0,nq1,nq2;
	nq1 = n;
	nq2 = 0;
	heap q;
	/*for(i = 0; i < na; i++) q.Add(0,AFree, i,a[i], i);
	for(i = 0; i < nb; i++) q.Add(0,BFree,i,-b[i],i + na);*/
	int tm,tp,prm;
	while (q.Num > 0 || nq1 > 0 || nq2 > 0) {
		if (DEB) { printf("****************\nnq1 = %d nq2 = %d\n*************\n", nq1, nq2);}
		if (DEB) { printf("CurA = %d CurB = %d\n*************\n", CurTimeA, CurTimeB);}
		q.ExtractMin(tm,tp,prm);
		if (tp == AFree) {
			nq2++;
			CurTimeA = tm;
			if (nq1 > 0){
				nq1--;
				q.Add(tm + a[prm], AFree, prm, a[prm], prm);
				ause[prm] = tm + a[prm];
			}else{
				for( i = 0; i < na; i++) {
					if (i == prm) continue;
					if (ause[i] > tm + a[prm]) {
						q.Add(tm + a[prm], AFree, prm, a[prm], prm );
						q.Delete( i );
						break;
					}
				}
			}
		} else
		if (tp == BFree) {
			CurTimeB = tm;
			if (nq2 > 0){
				nq2--;
				q.Add(tm + b[prm], BFree, prm, -b[prm], prm + na);
				buse[prm] = tm + b[prm];
			}else{
				for( i = 0; i < nb; i++) {
					if (i == prm) continue;
					if (buse[i] > tm + b[prm]) {
						q.Add(tm + b[prm], BFree, prm, -b[prm], prm + na);
						q.Delete( i + na );
						break;
					}
				}
			}
		}
			if (nq1 > 0)
			for(i = 0; i < na; i++){
				if(nq1 == 0) break;
				if( ause[i] <= CurTimeA && q.wh[i] == -1) { 
					ause[i] += a[i];
					q.Add(ause[i] , AFree, i, a[i], i);
					nq1--;
				}
			}
			if (nq2 > 0)
			for(i = 0; i < nb; i++){
				if(nq2 == 0) break;
				if( buse[i] <= CurTimeB && q.wh[i + na] == -1) { 
					buse[i] += b[i];
					q.Add(buse[i] , BFree, i, -b[i], i + na);
					break;
				}
			}
	}
	printf("%d\n%d\n", CurTimeA, CurTimeB);
}

int main()
{
	freopen( "input.txt", "rt", stdin);
	freopen( "output.txt", "wt", stdout);
	Load();
	Solve();
	return 0;
}