// !! not optimized

#include <cstdio>
#include <cstdlib>
#include <cmath>
#include <cassert>
#include <memory>
#include <string>

using namespace std;

#define cinfile "brackets3.in"
#define coutfile "brackets3.out"
#define forn(i, n) for (i = 0; i < (int)(n); ++i)
#define foro(i, n) for (i = 1; i <= (int)(n); ++i)

#define f0(a) memset(a, 0, sizeof(a))
#define VI vector<int>
#define pb push_back
#define all(a) a.begin(), a.end()

const int inf = (int)1e+9;
const double eps = (double)1e-9;

const int nmax = 61;

// A == [, a == ]

int n, m;
char a[nmax];
char b[nmax];
char d[nmax][nmax][nmax][nmax]; // -1 == impossible, 0 == not determined yet, 1 == AC
char ba[nmax][nmax][26];
char bb[nmax][nmax][26];
char gooda[nmax][nmax];
char goodb[nmax][nmax];

void init()
{
    fgets(a, nmax, stdin);
    fgets(b, nmax, stdin);
    n = strlen(a);
    m = strlen(b);
    if (a[n - 1] == '\n') --n;
    if (b[m - 1] == '\n') --m;
}

char lowcase(char x)
{
    if (x >= 'a' && x <= 'z') return x;
    else return (x - 'A' + 'a');
}

#define upgrade1(i, j) if (ch >= 'a' && ch <= 'z') ba[i][j][ch - 'a']--; else ba[i][j][ch - 'A']++;
#define upgrade2(i, j) if (ch >= 'a' && ch <= 'z') bb[i][j][ch - 'a']--; else bb[i][j][ch - 'A']++;

void preprocess()
{
    f0(ba);
    f0(bb);
    int i, j, size, t;
    char stack[nmax + 1];
    char ch;
    for (i = 0; i < n; ++i) {
        ch = a[i];
//      if (ch >= 'a' && ch <= 'z') ba[i][j][ch - 'a']--; else ba[i][j][ch - 'A']++;
        upgrade1(i, i);
        for (j = i + 1; j < n; ++j) {
            for (ch = 0; ch < 26; ++ch) {
                ba[i][j][ch] = ba[i][j - 1][ch];
            }
            ch = a[j];
            upgrade1(i, j);
        }
    }
    forn(i, n) {
        for (j = i; j < n; ++j) {
            size = 0;
            stack[0] = 'A';
            for (t = i; t <= j; ++t) {
                if (size == 0 || lowcase(stack[size]) != a[t]) {
                    if (a[t] >= 'a' && a[t] <= 'z') break;
                    stack[++size] = a[t];
                } else --size;
            }
            if (t > j && size == 0) gooda[i][j] = 1;
            else gooda[i][j] = -1;
        }
    }

    int k, l;
    for (i = 0; i < m; ++i) {
        ch = b[i];
        upgrade2(i, i);
        for (j = i + 1; j < m; ++j) {
            for (ch = 0; ch < 26; ++ch) {
                bb[i][j][ch] = bb[i][j - 1][ch];
            }
            ch = b[j];
            upgrade2(i, j);
        }
    }
    forn(i, m) {
        for (j = i; j < m; ++j) {
            size = 0;
            stack[0] = 'A';
            for (t = i; t <= j; ++t) {
                if (size == 0 || lowcase(stack[size]) != b[t]) {
                    if (b[t] >= 'a' && b[t] <= 'z') break;
                    stack[++size] = b[t];
                } else --size;
            }
            if (t > j && size == 0) goodb[i][j] = 1;
            else goodb[i][j] = -1;
        }
    }

    forn(i, n) {
        for (j = i; j < n; ++j) {
            forn(k, m) {
                for (l = k; l < m; ++l) {
                    forn(ch, 26) {
                        if (ba[i][j][ch] + bb[k][l][ch] != 0) break;
                    }
                    if (ch < 26) d[i][j][k][l] = -1;
                }
            }
        }
    }

    forn(i, n) {
        forn(k, m) if (d[i][i][k][k] >= 0) {
            d[i][i][k][k] = 1;
        }
    }
}

char go(int i, int j, int k, int l)
{
    if (i > j && k > l) return 1;
    if (i > j) {
        if (goodb[k][l] == 1) return 1;
        else return -1;
    }
    if (k > l) {
        if (gooda[i][j] == 1) return 1;
        else return -1;
    }

    if (d[i][j][k][l] != 0) return d[i][j][k][l];

    int t1, t2;
    
    if (a[i] >= 'A' && a[i] <= 'Z') {
        for (t1 = i + 1; t1 <= j; ++t1) {
            if (a[t1] >= 'a' && a[t1] <= 'z' && a[t1] == lowcase(a[i])) {
                for (t2 = k - 1; t2 <= l; ++t2) {
                    if (go(i + 1, t1 - 1, k, t2) == 1)
                        if (go(t1 + 1, j, t2 + 1, l) == 1) {
                            d[i][j][k][l] = 1;
                            return 1;
                        }
                }
            }
        }

        for (t2 = k; t2 <= l; ++t2) {
            if (b[t2] >= 'a' && b[t2] <= 'z' && b[t2] == lowcase(a[i])) {
                for (t1 = i; t1 <= j; ++t1) {
                    if (go(i + 1, t1, k, t2 - 1) == 1)
                        if (go(t1 + 1, j, t2 + 1, l) == 1) {
                            d[i][j][k][l] = 1;
                            return 1;
                        }
                }
            }
        }
    }

    if (b[k] >= 'A' && b[k] <= 'Z') {
        for (t2 = k + 1; t2 <= l; ++t2) {
            if (b[t2] >= 'a' && b[t2] <= 'z' && b[t2] == lowcase(b[k])) {
                for (t1 = i - 1; t1 <= j; ++t1) {
                    if (go(i, t1, k + 1, t2 - 1) == 1)
                        if (go(t1 + 1, j, t2 + 1, l) == 1) {
                            d[i][j][k][l] = 1;
                            return 1;
                        }
                }
            }
        }

        for (t1 = i; t1 <= j; ++t1) {
            if (a[t1] >= 'a' && a[t1] <= 'z' && a[t1] == lowcase(b[k])) {
                for (t2 = k; t2 <= l; ++t2) {
                    if (go(i, t1 - 1, k + 1, t2) == 1)
                        if (go(t1 + 1, j, t2 + 1, l) == 1) {
                            d[i][j][k][l] = 1;
                            return 1;
                        }
                }               
            }
        }
    }

    d[i][j][k][l] = -1;
    return -1;
}

int main()
{
    freopen(cinfile, "rt", stdin);
    freopen(coutfile, "wt", stdout);

    int testid, testcnt;
    scanf("%d\n", &testcnt);
    forn(testid, testcnt) {
        init();

        int i;
        printf("s1 = ");
        forn(i, n) printf("%c", a[i]);
        printf("\n");
        printf("s2 = ");
        forn(i, m) printf("%c", b[i]);
        printf("\n");
        

        f0(d);
        preprocess();
        if (n == 0 && m == 0) {
            printf("YES\n");
            continue;
        }
        if (n == 0) {
            if (goodb[0][m - 1] == 1) printf("YES\n");
            else printf("NO\n");
            continue;
        }
        if (m == 0) {
            if (gooda[0][n - 1] == 1) printf("YES\n");
            else printf("NO\n");
            continue;
        }

        if (d[0][n - 1][0][m - 1] == 0) 
            go(0, n - 1, 0, m - 1);

        if (d[0][n - 1][0][m - 1] == 1) printf("YES");
        else printf("NO");
        printf("\n");
    }
        
    return 0;
}
