#include <cstdio>
#include <cstdlib>
#include <assert.h>
//#include <cmath>
#include <memory.h>


#define DEB false
#define EPS 1e-6
#define ABS(x) (((x) < 0)?(-(x)):(x))
#define VECT(x1,y1,x2,y2) ((x1) * (y2) - (x2) * (y1))
#define SCOLAR(x1,y1,x2,y2) ((x1) * (x2) + (y1) * (y2))
//#define DST(x1,y1,x2,y2) ( sqrt( ((x1) - (x2)) * ((x1) - (x2)) + ((y1) - (y2)) * ((y1) - (y2))) )


double X, Y, x[31000], y[31000];
double xa[31000], ya[31000];
int ans[31000];

int n, nn;

double MM;


void Load()
{
	int i;
	scanf( "%lf%lf%d", &X, &Y, &n);
	MM = X * 100000 + Y * 100000;
	for (i  = 0; i < n; i++) {
		scanf( "%lf %lf", &x[i],&y[i]);
	}
}

void Init(int ver)
{
	nn = 0;
	x[n] = x[ver];y[n] = -y[ver];
	x[n + 1] = x[ver];y[n + 1] = 2 * Y - y[ver];
	y[n + 2] = y[ver];x[n + 2] = -x[ver];
	y[n + 3] = y[ver];x[n + 3] = 2 * X - x[ver];
}

double GetT(double x1, double y1, double x2, double y2, double x0, double y0, double xx, double yy)
{
	x2 -= x1;
	y2 -= y1;
	double d = x2 * (-yy) - y2 * (-xx);
	double d1 = (x0 - x1) * (-yy) - (y0 - y1) * (-xx);
	if (ABS(d) < EPS) return 2 * (MM);
	return (d1 / d);
}	

double GetT2(int k, int i, int j)
{
	double xx = (x[i] + x[j]) / 2.0;
	double yy = (y[i] + y[j]) / 2.0;
	double xx2 = xa[k];
	double yy2 = ya[k];
	return GetT(xx2,yy2,xx2 - y[ans[k]] + y[i], yy2 + x[ans[k]] - x[i],xx,yy,-y[j] + y[i], x[j] - x[i]);
}

void GetPoint(double x1, double y1, double x2, double y2, double t, double &xx, double &yy)
{
	xx = x1 + t * (x2 - x1);
	yy = y1 + t * (y2 - y1);
}

void MakeDump()
{
	int i;
	printf("\n*************************************************\n");
	for(i = 0; i <= nn; i++) {
		printf("(%.3lf, %.3lf)", xa[i],ya[i]);
		if (i < nn) printf("--(%d)-->",ans[i]);
	}
	printf("\n");
	fflush(stdout);
}


int was[40000];
void Solve()
{
	int i,j,k;
	double dst2 = MM * MM;
	for( int ii = 0; ii < n; ii++) {
		Init(ii);
		//find first
		j = -1;
		dst2 = MM * MM;
		for (i = 0; i < n + 4; i++) {
			if (i == ii) continue;
			if ( (x[i] - x[ii]) * (x[i] - x[ii]) + (y[i] - y[ii]) * (y[i] - y[ii]) < dst2) {
				dst2 = (x[i] - x[ii]) * (x[i] - x[ii]) + (y[i] - y[ii]) * (y[i] - y[ii]);
				j = i;
			}
		}
		assert(j != -1);
		xa[0] = (x[j] + x[ii]) / 2.0;
		ya[0] = (y[j] + y[ii]) / 2.0;
		xa[1] = (x[j] + x[ii]) / 2.0 + ( - (y[j] - y[ii]));
		ya[1] = (y[j] + y[ii]) / 2.0 + ( (x[j] - x[ii]));
		nn = 1;
		ans[0] = j;
		if (DEB) MakeDump();
		double t, tm = -1;
		int jj = -1;
		memset(was,0,sizeof was);
		was[ii] = 1; 
		for(i = 0; i < nn; i++) {
			tm =  - 1;
			jj = -1;
			double vct = -1;
			double xx, yy;
			for(k = 0; k < n + 4; k++) {
				if (k == ii) continue;
				//if ((jj != -1) &&  VECT(x[jj] - x[ii], y[jj] - y[ii], x[k] - x[ii], y[k] - y[ii]) < EPS) continue;
				t = GetT2(i,ii,k);
				if (t > EPS && (tm < - EPS || ( t < tm - EPS  || ( ( ABS( t - tm ) < EPS ) && ( VECT(x[jj] - x[ii],y[jj] - y[ii], x[k] - x[ii], y[k] - y[ii]) > EPS )) ) ) ) {
					tm = t;
					jj = k;
				}
			}
			j = jj;
			if (jj == -1) break;
			if (DEB)printf("Adding from point (%lf,%lf)->(%lf,%lf):\n",x[ii],y[ii],x[jj],y[jj]);
			//was[jj] = 1;
			//GetPoint((xa[i] + xa[i + 1]) / 2.0,(ya[i] + ya[i + 1]) / 2.0, xa[i + 1], ya[i + 1],tm,xx,yy);
			//GetPoint((x[jj] + x[ii]) / 2.0,(y[ii] + y[jj]) / 2.0, -y[jj] + y[ii],x[jj] - x[ii],tm,xx,yy);
			xx = xa[i] + tm * (- y[ans[i]] + y[ii]);
			yy = ya[i] + tm * ( x[ans[i]] - x[ii]);
			ans[i + 1] = jj;
			xa[i + 1] = xx;
			ya[i + 1] = yy;
			nn++;
			xa[i + 2] = xa[i + 1] + (-y[jj] + y[ii]);
			ya[i + 2] = ya[i + 1] + (x[jj] - x[ii]);
 			if (DEB) MakeDump();
			if (was[jj] != 0) break;
			was[jj] = 1;
		}
		j = 1;
		for(i = 1; i < nn - 1 ; i++) {
			if (xa[i] < xa[j] - EPS || (ABS(xa[i] - xa[j]) < EPS && ya[i] < ya[j] )) j = i;
		}
		i = j;
		k =	0;
		printf("%d ", nn - 2);
		while(i != j || k == 0) {
			k = 1;
			printf(" %.8lf %.8lf", xa[i], ya[i]);
			i++;
			if (i == nn - 1) i = 1;
		}
		printf("\n");
	}
	}
int main()
{
	freopen( "football.in", "rt", stdin);
	freopen( "football.out", "wt", stdout);
	Load();
	Solve();
	return 0;
}