{$R-,Q-,S-,H+}
Uses SysUtils;
Const
  MaxLen=300;
  MaxAnsLen=3*MaxLen;
  TaskID='cipher';
  InFile=TaskID+'.in';
  OutFile=TaskID+'.out';
Type
  Str=Record
    Any:Boolean;
    Len:Integer;
    Value:Array[1..(MaxAnsLen-1) Shr 4+2]Of Cardinal;
  End;
Var
  OneChar,OpenBracket,CloseBracket:Str;
  S,Res:String;
  MinChar,MaxChar:Array[1..MaxLen+1,0..MaxLen]Of Char;
  Best:Array[1..MaxLen+1,0..MaxLen,Boolean]Of Str;
  Got:Array[1..MaxLen+1,0..MaxLen]Of Boolean;
  Cur:Str;

Function IsBetter(Const A,B:Str):Boolean;
Var
  I:Integer;
Begin
  If Not A.Any Then IsBetter:=True Else If Not B.Any Then IsBetter:=False Else
    If A.Len<B.Len Then IsBetter:=False Else If A.Len>B.Len Then IsBetter:=True Else Begin
      For I:=1 To (A.Len+$F) Shr 4 Do
        If A.Value[I]<B.Value[I] Then Begin
          IsBetter:=False;
          Exit;
        End Else If A.Value[I]>B.Value[I] Then Begin
          IsBetter:=True;
          Exit;
        End;
      IsBetter:=False;
    End;
End;

Procedure Append(Var S1:Str; Const S2:Str);
Var
  I,By,Shift:Integer;
  Mask:Cardinal;
Begin
  Shift:=S1.Len And $F;
  If Shift=0 Then Begin
    By:=(S1.Len+$F) Shr 4;
    For I:=1 To (S2.Len+$F) Shr 4 Do
      S1.Value[I+By]:=S2.Value[I];          
  End Else Begin
    By:=(S1.Len+$F) Shr 4;
    Mask:=(Cardinal(1) Shl (2*($10-Shift)))-1;
    For I:=1 To (S2.Len+$F) Shr 4 Do Begin
      S1.Value[I+By-1]:=S1.Value[I+By-1] And Not Mask Or (S2.Value[I] Shr (2*Shift));
      S1.Value[I+By]:=(S2.Value[I] Shl (2*($10-Shift)));
    End;
  End;
  S1.Len:=S1.Len+S2.Len;
End;

Procedure GetBest(At:Integer; Len:Integer);
Var
  I:Integer;
Begin
  If Got[At,Len] Then Exit;
  Got[At,Len]:=True;

  If Len=1 Then Begin
    Best[At,Len,False]:=OneChar;
    Best[At,Len,True]:=OneChar;
    Exit;
  End;

  For I:=1 To Len-1 Do If (MaxChar[At,I]<=MinChar[At+I,Len-I]) Or (MinChar[At,I]>=MaxChar[At+I,Len-I]) Then Begin
    GetBest(At,I);
    GetBest(At+I,Len-I);
    If (Best[At,I,False].Any) And (Best[At+I,Len-I,False].Any) Then Begin
      If MaxChar[At,I]<=MinChar[At+I,Len-I] Then Begin
        Cur:=Best[At,I,False];
        Append(Cur,Best[At+I,Len-I,False]);
        If IsBetter(Best[At,Len,False],Cur) Then
          Best[At,Len,False]:=Cur;
      End;       
      If MinChar[At,I]>=MaxChar[At+I,Len-I] Then Begin
        Cur:=Best[At+I,Len-I,True];
        Append(Cur,Best[At,I,True]);
        If IsBetter(Best[At,Len,True],Cur) Then
          Best[At,Len,True]:=Cur;
      End;
    End;
  End;

  If Best[At,Len,False].Any Then Begin
    Cur:=OpenBracket;
    Append(Cur,Best[At,Len,False]);
    Append(Cur,CloseBracket);
    If IsBetter(Best[At,Len,True],Cur) Then
      Best[At,Len,True]:=Cur;
  End;
  If Best[At,Len,True].Any Then Begin
    Cur:=OpenBracket;
    Append(Cur,Best[At,Len,True]);
    Append(Cur,CloseBracket);
    If IsBetter(Best[At,Len,False],Cur) Then
      Best[At,Len,False]:=Cur;
  End;
End;

Procedure FillMinMaxChars;
Var
  I,J:Integer;
  Ch,CMin,CMax:Char;
Begin
  For I:=1 To Length(S)+1 Do Begin 
    CMin:=High(Char);
    CMax:=Low(Char);
    For J:=0 To Length(S)+1-I Do Begin
      If J>0 Then Begin
        Ch:=S[I+J-1];
        If Ch>CMax Then CMax:=Ch;
        If Ch<CMin Then CMin:=Ch;
      End;
      MinChar[I,J]:=CMin;
      MaxChar[I,J]:=CMax;
    End;
  End;
End;

Function SortString(S:String):String;
Var
  I,J:Integer;
  Ch:Char;
Begin
  For I:=1 To Length(S) Do
    For J:=Length(S) DownTo I+1 Do
      If S[J-1]>S[J] Then Begin
        Ch:=S[J-1];
        S[J-1]:=S[J];
        S[J]:=Ch;
      End;
  Result:=S;
End;


Function Unpack(S:Str; By:String):String;
Var
  Cur,I,J:Integer;
Begin
  J:=1;
  Result:='';
  For I:=1 To S.Len Do Begin
    Cur:=(S.Value[(I-1) Shr 4+1] Shr (2*(($10-I And $F) And $F))) And 3;
    Case Cur Of
      3:Begin
        Result:=Result+By[J];
        Inc(J);
      End;
      1:Result:=Result+'[';
      2:Result:=Result+']';
    End;
  End;
End;

Begin
  ReSet(Input,InFile);
  ReadLn(S);
  Close(Input);
  FillChar(Best,SizeOf(Best),0);
  FillChar(Got,SizeOf(Got),False);
  FillMinMaxChars;
  OneChar.Value[1]:=Cardinal(3) Shl 30;
  OneChar.Len:=1;
  OneChar.Any:=True;
  OpenBracket.Value[1]:=Cardinal(1) Shl 30;
  OpenBracket.Len:=1;  
  OpenBracket.Any:=True;
  CloseBracket.Value[1]:=Cardinal(2) Shl 30;
  CloseBracket.Len:=1;
  CloseBracket.Any:=True;
  GetBest(1,Length(S));
  If Not Best[1,Length(S),False].Any Then 
    Res:='NO SOLUTION' 
  Else 
    Res:=Unpack(Best[1,Length(S),False],SortString(S));
  ReWrite(Output,OutFile);
  WriteLn(Res);
  Close(Output);
End.
