#include <iostream>
#include <string>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)
#define NMAX 13
#define PMAX 1594323

int n, m;

int pattern;

int code(int *ptr, int n)
{
	int r = 0;
	forn (i, n)	r = r * 3 + ptr[i];
	return r;
}

bool fit(int *p1)
{
	if (n < m) return false;
	int c1 = code(p1, m);
	int st = 1;
	forn (i, m - 1) st *= 3;
	forn (i, n - m + 1)				
	{
		if (c1 == pattern) return true;
  		if (i != n - m)
			c1 = (c1 - p1[i] * st) * 3 + p1[i + m];
	}
	return false;
}

int af[PMAX];
int cf[PMAX];

int alwaysfit(int *s)
{
	int t = code(s, n);
	if (af[t] != -1) return af[t];
	if (fit(s)) return af[t] = 1;
	forn (i, n)		
		if (s[i] == 2)
		{
			s[i] = 0;
			bool v1 = alwaysfit(s);
			s[i] = 1;
			bool v2 = alwaysfit(s);
			s[i] = 2;
			return af[t] = (v1 & v2);
		}
	return af[t] = 0;
}

int canfit(int *s)
{
	int t = code(s, n);
	if (cf[t] != -1) return cf[t];
	if (fit(s)) return cf[t] = 1;
	forn (i, n)		
		if (s[i] == 2)
		{
			s[i] = 0;
			bool v1 = canfit(s);
			s[i] = 1;
			bool v2 = canfit(s);
			s[i] = 2;
			return cf[t] = (v1 | v2);
		}
	return cf[t] = 0;
}

bool known(int *s)
{
	bool v1 = !(bool)canfit(s);
	bool v2 = (bool)(alwaysfit(s));
	return  v1 || v2;
}

double T[PMAX];

double ans(int *s)
{
	int c = code(s, n);
	if (T[c] != -1) return T[c];
	if (known(s)) return T[c] = 0;
	double res = 1E+20;
	forn (i, n)
		if (s[i] == 2)
		{
			s[i] = 0;
			double val1 = ans(s);
			s[i] = 1;
			double val2 = ans(s);
			s[i] = 2;
			res = min(res, 1 + 0.5 * (val1 + val2));
		}
	return T[c] = res;
}

int main()
{
	freopen("substring.in", "rt", stdin);
	freopen("substring.out", "wt", stdout);

	string a, b;
	cin >> a >> b;

	n = a.length(), m = b.length();

	int ta[NMAX], tb[NMAX];

	forn (i, n) ta[i] = (a[i] == '?' ? ta[i] = 2 : ta[i] = a[i] - '0');
	forn (i, m) tb[i] = (b[i] == '?' ? tb[i] = 2 : tb[i] = b[i] - '0');

    pattern = code(tb, m);

	forn (i, PMAX)
	{
		T[i] = -1;
		cf[i] = -1;
		af[i] = -1;
	}

	double res = ans(ta);
		
	printf("%.20lf\n", res);

	return 0;
}
