#include <iostream>
#include <vector>
#include <cassert>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)

#define ALPH 26
#define SMALL 20
#define MMAX 1000
#define INF int(1E+9)

#define pb push_back

int amount[ALPH][ALPH];
int deg_in[ALPH], deg_out[ALPH];
int vertex;

void readData()
{
	memset(deg_in, 0, sizeof(deg_in));
	memset(deg_out, 0, sizeof(deg_out));

	forn (i, ALPH)	
		forn (j, ALPH)
		{
			scanf("%d", &amount[i][j]);
			deg_in[j] += amount[i][j]; 
			deg_out[i] += amount[i][j]; 
		}
	vertex = getchar();
	while (vertex <= ' ') vertex = getchar();
	vertex -= 'a';
}

bool canWin(int &move)
{
	forn (i, ALPH)			
		if (amount[vertex][i] > 0 && deg_out[i] == 0) 
		{
			move = i;
			return true;
		}
   	if (deg_out[vertex] == 1 && amount[vertex][vertex] == 1)
   	{
   		move = vertex;
   		return true;
   	}
	move = -1;
	return false;
}

bool used[ALPH];

void go(int v)
{
	if (used[v]) return;
	used[v] = true;
	forn (i, ALPH)
		if (amount[v][i] > 0) go(i);
}

void reduce()
{
	memset(used, false, sizeof(used));
	go(vertex);
	forn (i, ALPH)
		if (!used[i])
			forn (j, ALPH) 
			{
				deg_in[j] -= amount[i][j]; 
				deg_out[i] -= amount[i][j]; 
				amount[i][j] = 0;
			}
}

struct edge
{
	int a, b;
	int num;	

	edge (int _a, int _b, int _num)
	{
		a = _a;
		b = _b;
		num = _num;
	}

	edge () {}
};

int makeSilyMove()
{
	int ans = -1;
	int mn = INF;
	forn (i, ALPH)		
		if (amount[vertex][i] > 0 && deg_out[i] < mn)
		{
			ans = i;
			mn = deg_out[i];
		}
	return ans;
}

int edges;

edge e[2 * MMAX];
int kvs;
int vs[2 * MMAX];

void list(int v)
{
	if (used[v]) return;
	used[v] = true;
	vs[kvs] = v;
    ++kvs;
	forn (i, ALPH)
		if (amount[v][i] > 0)
		{
			forn (g, amount[v][i])
			{
				e[edges] = edge(v, i, edges);
				edges++;
			}
			go(i);
		}
}

void listall(int v)
{
	memset(used, false, sizeof(used));
	edges = 0;
	kvs = 0;
	list(v);
}

bool T[1 << SMALL][ALPH];

bool lessEdges(int &ans)
{
	forn (t, ALPH)
		if (amount[vertex][t] > 0)
		{
			amount[vertex][t]--;
			listall(t);
			amount[vertex][t]++;
			if (edges > SMALL) continue;
			forn (i, 1 << edges) forn (j, ALPH) T[i][j] = false;
			forn (mask, 1 << edges)
				forn (r, edges)
				{
					int num = e[r].num;
					if ((mask & (1 << num)) != 0)
						if (!T[mask ^ (1 << num)][e[r].b]) 
						{
							T[mask][e[r].a] = true;
							break;
						}
				}
		   	int mask = (1 << edges) - 1;
			if (!T[mask][t])
			{
				ans = t;
				return true;
		    }
		}
	return false;
}

bool canDetermine(int &ans)
{
	int state[ALPH];
	int dist[ALPH];
	memset(state, 0, sizeof(state));
	memset(dist, 0, sizeof(dist));

	forn (a, ALPH) if (deg_out[a] == 0) state[a] = -1;

	forn (it, 2 * MMAX)
		forn (a, ALPH) if (state[a] == 0)
		{
			dist[a] = INF;
			forn (b, ALPH) if (state[b] == -1)
				if (amount[a][b] > 0)
					dist[a] = min(dist[a], dist[b] + 1);
			if (dist[a] != INF)
			{
				state[a] = 1;
				continue;
			}
			bool bad = true;
			dist[a] = 0;
			forn (b, ALPH) 
				if (amount[a][b] > 0)
				{
					if (state[b] == 0)
					{
						bad = false;
						break;
					}
					if (state[b] == 1)
						dist[a] = max(dist[a], dist[b] + 1);
				}
			if (!bad) continue;
			state[a] = -1;
		}

	if (state[vertex] == 0) 
	{
		int mn = INF;
		forn (i, ALPH)
			if (amount[vertex][i] > 0 && state[i] <= 0 && deg_out[i] < mn)
			{
				ans = i;
				mn = deg_out[i];
			} 
		return true;
	}
	if (state[vertex] == -1)	
	{
		int mx = -1;
		forn (i, ALPH)
			if (amount[vertex][i] > 0 && dist[i] > mx)
			{
				mx = dist[i];
				ans = i;
			}
		int mn = INF; 
		forn (i, ALPH)
			if (amount[vertex][i] > 0 && dist[i] == mx && deg_out[i] < mn)
			{
				ans = i;
				mn = deg_out[i];
			} 
		return true;
	}
	if (state[vertex] == 1)	
	{

cerr << "WINNABLE" << endl;

		forn (i, ALPH)
			if (amount[vertex][i] > 0 && state[i] == -1 && dist[i] < dist[vertex])
			{
				ans = i;
				return true;
			} 
		assert(false);	
	}
	assert(false);
	return false;
}

int R[ALPH];
int col[ALPH];
bool ok;

int res(int v, int &p)
{
	if (R[v] != -1) return R[v];
	col[v] = 1;
	R[v] = 0;
	int tmp;
	forn (i, ALPH)
	{
		if (amount[v][i] > 0 && col[i] == 0)
		{
			if (res(i, tmp) == 0)
			{
				p = i;
				R[v] = 1;
				break;
			}
		}
		if (amount[v][i] > 0 && col[i] == 2 && R[i] == 0)
		{
			p = i;
			R[v] = 1;
			break;
		}
	}

	forn (i, ALPH)
		if (amount[v][i] > 0 && col[i] == 1) 
			return R[v] = 3;

	forn (i, ALPH)
		if (amount[v][i] > 0 && R[i] == 3) 
			return R[v] = 3;

	col[v] = 2;
	return R[v];
}
            
bool acyclic(int &ans)
{
	ok = true;
	memset(R, 255, sizeof(R));
	memset(col, 0, sizeof(col));
	if (res(vertex, ans) == 1) return true;
	return false;
}

int makeMove()
{
	int ans;
	reduce();
	if (canWin(ans)) return ans;
	if (acyclic(ans)) return ans;

cerr << (int)ok << endl;

	if (lessEdges(ans)) return ans;
	if (canDetermine(ans)) return ans;

cerr << "sily move" << endl;

	return makeSilyMove();
}

int main()
{
	srand(time(NULL));
	freopen("towns.in", "rt", stdin);
	freopen("towns.out", "wt", stdout);

	readData();
	vertex = makeMove();
	printf("%c\n", vertex + 'a');

	return 0;
}
