#include <iostream>

using namespace std;

#define forn(i, n) for (int i = 0; i < (int)n; ++i)

#define ALPH 26
#define INF int(1E+9)

int amount[ALPH][ALPH];
int deg_in[ALPH], deg_out[ALPH];
int vertex;

void readData()
{
	memset(deg_in, 0, sizeof(deg_in));
	memset(deg_out, 0, sizeof(deg_out));

	forn (i, ALPH)	
		forn (j, ALPH)
		{
			scanf("%d", &amount[i][j]);
			deg_in[j] += amount[i][j]; 
			deg_out[i] += amount[i][j]; 
		}
	vertex = getchar();
	while (vertex <= ' ') vertex = getchar();
	vertex -= 'a';
}

bool canWin(int &move)
{
	forn (i, ALPH)			
		if (amount[vertex][i] > 0 && deg_out[i] == 0) 
		{
			move = i;
			return true;
		}
   	if (deg_out[vertex] == 1 && amount[vertex][vertex] == 1)
   	{
   		move = vertex;
   		return true;
   	}
	move = -1;
	return false;
}

int makeMove()
{
	int ans = -1;
	if (canWin(ans)) return ans;
	int mn = INF;
	forn (i, ALPH)		
		if (amount[vertex][i] > 0 && deg_out[i] < mn)
		{
			ans = i;
			mn = deg_out[i];
		}
	return ans;
}

int main()
{
	freopen("towns.in", "rt", stdin);
	freopen("towns.out", "wt", stdout);

	srand(time(NULL));

	readData();
	vertex = makeMove();
	printf("%c\n", vertex + 'a');
	return 0;
}
