#include <stdio.h>
#include <stdlib.h>

#define SIZE 110

int m, n;
int matr[SIZE][SIZE];
int cnum;
int coms[SIZE*SIZE*10][2];
int mx, my;

int lastnum;
int dominate(int x, int y) {
	int cnt[] = {0, 0, 0};
	cnt[matr[x][y]]++;
	cnt[matr[x+1][y]]++;
	cnt[matr[x][y+1]]++;
	cnt[matr[x+1][y+1]]++;
	int res = -1;
	if ((cnt[0]>cnt[1]) && (cnt[0]>cnt[2]))
		res = 0;
	if ((cnt[1]>cnt[0]) && (cnt[1]>cnt[2]))
		res = 1;
	if ((cnt[2]>cnt[0]) && (cnt[2]>cnt[1]))
		res = 2;
	if (res >= 0)
		lastnum = cnt[res];
	return res;
}

void repaint(int x, int y) {
	int cnt[] = {0, 0, 0};
	cnt[matr[x][y]]++;
	cnt[matr[x+1][y]]++;
	cnt[matr[x][y+1]]++;
	cnt[matr[x+1][y+1]]++;
	int domc = -1;
	if ((cnt[0]>cnt[1]) && (cnt[0]>cnt[2]))
		domc = 0;
	if ((cnt[1]>cnt[0]) && (cnt[1]>cnt[2]))
		domc = 1;
	if ((cnt[2]>cnt[0]) && (cnt[2]>cnt[1]))
		domc = 2;
	if (domc < 0) {
		if (cnt[0] == 0) domc = 0;
		if (cnt[1] == 0) domc = 1;
		if (cnt[2] == 0) domc = 2;
	}
	coms[cnum][0] = x;
	coms[cnum][1] = y;
	cnum++;
	matr[x][y] = domc;
	matr[x+1][y] = domc;
	matr[x][y+1] = domc;
	matr[x+1][y+1] = domc;
}

void addRow(int r) {
	int i, j;
	bool ok;
start:
	ok = true;
	for (i = 0; i<my-1; i++)
		if (dominate(r-1, i) >= 0) {
			for (j = i; j>=0; j--)
				repaint(r-1, j);
			for (j = i+1; j<my-1; j++)
				repaint(r-1, j);
			ok = false;
			break;
		}
	if (ok) {
		repaint(r-1, 0);
		repaint(r-2, 1);
		repaint(r-2, 0);
		goto start;
	}
	mx++;
}

void addColumn(int c) {
	int i, j;
	bool ok;
start:
	ok = true;
	for (i = 0; i<mx-1; i++)
		if (dominate(i, c-1) >= 0) {
			for (j = i; j>=0; j--)
				repaint(j, c-1);
			for (j = i+1; j<mx-1; j++)
				repaint(j, c-1);
			ok = false;
			break;
		}
	if (ok) {
		repaint(c-1, 0);
		repaint(c-2, 1);
		repaint(c-2, 0);
		goto start;
	}
	my++;
}

void Solve3x3() {
	int i, j;
	while (1) {
        if (rand()&1) {
        	int cx = rand()&1;
        	int cy = rand()&1;
        	if ((dominate(cx,cy)<0) || (lastnum<4))
				repaint(cx, cy);
		}
		bool ok = true;
		for (i = 0; i<2; i++)
			for (j = 0; j<2; j++)
				if (dominate(i, j) >= 0)
					if (lastnum < 4) {
						repaint(i, j);
						ok = false;
					}
		if (ok) {
			for (i = 0; i<2; i++)
				for (j = 0; j<2; j++)
					if (dominate(i, j) < 0) {
						repaint(i, j);
						ok = false;
						break;
					}
		}
        int cnt[] = {0, 0, 0};
		for (i = 0; i<3; i++)
			for (j = 0; j<3; j++)
				cnt[matr[i][j]]++;
    	if ((cnt[0]==9) || (cnt[1]==9) || (cnt[2]==9))
        	break;
	}
}

int main(int argc, char **argv) {
    freopen("threecolors.in", "r", stdin);
    freopen("threecolors.out", "w", stdout);
    srand(666);
    scanf("%d%d\n", &m, &n);
	int i, j;
	for (i = 0; i<m; i++) {
		for (j = 0; j<n; j++) {
			char ch;
			scanf("%c", &ch);
			if (ch == 'R') matr[i][j] = 0;
			if (ch == 'G') matr[i][j] = 1;
			if (ch == 'B') matr[i][j] = 2;
		}
		scanf("\n");
	}
	Solve3x3();
	mx = 3;
	my = 3;
	for (i = 3; i<m; i++)
		addRow(i);
	for (i = 3; i<n; i++)
		addColumn(i);
	for (i = 0; i<cnum; i++)
		printf("%d %d\n", coms[i][0]+1, coms[i][1]+1);
    return 0;
}
