{$apptype console}

const
 maxr = 3010;

var
 P, m, n, i, j, HZ, TZ, TRoot, Tmp, TempK, TempV: longint;
 Ans, Temp: Int64;
 ch: char;
 A: array[0..maxr, 0..maxr] of byte;
 S: array[0..maxr, 0..maxr] of integer;
 SS, SL, HK, HV, TK, TV, TC, TL, TR: array[0..maxr * 3] of longint;

procedure swap(var a, b: longint);
 var
  t: longint;
 begin
   t := a;
   a := b;
   b := t;
 end;

procedure HPut(K, V: longint);
 var
  i: longint;
 begin
   inc(HZ);
   HK[HZ] := K;
   HV[HZ] := V;
   i := HZ;
   while (i > 1) and (HK[i] < HK[i shr 1]) do begin
     swap(HK[i], HK[i shr 1]);
     swap(HV[i], HV[i shr 1]);
     i := i shr 1;
   end;
 end;

function HGet: integer;
 var
  i, j, V: longint;
 begin
   V := HV[1];
   HK[1] := HK[HZ];
   HV[1] := HV[HZ];
   dec(HZ);
   i := 1;
   while true do begin
     j := i;
     if ((i shl 1) <= HZ) and (HK[i shl 1] < HK[j]) then
       j := i shl 1;
     if ((i shl 1 + 1) <= HZ) and (HK[i shl 1 + 1] < HK[j]) then
       j := i shl 1 + 1;
     if i = j then
       break;
     swap(HK[i], HK[j]);
     swap(HV[i], HV[j]);
     i := j;
   end;
   HGet := V;
 end;

procedure TSplit(T, K: longint; var A, B: longint);
 var
  TA, TB: longint;
 begin
   if T = -1 then begin
     A := -1;
     B := -1;
     exit;
   end;
   if TK[T] < K then begin
     if TR[T] <> -1 then
       TC[T] := TC[T] - TC[TR[T]];
     TSplit(TR[T], K, TA, TB);
     TR[T] := TA;
     if TR[T] <> -1 then
       TC[T] := TC[T] + TC[TR[T]];
     A := T;
     B := TB;
   end else begin
     if TL[T] <> -1 then
       TC[T] := TC[T] - TC[TL[T]];
     TSplit(TL[T], K, TA, TB);
     TL[T] := TB;
     if TL[T] <> -1 then
       TC[T] := TC[T] + TC[TL[T]];
     A := TA;
     B := T;
   end;
 end;

procedure TPut(var T: longint; K, V: longint);
 var
  A, B: longint;
 begin
   if T = -1 then begin
     TK[TZ] := K;
     TV[TZ] := V;
     TL[TZ] := -1;
     TR[TZ] := -1;
     TC[TZ] := 1;
     T := TZ;
     inc(TZ);
     exit;
   end;
   if random(TC[T]) <> 0 then begin
     inc(TC[T]);
     if TK[T] < K then
       TPut(TR[T], K, V)
     else
       TPut(TL[T], K, V);
     exit;
   end;
   TSplit(T, K, A, B);
   TK[TZ] := K;
   TV[TZ] := V;
   TL[TZ] := A;
   TR[TZ] := B;
   TC[TZ] := 1;
   if A <> -1 then
     TC[TZ] := TC[TZ] + TC[A];
   if B <> -1 then
     TC[TZ] := TC[TZ] + TC[B];
   T := TZ;
   inc(TZ);
 end;

function TFind(T: longint; K: longint): longint;
 begin
   if (K >= TK[T]) and (K < TK[T] + TV[T]) then begin
     TFind := T;
     exit;
   end;
   if K > TK[T] then
     TFind := TFind(TR[T], K)
   else
     TFind := TFind(TL[T], K);
 end;

function TMerge(TA, TB: longint): longint;
 begin
   if TA = -1 then
     TMerge := TB
   else if TB = -1 then
     TMerge := TA
   else begin
     if random(TC[TA] + TC[TB]) < TC[TA] then begin
       TC[TA] := TC[TA] + TC[TB];
       TR[TA] := TMerge(TR[TA], TB);
       TMerge := TA;
     end else begin
       TC[TB] := TC[TB] + TC[TA];
       TL[TB] := TMerge(TA, TL[TB]);
       TMerge := TB;
     end;
   end;
 end;

procedure TDel(var T: longint; K: longint);
 begin
   dec(TC[T]);
   if T = K then
     T := TMerge(TL[T], TR[T])
   else if TK[T] < TK[K] then
     TDel(TR[T], K)
   else
     TDel(TL[T], K);
 end;

begin
  randseed := 541510527;
  assign(input, 'rect.in');
  assign(output, 'rect.out');
  reset(input);
  rewrite(output);

  readln(m, n);
  fillchar(A, sizeof(A), 0);
  fillchar(SS, sizeof(SS), 0);
  fillchar(SL, sizeof(SL), 0);
  for i := 0 to m - 1 do begin
    for j := 0 to n - 1 do begin
      read(ch);
      if ch = 'B' then
        A[i, j] := 1;
    end;
    readln;
  end;
  for i := 0 to m - 1 do
    for j := 0 to n - 1 do
      if A[i, j] = 1 then begin
        S[i, SL[i]] := j;
        inc(SL[i]);
      end;
  Ans := 0;
  for i := 0 to n - 1 do begin
    for j := 0 to m - 1 do
      while (SS[j] < SL[j]) and (S[j, SS[j]] < i) do
        inc(SS[j]);
    HZ := 0;
    for j := 0 to m - 1 do
      if SS[j] < SL[j] then
        HPut(S[j, SS[j]], j);
    TZ := 0;
    TRoot := -1;
    TPut(TRoot, 0, m);
    Temp := m * (m + 1) div 2;
    for j := i to n - 1 do begin
      while (HZ > 0) and (HK[1] <= j) do begin
        P := HGet;
        Tmp := TFind(TRoot, P);
        TempK := TK[Tmp];
        TempV := TV[Tmp];
        Temp := Temp - TempV * (TempV + 1) div 2;
        TDel(TRoot, Tmp);
        Temp := Temp + (P - TempK) * (P - TempK + 1) div 2;
        if P <> TempK then
          TPut(TRoot, TempK, P - TempK);
        TempK := TempK + TempV;
        inc(P);
        Temp := Temp + (TempK - P) * (TempK - P + 1) div 2;
        if P <> TempK then
          TPut(TRoot, P, TempK - P);
      end;
      Ans := Ans + Temp;
    end;
  end;
  writeln(Ans);

  close(input);
  close(output);
end.
