#include <stdio.h>

int cells [102][102];
int width, height;

void read_input ()
{
   char buf [256];
   FILE* f = fopen ( "a.in", "rt" );
   fscanf ( f, "%d %d", &height, &width );
   for ( int i = 0; i < height; i++ )
   {
      fscanf ( f, "%s", buf );
      for ( int j = 0; j < width; j++ )
      {
         switch ( buf [j] )
         {
         case 'R':
            cells [j][i] = 0;
            break;
         case 'G':
            cells [j][i] = 1;
            break;
         case 'B':
            cells [j][i] = 2;
            break;
         }
      }
   }
   fclose ( f );
}

FILE* fout;
void open_output ()
{
   fout = fopen ( "a.out", "wt" );
}
void close_output ()
{
   fclose ( fout );
}
void write_output ( int x, int y )
{
   int nclr;
   int count [3] = { 0, 0, 0 };
   count [cells [x][y]]++;
   count [cells [x+1][y]]++;
   count [cells [x][y+1]]++;
   count [cells [x+1][y+1]]++;
   if ( count [0] == 4 || count [1] == 4 || count [2] == 4 )
      return;
   if ( count [0] > count [1] && count [0] > count [2] )
      nclr = 0;
   else if ( count [1] > count [0] && count [1] > count [2] )
      nclr = 1;
   else if ( count [2] > count [0] && count [2] > count [1] )
      nclr = 2;
   else if ( count [0] == 0 )
      nclr = 0;
   else if ( count [1] == 0 )
      nclr = 1;
   else if ( count [2] == 0 )
      nclr = 2;
   else
      nclr = 0;
      
   cells [x][y] = nclr;
   cells [x+1][y] = nclr;
   cells [x][y+1] = nclr;
   cells [x+1][y+1] = nclr;
     
   fprintf ( fout, "%d %d\n", y + 1, x + 1 );
}

void add_3right ( int x, int y )
{
   if ( cells [x+2][y] == cells [x+2][y+1] )
   {
      if ( cells [x+2][y] == cells [x+2][y+2] )
      {
         write_output ( x, y+1 );
         write_output ( x, y );
         write_output ( x+1, y+1 );
         write_output ( x+1, y );
      }
      else
      {
         write_output ( x+1, y+1 );
         write_output ( x+1, y );
      }
   }
   else
   {
      write_output ( x+1, y );
      write_output ( x+1, y+1 );
   }
}

void add_3bottom ( int x, int y )
{
   if ( cells [x][y+2] == cells [x+1][y+2] )
   {
      if ( cells [x][y+2] == cells [x+2][y+2] )
      {
         write_output ( x+1, y );
         write_output ( x, y );
         write_output ( x+1, y+1 );
         write_output ( x, y+1 );
      }
      else
      {
         write_output ( x+1, y+1 );
         write_output ( x, y+1 );
      }
   }
   else
   {
      write_output ( x, y+1 );
      write_output ( x+1, y+1 );
   }
}

void add_3left ( int x, int y )
{
   if ( cells [x][y] == cells [x][y+1] )
   {
      if ( cells [x][y] == cells [x][y+2] )
      {
         write_output ( x+1, y+1 );
         write_output ( x+1, y );
         write_output ( x, y+1 );
         write_output ( x, y );
      }
      else
      {
         write_output ( x, y+1 );
         write_output ( x, y );
      }
   }
   else
   {
      write_output ( x, y );
      write_output ( x, y+1 );
   }
}

void fill3 ( int x, int y )
{
   if ( cells [x][y] == cells [x+1][y] && cells [x][y] == cells [x+2][y] )
   {
      if ( cells [x][y+1] == cells [x+1][y+1] && cells [x][y+1] == cells [x+2][y+1] )
      {
         write_output ( x, y );
         write_output ( x+1, y );
         add_3bottom ( x, y );
      }
      else if ( cells [x][y+1] != cells [x+1][y+1] )
      {
         write_output ( x, y );
         write_output ( x+1, y );
         add_3bottom ( x, y );
      }
      else
      {
         write_output ( x+1, y );
         write_output ( x, y );
         add_3bottom ( x, y );
      }
   }
   else if ( cells [x][y] != cells [x+1][y] )
   {
      write_output ( x, y+1 );
      write_output ( x, y );
      add_3right ( x, y );
   }
   else
   {
      write_output ( x+1, y+1 );
      write_output ( x+1, y );
      add_3left ( x, y );
   }
}

int main ()
{
   read_input ();
   
   open_output ();
   
   fill3 ( 0, 0 );
   int filling = cells [0][0];
   for ( int j = 1; j <= width - 3; j++ )
      add_3right ( j, 0 );
   for ( int i = 1; i <= height - 3; i++ )
   {
      add_3bottom ( 0, i );
      for ( int j = 2; j < width-1; j++ )
         write_output ( j, i + 1 );
   }
   
   close_output ();
   
   return 0;
}
