type integer = longint;
const MNOGO = $7F7F7F7F;
var n, m : integer;
	edg : array[1..100000, 1..4] of integer;
	ne : integer;
	ee : array[1..800000, 1..4] of integer;
	next, inv : array[1..800000] of integer;
	first : array[0..200000] of integer;

procedure AddEdge(v1, v2, cfl, cst : integer);
begin
	inc(ne);
	ee[ne, 1] := v1;
	ee[ne, 2] := v2;
	ee[ne, 3] := cfl;
	ee[ne, 4] := cst;
	next[ne] := first[v1];
	first[v1] := ne;
end;

procedure Load;
var i : integer;
begin
	read(n, m);
	for i := 1 to m do begin
		read(edg[i, 1], edg[i, 2], edg[i, 3], edg[i, 4]);
	end;
	ne := 0;
	for i := 1 to n do begin
		AddEdge(0, i, 1, 0);
		AddEdge(i, 0, 0, 0);
		inv[ne - 1] := ne;
		inv[ne] := ne - 1;
	end;
	for i := 1 to m do begin
		AddEdge(n + i, n + m + 1, 1, 0);
		AddEdge(n + m + 1, n + i, 0, 0);
		inv[ne - 1] := ne;
		inv[ne] := ne - 1;
	end;
	for i := 1 to m do begin
		AddEdge(edg[i, 1], i + n, 1, edg[i, 3]);
		AddEdge(i + n, edg[i, 1], 0, -edg[i, 3]);
		inv[ne - 1] := ne;
		inv[ne] := ne - 1;
		AddEdge(edg[i, 2], i + n, 1, edg[i, 4]);
		AddEdge(i + n, edg[i, 2], 0, -edg[i, 4]);
		inv[ne - 1] := ne;
		inv[ne] := ne - 1;
	end;
end;

var p, dst, was, prev, bye : array[0..200000] of integer;

function DijkstRA : boolean;
var i, mi, min : integer;
begin
	fillchar(dst, sizeof(dst), $7F);
	fillchar(was, sizeof(was), 0);
	dst[0] := 0;
	while true do begin
		min := MNOGO;
		mi := -1;
		for i := 0 to n + m + 1 do begin
			if was[i] = 1 then continue;
			if dst[i] < min then begin
				min := dst[i];
				mi := i;	
			end;
		end;
		if min = MNOGO then break;
		i := first[mi];
		while i <> 0 do begin	
			if ee[i, 3] > 0 then begin
				if dst[ee[i, 2]] > dst[mi] + ee[i, 4] + p[mi] - p[ee[i, 2]] then begin
					dst[ee[i, 2]] := dst[mi] + ee[i, 4] + p[mi] - p[ee[i, 2]];
					prev[ee[i, 2]] := mi;
					bye[ee[i, 2]] := i;
				end;
			end;
			i := next[i];
		end;
		was[mi] := 1;
	end;
	DijkstRA := (dst[n + m + 1] <> MNOGO);
end;

procedure Solve;
var cur, i, res1, res2 : integer;
begin
	fillchar(p, sizeof(p), 0);
	while DijkstRA do begin
		cur := n + m + 1;
		while cur <> 0 do begin
			dec(ee[bye[cur], 3]);
			inc(ee[inv[bye[cur]], 3]);
			cur := prev[cur];
		end;
		for i := 0 to n + m + 1 do begin
			if p[i] = MNOGO then continue;
			if dst[i] = MNOGO then p[i] := MNOGO
			else inc(p[i], dst[i]);
		end;
	end;
	res1 := 0;
	res2 := 0;
	for i := 1 to ne do begin
		if (ee[i, 1] <= n) and (ee[i, 1] > 0) and (ee[i, 2] <= n + m) and (ee[i, 2] > n) then begin
			if ee[i, 3] = 0 then begin
				inc(res1);
				inc(res2, ee[i, 4]);
			end;
		end;
	end;
	write(res1, ' ', res2);
end;

begin
	assign(input, 'orient.in');
	assign(output, 'orient.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
