#include <stdio.h>
#include <string.h>

#define MAXI(A, B) ((A) > (B) ? (A) : (B))

#define MAX 53
#define LEN 503
#define SLEN 100010
#define MAXQ (MAX * SLEN)

#define MAXT 150010

typedef struct
{
  char c;
  int len, f, pr, ne[26];
} tree;

tree T[MAXT];
int TPos;

int NewT( int len, int pr, char c )
{
  memset(&T[TPos], -1, sizeof(tree));
  T[TPos].len = len, T[TPos].pr = pr, T[TPos].c = c;
  return TPos++;
}

void Add( int t, char *s )
{
  if (!*s)
    return;
  if (T[t].ne[*s - 'a'] == -1)
    T[t].ne[*s - 'a'] = NewT(T[t].len + 1, t, *s - 'a');
  Add(T[t].ne[*s - 'a'], s + 1);
}

void Z( short *Pr, char *Str, char *Text )
{
  static char S[SLEN + LEN];
  static int P[SLEN + LEN];
  static int Q[LEN * LEN];
  int StrLen = strlen(Str), TLen = strlen(Text);
  int k, i, j, len, qpo, qsi;

  TPos = 0, NewT(0, -1, 0);
  for (j = 0; j < StrLen; j++)
  {
    for (i = 0; i < StrLen - j; i++)
      S[i] = Str[StrLen - j - i - 1];
    S[i] = 0;
    Add(0, S);
  }
  qpo = qsi = 0;
  Q[qsi++] = 0;
  while (qpo < qsi)
  {
    k = Q[qpo++];
    for (i = 0; i < 26; i++)
      if (T[k].ne[i] != -1)
        Q[qsi++] = T[k].ne[i];
    if (T[k].pr <= 0)
      T[k].f = 0;
    else
    {
      i = T[T[k].pr].f;
      while (i > 0 && T[i].ne[T[k].c] == -1)
        i = T[k].f;
      if (T[i].ne[T[k].c] != -1)
        i = T[i].ne[T[k].c];
      T[k].f = i;
    }
  }
  
  for (len = i = 0; i < TLen; i++)
    S[len++] = Text[TLen - i - 1];
  for (k = 0, i = 0; i < len; i++)
  {
    while (k > 0 && T[k].ne[S[i] - 'a'] == -1)
      k = T[k].f;
    if (T[k].ne[S[i] - 'a'] != -1)
      k = T[k].ne[S[i] - 'a'];
    P[i] = T[k].len;
  }
  for (i = 0; i < TLen; i++)
    Pr[i] = MAXI(1, P[len - i - 1]);
}

#define RELAX(i, j, d, dt) { \
  if (D[i][j] == -1) { \
    D[i][j] = d; \
    if (dt) \
      Q[Si] = i * MAX + j, Si = (Si + 1) % MAXQ; \
    else \
      Po = (Po + MAXQ - 1) % MAXQ, Q[Po] = i * MAX + j; \
  }}

short Pr[MAX][SLEN];
int N, Len[MAX], D[SLEN][MAX], Pos[MAX];
int Po = 0, Si = 0, Q[MAXQ];
char Dic[MAX][LEN], S[SLEN];

int main( void )
{
  int i, j, k, l, d, len;

  freopen("typing.in", "rt", stdin);
  freopen("typing.out", "wt", stdout);
  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%s", Dic[i]), Len[i] = strlen(Dic[i]);
  gets(S), gets(S), len = strlen(S);
  for (j = 0; j < N; j++)
    Z(Pr[j], Dic[j], S);
  memset(D, -1, sizeof(D));
  for (j = 0; j < N; j++)
    RELAX(0, j, 1, 1)
  memset(Pos, 0, sizeof(Pos));
  while (Po < Si)
  {
    i = Q[Po] / MAX, j = Q[Po++] % MAX;
    d = D[i][j] + 1;
    if (j == N)
    {
      for (k = 0; k < N; k++)
        RELAX(i, k, d, 1);
      continue;
    }
    RELAX(i, N, d - 1, 0);
    if (Pos[j] < i)
      Pos[j] = i;
    while (Pos[j] < i + Pr[j][i])
    {
      Pos[j]++;
      RELAX(Pos[j], j, d, 1);
    }
  }
  for (j = len, i = 0; i < N; i++)
    if (j > D[len][i])
      j = D[len][i];
  printf("%d", j);
  return 0;
}

