{ $DEFINE DEBUG}
{$H+}
{$IFDEF DEBUG}
{$C+,I+,Q+,R+,S+}
{$ELSE}
{$C-,I-,Q-,R-,S-}
{$ENDIF}
const taskid='orient';
      infile=taskid+'.in';
      outfile=taskid+'.out';
      inf=1000000000;
var n,m,ne,i,a,b,cab,cba,hlen,cnode,cedge,ans1,ans2:longint;
    first,best,heap,hpos,last,ledge,phi:array [0..150000] of longint;
    edge:array [-350000..350000] of record
      v,c,n:longint;
      can:boolean;
    end;
procedure addedge(a,b,c:longint);
begin
  inc(ne);
  edge[ne].v:=b;
  edge[ne].c:=c;
  edge[ne].n:=first[a];
  edge[ne].can:=true;
  first[a]:=ne;
  edge[-ne].v:=a;
  edge[-ne].c:=-c;
  edge[-ne].n:=first[b];
  edge[-ne].can:=false;
  first[b]:=-ne;
end;
function less(x,y:longint):boolean;
begin
  less:=best[x]<=best[y];
end;
procedure swap(x,y:longint);
var t:longint;
begin
  t:=heap[x];
  heap[x]:=heap[y];
  heap[y]:=t;
  hpos[heap[x]]:=x;
  hpos[heap[y]]:=y;
end;
procedure siftup(x:longint);
begin
  while (x>1) and (less(heap[x],heap[x shr 1])) do
  begin
    swap(x,x shr 1);
    x:=x shr 1;
  end;
end;
procedure hadd(x:longint);
begin
  inc(hlen);
  heap[hlen]:=x;
  hpos[x]:=hlen;
  siftup(hlen);
end;
procedure siftdown(x:longint);
var l,r,b:longint;
begin
  l:=x shl 1;
  r:=l or 1;
  b:=x;
  if (l<=hlen) and (less(heap[l],heap[b])) then
    b:=l;
  if (r<=hlen) and (less(heap[r],heap[b])) then
    b:=r;
  if x<>b then
  begin
    swap(b,x);
    siftdown(b);
  end;
end;
procedure hextract(var x:longint);
begin
  x:=heap[1];
  swap(1,hlen);
  dec(hlen);
  if hlen>0 then
    siftdown(1);
end;
procedure update(x:longint);
begin
  siftup(x);
  siftdown(x);
end;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  {$IFDEF DEBUG}
  writeln('DEBUG MODE');
  {$ENDIF}
  read(n,m);
  fillchar(first,sizeof(first),0);
  ne:=0;
  for i:=1 to m do
  begin
    read(a,b,cab,cba);
    addedge(a,i+n,cba);
    addedge(b,i+n,cab);
  end;
  for i:=1 to n do
    addedge(0,i,0);
  for i:=1 to m do
    addedge(i+n,n+m+1,0);
  fillchar(phi,sizeof(phi),0);
  ans1:=0;
  repeat
    best[0]:=0;
    for i:=1 to n+m+1 do
      best[i]:=inf;
    hlen:=0;
    for i:=0 to n+m+1 do
      hadd(i);
    last[0]:=-1;
    ledge[0]:=0;
    repeat
      hextract(cnode);
      {$IFDEF DEBUG}
      for i:=1 to hlen do
      begin
        if (2*i<=hlen) then assert(less(heap[i],heap[2*i]));
        if (2*i+1<=hlen) then assert(less(heap[i],heap[2*i+1]));
      end;
      {$ENDIF}
      if cnode=n+m+1 then
        break;
      cedge:=first[cnode];
      while cedge<>0 do
      begin
        if (edge[cedge].can) and (best[cnode]+edge[cedge].c+
                                  phi[cnode]-phi[edge[cedge].v]<
                                  best[edge[cedge].v]) then
        begin
          best[edge[cedge].v]:=best[cnode]+edge[cedge].c+phi[cnode]-phi[edge[cedge].v];
          update(hpos[edge[cedge].v]);
          last[edge[cedge].v]:=cnode;
          ledge[edge[cedge].v]:=cedge;
        end;
        cedge:=edge[cedge].n;
      end;
    until false;
    if best[n+m+1]=inf then
      break;
    inc(ans1);
    cnode:=n+m+1;
    while cnode<>0 do
    begin
      edge[ledge[cnode]].can:=false;
      edge[-ledge[cnode]].can:=true;
      cnode:=last[cnode];
    end;
    for i:=0 to n+m+1 do
      if best[i]<>inf then
        inc(phi[i],best[i]);
  until false;
  ans2:=0;
  for i:=1 to n do
  begin
    cedge:=first[i];
    while cedge<>0 do
    begin
      if not edge[cedge].can then
        inc(ans2,edge[cedge].c);
      cedge:=edge[cedge].n;
    end;
  end;
  writeln(ans1,' ',ans2);
  close(input);
  close(output);
end.
