#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#define MAXI(A, B) ((A) > (B) ? (A) : (B))

#define MAX 53
#define LEN 503
#define SLEN 100010
#define MAXQ 3000010

#define MAXT 150010
#define MAXNE 2010

typedef struct
{
  char c, ch;
  short len;
  int f, pr, chne, ne;
} tree;

tree T[MAXT];
int TPos, NePos, Ne[MAXNE][26];

int NewT( int len, int pr, int c )
{
  memset(&T[TPos], -1, sizeof(tree));
  T[TPos].len = len, T[TPos].pr = pr, T[TPos].c = c;
  return TPos++;
}

void Add( int t, char *s )
{
  if (!*s)
    return;
  if (T[t].chne == -1)
  {
    T[t].ch = *s - 'a', T[t].chne = NewT(T[t].len + 1, t, *s - 'a');
    Add(T[t].chne, s + 1);
    return;
  }
  if (T[t].ne == -1)
  {
    memset(Ne[NePos], -1, sizeof(Ne[NePos]));
    T[t].ne = NePos++;
    Ne[T[t].ne][T[t].ch] = T[t].chne;
  }
  if (Ne[T[t].ne][*s - 'a'] == -1)
    Ne[T[t].ne][*s - 'a'] = NewT(T[t].len + 1, t, *s - 'a');
  Add(Ne[T[t].ne][*s - 'a'], s + 1);
}

#define GetNe(t, c) ((T[t].ne != -1) ? Ne[T[t].ne][c] : \
  ((T[t].chne != -1) ? ((T[t].ch == c) ? T[t].chne : -1) : -1))

void Z( short *Pr, char *Str, char *Text )
{
  static char S[SLEN + LEN];
  static int P[SLEN + LEN];
  static int Q[LEN * LEN];
  int StrLen = strlen(Str), TLen = strlen(Text);
  int tmp, k, i, j, len, qpo, qsi;

  NePos = TPos = 0, NewT(0, -1, 0);
  for (j = 0; j < StrLen; j++)
  {
    for (i = 0; i < StrLen - j; i++)
      S[i] = Str[StrLen - j - i - 1];
    S[i] = 0;
    Add(0, S);
  }
  qpo = qsi = 0;
  Q[qsi++] = 0;
  while (qpo < qsi)
  {
    k = Q[qpo++];
    if (T[k].chne != -1 && T[k].ne == -1)
      Q[qsi++] = T[k].chne;
    else if (T[k].ne != -1)
      for (i = 0; i < 26; i++)
        if (Ne[T[k].ne][i] != -1)
          Q[qsi++] = Ne[T[k].ne][i];
    if (T[k].pr <= 0)
      T[k].f = 0;
    else
    {
      i = T[T[k].pr].f;
      while (i > 0 && GetNe(i, T[k].c) == -1)
        i = T[k].f;
      if ((tmp = GetNe(i, T[k].c)) != -1)
        i = tmp;
      T[k].f = i;
    }
  }
  
  for (len = i = 0; i < TLen; i++)
    S[len++] = Text[TLen - i - 1];
  for (k = 0, i = 0; i < len; i++)
  {
    while (k > 0 && GetNe(k, S[i] - 'a') == -1)
      k = T[k].f;
    if ((tmp = GetNe(k, S[i] - 'a')) != -1)
      k = tmp;
    P[i] = T[k].len;
  }
  for (i = 0; i < TLen; i++)
    Pr[i] = MAXI(1, P[len - i - 1]);
}

#define RELAX(i, j, d, dt) { \
  if (D[i][j] == -1) { \
    D[i][j] = d; \
    if (dt) \
      Q[Si] = i * MAX + j, Si = (Si + 1 == MAXQ ? 0 : Si + 1); \
    else \
      Po = (Po == 0 ? MAXQ - 1 : Po - 1) % MAXQ, Q[Po] = i * MAX + j; \
  }}

short Pr[MAX][SLEN];
int N, Len[MAX], D[SLEN][MAX], Pos[MAX];
int Po = 0, Si = 0, Q[MAXQ];
char Dic[MAX][LEN], S[SLEN];

int main( void )
{
  int i, j, k, l, d, len;

  freopen("typing.in", "rt", stdin);
  freopen("typing.out", "wt", stdout);
  scanf("%d", &N);
  gets(S);
  for (i = 0; i < N; i++)
    gets(Dic[i]), Len[i] = strlen(Dic[i]);
  gets(S), len = strlen(S);
  for (j = 0; j < N; j++)
    Z(Pr[j], Dic[j], S);
  memset(D, -1, sizeof(D));
  for (j = 0; j < N; j++)
    RELAX(0, j, 1, 1)
  memset(Pos, 0, sizeof(Pos));
  while (Po != Si)
  {
    i = Q[Po] / MAX, j = Q[Po] % MAX;
    if (++Po >= MAXQ) Po = 0;
    d = D[i][j] + 1;
    if (j == N)
    {
      for (k = 0; k < N; k++)
        RELAX(i, k, d, 1);
      continue;
    }
    RELAX(i, N, d - 1, 0);
    if (Pos[j] < i)
      Pos[j] = i;
    while (Pos[j] < i + Pr[j][i])
    {
      Pos[j]++;
      RELAX(Pos[j], j, d, 1);
    }
  }
  for (j = len, i = 0; i < N; i++)
    if (j > D[len][i])
      j = D[len][i];
  printf("%d", j);
  return 0;
}

