{$R-}
uses SysUtils, Math;
const namein='orient.in';
      nameout='orient.out';
      NMax=11000;
      CMax=110;
      MMax=110000;
      Inf=100*NMax;
      TCC=24*60*60*1000;
      TLE=4500;
type
 integer=longint;
 real=extended;
 TGraph=array [1..NMax] of array of integer;
 TVect=array [0..NMax] of integer;
 TBool=array [1..NMax] of boolean;
var g,w1,w2:TGraph;
    n,m,Sol1,Sol2:integer;
    v,d,h,u,f:TVect;
    p:TBool;
    BTime:int64;

procedure AddEdge(const a,b,c1,c2:integer);
begin
 inc(v[a]);
 if v[a] mod CMax=0 then begin
   setlength(g[a],v[a]+CMax);
   setlength(w1[a],v[a]+CMax);
   setlength(w2[a],v[a]+CMax)
  end;
 g[a,v[a]]:=b;
 w1[a,v[a]]:=c1;
 w2[a,v[a]]:=c2
end;

procedure Init;
var i,a,b,c1,c2:integer;
begin
 BTime:=trunc(Now*TCC);
 assign(input,namein);
 reset(input);
 readln(n,m);
 for i:=1 to n do begin
   v[i]:=0;
   setlength(g[i],CMax);
   setlength(w1[i],CMax);
   setlength(w2[i],CMax)
  end;
 for i:=1 to m do begin
   readln(a,b,c1,c2);
   AddEdge(a,b,c1,c2);
   AddEdge(b,a,c2,c1)
  end;
 close(input)
end;

procedure Done;
begin
 assign(output,nameout);
 rewrite(output);
 writeln(Sol1,' ',Sol2);
 close(output);
 halt(0)
end;

procedure CheckTime;
var v:int64;
begin
 v:=trunc(Now*TCC);
 if (v-BTime)>TLE
 then Done
end;

procedure UHeap(a:integer);
var q:integer;
begin
 if (a>1) and (d[h[a div 2]]>d[h[a]])
 then begin
   u[h[a div 2]]:=a;
   u[h[a]]:=a div 2;
   q:=h[a];
   h[a]:=h[a div 2];
   h[a div 2]:=q;
   UHeap(a div 2)
  end
end;

procedure DHeap(a:integer);
var l,r,larg:integer;
begin
 l:=a*2; r:=l+1; larg:=a;
 if (l<=h[0]) and (d[h[l]]<d[h[larg]]) then larg:=l;
 if (r<=h[0]) and (d[h[r]]<d[h[larg]]) then larg:=r;
 if larg<>a then begin
   u[h[a]]:=larg;
   u[h[larg]]:=a;
   r:=h[a];
   h[a]:=h[larg];
   h[larg]:=r;
   DHeap(larg)
  end
end;

procedure AddHeap(const a:integer);
begin
 inc(h[0]);
 h[h[0]]:=a;
 u[a]:=h[0];
 UHeap(h[0])
end;

procedure Solve;
var k,i,j,q,t,ts,r:integer;
begin
 if (m+1)=n then Sol1:=n-1
 else Sol1:=n;
 Sol2:=Inf;
 for k:=1 to n do begin
   for i:=1 to n do d[i]:=Inf;
   d[k]:=0; h[0]:=0;
   for i:=1 to n do AddHeap(i);
   fillchar(p,sizeof(p),true);
   t:=0;
   for i:=1 to n do begin
     q:=h[1];
     inc(t,d[q]);
     p[q]:=false;
     h[1]:=h[h[0]];
     u[h[1]]:=1;
     dec(h[0]);
     if h[0]>0 then DHeap(1);
     for j:=1 to v[q] do
      if p[g[q,j]] and (d[g[q,j]]>w1[q,j]) then begin
        d[g[q,j]]:=w1[q,j];
        f[g[q,j]]:=q;
        UHeap(u[g[q,j]])
       end
    end;
   if t<Sol2 then begin
     if (m+1)=n then ts:=t
     else begin
       ts:=Inf;
       for i:=1 to v[k] do
        if f[g[k,i]]<>k then ts:=min(ts,t+w2[k,i])
        else begin
          r:=g[k,i];
          for j:=1 to v[r] do
           if (g[r,j]<>k)and(f[g[r,j]]<>r)
           then ts:=min(ts,t+w2[k,i]-d[r]+w2[r,j])
         end
      end;
     Sol2:=min(Sol2,ts)
    end;
   CheckTime
  end
end;

begin
 Init;
 Solve;
 Done
end.
