#include <cstdio>
#include <memory.h>
#include <vector>
#include <queue>
#include <algorithm>

#define maxn 2000
#define inf 100000000

using namespace std;

long n,m;
long c[maxn+100][maxn+100];
signed char f[maxn+100][maxn+100],p[maxn+100][maxn+100];
long d[maxn+100],fr[maxn+100];
vector<long> v[maxn+100];

void ford_bellman()
{
/*	printf("<--------New cycle--------->\n");*/
	long cs,tmp;
	while(1)
	{
		bool fl=false;
		for(long i=0;i<=n+m+1;i++){
			for(long j=0;j<v[i].size();j++){
				tmp=v[i][j];
				if(p[i][tmp]-f[i][tmp]<=0) continue;
				cs=c[i][tmp];
				if(f[i][tmp]<0) cs=-cs;
/*				printf("Trying to go %d %d, cs=%d, d[i]=%d, d[v[i][j]]=%d\n",i,v[i][j],cs,d[i],d[v[i][j]]);*/
				if(d[i]+cs<d[tmp]){
					d[tmp]=d[i]+cs;
					fr[tmp]=i;
					fl=true;
				}
			}
		}
		if(!fl) break;
	}
}

void dfs(long x)
{
	f[fr[x]][x]++,f[x][fr[x]]--;
	if(fr[x]>0) dfs(fr[x]);
}

bool add()
{
	for(long i=0;i<=n+m+1;i++)
		d[i]=(i==0)? 0:inf;
	memset(fr,0,sizeof(fr));
	ford_bellman();
	long mi=n+m+1,mx=d[mi];
	if(mx>=inf) return false;
	dfs(mi);
	return true;
}

int main()
{
	for(long i=0;i<maxn+100;i++)
		for(long j=0;j<maxn+100;j++)
			c[i][j]=inf;
	memset(f,0,sizeof(f));
	memset(p,0,sizeof(p));
	freopen("orient.in","r",stdin);
	scanf("%d%d",&n,&m);
	if(n+m<=1500){
		long x,y,c1,c2;
		for(long i=1;i<=m;i++){
			scanf("%d%d%d%d",&x,&y,&c1,&c2);
			c[x][n+i]=c1,c[n+i][x]=c1,p[x][n+i]=1,
				v[x].push_back(n+i),v[n+i].push_back(x);
			c[y][n+i]=c2,c[n+i][y]=c2,p[y][n+i]=1,
				v[y].push_back(n+i),v[n+i].push_back(y);
		}
		fclose(stdin);
		long a1=0,a2=0;
		for(long i=1;i<=m;i++)
			v[n+m+1].push_back(n+i),v[n+i].push_back(n+m+1),
				p[n+i][n+m+1]=1,c[n+i][n+m+1]=0,c[n+m+1][n+i]=0;
		for(long i=1;i<=n;i++)
			v[0].push_back(i),v[i].push_back(0),
				p[0][i]=1,c[0][i]=0,c[i][0]=0;
		while(add()) a1++;
		for(long i=0;i<=n+m+1;i++){
			for(long j=0;j<=n+m+1;j++){
				if(f[i][j]>0) a2+=c[i][j];
/*				printf("%d ",f[i][j]);*/
			}
/*			printf("\n");*/
		}
		freopen("orient.out","w",stdout);
		printf("%d %d\n",a1,a2);
		fclose(stdout);
	} else {
		long x,y,c1,c2;
		priority_queue<pair<long,pair<long,long> > > h;
		for(long i=1;i<=m;i++){
			scanf("%d%d%d%d",&x,&y,&c1,&c2);
			v[x].push_back(n+i),v[n+i].push_back(x);
			v[y].push_back(n+i),v[n+i].push_back(y);
			h.push(make_pair(c1,make_pair(x,i)));
			h.push(make_pair(c2,make_pair(y,i)));
		}
		fclose(stdin);
		bool us[200000];
		memset(us,0,sizeof(us));
		long a1=0,a2=0;
		while(!h.empty()){
			if((!us[h.top().second.first])&&(!us[n+h.top().second.second])){
				us[h.top().second.first]=true;
				us[n+h.top().second.second]=true;
				a1++,a2+=h.top().first;
			}
			h.pop();
		}
		freopen("orient.out","w",stdout);
		printf("%d %d\n",a1,a2);
		fclose(stdout);
	}
	return 0;
}
