#include <stdio.h>
#include <string.h>

#define INF (int)1e9
#define MAX_V 110010
#define MAX_E 520010

char F[MAX_E], C[MAX_E], InQ[MAX_V];
short W[MAX_E];
int N, M, E = 0, St, En, He[MAX_V], Ne[MAX_E], Y[MAX_E];
int Po, Si, Q[MAX_V], D[MAX_V], La[MAX_V], LaE[MAX_V];
int SumN = 0;
long long SumW = 0;

void AddE( int a, int b, int w )
{
  Ne[E] = He[a], Y[E] = b, W[E] = w, F[E] = 0, C[E] = 1, He[a] = E++;
  if (a == St || b == En)
    return;
  Ne[E] = He[b], Y[E] = a, W[E] = -w, F[E] = 0, C[E] = 0, He[b] = E++;
}

#define RELAX(i, d, j, e) { if (D[i] > d) { D[i] = d; La[i] = j; LaE[i] = e; if (!InQ[i]) { \
  Q[Si++] = i; InQ[i] = 1; if (Si == MAX_V) Si = 0; }}}

int main( void )
{
  int i, j, e;

  freopen("orient.in", "rt", stdin);
  freopen("orient.out", "wt", stdout);
  scanf("%d%d", &N, &M);
  St = 0, En = N + M + 1;
  memset(He, -1, sizeof(He));
  for (i = 1; i <= M; i++)
  {
    int a, b, cab, cba;
    scanf("%d%d%d%d", &a, &b, &cab, &cba);
    AddE(i, M + a, cab);
    AddE(i, M + b, cba);
  }
  for (i = 1; i <= M; i++)
    AddE(St, i, 0);
  for (i = 1; i <= N; i++)
    AddE(M + i, En, 0);
  while (1)
  {
    for (i = St; i <= En; i++)
      D[i] = INF, InQ[i] = 0;
    Po = Si = 0;
    RELAX(St, 0, -1, -1);
    while (Po != Si)
    {
      i = Q[Po++], InQ[i] = 0;
      if (Po == MAX_V) Po = 0;
      for (e = He[i]; e != -1; e = Ne[e])
        if (F[e] < C[e])
          RELAX(Y[e], D[i] + W[e], i, e);
    }
    if (D[En] == INF)
      break;
    SumN++;
    for (i = En; i != St; i = La[i])
    {
      j = LaE[i], SumW += W[j], F[j]++;
      if (i != En && La[i] != St)
        F[j ^ 1]--;
    }
  }
  printf("%d %Ld\n", SumN, SumW);
  return 0;
}
