#include <stdio.h>
#include <fstream>
#include <iostream>
#include <stdlib.h>
#include <memory.h>

using namespace std;

class huge
{
   int d [1157];
   int size;
   bool neg;
   enum { dSize = 1000000000 };
   
public:
   huge ();
   huge ( int n );
   huge ( huge const& h );
   
   ~huge () {}
   
   huge operator + () const
   {
      return *this;
   }
   huge operator - ()
   {
      huge h ( *this );
      h.neg = !h.neg;
      return h;
   }
   huge osgn ()
   {
      huge h ( *this );
      h.neg = !h.neg;
      return h;
   }
   
   huge& operator = ( huge const& h );
   huge& operator = ( int n );
   
   huge& operator += ( huge& h );
   huge& operator -= ( huge& h );
   
   huge& operator *= ( int n );
   
   huge& operator >>= ( int n );
   huge& operator <<= ( int n );
   
   huge& operator *= ( huge& h )
   {
      return (*this) = (*this) * h;
   }
   
   friend huge operator + ( huge const& a, huge& b )
   {
      return huge ( a ) += b;
   }
   friend huge operator - ( huge const& a, huge& b )
   {
      return huge ( a ) -= b;
   }
   
   friend huge operator * ( huge const& a, huge& b );
   
   friend bool operator > ( huge const& a, huge const& b );
   friend bool operator < ( huge const& a, huge const& b );
   friend bool operator >= ( huge const& a, huge const& b );
   friend bool operator <= ( huge const& a, huge const& b );
   friend bool operator == ( huge const& a, huge const& b );
   friend bool operator != ( huge const& a, huge const& b );
/*   
   static void div ( huge const& a, huge& b, huge const& c, huge const& r );
   
   huge& operator /= ( huge& h )
   {
      huge c, r;
      div ( *this, h, c, r );
      return (*this) = c;
   }
   huge& operator %= ( huge& h )
   {
      huge c, r;
      div ( *this, h, c, r );
      return (*this) = r;
   }
   friend huge operator / ( huge const& a, huge& b )
   {
      huge c, r;
      div ( a, b, c, r );
      return c;
   }
   friend huge operator % ( huge const& a, huge& b )
   {
      huge c, r;
      div ( a, b, c, r );
      return r;
   }*/
   void print ( char* buf )
   {
      if ( size == 0 )
      {
         buf [0] = '0';
         buf [1] = 0;
         return;
      }
      if ( neg )
        *(buf++) = '-';
      for ( int i = size-1; i >= 0; i-- )
      {
         if ( i == size-1 )
            buf += sprintf ( buf, "%d", d [i] );
         else
            buf += sprintf ( buf, "%09d", d [i] );
      }
   }
};

huge::huge ()
{
   memset ( d, 0, sizeof d );
   size = 0;
   neg = false;
}
huge::huge ( int n )
{
   if ( n < 0 )
   {
      neg = true;
      n = -n;
   }
   else
      neg = false;
      
   if ( n > 0 )
      size = 1;
   else
      size = 0;
   memset ( d, 0, sizeof d );
   d [0] = n;
}

huge::huge ( huge const& h )
{
   memcpy ( d, h.d, sizeof d );
   size = h.size;
   neg = h.neg;
}

huge& huge::operator = ( huge const& h )
{
   memcpy ( d, h.d, sizeof d );
   size = h.size;
   neg = h.neg;
}
huge& huge::operator = ( int n )
{
   if ( n < 0 )
   {
      neg = true;
      n = -n;
   }
   else
      neg = false;
      
   if ( n > 0 )
      size = 1;
   else
      size = 0;
   memset ( d, 0, sizeof d );
   d [0] = n;
}

huge& huge::operator += ( huge& h )
{
   if ( neg != h.neg )
   {
      huge m ( *this );
      huge l = h.osgn ();
      m -= l;
      return (*this) = m;
   }
   
   int c = 0;
   int i;
   for ( i = 0; i < h.size || c; i++ )
   {
      int v = d [i] + h.d [i] + c;
      if ( v >= dSize )
      {
         v -= dSize;
         c = 1;
      }
      else
         c = 0;
      d [i] = v;
   }
   if ( i > size )
      size = i;
   return *this;
}

huge& huge::operator -= ( huge& h )
{
   if ( neg != h.neg )
   {
      huge m ( *this );
      huge l = h.osgn ();
      m += l;
      return (*this) = m;
   }
   
   bool n = neg;
   neg = false;
   h.neg = false;
   if ( (*this) < h )
   {
      neg = n;
      h.neg = n;
      return (*this) = - ( h - (*this) );
   }
   neg = n;
   h.neg = n;
      
   int c = 0;
   for ( int i = 0; i < h.size || c; i++ )
   {
      int v = d [i] - h.d [i] - c;
      if ( v < 0 )
      {
         v += dSize;
         c = 1;
      }
      else
         c = 0;
      d [i] = v;
   }
   while ( size > 0 )
   {
      if ( d [size-1] == 0 )
         size--;
      else
         break;
   }
   return *this;
}

huge& huge::operator *= ( int n )
{
   if ( n < 0 )
   {
      neg = !neg;
      n = -n;
   }
   
   long long c = 0;
   int i;
   for ( i = 0; i < size || c; i++ )
   {
      long long v = (long long) d [i] * n + c;
      if ( v >= dSize )
      {
         c = v / dSize;
         v -= c * dSize;
      }
      else
         c = 0;
      d [i] = v;
   }
   if ( i > size )
      size = i;
   return *this;
}

huge& huge::operator >>= ( int n )
{
   if ( n == 0 )
      return *this;
   if ( size <= n )
      return (*this) = huge ();
   
   size -= n;
   memmove ( d, d + n, size );
   memset ( d + size, 0, sizeof d [0] * n );
   
   return *this;
}
huge& huge::operator <<= ( int n )
{
   if ( n == 0 )
      return *this;
   
   memmove ( d + n, d, size );
   memset ( d, 0, sizeof d [0] * n );
   size += n;
   
   return *this;
}

huge operator * ( huge const& a, huge& b )
{
   huge r;
   for ( int i = 0; i < b.size; i++ )
      r += ( ( huge ( a ) *= b.d [i] ) <<= i );
   r.neg ^= b.neg;
   return r;
}

bool operator < ( huge const& a, huge const& b )
{
   if ( a.size == 0 && b.size == 0 )
      return false;
      
   if ( a.neg != b.neg )
      return a.neg;

   if ( a.size > b.size )
      return a.neg;
   if ( a.size < b.size )
      return !a.neg;
      
   for ( int i = a.size - 1; i >= 0; i-- )
   {
      if ( a.d [i] > b.d [i] )
         return a.neg;
      if ( a.d [i] < b.d [i] )
         return !a.neg;
   }
   return false;
}
bool operator > ( huge const& a, huge const& b )
{
   if ( a.size == 0 && b.size == 0 )
      return false;
      
   if ( a.neg != b.neg )
      return !a.neg;

   if ( a.size > b.size )
      return !a.neg;
   if ( a.size < b.size )
      return a.neg;
      
   for ( int i = a.size - 1; i >= 0; i-- )
   {
      if ( a.d [i] > b.d [i] )
         return !a.neg;
      if ( a.d [i] < b.d [i] )
         return a.neg;
   }
   return false;
}

bool operator <= ( huge const& a, huge const& b )
{
   if ( a.size == 0 && b.size == 0 )
      return true;
      
   if ( a.neg != b.neg )
      return !a.neg;

   if ( a.size > b.size )
      return !a.neg;
   if ( a.size < b.size )
      return a.neg;
      
   for ( int i = a.size - 1; i >= 0; i-- )
   {
      if ( a.d [i] > b.d [i] )
         return !a.neg;
      if ( a.d [i] < b.d [i] )
         return a.neg;
   }
   return true;
}

bool operator >= ( huge const& a, huge const& b )
{
   if ( a.size == 0 && b.size == 0 )
      return true;
      
   if ( a.neg != b.neg )
      return a.neg;

   if ( a.size > b.size )
      return a.neg;
   if ( a.size < b.size )
      return !a.neg;
      
   for ( int i = a.size - 1; i >= 0; i-- )
   {
      if ( a.d [i] > b.d [i] )
         return a.neg;
      if ( a.d [i] < b.d [i] )
         return !a.neg;
   }
   return true;
}

bool operator == ( huge const& a, huge const& b )
{
   if ( a.size == 0 && b.size == 0 )
      return true;
      
   if ( a.neg != b.neg )
      return false;

   if ( a.size != b.size )
      return false;
      
   for ( int i = a.size - 1; i >= 0; i-- )
      if ( a.d [i] != b.d [i] )
         return false;
   return true;
}

bool operator != ( huge const& a, huge const& b )
{
   if ( a.size == 0 && b.size == 0 )
      return false;
      
   if ( a.neg != b.neg )
      return true;

   if ( a.size != b.size )
      return true;
      
   for ( int i = a.size - 1; i >= 0; i-- )
      if ( a.d [i] != b.d [i] )
         return true;
         
   return false;
}

int k;
int m;
int i_p [100];
int i_b [100];
int i_a [100][100];
long long p [100];
long long b [100];
long long a [100][100];
long long sp [100];
long long sb [100];
long long sa [100][100];

void read_input ()
{
   FILE* f = fopen ( "lock.in", "rt" );
   
   fscanf ( f, "%d %d", &k, &m );
   
   for ( int i = 0; i < m; i++ )
   {
      fscanf ( f, "%d", &( i_p [i] ) );
      p [i] = i_p [i];
   }
   
   for ( int i = 0; i < m; i++ )
   {
      fscanf ( f, "%d", &( i_b [i] ) );
      i_b [i]--;
      b [i] = i_b [i];
   }
      
   for ( int i = 0; i < k; i++ )
   {
      for ( int j = 0; j < m; j++ )
      {
         fscanf ( f, "%d", &( i_a [i][j] ) );
         a [i][j] = ( i_a [i][j] % i_p [j] );
      }
   }
   
   fclose ( f );
}

void scale_row ( int j, long long scale )
{
   p [j] *= scale;
   b [j] *= scale;
   for ( int i = 0; i < k; i++ )
      a [i][j] *= scale;
}
void scale_row_left ( int j, long long scale )
{
   b [j] *= scale;
   for ( int i = 0; i < k; i++ )
      a [i][j] *= scale;
}
void sub_row ( int j1, int j2 )
{
   b [j2] -= b [j1];
   for ( int i = 0; i < k; i++ )
      a [i][j2] -= a [i][j1];
}
void sub_row_sc ( int j1, int j2, int s )
{
   b [j2] -= b [j1] * s;
   for ( int i = 0; i < k; i++ )
      a [i][j2] -= a [i][j1] * s;
}
#define SWAP(a,b,t) {t=a;a=b;b=t;}
void swap_rows ( int j1, int j2 )
{
   long long t;
   SWAP ( b [j1], b [j2], t );
   for ( int i = 0; i < k; i++ )
      SWAP ( a [i][j1], a [i][j2], t );
}

long long gcd2 ( long long a, long long b, long long& p, long long& q )
{
   if ( b == 0 )
   {
      p = 1;
      q = 0;
      return a;
   }
   long long p1, q1;
   long long g = gcd2 ( b, a % b, p1, q1 );
   p = q1;
   q = p1 - q1 * ( a / b );
   return g;
}
long long gcd ( long long a, long long b )
{
   if ( b == 0 )
      return a;
   return gcd ( b, a % b );
}
long long mod ( long long a, long long b )
{
   if ( a >= 0 )
      return a % b;
   else
      return b - ( ( -a ) % b );
}

long long solve ( long long a, long long b, long long p, long long* delta = NULL )
{
   long long x, y;
   long g = gcd2 ( a, p, x, y );
   if ( ( b % g ) != 0 )
      return -1;
   if ( delta )
      *delta = p / g;
   return mod ( -( b / g ) * x, p );
}

long long out [100];

void remove ( int j1, int j2, int p )
{
   long long g = gcd ( a [p][j1], a [p][j2] );
   long long l = a [p][j2];
   scale_row_left ( j2, a [p][j1] / g );
   sub_row_sc ( j1, j2, l / g );
}

bool compute ()
{
   long long gmul = 1;
   for ( int i = 0; i < m; i++ )
   {
      if ( ( gmul % p [i] ) != 0 )
         gmul *= p [i];
   }
   for ( int i = 0; i < m; i++ )
      scale_row ( i, gmul / p [i] );

   int p = 0;
   int i = 0;
   while ( p < k-1 && i < m )
   {
      int i0 = i;
      while ( i < m && a [p][i] == 0 )
         i++;
      if ( i >= m )
      {
         i0++;
         i = i0;
         continue;
      }
      swap_rows ( i, i0 );
      i = i0 + 1;
      bool got_row = false;
      sp [p] = -1;
      for ( int j = i; j < m; j++ )
      {
         if ( a [p][j] != 0 && !got_row )
         {
            sp [p] = gmul;
            sb [p] = b [j];
            for ( int h = 0; h < k; h++ )
               sa [p][h] = a [h][j];
            got_row = true;
         }
         remove ( i0, j, p );
      }
      p++;
   }
   while ( i < m && a [p][i] == 0 )
      i++;
   if ( i >= m )
      out [p] = 0;
   else
   {
      out [p] = solve ( a [p][i], b [i], gmul );
      if ( out [p] < 0 )
         return false;
   }
   for ( int j = p-1; j >= 0; j-- )
   {
      if ( a [j][j] == 0 )
      {
         out [j] = 0;
         continue;
      }
      long long bsum = b [j];
      for ( int x = j + 1; x <= p; x++ )
         bsum += a [x][j] * out [x];
      long long delta;
      out [j] = solve ( a [j][j], bsum, gmul, &delta );
      
      if ( out [j] < 0 )
         return false;
      
      {
         long long bsum = sb [j];
         for ( int x = j + 1; x <= p; x++ )
            bsum += sa [j][x] * out [x];
         long long delta2;
         long long out2 = solve ( sa [j][j], bsum, gmul, &delta2 );
         long long pX, qX;
         long long gx = gcd2 ( -delta2, delta, pX, qX );
         if ( ( ( out2 - out [j] ) % gx ) != 0 )
            return false;
         out [j] += delta * qX * ( out2 - out [j] ) / gx;
      }
      
      out [j] %= gmul;
   }
   return true;
}
void write_output ()
{
   FILE* f = fopen ( "lock.out", "wt" );
   for ( int i = 0; i < k; i++ )
      fprintf ( f, "%d ", out [i] );
   fclose ( f );
}
void write_false ()
{
   FILE* f = fopen ( "lock.out", "wt" );
   fprintf ( f, "impossible" );
   fclose ( f );
}

int main ()
{
   read_input ();
   if ( !compute () )
      write_false ();
   else
      write_output ();
   
   return 0;
}
