#include <stdio.h>
#include <memory.h>
#include <string.h>

#define SIZE 500

struct Long {
	int len;
	int arr[SIZE+1];
};

int k, m;
int p[110];
int matr[110][110];

int gn, gm;
int gmatr[110][110];
bool solved;
int gres[110];

int mres[110][110];

bool used[10010];
bool insum[110];
Long res[110];
Long pprod;
Long prd[110];
Long lbuff;
int ranti[110][10010];

inline int mod(int a, int b) {
	a %= b;
	while (a<0) a += b;
	return a;	
}

void NOD(int a, int b, int &x, int &y) {
	if (b == 0) {
		x = 1;
		y = 0;
		return;
	}
	if (a < b) {
		NOD(b, a, y, x);
		return;
	}
	int mlt = a/b;
	NOD(a%b, b, x, y);
	y -= mlt*x;
}

void operator += (Long &a, Long &b) {
	if (a.len < b.len)
		a.len = b.len;
	int buff = 0;
	for (int i = 0; i<a.len; i++) {
		a.arr[i] += b.arr[i]+buff;
		if (a.arr[i] > 9) {
			a.arr[i] -= 10;
			buff = 1;
		}
		else
			buff = 0;
	}
	while (buff > 0) {
		a.arr[a.len] = buff%10;
		a.len++;
		buff /= 10;
	}
}

void operator *= (Long &a, int b) {
	int buff = 0;
	for (int i = 0; i<a.len; i++) {
		a.arr[i] = a.arr[i]*b + buff;
		buff = a.arr[i] / 10;
		a.arr[i] %= 10;
	}
	while (buff > 0) {
		a.arr[a.len] = buff%10;
		a.len++;
		buff /= 10;
	}
}

void operator /= (Long &a, int b) {
	int buff = 0;
	int rl = -1;
	for (int i = a.len-1; i>=0; i--) {
		a.arr[i] += buff * 10;
		buff = a.arr[i] % b;
		a.arr[i] /= b;
		if (a.arr[i] > 0)
			if (rl < 0)
				rl = i+1;
	}
	a.len = rl;
}

int anti[10010];
int adr[110];
void SolveGauss(int pr) {
	anti[0] = -1;
	bool deld[110];
	int i, j, u;
	for (i = 1; i<pr; i++) {
		int sx, sy;
		NOD(i, pr, sx, sy);
		anti[i] = mod(sx, pr);
	}
	for (i = 0; i<gm; i++)
		adr[i] = i;
	int pd = 0;
	for (i = 1; i<=gn; i++) {
		bool ok = false;
		for (j = pd; j<gm; j++)
			if (gmatr[adr[j]][i] != 0) {
				ok = true;
				int buff = adr[j];
				adr[j] = adr[pd];
				adr[pd] = buff;
				break;
			}
		if (!ok) {
			gres[i] = 0;
			deld[i] = true;
			continue;
		}
		deld[i] = false;
		for (j = pd+1; j<gm; j++) {
		    int coef = anti[gmatr[adr[pd]][i]];
		    coef *= gmatr[adr[j]][i];
		    coef %= pr;
			for (u = 0; u<=gn; u++)
				gmatr[adr[j]][u] = mod(gmatr[adr[j]][u] - gmatr[adr[pd]][u]*coef, pr);
		}
		pd++;
	}
	solved = true;
	for (i = pd; i<gm; i++)
		if (gmatr[adr[i]][0] != 0) {
			solved = false;
			return;
		}
	for (i = gn; i>0; i--) {
		if (deld[i])
			continue;
		pd--;
		for (j = i+1; j<=gn; j++) {
			gmatr[adr[pd]][0] -= gmatr[adr[pd]][j] * gres[j];
			gmatr[adr[pd]][0] = mod(gmatr[adr[pd]][0], pr);
		}
		gres[i] = mod(gmatr[adr[pd]][0] * anti[gmatr[adr[pd]][i]], pr);
	}
}

int main(int argc, char **argv) {
	freopen("lock.in", "r", stdin);
	freopen("lock.out", "w", stdout);
	int i, j, u, v;
	scanf("%d%d", &k, &m);
	for (i = 0; i<m; i++)
		scanf("%d", p+i);
	for (i = 0; i<m; i++) {
		scanf("%d", matr[i]);
		matr[i][0]--;
		matr[i][0] = (p[i] - matr[i][0]) % p[i];
	}
	for (i = 1; i<=k; i++)
		for (j = 0; j<m; j++) {
			scanf("%d", &(matr[j][i]));
			matr[j][i] %= p[j];
		}
	for (i = 0; i<10010; i++) {
		int adr[110];
		int num = 0;
		for (j = 0; j<m; j++)
			if (p[j] == i) {
				adr[num] = j;
				num++;
			}
		if (num>0) {
			gn = k;
			gm = num;
			for (j = 0; j<num; j++)
				for (u = 0; u<=k; u++)
					gmatr[j][u] = matr[adr[j]][u];
			SolveGauss(i);
			if (!solved) {
				printf("impossible");
				return 0;
			}
			for (j = 0; j<num; j++)
				for (u = 1; u<=k; u++)
					mres[adr[j]][u] = gres[u];
		}
	}
/*	for (i = 0; i<m; i++) {
		for (j = 1; j<=k; j++)
			printf("%d ", mres[i][j]);
		printf("\n");
	}*/

	pprod.len = 1;
	pprod.arr[0] = 1;
	for (i = 0; i<m; i++) {
		if (used[p[i]])
			continue;
		pprod *= p[i];
		insum[i] = true;
		used[p[i]] = true;
	}
	for (i = 0; i<m; i++) {
		prd[i] = pprod;
		prd[i] /= p[i];
	}
	for (i = 0; i<m; i++) {
		ranti[i][0] = -1;
		for (j = 1; j<p[i]; j++) {
			int sx, sy;
			NOD(j, p[i], sx, sy);
			ranti[i][j] = mod(sx, p[i]);
		}
	}
	for (i = 1; i<=k; i++) {
		int adr[110];
		res[i].len = 0;
		res[i].arr[0] = 0;
                int currmult[110];
		for (j = 0; j<m; j++) {
			if (!insum[j]) continue;
			int tost = 0;
			int post = 1;
			for (u = j-1; u>=0; u--)
				if (insum[u]) {
					tost = mod(tost*p[u] + currmult[u], p[j]);
					post = mod(post*p[u], p[j]);
				}
			int tpr = mod(mres[j][i] - tost, p[j]);
			tpr *= ranti[j][mod(post, p[j])];
			tpr = mod(tpr, p[j]);
                        currmult[j] = tpr;
		}
		for (j = m-1; j>=0; j--) {
			if (!insum[j]) continue;
                        res[i] *= p[j];
                        lbuff.len = 1;
                        lbuff.arr[0] = currmult[j];
                        res[i] += lbuff;
                }
	}
	for (i = 1; i<=k; i++) {
		bool print = false;
		for (j = res[i].len-1; j>=0; j--) {
			if (res[i].arr[j] > 0)			
				print = true;
			if (print)
				printf("%d", res[i].arr[j]);
		}
		if (!print)
			printf("0");
		printf(" ");
	}
	return 0;
}
