#include <cstdio>

#define MAX(a, b) ((a)<(b)?(b):(a))

struct Long{
  int len, a[1000];
  void norm(){
    int i;
    for (i=0; i<len; i++){
      if (a[i]<=-10||a[i]>=10) a[len++]=0;
      a[i+1]+=a[i]/10;
      a[i]%=10;
      if (a[i]<0&&i<len-1){
        a[i+1]--;
        a[i]+=10;
      }
    }
    while (len&&a[len-1]==0) len--;
  }
} M;

Long c(Long tmp){
  return tmp;
}

Long L(int t){
  Long tmp;
  tmp.len=1;
  tmp.a[0]=t;
  tmp.norm();
  return c(tmp);
}

bool LLessEq(Long a, Long b){
  int i;
  if (a.len<b.len) return true;
  if (a.len>b.len) return false;
  for (i=a.len-1; i>=0; i--){
    if (a.a[i]<b.a[i]) return true;
    if (a.a[i]>b.a[i]) return false;
  }
  return true;
}

Long LSum(Long a, Long b){
  int i;
  Long t;
  t.len=MAX(a.len, b.len);
  for (i=0; i<t.len; i++) t.a[i]=0;
  for (i=0; i<a.len; i++) t.a[i]+=a.a[i];
  for (i=0; i<b.len; i++) t.a[i]+=b.a[i];
  t.norm();
  return c(t);
}

Long LSMul(Long a, int b, int shift=0){
  int i;
  Long t;
  t.len=a.len+shift;
  for (i=0; i<shift; i++) t.a[i]=0;
  for (i=0; i<a.len; i++) t.a[i+shift]=a.a[i]*b;
  t.norm();
  return c(t);
}

Long LMul(Long a, Long b){
  Long t;
  int i, j;
  t.len=a.len+b.len-1;
  for (i=0; i<t.len; i++) t.a[i]=0;
  for (i=0; i<a.len; i++)
    for (j=0; j<b.len; j++)
      t.a[i+j]+=a.a[i]*b.a[j];
  t.norm();
  return c(t);
}

Long LDiv(Long a, Long b){
  int i;
  Long t;
  t.len=a.len-b.len+1;
  for (i=t.len-1; i>=0; i--){
    t.a[i]=0;
    while (LLessEq(LSMul(b, t.a[i]+1, i), a)) t.a[i]++;
    a=LSum(a, LSMul(b, -t.a[i], i));
  }
  t.norm();
  return c(t);
}

Long LMod(Long a, Long b){
  int i;
  int t;
  for (i=a.len-b.len; i>=0; i--){
    t=0;
    while (LLessEq(LSMul(b, t+1, i), a)) t++;
    a=LSum(a, LSMul(b, -t, i));
  }
  return c(a);
}

Long MNorm(Long t){
  if (t.len&&t.a[t.len-1]<0)
    return LMod(LSum(LSMul(LMod(LSMul(t, -1), M), -1), M), M);
  else
    return LMod(t, M);
}

Long MSum(Long a, Long b){
  return MNorm(LSum(a, b));
}

Long MMul(Long a, Long b){
  return MNorm(LMul(a, b));
}

Long MSMul(Long a, int b){
  return MNorm(LSMul(a, b));
}

Long Anti(Long a){
  Long b=M, x=L(1), y=L(0), t;
  while (b.len){
    t=MSum(x, MSMul(MMul(LDiv(a, b), y), -1));
    x=y;
    y=t;
    t=LMod(a, b);
    a=b;
    b=t;
  }
  return c(x);
}

Long Euclidx(Long a, Long b){
  Long x=L(1), y=L(0), t;
  while (b.len){
    t=MSum(x, MSMul(MMul(LDiv(a, b), y), -1));
    x=y;
    y=t;
    t=LMod(a, b);
    a=b;
    b=t;
  }
  return c(x);
}

Long Euclidy(Long a, Long b){
  Long x=L(0), y=L(1), t;
  while (b.len){
    t=MSum(x, MSMul(MMul(LDiv(a, b), y), -1));
    x=y;
    y=t;
    t=LMod(a, b);
    a=b;
    b=t;
  }
  return c(x);
}

Long GCD(Long a, Long b){
  Long t;
  while (b.len){
    t=LMod(a, b);
    a=b;
    b=t;
  }
  return a;
}

int K, bK, m, p[100], t, i, j, k;
int var[100];
Long b[100], a[100][100], ans[100], x, y, u, v, t1, t2;

void swapvar(int i, int j){
  int k;
  Long t;
  for (k=0; k<m; k++){
    t=a[k][i];
    a[k][i]=a[k][j];
    a[k][j]=t;
  }
  var[i]^=var[j]^=var[i]^=var[j];
}

void swapeq(int i, int j){
  int k;
  Long t;
  for (k=0; k<K; k++){
    t=a[i][k];
    a[i][k]=a[j][k];
    a[j][k]=t;
  }
  t=b[i];
  b[i]=b[j];
  b[j]=t;
}

int main(){
  freopen("lock.in", "rt", stdin);
  freopen("lock.out", "wt", stdout);
  scanf("%d%d", &bK, &m);
  /*if (bK==2&&m==2){
    printf("4 0");
    return 0;
  }*/
  K=bK;
  for (i=0; i<K; i++)
    var[i]=i;
  M=L(1);
  for (i=0; i<m; i++){
    scanf("%d", &p[i]);
    M=LSMul(M,p[i]);
  }
  for (i=0; i<m; i++){
    scanf("%d", &t);
    b[i]=L(p[i]-t+1);
    for (k=0; k<m; k++)
      if (k!=i) b[i]=MSMul(b[i], p[k]);
  }
  for (i=0; i<K; i++)
    for (j=0; j<m; j++){
      scanf("%d", &t);
      a[j][i]=L(t);
      for (k=0; k<m; k++)
        if (k!=j) a[j][i]=MSMul(a[j][i], p[k]);
    }
  for (i=0; i<m&&i<K; i++){
    t=i;
    for (j=m-1; j>i; j--)
      if (a[j][i].len!=0) t=j;
    if (a[t][i].len==0){
      swapvar(i, --K);
      continue;
    } else
      swapeq(i, t);
    for (j=0; j<m; j++){
      if (j==i) continue;
      x=Euclidx(a[i][i], a[j][i]);
      y=Euclidy(a[i][i], a[j][i]);
      u=a[i][i];
      v=MSMul(a[j][i], -1);
      for (k=0; k<m; k++){
        t1=MSum(MMul(a[i][k], x), MMul(a[j][k], y));
        t2=MSum(MMul(a[i][k], v), MMul(a[j][k], u));
        a[i][k]=t1;
        a[j][k]=t2;
      }
      t1=MSum(MMul(b[i], x), MMul(b[j], y));
      t2=MSum(MMul(b[i], v), MMul(b[j], u));
      b[i]=t1;
      b[j]=t2;
    }
  }
  for (i=0; i<K; i++){
    b[i]=MMul(b[i], Anti(a[i][i]));
    if (LMod(b[i], GCD(a[i][i], M)).len!=0){
      printf("impossible");
      return 0;
    }
    ans[var[i]]=LDiv(b[i], GCD(a[i][i], M));
  }
  for (i=0; i<bK; i++){
    if (ans[i].len==0) printf("0");
    for (j=ans[i].len-1; j>=0; j--) printf("%d", ans[i].a[j]);
    printf(" ");
  }
  return 0;
}
