#include <stdio.h>
#include <string.h>

#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))

#define INF (int)1e9
#define MAX_V 110010
#define MAX_E 520010

char F[MAX_E], C[MAX_E], InQ[MAX_V];
short W[MAX_E];
int N, M, E = 0, St, En, X[MAX_E], Y[MAX_E], Re[MAX_E];
int First[MAX_V], Last[MAX_V];
int Po, Si, Q[MAX_V], D[MAX_V], La[MAX_V], LaE[MAX_V];
int SumN = 0;
long long SumW = 0;

void AddE( int a, int b, int w )
{
  X[E] = a, Y[E] = b, W[E] = w, F[E] = 0, C[E] = 1, Re[E] = E, E++;
  if (a == St || b == En)
    return;
  Re[E - 1] = E, Re[E] = E - 1;
  X[E] = b, Y[E] = a, W[E] = -w, F[E] = 0, C[E] = 0, E++;
}

void QSort( int L, int R )
{
  int i = L, j = R, x, tmp, ri, rj;

  if (L >= R)
    return;
  x = X[L + (rand() % (R - L + 1))];
  while (i <= j)
  {
    while (X[i] < x) i++;
    while (X[j] > x) j--;
    if (i <= j)
    {
      ri = Re[i], rj = Re[j];
      if (ri != j)
        Re[ri] = j, Re[rj] = i, Re[i] = rj, Re[j] = ri;
      if (i == ri)
        Re[j] = j;
      if (j == rj)
        Re[i] = i;
        
      SWAP(W[i], W[j], tmp);
      SWAP(X[i], X[j], tmp);
      SWAP(Y[i], Y[j], tmp);
      SWAP(F[i], F[j], tmp);
      SWAP(C[i], C[j], tmp);
      i++, j--;
    }
  }
  QSort(L, j), QSort(i, R);
}

#define RELAX(i, d, j, e) { if (D[i] > d) { D[i] = d; La[i] = j; LaE[i] = e; if (!InQ[i]) { \
  Q[Si++] = i; InQ[i] = 1; if (Si == MAX_V) Si = 0; }}}

int main( void )
{
  int i, j, e;

  freopen("orient.in", "rt", stdin);
  freopen("orient.out", "wt", stdout);
  scanf("%d%d", &N, &M);
  St = 0, En = N + M + 1;
  for (i = 1; i <= M; i++)
  {
    int a, b, cab, cba;
    scanf("%d%d%d%d", &a, &b, &cab, &cba);
    AddE(i, M + a, cab);
    AddE(i, M + b, cba);
  }
  for (i = 1; i <= M; i++)
    AddE(St, i, 0);
  for (i = 1; i <= N; i++)
    AddE(M + i, En, 0);
  QSort(0, E - 1);
  First[St] = 0;
  for (j = 0, i = St; i <= En; i++)
  {
    while (j < E && X[j] == i)
      j++;
    Last[i] = First[i + 1] = j;   
  }
  while (1)
  {
    for (i = St; i <= En; i++)
      D[i] = INF, InQ[i] = 0;
    Po = Si = 0;
    RELAX(St, 0, -1, -1);
    while (Po != Si)
    {
      i = Q[Po++], InQ[i] = 0;
      if (Po == MAX_V) Po = 0;
      for (e = First[i]; e < Last[i]; e++)
        if (F[e] < C[e])
          RELAX(Y[e], D[i] + W[e], i, e);
    }
    if (D[En] == INF)
      break;
    SumN++;
    for (i = En; i != St; i = La[i])
    {
      j = LaE[i], SumW += W[j], F[j]++;
      if (i != En && La[i] != St)
        F[Re[j]]--;
    }
  }
  printf("%d %Ld\n", SumN, SumW);
  return 0;
}
