#include <stdio.h>
#include <memory.h>
#include <string.h>

const int strLength = 8192;

int kmp [strLength*2];
int kmpLength;

void buildKmp ( char const* stra, char const* strb )
{
  static char comp [strLength*2];
  int len1 = strlen ( stra );
  int len2 = strlen ( strb );
  memcpy ( comp, stra, len1 );
  comp [len1] = '$';
  memcpy ( comp+len1+1, strb, len2+1 );

  kmp [0] = 0;
  int i = 1;
  int len = len1 + len2 + 1;
  kmpLength = len;
  while ( i < len )
  {
    int k = kmp [i-1];
    while ( k > 0 && comp [k] != comp [i] )
      k = kmp [k-1];
    if ( comp [k] == comp [i] )
      kmp [i] = k + 1;
    else
      kmp [i] = 0;
    i++;
  }
}

char stra [strLength];
char strb [strLength];
void read_input ()
{
  FILE* f = fopen ( "stragain.in", "rt" );
  fscanf ( f, "%s", stra );
  fscanf ( f, "%s", strb );
  fclose ( f );
}
bool ans;
char ans1 [strLength];
char ans2 [strLength];
char ans3 [strLength]; 
void solve ()
{
  buildKmp ( stra, strb );

  int maxi = -1;
  int maxv = -1;
  for ( int i = strlen ( stra ); i < kmpLength; i++ )
  {
    if ( kmp [i] > maxv )
    {
      maxi = i;
      maxv = kmp [i];
    }
  }
  if ( maxv < 0 )
  {
    ans = false;
    return;
  }
  char tmp = stra [maxv];
  stra [maxv] = 0;
  strcpy ( ans1, stra );
  stra [maxv] = tmp;

  strcpy ( stra, stra+maxv );
  strcpy ( strb + maxi - maxv + 1, strb + maxi + 1 );

  buildKmp ( stra, strb );

  maxi = -1;
  maxv = -1;
  for ( int i = strlen ( stra ); i < kmpLength; i++ )
  {
    if ( kmp [i] > maxv )
    {
      maxi = i;
      maxv = kmp [i];
    }
  }
  if ( maxv < 0 )
  {
    ans = false;
    return;
  }
  tmp = stra [maxv];
  stra [maxv] = 0;
  strcpy ( ans2, stra );
  stra [maxv] = tmp;

  strcpy ( stra, stra+maxv );
  strcpy ( strb + maxi - maxv + 1, strb + maxi + 1 );

  ans = ( strcmp ( stra, strb ) == 0 );
  strcpy ( ans3, stra );
}

void write_output ()
{
  FILE* f = fopen ( "stragain.out", "wt" );

  if ( ans )
    fprintf ( f, "NO" );
  else
    fprintf ( f, "YES\n%s\n%s\n%s", ans1, ans2, ans3 );

  fclose ( f );
}

int main ()
{
  read_input ();
  solve ();
  write_output ();

  return 0;
}
