#include <stdio.h>
#include <stdlib.h>
#define T 5000

#define min(a, b) ((a) < (b) ? (a) : (b))

char s1[5002], s2[5002];
int sn1, sn2, rn1, rn2, rn3, R1[11002], R2[11002];
char r1[5002], r2[5002], r3[5002], t1[11002], t2[11002];

void KMP( char *s1, int N, int *res )
{
  int i, t;

  res[0] = 0;
  
  for (i = 1; i < N; i++)
  {
    t = i - 1;
    res[i] = 0;
    do
    {
      t = res[t] - 1;
      if (s1[t + 1] == s1[i])
      {
        res[i] = t + 2;
        break;
      }
    } while (t >= 0); 
  }
  return;
}

void Z( char *s, int N, int *R )
{
  int i, j, k, lstl = 0, lstd = 0, t, r;
  R[0] = 0;
  for (i = 1; i < N; i++)
  {
   
    t = 0; 	
    r = lstl + lstd - 1;
    if (r >= i)
    {
      t += min(R[i - lstl], r - i + 1);
    }
    k = i + t;	
    while (k < N && s[t] == s[k])
      t++, k++;
    R[i] = t;
    if (i + t - 1 > r)
      lstl = i, lstd = R[i];
  }
  /* DEBUG */ /*
  for (i = 0; i < N; i++)
    printf("%c", s[i]);
  printf("\n");
  for (i =0 ; i < N; i++)
    printf("%i ", R[i]);
  printf("\n"); */

 
}
void TestZ( char *s, int N, int *R )
{
  int i, j, t;

  for (i = 0; i  < N; i++)
  {
    j = i;
    t = 0;
    while (j < N && s[t] == s[j])
      t++, j++;
    R[i] = t;
  }
  R[0] = 0;
}

int CanBy2( char *s1, char *s2, int N )
{
  int f, i, j, k;

  if (N <= 1)
    return 0;
  for (f = 1, i = 0; i < N && f; i++)
    if (s1[i] != s2[i]) 
      f = 0;
  if (f)
  {
    for (i = 0; i < N - 1; i++)
      r1[i] = s1[i];
    rn1 = N - 1;
    rn2 = 1;
    r2[0] = s1[i];
    return 1;
  }
  for (i = 0; i < N; i++)
    t1[i] = s1[i],
    t2[i] = s2[i];
  t1[i] = '#';
  t2[i] = '#';
  for (i = 0; i < N; i++)
    t1[i + N + 1] = s2[i],
    t2[i + N + 1] = s1[i];
  Z(t1, (N << 1) + 1, R1);
  Z(t2, (N << 1) + 1, R2);
  for (i = 0; i < N - 1; i++)
  {
    k = N - i - 1;
    if (R2[(N << 1) - i] == i + 1 && R1[(N << 1) - k + 1] == k)	
    {
      rn2 = i + 1;
      rn1 = k;
      for (j = 0; j < rn1; j++)
        r1[j] = s2[j + i + 1];
      for (j = 0; j < rn2; j++)
        r2[j] = s2[j];
      return 1;
    }
  }

  return 0;
}

void OutYES( char *r1, char *r2, char *r3, int rn1, int rn2, int rn3 )
{
  int i;
  printf("YES\n");
  for (i = 0; i < rn1; i++)
    printf("%c", r1[i]);
  printf("\n");
  for (i = 0; i < rn2; i++)
    printf("%c", r2[i]);
  printf("\n");
  for (i = 0; i < rn3; i++)
    printf("%c", r3[i]);
}

int main( void )
{
 int i, j, k, f; 
 char c;
 
 freopen("stragain.in", "rt", stdin);
 freopen("stragain.out", "wt", stdout);
 while ((c = getc(stdin)) >= 'a' && c <= 'z')
   s1[sn1++] = c;
 while (c != '\n')
   c = getc(stdin);
 while ((c = getc(stdin)) >= 'a' && c <= 'z')
   s2[sn2++] = c;
 if (sn1 < 3)
 {
   printf("NO");
   return 0;
 }
 /* 1 case: strings are equeal */
 for (i = 0, f = 1; i < sn1 && f; i++)
   if (s1[i] != s2[i])
     f = 0;
 if (f)
 {
   r1[0] = s1[0];
   rn1 = 1;
   r2[0] = s1[1];
   rn2 = 1;
   for (i = 2; i < sn1; i++)
     r3[i - 2] = s1[i];
   rn3 = sn1 - 2;
   OutYES(r1, r2, r3, rn1, rn2, rn3);
   return 0;
 }
 /* 2 case: first part is on the same place */
 for (i = 0; i < sn1 && s1[i] == s2[i]; i++)
 {
   if (CanBy2(s1 + i + 1, s2 + i + 1, sn1 - i - 1))
   {
     rn3 = i + 1;
     for (j = 0; j <= i; j++)
       r3[j] = s1[j];
     OutYES(r3, r1, r2, rn3, rn1, rn2);
     return 0;
   }
 }
 /* 3 case: last part is on the same place */
 for (i = sn1 - 1; i >= 0 && s1[i] == s2[i]; i--)
 {
   if (CanBy2(s1, s2, i))
   {
     rn3 = sn1 - i;
     for (j = i; j < sn1; j++)
       r3[j - i] = s1[j];
     OutYES(r1, r2, r3, rn1, rn2, rn3);
     return 0;   
   }
 }
 /* 4 case: first part goes to last */
 for (i = 0; i < sn1; i++)
   t1[i] = s2[i];
 t1[i] = '#';
 for (i = 0; i < sn1; i++)
   t1[i + sn1 + 1] = s1[i];
 Z(t1, sn1 * 2 + 1, R1);
 for (i = sn1 * 2; i > sn1; i--)
   if (R1[i] == (sn1 << 1) + 1 - i)
   {
     j = i - sn1 - 1;
     if (CanBy2(s1, s2 + (sn1 << 1) + 1 - i, j))
     {
       rn3 = (sn1 << 1) + 1 - i;
       for (k = 0; k < rn3; k++)
         r3[k] = s2[k];
       OutYES(r1, r2, r3, rn1, rn2, rn3);
       return 0;
     }
   }
 /* 5 case: last part goes to first */
 for (i = 0; i < sn1; i++)
   t1[i] = s1[i];
 t1[i] = '#';
 for (i = 0; i < sn1; i++)
   t1[i + sn1 + 1] = s2[i];
 Z(t1, sn1 * 2 + 1, R1);
 for (i = sn1 * 2; i > sn1; i--)
   if (R1[i] == (sn1 << 1) + 1 - i)
   {
     j = i - sn1 - 1;
     if (CanBy2(s1 + (sn1 << 1) + 1 - i, s2, j))
     {
       rn3 = (sn1 << 1) + 1 - i;
       for (k = 0; k < rn3; k++)
         r3[k] = s2[k + i];
       OutYES(r3, r1, r2, rn1, rn2, rn3);
       return 0;
     }
   }
 printf("NO");
 /*if (CanBy2(s1, s2, sn1))
 {
   for (i = 0; i < rn1; i++)
     printf("%c", r1[i]);
   printf(" ");
   for (i = 0; i < rn2; i++)
     printf("%c", r2[i]);
 }
 else
 {
   printf("NO");
 }*/



 /*
 for (i = 0; i < 100; i++)
 {
   for (j = 0; j < T; j++)
     s1[j] = (rand() & 1) + 'a';
   printf("Start Z\n");
   Z(s1, T, R1);
   printf("End Z\n");
   TestZ(s1, T, R2);
   for (j = 0; j < T; j++)
     if (R1[j] != R2[j])
     {
       printf("Hmmm\n\n");
       for (k = 0; k < T; k++)
         printf("%c", s1[k]);
       printf("\n");
       printf("    Z:");
       for(k = 0; k < T; k++)
         printf("%i,", R1[k]);
       
       printf("\nTestZ:");
       for(k = 0; k < T; k++)
         printf("%i,", R2[k]);
       return 0;
     }
 }
 */
 return 0;
}
