{$R+,H+}
uses SysUtils;
const namein='stragain.in';
      nameout='stragain.out';
      NMax=5001;
      TLE=1950;
      CTime=24*60*60*1000;
type
 TVect=array [1..NMax] of integer;
 TDp=array [1..NMax] of TVect;
var d:TDp;
    a,b,v,r1,r2,r3:string;
    n:integer;
    BTime:int64;

procedure Init;
begin
 BTime:=trunc(Now*CTime);
 assign(input,namein);
 reset(input);
 readln(a);
 readln(b);
 n:=length(a);
 close(input)
end;

procedure Done(Ok:boolean);
begin
 assign(output,nameout);
 rewrite(output);
 if not Ok then writeln('NO')
 else begin
   writeln('YES');
   writeln(r1);
   writeln(r2);
   writeln(r3)
  end;
{ writeln(trunc(Now*CTime)-BTime);}
 close(output);
 halt(0)
end;

function max(const a,b:integer):integer;
begin
 if a>b then max:=a
 else max:=b
end;

procedure KMP(const a,b:string; const c:integer);
var p:TVect;
    i,k:integer;
begin
 p[1]:=0;
 k:=0;
 for i:=2 to length(b) do begin
   while (k>0) and (b[i]<>b[k+1]) do k:=p[k];
   if b[i]=b[k+1] then inc(k);
   p[i]:=k
  end;
 k:=0;
 for i:=1 to length(a) do begin
   while (k>0) and (a[i]<>b[k+1]) do k:=p[k];
   if a[i]=b[k+1] then inc(k);
   d[i-k+1,c]:=max(d[i-k+1,c],k);
   if k=length(b) then k:=p[k]
  end;
 while k>0 do begin
   d[n-k+1,c]:=max(d[n-k+1,c],k);
   k:=p[k]
  end
end;

procedure CheckTime;
begin
 if (trunc(Now*CTime)-BTime)>TLE then Done(False)
end;

procedure Solve;
var i,j:integer;
begin
 for i:=1 to NMax do
  for j:=1 to NMax do d[i,j]:=maxint;
 fillchar(d,sizeof(d),0);
 v:=b;
 for i:=1 to n do begin
   KMP(a,v,i);
   delete(v,1,1);
   CheckTime
  end;
 for i:=1 to n-2 do begin
   for j:=i+1 to n-1 do begin
     if (d[1,1]>=i) and (d[i+1,i+1]>=(j-i)) and (d[j+1,j+1]>=(n-j))
     then begin
       r1:=Copy(b,1,i);
       r2:=Copy(b,i+1,j-i);
       r3:=Copy(b,j+1,n-j);
       Done(True)
      end;
     if (d[1,1]>=i) and (d[i+1,j+1]>=(n-j)) and (d[i+(n-j)+1,i+1]>=(j-i))
     then begin
       r1:=Copy(b,1,i);
       r3:=Copy(b,i+1,j-i);
       r2:=Copy(b,j+1,n-j);
       Done(True)
      end;
     if (d[1,i+1]>=(j-i)) and (d[j-i+1,1]>=i) and (d[j+1,j+1]>=(n-j))
     then begin
       r2:=Copy(b,1,i);
       r1:=Copy(b,i+1,j-i);
       r3:=Copy(b,j+1,n-j);
       Done(True)
      end;
     if (d[1,j+1]>=(n-j)) and (d[n-j+1,1]>=i) and (d[n-(j-i)+1,i+1]>=(j-i))
     then begin
       r2:=Copy(b,1,i);
       r3:=Copy(b,i+1,j-i);
       r1:=Copy(b,j+1,n-j);
       Done(True)
      end;
     if (d[1,i+1]>=(j-i)) and (d[j-i+1,j+1]>=(n-j)) and (d[n-i+1,1]>=i)
     then begin
       r3:=Copy(b,1,i);
       r1:=Copy(b,i+1,j-i);
       r2:=Copy(b,j+1,n-j);
       Done(True)
      end;
     if (d[1,j+1]>=(n-j)) and (d[n-j+1,i+1]>=(j-i)) and (d[n-i+1,1]>=i)
     then begin
       r3:=Copy(b,1,i);
       r2:=Copy(b,i+1,j-i);
       r1:=Copy(b,j+1,n-j);
       Done(True)
      end
    end;
   CheckTime
  end
end;

begin
 Init;
 Solve;
 Done(False)
end.
