#include <stdio.h>
#include <time.h>
#include <algorithm>
#include <queue>
#include <vector>

typedef std::queue<int> iQueue;
typedef std::vector<int> iVect;
typedef iVect::iterator vIter;

#define WORK_TIME 1500

int answer;
int n, m, k;
int plist[110];
bool peace[110];
bool matr[110][110];
iVect rels[110];

int stime;

bool used[110];

bool vis[110];
int father[110];
iQueue q;

int BFS(int u) {
	memcpy(vis, used, n*sizeof(int));
	while (!q.empty()) q.pop();
	q.push(u);
	father[u] = -1;
	vis[u] = true;
	while (!q.empty()) {
		int curr = q.front();
		q.pop();
		if (peace[curr])
			if (u != curr)
				return curr;
		for (vIter it = rels[curr].begin(); it != rels[curr].end(); it++)
			if (!used[*it])
				if (!vis[*it]) {
					father[*it] = curr;
					vis[*it] = true;
					q.push(*it);
				}
	}
	return -1;
}

int main(int argc, char **argv) {
	freopen("peace.in", "r", stdin);
	freopen("peace.out", "w", stdout);
	stime = clock();
	int i, j;
	scanf("%d%d%d", &n, &m, &k);
	for (i = 0; i<k; i++) {
		int curr;
		scanf("%d", &curr);
		curr--;
		plist[i] = curr;
		peace[curr] = true;
	}
	for (i = 0; i<m; i++) {
		int a, b;
		scanf("%d%d", &a, &b);
		a--;  b--;
		matr[a][b] = true;
		rels[a].push_back(b);
		matr[b][a] = true;
		rels[b].push_back(a);
	}
	while (1) {
		std::random_shuffle(plist, plist+k);
		for (i = 0; i<n; i++)
			std::random_shuffle(rels[i].begin(), rels[i].end());
		memset(vis, 0, n*sizeof(bool));
		int res = 0;
		for (i = 0; i<k; i++) {
			if ((k-i)/2 + res <= answer) break;
			if (!used[plist[i]]) {
				int curr = BFS(plist[i]);
				if (curr<0) continue;
				res++;
				while (curr >= 0) {
					used[curr] = true;
					curr = father[curr];
				}
			}
		}
		if (res > answer)
			answer = res;
		int nowt = clock();
		if ((nowt-stime) * 1000 > WORK_TIME * CLOCKS_PER_SEC)
			break;
	}
	printf("%d", answer);
	return 0;
}
