type integer = longint;
const MNOGO = 1000000000;
const eps = 1e-9;
const NUMP = 6561;
var m, n, k, l : integer;
	ma : array[1..110, 1..8] of extended;

procedure Load;
var i, j : integer;
begin
	read(m, n, k, l);
	for i := 1 to n do begin
		for j := 1 to m do begin
			read(ma[i, j]);
			ma[i, j] := ln(ma[i, j]);
		end;
	end;
end;

var res : array[1..101, 0..NUMP] of extended;
	plc, lp : array[1..101, 0..NUMP] of integer;
	rma : array[1..101, 1..8] of integer;

procedure GenGO(cs, cp : integer);
var nma, cma : array[1..3, 1..8] of integer;
	f, i, j, cur, ii, jj, np : integer;
begin
	{unpack profile}
	fillchar(cma, sizeof(cma), 0);
	cur := cp;
	for i := 1 to m do begin
		for j := 1 to cur mod 3 do cma[j, i] := 1;
		cur := cur div 3;
	end;
	{generate moves}
	for i := 1 to m do begin
		if cma[1, i] = 0 then begin
			move(cma, nma, sizeof(nma));
			for ii := 2 to l do begin
				for jj := i - k + 1 to i + k - 1 do begin
					if (jj < 1) then continue;
					if (jj > m)then break;
					nma[ii, jj] := 1;
				end;
			end;
			{check}
			f := 1;
			for ii := 1 to m do begin
				if nma[2, ii] = 0 then begin
					f := 0;
					break;
				end;
			end;
			if f = 1 then continue;
			{pack profile}
			np := 0;
			for j := m downto 1 do begin
				if nma[3, j] = 1 then np := np * 3 + 2
				else if nma[2, j] = 1 then np := np * 3 + 1
				else np := np * 3;
			end;
			{relax}
			if res[cs + 1, np] < res[cs, cp] + ma[cs, i] then begin
				res[cs + 1, np] := res[cs, cp] + ma[cs, i];
				plc[cs + 1, np] := i;
				lp[cs + 1, np] := cp;
			end;
		end;
	end;
end;

procedure Solve;
var i, j, mi : integer;
	max : extended;
begin
	for i := 1 to 101 do begin
		for j := 0 to NUMP do begin
			res[i, j] := -MNOGO;
		end;
	end;
	res[1, 0] := 0;
	for i := 1 to n do begin
		for j := 0 to NUMP do begin
			if abs(res[i, j] + MNOGO) < eps then continue;
			GenGo(i, j);
		end;
	end;
	max := -MNOGO;
	mi := 0;
	for i := 0 to NUMP do begin
		if res[n + 1, i] > max then begin
			max := res[n + 1, i];
			mi := i;
		end;
	end;
	if abs(max + MNOGO) < eps then begin
		write('IMPOSSIBLE');
	end
	else begin
		fillchar(rma, sizeof(rma), 0);
		j := mi;
		for i := n + 1 downto 2 do begin
			rma[i - 1, plc[i, j]] := 1;
			j := lp[i, j];	
		end;
		for i := 1 to n do begin
			for j := 1 to m do begin
				write(rma[i, j], ' ');
			end;
			writeln;
    	end;
   	end;
end;

begin
	assign(input, 'sprats.in');
	assign(output, 'sprats.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
