#include <stdio.h>
#define _USE_MATH_DEFINES
#include <math.h>
#include <algorithm>

typedef double real;

#define DELTA 1e-6
#define EPS 1e-9
#define SIZE 2096

int n;
int px[2010], py[2010];
real cx, cy;
real angle[2010];
int adr[2010];
int cross[2*SIZE+1];
int answer;
double pa, pb, pc;

real a11, a12, a21, a22, b1, b2, det, detu, detv;
inline bool crossLines(real x1, real y1, real x2, real y2, real x3, real y3, real x4, real y4) {
	a11 = x2-x1;
	a12 = x3-x4;
	a21 = y2-y1;
	a22 = y3-y4;
	b1  = x3-x1;
	b2  = y3-y1;
	det  = a11*a22 - a12*a21;
	detu = b1 *a22 - a12*b2 ;
	detv = a11*b2  - b1 *a21;
	if (det < 0) {
		det = -det;
		detu = -detu;
		detv = -detv;
	}
//	return ((detu>0) && (detu<det) && (detv>0) && (detv<det));
	return ((detu>0) && (detu<det));
}

bool cmpPoints(int a, int b) {
     return (angle[a] < angle[b]);
}

inline void Xor(int a) {
	cross[a] = !cross[a];
}

int findMaxLine() {
	int res = 0;
	int cr = 0;
	for (int i = 0; i<=n; i++) {
		if (cross[i])
			cr++;
		else {
			if (cr > res)
				res = cr;
			cr = 0;
		}
	}
	return res;
}

void ClearCrosses() {
     memset(cross, 0, (n+1)*sizeof(int));
}

int main(int argc, char **argv) {
	freopen("polyline.in", "r", stdin);
	freopen("polyline.out", "w", stdout);
	int i, j, k;
	scanf("%d", &n);
	n--;
	for (i = 0; i<=n; i++)
		scanf("%d%d", px+i, py+i);
	for (i = 1; i<=2*n; i++) {
		int done;
		for (j = 0; j<=n; j++)
			adr[j] = j;
		if (i<=n) {
			cx = px[i] + (px[i-1]-px[i]) * DELTA;
			cy = py[i] + (py[i-1]-py[i]) * DELTA;
			done = i-1;
		}
		else {
			cx = px[i-n-1] + (px[i-n]-px[i-n-1]) * DELTA;
			cy = py[i-n-1] + (py[i-n]-py[i-n-1]) * DELTA;
			done = i-n-1;
		}
		for (j = 0; j<=n; j++) {
			angle[j] = atan2(py[j]-cy, px[j]-cx);
                        if (angle[j] < 0) angle[j] += M_PI;
                }

		std::sort(adr, adr+n+1, cmpPoints);
                ClearCrosses();
		for (j = 0; j<n; j++) {
			if (j != done) {
				if (crossLines(px[j], py[j], px[j+1], py[j+1], cx, cy, cx+1000.0, cy))
					Xor(j);
			}
			else
				Xor(j);
		}
		double last = angle[adr[n]] - M_PI;
		for (j = 0; j<n; j++) {
			if (angle[adr[j]]-last > EPS) {
				int tr = findMaxLine();
				real tang = (angle[adr[j]] + last) / 2.0;
				if (tr > answer) {
					answer = tr;
					pa = sin(tang)*1024.0;
					pb = -cos(tang)*1024.0;
					pc = (-(cx*sin(tang) - cy*cos(tang)))*1024.0;
				}
			}
			if (adr[j]>0)
				if (adr[j]-1 != done)
					Xor(adr[j]-1);
			if (adr[j]<n)
				if (adr[j] != done)
					Xor(adr[j]);
			last = angle[adr[j]];
		}
	}
	printf("%0.20lf\n%0.20lf\n%0.20lf", pa, pb, pc);
//	printf("    (%d)", answer);
	return 0;
}
