#include <cstdio>
#include <queue>
#include <memory.h>
#include <cstdlib>

#define maxn 11000

using namespace std;

struct pos{
	long x;
	char a,b;
	pos(){x=0,a=0,b=0;}
	pos(long xx,char aa,char bb){x=xx,a=aa,b=bb;}
};

char c[maxn];
long d[maxn]['h'-'a'+2]['h'-'a'+2];
long cnt[maxn]['h'-'a'+2]['h'-'a'+2];
queue<pos> q;
long l,r,n;

inline long go_left(long x,long l)
{
	x-=l;
	if(x<0) x+=n;
	return x;
}

inline long go_right(long x,long l)
{
	x+=l;
	if(x>=n) x-=n;
	return x;
}

void save(long x)
{
	printf("%d\n",x);
	fclose(stdout);
	exit(0);
}

int main()
{
	freopen("strgame.in","r",stdin);
	scanf("%s%d%d",c,&l,&r);
	fclose(stdin);
	n=0;
	while(c[n]!=0) n++;
	long w;
	for(long i=0;i<n;i++)
		for(char j='a';j<='i';j++){
			if((j!='i')&&(c[i]==j)) continue;
			for(char k='a';k<='i';k++){
				if(((j!='i')&&(c[i]==j))||((k!='i')&&(c[i]==k))||((j!='i')&&(j==k))){
					d[i][j][k]=-10; continue;
				}
				d[i][j][k]=-1;
				cnt[i][j][k]=0;
				for(long t=1;t<=l;t++){
					w=go_left(i,t);
					if((c[w]==c[i])||(c[w]==j)||(c[w]==k)) continue;
					cnt[i][j][k]++;
				}
				for(long t=1;t<=r;t++){
					w=go_right(i,t);
					if((c[w]==c[i])||(c[w]==j)||(c[w]==k)) continue;
					cnt[i][j][k]++;
				}
				if(cnt[i][j][k]==0){ 
        			d[i][j][k]=0;
		                q.push(pos(i,j,k));
/*				printf("Pushing %d %c %c\n",i,j,k);*/
                	}
		}
      }
	pos p;
	long x,rr,i;
	char a,b,pp;
	while(!q.empty()){
		p=q.front();
		q.pop();
		if((p.x==0)&&(p.a=='i')&&(p.b=='i')) break;
		x=p.x,a=p.a,b=p.b;
		rr=d[x][a][b];
		i=x;
/*		printf("(%d,%c,%c) is %s\n",x,a,b,(d[x][a][b]%2) ? "win":"lose");*/
		if(d[x][a][b]%2==0){
/*			if((x==3)&&(a=='b')&&(b=='a')) printf("Working on it, l=%d,r=%d\n",l,r);*/
			for(long t=1;t<=r;t++){
				w=go_left(i,t);
				if(c[w]!=a) continue;
				for(pp='a';pp<='i';pp++){
					if(!((pp=='i')||((pp!=a)&&(pp!=b)&&(pp!=c[x])))) continue;
					if(d[w][b][pp]==-1){
/*						if((w==6)&&(b=='c')&&(pp=='b')) printf("!!!Went from %d %c %c!!!\n",x,a,b);*/
						d[w][b][pp]=rr+1;
                				q.push(pos(w,b,pp));
					}	
				}
			}
			for(long t=1;t<=l;t++){
				w=go_right(i,t);
/*				if((x==3)&&(a=='b')&&(b=='a')) printf("Trying to go into %d\n",w);*/
				if(c[w]!=a) continue;
				for(pp='a';pp<='i';pp++){
					if(!((pp=='i')||((pp!=a)&&(pp!=b)&&(pp!=c[x])))) continue;
					if(d[w][b][pp]==-1){
/*						if((x==3)&&(a=='b')&&(b=='a')&&(w==5)&&(pp='i')) printf("Now update %c,%d\n",pp,rr+1);*/
/*						if((w==6)&&(b=='c')&&(pp=='b')) printf("!!!Went from %d %c %c!!!\n",x,a,b);*/
						d[w][b][pp]=rr+1;
				                q.push(pos(w,b,pp));
			               }	
				}
			}
		} else{
			for(long t=1;t<=r;t++){
				w=go_left(i,t);
				if(c[w]!=a) continue;
				for(pp='a';pp<='i';pp++){
					if(!((pp=='i')||((pp!=a)&&(pp!=b)&&(pp!=c[x])))) continue;
					cnt[w][b][pp]--;
					if((d[w][b][pp]==-1)&&(cnt[w][b][pp]==0)){
						d[w][b][pp]=rr+1;
                        q.push(pos(w,b,pp));
                    }	
				}
			}
			for(long t=1;t<=l;t++){
				w=go_right(i,t);
				if(c[w]!=a) continue;
				for(pp='a';pp<='i';pp++){
					if(!((pp=='i')||((pp!=a)&&(pp!=b)&&(pp!=c[x])))) continue;
					cnt[w][b][pp]--;
					if((d[w][b][pp]==-1)&&(cnt[w][b][pp]==0))
						d[w][b][pp]=rr+1,q.push(pos(w,b,pp));
				}
			}
		}
	}
	freopen("strgame.out","w",stdout);
	if(d[0]['i']['i']<0){
		printf("DRAW\n");
	} else
	if(d[0]['i']['i']%2==0){
		printf("LOSE\n%d\n",d[0]['i']['i']);
	} else{
		printf("WIN\n%d\n",d[0]['i']['i']);
				for(long t=1;t<=l;t++){
					w=go_left(0,t);
					if(c[w]==c[0]) continue;
					if((d[w][c[0]]['i']>=0)&&(d[w][c[0]]['i']%2==0)) save(-t);
				}
				for(long t=1;t<=r;t++){
					w=go_right(0,t);
					if(c[w]==c[0]) continue;
					if((d[w][c[0]]['i']>=0)&&(d[w][c[0]]['i']%2==0)) save(t);
				}
	}
	fclose(stdout);
	return 0;
}
