program apas;

const eps = 1e-12;

type integer = longint;

var m, n, k, l, np, nj, i, j, t, x : longint;
    p   : array [1..7000] of longint;
    lk  : array [1..7000, 1..256] of longint;
    jm  : array [1..256] of byte;
    jg  : array [0..255] of boolean;
    dp  : array [0..1, 1..7000] of extended;
    dh  : array [1..100, 1..7000] of longint;
    a   : array [1..100, 1..8] of extended;
    c   : array [1..256] of extended;
    ans : array [1..100] of integer;

procedure go(y, x : longint);
var i : integer;
begin
   if y <= m then begin
      go(y+1, x);
      for i := 1 to l-1 do
         go(y+k, x+(1 shl ((l-1-i)*m+y-1)));
   end else begin
      inc(np);
      p[np] := x;
   end;
end;

procedure gj(y, x : integer);
begin
   if y <= m then begin
      gj(y+1, x);
      gj(y+k, x+1 shl (y-1));
   end else begin
      inc(nj);
      jm[nj] := x;
      jg[x] := true;
   end;
end;

procedure Sort(l, r : integer);
var i, j, x, y : integer;
begin
   i := l; j := r; x := p[l+random(r-l+1)];
   repeat
      while p[i] < x do inc(i);
      while p[j] > x do dec(j);
      if i <= j then begin
         y := p[i]; p[i] := p[j]; p[j] := y;
         inc(i); dec(j);
      end;
   until i > j;
   if i < r then Sort(i, r);
   if j > l then Sort(l, j);
end;

function find(l, r, x : integer) : integer;
begin
   if l = r then begin
      find := l; exit;
   end;
   if p[(l+r) div 2] < x then
      find := find((l+r) div 2+1, r, x)
   else
      find := find(l, (l+r) div 2, x);
end;

procedure GenLinks;
var i, t, j, r : integer;
begin
   for i := 1 to np do begin
      r := 0; t := p[i];
      for j := 1 to l-1 do begin
         r := r or (t and (1 shl m - 1));
         t := t shr m;
      end;
      t := p[i] and (1 shl ((l-2)*m) - 1);
      t := t shl m;
      for j := 1 to nj do
         if ((jm[j] and r) = 0) and (jg[jm[j] or r]) then
            lk[i][j] := find(1, np, t+jm[j])
         else
            lk[i][j] := 0;
   end;
end;

begin
   randseed := 8751;
   assign(Input, 'sprats.in');
   reset(Input);
   assign(Output, 'sprats.out');
   rewrite(Output);

   read(m, n, k, l);

   np := 0;
   go(1, 0);
   fillchar(jg, sizeof(jg), 0);
   gj(1, 0);
   Sort(1, np);
   GenLinks;

   for i := 1 to n do
      for j := 1 to m do read(a[i][j]);

   for i := 1 to np do dp[0][i] := 0;
   dp[0][1] := 1;

   t := 1;
   for i := 1 to n do begin
      for j := 1 to np do dp[t][j] := 0;

      for j := 1 to nj do begin
         c[j] := 0;
         for x := 0 to m-1 do
            if (jm[j] shr x) mod 2 = 1 then
               c[j] := c[j]+a[i][x+1];
      end;
      for j := 1 to np do
         for x := 1 to nj do
            if lk[j][x] > 0 then
               if dp[1-t][j]*c[x]-dp[t][lk[j][x]] > eps then begin
                  dp[t][lk[j][x]] := dp[1-t][j]*c[x];
                  dh[i][lk[j][x]] := j shl 8 + jm[x];
               end;
{
      writeln(i);
      for j := 1 to np do begin
         for x := 0 to m-1 do write((p[j] shr x) mod 2);
         writeln(' ', dp[t][j]:0:4);
      end;
}
      t := 1-t;
   end;
   t := 1-t;
   x := 1;
   for i := 2 to np do
      if dp[t][i]-dp[t][x] > eps then x := i;

   if dp[t][x] < eps then begin
      writeln('IMPOSSIBLE');
      close(Output);
      halt(0);
   end;
   for i := n downto 1 do begin
      ans[i] := dh[i][x] and 255;
      x := dh[i][x] shr 8;
   end;
   for i := 1 to n do begin
      for j := 1 to m do begin
         write(ans[i] mod 2, ' '); ans[i] := ans[i] div 2;
      end;
      writeln;
   end; 

   close(Input);
   close(Output);
end.