{$R+}
uses
  SysUtils, Windows, Math;

const namein='polyline.in';
      nameout='polyline.out';
      NMax=2100;
      RMax=3000;
      TLRes=1800;
type
 integer=longint;
 TCord=record
   x,y:integer
  end;
 TLine=record
   a,b,c:real
  end;
 TSet=array [1..NMax] of TCord;
 TVect=array [1..NMax] of boolean;
var p:TSet;
    n,Sol,tt:integer;
    Res:TLine;
    z:TVect;

procedure Init;
var i:integer;
begin
 tt:=gettickcount;
 assign(input,namein);
 reset(input);
 readln(n);
 for i:=1 to n do
  readln(p[i].x,p[i].y);
 close(input)
end;

procedure GetL(const p1,p2:TCord; var l:TLine);
begin
 with l do begin
   a:=p2.y-p1.y;
   b:=p1.x-p2.x;
   c:=p2.x*(p1.y-p2.y)+p1.y*(p2.x+p1.x)
  end
end;

function CheckTLE:boolean;
begin
 CheckTLE:=(gettickcount-tt)>TLRes
end;

procedure Solve;
var v,w:TCord;
    xx,yy,tt,t,i,lx,ly,rx,ry,XMax,YMax:integer;
    l:TLine;
begin
 RandSeed:=(n*1273482) mod 612677;
 with v do begin
   x:=0;
   y:=0;
  end;
 Sol:=0;
 lx:=maxint; rx:=-lx;
 ly:=maxint; ry:=-ly;
 for i:=1 to n do begin
   lx:=min(lx,p[i].x);
   ly:=min(ly,p[i].y);
   rx:=max(lx,p[i].x);
   ry:=max(ry,p[i].y)
  end;
 if n<30 then begin
   XMax:=800;
   YMax:=800;
  end
 else
  if n<150 then begin
    XMax:=200;
    YMax:=200
   end
  else
   if n<500 then begin
     XMax:=100;
     YMax:=100
    end
   else begin
     XMax:=30;
     YMax:=30
    end;
 for xx:=-XMax to XMax do
  for yy:=-YMax to YMax do begin
    with w do begin
       x:=xx;
       y:=yy
      end;
    GetL(v,w,l);
    for i:=1 to n-1 do
     z[i]:=((l.a*p[i].x+l.b*p[i].y+l.c)*
            (l.a*p[i+1].x+l.b*p[i+1].y+l.c))<0;
    tt:=0; t:=0;
    for i:=1 to n-1 do
     if not z[i] then  begin
        t:=max(t,tt);
        tt:=0
       end
     else inc(tt);
    t:=max(t,tt);
    if t>Sol then begin
      Sol:=t;
      Res:=l
     end
   end;
 while not CheckTLE do begin
   xx:=random(RMax);
   for i:=1 to 100 do begin
     yy:=random(RMax);
     with w do begin
       x:=xx;
       y:=yy
      end
    end;
   GetL(v,w,l);
   for i:=1 to n-1 do
    z[i]:=((l.a*p[i].x+l.b*p[i].y+l.c)*
           (l.a*p[i+1].x+l.b*p[i+1].y+l.c))<0;
   tt:=0; t:=0;
   for i:=1 to n-1 do
    if not z[i] then  begin
       t:=max(t,tt);
       tt:=0
      end
    else inc(tt);
   t:=max(t,tt);
   if t>Sol then begin
     Sol:=t;
     Res:=l
    end
  end;
end;

procedure Done;
begin
 assign(output,nameout);
 rewrite(output);
 writeln(Res.a);
 writeln(Res.b);
 writeln(Res.c);
 writeln(Sol);
 close(output)
end;

begin
 Init;
 Solve;
 Done
end.
