type integer = longint;
const LEN = 1000.0;
const MAXN = 220;
const MAXIMUM = 1000000.0;
const eps = 1e-8;
	  eps2 = 1e-6;
var n : integer;
	px, py : array[1..2100] of extended;

procedure Load;
var i : integer;
begin
	read(n);
	for i := 1 to n do begin
		read(px[i], py[i]);
	end;
end;

var gcnt, max : integer;
	ma, mb, mc : extended;

procedure MakeLine(x1, y1, x2, y2 : extended; var a, b, c : extended);
begin
	a := y1 - y2;
	b := x2 - x1;
	c := - a * x1 - b * y1;
end;

function VSign(v1x, v1y, v2x, v2y : extended) : integer;
var vct : extended;
begin
	vct := v1x * v2y - v1y * v2x;
	if vct < -eps then VSign := -1
	else if vct > eps then VSign := 1
	else VSign := 0;
end;

var res, was : array[1..2001] of integer;

function InterLineOtr(a, b, c, x1, y1, x2, y2 : extended) : boolean;
var dd1, dd2 : extended;
begin
	dd1 := a * x1 + b * y1 + c;
	dd2 := a * x2 + b * y2 + c;
	if (dd1 * dd2 < -eps) then InterLineOtr := true
	else InterLineOtr := false;
end;

procedure CheckLine(a, b, c: extended);
var i : integer;
begin
	inc(gcnt);
	for i := 1 to n - 1 do begin	
		if InterLineOtr(a, b, c, px[i], py[i], px[i + 1], py[i + 1]) then was[i] := gcnt;
	end;
	res[n + 1] := 0;
	for i := n downto 1 do begin
		if was[i] <> gcnt then res[i] := 0
		else res[i] := res[i + 1] + 1;
	end;
	for i := 1 to n do begin
		if res[i] > max then begin
			max := res[i];
			ma := a;
			mb := b;
			mc := c;
		end;
	end;
end;

procedure SolveCubic;
var i, j, bdir, cdir, ndir : integer;
	vx, vy, vcx, vcy, vnx, vny, x1, y1, x2, y2, x3, y3, a, b, c, t : extended;
begin
	gcnt := 0;
	max := 0;
	for i := 1 to n - 1 do begin
		MakeLine(px[i], py[i], px[i + 1], py[i + 1], a, b, c);
		t := b;
		b := a;
		a := -t;
		CheckLine(a, b, c);			
	end; 
	for i := 1 to n do begin
		for j := i + 1 to n do begin
			MakeLine(px[i], py[i], px[j], py[j], a, b, c);
			CheckLine(a, b, c + eps2);
			CheckLine(a, b, c - eps2);
		end;
	end;
	for i := 1 to n - 2 do begin
		vcx := px[i + 2] - px[i];
		vcy := py[i + 2] - py[i];
		vnx := px[i + 1] - px[i];
		vny := py[i + 1] - py[i];
		j := i + 3;
		cdir := VSign(vcx, vcy, vnx, vny);
		ndir := VSign(vnx, vny, vcx, vcy);
		bdir := VSign(vcx, vcy, vnx, vny);
		while (j <= n) and (VSign(vcx, vcy, vnx, vny) = bdir) do begin
		    if (j - i) mod 2 = 0 then begin
		    	vx := px[j] - px[i];
		    	vy := py[j] - py[i];
		    	if VSign(vcx, vcy, vx, vy) = cdir then begin
		    		if VSign(vx, vy, vnx, vny) <> bdir then break;
		    		vcx := vx;
		    		vcy := vy;
		    	end;
		    end
		    else begin
			    vx := px[j] - px[i];
		    	vy := py[j] - py[i];
		    	if VSign(vnx, vny, vx, vy) = ndir then begin
					if VSign(vcx, vcy, vx, vy) <> bdir then break;
					vnx := vx;
					vny := vy;
		    	end;
		    end;
			inc(j);
		end;
		{}
		t := sqrt(vcx * vcx + vcy * vcy);
		x1 := px[i] + LEN * vcx;
		y1 := py[i] + LEN * vcy;
		x2 := px[i] + LEN * vnx;
		y2 := py[i] + LEN * vny;
		x3 := (x1 + x2) / 2;
		y3 := (y1 + y2) / 2;
		{}
		MakeLine(px[i], py[i], x3, y3, a, b, c);
		{}
		if (abs(a) > MAXIMUM) or (abs(b) > MAXIMUM) or (abs(c) > MAXIMUM) then begin
			a := a / MAXIMUM;
			b := b / MAXIMUM;
			c := c / MAXIMUM;
		end;
		{}
		CheckLine(a, b, c + eps2);
		CheckLine(a, b, c - eps2);
	end;
	writeln(ma : 0 : 15);
	writeln(mb : 0 : 15);
	writeln(mc : 0 : 15);
end;

procedure SolveQuadric;
var j, i, bdir, cdir, ndir : integer;
	vx, vy, t, vcx, vcy, vnx, vny, a, b, c, x1, y1, x2, y2, x3, y3 : extended;
begin
	max := 0;
	gcnt := 0;         
	for i := 1 to n - 1 do begin
		MakeLine(px[i], py[i], px[i + 1], py[i + 1], a, b, c);
		t := b;
		b := a;
		a := -t;
		CheckLine(a, b, c);			
	end;
	for i := 1 to n - 2 do begin
		vcx := px[i + 2] - px[i];
		vcy := py[i + 2] - py[i];
		vnx := px[i + 1] - px[i];
		vny := py[i + 1] - py[i];
		j := i + 3;
		cdir := VSign(vcx, vcy, vnx, vny);
		ndir := VSign(vnx, vny, vcx, vcy);
		bdir := VSign(vcx, vcy, vnx, vny);
		while (j <= n) and (VSign(vcx, vcy, vnx, vny) = bdir) do begin
		    if (j - i) mod 2 = 0 then begin
		    	vx := px[j] - px[i];
		    	vy := py[j] - py[i];
		    	if VSign(vcx, vcy, vx, vy) = cdir then begin
		    		if VSign(vx, vy, vnx, vny) <> bdir then break;
		    		vcx := vx;
		    		vcy := vy;
		    	end;
		    end
		    else begin
			    vx := px[j] - px[i];
		    	vy := py[j] - py[i];
		    	if VSign(vnx, vny, vx, vy) = ndir then begin
					if VSign(vcx, vcy, vx, vy) <> bdir then break;
					vnx := vx;
					vny := vy;
		    	end;
		    end;
			inc(j);
		end;
		{}
		t := sqrt(vcx * vcx + vcy * vcy);
		x1 := px[i] + LEN * vcx;
		y1 := py[i] + LEN * vcy;
		x2 := px[i] + LEN * vnx;
		y2 := py[i] + LEN * vny;
		x3 := (x1 + x2) / 2;
		y3 := (y1 + y2) / 2;
		{}
		MakeLine(px[i], py[i], x3, y3, a, b, c);
		{}
		if (abs(a) > MAXIMUM) or (abs(b) > MAXIMUM) or (abs(c) > MAXIMUM) then begin
			a := a / MAXIMUM;
			b := b / MAXIMUM;
			c := c / MAXIMUM;
		end;
		{}
		CheckLine(a, b, c + eps2);
		CheckLine(a, b, c - eps2);
	end;
	writeln(ma : 0 : 15);
	writeln(mb : 0 : 15);
	writeln(mc : 0 : 15);
end;


begin
	assign(input, 'polyline.in');
	assign(output, 'polyline.out');
	reset(input);
	rewrite(output);
	Load;
	if n <= MAXN then SolveCubic
	else SolveQuadric;
	close(input);
	close(output);
end.
