#include <stdio.h>
#include <math.h>
#include <time.h>

#define ABS(A) ((A) > 0 ? (A) : -(A))
#define MINI(A, B) ((A) < (B) ? (A) : (B))
#define MAXI(A, B) ((A) > (B) ? (A) : (B))

#define MAX 2010
#define SH 1e-2
#define EPS 1e-9

typedef long double dbl;

int Max = 1, K = 0, N, X[MAX], Y[MAX];
dbl A, B, C, XX[MAX], YY[MAX];

int main( void )
{
  int i, j, k, sum;
  dbl a, b, c, n, xx, yy;
  int a1, b1, c1;
  int start = clock();

  freopen("polyline.in", "rt", stdin);
  freopen("polyline.out", "wt", stdout);
  scanf("%d", &N);
  for (i = 0; i < N; i++)
    scanf("%d%d", &X[i], &Y[i]);
  A = Y[1] - Y[0], B = X[0] - X[1];
  C = -(a * (X[0] + X[1]) + b * (Y[0] + Y[1])) * 0.5;
  for (i = 0; i < N - 1; i++)
  {
    a = X[i + 1] - X[i], b = Y[i + 1] - Y[i];
    n = sqrt(a * a + b * b);
    a /= n, b /= n;
    XX[K] = X[i] + a * SH, YY[K++] = Y[i] + b * SH;
    XX[K] = X[i + 1] - a * SH, YY[K++] = Y[i + 1] - b * SH;
  }
  for (i = 0; i < K; i++)
    for (j = i + 1; j < K; j++)
    {
      a = YY[j] - YY[i], b = XX[i] - XX[j];
      n = sqrt(a * a + b * b);
      a /= n, b /= n;
      c = -(a * XX[i] + b * YY[i]);
      sum = 0;
      for (k = 1; k < N; k++)
      {
        a1 = Y[k] - Y[k - 1], b1 = X[k - 1] - X[k];
        c1 = -(X[k] * a1 + Y[k] * b1);
        n = a * b1 - a1 * b;
        if (ABS(n) < EPS)
          continue;
        xx = -(c * b1 - c1 * b) / n;
        yy = (c * a1 - c1 * a) / n;
        if (MINI(X[k], X[k - 1]) - EPS < xx && xx < MAXI(X[k], X[k - 1]) + EPS &&
            MINI(Y[k], Y[k - 1]) - EPS < yy && yy < MAXI(Y[k], Y[k - 1]) + EPS)
          if ((ABS(X[k] - xx) > EPS || ABS(Y[k] - yy) > EPS) &&
              (ABS(X[k - 1] - xx) > EPS || ABS(Y[k - 1] - yy) > EPS))
            sum++;
      }
      if (sum > Max)
        Max = sum, A = a, B = b, C = c;
    }
  printf("%.18Lf\n%.18Lf\n%.18Lf", A, B, C);
  fprintf(stderr, "%d\n", Max);
  fprintf(stderr, "x=%25.18Lf\n", -C / A);
  fprintf(stderr, "y=%25.18Lf\n", -C / B);
  return 0;
}
