#include <stdio.h>
#include <time.h>

#define m 2020
#define eps 1e-6

#define min(a, b) ((a) < (b) ? (a) : (b))
#define max(a, b) ((a) > (b) ? (a) : (b))

int n, x[m], y[m], be;
long double ba, bb, bc;

void check( long double x1, long double y1, long double x2, long double y2 )
{
  long double a, b, c, a2, b2, c2, xx, yy;
  int i, r;

  r = 0;
  a = y2 - y1, b = x1 - x2, c = -(a * x1 + b * y1);
  for (i = 0; i < n - 1; i++)
  {
    a2 = y[i + 1] - y[i], b2 = x[i] - x[i + 1], c2 = -(a2 * x[i] + b2 * y[i]);
    if (abs(a * b2 - a2 * b) < eps)
      continue;
    xx = (c2 * b - b2 * c) / (a * b2 - a2 * b);
    yy = (c * a2 - c2 * a) / (a * b2 - a2 * b);
    if (min(x1, x2) < xx + eps && xx - eps < max(x1, x2) &&
        min(y1, y2) < yy + eps && yy - eps < max(y1, y2))
      r++;
  }
  if (r > be)
    be = r, ba = a, bb = b, bc = c;
}

int main( void )
{
  int st, i, a, b;

  st = clock();
  freopen("polyline.in", "rt", stdin);
  freopen("polyline.out", "wt", stdout);
  scanf("%d", &n);
  for (i = 0; i < n; i++)
    scanf("%d%d", &x[i], &y[i]);
  if (n == 2)
  {
    printf("%d %d %d", 2 * (x[1] - x[0]), 2 * (y[1] - y[0]), -((x[1] - x[0]) * (x[0] + x[1]) + (y[1] - y[0]) * (y[0] + y[1])));
    return 0;
  }
  be = -1;
  ba = 1, bb = 0, bc = 0;
  while (clock() - st < 1.9 * CLOCKS_PER_SEC)
  {
    a = rand() % (n - 1), b = rand() % (n - 1);
    b += b >= a;
    check(x[a] * 0.5 + x[a + 1] * 0.5, y[a] * 0.5 + y[a + 1] * 0.5,
          x[b] * 0.5 + x[b + 1] * 0.5, y[b] * 0.5 + y[b + 1] * 0.5);
  }
  printf("%.15Lf %.15Lf %.15Lf", ba, bb, bc);
  return 0;
}
