#include <cstdio>
#include <algorithm>
#include <vector>
#include <math.h>

#define inf 1E20
#define eps 1E-12
#define pi 3.1415926535897932384626433832795
#define maxn 3000
#define delt 1E-4

using namespace std;

inline double sqr(double x)
{
	return x*x;
}

struct point{
	double x,y;
	long a,b;
	point(){x=0,y=0;}
	point(double xx,double yy){x=xx,y=yy;}
	point(double xx,double yy,long aa,long bb){x=xx,y=yy,a=aa,b=bb;}
	friend double operator*(point p1,point p2)
	{
		return p1.x*p2.y-p1.y*p2.x;
	}
	friend double operator&(point p1,point p2)
	{
		return p1.x*p2.x+p1.y*p2.y;
	}
	friend point operator-(point p1,point p2)
	{
		return point(p1.x-p2.x,p1.y-p2.y);
	}
	double mod()
	{
		return sqrt(sqr(x)+sqr(y));
	}
	void operator/=(double t)
	{
		x/=t,y/=t;
	}
	void write()
	{
		printf("%0.1lf %0.1lf\n",x,y);
	}
};

vector<point> v;
double rng[maxn],r[maxn][2],a,b,ta,tb;

long n;

pair<double,double> cross(long x,long y)
{
	double a1=r[x][0],b1=r[x][1];
	double a2=r[y][0],b2=r[y][1];
	if(a2<b1){
		if(a2<a1){
			if(b2<b1) return make_pair(inf,-inf);
			if(b1<b2) return make_pair(a1,b1);
			else return make_pair(a1,b2);
		} else{
			if(b1<b2) return make_pair(a2,b1);
			else return make_pair(a2,b2);
		}
	} else return make_pair(inf,-inf);
	
}

bool is_cross(long x,long y)
{
	pair<double,double> p=cross(x,y);
	return (p.first<p.second);
}


double angle(point p)
{
	p/=p.mod();
	double alf=p*point(1,0);
	alf=asin(alf);
	if((p&point(1,0))<0) alf=pi-alf;
	return alf;
}


int main()
{
	freopen("polyline.in","r",stdin);
	scanf("%d",&n);
	double x,y;
	for(long i=1;i<=n;i++){
		scanf("%lf%lf",&x,&y);
		v.push_back(point(x,y,i,i+1));
	}
	fclose(stdin);
/*	long pa;
	double alf;
	long ai,vl=-1; double alf;
	for(long i=0;i<n;i++){
		for(long j=0;j<n;j++){
			if(j==i) continue;
			rng[j]=angle(v[j]-v[i]);
		}
		a=-inf,b=inf;
		for(long j=i+1;j<n-1;j++){
			ta=rng[j],tb=rng[j+1];
			if(ta>tb) swap(ta,tb);
			a=max(a,ta),b=min(b,tb);
			r[j][0]=a,r[j][1]=b;
		}
		a=-inf,b=inf;
		for(long j=i-1;j>0;j--){
			ta=rng[j],tb=rng[j-1];
			if(ta>tb) swap(ta,tb);
			a=max(a,ta),b=min(b,tb);
			r[j][0]=a,r[j][1]=b;
		}
		r[i][0]=-inf,r[i][1]=inf;
		long lf=1,rg=i;
		while(lf<=i){
			while((rg<n)&&(is_cross(lf,rg))) rg++;
			rg--;
			if(rg-lf+1>vl){
				ai=i,vl=rg-lf+1;
				pair<double,double> p=cross(lf,rg);
				alf=(p.first+p.second)/2;
			}
		}
	}*/
	point p1,p2,pp1,pp2;
	long vl=-1;
	for(long i=0;i<n;i++)
		for(long j=i+1;j<n;j++){
			#define p v
			pp1=p[i],pp2=p[j];
			pp1=pp1-point(delt,delt),pp2=pp2-point(delt,delt);
			long nv=0,mx=0;
			for(long k=0;k<n-1;k++){
				if((fabs((p[k]-pp1)*(pp2-pp1))<eps)xor(fabs((pp2-pp1)*(p[k+1]-pp1))<eps)) nv=0; else
				if(((p[k]-pp1)*(pp2-pp1)>0)xor((pp2-pp1)*(p[k+1]-pp1)>0)) nv=0;
				else nv++;
				mx=max(mx,nv);
			}
			if(mx>vl) vl=mx,p1=pp1,p2=pp2;
			pp1=p[i],pp2=p[j];
			pp1=pp1-point(-delt,-delt),pp2=pp2-point(-delt,-delt);
			nv=0,mx=0;
			for(long k=0;k<n-1;k++){
				if((fabs((p[k]-pp1)*(pp2-pp1))<eps)xor(fabs((pp2-pp1)*(p[k+1]-pp1))<eps)) nv=0; else
				if(((p[k]-pp1)*(pp2-pp1)>0)xor((pp2-pp1)*(p[k+1]-pp1)>0)) nv=0;
				else nv++;
				mx=max(mx,nv);
			}
			if(mx>vl) vl=mx,p1=pp1,p2=pp2;
			#undef p
		}
	double a,b,c;
	a=p2.y-p1.y;
	b=p1.x-p2.x;
	c=-a*p1.x-b*p1.y;
	freopen("polyline.out","w",stdout);
	printf("%0.20lf %0.20lf %0.20lf\n",a,b,c);
	fclose(stdout);
	return 0;
}
