{$I-,Q-,R-,S-}
//{$I+,Q+,R+,S+}
program Temp;

uses
  SysUtils;
const
 in_f='polyline.in';
 out_f='polyline.out';
type
  int=longint;
  real=extended;
  bool=boolean;
  TPoint=record
    x,y:real;
  end;
  TLine=record
     a,b,c:real;
   end;
const
  maxN=2000;
  epsot=1e-3;
  eps=1e-9;
  tl=1.9/24/60/60;
var
  N:int;
  P:Array[1..maxN] of TPoint;
  ans:int;
  answer:TLine;

  ok:array[0..maxN+1] of bool;
  h:Array[1..maxN] of real;

  saw:array[1..maxN,1..maxN] of bool;

  begtime:real;

  kol:array[1..maxN] of int;
  pp:array[1..maxN,1..2] of TPoint;

function Make(const a,b:TPoint):TPoint;
begin
  Make.x:=b.x-a.x;
  Make.y:=b.y-a.y;
end;

function Sum(const a,b:TPoint):TPoint;
begin
  Sum.x:=a.x+b.x;
  Sum.y:=a.y+b.y;
end;

function Len(const V:TPoint):real;
begin
 Len:=sqrt(sqr(V.x)+sqr(v.y));
end;

procedure Norm(var V:TPoint; L:real);
 var
   K:real;
 begin
   K:=epsot/Len(V);
   v.x:=k*v.x;
   v.y:=k*v.y;
 end;


function Line(const p1,p2:TPoint):Tline;
 begin
   Line.a:=p2.y-p1.y;
   Line.b:=p1.x-p2.x;
   Line.c:=p1.y*p2.x-p1.x*p2.y;
 end;

function Less(const a,b:real):bool;
 begin
   Less:=(a-b)<-eps;
 end;

procedure TryLine(Ln:TLine);

procedure DoIt(k:int);
 begin
   if not ok[k-1] then
     h[k]:=Ln.a*p[k].x+Ln.b*p[k].y+Ln.c;
   if not ok[k+1] then
     h[k+1]:=Ln.a*p[k+1].x+Ln.b*p[k+1].y+Ln.c;
   ok[k]:=Less(h[k]*h[k+1],0);
 end;

procedure Check(a,b:int);
 var
  L,R:int;
 begin
   if b-a+1>ans then
     begin
       L:=(a+b) shr 1;
       R:=L;

       DoIt(L);
       while (L>a) and ok[L] do
         begin
           dec(L);
           DoIt(L);
         end;
       if ok[L] then dec(L);
       Check(a,L-1);

       if b-L<=ans then exit;

       while (R<b) and ok[R] do
         begin
           inc(r);
           DoIt(r);
         end;
       if ok[R] then inc(R);
       Check(R+1,b);

       if R-L-1>ans then
         begin
           ans:=R-L-1;
           answer:=Ln;
         end;
     end;
 end;

 begin
   fillchar(ok,sizeof(ok),0);
   Check(1,N-1);
 end;

procedure Run;
 var
   i,j,k,l:int;
   V:TPoint;
 begin
   RandSeed:=239017+N;
   Ans:=0;
   fillchar(saw,sizeof(saw),0);

   for i := 1 to N do
     begin
       kol[i]:=0;
       if i<>N then
         begin
           V:=Make(p[i],p[i+1]);
           Norm(V,epsot);
           inc(kol[i]);
           pp[i,kol[i]]:=Sum(p[i],V);
         end;
       if i<>1 then
         begin
           V:=Make(p[i],p[i-1]);
           Norm(V,epsot);
           inc(kol[i]);
           pp[i,kol[i]]:=Sum(p[i],V);
         end;
     end;

   while now<begTime+tl do
     begin
       i:=random(N)+1;
       j:=random(N)+1;
       if not saw[i,j] then
         begin
           for k := 1 to kol[i] do
             for  l := 1 to kol[j] do
               TryLine(Line(pp[i,k],pp[j,l]));
           saw[i,j]:=true;
           saw[j,i]:=true;
         end;
    end;
  Writeln(answer.a:0:18,' ',answer.b:0:18,' ',answer.c:0:18);
 end;

procedure Init;
 var
   i:int;
 begin
   Read(N);
   for i := 1 to N do
     Read(p[i].x,p[i].y);
 end;

procedure OpenFiles;
 begin
  Assign(input,in_f);
  Reset(input);
  Assign(output,out_f);
  Rewrite(output);
 end;

procedure CloseFiles;
 begin
  Close(input);
  Close(output);
 end;

Begin
  begTime:=now;
  OpenFiles;
  Init;
  Run;
  CloseFiles;
End.
