#include <stdio.h>
#include <string.h>
#include <memory.h>
#include <time.h>

#define WORK_TIME 1600

int m, n, k, l;
double matr[8][110];

double answer;
bool best[8][110];

bool curr[8][110];
double csum[8];
int used[8][110];
bool solved;
int stime;
int cnt;

void Solve(int x, int y) {
	if ((cnt&255) == 0)
		if ((clock() - stime) * 1000 > WORK_TIME*CLOCKS_PER_SEC)
			return;
	cnt++;
	if (y==n) {
		double tr = 1.0;
		for (int i = 0; i<m; i++)
			tr *= csum[i];
		if (tr > answer) {
			solved = true;
			answer = tr;
			memcpy(best, curr, sizeof(best));
		}
		return;
	}
	int nx, ny;
	nx = x+1;
	if (nx==m) {
		nx = 0;
		ny = y+1;
	}
	else
		ny = y;

	Solve(nx, ny);
	if (used[x][y] > 0)
		return;
		
	curr[x][y] = true;
	csum[x] += matr[x][y];
	int i, j;
	for (i = -k+1; i<k; i++)
		if ((x+i >= 0) && (x+i < m))
			for (j = 0; j<l; j++)
				if (y+j < n)
					used[x+i][y+j]++;
	Solve(nx, ny);
	for (i = -k+1; i<k; i++)
		if ((x+i >= 0) && (x+i < m))
			for (j = 0; j<l; j++)
				if (y+j < n)
					used[x+i][y+j]--;
	csum[x] -= matr[x][y];
	curr[x][y] = false;
}

int main(int argc, char **argv) {
	freopen("sprats.in", "r", stdin);
	freopen("sprats.out", "w", stdout);
	scanf("%d%d%d%d", &m, &n, &k, &l);
	stime = clock();
	int i, j;
	for (i = 0; i<m; i++)
		for (j = 0; j<n; j++)
			scanf("%lf", &(matr[i][j]));
	Solve(0, 0);
	if (!solved)
		printf("IMPOSSIBLE");
	else {
		for (i = 0; i<m; i++) {
			for (j = 0; j<n; j++)
				printf("%d ", best[i][j]);
			printf("\n");
		}
	}
	return 0;
}
