const
        eps = 1e-6;
type
        Real = Extended;
        TPoint =
        record
          x, y : Real;
        end;
        TLine =
        record
          a, b, c : Real;
        end;
var
        p : Array[1 .. 2000] of TPoint;
        n : LongInt;

Procedure Init;
var
        i : LongInt;
begin
  ReadLn(n);
  for i := 1 to n do
    ReadLn(p[i].x, p[i].y);
end;

Procedure MakeLine(const a, b : TPoint; var l : TLine);
begin
  l.a := (a.y - b.y);
  l.b := (b.x - a.x);
  l.c := -(l.a * a.x + l.b * a.y);
  l.a := l.a + eps;
  l.c := l.c + (l.c + l.a * a.x + l.b * a.y + l.c + l.a * b.x + l.b * b.y) / 2;
end;

Function Intersect(const a, b : TPoint; const l : TLine) : Boolean;
begin
  Intersect := (l.a * a.x + l.b * a.y + l.c > 0) xor (l.a * b.x + l.b * b.y + l.c > 0);
end;

Procedure Solve;
var
        l, ll : TLine;
        i, j, r, rez : LongInt;
begin
  rez := 0;
  for i := 1 to n - 1 do
  begin
    MakeLine(p[i], p[i + 1], l);
    r := 0;
    for j := 1 to n - 1 do
      if Intersect(p[i], p[i + 1], l) then
        Inc(r);
    if r > rez then
    begin
      rez := r;
      ll := l;
    end;
  end;
  Write(ll.a : 0 : 30, ' ', ll.b : 0 : 30, ' ', ll.c : 0 : 30);
end;

Procedure Print;
begin
end;

begin
  Assign(input, 'polyline.in');
  Reset(input);
  Assign(output, 'polyline.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.