#include <stdio.h>
#include <string.h>
#include <vector>
#include <queue>
#include <time.h>

struct Pos {
	int p;
	char c1, c2;
};

typedef std::vector<Pos> pVect;
typedef pVect::iterator vIter;
typedef std::queue<Pos> pQueue;
#define WORK_TIME 1800
int stime;

int n, l, r;
char expr[10010];
pVect prevs;
int deg[10010][9][9];
int win[10010][9][9];
int dist[10010][9][9];
Pos father[10010][9][9];
pQueue q;

inline int shift(int a, int b) {
	a += b;
	a %= n;
	while (a<0) a += n;
	return a;
}

void readExpr() {
	fgets(expr, 10005, stdin);
	n = strlen(expr);
	while ((expr[n-1] == ' ') || (expr[n-1] == '\n'))
		n--;
	expr[n] = 0;
}

int main(int argc, char **argv) {
	freopen("strgame.in", "r", stdin);
	freopen("strgame.out", "w", stdout);
	stime = clock();
	int i, j, a, b;
	readExpr();
	scanf("%d%d", &l, &r);
	for (i = 0; i<n; i++) {
		Pos curr;
		curr.p = i;
		for (a = 0; a<=8; a++) {
			curr.c1 = a;
			for (b = 0; b<=8; b++) {
				curr.c2 = b;
				for (j = -l; j<=r; j++) {
					int rp = shift(i, j);
					if (expr[rp] == expr[i]) continue;
					if (expr[rp] == a + 'a'-1) continue;
					if (expr[rp] == b + 'a'-1) continue;
					if (j==0) continue;
					deg[i][a][b]++;
				}
			}
		}
	}
	memset(win, -1, sizeof(win));
	for (i = 0; i<n; i++)
		for (a = 0; a<=8; a++)
			for (b = 0; b<=8; b++)
				if (deg[i][a][b] == 0) {
					if (a==b) continue;
					if (expr[i] == a+'a'-1) continue;
					if (expr[i] == b+'a'-1) continue;
					win[i][a][b] = 0;
					dist[i][a][b] = 0;
					Pos curr;
					curr.p = i;  curr.c1 = a;  curr.c2 = b;
					q.push(curr);
				}
	prevs.reserve(10000);
	while (!q.empty()) {
		#define CIND curr.p][curr.c1][curr.c2
		#define ITIND it->p][it->c1][it->c2
		if ((clock()-stime)*1000 > WORK_TIME*CLOCKS_PER_SEC)
			break;
		Pos curr;
		curr = q.front();
		q.pop();
		prevs.resize(0);
		for (i = -r; i<=l; i++) {
			int rp = shift(curr.p, i);
			if (expr[rp] != curr.c1 + 'a'-1) continue;
				if (expr[rp]       == expr[curr.p]) continue;
				if (curr.c2+ 'a'-1 == expr[curr.p]) continue;
			for (a = 0; a<=8; a++) {
				if (a      + 'a'-1 == expr[curr.p]) continue;
				Pos prp;
				prp.p = rp;
				prp.c1 = curr.c2;
				prp.c2 = a;
				prevs.push_back(prp);
			}
		}
		for (vIter it = prevs.begin(); it != prevs.end(); it++) {
			if (win[ITIND] >= 0) continue;
			if (win[CIND] == 0) {
				win[ITIND] = 1;
				dist[ITIND] = dist[CIND] + 1;
				father[ITIND] = curr;
				q.push(*it);
			}
			else {
				deg[ITIND]--;
				if (deg[ITIND] == 0) {
					win[ITIND] = 0;
					dist[ITIND] = dist[CIND] + 1;
					q.push(*it);
				}
			}
		}
	}
/*	for (i = 0; i<n; i++)
		for (a = 0; a<=8; a++)
			for (b = 0; b<=8; b++) {
				printf("Pos %d %c %c : ", i, a+'a'-1, b+'a'-1);
				if (win[i][a][b] < 0)
					printf("D\n");
				if (win[i][a][b] == 0)
					printf("L %d\n", dist[i][a][b]);
				if (win[i][a][b] > 0)
					printf("W %d\n", dist[i][a][b]);
			}*/
	if (win[0][0][0] < 0) {
		printf("DRAW\n");
		return 0;
	}
	if (win[0][0][0] == 0)
		printf("LOSE\n");
	else
		printf("WIN\n");
	printf("%d\n", dist[0][0][0]);
	if (win[0][0][0] == 1) {
		Pos np = father[0][0][0];
		if (np.p <= r)
			printf("%d", np.p);
		else
			printf("%d", -(n - np.p));
	}
	return 0;
}
