{$I-,Q-,R-,S-}
const
        MaxN = 103;
        MaxM = 8;
        MaxL = 3;
        MaxMask = 81 * 81 - 1;
        MaxMax = 1000 * 1000 * 1000;
        eps = 1e-12;
type
        Real = Extended;
        TLong =
        record
          zn : Int64;
          step : Word; {zn * 10^(-step)}
        end;
        TMask = Array[1 .. MaxM] of Byte;
        Arr = Array[0 .. MaxMask] of TLong;
var
        tt, m, n, k, l, tek : LongInt;
        mas : Array[0 .. 1{ப}] of Arr;
        e : Array[1 .. MaxM] of TLong;
        f : Array[1 .. MaxM] of Boolean;
        rez : Array[1 .. MaxN, 0 .. MaxMask] of
        record
          e : Byte;
          pred : Word;
        end;
        mask : TMask;
        know : TLong;

Function ToN : Byte;
var
        i, r : Byte;
begin
  r := 0;
  for i := m downto 1 do
    r := r * 2 + Ord(f[i]);
  ToN := r;
end;

Procedure ReadChis;
var
        i, r : LongInt;
        q : Char;
begin
  r := 0;
  for i := 1 to m do
  begin
    Read(q);
    While q = ' ' do
      Read(q);
    if q <> '0' then
    begin
      e[i].step := 0;
      e[i].zn := 1;
      While (q <> ' ') and (not EoLn) do
        Read(q);
    end
    else
    begin
      e[i].step := 0;
      e[i].zn := 0;
      While (q <> ' ') and (not EoLn) do
      begin
        Read(q);
        if q in ['0' .. '9'] then
        begin
          Inc(e[i].step);
          e[i].zn := e[i].zn * 10 + Ord(q) - Ord('0');
        end;
        if e[i].step > r then
          r := e[i].step;
      end;
    end;
  end;
  ReadLn;
  for i := 1 to m do
    While e[i].step < r do
    begin
      Inc(e[i].step);
      e[i].zn := e[i].zn * 10;
    end;
end;

Procedure ToMask(a : Word; var mask : TMask);
var
        i  : LongInt;
begin
  for i := m downto 1 do
  begin
    mask[i] := a mod MaxL;
    a := a div MaxL;
  end;
end;

Procedure Init;
var
        i : LongInt;
begin
  ReadLn(m, n, k, l);
  Dec(l);
  FillChar(mas, SizeOf(mas), 0);
  for i := 0 to 1 do
    FillChar(mas[i], SizeOf(mas[i]), 0);
  mas[1][0].zn := 1;
  mas[1][0].step := 0;
end;

Procedure ToNumb(const mask : TMask; var r : Word);
var
        i : Byte;
begin
  r := 0;
  for i := 1 to m do
    r := r * 3 + mask[i];
end;

Function Obn(var a, b : TLong) : Boolean;
begin
  While a.step < b.step do
  begin
    Inc(a.step);
    a.zn := a.zn * 10;
  end;
  While b.step < a.step do
  begin
    Inc(b.step);
    b.zn := b.zn * 10;
  end;
  if a.zn < b.zn then
  begin
    a.zn := b.zn;
    Obn := True;
  end
  else
    Obn := False;
  While ((a.zn mod 10 = 0) and (a.step > 1)) or (a.zn > MaxMax) do
  begin
    a.zn := a.zn div 10;
    Dec(a.step);
  end;
end;

Procedure TRYTo;
var
        i : Word;
        j : Integer;
        s : TLong;
        my : TMask;
begin
  for i := 1 to m do
    if mask[i] <> 0 then
      my[i] := mask[i] - 1
    else
      my[i] := 0;
  s.step := e[1].step;
  s.zn := 0;
  for i := 1 to m do
    if f[i] then
    begin
      for j := i - k + 1 to i + k - 1 do
        if (j > 0) and (j <= m) then
          my[j] := l;
      s.zn := s.zn + e[i].zn;
    end;
  While ((s.zn mod 10 = 0) and (s.step > 1)) or (s.zn > MaxMax) do
  begin
    s.zn := s.zn div 10;
    Dec(s.step);
  end;
  Inc(s.step, know.step);
  s.zn := s.zn * know.zn;
  While ((s.zn mod 10 = 0) and (s.step > 1)) or (s.zn > MaxMax) do
  begin
    s.zn := s.zn div 10;
    Dec(s.step);
  end;
  TONumb(my, i);
  if Obn(mas[tek mod 2][i], s) then
  begin
    rez[tek - 1][i].e := ToN;
    ToNumb(mask, rez[tek - 1][i].pred);
  end;
end;

Procedure DFS(const pos : Byte);
begin
  if pos > m then
    TRYTo
  else
  begin
    if mask[pos] = 0 then
    begin
      f[pos] := True;
      DFS(pos + k);
    end;
    f[pos] := False;
    DFS(pos + 1);
  end;
end;

Procedure Solve;
var
        i, j : LongInt;
begin
  for i := 1 to n do
  begin
    tek := i + 1;
    ReadChis;
    FillChar(mas[tek mod 2], SizeOf(mas[tek mod 2]), 0);
    for j := 0 to MaxMask do
      if mas[i mod 2][j].zn <> 0 then
      begin
        ToMask(j, mask);
        know := mas[i mod 2][j];
        DFS(1);
      end;
  end;
end;

Procedure P(const n : Byte; const q : Word);
begin
  if n = 0 then
    Exit;
  P(n - 1, rez[n][q].pred);
  for tt := 0 to m - 1 do
    Write((rez[n][q].e shr tt) mod 2, ' ');
  WriteLn;
end;

Procedure Print;
var
        i, j, r, re : LongInt;
begin
  tek := tek mod 2;
  r := 1;
  for i := 0 to MaxMask do
    if mas[tek][i].step > r then
      r := mas[tek][i].step;
  re := 0;
  for i := 0 to MaxMask do
  begin
    While mas[tek][i].step < r do
    begin
      Inc(mas[tek][i].step);
      mas[tek][i].zn := mas[tek][i].zn * 10;
    end;
    if mas[tek][i].zn > mas[tek][re].zn then
      re := i;
  end;
  if mas[tek][re].zn = 0 then
    Write('IMPOSSIBLE')
  else
    P(n, re);
end;

Procedure GenTest;
var
        m, i, j : LongInt;
        ost, k : Real;
begin
  Assign(output, 'sprats.in');
  Rewrite(output);
  m := Random(8) + 1;
  WriteLn(m, ' 100 ', Random(m) + 1, ' ', Random(3) + 1);
  for i := 1 to 100 do
  begin
    ost := 1;
    for j := 1 to m - 1 do
    begin
      k := 2;
      While k > ost do
        k := Random;
      Write(k : 0 : 10, ' ');
      ost := ost - k;
    end;
    Write(ost : 0 : 10);
    WriteLn;
  end;
  Close(output);
end;

begin
  Assign(input, 'sprats.in');
  Reset(input);
  Assign(output, 'sprats.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
