#include <cstdio>
#include <algorithm>
#include <vector>
#include <map>
#include <memory.h>

#define maxn (long)110000
#define inf (double)1E100

using namespace std;

template<long max_el>
struct dsu{
	long a[max_el],r[max_el];
	dsu()
	{
		memset(a,0,sizeof(a));
		memset(r,0,sizeof(r));
	}
	long get(long x)
	{
		if(a[x]==0) return x;
		long t=get(a[x]);
		a[x]=t;
		return t;
	}
	long operator[](long x)
	{
		return get(x);
	}
	long merge(long x,long y)
	{
		x=get(x),y=get(y);
		if(r[x]>r[y]) a[y]=x; else
		if(r[x]<r[y]) a[x]=y; else
		a[y]=x,r[x]++;
		return get(x);
	}
};


struct grp{
	long n,l,r,c;
	double x;
	grp(){n=0,x=0,c=0,l=0,r=0;}
	grp(long nn,long cc,double xx){n=nn,x=xx,c=cc,l=nn,r=nn;}
	friend bool operator<(grp g1,grp g2)
	{
		return (g1.x<g2.x);
	}
};

struct pr{
	long x1,x2;
	double t;
	pr(){x1=0,x2=0,t=0;}
	pr(long xx1,long xx2,double tt){x1=xx1,x2=xx2,t=tt;}
	friend bool operator<(pr g1,pr g2)
	{
		return (g1.t<g2.t);
	}
};

map<pair<long,long>,long> w;

template<class T>
struct pr_queue{
	T a[maxn];
	long n;
	pr_queue(){n=0;}
	inline long size(){return n;}
	void heap_up(long x)
	{
		while((x>1)&&(a[x]<a[x/2])){
			swap(w[make_pair(a[x].x1,a[x].x2)],w[make_pair(a[x/2].x1,a[x/2].x2)]);
			swap(a[x],a[x/2]);
			x/=2;
		}
	}
	void heap_down(long x)
	{
		long t;
		while(1){
			t=x;
			if((2*x<=n)&&(a[2*x]<a[t])) t=2*x;
			if((2*x+1<=n)&&(a[2*x+1]<a[t])) t=2*x+1;
			if(t==x) break;
			swap(w[make_pair(a[x].x1,a[x].x2)],w[make_pair(a[t].x1,a[t].x2)]);
			swap(a[t],a[x]);
			x=t;
		}
	}
	void insert(T t)
	{
		a[++n]=t;
		/*!*/w[make_pair(t.x1,t.x2)]=n;
		heap_up(n);
	}
	inline T top()
	{
		return a[1];
	}
	inline bool empty()
	{
		return (n==0);
	}
	void pop()
	{
		swap(a[1],a[n]);
		/*!*/w[make_pair(a[n].x1,a[n].x2)]=-1;
		n--;
		heap_down(1);
	}
};

dsu<maxn> d;
pr_queue<pr> q;
vector<grp> v;
long n;
vector<pair<long,long> > u;
bool us[maxn];

double time(long x,long y)
{
	double t;
	if(v[y].c<=v[x].c) t=inf; else{
		double c1=v[x].c,c2=v[y].c;
		t=((v[y].x-v[x].x)*c1*c2)/(c2-c1);
	}
	return t;
}


int main()
{
	freopen("longpath.in","r",stdin);
	scanf("%d",&n);
	double x,t;
	long c;
	for(long i=1;i<=n;i++){
		scanf("%d%lf",&c,&x);
		v.push_back(grp(i,c,x));
	}
	fclose(stdin);
	sort(v.begin(),v.end());
	for(long i=0;i<n-1;i++)
	{
		pr p;
		p.x1=i,p.x2=i+1;
		v[i].n=i,v[i+1].n=i+1;
		v[i].l=i,v[i+1].l=i+1;
		v[i].r=i,v[i+1].r=i+1;
		if(v[i+1].c<=v[i].c) p.t=inf; else{
			double c1=v[i].c,c2=v[i+1].c;
			p.t=((v[i+1].x-v[i].x)*c1*c2)/(c2-c1);
		}
		q.insert(p);
		
	}
	pr p;
	long m1,m2,nv,ls,rs;
	while(!q.empty()){
		p=q.top(),q.pop();
		if(p.t>=inf/100) break;
		m1=p.x1,m2=p.x2;
		m1=d[m1],m2=d[m2];
		if(m1<m2) swap(m1,m2);
		ls=-1;
		if(m1-1>=0){
			ls=w[make_pair(m1-1,m1)];
		}
		rs=-1;
		if(m2+1<n){
			rs=w[make_pair(m2,m2+1)];
		}
		nv=d.merge(m1,m2);
		v[nv].l=min(v[m1].l,v[m2].l);
		v[nv].r=max(v[m1].r,v[m2].r);
		v[nv].c=v[m1].c+v[m2].c;
		if(ls!=-1){
			q.a[ls].x2=nv;
			q.a[ls].t=time(d[m1-1],d[m1]);
			q.heap_up(ls);
			q.heap_down(ls);
		}
		if(rs!=-1){
			q.a[rs].x2=nv;
			q.a[rs].t=time(d[m2],d[m2+1]);
			q.heap_up(rs);
			q.heap_down(rs);
		}
	}
	memset(us,0,sizeof(us));
	for(long i=0;i<v.size();i++){
		nv=d[i];
		if(us[nv]) continue;
		us[nv]=true;
		u.push_back(make_pair(nv,v[nv].c));
	}
	freopen("longpath.out","w",stdout);
	printf("%d\n",u.size());
	for(long i=0;i<u.size();i++)
		printf("%d ",u[i].second);
	printf("\n");
	fclose(stdout);
	return 0;
}
