type integer = longint;
const SIZE = 131072;
const MNOGO = $7F7F7F7F;
var n : integer;
	whr, b, a, num : array[1..100000] of integer;

procedure Qsort(be, en : integer);
var l, r, x, t : integer;
begin
	l := be;
	r := en;
	x := b[l + random(r - l + 1)];
	while l < r do begin
		while x > b[l] do inc(l);
		while x < b[r] do dec(r);
		if l <= r then begin
			t := b[l];
			b[l] := b[r];
			b[r] := t;
			inc(l);
			dec(r);
		end;
	end;
	if be < r then Qsort(be, r);
	if l < en then Qsort(l, en);
end;

function Find(num : integer) : integer;
var l, r, mid : integer;
begin
	l := 1;
	r := n;
	while l <= r do begin
		mid := (l + r) div 2;
		if b[mid] = num then begin
			Find := mid;
			exit;
		end;
		if b[mid] > num then r := mid - 1
		else l := mid + 1;
	end;
	Find := 0;
end;

procedure Load;
var i : integer;
begin
	read(n);
	for i := 1 to n do begin
		read(a[i]);
		b[i] := a[i];
	end;
	Qsort(1, n);
	for i := 1 to n do begin
		num[i] := Find(a[i]);
		whr[num[i]] := i;
	end;
end;

var ans : array[1..100000, 1..2] of integer;
	nans : integer;
	was : array[1..100000] of integer;
	otr : array[1..2 * SIZE, 1..2] of integer;
	val : array[1..2 * SIZE] of integer;

procedure GenT(ver : integer);
begin
	if ver >=SIZE then begin
		otr[ver, 1] := ver - SIZE + 1;
		otr[ver, 2] := otr[ver, 1];
		exit;
	end;
	GenT(2 * ver);
	GenT(2 * ver + 1);
	otr[ver, 1] := otr[2 * ver, 1];
	otr[ver, 2] := otr[2 * ver + 1, 2];
end;

procedure ReplaceTree(pos, vl : integer);
var cur : integer;
begin
	cur := pos + SIZE - 1;
	val[cur] := vl;
    cur := cur shr 1;
	while (cur <> 0) do begin
        val[cur] := val[cur shl 1];
        if val[cur shl 1 + 1] < val[cur] then val[cur] := val[cur shl 1 + 1];
		cur := cur shr 1;
	end;
end;

procedure AddAns(i, j : integer);
begin
	inc(nans);
	ans[nans, 1] := i;
	ans[nans, 2] := j;
end;

function GetMin(ver, be, en : integer) : integer;
var cres, cur, cl, cr : integer;
begin
	if otr[ver, 1] = otr[ver, 2] then begin	
		GetMin := val[ver];
		exit;
	end;
	if (otr[ver, 1] = be) and (otr[ver, 2] = en) then begin
		GetMin := val[ver];
		exit;
	end;
	{left}
	cres := MNOGO;
	if be <= otr[ver shl 1, 2] then begin
		cr := otr[ver shl 1, 2];
		if en < cr then cr := en;
		cur := GetMin(ver shl 1, be, cr);
		if cur < cres then cres := cur;
	end;
	if en >= otr[ver shl 1 + 1, 1] then begin
		cl := otr[ver shl 1 + 1, 1];
		if be > cl then cl := be;
		cur := GetMin(ver shl 1 + 1, cl, en);
		if cur < cres then cres := cur;
	end;
	GetMin := cres;
end;

var wpos, srt, wh, cnum : array[1..100000] of integer;
	len : integer;

procedure Qsort2(be, en : integer);
var l, r, x, t : integer;
begin
	l := be;
    r := en;
    x := srt[l + random(r - l + 1)];
    while l < r do begin
    	while x > srt[l] do inc(l);
        while x < srt[r] do dec(r);
        if l <= r then begin
        	t := srt[l];
            srt[l] := srt[r];
            srt[r] := t;
            inc(l);
            dec(r);
        end;
    end;
    if be < r then Qsort2(be, r);
    if l < en then Qsort2(l, en);
end;

procedure ProcessCycle;
var k, t, i, j, npos : integer;
begin
	Qsort2(1, len);
	for i := 1 to len do begin
		if i = 1 then npos := len
		else npos := wpos[srt[i]] - 1;
		j := wh[srt[i]];
		while j <> npos do begin
			k := wh[GetMin(1, j + 1, npos)];
			{swap}
			AddAns(cnum[j], cnum[k]);
			t := cnum[j];
			cnum[j] := cnum[k];
			cnum[k] := t;
			wh[cnum[j]] := j;
			wh[cnum[k]] := k;
			j := k;
            {tree update}
            ReplaceTree(j, cnum[j]);
            ReplaceTree(k, cnum[k]);
		end;
	end;
end;

procedure Solve;
var i, cur : integer;
begin
	fillchar(was, sizeof(was), 0);
	nans := 0;
	for i := 1 to n do begin
		if was[i] = 1 then continue;
		len := 1;
		cnum[1] := i;
        srt[1] := i;
		wh[i] := 1;
        wpos[i] := 1;
		cur := whr[i];
		while cur <> i do begin
			inc(len);
			cnum[len] := cur;
            srt[len] := cur;
			wh[cur] := len;
            wpos[cur] := len;
			ReplaceTree(len, cur);
			was[cur] := 1;
			cur := whr[cur];
		end;
		ProcessCycle;
	end;
end;

procedure Save;
var i : integer;
begin
	writeln(nans);
	for i := 1 to nans do begin
		writeln(b[ans[i, 1]], ' ', b[ans[i, 2]]);

	end;
end;

var nt, it : integer;

begin
	assign(input, 'sort.in');
	assign(output, 'sort.out');
	reset(input);
	rewrite(output);
    randseed := 875;
	GenT(1);
	fillchar(val, sizeof(val), $7F);
	read(nt);
	for it := 1 to nt do begin
		Load;
		Solve;
		Save;
	end;
	close(input);
	close(output);
end.
