const
        MaxN = 100000;
var
        t, n, s, tmp : LongInt;
        m, p, k : Array[1 .. MaxN] of LongInt;

Procedure Swap(var a, b : LongInt);
var
        c : LongInt;
begin
  c := a;
  a := b;
  b := c;
end;

Procedure QSort(const l, r : LongInt);
var
        i, j, x : LongInt;
begin
  i := l;
  j := r;
  x := m[(l + r) div 2];
  repeat
    While m[i] < x do
      Inc(i);
    While m[j] > x do
      Dec(j);
    if i <= j then
    begin
      Swap(m[i], m[j]);
      Swap(p[i], p[j]);
      Inc(i);
      Dec(j);
    end;
  until i > j;
  if l < j then
    QSort(l, j);
  if i < r then
    QSort(i, r);
end;

Procedure Init;
var
        i : LongInt;
begin
  ReadLn(n);
  for i := 1 to n do
  begin
    Read(m[i]);
    p[i] := i;
  end;
  for i := 1 to n - 1 do
    if Random(3) = 0 then
    begin
      Swap(m[i], m[i + 1]);
      Swap(p[i], p[i + 1]);
    end;
  QSort(1, n);
end;

Procedure DFS(u, s : Word);
begin
  While k[u] = 0 do
  begin
    k[u] := s;
    u := p[u];
  end;
end;

Function Cycle(const i : LongInt) : Boolean;
var
        j : LongInt;
begin
  for j := i + 1 to n do
    if k[i] = k[j] then
    begin
      Cycle := True;
      Swap(p[i], p[j]);
      WriteLn(m[i], ' ', m[j]);
      tmp := j;
      While k[tmp] <> s do
      begin
        k[tmp] := s;
        tmp := p[tmp];
      end;
      Inc(s);
      Exit;
    end;
  Cycle := False;
end;

Procedure Solve;
var
        i, rez : LongInt;
begin
  s := 1;
  rez := n;
  FillChar(k, SizeOf(k), 0);
  for i := 1 to n do
    if k[i] = 0 then
    begin
      Dec(rez);
      DFS(i, s);
      Inc(s);
    end;
  WriteLn(rez);
  for i := 1 to n do
    While Cycle(i) do;
end;

Procedure Print;
begin
end;

begin
  RandSeed := Ord('I') + Ord('N') + Ord('T') + Ord('E') + Ord('L') + Ord('L') + Ord('E') + Ord('C') + Ord('T') + Ord('U') + Ord('A') + Ord('L');
  Assign(input, 'sort.in');
  Reset(input);
  Assign(output, 'sort.out');
  Rewrite(output);
  ReadLn(t);
  While t <> 0 do
  begin
    Dec(t);
    Init;
    Solve;
    Print;
  end;
  Close(input);
  Close(output);
end.