{$I-,Q-,R-,S-}
//{$I+,Q+,R+,S+}
program Temp;

uses
  Math;
const
 in_f='longpath.in';
 out_f='longpath.out';
type
  int=longint;
  real=extended;
  bool=boolean;
  PGroup=^TGroup;
  PTree=^TTree;
  TGroup=record
    writen:bool;
    k:int;
    x,t:real;
    L,R:PTree;
    end;
  TTree=record
      parent:PTree;
      min:real;
      Left:bool;
      case list:bool of
        false:
          (L,R:PTree);
        true:
          (Lg,Rg:PGroup);
    end;
const
  maxN=100000+10;
  inf=100000;
var
  N:int;
  grA:array[1..maxN] of TGroup;
  trA:array[1..2*maxN] of TTree;
  uk:int;
  root:PTree;

procedure UpdateNotList(p:PTree);
 begin
  if p^.L^.min=-1 then
    p^.Left:=false
  else
  if p^.R^.min=-1 then
    p^.Left:=true
  else
    if p^.L^.min<p^.R^.min then
      p^.Left:=true
    else
      p^.Left:=false;
  if p^.Left then
    p^.min:=p^.L^.min
  else
    p^.min:=p^.R^.min
end;

procedure UpdateList(p:PTree);
 begin
   if P^.Lg^.k<P^.Rg^.k then
     begin
       if p^.Lg^.t>p^.Rg^.t then
         begin
           p^.Rg^.x:= p^.Rg^.x + (p^.Lg^.t-p^.Rg^.t)/p^.Rg^.k;
           p^.Rg^.t:=p^.Lg^.t;
         end
       else if p^.Lg^.t<p^.Rg^.t then
         begin
           p^.Lg^.x:= p^.Lg^.x + (p^.Rg^.t-p^.Lg^.t)/p^.Lg^.k;
           p^.Lg^.t:=p^.Rg^.t;
         end;
       p^.min:=p^.Lg^.t+(p^.Rg^.x-p^.Lg^.x)/(1/p^.Lg^.k-1/p^.Rg^.k);
     end
   else
     p^.min:=-1;
 end;

procedure UpdateFromList(P:PTree);
 var
   cur:PTree;
 begin
   cur:=p^.parent;
   while cur<>nil do
     begin
       UpdateNotList(cur);
       cur:=cur^.parent;
     end;
 end;

procedure MergeFrom(P:PTree);
 begin
   if P^.list then
     begin
       p^.Lg^.x:=p^.Lg^.x+(p^.min-p^.Lg^.t)/p^.Lg^.k;
       p^.Lg^.t:=p^.min;
       inc(p^.Lg^.k,p^.Rg^.k);
       p^.Lg^.R:=p^.Rg^.R;
       if p^.Lg^.R<>nil then
         p^.Lg^.R^.Lg:=p^.Lg;
       if p^.Lg^.L<>nil then
         UpdateList(p^.Lg^.L);
       if p^.Lg^.R<>nil then
         UpdateList(p^.Lg^.R);
       p^.min:=-1;
       UpdateFromList(p);
       if p^.Lg^.L<>nil then
         UpdateFromList(p^.Lg^.L);
       if p^.Lg^.R<>nil then
         UpdateFromList(p^.Lg^.R);
       p^.Lg:=nil;
       p^.Rg:=nil;
     end
   else
     begin
       if p^.Left then
         MergeFrom(p^.L)
       else
         MergeFrom(p^.R);
     end;
 end;

procedure InitMin(p:PTree);
 begin
   if p^.list then
     begin
       UpdateList(p);
     end
   else
     begin
       InitMin(p^.L);
       InitMin(p^.R);
       UpdateNotList(p);
     end;
 end;


function Make(a,b:int):PTree;
 var
  it:PTree;
  M:int;
 begin
   if a+1=b then
     begin
       inc(uk);
       it:=@trA[uk];
       it^.list:=true;
       it^.L:=@grA[a];
       it^.Lg^.R:=it;
       it^.R:=@grA[b];
       it^.Rg^.L:=it;
     end
   else
     begin
       M:=(a+b) div 2;
       inc(uk);
       it:=@trA[uk];
       it^.list:=false;
       it^.L:=Make(a,m);
       it^.L^.parent:=it;
       it^.R:=Make(m,b);
       it^.R^.parent:=it;
     end;
  Make:=it;
 end;

procedure WriteAns(p:PTree);
 begin
   if p^.list then
     begin
       if p^.Lg<>nil then
         if not p^.Lg^.Writen then   
           begin
             Write(p^.Lg^.k, ' ');
             p^.Lg^.Writen:=true;
           end;
       if p^.Rg<>nil then
         if not p^.Rg^.Writen then
           begin
             Write(p^.Rg^.k, ' ');
             p^.Rg^.Writen:=true;
           end;
     end
   else
     begin
       WriteAns(p^.L);
       WriteAns(p^.R);
     end;
 end;

procedure Solve;
 begin
   fillchar(trA,sizeof(trA),0);
   uk:=0;
   root:=Make(1,N);
   root^.parent:=nil;
   InitMin(root);

   while root^.min<>-1 do
     begin
       MergeFrom(root);
       dec(n);
     end;
   Writeln(n-1);
   WriteAns(root);
 end;

procedure QSort(l, r: Int);
var
  i, j: int;
  x,y:TGroup;
begin
  i := l; j := r; x := grA[l+random(r-l+1)];
  repeat
    while grA[i].x < x.x do i := i + 1;
    while x.x < grA[j].x do j := j - 1;
    if i <= j then
    begin
      y := grA[i]; grA[i] := grA[j]; grA[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then QSort(l, j);
  if i < r then QSort(i, r);
end;


procedure Init;
 var
   i:int;
 begin
   Read(N);
   for i :=  1 to N do
     begin
       Read(grA[i].k);
       Read(grA[i].x);
       grA[i].t:=0;
       grA[i].L:=nil;
       grA[i].R:=nil;
       grA[i].writen:=false;
     end;
   inc(N);
   grA[N].k:=1;
   grA[N].x:=inf;
   grA[N].t:=0;
   grA[N].L:=nil;
   grA[N].R:=nil;
   grA[N].writen:=true;
   QSort(1,N);
 end;

procedure OpenFiles;
 begin
  Assign(input,in_f);
  Reset(input);
  Assign(output,out_f);
  Rewrite(output);
 end;

procedure CloseFiles;
 begin
  Close(input);
  Close(output);
 end;

Begin
RandSeed:=23432;
OpenFiles;
Init;
Solve;
CloseFiles;
End.
