#include <cstdio>
#include <vector>
#include <algorithm>
#include <queue>

#define F first
#define S second
#define P push_back
#define PII pair<int, int>

using namespace std;

class tree
{
  static const int maxt = 1 << 17;
  int t[maxt * 2], p[maxt * 2];
public:
  void build( vector <int> &a )
  {
    int i;
    for (i = 0; i < a.size(); i++)
      t[maxt + i] = a[i], p[maxt + i] = i;
    for (i = maxt - 1; i > 0; i--)
      if (t[i + i] < t[i + i + 1])
        t[i] = t[i + i], p[i] = p[i + i];
      else
        t[i] = t[i + i + 1], p[i] = p[i + i + 1];
  }
  int get( int l, int r )
  {
    l += maxt, r += maxt;
    int res = l;
    while (l <= r)
    {
      if ((l & 1) && t[res] > t[l])
        res = l;
      if (!(r & 1) && t[res] > t[r])
        res = r;
      l += l & 1, r -= !(r & 1);
      if (l > r)
        break;
      l = l >> 1, r >>= 1;
    }
    return p[res];
  }
} t;

#define DO(i) { if (en[i] != st[i]) q.push(make_pair(-c[st[i]], i)); }

int main( void )
{
  int test_num;
  freopen("sort.in", "rt", stdin);
  freopen("sort.out", "wt", stdout);
  scanf("%d", &test_num);
  while (test_num--)
  {
    int i, j, n;

    scanf("%d", &n);
    vector <int> a(n), u(n, 0);
    vector < PII > b(n);
    for (i = 0; i < n; i++)
      scanf("%d", &a[i]), b[i].F = a[i], b[i].S = i;
    sort(b.begin(), b.end());

    vector <int> c, st, en;
    for (i = 0; i < n; i++)
      if (!u[i])
      {
        st.P(c.size());
        for (j = i; !u[j]; j = b[j].S)
          c.P(b[j].F), u[j] = 1;
        en.P(c.size() - 1);
      }

    printf("%d\n", n - st.size());
    t.build(c);
    priority_queue < PII > q;
    for (i = 0; i < st.size(); i++)
      DO(i)
    while (!q.empty())
    {
      PII p = q.top(); q.pop();
      i = p.S;
      j = t.get(st[i] + 1, en[i]);
      printf("%d %d\n", c[st[i]], c[j]);
      swap(c[st[i]], c[j]);
      st.P(j), en.P(en[i]);
      en[i] = j - 1;
      DO(i) 
      DO(st.size() - 1)
    }
  }
  return 0;  
}
