{$UNDEF DEBUG}
type integer = longint;
const MNOGO = $7F7F7F7F;
var n, m : integer;
	a : array[1..100, 1..100] of integer;
	bfl, cfl : array[1..202, 1..202] of integer;

procedure Load;
var i, j : integer;
begin
	read(n, m);
	for i := 1 to n do begin
		for j := 1 to m do begin
			read(a[i, j]);
		end;
	end;
	fillchar(cfl, sizeof(cfl), 0);
	fillchar(bfl, sizeof(bfl), 0);
	{n + m + 1 - source n + m + 2 - destination}
	{generate in and out edges}
	for i := 1 to m do begin
		if a[1, i] = 0 then begin
			bfl[i, n + m + 2] := 1;
			cfl[i, n + m + 2] := 1;
		end
		else begin
			bfl[n + m + 1, i] := a[1, i] - 1;
			cfl[n + m + 1, i] := a[1, i] - 1;
		end;
	end;
	{generate middle edges}
	for i := 1 to m do begin
		for j := 2 to n do begin
			if a[j, i] = 0 then begin
				cfl[i, j + m] := 1;
				bfl[i, j + m] := 1;
			end;
			if a[j, i] > 1 then begin
				cfl[j + m, i] := a[j, i] - 1;
				bfl[j + m, i] := a[j, i] - 1;
			end;
		end;
	end;
end;

var was : array[1..202] of integer;

function Dfs(ver : integer; var min : integer) : boolean;
var cmin, i : integer;
begin
	was[ver] := 1;
	if ver = n + m + 2 then begin
		{$IFDEF DEBUG}
        writeln;
        write('Found path: ', ver);
        {$ENDIF}
        Dfs := true;
		exit;
	end;
	for i := 1 to n + m + 2 do begin
		if cfl[ver, i] = 0 then continue;
        if was[i] = 1 then continue;
		cmin := min;
		if cfl[ver, i] < cmin then cmin := cfl[ver, i];
		if Dfs(i, cmin) then begin
			{$IFDEF DEBUG}
			write(' ', ver);
            {$ENDIF}        	
			dec(cfl[ver, i], cmin);
			inc(cfl[i, ver], cmin);
			min := cmin;
			Dfs := true;
			exit;
		end;
	end;
	Dfs := false;
end;

var ans : array[1..20000, 1..3] of integer;
	nans, npth : integer;
	pth : array[1..202] of integer;

procedure AddAns(v1, v2, v3 : integer);
begin
	inc(nans);
	ans[nans, 1] := v1;
	ans[nans, 2] := v2;
	ans[nans, 3] := v3;
end;

function DfsPath(ver : integer) : boolean;
var i : integer;
begin
	was[ver] := 1;
	if ver = n + m + 2 then begin
		DfsPath := true;
		inc(npth);
		pth[npth] := ver;
		exit;
	end;
	for i := 1 to n + m + 2 do begin
    	if was[i] = 1 then continue;
		if bfl[ver, i] - cfl[ver, i] = 0 then continue;
		if DfsPath(i) then begin
            inc(cfl[ver, i]);
			dec(cfl[i, ver]);
			inc(npth);
			pth[npth] := ver;
            DfsPath := true;
			exit;
		end;
	end;
	DfsPath := false;
end;

procedure Solve;
var min, i : integer;
begin
	{flow generate}
	fillchar(was, sizeof(was), 0);
    min := MNOGO;
	while Dfs(n + m + 1, min) do begin
		fillchar(was, sizeof(was), 0);
        min := MNOGO;
	end;
	{restore answer}
	nans := 0;
	fillchar(was, sizeof(was), 0);
	npth := 0;
	while DfsPath(n + m + 1) do begin
		{}
		for i := npth - 1 downto 2 do begin
			if pth[i] > m then begin
				AddAns(pth[i] - m, pth[i - 1], pth[i + 1]);
			end;
		end;
		{}
		fillchar(was, sizeof(was), 0);
		npth := 0;
	end;
end;

var cur : array[1..100] of integer;

procedure Save;
var i, f : integer;
begin
	for i := 1 to m do cur[i] := a[1, i];
	for i := 1 to nans do begin
		dec(cur[ans[i, 3]]);
		inc(cur[ans[i, 2]]);
	end;
	f := 0;
	for i := 1 to m do if cur[i] > 0 then inc(f);
	writeln(f);
	for i := 1 to nans do begin
		writeln(ans[i, 1], ' ', ans[i, 2], ' ', ans[i, 3]);
	end;
end;

begin
	assign(input, 'coins.in');
	assign(output, 'coins.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	Save;
	close(input);
	close(output);
end.
