{$H-,B-,I-,Q-,R-,S-}
{H-,B-,I+,Q+,R+,S+}
const
 eps    = 1e-10;
 inf    = 1000000000.0;
 maxN   = 100000+1;
type
 int    =  longint;
 rl     =  extended;
 TGroup =  record
  k:int;x:rl;
 end;
 HeapEl =  record
  t:rl;n1,n2:int;
 end;

var
 val        :  array[1..maxN]of TGroup;
 h          :  array[1..maxN]of HeapEl;
 num,pos    :  array[1..maxN]of int;
 newgr      :  TGroup;
 prom       :  HeapEl;
 dlT,t:rl;
 n,hs,i,n1,n2,maxn2,prm:int;


procedure Sort(l,r:int);
var
 i,j:int;
 x,y:TGroup;
begin
  i := l; j := r; x := val[(11*l+7*r) DIV 18];
  repeat
    while val[i].x < x.x do i := i + 1;
    while x.x < val[j].x do j := j - 1;
    if i <= j then
    begin
      y := val[i]; val[i] := val[j]; val[j] := y;
      i := i + 1; j := j - 1;
    end;
  until i > j;
  if l < j then Sort(l, j);
  if i < r then Sort(i, r);
end;

function calctx(var a,b:TGroup):rl;
var ax,bx:real;
begin
 ax:=a.x+dlT*100/a.k;
 bx:=b.x+dlT*100/b.k;

 if (abs(ax-bx)<eps) then begin
  calctx:=0;
  newgr.x:=a.x;
  newgr.k:=a.k+b.k;
 end else
 if (a.k<b.k) then begin
  newgr.k:=a.k+b.k;
  calctx:=(bx-ax)/(100/a.k-100/b.k);
  newgr.x:=bx+100/b.k*calctx-dlT*100/b.k;
 end else calctx:=inf;
end;

procedure swap(i,j:int);
begin
 prom:=h[i]; h[i]:=h[j]; h[j]:=prom;
 pos[num[i]]:=j; pos[num[j]]:=i;
 prm:=num[i]; num[i]:=num[j]; num[j]:=prm;
end;
procedure siftdown(i:int);
var j:int;
begin
 while (2*i<=hs) do begin
  if (h[i].t>h[2*i].t) then j:=2*i else j:=i;
  if (2*i+1<=hs)and(h[j].t>h[2*i+1].t) then j:=2*i+1;
  if (i=j) then break;
  swap(i,j);
  i:=j;
 end;
end;
procedure siftup(i:int);
var j:int;
begin
 while (i div 2 > 0) do begin
  if (h[i].t<h[i div 2].t) then swap(i,i div 2) else break;
  i:=i div 2;
 end;
end;
procedure ChangeKey(i:int;key:rl);
begin
 if (h[i].t<key) then begin
  h[i].t:=key;
  siftdown(i);
 end else begin
  h[i].t:=key;
  siftup(i);
 end;
end;
procedure DelElem(i:int);
begin
 swap(i,hs);
 h[hs].t:=0;
 h[hs].n1:=0;
 h[hs].n2:=0;
 dec(hs);
 siftdown(i);
end;

Begin
 //Initialization
 assign(input,'longpath.in');
 reset(input);
 assign(output,'longpath.out');
 rewrite(output);
 dlT:=0;
 read(n);
 for i:=1 to n do
  read(val[i].k,val[i].x);
 sort(1,n);
 hs:=n-1;
 for i:=1 to n-1 do begin
  h[i].n1:=i;
  h[i].n2:=i+1;
  h[i].t:=calctx(val[i],val[i+1]);
  pos[i]:=i;
  num[i]:=i;
 end;
 //buildheap;
 for i:=(hs div 2) downto 1 do
  siftdown(i);
 //Solve;
 while (hs>0)and(h[1].t<inf) do begin
  n1:=h[1].n1; n2:=h[1].n2;
  t:=calctx(val[n1],val[n2]); //finding new group, t=prom
  dlT:=dlT+t;
  val[n1]:=newgr; val[n2]:=newgr;
  if (n2<n) then begin
   h[1].n2:=n2+1;
   ChangeKey(1,calctx(val[n1],val[n2+1]));
   DelElem(pos[n2]);
  end;
  if (n1>1)
   then ChangeKey(pos[n1-1],calctx(val[n1-1],val[n1]));
  if (n2=n) then DelElem(pos[n1]);
 end;
 //WriteAnswer;
 writeln(hs+1);
 if (hs>0) then begin
  maxn2:=0;
  for i:=1 to hs do begin
   write(val[h[i].n1].k,' ');
   if (maxn2<h[i].n2) then maxn2:=h[i].n2;
  end;
  writeln(val[maxn2].k);
 end else writeln(val[1].k);
 close(input);
 close(output);
End.
