#include <stdio.h>
#include <memory.h>
#include <string.h>
#include <vector>

struct Edge {
	int to;
	int cap;
	int flow;
	int ak;
};
typedef std::vector<Edge> eVect;
typedef eVect::iterator vIter;

int m, n;
int st[110][110];
int v;
eVect rels[20000];
bool used[20000];
int father[20000][2];

int change[1000000][3];
bool done[1000000];
int chnum;

inline void AddEdge(int a, int b, int cap) {
	Edge ne;
	int abn, ban;
	abn = rels[a].size();
	ban = rels[b].size();

	ne.to = b;
	ne.flow = 0;
	ne.cap = cap;
	ne.ak = ban;
	rels[a].push_back(ne);

	ne.to = a;
	ne.flow = 0;
	ne.cap = 0;
	ne.ak = abn;
	rels[b].push_back(ne);
}

inline void pushFlow(int a, int b, int f, int ind) {
	rels[a][ind].flow += f;
	rels[b][rels[a][ind].ak].flow -= f;
}

void DFS(int u) {
	used[u] = true;
	if (u == v-1)
		return;
	for (int i = 0; i<rels[u].size(); i++)
		if (rels[u][i].cap - rels[u][i].flow > 0)
			if (!used[rels[u][i].to]) {
				father[rels[u][i].to][0] = u;
				father[rels[u][i].to][1] = i;
				DFS(rels[u][i].to);
				if (used[v-1])
					return;
			}
}

int main(int argc, char **argv) {
	freopen("coins.in", "r", stdin);
	freopen("coins.out", "w", stdout);
	int i, j, k;
	scanf("%d%d", &n, &m);
	for (i = 0; i<n; i++)
		for (j = 0; j<m; j++)
			scanf("%d", &(st[i][j]));
	v = 2 + m*(2*n-1);
	for (i = 0; i<m; i++) {
		AddEdge(0, i+1, st[0][i]);
		AddEdge(i+1, v-1, 1);
	}
	for (i = 1; i<n; i++)
		for (j = 0; j<m; j++) {
			int tind = 2 * ((i-1)*m + j);
			if (st[i][j] == 0) {
				AddEdge(j+1, m+1+tind, 1);
				AddEdge(m+1+tind, m+1+tind+1, 1);
			}
			if (st[i][j] > 1) {
				AddEdge(m+1+tind, m+1+tind+1, st[i][j]-1);
				AddEdge(m+1+tind+1, j+1, st[i][j]-1);
			}
			if (st[i][j] == 0)
				for (k = 0; k<m; k++)
					if (st[i][k] > 1) {
						int indk = 2 * ((i-1)*m + k);
						AddEdge(m+1+tind+1, m+1+indk, 1);
					}
		}	
	int answer = 0;
	while (1) {
		memset(father, -1, sizeof(father));
		memset(used, 0, sizeof(used));
		DFS(0);
		if (!used[v-1])
			break;
		int curr = v-1;
		answer++;
		while (curr != 0) {
			int next = father[curr][0];
			pushFlow(next, curr, 1, father[curr][1]);
			curr = next;
		}
	}
	printf("%d\n", answer);
	for (i = 0; i<m; i++) {
		int delta;
		for (j = 0; j<rels[i+1].size(); j++)
			if (rels[i+1][j].flow > 0)
				if (rels[i+1][j].to != v-1) {
					int curr = rels[i+1][j].to;
					int peop = (curr-m-1) / (2*m);
					int from = (curr-m-1) - peop*2*m;
					from /= 2;
					int tom;
					for (k = 0; k<rels[curr+1].size(); k++)
						if (rels[curr+1][k].flow > 0) {
							tom = (rels[curr+1][k].to-m-1);
							tom -= peop*2*m;
							tom /= 2;
							break;
						}
					change[chnum][0] = peop+1;
					change[chnum][1] = from;
					change[chnum][2] = tom;
					chnum++;
				}
	}
	while (1) {
		bool ok = true;
		for (i = 0; i<chnum; i++)
			if (!done[i])
				if (st[0][change[i][1]] > 0) {
					printf("%d %d %d\n", change[i][0]+1, change[i][2]+1, change[i][1]+1);
					done[i] = true;
					st[0][change[i][1]]--;
					st[0][change[i][2]]++;
					ok = false;
				}
		if (ok) break;
	}
	return 0;
}
