#include <stdio.h>
#include <math.h>
#include <set>

#define NUM 100010
#define EPS 1e-6
typedef double real;
real gtime;
struct Group {
	real x;
	int pop;
	real lxi;
};
struct cmpGroups {
	inline bool operator() (const Group &a, const Group &b) const {
		real arx = a.x + (100.0/a.pop) * (gtime-a.lxi);
		real brx = b.x + (100.0/b.pop) * (gtime-b.lxi);
		if (fabs(arx - brx) < EPS)
			return false;
		else
			return (arx < brx);
	}
};
struct Event {
	real fx;
	real time;
};
struct cmpEvents {
	inline bool operator() (const Event &a, const Event &b) const {
		if (fabs(a.time-b.time) <= EPS) {
			if (fabs(a.fx-b.fx) <= EPS)
				return false;
			return (a.fx < b.fx);
		}
		return a.time < b.time;
	}
};
typedef std::multiset<Event, cmpEvents> eSet;
typedef eSet::iterator eIter;
typedef std::multiset<Group, cmpGroups> gSet;
typedef gSet::iterator gIter;

int n;
eSet evs;
gSet gs;

int main(int argc, char **argv) {
	freopen("longpath.in", "r", stdin);
	freopen("longpath.out", "w", stdout);
	scanf("%d", &n);
	int i;
	for (i = 0; i<n; i++) {
		Group ng;
		scanf("%d%lf", &(ng.pop), &(ng.x));
		ng.lxi = 0;
		gs.insert(ng);
	}
	gIter git;
	for (git = gs.begin(); ; git++) {
		gIter ngit = git;  ngit++;
		if (ngit == gs.end()) break;
		if (git->pop < ngit->pop) {
			Event ne;
			ne.time = (ngit->x - git->x) / (100.0/git->pop - 100.0/ngit->pop);
			ne.fx = git->x + (100.0/git->pop) * ne.time;
			evs.insert(ne);
		}
	}
	while (!evs.empty()) {
		Group ff;
		eIter bit = evs.begin();
		eIter it;
		eIter endit = evs.upper_bound(*bit);
		if (gtime > bit->time) {
			evs.erase(bit, endit);
			continue;
		}
		gtime = bit->time;
		ff.x = bit->fx;
		ff.pop = 1;
		ff.lxi = gtime;
		git = gs.lower_bound(ff);
		gIter gxit;
		gIter engit = gs.upper_bound(ff);
		if (git == engit) {
			evs.erase(bit, endit);
			continue;
		}
		engit--;
		if (git == engit) {
			evs.erase(bit, endit);
			continue;
		}
		engit++;
		int popsum = 0;
		int leftp, rightp;
		leftp = git->pop;
		engit--;  rightp = engit->pop;  engit++;
		for (gxit = git; gxit != engit; gxit++)
			popsum += gxit->pop;
		gs.erase(git, engit);
		evs.erase(bit, endit);
		ff.pop = popsum;
//		printf("%d %0.3lf\n", popsum, gtime);

		git = gs.lower_bound(ff);
		if (git != gs.end()) {
			Group tg;
			tg = *git;
			gs.erase(git);
			tg.x += (gtime-tg.lxi) * (100.0/tg.pop);
			tg.lxi = gtime;
			gs.insert(tg);
		}
		git = gs.lower_bound(ff);
		if (git != gs.begin()) {
			git--;
			Group tg;
			tg = *git;
			gs.erase(git);
			tg.x += (gtime-tg.lxi) * (100.0/tg.pop);
			tg.lxi = gtime;
			gs.insert(tg);
		}
		git = gs.lower_bound(ff);

		if (git != gs.end()) {
			if (git->pop > ff.pop) {
				Event ne;
				git = gs.lower_bound(ff);
				ne.time = (git->x - ff.x) / (100.0/ff.pop - 100.0/git->pop);
				ne.fx = git->x + (100.0/git->pop) * ne.time;
				ne.time += gtime;
				evs.insert(ne);
			}
		}
		if (git != gs.begin()) {
			git--;
			if (git->pop < ff.pop) {
				Event ne;
				ne.time = (ff.x - git->x) / (100.0/git->pop - 100.0/ff.pop);
				ne.fx = git->x + (100.0/git->pop) * ne.time;
				ne.time += gtime;
				evs.insert(ne);
			}
		}
		gs.insert(ff);
	}
	printf("%d\n", gs.size());
	for (git = gs.begin(); git != gs.end(); git++) {
		real tgx = git->x + (100.0/git->pop) * (gtime - git->lxi);
//		printf("%d %0.3lf\n", git->pop, tgx);
		printf("%d ", git->pop);
	}
	return 0;
}
