{$R-}
const namein='longpath.in';
      nameout='longpath.out';
      NMax=110000;
      SMax=2*NMax;
      Eps=0.00000001;
      NA=-1;
      RConst=21761;
type
 integer=longint;
 real=extended;
 TVInt=array [NA..NMax] of integer;
 TVExt=array [NA..NMax] of real;
 TTree=array [NA..SMax] of integer;
 TBool=array [NA..NMax] of boolean;
var k,next,prev:TVInt;
    x,t:TVExt;
    p:TBool;
    S:TTree;
    n:integer;

procedure Init;
var i:integer;
begin
 assign(input,namein);
 reset(input);
 readln(n);
 for i:=1 to n do
  readln(k[i],x[i]);
 close(input)
end;

procedure Sort(l,r:integer);
var i,j,v2:integer;
    q,v1:real;
begin
 i:=l; j:=r; q:=x[l+random(r-l+1)];
 repeat
  while x[i]<q do inc(i);
  while x[j]>q do dec(j);
  if i<=j then begin
    v1:=x[i]; x[i]:=x[j]; x[j]:=v1;
    v2:=k[i]; k[i]:=k[j]; k[j]:=v2;
    inc(i); dec(j)
   end
 until i>j;
 if i<r then Sort(i,r);
 if l<j then Sort(l,j)
end;

procedure Relax(a:integer; const v:integer);
var l,r:integer;
begin
 l:=a*2; r:=l+1;
 if S[a]=NA then begin
   if p[v] then S[a]:=v;
  end
 else begin
   if l<=SMax then l:=S[l] else l:=NA;
   if r<=SMax then r:=S[r] else r:=NA;
   if (l<>NA) and p[l] and ((not p[S[a]]) or (t[l]<t[S[a]]))
   then S[a]:=l;
   if (r<>NA) and p[r] and ((not p[S[a]]) or (t[r]<t[S[a]]))
   then S[a]:=r;
   if not p[S[a]] then S[a]:=NA
  end;
 if a<>0 then Relax(a div 2,v)
end;

function CalcMin(l,r:integer):integer;
var larg,q:integer;
begin
 if l=r then CalcMin:=S[l]
 else begin
   larg:=NA;
   if l mod 2<>0 then begin
     if S[l]<>NA then
      if (larg=NA) or ((t[larg]-t[S[l]])>Eps) then larg:=S[l];
     inc(l)
    end;
   if r mod 2=0 then begin
     if S[r]<>NA then
      if (larg=NA) or ((t[larg]-t[S[r]])>Eps) then larg:=S[r];
     dec(r)
    end;
   if l<=r then begin
     q:=CalcMin(l div 2,r div 2);
     if q<>NA then
      if (larg=NA) or (t[larg]>t[q]) then larg:=q
    end;
   CalcMin:=larg
  end
end;

procedure Solve;
var i,q:integer;
    xx:real;
    Ok:boolean;
begin
 RandSeed:=RConst;
 Sort(1,n);
 for i:=1 to n do begin
   if i<>n then next[i]:=i+1 else next[i]:=NA;
   if i<>1 then prev[i]:=i-1 else prev[i]:=NA
  end;
 for i:=0 to SMax do S[i]:=NA;
 for i:=1 to n do
  if (i<>n) and (k[i]<k[i+1]) then begin
    t[i]:=(x[i+1]-x[i])/((100/k[i])-(100/k[i+1]));
    p[i]:=true
   end
  else p[i]:=false;
 for i:=1 to n do Relax(SMax-n+i,i);
 Ok:=true;
 repeat
  q:=CalcMin(1,n);
  Ok:=Ok and (q<>NA);
  if Ok then begin
    if next[next[q]]<>NA then
     if p[next[q]] and
        (abs(t[next[q]]-t[q])>Eps)
     then begin
       xx:=(x[next[next[q]]]-x[next[q]])-
           ((100/k[next[q]])-(100/k[next[next[q]]]))*t[q];
       if (k[q]+k[next[q]])<k[next[next[q]]]
       then t[next[q]]:=xx/((100/(k[q]+k[next[q]]))-(100/(k[next[next[q]]])))
       else p[next[q]]:=false;
       Relax(SMax-n+next[q],next[q])
      end;
    prev[next[q]]:=prev[q];
    inc(k[next[q]],k[q]);
    if prev[q]<>NA then begin
      next[prev[q]]:=next[q];
      if p[q] then xx:=(x[q]-x[prev[q]])-((100/k[prev[q]])-(100/k[q]))*t[q]
      else xx:=(x[q]-x[prev[q]])+((100/k[q])-(100/k[prev[q]]))*t[q];
      if k[prev[q]]<k[next[q]]
      then begin
        t[prev[q]]:=xx/((100/k[prev[q]])-(100/k[next[q]]));
        p[prev[q]]:=true
       end;
      Relax(SMax-n+prev[q],prev[q])
     end;
    k[q]:=0;
    p[q]:=false;
    Relax(SMax-n+q,q)
   end;
 until not Ok
end;

procedure Done;
var i,Sol:integer;
begin
 assign(output,nameout);
 rewrite(output);
 Sol:=0;
 for i:=1 to n do
  if k[i]<>0 then inc(Sol);
 writeln(Sol);
 for i:=1 to n do
  if k[i]<>0 then write(k[i],' ');
 close(output)
end;

begin
 Init;
 Solve;
 Done
end.
