#include <stdio.h>
#include <stdlib.h>

#define m 100100

#define min(a, b) ((a) < (b) ? (a) : (b))
#define max(a, b) ((a) > (b) ? (a) : (b))

int a[m], p[m], q[m], h[m], vh[m], hs, n, a1[m], a2[m], nu;

void sort( int l, int r )
{
  int i, j, x, t;

  if (l >= r)
    return;
  i = l, j = r, x = a[l + rand() % (r - l + 1)];
  while (i <= j)
  {
    while (a[i] < x) i++;
    while (a[j] > x) j--;
    if (i <= j)
    {
      t = a[i], a[i] = a[j], a[j] = t;
      t = p[i], p[i] = p[j], p[j] = t;
      i++, j--;
    }
  }
  sort(l, j), sort(i, r);
}

void swap( int i, int j )
{
  int t;

  t = h[i], h[i] = h[j], h[j] = t;
  vh[h[i]] = i, vh[h[j]] = j;
}

int less( int i, int j )
{
  int a1, b1, a2, b2;

  i = h[i], j = h[j];
  a1 = min(q[i], q[q[i]]);
  b1 = max(q[i], q[q[i]]);
  a2 = min(q[j], q[q[j]]);
  b2 = max(q[j], q[q[j]]);
  return a1 < a2 || (a1 == a2 && b1 < b2);
}

void siftup( int i )
{
  while (i > 1 && less(i, i >> 1))
    swap(i, i >> 1), i >>= 1;
}

void siftdown( int i )
{
  int l, r, e;

  while (i <= hs)
  {
    l = i << 1, r = l + 1, e = i;
    if (l <= hs && less(l, e)) e = l;
    if (r <= hs && less(r, e)) e = r;
    if (e == i)
      break;
    swap(i, e), i = e;
  }
}

void add( int i )
{
  h[++hs] = i, vh[i] = hs;
  siftup(hs);
}

void del( int i )
{
  int j;
  
  j = h[hs];
  swap(vh[i], hs--);
  vh[i] = -1;
  siftdown(vh[j]);
  siftup(vh[j]);
}

int main( void )
{
  int i, j, t, tn, pr;

  srand(301703);
  freopen("sort.in", "rt", stdin);
  freopen("sort.out", "wt", stdout);
  scanf("%d", &tn);
  while (tn--)
  {
    scanf("%d", &n);
    for (i = 0; i < n; i++)
      scanf("%d", &a[i]), p[i] = i;
    sort(0, n - 1);
    for (i = 0; i < n; i++)
      q[p[i]] = i;
    for (hs = 0, i = 0; i < n; i++)
      if (q[i] != i)
        add(i);
    nu = 0;
    while (hs > 0)
    {
      i = h[1];
      del(i);
      if (q[i] == i)
        continue;
      a1[nu] = min(q[i], q[q[i]]), a2[nu++] = max(q[i], q[q[i]]);
      if (q[q[i]] == i)
      {
        del(q[i]);
        continue;
      }
      j = q[i], pr = p[i];
      t = q[i], q[i] = q[j], q[j] = t;
      p[q[i]] = i, p[q[j]] = j;
      del(j);
      add(i);
      del(pr);
      add(pr);
    }
    printf("%d\n", nu);
    for (i = 0; i < nu; i++)
      printf("%d %d\n", a[a1[i]], a[a2[i]]);
  }
  return 0;
}
