#include <cstdio>
#include <vector>
#include <algorithm>
#include <memory.h>
#include <queue>
#include <map>

#define inf (long)1000000010
#define maxn 100100

using namespace std;

long T;

long n;

template<long max_el>
struct interval_tree{
	#define h max_el
	long a[2*max_el+1];
	interval_tree(){memset(a,0,sizeof(a));}
	long& operator[](long x)
	{
		return a[x+h-1];
	}
	void build()
	{
		for(long i=h-1;i>=1;i--)
			a[i]=(a[2*i]<a[2*i+1]) ? (2*i):(2*i+1);
	}
	long find_min(long x,long y)
	{
		if(x>y) return inf;
		x+=h,y+=h;
		long ax=x,ay=y;
		while(x<y-1){
			if(x%2==0) ax=(a[ax]<a[a[x+1]]) ? ax:a[x+1];
			if(y%2==1) ay=(a[ay]<a[a[y-1]]) ? ay:a[y-1];
			x/=2,y/=2;
		}
		return ((a[ax]<a[ay]) ? ax:ay)-h+1;
	}
	#undef h
};

vector<long> v,u;
long p[maxn],pp[maxn];
interval_tree<131072> t;
map<long,long> mp;

struct cyc{
	long x1,y1,x2,y2;
	cyc(){x1=1,y1=0,x2=1,y2=0;}
	cyc(long x,long y){x1=x,y1=y,x2=1,y2=0;}
	long vl()
	{
		return min(t[t.find_min(x1,y1)],t[t.find_min(x2,y2)]);
	}
	friend bool operator<(cyc c1,cyc c2)
	{
		return c1.vl()<c2.vl();
	}
};

queue<cyc> q;
vector<cyc> qq;
bool us[maxn];
long now;
vector<pair<long,long> > ans;

void work(long x)
{
	if(p[x]==x){
		us[x]=true;
		return;
	}
	long t=x,mn1=inf,mn2=inf;
/*	printf("Searching %d\n",v[x]);*/
	do{
/*		printf("Working %d\n",v[x]);*/
		if((mn1>=inf)||(v[x]<v[mn1])) mn2=mn1,mn1=x;
		else{
			if((mn2>=inf)||(v[x]<v[mn2])) mn2=x;
		}
		us[x]=true;
		x=p[x];	
	}while(x!=t);
/*	printf("Found %d %d\n",v[mn1],v[mn2]);*/
	if(v[mn1]>v[mn2]) swap(mn1,mn2);
	ans.push_back(make_pair(v[mn1],v[mn2]));
	swap(p[mn1],p[mn2]);
	work(mn1);
	work(mn2);
}

void work_prob()
{
	u.resize(0),v.resize(0),ans.resize(0),qq.resize(0);
	mp.clear();
	scanf("%d",&n);
	long x;
	for(long i=1;i<=n;i++)
		scanf("%d",&x),v.push_back(x),u.push_back(x),us[i]=false;
	sort(u.begin(),u.end());
	long cnt=0;
	for(long i=0;i<u.size();i++)
		mp[u[i]]=cnt++;
	for(long i=0;i<v.size();i++)
		pp[i]=mp[v[i]],p[pp[i]]=i;
/*	for(long i=0;i<n;i++) printf("%d",p[i]);
	printf("\n");*/
	now=0;
	for(long i=0;i<n;i++)
		if(!us[i])
			work(i);
	sort(ans.begin(),ans.end());
	printf("%d\n",ans.size());
	for(long i=0;i<ans.size();i++)
		printf("%d %d\n",ans[i].first,ans[i].second);
}

int main()
{
	freopen("sort.in","r",stdin);
	freopen("sort.out","w",stdout);
	scanf("%d",&T);
	for(long i=1;i<=T;i++)
		work_prob();
	fclose(stdout);
	fclose(stdin);
	return 0;
}
