#include <stdio.h>
#include <stdlib.h>

#define SWAP(a, b, c) ((c) = (a), (a) = (b), (b) = (c))
#define eps 1e-12

typedef struct
{
  int PeopleCnt, next, prev;
  long double St; 
} GROUP;

GROUP A[100010];
int N;

void Union( int a )
{
  int b;
  long double time, NowPos;

  b = A[a].next;
  if (A[b].next != -1)
    A[A[b].next].prev = a;
  A[a].next = A[b].next;
  time = (A[b].St - A[a].St) / (100.0 / A[a].PeopleCnt - 100.0 / A[b].PeopleCnt);
  NowPos = A[a].St + time * 100.0 / A[a].PeopleCnt;
  A[a].PeopleCnt += A[b].PeopleCnt;
  A[a].St = NowPos - time * 100.0 / A[a].PeopleCnt;
}

void QSort( int l, int r )
{
  long double c, td;
  int t, i, j;

  if (l >= r)
    return;
  c = A[(l + (rand() % (r - l + 1)))].St;
  i = l, j = r;
  while (i < j)
  {  
    while (A[i].St < c)
      i++;
    while (A[j].St > c)
      j--;
    if (i <= j)
      SWAP(A[i].St, A[j].St, td),
      SWAP(A[i].PeopleCnt, A[j].PeopleCnt, t),
      i++, j--;
  }
  QSort(l, j);
  QSort(i, r);
}

long double Heap[100010];
int Wich[100010], Where[100010], HN, IsIn[100010];
void SWP( int i, int j )
{ 
  long double td;
  int t;


  SWAP(Heap[i], Heap[j], td);
  SWAP(Wich[i], Wich[j], t);
  Where[Wich[i]] = i;
  Where[Wich[j]] = j;

}
void FixDown( int i )
{
  int min, l, r;

 l = (i << 1) + 1;
 r = l + 1;
 min = i;
 if (l < HN && Heap[l] < Heap[min]) 
   min = l;
 if (r < HN && Heap[r] < Heap[min])
   min = r;
 if (min != i)
   SWP(i, min),
   FixDown(min);
}

void FixUp( int i )
{
  int j;

  while (i > 0 && Heap[j = (i - 1) >> 1] > Heap[i])
    SWP(i, j), i = j;
}

void DelMin( void )
{
  if (HN == 0)
    return;
  HN--;
  IsIn[Wich[0]] = 0;
  SWP(0, HN);
  FixDown(0);
}
void Del( int i )
{
  while (i > 0)
    SWP(i, (i - 1) >> 1), i = (i - 1) >> 1;
  DelMin();
}
void Add( long double d, int num )
{
  //printf("Added %Lf\n", d);
  Heap[HN] = d;
  Wich[HN] = num;
  Where[num] = HN;
  IsIn[num] = 1;
  HN++;
  FixUp(HN - 1); 
}

void Fix( int i )
{
  FixUp(i);
  FixDown(i);
}

void Check( int a )
{
  int b;
  long double time;
  b = A[a].next;

  if (A[a].PeopleCnt > A[b].PeopleCnt)
  {
    if (IsIn[a])
      Del(Where[a]);
    return;
  }
  if (A[a].PeopleCnt == A[b].PeopleCnt)
  {
    if (A[a].St != A[b].St)
      return;
    if (!IsIn[a])
    {
      Add(0, a);
    }
    else
    {
      Heap[Where[a]] = 0;
      Fix(Where[a]);
    }
  }
  time = (A[b].St - A[a].St) / (100.0 / A[a].PeopleCnt - 100.0 / A[b].PeopleCnt);
/*  if (a == 0 && b == 4)
  {
    printf("time : %Lf HN : %i %i\n", time, HN, IsIn[a]);

  }*/

  if (!IsIn[a])
  {
    Add(time, a);
  }
  else
  {
    Heap[Where[a]] = time;
    Fix(Where[a]);
  }

}     
int main( void )
{
  int i, j, k, r = 0;
  long double t;

  freopen("longpath.in", "rt", stdin); 
  freopen("longpath.out", "wt", stdout);
  scanf("%i", &N);

  for (i = 0; i < N; i++)
    scanf("%i%Lf", &A[i].PeopleCnt, &A[i].St), A[i].next = i + 1, A[i].prev = i - 1;
  A[0].prev = -1;
  A[N - 1].next = -1;
  QSort(0, N - 1);
  /*printf("Sorted input:\n");
  for (i = 0; i < N; i++)
    printf("  %i %Lf\n", A[i].PeopleCnt, A[i].St);
  printf("End of sorted input\n");*/

  for (i = 0; i < N - 1; i++)
    if (A[i].PeopleCnt < A[i + 1].PeopleCnt)
      Add((A[i + 1].St - A[i].St) / (100.0 / A[i].PeopleCnt - 100.0 / A[i + 1].PeopleCnt), i);
 
  while (HN > 0)
  {
    k = Wich[0];
    //printf("%i %Lf - %i %Lf (%Lf)\n", A[k].PeopleCnt, A[k].St, A[A[k].next].PeopleCnt, A[A[k].next].St, Heap[0]);
    if (IsIn[A[k].next])
      Del(Where[A[k].next]);
    Union(k);
    DelMin();
    /*if (k == 4)
    {
      printf("!!\n");
      printf("%i %i\n", A[k].next, A[k].prev);

    } */
    if (A[k].prev != -1)
      Check(A[k].prev);
    if (A[k].next != -1)
      Check(k);
    /*i = 0;
    printf("%i\n", k);
    while (i != -1)
      printf("%i %Lf\n", A[i].PeopleCnt, A[i].St),
      i = A[i].next;
    printf("\n");*/

  }

  i = 0;
  while (i != -1)
    r++, i = A[i].next;
  printf("%i\n", r);
  i = 0;
  while (i != -1)
    printf("%i ", A[i].PeopleCnt), i = A[i].next;
  return 0;
}
