#include <cstdio>
#include <algorithm>

#define EPS 1e-10
#define size 100000

using namespace std;

int b[size], hsize;

class key{
public:
  int x;
  double t;
  key(int X=0, double T=0){
    x=X;
    t=T;
  }
  friend bool operator<(const key& x, const key& y){
    return x.t<y.t;
  }
} h[size];

void swap(int x, int y){
  swap(h[x], h[y]);
  b[h[x].x]=x;
  b[h[y].x]=y;
}

void pushup(int i){
  int min=i;
  if (i*2+1<hsize&&h[i*2+1]<h[min]) min=i*2+1;
  if (i*2+2<hsize&&h[i*2+2]<h[min]) min=i*2+2;
  if (min==i) return;
  swap(min, i);
  pushup(min);
}

void pushdown(int i){
  if (i==0||h[(i-1)/2]<h[i]) return;
  swap(i, (i-1)/2);
  pushdown((i-1)/2);
}

void extractmin(){
  swap(0, --hsize);
  b[h[hsize].x]=-1;
  pushup(0);
}

void add(key k){
  h[hsize]=k;
  b[k.x]=hsize;
  pushdown(hsize++);
}

void del(int x){
  h[x].t=-1;
  pushdown(x);
  extractmin();
}

double curt=0, x0[size];
int i, n, next[size], prev[size], w[size], first, u, v;

double x(int n){
  return x0[n]+curt/w[n];
}

void trytoadd(int i){
  if (next[i]!=-1&&w[i]<w[next[i]]||x(next[i])-x(i)<EPS)
    add(key(i, (x0[next[i]]-x0[i])/(1.0/w[i]-1.0/w[next[i]])));
}

struct it{
  int a;
  friend bool operator<(const it& x, const it& y){
    return x0[x.a]<x0[y.a];
  }
} ind[size];

int main(){
  freopen("longpath.in", "rt", stdin);
  freopen("longpath.out", "wt", stdout);
  scanf("%d", &n);
  for (i=0; i<n; i++){
    scanf("%d%lf", &w[i], &x0[i]);
    ind[i].a=i;
    b[i]=-1;
  }
  sort(&ind[0], &ind[n]);
  first=ind[0].a;
  for (i=0; i<n-1; i++){
    next[ind[i].a]=ind[i+1].a;
    prev[ind[i+1].a]=ind[i].a;
  }
  prev[ind[0].a]=next[ind[n-1].a]=-1;
  for (i=0; i<n; i++)
    trytoadd(i);
  while (hsize){
    n--;
    u=h[0].x;
    v=next[u];
    curt=h[0].t;
    extractmin();
    if (b[v]!=-1) del(b[v]);
    next[u]=next[v];
    prev[next[u]]=u;
    x0[u]+=curt/double(w[u]);
    w[u]+=w[v];
    x0[u]-=curt/double(w[u]);
    if (prev[u]!=-1){
      if (b[prev[u]]!=-1) del(b[prev[u]]);
      trytoadd(prev[u]);
    }
    trytoadd(u);
  }
  printf("%d\n", n);
  for (i=first; i!=-1; i=next[i]) printf("%d ", w[i]);
  return 0;
}
