{$DEFINE DEBUG}
{$UNDEF DEBUG}
type integer = longint;
const INFINITE = 1e+3000;
const eps = 1e-9;
var bt, bx : array[1..110000] of extended;
	bk : array[1..100000] of integer;
    n : integer;
	prv, nxt : array[0..100001] of integer;

procedure Qsort(be, en : integer);
var tl, l, r : integer;
	t, x : extended;
begin
	l := be;
	r := en;
	x := bx[l + random(r - l + 1)];
	while l < r do begin
		while (x - bx[l] > eps) do inc(l);
		while (x - bx[r] < -eps) do dec(r);
		if l <= r then begin
			t := bx[l];
			bx[l] := bx[r];
			bx[r] := t;
			tl := bk[l];
			bk[l] := bk[r];
			bk[r] := tl;
			inc(l);
			dec(r);
		end;
	end;
	if be < r then Qsort(be, r);
	if l < en then Qsort(l, en);
end;

procedure Load;
var i : integer;
begin
	read(n);
	for i := 1 to n do begin
		prv[i] := i - 1;
		nxt[i] := i + 1;
		bt[i] := 0;
		read(bk[i], bx[i]);
	end;
	nxt[0] := 1;
	prv[n + 1] := n;
	Qsort(1, n);
end;

var hp, whr : array[1..100000] of integer;
	nhp : integer;
	nextt : array[1..100000] of extended;

procedure Swap(i1, i2 : integer);
var t : integer;
begin
	t := hp[i1];
	hp[i1] := hp[i2];
	hp[i2] := t;
	whr[hp[i1]] := i1;
	whr[hp[i2]] := i2;
end;

procedure StepUp(pos : integer);
var cur, nxt : integer;
begin
	cur := pos;
	nxt := cur shr 1;
	while (nxt > 0) and (nextt[hp[nxt]] > nextt[hp[cur]]) do begin
		Swap(nxt, cur);
		cur := nxt;
		nxt := cur shr 1;
	end;
end;

procedure StepDown(pos : integer);
var nxt, cur : integer;
begin
	cur := pos;
	nxt := cur * 2;
	if (nxt < nhp) and (nextt[hp[nxt + 1]] < nextt[hp[nxt]]) then inc(nxt);
	while (nxt <= nhp) and (nextt[hp[nxt]] < nextt[hp[cur]]) do begin
		Swap(cur, nxt);
		cur := nxt;
		nxt := cur * 2;
		if (nxt < nhp) and (nextt[hp[nxt + 1]] < nextt[hp[nxt]]) then inc(nxt);
	end;
end;

function ExtractMin : integer;
var res : integer;
begin
	res := hp[1];
	whr[hp[1]] := 0;
	hp[1] := hp[nhp];
	whr[hp[1]] := 1;
	dec(nhp);
	StepDown(1);
	ExtractMin := res;
end;

procedure UpdateTime(i : integer);
var j : integer;
	xi, xj, ctime : extended;
begin
	{$IFDEF DEBUG}
	writeln('UpdateTime ', i);
	close(output);
	assign(output, 'longpath.out');
	append(output);
	{$ENDIF}
	if (i < 1) or (i > n) then exit;
	j := nxt[i];
	if (j > n) then begin
		nextt[i] := 1e+4000;
	end
	else begin
		ctime := bt[i];
		if bt[j] > ctime then ctime := bt[j];
		xi := bx[i] + (100 / bk[i]) * (ctime - bt[i]);
		xj := bx[j] + (100 / bk[j]) * (ctime - bt[j]);
		if bk[i] >= bk[j] then begin
			nextt[i] := 1e+4000;
		end
		else begin
			nextt[i] := (xj - xi) / (100 / bk[i] - 100 / bk[j]) + ctime;
	   	end;
	end;
	{$IFDEF DEBUG}
	writeln('Next cross ', nextt[i] : 0 : 6);
	close(output);
	assign(output, 'longpath.out');
	append(output);
	{$ENDIF}
	StepUp(whr[i]);
	StepDown(whr[i]);
end;

procedure Solve;
var i, num : integer;
begin
	nhp := 0;
	for i := 1 to n do begin
		inc(nhp);
		whr[i] := nhp;
		hp[nhp] := i;
		UpdateTime(i);
	end;
	while nhp > 0 do begin
		i := ExtractMin;
		{$IFDEF DEBUG}
		writeln('Extracted ', i);
		close(output);
		assign(output, 'longpath.out');
		append(output);
		{$ENDIF}
		if nextt[i] > INFINITE then break;
		{merge}
		bx[nxt[i]] := bx[nxt[i]] + (100 / (bk[nxt[i]])) * (nextt[i] - bt[nxt[i]]);
		bt[nxt[i]] := nextt[i];
		bk[nxt[i]] := bk[i] + bk[nxt[i]];
		prv[nxt[i]] := prv[i];
		nxt[prv[i]] := nxt[i];
		{$IFDEF DEBUG}
		writeln('New x - coordinate: ', bx[nxt[i]] : 0 : 6);
		{$ENDIF}
		UpdateTime(nxt[i]);
		UpdateTime(prv[i]);
	end;
	num := 0;
	i := nxt[0];
	{$IFDEF DEBUG}
	write('List going: ');
	write(i, ' ');
	{$ENDIF}
	while i <> n + 1 do begin
		inc(num);
		i := nxt[i];
		{$IFDEF DEBUG}
		write(i, ' ');
		{$ENDIF}
	end;
	writeln(num);
	i := nxt[0];
	while i <> n + 1 do begin
		write(bk[i], ' ');
		i := nxt[i];
	end;
end;

begin
	assign(input, 'longpath.in');
	assign(output, 'longpath.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
