{$I-,Q-,R-,S-}
const
        MaxN = 200 * 1000;
        Inf = 1e50;
        eps = 1e-6;
type
        Real = Extended;
        TSbor =
        record
          x : Real;
          c : LongInt;
        end;
var
        rez, n, nn : LongInt;
        mas : Array[1 .. MaxN] of TSbor;
        f{time before collision with (i+1)th group} : Array[1 .. MaxN] of Real;
        first, last{groups already collised} : Array[1 .. MaxN] of LongInt;
        tree : Array[1 .. MaxN * 2] of LongInt;

Procedure Swap(var a, b : TSbor);
var
        c : TSbor;
begin
  c := a;
  a := b;
  b := c;
end;

Procedure QSort(const l, r : LongInt);
var
        i, j : LongInt;
        x : Real;
begin
  i := l;
  j := r;
  x := mas[(l + r) div 2].x;
  repeat
    While mas[i].x < x do
      Inc(i);
    While mas[j].x > x do
      Dec(j);
    if i <= j then
    begin
      Swap(mas[i], mas[j]);
      Inc(i);
      Dec(j);
    end;
  until i > j;
  if l < j then
    QSort(l, j);
  if i < r then
    QSort(i, r);
end;



Procedure Init;
var
        i : LongInt;
begin
  ReadLn(n);
  rez := n;
  nn := 0;
  for i := 1 to n do
  begin
    Read(mas[i].c, mas[i].x);
    Inc(nn, mas[i].c);
  end;
  for i := 1 to n - 1 do
    if Random(3) = 0 then
      Swap(mas[i], mas[i + 1]);
  QSort(1, n);
end;

Procedure MakeTree;
var
        i : LongInt;
begin
  i := 1;
  While i < n do
    i := i * 2;
  While n < i do
  begin
    Inc(n);
    f[n] := Inf;
  end;
  for i := n to n * 2 - 1 do
    tree[i] := i - n + 1;
  for i := n - 1 downto 1 do
    if f[tree[i * 2]] < f[tree[i * 2 + 1]] then
      tree[i] := tree[i * 2]
    else
      tree[i] := tree[i * 2 + 1];
end;

Procedure Change(i : LongInt);
begin
  i := i + n - 1;
  While i <> 1 do
  begin
    i := i div 2;
    if f[tree[i * 2]] < f[tree[i * 2 + 1]] then
      tree[i] := tree[i * 2]
    else
      tree[i] := tree[i * 2 + 1];
  end;
end;

Function Collision : Boolean;
var
        l, r : LongInt;
begin
  if Abs(f[tree[1]] - Inf) < eps then
  begin
    Collision := False;
    Exit;
  end;
  Collision := True;
  l := first[tree[1]];
  r := last[tree[1] + 1];
  mas[l].x := mas[l].x + 100 / mas[l].c * f[tree[1]] - 100 / (mas[l].c + mas[first[r]].c) * f[tree[1]];
  mas[l].c := mas[l].c + mas[first[r]].c;
  first[r] := l;
  last[l] := r;
  f[tree[1]] := Inf;
  Change(tree[1]);
  if l <> 1 then
  begin
    if mas[first[l - 1]].c = mas[l].c then
      f[l - 1] := Inf
    else
      f[l - 1] := -(mas[l].x - mas[first[l - 1]].x) / (100 / mas[first[l - 1]].c - 100 / mas[l].c);
    if f[l - 1] < 0 then
      f[l - 1] := Inf;
    Change(l - 1);
  end;
  if (r <> n) and (mas[r + 1].c <> 0) then
  begin
    if mas[r + 1].c = mas[l].c then
      f[r] := Inf
    else
      f[r] := -(mas[r + 1].x - mas[l].x) / (100 / mas[l].c - 100 / mas[r + 1].c);
    if f[r] < 0 then
      f[r] := Inf;
    Change(r);
  end;
end;

Procedure ML;
type
        A = Array[1 .. MaxN] of LongInt;
var
        mas : ^A;
begin
  While True do
    New(mas);
end;

Procedure Solve;
var
        i : LongInt;
begin
  for i := 1 to n - 1 do
    if mas[i].c <> mas[i + 1].c then
    begin
      f[i] := (mas[i + 1].x - mas[i].x) / (100 / mas[i].c - 100 / mas[i + 1].c);
      if f[i] < 0 then
        f[i] := Inf;
    end
    else
      f[i] := Inf;
  f[n] := Inf;
  for i := 1 to n do
  begin
    last[i] := i;
    first[i] := i;
  end;
  MakeTree;
  While Collision do
    Dec(rez);
  WriteLn(rez);
  i := 1;
  While mas[i].c <> 0 do
  begin
    Write(mas[i].c, ' ');
    i := last[i] + 1;
  end;
end;

Procedure Print;
begin
end;

Procedure GenTest;
const
        MaxN = 100;
var
        i : LongInt;
begin
  Assign(output, 'longpath.in');
  Rewrite(output);
  WriteLn(MaxN);
  for i := 1 to MaxN do
    WriteLn(((i - 1) mod 100) + 1, ' ', 101 - i);
  Close(output);
end;

begin
{  GenTest;}
  Assign(input, 'longpath.in');
  Reset(input);
  Assign(output, 'longpath.out');
  Rewrite(output);
  Init;
  Solve;
  Print;
  Close(input);
  Close(output);
end.
