{ $DEFINE DEBUG}
{$H+}
{$IFDEF DEBUG}
{$C+,I+,Q+,R+,S+}
{$ELSE}
{$C-,I-,Q-,R-,S-}
{$ENDIF}
{$M 60000000,60000000}
const taskid='longpath';
      infile=taskid+'.in';
      outfile=taskid+'.out';
      eps=1e-4;
      infinity=1e100;
type plist=^tlist;
     tlist=record
       start,time:extended;
       hpos,people:longint;
       next,prev:plist;
     end;
var n,i,hlen,answer:longint;
    k,num:array [1..100000] of longint;
    x:array [1..100000] of extended;
    list,cnode,pnode,nnode:plist;
    timer:extended;
    heap:array [1..100000] of plist;
procedure qsort(l,r:longint);
var i,j,m,t:longint;
begin
  i:=l;
  j:=r;
  m:=num[l+random(r-l+1)];
  repeat
    while x[num[i]]<x[m] do
      inc(i);
    while x[num[j]]>x[m] do
      dec(j);
    if i<=j then
    begin
      t:=num[i];
      num[i]:=num[j];
      num[j]:=t;
      inc(i);
      dec(j);
    end;
  until i>j;
  if l<j then qsort(l,j);
  if i<r then qsort(i,r);
end;
function doit(a,b:plist):extended;
var ct:extended;
begin
  if (a^.people=0) or (b^.people=0) then
  begin
    doit:=infinity;
    exit;
  end;
  assert(a^.start+100*timer/a^.people<b^.start+100*timer/b^.people+eps);
  if (a^.people=b^.people) and (abs(a^.start+100*timer/a^.people-b^.start-100*timer/b^.people)<eps) then
    doit:=0
  else if a^.people<b^.people then
  begin
    ct:=(b^.start-a^.start)/100*a^.people*b^.people/(b^.people-a^.people);
    if ct<timer-eps then
      ct:=infinity;
    doit:=ct;
  end
  else doit:=infinity;
end;
procedure swap(x,y:longint);
var t:plist;
begin
  t:=heap[x];
  heap[x]:=heap[y];
  heap[y]:=t;
  heap[x]^.hpos:=x;
  heap[y]^.hpos:=y;
end;
procedure siftup(x:longint);
begin
  while (x>1) and (heap[x]^.time<heap[x shr 1]^.time-eps) do
  begin
    swap(x,x shr 1);
    x:=x shr 1;
  end;
end;
procedure siftdown(x:longint);
var left,right,best:longint;
begin
  left:=x shl 1;
  right:=left or 1;
  best:=x;
  if (left<=hlen) and (heap[left]^.time<heap[best]^.time-eps) then
    best:=left;
  if (right<=hlen) and (heap[right]^.time<heap[best]^.time-eps) then
    best:=right;
  if best<>x then
  begin
    swap(best,x);
    siftdown(best);
  end;
end;
procedure hupdate(x:longint);
begin
  siftup(x);
  siftdown(x);
end;
procedure hadd(t:plist);
begin
  inc(hlen);
  heap[hlen]:=t;
  t^.hpos:=hlen;
  siftup(hlen);
end;
procedure insert(t:plist;start:extended;people:longint);
var tmp:plist;
begin
  new(tmp);
  tmp^.start:=start;
  tmp^.people:=people;
  tmp^.next:=t^.next;
  tmp^.prev:=t;
  tmp^.next^.prev:=tmp;
  tmp^.prev^.next:=tmp;
  tmp^.time:=doit(tmp,tmp^.next);
  tmp^.prev^.time:=doit(tmp^.prev,tmp);
  if tmp^.prev^.people<>0 then
    hupdate(tmp^.prev^.hpos);
  hadd(tmp);
end;
procedure hextract(var t:plist);
begin
  t:=heap[1];
  swap(1,hlen);
  dec(hlen);
  if hlen>0 then
    siftdown(1);
end;
procedure delete(t:plist);
var k:longint;
begin
  t^.prev^.next:=t^.next;
  t^.next^.prev:=t^.prev;
  k:=t^.hpos;
  swap(t^.hpos,hlen);
  dec(hlen);
  if k<=hlen then
    hupdate(k);
end;
begin
  assign(input,infile);
  reset(input);
  assign(output,outfile);
  rewrite(output);
  read(n);
  for i:=1 to n do
  begin
    read(k[i],x[i]);
    num[i]:=i;
  end;
  qsort(1,n);
  timer:=0;
  new(list);
  list^.people:=0;
  list^.next:=list;
  list^.prev:=list;
  hlen:=0;
  for i:=1 to n do
    insert(list^.prev,x[num[i]],k[num[i]]);
  while heap[1]^.time<1e50 do
  begin
    {$IFDEF DEBUG}
    cnode:=list^.next;
    while cnode<>list do
    begin
      write(cnode^.people,' ',cnode^.start+100/cnode^.people*timer:0:5,' ');
      cnode:=cnode^.next;
    end;
    writeln;
    {$ENDIF}
    cnode:=heap[1];
    timer:=cnode^.time;
    pnode:=cnode^.prev;
    nnode:=cnode^.next;
    assert(abs(cnode^.start+100/cnode^.people*timer-
               nnode^.start-100/nnode^.people*timer)<eps);
    delete(cnode);
    delete(nnode);
    insert(pnode,cnode^.start+100/cnode^.people*timer-
                 100/(cnode^.people+nnode^.people)*timer,
                 cnode^.people+nnode^.people);
  end;
  answer:=0;
  cnode:=list^.next;
  while cnode<>list do
  begin
    inc(answer);
    cnode:=cnode^.next;
  end;
  writeln(answer);
  cnode:=list^.next;
  while cnode<>list do
  begin
    write(cnode^.people,' ');
    cnode:=cnode^.next;
  end;
  writeln;
  close(input);
  close(output);
end.
