const eps=1e-7;
var heap:array[1..200000]of record
                              a,b:longint;
                              d,x:extended;
                            end;
    p,ng,pg,prev,next:array[0..100000]of longint;
    x:array[0..100000]of extended;
    np,ans,r,n,i,a,b:longint;
    time,xc,d:extended;

procedure swap(a,b:longint);
var t:longint;
    tt:extended;
begin
  next[heap[a].a]:=b;
  prev[heap[a].b]:=b;
  next[heap[b].a]:=a;
  prev[heap[b].b]:=a;
  t:=heap[a].a;
  heap[a].a:=heap[b].a;
  heap[b].a:=t;
  t:=heap[a].b;
  heap[a].b:=heap[b].b;
  heap[b].b:=t;
  tt:=heap[a].d;
  heap[a].d:=heap[b].d;
  heap[b].d:=tt;
  tt:=heap[a].x;
  heap[a].x:=heap[b].x;
  heap[b].x:=tt;
end;

procedure up(x:longint);
label 1;
begin
1:
  if x=1 then
    exit;
  if (heap[x].d+eps<heap[x div 2].d)or(abs(heap[x].d-heap[x div 2].d)<eps)and(heap[x].a<heap[x div 2].a) then
  begin
    swap(x,x div 2);
    x:=x div 2;
    goto 1;
  end;
end;

procedure down(x:longint);
var lc,rc,next:longint;
begin
  lc:=x*2;
  rc:=x*2+1;
  next:=x;
  if lc<=r then
    if (heap[next].d+eps>heap[lc].d)or(abs(heap[next].d-heap[lc].d)<eps)and(heap[next].a>heap[lc].a) then
      next:=lc;
  if rc<=r then
    if (heap[next].d+eps>heap[rc].d)or(abs(heap[next].d-heap[rc].d)<eps)and(heap[next].a>heap[rc].a) then
      next:=rc;
  if next<>x then
  begin
    swap(next,x);
    down(next);
  end;
end;


procedure delete(x:longint);
begin
  if x=0 then
    exit;
  heap[x].a:=heap[r].a;
  heap[x].b:=heap[r].b;
  heap[x].d:=heap[r].d;
  heap[x].x:=heap[r].x;
  prev[heap[x].a]:=0;
  next[heap[x].b]:=0;
  prev[heap[x].b]:=0;
  next[heap[x].a]:=0;
  dec(r);
  up(x);
  down(x);
end;

procedure add(a,b:longint;d,xc:extended);
begin
  inc(r);
  heap[r].a:=a;
  heap[r].b:=b;
  heap[r].d:=d;
  heap[r].x:=xc;
  prev[b]:=r;
  next[a]:=r;
  up(r);
end;

procedure qsort(l,r:longint);
var i,j,t:longint;
    tt,m:extended;
begin
  if l<r then
  begin
    i:=l;
    j:=r;
    m:=x[random(r-l+1)+l];
    while i<j do
    begin
      while x[i]<m do
        inc(i);
      while x[j]>m do
        dec(j);
      if i<=j then
      begin
        tt:=x[i];
        x[i]:=x[j];
        x[j]:=tt;
        t:=p[i];
        p[i]:=p[j];
        p[j]:=t;
        inc(i);
        dec(j);
      end;
    end;
    qsort(l,j);
    qsort(i,r);
  end;
end;

begin
  assign(input,'longpath.in');
  reset(input);
  assign(output,'longpath.out');
  rewrite(output);
  read(n);
  for i:=1 to n do
    read(p[i],x[i]);
  qsort(1,n);
  for i:=1 to n do
  begin
    pg[i]:=i-1;
    ng[i]:=(i+1)*byte(i<>n);
  end;
  r:=0;
  for i:=2 to n do
    if p[i]>p[i-1] then
    begin
      a:=p[i-1];
      b:=p[i];
      d:=(x[i]-x[i-1])*a*b/(b-a);
      xc:=x[i]+d/b;
      add(i-1,i,d,xc);
    end;
  ans:=n;
  time:=0;
  while r<>0 do
  begin
    d:=heap[1].d;
    a:=heap[1].a;
    b:=heap[1].b;
    xc:=heap[1].x;
    time:=time+d;
    ng[a]:=ng[b];
    pg[ng[b]]:=a;
    np:=p[a]+p[b];
    dec(ans);
    p[b]:=0;
    delete(prev[a]);
    delete(1);
    while (r>0)and(abs(heap[1].d-d)<eps)and(abs(heap[1].x-xc)<eps) do
    begin
      b:=heap[1].b;
      np:=np+p[b];
      ng[a]:=ng[b];
      pg[ng[b]]:=a;
      p[b]:=0;
      delete(1);
      dec(ans);
    end;
    delete(next[b]);
    p[a]:=np;
    x[a]:=xc;
    if pg[a]<>0 then
    begin
      x[pg[a]]:=x[pg[a]]+time/p[pg[a]];
      if p[a]>p[pg[a]] then
      begin
        d:=(x[a]-x[pg[a]])*p[a]*p[pg[a]]/(p[a]-p[pg[a]]);
        xc:=x[a]+d/p[a];
        add(pg[a],a,d+time,xc);
      end;
    end;
    if ng[a]<>0 then
    begin
      x[ng[a]]:=x[ng[a]]+time/p[ng[a]];
      if p[ng[a]]>p[a] then
      begin
        d:=(x[ng[a]]-x[a])*p[a]*p[ng[a]]/(p[ng[a]]-p[a]);
        xc:=x[a]+d/p[a];
        add(a,ng[a],d+time,xc);
      end;
    end;
  end;
  writeln(ans);
  for i:=1 to n do
    if p[i]<>0 then
      write(p[i],' ');
  close(input);
  close(output);
end.
