#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#define m 200100

#define eps 1e-7

#define abs(a) ((a) > 0 ? (a) : -(a))

typedef long double ldbl;

int n, k[m], ne[m], pr[m], h[m], vh[m], hs;
ldbl x[m], ts[m];

void sort( int l, int r )
{
  int i, j, t;
  ldbl xx, tt;

  if (l >= r)
    return;
  i = l, j = r, xx = x[l + rand() % (r - l + 1)];
  while (i <= j)
  {
    while (x[i] < xx - eps) i++;
    while (x[j] > xx + eps) j--;
    if (i <= j)
    {
      tt = x[i], x[i] = x[j], x[j] = tt;
      t = k[i], k[i] = k[j], k[j] = t;
      i++, j--;
    }
  }
  sort(l, j), sort(i, r);
}

void swap( int i, int j )
{
  int t;

  t = h[i], h[i] = h[j], h[j] = t;
  vh[h[i]] = i, vh[h[j]] = j;
}

ldbl gett( int i )
{
  return (x[ne[i]] - x[i] - ts[ne[i]] * 100 / k[ne[i]] + ts[i] * 100 / k[i]) * 100 * k[i] * k[ne[i]] / (k[ne[i]] - k[i]);
}

int less( int i, int j )
{
  ldbl t1, t2;

  i = h[i], j = h[j];
  t1 = gett(i);
  t2 = gett(j);
//  t1 = (ts[i] + (x[ne[i]] - x[i]) * k[i] * k[ne[i]] / 100 / (k[i] + k[ne[i]]));
//  t2 = (ts[j] + (x[ne[j]] - x[j]) * k[j] * k[ne[j]] / 100 / (k[j] + k[ne[j]]));
  if (abs(t1 - t2) < eps)
    return i < j;
  return t1 < t2;
}

void siftup( int i )
{
  while (i > 1 && less(i, i >> 1))
    swap(i, i >> 1), i >>= 1;
}

void siftdown( int i )
{
  int l, r, e;

  while (i <= hs)
  {
    l = i << 1, r = l + 1, e = i;
    if (l <= hs && less(l, e)) e = l;
    if (r <= hs && less(r, e)) e = r;
    if (e == i)
      break;
    swap(i, e), i = e;
  }
}

void add( int i )
{
  if (vh[i] != -1)
    return;
  h[++hs] = i, vh[i] = hs;
  siftup(hs);
}

void del( int i )
{
  int j;
  
  if (vh[i] == -1)
    return;
  j = h[hs];
  swap(vh[i], hs--);
  vh[i] = -1;
  siftdown(vh[hs]);
  siftup(vh[hs]);
}

int main( void )
{
  int i, j, l, st;
  ldbl dx, dt;

  st = clock();
  srand(301703);
  freopen("longpath.in", "rt", stdin);
  freopen("longpath.out", "wt", stdout);
  scanf("%d", &n);
  for (i = 0; i < n; i++)
    scanf("%d%Lf", &k[i], &x[i]), ts[i] = 0;
  sort(0, n - 1);
  for (i = 0; i < n; i++)
    ne[i] = i + 1, pr[i] = i - 1;
  ne[i - 1] = pr[0] = -1;
  hs = 0;
  memset(vh, -1, sizeof(vh));
  for (i = 0; i < n - 1; i++)
    if (k[i + 1] > k[i])
      add(i);
  while (hs > 0)
  {
    i = h[1], del(i);
    for (j = i; ne[j] != -1 && k[ne[j]] > k[j] && abs(gett(j) - gett(i)) < eps; j = ne[j])
      ;
    dt = gett(i) - ts[i];
    dx = dt * 100 / k[i];
    ts[i] += dt;
    x[i] += dx;
    for (l = ne[i]; l != ne[j]; l = ne[l])
      del(l), k[i] += k[l];
    ne[i] = ne[j];
    if (ne[i] != -1)
      pr[ne[i]] = i;
    if (pr[i] != -1 && k[pr[i]] < k[i])
    {
      del(pr[i]);
      add(pr[i]);
    }
    if (ne[i] != -1 && k[i] < k[ne[i]])
      add(i);
    if (clock() - st > 1.9 * CLOCKS_PER_SEC)
      break;
  }
  n = 0;
  for (i = 0; i != -1; i = ne[i])
    n++;
  printf("%d\n", n);
  for (i = 0; i != -1; i = ne[i])
    printf("%d ", k[i]);
  return 0;
}
