program cpas;

const maxn = 100010;
      inf = 1.0e12;

type integer = longint;
     real = extended;
     tgr = record
        k, next, pos : integer;
        x, t : real;
     end;

var g : array [1..maxn] of tgr;
    h : array [0..maxn] of integer;
    i, n, hs, cur, nxt : integer;

procedure Sort(l, r : integer);
var i, j : integer;
    x, y : tgr;
begin
   i := l; j := r; x := g[l+random(r-l+1)];
   repeat
      while g[i].x < x.x do inc(i);
      while g[j].x > x.x do dec(j);
      if i <= j then begin
         y := g[i]; g[i] := g[j]; g[j] := y;
         inc(i); dec(j);
      end;
   until i > j;
   if i < r then Sort(i, r);
   if j > l then Sort(l, j);
end;

procedure pushup(v : integer);
begin
   while (v > 1) and (g[h[v]].t < g[h[v div 2]].t) do begin
      g[h[v div 2]].pos := v;
      g[h[v]].pos := v div 2;
      h[0] := h[v div 2]; h[v div 2] := h[v]; h[v] := h[0];
      i := v div 2;
   end;
end;

procedure pull(v : integer);
var minv : integer;
begin
   i := v;
   minv := 0;
   while (i <> minv) do begin
      minv := i;
      if 2*i <= hs then
         if g[h[minv]].t > g[h[2*i]].t then minv := 2*i;
      if 2*i < hs then
         if g[h[minv]].t > g[h[2*i+1]].t then minv := 2*i+1;
      if minv <> i then begin
         g[h[minv]].pos := i;
         g[h[i]].pos := minv;
         h[0] := h[i]; h[i] := h[minv]; h[minv] := h[0];
         i := minv;
         minv := 0;
      end;
   end;
end;

function extract(v : integer) : integer;
begin
   extract := h[v];
   h[v] := h[hs];
   g[h[v]].pos := v;
   dec(hs);
   if v <= hs then begin
      pull(v);
      pushup(v);
   end;
end;

function pop : integer;
begin
   pop := extract(1);
end;

procedure push(v : integer);
begin
   inc(hs);
   h[hs] := v;
   if g[v].k < g[g[v].next].k then
      g[v].t := (g[g[v].next].x-g[v].x)/(100/g[v].k-100/g[g[v].next].k)
   else
      g[v].t := inf;
   g[v].pos := hs;
   pushup(hs);
end;

begin
   randseed := 3751;
   assign(Input, 'longpath.in');
   reset(Input);
   assign(Output, 'longpath.out');
   rewrite(Output);
   
   read(n);
   for i := 1 to n do
      read(g[i].k, g[i].x);
   inc(n);
   g[n].k := 1;
   g[n].x := 20000;
   Sort(1, n);
   hs := 0;
   for i := 1 to n-1 do
      g[i].next := i+1;
   for i := 1 to n-1 do
      push(i);
   while (g[h[1]].t < inf/2) do begin
      cur := extract(1);
      nxt := extract(g[g[cur].next].pos);
      g[cur].next := g[nxt].next;
      g[cur].x := g[cur].x+g[cur].t*100/g[cur].k;
      g[cur].k := g[cur].k+g[nxt].k;
      g[cur].x := g[cur].x-g[cur].t*100/g[cur].k;
      push(cur);
   end;
   writeln(hs);
   for i := 1 to hs-1 do write(g[h[i]].k, ' ');
   writeln(g[h[hs]].k);

   close(Input);
   close(Output);
end.
