#include <stdio.h>

char const* problem = "details";

#define relax(a,b) if(a>(b))a=(b)

int num_details;
int num_a;
int a_speed [32];
int num_b;
int b_speed [32];

int ans_a;
int ans_b;

void read_input ()
{
  char buf [256];
  sprintf ( buf, "%s.in", problem );
  FILE* f = fopen ( buf, "rt" );

  fscanf ( f, "%d", &num_details );
  
  fscanf ( f, "%d", &num_a );
  for ( int i = 0; i < num_a; i++ )
    fscanf ( f, "%d", &a_speed [i] );

  fscanf ( f, "%d", &num_b );
  for ( int i = 0; i < num_b; i++ )
    fscanf ( f, "%d", &b_speed [i] );

  fclose ( f );
}
void write_output ()
{
  char buf [256];
  sprintf ( buf, "%s.out", problem );
  FILE* f = fopen ( buf, "wt" );

  fprintf ( f, "%d\n%d", ans_a, ans_b );
  
  fclose ( f );
}

struct kpair
{
  int key, value;
};

kpair heap [32];
int hsize = 0;

void h_push ( int key, int value )
{
  int cur = hsize++;
  while ( cur > 0 )
  {
    int p = ( cur + 1 ) / 2 - 1;
    if ( heap [p].key <= key )
    {
      heap [cur].key = key;
      heap [cur].value = value;
      return;
    }
    heap [cur].key = heap [p].key;
    heap [cur].value = heap [p].value;
    cur = p;
  }
  heap [cur].key = key;
  heap [cur].value = value;
}

int h_pop ()
{
  int ret = heap [0].value;
  
  hsize--;

  int cur = 0;
  while ( cur * 2 + 1 < hsize )
  {
    int k = hsize;
    int j = cur * 2 + 1;
    if ( heap [j].value < heap [k].value )
      k = j;
    j++;
    if ( j < hsize && heap [j].value < heap [k].value )
      k = j;
    if ( k == hsize )
    {
      heap [cur].key = heap [hsize].key;
      heap [cur].value = heap [hsize].value;
      return ret;
    }
    heap [cur].key = heap [k].key;
    heap [cur].value = heap [k].value;
    cur = k;
  }
  heap [cur].key = heap [hsize].key;
  heap [cur].value = heap [hsize].value;

  return ret;
}

inline void h_clear ()
{
  hsize = 0;
}
inline bool h_empty ()
{
  return hsize == 0;
}

void solve ()
{
  int free_a [32];
  int free_b [32];
  for ( int i = 0; i < num_a; i++ ) free_a [i] = -1;
  for ( int i = 0; i < num_b; i++ ) free_b [i] = 1000000;

  int pool_a = num_details;
  int pool_b = 0;
  int out = 0;

  int ctime = 0;
  
  int b_pool [1024];

  while ( true )
  {
    h_clear ();

    int min_time = 1000000;
    for ( int i = 0; i < num_a; i++ )
    {
      if ( free_a [i] <= ctime )
      {
        if ( free_a [i] >= 0 )
        {
          b_pool [pool_b] = ctime;
          pool_b++;
        }
        free_a [i] = -1;
        h_push ( a_speed [i], i );
      }
      else
        relax ( min_time, free_a [i] );
    }
    while ( pool_a > 0 && !h_empty () )
    {
      int i = h_pop ();
      pool_a--;
      free_a [i] = ctime + a_speed [i];
      relax ( min_time, free_a [i] );
    }

    if ( pool_b >= num_details )
      break;

    ctime = min_time;
  }

  ans_a = ctime;

  ans_b = 0;
  for ( int j = pool_b-1; j >= 0; j-- )
  {
    int fast = -1;
    int speed = 1000;
    for ( int i = 0; i < num_b; i++ )
    {
      if ( free_b [i] >= b_pool [j] + b_speed [i] && b_speed [i] < speed )
      {
        fast = i;
        speed = b_speed [i];
      }
    }
    if ( fast >= 0 )
    {
      free_b [fast] = b_pool [j];
      if ( ans_b < b_pool [j] + b_speed [fast] )
        ans_b = b_pool [j] + b_speed [fast];
    }
  }
}

int main ()
{
  read_input ();
  solve ();
  write_output ();

  return 0;
}
