#include <stdio.h>

char const* problem = "batch";

int n;
int S;

struct batch
{
  int time;
  int cost;
  int right;

  batch* prev;
  batch* next;
};
batch batch_pool [16384];

batch* first;
batch* last;

void merge_batch ( batch* b )
{
  if ( b->prev )
  {
    b->prev->cost += b->cost;
    b->prev->time += b->time;
    b->prev->next = b->next;
  }
  else
    return;
  if ( b->next )
    b->next->prev = b->prev;
  else
    last = b->prev;
}

void read_input ()
{
  char buf [256];
  sprintf ( buf, "%s.in", problem );
  FILE* f = fopen ( buf, "rt" );

  fscanf ( f, "%d %d", &n, &S );

  for ( int i = 0; i < n; i++ )
  {
    fscanf ( f, "%d %d", &batch_pool [i].time, &batch_pool [i].cost );
    if ( i > 0 )
      batch_pool [i].prev = &batch_pool [i-1];
    else
      batch_pool [i].prev = NULL;
    if ( i < n-1 )
      batch_pool [i].next = &batch_pool [i+1];
    else
      batch_pool [i].next = NULL;
  }
  first = batch_pool;
  last = &batch_pool [n-1];

  last->right = last->cost;
  for ( int i = n-2; i >= 0; i-- )
    batch_pool [i].right = batch_pool [i+1].right + batch_pool [i].cost;
  
  fclose ( f );
}
void write_output ()
{
  char buf [256];
  sprintf ( buf, "%s.out", problem );
  FILE* f = fopen ( buf, "wt" );

  int t = 0;
  int cost = 0;
  batch* cur = first;
  while ( cur != NULL )
  {
    t += cur->time + S;
    cost += cur->cost * t;

    cur = cur->next;
  }

  fprintf ( f, "%d", cost );
  
  fclose ( f );
}

void solve ()
{
  batch* cur = first;
  while ( cur != NULL && cur->next != NULL )
  {
    if ( cur->cost * cur->next->time < S * cur->next->right )
      merge_batch ( cur->next );
    else
      cur = cur->next;
  }
}

int main ()
{
  read_input ();
  solve ();
  write_output ();

  return 0;
}
