#include <cstdio>
#include <algorithm>

#define shift 2097151
#define treesize 4194304
#define size 1500000
#define MIN(a, b) ((a)<(b)?(a):(b))
#define MAX(a, b) ((a)>(b)?(a):(b))

struct Ans{
  int A, B;
  friend bool operator<(const Ans& x, const Ans& y){
    return x.A<y.A;
  }
  friend bool operator==(const Ans& x, const Ans& y){
    return x.A==y.A&&x.B==y.B;
  }
} ans[size];

int tMin[treesize], tMax[treesize];
int a[size+1], b[size+1], n, i, ansc;

void BuildTrees(){
  int i;
  for (i=1; i<=n; i++)
    tMin[i+shift]=tMax[i+shift]=a[i];
  for (i=shift; i>=1; i--){
    tMin[i]=MIN(tMin[i*2], tMin[i*2+1]);
    tMax[i]=MAX(tMax[i*2], tMax[i*2+1]);
  }
}

int min(int i, int j){
  int ans=n;
  i+=shift;
  j+=shift;
  while (i<=j){
    if ((i&1)==1){
      ans=MIN(ans, tMin[i]);
      i++;
    }
    if ((j&1)==0){
      ans=MIN(ans, tMin[j]);
      j--;
    }
    i>>=1;
    j>>=1;
  }
  return ans;
}

int max(int i, int j){
  int ans=0;
  i+=shift;
  j+=shift;
  while (i<=j){
    if ((i&1)==1){
      ans=MAX(ans, tMax[i]);
      i++;
    }
    if ((j&1)==0){
      ans=MAX(ans, tMax[j]);
      j--;
    }
    i>>=1;
    j>>=1;
  }
  return ans;
}

bool rec(int i, int j){
  if (j-i+1<4) return false;
  int l=b[min(i, j)], r=b[max(i, j)];
  bool an=false;
  if (l==i&&r==j){
    bool x=rec(l+1, r), y=rec(l, r-1);
    if (x==false&&y==false&&r-l==a[r]-a[l]){
      ans[ansc].A=l;
      ans[ansc].B=r;
      ansc++;
    }
    return true;
  } else if (l<r){
    if (rec(i, l-1)) an=true;
    if (rec(l, r)) an=true;
    if (rec(r+1, j)) an=true;
  } else {
    if (rec(i, r)) an=true;
    if (rec(r+1, l-1)) an=true;
    if (rec(l, j)) an=true;
  }
  return an;
}

int main(){
  freopen("empodio.in", "rt", stdin);
  freopen("empodio.out", "wt", stdout);
  scanf("%d", &n);
  for (i=1; i<=n; i++){
    scanf("%d", &a[i]);
    a[i]++;
    b[a[i]]=i;
  }
  BuildTrees();
  rec(1, n);
  std::sort(&ans[0], &ans[ansc]);
  ansc=std::unique(&ans[0], &ans[ansc])-&ans[0];
  if (ansc==1&&ans[0].A==1&&ans[0].B==n) ansc--;
  printf("%d\n", ansc);
  for (i=0; i<ansc; i++) printf("%d %d\n", ans[i].A, ans[i].B);
  return 0;
}
