#include <stdio.h>
#include <memory.h>
#include <string.h>
#include <algorithm>
#include <set>
#include <time.h>

#define WORK_TIME 1800
#define NUM 10010

int n, s;
int f[NUM], t[NUM];
int fs[NUM], ts[NUM];
int curr[NUM];
int prev[NUM];
int prmin[NUM];
int answer;
int gtime;
struct Column {
	int x, v;
};
Column carr[NUM];
bool deld[NUM];
int pl[NUM], nl[NUM];
int cnum;
int stime;

bool cmpColumns(Column a, Column b) {
	return (a.x - a.v*gtime) < (b.x - b.v*gtime);
}
struct Event {
	int time;
	int u, v;
};
struct cmpEvents {
	inline bool operator() (const Event &a, const Event &b) const {
		if (a.time == b.time)
			return a.u < b.u;
		return a.time < b.time;
	}
};
typedef std::set<Event, cmpEvents> eSet;
typedef eSet::iterator sIter;
eSet es;

int main(int argc, char **argv) {
	freopen("batch.in", "r", stdin);
	freopen("batch.out", "w", stdout);
	stime = clock();
	int i, k, l;
	scanf("%d%d", &n, &s);
	for (i = 0; i<n; i++)
		scanf("%d%d", t+i, f+i);
	ts[0] = 0;
	for (i = 1; i<=n; i++)
		ts[i] = ts[i-1] + t[i-1];
	fs[0] = 0;
	for (i = 1; i<=n; i++)
		fs[i] = fs[i-1] + f[i-1];
	answer = (1<<31)-1;
	for (i = 0; i<=n; i++)
		prev[i] = (1<<31)-1;
	prev[0] = 0;
	for (k = 1; k<=n; k++) {
		for (i = 0; i<=n; i++)
			curr[i] = (1<<31)-1;
		gtime = 0;
		cnum = 0;
		for (i = 0; i<=n; i++)
			if (prev[i] < (1<<31)-1) {
				prev[i] -= k*s*fs[i];
				Column nc;
				nc.x = prev[i];
				nc.v = fs[i];
				carr[cnum] = nc;
				cnum++;
			}
		std::sort(carr, carr+cnum, cmpColumns);
		memset(deld, 0, cnum*sizeof(bool));
		es.clear();
		pl[0] = -1;
		nl[cnum-1] = -1;
		for (i = 0; i<cnum-1; i++) {
			pl[i+1] = i;
			nl[i] = i+1;
			if (carr[i+1].v > carr[i].v) {
				Event ne;
				int dv = (carr[i+1].v - carr[i].v);
				ne.time = (carr[i+1].x - carr[i].x - 1) / dv;
				ne.u = i;
				ne.v = i+1;
				es.insert(ne);
			}
		}
		l = 0;
		for (i = k; i<=n; i++) {
			if (es.size() > 0)
			while (es.begin()->time < ts[i]) {
				sIter it = es.begin();
				int itu = it->u;
				int itv = it->v;
				es.erase(it);
				if (!deld[itu] && !deld[itv]) {
					deld[itu] = true;
					if (itu == l)
						l = nl[itu];
					if (nl[itu] >= 0)
						pl[nl[itu]] = pl[itu];
					if (pl[itu] >= 0)
						nl[pl[itu]] = nl[itu];
					Event ne;
					if (pl[itu] >= 0) {
						int dv = (carr[itu].v - carr[pl[itu]].v);
						if (dv > 0) {
							ne.time = (carr[itu].x - carr[pl[itu]].x - 1) / dv;
							ne.u = pl[itu];
							ne.v = itu;
							es.erase(es.find(ne));
						}
						dv = (carr[nl[itu]].v - carr[pl[itu]].v);
						if (dv > 0) {
							ne.time = (carr[nl[itu]].x - carr[pl[itu]].x - 1) / dv;
							ne.u = pl[itu];
							ne.v = nl[itu];
							es.insert(ne);
						}
					}
				}
				if (es.size() == 0)
					break;
			}
			gtime = ts[i];
			int tr = carr[l].x - carr[l].v * gtime;
			if (curr[i] > tr)
				curr[i] = tr;
			if ((curr[i] < 0) || (curr[i] < (1<<31)-1))
				curr[i] += (k*s + ts[i]) * fs[i];
		}
		if (curr[n] < answer)
			answer = curr[n];
		if ((clock()-stime)*1000 > WORK_TIME*CLOCKS_PER_SEC)
			break;
		memcpy(prev, curr, (n+1)*sizeof(int));
	}
	printf("%d", answer);
}
