#include <cstdio>
#include <string>
#include <iostream>

#define shift 1023
#define tsize 2048

#define MIN(a, b) ((a)<(b)?(a):(b))

int l[tsize], r[tsize], k[tsize], m[tsize], mid[tsize];
int f[26], next[1000], s[26], ch[26], chsize;
int i, j, sum;
std::string a;

void buildtree(int p, int i, int j){
  l[p]=i;
  r[p]=j;
  if (i<j){
    buildtree(p*2+1, i, (i+j-1)/2);
    buildtree(p*2+2, (i+j+1)/2, j);
    mid[p]=(i+j-1)/2;
  }
}

void add(int p, int i, int j, int delta){
  if (i==l[p]&&j==r[p]){
    k[p]+=delta;
    return;
  }
  if (j<=mid[p])
    add(p*2+1, i, j, delta);
  else if (i>mid[p])
    add(p*2+2, i, j, delta);
  else {
    add(p*2+1, i, mid[p], delta);
    add(p*2+2, mid[p]+1, j, delta);
  }
  m[p]=MIN(m[p*2+1]+k[p*2+1], m[p*2+2]+k[p*2+2]);
}

int get(int p, int i, int j){
  if (i==l[p]&&j==r[p])
    return m[p]+k[p];
  if (j<=mid[p])
    return get(p*2+1, i, j)+k[p];
  else if (i>mid[p])
    return get(p*2+2, i, j)+k[p];
  else
    return MIN(get(p*2+1, i, mid[p]), get(p*2+2, mid[p]+1, j))+k[p];
}

int g(int i){
  int ans=0;
  for (; i; i>>=1) ans+=i&1;
  return ans;
}

int change(int i){
  int j;
  s[i]*=-1;
  for (j=f[i]; j!=-1; j=next[j]){
    sum+=s[i]*2;
    add(0, 0, a.size(), s[i]*2);
  }
}

int main(){
  freopen("brackets2.in", "rt", stdin);
  freopen("brackets2.out", "wt", stdout);
  buildtree(0, 0, 1023);
  std::cin>>a;
  for (i=0; i<26; i++) f[i]=-1;
  for (i=0; i<a.size(); i++){
    next[i]=f[a[i]-'a'];
    f[a[i]-'a']=i;
  }
  if (a[0]==a[a.size()-1]){
    printf("IMPOSSIBLE");
    return 0;
  }
  s[a[0]-'a']=1;
  for (i=f[a[0]-'a']; i!=-1; i=next[i]){
    sum++;
    add(0, i+1, a.size(), 1);
  }
  f[a[0]-'a']=-1;
  s[a[a.size()-1]-'a']=-1;
  for (i=f[a[a.size()-1]-'a']; i!=-1; i=next[i]){
    sum--;
    add(0, i+1, a.size(), -1);
  }
  f[a[a.size()-1]-'a']=-1;
  for (i=0; i<26; i++){
    if (f[i]==-1) continue;
    s[i]=-1;
    for (j=f[i]; j!=-1; j=next[j]){
      sum--;
      add(0, j+1, a.size(), -1);
    }
    ch[chsize++]=i;
  }
  for (i=1; i<(1<<chsize); i++){
    change(ch[g(i)-1]);
    if (sum==0&&get(0, 0, a.size())==0) break;
  }
  if (sum==0&&get(0, 0, a.size())==0){
    for (i=0; i<a.size(); i++)
      printf("%c", s[a[i]-'a']==1?'(':')');
  } else
    printf("IMPOSSIBLE");
  return 0;
}
