#include <cstdio>
#include <memory.h>
#include <cctype>

#define maxn 62


using namespace std;

inline char up(char ch)
{
	return ch+'A'-'a';
}

inline char down(char ch)
{
	return ch-'A'+'a';
}

char ss1[maxn],ss2[maxn],s1[maxn],s2[maxn];
long u1[maxn],u2[maxn],l1[maxn],l2[maxn],n1,n2;
signed char d[maxn][maxn][maxn][maxn];

inline long count1(long x,long y)
{
	return (u1[y]-u1[x-1])-(l1[y]-l1[x-1]);
}

inline long count2(long x,long y)
{
	return (u2[y]-u2[x-1])-(l2[y]-l2[x-1]);
}

inline bool good(long x1,long y1,long x2,long y2)
{
	return (count1(x1,y1)+count2(x2,y2))==0;
}

char stk[maxn],sth;
inline bool check1(long x,long y)
{
	sth=0;
	for(long i=x;i<=y;i++){
		if(sth==0){
			if(!isupper(s1[i])) return false;
			stk[sth++]=s1[i];
		} else{
			if(isupper(s1[i])) stk[sth++]=s1[i];
			else{
				if(stk[sth-1]!=up(s1[i])) return false;
				sth--;
			}
		}
	}
	return true;
}

inline bool check2(long x,long y)
{
	sth=0;
	for(long i=x;i<=y;i++){
		if(sth==0){
			if(!isupper(s2[i])) return false;
			stk[sth++]=s2[i];
		} else{
			if(isupper(s2[i])) stk[sth++]=s2[i];
			else{
				if(stk[sth-1]!=up(s2[i])) return false;
				sth--;
			}
		}
	}
	return true;
}

inline void dbgout(char *s,long x1,long y1,long x2,long y2,long v)
{
/*	printf(s,x1,y1,x2,y2,v);*/
}

bool f(long x1,long y1,long x2,long y2)
{
/*	printf("Starting %d %d %d %d...\n",x1,y1,x2,y2);*/
	if((x1>y1)&&(x2>y2)){
		dbgout("%d,%d,%d,%d, returning %d\n",x1,y1,x2,y2,1); 
		return 1;
	}
	if(d[x1][y1][x2][y2]!=-1){
		dbgout("%d,%d,%d,%d, returning %d\n",x1,y1,x2,y2,d[x1][y1][x2][y2]); 
		return d[x1][y1][x2][y2];
	}
	if(x1>y1){
		d[x1][y1][x2][y2]=check2(x2,y2) ? 1:0;
		dbgout("%d,%d,%d,%d, returning %d\n",x1,y1,x2,y2,d[x1][y1][x2][y2]); 
		return d[x1][y1][x2][y2];
	}
	if(x2>y2){
		d[x1][y1][x2][y2]=check1(x1,y1) ? 1:0;
		dbgout("%d,%d,%d,%d, returning %d\n",x1,y1,x2,y2,d[x1][y1][x2][y2]); 
		return d[x1][y1][x2][y2];
	}
	if(!good(x1,y1,x2,y2)){
		d[x1][y1][x2][y2]=0;
		dbgout("%d,%d,%d,%d, returning %d after heuristic\n",x1,y1,x2,y2,d[x1][y1][x2][y2]); 
		return 0;
	}
	
	/*1st - 1,2st - 1*/
	if(isupper(s1[x1])){
		for(long i=x1+1;i<=y1;i++){
			if((!islower(s1[i]))||(up(s1[i])!=s1[x1])) continue;
			for(long j=x2-1;j<=y2;j++){
/*				printf("j=%d, calling %d,%d,%d,%d and %d,%d,%d,%d\n",j,x1,i,x2,j,i+1,y1,j+1,y2);*/
				if(f(x1+1,i-1,x2,j)&&(f(i+1,y1,j+1,y2))){
					d[x1][y1][x2][y2]=1;
					dbgout("%d,%d,%d,%d, returning %d\n",x1,y1,x2,y2,d[x1][y1][x2][y2]); 
					return 1;
				}
			}
		}
	}
	/*1st - 1,2st - 2*/
/*	if((x1==1)&&(y1==4)&&(x2==1)&&(y2==4)) printf("now is the main part\n");*/
	if(isupper(s1[x1])){
		for(long i=x2;i<=y2;i++){
/*			if((x1==1)&&(y1==4)&&(x2==1)&&(y2==4)) printf("trying to proccess %d,%d, expr1=%d, expr2=%d, s2[i]=%c,s1[x1]=%c\n",x1,i,(!islower(s2[i])),(up(s2[i])!=s1[x1]),s2[i],s1[x1]);*/
			if((!islower(s2[i]))||(up(s2[i])!=s1[x1])) continue;
			for(long j=x1;j<=y1;j++)
				if(f(x1+1,j,x2,i-1)&&(f(j+1,y1,i+1,y2))){
					d[x1][y1][x2][y2]=1;
					dbgout("%d,%d,%d,%d, returning %d\n",x1,y1,x2,y2,d[x1][y1][x2][y2]); 
					return 1;
				}
		}
	}
	/*1st - 2,2st - 1*/
	if(isupper(s2[x2])){
		for(long i=x1;i<=y1;i++){
			if((!islower(s1[i]))||(up(s1[i])!=s2[x2])) continue;
			for(long j=x2;j<=y2;j++)
				if(f(x1,i-1,x2+1,j)&&(f(i+1,y1,j+1,y2))){
					d[x1][y1][x2][y2]=1;
					dbgout("%d,%d,%d,%d, returning %d\n",x1,y1,x2,y2,d[x1][y1][x2][y2]); 
					return 1;
				}
		}
	}
	/*1st - 2,2st - 2*/
	if(isupper(s2[x2])){
		for(long i=x2+1;i<=y2;i++){
			if((!islower(s2[i]))||(up(s2[i])!=s2[x2])) continue;
			for(long j=x1-1;j<=y1;j++)
				if(f(x1,j,x2+1,i-1)&&(f(j+1,y1,i+1,y2))){
					d[x1][y1][x2][y2]=1;
					dbgout("%d,%d,%d,%d, returning %d\n",x1,y1,x2,y2,d[x1][y1][x2][y2]); 
					return 1;
				}
		}
	}

	d[x1][y1][x2][y2]=0;
	dbgout("%d,%d,%d,%d, nothing found, returning %d\n",x1,y1,x2,y2,d[x1][y1][x2][y2]); 
	return 0;
} 

void work()
{
	scanf("%s%s",ss1,ss2);
	n1=0;
	for(long i=0;ss1[i]!=0;i++)
		s1[i+1]=ss1[i],n1++;
	n2=0;
	for(long i=0;ss2[i]!=0;i++)
		s2[i+1]=ss2[i],n2++;
	u1[0]=0,u2[0]=0,l1[0]=0,l2[0]=0;
	for(long i=1;i<=n1;i++){
		if(isupper(s1[i])) u1[i]=u1[i-1]+1,l1[i]=l1[i-1];
		else u1[i]=u1[i-1],l1[i]=l1[i-1]+1;
	}
	for(long i=1;i<=n2;i++){
		if(isupper(s2[i])) u2[i]=u2[i-1]+1,l2[i]=l2[i-1];
		else u2[i]=u2[i-1],l2[i]=l2[i-1]+1;
	}
	for(long i=0;i<=n1;i++)
		for(long j=i;j<=n1;j++)
			for(long x=0;x<=n2;x++)
				for(long y=x;y<=n2;y++)
					d[i][j][x][y]=-1;
	printf("%s\n",f(1,n1,1,n2) ? "YES":"NO");
}

int main()
{
	long test_count;
	freopen("brackets3.in","r",stdin);
	freopen("brackets3.out","w",stdout);
	scanf("%d",&test_count);
	for(long i=1;i<=test_count;i++)
		work();
	fclose(stdout);
	fclose(stdin);
	return 0;
}
