#include <stdio.h>
#include <math.h>

#define EPS 1e-16

template <class T>
inline T sqr (T t)
{ return t * t; }

const double nRadius = 0.3535533905932738;
const double nDist = 0.6123724356957945;

int main ()
{
  freopen ( "tetrahedron.in", "rt", stdin );
  freopen ( "tetrahedron.out", "wt", stdout );

  int i, j;
  int d [4][4];

  for (i = 0; i < 4; i++)
    for (j = i + 1; j < 4; j++)
      scanf ("%d", &d[i][j]), d[j][i] = d[i][j];

  // check tetra
  double p = double (d[0][1] + d[0][2] + d[1][2]) / 2;
  double s = p * (p - d[0][1]) * (p - d[0][2]) * (p - d[1][2]);
  if (s < EPS)
  {printf ("IMPOSSIBLE"); return 0;}
  s = sqrt (s) / 4;
  double h012 = s * 2 / d[0][1];
  double sl = sqrt (sqr (d[0][2]) - sqr (h012));
  double c = (sqr (d[0][1]) + sqr (d[0][3]) - sqr (d[1][3])) / (2 * d[0][1] * d[0][3]);
  double dl = sqr (sl) + sqr (d[0][3]) - 2 * c * d[0][3] * sl;
  if (dl < EPS)
  {printf ("IMPOSSIBLE"); return 0;}
  dl = sqrt (dl);
  double px = (h012 + dl + d[2][3]) / 2;
  if (p * (p - h012) * (p - dl) * (p - d[2][3]) < EPS)
  {printf ("IMPOSSIBLE"); return 0;}

  double x;
  if (d[0][1] == d[0][2] && d[0][1] == d[0][3] && d[0][1] == d[1][2] && d[0][1] == d[1][3] && d[0][1] == d[2][3])
    x = d[0][1] * nDist, printf ("YES\n%.16lf\n%.16lf\n%.16lf\n%.16lf\n%.16lf", nRadius * d[0][1], x, x, x, x);
  else
    printf ("NO");

  return 0;
}
