{$H-,B-,I-,Q-,R-,S-}
{H-,B-,I+,Q+,R+,S+}
const
 eps=1e-15;
type
 int   = integer;
 rl    = extended;
 point = record x,y,z:rl; end;
 line  = record a,b:point; end;
var
 k     : array[0..3]of point;
 O,p1,p2,c: point;
 d01,d02,d03,d12,d13,d23,
 xp,yp,l,r,d1,d2,xb,yb:rl;
 i,j:int;
 ok:boolean;

procedure print_error();
begin
 writeln('IMPOSSIBLE');
 close(input);
 close(output);
 halt(0);
end;

function getline(p1,p2:point):line;
var r:line;
begin
 r.a:=p1; r.b:=p2;
 getline:=r;
end;
function d(a,b:point):rl;
var r:rl;
begin
 r:=(a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y)+(a.z-b.z)*(a.z-b.z);
 if (r>eps)
  then d:=sqrt(r)
  else d:=0;
end;
function area(P,Q,R:point):rl;
var a,b,c,s:rl;
begin
 a:=d(P,Q); b:=d(Q,R); c:=d(R,P);
 s:=(a+b-c)*(b+c-a)*(c+a-b)*(a+b+c);
 area:=sqrt(s+eps)/4;
end;
function dist(p:point;m:line):rl;
var s:rl;
begin
 s:=area(p,m.a,m.b);
 dist:=2*s/d(m.a,m.b);
end;
function mindist(p:point):real;
var
 r:rl;
 i,j:int;
begin
 r:=1e10;
 for i:=0 to 3 do
  for j:=i+1 to 3 do
   if (r>dist(p,getline(k[i],k[j]))) then r:=dist(p,getline(k[i],k[j]));
 mindist:=r;
end;

Begin
 //init
 assign(input,'tetrahedron.in');
 reset(input);
 assign(output,'tetrahedron.out');
 rewrite(output);
 O.x:=0; O.y:=0; O.z:=0;
 read(d01,d02,d03,d12,d13,d23);
 //finding tetrahedron koordinates
 fillchar(k,sizeof(k),0);
 k[2].y:=d12;
 yp:=(sqr(d13)+sqr(d12)-sqr(d23))/(2*d12);
 if (sqr(d13)-sqr(yp)<eps) then print_error;
 xp:=sqrt(sqr(d13)-sqr(yp));
 k[3].x:=xp; k[3].y:=yp;
 k[0].y:=(sqr(d01)+sqr(d12)-sqr(d02))/(2*d12);
 k[0].x:=(sqr(d01)+sqr(d13)-sqr(d03)-2*yp*k[0].y)/(2*xp);
 if (sqr(d01)-sqr(k[0].x)-sqr(k[0].y)<eps) then print_error;
 k[0].z:=sqrt(sqr(d01)-sqr(k[0].x)-sqr(k[0].y));
 //solution
 {
 v12.x:=0; v12.y:=1; v12.z:=0;
 v13.x:=xp/sqrt(sqr(xp)+sqr(yp)); v13.y:=yp/sqrt(sqr(xp)+sqr(yp)); v13.z:=0;
 v1.x:=
 }
 xb:=k[0].x;
 yb:=k[0].y;
 p1.x:=xb; p1.y:=yb;
 p2.x:=xb; p2.y:=yb;
 l:=0; r:=k[0].z;
 while (r-l>eps/10) do begin
  p1.z:=1/3*(r-l)+l;
  p2.z:=2/3*(r-l)+l;
  d1:=mindist(p1);
  d2:=mindist(p2);
  if (d1<d2)
   then l:=p1.z
   else r:=p2.z;
 end;
 //Output
 ok:=true;
 c:=p1;
 d1:=dist(c,getline(k[0],k[1]));
 for i:=0 to 3 do
  for j:=i+1 to 3 do
   if (abs(d1-dist(c,getline(k[i],k[j])))>eps*10) then ok:=false;
 if (ok) then begin
  writeln('YES');
  writeln(d1:0:14);
  for i:=0 to 3 do begin
   d2:=d(c,k[i]);
   writeln(d2:0:14);
  end;
 end else begin
  writeln('NO');
 end;
 close(input);
 close(output);
End.
