{$I-,Q-,R-,S-}
//{$I+,Q+,R+,S+}
program Temp;

const
 in_f='tetrahedron.in';
 out_f='tetrahedron.out';
type
  int=longint;
  real=extended;
  bool=boolean;
  TPOint=record
      x,y,z:real;
    end;
const
  N=4;
  imp='IMPOSSIBLE';
  no='NO';
  yes='YES';
  eps=1e-18;
  epsB=1e-18;
  inf=100000;
var
  d:array[1..N,1..N] of real;
  p:array[1..N] of TPoint;
  O:TPoint;


function More(const a,b:real):bool;
 begin
   More:=a-b>eps;
 end;

function Eq(const a,b:real):bool;
 begin
   Eq:=Abs(a-b)<=eps;
 end;

function dist(const a,b:TPoint):real;
 begin
   Dist:=sqrt(sqr(a.x-b.x)+sqr(a.y-b.y)+sqr(a.z-b.z));
 end;

function mk(const a,b:TPoint):TPoint;
 begin
   mk.x:=b.x-a.x;
   mk.y:=b.y-a.y;
   mk.z:=b.z-a.z;
 end;

function Len(a:TPoint):real;
 begin
   Len:=sqrt(sqr(a.x)+sqr(a.y)+sqr(a.z));
 end;

function Vect(a,b:TPoint):TPoint;
 begin
   Vect.z:=a.x*b.y-a.y*b.x;
   Vect.y:=a.z*b.x-a.x*b.z;
   Vect.x:=a.y*b.z-a.z*b.y;
 end;

function DistLine(const x,a,b:TPoint):real;
begin
  DistLine:=Len(Vect(mk(x,a),mk(x,b)))/Dist(a,b);
end;


procedure Run;
 var
   i,j,k:int;
   L,R:real;
 begin
   Read(d[1,2],d[1,3],d[1,4],d[2,3],d[2,4],d[3,4]);
   for i :=1 to N do
     begin
       d[i,i]:=0;
       for j := 1 to i-1 do
         d[i,j]:=d[j,i];
     end;
   for i := 1 to N do
     for j := 1 to N do
       for k := 1 to N do
         if (i<>k) and (j<>k) then
           if d[i,j]>=d[i,k]+d[k,j] then
             begin
               Writeln(imp);
               exit;
             end;
  if not eq(d[1,2]+d[3,4],d[1,3]+d[2,4]) or not eq(d[1,2]+d[3,4],d[1,4]+d[2,3]) then
    begin
      Writeln(no);
      exit;
    end;
  p[1].x:=0;
  p[1].y:=0;
  p[1].z:=0;
  p[2].x:=d[1,2];
  p[2].y:=0;
  p[2].z:=0;
  p[3].x:=(sqr(d[1,2]) + sqr(d[1,3]) - sqr(d[2,3]))/(2*d[1,2]);
  p[3].y:=sqrt(sqr(d[1,3])-sqr(p[3].x));
  p[3].z:=0;
  p[4].x:=(sqr(d[1,2]) + sqr(d[1,4]) - sqr(d[2,4]))/(2*d[1,2]);

  p[4].y:=(sqr(d[1,4]) + sqr(d[1,3]) - sqr(d[3,4]) - 2*p[4].x*p[3].x )/(2*p[3].y);
  if not More(sqr(d[1,4])-sqr(p[4].x) - sqr(p[4].y),0) then
    begin
      Writeln(imp);
      exit;
    end;
  p[4].z:=sqrt(sqr(d[1,4])-sqr(p[4].x) - sqr(p[4].y));
{
  for i := 1 to N do
    WRiteln(i,': ',p[i].x:0:3,' ',p[i].y:0:3,' ',p[i].z:0:3);
}
{
  for i := 1 to N do
    for j := 1 to N do
      if not Eq(Dist(p[i],p[j]),d[i,j]) then
        Writeln('Invalid coordinates! ',i,' ',j,' d=',dist(p[i],p[j]):0:5);
}
  o.x:=(d[1,2]-d[2,3]+d[3,1])/2;
  o.z:=0;
  L:=0;
  R:=inf;
  While R-L>epsB do
    begin
      o.y:=(L+R)/2;
      if More(DistLine(o,p[1],p[3]),o.y) then
        L:=o.y
      else
        r:=o.y;
    end;
{
  if not Eq(DistLine(o,p[1],p[3]),o.y) then
    Writeln('invalid centre1');
}

  L:=0;
  R:=inf;
  While R-L>epsB do
    begin
      o.Z:=(L+R)/2;
      if More(DistLine(o,p[1],p[4]),DistLine(o,p[1],p[2])) then
        L:=o.z
      else
        r:=o.z;
    end;
{
  for i := 1 to N do
    for j := 1 to N do
      if i<>j then
        Writeln('dist to ',i,',',j,'=',DistLine(o,p[i],p[j]):0:20 );
}
{
  if not Eq(DistLine(o,p[3],p[4]),o.z) then
    Writeln('invalid centre2');
  if not Eq(DistLine(o,p[2],p[4]),o.z) then
    Writeln('invalid centre3');
}
  Writeln(yes);
  Writeln(DistLine(o,p[1],p[2]):0:16);
  for i := 1 to N do
    Writeln(Dist(o,p[i]):0:16);
 end;

procedure OpenFiles;
 begin
  Assign(input,in_f);
  Reset(input);
  Assign(output,out_f);
  Rewrite(output);
 end;

procedure CloseFiles;
 begin
  Close(input);
  Close(output);
 end;

Begin
OpenFiles;
Run;
CloseFiles;
End.
