{$R-,Q-,S-,B-}
//uses math;

const taskid='tetrahedron';
      eps=1e-12;

type tpoint=record x,y,z:extended; end;
     tplane=record a,b,c,d:extended; end;

var i,j,k,npl:longint;
    d:array [0..3,0..3] of extended;
    p:array [0..3] of tpoint;
    g,w,h,l,r,t,u,v:extended;
    pt,pl,pr,o:tpoint;
    tpl:array [1..15] of tplane;
    solved:boolean;

function getpoint(x,y,z:extended):tpoint;
 begin
 getpoint.x:=x;
 getpoint.y:=y;
 getpoint.z:=z;
 end;

function add(p1,p2:tpoint):tpoint;
 begin
 add.x:=p1.x+p2.x;
 add.y:=p1.y+p2.y;
 add.z:=p1.z+p2.z;
 end;

function sub(p1,p2:tpoint):tpoint;
 begin
 sub.x:=p1.x-p2.x;
 sub.y:=p1.y-p2.y;
 sub.z:=p1.z-p2.z;
 end;

function dot(p1,p2:tpoint):extended;
 begin
 dot:=p1.x*p2.x+p1.y*p2.y+p1.z*p2.z;
 end;

function cross(p1,p2:tpoint):tpoint;
 begin
 cross.x:=p1.y*p2.z-p1.z*p2.y;
 cross.y:=p1.z*p2.x-p1.x*p2.z;
 cross.z:=p1.x*p2.y-p1.y*p2.x;
 end;

function mul(p:tpoint; a:extended):tpoint;
 begin
 mul.x:=p.x*a;
 mul.y:=p.y*a;
 mul.z:=p.z*a;
 end;

function mid(p1,p2:tpoint):tpoint;
 begin
 mid:=mul(add(p1,p2),0.5);
 end;

function norm(p:tpoint):tpoint;
 var d:extended;
 begin
 d:=sqrt(sqr(p.x)+sqr(p.y)+sqr(p.z));
 norm.x:=p.x/d;
 norm.y:=p.y/d;
 norm.z:=p.z/d;
 end;

function plane(p1,p2,p3:tpoint):tplane;
 var n:tpoint; pl:tplane;
 begin
 n:=cross(sub(p2,p1),sub(p3,p1));
 pl.a:=n.x;
 pl.b:=n.y;
 pl.c:=n.z;
 pl.d:=-dot(n,p1);
 plane:=pl;
 end;

function theplane(p1,p2,p3:tpoint):tplane;
 var u1,u3,v,w:tpoint; o:tplane;
 begin
 u1:=add(p2,norm(sub(p1,p2)));
 u3:=add(p2,norm(sub(p3,p2)));
 v:=mid(u1,u3);
 o:=plane(p1,p2,p3);
 theplane:=plane(v,p2,add(p2,getpoint(o.a,o.b,o.c)));
 end;

function dist(p1,p2:tpoint):extended;
 begin
 dist:=sqrt(sqr(p1.x-p2.x)+sqr(p1.y-p2.y)+sqr(p1.z-p2.z));
 end;

function dist1(p,p1,p2:tpoint):extended;
 var u:extended; s:tpoint;
 begin
 u:=dot(sub(p,p1),sub(p2,p1))/dist(p1,p2);
 s:=add(p1,mul(norm(sub(p2,p1)),u));
 dist1:=dist(p,s);
 end;

begin
assign(input,taskid+'.in');
assign(output,taskid+'.out');
reset(input);
rewrite(output);
readln(d[0,1],d[0,2],d[0,3],d[1,2],d[1,3],d[2,3]);
for i:=1 to 3 do
 for j:=0 to i-1 do d[i,j]:=d[j,i];
for i:=0 to 1 do
 for j:=i+1 to 2 do
  for k:=j+1 to 3 do
   if (d[i,j]>d[j,k]+d[k,i]) or (d[j,k]>d[k,i]+d[i,j]) or (d[k,i]>d[i,j]+d[j,k]) then
    begin
    writeln('IMPOSSIBLE');
    close(input);
    close(output);
    halt(0);
    end;
if not((abs(d[0,1]+d[2,3]-d[0,2]-d[1,3])<eps) and (abs(d[0,1]+d[2,3]-d[0,3]-d[1,2])<eps)) then
 begin
 writeln('NO');
 close(input);
 close(output);
 halt(0);
 end;
p[0]:=getpoint(0,0,0);
p[1]:=getpoint(d[0,1],0,0);
l:=0;
r:=pi;
pl:=getpoint(d[0,2],0,0);
pr:=getpoint(-d[0,2],0,0);

while dist(pl,pr)>1e-15 do
 begin
 t:=(l+r)/2;
 pt:=getpoint(d[0,2]*cos(t),0,d[0,2]*sin(t));
 if dist(pt,p[1])<d[1,2] then
  begin
  l:=t;
  pl:=pt;
  end
 else
  begin
  r:=t;
  pr:=pt;
  end;
 end;
p[2]:=pt;
u:=(sqr(d[0,1])+sqr(d[0,3])-sqr(d[1,3]))/(2*d[0,1]);
h:=sqr(d[0,3])-sqr(u);
u:=sqrt(sqr(d[0,3])-h);
h:=sqrt(h);
l:=0;
r:=pi;
pl:=getpoint(u,0,h);
pr:=getpoint(u,0,-h);
while dist(pl,pr)>1e-15 do
 begin
 t:=(l+r)/2;
 pt:=getpoint(u,h*sin(t),h*cos(t));
 if dist(pt,p[2])<d[2,3] then
  begin
  l:=t;
  pl:=pt;
  end
 else
  begin
  r:=t;
  pr:=pt;
  end;
 end;
p[3]:=pt;
npl:=0;
for i:=0 to 2 do
 for j:=0 to 3 do
  for k:=i+1 to 3 do
   if (i<>j) and (j<>k) and (k<>i) then
    begin
    inc(npl);
    tpl[npl]:=theplane(p[i],p[j],p[k]);
    end;
solved:=false;
for i:=1 to npl do
 if abs(tpl[i].a)>eps then
  begin
  u:=-tpl[i].b/tpl[i].a;
  v:=-tpl[i].c/tpl[i].a;
  t:=-tpl[i].d/tpl[i].a;
  for j:=1 to npl do
   if abs(tpl[j].b+tpl[j].a*u)>eps then
    begin
    w:=-(tpl[j].c+tpl[j].a*v)/(tpl[j].b+tpl[j].a*u);
    l:=-(tpl[j].d+tpl[j].a*t)/(tpl[j].b+tpl[j].a*u);
    g:=u*w+v;
    h:=u*l+t;
    for k:=1 to npl do
     if abs(tpl[k].c+w*tpl[k].b+g*tpl[k].a)>eps then
      begin
      o.z:=-(tpl[k].d+l*tpl[k].b+h*tpl[k].a)/(tpl[k].c+w*tpl[k].b+g*tpl[k].a);
      o.y:=w*o.z+l;
      o.x:=u*o.y+v*o.z+t;
      solved:=true;
      break;
      end;
    if solved then break;
    end;
  if solved then break;
  end;
u:=dot(sub(o,p[0]),sub(p[1],p[0]))/d[0,1];
pl:=add(p[0],mul(norm(sub(p[1],p[0])),u));
r:=dist(o,pl);
writeln('YES');
writeln(r:0:16);
writeln(dist(o,p[0]):0:16);
writeln(dist(o,p[1]):0:16);
writeln(dist(o,p[2]):0:16);
writeln(dist(o,p[3]):0:16);
{writeln;
writeln(dist1(o,p[0],p[1]):0:16);
writeln(dist1(o,p[0],p[2]):0:16);
writeln(dist1(o,p[0],p[3]):0:16);
writeln(dist1(o,p[1],p[2]):0:16);
writeln(dist1(o,p[1],p[3]):0:16);
writeln(dist1(o,p[2],p[3]):0:16);}

close(input);
close(output);
end.
