#include <stdio.h>
#include <stdlib.h>
#include <math.h>

#define MAX_MEM 1000000
#define eps 1e-9
#define double long double

typedef struct
{
 double x, y;
} VEC;

typedef struct
{
  VEC st, t;
} RAY;

typedef struct
{
  double A, B, C;
} LINE;

typedef struct
{
  RAY r;
  int next;
} VERT;
VEC In[30000];

VERT MEM[MAX_MEM];
int MN;
int N, x, y;

double Get( LINE L, VEC V )
{
  return L.A * V.x + L.B * V.y + L.C;
}


double Inter( RAY R, LINE L )
{
  double t;

  t = L.A * R.t.x + R.t.y * L.B;
  if (t < eps && t > -eps)
    return -1;
  return -(L.C + L.A * R.st.x + L.B * R.st.y) / t;
}

int sg( double a )
{
  if (a < -eps) 
    return -1;
  if (a > eps)
    return 1;
  return 0;

}

int Add( int ST, LINE L, int num )
{
  int t, prev, now, next, f = 0, end1, in, out;
  double t1, t2, t3;

  t = ST;
  end1 = MEM[ST].next;
  prev = ST;
  now = MEM[ST].next;
  next = MEM[now].next;
  do
  {
    if ((sg(Get(L, In[num])) == (t3 = sg(Get(L, MEM[now].r.st))) || 
    (t3 == 0 && sg(Get(L, MEM[prev].r.st)) == sg(Get(L, In[num])))) &&
      (sg(Get(L, MEM[next].r.st)) * (t3 = sg(Get(L, MEM[prev].r.st))) == -1 || t3 * sg(Get(L, MEM[now].r.st)) == -1 )
      && ((t2 = Inter(MEM[now].r, L)) > -eps && t2 <= 1 - eps))
    {
      f = 1;
      in = now;
    }
    prev = now;
    now = next;
    next = MEM[now].next;

  } while (now != end1 && !f);
  if (f)
  {
    while (1)
    {
      if (/*sg(Get(L, MEM[next].r.st)) * sg(Get(L, MEM[prev].r.st)) <= 0 &&*/
      ((t2 = Inter(MEM[now].r, L)) > -eps && t2 <= 1 - eps))
      {
        f = 1;
        out = now;
        break;
      }
      prev = now;
      now = next;
      next = MEM[now].next;
    }
    t1 = Inter(MEM[in].r, L);
    t2 = Inter(MEM[out].r, L);

    MEM[MN].next = MEM[out].next;
    MEM[MN].r.st.x = MEM[out].r.st.x + MEM[out].r.t.x * t2;
    MEM[MN].r.st.y = MEM[out].r.st.y + MEM[out].r.t.y * t2;
    MEM[MN].r.t.x = MEM[MEM[MN].next].r.st.x - MEM[MN].r.st.x;
    MEM[MN].r.t.y = MEM[MEM[MN].next].r.st.y - MEM[MN].r.st.y;
    MN++;

    if (t1 < eps)
    {
      MEM[in].next = MN - 1;
      MEM[in].r.t.x = MEM[MN - 1].r.st.x - MEM[in].r.st.x;
      MEM[in].r.t.y = MEM[MN - 1].r.st.y - MEM[in].r.st.y;

      return MN - 1;
    }

    MEM[MN].next = MN - 1;
    MEM[in].next = MN;
    MEM[MN].r.st.x = MEM[in].r.st.x + MEM[in].r.t.x * t1;
    MEM[MN].r.st.y = MEM[in].r.st.y + MEM[in].r.t.y * t1;
    MEM[MN].r.t.x = MEM[MEM[MN].next].r.st.x - MEM[MN].r.st.x;
    MEM[MN].r.t.y = MEM[MEM[MN].next].r.st.y - MEM[MN].r.st.y;
    MEM[in].r.t.x *= t1;
    MEM[in].r.t.y *= t1;
    MN++;
    return MN - 1;
  }
  return ST;
  
}
VEC Res[40000];
int ON;

void GetPolygon( int num )
{
  int i, j, k, ST = 0;

  LINE L;
  MN = 4;
  MEM[0].r.st.x = 0;
  MEM[0].r.st.y = 0;
  MEM[0].next = 1;
  MEM[1].r.st.x = 0;
  MEM[1].r.st.y = y;
  MEM[1].next = 2;
  MEM[2].r.st.x = x;
  MEM[2].r.st.y = y;
  MEM[2].next = 3;
  MEM[3].r.st.x = x;
  MEM[3].r.st.y = 0;
  MEM[3].next = 0;
  for (i = 0; i < 4; i++)
    MEM[i].r.t.x = MEM[(i + 1) % 4].r.st.x - MEM[i].r.st.x,
    MEM[i].r.t.y = MEM[(i + 1) % 4].r.st.y - MEM[i].r.st.y;
  for (i = 0; i < N; i++)
    if (i != num)
    {
    
      
      L.A = (In[i].x - In[num].x);
      L.B = (In[i].y - In[num].y);
      L.C = -(L.A * (In[i].x + In[num].x) / 2 + 
            L.B * (In[i].y + In[num].y) / 2);
      ST = Add(ST, L, num);
      /*j = ST;
      do 
      {
        printf("%lf %lf (%lf %lf) ", MEM[j].r.st.x, MEM[j].r.st.y, MEM[j].r.t.x, MEM[j].r.t.y);
        j = MEM[j].next;

      } while (j != ST);
      printf("\n");*/
    }
  i = ST;
  ON = 0;
  k = 0;
  do
  {
    //printf("%lf %lf ", MEM[i].r.st.x, MEM[i].r.st.y);
    Res[ON++] = MEM[i].r.st;
    if (Res[k].x > Res[ON - 1].x || (Res[k].x == Res[ON - 1].x && Res[k].y > Res[ON - 1].y))
      k = ON - 1;                                                                           
      
    i = MEM[i].next;                                            
  } while (i != ST); 
  i = k;
  printf("%i ", ON);
  do
  {
   
    printf("%.13Lf %.13Lf ", Res[i].x, Res[i].y);
    i = (i + ON - 1) % ON;
  } while (i != k);
  printf("\n");
  return;
}

int main( void )
{
  int i, j, k;

  freopen("football.in", "rt", stdin);
  freopen("football.out", "wt", stdout);

  scanf("%i%i%i", &x, &y, &N);
  for (i = 0; i < N; i++)
    scanf("%Lf%Lf", &In[i].x, &In[i].y);    
  for (i = 0; i < N; i++)
    GetPolygon(i);

  return 0;
}

