{$H-,B-,I-,Q-,R-,S-}
{H-,B-,I+,Q+,R+,S+}
const
 eps   = 1e-14;
type
 int   = integer;
 rl    = extended;
 point = record x,y,z:rl; end;
 line  = record a,b:point; end;
var
 k     : array[0..3]of point;
 p1,p2,c: point;
 d01,d02,d03,d12,d13,d23,
 xp,yp,l,r,d1,d2,xi,yi,maxd:rl;
 i,j:int;
 ok:boolean;

procedure print_error();
begin
 writeln('IMPOSSIBLE');
 close(input);
 close(output);
 halt(0);
end;

function getline(p1,p2:point):line;
var r:line;
begin
 r.a:=p1; r.b:=p2;
 getline:=r;
end;
function d(a,b:point):rl;
var r:rl;
begin
 r:=(a.x-b.x)*(a.x-b.x)+(a.y-b.y)*(a.y-b.y)+(a.z-b.z)*(a.z-b.z);
 if (r>eps)
  then d:=sqrt(r)
  else d:=0;
end;
function area(P,Q,R:point):rl;
var a,b,c,s:rl;
begin
 a:=d(P,Q); b:=d(Q,R); c:=d(R,P);
 s:=(a+b-c)*(b+c-a)*(c+a-b)*(a+b+c);
 area:=sqrt(s+eps/10)/4;
end;
function dist(p:point;m:line):rl;
var s:rl;
begin
 s:=area(p,m.a,m.b);
 dist:=2*s/d(m.a,m.b);
end;
function mindist(p:point):rl;
var
 r:rl;
 i,j:int;
begin
 r:=1e10;
 for i:=0 to 3 do
  for j:=i+1 to 3 do
   if (r>dist(p,getline(k[i],k[j]))) then r:=dist(p,getline(k[i],k[j]));
 mindist:=r;
end;

Begin
 //Init
 assign(input,'tetrahedron.in');
 reset(input);
 assign(output,'tetrahedron.out');
 rewrite(output);
 read(d01,d02,d03,d12,d13,d23);
 maxd:=d01; if (maxd<d23) then maxd:=d23;
 if (maxd<d02) then maxd:=d02; if (maxd<d03) then maxd:=d03;
 if (maxd<d12) then maxd:=d12; if (maxd<d13) then maxd:=d13;
 //finding tetrahedron koordinates
 fillchar(k,sizeof(k),0);
 k[2].y:=d12;
 yp:=(sqr(d13)+sqr(d12)-sqr(d23))/(2*d12);
 if (sqr(d13)-sqr(yp)<eps) then print_error;
 xp:=sqrt(sqr(d13)-sqr(yp));
 k[3].x:=xp; k[3].y:=yp;
 k[0].y:=(sqr(d01)+sqr(d12)-sqr(d02))/(2*d12);
 k[0].x:=(sqr(d01)+sqr(d13)-sqr(d03)-2*yp*k[0].y)/(2*xp);
 if (sqr(d01)-sqr(k[0].x)-sqr(k[0].y)<eps) then print_error;
 k[0].z:=sqrt(sqr(d01)-sqr(k[0].x)-sqr(k[0].y));
 //Solution
 //finding I(xi,yi) in (1,2,3) triangle
 xi:=k[0].x;
 yi:=k[0].y;
 r:=2*area(k[1],k[2],k[3])/(d(k[1],k[2])+d(k[2],k[3])+d(k[3],k[1]));
 xi:=r;
 yi:=r*(yp+d13)/xp;
 //searching
 p1.x:=xi; p1.y:=yi;
 p2.x:=xi; p2.y:=yi;
 l:=0; r:=k[0].z;
 while (r-l>eps/10) do begin
  p1.z:=1/3*(r-l)+l;
  p2.z:=2/3*(r-l)+l;
  d1:=mindist(p1);
  d2:=mindist(p2);
  if (d1<d2)
   then l:=p1.z
   else r:=p2.z;
 end;
 //Output
 ok:=true;
 c:=p1;
 d1:=dist(c,getline(k[0],k[1]));
 for i:=0 to 3 do
  for j:=i+1 to 3 do
   if (abs(d1-dist(c,getline(k[i],k[j])))>eps*10*maxd) then ok:=false;
 if (ok) then begin
  writeln('YES');
  writeln(d1:0:9);
  for i:=0 to 3 do begin
   d2:=d(c,k[i]);
   writeln(d2:0:9);
  end;
 end else begin
  writeln('NO');
 end;
 close(input);
 close(output);
End.
