type integer = longint;
const eps = 1e-9;
var x, y : extended;
	n : integer;
	px, py : array[1..31000] of extended;

procedure Load;
var i : integer;
begin
	read(x, y, n);
	for i := 1 to n do begin
		read(px[i], py[i]);
	end;
end;

var cur, nxt1, nxt2 : array[1..31000, 1..2] of extended;
	ncur, nx1, nx2 : integer;

procedure MakeLine(x1, y1, x2, y2 : extended; var a, b, c : extended);
begin
	a := y1 - y2;
	b := x2 - x1;
	c := - x1 * a - y1 * b;
end;

var was : array[0..31000] of byte;
	d1, d2, d3 : extended;

function InterLine(a1, b1, c1, a2, b2, c2 : extended; var xx, yy : extended) : boolean;
begin
	d1 := a1 * b2 - b1 * a2;
	if abs(d1) < eps then begin
		InterLine := false;
		exit;
	end;
	d2 := (-c1) * b2 - b1 * (-c2);
	d3 := a1 * (-c2) - (-c1) * a2;
	xx := d2 / d1;
	yy := d3 / d1;
    InterLine := true;
end;

function GetT(x1, y1, x2, y2, x3, y3 : extended) : extended;
var dx, dy : extended;
begin
	dx := x2 - x1;
	dy := y2 - y1;
	if abs(dx) < eps then begin
		if abs(dy) < eps then GetT := 1000000000
		else GetT := (y3 - y1) / dy;
	end
	else GetT := (x3 - x1) / dx;
end;

function InterLineOtr(a, b, c, x1, y1, x2, y2 : extended; var xx, yy : extended) : boolean;
var t, a1, b1, c1 : extended;
begin
	MakeLine(x1, y1, x2, y2, a1, b1, c1);
	if not InterLine(a, b, c, a1, b1, c1, xx, yy) then begin
		InterLineOtr := false;
		exit;
	end;
	t := GetT(x1, y1, x2, y2, xx, yy);
	if (t < -eps) or (t - 1 > eps) then begin
		InterLineOtr := false;
		exit;
	end;
	InterLineOtr := true;
end;

procedure SplitPoly(a, b, c : extended);
var ix, iy : array[1..4] of extended;
	io : array[1..4] of integer;
	k, tl, i, ni, j : integer;
	t, xx, yy : extended;
begin
	fillchar(was, sizeof(was), 0);
	cur[ncur + 1, 1] := cur[1, 1];
	cur[ncur + 1, 2] := cur[1, 2];
	ni := 0;
	for i := 1 to ncur do begin
		if InterLineOtr(a, b, c, cur[i, 1], cur[i, 2], cur[i + 1, 1], cur[i + 1, 2], xx, yy) then begin
			inc(ni);
			ix[ni] := xx;
			iy[ni] := yy;
			io[ni] := i;
		end;
	end;
	for i := ni downto 1 do begin
		for j := i + 1 to ni do begin
			if (abs(ix[j] - ix[i]) < eps) and (abs(iy[j] - iy[i]) < eps) then begin
				for k := j to ni - 1 do begin
					ix[k] := ix[k + 1];
					iy[k] := iy[k + 1];
					io[k] := io[k + 1];
				end;
				dec(ni);
				break;
			end;
		end;
	end;
	{OK, let's split}
	nx1 := 0;
	nx2 := 0;
	i := 1;
	while i <= ncur do begin
		inc(nx1);
		nxt1[nx1, 1] := cur[i, 1];
		nxt1[nx1, 2] := cur[i, 2];
		if io[2] = i then begin
			tl := io[1];
			io[1] := io[2];
			io[2] := tl;
			t := ix[1];
			ix[1] := ix[2];
			ix[2] := t;
			t := iy[1];
			iy[1] := iy[2];
			iy[2] := t;
		end;
		if io[1] = i then begin
			inc(nx1);
			nxt1[nx1, 1] := ix[1];
			nxt1[nx1, 2] := iy[1];
			inc(nx1);
			nxt1[nx1, 1] := ix[2];
			nxt1[nx1, 2] := iy[2];
			{}
			inc(nx2);
			nxt2[nx2, 1] := ix[2];
			nxt2[nx2, 2] := iy[2];
			inc(nx2);
			nxt2[nx2, 1] := ix[1];
			nxt2[nx2, 2] := iy[1];
			j := i + 1;
			{}
			i := io[2];
			if i > ncur then break;
		end;
		inc(i);
		was[i] := 1;
	end;
	while was[j] = 0 do begin
	    inc(nx2);
		nxt2[nx2, 1] := cur[j, 1];
		nxt2[nx2, 2] := cur[j, 2];
		inc(j);
	end;
end;

function TriSqr(x1, y1, x2, y2, x3, y3 : extended) : extended;
begin
	TriSqr := abs((x2 - x1) * (y3 - y1) - (y2 - y1) * (x3 - x1)) / 2;
end;

function InsideNxt1(x, y : extended) : boolean;
var ns, sqr : extended;
	i : integer;
begin
	{count square}
	sqr := 0;
	nxt1[nx1 + 1, 1] := nxt1[1, 1];
	nxt1[nx1 + 1, 2] := nxt1[1, 2];
	for i := 2 to nx1 - 1 do begin
		sqr := sqr + TriSqr(nxt1[1, 1], nxt1[1, 2], nxt1[i, 1], nxt1[i, 2], nxt1[i + 1, 1], nxt1[i + 1, 2]);
	end;
	{check}
	ns := 0;
	for i := 1 to nx1 do begin
		ns := ns + TriSqr(x, y, nxt1[i, 1], nxt1[i, 2], nxt1[i + 1, 1], nxt1[i + 1, 2]);
	end;
	InsideNxt1 := (abs(sqr - ns) < eps);
end;

procedure TrimCur;
var cr, i : integer;
begin
	cr := 1;
    for i := 2 to ncur do begin
    	if (abs(cur[i, 1] - cur[cr, 1]) > eps) or (abs(cur[i, 2] - cur[cr, 2]) > eps) then begin
        	inc(cr);
            cur[cr, 1] := cur[i, 1];
            cur[cr, 2] := cur[i, 2];
        end;
    end;
    ncur := cr;
end;

function GetNext(a : integer) : integer;
begin
	if a = ncur then GetNext := 1
    else GetNext := a + 1;
end;

function GetPrev(a : integer) : integer;
begin
	if a = 1 then GetPrev := ncur
    else GetPrev := a - 1;
end;

procedure GOutCur;
var mi, i, i2, i1 : integer;
	v1x, v1y, v2x, v2y : extended;
begin
	{find left - bottom vertex}
	mi := 1;
    for i := 2 to ncur do begin
    	if (cur[i, 1] - cur[mi, 1] < -eps) or ((abs(cur[i, 1] - cur[mi, 1]) < eps) and (cur[i, 2] < cur[mi, 2])) then begin
        	mi := i;
        end;
    end;
	{check}
    i1 := GetNext(mi);
    i2 := GetNext(i1);
    v1x := cur[i2, 1] - cur[i1, 1];
    v1y := cur[i2, 2] - cur[i1, 2];
    v2x := cur[i1, 1] - cur[mi, 1];
    v2y := cur[i1, 2] - cur[mi, 2];
    for i := 1 to ncur do begin
    	if abs(cur[i, 1]) < eps then cur[i, 1] := 0;
        if abs(cur[i, 2]) < eps then cur[i, 2] := 0;
    end;
    write(ncur);
    if v2x * v1y - v2y * v1x > eps then begin
		i := mi;
        repeat
			write(' ', cur[i, 1] :0 :12, ' ', cur[i, 2] : 0 : 12);
            i := GetNext(i);	
        until i = mi;	
    end
    else begin
    	i := mi;
        repeat
			write(' ', cur[i, 1] :0 :12, ' ', cur[i, 2] : 0 : 12);
            i := GetPrev(i);	
        until i = mi;
    end;
    writeln;
end;

procedure Solve;
var i, j : integer;
	a, b, c, xx, yy : extended;
begin
	for i := 1 to n do begin
		ncur := 4;
		cur[4, 1] := 0;
		cur[4, 2] := 0;
		cur[1, 1] := x;
		cur[1, 2] := 0;
		cur[2, 1] := x;
		cur[2, 2] := y;
		cur[3, 1] := 0;
		cur[3, 2] := y;
		for j := 1 to n do begin
        	if j = i then continue;
			MakeLine(px[i], py[i], px[j], py[j], a, b ,c);
			xx := (px[i] + px[j]) / 2;
			yy := (py[i] + py[j]) / 2;
			c := a;
			a := -b;
			b := c;
			c := - a * xx - b * yy;
			SplitPoly(a, b, c);
			if InsideNxt1(px[i], py[i]) then begin
				ncur := nx1;
				move(nxt1, cur, sizeof(cur));
			end
			else begin
				ncur := nx2;
				move(nxt2, cur, sizeof(cur));
            end;
	        TrimCur;
        end;
        GOutCur;
	end;
end;

begin
	assign(input, 'football.in');
	assign(output, 'football.out');
	reset(input);
	rewrite(output);
	Load;
	Solve;
	close(input);
	close(output);
end.
