#include <set>
#include <map>
#include <cmath>
#include <cstdio>
#include <utility>
#include <algorithm>

#define EPS 1e-10

struct TSourcePoint{
  long double x, y;
  int i, ce;
  friend bool operator<(const TSourcePoint& a, const TSourcePoint& b){
    return (a.x<b.x||(a.x==b.x&&a.i<b.i));
  }
} p[30000];

std::set<int> e[30000];

struct TEvent{
  long double y;
  int i, x;
  bool ce;
  friend bool operator<(const TEvent& a, const TEvent& b){
    return (a.y<b.y||(a.y==b.y&&a.i<b.i));
  }
} h[30000];

/*struct TEdge{
  int a, b, l, r;
} edges[100000];

struct TPoint{
  long double x, y;
  friend bool operator<(TPoint& a, TPoint& b){
    return (a.x<b.x-EPS||(fabs(a.x-b.x)<EPS&&a.y<b.y-EPS));
  }
  std::map<int, std::pair<int, int> > e;
};*/

//std::set<TPoint> points;

int b[30000], hsize, freei;

void swap(int i, int j){
  std::swap(h[i], h[j]);
  b[h[i].i]=i;
  b[h[j].i]=j;
}

void pushup(int i){
  int max=i;
  if (i*2+1<hsize&&h[max]<h[i*2+1]) max=i*2+1;
  if (i*2+2<hsize&&h[max]<h[i*2+2]) max=i*2+2;
  if (max==i) return;
  swap(i, max);
  pushup(max);
}

void pushdown(int i){
  if (i==0||h[i]<h[(i-1)/2]) return;
  swap(i, (i-1)/2);
  pushdown((i-1)/2);
}

void extractmin(){
  swap(0, --hsize);
  pushup(0);
}

int add(TEvent e){
  e.i=freei;
  h[hsize]=e;
  b[freei]=hsize;
  pushdown(hsize++);
  return freei++;
}

void del(int x){
  h[x].y=1000000000;
  pushdown(x);
  extractmin();
}

std::set<TSourcePoint> sweep;

void addcircleevent(int a, int b, int c){
  p[b].ce=-1;
  sweep.erase(sweep.find(p[b]));
  sweep.insert(p[b]);
  long double px1, py1, px2, py2, vx1, vx2, vy1, vy2, t;
  px1=(p[a].x+p[b].x)/2.0;
  py1=(p[a].y+p[b].y)/2.0;
  px2=(p[b].x+p[c].x)/2.0;
  py2=(p[b].y+p[c].y)/2.0;
  vx1=(p[a].y-p[b].y)/2.0;
  vy1=(-p[a].x+p[b].x)/2.0;
  vx2=(p[b].y-p[c].y)/2.0;
  vy2=(-p[b].x+p[c].x)/2.0;
  if (fabs(vx1*vy2-vx2*vy1)<EPS) return;
  t=(vy2*(px2-px1)-vx2*(py2-py1))/(vx1*vy2-vx2*vy1);
  TEvent tmp;
  tmp.ce=true;
  tmp.x=a;
  tmp.y=py1+t*vy1-t*sqrt((px1+t*vx1)*(px1+t*vx1)+(py1+t*vy1)*(py1+t*vy1));
  p[b].ce=add(tmp);
  sweep.erase(sweep.find(p[b]));
  sweep.insert(p[b]);
}

long double W, H;
int i, j, n, edgec;

int main(){
  freopen("football.in", "rt", stdin);
  freopen("football.out", "wt", stdout);
  scanf("%llf%llf%d", &W, &H, &n);
  TEvent t;
  t.ce=false;
  for (i=0; i<n; i++){
    scanf("%llf%llf", &p[i].x, &p[i].y);
    p[i].i=i;
    p[i].ce=-1;
    t.x=i;
    t.y=p[i].y;
    add(t);
  }
  int q, r;
  std::set<TSourcePoint>::iterator it, it1, it2;
  while (hsize){
    if (h[0].ce==false){
      it1=sweep.lower_bound(p[h[0].x]);
      it2=it1;//sweep.upper_bound(p[h[0].x]);
      if (it2!=sweep.end()) it2++;
      sweep.insert(p[h[0].x]);
      it=sweep.find(p[h[0].x]);
      //int watch=it1->i;
      //long double watch=((it2->x-p[h[0].x].x)*(it2->x-p[h[0].x].x)+
      //    it2->y*it2->y-h[0].y*h[0].y)/(-2*(h[0].y-it2->y));
      //bool watch=it2==sweep.end();
      //bool watch=fabs(it2->y-h[0].y)>EPS&&it2!=sweep.end();
      if (fabs(it1->y-h[0].y)>EPS&&it1!=sweep.end()&&
        (it2==sweep.end()||fabs(it2->y-h[0].y)<EPS||
        ((it1->x-p[h[0].x].x)*(it1->x-p[h[0].x].x)+
          it1->y*it1->y-h[0].y*h[0].y)/(-2*(h[0].y-it1->y))<
        ((it2->x-p[h[0].x].x)*(it2->x-p[h[0].x].x)+
          it2->y*it2->y-h[0].y*h[0].y)/(-2*(h[0].y-it2->y)))){
        e[it1->i].insert(it->i);
        e[it->i].insert(it1->i);
        if (it2!=sweep.end()) addcircleevent(it1->i, it->i, it2->i);
      } else if (fabs(it2->y-h[0].y)>EPS&&it2!=sweep.end()&&
        (it1==sweep.end()||fabs(it1->y-h[0].y)<EPS||
        ((it2->x-p[h[0].x].x)*(it2->x-p[h[0].x].x)+
          it2->y*it2->y-h[0].y*h[0].y)/(-2*(h[0].y-it2->y))<
        ((it1->x-p[h[0].x].x)*(it1->x-p[h[0].x].x)+
          it1->y*it1->y-h[0].y*h[0].y)/(-2*(h[0].y-it1->y)))){
        e[it2->i].insert(it->i);
        e[it->i].insert(it2->i);
        if (it2!=sweep.end()) addcircleevent(it1->i, it->i, it2->i);
      } else {
        if (it1!=sweep.end()){
          e[it1->i].insert(it->i);
          e[it->i].insert(it1->i);
        }
        if (it2!=sweep.end()&&it1!=it2){
          e[it2->i].insert(it->i);
          e[it->i].insert(it2->i);
        }
      }
    } else {
      //it2=sweep.upper_bound(p[h[0].x]);
      it=sweep.find(p[h[0].x]);
      it1=it;
      it2=it;
      it1--;
      it2++;
      e[it1->i].insert(it2->i);
      e[it2->i].insert(it1->i);
      sweep.erase(it);
      if (it1->ce!=-1) del(it1->ce);
      if (it2->ce!=-1) del(it2->ce);
      it=it2;
      it++;
      if (it!=sweep.end()) addcircleevent(it1->i, it2->i, it->i);
      it=it1;
      it--;
      if (it!=sweep.end()) addcircleevent(it->i, it1->i, it2->i);
    }
    extractmin();
  }
  std::set<int>::iterator jt;
  /*for (i=0; i<n; i++){
    printf("%d\n", i);
    for (jt=e[i].begin(); jt!=e[i].end(); jt++)
      printf("%d ", *jt);
  }*/
  return 0;
}
