Program prg;

var
  s: string;
  open, closed: array[0..310] of  integer;
  bo, bc: array[0..300] of boolean;
  i: integer;
  a, b: integer;
  now: char;

procedure inv(a, b: integer);
  var
    i :integer;
    ss: string;

  begin
    inc(open[0]);
    open[open[0]]:=a-1;
    inc(closed[0]);
    closed[closed[0]]:=b;
    bo[a-1]:=true;
    bc[b]:=true;
    ss:='';
    for i:=a to b do begin
      ss:=s[i]+ss;
    end;
    for i:=a to b do begin
      s[i]:=ss[i-a+1];
    end;
  end;

procedure qsorts(l, r: integer);
  var
    lh, rh: integer;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      if (bo[lh])or(bc[lh]) then begin
        if (lh-l)>1 then qsorts(l, lh-1);
        if (r-lh)>1 then qsorts(lh+1, r);
        exit;
      end;
      if (bo[rh-1])or(bc[rh-1]) then begin
        if (rh-l)>1 then qsorts(l, rh-1);
        if (r-rh)>1 then qsorts(rh+1, r);
        exit;
      end;
      inc(lh);
    end;
    lh:=l;
    rh:=r;

    while (lh<rh) do begin
      while (lh<rh)and(s[lh]<=s[rh]) do inc(lh);
      if lh<>rh then inv(lh, rh);
      while (lh<rh)and(s[lh]<=s[rh]) do dec(rh);
      if lh<>rh then inv(lh, rh);
    end;
    if (lh-l)>1 then qsorts(l, lh-1);
    if (r-rh)>1 then qsorts(rh+1, r);
  end;

procedure swap(var a, b: integer);
  var
    t: integer;

  begin
    t:=a;
    a:=b;
    b:=t;
  end;

procedure qsorto(l, r: integer);
  var
    lh, rh: integer;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      while (lh<rh)and(open[lh]<=open[rh]) do inc(lh);
      swap(open[lh], open[rh]);
      while (lh<rh)and(open[lh]<=open[rh]) do dec(rh);
      swap(open[lh], open[rh]);
    end;
    if (lh-l)>1 then qsorto(l, lh-1);
    if (r-rh)>1 then qsorto(rh+1, r);
  end;

procedure qsortc(l, r: integer);
  var
    lh, rh: integer;

  begin
    lh:=l;
    rh:=r;
    while (lh<rh) do begin
      while (lh<rh)and(closed[lh]<=closed[rh]) do inc(lh);
      swap(closed[lh], closed[rh]);
      while (lh<rh)and(closed[lh]<=closed[rh]) do dec(rh);
      swap(closed[lh], closed[rh]);
    end;
    if (lh-l)>1 then qsortc(l, lh-1);
    if (r-rh)>1 then qsortc(rh+1, r);
  end;


begin
  assign(input, 'cipher.in');
  assign(output, 'cipher.out');
  reset(input);
  rewrite(output);

  readln(s);

  qsorts(1, length(s));

  qsorto(1, open[0]);
  qsortc(1, closed[0]);

  a:=1;
  b:=1;

  now:='a';
  for i:=1 to length(s) do begin
    if now>s[i] then begin
      write('NO SOLUTION');
      close(input);
      close(output);
      halt;
    end else now:=s[i];
  end;

  while (open[a]=0)and(open[0]>=a) do begin
    write('[');
    inc(a);
  end;
  for i:=1 to length(s) do begin
    write(s[i]);
    while (open[a]=i) do begin
      write('[');
      inc(a);
    end;
    while (closed[b]=i) do begin
      write(']');
      inc(b);
    end;
  end;


  close(input);
  close(output);

end.
