#include <stdio.h>
#include <string.h>

struct dtcell
{
  int split;
  bool rev;
  char first, last;
  int len;
};
dtcell ds[300][301];
dtcell dr[300][301];
char str[301];

void format (char* buf, int i, int j, bool rev = false)
{
  if (j == i + 1)
  {
    buf[0] = str[i];
    return;
  }
  if (rev)
  {
    if (dr[i][j].rev)
    {
      *buf = '[';
      buf++;
      format (buf, i, dr[i][j].split, false);
      format (buf + ds[i][dr[i][j].split].len, dr[i][j].split, j, false);
      int len = ds[i][dr[i][j].split].len + ds[dr[i][j].split][j].len;
      int tmp;
      for (int p = 0; p + p < len; p++)
        tmp = buf[p],
        buf[p] = buf[len - p - 1],
        buf[len - p - 1] = tmp;
      for (int p = 0; p < len; p++)
        if (buf[p] == '[')
          buf[p] = ']';
        else if (buf[p] == ']')
          buf[p] = '[';
      buf[len] = ']';
    }
    else
      format (buf, i, dr[i][j].split, true),
      format (buf + dr[i][dr[i][j].split].len, dr[i][j].split, j, true);
  }
  else
  {
    if (ds[i][j].rev)
    {
      *buf = '[';
      buf++;
      format (buf, i, ds[i][j].split, true);
      format (buf + dr[i][ds[i][j].split].len, ds[i][j].split, j, true);
      int len = dr[i][ds[i][j].split].len + dr[ds[i][j].split][j].len;
      int tmp;
      for (int p = 0; p + p < len; p++)
        tmp = buf[p],
        buf[p] = buf[len - p - 1],
        buf[len - p - 1] = tmp;
      for (int p = 0; p < len; p++)
        if (buf[p] == '[')
          buf[p] = ']';
        else if (buf[p] == ']')
          buf[p] = '[';
      buf[len] = ']';
    }
    else
      format (buf, i, ds[i][j].split, false),
      format (buf + ds[i][ds[i][j].split].len, ds[i][j].split, j, false);
  }
}

int main ()
{
  freopen ("cipher.in", "rt", stdin);
  freopen ("cipher.out", "wt", stdout);

  scanf ("%s", str);
  int len = strlen (str);

  for (int l = 1; l <= len; l++)
  {
    for (int i = 0; i + l <= len; i++)
    {
      int j = i + l;

      ds[i][j].len = 1000;
      dr[i][j].len = 1000;

      if (l == 1)
      {
        ds[i][j].split = -1;
        ds[i][j].rev = false;
        ds[i][j].first = str [i];
        ds[i][j].last = str [i];
        ds[i][j].len = 1;
        dr[i][j].split = -1;
        dr[i][j].rev = false;
        dr[i][j].first = str[i];
        dr[i][j].last = str[i];
        dr[i][j].len = 1;
        continue;
      }

      for (int k = i; k < j; k++)
      {
        if (ds[i][k].len < 1000 && ds[k][j].len < 1000 && ds[k][j].first >= ds[i][k].last)
        {
          if (ds[i][k].len + ds[k][j].len < ds[i][j].len)
          {
            ds[i][j].len = ds[i][k].len + ds[k][j].len;
            ds[i][j].split = k;
            ds[i][j].rev = false;
            ds[i][j].first = ds[i][k].first;
            ds[i][j].last = ds[k][j].last;
          }
          if (ds[i][k].len + ds[k][j].len + 2 < dr[i][j].len)
          {
            dr[i][j].len = ds[i][k].len + ds[k][j].len + 2;
            dr[i][j].split = k;
            dr[i][j].rev = true;
            dr[i][j].first = ds[k][j].last;
            dr[i][j].last = ds[i][k].first;
          }
        }
        if (dr[i][k].len < 1000 && dr[k][j].len < 1000 && dr[k][j].first <= dr[i][k].last)
        {
          if (ds[i][k].len + ds[k][j].len + 2 < ds[i][j].len)
          {
            ds[i][j].len = dr[i][k].len + dr[k][j].len + 2;
            ds[i][j].split = k;
            ds[i][j].rev = true;
            ds[i][j].first = dr[k][j].last;
            ds[i][j].last = dr[i][k].first;
          }
          if (ds[i][k].len + ds[k][j].len < dr[i][j].len)
          {
            dr[i][j].len = dr[i][k].len + dr[k][j].len;
            dr[i][j].split = k;
            dr[i][j].rev = false;
            dr[i][j].first = dr[i][k].first;
            dr[i][j].last = dr[k][j].last;
          }
        }
      }
    }
  }

  if (dr[0][len].len >= 1000)
    printf ("NO SOLUTION");
  else
  {
    char buf [1000];
    memset (buf, 0, sizeof buf);
    format (buf, 0, len);
    printf (buf);
  }

  return 0;
}
