#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))
#define SQR(X) ((X) * (X))

#define eps 1e-9
#define inf (int)2e9

#define MAXL 310

void KMP(char *S, int *R)
{
  int i, t;
  R[0] = 0;
  for (i = 1; S[i]; i++)
  {
    t = R[i - 1];
    while (S[t] != S[i] && t != 0)
      t = R[t - 1];
    if (S[t] == S[i])
      t++;
    R[i] = t;
  }
}

char S1[MAXL], S2[MAXL], S3[MAXL], S4[MAXL], T1[MAXL * 3], T2[MAXL * 3];
int N1, N2, N3, N4, L1, L2, LT1, LT2, R1[MAXL * 3], R2[MAXL * 3], M1, M2;

int main( void )
{
  int i, j, k, t, Ans, s1, s2, s3, s4, l1, l2, l3, l4;

  freopen("nostrings.in", "rt", stdin);
  freopen("nostrings.out", "wt", stdout);

  scanf("%s%s%s%s", S1, S2, S3, S4);
  N1 = strlen(S1), N2 = strlen(S2), N3 = strlen(S3), N4 = strlen(S4);

  Ans = s1 = s2 = s3 = s4 = l1 = l2 = l3 = l4 = 0;
  for (i = 0; i < N1; i++)
    for (j = 0; j <= N1 - i; j++)
      for (k = 0; k < N2; k++)
      {
        L1 = L2 = 0;
        for (t = 0; t < j; t++)
          T1[L1++] = S1[i + t];
        for (t = 0; t < N2 - k; t++)
          T1[L1++] = S2[k + t];
        T1[L1++] = '@';
        LT1 = L1;
        for (t = 0; t < N3; t++)
          T1[L1++] = S3[t];
        T1[L1] = '\0';
        KMP(T1, R1);
        for (M1 = 0, t = LT1; T1[t]; t++)
          M1 = MAX(M1, R1[t]);
        for (t = M1; T1[t] != '@'; t++)
          T2[L2++] = T1[t];
        T2[L2++] = '@';
        LT2 = L2;
        for (t = 0; t < N4; t++)
          T2[L2++] = S4[t];
        T2[L2] = '\0';
        KMP(T2, R2);
        for (M2 = 0, t = LT2; T2[t]; t++)
          M2 = MAX(M2, R2[t]);
        if (M1 + M2 > Ans)
        {
          Ans = M1 + M2;
          s1 = i, l1 = MIN(j, M1 + M2);
          s2 = k, l2 = MAX(0, M1 + M2 - j);
          for (t = LT1; T1[t]; t++)
            if (R1[t] == M1)
            {
              s3 = t - LT1 - M1 + 1;
              break;
            }
          l3 = M1;
          for (t = LT2; T2[t]; t++)
            if (R2[t] == M2)
            {
              s4 = t - LT2 - M2 + 1;
              break;
            }
          l4 = M2;
        }
      }

  for (i = 0; i < l1; i++)
    putc(S1[i + s1], stdout);
  putc('\n', stdout);
  for (i = 0; i < l2; i++)
    putc(S2[i + s2], stdout);
  putc('\n', stdout);
  for (i = 0; i < l3; i++)
    putc(S3[i + s3], stdout);
  putc('\n', stdout);
  for (i = 0; i < l4; i++)
    putc(S4[i + s4], stdout);
  putc('\n', stdout);

  return 0;
}
