uses
        SysUtils;
const
        MaxN = 300;
        Inf = 1000000;
var
        a : Array[1 .. MaxN] of Char;
        rez : Array[1 .. MaxN, 1 .. MaxN, False .. True] of
        record
          used : Boolean;
          rez : LongInt;
{          sko : Array[1 .. MaxN] of Word;}
        end;
        min, max : Array[1 .. MaxN, 1 .. MaxN] of Char;
        n : LongInt;
        q : TDateTime;


Procedure DFS(const i, j : Word; const r : Boolean);
var
        k : Word;
begin
  if rez[i][j][r].used then
  begin
    Exit;
  end;
  rez[i][j][r].used := True;
  DFS(i, j, not r);
  if rez[i][j][not r].rez + 1 <= rez[i][j][r].rez then
  begin
    rez[i][j][r].rez := rez[i][j][not r].rez + 1;
  end;
  for k := i to j - 1 do
  begin
    DFS(i, k, r);
    DFS(k + 1, j, r);
    Case r of
      False :
      begin
        if (rez[i][j][r].rez > rez[i][k][r].rez + rez[k + 1][j][r].rez) and (max[i][k] <= min[k + 1][j]) then
          rez[i][j][r].rez := rez[i][k][r].rez + rez[k + 1][j][r].rez;
      end;
      True :
      begin
        if (rez[i][j][r].rez > rez[i][k][r].rez + rez[k + 1][j][r].rez) and (min[i][k] >= max[k + 1][j]) then
          rez[i][j][r].rez := rez[i][k][r].rez + rez[k + 1][j][r].rez;
      end;
    end;
  end;
  if rez[i][j][r].rez + 1 <= rez[i][j][not r].rez then
  begin
    rez[i][j][not r].rez := rez[i][j][r].rez + 1;
  end;
end;

Procedure Init;
var
        i, k : LongInt;
        j : Char;
        r : Boolean;
begin
  n := 0;
  While not EoLn do
  begin
    Inc(n);
    Read(a[n]);
  end;
  n := 0;
  While n <> 300 do
  begin
    Inc(n);
    if n mod 2 = 0 then
      a[n] := 'a'
    else
      a[n] := 'b';
  end;
  FillChar(rez, SizeOf(rez), 0);
  for i := 1 to n do
    for k := 1 to n do
      for r := False to True do
        rez[i][k][r].rez := Inf;
  for i := 1 to n do
  begin
    min[i][i] := a[i];
    max[i][i] := a[i];
    for k := i + 1 to n do
    begin
      max[i][k] := max[i][k - 1];
      if max[i][k] < a[k] then
        max[i][k] := a[k];
      min[i][k] := min[i][k - 1];
      if min[i][k] > a[k] then
        min[i][k] := a[k];
    end;
    rez[i][i][False].rez := 0;
    rez[i][i][True].rez := 0;
  end;
end;

Procedure Solve;
var
        i, j, k, len : LongInt;
        r : Boolean;
begin
  for len := 1 to n do
    for i := 1 to n - len + 1 do
    begin
      j := i + len - 1;
      if (rez[i][j][True].rez > rez[i][j][False].rez) then
      begin
        if rez[i][j][True].rez > rez[i][j][False].rez + 1 then
          rez[i][j][True].rez := rez[i][j][False].rez + 1;
      end;
      if (rez[i][j][False].rez > rez[i][j][True].rez) then
      begin
        if rez[i][j][False].rez > rez[i][j][True].rez + 1 then
          rez[i][j][False].rez := rez[i][j][True].rez + 1;
      end;

      for k := j + 1 to n do
        if (max[i][j] <= min[j + 1][k]) then
        begin
          if rez[i][k][False].rez > rez[i][j][False].rez + rez[j + 1][k][False].rez then
            rez[i][k][False].rez := rez[i][j][False].rez + rez[j + 1][k][False].rez;
        end;
      for k := j + 1 to n do
        if (min[i][j] >= max[j + 1][k]) then
        begin
          if rez[i][k][True].rez > rez[i][j][True].rez + rez[j + 1][k][True].rez then
            rez[i][k][True].rez := rez[i][j][True].rez + rez[j + 1][k][True].rez;
        end;
      for k := 1 to i - 1 do
        if (max[k][i - 1] <= min[i][j]) then
        begin
          if rez[k][j][False].rez > rez[k][i - 1][False].rez + rez[i][j][False].rez then
            rez[k][j][False].rez := rez[k][i - 1][False].rez + rez[i][j][False].rez;
        end;
      for k := 1 to i - 1 do
        if (min[k][i - 1] >= max[i][j]) then
        begin
          if rez[k][j][True].rez > rez[k][i - 1][True].rez + rez[i][j][True].rez then
            rez[k][j][True].rez := rez[k][i - 1][True].rez + rez[i][j][True].rez;
        end;
    end;
end;

Procedure Print;
begin
end;

begin
  Assign(input, 'cipher.in');
  Reset(input);
  Assign(output, 'cipher.out');
  Rewrite(output);
  q := Now;
  Init;
  Solve;
  DFS(1, n, False);
{  Print;}
  WriteLn(rez[1][n][False].rez);
  Close(input);
  Close(output);
  Assign(output, 'CON');
  Rewrite(output);
  WriteLn((Now - q) * 24 * 60 * 60 : 0 : 10);
  Close(output);
end.
