#include <stdio.h>
#include <string.h>

#define MAX 13
#define MAXPR 2100100

typedef double dbl;

char S1[MAX + 1], S2[MAX + 1];
int N, L, Pow3[MAX + 1];
int Pr = 0, A[MAX];
dbl F[MAXPR];

dbl dfs( void )
{
  int i, j, Pr1 = Pr;
  dbl f1, f0;

  if (F[Pr] != -1)
    return F[Pr]; 
  F[Pr] = 1e9;
  for (i = 0; i <= N - L; i++)
  {
    for (j = 0; j < L; j++)
      if (A[i + j] != S2[j])
        break;
    if (j == L)
      return F[Pr] = 0;
  }
  for (i = 0; i <= N - L; i++)
  {
    for (j = 0; j < L; j++)
      if (A[i + j] != S2[j] && A[i + j] != 2)
        break;
    if (j == L)
      break;
  }
  if (i > N - L)
    return F[Pr] = 0;
  for (i = 0; i < N; i++)
    if (A[i] == 2)
    {
      Pr -= Pow3[i], A[i]--;
      f1 = dfs();
      Pr -= Pow3[i], A[i]--;
      f0 = dfs();
      Pr = Pr1, A[i] = 2;
      if ((f1 + f0) * 0.5 + 1 < F[Pr])
        F[Pr] = (f1 + f0) * 0.5 + 1;
    }
  return F[Pr];
}

int main( void )
{
  int i;

  freopen("substring.in", "rt", stdin);
  freopen("substring.out", "wt", stdout);
  scanf("%s%s", S1, S2);
  N = strlen(S1);
  L = strlen(S2);
  for (i = 0; i < L; i++)
    S2[i] -= '0';
  for (Pow3[0] = 1, i = 0; i < N; i++)
    Pow3[i + 1] = Pow3[i] * 3;
  for (i = N - 1; i >= 0; i--)
  {
    if (S1[i] == '?')
      A[i] = 2;
    else
      A[i] = S1[i] - '0';
    Pr = Pr * 3 + A[i];
  }
  for (i = 0; i < MAXPR; i++)
    F[i] = -1;
  dfs();
  printf("%.18lf\n", F[Pr]);
  return 0;
}
