#include <stdio.h>
#include <string.h>

#define MIN(A, B) (((A) <= (B)) ? (A) : (B))
#define MAX(A, B) (((A) >= (B)) ? (A) : (B))
#define SWAP(A, B, C) ((C) = (A), (A) = (B), (B) = (C))
#define ABS(X) (((X) >= 0) ? (X) : -(X))
#define SQR(X) ((X) * (X))

#define eps 1e-9
#define inf (int)2e9

#define MAXL 15
#define MAXP 2 << 20

char S[MAXL], S2[MAXL];
int P3[MAXL], N, N2, B[MAXP], WP, WM;
double D[MAXP];

double F( int pr )
{
  int i, mask = 0, prof = 0, f = 1;
  if (B[pr])
    return D[pr];
  for (i = 0; i <= N - N2; i++)
    if ((pr / P3[i]) % P3[N2] == WP)
    {
      B[pr] = 1;
      return D[pr] = 0;
    }
  for (i = 0; i < N; i++)
    if ((pr / P3[i]) % 3)
      mask |= 1 << i;
  for (i = 0; i < N; i++)
    if ((pr / P3[i]) % 3 == 2)
      prof |= 1 << i;
  for (i = 0; i <= N - N2 && f; i++)
    if (((prof >> i) & ((1 << N2) - 1)) == (WM & ((mask >> i) & ((1 << N2) - 1))))
      f = 0;
  if (f)
  {
    B[pr] = 1;
    return D[pr] = 0;
  }
  D[pr] = 1e255;
  for (i = 0; i < N; i++)
    if (!(mask & (1 << i)))
    {
      double T = 1 + 0.5 * F(pr + P3[i]) + 0.5 * F(pr + 2 * P3[i]);
      D[pr] = MIN(D[pr], T);
    }
  B[pr] = 0;
  return D[pr];
}

int main( void )
{
  int i, pr;

  P3[0] = 1;
  for (i = 0; i < 13; i++)
    P3[i + 1] = 3 * P3[i];

  freopen("substring.in", "rt", stdin);
  freopen("substring.out", "wt", stdout);

  scanf("%s%s", S, S2);
  N = strlen(S), N2 = strlen(S2);

  WP = 0;
  for (i = 0; i < N2; i++)
    if (S2[i] == '0')
      WP += P3[i];
    else if (S2[i] == '1')
      WP += 2 * P3[i];

  WM = 0;
  for (i = 0; i < N2; i++)
    if (S2[i] == '1')
      WM |= 1 << i;

  pr = 0;
  for (i = 0; i < N; i++)
    if (S[i] == '0')
      pr += P3[i];
    else if (S[i] == '1')
      pr += 2 * P3[i];
  memset(B, 0, sizeof(B));
  printf("%.15lf\n", F(pr));

  return 0;
}
