#include <stdio.h>
#include <memory.h>
#include <string.h>

int n;
int cnt['z'-'a'+1];
int cc['z'-'a'+1];
char expr[310];
int res[310][310][2];
int father[310][310][2];
bool done[310][310][2];
bool left[310][310][310];
bool lrev[310][310][310];
bool sorted[310][310][2];

int readString(char *arr) {
	fgets(arr, 305, stdin);
	int len = strlen(arr);
	while ((arr[len-1] == ' ') || (arr[len-1] == '\n'))
		len--;
	arr[len] = 0;
	return len;
}

int Solve(int u, int v, bool rev) {
	if (done[u][v][rev])
		return res[u][v][rev];
	done[u][v][rev] = true;
	if (sorted[u][v][rev])
		return (res[u][v][rev] = 0);
	int tr;
	tr = Solve(u, v, !rev) + 1;
	if (res[u][v][rev] > tr) {
		res[u][v][rev] = tr;
		father[u][v][rev] = -1;
	}
	int l;
	for (l = 1; l<v-u; l++) {
		if (rev) {
			if (!lrev[u][v][l])
				continue;
		}
		else {
			if (!left[u][v][l])
				continue;
		}
		if (rev)
			tr = Solve(u, v-l, rev) + Solve(v-l, v, rev);
		else
			tr = Solve(u, u+l, rev) + Solve(u+l, v, rev);
		if (res[u][v][rev] > tr) {
			res[u][v][rev] = tr;
			father[u][v][rev] = l;
		}
	}
	return res[u][v][rev];
}

void DFSPrint(int u, int v, bool rev) {
	if (sorted[u][v][rev]) {
		if (rev) {
			for (int i = v-1; i>=u; i--)
				printf("%c", expr[i]);
		}
		else {
			for (int i = u; i<v; i++)
				printf("%c", expr[i]);
		}
		return;
	}
	if (father[u][v][rev] < 0) {
		printf("[");
		DFSPrint(u, v, !rev);
		printf("]");
		return;
	}
	if (rev) {
		DFSPrint(v-father[u][v][rev], v, rev);
		DFSPrint(u, v-father[u][v][rev], rev);
	}
	else {
		DFSPrint(u, u+father[u][v][rev], rev);
		DFSPrint(u+father[u][v][rev], v, rev);
	}
}

int main(int argc, char **argv) {
	freopen("cipher.in", "r", stdin);
	freopen("cipher.out", "w", stdout);
	n = readString(expr);
	memset(res, 21, sizeof(res));
	int i, j, k, u;
        for (i = 0; i<=n; i++) {
            sorted[i][i][0] = true;
            sorted[i][i][1] = true;
        }
	for (i = 0; i<n; i++)
		for (j = i+1; j<=n; j++) {
			memset(cnt, 0, sizeof(cnt));
			for (k = i; k<j; k++)
				cnt[expr[k]-'a']++;
			memset(cc, 0, sizeof(cc));
			sorted[i][j][0] = true;
			for (k = i; k<=j; k++) {
				bool diff = false;
				bool ok = true;
				for (u = 0; u<='z'-'a'; u++) {
					if (diff) {
						if (cc[u]>0) {
							ok = false;
							break;
						}
					}
					else {
						if (cc[u] < cnt[u])
							diff = true;
					}
				}
				left[i][j][k-i] = ok;
				if (!ok) sorted[i][j][0] = false;
				if (expr[k] >= 'a')
					cc[expr[k]-'a']++;
			}
			sorted[i][j][1] = true;
			memset(cc, 0, sizeof(cc));
			for (k = j; k>=i; k--) {
				bool diff = false;
				bool ok = true;
				for (u = 0; u<='z'-'a'; u++) {
					if (diff) {
						if (cc[u]>0) {
							ok = false;
							break;
						}
					}
					else {
						if (cc[u] < cnt[u])
							diff = true;
					}
				}
				lrev[i][j][j-k] = ok;
				if (!ok) sorted[i][j][1] = false;
				if (expr[k-1] >= 'a')
					cc[expr[k-1]-'a']++;
			}

		}
    Solve(0, n, 0);
    if (res[0][n][0] > 100000) {
    	printf("NO SOLUTION");
    	return 0;
    }
//    printf("%d\n", res[0][n][0]);
    DFSPrint(0, n, 0);
	return 0;
}
