#include <cstdio>
#include <cstdlib>
#include <ctime>
#include <cstring>

#include <algorithm>
using namespace std;

int left[26][26];
int your_c;

int end_clock;

#define WIN_SCORE        10000
#define LOSE_SCORE      -10000
int MAX_REC_LENGTH = 5;

int get_max (int l, int a, int b);
int get_min (int l, int a, int b);

int rate ()
{
  int num_s = 0;
  for (int i = 0; i < 26; i++)
    if (left[your_c][i])
      num_s++;
  if (num_s)
    return num_s;
  return LOSE_SCORE;
}

int get_max (int l, int a, int b)
{
  if (l == 0 || clock () > end_clock)
    return rate () * (MAX_REC_LENGTH-l+1);
  int r = a;
  int sv_pos = your_c;
  for (int c = 0; c < 26; c++)
  {
    if (!left[your_c][c])
      continue;
    left[your_c][c]--;
    your_c = c;
    int t = get_min (l - 1, r, b);
    your_c = sv_pos;
    left[your_c][c]++;
    if (r < t)
      r = t;
    if (r >= b)
      return b;
  }
  return r;
}

int get_min (int l, int a, int b)
{
  if (l == 0 || clock () > end_clock)
    return -rate () * (MAX_REC_LENGTH-l+1);
  int r = b;
  int sv_pos = your_c;
  for (int c = 0; c < 26; c++)
  {
    if (!left[your_c][c])
      continue;
    left[your_c][c]--;
    your_c = c;
    int t = get_max (l - 1, a, r);
    your_c = sv_pos;
    left[your_c][c]++;
    if (r > t)
      r = t;
    if (r <= a)
      return a;
  }
  return r;
}

struct turn
{
  int c;
  int rating;
};

inline bool operator < (turn const& a, turn const& b)
{
  return a.rating < b.rating;
}

int bfs_count ()
{
  int queue [32];
  bool vis [26];
  int qh = 1, qt = 0;
  queue[0] = your_c;
  memset (vis, 0, sizeof vis);
  vis[your_c] = true;
  int count = 1;
  
  while (qt < qh)
  {
    int ch = queue [qt++];
    
    for (int i = 0; i < 26; i++)
      if (left[ch][i] && !vis[i])
        vis[i] = true,
        count++,
        queue[qh++] = i;
  }
  return count;
}

int main ()
{
  end_clock = clock () + CLOCKS_PER_SEC * 950 / 1000;

  freopen ( "towns.in", "rt", stdin );
  freopen ( "towns.out", "wt", stdout );

  int i, j, k;
  char str[64];

  for (i = 0; i < 26; i++)
    for (j = 0; j < 26; j++)
      scanf ("%d", &left[i][j]);
  scanf ("%s", str);
  your_c = str[0] - 'a';

  turn turns [26];
  int num_t = 0;
  int sv_pos = your_c;
  for (i = 0; i < 26; i++)
  {
    if (left[your_c][i])
    {
      turns[num_t].c = i;
      left[your_c][i]--;
      your_c = i;
      turns[num_t++].rating = rate ();
      your_c = sv_pos;
      left[your_c][i]++;
    }
  }
  if (num_t <= 0)
    return 1;
  sort (turns, turns + num_t);

  // bfs to find accessible cells
  int usec = bfs_count ();
  if (usec >= 10)
    MAX_REC_LENGTH = 5;
  else
    MAX_REC_LENGTH = 15 - usec;

  int bturn = -1;
  int r = LOSE_SCORE;

  for (i = 0; i < num_t; i++)
  {
    if (clock () > end_clock)
    {
      FILE* b = fopen ("botva.txt", "wt");
      fprintf (b, "BOTVA");
      fclose (b);
      break;
    }
    int c = turns[i].c;
    left[your_c][c]--;
    your_c = c;
    int t = get_min (MAX_REC_LENGTH, r, WIN_SCORE);
    if (t > r || bturn < 0)
      r = t, bturn = c;
    if (r >= WIN_SCORE)
      break;
    your_c = sv_pos;
    left[your_c][c]++;
  }

  printf ("%c", bturn + 'a');

  return 0;
}
