#include <stdio.h>
#include <math.h>
#include <time.h>

int MAX_DEPTH;
int matr[26][26];
int deg[26];
double avdeg;
char start;
int turn;
int stime;

float Solve(int x, int depth) {
	if ((clock()-stime)*1000 > 900*CLOCKS_PER_SEC)
		return 0.5;
	int i;
	if (depth > MAX_DEPTH) {
		if (deg[x]<=5)
			return ((deg[x]&1)+1) / 3.0;
		else
			return 0.5;
	}
	float res = 1.0;
	for (i = 0; i<='z'-'a'; i++) {
		float tr;
		if (matr[x][i] > 0) {
			matr[x][i]--;
			deg[x]--;
			tr = Solve(i, depth+1);
			deg[x]++;
			matr[x][i]++;
			if (tr < res) {
				res = tr;
				if (depth==0) turn = i;
				if (tr==0.0) break;
			}
		}
	}
	res = 1.0 - res;
	return res;
}

int main(int argc, char **argv) {
	freopen("towns.in", "r", stdin);
	freopen("towns.out", "w", stdout);
	int i, j;
	stime = clock();
	avdeg = 1.0;
	for (i = 0; i<26; i++) {
		int cdeg = 0;
		for (j = 0; j<26; j++) {
			scanf("%d", &(matr[i][j]));
			if (matr[i][j] > 0) cdeg++;
			deg[i] += matr[i][j];
		}
		if (cdeg > avdeg) avdeg = cdeg;
		scanf("\n");
	}
	if (avdeg > 1.0)
		MAX_DEPTH = log(500000000/26)/log(avdeg);
	else
		MAX_DEPTH = 100000;
	scanf("%c", &start);
	start -= 'a';
	turn = -1;
	Solve(start, 0);
	if (turn<0) {
		for (i = 0; i<26; i++)
			if (matr[start][i] > 0)
				turn = i;
	}
	printf("%c", turn+'a');
	return 0;
}
