#include "stack.h"
#include <stdio.h>
#include <memory.h>
#include <string.h>
#include <stdlib.h>
#include <math.h>
#include <deque>
#include <time.h>

#define DEBUG 0
#define START 270
#define SIZE 5000010
#define CHUNK 10000
#define MAXT 102

int c1, c2, t;
int curr;
int lowb, upb;
int cnt;
int p[2][110][110];
bool history[SIZE];
struct TRes {
	bool his;
	int res[MAXT];
	int father[MAXT];
};
typedef std::deque<TRes> rDeque;
typedef rDeque::iterator dIter;
rDeque arr;
int stime;

template<class T> inline T min2(T a, T b) { return (a<b ? a : b); }
template<class T> inline T max2(T a, T b) { return (a>b ? a : b); }

inline void loadX(int a) {
	a = min2(a, slowCount());
	if (DEBUG) printf("    Loaded %d of %d (%d).\n", a, slowCount(), c1 + c2*a);
	load(a);
}
inline void saveX(int a) {
	a = min2(a, fastCount());
	if (DEBUG) printf("    Saved %d of %d (%d).\n", a, fastCount(), c1 + c2*a);
	save(a);
}

void Solve(bool op) {
	TRes nr;
	nr.his = op;	
	TRes &it = arr.front();
	int i;
	if (op == PUSH) {
		nr.res[0] = 0x3f3f3f3f;
		nr.father[0] = -1;
		for (i = 1; i<=t; i++) {
			nr.res[i] = it.res[i-1] + 1;
			nr.father[i] = 0;
		}
		int best = t;
		int cost = c1 + it.res[t];
		for (i = t; i>0; i--) {
			cost += c2;
			if (nr.res[i] > cost) {
				nr.res[i] = cost;
				nr.father[i] = best-i+1;
			}
			if (cost > it.res[i-1] + c1) {
				cost = it.res[i-1] + c1;
				best = i-1;
			}
		}
	}
	if (op == POP) {
		nr.res[t] = 0x3f3f3f3f;
		nr.father[t] = -1;
		for (i = 0; i<t; i++) {
			nr.res[i] = it.res[i+1] + 1;
			nr.father[i] = 0;
		}
		int best = 0;
		int cost = c1 + it.res[0];
		for (i = 0; i<t; i++) {
			cost += c2;
			if (nr.res[i] > cost) {
				nr.res[i] = cost;
				nr.father[i] = i-best+1;
			}
			if (cost > it.res[i+1] + c1) {
				cost = it.res[i+1] + c1;
				best = i+1;
			}
		}
	}
	if (arr.size() >= CHUNK-1)
		arr.pop_back();
	arr.push_front(nr);
}

int main(int argc, char **argv) {
	if (DEBUG) freopen("debug.out", "w", stdout);
	stime = clock();
	freopen("debst.in", "r", stdin);
	int n;
	scanf("%d", &n);
	init(&c1, &c2, &t);
	if (DEBUG) printf("Initialization: c1=%d, c2=%d, T=%d.\n", c1, c2, t);
    TRes str;
    memset(str.res, 63, sizeof(str.res));
    memset(str.father, -1, sizeof(str.father));
    str.res[0] = 0;
    arr.push_front(str);
	lowb = 0;
	upb = t;
	cnt = 0;
	int i;
	while (1) {
		cnt++;
		curr = nextOp();
		history[cnt-1] = curr;
		if ((clock()-stime) < 9*CLOCKS_PER_SEC) {
			Solve(curr);
		if (((cnt&255) == 0) && (cnt>=START-2)) {
			int best = 64;
			int j;
			int min = 1000000000;
			for (i = 0; i<min2(SIZE/cnt, cnt); i++) {
				int from = rand()%(min2(cnt, CHUNK)-127) + 127;
				int diff = 0;
				for (j = 1; j<=125; j++)
					diff += history[cnt-from-j] != history[cnt-j];
				if (diff < min) {
					min = diff;
					best = from;
				}
			}
			memset(p, 0, sizeof(p));
			dIter it = arr.begin();
			it += best;
			for (i = 127; i>=0; i--) {
				for (j = 0; j<=t; j++) {
					if (it->res[j] < 1000000000) {
						if (it->his)
							p[1][j+(it->father[j])-1][it->father[j]]++;
						else
							p[0][j-(it->father[j])+1][it->father[j]]++;
					}
				}
				it--;
			}
		}
		}
		if (DEBUG) printf("Operation %d: %s.\n", cnt, (curr ? "PUSH" : "POP"));
		if (cnt < START) {
			if (curr == PUSH) {
				if (fastCount() >= upb)
					saveX((upb-lowb+1)/2);
			}
			if (curr == POP) {
				if (fastCount() <= lowb)
					loadX((upb-lowb+1)/2);
			}
		}
		else {
			int best = 0;
			int fc = fastCount();
			for (i = 0; i<=t; i++)
				if (p[curr][fc][i] > p[curr][fc][best])
					best = i;
			if (curr) {
				if (best>0)
					saveX(best);
				else {
					if (fc==t)
						saveX((t+1)/2);
				}
			}
			else {
				if (best>0)
					loadX(best);
				else {
					if (fc==0)
						loadX((t+1)/2);
				}
			}
		}
		if (DEBUG) printf("(done)\n");
	}
	return 0;
}
