#pragma comment (linker, "/STACK:30000000")
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "a.in"
#define OUT_FILE "a.out"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define NMAX 200000

int n, m;
vector<int> g[NMAX];
vector<bool> u[NMAX];
VI cf, res;
bool ansexist;

void outdata() {
    if (ansexist) {
        printf("%d\n", (int)res.size());
        forv(i, res) {
            printf("%d\n", res[i] + 1);
        }
    } else {
        printf("0\n");
    }
}

void face(int v, int r) {
    if (u[v][r]) {
        if (cf.size() == 0 || (int)cf.size() == n) return ;
        if (cf.size() > 3) {
            res = cf;
            ansexist = true;
        }
        return ;
    }
    u[v][r] = true;
    cf.pb(v);
    r = (r + 1) % (int)g[v].size();
    int nv = (g[v][r] + v) % n;
    int vp = v - nv; 
    while (vp < 0) vp += n; while (vp >= n) vp -= n;
    face(nv, (int)(lower_bound(all(g[nv]), vp) - g[nv].begin()));
}

void solve() {
    ansexist = false;
    if (m == 0) {
	if (n <= 3) return ;
        ansexist = true;
        res.resize(n);
        forn(i, n) res[i] = i;
        return ;
    }
    forn(i, n) {
        sort(all(g[i]));
        g[i].erase(unique(all(g[i])), g[i].end());
        u[i] = vector<bool>(g[i].size(), false);
    }
    forn(i, n) {
        forv(j, g[i]) {
            cf.clear();
            face(i, j);
        }
    }
}

void push(int x, int y) {
    g[x].pb(y);
    g[y].pb(x);
}

void readdata() {
    scanf("%d%d", &n, &m);
    forn(i, m) {
        int x, y;
        scanf("%d%d", &x, &y);
        --x; --y;
        push(x, y);
		assert(x >= 0 && x < n);
		assert(y >= 0 && y < n);
		assert(x != y);
    }
    forn(i, n) {
        push(i, (i + 1) % n);
    }
    forn(i, n) {
        forv(j, g[i]) {
            g[i][j] -= i;
            while (g[i][j] < 0) g[i][j] += n;
            while (g[i][j] >= n) g[i][j] -= n;
        }
    }
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}

