#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "necklace.in"
#define OUT_FILE "necklace.out"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define CMAX 6
#define NMAX 210

struct event {
    int msexist, msodd;
    VI p;
};

bool operator < (const event &a, const event &b) {
    if (a.msexist != b.msexist) return a.msexist < b.msexist;
    if (a.msodd != b.msodd) return a.msodd < b.msodd;
    return a.p < b.p;
}

int n, k, os;
int cost[CMAX];
map<event, int> d[NMAX], pv[NMAX];
map<event, event> ps[NMAX];
vector< VI > zag;

int res;
event evr;

int gr[CMAX][CMAX];
int deg[CMAX], uk[CMAX];
vector< PII > grv[CMAX][CMAX];

VI start() {
    VI res(CMAX);
    forn(i, CMAX) res[i] = i;
    return res;
}

bool good(const event &a) {
    if (a.msodd != 0) return false;
    set<int> par;
    forv(i, a.p) {
        if ((a.msexist & (1 << i)) != 0) {
            par.insert(a.p[i]);
        }
    }
    return par.size() <= 1;
}

bool POCHTYgood(const event &a) {
    return a.msodd == 0;
}

void connect(VI &res, VI &c, int a, int b) {
    int mn = min(c[a], c[b]), mx = max(c[a], c[b]);
    res.resize((int)c.size());
    forv(i, c) {
        if (c[i] == mx) res[i] = mn; else res[i] = c[i];
    }
}

void addPolygon(int num, int rot) {
    int a = zag[num][rot], b = zag[num][(rot + os) % k];
    if (a > b) swap(a, b);
    ++gr[a][b]; ++gr[b][a];
    ++deg[a]; ++deg[b];
    grv[a][b].pb(mp(num, rot));
}

VI resP;

void deep(int v) {
    for(int i = uk[v]; i < CMAX; ++i) {
        if (gr[v][i] > 0) {
            uk[v] = i;
            --gr[v][i]; --gr[i][v];
            --deg[v]; --deg[i];
            deep(i);
        }
    }
    uk[v] = CMAX;
    resP.pb(v);
}

int convert(int a) {
    int res;
    if (a >= os) {
        res = (a - os) * 2 + 1;
    } else {
        res = a * 2;
    }
    return res;
}

void outdata() {
    if (res >= INF) {
        printf("-1\n");
    } else {
        forn(i, CMAX) {
            forn(j, CMAX) {
                gr[i][j] = 0;
            }
        }
        forn(i, CMAX) {
            deg[i] = 0;
            uk[i] = 0;
        }
        assert((res & 1) == 0);
        printf("%d\n", -res / 2);
        int position = n;
        while (position > 0) {
            addPolygon(position - 1, pv[position][evr]);
            evr = ps[position][evr];
            --position;
        }
        cerr << "ok \n";
        forn(i, CMAX) {
            if (deg[i] > 0) {
                deep(i);
                break;
            }
        }
        cerr << "ok \n";
        forn(i, CMAX) {
            assert(deg[i] == 0);    
        }
        cerr << "ok \n";
        forv(i, resP) {
            cerr << "start " << i << " \n";
            if (i + 1 < (int)resP.size()) {
                int a = resP[i], b = resP[i + 1];
                if (a > b) swap(a, b);
                PII tp = grv[a][b].back();
                grv[a][b].pop_back();
                int add = 0;
                a = resP[i], b = resP[i + 1];
                if (zag[tp.first][tp.second] != a) add = os;
                printf("%d %d\n", tp.first + 1, convert(tp.second + 1 + add));
            }
        }
    }
}

void solve() {
    event t;
    t.p = start();
    t.msexist = 0;
    t.msodd = 0;
    d[0][t] = 0;
    forn(i, n) {
        cerr << d[i].size() << " --- size\n";
        for(map<event, int>::iterator j = d[i].begin(); j != d[i].end(); ++j) {
            forn(t, os) {
                event olev = j->first, nev;
                int a = zag[i][t], b = zag[i][(t + os) % k];
                nev.msexist = olev.msexist | (1 << a) | (1 << b);
                nev.msodd = olev.msodd ^ (1 << a) ^ (1 << b);
                connect(nev.p, olev.p, a, b);
                if (d[i + 1].count(nev) == 0 || d[i + 1][nev] > j->second + cost[a] + cost[b]) {
                    d[i + 1][nev] = j->second + cost[a] + cost[b];
                    ps[i + 1][nev] = olev;
                    pv[i + 1][nev] = t;
                }
            }
        }
    }
    res = INF;
    int resPOCHTY = INF;
    int numGOOD = 0, numPOCHTYGOOD = 0;
    for(map<event, int>::iterator i = d[n].begin(); i != d[n].end(); ++i) {
        if (good(i->first)) {
            cerr << (i->first).msexist << " " << (i->first).msodd << " \nxxxxx\n" << endl;
            good(i->first);
            ++numGOOD;
            if (res > i->second) {
                res = i->second;
                evr = i->first;
            }
        }
        if (POCHTYgood(i->first)) {
            ++numPOCHTYGOOD;
            if (resPOCHTY > i->second) {
                resPOCHTY = i->second;
            }
        }
    }
    cout << -resPOCHTY / 2 << endl;
    exit(0);
    cerr << -resPOCHTY / 2 << " POCHTY\n";
    cerr << numGOOD << " numGOOD\n";
    cerr << numPOCHTYGOOD << " numPOCHTYGOOD\n";
}

void readdata() {
    cin >> n >> k;
    forn(i, CMAX) {
        cin >> cost[i];
        cost[i] = -cost[i];
    }
    assert(1 <= n && n <= 200);
    assert(1 <= k && k <= 10 && (k & 1) == 0);
    os = k / 2;
    string s;
    getline(cin, s);
    zag.reserve(n);
    forn(i, n) {
        getline(cin, s);
        assert((int)s.length() == k);
        VI bf(k, 0);
        forn(j, os) bf[j] = s[j * 2] - 'a';
        forn(j, os) bf[j + os] = s[j * 2 + 1] - 'a';
        fors(j, s) assert(bf[j] < CMAX);
        zag.pb(bf);
    }
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}
