#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "torus.in"
#define OUT_FILE "torus.out"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

int n, m;

#define NMAX 111111

struct edge
{
	int v;
	bool active;
	int undo;
};

vector<edge> g[NMAX];
VI used, p, c, h;

int cyc;
int intr;

void outdata() 
{
	bool ok = (cyc < 2 || (cyc == 2 && intr == 1));
	printf((ok) ? "YES" : "NO");
	printf("\n");
}

void use_edge(int a, int ps)
{
	g[a][ps].active = false;
	g[g[a][ps].v][g[a][ps].undo].active = false;
}

void push(int a, int b)
{
	edge e1;
	int ptr = g[a].size();
	g[a].pb(e1);
	g[a][ptr].v = b; g[a][ptr].active = true; g[a][ptr].undo = g[b].size();
	edge e2;
	e2.v = a; e2.active = true; e2.undo = ptr;
	g[b].pb(e2);
}

void go(int v)
{
	if (used[v]) return ;
	used[v] = 1;
	forv (i, g[v]) if (g[v][i].active)
	{
		use_edge(v, i);
		int nx = g[v][i].v;
		if (used[nx] > 0) 
		{
			if (h[nx] > h[v]) continue;
			++cyc;
			if (cyc > 2) return ;
			int ptr = v;
			while (1)
			{
				if (++c[ptr] > 1) intr = 1;
				if (ptr == nx) break;
				ptr = p[ptr];
			}
		} else
		{
			p[nx] = v;
			h[nx] = h[v] + 1;
			go(nx);
			if (cyc > 2) return ;
		}
	}
}

void solve() 
{
	cyc = 0; intr = 0;
	used = VI(n, 0);
	p = VI(n, -1);
	c = VI(n, 0);
	h = VI(n, 0);
	forn (i, n) go(i);
}

void readdata(int test) 
{
	scanf("%d %d", &n, &m);
	assert(n <= 100000 && m <= 150000);
	forn (i, n) g[i].clear();
	forn (i, m)
	{
		int a, b;
		scanf("%d %d", &a, &b);
		--a; --b;
		if (!(a >= 0 && a < n && b >= 0 && b < n)) 
		{
			cerr << "Test No " << test << " line No " << i + 1 << " INCORRECT\n" << "a = " << a + 1 << " b = " << b + 1 << " N = " << n << endl;
			assert(false);
		}
		push(a, b);
	}
}

int main() 
{
	freopen(IN_FILE, "rt", stdin);
	freopen(OUT_FILE, "wt", stdout);
	int tst;
	scanf("%d", &tst);
	forn (i, tst)
	{
		readdata(i + 1);
		solve();
		outdata();
	}
	return 0;
}

