#define _CRT_SECURE_NO_DEPRECATE

#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;
#define IN_FILE "hangup.in"
#define OUT_FILE "hangup.out"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define NMAX 100000
#define XMAX (int)(1E+9)
#define list (1 << 17)

int n;
vector< pair<int, pair<int, int> > > a;
long long ans;
int tree[(list << 1) + 1];
VI numV;

void outdata() {
	cout << ans << endl;
	forn(i, n) {
		printf("%d\n", numV[i]);
	}
}

int treeFind(int l, int r) {
	int v = 1;
	while (v < list) {
		v <<= 1;
		if (tree[v] > l) ++v;
	}
	assert(tree[v] <= l);
	int res = v - list + 1;
	tree[v] = r;
	while (v > 1) {
		v >>= 1;
		tree[v] = min(tree[v << 1], tree[(v << 1) + 1]);
	}
	return res;
}

void solve() {
	numV.resize(n);
	sort(all(a));
	memset(tree, 0, sizeof(tree));
	ans = 0;
	int maxNumV = 0;
	forv(i, a) {
		int c = treeFind(a[i].second.first, a[i].first);
		maxNumV = max(maxNumV, c);
		numV[a[i].second.second] = c;
		ans += c << 1;
	}
	cerr << n << " " << maxNumV << endl;
}

void readdata() {
	scanf("%d", &n);
	assert(n >= 1 && n <= NMAX);
	a.reserve(n);
	forn(i, n) {
		int l, r;
		scanf("%d%d", &l, &r);
		assert(l >= 1 && l <= XMAX);
		assert(r >= 1 && r <= XMAX);
		assert(r > l);
		a.pb(mp(r, mp(l, i)));
	}
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}

