#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")

#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "icecream.in"
#define OUT_FILE "icecream.out"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

struct edge {
	int v, w;
	int c, p;
	int nxt;
};

int n, m;
int ist, sto;
int st, fn, md;
VI g;
vector<edge> r;
VI pt;

int rn;
bool ans;
int result;

VI go(int v) {
	VI res;
	while (v != sto) {
		if (v < rn) res.pb(v);
		int e;
		for (e = g[v]; e != -1; e = r[e].nxt) {
			if (r[e].p > 0) {
				--r[e].p;
				result += r[e].w;
				v = r[e].v;
				break;
			}
		}
		assert(e != -1);
	}
	return res;
}

void outdata() {
	if (!ans) {
		printf("-1\n");
		return ;
	}
	result = 0;
	VI pac = go(st), pbc = go(fn);
	pac.pop_back();
	reverse(all(pbc));
	printf("%d %d\n", (int)(pac.size() + pbc.size()) - 1, result);
	forv(i, pac) printf("%d ", pac[i] + 1);
	forv(i, pbc) printf("%d ", pbc[i] + 1);
	printf("\n");
}

bool dijkstra(int a, int b) {
	set< pair<int, int> > s;
	VI d(n, INF), p(n, -1);
	d[a] = 0;
	s.insert(mp(0, a));
	while (!s.empty()) {
		int v = s.begin()->second, ds = s.begin()->first;
		s.erase(s.begin());
		if (d[v] < ds) continue;
		for (int e = g[v]; e != -1; e = r[e].nxt) {
			if (r[e].c > r[e].p && d[r[e].v] > ds + r[e].w + pt[v] - pt[r[e].v]) {
				d[r[e].v] = ds + r[e].w + pt[v] - pt[r[e].v];
				p[r[e].v] = e;
				s.insert(mp(d[r[e].v], r[e].v));
			}
		}
	}
	if (d[b] >= INF) return false;
	forn(i, n) pt[i] += d[i] * (d[i] < INF);
	int v = b;
	while (p[v] > -1) {
		r[p[v]].p += 1;
		v = r[p[v] ^ 1].v;
	}
	return true;
}

void push(int a, int b, int w, int c) {
	edge e;
	e.v = b; e.w =  w, e.c = c; e.p = 0; e.nxt = g[a]; g[a] = (int)r.size();
	r.pb(e);
	e.v = a; e.w = -w, e.c = 0; e.p = 0; e.nxt = g[b]; g[b] = (int)r.size();
	r.pb(e);
}

void solve() {
	rn = n;
	n = 2 * n;
	ist = n++, sto = n++;
	push(ist, st, 0, 1);
	push(ist, fn, 0, 1);
	push(md, sto, 0, 2);
	pt = VI(n, 0);
	forn(ii, 2) {
		if (!dijkstra(ist, sto)) {
			ans = false;
			return ;
		}
	}
	ans = true;
}

void readdata() {
	scanf("%d%d", &n, &m);
	assert(3 <= n && n <= 30000);
	assert(0 <= m && m <= 50000);
	scanf("%d%d%d", &st, &fn, &md);
	--st; --fn; --md;
	assert(st >= 0 && st < n);
	assert(fn >= 0 && fn < n);
	assert(md >= 0 && md < n);
	g = VI(2 * n + 2, -1);
	r.reserve(m * 4 + n + 3);
	forn(i, m) {
		int x, y, z;
		scanf("%d%d%d", &x, &y, &z);
		--x; --y;
		assert(x >= 0 && x < n);
		assert(y >= 0 && y < n);
		assert(x != y);
		push(x + n, y, z, 1);
		push(y + n, x, z, 1);
	}
	forn(i, n) push(i, i + n, 0, 1);
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}

