#define _CRT_SECURE_NO_DEPRECATE

#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "icecream.in"
#define OUT_FILE "icecream.out"

const int INF = (int)1E+8;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

int n, m;

struct edge
{
    int a;
    int b;
    int w;
    int c;
    int f;
    int undo;
	int next;
	bool right;
};

const int NMAX = 30000;
const int MMAX  = 50000;

#define VMAX (2 * NMAX + 10)
#define EMAX (4 * MMAX + 2 * NMAX + 10)

#define INF ((int)(1E+9))

edge e[EMAX];
int g[VMAX];
int ke = 0;

int s, t, kv;

int a, b, c;

int pot[VMAX];

bool ans = true;
long long weight = 0;

void push(int a, int b, int w, int c)
{
    e[ke].a = a; e[ke].b = b; e[ke].w = w; e[ke].c = c;
    e[ke].f = 0;
    e[ke].undo = ke + 1;
	e[ke].next = g[a];
	e[ke].right = true;
	g[a] = ke;
    ++ke;
    e[ke].a = b; e[ke].b = a; e[ke].w = -w; e[ke].c = 0;
    e[ke].f = 0;
    e[ke].undo = ke - 1;
	e[ke].next = g[b];
	e[ke].right = false;
	g[b] = ke;
    ++ke;
}

int dst[VMAX];
int par[VMAX];

int path()
{
	forn (i, VMAX) dst[i] = INF;
	forn (i, kv) par[i] = -1;
	dst[s] = 0;
	bool updated = true;
	while (updated)
	{
		updated = false;
		forn (j, ke) if (e[j].c - e[j].f > 0 && dst[e[j].a] < INF)
			if (dst[e[j].b] > dst[e[j].a] + e[j].w)
			{
				dst[e[j].b] = dst[e[j].a] + e[j].w;
				par[e[j].b] = j;
				updated = true;
			}
	}
	if (dst[t] == INF) return 0;
	int v = t;
	weight += dst[t];
	while (v != s)
	{
		int ptr = par[v];
		++e[ptr].f;
		--e[e[ptr].undo].f;
		v  = e[ptr].a;
	}
	return 1;
}

void outdata() 
{
	if (!ans) 
	{
		printf("-1\n");
		return ;
	}
	VI fromA, fromB;
	int v = 2 * a;
	fromA.pb(a);
	while (v != t)
	{
		for (int ptr = g[v]; ptr != -1; ptr = e[ptr].next)
			if (e[ptr].right && e[ptr].f > 0)
			{
				v = e[ptr].b;
				--e[ptr].f;
				if ((v & 1) == 0 && (v / 2 < n)) fromA.pb(v / 2);
				break;
			}
	}
	v = 2 * b;
	while (v != t)
	{
		for (int ptr = g[v]; ptr != -1; ptr = e[ptr].next)
			if (e[ptr].right && e[ptr].f > 0)
			{
				v = e[ptr].b;
				e[ptr].f = 0;
				if ((v & 1) == 1 && ((v - 1) / 2 < n)) fromB.pb((v - 1) / 2);
				break;
			}
	}
	reverse(all(fromB));
	cout << fromA.size() + fromB.size() - 1 << " " << weight << endl;
	forv (i, fromA) 
	{
		if (i > 0) printf(" ");
		printf("%d", fromA[i] + 1);
	}
	forv (i, fromB)	printf(" %d", fromB[i] + 1);
}

void solve() 
{
	forn (i, kv) pot[i] = 0;
	forn (i, 2)
		if (!path()) 
		{
			ans = false;
			return ;
		}
}

void readdata() 
{
	scanf("%d %d", &n, &m);
	scanf("%d %d %d", &a, &b, &c);
	--a; --b; --c;
	forn (i, VMAX) g[i] = -1;
    forn (i, m)
    {
        int a, b, w;
        scanf("%d %d %d", &a, &b, &w);
		--a; --b;
        push(2 * a + 1, 2 * b, w, 1);
        push(2 * b + 1, 2 * a, w, 1);
    }
    forn (i, n) push(2 * i, 2 * i + 1, 0, 1);
    kv = 2 * n;
    s = kv++;
    t = kv++;
	push(s, 2 * a, 0, 1);
	push(s, 2 * b, 0, 1);
	push(2 * c, t, 0, 2);
}

int main() 
{
    freopen(IN_FILE, "rt", stdin);
    freopen(OUT_FILE, "wt", stdout);
    readdata();
    solve();
    outdata();
    return 0;
}

