#include <string>
#include <vector>
#include <cstdio>
#include <cassert>

using namespace std;

#define IN_FILE "seti.in"
#define OUT_FILE "seti.out"

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define pb push_back
#define VI vector<int>

#define LMAX 200000

int toAnswer[LMAX + 1];
VI answer;

string text, pattern;

void outdata() 
{
	forn (i, pattern.length() + 1)
		forn (j, toAnswer[i]) printf("%d\n", answer[i]);
}

void solve() 
{
	string s = '!' + pattern + '$' + text;
	VI p = VI(s.length(), 0);
	answer = VI(pattern.length() + 1, 0);
	for (int i = 2; i < s.length(); ++i)
	{
		int ptr = p[i - 1];
		while (ptr > 0 && s[ptr + 1] != s[i]) ptr = p[ptr];
		if (s[ptr + 1] == s[i]) p[i] = ptr + 1;
		if (i > pattern.length()) ++answer[p[i]];
	}
	for (int i = pattern.length(); i > 0; --i) answer[p[i]] += answer[i];
}

string readString()
{
	int c = getchar();
	while (c <= ' ') c = getchar();
	string res = "";
	while (isalpha(c)) 
	{
		res += c;
		c = getchar();
	}
	return res;
}

int readChar()
{
	int c = getchar();
	while (!isalpha(c)) c = getchar();
	return c;
}

void readdata() 
{
	text = readString();
	forn (i, LMAX + 1) toAnswer[i] = 0;
	int c = readChar();
	pattern = "";

	int quest = 0;

	while (isalpha(c) || (c == '?'))
	{
		++quest;
		if (c == '?') 
			++toAnswer[pattern.length()];
		else
			pattern.pb(c);
		c = getchar();
	}

	assert(quest > 0 && quest <= LMAX && text.length() > 0 && text.length() <= LMAX);
}

int main() 
{
	freopen(IN_FILE, "rt", stdin);
	freopen(OUT_FILE, "wt", stdout);
	readdata();
	solve();
	outdata();
	return 0;
}