#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "bridge.in"
#define OUT_FILE "bridge.out"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<long long, long long>
#define mp make_pair
#define VI vector<long long>
#define VS vector<string>

int n, dx;
VI a, res;
int cp = 0;

void outdata() {
	if (res.size() == 0) {
		cout << "No solution\n";
		return ;
	}
	cout << res.size() << endl;
	forv(i, res) cout << res[i] << " ";
	cout << endl;
}

bool good(int i) {
	if (abs(cp - i) == 0 || abs(cp - i) > dx || i >= n || i < 0 || a[i] != 1) return false;
	if (i == n - 1) return true;
	int ncp = i;
   	for(int i = min(n - 1, ncp + dx); i >= max(0, ncp - dx); --i) {
   		if (a[i] == 0) {
   			return true;
   		}
   	}
   	return false;
}

void solve() {
	while (cp < n - 1) {
		bool ok = false;
		for(int i = min(n - 1, cp + dx); i >= max(0, cp - dx); --i) {
			if (good(i)) {
				res.pb(i - cp);
				cp = i;
				ok = true;
				break;
			}
		}
		if (!ok) {
			res.clear();
			return ;
		}
		forn(i, n) {
			if (i != cp) {
				a[i] = 1 - a[i];
			}
		}
	}
}

void readdata() {
	cin >> n >> dx;
	a.resize(n);
	forn(i, n) {
		cin >> a[i];
	}
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}
