#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "magic.in"
#define OUT_FILE "magic.out"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<long long, long long>
#define mp make_pair
#define VI vector<long long>
#define VS vector<string>


struct line {
	double x, d;
	long long y, t;
};

bool operator < (const line &a, const line &b) {
	return a.y < b.y;
}

bool operator == (const line &a, const line &b) {
	return a.y == b.y;
}

int n;
double ans;
bool eans;
long long xf, yf;
vector< line > l, st;
VI t, y;

void outdata() {
	if (!eans) {
		printf("-1\n");
	} else {
		printf("%f", ans);
	}
}

double vMul(line p, line c, line f) {
	return (c.x - p.x) * (f.y - c.y) - (c.y - p.y) * (f.x - c.x);
}

bool good(double dx, int nmL) {
	line pl = st.back();
	if (dx < 0) {
		st.pop_back();
	} else {
		l[nmL].x = pl.x + dx;
		int num = (int)st.size();
		if (num == 1 || vMul(st[num - 2], st[num - 1], l[nmL]) < -EPS) return true;
		st.pop_back();
	}
	return false;
}

void solve() {
	st.pb(l[0]);
	sort(all(l));
	assert(yf > l[n].y);
	assert(l.end() == unique(all(l)));
	eans = true;
	for(int i = 1; i <= n; ++i) {
		while (!st.empty()) {
			line pl = st.back();
			long long dt = l[i].t - pl.t;
			long long dy = l[i].y - pl.y;
			long long dx = dt * dt - dy * dy;
			if (dt < 0 || dx < 0) {
				st.pop_back();
			} else {
				l[i].d = pl.d + sqrt((double)(dx + dy * dy));
				if (good(sqrt((double)dx), i)) break;
			}
		}
		if (st.empty()) {
			eans = false;
			return ;
		}
		st.pb(l[i]);
		assert(fabs(l[i].d - l[i].t) < EPS);
	}
	int i = n + 1;
	while (!st.empty()) {
		line pl = st.back();
		double dx = xf - pl.x;
		long long dy = l[i].y - pl.y;
		l[i].d = pl.d + sqrt((double)(dx * dx + dy * dy));
		if (good(dx, i)) break;
	}
	if (st.empty()) {
		eans = false;
		return ;
	}
	ans = l[i].d;
}

void readdata() {
	cin >> xf >> yf;
	assert(1 <= xf && xf <= (int)1E+9);
	assert(1 <= yf && yf <= (int)1E+9);
	scanf("%d", &n);
	assert(0 <= n && n <= (int)1E+5);
	l.resize(n + 2);
	l[0].t = 0;
	l[0].x = 0;
	l[0].y = 0;
	l[0].d = 0;
	forn(i, n) {
		int cy, ct;
		scanf("%d%d", &cy, &ct);
		l[i + 1].y = cy;
		l[i + 1].t = ct;
	}
	l[n + 1].x = (double)xf;
	l[n + 1].y = yf;
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}

