#define _CRT_SECURE_NO_DEPRECATE

#include <set>
#include <vector>
#include <cstdio>
#include <utility>
#include <cassert>
#include <iostream>

#define VI vector<int>
#define mp make_pair
#define forn(i, n) for (int i = 0; i < (int)(n); ++i)

using namespace std;

#define elType pair<int, int>

	struct tree
	{
		elType key;
		int heap;
		tree *l;
		tree *r;

		tree (elType key, int heap, tree *p)
		{
			this -> key = key;
			this -> heap = heap;
			this -> l = this -> r = NULL;
		}
	};

	int random()
	{
		return (int)((unsigned int)rand()) * ((unsigned int)rand());
	}

	tree * merge(tree * left, tree * right)
	{
		if (left == NULL) return right;
		if (right == NULL) return left;
		if (right -> heap >= left -> heap) 
		{
			right -> l = merge(left, right -> l);
			return right;
		}
		else
		{
			left -> r = merge(left -> r, right);
			return left;
		}
	}

	void split(tree * v,  elType x, tree * &left, tree * &right)
	{
		if (v == NULL) left = right = NULL; 
		else if (x < v -> key) 	
		{
			split(v -> l, x, left, v -> l);
			right = v;
		}
		else
		{
			split(v -> r, x, v -> r, right);
			left = v;
		}
	}

	void insert(tree * &root, elType x)
	{
		tree *our = new tree(x, random(), NULL);
		tree *left, *right;
		split(root, x, left, right);
		left = merge(left, our);
		root = merge(left, right);
	}

	tree * lower_bound(tree * root, elType x)
	{
		if (root == NULL) return NULL;
		if (root -> key == x) return root;
		if (x > root -> key) return lower_bound(root -> r, x);
		tree * t = lower_bound(root -> l, x);
		if (t == NULL) return root;
		return (root -> key < t -> key ? root : t);
	}

	void erase(tree * &root, elType x)
	{
		if (x < root -> key) erase(root -> l, x);
		else if (x > root -> key) erase(root -> r, x);
		else root = merge(root -> l, root -> r);
	}

   	tree *root;


VI weight;
VI num;
VI sumka;

int n;

int main()
{
	srand(13);
	freopen("hotel.in", "rt", stdin);
	freopen("hotel.out", "wt", stdout);
	scanf("%d", &n);
	weight.resize(n);
	forn (i, n) 
	{
		scanf("%d", &weight[i]);
		insert(root, mp(weight[i], i));
	}
	int k;
	scanf("%d", &k);
	num.resize(k);
	sumka.resize(k);
	forn (i, k)
	{
		int b;
		scanf("%d", &b);
		if (b > 0)
		{
			tree * ptr = lower_bound(root, mp(b, -2));
			if (ptr == NULL)
			{
				num[i] = -2;
				printf("%d\n", num[i] + 1);
				continue;
			}
			pair<int, int> toDel = ptr -> key;
			pair<int, int> toInsert = mp(ptr -> key.first - b, ptr -> key.second);
			num[i] = ptr -> key.second; 
			weight[ptr -> key.second] -= b;
			erase(root, toDel);
			insert(root, toInsert);
			printf("%d\n", num[i] + 1);
			sumka[i] = b;
		} else
		{
			b = -b - 4;
			printf("%d\n", num[b] + 1);
			if (num[b] == -2) continue;
			pair<int, int> toDel = mp(weight[num[b]], num[b]);
			pair<int, int> toInsert = mp(weight[num[b]] + sumka[b], num[b]);
			weight[num[b]] += sumka[b];
			erase(root, toDel);
			insert(root, toInsert);
			num[b] = -2;
		}
	}
	return 0;
}