#include <string>
#include <vector>

#define mn(a,b) (((a)<(b))?(a):(b))
 
using namespace std;

void getb (int x1, int y1, int x2, int y2, int *a1, int *b1, int *a2, int *b2) {
  if (x1<x2) *a1=x1, *a2=x2; else *a1=x2, *a2=x1;
  if (y1<y2) *b1=y1, *b2=y2; else *b1=y2, *b2=y1;
};

int vect (int x1, int y1, int x2, int y2) {
  return x1*y2-x2*y1;
};

char PC[8][8][8][8][8][8][8][8];

int intersect (int x1, int y1, int x2, int y2, int x3, int y3, int x4, int y4) {
  int a1, b1, a2, b2, a3, b3, a4, b4;
  getb (x1, y1, x2, y2, &a1, &b1, &a2, &b2);
  getb (x3, y3, x4, y4, &a3, &b3, &a4, &b4);
  if (a2<a3||a4<a1||b2<b3||b4<b1) return 0;

  int v1=vect (x2-x1, y2-y1, x3-x1, y3-y1);
  int v2=vect (x2-x1, y2-y1, x4-x1, y4-y1);

  if (v1*v2>0) return 0;

  int v3=vect (x4-x3, y4-y3, x1-x3, y1-y3);
  int v4=vect (x4-x3, y4-y3, x2-x3, y2-y3);

  if (v3*v4>0) return 0;

  if ((x1==x3&&y1==y3)||
      (x1==x4&&y1==y4)||
      (x2==x3&&y2==y3)||
      (x2==x4&&y2==y4)) {

    if (vect (x2-x1, y2-y1, x4-x3, y4-y3)!=0) return 0;
    else
    if ((a2==a3||a4==a1)&&(b2==b3||b4==b1)) return 0;
  };


  return 1;
};

int G[10][10], n;
int xc[10], yc[10], mxc[10], myc[10], F[10][10];


int placep (int p, int xs, int ys) {
  if (p>=n) {
    return 1;
  };
  for (int x=0; x<=xs; x++)
    for (int y=0; y<=ys; y++)
      if (!F[x][y]) {
        F[x][y]=1;
        xc[p]=x; yc[p]=y;
        for (int k=0; k<p; k++)
          if (G[p][k])
            for (int l=0; l<p; l++) 
              for (int m=0; m<p; m++) if (m!=l)
                if (G[l][m]&&PC[x][y][xc[k]][yc[k]][xc[l]][yc[l]][xc[m]][yc[m]])
                  goto skip;
        if (placep (p+1, xs, ys)) return 1;
        skip:;
        F[x][y]=0;
      };
  return 0;
};


int place (int xs, int ys) {
  return placep (0, xs, ys);
};

int mi, mj;

int main () {
  freopen ("planar.in", "rt", stdin);
  freopen ("planar.out", "wt", stdout);
  
  char temp [20];
  scanf ("%d", &n); fgets (temp, sizeof (temp), stdin);
  assert ((n>=1)&&(n<=7));

  for (int i=0; i<n; i++) {
    fgets (temp, sizeof (temp), stdin);
    for (int j=0; j<n; j++) {
      G[i][j]=(temp[j]=='Y');
      assert (temp[j]=='Y'||temp[j]=='N');
    };
  };

  /*for (int i=0; i<n; i++) {
    for (int j=0; j<n; j++)
      printf ("%d", G[i][j]);
    puts ("");
  };*/
  for (int i=0; i<n; i++)
    assert (!G[i][i]);

  for (int i=0; i<n; i++)
    for (int j=i+1; j<n; j++)
      assert (G[i][j]==G[j][i]);
  
  
  int min=10000;

  for (int x1=0; x1<8; x1++)
    for (int y1=0; y1<8; y1++)
      if (x1+y1<=8)
      for (int x2=0; x2<8; x2++)
        for (int y2=0; y2<8; y2++)
          if (x2+y2<=8)
          for (int x3=0; x3<8; x3++)
            for (int y3=0; y3<8; y3++)
              if (x3+y3<=8)
              for (int x4=0; x4<8; x4++)
                for (int y4=0; y4<8; y4++)
                  if (x4+y4<=8)
                  PC[x1][y1][x2][y2][x3][y3][x4][y4]=intersect (x1, y1, x2, y2, x3, y3, x4, y4);

  for (int i=0; i<8; i++)
    for (int j=0; j<=mn (i, 8-i); j++)
      if ((i+1)*(j+1)>=n&&(i+1)*(j+1)<min&&place (i, j)) {
        memset (F, 0, sizeof (F));
        min=(i+1)*(j+1);
        mi=i+1; mj=j+1;

        for (int k=0; k<10; k++) {
          mxc[k]=xc[k];
          myc[k]=yc[k];
        };

      };

  printf ("%d\n", min);

  printf ("%d %d\n", mi, mj);
  for (int i=0; i<n; i++)
    printf ("%d %d\n", mxc[i]+1, myc[i]+1);
   
};
