{$apptype console}
{$q+,r+,n-,o+}

const cinfile = 'input.txt';
      coutfile = 'output.txt';

const nmax = 200;
      base = 1000000;
      vmax = 50;

type int = longint;
     tlong = array[-1..1000] of int;

var a, b : array[1..nmax, 1..nmax] of int;
    c, d : array[1..nmax] of int;
    x : array[1..vmax shl 1 + 1] of int;
    y : array[-vmax..vmax] of tlong;
    k, ans : array[0..nmax] of tlong;
    par_mul : array[1..nmax] of tlong;
    denominator : tlong;
    m, n : int;

procedure mul_int(var x : tlong; y : int);
var i, t : int;
begin
   if x[0] = 0 then exit;
   if y = 0 then begin
      fillchar(x, sizeof(x), 0);
      x[-1]:=1;
      exit;
   end;
   if y < 0 then begin
      y:=-y;
      x[-1]:=-x[-1];
   end;
   t:=0;
   for i:=1 to x[0] do begin
      x[i]:=x[i]*y + t;
      t:=x[i] div base;
      x[i]:=x[i] - t*base;
   end;
   while t > 0 do begin
      inc(x[0]);
      x[x[0]]:=t mod base;
      t:=t div base;
   end;
end;

function diff(var x, y : tlong) : int;
var i : int;
begin
   for i:=-1 to 0 do
      if x[i] <> y[i] then begin
         diff:=x[0] - y[0];
         exit;
      end;
   for i:=x[0] downto 1 do
      if x[i] <> y[i] then begin
         diff:=x[i] - y[i];
         exit;
      end;
   diff:=0;
end;

function sgn(x : int) : int;
begin
   if x < 0 then sgn:=-1 else sgn:=1;
end;

procedure add(var x : tlong; y : tlong);
var i : int;
begin
   if x[-1] = y[-1] then begin
      if x[0] < y[0] then x[0]:=y[0];
      for i:=1 to x[0] do begin
         inc(x[i], y[i]);
         if x[i] >= base then begin
            inc(x[i + 1]);
            dec(x[i], base);
         end;
      end;
      if x[x[0] + 1] <> 0 then inc(x[0]);
   end else begin
      y[-1]:=x[-1];
      if diff(x, y) > 0 then begin
         for i:=1 to x[0] do begin
            dec(x[i], y[i]);
            if x[i] < 0 then begin
               dec(x[i + 1]);
               inc(x[i], base);
            end;
         end;
      end else begin
         for i:=1 to y[0] do begin
            dec(y[i], x[i]);
            if y[i] < 0 then begin
               dec(y[i + 1]);
               inc(y[i], base);
            end;
         end;
         y[-1]:=-x[-1];
         x:=y;
      end;
      while (x[x[0]] = 0) and (x[0] > 0) do dec(x[0]);
   end;
end;

procedure mul_long(var x, y : tlong);
var i, j, p : int;
    t : int64;
    r : tlong;
begin
   if (x[0] = 0) or (y[0] = 0) then begin
      if y[0] = 0 then begin
         fillchar(x, sizeof(x), 0);
         x[-1]:=1;
      end;
      exit;
   end;
   fillchar(r, sizeof(r), 0);
   r[-1]:=x[-1]*y[-1];
   for i:=1 to x[0] do
      for j:=1 to y[0] do begin
         t:=x[i];
         t:=t*y[j];
         p:=i + j - 1;
         while t > 0 do begin
            inc(t, r[p]);
            r[p]:=t mod base;
            t:=t div base;
            inc(p);
         end;
         if r[0] < p - 1 then r[0]:=p - 1;            
      end;
   while (r[r[0]] = 0) and (r[0] > 0) do dec(r[0]);
   x:=r;
end;

procedure value_r(i, x : int; var r : tlong);
var j : int;
begin
   fillchar(r, sizeof(r), 0);
   r[-1]:=1;
   r[0]:=1;
   r[1]:=1;
   for j:=1 to d[i] do
      mul_int(r, x - b[i, j]);
end;

procedure write_long(var x : tlong);
var i, j : int;
begin
   if (x[0] > 0) and (x[-1] = -1) then write('-');
   write(x[x[0]]);
   for i:=x[0] - 1 downto 1 do begin
      j:=10;
      while x[i] >= j do j:=10*j;
      while j < base do begin
         write('0');
         j:=10*j;
      end;
      write(x[i]);
   end;
end;

procedure init;
var i, j : int;
begin
   read(m);
   for i:=1 to m do begin
      read(c[i]);
      for j:=1 to c[i] do read(a[i, j]);
      read(d[i]);
      for j:=1 to d[i] do read(b[i, j]);
   end;
end;

procedure make_values;
var i, j : int;
    tmp : tlong;
begin
   fillchar(y, sizeof(y), 0);
   n:=0;
   for i:=1 to m do begin
      for j:=1 to c[i] do begin
         value_r(i, a[i, j], tmp);
         if y[a[i, j]][-1] <> 0 then begin
            if diff(y[a[i, j]], tmp) <> 0 then begin
               write('No solution');
               close(input); close(output);
               halt(0);
            end;
         end else begin
            inc(n);
            x[n]:=a[i, j];
            y[x[n]]:=tmp;
         end;
      end;
   end;
end;

procedure solve;
var i, j, t, cnt : int;
begin
   fillchar(par_mul, sizeof(par_mul), 0);
   fillchar(denominator, sizeof(denominator), 0);
   denominator[-1]:=1;
   denominator[0]:=1;
   denominator[1]:=1;
   for t:=1 to n do begin
      par_mul[t][-1]:=1;
      par_mul[t][0]:=1;
      par_mul[t][1]:=1;
      for j:=1 to n do if j <> t then
         mul_int(par_mul[t], x[t] - x[j]);
      mul_long(denominator, par_mul[t]);
   end;

   fillchar(ans, sizeof(ans), 0);
   for i:=0 to n - 1 do
      ans[i][-1]:=1;
   for i:=1 to n do begin
      cnt:=1;
      fillchar(k, sizeof(k), 0);
      for j:=0 to n - 1 do
         k[j][-1]:=1;
      k[0][0]:=1;
      k[0][1]:=1;
      for j:=1 to n do if j <> i then begin
         for t:=cnt downto 0 do begin
            if t < cnt then mul_int(k[t], -x[j]);
            if t > 0 then add(k[t], k[t - 1])
         end;
         inc(cnt);
      end;

      for t:=1 to n do if t <> i then
         mul_long(y[x[i]], par_mul[t]);

      for t:=0 to n - 1 do begin
         mul_long(k[t], y[x[i]]);
         add(ans[t], k[t]);
      end;      
   end;
end;

procedure writeanswer;
var i, sgn : int;
begin
   while (ans[n - 1][0] = 0) and (n > 1) do dec(n); 
   writeln(n - 1);
   sgn:=denominator[-1];
   denominator[-1]:=1;
   for i:=0 to n - 1 do begin
      ans[i][-1]:=ans[i][-1]*sgn;
      write_long(ans[i]);
      writeln;
   end;
   write_long(denominator);
   writeln;
end;

begin
   assign(input, cinfile); reset(input);
   assign(output, coutfile); rewrite(output);
   init;
   make_values;
   solve;
   writeanswer;
   close(input); close(output);
end.
