#pragma comment(linker, "/STACK:36536000")
#include <string>
#include <vector>
#include <cmath>
#include <set>
#include <map>
#include <algorithm>
#include <set>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "sqrtk.in"
#define OUT_FILE "sqrtk.out"

#define EPS 1E-8

#define forn(i, n) for (int i = 0; i < int(n); ++i)
#define forv(i, v) for (int i = 0; i < int(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < int(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define NMAX 200001
#define POWMAX 100

long long k;
int n;

VI p, r;
vector<bool> u;
VI s[NMAX];
int sumN;

bool ok;

void outdata() {
    if (ok) {
        printf("YES\n");
        forv(i, r) {
            printf("%d ", r[i] + 1);
        }
    } else {
        printf("NO");
    }
    printf("\n");
}

int power(long long a, long long b, int n) {
    long long res = 1;
    while (b) {
        if (b & 1) {
            res = (res * a) % n;
            --b;
        } else {
            a = (a * a) % n;
            b >>= 1;
        }
    }
    return res % n;
}

long long gcd(long long a, long long b)
{
    return (a ? gcd(b % a, a) : b);
}

bool solve() {
    forn(i, n + 1) s[i].clear();
    u = vector<bool>(n, false);
    forn(i, n) {
        int l = 0;
        for (int x = i; !u[x]; x = p[x]) {
            u[x] = true;
            ++l;
        }
        if (l > 0) {
            s[l].pb(i);
        }
    }
    r = VI(n, 0);
    forn(i, n + 1) {
        if (0 == s[i].size()) continue;
        long long t = gcd(power(i, POWMAX, k), k);
        if (s[i].size() % t != 0) {
            return false;
        }
        int st = 0;
        forn(ii, s[i].size() / t) {
            VI e(t * i, -1);
            int uks = 0;
            forn(j, t) {
                while (e[uks] != -1) ++uks;
                int ps = uks;
                forn(ll, i) {
                    assert(e[ps] == -1);
                    e[ps] = s[i][j + st];
                    s[i][j + st] = p[s[i][j + st]];
                    ps = (ps + k) % (int)e.size();
                }
                assert(ps == uks);
            }
            forv(i, e) {
                r[e[i]]= e[(i + 1) % e.size()];
            }
            st += t;
        }
    }
    return true;
}

void readdata() {
    scanf("%d%d", &n, &k);
    sumN += n;
    assert(k >= 1 && k <= (int)1E+9);
    p = VI(n, 0);
    forn(i, n) {
        scanf("%d", &p[i]);
        --p[i];
    }
}

int main() {
    freopen(IN_FILE, "rt", stdin);
    freopen(OUT_FILE, "wt", stdout);
    int tst;
    sumN = 0;
    scanf("%d", &tst);
    forn(ii, tst) {
        readdata();
        ok = solve();
        outdata();
    }
    assert(sumN <= 200000);
    return 0;
}
