//#define debug2

#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "toral.in"
#define OUT_FILE "toral.out"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define x first
#define y second

#define NMAX 10

struct pos {
	PII k, l1, l2;
	char win, move;
	short dst;
	pos() {
	}
	pos(PII kp, PII l1p, PII l2p, int movep) {
		k = kp; l1 = l1p; l2 = l2p; move = movep;
	}
	bool operator == (pos & a) {
		return (this->k == a.k && this->l1 == a.l1 && this->l2 == a.l2 && this->move == a.move);
	}
};


int n;
PII l1, l2, kw, kb;

int numCorrect = 0, numMAT = 0, numPAT = 0, numPosCalc = 0, sumSt = 0;
int cor[NMAX][NMAX][NMAX][NMAX][NMAX][NMAX][2];
int d[NMAX][NMAX][NMAX][NMAX][NMAX][NMAX][2];
int h[NMAX][NMAX][NMAX][NMAX][NMAX][NMAX][2];
int dst[NMAX][NMAX][NMAX][NMAX][NMAX][NMAX][2];
int ktmp = 0;
pos tmp[100];
int chtmp[100];
bool existMOVE;

int dkx[8] = {-1, -1, 0, 1, 1, 1, 0, -1};
int dky[8] = {0, 1, 1, 1, 0, -1, -1, -1};

int dlx[4] = {-1, 0, 1, 0};
int dly[4] = {0, 1, 0, -1};

queue<pos> q;

inline PII operator + (const PII & a, const PII & b) {
	return mp((a.x + b.x + n) % n, (a.y + b.y + n) % n);
}

inline PII operator - (const PII & a, const PII & b) {
	return mp((a.x - b.x + n) % n, (a.y - b.y + n) % n);
}

inline void operator += (PII & a, const PII & b) {
	a = a + b;
}

inline void operator -= (PII & a, const PII & b) {
	a = a - b;
}

bool fightLK(const PII &l, const PII &k) {
	return (l.x == k.x) ^ (l.y == k.y);
}

inline int dist1(int a, int b) {
	int res = abs(a - b);
	return min(res, n - res);
}

inline int dist(const PII &k1, const PII &k2) {
	return max(dist1(k1.x, k2.x), dist1(k1.y, k2.y));
}

inline int correct(const pos &c) {
	int &res = cor[c.k.x][c.k.y][c.l1.x][c.l1.y][c.l2.x][c.l2.y][c.move];
	if (res != -1) return res;
	if (dist(mp(0, 0), c.k) <= 1) return (res = 0);
	if (c.k == c.l1 || c.k == c.l2 || c.l1 == c.l2) return (res = 0);
	if (c.k == mp(0, 0) || mp(0, 0) == c.l1 || c.l2 == mp(0, 0)) return (res = 0);
	if (c.move == 1) {
		if (fightLK(c.l1, c.l2)) return (res = 1);
		if (dist(c.l1, c.k) <= 1 && dist(c.l1, mp(0, 0)) > 1) return (res = 0);
		if (dist(c.l2, c.k) <= 1 && dist(c.l2, mp(0, 0)) > 1) return (res = 0);
	} else {
		if (fightLK(c.l1, c.k) || fightLK(c.l2, c.k)) return (res = 0);
	}
	return (res = 1);		
}

void outPos(pos &c) {
	char t[NMAX][NMAX];
	memset(t, '.', sizeof(t));
	t[c.k.x][c.k.y] = 'k';
	t[c.l1.x][c.l1.y] = 'R';
	t[c.l2.x][c.l2.y] = 'R';
	t[0][0] = 'K';
	cerr << (int)c.move << " " << c.dst << " " << (int)c.win << endl;
	forn(i, n) {
		forn(j, n) {
			cerr << t[i][j];
		}
		cerr << endl;
	}
	cerr << endl << endl;
}

inline void sym(const pos &u, pos &u2) {
	u2 = u;
	return ;
	int mnx = min(u2.l1.x, u2.l2.x);
	int mny = min(u2.l1.y, u2.l2.y);
	if (mnx >= n / 2) {
		u2.l1.x = n - u2.l1.x;
		u2.l2.x = n - u2.l2.x;
		u2.k.x = (2 * n - u2.k.x) % n;
	}

	if (mny >= n / 2) {
		u2.l1.y = n - u2.l1.y;
		u2.l2.y = n - u2.l2.y;
		u2.k.y = (2 * n - u2.k.y) % n;
	}
	if (u2.l1 > u2.l2) {
		swap(u2.l1, u2.l2);
	}
/*
	assert(min(u2.l1.x, u2.l2.x) <= (n + 1) / 2);
	assert(min(u2.l1.y, u2.l2.y) <= (n + 1) / 2);
*/
//	assert(!(correct(u2) ^ correct(u)));
}

void push(const pos &u, bool put, int ch) {
	existMOVE = true;
	if (put) {
		chtmp[ktmp] = ch;
		tmp[ktmp++] = u;
	}
}

void push2(const pos &u) {
	pos u2;
	sym(u, u2);
	tmp[ktmp++] = u2;
}

void go(pos &c, bool put = false) {
	ktmp = 0;
	existMOVE = false;
	int st = 0;
	if (c.move == 1) {
		forn(i, 8) {
			pos cn = c;
			cn.move = 1 - c.move;
			cn.k = c.k + mp(dkx[i], dky[i]);
			if (correct(cn)) {
				++st;
				push(cn, put, 0);
			}
		}
	} else {
		forn(i, 8) {
			pos cn = c;
			cn.move = 1 - c.move;
			cn.k = c.k - mp(dkx[i], dky[i]);
			cn.l1 = c.l1 - mp(dkx[i], dky[i]);
			cn.l2 = c.l2 - mp(dkx[i], dky[i]);
			if (correct(cn)) {
				++st;
				push(cn, put, 0);
			}
		}
		int km[4]; 
		memset(km ,0, sizeof(km));
		forn(d, 4) {
			pos cn = c;
			cn.move = 1 - c.move;
			int ug = n - km[(d + 2) & 3];
			forn(i, ug) {
				cn.l1 = cn.l1 + mp(dlx[d], dly[d]);
				if (correct(cn)) {
					++st;
					if (put) {
						push(cn, put, 1);
					}
				}
				if (cn.l1 == cn.l2 || cn.l1 == mp(0, 0)) break;
				++km[d];
			}
		}
		memset(km ,0, sizeof(km));
		forn(d, 4) {
			pos cn = c;
			cn.move = 1 - c.move;
			int ug = n - km[(d + 2) & 3];
			forn(i, ug) {
				cn.l2 = cn.l2 + mp(dlx[d], dly[d]);
				if (correct(cn)) {
					++st;
					push(cn, put, 2);
				}
				if (cn.l1 == cn.l2 || cn.l2 == mp(0, 0)) break;
				++km[d];
			}
		}
	}
	d[c.l1.x][c.l1.y][c.l2.x][c.l2.y][c.k.x][c.k.y][c.move] = st;
	sumSt += st;
}

void go2(pos &c, bool put = true) {
#ifdef debugcur
	outPos(c);
#endif
	ktmp = 0;
	existMOVE = false;
	int st = 0;
	c.move = 1 - c.move;
	if (c.move == 1) {
		forn(i, 8) {
			pos cn = c;
			cn.k = c.k + mp(dkx[i], dky[i]);
			#ifdef debugcur
				outPos(cn);
			#endif
			if (correct(cn)) {
				++st;
				if (put) {
					push2(cn);
				}
			}
		}
	} else {
		forn(i, 8) {
			pos cn = c;
			cn.k = c.k - mp(dkx[i], dky[i]);
			cn.l1 = c.l1 - mp(dkx[i], dky[i]);
			cn.l2 = c.l2 - mp(dkx[i], dky[i]);
			#ifdef debugcur
				outPos(cn);
			#endif
			if (correct(cn)) {
				++st;
				if (put) {
					push2(cn);
				}
			}
		}
		int km[4]; 
		memset(km, 0, sizeof(km));
		forn(d, 4) {
			pos cn = c;
			int ug = n - km[(d + 2) & 3];
			forn(i, ug) {
				cn.l1 = cn.l1 + mp(dlx[d], dly[d]);
			#ifdef debugcur
				outPos(cn);
			#endif
				if (correct(cn)) {
					++st;
					if (put) {
						push2(cn);
					}
				}
				if (cn.l1 == cn.l2 || cn.l1 == mp(0, 0)) break;
				++km[d];
			}
		}
		memset(km ,0, sizeof(km));
		forn(d, 4) {
			pos cn = c;
			#ifdef debugcur
				outPos(cn);
			#endif
			int ug = n - km[(d + 2) & 3];
			forn(i, ug) {
				cn.l2 = cn.l2 + mp(dlx[d], dly[d]);
				if (correct(cn)) {
					++st;
					if (put) {
						push2(cn);
					}
				}
				if (cn.l1 == cn.l2 || cn.l2 == mp(0, 0)) break;
				++km[d];
			}
		}
	}
}

void puth(pos &c, int r, int pdst) {
	c.dst = pdst + 1;
	int &t = h[c.l1.x][c.l1.y][c.l2.x][c.l2.y][c.k.x][c.k.y][c.move];
	c.win = r;
	if (t == -1) {
		dst[c.l1.x][c.l1.y][c.l2.x][c.l2.y][c.k.x][c.k.y][c.move] = pdst + 1;
		q.push(c);
	}
	t = r;
}

void decd(pos &c, int pdst) {
	int &t = d[c.l1.x][c.l1.y][c.l2.x][c.l2.y][c.k.x][c.k.y][c.move];
	assert(t > 0);
	--t;
#ifdef debug
	cerr << t << endl;
	outPos(c);
#endif
	if (t == 0) {
		puth(c, 0, pdst);
	}
}

void MakeGraph() {
	memset(h, 255, sizeof(h));
	memset(d, 0, sizeof(d));
	memset(dst, 255, sizeof(dst));
	memset(cor, 255, sizeof(dst));
	forn(xl1, n) {
		forn(yl1, n) {
			forn(xl2, n) {
				forn(yl2, n) {
					pos tmp = pos(mp(0, 0), mp(xl1, yl1), mp(xl2, yl2), 0);
					pos utmp;
					sym(tmp, utmp);
//					if (!(tmp == utmp)) continue;
					forn(xkb, n) {
						forn(ykb, n) {
							forn(move, 2) {
								pos c = pos(mp(xkb, ykb), mp(xl1, yl1), mp(xl2, yl2), move);
								pos u2;
								sym(c, u2);
								if (!correct(c) || !(c == u2)) continue;
								go(c, false);
#ifdef debug
								outPos(c);
#endif
								++numCorrect;
								if (c.move == 1) {
									if ((fightLK(c.l1, c.k) || fightLK(c.l2, c.k)) && !existMOVE) {
										puth(c, 0, -1);
										++numMAT;
										c.win = false;
									}
									if ((!fightLK(c.l1, c.k) && !fightLK(c.l2, c.k)) && !existMOVE) {
										puth(c, 2, -1);
										++numPAT;
										c.win = false;
									}
								}
							}
						}
					}
				}
			}
		}
	}
}

void solve() {
	MakeGraph();
/*
	cerr << numCorrect << " --- num correct \n";
	cerr << numMAT << " --- num mat \n";
	cerr << numPAT << " --- num pat \n";
	cerr << sumSt << " --- sumSt \n";
	cerr << endl << endl << endl;
*/
#ifdef debug
	queue<pos> z = q;
	while (!q.empty()) {
		outPos(q.front());
		q.pop();
	}
	q = z;

#endif
	while (!q.empty()) {
		pos c = q.front();
		q.pop();
		++numPosCalc;
		pos u;
		sym(c, u);
		if (!(c == u)) outPos(c);
		assert(c == u);
#ifdef debug2
		outPos(c);
#endif
		go2(c);
		if (c.win == 1) {
			forn(i, ktmp) {
				decd(tmp[i], c.dst);
			}
		}
		if (c.win == 0) {
			forn(i, ktmp) {
				puth(tmp[i], 1, c.dst);
			}
		}
	}
	cerr << numPosCalc << endl;
}

PII getPoint(string s) {
	PII res;
	res.x = s[0] - 'a';
	res.y = 0;
	for (int i = 1; i < s.length(); ++i) res.y = res.y * 10 + s[i] - '0';
	res.y--;
	return res;
}

void readdata() {
	string sl1, sl2, skw, skb;
	cin >> n;
	assert(n >= 5 && n <= 10);
	cin >> skw >> sl1 >> sl2 >> skb;
	l1 = getPoint(sl1);
	l2 = getPoint(sl2);
	kw = getPoint(skw);
	kb = getPoint(skb);
	assert(l1.x >= 0 && l1.x < n);
	assert(l1.y >= 0 && l1.y < n);
	assert(l2.x >= 0 && l2.x < n);
	assert(l2.y >= 0 && l2.y < n);
	assert(kw.x >= 0 && kw.x < n);
	assert(kw.y >= 0 && kw.y < n);
	assert(kb.x >= 0 && kb.x < n);
	assert(kb.y >= 0 && kb.y < n);
}

void outdata() {
	pos start;
	start.k = kb - kw;
	start.l1 = l1 - kw;
	start.l2 = l2 - kw;
	start.move = 0;
	assert(correct(start));
	pos cur;
	sym(start, cur);
	if (h[cur.l1.x][cur.l1.y][cur.l2.x][cur.l2.y][cur.k.x][cur.k.y][cur.move] == 0)
	{
		cout << -1 << endl;
		return ;
	}
	int r = dst[cur.l1.x][cur.l1.y][cur.l2.x][cur.l2.y][cur.k.x][cur.k.y][cur.move];
	cout << (r + 1) / 2 << endl;
	go(start, true);
	forn (i, ktmp)
	{
		pos cur;
		sym(tmp[i], cur);
		PII p1, p2;
		if (h[cur.l1.x][cur.l1.y][cur.l2.x][cur.l2.y][cur.k.x][cur.k.y][cur.move] == 1) continue;
		if (dst[cur.l1.x][cur.l1.y][cur.l2.x][cur.l2.y][cur.k.x][cur.k.y][cur.move] != r - 1) continue;
		cur = tmp[i];
		int chgs = (int)(start.l1 != cur.l1) + (int)(start.l2 != cur.l2) + (int)(start.k != cur.k);
		if (chgs <= 1)
		{
			if (chgs == 1) {
				if (start.l1 != cur.l1)	p1 = start.l1, p2 = cur.l1; else p1 = start.l2, p2 = cur.l2;
			} else {
				if (chtmp[i] == 1) p1 = p2 = start.l1; else p1 = p2 = start.l2;
			}
		} else
		{
			p1 = mp(0, 0);
			p2 = start.l2 - tmp[i].l2;
		}
		p1 += kw;
		p2 += kw;
		cout << char('a' + p1.x) << p1.y + 1 << "-" << char('a' + p2.x) << p2.y + 1 << endl; 
	}
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}
