#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "color.in"
#define OUT_FILE "color.out"

#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define fore(i, v) for (typeof(v.begin())i = v.begin(); i != v.end(); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

#define NMAX 100000

struct vertex {
    int color;
    VI cs;
};

int n;
VI g[NMAX], gt[NMAX];
map<int, map<VI, set<int> > > c;
vertex vr[NMAX];
int numColors;
set<int> badColors;

void outdata() {
    printf("%d\n", numColors);
    forn(i, n) {
        printf("%d ", vr[i].color + 1);
    }
	printf("\n");
}

void add(int v) {
    c[vr[v].color][vr[v].cs].insert(v);
    if (c[vr[v].color].size() > 1) 
        badColors.insert(vr[v].color);
}

void del(int v) {
    c[vr[v].color][vr[v].cs].erase(v);
	if (c[vr[v].color][vr[v].cs].size() == 0) {
		c[vr[v].color].erase(vr[v].cs);
	}
    if (c[vr[v].color].size() < 2) badColors.erase(vr[v].color);
}

void calcCS(int v) {
    VI t;
    forv(j, g[v]) t.pb(vr[g[v][j]].color);
    vr[v].cs = t;
    sort(all(vr[v].cs));
}

void reColor(set<int> &s, int newColor) {
    for(set<int>::iterator i = s.begin(); i != s.end(); ++i) {
        vr[*i].color = newColor;
    }
}

void solve() {
    numColors = 0;
    int cSize[10];
    fill_n(cSize, 10, -1);
    forn(i, n) {
        if (cSize[g[i].size()] < 0) {
            cSize[g[i].size()] = numColors;
            ++numColors;
        }
        vr[i].color = cSize[g[i].size()];
    }
    forn(i, n) {
        calcCS(i);
    }
    forn(i, n) {
        add(i);
    }   
    while (badColors.size() > 0) {
        int BC = *badColors.begin();
        badColors.erase(BC);
        int max = -1;
        map<VI, set<int> >::iterator mxI;
        for (map<VI, set<int> >::iterator i = c[BC].begin(); i != c[BC].end(); ++i) {
            if (max < (int)(i->second).size()) {
                max = (int)(i->second).size();
                mxI = i;
            }
        }
        vector< VI > whatToDel;
        set<int> changeColor;
        for (map<VI, set<int> >::iterator i = c[BC].begin(); i != c[BC].end(); ++i) {
            if (mxI != i) {
                c[numColors][i->first] = i->second;
                whatToDel.pb(i->first);
                changeColor.insert(all(i->second));
                reColor(i->second, numColors);
                ++numColors;
            }
        }
        forv(i, whatToDel) {
            c[BC].erase(whatToDel[i]);
        }
        for(set<int>::iterator i = changeColor.begin(); i != changeColor.end(); ++i) {
            int cv = *i;
            forv(t, gt[cv]) {
                del(gt[cv][t]);
                calcCS(gt[cv][t]);
                add(gt[cv][t]);
            }
        }
    }
}

void push(int x, int y) {
    g[x].pb(y);
    gt[y].pb(x);
}

void readdata() {
    scanf("%d", &n);
    forn(i, n) {
        int x, y;
        scanf("%d%d", &x, &y);
        --x; --y;
        if (x >= 0) {
            push(i, x); 
        }
        if (y >= 0) {
            push(i, y); 
        }
    }
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}

