#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "rectangles.in"
#define OUT_FILE "rectangles.out"

#define x first
#define y second


#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

int n, m;
vector< PII > p;

struct tree {
	int lx, ly, rx, ry, k;
	tree *f, *s, *t, *ft;
	tree(int plx, int ply, int prx, int pry, int pk) {
		lx = plx; ly = ply; rx = prx; ry = pry; k = pk;
		f = NULL; s = NULL; t = NULL; ft = NULL;
	}
};

void outdata() {
}

bool lessYX(const PII &a, const PII &b) {
	if (a.second != b.second) return a.second < b.second;
	return a.first < b.first;
}

void divideVectorY(vector< PII > &p, vector< PII > &f, vector< PII > &s) {
	sort(all(p), lessYX);
	int c = (int)p.size(), mn = (int)p.size(), k = 1, i = 1;
	while (i < (int)p.size()) {
		while (i < (int)p.size() && p[i].second == p[i - 1].second) {
			++i;
			++k;
		}
		if (mn > abs(k - (int)p.size() / 2)) {
			mn = abs(k - (int)p.size() / 2);
			c = k;
		}
		++i;
		++k;
	}
	f.reserve(c);
	forn(i, c) f.pb(p[i]);
	s.reserve(p.size() - c);
	for(int i = c; i < (int)p.size(); ++i) s.pb(p[i]);
}

void divideVectorX(vector< PII > &p, vector< PII > &f, vector< PII > &s) {
	sort(all(p));
	int c = (int)p.size(), mn = (int)p.size(), k = 1, i = 1;
	while (i < (int)p.size()) {
		while (i < (int)p.size() && p[i].first == p[i - 1].first) {
			++i;
			++k;
		}
		if (mn > abs(k - (int)p.size() / 2)) {
			mn = abs(k - (int)p.size() / 2);
			c = k;
		}
		++i;
		++k;
	}
	f.reserve(c);
	forn(i, c) f.pb(p[i]);
	s.reserve(p.size() - c);
	for(int i = c; i < (int)p.size(); ++i) s.pb(p[i]);
}

void calcRect(int &lx, int &ly, int &rx, int &ry, vector< PII > &p) {
	lx = ly = INF;
	rx = ry = -INF;
	forv(i, p) {
		lx = min(lx, p[i].x);
		rx = max(rx, p[i].x);
		ly = min(ly, p[i].y);
		ry = max(ry, p[i].y);
	}
}

tree *makeTree(vector< PII > &p) {
	int lx, ly, rx, ry;
	calcRect(lx, ly, rx, ry, p);
	tree *w = new tree(lx, ly, rx, ry, (int)p.size());
	if ((int)p.size() <= 1) {
		return w;
	}
	vector< PII > fp, sp, tp, ftp;
	vector< PII > lv, rv;
	divideVectorX(p, lv, rv);
	divideVectorY(lv, fp, ftp);
	divideVectorY(rv, sp, tp);
	lv.clear(); rv.clear();
	w->f = makeTree(fp);
	w->s = makeTree(sp);
	w->t = makeTree(tp);
	w->ft = makeTree(ftp);
	return w;
}

int lx, ly, rx, ry;

int calc(register tree *root) {
	//if (!root || root->k == 0) return 0;
	int rlx = max(lx, root->lx), rrx = min(rx, root->rx);
	int rly = max(ly, root->ly), rry = min(ry, root->ry);
	if (rrx < rlx || rry < rly) return 0;
	if (rlx == root->lx && rly == root->ly && rrx == root->rx && rry == root->ry) {
		return root->k;
	}
	int res = 0;
	if (root->f && root->f->k > 0) res += calc(root->f);
	if (root->s && root->s->k > 0) res += calc(root->s);
	if (root->t && root->t->k > 0) res += calc(root->t);
	if (root->ft && root->ft->k > 0) res += calc(root->ft);
	return res;
}

void solve() {
	tree *root = makeTree(p);
	cerr << "gen Tree fin" << endl;
	scanf("%d", &m);
	forn(i, m) {
		scanf("%d%d%d%d", &lx, &ly, &rx, &ry);
		assert(lx < rx);
		assert(ly < ry);
		assert(0 <= abs(lx) && abs(lx) <= (int)1E+9);
		assert(0 <= abs(rx) && abs(rx) <= (int)1E+9);
		assert(0 <= abs(ly) && abs(ly) <= (int)1E+9);
		assert(0 <= abs(ry) && abs(ry) <= (int)1E+9);
		int res = calc(root);
		printf("%d\n", res);
	}
}

void readdata() {
	scanf("%d", &n);
	assert(1 <= n && n <= 50000);
	p.resize(n);
	forn(i, n) {
		int x, y;
		scanf("%d%d", &x, &y);
		assert(0 <= abs(x) && abs(x) <= (int)1E+9);
		assert(0 <= abs(y) && abs(y) <= (int)1E+9);
		p[i] = mp(x, y);
	}
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}

