#define _CRT_SECURE_NO_DEPRECATE
#pragma comment (linker, "/STACK:30000000")
#include <string>
#include <vector>
#include <cmath>
#include <queue>
#include <set>
#include <map>
#include <algorithm>
#include <iostream>
#include <cstdio>
#include <cassert>
#include <utility>

using namespace std;

#define IN_FILE "rectangles.in"
#define OUT_FILE "rectangles.out"

#define x first
#define y second


#define EPS 1E-8
const int INF = (int)1E+9;

#define forn(i, n) for (int i = 0; i < (int)(n); ++i)
#define forv(i, v) for (int i = 0; i < (int)(v.size()); ++i)
#define fors(i, s) for (int i = 0; i < (int)(s.length()); ++i)
#define all(a) a.begin(), a.end()
#define pb push_back
#define PII pair<int, int>
#define mp make_pair
#define VI vector<int>
#define VS vector<string>

int n, m;
vector< PII > p, p2;

bool lessYX(const PII &a, const PII &b) {
	if (a.second != b.second) return a.second < b.second;
	return a.first < b.first;
}

void outdata() {
}

void solve() {
	scanf("%d", &m);
	forn(ii, m) {
		int lx, ly, rx, ry;
		scanf("%d%d%d%d", &lx, &ly, &rx, &ry);
		assert(lx < rx);
		assert(ly < ry);
		assert(0 <= abs(lx) && abs(lx) <= (int)1E+9);
		assert(0 <= abs(rx) && abs(rx) <= (int)1E+9);
		assert(0 <= abs(ly) && abs(ly) <= (int)1E+9);
		assert(0 <= abs(ry) && abs(ry) <= (int)1E+9);
		int l1 = lower_bound(all(p), mp(lx, -INF)) - p.begin(), r1 = upper_bound(all(p), mp(rx, INF)) - p.begin();
		int l2 = lower_bound(all(p2), mp(-INF, ly), lessYX) - p2.begin(), r2 = upper_bound(all(p2), mp(INF, ry), lessYX) - p2.begin();
		int res = 0;
		if (r2 - l2 >  r1 - l1) {
        	for(int i = l1; i < r1; ++i) 
        		if (lx <= p[i].x && ly <= p[i].y && p[i].x <= rx && p[i].y <= ry) ++res;
        } else {
        	for(int i = l2; i < r2; ++i) 
        		if (lx <= p2[i].x && ly <= p2[i].y && p2[i].x <= rx && p2[i].y <= ry) ++res;
        }
		printf("%d\n", res);
	}
}

void readdata() {
	scanf("%d", &n);
	assert(1 <= n && n <= 50000);
	p.resize(n);
	forn(i, n) {
		int x, y;
		scanf("%d%d", &x, &y);
		assert(0 <= abs(x) && abs(x) <= (int)1E+9);
		assert(0 <= abs(y) && abs(y) <= (int)1E+9);
		p[i] = mp(x, y);
	}
	sort(all(p));
	p2 = p;
	sort(all(p2), lessYX);
}

int main() {
        freopen(IN_FILE, "rt", stdin);
        freopen(OUT_FILE, "wt", stdout);
        readdata();
        solve();
        outdata();
        return 0;
}

