{$A+,B-,D+,E+,F-,G-,I-,L+,N+,O-,P-,Q+,R+,S+,T-,V+,X+,Y+}
{M 64384,0,655360}
{$APPTYPE CONSOLE}

uses
  sysutils;

const
  cInFile = 'bicycle.in';
  cOutFile = 'bicycle.out';

type
  int = longint;
  ext = extended;
  bool = boolean;
  tedge = record
    v,b,p: int;
  end;
  tstate = record
    t1,t2,v1,v2,cp{,par}: smallint;
    ds: integer;
  end;

procedure Assert(C: Bool;Msg: String);
begin
  if not c then begin
    writeln('*** Assertion failed. ',Msg);
    halt(239);
  end;
end;

var
  n,m: int;
  g: array[1..150]of record
    c: int;
    u: array of tedge;
  end;

procedure ReadData;
var
  u,v_,b_,p_,pow: array[1..150]of int;
  i: int;
begin
  assign(input, cInFile);
  reset(input);
  Assert(IORESULT = 0,'Input file is absent');
  read(n);
  Assert(IORESULT = 0,'N read err');
  Assert((2 <= n) and (n <= 150),'N limitations');
  readln(m);
  Assert(IORESULT = 0,'K read err');
  Assert((1 <= m) and (m <= ((n*(n-1)) shr 1)),'M limitations');

  FillChar(pow, sizeof(pow), 0);
  for i := 1 to m do
    begin
      read(u[i]);
      Assert((1 <= u[i]) and (u[i] <= n),'u[i] limitations');
      read(v_[i]);
      Assert((1 <= v_[i]) and (v_[i] <= n),'v_[i] limitations');
      read(b_[i]);
      Assert((1 <= b_[i]) and (b_[i] <= 30),'b_[i] limitations');
      readln(p_[i]);
      Assert((1 <= p_[i]) and (p_[i] <= 30),'p_[i] limitations');
      {}
      inc(pow[u[i]]);
    end;

        inc(m);
  u[m]:=n;
  v_[m]:=n+1;
  b_[m]:=5000;
  p_[m]:=5000;    

  Assert(SeekEof,'extra data');
  close(input);
      
  for i := 1 to n do
    begin 
      setlength(g[i].u, pow[i] + 2);
      g[i].c := 0;
    end;

  for i := 1 to m do
    begin
      inc(g[u[i]].c);
      with g[u[i]].u[g[u[i]].c] do
        begin
          v := v_[i];
          b := b_[i];
          p := p_[i];
        end;
    end;
end;

const maxq = 1 shl 20 - 1;

var
  q: array[0..maxq]of tstate;
  i,j,head,tail,ans: int;
  cur,new: tstate;
begin
  ReadData;
  {}
  head := 1;
  tail := 1;
  with q[1] do begin
    v1:=1;
    t1:=0;
    v2:=1;
    t2:=0;
    cp:=1;
    ds:=0;
  end;
  {}
  ans:=1 Shl 30;
  assign(output, 'output.txt');rewrite(output);
  {}
  while head <= tail do begin
    cur := q[head and maxq];
    {with cur do begin
        //if t1*t2=0 then begin
                writeln(head,#9,v1,#9,t1,#9,v2,#9,t2,#9,cp,#9,ds,#9,par);
        writeln('-------------------------------------------------------------');
      //end;
    end;}
    inc(head);
    {Finite state}
                with cur do begin
        if (((t1=0) and (v1=n)) or (v1>n)) and (((t2=0) and (v2=n)) or (v2>n)) then begin
        if ds<ans then begin
                ans:=ds;
          //if ans=25 then writeln('!');
        end;
        continue;
      end;
    end;
    {Both on edges:}
    with cur do
      if (t1>0) and (t2>0) then begin
        dec(t1);
        dec(t2);
        inc(ds);
        inc(tail);
        //cur.par:=head-1;
        q[tail and maxq]:=cur;
        continue;
      end;
    {1st on edge, 2nd in vertex}
    with cur do
        if (t1>0) and (t2=0) then begin
        dec(t1);
        inc(ds);
        new := cur;
        //new.par:=head-1;
        if cp=-1 then begin
                {1st rides bicycle}
          for i := 1 to g[v2].c do begin
            new.v2 := g[v2].u[i].v;
            new.t2 := g[v2].u[i].p-1;
            inc(tail);
            q[tail and maxq]:=new;
          end;
        end;
        if cp=0 then begin
                {2nd rides bicycle}
          for i := 1 to g[v2].c do begin
            new.v2 := g[v2].u[i].v;
            try
            new.t2 := g[v2].u[i].b-1;
            except
            end;
            new.cp := 0;
            inc(tail);
            q[tail and maxq]:=new;{2nd still rides}
            new.t2 := g[v2].u[i].p-1;
            new.cp := v2;
            inc(tail);
            q[tail and maxq]:=new;{2nd drops bicycle}
          end;
        end;
                                if cp>0 then begin
                {Nobody rides bicycle}
                for i := 1 to g[v2].c do begin
            new.v2 := g[v2].u[i].v;
            new.t2 := g[v2].u[i].p-1;
            new.cp := cur.cp;
            inc(tail);
            q[tail and maxq]:=new;{2nd goes by foot}
            if v2 = cp then begin
              new.t2 := g[v2].u[i].b-1;
              new.cp := 0;
              inc(tail);
              q[tail and maxq]:=new;{2nd takes bicycle}
            end;
          end;
        end;
        continue;
      end;
    {2nd on edge, 1st in vertex}
    with cur do
        if (t1=0) and (t2>0) then begin
        dec(t2);
        inc(ds);
        new := cur;
        //new.par:=head-1;
        if cp=0 then begin
                {2nd rides bicycle}
          for i := 1 to g[v1].c do begin
            new.v1 := g[v1].u[i].v;
            new.t1 := g[v1].u[i].p-1;
            inc(tail);
            q[tail and maxq]:=new;
          end;
        end;
        if cp=-1 then begin
                {1st rides bicycle}
          for i := 1 to g[v1].c do begin
            new.v1 := g[v1].u[i].v;
            new.t1 := g[v1].u[i].b-1;
            new.cp := -1;
            inc(tail);
            q[tail and maxq]:=new;{1st still rides}
            new.t1 := g[v1].u[i].p-1;
            new.cp := v1;
            inc(tail);
            q[tail and maxq]:=new;{1st drops bicycle}
          end;
        end;
                                if cp>0 then begin
                {Nobody rides bicycle}
                for i := 1 to g[v1].c do begin
            new.v1 := g[v1].u[i].v;
            new.t1 := g[v1].u[i].p-1;
            new.cp := cur.cp;
            inc(tail);
            q[tail and maxq]:=new;{1st goes by foot}
            if v1 = cp then begin
              new.t1 := g[v1].u[i].b-1;
              new.cp := -1;
              inc(tail);
              q[tail and maxq]:=new;{1st takes bicycle}
            end;
          end;
        end;
        continue;
      end;
    {Both in vertex}
    with cur do begin
        inc(ds);
      new := cur;
      //new.par:=head-1;
      for i := 1 to g[v1].c do
        for  j := 1 to g[v2].c do begin
          new.v1 := g[v1].u[i].v;
          new.v2 := g[v2].u[j].v;
          if v1 = cp then begin
            {1st takes bicycle}
            new.t1 := g[v1].u[i].b-1;
            new.t2 := g[v2].u[j].p-1;
            new.cp := -1;
            inc(tail);
            q[tail and maxq]:=new;
          end;
          if v2 = cp then begin
            {2nd takes bicycle}
            new.t1 := g[v1].u[i].p-1;
            new.t2 := g[v2].u[j].b-1;
            new.cp := 0;
            inc(tail);
            q[tail and maxq]:=new;
          end;
        end;
      end;
  end;
  {}
  write(ans);
  close(output);
end.