{$R+,Q+,S+,N+,I+}

uses Math;

const
      cInFile = 'bicycle.in';
      cOutFile = 'bicycle.out';

      nmax = 150;
      mmax = (nmax * (nmax - 1)) div 2;
      tmax = 30;
      inf = maxlongint shr 1;

type int = longint;
     float = extended;

var
  n, m, ans : int;
  gb, gp : array[1..nmax, 1..nmax] of int;
  t : array[1..nmax, 0..nmax * tmax] of int;
  u : array[1..nmax] of boolean;
  p : array[1..nmax] of int;
  top : int;

procedure assert(f : boolean; msg : string);
begin
  if f then exit;
  writeln('Error: ', msg);
  halt(255);
  assert(false, 'hmm...');
end;

procedure OutData;
var
  i, j : int;
begin
  writeln(ans);
end;

procedure go(v : int);
var
  i : int;
begin
  if u[v] then exit;
  u[v] := true;
  for i := 1 to n do
    if gb[v, i] < inf then go(i);
  inc(top);
  p[top] := v;
end;

procedure Solve;
var
  i, j, k, dt, ii : int;
begin
  fillchar(u, sizeof(u), 0);
  top := 0;
  go(1);
  for k := 1 to n do
    for i := 1 to n do
      for j := 1 to n do
      begin
        gb[i, j] := min(gb[i, j], gb[i, k] + gb[k, j]);
        gp[i, j] := min(gp[i, j], gp[i, k] + gp[k, j]);
      end;
  for i := 1 to n do
    for j := 1 to n do
    begin
      assert((gb[i, j] = inf) or (gb[j, i] = inf), 'Cycle detected');
      assert((gp[i, j] = inf) or (gp[j, i] = inf), 'Cycle detected');
    end;
  assert(gb[1, n] < inf, 'Can''t reach destination');
  assert(gp[1, n] < inf, 'Can''t reach destination');
  for i := 1 to n do
  begin
    gp[i, i] := 0;
    gb[i, i] := 0;
  end;
  for i := 1 to n do
    for j := 0 to n * tmax do t[i, j] := inf;
  t[1, 0] := 0;
  ans := inf;
  for ii := top downto 1 do
  begin
    i := p[ii];
    for j := 0 to n * tmax do if t[i, j] < inf then
    begin
      ans := min(ans, t[i, j] + max(gp[i, n], j + gb[i, n]));
      for k := 1 to n do 
        if gp[i, k] < inf then
        begin
          dt := - (j + gb[i, k]) + gp[i, k];
          if dt >= 0 then
            t[k, dt] := min(t[k, dt], t[i, j] + j + gb[i, k]);  
        end;
    end;
  end;
end;

procedure ReadData;
var
  i, j : int;
  u, v, b, p : int;
begin
  readln(n, m);
  assert((n >= 2) and (n <= nmax), 'N Limits Incorrect');
  assert((m >= 1) and (m <= mmax), 'M Limits Incorrect');
  for i := 1 to n do
    for j := 1 to n do
    begin
      gp[i, j] := inf;
      gb[i, j] := inf;
    end;
  for i := 1 to m do
  begin
    readln(u, v, b, p);
    assert(IORESULT = 0, 'Wrong Input Format');
    assert((u >= 1) and (u <= n), '"ui" Limits Incorrect');
    assert((v >= 1) and (v <= n), '"vi" Limits Incorrect');
    assert(u <> v, 'Self Edge');
    assert((b >= 1) and (b <= tmax), '"bi" Limits Incorrect');
    assert((p >= 1) and (p <= tmax), '"bi" Limits Incorrect');
    assert(b <= p, 'B > P');
    assert(u <> n, 'Down Path');
    assert(v <> 1, 'Down Path');
    assert((gb[u, v] = inf) and (gb[v, u] = inf), 'Multiply edges');
    gb[u, v] := b;
    gp[u, v] := p;
  end;
end;

begin
  assign(input, cInFile); reset(input);
  assert(IORESULT = 0, 'Can''t open file');
  assign(output, cOutFile); rewrite(output);
  assert(IORESULT = 0, 'Can''t create file');

  ReadData;
  assert(SeekEof, 'Extra info in the input');
  Solve;
  OutData;

  close(output);
  close(input);
end.
