{$I-,Q-,R-,S-,O+,H-}
{$I+,Q+,R+,S+,O-,H+}
{$apptype console}
{$M 1000000, 10000000}

uses Math, SysUtils;

const
  cInFile = 'office.in';
  cOutFile = 'office.out';

  inf = maxlongint shr 1;
  eps = 1e-8;

  nmax = 110000;
  mmax = 110000;
  lgmax = 17;

type
  int = longint;
  real = extended;

  rebro = record
    v, w : int;
    nx : int;
  end;

var
  n, m, k : int;
  ans : int;

  allKol : int;

  g : array [0..nmax] of int;
  kl : int;
  s : array [0..mmax * 2] of rebro;

  p, d : array [0..nmax, 0..lgmax] of int;

  tc, gl : int;
  tin, tout, dp : array [0..nmax] of int;

  v : array [0..nmax] of int;

procedure OutData;
var
  i, j : int;
begin

end;

procedure go(v, pr, wc : int);
var
  i, x : int;
begin
  inc(tc);
  tin[v]:= tc;
  if v <> 1 then inc(gl, wc);
  dp[v]:= gl;
  x:= g[v];
  p[v, 0]:= pr;
  d[v, 0]:= wc;
  for i:= 1 to lgmax do p[v, i]:= p[p[v, i - 1], i - 1];
  for i:= 1 to lgmax do
  begin
    d[v, i]:= d[v, i - 1] + d[p[v, i - 1], i - 1];
    if d[v, i] > inf then d[v, i]:= inf;
  end;
  while x <> 0 do
  begin
    if s[x].v <> pr then go(s[x].v, v, s[x].w);
    x:= s[x].nx;
  end;
  if v <> 1 then dec(gl, wc);
  inc(tc);
  tout[v]:= tc;
end;

function pred(v1, v2 : int) : boolean;
begin
  pred:= (tin[v1] <= tin[v2]) and (tout[v1] >= tout[v2]);
end;

function lca(v1, v2 : int) : int;
var
  i : int;
begin
  if pred(v1, v2) then lca:= v1 else
    if pred(v2, v1) then lca:= v2 else
    begin
      for i:= lgmax downto 0 do
        if not pred(p[v1, i], v2) then v1:= p[v1, i];
      lca:= p[v1, 0];
    end;
end;

function dist(v1, v2 : int) : int;
var
  vl : int;
begin
  vl:= lca(v1, v2);
  dist:= dp[v1] + dp[v2] - 2 * dp[vl];
end;

function farest(vr : int) : int;
var
  i, dst, cd : int;
begin
  dst:= dist(vr, v[1]);
  Result:= v[1];
  for i:= 2 to k do
  begin
    cd:= dist(vr, v[i]);
    if dst < cd then
    begin
      dst:= cd;
      Result:= v[i];
    end;
  end;
end;

function find(v, du : int) : int;
var
  i : int;
begin
  for i:= lgmax downto 0 do
    if du >= d[v, i] then
    begin
      dec(du, d[v, i]);
      v:= p[v, i];
    end;
  find:= v;
end;

procedure Solve;
var
  i, j : int;
  ii, tst : int;
  v1, v2, ds, vl : int;
  x, vr1, vr2 : int;
  r1, r2 : int;
begin
  fillchar(p, sizeof(p), 0);
  tin[0]:= -inf;
  tout[0]:= inf;
  dp[0]:= -inf;
  for i:= 0 to lgmax do d[0, i]:= inf;
  tc:= 0;
  gl:= 0;
  go(1, 0, inf);
  assert(tc = 2 * n); // is tree!!
  assert(gl = 0);
  read(tst);
  allKol:= 0;
  for ii:= 1 to tst do
  begin
    read(k);
    inc(allKol, k);
    for i:= 1 to k do read(v[i]);
    for i:= 1 to k do assert((v[i] > 0) and (v[i] <= n));
    v1:= farest(v[1]);
    v2:= farest(v1);
    ds:= dist(v1, v2);
    if dp[v1] > dp[v2] then vl:= find(v1, ds div 2) else vl:= find(v2, ds div 2);
    vr1:= vl;
    vr2:= p[vl, 0];
    r1:= max(dist(vr1, v1), dist(vr1, v2));
    r2:= max(dist(vr2, v1), dist(vr2, v2));
    if (vr2 <> 0) and (r1 > r2) then
    begin ;
      vl:= vr1;
      vr1:= vr2;
      vr2:= vl;
    end;
    if r1 = r2 then write('2 ') else write('1 ');
    if r1 = r2 then
      if vr1 > vr2 then
      begin
        x:= vr1;
        vr1:= vr2;
        vr2:= x;
      end;
    write(vr1);
    if r1 = r2 then write(' ', vr2);
    writeln;
  end;
  assert(allKol <= 100000);
end;

procedure push(x, y, z : int);
begin
  inc(kl);
  s[kl].v:= y;
  s[kl].w:= z;
  s[kl].nx:= g[x];
  g[x]:= kl;
end;

procedure ReadData;
var
  i, j : int;
  x, y, z : int;
begin
  kl:= 0;
  fillchar(g, sizeof(g), 0);
  read(n);
  assert((n <= 100000) and (n >= 1));
  for i:= 1 to n - 1 do
  begin
    read(x, y, z);
    assert((x > 0) and (x <= n));
    assert((y > 0) and (y <= n));
    assert((z > 0) and (z <= 100));
    push(x, y, z);
    push(y, x, z);
  end;
end;

begin
  assign(input,cinfile);
  assign(output,coutfile);
  reset(input);
  rewrite(output);
  ReadData;
  Solve;
  OutData;
  close(input);
  close(output);
end.
