{$R+,Q+,S+,E-,N+,O+,I+}
{$MaxstackSize 10000000}

uses Math;

const
      cInFile = 'office.in';
      cOutFile = 'office.out';

      inf = maxlongint shr 1;
      nmax = 111111;
      lmax = 18;

type int = longint;
     real = extended;
     float = extended;

     edge = record
       a, b, c : int;
       next : int;
     end;

     tr = record
       p : int;
       d : int;
     end;

var
  n, m, k, ans : int;
  e : array[1..2 * nmax] of edge;
  g, t_in, t_out : array[1..nmax] of int;
  up : array[0..nmax, 0..lmax] of tr;
  v : array[1..nmax] of int;
  r : array[0..2 * nmax] of int;
  tme : int;
  ke : int;

procedure OutData;
var
  i, j : int;
begin

end;

function IsUp(a, b : int) : boolean;
begin
  Result := (t_in[a] <= t_in[b]) and (t_out[a] >= t_out[b]);
end;

function dist(a, b : int; var lca : int; var da, db : int) : int;
var
  i : int;
begin
  da := 0;
  db := 0;
  for i := lmax downto 0 do
  begin
    if not IsUp(a, b) and (up[a][i].p <> 0) and (not IsUp(up[a][i].p, b)) then
    begin
      inc(da, up[a][i].d);
      a := up[a][i].p;
    end;
    if not IsUp(b, a) and (up[b][i].p <> 0) and (not IsUp(up[b][i].p, a)) then
    begin
      inc(db, up[b][i].d);
      b := up[b][i].p;
    end;
  end;
  lca := a;
  if not IsUp(a, b) then
  begin
    inc(da, up[a][0].d);
    lca := up[a][0].p;
  end;
  if not IsUp(b, a) then
  begin
    inc(db, up[b][0].d);
    lca := up[b][0].p;
  end;
  Result := da + db;
end;

procedure go(v, p, d : int);
var
  ptr, i : int;
begin
  up[v][0].p := p;
  up[v][0].d := d;
  for i := 1 to lmax do
  begin
    up[v][i].p := up[up[v][i - 1].p][i - 1].p;
    if up[v][i].p <> 0 then
      up[v][i].d := up[v][i - 1].d + up[up[v][i - 1].p][i - 1].d;
  end;
  inc(tme);
  t_in[v] := tme;
  ptr := g[v];
  while ptr <> 0 do
  begin
    if e[ptr].b <> p then
      go(e[ptr].b, e[ptr].a, e[ptr].c);
    ptr := e[ptr].next;
  end;
  inc(tme);
  t_out[v] := tme;
end;

procedure getpath(var a, b : int);
var
  dst, c : int;
  lca, da, db : int;
  i : int;
begin
  b := v[1];
  dst := 0;
  for i := 1 to k do
  begin
    c := dist(v[1], v[i], lca, da, db);
    if dst < c then
    begin
      dst := c;
      b := v[i];
    end;
  end;
  a := b;
  dst := 0;
  for i := 1 to k do
  begin
    c := dist(a, v[i], lca, da, db);
    if dst < c then
    begin
      dst := c;
      b := v[i];
    end;
  end;
end;

procedure sol;
var
  a, b, lca, da, db : int;
  l : int;

  procedure add(v : int);
  var
    i : int;
    cd : int;
  begin
    cd := 0;
    for i := lmax downto 0 do
      if (up[v][i].p <> 0) and (cd + up[v][i].d <= l) then
      begin
        inc(cd, up[v][i].d);
        v := up[v][i].p;
      end;
    inc(r[0]);
    r[r[0]] := v;
    if up[v][0].p <> 0 then
    begin
      inc(r[0]);
      r[r[0]] := up[v][0].p;
    end;
  end;

var
  i, j, t, dst : int;

begin
  getpath(a, b);
  l := dist(a, b, lca, da, db);
  l := l shr 1;
  r[0] := 0;
  add(a);
  add(b);
  for i := 1 to r[0] do
    for j := i + 1 to r[0] do
      if r[i] > r[j] then
      begin
        t := r[i];
        r[i] := r[j];
        r[j] := t;
      end;
  t := 0;
  dst := inf;
  for i := 1 to r[0] do
    dst := min(dst, max(dist(a, r[i], lca, da, db), dist(b, r[i], lca, da, db)));
  t := 0;
  for i := 1 to r[0] do
    if max(dist(a, r[i], lca, da, db), dist(b, r[i], lca, da, db)) = dst then
      if (t = 0) or (r[i] > r[t]) then
      begin
        inc(t);
        r[t] := r[i];
      end;
  write(t);
  for i := 1 to t do write(' ', r[i]);
  writeln;
end;

procedure Solve;
var
  i, j, ii : int;
  v0 : int;
begin
  v0 := random(n) + 1;
  fillchar(up, sizeof(up), 0);
  tme := 0;
  go(v0, 0, 0);
  read(m);
  for ii := 1 to m do
  begin
    read(k);
    for i := 1 to k do read(v[i]);
    sol;
  end;
end;

procedure push(a, b, c : int);
begin
  inc(ke);
  e[ke].a := a;
  e[ke].b := b;
  e[ke].c := c;
  e[ke].next := g[a];
  g[a] := ke;
end;

procedure ReadData;
var
  i, j : int;
  a, b, c : int;
begin
  read(n);
  ke := 0;
  fillchar(g, sizeof(g), 0);
  for i := 1 to n - 1 do
  begin
    read(a, b, c);
    push(a, b, c);
    push(b, a, c);
  end;
end;

begin
  randomize;
  assign(input, cInFile); reset(input);
  assign(output, cOutFile); rewrite(output);
    ReadData;
    Solve;
    OutData;
  close(output);
  close(input);
end.
