program Veze;                   {P-III-1}
const
  MAXN = 100;
type
  {Popis jednoho intervalu}
  Int = record
           s, e : Integer;      {Potek a konec intervalu}
           n : Integer;         {slo ve, kter interval pat}
         end;
  {Popis jednoho bodu}
  Point = array [1..2] of Integer;
  {Popis jednoho obdlnka}
  Rectangle = record
                a, b : Point;   {Lev horn a prav doln roh}
              end;
  {Intervaly v jedn souadnici}
  IntList = array[1..MAXN] of Int;
  CmpProc = function(A, B : Int) : ShortInt;
var
  N : Integer;  {Pocet vezi}
  Rec : Array[1..MAXN] of Rectangle;    {Obdlnky}
  T : Array[1..MAXN] of Point;          {Umstn v}

{Nate vstup}
procedure ReadInp;
var
  i : Integer;
begin
  Write('Pocet vezi: ');
  Read(N);
  WriteLn('Souradnice obdelniku:');
  for i := 1 to N do
    Read(Rec[i].a[1], Rec[i].a[2], Rec[i].b[1], Rec[i].b[2]);
end;

{Pid interval do haldy}
procedure AddHeap(var N : Integer; var H : IntList; I : Int; 
                  Cmp : CmpProc);
var
  A : Integer;
  Tmp : Int;
begin
  Inc(N);
  H[N] := I;
  A := N;
  while A <> 1 do begin {Nejsme na vrcholu}
    if Cmp(H[A], H[A div 2]) <> -1 then    
      break;  {Je splnna podmnka haldy?}
    {Zamnme prvky, aby byla podmnka splnna}
    Tmp := H[A];
    H[A] := H[A div 2];
    H[A div 2] := Tmp;
    A := A div 2; {Posun o rove ve}
  end;
end;

{Odebere z haldy minimum}
procedure GetHeapMin(var N : Integer; var H : IntList; Cmp : CmpProc;
                     var Res : Int);
var
  A, M : Integer;
  Tmp : Int;
begin
  Res := H[1];
  H[1] := H[N];
  Dec(N);
  A := 1;
  while A * 2 < N do begin      {Nejsme na dn?}
    {Nalezneme menho ze syn}
    if Cmp(H[A*2], H[A*2+1]) = -1 then
      M := A*2
    else
      M := A*2+1;
    if Cmp(H[M], H[A]) <> -1 then  {Podmnka haldy splnna?}
      break;
    {Zamnme prvky, aby byla podmnka splnna}
    Tmp := H[M];
    H[M] := H[A];
    H[A] := Tmp;
    A := M; {Posun o rove ne}
  end;
end;

{Porovn dva intervaly podle potku}
function CmpInt(a, b : Int) : ShortInt; far;
begin
  if (a.s < b.s) or ((a.s = b.s) and (a.e < b.e)) then
    CmpInt := -1
  else if (a.s = b.s) and (a.e = b.e) then
    CmpInt := 0
  else
    CmpInt := 1;
end;

{Setd pole interval}
procedure SortInts(var A : IntList);
var
  C, i : Integer;
  H : IntList;
begin
  C := 0;
  for i := 1 to N do
    AddHeap(C, H, A[i], CmpInt);
  for i := 1 to N do
    GetHeapMin(C, H, CmpInt, A[i]);
end;

{Srovn intervaly podle konce}
function CmpBack(a, b : Int) : ShortInt; far;
begin
  if a.e < b.e then
    CmpBack := -1
  else if a.e = b.e then
    CmpBack := 0
  else
    CmpBack := 1;
end;

{Spote jednu souadnici pro kadou v}
function CountCoord(c : Integer) : Boolean;
var
  Ints : IntList;  {Intervaly}
  i, a : Integer;
  ActInts : IntList;    {Halda interval k uplatnn}
  ActIntsN : Integer;   {Poet interval v hald}
  Tmp : Int;
begin
  {Vytvo pole interval z obdlnku}
  for i := 1 to N do begin
    Ints[i].s := Rec[i].a[c];
    Ints[i].e := Rec[i].b[c];
    Ints[i].n := i;
  end;
  SortInts(Ints); {Setd intervaly}
  {Ur souadnici v}
  ActIntsN := 0;
  a := 1;
  for i := 1 to N do begin
    {Pid do haldy vechny intervaly zanajc na aktuln pozici}
    while (a <= N) and (Ints[a].s = i) do begin
      AddHeap(ActIntsN, ActInts, Ints[a], CmpBack);
      Inc(a);
    end;
    if ActIntsN > 0 then begin
      {Vybereme nejdve konc interval}
      GetHeapMin(ActIntsN, ActInts, CmpBack, Tmp);
      if Tmp.e < i then begin	{U skonil?}
        CountCoord := False;
        Exit;
      end;
      T[Tmp.n][c] := i;
    end;
  end;
  CountCoord := True;
end;

{Vytiskne souadnice v}
procedure Print;
var
  i : Integer;
begin
  WriteLn('Souradnice vezi jsou:');
  for i := 1 to N do
    WriteLn(T[i][1], ' ', T[i][2]);
end;

begin
  ReadInp;              {Nate vstup}
  if CountCoord(1) and CountCoord(2) then 
    Print   {Ur souadnice v - vely se?}
  else
    WriteLn('Rozmisteni vezi neexistuje.');
end.

