program P_I_4a;
{program semigraficky zobraz priebeh vpotu kompartorovej siete}
uses crt;
const MAXM  = 100; {maximlny poet kompartorov}
      MAXN  = 100; {maximlny poet vodiov}
var n : integer;   {poet vodiov}
    poloziek : integer;   {poet poloiek v poli komparatory}
    komparatory : array[1..2*MAXM, 1..2] of integer;
                         {zoznam kompartorov a oddeovaov rovn}
    stav : array[1..MAXN] of integer;
                         {aktulny stav vodiov po niekokch krokoch}
    plne : array[1..MAXN] of boolean;
                         {i ide cez vodi iara v aktulnom stpci}

procedure nacitaj;
var inp : text;      {vstupn sbor}
    i, komparatorov, bolo_komparatorov : integer;
begin
   assign(inp, 'siete.in');    {otvor vstupn sbor}
   reset(inp);
   read(inp, n, komparatorov); {taj poet vodiov a kompartorov}   
   for i := 1 to n do     {nataj vstupy siete - (stav vodiov)}
      read(inp, stav[i]);
   
   {natavaj kompartory a oddeovae,
    a km nedosiahne dan poet kompartorov}
   bolo_komparatorov := 1; poloziek := 0;
   while bolo_komparatorov <= komparatorov do begin
      poloziek := poloziek+1;
      read(inp, komparatory[poloziek, 1], komparatory[poloziek, 2]);      
      {ak poloka bola kompartor, zvs poet kompartorov}
      if komparatory[poloziek, 1] <> 0 then
         bolo_komparatorov := bolo_komparatorov+1;
   end;   
   {za poslednm natanm kompartorom pridaj oddeova}
   poloziek := poloziek+1;
   komparatory[poloziek, 1] := 0;
   komparatory[poloziek, 2] := 0;
   close(inp);                 {zatvor vstupn sbor}
end; { nacitaj }

procedure prazdne_stlpce(stlpec, kolko : integer);
var i, j : integer;
begin  {vypis <kolko> przdnych stpcov}
   for i := 1 to n do begin
      gotoxy(stlpec, i*2-1);
      for j := 1 to kolko do write('-');
   end;
end; { prazdne_stlpce }

procedure vypis_stav(stlpec, sirka : integer);
var i : integer;
begin
   for i := 1 to n do begin  {vyp aktulny stav vodiov}
      gotoxy(stlpec, i*2-1);
      write(stav[i]:sirka);  {kad slo m rku <sirka>}
   end;
end; { vypis_stav }

function najdi_sirku : integer;
var i, max, sirka, cislo : integer;
begin   {najde rku (poet miest) najirieho sla na vstupe}
   max:=1;
   for i := 1 to n do begin
      sirka := 1;
      cislo := stav[i];         {njdi rku sla stav[i]}
      while cislo>=10 do begin  
         sirka := sirka+1;      {del 10, km neklesne pod 10}
         cislo := cislo div 10;
      end;
      if sirka>max then max := sirka; {porovnaj s maximom}
   end;
   najdi_sirku := max;
end; { najdi_sirku }

function je_volno(odkial, pokial : integer) : boolean;
var i : integer;
    ok : boolean;
begin  {zisti, i meme zakresli kompartor do stpca}
   ok := true;
   for i := odkial to pokial do begin
      if plne[i] then ok := false;  {ak sa kri s inm, nememe}
   end;
   je_volno := ok;
end; { je_volno }

procedure spracuj_komparator(odkial, pokial, stlpec : integer);
var i, pom : integer;
begin  {vykresli jeden kompartor, zap do pola plne, me stav}
   gotoxy(stlpec,2*odkial-1);    {vykresli horn koniec}
   write('*');
   gotoxy(stlpec,2*pokial-1);    {vykresli doln koniec}
   write('*');
   for i:= 2*odkial to 2*pokial-2 do begin  {spojnica medzi}
      gotoxy(stlpec,i);
      write('|');
   end;   
   for i := odkial to pokial do   {zap kompartor do pola plne}
      plne[i] := true;
   {vykonaj porovnanie a vmenu dan kompartorom}
   if stav[odkial]>stav[pokial] then begin
      pom := stav[odkial];
      stav[odkial] := stav[pokial];
      stav[pokial] := pom;
   end;
end; { vykresli_komparator }

procedure vykresli;
var i, j, stlpec, sirka : integer;
    novy_stlpec  : boolean;
begin  {vykresli cel priebeh vpotu}
   clrscr;               {zma obrazovku}
   sirka := najdi_sirku; {njdi rku sla na vodii}
   vypis_stav(1,sirka);  {vyp vstupy do stpca 1}
   stlpec := sirka;      {posledn pouit stpec je <sirka>}
   novy_stlpec := true;  {v tomto stpci nebol iaden kompartor}

   for i := 1 to poloziek do begin
      if komparatory[i][1]=0 then begin   {oddeova rovn}
         prazdne_stlpce(stlpec+1,2);      {vykresli vodie}
         vypis_stav(stlpec+3,sirka);      {vyp aktulny stav}
         stlpec := stlpec+2+sirka;
         novy_stlpec := true;      {zaneme nov stpec kompartorov}
      end
      else begin   {kompartor}
         if novy_stlpec
            or not je_volno(komparatory[i][1],komparatory[i][2]) then
         begin {ak treba zaa nov stpec kompartorov}
            prazdne_stlpce(stlpec+1,3);          {vykresli vodie}
            for j := 1 to n do plne[j] := false; {inicializuj pole} 
            stlpec := stlpec+3;
            novy_stlpec := false;
         end;
         {vykresli a simuluj komp., zap ho pola plne}
         spracuj_komparator(komparatory[i][1],komparatory[i][2],stlpec);
      end;
   end; {for i}
end; { vykresli }

begin          {hlavn program}
   nacitaj;    {nataj vstup}
   vykresli;   {vykresli priebeh vpotu siete}
   readln;     {pokaj na stlaenie klvesy enter}
   clrscr;     {zma obrazovku}
end.






