program P_II_3; 
const MAX =  1000;               { maximlny poet bodov }      
const priamo = 1; vlavo = 2; vpravo = 3; { smery }
type bod     = record            { daje pre jednho iaka }   
		  x,y	: real;  { sradnice }
		  uhol	: real;  { uhol vypotan funkciou "uhol" }
		  sucet	: real;  { set uhlov prvch niekoko iakov }
	       end;	
var a : array [0..2*MAX] of bod; { pole bodov, kad je tam dvakrt } 
   n  : integer;                 { poet bodov (iakov) }

function uhol(x, y :  real) : real;
var vysl : real;     
begin  { implementcia funkcie "uhol" definovanej v zadan }
   if x = 0 then begin          { pecilny prpad x=0 }
      if y > 0 then uhol := 90
      else uhol := 270;
   end
   else begin                   { x<>0, meme poui arctan }
      vysl := arctan(y/x) / pi * 180;
      if x < 0 then vysl := vysl - 180;  { zme vsledok poda kvadrantu }
      if vysl < 0 then vysl := vysl + 360;
      uhol := vysl;
   end;
end; { uhol }

procedure nacitaj;
var i : integer;
begin  { nataj slo n a sradnice n bodov }
   read(n);
   for i := 1 to n do read(a[i].x, a[i].y);
end; { nacitaj }

procedure tried(zac, kon : integer);
var pom	: bod;
var i, j, min : integer;
begin { tried pole a od pozcie "zac" po pozciu "kon" poda uhla }
   for i := zac to kon-1 do begin
      min := i;    { njdi minimum v neutriedenej asti pola }
      for j := i+1 to kon do begin
	 if a[j].uhol < a[min].uhol then min := j;
      end;
      { ulo minimum do a[i] }
      pom := a[i]; a[i] := a[min]; a[min] := pom;
   end;
end; { tried }

procedure priprav_pole;
var i : integer;
begin { sprav predvpoty na pripravenie poa a }
   for i := 1 to n do    { kadmu bodu spotaj uhol }
      a[i].uhol := uhol(a[i].x,a[i].y);
   tried(1,n);           { utried pole poda uhlov }
   for i := 1 to n do    { urob kpiu kadho bodu }
      a[i+n] := a[i];
   a[0].sucet := 0;      { spotaj iaston sty uhlov }
   for i:=1 to 2*n do 
      a[i].sucet := a[i-1].sucet + a[i].uhol;
end; { priprav_pole }

function poloha(kto, odkoho : integer) : integer;
begin { zisti, v akej polohe je bod "kto" vzhadom na bod "odkoho" }
   if a[kto].uhol = a[odkoho].uhol then poloha := priamo
   else if a[odkoho].uhol < a[kto].uhol then begin
      if a[kto].uhol < a[odkoho].uhol + 180 then poloha := vlavo
      else poloha := vpravo;
   end
   else begin
      if a[kto].uhol < a[odkoho].uhol - 180 then poloha := vlavo
      else poloha := vpravo;
   end;
end;

function sucet_uhlov(smer, posl_vlavo : integer) : real;
var sucet : real;
begin  { spotaj set uhol, ak je uite otoen k iakovi "smer",
         "posl_vlavo" je posledn  iak, ktor je naavo od uitea } 
   { zapotaj iakov naavo od uitea (od smer+1 po posl_vlavo) }
   sucet := (a[posl_vlavo].sucet - a[smer].sucet) -
            (posl_vlavo-smer) * a[smer].uhol;
   { niektor iaci naavo maj men uhol }
   if posl_vlavo>n then 
      sucet := sucet + (posl_vlavo-n) * 360;
   { zapotaj iakov napravo od uitea (od posl_vlavo+1 po smer+n-1) }
   sucet := sucet + ((smer+n-1) - posl_vlavo) * a[smer].uhol -
           (a[smer+n-1].sucet - a[posl_vlavo].sucet);
   { niektor iaci napravo maj v uhol }
   if posl_vlavo+1 <= n then 
      sucet := sucet + (n - posl_vlavo) * 360;
   
   sucet_uhlov := sucet;
end;

function najdi_posl_vlavo(smer, zac : integer) : integer;
var posl_vlavo : integer;
begin  { njdi poslednho iaka naavo od smeru "smer",
         zani hada v bode "zac" }
   posl_vlavo := zac;
   while (poloha(posl_vlavo, smer) <> vpravo) and 
      (posl_vlavo < smer+n) do begin
	 posl_vlavo := posl_vlavo + 1;
      end;
   najdi_posl_vlavo := posl_vlavo - 1;
end;

var smer, posl_vlavo, min_smer : integer;
var sucet, min :  real;
begin { **** hlavn program **** }
   nacitaj;             { nataj vstup }
   priprav_pole;        { trie, predpotaj uhly a ich sty}

   smer := 1;           { spotaj otoenie smerom k iakovi 1 }
   posl_vlavo := najdi_posl_vlavo(smer, 1);
   min := sucet_uhlov(smer, posl_vlavo);
   min_smer := 1;

   while smer<n do begin  { km sa neprezr vetky body }
      smer := smer+1;      { oto sa k aliemu iakovi }
      posl_vlavo := najdi_posl_vlavo(smer, posl_vlavo);
      sucet := sucet_uhlov(smer, posl_vlavo);
      if sucet < min then begin { porovnaj set uhlov s doterajm minimom }
	 min := sucet;
	 min_smer := smer;
      end;
   end; 
   { vyp vsledok }
   writeln('Otocit sa v smere [', a[min_smer].x:0:1, ',',
	   a[min_smer].y:0:1, ']');
end.