program P_III_5;
const MAX =  200;
type uzol_sm  = ^ uzol;    { typ: smernk na uzol stromu }
     uzol = record           { typ: uzol stromu }
       vetva : array[boolean] of uzol_sm; { smernky na deti }
       vlozeny : boolean;       { i bol zodpovedajci reazec vloen }
     end;	  
     pozicia =  array[1..MAX] of boolean; { typ: pozcia hry }
var koren : uzol_sm;              { kore psmenkovho stromu }
    K, N : integer;               { K a N zo vstupu }
    pocet_pozicii : integer;      { poet objavench pozci }

function novy_uzol : uzol_sm;   { vytvor nov uzol stromu }
var p : uzol_sm;
begin
   new(p);                   { alokcia pamte }
   p^.vetva[false] := nil;   { uzol nem iadne deti }
   p^.vetva[true] := nil;
   p^.vlozeny := false;      { zodpovedajci reazec nebol vloen }  
   novy_uzol := p;           { vr vytvoren uzol }
end; { novy_uzol }

function pridaj(var poz :  pozicia) : boolean;
{ pridaj pozciu "poz" do stromu, vr true, ak tam ete nebola }
var i : integer;  
    p : uzol_sm;  { aktulny uzol stromu }
begin
   p := koren;    { zaneme v koreni } 
   for i:=1 to K do begin
      if p^.vetva[poz[i]] = nil then { ak vetva neexistuje, vytvorme }
	 p^.vetva[poz[i]] := novy_uzol;
      p := p^.vetva[poz[i]];         { posume sa po prslunej vetve }
   end;
   if p^.vlozeny then pridaj := false { pozcia u je v strome }
   else begin { pozcia nie je v strome }
      p^.vlozeny := true;    { pridme ju }         
      inc(pocet_pozicii);    { zvime poet objavench pozci }
      pridaj := true;
   end;
end; { pridaj }

procedure prirad(var poz : pozicia; kde : integer; b1, b2, b3 : boolean);
{ pomocn procedra, ktor prirad hodnoty trom polkam pozcie }
begin
   poz[kde]:=b1; poz[kde+1]:=b2; poz[kde+2]:=b3;
end; { prirad }

procedure generuj(var poz : pozicia; pocet_kamenov : integer);
{ rekurzvne generuj vetky pozcie z pozcie "poz",
"pocet_kamenov" je poet kamenov v "poz". }
var i : integer;
begin
   if pocet_kamenov < N then begin 
      for i:=1 to K-2 do begin
	 { sks ah z pozcie i+2 doava }
	 if poz[i] and (not poz[i+1]) and (not poz[i+2]) then begin
	    prirad(poz, i, false, true, true); { zme "poz" }
	    if pridaj(poz) then generuj(poz, pocet_kamenov+1);
	    prirad(poz, i, true, false, false); { obnov "poz" }
	 end;
	 { sks ah z pozcie i doprava }
         if (not poz[i]) and (not poz[i+1]) and poz[i+2] then begin
	    prirad(poz, i, true, true, false); { zme "poz" }
	    if pridaj(poz) then generuj(poz, pocet_kamenov+1);
	    prirad(poz, i, false, false, true); { obnov "poz" }
	 end;
      end;
   end;
end; { generuj }

var i, kamen, pocet_kamenov : integer;
   poz : pozicia;
begin { hlavn program }
   { nataj a spotaj kamene na vstupe }
   readln(K, N);
   pocet_kamenov := 0;
   for i := 1 to K do begin
      read(kamen);
      poz[i] := (kamen=1);
      if poz[i] then inc(pocet_kamenov);
   end; 
   { inicializuj globlne premenn }
   koren := novy_uzol;
   pocet_pozicii := 0;
   { generuj z danej pozcie }
   if pocet_kamenov <= N then begin
      pridaj(poz);
      generuj(poz, pocet_kamenov);
   end; 
   writeln(pocet_pozicii); { vyp vsledok }
end.



