program P_III_4;
const MAXN = 201; MAXM = MAXN * MAXN + MAXN;
type
   hrana = record  { typ: hrana }
	      zac, kon : integer;  { zaiaton a koncov vrchol }  
	      pridana  : boolean;  { je to jedna z umelo pridanch hrn? }
	      pouzita  : boolean;  { je hrana pouit v ahu? }
	      dalsia   : integer;  { alia hrana v ahu }
   end;		       
   zoznam_sm = ^ zoznam; { typ: smernk na prvok zoznamu hrn }
   zoznam =  record  { typ: prvok zoznamu hrn }
	       hrana  : integer;  { slo hrany }
	       dalsia :  zoznam_sm; { smernk na al prvok zoznamu }
   end;
var hrany   : array[1..MAXM] of hrana;  { pole hrn }
   susedia  : array[1..MAXN] of zoznam_sm; { zoznam hrn pre kad vrchol }
   stupen   : array[1..MAXN] of integer; { stupe vrchola }
   nepouzite  : array[1..MAXN] of zoznam_sm;
                  { prv hrana v zozname, ktor me by nepouit }
   zaciatky : array[1..MAXN] of integer; { zaiatky ahov }
   pocet_zac  : integer; { poet zaiatkov v poli zaciatky }
   n, m	    : integer;   { poet hrn a vrcholov }

procedure pridaj_suseda(komu, hrana : integer);
var zvysok :  zoznam_sm;
begin { pridaj hranu "hrana" do zoznamu pre vrchol "komu" }
   zvysok := susedia[komu]; { odlo si zvyok zoznamu }
   new(susedia[komu]);  { vytvor nov prvok }
   susedia[komu]^.hrana := hrana;
   susedia[komu]^.dalsia := zvysok;
   inc(stupen[komu]); { zv stupe vrcholu }
end; { pridaj_suseda }

procedure pridaj_hranu(index, zac, kon : integer; pridana : boolean);
begin { pridaj nov hranu na pozciu "index" }
   hrany[index].zac := zac;  hrany[index].kon := kon;
   hrany[index].dalsia := 0;
   hrany[index].pouzita := false;
   hrany[index].pridana := pridana;
   pridaj_suseda(zac, index);   { pridaj do zoznamov pre oba koncov vrcholy }
   pridaj_suseda(kon, index);
end; { pridaj_hranu }

procedure nacitaj;
var i, zac, kon : integer;
begin { nataj vstup a inicializuj polia }
   readln(n,m);
   for i := 1 to n do begin
      susedia[i] := nil;
      stupen[i] := 0;
   end;
   for i := 1 to m do begin
      readln(zac, kon);
      pridaj_hranu(i, zac, kon, false);
   end;
end; { nacitaj }

function nepouzita_hrana(vrchol	:  integer) : integer;
{ Vrti prv nepouit hranu z vrcholu alebo 0, ak neexistuje.
  V "nepouzite[vrchol]" si ulome hrany, ktor u sme prehadali
  (kvli zrchleniu alieho prehadvania). }
var p	  : zoznam_sm;
   nasiel :  boolean;
begin
   p := nepouzite[vrchol];
   nasiel := false;
   while (p <> nil) and not nasiel do begin { presko pouit hrany }
      if not hrany[p^.hrana].pouzita then nasiel := true
      else p := p^.dalsia;
   end;
   nepouzite[vrchol] := p;  { ulo si preskoen hrany }
   { nali sme nepouit hranu ? }
   if nasiel then nepouzita_hrana := p^.hrana
   else nepouzita_hrana := 0;
end; { nepouzita_hrana }

function druhy_koniec(hrana, koniec :  integer) : integer;
begin { vr ten koniec hrany, ktor nie je rovn "koniec". }
   if hrany[hrana].zac = koniec then
      druhy_koniec := hrany[hrana].kon
   else
      druhy_koniec := hrany[hrana].zac;
end; { druhy_koniec }

procedure zorientuj_hranu(hrana, koniec :  integer);
begin { oto hranu tak, aby mala koniec v "koniec" }
   if hrany[hrana].zac = koniec then begin
      hrany[hrana].zac := hrany[hrana].kon;
      hrany[hrana].kon := koniec;
   end;
end;

procedure vytvor_tah(vrchol : integer;
		     var prva_hrana, posledna_hrana : integer;
		     var bola_pridana : boolean);
{ Rekurzvne vytvor uzavret ah zanajci vo "vrchol" tak,
  e kad vrchol na om m pouit vetky hrany. Vr prv
  a posledn hranu a tie i sme pridali aspo jednu pridan hranu. }
var akt, hrana, dalsia_hrana, nova_prva, nova_posledna : integer;
   nova_bola : boolean;
begin
   bola_pridana := false;
   { njdi cyklus zanajci vo vrchole "vrchol" }
   akt := vrchol;   { aktulny vrchol }
   hrana := nepouzita_hrana(akt);
   prva_hrana := hrana;
   while hrana<>0 do begin        { km vieme cyklus predi, predme }
      posledna_hrana := hrana;
      hrany[hrana].pouzita := true;
      akt := druhy_koniec(hrana, akt);
      hrana := nepouzita_hrana(akt);
      hrany[posledna_hrana].dalsia := hrana;
      zorientuj_hranu(posledna_hrana,akt);
   end;
   
   { prejdi cyklus znova a dopl alie cykly, kde chbaj }
   hrana := prva_hrana;
   akt := vrchol;
   while hrana<>0 do begin
      if hrany[hrana].pridana then bola_pridana := true;
      dalsia_hrana := hrany[hrana].dalsia;
      if nepouzita_hrana(akt)<>0 then begin { ete je o prida }
	 vytvor_tah(akt, nova_prva, nova_posledna, nova_bola);
	 if nova_bola then bola_pridana := true;
	 hrany[hrana].dalsia := nova_prva;
	 hrany[nova_posledna].dalsia := dalsia_hrana;
      end;
      akt := druhy_koniec(hrana, akt);
      hrana := dalsia_hrana;
   end;

   { zacyklme njden cyklus }
   hrany[posledna_hrana].dalsia := prva_hrana;
end;

procedure pridaj_hrany;
var i, posledny	: integer;
begin { pridaj hrany medyi vrcholmi neprneho stupa }
   pocet_zac := 0;
   posledny := 0; { slo poslednho neprneho nesprovanho vrcholu }
   for i := 1 to n do begin
      if stupen[i] mod 2 = 1 then begin
	 if posledny = 0 then posledny := i
	 else begin
	    inc(m);
	    pridaj_hranu(m, posledny, i, true);
	    inc(pocet_zac);
	    zaciatky[pocet_zac]:=m;
	    posledny := 0;
	 end; {else}
      end; {if stupen}
   end; {for i}
end;

procedure vypis_tah(zmazana_hrana : integer);
var hrana : integer;
begin { vyp tah pokraujci za hranou "zmazana_hrana" }
   hrana := hrany[zmazana_hrana].dalsia;  { prv hrana, ktor vypeme }
   while (hrana<>zmazana_hrana) and (not hrany[hrana].pridana) do begin
      write(hrany[hrana].zac,' ');
      hrana := hrany[hrana].dalsia;
   end;
   write(hrany[hrana].zac); { vyp druh koniec posledne vypsanej hrany }
   if not hrany[hrana].pridana then { ak sme v komponente bez pridanej hrany }
      writeln(' ',hrany[hrana].kon) { vypeme ete jeden vrchol }
   else
      writeln;
end;

var i, prva_hrana, posledna_hrana : integer;
    bola_pridana :  boolean;
begin { Hlavn program } 
   nacitaj;   { vstup a inicializcia }
   pridaj_hrany;   { pridanie hrn, aby stupe boli prne }
   for i := 1 to n do nepouzite[i] := susedia[i]; { inicializuj "nepouzite" }
   { pre kad vrchol, ktor m neprejden hrany prejdi komponent }	  
   for i := 1 to n do begin
      if nepouzita_hrana(i)<>0 then begin 
	 vytvor_tah(i, prva_hrana, posledna_hrana, bola_pridana);
	 if not bola_pridana then begin { prny komponent pridaj do zaiatkov }
	    inc(pocet_zac);
	    zaciatky[pocet_zac] := prva_hrana;
	 end;
      end;
   end;
   { vpis vsledku }
   writeln(pocet_zac);
   for i := 1 to pocet_zac do begin
      vypis_tah(zaciatky[i]);
   end;
end.