program Hviezdy;
const MAXN = 100;
type Hviezda = record x, y, z : Integer; end;
     PoleHviezd = Array[1..MAXN] of Hviezda;
var N : Integer;		{Pocet hviezd}
    H : PoleHviezd;		{Jednotlive hviezdy}
    Stred : Hviezda;		{Spocitany stred symetrie}

{Nacita vstup}
procedure Nacitaj;
var i : Integer;
begin
  Write('Pocet hviezd: '); ReadLn(N);
  for i := 1 to N do begin Write('Hviezda: '); ReadLn(H[i].x, H[i].y, H[i].z); end;
end;

{Najde stred symetrie}
procedure NajdiStred(var Stred : Hviezda);
var i, xs, ys, zs : Integer;
begin
  xs := 0; ys := 0; zs := 0;
  for i := 1 to N do begin
    xs := xs + H[i].x; ys := ys + H[i].y; zs := zs + H[i].z;
  end;
  Stred.x := xs div N; Stred.y := ys div N; Stred.z := zs div N;
end;

{Porovna suradnice dvoch hviezd}
function PorovnajHviezdy(A, B : Hviezda) : Integer;
begin
  if A.x <> B.x then begin PorovnajHviezdy := A.x - B.x; Exit; end;
  if A.y <> B.y then begin PorovnajHviezdy := A.y - B.y; Exit; end;
  if A.z <> B.z then begin PorovnajHviezdy := A.z - B.z; Exit; end;
  PorovnajHviezdy := 0;
end;

{Prehodi dva prvky haldy}
procedure Prehod(var Halda : PoleHviezd; A,B : Integer);
var Tmp : Hviezda;
begin Tmp := Halda[A]; Halda[A] := Halda[B]; Halda[B] := Tmp; end;

{Vlozi prvok H do haldy}
procedure Vloz(var HT : Integer; var Halda : PoleHviezd; H : Hviezda);
var S : Integer;
begin
  Inc(HT); Halda[HT] := H; S := HT;
  while (S > 1) and (PorovnajHviezdy(Halda[S], Halda[S div 2]) < 0) do begin
    Prehod(Halda, S, S div 2); S := S div 2;
  end;
end;

{Vybere prvu hviezdu z haldy}
function Vyber(var HT : Integer; var Halda : PoleHviezd) : Hviezda;
var S, T : Integer;
begin
  Vyber := Halda[1]; Halda[1] := Halda[HT]; Dec(HT); S := 1;
  while 2*S <= HT do begin
    T := 0;
    if PorovnajHviezdy(Halda[S], Halda[2*S]) > 0 then T := 2*S;
    if (2*S+1 <= HT) and (PorovnajHviezdy(Halda[S], Halda[2*S+1]) > 0) then
      if PorovnajHviezdy(Halda[2*S], Halda[2*S+1]) > 0 then
        T := 2*S+1;
    if T > 0 then begin Prehod(Halda, S, T); S := T; end else S := HT;
  end;
end;

{Zotriedi hviezdy podla suradnic}
procedure Zotried;
var Halda : PoleHviezd;	{Halda na triedenie}
    HT : Integer;	{Pocet prvkov v halde}
    i : Integer;
begin
  HT := 0;
  for i := 1 to N do Vloz(HT, Halda, H[i]);
  for i := 1 to N do H[i] := Vyber(HT, Halda);
end;

{Overi, ci su hviezdy symetricke podle daneho stredu}
function Over(Stred : Hviezda) : Boolean;
var i : Integer;
begin
  Zotried;	{Zotriedi hviezdy podla suradnic}
  for i := 1 to (N+1) div 2 do
    if (Stred.x - H[i].x <> H[N-i+1].x - Stred.x) or
       (Stred.y - H[i].y <> H[N-i+1].y - Stred.y) or
       (Stred.z - H[i].z <> H[N-i+1].z - Stred.z) then begin
         Over := False; Exit;
       end;
  Over := True; 
end;

begin
  Nacitaj;
  NajdiStred(Stred);
  if Over(Stred) then
    WriteLn('Stred symetrie lezi na pozicii ',
      Stred.x, ', ', Stred.y, ', ', Stred.z, '.')
  else
    WriteLn('Hviezdy nie su symetricke podla ziadneho stredu.');
end.

