#include <stdio.h>
#include <stdlib.h>

#define MAXV 30000	/* Maximlny poet vrcholov */
#define MAXR 30000	/* Maximlny poet tetv */

/* truktra pre jednu tetivu */
struct tetiva {
  int a, b;
};

int tetiv, vrcholov;	/* Poet tetv a vrcholov */
struct tetiva t[MAXR];	/* Jednotliv tetivy */
int vpoc[MAXV];		/* Poty tetv v jednotlivch vrcholoch */

/* Nata vstup */
void nacitaj(void)
{
  int pom, i;
  FILE *vstup;

  if (!(vstup = fopen("poklad.in", "r")))
    exit(1);
  fscanf(vstup, "%d %d", &vrcholov, &tetiv);
  for (i = 0; i < tetiv; i++) {
    fscanf(vstup, "%d %d", &t[i].a, &t[i].b);
    t[i].a--; t[i].b--;
    if (t[i].a > t[i].b) {
      pom = t[i].a;
      t[i].a = t[i].b;
      t[i].b = pom;
    }
  }
  fclose(vstup);
  /* Pridme ete fiktvnu tetivu medzi vrcholmi 1, N */
  t[tetiv].a = 0;
  t[tetiv].b = vrcholov-1;
  tetiv++;
}

/* Zotriedi tetivy */
void zotried(void)
{
  struct tetiva t1[MAXR];	/* Jednotliv tetivy */
  int vrchind[MAXV];	/* Index, kde zanaj tetivy z vrcholu */
  int vrchpoc[MAXV];	/* Poet tetiv z vrcholu */
  int i;

  /* Prv prechod triedenia */
  for (i = 0; i < vrcholov; i++)
    vrchpoc[i] = 0;
  /* Spotame poty tetv pre jednotliv vrcholy */
  for (i = 0; i < tetiv; i++)
    vrchpoc[t[i].b]++;
  vrchind[0] = 0;
  for (i = 1; i < vrcholov; i++)
    vrchind[i] = vrchind[i-1] + vrchpoc[i-1];
  /* Preusporiadame tetivy poda koncovho vrcholu */
  for (i = 0; i < tetiv; i++)
    t1[vrchind[t[i].b]++] = t[i];

  /* Druh prechod triedenia */
  for (i = 0; i < vrcholov; i++)
    vrchpoc[i] = 0;
  for (i = 0; i < tetiv; i++)
    vrchpoc[t1[i].a]++;
  vrchind[0] = 0;
  for (i = 1; i < vrcholov; i++)
    vrchind[i] = vrchind[i-1] + vrchpoc[i-1];
  /* Preusporiadame hrany poda zaiatonho vrcholu 
   * (berieme ich zostupne poda koncovho vrcholu) */
  for (i = tetiv; i >= 0; i--)
    t[vrchind[t1[i].a]++] = t1[i];
}

/* Spota koko kusov mapy sa d rozda */
int spocitaj(void)
{
  int casti = 0;	/* Poet ast */
  int zasvrch = 0;	/* Vrchol zsobnka */
  int zas[MAXR];	/* Zsobnk na spracovvan tetivy */
  int vybrat[MAXR];	/* Znaka, e prsl. as meme vybra */
  int actvrch = 0, acttetiva = 0; /* Aktulny vrchol a tetiva */

  while (actvrch < vrcholov) {
    while (zasvrch && t[zas[zasvrch-1]].b == actvrch) {
      if (vybrat[zasvrch-1]) {	
        casti++;
        vybrat[zasvrch-2] = 0;
      }
      zasvrch--;
    }
    while (acttetiva < tetiv && t[acttetiva].a == actvrch) {
      zas[zasvrch] = acttetiva++;
      vybrat[zasvrch++] = 1;
    }
    actvrch++;
  }
  return casti;
}

int main(void)
{
  FILE *vystup;

  nacitaj();
  zotried();

  if (!(vystup = fopen("poklad.out", "w")))
    exit(1);
  fprintf(vystup, "%d\n", spocitaj());
  fclose(vystup);
  return 0;
}

