#include <stdio.h>
#include <stdlib.h>
#include "vahy_lib.h"

struct tUzol { 
  int prvok;
  struct tUzol *lavy, *pravy;
};

struct tZoznam {
  struct tUzol *strom;
  struct tZoznam *dalsi;
};

struct tZoznam *vytvor(int prvy, int posledny) {
  struct tZoznam *vysledok, *zoznam1, *zoznam2, **chvost, *pomocna;
  if (prvy==posledny) {
    vysledok=malloc(sizeof(struct tZoznam));
    vysledok->dalsi=NULL;
    vysledok->strom=malloc(sizeof(struct tUzol));
    vysledok->strom->prvok=prvy;
    vysledok->strom->lavy=vysledok->strom->pravy=NULL;
    return vysledok;
  }
  zoznam1=vytvor(prvy,(prvy+posledny)/2);
  zoznam2=vytvor((prvy+posledny)/2+1,posledny);
  chvost=&vysledok;
  while (zoznam1&&zoznam2) {
    switch (porovnaj(zoznam1->strom->prvok,zoznam2->strom->prvok)) {
    case 0:
      (*chvost)=malloc(sizeof(struct tZoznam));
      (*chvost)->strom=malloc(sizeof(struct tUzol));
      (*chvost)->strom->prvok=zoznam1->strom->prvok;
      (*chvost)->strom->lavy=zoznam1->strom;
      (*chvost)->strom->pravy=zoznam2->strom;
      pomocna=zoznam1; zoznam1=zoznam1->dalsi; free(pomocna);
      pomocna=zoznam2; zoznam2=zoznam2->dalsi; free(pomocna);
      break;
    case 1:
      *chvost=zoznam1; zoznam1=zoznam1->dalsi;
      break;
    case -1:
      *chvost=zoznam2; zoznam2=zoznam2->dalsi;
      break;
    }
    chvost=&((*chvost)->dalsi);
  }
  *chvost=zoznam1?zoznam1:(zoznam2?zoznam2:NULL);
  return vysledok;
}

void vypis_strom(FILE *subor, struct tUzol *uzol) {
  if (uzol->lavy) {
    vypis_strom(subor,uzol->lavy);
    vypis_strom(subor,uzol->pravy);
  }
  else
    fprintf(subor,"%d ",uzol->prvok);
}  

void vypis_zoznam(FILE *subor, struct tZoznam *zoznam) {
  while (zoznam) {
    vypis_strom(subor, zoznam->strom);
    fprintf(subor,"\n");
    zoznam=zoznam->dalsi;
  }
}

int main() {
  FILE *subor;
  int N;
  struct tZoznam *zoznam;

  subor=fopen("vahy.in","rt");
  fscanf(subor,"%d",&N);
  fclose(subor);
  zoznam=vytvor(1,N);
  subor=fopen("vahy.out","wt");
  vypis_zoznam(subor,zoznam);
  fclose(subor);
  return 0;
}

