{ Mugurel Ionut Andreica - Bucuresti, ROMANIA }

{$S-,I-,R-,Q-,N+}
{$M 15000,0,655360}
Program FIGURI_GEOMETRICE;

const filein='figuri.in';
      fileout='figuri.out';
      MAXN=255;

type matrix=array[1..MAXN,1..MAXN] of byte;
     pmatrix=^matrix;
     cardx=(N,E,S,W);
     cardy=(NE,SE,SW,NW);

var fin,fout:text;
    dir:array[cardx] of pmatrix;
    tri:array[cardy] of pmatrix;
    i,j,k,m,p,dim,q,lp,np,lr,nr,p1,q1,p2,q2:longint;
    sq:pmatrix;
    a:cardx;
    b:cardy;

function min(a,b:byte):byte;
begin
if (a<b) then min:=a
else min:=b;
end;

procedure ReadInput;
var ch:char;
begin
assign(fin,filein);
reset(fin);
readln(fin,dim);

new(sq);
fillchar(sq^,sizeof(matrix),0);

for i:=1 to dim do
  begin
    for j:=1 to dim do
      begin
        read(fin,ch);
        sq^[i,j]:=ord(ch)-ord('0');
      end;
    readln(fin);
  end;
close(fin);
end;

procedure ComputeDirs;
begin
for a:=N to W do
  begin
    new(dir[a]);
    fillchar(dir[a]^,sizeof(matrix),0);
  end;

{ North }
for j:=1 to dim do
  dir[N]^[1,j]:=sq^[1,j];

for i:=2 to dim do
  for j:=1 to dim do
    if (sq^[i,j]=1) then
      dir[N]^[i,j]:=1+dir[N]^[i-1,j];

{ East }
for i:=1 to dim do
  dir[E]^[i,dim]:=sq^[i,dim];

for j:=dim-1 downto 1 do
  for i:=1 to dim do
    if (sq^[i,j]=1) then
      dir[E]^[i,j]:=1+dir[E]^[i,j+1];

{ South }
for j:=1 to dim do
  dir[S]^[dim,j]:=sq^[dim,j];

for i:=dim-1 downto 1 do
  for j:=1 to dim do
    if (sq^[i,j]=1) then
      dir[S]^[i,j]:=1+dir[S]^[i+1,j];

{ West }
for i:=1 to dim do
  dir[W]^[i,1]:=sq^[i,1];

for j:=2 to dim do
  for i:=1 to dim do
    if (sq^[i,j]=1) then
      dir[W]^[i,j]:=1+dir[W]^[i,j-1];
end;

procedure FindLargestSquare;
begin
lp:=0; np:=0;

for i:=1 to dim do
  begin
    if (sq^[1,i]=1) then
      begin
        lp:=1; inc(np);
      end;

    if (sq^[i,1]=1) then
      begin
        lp:=1; inc(np);
      end;
  end;

for i:=2 to dim do
  for j:=2 to dim do
    if (sq^[i,j]=1) then
      begin
        k:=min(dir[W]^[i,j],min(dir[N]^[i,j],1+sq^[i-1,j-1]));
        sq^[i,j]:=k;

        if (k>lp) then
          begin
            lp:=k; np:=1;
          end
        else
        if (k=lp) then
          inc(np);
      end;
dispose(sq);
end;

procedure ComputeTris;
begin
for b:=NE to NW do
  begin
    new(tri[b]);
    fillchar(tri[b]^,sizeof(matrix),0);
  end;

{ North-East }
for i:=1 to dim do
  begin
    if (dir[N]^[1,i]=1) then
      tri[NE]^[1,i]:=1;
    if (dir[E]^[i,dim]=1) then
      tri[NE]^[i,dim]:=1;
  end;

for i:=2 to dim do
  for j:=1 to dim-1 do
    if (dir[N]^[i,j]>0) then
      begin
        k:=min(dir[N]^[i,j],min(dir[E]^[i,j],2+tri[NE]^[i-1,j+1]));
        tri[NE]^[i,j]:=k;
      end;

{ North-West }
for i:=1 to dim do
  begin
    if (dir[N]^[1,i]=1) then
      tri[NW]^[1,i]:=1;
    if (dir[W]^[i,1]=1) then
      tri[NE]^[i,1]:=1;
  end;

for i:=2 to dim do
  for j:=2 to dim do
    if (dir[N]^[i,j]>0) then
      begin
        k:=min(dir[N]^[i,j],min(dir[W]^[i,j],2+tri[NW]^[i-1,j-1]));
        tri[NW]^[i,j]:=k;
      end;

{ South-East }
for i:=1 to dim do
  begin
    if (dir[S]^[dim,i]=1) then
      tri[SE]^[dim,i]:=1;
    if (dir[E]^[i,dim]=1) then
      tri[SE]^[i,dim]:=1;
  end;

for i:=dim-1 downto 1 do
  for j:=1 to dim-1 do
    if (dir[N]^[i,j]>0) then
      begin
        k:=min(dir[S]^[i,j],min(dir[E]^[i,j],2+tri[SE]^[i+1,j+1]));
        tri[SE]^[i,j]:=k;
      end;

{ Souh-West }
for i:=1 to dim do
  begin
    if (dir[S]^[dim,i]=1) then
      tri[SW]^[dim,i]:=1;
    if (dir[W]^[i,1]=1) then
      tri[SW]^[i,1]:=1;
  end;

for i:=dim-1 downto 1 do
  for j:=2 to dim do
    if (dir[N]^[i,j]>0) then
      begin
        k:=min(dir[S]^[i,j],min(dir[W]^[i,j],2+tri[SW]^[i+1,j-1]));
        tri[SW]^[i,j]:=k;
      end;
end;

procedure FindLargestDiamond;
begin
lr:=0; nr:=0;
for i:=1 to dim do
  for j:=1 to dim do
    if (dir[N]^[i,j]>0) then
      begin
        if (i>1) and (j>1) then
          p1:=tri[NW]^[i-1,j-1]
        else
          p1:=0;

        if (i>1) and (j<dim) then
          q1:=tri[NE]^[i-1,j+1]
        else
          q1:=0;

        if (i<dim) and (j>1) then
          p2:=tri[SW]^[i+1,j-1]
        else
          p2:=0;

        if (i<dim) and (j<dim) then
          q2:=tri[SE]^[i+1,j+1]
        else
          q2:=0;

        k:=min(min(
                  min(dir[W]^[i,j],dir[E]^[i,j]),
                  min(dir[N]^[i,j],dir[S]^[i,j])
                  ),
               min(
                  2+min(p1,q1),
                  2+min(p2,q2)
                  )
               );

        if (k=lr) then
          inc(nr)
        else
        if (k>lr) then
          begin
            lr:=k; nr:=1;
          end;
      end;
end;

procedure WriteOutput;
begin
assign(fout,fileout);
rewrite(fout);
writeln(fout,lp,' ',np);
writeln(fout,lr,' ',nr);
close(fout);
end;

begin
ReadInput;
ComputeDirs;
FindLargestSquare;
ComputeTris;
FindLargestDiamond;
WriteOutput;
end.