/* Mugurel Ionut Andreica - Bucuresti, ROMANIA */

#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <math.h>
#define maxn 25
#define maxparts 101
#define eps 1e-8

double x[maxparts][maxn], y[maxparts][maxn];
double xa, ya, xb, yb, a1, b1, c1, a2, b2, c2, xi, yi, xint[5], yint[5];
int np[maxparts],prev[5], i, j, k, m, n, p, q, nparts, newnparts, nint, missed, res;

void readdata(void)
{
	scanf("%d %d", &n, &m);

	nparts = 1;
	np[1] = n;

	for (i = 1; i <= n; i++)
		scanf("%lf %lf", &x[1][i], &y[1][i]);
}

int semn(double a, double b, double c, double xa, double ya)
{
	double r = a * xa + b * ya + c;

	if (fabs(r) < eps)
		return 0;
	else if (r>0)
		return 1;
	else
		return -1;
}

int intre(double a, double b, double c)
{
	if (fabs(a - c) < eps)
		return 1;
	else
	if (fabs(b - c) < eps)
		return 1;
	else
	if (a < c && c < b)
		return 1;
	else
	if (b < c && c < a)
		return 1;
	else
		return 0;
}

int intersect(double a1, double b1, double c1, double a2, double b2, double c2,
	       double& xi, double& yi)
{
	double num;

	num = (a2 * b1 - a1 * b2);
	if (fabs(num) > eps)
	{
		xi = (b2 * c1 - b1 * c2) / num;
		yi = (c2 * a1 - c1 * a2) / num;
		return 1;
	}
	else
		return 0;
}

void compute(void)
{
	//int maxv;

	for (k = 1; k <= m; k++)
	{
		scanf("%lf %lf %lf %lf", &xa, &ya, &xb, &yb);

		a1 = ya - yb;
		b1 = xb - xa;
		c1 = xa * yb - xb * ya;

		for (newnparts = nparts, p=1; p <= nparts; p++)
		{
			nint=missed=0;

			for (i = 1; i < np[p]; i++)
			{
				if (semn(a1, b1, c1, x[p][i], y[p][i]) == 0 &&
					semn(a1, b1, c1, x[p][i+1], y[p][i+1]) == 0)
				{
					missed=1;
					break;
				}

				a2 = y[p][i] - y[p][i+1];
				b2 = x[p][i+1] - x[p][i];
				c2 = x[p][i] * y[p][i+1] - x[p][i+1] * y[p][i];

				res = intersect(a1, b1, c1, a2, b2, c2, xi, yi);
				
				if (res)
				{
					if (intre(x[p][i], x[p][i+1], xi) &&
						intre(y[p][i], y[p][i+1], yi))
					{
						if (nint==0 || fabs(xi - xint[nint]) > eps || fabs(yi - yint[nint]) > eps)
						{
							nint++;
							xint[nint] = xi;
							yint[nint] = yi;
							prev[nint]=i;
						}
					}
				}
			}

			if (semn(a1, b1, c1, x[p][np[p]], y[p][np[p]]) == 0 &&
				semn(a1, b1, c1, x[p][1], y[p][1]) == 0)
				missed=1;

			if (!missed)
			{
				/* process the last edge */
				a2 = y[p][1] - y[p][np[p]];
				b2 = x[p][np[p]] - x[p][1];
				c2 = x[p][1] * y[p][np[p]] - x[p][np[p]] * y[p][1];

				res = intersect(a1, b1, c1, a2, b2, c2, xi, yi);
	
				if (res)
				{
					if (intre(x[p][1], x[p][np[p]], xi) &&
						intre(y[p][1], y[p][np[p]], yi))
					{
						if (nint == 0 || fabs(xi - xint[nint]) > eps || fabs(yi - yint[nint]) > eps ||
										 fabs(xi - xint[1]) > eps || fabs(yi - yint[1]) > eps)
						{
							nint++;
							xint[nint] = xi;
							yint[nint] = yi;
							prev[nint] = np[p];
						}
					}
				}

				/* try to split the poly */
				if (nint>=2)
				{
					/* create the first new polygon */
					newnparts++;
					np[newnparts] = 0;

					for (i = 1; i <= prev[1]; i++)
						if ((fabs(x[p][i] - xint[1]) > eps ||
							 fabs(y[p][i] - yint[1]) > eps))
						{
							np[newnparts]++;
							x[newnparts][np[newnparts]] = x[p][i];
							y[newnparts][np[newnparts]] = y[p][i];
						}

					np[newnparts]++;
					x[newnparts][np[newnparts]] = xint[1];
					y[newnparts][np[newnparts]] = yint[1];

					np[newnparts]++;
					x[newnparts][np[newnparts]] = xint[2];
					y[newnparts][np[newnparts]] = yint[2];

					for (i = prev[2] + 1; i <= np[p]; i++)
						if ((fabs(x[p][i] - xint[2]) > eps ||
							 fabs(y[p][i] - yint[2]) > eps) &&
							(fabs(x[p][i]-xint[1])>eps ||
							 fabs(y[p][i]-yint[1])>eps))
						{
							np[newnparts]++;
							x[newnparts][np[newnparts]] = x[p][i];
							y[newnparts][np[newnparts]] = y[p][i];
						}

					/* create the second new polygon */
					newnparts++;
					np[newnparts] = 1;
					x[newnparts][1] = xint[1];
					y[newnparts][1] = yint[1];

					for (i = prev[1] + 1; i <= prev[2]; i++)
						if ((fabs(x[p][i] - xint[2]) > eps ||
							 fabs(y[p][i] - yint[2]) > eps) &&
							(fabs(x[p][i] - xint[1]) > eps ||
							 fabs(y[p][i] - yint[1]) > eps))
						{
							np[newnparts]++;
							x[newnparts][np[newnparts]] = x[p][i];
							y[newnparts][np[newnparts]] = y[p][i];
						}

					np[newnparts]++;
					x[newnparts][np[newnparts]] = xint[2];
					y[newnparts][np[newnparts]] = yint[2];

					/* update */
					for (i = 1; i <= np[newnparts]; i++)
					{
						x[p][i]=x[newnparts][i];
						y[p][i]=y[newnparts][i];
					}

					np[p]=np[newnparts];
					newnparts--;
				}
			}
		}

		nparts = newnparts;
		//fprintf(stderr, "%d: %d\n", k, nparts);

		/*
		maxv = 0;
		for (p = 1; p <= nparts; p++)
			if (np[p] > maxv)
				maxv = np[p];

		fprintf(stderr, "%d: %d\n", k, maxv);
		*/
	}
}

void writedata(void)
{
	printf("Number of regions=%d.\n", nparts);
}

int main()
{
	int te, T;

	//freopen("a.in", "r", stdin);

	scanf("%d", &T);

	for (te = 1; te <= T; te++)
	{
		readdata();
		compute();
		writedata();
	}

	return 0;
}
