#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <vector>
using namespace std;

#define BIGINT __int64 //long long
#define fmt "%I64d" //"%lld"
#define LSUP 10000000000000
#define INF 1111111111
#define NMAX 100100

int w[NMAX], dmax[NMAX], dsup[NMAX], dist[NMAX], q[NMAX], t[NMAX], lt[NMAX];
char viz[NMAX];
vector<pair<int, int> > v[NMAX];
int i, j, l, k, n, N, K, le, ri, cnt, cntok;
BIGINT li, ls, mid, x, cok;

void compute(int n)
{
	int i, x;	

	dsup[n] = dmax[n];
	dist[n] = INF;

	viz[n] = 1;

	for (i = 0; i < v[n].size(); i++)
	{
		x = v[n][i].first;

		if (x != t[n])
		{
			if (dsup[x] - v[n][i].second < dsup[n])
				dsup[n] = dsup[x] - v[n][i].second;

			if (dist[x] + v[n][i].second < dist[n])
				dist[n] = dist[x] + v[n][i].second;
		}
	}

	if (dsup[n] >= dist[n])
		dsup[n] = INF;
	else
	if (t[n] == 0)
	{
		cnt++;
		dsup[n] = INF;
		dist[n] = 0;
	}
	else
	if (dsup[n] < lt[n])
	{
		cnt++;
		dsup[n] = INF;
		dist[n] = 0;
	}
}

int main()
{
	int te, T;

	freopen("b.in", "r", stdin);
	freopen("b.ok", "w", stdout);

	scanf("%d", &T);
	//T = 15;

	for (te = 1; te <= T; te++)
	{
		scanf("%d %d", &N, &K);

		//fprintf(stderr, "### N=%d, K=%d\n", N, K);

		// read the demands

		for (i = 1; i <= N; i++)
		{
			scanf("%d", &w[i]);
			v[i].clear();
		}

		// read the edges

		for (k = 1; k < N; k++)
		{
			scanf("%d %d %d", &i, &j, &l);
			v[i].push_back(make_pair(j, l));
			v[j].push_back(make_pair(i, l));
		}

		// BF on the tree, starting from node 1

		memset(viz, 0, sizeof(viz));

		q[le = ri = 1] = 1;
		viz[1] = 1;
		t[1] = lt[1] = 0;

		while (le <= ri)
		{
			n = q[le];

			for (i = 0; i < v[n].size(); i++)
			{
				j = v[n][i].first;

				if (!viz[j])
				{
					ri++;
					q[ri] = j;
					viz[j] = 1;
					t[j] = n;
					lt[j] = v[n][i].second;
				}
			}

			le++;
		}

		//fprintf(stderr, "%d %d -%d\n", N, K, ri);

		// binary search

		li = 0; ls = cok = LSUP;
		cntok = 0;

		while (li <= ls)
		{
			mid = (li + ls) / 2;

			for (i = 1; i <= N; i++)
			{
				x = mid / w[i];

				if (x > INF)
					dmax[i] = INF;
				else
					dmax[i] = (int) x;
			}

			cnt = 0;

			for (j = N; j >= 1; j--)
				compute(q[j]);

			if (cnt <= K)
				ls = mid - 1,
				cok = mid,
				cntok = cnt;
			else
				li = mid + 1;
		}

		printf(fmt, cok);
		printf("\n");

		//fprintf(stderr, fmt, cok);
		//fprintf(stderr, " [%d/%d]\n", cntok, K);
	}

	return 0;
}