#include <stdio.h>
#include <string.h>
#include <stdlib.h>

#include <vector>
#include <algorithm>
#include <set>
using namespace std;

#define BIGINT __int64 // long long
#define fmt "%I64d" // "%lld"
#define LSUP 10000000000000
#define INF 1111111111
#define NMAX 100100
#define MAXNOINC 100

int w[NMAX], d[NMAX], viz[NMAX], sel[NMAX], ss[NMAX], dm[NMAX][2], dmx[NMAX], f[NMAX][2];
vector<pair<int, int> > v[NMAX], vw;
set<pair<int, int> > heap;
pair<int, int> p;
int i, j, l, k, r, N, K, nviz, cnt, cntok, lastinc;
BIGINT li, ls, mid, a, b, cmax, cok;

void df1(int n, int t)
{
	int i, x;

	viz[n] = 1;

	dm[n][0] = dm[n][1] = 0;
	f[n][0] = f[n][1] = 0;

	for (i = 0; i < v[n].size(); i++)
	{
		x = v[n][i].first;

		if (!viz[x])
		{
			df1(x, n);

			if (dm[x][0] + v[n][i].second > dm[n][0])
			{
				dm[n][1] = dm[n][0];
				f[n][1] = f[n][0];

				dm[n][0] = dm[x][0] + v[n][i].second;
				f[n][0] = x;
			}
			else
			if (dm[x][0] + v[n][i].second > dm[n][1])
			{
				dm[n][1] = dm[x][0] + v[n][i].second;
				f[n][1] = x;
			}
		}
	}
}

void df2(int n, int t)
{
	int i, x;

	viz[n] = 1;

	dmx[n] = dm[n][0] + dm[n][1];

	for (i = 0; i < v[n].size(); i++)
	{
		x = v[n][i].first;

		if (!viz[x])
			df2(x, n);
		else
		if (x == t)
		{
			if (f[t][0] != n)
			{
				if (dm[n][0] + v[n][i].second + dm[t][0] > dmx[n])
					dmx[n] = dm[n][0] + v[n][i].second + dm[t][0];
			}
			else
			{
				if (dm[n][0] + v[n][i].second + dm[t][1] > dmx[n])
					dmx[n] = dm[n][0] + v[n][i].second + dm[t][1];
			}
		}
	}
}

void df(int n, int t)
{
	int i, x;

	viz[n] = r;
	//nviz++;

	a = d[n];
	b = w[n];

	a *= b;

	if (a > cmax)
	{
		cmax = a;

		if (cmax >= cok)
			return;
	}

	for (i = 0; i < v[n].size() && cmax < cok; i++)
	{
		x = v[n][i].first;

		if (viz[x] != r)
		{
			d[x] = d[n] + v[n][i].second;
			df(x, n);
		}
	}
}

void bkt(int niv, int last)
{
	int i;

	if (niv > K)
	{
		heap.clear();

		r++;

		for (i = 1; i <= K; i++)
		{
			d[ss[i]] = 0;
			viz[ss[i]] = r;
			heap.insert(make_pair(0, ss[i]));
		}

		cmax = 0;

		while (heap.size() > 0)
		{
			p = *(heap.begin());
			i = p.second;

			heap.erase(p);

			a = d[i];
			b = w[i];

			a *= b;

			if (a > cmax)
			{
				cmax = a;

				if (cmax >= cok)
					break;
			}

			for (j = 0; j < v[i].size(); j++)
			{
				k = v[i][j].first;
				l = v[i][j].second;

				if (viz[k] != r || d[k] > d[i] + l)
				{
					viz[k] = r;
					d[k] = d[i] + l;

					p.first = d[k];
					p.second = k;
					heap.erase(p);

					heap.insert(make_pair(d[k], k));
				}
			}
		}

		if (cmax < cok)
		{
			/*
			if (K == 2)
			{
				fprintf(stderr, "trying: ");

				for (i = 1; i <= K; i++)
					fprintf(stderr, "%d(%d) ", ss[i], dmx[ss[i]]);

				fprintf(stderr, "\n");
			}
			*/

			cok = cmax;
			lastinc = r;

			fprintf(stderr, "-> %I64d\n", cok);
		}
	}
	else
	{
		for (i = N - 1 - (K - niv); i > last && r - lastinc < MAXNOINC; i--)
		{
			sel[vw[i].second] = 1;
			ss[niv] = vw[i].second; 
			bkt(niv + 1, i);
			sel[vw[i].second] = 0;
		}
	}
}

int main()
{
	int te, T;

	freopen("b.in", "r", stdin);

	scanf("%d", &T);
	//T = 15;

	for (te = 1; te <= T; te++)
	{
		scanf("%d %d", &N, &K);

		fprintf(stderr, "### N=%d, K=%d\n", N, K);

		// read the demands

		vw.clear();

		for (i = 1; i <= N; i++)
		{
			scanf("%d", &w[i]);
			v[i].clear();

			//vw.push_back(make_pair(w[i], i));
		}

		// read the edges

		for (k = 1; k < N; k++)
		{
			scanf("%d %d %d", &i, &j, &l);
			v[i].push_back(make_pair(j, l));
			v[j].push_back(make_pair(i, l));
		}

		// compute centers

		memset(viz, 0, sizeof(viz));
		df1(1, 0);

		memset(viz, 0, sizeof(viz));
		df2(1, 0);

		for (i = 1; i <= N; i++)
			vw.push_back(make_pair(-dmx[i], i));

		sort(vw.begin(), vw.end());

		/*
		for (i = N - 1; i >= 0; i--)
			printf("%d -> %d\n", vw[i].second, dmx[vw[i].second]);

		continue;
		*/

		cok = LSUP;

		if (0 && K < 1)
		{
			memset(viz, 0, sizeof(viz));

			for (r = N - 1; r >= 0; r--)
			{
				d[vw[r].second] = 0;
				//nviz = 0;
				cmax = 0;
				df(vw[r].second, 0);

				if (cmax < cok)
				{
					cok = cmax;
					fprintf(stderr, "-> %I64d\n", cok);
				}

				//break;
			}

			//fprintf(stderr, "%d\n", nviz);
		}
		else //if (K == 0)
		{
			memset(sel, 0, sizeof(sel));
			memset(viz, 0, sizeof(viz));

			r = 0;

			lastinc = 0;

			if (K <= 3 || N - K <= 3)
				bkt(1, -1);

			//cok = -1;
		}

		printf(fmt, cok);
		printf("\n");

		//fprintf(stderr, fmt, cok);
		//fprintf(stderr, " [%d/%d]\n", cntok, K);
	}

	return 0;
}