// O(log CMAX * N^2)

#include <stdio.h>
#include <string.h>

#include <vector>
#include <set>

using namespace std;

#define NMAX 10010
#define INF 1666666666

vector<pair<int, pair<int, int> > > edge[NMAX];
vector<pair<int, int> > e[NMAX];
int dmin[NMAX], sel[NMAX];
int i, j, k, N, M, T, c, t, cmin, cmax, cmid, cok;

int main()
{
	int te, nt;

	freopen("d.in", "r", stdin);

	scanf("%d", &nt);

	for (te = 1; te <= nt; te++)
	{
		scanf("%d %d %d", &N, &M, &T);
		//fprintf(stderr, "%d %d %d\n", N, M, T);

		for (i = 1; i <= N; i++)
			edge[i].clear();

		cmin = INF;
		cmax = 0;

		for (k = 0; k < M; k++)
		{
			scanf("%d %d %d %d", &i, &j, &c, &t);
			edge[i].push_back(make_pair(j, make_pair(c, t)));
			edge[j].push_back(make_pair(i, make_pair(c, t)));

			if (c > cmax)
				cmax = c;
			if (c < cmin)
				cmin = c;
		}

		// binary search for the maximum capacity

		cok = 0;

		//fprintf(stderr, "### te=%d: %d - %d\n", te, cmin, cmax);

		while (cmin <= cmax)
		{
			cmid = cmin + ((cmax - cmin) >> 1);

			// build the new graph

			for (i = 1; i <= N; i++)
			{
				e[i].clear();

				for (j = 0; j < edge[i].size(); j++)
					if (edge[i][j].second.first >= cmid)
						e[i].push_back(make_pair(edge[i][j].first, edge[i][j].second.second));
			}

			// Dijkstra in O(N^2)

			//fprintf(stderr, "cmin=%d, cmax=%d, cmid=%d\n", cmin, cmax, cmid);

			for (i = 2; i <= N; i++)
				dmin[i] = INF,
				sel[i] = 0;
		
			dmin[1] = 0;
			i = 1;
			sel[1] = 1;

			while (i != N)
			{
				for (k = 0; k <	e[i].size(); k++)
				{
					j = e[i][k].first;
					t = e[i][k].second;

					if (dmin[i] + t < dmin[j])
						dmin[j] = dmin[i] + t;
				}

				t = T + 1;
				for (j = 1; j <= N; j++)
					if (!sel[j] && dmin[j] < t)
					{
						t = dmin[j];
						i = j;
					}

				if (t <= T)
					sel[i] = 1;
				else
					break;
			}

			//fprintf(stderr, "  -> dmin[N]=%d [T=%d]\n", dmin[N], T);

			if (dmin[N] <= T)
				cmin = cmid + 1,
				cok = cmid;
			else
				cmax = cmid - 1;
		}

		printf("%d\n", cok);
		//fprintf(stderr, "cok=%d\n", cok);
	}

	return 0;
}
