// O(log CMAX * M * log N)

#include <stdio.h>
#include <string.h>

#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define NMAX 10010
#define INF 1666666666
#define EINF 2100000000

vector<pair<int, pair<int, int> > > edge[NMAX];
vector<pair<int, int> > e[NMAX];
vector<int> ec;
set<pair<int, int> > heap;
pair<int, int> p;
int dmin[NMAX], inheap[NMAX];
int i, j, k, N, M, T, c, ic, lc, nc, t, cmin, cmax, cmid, cok;

int main()
{
	int te, nt;

	freopen("d.in", "r", stdin);

	scanf("%d", &nt);

	for (te = 1; te <= nt; te++)
	{
		scanf("%d %d %d", &N, &M, &T);
		//fprintf(stderr, "%d %d %d\n", N, M, T);

		for (i = 1; i <= N; i++)
			edge[i].clear();

		cmin = INF;
		cmax = 0;

		ec.clear();

		for (k = 0; k < M; k++)
		{
			scanf("%d %d %d %d", &i, &j, &c, &t);
			edge[i].push_back(make_pair(j, make_pair(c, t)));
			edge[j].push_back(make_pair(i, make_pair(c, t)));

			if (c > cmax)
				cmax = c;
			if (c < cmin)
				cmin = c;

			ec.push_back(c);
		}

		sort(ec.begin(), ec.end());

		// try every capacity

		cok = 0;
		nc = 0;

		//fprintf(stderr, "### te=%d: %d - %d\n", te, cmin, cmax);

		lc = EINF;

		for (ic = ec.size() - 1; ic >= 0; ic--)
		{
			cmid = ec[ic];

			if (cmid == lc)
				continue;

			nc++;
			lc = cmid;

			// build the new graph

			for (i = 1; i <= N; i++)
			{
				e[i].clear();

				for (j = 0; j < edge[i].size(); j++)
					if (edge[i][j].second.first >= cmid)
						e[i].push_back(make_pair(edge[i][j].first, edge[i][j].second.second));
			}

			// Dijkstra with heaps on this new graph

			//fprintf(stderr, "cmin=%d, cmax=%d, cmid=%d\n", cmin, cmax, cmid);

			for (i = 2; i <= N; i++)
				dmin[i] = INF,
				inheap[i] = 0;

			dmin[1] = 0;

			heap.clear();
			heap.insert(make_pair(0, 1));

			inheap[1] = 1;

			while (heap.size() > 0)
			{
				p = *(heap.begin());

				//fprintf(stderr, "%d %d\n", (*(heap.begin())).first, (*(heap.begin())).second);

				i = p.second;
				heap.erase(p);
				inheap[i] = 0;

				//fprintf(stderr, "%d %d\n", (*(heap.begin())).first, (*(heap.begin())).second);

				for (k = 0; k < e[i].size(); k++)
				{
					j = e[i][k].first;
					t = e[i][k].second;

					if (dmin[i] + t < dmin[j])
					{
						if (inheap[j])
							heap.erase(make_pair(dmin[j], j));

						dmin[j] = dmin[i] + t;

						heap.insert(make_pair(dmin[j], j));
						inheap[j] = 1;
					}
				}
			}

			//fprintf(stderr, "  -> dmin[N]=%d [T=%d]\n", dmin[N], T);

			if (dmin[N] <= T)
			{
				cok = cmid;
				break;
			}
		}

		printf("%d\n", cok);
		fprintf(stderr, "cok=%d, nc=%d\n", cok, nc);
	}

	return 0;
}
