// O(log CMAX * M * log N)

#include <stdio.h>
#include <string.h>

#include <vector>
#include <set>
#include <algorithm>

using namespace std;

#define NMAX 10010
#define INF 1666666666
#define EINF 2100000000

vector<pair<int, pair<int, int> > > edge[NMAX];
set<pair<int, int> > heap;
pair<int, int> p;
int dmin[NMAX], cmax[NMAX], inheap[NMAX];
int i, j, k, N, M, T, c, t;

int main()
{
	int te, nt;

	freopen("d.in", "r", stdin);

	scanf("%d", &nt);

	for (te = 1; te <= nt; te++)
	{
		scanf("%d %d %d", &N, &M, &T);
		//fprintf(stderr, "%d %d %d\n", N, M, T);

		for (i = 1; i <= N; i++)
			edge[i].clear();

		for (k = 0; k < M; k++)
		{
			scanf("%d %d %d %d", &i, &j, &c, &t);
			edge[i].push_back(make_pair(j, make_pair(c, t)));
			edge[j].push_back(make_pair(i, make_pair(c, t)));
		}

		//fprintf(stderr, "### te=%d: %d - %d\n", te, cmin, cmax);

		// Dijkstra with heaps on the graph

		for (i = 2; i <= N; i++)
			dmin[i] = INF,
			cmax[i] = 0,
			inheap[i] = 0;

		dmin[1] = 0;
		cmax[1] = EINF;

		heap.clear();
		heap.insert(make_pair(0, 1));

		inheap[1] = 1;

		while (heap.size() > 0)
		{
			p = *(heap.begin());

			//fprintf(stderr, "%d %d\n", (*(heap.begin())).first, (*(heap.begin())).second);

			i = p.second;
			heap.erase(p);
			inheap[i] = 0;

			//fprintf(stderr, "%d %d\n", (*(heap.begin())).first, (*(heap.begin())).second);

			for (k = 0; k < edge[i].size(); k++)
			{
				j = edge[i][k].first;
				c = edge[i][k].second.first;
				t = edge[i][k].second.second;

				if (c > cmax[i])
					c = cmax[i];

				if ((dmin[i] + t < dmin[j]) || (dmin[i] + t == dmin[j] && c > cmax[j]))
				{
					if (inheap[j])
						heap.erase(make_pair(dmin[j], j));

					dmin[j] = dmin[i] + t;
					cmax[j] = c;

					heap.insert(make_pair(dmin[j], j));
					inheap[j] = 1;
				}
			}
		}

		printf("%d\n", cmax[N]);
	}

	return 0;
}
