#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <vector>
using namespace std;

#define NMAX 340
#define KMAX 12
#define INF 666666666

vector<pair<int, int> > f[NMAX];
int nf[NMAX], distf[NMAX], cmin[NMAX][KMAX][NMAX], x[2][NMAX];
int i, j, k, N, K, c;

void df(int n)
{
	int i, j, k, p, q, fn, cf, c, a;

	if (f[n].size() == 0) // n is a leaf
	{
		for (k = 0; k <= K; k++)
		{
			cmin[n][k][0] = INF;
			cmin[n][k][1] = 0;

			for (j = 2; j <= N; j++)
				cmin[n][k][j] = INF;
		}

		nf[n] = 1;
		distf[n] = 0;

		return;
	}

	// n is not a leaf

	nf[n] = 0;
	distf[n] = 0;

	for (i = 0; i < f[n].size(); i++)
	{
		fn = f[n][i].first;
		cf = f[n][i].second;

		df(fn);

		nf[n] += nf[fn];
		distf[n] += distf[fn] + nf[fn] * cf;
	}

	// DP

	for (k = 0; k <= K; k++)
	{
		// layer K (leaves are on layer 0, root is on layer K+1)

		for (j = 0; j <= N; j++)
			cmin[n][k][j] = INF;

		// option 1: node n is a node on layer K

		if (k > 0)
		{
			c = a = 0;
			x[c][0] = 0;
			for (j = 1; j <= N; j++)
				x[c][j] = INF;

			for (i = 0; i < f[n].size(); i++)
			{
				fn = f[n][i].first;
				cf = f[n][i].second;
		
				a = c;
				c = 1 - c;
				for (p = 0; p <= N; p++)
					x[c][p] = INF;

				for (p = 0; p <= N; p++)
					if (cmin[fn][k - 1][p] < INF)
					{
						for (q = 0; q <= N - p; q++)
							if (x[a][q] + cmin[fn][k - 1][p] + cf * p < x[c][p + q])
								x[c][p + q] = x[a][q] + cmin[fn][k - 1][p] + cf * p;
					}
			}

			cmin[n][k][1] = x[c][1];
			for (p = 2; p <= N; p++)
				if (x[c][p] < cmin[n][k][1])
					cmin[n][k][1] = x[c][p];
		}
		
		// option 2: node n is between layer K and layer K+1 (this option is not valid for the root of the tree)

		if (n != 1) // n is not the root of the tree
		{
			c = a = 0;
			x[c][0] = 0;
			for (j = 1; j <= N; j++)
				x[c][j] = INF;

			for (i = 0; i < f[n].size(); i++)
			{
				fn = f[n][i].first;
				cf = f[n][i].second;
		
				a = c;
				c = 1 - c;
				for (p = 0; p <= N; p++)
					x[c][p] = INF;

				for (p = 0; p <= N; p++)
					if (cmin[fn][k][p] < INF)
					{
						for (q = 0; q <= N - p; q++)
							if (x[a][q] + cmin[fn][k][p] + cf * p < x[c][p + q])
								x[c][p + q] = x[a][q] + cmin[fn][k][p] + cf * p;
					}
			}

			for (p = 1; p <= N; p++)
				if (x[c][p] < cmin[n][k][p])
					cmin[n][k][p] = x[c][p];
		}
	}
}

int main()
{
	int te, T;

	//freopen("i.in", "r", stdin);
	//freopen("i.ok", "w", stdout);

	scanf("%d", &T);

	for (te = 1; te <= T; te++)
	{
		scanf("%d %d", &N, &K);
		K++;

		for (i = 1; i <= N; i++)
			f[i].clear();

		for (k = 1; k < N; k++)
		{
			scanf("%d %d %d", &i, &j, &c);
			f[i].push_back(make_pair(j, c));
		}

		df(1);

		printf("%d\n", cmin[1][K][1]);

		fprintf(stderr, "## Test %d\n", te);
		for (k = 0; k <= K; k++)
			fprintf(stderr, "K=%d -> %d\n", k, cmin[1][k][1]);
	}

	return 0;
}
