#include <stdio.h>
#include <stdlib.h>
#include <string.h>

#include <vector>
using namespace std;

#define NMAX 340
#define KMAX 12
#define INF 666666666

vector<pair<int, int> > f[NMAX];
int t[NMAX], l[2][NMAX], nl[2], sumf[NMAX], nf[NMAX], d[NMAX], sel[NMAX], econ[NMAX], lev[NMAX];
int i, j, k, p, N, K, nfr, c, a, cmin, nsel, emax;

void dflev(int n)
{
	int i, ff;

	for (i = 0; i < f[n].size(); i++)
	{
		ff = f[n][i].first;
		lev[ff] = lev[n] + 1;

		dflev(ff);
	}
}


void df(int n)
{
	int i, ff, cf;

	sel[n] = 1;
	sumf[n] = 0;
	nf[n] = 0;

	if (f[n].size() == 0) // leaf
	{
		nf[n] = 1;
		econ[n] = 0;
		return;
	}

	for (i = 0; i < f[n].size(); i++)
	{
		ff = f[n][i].first;
		cf = f[n][i].second;

		d[ff] = d[n] + cf;

		df(ff);

		nf[n] += nf[ff];
		sumf[n] += sumf[ff] + nf[ff] * cf;
	}

	econ[n] = d[n] * (nf[n] - 1);
}

void dfsel2(int n)
{
	int i, ff;

	sel[n] = 2;

	for (i = 0; i < f[n].size(); i++)
	{
		ff = f[n][i].first;
		dfsel2(ff);
	}
}

int main()
{
	int te, T;

	freopen("i.in", "r", stdin);
	freopen("i.log.txt", "w", stderr);

	scanf("%d", &T);

	for (te = 1; te <= T; te++)
	{
		scanf("%d %d", &N, &K);
		//K++;

		for (i = 1; i <= N; i++)
			f[i].clear();

		for (k = 1; k < N; k++)
		{
			scanf("%d %d %d", &i, &j, &c);
			f[i].push_back(make_pair(j, c));
			t[j] = i;
		}

		lev[1] = 0;
		dflev(1);

		for (i = 1; i <= N; i++)
			if (f[i].size() == 0)
				fprintf(stderr, " -> %d: %d/%d\n", i, lev[i], K + 1);

		a = c = 0;
		nl[0] = 1;
		l[0][1] = 1;

		cmin = 0;

		for (k = 1; k <= K; k++)
		{
			// the k-th intermediate layer

			a = c;
			c = 1 - c;
			nl[c] = 0;

			memset(sel, 0, sizeof(sel));

			for (i = 1; i <= nl[a]; i++)
			{
				d[l[a][i]] = 0;
				//nsel = 0;
				
				if (f[l[a][i]].size() == 0)
				{
					l[c][++nl[c]] = l[a][i];
				}
				else
				{
					df(l[a][i]);

					sel[l[a][i]] = 2;

					nfr = nf[l[a][i]];

					while (nfr > 0)
					{
						emax = -1;
						p = 0;

						for (j = 1; j <= N; j++)
							if (sel[j] == 1 && econ[j] > emax)
								emax = econ[j],
								p = j;

						if (p)
						{
							cmin += d[p];
							l[c][++nl[c]] = p;

							j = p;

							while (sel[j] != 2)
							{
								sel[j] = 2;
								j = t[j];
							}

							dfsel2(p);

							sel[p] = 2;
							nfr -= nf[p];
						}
						else
							break;
					}
				}
			}
		}

		for (i = 1; i <= nl[c]; i++)
		{
			df(l[c][i]);
			cmin += sumf[l[c][i]];
		}

		//fprintf(stderr, "N=%d, nf=%d\n", N, nf[1]);
		printf("%d\n", cmin);
	}

	return 0;
}
